#TITLE=Official PHP Functions
#INFO
EditPlus Official PHP File
This file created by: randomblink
http://ninjasquirrels.com
#SORT=n
;;*******************************************************************************	
;;* NINJA SQUIRRELS SOFTWARE DESIGN						*
;;* Copyright (C) 2002 by the Ninja Squirrels Development Team.			*
;;* http://www.ninjasquirrels.com;						*
;;*******************************************************************************	
;;* LICENSE									*
;;*										*
;;* This program is free software; you can redistribute it and;or		*
;;* modify it under the terms of the GNU General Public License (GPL)		*
;;* as published by the Free Software Foundation; either version 2		*
;;* of the License, or (at your option) any later version.			*
;;*										*
;;* This program is distributed in the hope that it will be useful,		*
;;* but WITHOUT ANY WARRANTY; without even the implied warranty of		*
;;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		*
;;* GNU General Public License for more details.				*
;;*										*
;;* To read the license please visit http:;;www.gnu.org;copyleft;gpl.html	*
;;*******************************************************************************	
;;* Original Author of file:	randomblink					*
;;* Authors Website:		http://randomblink.ninjasquirrels.com		*
;;* Purpose of file:		PHP Clip Text Library for Edit Plus		*
;;*******************************************************************************
;;* This file was created using the following steps:				*
;;* 1) I downloaded the php CHM file from http://www.php.net/download-docs.php  *
;;* 2) I downloaded eTextWizard v.1.95 from http://www.etextwizard.com		*
;;* 3) Using eTextWizard I exported the individual HTML files from the php CHM	*
;;* 4) I put all of the function.*.html files into a single folder.		*
;;* 5) I created a file and named it: combine.bat				*
;;* 6) I edited the combine.bat and put the following lines inside of it.	*
;;* *************************************************************************** *
;;* * combine.bat ************************************************************* *
;;* *************************************************************************** *
;;* *									      * *
;;* * dir *.html /b > filelist.txt					      * *
;;* * FOR %%1 in (*.html) do type %%1 >> combined.html			      * *
;;* *									      * *
;;* * ************************************************************************* *
;;* 7) I then saved the combine.bat file in the same folder as the html files.	*
;;* 8) I double-clicked on the combine.bat file					*
;;* 9) This combined ALL of the function.*.html files into combined.html.	*
;;* 10) I opened combined.html file in Windows Explorer.			*
;;* 11) I saved combined.html file as a TEXT file.				*
;;* 12) Now I had a HUGE combined.txt file which I opened in Edit Plus.		*
;;* 13) I SELECT'ed ALL and SHIFT+TAB to align everything against the left side.*
;;* 14) Then I put my cursor in front of the first entry(abs)			*
;;* 15) I created a macro that parsed the entries and created what you see here.*
;;*******************************************************************************

#T=abs - number abs ( mixed number)
(PHP 3, PHP 4 )
abs -- Absolute value
Description
number abs ( mixed number)
Returns the absolute value of number. If the argument number is of type 
float, the return type is also float, otherwise it is integer (as float 
usually has a bigger value range than integer). 
Example 1. abs() example
  <?php
  $abs = abs(-4.2); // $abs = 4.2; (double/float)
  $abs2 = abs(5);   // $abs2 = 5; (integer)
  $abs3 = abs(-5);  // $abs3 = 5; (integer)
  ?> 
#

#T=number abs ( mixed number)
abs ( ^!mixed number);
#

#T=acos - float acos ( float arg)
(PHP 3, PHP 4 )
acos -- Arc cosine
Description
float acos ( float arg)
Returns the arc cosine of arg in radians. acos() is the complementary 
function of cos(), which means that a==cos(acos(a)) for every value of a 
that is within acos()' range. 
See also acosh(), asin() and atan().   absUpacosh
#

#T=float acos ( float arg)
acos ( ^!float arg);
#

#T=acosh - float acosh ( float arg)
(PHP 4 >= 4.1.0)
acosh -- Inverse hyperbolic cosine
Description
float acosh ( float arg)
Returns the inverse hyperbolic cosine of arg, i.e. the value whose 
hyperbolic cosine is arg. 
Note: This function is not implemented on Windows platforms.
See also acos(), asinh() and atanh().   acosUpasin
#

#T=float acosh ( float arg)
acosh ( ^!float arg);
#

#T=addcslashes - string addcslashes ( string str, string charlist)
(PHP 4 )
addcslashes -- Quote string with slashes in a C style
Description
string addcslashes ( string str, string charlist)
Returns a string with backslashes before characters that are listed in 
charlist parameter. It escapes \n, \r etc. in C-like style, characters 
with ASCII code lower than 32 and higher than 126 are converted to octal 
representation. 
Be careful if you choose to escape characters 0, a, b, f, n, r, t and v. 
They will be converted to \0, \a, \b, \f, \n, \r, \t and \v. In PHP \0 
(NULL), \r (carriage return), \n (newline) and \t (tab) are predefined 
escape sequences, while in C all of these are predefined escape sequences. 

charlist like "\0..\37", which would escape all characters with ASCII code 
between 0 and 37. Example 1. addcslashes() example
  <?php
  $escaped = addcslashes($not_escaped, "\0..\37!@\177..\377");
  ?> 
When you define a sequence of characters in the charlist argument make 
sure that you know what characters come between the characters that you 
set as the start and end of the range. 
<?php
echo addcslashes('foo[ ]', 'A..z');
// output:  \f\o\o\[ \]
// All upper and lower-case letters will be escaped
// ... but so will the [\]^_` and any tabs, line
// feeds, carriage returns, etc.
?> 

Also, if the first character in a range has a higher ASCII value than the 
second character in the range, no range will be constructed. Only the 
start, end and period characters will be escaped. Use the ord() function 
to find the ASCII value for a character. 
<?php
echo addcslashes("zoo['.']", 'z..A');
// output:  \zoo['\.']
?> 

See also stripcslashes(), stripslashes(), htmlspecialchars(), and 
quotemeta().   String functionsUpaddslashes
#

#T=string addcslashes ( string str, string charlist)
addcslashes ( ^!string str, string charlist);
#

#T=addslashes - string addslashes ( string str)
(PHP 3, PHP 4 )
addslashes -- Quote string with slashes
Description
string addslashes ( string str)
Returns a string with backslashes before characters that need to be quoted 
in database queries etc. These characters are single quote ('), double 
quote ("), backslash (\) and NUL (the NULL byte). 
An example use of addslashes() is when you're entering data into a 
database. For example, to insert the name O'reilly into a database, you 
will need to escape it. Most databases do this with a \ which would mean 
O\'reilly. This would only be to get the data into the database, the extra 
\ will not be inserted. Having the PHP directive magic_quotes_sybase set 
to on will mean ' is instead escaped with another '. 
The PHP directive magic_quotes_gpc is on by default, and it essentially 
runs addslashes() on all GET, POST, and COOKIE data. Do not use 
addslashes() on strings that have already been escaped with 
magic_quotes_gpc as you'll then do double escaping. The function 
get_magic_quotes_gpc() may come in handy for checking this. 
Example 1. An addslashes() example
  <?php
  $str = "Is your name O'reilly?";

  // Outputs: Is your name O\'reilly?
  echo addslashes($str);
  ?> 
See also stripslashes(), htmlspecialchars(), quotemeta(), and 
get_magic_quotes_gpc().   addcslashesUpbin2hex
#

#T=string addslashes ( string str)
addslashes ( ^!string str);
#

#T=aggregate_info - array aggregate_info ( object object)
(PHP 5 CVS only)
aggregate_info --  returns an associative array of the methods and 
properties from each class that has been aggregated to the object. 
Description
array aggregate_info ( object object)
Will return the aggregation information for a particular object as an 
associative array of arrays of methods and properties. The key for the 
main array is the name of the aggregated class. 
For example the code below Example 1. Using aggregate_info()
  <?php

  class Slicer {
      var $vegetable;

      function Slicer($vegetable) {
	  $this->vegetable = $vegetable;
      }

      function slice_it($num_cuts) {
	  echo "Doing some simple slicing\n";
	  for ($i=0; $i < $num_cuts; $i++) {
	      // do some slicing
	  }
      }
  }

  class Dicer {
      var $vegetable;
      var $rotation_angle = 90;   // degrees

      function Dicer($vegetable) {
	  $this->vegetable = $vegetable;
      }

      function dice_it($num_cuts) {
	  echo "Cutting in one direction\n";
	  for ($i=0; $i < $num_cuts; $i++) {
	      // do some cutting
	  }
	  $this->rotate($this->rotation_angle);
	  echo "Cutting in a second direction\n";
	  for ($i=0; $i < $num_cuts; $i++) {
	      // do some more cutting
	  }
      }

      function rotate($deg) {
	  echo "Now rotating {$this->vegetable} {$deg} 
  degrees\n";
      }

      function _secret_super_dicing($num_cuts) {
	  // so secret we cannot show you ;-)
      }
  }

  $obj = new Slicer('onion');
  aggregate($obj, 'Dicer');
  print_r(aggregate_info($obj));
  ?> 

Will produce the output 
Array
(
[dicer] => Array
(
[methods] => Array
(
    [0] => dice_it
    [1] => rotate
)

[properties] => Array
(
    [0] => rotation_angle
)

)

)

As you can see, all properties and methods of the Dicer class have been 
aggregated into our new object, with the exception of the class 
constructor and the method _secret_super_dicing 
See also aggregate(), aggregate_methods(), aggregate_methods_by_list(), 
aggregate_methods_by_regexp(), aggregate_properties(), 
aggregate_properties_by_list(), aggregate_properties_by_regexp(), 
deaggregate()   Object Aggregation/Composition 
  FunctionsUpaggregate_methods_by_list
#

#T=array aggregate_info ( object object)
aggregate_info ( ^!object object);
#

#T=aggregate_methods_by_list - void aggregate_methods_by_list ( object object, string class_name, array 
(PHP 4 >= 4.2.0)
aggregate_methods_by_list --  selective dynamic class methods aggregation 
to an object 
Description
void aggregate_methods_by_list ( object object, string class_name, array 
methods_list [, bool exclude])
Aggregates methods from a class to an existing object using a list of 
method names. The optional paramater exclude is used to decide whether the 
list contains the names of methods to include in the aggregation (i.e. 
exclude is FALSE, which is the default value), or to exclude from the 
aggregation (exclude is TRUE). 
The class constructor or methods whose names start with an underscore 
character (_), which are considered private to the aggregated class, are 
always excluded. 
See also aggregate(), aggregate_info(), aggregate_methods(), 
aggregate_methods_by_regexp(), aggregate_properties(), 
aggregate_properties_by_list(), aggregate_properties_by_regexp(), 
deaggregate()   aggregate_infoUpaggregate_methods_by_regexp
#

#T=void aggregate_methods_by_list ( object object, string class_name, array 
aggregate_methods_by_list ( ^!object object, string class_name, array ;
#

#T=aggregate_methods_by_regexp - void aggregate_methods_by_regexp ( object object, string class_name, 
(PHP 4 >= 4.2.0)
aggregate_methods_by_regexp --  selective class methods aggregation to an 
object using a regular expression 
Description
void aggregate_methods_by_regexp ( object object, string class_name, 
string regexp [, bool exclude])
Aggregates methods from a class to an existing object using a regular 
expresion to match method names. The optional paramater exclude is used to 
decide whether the regular expression will select the names of methods to 
include in the aggregation (i.e. exclude is FALSE, which is the default 
value), or to exclude from the aggregation (exclude is TRUE). 
The class constructor or methods whose names start with an underscore 
character (_), which are considered private to the aggregated class, are 
always excluded. 
See also aggregate(), aggregate_info(), aggregate_methods(), 
aggregate_methods_by_list(), aggregate_properties(), 
aggregate_properties_by_list(), aggregate_properties_by_regexp(), 
deaggregate()   aggregate_methods_by_listUpaggregate_methods
#

#T=void aggregate_methods_by_regexp ( object object, string class_name, 
aggregate_methods_by_regexp ( ^!object object, string class_name, ;
#

#T=aggregate_methods - void aggregate_methods ( object object, string class_name)
(PHP 4 >= 4.2.0)
aggregate_methods --  dynamic class and object aggregation of methods 
Description
void aggregate_methods ( object object, string class_name)
Aggregates all methods defined in a class to an existing object, except 
for the class constructor, or methods whose names start with an underscore 
character (_) which are considered private to the aggregated class. 
See also aggregate(), aggregate_info(), aggregate_methods_by_list(), 
aggregate_methods_by_regexp(), aggregate_properties(), 
aggregate_properties_by_list(), aggregate_properties_by_regexp(), 
deaggregate()   aggregate_methods_by_regexpUpaggregate_properties_by_list
#

#T=void aggregate_methods ( object object, string class_name)
aggregate_methods ( ^!object object, string class_name);
#

#T=aggregate_properties_by_list - void aggregate_properties_by_list ( object object, string class_name, 
(PHP 4 >= 4.2.0)
aggregate_properties_by_list --  selective dynamic class properties 
aggregation to an object 
Description
void aggregate_properties_by_list ( object object, string class_name, 
array properties_list [, bool exclude])
Aggregates properties from a class to an existing object using a list of 
property names. The optional paramater exclude is used to decide whether 
the list contains the names of class properties to include in the 
aggregation (i.e. exclude is FALSE, which is the default value), or to 
exclude from the aggregation (exclude is TRUE). 
The properties whose names start with an underscore character (_), which 
are considered private to the aggregated class, are always excluded. 
See also aggregate(), aggregate_methods(), aggregate_methods_by_list(), 
aggregate_methods_by_regexp(), aggregate_properties(), 
aggregate_properties_by_regexp(), aggregate_info(), deaggregate()   aggregate_methodsUpaggregate_properties_by_regexp
#

#T=void aggregate_properties_by_list ( object object, string class_name, 
aggregate_properties_by_list ( ^!object object, string class_name, ;
#

#T=aggregate_properties_by_regexp - void aggregate_properties_by_regexp ( object object, string class_name, 
(PHP 4 >= 4.2.0)
aggregate_properties_by_regexp --  selective class properties aggregation 
to an object using a regular expression 
Description
void aggregate_properties_by_regexp ( object object, string class_name, 
string regexp [, bool exclude])
Aggregates properties from a class to an existing object using a regular 
expresion to match their names. The optional paramater exclude is used to 
decide whether the regular expression will select the names of class 
properties to include in the aggregation (i.e. exclude is FALSE, which is 
the default value), or to exclude from the aggregation (exclude is TRUE). 
The properties whose names start with an underscore character (_), which 
are considered private to the aggregated class, are always excluded. 
See also aggregate(), aggregate_methods(), aggregate_methods_by_list(), 
aggregate_methods_by_regexp(), aggregate_properties(), 
aggregate_properties_by_list(), aggregate_info(), deaggregate()   aggregate_properties_by_listUpaggregate_properties
#

#T=void aggregate_properties_by_regexp ( object object, string class_name, 
aggregate_properties_by_regexp ( ^!object object, string class_name, ;
#

#T=aggregate_properties - void aggregate_properties ( object object, string class_name)
(PHP 4 >= 4.2.0)
aggregate_properties --  dynamic aggregation of class properties to an 
object 
Description
void aggregate_properties ( object object, string class_name)
Aggregates all properties defined in a class to an existing object, except 
for properties whose names start with an underscore character (_) which 
are considered private to the aggregated class. 
See also aggregate(), aggregate_methods(), aggregate_methods_by_list(), 
aggregate_methods_by_regexp(), aggregate_properties_by_list(), 
aggregate_properties_by_regexp(), aggregate_info(), deaggregate()   aggregate_properties_by_regexpUpaggregate
#

#T=void aggregate_properties ( object object, string class_name)
aggregate_properties ( ^!object object, string class_name);
#

#T=aggregate - void aggregate ( object object, string class_name)
(PHP 4 >= 4.2.0)
aggregate --  dynamic class and object aggregation of methods and 
properties 
Description
void aggregate ( object object, string class_name)
Aggregates methods and properties defined in a class to an existing 
object. Methods and properties with names starting with an underscore 
character (_) are considered private to the aggregated class and are not 
used, constructors are also excluded from the aggregation procedure. 
See also aggregate_info(), aggregate_methods(), 
aggregate_methods_by_list(), aggregate_methods_by_regexp(), 
aggregate_properties(), aggregate_properties_by_list(), 
aggregate_properties_by_regexp(), deaggregate()   aggregate_propertiesUpaggregation_info
aggregation_info
aggregation_info -- Alias for aggregate_info()
Description
This function is an alias of aggregate_info().   aggregateUpdeaggregate
#

#T=void aggregate ( object object, string class_name)
aggregate ( ^!object object, string class_name);
#

#T=apache_child_terminate - bool apache_child_terminate ( void )
(PHP 4 >= 4.0.5)
apache_child_terminate -- Terminate apache process after this request
Description
bool apache_child_terminate ( void )
apache_child_terminate() will register the Apache process executing the 
current PHP request for termination once execution of PHP code it is 
completed. It may be used to terminate a process after a script with high 
memory consumption has been run as memory will usually only be freed 
internally but not given back to the operating system. 
Note: The availability of this feature is controlled by the php.ini 
directive child_terminate, which is set to off by default. 
This feature is also not available on multithreaded versions of apache 
like the win32 version. 
See also exit().   Apache-specific FunctionsUpapache_get_version
#

#T=bool apache_child_terminate ( void )
apache_child_terminate ( ^!void );
#

#T=apache_get_version - string apache_get_version ( void )
(PHP 4 >= 4.3.2)
apache_get_version --  Fetch Apache version 
Description
string apache_get_version ( void )
apache_get_version() returns the version of Apache as string, or FALSE on 
failure. 
Example 1. apache_get_version() example
  <?php
  $version = apache_get_version();
  echo "$version \n <br \>";
  ?> 

The printout of the above program will look similar to: 
Apache/1.3.29 (Unix) PHP/4.3.4
See also phpinfo().   apache_child_terminateUpapache_lookup_uri
#

#T=string apache_get_version ( void )
apache_get_version ( ^!void );
#

#T=apache_lookup_uri - object apache_lookup_uri ( string filename)
(PHP 3>= 3.0.4, PHP 4 )
apache_lookup_uri --  Perform a partial request for the specified URI and 
return all info about it 
Description
object apache_lookup_uri ( string filename)
This performs a partial request for a URI. It goes just far enough to 
obtain all the important information about the given resource and returns 
this information in a class. The properties of the returned class are: 
status
the_request
status_line
method
content_type
handler
uri
filename
path_info
args
boundary
no_cache
no_local_copy
allowed
send_bodyct
bytes_sent
byterange
clength
unparsed_uri
mtime
request_time

Note: apache_lookup_uri() only works when PHP is installed as an Apache 
module.   apache_get_versionUpapache_note
#

#T=object apache_lookup_uri ( string filename)
apache_lookup_uri ( ^!string filename);
#

#T=apache_note - string apache_note ( string note_name [, string note_value])
(PHP 3>= 3.0.2, PHP 4 )
apache_note -- Get and set apache request notes
Description
string apache_note ( string note_name [, string note_value])
apache_note() is an Apache-specific function which gets and sets values in 
a request's notes table. If called with one argument, it returns the 
current value of note note_name. If called with two arguments, it sets the 
value of note note_name to note_value and returns the previous value of 
note note_name.   apache_lookup_uriUpapache_request_headers
#

#T=string apache_note ( string note_name [, string note_value])
apache_note ( ^!string note_name [, string note_value]);
#

#T=apache_request_headers - array apache_request_headers ( void )
(PHP 4 >= 4.3.0)
apache_request_headers -- Fetch all HTTP request headers
Description
array apache_request_headers ( void )
apache_request_headers() returns an associative array of all the HTTP 
headers in the current request. This is only supported when PHP runs as an 
Apache module. 
Example 1. apache_request_headers() example
  <?php
  $headers = apache_request_headers();

  foreach ($headers as $header => $value) {
      echo "$header: $value <br />\n";
  }
  ?> 
Note: Prior to PHP 4.3.0, apache_request_headers() was called 
getallheaders(). After PHP 4.3.0, getallheaders() is an alias for 
apache_request_headers(). 
Note: You can also get at the value of the common CGI variables by 
reading them from the environment, which works whether or not you are 
using PHP as an Apache module. Use phpinfo() to see a list of all of the 
available environment variables. 
Note: From PHP 4.3.3 on you can use this function with the NSAPI server 
module in Netscape/iPlanet/SunONE webservers, too. 
See also apache_response_headers().   apache_noteUpapache_response_headers
#

#T=array apache_request_headers ( void )
apache_request_headers ( ^!void );
#

#T=apache_response_headers - array apache_response_headers ( void )
(PHP 4 >= 4.3.0)
apache_response_headers --  Fetch all HTTP response headers 
Description
array apache_response_headers ( void )
Returns an array of all Apache response headers. This functionality is 
only available in PHP version 4.3.0 and greater. 
Note: From PHP 4.3.3 on you can use this function with the NSAPI server 
module in Netscape/iPlanet/SunONE webservers, too. 
See also apache_request_headers(), and headers_sent().   apache_request_headersUpapache_setenv
#

#T=array apache_response_headers ( void )
apache_response_headers ( ^!void );
#

#T=apache_setenv - int apache_setenv ( string variable, string value [, bool walk_to_top])
(PHP 4 >= 4.2.0)
apache_setenv -- Set an Apache subprocess_env variable
Description
int apache_setenv ( string variable, string value [, bool walk_to_top])
Warning
This function is currently not documented; only the argument list is 
available.
  apache_response_headersUpascii2ebcdic
#

#T=int apache_setenv ( string variable, string value [, bool walk_to_top])
apache_setenv ( ^!string variable, string value [, bool walk_to_top]);
#

#T=array_change_key_case - array array_change_key_case ( array input [, int case])
(PHP 4 >= 4.2.0)
array_change_key_case -- Returns an array with all string keys lowercased 
or uppercased
Description
array array_change_key_case ( array input [, int case])
array_change_key_case() changes the keys in the input array to be all 
lowercase or uppercase. The change depends on the last optional case 
parameter. You can pass two constants there, CASE_UPPER and CASE_LOWER. 
The default is CASE_LOWER. The function will leave number indices as is. 
Example 1. array_change_key_case() example
  <?php
  $input_array = array("FirSt" => 1, "SecOnd" => 4);
  print_r(array_change_key_case($input_array, CASE_UPPER));
  ?> 

The printout of the above program will be: 
Array
(
[FIRST] => 1
[SECOND] => 4
)
If an array has indices that will be the same once run through this 
function (e.g. "keY" and "kEY"), the value that is later in the array will 
override other indices.   Array FunctionsUparray_chunk
#

#T=array array_change_key_case ( array input [, int case])
array_change_key_case ( ^!array input [, int case]);
#

#T=array_chunk - array array_chunk ( array input, int size [, bool preserve_keys])
(PHP 4 >= 4.2.0)
array_chunk -- Split an array into chunks
Description
array array_chunk ( array input, int size [, bool preserve_keys])
array_chunk() splits the array into several arrays with size values in 
them. You may also have an array with less values at the end. You get the 
arrays as members of a multidimensional array indexed with numbers 
starting from zero. 
By setting the optional preserve_keys parameter to TRUE, you can force PHP 
to preserve the original keys from the input array. If you specify FALSE 
new number indices will be used in each resulting array with indices 
starting from zero. The default is FALSE. 
Example 1. array_chunk() example
  <?php
  $input_array = array('a', 'b', 'c', 'd', 'e');
  print_r(array_chunk($input_array, 2));
  print_r(array_chunk($input_array, 2, true));
  ?> 

The printout of the above program will be: 
Array
(
[0] => Array
(
[0] => a
[1] => b
)

[1] => Array
(
[0] => c
[1] => d
)

[2] => Array
(
[0] => e
)

)
Array
(
[0] => Array
(
[0] => a
[1] => b
)

[1] => Array
(
[2] => c
[3] => d
)

[2] => Array
(
[4] => e
)

)

  array_change_key_caseUparray_combine
#

#T=array array_chunk ( array input, int size [, bool preserve_keys])
array_chunk ( ^!array input, int size [, bool preserve_keys]);
#

#T=array_combine - array array_combine ( array keys, array values)
(PHP 5 CVS only)
array_combine --  Creates an array by using one array for keys and another 
for its values 
Description
array array_combine ( array keys, array values)
Returns an array by using the values from the keys array as keys and the 
values from the values array as the corresponding values. 
Returns FALSE if the number of elements for each array isn't equal or if 
the arrays are empty. 
Example 1. A simple array_combine() example
  <?php
  $a = array('green', 'red', 'yellow');
  $b = array('avocado', 'apple', 'banana');
  $c = array_combine($a, $b);

  print_r($c);
  ?> 

Outputs: 
Array
(
[green]  => avocado
[red]    => apple
[yellow] => banana
)
See also array_merge(), array_walk(), and array_values().   array_chunkUparray_count_values
#

#T=array array_combine ( array keys, array values)
array_combine ( ^!array keys, array values);
#

#T=array_count_values - array array_count_values ( array input)
(PHP 4 )
array_count_values -- Counts all the values of an array
Description
array array_count_values ( array input)
array_count_values() returns an array using the values of the input array 
as keys and their frequency in input as values. 
Example 1. array_count_values() example
  <?php
  $array = array(1, "hello", 1, "world", "hello");
  print_r(array_count_values($array));
  ?> 

The printout of the above program will be: 
Array
(
[1] => 2
[hello] => 2
[world] => 1
)
See also count(), array_unique(), array_values(), and count_chars().   array_combineUparray_diff_assoc
#

#T=array array_count_values ( array input)
array_count_values ( ^!array input);
#

#T=array_diff_assoc - array array_diff_assoc ( array array1, array array2 [, array ...])
(PHP 4 >= 4.3.0)
array_diff_assoc -- Computes the difference of arrays with additional 
index check
Description
array array_diff_assoc ( array array1, array array2 [, array ...])
array_diff_assoc() returns an array containing all the values from array1 
that are not present in any of the other arguments. Note that the keys are 
used in the comparison unlike array_diff(). 
Example 1. array_diff_assoc() example
  <?php
  $array1 = array("a" => "green", "b" => "brown", "c" => "blue", 
  "red");
  $array2 = array("a" => "green", "yellow", "red");
  $result = array_diff_assoc($array1, $array2);
  print_r($result);
  ?> 

The result is: 
Array
(
[b] => brown
[c] => blue
[0] => red
)
In our example above you see the "a" => "green" pair is present in both 
arrays and thus it is not in the ouput from the function. Unlike this, the 
pair 0 => "red" is in the ouput because in the second argument "red" has 
key which is 1. 
Two values from key => value pairs are considered equal only if (string) 
$elem1 === (string) $elem2 . In other words a strict check takes place so 
the string representations must be the same. 
Note: Please note that this function only checks one dimension of a 
n-dimensional array. Of course you can check deeper dimensions by using, 
for example, array_diff_assoc($array1[0], $array2[0]);. 
See also array_diff(), array_intersect(), and array_intersect_assoc().   array_count_valuesUparray_diff_uassoc
array_diff_uassoc
(no version information, might be only in CVS)
array_diff_uassoc -- Computes the difference of arrays with additional 
index check which is performed by a user supplied callback function.
Description
array array_diff_assoc ( array array1, array array2 [, array ..., callback 
key_compare_func])
array_diff_uassoc() returns an array containing all the values from array1 
that are not present in any of the other arguments. Note that the keys are 
used in the comparison unlike array_diff(). This comparison is done by a 
user supplied callback function. It must return an integer less than, 
equal to, or greater than zero if the first argument is considered to be 
respectively less than, equal to, or greater than the second. This is 
unlike array_diff_assoc() where an internal function for comparing the 
indices is used. 
Example 1. array_diff_uassoc() example
  <?php
  function key_compare_func($a, $b) {
      if ($a === $b) return 0;
      return ($a > $b)? 1:-1;
  }

  $array1 = array("a" => "green", "b" => "brown", "c" => "blue", 
  "red");
  $array2 = array("a" => "green", "yellow", "red");
  $result = array_diff_uassoc($array1, $array2, 
  "key_compare_func");
  ?> 

The result is: 
Array
(
[b] => brown
[c] => blue
[0] => red
)
In our example above you see the "a" => "green" pair is present in both 
arrays and thus it is not in the ouput from the function. Unlike this, the 
pair 0 => "red" is in the ouput because in the second argument "red" has 
key which is 1. 
The equality of 2 indices is checked by the user supplied callback 
function. 
Note: Please note that this function only checks one dimension of a 
n-dimensional array. Of course you can check deeper dimensions by using, 
for example, array_diff_uassoc($array1[0], $array2[0], 
"key_compare_func");. 
See also array_diff(), array_diff_assoc(), array_udiff(), 
array_udiff_assoc(), array_udiff_uassoc(), array_intersect(), 
array_intersect_assoc(), array_uintersect(), array_uintersect_assoc() and 
array_uintersect_uassoc().   array_diff_assocUparray_diff
#

#T=array array_diff_assoc ( array array1, array array2 [, array ...])
array_diff_assoc ( ^!array array1, array array2 [, array ...]);
#

#T=array_diff - array array_diff ( array array1, array array2 [, array ...])
(PHP 4 >= 4.0.1)
array_diff -- Computes the difference of arrays
Description
array array_diff ( array array1, array array2 [, array ...])
array_diff() returns an array containing all the values of array1 that are 
not present in any of the other arguments. Note that keys are preserved. 
Example 1. array_diff() example
  <?php
  $array1 = array("a" => "green", "red", "blue", "red");
  $array2 = array("b" => "green", "yellow", "red");
  $result = array_diff($array1, $array2);

  print_r($result);
  ?> 

Multiple occurrences in $array1 are all treated the same way. This 
will output : 
Array
(
[1] => blue
)
Note: Two elements are considered equal if and only if (string) $elem1 
=== (string) $elem2. In words: when the string representation is the 
same. 
Note: Please note that this function only checks one dimension of a 
n-dimensional array. Of course you can check deeper dimensions by using 
array_diff($array1[0], $array2[0]);. 
Warning
This was broken in PHP 4.0.4! 

See also array_diff_assoc(), array_intersect(), and 
array_intersect_assoc().   array_diff_uassocUparray_fill
#

#T=array array_diff ( array array1, array array2 [, array ...])
array_diff ( ^!array array1, array array2 [, array ...]);
#

#T=array_fill - array array_fill ( int start_index, int num, mixed value)
(PHP 4 >= 4.2.0)
array_fill -- Fill an array with values
Description
array array_fill ( int start_index, int num, mixed value)
array_fill() fills an array with num entries of the value of the value 
parameter, keys starting at the start_index parameter. Note that num must 
be a number greater than zero, or PHP will throw a warning. 
Example 1. array_fill() example
  <?php
  $a = array_fill(5, 6, 'banana');
  print_r($a);
  ?> 

$a now is: 
Array
(
[5]  => banana
[6]  => banana
[7]  => banana
[8]  => banana
[9]  => banana
[10] => banana
)
See also str_repeat() and range().   array_diffUparray_filter
#

#T=array array_fill ( int start_index, int num, mixed value)
array_fill ( ^!int start_index, int num, mixed value);
#

#T=array_filter - array array_filter ( array input [, callback callback])
(PHP 4 >= 4.0.6)
array_filter --  Filters elements of an array using a callback function 
Description
array array_filter ( array input [, callback callback])
array_filter() iterates over each value in the input array passing them to 
the callback function. If the callback function returns true, the current 
value from input is returned into the result array. Array keys are 
preserved. 
Example 1. array_filter() example
  <?php
  function odd($var) {
      return($var % 2 == 1);
  }

  function even($var) {
      return($var % 2 == 0);
  }

  $array1 = array("a"=>1, "b"=>2, "c"=>3, "d"=>4, "e"=>5);
  $array2 = array(6, 7, 8, 9, 10, 11, 12);

  echo "Odd :\n";
  print_r(array_filter($array1, "odd"));
  echo "Even:\n";
  print_r(array_filter($array2, "even"));
  ?> 

The printout of the program above will be: 
  Odd :
  Array
  (
      [a] => 1
      [c] => 3
      [e] => 5
  )
  Even:
  Array
  (
      [0] => 6
      [2] => 8
      [4] => 10
      [6] => 12
  ) 
Users may not change the array itself from the callback function. e.g. 
Add/delete an element, unset the array that array_filter() is applied to. 
If the array is changed, the behavior of this function is undefined. 
If the callback function is not supplied, array_filter() will remove all 
the entries of input that are equal to FALSE. See converting to boolean 
for more information. 
Example 2. array_filter() without callback
  <?php

  $entry = array(
	       0 => 'foo',
	       1 => false,
	       2 => -1,
	       3 => null,
	       4 => ''
	    );

  print_r(array_filter($entry));
  ?> 

This will output : 
Array
(
[0] => foo
[2] => -1
)
See also array_map(), array_reduce(), and array_walk().   array_fillUparray_flip
#

#T=array array_filter ( array input [, callback callback])
array_filter ( ^!array input [, callback callback]);
#

#T=array_flip - array array_flip ( array trans)
(PHP 4 )
array_flip -- Exchanges all keys with their associated values in an array
Description
array array_flip ( array trans)
array_flip() returns an array in flip order, i.e. keys from trans become 
values and values from trans become keys. 
Note that the values of trans need to be valid keys, i.e. they need to be 
either integer or string. A warning will be emitted if a value has the 
wrong type, and the key/value pair in question will not be flipped. 
If a value has several occurrences, the latest key will be used as its 
values, and all others will be lost. 
array_flip() returns FALSE if it fails. 
Example 1. array_flip() example
  <?php
  $trans = array_flip($trans);
  $original = strtr($str, $trans);
  ?> 
Example 2. array_flip() example : collision
  <?php
  $trans = array("a" => 1, "b" => 1, "c" => 2);
  $trans = array_flip($trans);
  print_r($trans);
  ?> 

now $trans is: 
Array
(
[1] => b
[2] => c
)
See also array_values(), array_keys(), and array_reverse().   array_filterUparray_intersect_assoc
#

#T=array array_flip ( array trans)
array_flip ( ^!array trans);
#

#T=array_intersect_assoc - array array_intersect_assoc ( array array1, array array2 [, array ...])
(PHP 4 >= 4.3.0)
array_intersect_assoc -- Computes the intersection of arrays with 
additional index check
Description
array array_intersect_assoc ( array array1, array array2 [, array ...])
array_intersect_assoc() returns an array containing all the values of 
array1 that are present in all the arguments. Note that the keys are used 
in the comparison unlike in array_intersect(). 
Example 1. array_intersect_assoc() example
  <?php
  $array1 = array("a" => "green", "b" => "brown", "c" => "blue", 
  "red");
  $array2 = array("a" => "green", "yellow", "red");
  $result_array = array_intersect_assoc($array1, $array2);
  ?> 

$result_array will look like: 
Array
(
[a] => green
)
In our example you see that only the pair "a" => "green" is present in 
both arrays and thus is returned. The value "red" is not returned because 
in $array1 it's key is 0 while the key of "red" in $array2 is 1. 
The two values from the key => value pairs are considered equal only if 
(string) $elem1 === (string) $elem2 . In otherwords a strict type check is 
executed so the string representation must be the same. 
See also array_intersect(), array_diff() and array_diff_assoc().   array_flipUparray_intersect
#

#T=array array_intersect_assoc ( array array1, array array2 [, array ...])
array_intersect_assoc ( ^!array array1, array array2 [, array ...]);
#

#T=array_intersect - array array_intersect ( array array1, array array2 [, array ...])
(PHP 4 >= 4.0.1)
array_intersect -- Computes the intersection of arrays
Description
array array_intersect ( array array1, array array2 [, array ...])
array_intersect() returns an array containing all the values of array1 
that are present in all the arguments. Note that keys are preserved. 
Example 1. array_intersect() example
  <?php
  $array1 = array("a" => "green", "red", "blue");
  $array2 = array("b" => "green", "yellow", "red");
  $result = array_intersect($array1, $array2);
  ?> 

This makes $result have 
  Array
  (
      [a] => green
      [0] => red
  ) 
Note: Two elements are considered equal if and only if (string) $elem1 
=== (string) $elem2. In words: when the string representation is the 
same. 
See also array_intersect_assoc(), array_diff(), and array_diff_assoc().   array_intersect_assocUparray_key_exists
#

#T=array array_intersect ( array array1, array array2 [, array ...])
array_intersect ( ^!array array1, array array2 [, array ...]);
#

#T=array_key_exists - bool array_key_exists ( mixed key, array search)
(PHP 4 >= 4.1.0)
array_key_exists -- Checks if the given key or index exists in the array
Description
bool array_key_exists ( mixed key, array search)
array_key_exists() returns TRUE if the given key is set in the array. key 
can be any value possible for an array index. 
Example 1. array_key_exists() example
  <?php
  $search_array = array("first" => 1, "second" => 4);
  if (array_key_exists("first", $search_array)) {
      echo "The 'first' element is in the array";
  }
  ?> 
Note: The name of this function is key_exists() in PHP version 4.0.6. 
See also isset(), array_keys(), and in_array().   array_intersectUparray_keys
#

#T=bool array_key_exists ( mixed key, array search)
array_key_exists ( ^!mixed key, array search);
#

#T=array_keys - array array_keys ( array input [, mixed search_value])
(PHP 4 )
array_keys -- Return all the keys of an array
Description
array array_keys ( array input [, mixed search_value])
array_keys() returns the keys, numeric and string, from the input array. 
If the optional search_value is specified, then only the keys for that 
value are returned. Otherwise, all the keys from the input are returned. 
Example 1. array_keys() example
  <?php
  $array = array(0 => 100, "color" => "red");
  print_r(array_keys($array));

  $array = array("blue", "red", "green", "blue", "blue");
  print_r(array_keys($array, "blue"));

  $array = array("color" => array("blue", "red", "green"),
		 "size"  => array("small", "medium", "large"));
  print_r(array_keys($array));
  ?> 

The printout of the program above will be: 
Array
(
[0] => 0
[1] => color
)
Array
(
[0] => 0
[1] => 3
[2] => 4
)
Array
(
[0] => color
[1] => size
)
See also array_values() and array_key_exists().   array_key_existsUparray_map
#

#T=array array_keys ( array input [, mixed search_value])
array_keys ( ^!array input [, mixed search_value]);
#

#T=array_map - array array_map ( mixed callback, array arr1 [, array ...])
(PHP 4 >= 4.0.6)
array_map --  Applies the callback to the elements of the given arrays 
Description
array array_map ( mixed callback, array arr1 [, array ...])
array_map() returns an array containing all the elements of arr1 after 
applying the callback function to each one. The number of parameters that 
the callback function accepts should match the number of arrays passed to 
the array_map() 
Example 1. array_map() example
  <?php
  function cube($n) {
      return($n * $n * $n);
  }

  $a = array(1, 2, 3, 4, 5);
  $b = array_map("cube", $a);
  print_r($b);
  ?> 

This makes $b have: 
Array
(
[0] => 1
[1] => 8
[2] => 27
[3] => 64
[4] => 125
)
Example 2. array_map() - using more arrays
  <?php
  function show_Spanish($n, $m) {
      return("The number $n is called $m in Spanish");
  }

  function map_Spanish($n, $m) {
      return(array($n => $m));
  }

  $a = array(1, 2, 3, 4, 5);
  $b = array("uno", "dos", "tres", "cuatro", "cinco");

  $c = array_map("show_Spanish", $a, $b);
  print_r($c);

  $d = array_map("map_Spanish", $a , $b);
  print_r($d);
  ?> 

This results: 
// printout of $c
Array
(
[0] => The number 1 is called uno in Spanish
[1] => The number 2 is called dos in Spanish
[2] => The number 3 is called tres in Spanish
[3] => The number 4 is called cuatro in Spanish
[4] => The number 5 is called cinco in Spanish
)

// printout of $d
Array
(
[0] => Array
(
[1] => uno
)

[1] => Array
(
[2] => dos
)

[2] => Array
(
[3] => tres
)

[3] => Array
(
[4] => cuatro
)

[4] => Array
(
[5] => cinco
)

)
Usually when using two or more arrays, they should be of equal length 
because the callback function is applied in parallel to the corresponding 
elements. If the arrays are of unequal length, the shortest one will be 
extended with empty elements. 
An interesting use of this function is to construct an array of arrays, 
which can be easily performed by using NULL as the name of the callback 
function 
Example 3. Creating an array of arrays
  <?php
  $a = array(1, 2, 3, 4, 5);
  $b = array("one", "two", "three", "four", "five");
  $c = array("uno", "dos", "tres", "cuatro", "cinco");

  $d = array_map(null, $a, $b, $c);
  print_r($d);
  ?> 
The printout of the program above will be: 
Array
(
[0] => Array
(
[0] => 1
[1] => one
[2] => uno
)

[1] => Array
(
[0] => 2
[1] => two
[2] => dos
)

[2] => Array
(
[0] => 3
[1] => three
[2] => tres
)

[3] => Array
(
[0] => 4
[1] => four
[2] => cuatro
)

[4] => Array
(
[0] => 5
[1] => five
[2] => cinco
)

)

See also array_filter(), array_reduce(), and array_walk().   array_keysUparray_merge_recursive
#

#T=array array_map ( mixed callback, array arr1 [, array ...])
array_map ( ^!mixed callback, array arr1 [, array ...]);
#

#T=array_merge_recursive - array array_merge_recursive ( array array1, array array2 [, array ...])
(PHP 4 >= 4.0.1)
array_merge_recursive -- Merge two or more arrays recursively
Description
array array_merge_recursive ( array array1, array array2 [, array ...])
array_merge_recursive() merges the elements of two or more arrays together 
so that the values of one are appended to the end of the previous one. It 
returns the resulting array. 
If the input arrays have the same string keys, then the values for these 
keys are merged together into an array, and this is done recursively, so 
that if one of the values is an array itself, the function will merge it 
with a corresponding entry in another array too. If, however, the arrays 
have the same numeric key, the later value will not overwrite the original 
value, but will be appended. 
Example 1. array_merge_recursive() example
  <?php
  $ar1 = array("color" => array("favorite" => "red"), 5);
  $ar2 = array(10, "color" => array("favorite" => "green", 
  "blue"));
  $result = array_merge_recursive($ar1, $ar2);
  ?> 

The $result will be: 
  Array
  (
      [color] => Array
	  (
	      [favorite] => Array
		  (
		      [0] => red
		      [1] => green
		  )

	      [0] => blue
	  )

      [0] => 5
      [1] => 10
  ) 
See also array_merge().   array_mapUparray_merge
#

#T=array array_merge_recursive ( array array1, array array2 [, array ...])
array_merge_recursive ( ^!array array1, array array2 [, array ...]);
#

#T=array_merge - array array_merge ( array array1, array array2 [, array ...])
(PHP 4 )
array_merge -- Merge two or more arrays
Description
array array_merge ( array array1, array array2 [, array ...])
array_merge() merges the elements of two or more arrays together so that 
the values of one are appended to the end of the previous one. It returns 
the resulting array. 
If the input arrays have the same string keys, then the later value for 
that key will overwrite the previous one. If, however, the arrays contain 
numeric keys, the later value will not overwrite the original value, but 
will be appended. 
Example 1. array_merge() example
  <?php
  $array1 = array("color" => "red", 2, 4);
  $array2 = array("a", "b", "color" => "green", "shape" => 
  "trapezoid", 4);
  $result = array_merge($array1, $array2);
  print_r($result);
  ?> 

The $result is: 
  Array
  (
      [color] => green
      [0] => 2
      [1] => 4
      [2] => a
      [3] => b
      [shape] => trapezoid
      [4] => 4
  ) 
Example 2. Simple array_merge() example
  <?php
  $array1 = array();
  $array2 = array(1 => "data");
  $result = array_merge($array1, $array2);
  ?> 

Don't forget that numeric keys will be renumbered! 
  Array
  (
      [0] => data
  ) 

If you want to completely preserve the arrays and just want to 
append them to each other, use the + operator: 
  <?php
  $array1 = array();
  $array2 = array(1 => "data");
  $result = $array1 + $array2;
  ?> 

The numeric key will be preserved and thus the association remains. 
  Array
  (
      [1] => data
  ) 
Note: Shared keys will be overwritten on a first-come first-served 
basis. 
See also array_merge_recursive() and array_combine().   array_merge_recursiveUparray_multisort
#

#T=array array_merge ( array array1, array array2 [, array ...])
array_merge ( ^!array array1, array array2 [, array ...]);
#

#T=array_multisort - bool array_multisort ( array ar1 [, mixed arg [, mixed ... [, array 
(PHP 4 )
array_multisort -- Sort multiple or multi-dimensional arrays
Description
bool array_multisort ( array ar1 [, mixed arg [, mixed ... [, array 
...]]])
array_multisort() can be used to sort several arrays at once or a 
multi-dimensional array according by one of more dimensions. It maintains 
key association when sorting. 
The input arrays are treated as columns of a table to be sorted by rows - 
this resembles the functionality of SQL ORDER BY clause. The first array 
is the primary one to sort by. The rows (values) in that array that 
compare the same are sorted by the next input array, and so on. 
The argument structure of this function is a bit unusual, but flexible. 
The very first argument has to be an array. Subsequently, each argument 
can be either an array or a sorting flag from the following lists. 
Sorting order flags: 
SORT_ASC - sort in ascending order
SORT_DESC - sort in descending order
Sorting type flags: 
SORT_REGULAR - compare items normally
SORT_NUMERIC - compare items numerically
SORT_STRING - compare items as strings
No two sorting flags of the same type can be specified after each array. 
The sorting flags specified after an array argument apply only to that 
array - they are reset to default SORT_ASC and SORT_REGULAR before each 
new array argument. 
Returns TRUE on success or FALSE on failure. 
Example 1. Sorting multiple arrays
  <?php
  $ar1 = array("10", 100, 100, "a");
  $ar2 = array(1, 3, "2", 1);
  array_multisort($ar1, $ar2);
  ?> 
In this example, after sorting, the first array will contain 10, "a", 100, 
100. The second array will contain 1, 1, "2", 3. The entries in the second 
array corresponding to the identical entries in the first array (100 and 
100) were sorted as well. 
Example 2. Sorting multi-dimensional array
  <?php
  $ar = array(array("10", 100, 100, "a"), array(1, 3, "2", 1));
  array_multisort($ar[0], SORT_ASC, SORT_STRING,
		  $ar[1], SORT_NUMERIC, SORT_DESC);
  ?> 
In this example, after sorting, the first array will contain 10, 100, 100, 
"a" (it was sorted as strings in ascending order), and the second one will 
contain 1, 3, "2", 1 (sorted as numbers, in descending order).   array_mergeUparray_pad
#

#T=bool array_multisort ( array ar1 [, mixed arg [, mixed ... [, array 
array_multisort ( ^!array ar1 [, mixed arg [, mixed ... [, array ;
#

#T=array_pad - array array_pad ( array input, int pad_size, mixed pad_value)
(PHP 4 )
array_pad --  Pad array to the specified length with a value 
Description
array array_pad ( array input, int pad_size, mixed pad_value)
array_pad() returns a copy of the input padded to size specified by 
pad_size with value pad_value. If pad_size is positive then the array is 
padded on the right, if it's negative then on the left. If the absolute 
value of pad_size is less than or equal to the length of the input then no 
padding takes place. 
Example 1. array_pad() example
  <?php
  $input = array(12, 10, 9);

  $result = array_pad($input, 5, 0);
  // result is array(12, 10, 9, 0, 0)

  $result = array_pad($input, -7, -1);
  // result is array(-1, -1, -1, -1, 12, 10, 9)

  $result = array_pad($input, 2, "noop");
  // not padded
  ?> 
See also array_fill() and range().   array_multisortUparray_pop
#

#T=array array_pad ( array input, int pad_size, mixed pad_value)
array_pad ( ^!array input, int pad_size, mixed pad_value);
#

#T=array_pop - mixed array_pop ( array array)
(PHP 4 )
array_pop -- Pop the element off the end of array
Description
mixed array_pop ( array array)
array_pop() pops and returns the last value of the array, shortening the 
array by one element. If array is empty (or is not an array), NULL will be 
returned. 
Note: This function will reset() the array pointer after use.
Example 1. array_pop() example
  <?php
  $stack = array("orange", "banana", "apple", "raspberry");
  $fruit = array_pop($stack);
  print_r($stack);
  ?> 

After this, $stack will have only 3 elements: 
  Array
  (
      [0] => orange
      [1] => banana
      [2] => apple
  ) 

and raspberry will be assigned to $fruit. 

Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

See also array_push(), array_shift(), and array_unshift().   array_padUparray_push
#

#T=mixed array_pop ( array array)
array_pop ( ^!array array);
#

#T=array_push - int array_push ( array array, mixed var [, mixed ...])
(PHP 4 )
array_push --  Push one or more elements onto the end of array 
Description
int array_push ( array array, mixed var [, mixed ...])
array_push() treats array as a stack, and pushes the passed variables onto 
the end of array. The length of array increases by the number of variables 
pushed. Has the same effect as: <?php
$array[] = $var;
?> 
repeated for each var. 
Returns the new number of elements in the array. 
Example 1. array_push() example
  <?php
  $stack = array("orange", "banana");
  array_push($stack, "apple", "raspberry");
  print_r($stack);
  ?> 

This example would result in $stack having the following elements: 
  Array
  (
      [0] => orange
      [1] => banana
      [2] => apple
      [3] => raspberry
  ) 
See also array_pop(), array_shift(), and array_unshift().   array_popUparray_rand
#

#T=int array_push ( array array, mixed var [, mixed ...])
array_push ( ^!array array, mixed var [, mixed ...]);
#

#T=array_rand - mixed array_rand ( array input [, int num_req])
(PHP 4 )
array_rand --  Pick one or more random entries out of an array 
Description
mixed array_rand ( array input [, int num_req])
array_rand() is rather useful when you want to pick one or more random 
entries out of an array. It takes an input array and an optional argument 
num_req which specifies how many entries you want to pick - if not 
specified, it defaults to 1. 
If you are picking only one entry, array_rand() returns the key for a 
random entry. Otherwise, it returns an array of keys for the random 
entries. This is done so that you can pick random keys as well as values 
out of the array. 
Note: As of PHP 4.2.0, there is no need to seed the random number 
generator with srand() or mt_srand() as this is now done automatically. 
Example 1. array_rand() example
  <?php
  srand((float) microtime() * 10000000);
  $input = array("Neo", "Morpheus", "Trinity", "Cypher", 
"Tank");
  $rand_keys = array_rand($input, 2);
  echo $input[$rand_keys[0]] . "\n";
  echo $input[$rand_keys[1]] . "\n";
  ?> 
See also shuffle().   array_pushUparray_reduce
#

#T=mixed array_rand ( array input [, int num_req])
array_rand ( ^!array input [, int num_req]);
#

#T=array_reduce - mixed array_reduce ( array input, callback function [, int initial])
(PHP 4 >= 4.0.5)
array_reduce --  Iteratively reduce the array to a single value using a 
callback function 
Description
mixed array_reduce ( array input, callback function [, int initial])
array_reduce() applies iteratively the function function to the elements 
of the array input, so as to reduce the array to a single value. If the 
optional initial is available, it will be used at the beginning of the 
process, or as a final result in case the array is empty. 
Example 1. array_reduce() example
  <?php
  function rsum($v, $w) {
      $v += $w;
      return $v;
  }

  function rmul($v, $w) {
      $v *= $w;
      return $v;
  }

  $a = array(1, 2, 3, 4, 5);
  $x = array();
  $b = array_reduce($a, "rsum");
  $c = array_reduce($a, "rmul", 10);
  $d = array_reduce($x, "rsum", 1);
  ?> 
This will result in $b containing 15, $c containing 1200 (= 1*2*3*4*5*10), 
and $d containing 1. 
See also array_filter(), array_map(), array_unique(), and 
array_count_values().   array_randUparray_reverse
#

#T=mixed array_reduce ( array input, callback function [, int initial])
array_reduce ( ^!array input, callback function [, int initial]);
#

#T=array_reverse - array array_reverse ( array array [, bool preserve_keys])
(PHP 4 )
array_reverse --  Return an array with elements in reverse order 
Description
array array_reverse ( array array [, bool preserve_keys])
array_reverse() takes input array and returns a new array with the order 
of the elements reversed, preserving the keys if preserve_keys is TRUE. 
Example 1. array_reverse() example
  <?php
  $input  = array("php", 4.0, array("green", "red"));
  $result = array_reverse($input);
  $result_keyed = array_reverse($input, true);
  ?> 

This makes both $result and $result_keyed have the same elements, 
but note the difference between the keys. The printout of $result 
and $result_keyed will be: 
  Array
  (
      [0] => Array
	  (
	      [0] => green
	      [1] => red
	  )

      [1] => 4
      [2] => php
  )
  Array
  (
      [2] => Array
	  (
	      [0] => green
	      [1] => red
	  )

      [1] => 4
      [0] => php
  ) 
Note: The second parameter was added in PHP 4.0.3. 
See also array_flip().   array_reduceUparray_search
#

#T=array array_reverse ( array array [, bool preserve_keys])
array_reverse ( ^!array array [, bool preserve_keys]);
#

#T=array_search - mixed array_search ( mixed needle, array haystack [, bool strict])
(PHP 4 >= 4.0.5)
array_search --  Searches the array for a given value and returns the 
corresponding key if successful 
Description
mixed array_search ( mixed needle, array haystack [, bool strict])
Searches haystack for needle and returns the key if it is found in the 
array, FALSE otherwise. 
Note: If needle is a string, the comparison is done in a case-sensitive 
manner. 
Note: Prior to PHP 4.2.0, array_search() returns NULL on failure instead 
of FALSE. 
If the optional third parameter strict is set to TRUE then the 
array_search() will also check the types of the needle in the haystack. 
If needle is found in haystack more than once, the first matching key is 
returned. To return the keys for all matching values, use array_keys() 
with the optional search_value parameter instead. 
Example 1. array_search() example
  <?php
  $array = array(0 => 'blue', 1 => 'red', 2 => 'green', 3 => 
  'red');

  $key = array_search('green', $array); // $key = 2;
  $key = array_search('red', $array);   // $key = 1;
  ?> 
Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

See also array_keys(), array_values(), array_key_exists(), and in_array(). 
  array_reverseUparray_shift
#

#T=mixed array_search ( mixed needle, array haystack [, bool strict])
array_search ( ^!mixed needle, array haystack [, bool strict]);
#

#T=array_shift - mixed array_shift ( array array)
(PHP 4 )
array_shift --  Shift an element off the beginning of array 
Description
mixed array_shift ( array array)
array_shift() shifts the first value of the array off and returns it, 
shortening the array by one element and moving everything down. All 
numerical array keys will be modified to start counting from zero while 
literal keys won't be touched. If array is empty (or is not an array), 
NULL will be returned. 
Note: This function will reset() the array pointer after use.
Example 1. array_shift() example
  <?php
  $stack = array("orange", "banana", "apple", "raspberry");
  $fruit = array_shift($stack);
  print_r($stack);
  ?> 

This would result in $stack having 3 elements left: 
  Array
  (
      [0] => banana
      [1] => apple
      [2] => raspberry
  ) 

and orange will be assigned to $fruit. 

See also array_unshift(), array_push(), and array_pop().   array_searchUparray_slice
#

#T=mixed array_shift ( array array)
array_shift ( ^!array array);
#

#T=array_slice - array array_slice ( array array, int offset [, int length])
(PHP 4 )
array_slice -- Extract a slice of the array
Description
array array_slice ( array array, int offset [, int length])
array_slice() returns the sequence of elements from the array array as 
specified by the offset and length parameters. 
If offset is positive, the sequence will start at that offset in the 
array. If offset is negative, the sequence will start that far from the 
end of the array. 
If length is given and is positive, then the sequence will have that many 
elements in it. If length is given and is negative then the sequence will 
stop that many elements from the end of the array. If it is omitted, then 
the sequence will have everything from offset up until the end of the 
array. 
Note that array_slice() will ignore array keys, and will calculate offsets 
and lengths based on the actual positions of elements within the array. 
Example 1. array_slice() examples
  <?php
  $input = array("a", "b", "c", "d", "e");

  $output = array_slice($input, 2);      // returns "c", "d", 
  and "e"
  $output = array_slice($input, 2, -1);  // returns "c", "d"
  $output = array_slice($input, -2, 1);  // returns "d"
  $output = array_slice($input, 0, 3);   // returns "a", "b", 
  and "c"
  ?> 
See also array_splice() and unset().   array_shiftUparray_splice
#

#T=array array_slice ( array array, int offset [, int length])
array_slice ( ^!array array, int offset [, int length]);
#

#T=array_splice - array array_splice ( array input, int offset [, int length [, array 
(PHP 4 )
array_splice --  Remove a portion of the array and replace it with 
something else 
Description
array array_splice ( array input, int offset [, int length [, array 
replacement]])
array_splice() removes the elements designated by offset and length from 
the input array, and replaces them with the elements of the replacement 
array, if supplied. It returns an array containing the extracted elements. 

If offset is positive then the start of removed portion is at that offset 
from the beginning of the input array. If offset is negative then it 
starts that far from the end of the input array. 
If length is omitted, removes everything from offset to the end of the 
array. If length is specified and is positive, then that many elements 
will be removed. If length is specified and is negative then the end of 
the removed portion will be that many elements from the end of the array. 
Tip: to remove everything from offset to the end of the array when 
replacement is also specified, use count($input) for length. 
If replacement array is specified, then the removed elements are replaced 
with elements from this array. If offset and length are such that nothing 
is removed, then the elements from the replacement array are inserted in 
the place specified by the offset. Tip: if the replacement is just one 
element it is not necessary to put array() around it, unless the element 
is an array itself. 
The following equivalences hold: 
Table 1. array_splice() equivalents
array_push($input, $x, $y) array_splice($input, count($input), 0, 
array($x, $y)) 
array_pop($input) array_splice($input, -1) 
array_shift($input) array_splice($input, -1) 
array_unshift($input, $x, $y) array_splice($input, 0, 0, array($x, 
$y)) 
$a[$x] = $y array_splice($input, $x, 1, $y) 

Returns the array consisting of removed elements. 
Example 1. array_splice() examples
  <?php
  $input = array("red", "green", "blue", "yellow");
  array_splice($input, 2);
  // $input is now array("red", "green")

  $input = array("red", "green", "blue", "yellow");
  array_splice($input, 1, -1);
  // $input is now array("red", "yellow")

  $input = array("red", "green", "blue", "yellow");
  array_splice($input, 1, count($input), "orange");
  // $input is now array("red", "orange")

  $input = array("red", "green", "blue", "yellow");
  array_splice($input, -1, 1, array("black", "maroon"));
  // $input is now array("red", "green",
  //          "blue", "black", "maroon")

  $input = array("red", "green", "blue", "yellow");
  array_splice($input, 3, 0, "purple");
  // $input is now array("red", "green",
  //          "blue", "purple", "yellow");
  ?> 
See also array_slice(), unset(), and array_merge().   array_sliceUparray_sum
#

#T=array array_splice ( array input, int offset [, int length [, array 
array_splice ( ^!array input, int offset [, int length [, array ;
#

#T=array_sum - mixed array_sum ( array array)
(PHP 4 >= 4.0.4)
array_sum --  Calculate the sum of values in an array. 
Description
mixed array_sum ( array array)
array_sum() returns the sum of values in an array as an integer or float. 
Example 1. array_sum() examples
  <?php
  $a = array(2, 4, 6, 8);
  echo "sum(a) = " . array_sum($a) . "\n";

  $b = array("a" => 1.2, "b" => 2.3, "c" => 3.4);
  echo "sum(b) = " . array_sum($b) . "\n";
  ?> 

The printout of the program above will be: 
sum(a) = 20
sum(b) = 6.9
Note: PHP versions prior to 4.2.1 modified the passed array itself and 
converted strings to numbers (which most of the time converted them to 
zero, depending on their value).   array_spliceUparray_udiff_assoc
array_udiff_assoc
(no version information, might be only in CVS)
array_udiff_assoc -- Computes the difference of arrays with additional 
index check. The data is compared by using a callback function.
Description
array array_udiff_assoc ( array array1, array array2 [, array ..., 
callback data_compare_func])
array_udiff_assoc() returns an array containing all the values from array1 
that are not present in any of the other arguments. Note that the keys are 
used in the comparison unlike array_diff() and array_udiff(). The 
comparison of arrays' data is performed by using an user-supplied 
callback. In this aspect the behaviour is opposite to the behaviour of 
array_diff_assoc() which uses internal function for comparison. 
Example 1. array_udiff_assoc() example
  <?php
  class cr {
      var $priv_member;
      function cr($val) {
	  $this->priv_member = $val;
      }
      function comp_func_cr($a, $b) {
	  if ($a->priv_member === $b->priv_member) return 0;
	  return ($a->priv_member > $b->priv_member)? 1:-1;
      }
  }
  $a = array("0.1" => new cr(9), "0.5" => new cr(12), 0 => new 
  cr(23), 1=> new cr(4), 2 => new cr(-15),);
  $b = array("0.2" => new cr(9), "0.5" => new cr(22), 0 => new 
  cr(3), 1=> new cr(4), 2 => new cr(-15),);

  $result = array_udiff_assoc($a, $b, array("cr", 
  "comp_func_cr"));
  print_r($result);
  ?> 

The result is: 
Array
(
[0.1] => cr Object
(
[priv_member:private] => 9
)

[0.5] => cr Object
(
[priv_member:private] => 12
)

[0] => cr Object
(
[priv_member:private] => 23
)
)
In our example above you see the "1" => new cr(4) pair is present in both 
arrays and thus it is not in the ouput from the function. 
For comparison is used the user supplied callback function. It must return 
an integer less than, equal to, or greater than zero if the first argument 
is considered to be respectively less than, equal to, or greater than the 
second. 
Note: Please note that this function only checks one dimension of a 
n-dimensional array. Of course you can check deeper dimensions by using, 
for example, array_udiff_assoc($array1[0], $array2[0], 
"some_comparison_func");. 
See also array_diff(), array_diff_assoc(), array_diff_uassoc(), 
array_udiff(), array_udiff_uassoc(), array_intersect(), 
array_intersect_assoc(), array_uintersect(), array_uintersect_assoc() and 
array_uintersect_uassoc().   array_sumUparray_udiff_uassoc
array_udiff_uassoc
(no version information, might be only in CVS)
array_udiff_uassoc -- Computes the difference of arrays with additional 
index check. The data is compared by using a callback function. The index 
check is done by a callback function also
Description
array array_udiff_uassoc ( array array1, array array2 [, array ..., 
callback data_compare_func, callback key_compare_func])
array_udiff_uassoc() returns an array containing all the values from 
array1 that are not present in any of the other arguments. Note that the 
keys are used in the comparison unlike array_diff() and array_udiff(). The 
comparison of arrays' data is performed by using an user-supplied callback 
: data_compare_func. In this aspect the behaviour is opposite to the 
behaviour of array_diff_assoc() which uses internal function for 
comparison. The comparison of keys (indices) is done also by the callback 
function key_compare_func. This behaviour is unlike what 
array_udiff_assoc() does, since the latter compares the indices by using 
an internal function. 
Example 1. array_udiff_uassoc() example
  <?php
  class cr {
      var $priv_member;
      function cr($val) {
	  $this->priv_member = $val;
      }
      function comp_func_cr($a, $b) {
	  if ($a->priv_member === $b->priv_member) return 0;
	  return ($a->priv_member > $b->priv_member)? 1:-1;
      }
      function comp_func_key($a, $b) {
	  if ($a === $b) return 0;
	  return ($a > $b)? 1:-1;
      }
  }
  $a = array("0.1" => new cr(9), "0.5" => new cr(12), 0 => new 
  cr(23), 1=> new cr(4), 2 => new cr(-15),);
  $b = array("0.2" => new cr(9), "0.5" => new cr(22), 0 => new 
  cr(3), 1=> new cr(4), 2 => new cr(-15),);

  $result = array_udiff_uassoc($a, $b, array("cr", 
  "comp_func_cr"), array("cr", "comp_func_key"));
  print_r($result);
  ?> 

The result is: 
Array
(
[0.1] => cr Object
(
[priv_member:private] => 9
)

[0.5] => cr Object
(
[priv_member:private] => 12
)

[0] => cr Object
(
[priv_member:private] => 23
)
)
In our example above you see the "1" => new cr(4) pair is present in both 
arrays and thus it is not in the ouput from the function. Keep in mind 
that you have to supply 2 callback functions. 
For comparison is used the user supplied callback function. It must return 
an integer less than, equal to, or greater than zero if the first argument 
is considered to be respectively less than, equal to, or greater than the 
second. 
Note: Please note that this function only checks one dimension of a 
n-dimensional array. Of course you can check deeper dimensions by using, 
for example, array_udiff_uassoc($array1[0], $array2[0], 
"data_compare_func", "key_compare_func");. 
See also array_diff(), array_diff_assoc(), array_diff_uassoc(), 
array_udiff(), array_udiff_assoc(), array_intersect(), 
array_intersect_assoc(), array_uintersect(), array_uintersect_assoc() and 
array_uintersect_uassoc().   array_udiff_assocUparray_udiff
array_udiff
(no version information, might be only in CVS)
array_udiff -- Computes the difference of arrays by using a callback 
function for data comparison.
Description
array array_udiff ( array array1, array array2 [, array ..., callback 
data_compare_func])
array_udiff() returns an array containing all the values of array1 that 
are not present in any of the other arguments. Note that keys are 
preserved. For the comparison of the data data_compare_func is used. It 
must return an integer less than, equal to, or greater than zero if the 
first argument is considered to be respectively less than, equal to, or 
greater than the second. This is unlike array_diff() which uses an 
internal function for comparing the data. 
Example 1. array_udiff() example
  <?php
  class cr {
      var $priv_member;
      function cr($val) {
	  $this->priv_member = $val;
      }
      function comp_func_cr($a, $b) {
	  if ($a->priv_member === $b->priv_member) return 0;
	  return ($a->priv_member > $b->priv_member)? 1:-1;
      }
  }
  $a = array("0.1" => new cr(9), "0.5" => new cr(12), 0 => new 
  cr(23), 1=> new cr(4), 2 => new cr(-15),);
  $b = array("0.2" => new cr(9), "0.5" => new cr(22), 0 => new 
  cr(3), 1=> new cr(4), 2 => new cr(-15),);

  $result = array_udiff($a, $b, array("cr", "comp_func_cr"));
  print_r($result);
  ?> 

The result is: 
Array
(
[0.5] => cr Object
(
[priv_member:private] => 12
)

[0] => cr Object
(
[priv_member:private] => 23
)

)
Note: Two elements are considered equal if and only if (string) $elem1 
=== (string) $elem2. In words: when the string representation is the 
same. 
Note: Please note that this function only checks one dimension of a 
n-dimensional array. Of course you can check deeper dimensions by using 
array_udiff($array1[0], $array2[0], "data_compare_func");. 
See also array_diff(), array_diff_assoc(), array_diff_uassoc(), 
array_udiff_assoc(), array_udiff_uassoc(), array_intersect(), 
array_intersect_assoc(), array_uintersect(), array_uintersect_assoc() and 
array_uintersect_uassoc().   array_udiff_uassocUparray_unique
#

#T=mixed array_sum ( array array)
array_sum ( ^!array array);
#

#T=array_unique - array array_unique ( array array)
(PHP 4 >= 4.0.1)
array_unique -- Removes duplicate values from an array
Description
array array_unique ( array array)
array_unique() takes input array and returns a new array without duplicate 
values. 
Note that keys are preserved. array_unique() sorts the values treated as 
string at first, then will keep the first key encountered for every value, 
and ignore all following keys. It does not mean that the key of the first 
related value from the unsorted array will be kept. 
Note: Two elements are considered equal if and only if (string) $elem1 
=== (string) $elem2. In words: when the string representation is the 
same. 
The first element will be used. 
Example 1. array_unique() example
  <?php
  $input = array("a" => "green", "red", "b" => "green", "blue", 
  "red");
  $result = array_unique($input);
  print_r($result);
  ?> 

This will output: 
  Array
  (
      [a] => green
      [0] => red
      [1] => blue
  ) 
Example 2. array_unique() and types
  <?php
  $input = array(4, "4", "3", 4, 3, "3");
  $result = array_unique($input);
  var_dump($result);
  ?> 

This script will output: 
  array(2) {
    [0] => int(4)
    [2] => string(1) "3"
  } 

  array_udiffUparray_unshift
#

#T=array array_unique ( array array)
array_unique ( ^!array array);
#

#T=array_unshift - int array_unshift ( array array, mixed var [, mixed ...])
(PHP 4 )
array_unshift --  Prepend one or more elements to the beginning of an 
array 
Description
int array_unshift ( array array, mixed var [, mixed ...])
array_unshift() prepends passed elements to the front of the array. Note 
that the list of elements is prepended as a whole, so that the prepended 
elements stay in the same order. All numerical array keys will be modified 
to start counting from zero while literal keys won't be touched. 
Returns the new number of elements in the array. 
Example 1. array_unshift() example
  <?php
  $queue = array("orange", "banana");
  array_unshift($queue, "apple", "raspberry");
  ?> 

This would result in $queue having the following elements: 
  Array
  (
      [0] => apple
      [1] => raspberry
      [2] => orange
      [3] => banana
  ) 
See also array_shift(), array_push(), and array_pop().   array_uniqueUparray_values
#

#T=int array_unshift ( array array, mixed var [, mixed ...])
array_unshift ( ^!array array, mixed var [, mixed ...]);
#

#T=array_values - array array_values ( array input)
(PHP 4 )
array_values -- Return all the values of an array
Description
array array_values ( array input)
array_values() returns all the values from the input array and indexes 
numerically the array. 
Example 1. array_values() example
  <?php
  $array = array("size" => "XL", "color" => "gold");
  print_r(array_values($array));
  ?> 

This will output: 
  Array
  (
      [0] => XL
      [1] => gold
  ) 
See also array_keys().   array_unshiftUparray_walk
#

#T=array array_values ( array input)
array_values ( ^!array input);
#

#T=array_walk - bool array_walk ( array array, callback function [, mixed userdata])
(PHP 3>= 3.0.3, PHP 4 )
array_walk --  Apply a user function to every member of an array 
Description
bool array_walk ( array array, callback function [, mixed userdata])
Returns TRUE on success or FALSE on failure. 
Applies the user-defined function function to each element of the array 
array. Typically, function takes on two parameters. The array parameter's 
value being the first, and the key/index second. If the optional userdata 
parameter is supplied, it will be passed as the third parameter to the 
callback function. 
If function function requires more parameters than given to it, an error 
of level E_WARNING will be generated each time array_walk() calls 
function. These warnings may be suppressed by prepending the PHP error 
operator @ to the array_walk() call, or by using error_reporting(). 
Note: If function needs to be working with the actual values of the 
array, specify the first parameter of function as a reference. Then, any 
changes made to those elements will be made in the original array 
itself. 
Note: Passing the key and userdata to function was added in 4.0.0 
array_walk() is not affected by the internal array pointer of array. 
array_walk() will walk through the entire array regardless of pointer 
position. To reset the pointer, use reset(). In PHP 3, array_walk() resets 
the pointer. 
Users may not change the array itself from the callback function. e.g. 
Add/delete elements, unset elements, etc. If the array that array_walk() 
is applied to is changed, the behavior of this function is undefined, and 
unpredictable. 
Example 1. array_walk() example
  <?php
  $fruits = array("d" => "lemon", "a" => "orange", "b" => 
  "banana", "c" => "apple");

  function test_alter(&$item1, $key, $prefix) {
      $item1 = "$prefix: $item1";
  }

  function test_print($item2, $key) {
      echo "$key. $item2<br />\n";
  }

  echo "Before ...:\n";
  array_walk($fruits, 'test_print');

  array_walk($fruits, 'test_alter', 'fruit');
  echo "... and after:\n";

  array_walk($fruits, 'test_print');
  ?> 

The printout of the program above will be: 
  Before ...:
  d. lemon
  a. orange
  b. banana
  c. apple
  ... and after:
  d. fruit: lemon
  a. fruit: orange
  b. fruit: banana
  c. fruit: apple 
See also list(), foreach, each(), and call_user_func_array().   array_valuesUparray
#

#T=bool array_walk ( array array, callback function [, mixed userdata])
array_walk ( ^!array array, callback function [, mixed userdata]);
#

#T=array - array array ( [mixed ...])
(PHP 3, PHP 4 )
array --  Create an array 
Description
array array ( [mixed ...])
Returns an array of the parameters. The parameters can be given an index 
with the => operator. Read the section on the array type for more 
information on what an array is. 
Note: array() is a language construct used to represent literal arrays, 
and not a regular function. 
Syntax "index => values", separated by commas, define index and values. 
index may be of type string or numeric. When index is omitted, an integer 
index is automatically generated, starting at 0. If index is an integer, 
next generated index will be the biggest integer index + 1. Note that when 
two identical index are defined, the last overwrite the first. 
The following example demonstrates how to create a two-dimensional array, 
how to specify keys for associative arrays, and how to skip-and-continue 
numeric indices in normal arrays. Example 1. array() example
  <?php
  $fruits = array (
      "fruits"  => array("a" => "orange", "b" => "banana", "c" 
  => "apple"),
      "numbers" => array(1, 2, 3, 4, 5, 6),
      "holes"   => array("first", 5 => "second", "third")
  )
  ?> 
Example 2. Automatic index with array()
  <?php
  $array = array(1, 1, 1, 1,  1, 8 => 1,  4 => 1, 19, 3 => 13);
  print_r($array);
  ?> 

will display: 
  Array
  (
      [0] => 1
      [1] => 1
      [2] => 1
      [3] => 13
      [4] => 1
      [8] => 1
      [9] => 19
  ) 
Note that index '3' is defined twice, and keep its final value of 13. 
Index 4 is defined after index 8, and next generated index (value 19) is 
9, since biggest index was 8. 
This example creates a 1-based array. Example 3. 1-based index with 
array()
  <?php
  $firstquarter = array(1 => 'January', 'February', 'March');
  print_r($firstquarter);
  ?> 

will display: 
Array
(
[1] => January
[2] => February
[3] => March
)
See also array_pad(), list(), foreach, and range().   array_walkUparsort
#

#T=array array ( [mixed ...])
array ( ^![mixed ...]);
#

#T=arsort - bool arsort ( array array [, int sort_flags])
(PHP 3, PHP 4 )
arsort --  Sort an array in reverse order and maintain index association 
Description
bool arsort ( array array [, int sort_flags])
This function sorts an array such that array indices maintain their 
correlation with the array elements they are associated with. This is used 
mainly when sorting associative arrays where the actual element order is 
significant. 
Returns TRUE on success or FALSE on failure. 
Example 1. arsort() example
  <?php
  $fruits = array("d" => "lemon", "a" => "orange", "b" => 
  "banana", "c" => "apple");
  arsort($fruits);
  reset($fruits);
  while (list($key, $val) = each($fruits)) {
      echo "$key = $val\n";
  }
  ?> 

This example would display: 
a = orange
d = lemon
b = banana
c = apple
The fruits have been sorted in reverse alphabetical order, and the index 
associated with each element has been maintained. 
You may modify the behavior of the sort using the optional parameter 
sort_flags, for details see sort(). 
See also asort(), rsort(), ksort(), and sort().   arrayUpasort
#

#T=bool arsort ( array array [, int sort_flags])
arsort ( ^!array array [, int sort_flags]);
#

#T=ascii2ebcdic - int ascii2ebcdic ( string ascii_str)
(PHP 3>= 3.0.17)
ascii2ebcdic -- Translate string from ASCII to EBCDIC
Description
int ascii2ebcdic ( string ascii_str)
ascii2ebcdic() is an Apache-specific function which is available only on 
EBCDIC based operating systems (OS/390, BS2000). It translates the ASCII 
encoded string ascii_str to its equivalent EBCDIC representation (binary 
safe), and returns the result. 
See also the reverse function ebcdic2ascii()   apache_setenvUpebcdic2ascii
#

#T=int ascii2ebcdic ( string ascii_str)
ascii2ebcdic ( ^!string ascii_str);
#

#T=asin - float asin ( float arg)
(PHP 3, PHP 4 )
asin -- Arc sine
Description
float asin ( float arg)
Returns the arc sine of arg in radians. asin() is the complementary 
function of sin(), which means that a==sin(asin(a)) for every value of a 
that is within asin()'s range. 
See also asinh(), acos() and atan().   acoshUpasinh
#

#T=float asin ( float arg)
asin ( ^!float arg);
#

#T=asinh - float asinh ( float arg)
(PHP 4 >= 4.1.0)
asinh -- Inverse hyperbolic sine
Description
float asinh ( float arg)
Returns the inverse hyperbolic sine of arg, i.e. the value whose 
hyperbolic sine is arg. 
Note: This function is not implemented on Windows platforms.
See also asin(), acosh() and atanh().   asinUpatan2
#

#T=float asinh ( float arg)
asinh ( ^!float arg);
#

#T=asort - bool asort ( array array [, int sort_flags])
(PHP 3, PHP 4 )
asort -- Sort an array and maintain index association
Description
bool asort ( array array [, int sort_flags])
This function sorts an array such that array indices maintain their 
correlation with the array elements they are associated with. This is used 
mainly when sorting associative arrays where the actual element order is 
significant. 
Returns TRUE on success or FALSE on failure. 
Example 1. asort() example
  <?php
  $fruits = array("d" => "lemon", "a" => "orange", "b" => 
  "banana", "c" => "apple");
  asort($fruits);
  reset($fruits);
  while (list($key, $val) = each($fruits)) {
      echo "$key = $val\n";
  }
  ?> 

This example would display: 
c = apple
b = banana
d = lemon
a = orange
The fruits have been sorted in alphabetical order, and the index 
associated with each element has been maintained. 
You may modify the behavior of the sort using the optional parameter 
sort_flags, for details see sort(). 
See also arsort(), rsort(), ksort(), and sort().   arsortUpcompact
#

#T=bool asort ( array array [, int sort_flags])
asort ( ^!array array [, int sort_flags]);
#

#T=aspell_check_raw - bool aspell_check_raw ( int dictionary_link, string word)
(PHP 3>= 3.0.7, PHP 4 <= 4.2.3)
aspell_check_raw --  Check a word without changing its case or trying to 
trim it [deprecated] 
Description
bool aspell_check_raw ( int dictionary_link, string word)
aspell_check_raw() checks the spelling of a word, without changing its 
case or trying to trim it in any way and returns TRUE if the spelling is 
correct, FALSE if not. 
Example 1. aspell_check_raw()
  <?php

  $aspell_link = aspell_new("english");

  if (aspell_check_raw($aspell_link, "test")) {
      echo "This is a valid spelling";
  } else {
      echo "Sorry, wrong spelling";
  }

  ?> 

  Aspell functions [deprecated]Upaspell_check
#

#T=bool aspell_check_raw ( int dictionary_link, string word)
aspell_check_raw ( ^!int dictionary_link, string word);
#

#T=aspell_check - bool aspell_check ( int dictionary_link, string word)
(PHP 3>= 3.0.7, PHP 4 <= 4.2.3)
aspell_check -- Check a word [deprecated]
Description
bool aspell_check ( int dictionary_link, string word)
aspell_check() checks the spelling of a word and returns TRUE if the 
spelling is correct, FALSE if not. 
Example 1. aspell_check()
  <?php

  $aspell_link = aspell_new("english");

  if (aspell_check($aspell_link, "testt")) {
      echo "This is a valid spelling";
  } else {
      echo "Sorry, wrong spelling";
  }

  ?> 

  aspell_check_rawUpaspell_new
#

#T=bool aspell_check ( int dictionary_link, string word)
aspell_check ( ^!int dictionary_link, string word);
#

#T=aspell_new - int aspell_new ( string master [, string personal])
(PHP 3>= 3.0.7, PHP 4 <= 4.2.3)
aspell_new -- Load a new dictionary [deprecated]
Description
int aspell_new ( string master [, string personal])
aspell_new() opens up a new dictionary and returns the dictionary link 
identifier for use in other aspell functions. Returns FALSE on error. 
Example 1. aspell_new()
  <?php
  $aspell_link = aspell_new("english");
  ?> 

  aspell_checkUpaspell_suggest
#

#T=int aspell_new ( string master [, string personal])
aspell_new ( ^!string master [, string personal]);
#

#T=aspell_suggest - array aspell_suggest ( int dictionary_link, string word)
(PHP 3>= 3.0.7, PHP 4 <= 4.2.3)
aspell_suggest -- Suggest spellings of a word [deprecated]
Description
array aspell_suggest ( int dictionary_link, string word)
aspell_suggest() returns an array of possible spellings for the given 
word. 
Example 1. aspell_suggest()
  <?php

  $aspell_link = aspell_new("english");

  if (!aspell_check($aspell_link, "test")) {
      $suggestions = aspell_suggest($aspell_link, "test");

      foreach ($suggestions as $suggestion) {
	  echo "Possible spelling: $suggestion<br />\n"; 
      }
  }

  ?> 

  aspell_newUpBCMath Arbitrary Precision Mathematics Functions
#

#T=array aspell_suggest ( int dictionary_link, string word)
aspell_suggest ( ^!int dictionary_link, string word);
#

#T=assert_options - mixed assert_options ( int what [, mixed value])
(PHP 4 )
assert_options -- Set/get the various assert flags
Description
mixed assert_options ( int what [, mixed value])
Using assert_options() you may set the various assert() control options or 
just query their current settings. 
Table 1. Assert Options
optionini-parameterdefaultdescription
ASSERT_ACTIVEassert.active1enable assert() evaluation
ASSERT_WARNINGassert.warning1issue a PHP warning for each failed 
assertion
ASSERT_BAILassert.bail0terminate execution on failed assertions
ASSERT_QUIET_EVALassert.quiet_eval0disable error_reporting during 
assertion expression evaluation 
ASSERT_CALLBACKassert.callback(NULL)user function to call on failed 
assertions

assert_options() will return the original setting of any option or FALSE 
on errors.   PHP Options&InformationUpassert
#

#T=mixed assert_options ( int what [, mixed value])
assert_options ( ^!int what [, mixed value]);
#

#T=assert - int assert ( mixed assertion)
(PHP 4 )
assert -- Checks if assertion is FALSE
Description
int assert ( mixed assertion)
assert() will check the given assertion and take appropriate action if its 
result is FALSE. 
If the assertion is given as a string it will be evaluated as PHP code by 
assert(). The advantages of a string assertion are less overhead when 
assertion checking is off and messages containing the assertion expression 
when an assertion fails. This means that if you pass a boolean condition 
as assertion this condition will not show up as parameter to the assertion 
function which you may have defined with the assert_options() function, 
the condition is converted to a string before calling that handler 
function, and the boolean FALSE is converted as the empty string. 
Assertions should be used as a debugging feature only. You may use them 
for sanity-checks that test for conditions that should always be TRUE and 
that indicate some programming errors if not or to check for the presence 
of certain features like extension functions or certain system limits and 
features. 
Assertions should not be used for normal runtime operations like input 
parameter checks. As a rule of thumb your code should always be able to 
work correctly if assertion checking is not activated. 
The behavior of assert() may be configured by assert_options() or by 
.ini-settings described in that functions manual page. 
The assert_options() function and/or ASSERT_CALLBACK configuration 
directive allow a callback function to be set to handle failed assertions. 

assert() callbacks are particularly useful for building automated test 
suites because they allow you to easily capture the code passed to the 
assertion, along with information on where the assertion was made. While 
this information can be captured via other methods, using assertions makes 
it much faster and easier! 
The callback function should accept three arguments. The first argument 
will contain the file the assertion failed in. The second argument will 
contain the line the assertion failed on and the third argument will 
contain the expression that failed (if any - literal values such as 1 or 
"two" will not be passed via this argument) 
Example 1. Handle a failed assertion with a custom handler
  <?php
  // Active assert and make it quiet
  assert_options(ASSERT_ACTIVE, 1);
  assert_options(ASSERT_WARNING, 0);
  assert_options(ASSERT_QUIET_EVAL, 1);

  // Create a handler function
  function my_assert_handler($file, $line, $code) {
      echo "<hr>Assertion Failed:
	  File '$file'<br />
	  Line '$line'<br />
	  Code '$code'<br /><hr />";
  }

  // Set up the callback
  assert_options(ASSERT_CALLBACK, 'my_assert_handler');

  // Make an assertion that should fail
  assert('mysql_query("")');
  ?> 

  assert_optionsUpdl
#

#T=int assert ( mixed assertion)
assert ( ^!mixed assertion);
#

#T=atan - float atan ( float arg)
(PHP 3, PHP 4 )
atan -- Arc tangent
Description
float atan ( float arg)
Returns the arc tangent of arg in radians. atan() is the complementary 
function of tan(), which means that a==tan(atan(a)) for every value of a 
that is within atan()'s range. 
See also atanh(), asin() and acos().   atan2Upatanh
#

#T=float atan ( float arg)
atan ( ^!float arg);
#

#T=atan2 - float atan2 ( float y, float x)
(PHP 3>= 3.0.5, PHP 4 )
atan2 -- Arc tangent of two variables
Description
float atan2 ( float y, float x)
This function calculates the arc tangent of the two variables x and y. It 
is similar to calculating the arc tangent of y / x, except that the signs 
of both arguments are used to determine the quadrant of the result. 
The function returns the result in radians, which is between -PI and PI 
(inclusive). 
See also acos() and atan().   asinhUpatan
#

#T=float atan2 ( float y, float x)
atan2 ( ^!float y, float x);
#

#T=atanh - float atanh ( float arg)
(PHP 4 >= 4.1.0)
atanh -- Inverse hyperbolic tangent
Description
float atanh ( float arg)
Returns the inverse hyperbolic tangent of arg, i.e. the value whose 
hyperbolic tangent is arg. 
Note: This function is not implemented on Windows platforms.
See also atan(), asinh() and acosh().   atanUpbase_convert
#

#T=float atanh ( float arg)
atanh ( ^!float arg);
#

#T=base_convert - string base_convert ( string number, int frombase, int tobase)
(PHP 3>= 3.0.6, PHP 4 )
base_convert -- Convert a number between arbitrary bases
Description
string base_convert ( string number, int frombase, int tobase)
Returns a string containing number represented in base tobase. The base in 
which number is given is specified in frombase. Both frombase and tobase 
have to be between 2 and 36, inclusive. Digits in numbers with a base 
higher than 10 will be represented with the letters a-z, with a meaning 
10, b meaning 11 and z meaning 35. Example 1. base_convert()
  <?php
  $hexadecimal = 'A37334';
  echo base_convert($hexadecimal, 16, 2);
  ?> 

Outputs: 
101000110111001100110100

  atanhUpbindec
#

#T=string base_convert ( string number, int frombase, int tobase)
base_convert ( ^!string number, int frombase, int tobase);
#

#T=base64_decode - string base64_decode ( string encoded_data)
(PHP 3, PHP 4 )
base64_decode -- Decodes data encoded with MIME base64
Description
string base64_decode ( string encoded_data)
base64_decode() decodes encoded_data and returns the original data or 
FALSE on failure. The returned data may be binary. 
Example 1. base64_decode() example
  <?php
  $str = 'VGhpcyBpcyBhbiBlbmNvZGVkIHN0cmluZw==';
  echo base64_decode($str);
  ?> 

This example will produce : 
This is an encoded string
See also base64_encode() and RFC 2045 section 6.8.   URL FunctionsUpbase64_encode
#

#T=string base64_decode ( string encoded_data)
base64_decode ( ^!string encoded_data);
#

#T=base64_encode - string base64_encode ( string data)
(PHP 3, PHP 4 )
base64_encode -- Encodes data with MIME base64
Description
string base64_encode ( string data)
base64_encode() returns data encoded with base64. This encoding is 
designed to make binary data survive transport through transport layers 
that are not 8-bit clean, such as mail bodies. 
Base64-encoded data takes about 33% more space than the original data. 
Example 1. base64_encode() example
  <?php
    $str = 'This is an encoded string';
    echo base64_encode($str);
  ?> 

This example will produce : 
VGhpcyBpcyBhbiBlbmNvZGVkIHN0cmluZw==
See also base64_decode(), chunk_split() and RFC 2045 section 6.8.   base64_decodeUpget_meta_tags
#

#T=string base64_encode ( string data)
base64_encode ( ^!string data);
#

#T=basename - string basename ( string path [, string suffix])
(PHP 3, PHP 4 )
basename -- Returns filename component of path
Description
string basename ( string path [, string suffix])
Given a string containing a path to a file, this function will return the 
base name of the file. If the filename ends in suffix this will also be 
cut off. 
On Windows, both slash (/) and backslash (\) are used as path separator 
character. In other environments, it is the forward slash (/). 
Example 1. basename() example
  <?php
  $path = "/home/httpd/html/index.php";
  $file = basename($path);        // $file is set to "index.php"
  $file = basename($path, ".php"); // $file is set to "index"
  ?> 
Note: The suffix parameter was added in PHP 4.1.0. 
See also: dirname()   Filesystem functionsUpchgrp
#

#T=string basename ( string path [, string suffix])
basename ( ^!string path [, string suffix]);
#

#T=bcadd - string bcadd ( string left_operand, string right_operand [, int scale])
(PHP 3, PHP 4 )
bcadd -- Add two arbitrary precision numbers
Description
string bcadd ( string left_operand, string right_operand [, int scale])
Adds the left_operand to the right_operand and returns the sum in a 
string. The optional scale parameter is used to set the number of digits 
after the decimal place in the result. 
Example 1. bcadd() example
  <?php

  $a = 1.234;
  $b = 5;

  echo bcadd($a, $b);     // 6
  echo bcadd($a, $b, 4);  // 6.2340

  ?> 
See also bcsub().   BCMath Arbitrary Precision Mathematics FunctionsUpbccomp
#

#T=string bcadd ( string left_operand, string right_operand [, int scale])
bcadd ( ^!string left_operand, string right_operand [, int scale]);
#

#T=bccomp - int bccomp ( string left_operand, string right_operand [, int scale])
(PHP 3, PHP 4 )
bccomp -- Compare two arbitrary precision numbers
Description
int bccomp ( string left_operand, string right_operand [, int scale])
Compares the left_operand to the right_operand and returns the result as 
an integer. The optional scale parameter is used to set the number of 
digits after the decimal place which will be used in the comparison. The 
return value is 0 if the two operands are equal. If the left_operand is 
larger than the right_operand the return value is +1 and if the 
left_operand is less than the right_operand the return value is -1. 
Example 1. bccomp() example
  <?php
  echo bccomp('1', '2') . "\n";

  echo bccomp('1.00001', '1', 3) . "\n";
  echo bccomp('1.00001', '1', 5);
  ?> 

The above example will output: 
-1
0
1

  bcaddUpbcdiv
#

#T=int bccomp ( string left_operand, string right_operand [, int scale])
bccomp ( ^!string left_operand, string right_operand [, int scale]);
#

#T=bcdiv - string bcdiv ( string left_operand, string right_operand [, int scale])
(PHP 3, PHP 4 )
bcdiv -- Divide two arbitrary precision numbers
Description
string bcdiv ( string left_operand, string right_operand [, int scale])
Divides the left_operand by the right_operand and returns the result. The 
optional scale sets the number of digits after the decimal place in the 
result. 
Example 1. bcdiv() example
  <?php

  echo bcdiv(105, 6.55957, 3);  // 16.007

  ?> 
See also bcmul().   bccompUpbcmod
#

#T=string bcdiv ( string left_operand, string right_operand [, int scale])
bcdiv ( ^!string left_operand, string right_operand [, int scale]);
#

#T=bcmod - string bcmod ( string left_operand, string modulus)
(PHP 3, PHP 4 )
bcmod --  Get modulus of an arbitrary precision number 
Description
string bcmod ( string left_operand, string modulus)
Get the modulus of the left_operand using modulus. 
Example 1. bcmod() example
  <?php
  echo bcmod(4, 2) . "\n";
  echo bcmod(2, 4);
  ?> 

The above example will output: 
0
2
See also bcdiv().   bcdivUpbcmul
#

#T=string bcmod ( string left_operand, string modulus)
bcmod ( ^!string left_operand, string modulus);
#

#T=bcmul - string bcmul ( string left_operand, string right_operand [, int scale])
(PHP 3, PHP 4 )
bcmul -- Multiply two arbitrary precision number
Description
string bcmul ( string left_operand, string right_operand [, int scale])
Multiply the left_operand by the right_operand and returns the result. The 
optional scale sets the number of digits after the decimal place in the 
result. 
Example 1. bcmul() example
  <?php
  echo bcmul(1.34747474747, 35, 3) . "\n";
  echo bcmul(2, 4);
  ?> 

The above example will output: 
47.162
8
See also bcdiv().   bcmodUpbcpow
#

#T=string bcmul ( string left_operand, string right_operand [, int scale])
bcmul ( ^!string left_operand, string right_operand [, int scale]);
#

#T=bcpow - string bcpow ( number x, int y [, int scale])
(PHP 3, PHP 4 )
bcpow --  Raise an arbitrary precision number to another 
Description
string bcpow ( number x, int y [, int scale])
Raise x to the power y. The optional scale can be used to set the number 
of digits after the decimal place in the result. 
Example 1. bcpow() example
  <?php

  echo bcpow(4.2, 3, 2); // 74.08

  ?> 
See also bcpowmod(), and bcsqrt().   bcmulUpbcpowmod
#

#T=string bcpow ( number x, int y [, int scale])
bcpow ( ^!number x, int y [, int scale]);
#

#T=bcpowmod - string bcpowmod ( string x, string y, string modulus [, int scale])
(PHP 5 CVS only)
bcpowmod --  Raise an arbitrary precision number to another, reduced by a 
specified modulus. 
Description
string bcpowmod ( string x, string y, string modulus [, int scale])
Use the fast-exponentiation method to raise x to the power y with respect 
to the modulus modulus. The optional scale can be used to set the number 
of digits after the decimal place in the result. 
The following two statements are functionally identical. The bcpowmod() 
version however, executes in less time and can accept larger parameters. 
<?php
$a = bcpowmod($x, $y, $mod);

$b = bcmod(bcpow($x, $y), $mod);

// $a and $b are equal to each other. 

?> 

Note: Because this method uses the modulus operation, non-natural 
numbers may give unexpected results. A natural number is any positive 
non-zero integer. 
See also bcpow(), and bcmod().   bcpowUpbcscale
#

#T=string bcpowmod ( string x, string y, string modulus [, int scale])
bcpowmod ( ^!string x, string y, string modulus [, int scale]);
#

#T=bcscale - string bcscale ( int scale)
(PHP 3, PHP 4 )
bcscale --  Set default scale parameter for all bc math functions 
Description
string bcscale ( int scale)
This function sets the default scale parameter for all subsequent bc math 
functions that do not explicitly specify a scale parameter. 
Example 1. bcscale() example
  <?php

  // default scale : 3
  bcscale(3);
  echo bcdiv(105, 6.55957); // 16.007

  // this is the same without bcscale()
  echo bcdiv(105, 6.55957, 3); // 16.007

  ?> 

  bcpowmodUpbcsqrt
#

#T=string bcscale ( int scale)
bcscale ( ^!int scale);
#

#T=bcsqrt - string bcsqrt ( string operand [, int scale])
(PHP 3, PHP 4 )
bcsqrt --  Get the square root of an arbitrary precision number 
Description
string bcsqrt ( string operand [, int scale])
Return the square root of the operand. The optional scale parameter sets 
the number of digits after the decimal place in the result. 
Example 1. bcsqrt() example
  <?php

  echo bcsqrt(2, 3); // 1.414

  ?> 
See also bcpow().   bcscaleUpbcsub
#

#T=string bcsqrt ( string operand [, int scale])
bcsqrt ( ^!string operand [, int scale]);
#

#T=bcsub - string bcsub ( string left_operand, string right_operand [, int scale])
(PHP 3, PHP 4 )
bcsub --  Subtract one arbitrary precision number from another 
Description
string bcsub ( string left_operand, string right_operand [, int scale])
Subtracts the right_operand from the left_operand and returns the result 
in a string. The optional scale parameter is used to set the number of 
digits after the decimal place in the result. 
Example 1. bcsub() example
  <?php

  $a = 1.234;
  $b = 5;

  echo bcsub($a, $b);     // -3
  echo bcsub($a, $b, 4);  // -3.7660

  ?> 
See also bcadd().   bcsqrtUpBzip2 Compression Functions
#

#T=string bcsub ( string left_operand, string right_operand [, int scale])
bcsub ( ^!string left_operand, string right_operand [, int scale]);
#

#T=bin2hex - string bin2hex ( string str)
(PHP 3>= 3.0.9, PHP 4 )
bin2hex --  Convert binary data into hexadecimal representation 
Description
string bin2hex ( string str)
Returns an ASCII string containing the hexadecimal representation of str. 
The conversion is done byte-wise with the high-nibble first. 
See also pack() and unpack().   addslashesUpchop
#

#T=string bin2hex ( string str)
bin2hex ( ^!string str);
#

#T=bind_textdomain_codeset - string bind_textdomain_codeset ( string domain, string codeset)
(PHP 4 >= 4.2.0)
bind_textdomain_codeset --  Specify the character encoding in which the 
messages from the DOMAIN message catalog will be returned 
Description
string bind_textdomain_codeset ( string domain, string codeset)
Warning
This function is currently not documented; only the argument list is 
available.
  GettextUpbindtextdomain
#

#T=string bind_textdomain_codeset ( string domain, string codeset)
bind_textdomain_codeset ( ^!string domain, string codeset);
#

#T=bindec - int bindec ( string binary_string)
(PHP 3, PHP 4 )
bindec -- Binary to decimal
Description
int bindec ( string binary_string)
Returns the decimal equivalent of the binary number represented by the 
binary_string argument. 
bindec() converts a binary number to an integer. The largest number that 
can be converted is 31 bits of 1's or 2147483647 in decimal. 
Example 1. bindec() example
  <?php
  echo bindec('110011') . "\n";
  echo bindec('000110011') . "\n";

  echo bindec('111');
  ?> 

The above example will output: 
51
51
7
See also decbin(), octdec(), hexdec() and base_convert().   base_convertUpceil
#

#T=int bindec ( string binary_string)
bindec ( ^!string binary_string);
#

#T=bindtextdomain - string bindtextdomain ( string domain, string directory)
(PHP 3>= 3.0.7, PHP 4 )
bindtextdomain -- Sets the path for a domain
Description
string bindtextdomain ( string domain, string directory)
The bindtextdomain() function sets the path for a domain. It returns the 
full pathname for the domain currently being set. 
Example 1. bindtextdomain() example
  <?php

  $domain = 'myapp';
  echo bindtextdomain($domain, '/usr/share/myapp/locale'); 

  ?> 

This will output : 
/usr/share/myapp/locale

  bind_textdomain_codesetUpdcgettext
bzclose
(4.0.4 - 4.3.2 only)
bzclose -- Close a bzip2 file pointer
Description
int bzclose ( resource bz)
Closes the bzip2 file referenced by the pointer bz. 
Returns TRUE on success or FALSE on failure. 
The file pointer must be valid, and must point to a file successfully 
opened by bzopen(). 
See also bzopen().   Bzip2 Compression FunctionsUpbzcompress
bzcompress
(4.0.4 - 4.3.2 only)
bzcompress -- Compress a string into bzip2 encoded data
Description
string bzcompress ( string source [, int blocksize [, int workfactor]])
bzcompress() compresses the source string and returns it as bzip2 encoded 
data. 
The optional parameter blocksize specifies the blocksize used during 
compression and should be a number from 1 to 9 with 9 giving the best 
compression, but using more resources to do so. blocksize defaults to 4. 
The optional parameter workfactor controls how the compression phase 
behaves when presented with worst case, highly repetitive, input data. The 
value can be between 0 and 250 with 0 being a special case and 30 being 
the default value. Regardless of the workfactor, the generated output is 
the same. 
Example 1. bzcompress() Example
  <?php
  $str = "sample data";
  $bzstr = bzcompress($str, 9);
  echo $bzstr;
  ?> 
See also bzdecompress().   bzcloseUpbzdecompress
bzdecompress
(4.0.4 - 4.3.2 only)
bzdecompress -- Decompresses bzip2 encoded data
Description
string bzdecompress ( string source [, int small])
bzdecompress() decompresses the source string containing bzip2 encoded 
data and returns it. If the optional parameter small is TRUE, an 
alternative decompression algorithm will be used which uses less memory 
(the maximum memory requirement drops to around 2300K) but works at 
roughly half the speed. See the bzip2 documentation for more information 
about this feature. 
Example 1. bzdecompress()
  <?php
  $start_str = "This is not an honest face?";
  $bzstr = bzcompress($start_str);

  echo "Compressed String: ";
  echo $bzstr;
  echo "\n<br />\n";

  $str = bzdecompress($bzstr);
  echo "Decompressed String: ";
  echo $str;
  echo "\n<br />\n";
  ?> 
See also bzcompress().   bzcompressUpbzerrno
bzerrno
(4.0.4 - 4.3.2 only)
bzerrno -- Returns a bzip2 error number
Description
int bzerrno ( resource bz)
Returns the error number of any bzip2 error returned by the file pointer 
bz. 
See also bzerror() and bzerrstr().   bzdecompressUpbzerror
bzerror
(4.0.4 - 4.3.2 only)
bzerror -- Returns the bzip2 error number and error string in an array
Description
array bzerror ( resource bz)
Returns the error number and error string, in an associative array, of any 
bzip2 error returned by the file pointer bz. 
Example 1. bzerror() Example
  <?php
  $error = bzerror($bz);

  echo $error["errno"];
  echo $error["errstr"];
  ?> 
See also bzerrno() and bzerrstr().   bzerrnoUpbzerrstr
bzerrstr
(4.0.4 - 4.3.2 only)
bzerrstr -- Returns a bzip2 error string
Description
string bzerrstr ( resource bz)
Returns the error string of any bzip2 error returned by the file pointer 
bz. 
See also bzerrno() and bzerror().   bzerrorUpbzflush
bzflush
(4.0.4 - 4.3.2 only)
bzflush -- Force a write of all buffered data
Description
int bzflush ( resource bz)
Forces a write of all buffered bzip2 data for the file pointer bz. 
Returns TRUE on success or FALSE on failure. 
See also bzread() and bzwrite().   bzerrstrUpbzopen
bzopen
(4.0.4 - 4.3.2 only)
bzopen -- Opens a bzip2 compressed file
Description
resource bzopen ( string filename, string mode)
bzopen() opens a bzip2 (.bz2) file for reading or writing. filename is the 
name of the file to open. mode is similar to the fopen() function (`r' for 
read, `w' for write, etc.). 
If the open fails, bzopen() returns FALSE, otherwise it returns a pointer 
to the newly opened file. 
Example 1. bzopen() Example
  <?php

  $file = "/tmp/foo.bz2";
  $bz = bzopen($file, "r") or die("Couldn't open $file for 
  reading");

  bzclose($bz);

  ?> 
See also bzclose().   bzflushUpbzread
bzread
(4.0.4 - 4.3.2 only)
bzread -- Binary safe bzip2 file read
Description
string bzread ( resource bz [, int length])
bzread() reads up to length bytes from the bzip2 file pointer referenced 
by bz. Reading stops when length (uncompressed) bytes have been read or 
EOF is reached, whichever comes first. If the optional parameter length is 
not specified, bzread() will read 1024 (uncompressed) bytes at a time. 
Example 1. bzread() Example
  <?php

  $file = "/tmp/foo.bz2";
  $bz = bzopen($file", "r") or die("Couldn't open $file");

  $decompressed_file = '';
  while (!feof($bz)) {
      $decompressed_file .= bzread($bz, 4096);
  }
  bzclose($bz);

  echo "The contents of /tmp/foo.bz2 are: <br />\n";
  echo $decompressed_file;

  ?> 
See also bzwrite(), feof(), and bzopen().   bzopenUpbzwrite
bzwrite
(4.0.4 - 4.3.2 only)
bzwrite -- Binary safe bzip2 file write
Description
int bzwrite ( resource bz, string data [, int length])
bzwrite() writes the contents of the string data to the bzip2 file stream 
pointed to by bz. If the optional length argument is given, writing will 
stop after length (uncompressed) bytes have been written or the end of 
string is reached, whichever comes first. 
Example 1. bzwrite() Example
  <?php
  $str = "uncompressed data";
  $bz = bzopen("/tmp/foo.bz2", "w");
  bzwrite($bz, $str, strlen($str));
  bzclose($bz);
  ?> 
See also bzread() and bzopen().   bzreadUpCalendar functions
#

#T=string bindtextdomain ( string domain, string directory)
bindtextdomain ( ^!string domain, string directory);
#

#T=cal_days_in_month - int cal_days_in_month ( int calendar, int month, int year)
(PHP 4 >= 4.1.0)
cal_days_in_month -- Return the number of days in a month for a given year 
and calendar
Description
int cal_days_in_month ( int calendar, int month, int year)
This function will return the number of days in the month of year for the 
specified calendar. 
Example 1. cal_days_in_month() example
  <?php
  $num = cal_days_in_month(CAL_GREGORIAN, 8, 2003); // 31
  echo "There was $num days in August 2003";
  ?> 
See also jdtounix().   Calendar functionsUpcal_from_jd
#

#T=int cal_days_in_month ( int calendar, int month, int year)
cal_days_in_month ( ^!int calendar, int month, int year);
#

#T=cal_from_jd - array cal_from_jd ( int jd, int calendar)
(PHP 4 >= 4.1.0)
cal_from_jd -- Converts from Julian Day Count to a supported calendar
Description
array cal_from_jd ( int jd, int calendar)
cal_from_jd() converts the Julian day given in jd into a date of the 
specified calendar. Supported calendar values are CAL_GREGORIAN, 
CAL_JULIAN, CAL_JEWISH and CAL_FRENCH. 
Example 1. cal_from_jd() example
  <?php
  $today = unixtojd(mktime(0, 0, 0, 8, 16, 2003));
  print_r(cal_from_jd($today, CAL_GREGORIAN));
  ?> 

This will output : 
Array
(
[date] => 8/16/2003
[month] => 8
[day] => 16
[year] => 2003
[dow] => 6
[abbrevdayname] => Sat
[dayname] => Saturday
[abbrevmonth] => Aug
[monthname] => August
)
See also cal_to_jd().   cal_days_in_monthUpcal_info
#

#T=array cal_from_jd ( int jd, int calendar)
cal_from_jd ( ^!int jd, int calendar);
#

#T=cal_info - array cal_info ( [int calendar])
(PHP 4 >= 4.1.0)
cal_info -- Returns information about a particular calendar
Description
array cal_info ( [int calendar])
cal_info() returns information on the specified calendar or on all 
supported calendars if no calendar is specified. 
Calendar information is returned as an array containing the elements 
calname, calsymbol, month, abbrevmonth and maxdaysinmonth. 
If no calendar is specified information on all supported calendars is 
returned as an array. This functionality will be available beginning with 
PHP 5.   cal_from_jdUpcal_to_jd
#

#T=array cal_info ( [int calendar])
cal_info ( ^![int calendar]);
#

#T=cal_to_jd - int cal_to_jd ( int calendar, int month, int day, int year)
(PHP 4 >= 4.1.0)
cal_to_jd -- Converts from a supported calendar to Julian Day Count
Description
int cal_to_jd ( int calendar, int month, int day, int year)
cal_to_jd() calculates the Julian day count for a date in the specified 
calendar. Supported calendars are CAL_GREGORIAN, CAL_JULIAN, CAL_JEWISH 
and CAL_FRENCH. 
See also cal_to_jd().   cal_infoUpeaster_date
#

#T=int cal_to_jd ( int calendar, int month, int day, int year)
cal_to_jd ( ^!int calendar, int month, int day, int year);
#

#T=call_user_func_array - mixed call_user_func_array ( callback function [, array param_arr])
(PHP 4 >= 4.0.4)
call_user_func_array --  Call a user function given with an array of 
parameters 
Description
mixed call_user_func_array ( callback function [, array param_arr])
Call a user defined function given by function, with the parameters in 
param_arr. For example: 
<?php
function debug($var, $val) {
echo "***DEBUGGING\nVARIABLE: $var\nVALUE:";
if (is_array($val) || is_object($val) || is_resource($val)) {
    print_r($val);
} else {
    echo "\n$val\n";
}
echo "***\n";
}

$c = mysql_connect();
$host = $_SERVER["SERVER_NAME"];

call_user_func_array('debug', array("host", $host));
call_user_func_array('debug', array("c", $c));
call_user_func_array('debug', array("_POST", $_POST));
?> 

See also: call_user_func().   Function Handling functionsUpcall_user_func
#

#T=mixed call_user_func_array ( callback function [, array param_arr])
call_user_func_array ( ^!callback function [, array param_arr]);
#

#T=call_user_func - mixed call_user_func ( callback function [, mixed parameter [, mixed 
(PHP 3>= 3.0.3, PHP 4 )
call_user_func --  Call a user function given by the first parameter 
Description
mixed call_user_func ( callback function [, mixed parameter [, mixed 
...]])
Call a user defined function given by the function parameter. Take the 
following: 
<?php
function barber($type) {
echo "You wanted a $type haircut, no problem";
}
call_user_func('barber', "mushroom");
call_user_func('barber', "shave");
?> 

Object methods may also be invoked statically using this function by 
passing array($objectname, $methodname) to the function parameter. 
<?php
class myclass {
function say_hello() {
echo "Hello!\n";
}
}

$classname = "myclass";

call_user_func(array($classname, 'say_hello'));
?> 

See also: is_callable(), and call_user_func_array()   call_user_func_arrayUpcreate_function
#

#T=mixed call_user_func ( callback function [, mixed parameter [, mixed 
call_user_func ( ^!callback function [, mixed parameter [, mixed ;
#

#T=call_user_method_array - mixed call_user_method_array ( string method_name, object obj [, array 
(PHP 4 >= 4.0.5)
call_user_method_array --  Call a user method given with an array of 
parameters [deprecated] 
Description
mixed call_user_method_array ( string method_name, object obj [, array 
paramarr])
Warning
The call_user_method_array() function is deprecated as of PHP 4.1.0, 
use the call_user_func_array() variety with the array(&$obj, 
"method_name") syntax instead. 

Calls the method referred by method_name from the user defined obj object, 
using the parameters in paramarr. 
See also: call_user_func_array(), and call_user_func().   Class/Object FunctionsUpcall_user_method
#

#T=mixed call_user_method_array ( string method_name, object obj [, array 
call_user_method_array ( ^!string method_name, object obj [, array ;
#

#T=call_user_method - mixed call_user_method ( string method_name, object obj [, mixed parameter 
(PHP 3>= 3.0.3, PHP 4 )
call_user_method --  Call a user method on an specific object [deprecated] 

Description
mixed call_user_method ( string method_name, object obj [, mixed parameter 
[, mixed ...]])
Warning
The call_user_method() function is deprecated as of PHP 4.1.0, use 
the call_user_func() variety with the array(&$obj, "method_name") 
syntax instead. 

Calls the method referred by method_name from the user defined obj object. 
An example of usage is below, where we define a class, instantiate an 
object and use call_user_method() to call indirectly its print_info 
method. 
<?php
class Country {
var $NAME;
var $TLD;

function Country($name, $tld) {
    $this->NAME = $name;
    $this->TLD = $tld;
}

function print_info($prestr = "") {
    echo $prestr . "Country: " . $this->NAME . "\n";
    echo $prestr . "Top Level Domain: " . $this->TLD . "\n";
}
}

$cntry = new Country("Peru", "pe");

echo "* Calling the object method directly\n";
$cntry->print_info();

echo "\n* Calling the same method indirectly\n";
call_user_method("print_info", $cntry, "\t");
?> 

See also call_user_func_array(), and call_user_func().   call_user_method_arrayUpclass_exists
ccvs_add
(4.0.2 - 4.2.3 only)
ccvs_add -- Add data to a transaction 
Description
string ccvs_add ( string session, string invoice, string argtype, string 
argval)
Warning
This function is currently not documented; only the argument list is 
available.
  CCVS API FunctionsUpccvs_auth
ccvs_auth
(4.0.2 - 4.2.3 only)
ccvs_auth --  Perform credit authorization test on a transaction 
Description
string ccvs_auth ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_addUpccvs_command
ccvs_command
(4.0.2 - 4.2.3 only)
ccvs_command --  Performs a command which is peculiar to a single 
protocol, and thus is not available in the general CCVS API 
Description
string ccvs_command ( string session, string type, string argval)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_authUpccvs_count
ccvs_count
(4.0.2 - 4.2.3 only)
ccvs_count --  Find out how many transactions of a given type are stored 
in the system 
Description
int ccvs_count ( string session, string type)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_commandUpccvs_delete
ccvs_delete
(4.0.2 - 4.2.3 only)
ccvs_delete -- Delete a transaction
Description
string ccvs_delete ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_countUpccvs_done
ccvs_done
(4.0.2 - 4.2.3 only)
ccvs_done -- Terminate CCVS engine and do cleanup work
Description
string ccvs_done ( string sess)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_deleteUpccvs_init
ccvs_init
(4.0.2 - 4.2.3 only)
ccvs_init -- Initialize CCVS for use
Description
string ccvs_init ( string name)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_doneUpccvs_lookup
ccvs_lookup
(4.0.2 - 4.2.3 only)
ccvs_lookup --  Look up an item of a particular type in the database # 
Description
string ccvs_lookup ( string session, string invoice, int inum)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_initUpccvs_new
ccvs_new
(4.0.2 - 4.2.3 only)
ccvs_new -- Create a new, blank transaction 
Description
string ccvs_new ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_lookupUpccvs_report
ccvs_report
(4.0.2 - 4.2.3 only)
ccvs_report -- Return the status of the background communication process 
Description
string ccvs_report ( string session, string type)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_newUpccvs_return
ccvs_return
(4.0.2 - 4.2.3 only)
ccvs_return --  Transfer funds from the merchant to the credit card holder 

Description
string ccvs_return ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_reportUpccvs_reverse
ccvs_reverse
(4.0.2 - 4.2.3 only)
ccvs_reverse --  Perform a full reversal on an already-processed 
authorization 
Description
string ccvs_reverse ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_returnUpccvs_sale
ccvs_sale
(4.0.2 - 4.2.3 only)
ccvs_sale --  Transfer funds from the credit card holder to the merchant 
Description
string ccvs_sale ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_reverseUpccvs_status
ccvs_status
(4.0.2 - 4.2.3 only)
ccvs_status -- Check the status of an invoice
Description
string ccvs_status ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_saleUpccvs_textvalue
ccvs_textvalue
(4.0.2 - 4.2.3 only)
ccvs_textvalue -- Get text return value for previous function call
Description
string ccvs_textvalue ( string session)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_statusUpccvs_void
ccvs_void
(4.0.2 - 4.2.3 only)
ccvs_void --  Perform a full reversal on a completed transaction 
Description
string ccvs_void ( string session, string invoice)
Warning
This function is currently not documented; only the argument list is 
available.
  ccvs_textvalueUpCOM support functions for Windows
#

#T=mixed call_user_method ( string method_name, object obj [, mixed parameter 
call_user_method ( ^!string method_name, object obj [, mixed parameter ;
#

#T=ceil - float ceil ( float value)
(PHP 3, PHP 4 )
ceil -- Round fractions up
Description
float ceil ( float value)
Returns the next highest integer value by rounding up value if necessary. 
The return value of ceil() is still of type float as the value range of 
float is usually bigger than that of integer. 
Example 1. ceil() example
  <?php
  echo ceil(4.3);    // 5
  echo ceil(9.999);  // 10
  ?> 
See also floor() and round().   bindecUpcos
#

#T=float ceil ( float value)
ceil ( ^!float value);
#

#T=chdir - bool chdir ( string directory)
(PHP 3, PHP 4 )
chdir -- Change directory
Description
bool chdir ( string directory)
Changes PHP's current directory to directory. Returns TRUE on success or 
FALSE on failure. 
Example 1. chdir() example
  <?php
      
  // current directory
  echo getcwd() . "\n";
      
  chdir('public_html');
      
  // current directory
  echo getcwd() . "\n";
      
  ?> 

This example will output: 
/home/vincent
/home/vincent/public_html
Note: When safe mode is enabled, PHP checks whether the directory in 
which you are about to operate has the same UID (owner) as the script 
that is being executed.
See also getcwd().   Directory functionsUpchroot
#

#T=bool chdir ( string directory)
chdir ( ^!string directory);
#

#T=checkdate - bool checkdate ( int month, int day, int year)
(PHP 3, PHP 4 )
checkdate -- Validate a Gregorian date
Description
bool checkdate ( int month, int day, int year)
Returns TRUE if the date given is valid; otherwise returns FALSE. Checks 
the validity of the date formed by the arguments. A date is considered 
valid if: 
year is between 1 and 32767 inclusive 
month is between 1 and 12 inclusive 
Day is within the allowed number of days for the given month. Leap years 
are taken into consideration. 
See also mktime() and strtotime().   Date and Time functionsUpdate
#

#T=bool checkdate ( int month, int day, int year)
checkdate ( ^!int month, int day, int year);
#

#T=checkdnsrr - int checkdnsrr ( string host [, string type])
(PHP 3, PHP 4 )
checkdnsrr --  Check DNS records corresponding to a given Internet host 
name or IP address 
Description
int checkdnsrr ( string host [, string type])
Searches DNS for records of type type corresponding to host. Returns TRUE 
if any records are found; returns FALSE if no records were found or if an 
error occurred. 
type may be any one of: A, MX, NS, SOA, PTR, CNAME, AAAA, or ANY. The 
default is MX. 
Host may either be the IP address in dotted-quad notation or the host 
name. 
Note: AAAA type added with PHP 5.0.0 
Note: This function is not implemented on Windows platforms. Try the 
PEAR class Net_DNS. 
See also getmxrr(), gethostbyaddr(), gethostbyname(), gethostbynamel(), 
and the named(8) manual page.   Network FunctionsUpcloselog
#

#T=int checkdnsrr ( string host [, string type])
checkdnsrr ( ^!string host [, string type]);
#

#T=chgrp - bool chgrp ( string filename, mixed group)
(PHP 3, PHP 4 )
chgrp -- Changes file group
Description
bool chgrp ( string filename, mixed group)
Attempts to change the group of the file filename to group (specified by 
name or number). Only the superuser may change the group of a file 
arbitrarily; other users may change the group of a file to any group of 
which that user is a member. 
Returns TRUE on success or FALSE on failure. 
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.
See also chown() and chmod().   basenameUpchmod
#

#T=bool chgrp ( string filename, mixed group)
chgrp ( ^!string filename, mixed group);
#

#T=chmod - bool chmod ( string filename, int mode)
(PHP 3, PHP 4 )
chmod -- Changes file mode
Description
bool chmod ( string filename, int mode)
Attempts to change the mode of the file specified by filename to that 
given in mode. 
Note that mode is not automatically assumed to be an octal value, so 
strings (such as "g+w") will not work properly. To ensure the expected 
operation, you need to prefix mode with a zero (0): 
<?php
chmod("/somedir/somefile", 755);   // decimal; probably incorrect   
chmod("/somedir/somefile", "u+rwx,go+rx"); // string; incorrect      

chmod("/somedir/somefile", 0755);  // octal; correct value of mode
?> 

The mode parameter consists of three octal number components specifying 
access restrictions for the owner, the user group in which the owner is 
in, and to everybody else in this order. One component can be computed by 
adding up the needed permissions for that target user base. Number 1 means 
that you grant execute rights, number 2 means that you make the file 
writeable, number 4 means that you make the file readable. Add up these 
numbers to specify needed rights. You can also read more about modes on 
Unix systems with 'man 1 chmod' and 'man 2 chmod'. 
<?php
// Read and write for owner, nothing for everybody else
chmod("/somedir/somefile", 0600);

// Read and write for owner, read for everybody else
chmod("/somedir/somefile", 0644);

// Everything for owner, read and execute for others
chmod("/somedir/somefile", 0755);

// Everything for owner, read and execute for owner's group
chmod("/somedir/somefile", 0750);
?> 

Returns TRUE on success or FALSE on failure. 
Note: The current user is the user under which PHP runs. It is probably 
not the same user you use for normal shell or FTP access. 
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed. In addition, you cannot set the SUID, 
SGID and sticky bits 
See also chown() and chgrp().   chgrpUpchown
chop
chop -- Alias of rtrim()
Description
This function is an alias of rtrim(). 
Note: chop() is different than the Perl chop() function, which removes 
the last character in the string.   bin2hexUpchr
#

#T=bool chmod ( string filename, int mode)
chmod ( ^!string filename, int mode);
#

#T=chown - bool chown ( string filename, mixed user)
(PHP 3, PHP 4 )
chown -- Changes file owner
Description
bool chown ( string filename, mixed user)
Attempts to change the owner of the file filename to user user (specified 
by name or number). Only the superuser may change the owner of a file. 
Returns TRUE on success or FALSE on failure. 
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.
See also chmod().   chmodUpclearstatcache
#

#T=bool chown ( string filename, mixed user)
chown ( ^!string filename, mixed user);
#

#T=chr - string chr ( int ascii)
(PHP 3, PHP 4 )
chr -- Return a specific character
Description
string chr ( int ascii)
Returns a one-character string containing the character specified by 
ascii. Example 1. chr() example
  <?php
  $str = "The string ends in escape: ";
  $str .= chr(27); /* add an escape character at the end of $str 
  */

  /* Often this is more useful */

  $str = sprintf("The string ends in escape: %c", 27);
  ?> 
You can find an ASCII-table over here: http://www.asciitable.com. 
This function complements ord(). See also sprintf() with a format string 
of %c.   chopUpchunk_split
#

#T=string chr ( int ascii)
chr ( ^!int ascii);
#

#T=chroot - bool chroot ( string directory)
(PHP 4 >= 4.0.5)
chroot -- Change the root directory
Description
bool chroot ( string directory)
Changes the root directory of the current process to directory. Returns 
TRUE on success or FALSE on failure. 
This function is only available if your system supports it and you're 
using the CLI, CGI or Embed SAPI. 
Note: chroot() requires root privileges.
Note: This function is not implemented on Windows platforms.  chdirUpdir
#

#T=bool chroot ( string directory)
chroot ( ^!string directory);
#

#T=chunk_split - string chunk_split ( string body [, int chunklen [, string end]])
(PHP 3>= 3.0.6, PHP 4 )
chunk_split -- Split a string into smaller chunks
Description
string chunk_split ( string body [, int chunklen [, string end]])
Can be used to split a string into smaller chunks which is useful for e.g. 
converting base64_encode output to match RFC 2045 semantics. It inserts 
end (defaults to "\r\n") every chunklen characters (defaults to 76). It 
returns the new string leaving the original string untouched. 
Example 1. chunk_split() example
  <?php
  // format $data using RFC 2045 semantics
  $new_string = chunk_split(base64_encode($data));
  ?> 
See also explode(), split(), wordwrap() and RFC 2045.   chrUpconvert_cyr_string
#

#T=string chunk_split ( string body [, int chunklen [, string end]])
chunk_split ( ^!string body [, int chunklen [, string end]]);
#

#T=class_exists - bool class_exists ( string class_name)
(PHP 4 )
class_exists -- Checks if the class has been defined
Description
bool class_exists ( string class_name)
This function returns TRUE if the class given by class_name has been 
defined, FALSE otherwise. 
See also get_declared_classes().   call_user_methodUpget_class_methods
#

#T=bool class_exists ( string class_name)
class_exists ( ^!string class_name);
#

#T=clearstatcache - void clearstatcache ( void )
(PHP 3, PHP 4 )
clearstatcache -- Clears file status cache
Description
void clearstatcache ( void )
When you use stat(), lstat(), or any of the other functions listed in the 
affected functions list (below), PHP caches the information those 
functions return in order to provide faster performance. However, in 
certain cases, you may want to clear the cached information. For instance, 
if the same file is being checked multiple times within a single script, 
and that file is in danger of being removed or changed during that 
script's operation, you may elect to clear the status cache. In these 
cases, you can use the clearstatcache() function to clear the information 
that PHP caches about a file. 
Note: This function caches information about specific filenames, so you 
only need to call clearstatcache() if you are performing multiple 
operations on the same filename and require the information about that 
particular file to not be cached. 
Affected functions include stat(), lstat(), file_exists(), is_writable(), 
is_readable(), is_executable(), is_file(), is_dir(), is_link(), 
filectime(), fileatime(), filemtime(), fileinode(), filegroup(), 
fileowner(), filesize(), filetype(), and fileperms().   chownUpcopy
#

#T=void clearstatcache ( void )
clearstatcache ( ^!void );
#

#T=closedir - void closedir ( resource dir_handle)
(PHP 3, PHP 4 )
closedir -- close directory handle
Description
void closedir ( resource dir_handle)
Closes the directory stream indicated by dir_handle. The stream must have 
previously been opened by opendir().   dirUpgetcwd
#

#T=void closedir ( resource dir_handle)
closedir ( ^!resource dir_handle);
#

#T=closelog - int closelog ( void )
(PHP 3, PHP 4 )
closelog -- Close connection to system logger
Description
int closelog ( void )
closelog() closes the descriptor being used to write to the system logger. 
The use of closelog() is optional. 
See also define_syslog_variables(), syslog() and openlog().   checkdnsrrUpdebugger_off
com_addref
(4.1.0 - 4.3.2 only)
com_addref --  Increases the components reference counter. 
Description
void com_addref ( void )
Increases the components reference counter.   VARIANTUpcom_get
#

#T=int closelog ( void )
closelog ( ^!void );
#

#T=com_get - mixed com_get ( resource com_object, string property)
(PHP 3>= 3.0.3, 4.0.5 - 4.3.2 only)
com_get --  Gets the value of a COM Component's property 
Description
mixed com_get ( resource com_object, string property)
Returns the value of the property of the COM component referenced by 
com_object. Returns FALSE on error.   com_addrefUpcom_invoke
#

#T=mixed com_get ( resource com_object, string property)
com_get ( ^!resource com_object, string property);
#

#T=com_invoke - mixed com_invoke ( resource com_object, string function_name [, mixed 
(PHP 3>= 3.0.3)
com_invoke --  Calls a COM component's method. 
Description
mixed com_invoke ( resource com_object, string function_name [, mixed 
function parameters, ...])
com_invoke() invokes a method of the COM component referenced by 
com_object. Returns FALSE on error, returns the function_name's return 
value on success.   com_getUpcom_isenum
com_isenum
(4.1.0 - 4.3.2 only)
com_isenum -- Grabs an IEnumVariant
Description
void com_isenum ( object com_module)
Warning
This function is currently not documented; only the argument list is 
available.
  com_invokeUpcom_load_typelib
com_load_typelib
(4.1.0 - 4.3.2 only)
com_load_typelib -- Loads a Typelib
Description
void com_load_typelib ( string typelib_name [, int case_insensitive])
Warning
This function is currently not documented; only the argument list is 
available.
  com_isenumUpcom_load
#

#T=mixed com_invoke ( resource com_object, string function_name [, mixed 
com_invoke ( ^!resource com_object, string function_name [, mixed ;
#

#T=com_load - string com_load ( string module_name [, string server_name [, int 
(PHP 3>= 3.0.3)
com_load --  Creates a new reference to a COM component 
Description
string com_load ( string module_name [, string server_name [, int 
codepage]])
com_load() creates a new COM component and returns a reference to it. 
Returns FALSE on failure. Possible values for codepage are: CP_ACP, 
CP_MACCP, CP_OEMCP, CP_SYMBOL, CP_THREAD_ACP, CP_UTF7, and CP_UTF8.   com_load_typelibUpcom_propget
com_propget
com_propget -- Alias of com_get()
Description
This function is an alias for com_get().   com_loadUpcom_propput
com_propput
com_propput -- Alias of com_set()
Description
This function is an alias for com_set().   com_propgetUpcom_propset
com_propset
com_propset -- Alias of com_set()
Description
This function is an alias for com_set().   com_propputUpcom_release
com_release
(4.1.0 - 4.3.2 only)
com_release --  Decreases the components reference counter. 
Description
void com_release ( void )
Decreases the components reference counter.   com_propsetUpcom_set
#

#T=string com_load ( string module_name [, string server_name [, int 
com_load ( ^!string module_name [, string server_name [, int ;
#

#T=com_set - void com_set ( resource com_object, string property, mixed value)
(PHP 3>= 3.0.3, 4.0.5 - 4.3.2 only)
com_set --  Assigns a value to a COM component's property 
Description
void com_set ( resource com_object, string property, mixed value)
Sets the value of the property of the COM component referenced by 
com_object. Returns the newly set value if succeeded, FALSE on error.   com_releaseUpClass/Object Functions
#

#T=void com_set ( resource com_object, string property, mixed value)
com_set ( ^!resource com_object, string property, mixed value);
#

#T=compact - array compact ( mixed varname [, mixed ...])
(PHP 4 )
compact --  Create array containing variables and their values 
Description
array compact ( mixed varname [, mixed ...])
compact() takes a variable number of parameters. Each parameter can be 
either a string containing the name of the variable, or an array of 
variable names. The array can contain other arrays of variable names 
inside it; compact() handles it recursively. 
For each of these, compact() looks for a variable with that name in the 
current symbol table and adds it to the output array such that the 
variable name becomes the key and the contents of the variable become the 
value for that key. In short, it does the opposite of extract(). It 
returns the output array with all the variables added to it. 
Any strings that are not set will simply be skipped. 
Example 1. compact() example
  <?php
  $city  = "San Francisco";
  $state = "CA";
  $event = "SIGGRAPH";

  $location_vars = array("city", "state");

  $result = compact("event", "nothing_here", $location_vars);
  ?> 

After this, $result will be: 
  Array
  (
      [event] => SIGGRAPH
      [city] => San Francisco
      [state] => CA
  ) 
See also extract().   asortUpcount
#

#T=array compact ( mixed varname [, mixed ...])
compact ( ^!mixed varname [, mixed ...]);
#

#T=connection_aborted - int connection_aborted ( void )
(PHP 3>= 3.0.7, PHP 4 )
connection_aborted -- Returns TRUE if client disconnected
Description
int connection_aborted ( void )
Returns TRUE if client disconnected. See the Connection Handling 
description in the Features chapter for a complete explanation. 
See also connection_status(), and ignore_user_abort().   Miscellaneous functionsUpconnection_status
#

#T=int connection_aborted ( void )
connection_aborted ( ^!void );
#

#T=connection_status - int connection_status ( void )
(PHP 3>= 3.0.7, PHP 4 )
connection_status -- Returns connection status bitfield
Description
int connection_status ( void )
Returns the connection status bitfield. See the Connection Handling 
description in the Features chapter for a complete explanation. 
See also connection_aborted(), and ignore_user_abort().   connection_abortedUpconnection_timeout
#

#T=int connection_status ( void )
connection_status ( ^!void );
#

#T=connection_timeout - bool connection_timeout ( void )
(PHP 3>= 3.0.7, PHP 4 <= 4.0.4)
connection_timeout -- Return TRUE if script timed out
Description
bool connection_timeout ( void )
Returns TRUE if script timed out. 
Deprecated
This function is deprecated, and doesn't even exist anymore as of 
4.0.5. 

See the Connection Handling description in the Features chapter for a 
complete explanation.   connection_statusUpconstant
#

#T=bool connection_timeout ( void )
connection_timeout ( ^!void );
#

#T=constant - mixed constant ( string name)
(PHP 4 >= 4.0.4)
constant -- Returns the value of a constant
Description
mixed constant ( string name)
constant() will return the value of the constant indicated by name. 
constant() is useful if you need to retrieve the value of a constant, but 
do not know it's name. i.e. It is stored in a variable or returned by a 
function. 
Example 1. constant() example
  <?php

  define("MAXSIZE", 100);

  echo MAXSIZE;
  echo constant("MAXSIZE"); // same thing as the previous line

  ?> 
See also define(), defined() and the section on Constants.   connection_timeoutUpdefine
#

#T=mixed constant ( string name)
constant ( ^!string name);
#

#T=convert_cyr_string - string convert_cyr_string ( string str, string from, string to)
(PHP 3>= 3.0.6, PHP 4 )
convert_cyr_string --  Convert from one Cyrillic character set to another 
Description
string convert_cyr_string ( string str, string from, string to)
This function returns the given string converted from one Cyrillic 
character set to another. The from and to arguments are single characters 
that represent the source and target Cyrillic character sets. The 
supported types are: 
k - koi8-r 
w - windows-1251 
i - iso8859-5 
a - x-cp866 
d - x-cp866 
m - x-mac-cyrillic   chunk_splitUpcount_chars
#

#T=string convert_cyr_string ( string str, string from, string to)
convert_cyr_string ( ^!string str, string from, string to);
#

#T=copy - bool copy ( string source, string dest)
(PHP 3, PHP 4 )
copy -- Copies file
Description
bool copy ( string source, string dest)
Makes a copy of the file source to dest. Returns TRUE on success or FALSE 
on failure. Example 1. copy() example
  <?php
  if (!copy($file, $file.'.bak')) {
      echo "failed to copy $file...<br />\n";
  }
  ?> 
Note: As of PHP 4.3.0, both source and dest may be URLs if the "fopen 
wrappers" have been enabled. See fopen() for more details. If dest is an 
URL, the copy operation may fail if the wrapper does not support 
overwriting of existing files. 
Warning
If the destination file already exists, it will be overwritten. 

See also move_uploaded_file(), rename(), and the section of the manual 
about handling file uploads.   clearstatcacheUpdelete
#

#T=bool copy ( string source, string dest)
copy ( ^!string source, string dest);
#

#T=cos - float cos ( float arg)
(PHP 3, PHP 4 )
cos -- Cosine
Description
float cos ( float arg)
cos() returns the cosine of the arg parameter. The arg parameter is in 
radians. 
Example 1. cos() example
  <?php

  echo cos(M_PI); // -1

  ?> 
See also acos(), sin(), tan() and deg2rad().   ceilUpcosh
#

#T=float cos ( float arg)
cos ( ^!float arg);
#

#T=cosh - float cosh ( float arg)
(PHP 4 >= 4.1.0)
cosh -- Hyperbolic cosine
Description
float cosh ( float arg)
Returns the hyperbolic cosine of arg, defined as (exp(arg) + exp(-arg))/2. 

See also cos(), acosh(), sin() and tan().   cosUpdecbin
#

#T=float cosh ( float arg)
cosh ( ^!float arg);
#

#T=count_chars - mixed count_chars ( string string [, int mode])
(PHP 4 )
count_chars --  Return information about characters used in a string 
Description
mixed count_chars ( string string [, int mode])
Counts the number of occurrences of every byte-value (0..255) in string 
and returns it in various ways. The optional parameter mode default to 0. 
Depending on mode count_chars() returns one of the following: 
0 - an array with the byte-value as key and the frequency of every byte 
as value. 
1 - same as 0 but only byte-values with a frequency greater than zero 
are listed. 
2 - same as 0 but only byte-values with a frequency equal to zero are 
listed. 
3 - a string containing all used byte-values is returned. 
4 - a string containing all not used byte-values is returned. 
Example 1. count_chars() example
  <?php

  $data = "Two Ts and one F.";

  $result = count_chars($data, 0);

  for ($i=0; $i < count($result); $i++) {
     if ($result[$i] != 0)
	 echo "There were $result[$i] instance(s) of \"" , 
  chr($i) , "\" in the string.\n";
  }

  ?> 

This will output : 
There were 4 instance(s) of " " in the string. 
There were 1 instance(s) of "." in the string. 
There were 1 instance(s) of "F" in the string. 
There were 2 instance(s) of "T" in the string. 
There were 1 instance(s) of "a" in the string. 
There were 1 instance(s) of "d" in the string. 
There were 1 instance(s) of "e" in the string. 
There were 2 instance(s) of "n" in the string. 
There were 2 instance(s) of "o" in the string. 
There were 1 instance(s) of "s" in the string. 
There were 1 instance(s) of "w" in the string.
See also strpos() and substr_count().   convert_cyr_stringUpcrc32
#

#T=mixed count_chars ( string string [, int mode])
count_chars ( ^!string string [, int mode]);
#

#T=count - int count ( mixed var [, int mode])
(PHP 3, PHP 4 )
count -- Count elements in a variable
Description
int count ( mixed var [, int mode])
Returns the number of elements in var, which is typically an array (since 
anything else will have one element). 
If var is not an array, 1 will be returned (exception: count(NULL) equals 
0). 
Note: The optional mode parameter is available as of PHP 4.2.0. 
If the optional mode parameter is set to COUNT_RECURSIVE (or 1), count() 
will recursively count the array. This is particularly useful for counting 
all the elements of a multidimensional array. The default value for mode 
is 0. 
Caution
count() may return 0 for a variable that isn't set, but it may also 
return 0 for a variable that has been initialized with an empty 
array. Use isset() to test if a variable is set. 

Please see the Arrays section of the manual for a detailed explanation of 
how arrays are implemented and used in PHP. 
Example 1. count() example
  <?php
  $a[0] = 1;
  $a[1] = 3;
  $a[2] = 5;
  $result = count($a);
  // $result == 3

  $b[0]  = 7;
  $b[5]  = 9;
  $b[10] = 11;
  $result = count($b);
  // $result == 3;
  ?> 

#

#T=int count ( mixed var [, int mode])
count ( ^!mixed var [, int mode]);
#

#T= - bool cpdf_add_annotation ( int pdf_document, float llx, float lly, float 
Example 2. recursive count() example (PHP >= 4.2.0) 
  <?php
  $food = array('fruits' => array('orange', 'banana', 'apple'),
		'veggie' => array('carrot', 'collard', 'pea'));

  // recursive count
  echo count($food, COUNT_RECURSIVE);  // output 8

  // normal count
  echo count($food);                  // output 2

  ?> 
Note: The sizeof() function is an alias for count(). 
See also is_array(), isset(), and strlen().   compactUpcurrent
#

#T=cpdf_add_annotation - bool cpdf_add_annotation ( int pdf_document, float llx, float lly, float 
(PHP 3>= 3.0.12, PHP 4 )
cpdf_add_annotation -- Adds annotation
Description
bool cpdf_add_annotation ( int pdf_document, float llx, float lly, float 
urx, float ury, string title, string content [, int mode])
The cpdf_add_annotation() adds a note with the lower left corner at (llx, 
lly) and the upper right corner at (urx, ury). Returns TRUE on success or 
FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.  ClibPDF functionsUpcpdf_add_outline
#

#T=bool cpdf_add_annotation ( int pdf_document, float llx, float lly, float 
cpdf_add_annotation ( ^!int pdf_document, float llx, float lly, float ;
#

#T=cpdf_add_outline - int cpdf_add_outline ( int pdf_document, int lastoutline, int sublevel, 
(PHP 3>= 3.0.9, PHP 4 )
cpdf_add_outline -- Adds bookmark for current page
Description
int cpdf_add_outline ( int pdf_document, int lastoutline, int sublevel, 
int open, int pagenr, string text)
The cpdf_add_outline() function adds a bookmark with text text that points 
to the current page. 
Example 1. Adding a page outline
  <?php
  $cpdf = cpdf_open(0);
  cpdf_page_init($cpdf, 1, 0, 595, 842);
  cpdf_add_outline($cpdf, 0, 0, 0, 1, "Page 1");
  // ...
  // some drawing
  // ...
  cpdf_finalize($cpdf);
  Header("Content-type: application/pdf");
  cpdf_output_buffer($cpdf);
  cpdf_close($cpdf);
  ?> 

  cpdf_add_annotationUpcpdf_arc
#

#T=int cpdf_add_outline ( int pdf_document, int lastoutline, int sublevel, 
cpdf_add_outline ( ^!int pdf_document, int lastoutline, int sublevel, ;
#

#T=cpdf_arc - bool cpdf_arc ( int pdf_document, float x-coor, float y-coor, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_arc -- Draws an arc
Description
bool cpdf_arc ( int pdf_document, float x-coor, float y-coor, float 
radius, float start, float end [, int mode])
The cpdf_arc() function draws an arc with center at point (x-coor, y-coor) 
and radius radius, starting at angle start and ending at angle end. 
Returns TRUE on success or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_circle().   cpdf_add_outlineUpcpdf_begin_text
#

#T=bool cpdf_arc ( int pdf_document, float x-coor, float y-coor, float 
cpdf_arc ( ^!int pdf_document, float x-coor, float y-coor, float ;
#

#T=cpdf_begin_text - bool cpdf_begin_text ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_begin_text -- Starts text section
Description
bool cpdf_begin_text ( int pdf_document)
The cpdf_begin_text() function starts a text section. Returns TRUE on 
success or FALSE on failure. The created text section must be ended with 
cpdf_end_text(). 
Example 1. Text output
  <?php
  cpdf_begin_text($pdf);
  cpdf_set_font($pdf, 16, "Helvetica", "WinAnsiEncoding");
  cpdf_text($pdf, 100, 100, "Some text");
  cpdf_end_text($pdf)
  ?> 
See also cpdf_end_text().   cpdf_arcUpcpdf_circle
#

#T=bool cpdf_begin_text ( int pdf_document)
cpdf_begin_text ( ^!int pdf_document);
#

#T=cpdf_circle - bool cpdf_circle ( int pdf_document, float x-coor, float y-coor, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_circle -- Draw a circle
Description
bool cpdf_circle ( int pdf_document, float x-coor, float y-coor, float 
radius [, int mode])
The cpdf_circle() function draws a circle with center at point (x-coor, 
y-coor) and radius radius. Returns TRUE on success or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_arc().   cpdf_begin_textUpcpdf_clip
#

#T=bool cpdf_circle ( int pdf_document, float x-coor, float y-coor, float 
cpdf_circle ( ^!int pdf_document, float x-coor, float y-coor, float ;
#

#T=cpdf_clip - bool cpdf_clip ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_clip -- Clips to current path
Description
bool cpdf_clip ( int pdf_document)
The cpdf_clip() function clips all drawing to the current path. Returns 
TRUE on success or FALSE on failure.   cpdf_circleUpcpdf_close
#

#T=bool cpdf_clip ( int pdf_document)
cpdf_clip ( ^!int pdf_document);
#

#T=cpdf_close - bool cpdf_close ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_close -- Closes the pdf document
Description
bool cpdf_close ( int pdf_document)
The cpdf_close() function closes the pdf document. Returns TRUE on success 
or FALSE on failure. This should be the last function even after 
cpdf_finalize(), cpdf_output_buffer() and cpdf_save_to_file(). 
See also cpdf_open().   cpdf_clipUpcpdf_closepath_fill_stroke
#

#T=bool cpdf_close ( int pdf_document)
cpdf_close ( ^!int pdf_document);
#

#T=cpdf_closepath_fill_stroke - bool cpdf_closepath_fill_stroke ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_closepath_fill_stroke -- Close, fill and stroke current path
Description
bool cpdf_closepath_fill_stroke ( int pdf_document)
The cpdf_closepath_fill_stroke() function closes, fills the interior of 
the current path with the current fill color and draws current path. 
Returns TRUE on success or FALSE on failure. 
See also cpdf_closepath(), cpdf_stroke(), cpdf_fill(), 
cpdf_setgray_fill(), cpdf_setgray(), cpdf_setrgbcolor_fill() and 
cpdf_setrgbcolor().   cpdf_closeUpcpdf_closepath_stroke
#

#T=bool cpdf_closepath_fill_stroke ( int pdf_document)
cpdf_closepath_fill_stroke ( ^!int pdf_document);
#

#T=cpdf_closepath_stroke - bool cpdf_closepath_stroke ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_closepath_stroke -- Close path and draw line along path
Description
bool cpdf_closepath_stroke ( int pdf_document)
The cpdf_closepath_stroke() function is a combination of cpdf_closepath() 
and cpdf_stroke(). Then clears the path. Returns TRUE on success or FALSE 
on failure. 
See also cpdf_closepath() and cpdf_stroke().   cpdf_closepath_fill_strokeUpcpdf_closepath
#

#T=bool cpdf_closepath_stroke ( int pdf_document)
cpdf_closepath_stroke ( ^!int pdf_document);
#

#T=cpdf_closepath - bool cpdf_closepath ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_closepath -- Close path
Description
bool cpdf_closepath ( int pdf_document)
The cpdf_closepath() function closes the current path. Returns TRUE on 
success or FALSE on failure.   cpdf_closepath_strokeUpcpdf_continue_text
#

#T=bool cpdf_closepath ( int pdf_document)
cpdf_closepath ( ^!int pdf_document);
#

#T=cpdf_continue_text - bool cpdf_continue_text ( int pdf_document, string text)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_continue_text -- Output text in next line
Description
bool cpdf_continue_text ( int pdf_document, string text)
The cpdf_continue_text() function outputs the string in text in the next 
line. Returns TRUE on success or FALSE on failure. 
See also cpdf_show_xy(), cpdf_text(), cpdf_set_leading() and 
cpdf_set_text_pos().   cpdf_closepathUpcpdf_curveto
#

#T=bool cpdf_continue_text ( int pdf_document, string text)
cpdf_continue_text ( ^!int pdf_document, string text);
#

#T=cpdf_curveto - bool cpdf_curveto ( int pdf_document, float x1, float y1, float x2, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_curveto -- Draws a curve
Description
bool cpdf_curveto ( int pdf_document, float x1, float y1, float x2, float 
y2, float x3, float y3 [, int mode])
The cpdf_curveto() function draws a Bezier curve from the current point to 
the point (x3, y3) using (x1, y1) and (x2, y2) as control points. Returns 
TRUE on success or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_moveto(), cpdf_rmoveto(), cpdf_rlineto() and cpdf_lineto().   cpdf_continue_textUpcpdf_end_text
#

#T=bool cpdf_curveto ( int pdf_document, float x1, float y1, float x2, float 
cpdf_curveto ( ^!int pdf_document, float x1, float y1, float x2, float ;
#

#T=cpdf_end_text - bool cpdf_end_text ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_end_text -- Ends text section
Description
bool cpdf_end_text ( int pdf_document)
The cpdf_end_text() function ends a text section which was started with 
cpdf_begin_text(). Returns TRUE on success or FALSE on failure. 
Example 1. Text output
  <?php
  cpdf_begin_text($pdf);
  cpdf_set_font($pdf, 16, "Helvetica", "WinAnsiEncoding");
  cpdf_text($pdf, 100, 100, "Some text");
  cpdf_end_text($pdf)
  ?> 
See also cpdf_begin_text().   cpdf_curvetoUpcpdf_fill_stroke
#

#T=bool cpdf_end_text ( int pdf_document)
cpdf_end_text ( ^!int pdf_document);
#

#T=cpdf_fill_stroke - bool cpdf_fill_stroke ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_fill_stroke -- Fill and stroke current path
Description
bool cpdf_fill_stroke ( int pdf_document)
The cpdf_fill_stroke() function fills the interior of the current path 
with the current fill color and draws current path. Returns TRUE on 
success or FALSE on failure. 
See also cpdf_closepath(), cpdf_stroke(), cpdf_fill(), 
cpdf_setgray_fill(), cpdf_setgray(), cpdf_setrgbcolor_fill() and 
cpdf_setrgbcolor().   cpdf_end_textUpcpdf_fill
#

#T=bool cpdf_fill_stroke ( int pdf_document)
cpdf_fill_stroke ( ^!int pdf_document);
#

#T=cpdf_fill - bool cpdf_fill ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_fill -- Fill current path
Description
bool cpdf_fill ( int pdf_document)
The cpdf_fill() function fills the interior of the current path with the 
current fill color. Returns TRUE on success or FALSE on failure. 
See also cpdf_closepath(), cpdf_stroke(), cpdf_setgray_fill(), 
cpdf_setgray(), cpdf_setrgbcolor_fill() and cpdf_setrgbcolor().   cpdf_fill_strokeUpcpdf_finalize_page
#

#T=bool cpdf_fill ( int pdf_document)
cpdf_fill ( ^!int pdf_document);
#

#T=cpdf_finalize_page - bool cpdf_finalize_page ( int pdf_document, int page_number)
(PHP 3>= 3.0.10, PHP 4 )
cpdf_finalize_page -- Ends page
Description
bool cpdf_finalize_page ( int pdf_document, int page_number)
The cpdf_finalize_page() function ends the page with page number 
page_number. Returns TRUE on success or FALSE on failure. 
This function is only for saving memory. A finalized page takes less 
memory but cannot be modified anymore. 
See also cpdf_page_init().   cpdf_fillUpcpdf_finalize
#

#T=bool cpdf_finalize_page ( int pdf_document, int page_number)
cpdf_finalize_page ( ^!int pdf_document, int page_number);
#

#T=cpdf_finalize - bool cpdf_finalize ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_finalize -- Ends document
Description
bool cpdf_finalize ( int pdf_document)
The cpdf_finalize() function ends the document. You still have to call 
cpdf_close(). Returns TRUE on success or FALSE on failure. 
See also cpdf_close().   cpdf_finalize_pageUpcpdf_global_set_document_limits
#

#T=bool cpdf_finalize ( int pdf_document)
cpdf_finalize ( ^!int pdf_document);
#

#T=cpdf_global_set_document_limits - bool cpdf_global_set_document_limits ( int maxpages, int maxfonts, int 
(PHP 4 )
cpdf_global_set_document_limits -- Sets document limits for any pdf 
document
Description
bool cpdf_global_set_document_limits ( int maxpages, int maxfonts, int 
maximages, int maxannotations, int maxobjects)
The cpdf_global_set_document_limits() function sets several document 
limits. This function has to be called before cpdf_open() to take effect. 
It sets the limits for any document open afterwards. Returns TRUE on 
success or FALSE on failure. 
See also cpdf_open().   cpdf_finalizeUpcpdf_import_jpeg
#

#T=bool cpdf_global_set_document_limits ( int maxpages, int maxfonts, int 
cpdf_global_set_document_limits ( ^!int maxpages, int maxfonts, int ;
#

#T=cpdf_import_jpeg - int cpdf_import_jpeg ( int pdf_document, string file_name, float x-coor, 
(PHP 3>= 3.0.9, PHP 4 )
cpdf_import_jpeg -- Opens a JPEG image
Description
int cpdf_import_jpeg ( int pdf_document, string file_name, float x-coor, 
float y-coor, float angle, float width, float height, float x-scale, float 
y-scale, int gsave [, int mode])
The cpdf_import_jpeg() function opens an image stored in the file with the 
name file name. The format of the image has to be jpeg. The image is 
placed on the current page at position (x-coor, y-coor). The image is 
rotated by angle degrees. gsave should be non-zero to allow this function 
to operate correctly. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_place_inline_image().   cpdf_global_set_document_limitsUpcpdf_lineto
#

#T=int cpdf_import_jpeg ( int pdf_document, string file_name, float x-coor, 
cpdf_import_jpeg ( ^!int pdf_document, string file_name, float x-coor, ;
#

#T=cpdf_lineto - bool cpdf_lineto ( int pdf_document, float x-coor, float y-coor [, int 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_lineto -- Draws a line
Description
bool cpdf_lineto ( int pdf_document, float x-coor, float y-coor [, int 
mode])
The cpdf_lineto() function draws a line from the current point to the 
point with coordinates (x-coor, y-coor). Returns TRUE on success or FALSE 
on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_moveto(), cpdf_rmoveto() and cpdf_curveto().   cpdf_import_jpegUpcpdf_moveto
#

#T=bool cpdf_lineto ( int pdf_document, float x-coor, float y-coor [, int 
cpdf_lineto ( ^!int pdf_document, float x-coor, float y-coor [, int ;
#

#T=cpdf_moveto - bool cpdf_moveto ( int pdf_document, float x-coor, float y-coor [, int 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_moveto -- Sets current point
Description
bool cpdf_moveto ( int pdf_document, float x-coor, float y-coor [, int 
mode])
The cpdf_moveto() function set the current point to the coordinates x-coor 
and y-coor. Returns TRUE on success or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.  cpdf_linetoUpcpdf_newpath
#

#T=bool cpdf_moveto ( int pdf_document, float x-coor, float y-coor [, int 
cpdf_moveto ( ^!int pdf_document, float x-coor, float y-coor [, int ;
#

#T=cpdf_newpath - bool cpdf_newpath ( int pdf_document)
(PHP 3>= 3.0.9, PHP 4 )
cpdf_newpath -- Starts a new path
Description
bool cpdf_newpath ( int pdf_document)
The cpdf_newpath() starts a new path on the document given by the 
pdf_document parameter. Returns TRUE on success or FALSE on failure.   cpdf_movetoUpcpdf_open
#

#T=bool cpdf_newpath ( int pdf_document)
cpdf_newpath ( ^!int pdf_document);
#

#T=cpdf_open - int cpdf_open ( int compression [, string filename])
(PHP 3>= 3.0.8, PHP 4 )
cpdf_open -- Opens a new pdf document
Description
int cpdf_open ( int compression [, string filename])
The cpdf_open() function opens a new pdf document. The first parameter 
turns document compression on if it is unequal to 0. The second optional 
parameter sets the file in which the document is written. If it is omitted 
the document is created in memory and can either be written into a file 
with the cpdf_save_to_file() or written to standard output with 
cpdf_output_buffer(). 
Note: The return value will be needed in further versions of ClibPDF as 
the first parameter in all other functions which are writing to the pdf 
document. 
The ClibPDF library takes the filename "-" as a synonym for stdout. If 
PHP is compiled as an apache module this will not work because the way 
ClibPDF outputs to stdout does not work with apache. You can solve this 
problem by skipping the filename and using cpdf_output_buffer() to 
output the pdf document. 
See also cpdf_close() and cpdf_output_buffer().   cpdf_newpathUpcpdf_output_buffer
#

#T=int cpdf_open ( int compression [, string filename])
cpdf_open ( ^!int compression [, string filename]);
#

#T=cpdf_output_buffer - bool cpdf_output_buffer ( int pdf_document)
(PHP 3>= 3.0.9, PHP 4 )
cpdf_output_buffer -- Outputs the pdf document in memory buffer
Description
bool cpdf_output_buffer ( int pdf_document)
The cpdf_output_buffer() function outputs the pdf document to stdout. The 
document has to be created in memory which is the case if cpdf_open() has 
been called with no filename parameter. Returns TRUE on success or FALSE 
on failure. 
See also cpdf_open().   cpdf_openUpcpdf_page_init
#

#T=bool cpdf_output_buffer ( int pdf_document)
cpdf_output_buffer ( ^!int pdf_document);
#

#T=cpdf_page_init - bool cpdf_page_init ( int pdf_document, int page_number, int orientation, 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_page_init -- Starts new page
Description
bool cpdf_page_init ( int pdf_document, int page_number, int orientation, 
float height, float width [, float unit])
The cpdf_page_init() function starts a new page with height height and 
width width. Returns TRUE on success or FALSE on failure. The page has 
number page_number and orientation orientation. orientation can be 0 for 
portrait and 1 for landscape. The last optional parameter unit sets the 
unit for the coordinate system. The value should be the number of 
postscript points per unit. Since one inch is equal to 72 points, a value 
of 72 would set the unit to one inch. The default is also 72. 
See also cpdf_set_current_page().   cpdf_output_bufferUpcpdf_place_inline_image
#

#T=bool cpdf_page_init ( int pdf_document, int page_number, int orientation, 
cpdf_page_init ( ^!int pdf_document, int page_number, int orientation, ;
#

#T=cpdf_place_inline_image - bool cpdf_place_inline_image ( int pdf_document, int image, float x-coor, 
(PHP 3>= 3.0.9, PHP 4 )
cpdf_place_inline_image -- Places an image on the page
Description
bool cpdf_place_inline_image ( int pdf_document, int image, float x-coor, 
float y-coor, float angle, float width, float height [, int mode])
The cpdf_place_inline_image() function places an image created with the 
PHP image functions on the page at position (x-coor, y-coor). The image 
can be scaled at the same time. Returns TRUE on success or FALSE on 
failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_import_jpeg().   cpdf_page_initUpcpdf_rect
#

#T=bool cpdf_place_inline_image ( int pdf_document, int image, float x-coor, 
cpdf_place_inline_image ( ^!int pdf_document, int image, float x-coor, ;
#

#T=cpdf_rect - bool cpdf_rect ( int pdf_document, float x-coor, float y-coor, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_rect -- Draw a rectangle
Description
bool cpdf_rect ( int pdf_document, float x-coor, float y-coor, float 
width, float height [, int mode])
The cpdf_rect() function draws a rectangle with its lower left corner at 
point (x-coor, y-coor). This width is set to width. This height is set to 
height. Returns TRUE on success or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
Example 1. Drawing a rectangle
  <?php

  $cpdf = cpdf_open(0);
  cpdf_page_init($cpdf, 1, 0, 595, 842, 1.0);

  // set the fill color to red
  cpdf_setrgbcolor($cpdf, 1, 0, 0);

  // draw a (180 * 100) rectangle
  cpdf_rect($cpdf, 645, 400, 180, 100);

  // fill the rectangle
  cpdf_fill($cpdf);

  cpdf_finalize($cpdf);
  Header("Content-type: application/pdf");
  cpdf_output_buffer($cpdf);
  cpdf_close($cpdf);

  ?> 

  cpdf_place_inline_imageUpcpdf_restore
#

#T=bool cpdf_rect ( int pdf_document, float x-coor, float y-coor, float 
cpdf_rect ( ^!int pdf_document, float x-coor, float y-coor, float ;
#

#T=cpdf_restore - bool cpdf_restore ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_restore -- Restores formerly saved environment
Description
bool cpdf_restore ( int pdf_document)
The cpdf_restore() function restores the environment saved with 
cpdf_save(). It works like the postscript command grestore. Very useful if 
you want to translate or rotate an object without effecting other objects. 
Returns TRUE on success or FALSE on failure. 
Example 1. Save/Restore
  <?php
  cpdf_save($pdf);
  // do all kinds of rotations, transformations, ...
  cpdf_restore($pdf)
  ?> 
See also cpdf_save().   cpdf_rectUpcpdf_rlineto
#

#T=bool cpdf_restore ( int pdf_document)
cpdf_restore ( ^!int pdf_document);
#

#T=cpdf_rlineto - bool cpdf_rlineto ( int pdf_document, float x-coor, float y-coor [, int 
(PHP 3>= 3.0.9, PHP 4 )
cpdf_rlineto -- Draws a line
Description
bool cpdf_rlineto ( int pdf_document, float x-coor, float y-coor [, int 
mode])
The cpdf_rlineto() function draws a line from the current point to the 
relative point with coordinates (x-coor, y-coor). Returns TRUE on success 
or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_moveto(), cpdf_rmoveto() and cpdf_curveto().   cpdf_restoreUpcpdf_rmoveto
#

#T=bool cpdf_rlineto ( int pdf_document, float x-coor, float y-coor [, int 
cpdf_rlineto ( ^!int pdf_document, float x-coor, float y-coor [, int ;
#

#T=cpdf_rmoveto - bool cpdf_rmoveto ( int pdf_document, float x-coor, float y-coor [, int 
(PHP 3>= 3.0.9, PHP 4 )
cpdf_rmoveto -- Sets current point
Description
bool cpdf_rmoveto ( int pdf_document, float x-coor, float y-coor [, int 
mode])
The cpdf_rmoveto() function set the current point relative to the 
coordinates x-coor and y-coor. Returns TRUE on success or FALSE on 
failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_moveto().   cpdf_rlinetoUpcpdf_rotate_text
#

#T=bool cpdf_rmoveto ( int pdf_document, float x-coor, float y-coor [, int 
cpdf_rmoveto ( ^!int pdf_document, float x-coor, float y-coor [, int ;
#

#T=cpdf_rotate_text - bool cpdf_rotate_text ( int pdfdoc, float angle)
(PHP 3>= 3.0.9, PHP 4 )
cpdf_rotate_text --  Sets text rotation angle 
Description
bool cpdf_rotate_text ( int pdfdoc, float angle)
Warning
This function is currently not documented; only the argument list is 
available.
  cpdf_rmovetoUpcpdf_rotate
#

#T=bool cpdf_rotate_text ( int pdfdoc, float angle)
cpdf_rotate_text ( ^!int pdfdoc, float angle);
#

#T=cpdf_rotate - bool cpdf_rotate ( int pdf_document, float angle)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_rotate -- Sets rotation
Description
bool cpdf_rotate ( int pdf_document, float angle)
The cpdf_rotate() function set the rotation in degrees to angle. Returns 
TRUE on success or FALSE on failure.   cpdf_rotate_textUpcpdf_save_to_file
#

#T=bool cpdf_rotate ( int pdf_document, float angle)
cpdf_rotate ( ^!int pdf_document, float angle);
#

#T=cpdf_save_to_file - bool cpdf_save_to_file ( int pdf_document, string filename)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_save_to_file -- Writes the pdf document into a file
Description
bool cpdf_save_to_file ( int pdf_document, string filename)
The cpdf_save_to_file() function outputs the pdf document into a file if 
it has been created in memory. Returns TRUE on success or FALSE on 
failure. 
This function is not needed if the pdf document has been open by 
specifying a filename as a parameter of cpdf_open(). 
See also cpdf_output_buffer() and cpdf_open().   cpdf_rotateUpcpdf_save
#

#T=bool cpdf_save_to_file ( int pdf_document, string filename)
cpdf_save_to_file ( ^!int pdf_document, string filename);
#

#T=cpdf_save - bool cpdf_save ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_save -- Saves current environment
Description
bool cpdf_save ( int pdf_document)
The cpdf_save() function saves the current environment. It works like the 
postscript command gsave. Very useful if you want to translate or rotate 
an object without effecting other objects. Returns TRUE on success or 
FALSE on failure. 
See also cpdf_restore().   cpdf_save_to_fileUpcpdf_scale
#

#T=bool cpdf_save ( int pdf_document)
cpdf_save ( ^!int pdf_document);
#

#T=cpdf_scale - bool cpdf_scale ( int pdf_document, float x-scale, float y-scale)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_scale -- Sets scaling
Description
bool cpdf_scale ( int pdf_document, float x-scale, float y-scale)
The cpdf_scale() function set the scaling factor in both directions. 
Returns TRUE on success or FALSE on failure.   cpdf_saveUpcpdf_set_action_url
#

#T=bool cpdf_scale ( int pdf_document, float x-scale, float y-scale)
cpdf_scale ( ^!int pdf_document, float x-scale, float y-scale);
#

#T=cpdf_set_action_url - bool cpdf_set_action_url ( int pdfdoc, float xll, float yll, float xur, 
(PHP 3>= 3.0.9, PHP 4 )
cpdf_set_action_url --  Sets hyperlink 
Description
bool cpdf_set_action_url ( int pdfdoc, float xll, float yll, float xur, 
float xur, string url [, int mode])
Warning
This function is currently not documented; only the argument list is 
available.
  cpdf_scaleUpcpdf_set_char_spacing
#

#T=bool cpdf_set_action_url ( int pdfdoc, float xll, float yll, float xur, 
cpdf_set_action_url ( ^!int pdfdoc, float xll, float yll, float xur, ;
#

#T=cpdf_set_char_spacing - bool cpdf_set_char_spacing ( int pdf_document, float space)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_char_spacing -- Sets character spacing
Description
bool cpdf_set_char_spacing ( int pdf_document, float space)
The cpdf_set_char_spacing() function sets the spacing between characters. 
Returns TRUE on success or FALSE on failure. 
See also cpdf_set_word_spacing() and cpdf_set_leading().   cpdf_set_action_urlUpcpdf_set_creator
#

#T=bool cpdf_set_char_spacing ( int pdf_document, float space)
cpdf_set_char_spacing ( ^!int pdf_document, float space);
#

#T=cpdf_set_creator - bool cpdf_set_creator ( string creator)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_creator -- Sets the creator field in the pdf document
Description
bool cpdf_set_creator ( string creator)
The cpdf_set_creator() function sets the creator of a pdf document. 
Returns TRUE on success or FALSE on failure. 
See also cpdf_set_subject(), cpdf_set_title() and cpdf_set_keywords().   cpdf_set_char_spacingUpcpdf_set_current_page
#

#T=bool cpdf_set_creator ( string creator)
cpdf_set_creator ( ^!string creator);
#

#T=cpdf_set_current_page - bool cpdf_set_current_page ( int pdf_document, int page_number)
(PHP 3>= 3.0.9, PHP 4 )
cpdf_set_current_page -- Sets current page
Description
bool cpdf_set_current_page ( int pdf_document, int page_number)
The cpdf_set_current_page() function set the page on which all operations 
are performed. One can switch between pages until a page is finished with 
cpdf_finalize_page(). Returns TRUE on success or FALSE on failure. 
See also cpdf_finalize_page().   cpdf_set_creatorUpcpdf_set_font_directories
#

#T=bool cpdf_set_current_page ( int pdf_document, int page_number)
cpdf_set_current_page ( ^!int pdf_document, int page_number);
#

#T=cpdf_set_font_directories - bool cpdf_set_font_directories ( int pdfdoc, string pfmdir, string pfbdir)
(PHP 4 >= 4.0.6)
cpdf_set_font_directories --  Sets directories to search when using 
external fonts 
Description
bool cpdf_set_font_directories ( int pdfdoc, string pfmdir, string pfbdir)
Warning
This function is currently not documented; only the argument list is 
available.
  cpdf_set_current_pageUpcpdf_set_font_map_file
#

#T=bool cpdf_set_font_directories ( int pdfdoc, string pfmdir, string pfbdir)
cpdf_set_font_directories ( ^!int pdfdoc, string pfmdir, string pfbdir);
#

#T=cpdf_set_font_map_file - bool cpdf_set_font_map_file ( int pdfdoc, string filename)
(PHP 4 >= 4.0.6)
cpdf_set_font_map_file --  Sets fontname to filename translation map when 
using external fonts 
Description
bool cpdf_set_font_map_file ( int pdfdoc, string filename)
Warning
This function is currently not documented; only the argument list is 
available.
  cpdf_set_font_directoriesUpcpdf_set_font
#

#T=bool cpdf_set_font_map_file ( int pdfdoc, string filename)
cpdf_set_font_map_file ( ^!int pdfdoc, string filename);
#

#T=cpdf_set_font - bool cpdf_set_font ( int pdf_document, string font_name, float size, 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_font -- Select the current font face and size
Description
bool cpdf_set_font ( int pdf_document, string font_name, float size, 
string encoding)
The cpdf_set_font() function sets the current font face, font size and 
encoding. Currently only the standard postscript fonts are supported. 
Returns TRUE on success or FALSE on failure. 
The last parameter encoding can take the following values: 
"MacRomanEncoding", "MacExpertEncoding", "WinAnsiEncoding", and "NULL". 
"NULL" stands for the font's built-in encoding. 
See the ClibPDF Manual for more information, especially how to support 
Asian fonts.   cpdf_set_font_map_fileUpcpdf_set_horiz_scaling
#

#T=bool cpdf_set_font ( int pdf_document, string font_name, float size, 
cpdf_set_font ( ^!int pdf_document, string font_name, float size, ;
#

#T=cpdf_set_horiz_scaling - bool cpdf_set_horiz_scaling ( int pdf_document, float scale)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_horiz_scaling -- Sets horizontal scaling of text
Description
bool cpdf_set_horiz_scaling ( int pdf_document, float scale)
The cpdf_set_horiz_scaling() function sets the horizontal scaling to scale 
percent. Returns TRUE on success or FALSE on failure.   cpdf_set_fontUpcpdf_set_keywords
#

#T=bool cpdf_set_horiz_scaling ( int pdf_document, float scale)
cpdf_set_horiz_scaling ( ^!int pdf_document, float scale);
#

#T=cpdf_set_keywords - bool cpdf_set_keywords ( string keywords)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_keywords -- Sets the keywords field of the pdf document
Description
bool cpdf_set_keywords ( string keywords)
The cpdf_set_keywords() function sets the keywords of a pdf document. 
Returns TRUE on success or FALSE on failure. 
See also cpdf_set_title(), cpdf_set_creator() and cpdf_set_subject().   cpdf_set_horiz_scalingUpcpdf_set_leading
#

#T=bool cpdf_set_keywords ( string keywords)
cpdf_set_keywords ( ^!string keywords);
#

#T=cpdf_set_leading - bool cpdf_set_leading ( int pdf_document, float distance)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_leading -- Sets distance between text lines
Description
bool cpdf_set_leading ( int pdf_document, float distance)
The cpdf_set_leading() function sets the distance between text lines. This 
will be used if text is output by cpdf_continue_text(). Returns TRUE on 
success or FALSE on failure. 
See also cpdf_continue_text().   cpdf_set_keywordsUpcpdf_set_page_animation
#

#T=bool cpdf_set_leading ( int pdf_document, float distance)
cpdf_set_leading ( ^!int pdf_document, float distance);
#

#T=cpdf_set_page_animation - bool cpdf_set_page_animation ( int pdf_document, int transition, float 
(PHP 3>= 3.0.9, PHP 4 )
cpdf_set_page_animation -- Sets duration between pages
Description
bool cpdf_set_page_animation ( int pdf_document, int transition, float 
duration)
The cpdf_set_page_animation() function set the transition between 
following pages. Returns TRUE on success or FALSE on failure. 
The value of transition can be 
0 for none,
1 for two lines sweeping across the screen reveal the page, 
2 for multiple lines sweeping across the screen reveal the page, 
3 for a box reveals the page,
4 for a single line sweeping across the screen reveals the page, 
5 for the old page dissolves to reveal the page,
6 for the dissolve effect moves from one screen edge to another, 
7 for the old page is simply replaced by the new page (default) 

The value of duration is the number of seconds between page flipping.   cpdf_set_leadingUpcpdf_set_subject
#

#T=bool cpdf_set_page_animation ( int pdf_document, int transition, float 
cpdf_set_page_animation ( ^!int pdf_document, int transition, float ;
#

#T=cpdf_set_subject - bool cpdf_set_subject ( int pdf_document, string subject)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_subject -- Sets the subject field of the pdf document
Description
bool cpdf_set_subject ( int pdf_document, string subject)
The cpdf_set_subject() function sets the subject of a pdf document. 
Returns TRUE on success or FALSE on failure. 
See also cpdf_set_title(), cpdf_set_creator() and cpdf_set_keywords().   cpdf_set_page_animationUpcpdf_set_text_matrix
#

#T=bool cpdf_set_subject ( int pdf_document, string subject)
cpdf_set_subject ( ^!int pdf_document, string subject);
#

#T=cpdf_set_text_matrix - bool cpdf_set_text_matrix ( int pdf_document, array matrix)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_text_matrix -- Sets the text matrix
Description
bool cpdf_set_text_matrix ( int pdf_document, array matrix)
The cpdf_set_text_matrix() function sets a matrix which describes a 
transformation applied on the current text font. Returns TRUE on success 
or FALSE on failure.   cpdf_set_subjectUpcpdf_set_text_pos
#

#T=bool cpdf_set_text_matrix ( int pdf_document, array matrix)
cpdf_set_text_matrix ( ^!int pdf_document, array matrix);
#

#T=cpdf_set_text_pos - bool cpdf_set_text_pos ( int pdf_document, float x-coor, float y-coor [, 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_text_pos -- Sets text position
Description
bool cpdf_set_text_pos ( int pdf_document, float x-coor, float y-coor [, 
int mode])
The cpdf_set_text_pos() function sets the position of text for the next 
cpdf_show() function call. Returns TRUE on success or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
See also cpdf_show() and cpdf_text().   cpdf_set_text_matrixUpcpdf_set_text_rendering
#

#T=bool cpdf_set_text_pos ( int pdf_document, float x-coor, float y-coor [, 
cpdf_set_text_pos ( ^!int pdf_document, float x-coor, float y-coor [, ;
#

#T=cpdf_set_text_rendering - bool cpdf_set_text_rendering ( int pdf_document, int rendermode)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_text_rendering -- Determines how text is rendered
Description
bool cpdf_set_text_rendering ( int pdf_document, int rendermode)
The cpdf_set_text_rendering() function determines how text is rendered. 
Returns TRUE on success or FALSE on failure. 
The possible values for rendermode are 0=fill text, 1=stroke text, 2=fill 
and stroke text, 3=invisible, 4=fill text and add it to clipping path, 
5=stroke text and add it to clipping path, 6=fill and stroke text and add 
it to clipping path, 7=add it to clipping path.   cpdf_set_text_posUpcpdf_set_text_rise
#

#T=bool cpdf_set_text_rendering ( int pdf_document, int rendermode)
cpdf_set_text_rendering ( ^!int pdf_document, int rendermode);
#

#T=cpdf_set_text_rise - bool cpdf_set_text_rise ( int pdf_document, float value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_text_rise -- Sets the text rise
Description
bool cpdf_set_text_rise ( int pdf_document, float value)
The cpdf_set_text_rise() function sets the text rising to value units. 
Returns TRUE on success or FALSE on failure.   cpdf_set_text_renderingUpcpdf_set_title
#

#T=bool cpdf_set_text_rise ( int pdf_document, float value)
cpdf_set_text_rise ( ^!int pdf_document, float value);
#

#T=cpdf_set_title - bool cpdf_set_title ( string title)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_title -- Sets the title field of the pdf document
Description
bool cpdf_set_title ( string title)
The cpdf_set_title() function sets the title of a pdf document. Returns 
TRUE on success or FALSE on failure. 
See also cpdf_set_subject(), cpdf_set_creator() and cpdf_set_keywords().   cpdf_set_text_riseUpcpdf_set_viewer_preferences
#

#T=bool cpdf_set_title ( string title)
cpdf_set_title ( ^!string title);
#

#T=cpdf_set_viewer_preferences - bool cpdf_set_viewer_preferences ( int pdfdoc, array preferences)
(PHP 3>= 3.0.9, PHP 4 )
cpdf_set_viewer_preferences --  How to show the document in the viewer 
Description
bool cpdf_set_viewer_preferences ( int pdfdoc, array preferences)
Warning
This function is currently not documented; only the argument list is 
available.
  cpdf_set_titleUpcpdf_set_word_spacing
#

#T=bool cpdf_set_viewer_preferences ( int pdfdoc, array preferences)
cpdf_set_viewer_preferences ( ^!int pdfdoc, array preferences);
#

#T=cpdf_set_word_spacing - bool cpdf_set_word_spacing ( int pdf_document, float space)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_set_word_spacing -- Sets spacing between words
Description
bool cpdf_set_word_spacing ( int pdf_document, float space)
The cpdf_set_word_spacing() function sets the spacing between words. 
Returns TRUE on success or FALSE on failure. 
See also cpdf_set_char_spacing() and cpdf_set_leading().   cpdf_set_viewer_preferencesUpcpdf_setdash
#

#T=bool cpdf_set_word_spacing ( int pdf_document, float space)
cpdf_set_word_spacing ( ^!int pdf_document, float space);
#

#T=cpdf_setdash - bool cpdf_setdash ( int pdf_document, float white, float black)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setdash -- Sets dash pattern
Description
bool cpdf_setdash ( int pdf_document, float white, float black)
The cpdf_setdash() function set the dash pattern white white units and 
black black units. If both are 0 a solid line is set. Returns TRUE on 
success or FALSE on failure.   cpdf_set_word_spacingUpcpdf_setflat
#

#T=bool cpdf_setdash ( int pdf_document, float white, float black)
cpdf_setdash ( ^!int pdf_document, float white, float black);
#

#T=cpdf_setflat - bool cpdf_setflat ( int pdf_document, float value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setflat -- Sets flatness
Description
bool cpdf_setflat ( int pdf_document, float value)
The cpdf_setflat() function set the flatness to a value between 0 and 100. 
Returns TRUE on success or FALSE on failure.   cpdf_setdashUpcpdf_setgray_fill
#

#T=bool cpdf_setflat ( int pdf_document, float value)
cpdf_setflat ( ^!int pdf_document, float value);
#

#T=cpdf_setgray_fill - bool cpdf_setgray_fill ( int pdf_document, float value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setgray_fill -- Sets filling color to gray value
Description
bool cpdf_setgray_fill ( int pdf_document, float value)
The cpdf_setgray_fill() function sets the current gray value to fill a 
path. Returns TRUE on success or FALSE on failure. 
See also cpdf_setrgbcolor_fill().   cpdf_setflatUpcpdf_setgray_stroke
#

#T=bool cpdf_setgray_fill ( int pdf_document, float value)
cpdf_setgray_fill ( ^!int pdf_document, float value);
#

#T=cpdf_setgray_stroke - bool cpdf_setgray_stroke ( int pdf_document, float gray_value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setgray_stroke -- Sets drawing color to gray value
Description
bool cpdf_setgray_stroke ( int pdf_document, float gray_value)
The cpdf_setgray_stroke() function sets the current drawing color to the 
given gray value. Returns TRUE on success or FALSE on failure. 
See also cpdf_setrgbcolor_stroke().   cpdf_setgray_fillUpcpdf_setgray
#

#T=bool cpdf_setgray_stroke ( int pdf_document, float gray_value)
cpdf_setgray_stroke ( ^!int pdf_document, float gray_value);
#

#T=cpdf_setgray - bool cpdf_setgray ( int pdf_document, float gray_value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setgray -- Sets drawing and filling color to gray value
Description
bool cpdf_setgray ( int pdf_document, float gray_value)
The cpdf_setgray() function sets the current drawing and filling color to 
the given gray value. Returns TRUE on success or FALSE on failure. 
See also cpdf_setrgbcolor_stroke() and cpdf_setrgbcolor_fill().   cpdf_setgray_strokeUpcpdf_setlinecap
#

#T=bool cpdf_setgray ( int pdf_document, float gray_value)
cpdf_setgray ( ^!int pdf_document, float gray_value);
#

#T=cpdf_setlinecap - bool cpdf_setlinecap ( int pdf_document, int value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setlinecap -- Sets linecap parameter
Description
bool cpdf_setlinecap ( int pdf_document, int value)
The cpdf_setlinecap() function set the linecap parameter between a value 
of 0 and 2. 0 = butt end, 1 = round, 2 = projecting square. Returns TRUE 
on success or FALSE on failure.   cpdf_setgrayUpcpdf_setlinejoin
#

#T=bool cpdf_setlinecap ( int pdf_document, int value)
cpdf_setlinecap ( ^!int pdf_document, int value);
#

#T=cpdf_setlinejoin - bool cpdf_setlinejoin ( int pdf_document, int value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setlinejoin -- Sets linejoin parameter
Description
bool cpdf_setlinejoin ( int pdf_document, int value)
The cpdf_setlinejoin() function set the linejoin parameter between a value 
of 0 and 2. 0 = miter, 1 = round, 2 = bevel. Returns TRUE on success or 
FALSE on failure.   cpdf_setlinecapUpcpdf_setlinewidth
#

#T=bool cpdf_setlinejoin ( int pdf_document, int value)
cpdf_setlinejoin ( ^!int pdf_document, int value);
#

#T=cpdf_setlinewidth - bool cpdf_setlinewidth ( int pdf_document, float width)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setlinewidth -- Sets line width
Description
bool cpdf_setlinewidth ( int pdf_document, float width)
The cpdf_setlinewidth() function set the line width to width. Returns TRUE 
on success or FALSE on failure.   cpdf_setlinejoinUpcpdf_setmiterlimit
#

#T=bool cpdf_setlinewidth ( int pdf_document, float width)
cpdf_setlinewidth ( ^!int pdf_document, float width);
#

#T=cpdf_setmiterlimit - bool cpdf_setmiterlimit ( int pdf_document, float value)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setmiterlimit -- Sets miter limit
Description
bool cpdf_setmiterlimit ( int pdf_document, float value)
The cpdf_setmiterlimit() function set the miter limit to a value greater 
or equal than 1. Returns TRUE on success or FALSE on failure.   cpdf_setlinewidthUpcpdf_setrgbcolor_fill
#

#T=bool cpdf_setmiterlimit ( int pdf_document, float value)
cpdf_setmiterlimit ( ^!int pdf_document, float value);
#

#T=cpdf_setrgbcolor_fill - bool cpdf_setrgbcolor_fill ( int pdf_document, float red_value, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setrgbcolor_fill -- Sets filling color to rgb color value
Description
bool cpdf_setrgbcolor_fill ( int pdf_document, float red_value, float 
green_value, float blue_value)
The cpdf_setrgbcolor_fill() function sets the current rgb color value to 
fill a path. Returns TRUE on success or FALSE on failure. 
Note: The values are expected to be floating point values between 0.0 
and 1.0. (i.e black is (0.0, 0.0, 0.0) and white is (1.0, 1.0, 1.0)). 
See also cpdf_setrgbcolor_stroke() and cpdf_setrgbcolor().   cpdf_setmiterlimitUpcpdf_setrgbcolor_stroke
#

#T=bool cpdf_setrgbcolor_fill ( int pdf_document, float red_value, float 
cpdf_setrgbcolor_fill ( ^!int pdf_document, float red_value, float ;
#

#T=cpdf_setrgbcolor_stroke - bool cpdf_setrgbcolor_stroke ( int pdf_document, float red_value, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setrgbcolor_stroke -- Sets drawing color to rgb color value
Description
bool cpdf_setrgbcolor_stroke ( int pdf_document, float red_value, float 
green_value, float blue_value)
The cpdf_setrgbcolor_stroke() function sets the current drawing color to 
the given rgb color value. Returns TRUE on success or FALSE on failure. 
Note: The values are expected to be floating point values between 0.0 
and 1.0. (i.e black is (0.0, 0.0, 0.0) and white is (1.0, 1.0, 1.0)). 
See also cpdf_setrgbcolor_fill() and cpdf_setrgbcolor().   cpdf_setrgbcolor_fillUpcpdf_setrgbcolor
#

#T=bool cpdf_setrgbcolor_stroke ( int pdf_document, float red_value, float 
cpdf_setrgbcolor_stroke ( ^!int pdf_document, float red_value, float ;
#

#T=cpdf_setrgbcolor - bool cpdf_setrgbcolor ( int pdf_document, float red_value, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_setrgbcolor -- Sets drawing and filling color to rgb color value
Description
bool cpdf_setrgbcolor ( int pdf_document, float red_value, float 
green_value, float blue_value)
The cpdf_setrgbcolor() function sets the current drawing and filling color 
to the given rgb color value. Returns TRUE on success or FALSE on failure. 

Note: The values are expected to be floating point values between 0.0 
and 1.0. (i.e black is (0.0, 0.0, 0.0) and white is (1.0, 1.0, 1.0)). 
See also cpdf_setrgbcolor_stroke() and cpdf_setrgbcolor_fill().   cpdf_setrgbcolor_strokeUpcpdf_show_xy
#

#T=bool cpdf_setrgbcolor ( int pdf_document, float red_value, float 
cpdf_setrgbcolor ( ^!int pdf_document, float red_value, float ;
#

#T=cpdf_show_xy - bool cpdf_show_xy ( int pdf_document, string text, float x-coor, float 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_show_xy -- Output text at position
Description
bool cpdf_show_xy ( int pdf_document, string text, float x-coor, float 
y-coor [, int mode])
The cpdf_show_xy() function outputs the string text at position with 
coordinates (x-coor, y-coor). Returns TRUE on success or FALSE on failure. 

The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
Note: The function cpdf_show_xy() is identical to cpdf_text() without 
the optional parameters. 
See also cpdf_text().   cpdf_setrgbcolorUpcpdf_show
#

#T=bool cpdf_show_xy ( int pdf_document, string text, float x-coor, float 
cpdf_show_xy ( ^!int pdf_document, string text, float x-coor, float ;
#

#T=cpdf_show - bool cpdf_show ( int pdf_document, string text)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_show -- Output text at current position
Description
bool cpdf_show ( int pdf_document, string text)
The cpdf_show() function outputs the string in text at the current 
position. Returns TRUE on success or FALSE on failure. 
See also cpdf_text(), cpdf_begin_text() and cpdf_end_text().   cpdf_show_xyUpcpdf_stringwidth
#

#T=bool cpdf_show ( int pdf_document, string text)
cpdf_show ( ^!int pdf_document, string text);
#

#T=cpdf_stringwidth - float cpdf_stringwidth ( int pdf_document, string text)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_stringwidth -- Returns width of text in current font
Description
float cpdf_stringwidth ( int pdf_document, string text)
The cpdf_stringwidth() function returns the width of the string in text. 
It requires a font to be set before. 
See also cpdf_set_font().   cpdf_showUpcpdf_stroke
#

#T=float cpdf_stringwidth ( int pdf_document, string text)
cpdf_stringwidth ( ^!int pdf_document, string text);
#

#T=cpdf_stroke - bool cpdf_stroke ( int pdf_document)
(PHP 3>= 3.0.8, PHP 4 )
cpdf_stroke -- Draw line along path
Description
bool cpdf_stroke ( int pdf_document)
The cpdf_stroke() function draws a line along current path. Returns TRUE 
on success or FALSE on failure. 
See also cpdf_closepath() and cpdf_closepath_stroke().   cpdf_stringwidthUpcpdf_text
#

#T=bool cpdf_stroke ( int pdf_document)
cpdf_stroke ( ^!int pdf_document);
#

#T=cpdf_text - bool cpdf_text ( int pdf_document, string text, float x-coor, float y-coor 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_text -- Output text with parameters
Description
bool cpdf_text ( int pdf_document, string text, float x-coor, float y-coor 
[, int mode [, float orientation [, int alignmode]]])
The cpdf_text() function outputs the string text at position with 
coordinates (x-coor, y-coor). Returns TRUE on success or FALSE on failure. 

The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.
The optional parameter orientation is the rotation of the text in degree. 
The optional parameter alignmode determines how the text is aligned. 
See the ClibPDF documentation for possible values. 
See also cpdf_show_xy().   cpdf_strokeUpcpdf_translate
#

#T=bool cpdf_text ( int pdf_document, string text, float x-coor, float y-coor 
cpdf_text ( ^!int pdf_document, string text, float x-coor, float y-coor ;
#

#T=cpdf_translate - bool cpdf_translate ( int pdf_document, float x-coor, float y-coor [, int 
(PHP 3>= 3.0.8, PHP 4 )
cpdf_translate -- Sets origin of coordinate system
Description
bool cpdf_translate ( int pdf_document, float x-coor, float y-coor [, int 
mode])
The cpdf_translate() function set the origin of coordinate system to the 
point (x-coor, y-coor). Returns TRUE on success or FALSE on failure. 
The optional parameter mode determines the unit length. If it is 0 or 
omitted the default unit as specified for the page is used. Otherwise the 
coordinates are measured in postscript points disregarding the current 
unit.  cpdf_textUpCrack functions
#

#T=bool cpdf_translate ( int pdf_document, float x-coor, float y-coor [, int 
cpdf_translate ( ^!int pdf_document, float x-coor, float y-coor [, int ;
#

#T=crack_check - bool crack_check ( [resource dictionary, string password])
(PHP 4 >= 4.0.5)
crack_check -- Performs an obscure check with the given password
Description
bool crack_check ( [resource dictionary, string password])
Returns TRUE if password is strong, or FALSE otherwise. 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

crack_check() performs an obscure check with the given password on the 
specified dictionary . If dictionary is not specified, the last opened 
dictionary is used.   Crack functionsUpcrack_closedict
#

#T=bool crack_check ( [resource dictionary, string password])
crack_check ( ^![resource dictionary, string password]);
#

#T=crack_closedict - bool crack_closedict ( [resource dictionary])
(PHP 4 >= 4.0.5)
crack_closedict -- Closes an open CrackLib dictionary 
Description
bool crack_closedict ( [resource dictionary])
Returns TRUE on success or FALSE on failure. 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

crack_closedict() closes the specified dictionary identifier. If 
dictionary is not specified, the current dictionary is closed.   crack_checkUpcrack_getlastmessage
#

#T=bool crack_closedict ( [resource dictionary])
crack_closedict ( ^![resource dictionary]);
#

#T=crack_getlastmessage - string crack_getlastmessage ( void )
(PHP 4 >= 4.0.5)
crack_getlastmessage -- Returns the message from the last obscure check
Description
string crack_getlastmessage ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

crack_getlastmessage() returns the message from the last obscure check.   crack_closedictUpcrack_opendict
#

#T=string crack_getlastmessage ( void )
crack_getlastmessage ( ^!void );
#

#T=crack_opendict - resource crack_opendict ( string dictionary)
(PHP 4 >= 4.0.5)
crack_opendict -- Opens a new CrackLib dictionary
Description
resource crack_opendict ( string dictionary)
Returns a dictionary resource identifier on success, or FALSE on failure. 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

crack_opendict() opens the specified CrackLib dictionary for use with 
crack_check(). 
Note: Only one dictionary may be open at a time. 
See also: crack_check(), and crack_closedict().   crack_getlastmessageUpCURL, Client URL Library Functions
#

#T=resource crack_opendict ( string dictionary)
crack_opendict ( ^!string dictionary);
#

#T=crc32 - int crc32 ( string str)
(PHP 4 >= 4.0.1)
crc32 -- Calculates the crc32 polynomial of a string
Description
int crc32 ( string str)
Generates the cyclic redundancy checksum polynomial of 32-bit lengths of 
the str. This is usually used to validate the integrity of data being 
transmitted. 
Because PHP's integer type is signed, and many crc32 checksums will result 
in negative integers, you need to use the "%u" formatter of sprintf() or 
printf() to get the string representation of the unsigned crc32 checksum. 
This second example shows how to print a converted checksum with the 
printf() function: Example 1. Displaying a crc32 checksum
  <?php
  $checksum = crc32("The quick brown fox jumped over the lazy 
  dog.");
  printf("%u\n", $checksum);
  ?> 
See also md5() and sha1().   count_charsUpcrypt
#

#T=int crc32 ( string str)
crc32 ( ^!string str);
#

#T=create_function - string create_function ( string args, string code)
(PHP 4 >= 4.0.1)
create_function -- Create an anonymous (lambda-style) function
Description
string create_function ( string args, string code)
Creates an anonymous function from the parameters passed, and returns a 
unique name for it. Usually the args will be passed as a single quote 
delimited string, and this is also recommended for the code. The reason 
for using single quoted strings, is to protect the variable names from 
parsing, otherwise, if you use double quotes there will be a need to 
escape the variable names, e.g. \$avar. 
You can use this function, to (for example) create a function from 
information gathered at run time: 
Example 1. Creating an anonymous function with create_function() 
  <?php
  $newfunc = create_function('$a,$b', 'return "ln($a) + ln($b) = 
  " . log($a * $b);');
  echo "New anonymous function: $newfunc\n";
  echo $newfunc(2, M_E) . "\n";
  // outputs
  // New anonymous function: lambda_1
  // ln(2) + ln(2.718281828459) = 1.6931471805599
  ?> 
Or, perhaps to have general handler function that can apply a set of 
operations to a list of parameters: 
Example 2. Making a general processing function with 
create_function() 
  <?php
  function process($var1, $var2, $farr) {
      for ($f=0; $f < count($farr); $f++)
	  echo $farr[$f]($var1, $var2) . "\n";
  }

  // create a bunch of math functions
  $f1 = 'if ($a >=0) {return "b*a^2 = ".$b*sqrt($a);} else 
  {return false;}';
  $f2 = "return \"min(b^2+a, a^2,b) = 
  \".min(\$a*\$a+\$b,\$b*\$b+\$a);";
  $f3 = 'if ($a > 0 && $b != 0) {return "ln(a)/b = ".log($a)/$b; 
  } else { return false; }';
  $farr = array(
      create_function('$x,$y', 'return "some trig: ".(sin($x) + 
  $x*cos($y));'),
      create_function('$x,$y', 'return "a hypotenuse: 
  ".sqrt($x*$x + $y*$y);'),
      create_function('$a,$b', $f1),
      create_function('$a,$b', $f2),
      create_function('$a,$b', $f3)
      );

  echo "\nUsing the first array of anonymous functions\n";
  echo "parameters: 2.3445, M_PI\n";
  process(2.3445, M_PI, $farr);

  // now make a bunch of string processing functions
  $garr = array(
      create_function('$b,$a', 'if (strncmp($a, $b, 3) == 0) 
  return "** \"$a\" '.
      'and \"$b\"\n** Look the same to me! (looking at the first 
  3 chars)";'),
      create_function('$a,$b', '; return "CRCs: " . crc32($a) . 
  " , ".crc32(b);'),
      create_function('$a,$b', '; return "similar(a,b) = " . 
  similar_text($a, $b, &$p) . "($p%)";')
      );
  echo "\nUsing the second array of anonymous functions\n";
  process("Twas brilling and the slithy toves", "Twas the 
  night", $garr);
  ?> 

and when you run the code above, the output will be: 
Using the first array of anonymous functions
parameters: 2.3445, M_PI
some trig: -1.6291725057799
a hypotenuse: 3.9199852871011
b*a^2 = 4.8103313314525
min(b^2+a, a^2,b) = 8.6382729035898
ln(a/b) = 0.27122299212594

Using the second array of anonymous functions
** "Twas the night" and "Twas brilling and the slithy toves"
** Look the same to me! (looking at the first 3 chars)
CRCs: -725381282 , 1908338681
similar(a,b) = 11(45.833333333333%)
But perhaps the most common use for of lambda-style (anonymous) functions 
is to create callback functions, for example when using array_walk() or 
usort() 
Example 3. Using anonymous functions as callback functions
  <?php
  $av = array("the ", "a ", "that ", "this ");
  array_walk($av, create_function('&$v,$k', '$v = $v . 
  "mango";'));
  print_r($av); 
  ?> 

outputs: 
Array
(
[0] => the mango
[1] => a mango
[2] => that mango
[3] => this mango
)

an array of strings ordered from shorter to longer 
  <?php

  $sv = array("small", "larger", "a big string", "it is a string 
  thing");
  print_r($sv);

  ?> 

outputs: 
Array
(
[0] => small
[1] => larger
[2] => a big string
[3] => it is a string thing
)

sort it from longer to shorter 
  <?php

  usort($sv, create_function('$a,$b','return strlen($b) - 
  strlen($a);'));
  print_r($sv);

  ?> 

outputs: 
Array
(
[0] => it is a string thing
[1] => a big string
[2] => larger
[3] => small
)

  call_user_funcUpfunc_get_arg
#

#T=string create_function ( string args, string code)
create_function ( ^!string args, string code);
#

#T=crypt - string crypt ( string str [, string salt])
(PHP 3, PHP 4 )
crypt -- One-way string encryption (hashing)
Description
string crypt ( string str [, string salt])
crypt() will return an encrypted string using the standard Unix DES-based 
encryption algorithm or alternative algorithms that may be available on 
the system. Arguments are a string to be encrypted and an optional salt 
string to base the encryption on. See the Unix man page for your crypt 
function for more information. 
If the salt argument is not provided, one will be randomly generated by 
PHP. 
Some operating systems support more than one type of encryption. In fact, 
sometimes the standard DES-based encryption is replaced by an MD5-based 
encryption algorithm. The encryption type is triggered by the salt 
argument. At install time, PHP determines the capabilities of the crypt 
function and will accept salts for other encryption types. If no salt is 
provided, PHP will auto-generate a standard two character salt by default, 
unless the default encryption type on the system is MD5, in which case a 
random MD5-compatible salt is generated. PHP sets a constant named 
CRYPT_SALT_LENGTH which tells you whether a regular two character salt 
applies to your system or the longer twelve character salt is applicable. 
If you are using the supplied salt, you should be aware that the salt is 
generated once. If you are calling this function recursively, this may 
impact both appearance and security. 
The standard DES-based encryption crypt() returns the salt as the first 
two characters of the output. It also only uses the first eight characters 
of str, so longer strings that start with the same eight characters will 
generate the same result (when the same salt is used). 
On systems where the crypt() function supports multiple encryption types, 
the following constants are set to 0 or 1 depending on whether the given 
type is available: 
CRYPT_STD_DES - Standard DES-based encryption with a two character salt 
CRYPT_EXT_DES - Extended DES-based encryption with a nine character salt 

CRYPT_MD5 - MD5 encryption with a twelve character salt starting with 
$1$ 
CRYPT_BLOWFISH - Blowfish encryption with a sixteen character salt 
starting with $2$ 
Note: There is no decrypt function, since crypt() uses a one-way 
algorithm. 
Example 1. crypt() examples
  <?php
  $password = crypt("My1sTpassword"); // let salt be generated

  # You should pass the entire results of crypt() as the salt 
  for comparing a
  # password, to avoid problems when different hashing 
  algorithms are used. (As
  # it says above, standard DES-based password hashing uses a 
  2-character salt,
  # but MD5-based hashing uses 12.)
  if (crypt($user_input, $password) == $password) {
     echo "Password verified!";
  }
  ?> 
See also md5() and the Mcrypt extension.   crc32Upecho
#

#T=string crypt ( string str [, string salt])
crypt ( ^!string str [, string salt]);
#

#T=ctype_alnum - bool ctype_alnum ( string text)
(PHP 4 >= 4.0.4)
ctype_alnum -- Check for alphanumeric character(s)
Description
bool ctype_alnum ( string text)
Returns TRUE if every character in text is either a letter or a digit, 
FALSE otherwise. In the standard C locale letters are just [A-Za-z] and 
the function is equivalent to preg_match('/^[a-z0-9]*$/i', $text). 
See also ctype_alpha(), ctype_digit(), and setlocale().   Character type functionsUpctype_alpha
#

#T=bool ctype_alnum ( string text)
ctype_alnum ( ^!string text);
#

#T=ctype_alpha - bool ctype_alpha ( string text)
(PHP 4 >= 4.0.4)
ctype_alpha -- Check for alphabetic character(s)
Description
bool ctype_alpha ( string text)
Returns TRUE if every character in text is a letter from the current 
locale, FALSE otherwise. In the standard C locale letters are just 
[A-Za-z] and ctype_alpha() is equivalent to (ctype_upper($text) || 
ctype_lower($text)) if $text is just a single character, but other 
languages have letters that are considered neither upper nor lower case. 
See also ctype_upper(), ctype_lower(), and setlocale().   ctype_alnumUpctype_cntrl
#

#T=bool ctype_alpha ( string text)
ctype_alpha ( ^!string text);
#

#T=ctype_cntrl - bool ctype_cntrl ( string text)
(PHP 4 >= 4.0.4)
ctype_cntrl -- Check for control character(s)
Description
bool ctype_cntrl ( string text)
Returns TRUE if every character in text has a special control function, 
FALSE otherwise. Control characters are e.g. line feed, tab, esc.   ctype_alphaUpctype_digit
#

#T=bool ctype_cntrl ( string text)
ctype_cntrl ( ^!string text);
#

#T=ctype_digit - bool ctype_digit ( string text)
(PHP 4 >= 4.0.4)
ctype_digit -- Check for numeric character(s)
Description
bool ctype_digit ( string text)
Returns TRUE if every character in text is a decimal digit, FALSE 
otherwise. 
See also ctype_alnum() and ctype_xdigit().   ctype_cntrlUpctype_graph
#

#T=bool ctype_digit ( string text)
ctype_digit ( ^!string text);
#

#T=ctype_graph - bool ctype_graph ( string text)
(PHP 4 >= 4.0.4)
ctype_graph -- Check for any printable character(s) except space
Description
bool ctype_graph ( string text)
Returns TRUE if every character in text is printable and actually creates 
visible output (no white space), FALSE otherwise. 
See also ctype_alnum(), ctype_print(), and ctype_punct().   ctype_digitUpctype_lower
#

#T=bool ctype_graph ( string text)
ctype_graph ( ^!string text);
#

#T=ctype_lower - bool ctype_lower ( string text)
(PHP 4 >= 4.0.4)
ctype_lower -- Check for lowercase character(s)
Description
bool ctype_lower ( string text)
Returns TRUE if every character in text is a lowercase letter in the 
current locale. 
See also ctype_alpha() and ctype_upper().   ctype_graphUpctype_print
#

#T=bool ctype_lower ( string text)
ctype_lower ( ^!string text);
#

#T=ctype_print - bool ctype_print ( string text)
(PHP 4 >= 4.0.4)
ctype_print -- Check for printable character(s)
Description
bool ctype_print ( string text)
Returns TRUE if every character in text will actually create output 
(including blanks). Returns FALSE if text contains control characters or 
characters that do not have any output or control function at all. 
See also ctype_cntrl(), ctype_graph(), and ctype_punct().   ctype_lowerUpctype_punct
#

#T=bool ctype_print ( string text)
ctype_print ( ^!string text);
#

#T=ctype_punct - bool ctype_punct ( string text)
(PHP 4 >= 4.0.4)
ctype_punct --  Check for any printable character which is not whitespace 
or an alphanumeric character 
Description
bool ctype_punct ( string text)
Returns TRUE if every character in text is printable, but neither letter, 
digit or blank, FALSE otherwise. 
See also ctype_cntrl(), ctype_graph(), and ctype_punct().   ctype_printUpctype_space
#

#T=bool ctype_punct ( string text)
ctype_punct ( ^!string text);
#

#T=ctype_space - bool ctype_space ( string text)
(PHP 4 >= 4.0.4)
ctype_space -- Check for whitespace character(s)
Description
bool ctype_space ( string text)
Returns TRUE if every character in text creates some sort of white space, 
FALSE otherwise. Besides the blank character this also includes tab, 
vertical tab, line feed, carriage return and form feed characters.   ctype_punctUpctype_upper
#

#T=bool ctype_space ( string text)
ctype_space ( ^!string text);
#

#T=ctype_upper - bool ctype_upper ( string text)
(PHP 4 >= 4.0.4)
ctype_upper -- Check for uppercase character(s)
Description
bool ctype_upper ( string text)
Returns TRUE if every character in text is an uppercase letter in the 
current locale. 
See also ctype_alpha() and ctype_lower().   ctype_spaceUpctype_xdigit
#

#T=bool ctype_upper ( string text)
ctype_upper ( ^!string text);
#

#T=ctype_xdigit - bool ctype_xdigit ( string text)
(PHP 4 >= 4.0.4)
ctype_xdigit --  Check for character(s) representing a hexadecimal digit 
Description
bool ctype_xdigit ( string text)
Returns TRUE if every character in text is a hexadecimal 'digit', that is 
a decimal digit or a character from [A-Fa-f] , FALSE otherwise. 
See also ctype_digit().   ctype_upperUpDatabase (dbm-style) abstraction layer functions
#

#T=bool ctype_xdigit ( string text)
ctype_xdigit ( ^!string text);
#

#T=curl_close - void curl_close ( resource ch)
(PHP 4 >= 4.0.2)
curl_close -- Close a CURL session
Description
void curl_close ( resource ch)
This function closes a CURL session and frees all resources. The CURL 
handle, ch, is also deleted.   CURL, Client URL Library FunctionsUpcurl_errno
#

#T=void curl_close ( resource ch)
curl_close ( ^!resource ch);
#

#T=curl_errno - int curl_errno ( resource ch)
(PHP 4 >= 4.0.3)
curl_errno -- Return the last error number
Description
int curl_errno ( resource ch)
Returns the error number for the last cURL operation on the resource ch, 
or 0 (zero) if no error occurred. 
See also curl_error().  curl_closeUpcurl_error
#

#T=int curl_errno ( resource ch)
curl_errno ( ^!resource ch);
#

#T=curl_error - string curl_error ( resource ch)
(PHP 4 >= 4.0.3)
curl_error --  Return a string containing the last error for the current 
session 
Description
string curl_error ( resource ch)
Returns a clear text error message for the last cURL operation on the 
resource ch, or '' (the empty string) if no error occurred. 
See also curl_errno().  curl_errnoUpcurl_exec
#

#T=string curl_error ( resource ch)
curl_error ( ^!resource ch);
#

#T=curl_exec - mixed curl_exec ( resource ch)
(PHP 4 >= 4.0.2)
curl_exec -- Perform a CURL session
Description
mixed curl_exec ( resource ch)
This function should be called after you initialize a CURL session and all 
the options for the session are set. Its purpose is simply to execute the 
predefined CURL session (given by the ch). 
Note: If you want to have the result returned instead of it being 
printed to the browser directly, use the CURLOPT_RETURNTRANSFER option 
of curl_setopt().   curl_errorUpcurl_getinfo
#

#T=mixed curl_exec ( resource ch)
curl_exec ( ^!resource ch);
#

#T=curl_getinfo - string curl_getinfo ( resource ch [, int opt])
(PHP 4 >= 4.0.4)
curl_getinfo --  Get information regarding a specific transfer 
Description
string curl_getinfo ( resource ch [, int opt])
Returns information about the last transfer, opt may be one of the 
following: 
"CURLINFO_EFFECTIVE_URL" - Last effective URL 
"CURLINFO_HTTP_CODE" - Last received HTTP code 
"CURLINFO_FILETIME" - Remote time of the retrieved document, if -1 is 
returned the time of the document is unknown 
"CURLINFO_TOTAL_TIME" - Total transaction time in seconds for last 
transfer 
"CURLINFO_NAMELOOKUP_TIME" - Time in seconds until name resolving was 
complete 
"CURLINFO_CONNECT_TIME" - Time in seconds it took to establish the 
connection 
"CURLINFO_PRETRANSFER_TIME" - Time in seconds from start until just 
before file transfer begins 
"CURLINFO_STARTTRANSFER_TIME" - Time in seconds until the first byte is 
about to be transferred 
"CURLINFO_REDIRECT_TIME" - Time in seconds of all redirection steps 
before final transaction was started 
"CURLINFO_SIZE_UPLOAD" - Total number of bytes uploaded 
"CURLINFO_SIZE_DOWNLOAD" - Total number of bytes downloaded 
"CURLINFO_SPEED_DOWNLOAD" - Average download speed 
"CURLINFO_SPEED_UPLOAD" - Average upload speed 
"CURLINFO_HEADER_SIZE" - Total size of all headers received 
"CURLINFO_REQUEST_SIZE" - Total size of issued requests, currently only 
for HTTP requests 
"CURLINFO_SSL_VERIFYRESULT" - Result of SSL certification verification 
requested by setting CURLOPT_SSL_VERIFYPEER 
"CURLINFO_CONTENT_LENGTH_DOWNLOAD" - content-length of download, read 
from Content-Length: field 
"CURLINFO_CONTENT_LENGTH_UPLOAD" - Specified size of upload 
"CURLINFO_CONTENT_TYPE" - Content-type of downloaded object, NULL 
indicates server did not send valid Content-Type: header 
If called without the optional parameter opt an associative array is 
returned with the following array elements which correspond to opt 
options: 
"url" 
"content_type" 
"http_encode" 
"header_size" 
"request_size" 
"filetime" 
"ssl_verify_result" 
"redirect_count" 
"total_time" 
"namelookup_time" 
"connect_time" 
"pretransfer_time" 
"size_upload" 
"size_download" 
"speed_download" 
"speed_upload" 
"download_content_length" 
"upload_content_length" 
"starttransfer_time" 
"redirect_time"   curl_execUpcurl_init
#

#T=string curl_getinfo ( resource ch [, int opt])
curl_getinfo ( ^!resource ch [, int opt]);
#

#T=curl_init - resource curl_init ( [string url])
(PHP 4 >= 4.0.2)
curl_init -- Initialize a CURL session
Description
resource curl_init ( [string url])
The curl_init() will initialize a new session and return a CURL handle for 
use with the curl_setopt(), curl_exec(), and curl_close() functions. If 
the optional url parameter is supplied then the CURLOPT_URL option will be 
set to the value of the parameter. You can manually set this using the 
curl_setopt() function. Example 1. Initializing a new CURL session 
and fetching a webpage 
  <?php
  $ch = curl_init();

  curl_setopt($ch, CURLOPT_URL, "http://www.example.com/");
  curl_setopt($ch, CURLOPT_HEADER, 0);

  curl_exec($ch);

  curl_close($ch);
  ?> 
See also: curl_close(), curl_setopt()   curl_getinfoUpcurl_multi_add_handle
#

#T=resource curl_init ( [string url])
curl_init ( ^![string url]);
#

#T=curl_multi_add_handle - int curl_multi_add_handle ( resource mh, resource ch)
(PHP 5 CVS only)
curl_multi_add_handle --  Add a normal cURL handle to a cURL multi handle 
Description
int curl_multi_add_handle ( resource mh, resource ch)
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_multi_init(), curl_init(), and curl_multi_remove_handle().   curl_initUpcurl_multi_close
#

#T=int curl_multi_add_handle ( resource mh, resource ch)
curl_multi_add_handle ( ^!resource mh, resource ch);
#

#T=curl_multi_close - void curl_multi_close ( resource mh)
(PHP 5 CVS only)
curl_multi_close --  Close a set of cURL handles 
Description
void curl_multi_close ( resource mh)
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_multi_init() and curl_close().   curl_multi_add_handleUpcurl_multi_exec
#

#T=void curl_multi_close ( resource mh)
curl_multi_close ( ^!resource mh);
#

#T=curl_multi_exec - int curl_multi_exec ( resource mh)
(PHP 5 CVS only)
curl_multi_exec --  Run the sub-connections of the current cURL handle 
Description
int curl_multi_exec ( resource mh)
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_multi_init() and curl_exec().   curl_multi_closeUpcurl_multi_getcontent
#

#T=int curl_multi_exec ( resource mh)
curl_multi_exec ( ^!resource mh);
#

#T=curl_multi_getcontent - string curl_multi_getcontent ( resource ch)
(PHP 5 CVS only)
curl_multi_getcontent --  Return the content of a cURL handle if 
CURLOPT_RETURNTRANSFER is set 
Description
string curl_multi_getcontent ( resource ch)
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_multi_init().   curl_multi_execUpcurl_multi_info_read
#

#T=string curl_multi_getcontent ( resource ch)
curl_multi_getcontent ( ^!resource ch);
#

#T=curl_multi_info_read - array curl_multi_info_read ( resource mh)
(PHP 5 CVS only)
curl_multi_info_read --  Get information about the current transfers 
Description
array curl_multi_info_read ( resource mh)
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_multi_init().   curl_multi_getcontentUpcurl_multi_init
#

#T=array curl_multi_info_read ( resource mh)
curl_multi_info_read ( ^!resource mh);
#

#T=curl_multi_init - resource curl_multi_init ( void )
(PHP 5 CVS only)
curl_multi_init --  Returns a new cURL multi handle 
Description
resource curl_multi_init ( void )
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_init() and curl_multi_close().   curl_multi_info_readUpcurl_multi_remove_handle
#

#T=resource curl_multi_init ( void )
curl_multi_init ( ^!void );
#

#T=curl_multi_remove_handle - int curl_multi_remove_handle ( resource mh, resource ch)
(PHP 5 CVS only)
curl_multi_remove_handle --  Remove a multi handle from a set of cURL 
handles 
Description
int curl_multi_remove_handle ( resource mh, resource ch)
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_multi_init(), curl_init(), and curl_multi_add_handle().   curl_multi_initUpcurl_multi_select
#

#T=int curl_multi_remove_handle ( resource mh, resource ch)
curl_multi_remove_handle ( ^!resource mh, resource ch);
#

#T=curl_multi_select - int curl_multi_select ( resource mh [, float timeout])
(PHP 5 CVS only)
curl_multi_select --  Get all the sockets associated with the cURL 
extension, which can then be "selected" 
Description
int curl_multi_select ( resource mh [, float timeout])
Warning
This function is currently not documented; only the argument list is 
available.

See also curl_multi_init().   curl_multi_remove_handleUpcurl_setopt
#

#T=int curl_multi_select ( resource mh [, float timeout])
curl_multi_select ( ^!resource mh [, float timeout]);
#

#T=curl_setopt - bool curl_setopt ( resource ch, string option, mixed value)
(PHP 4 >= 4.0.2)
curl_setopt -- Set an option for a CURL transfer
Description
bool curl_setopt ( resource ch, string option, mixed value)
The curl_setopt() function will set options for a CURL session identified 
by the ch parameter. The option parameter is the option you want to set, 
and the value is the value of the option given by the option. 
The value should be a long for the following options (specified in the 
option parameter): 
CURLOPT_INFILESIZE: When you are uploading a file to a remote site, this 
option should be used to tell PHP what the expected size of the infile 
will be. 
CURLOPT_VERBOSE: Set this option to a non-zero value if you want CURL to 
report everything that is happening. 
CURLOPT_HEADER: Set this option to a non-zero value if you want the 
header to be included in the output. 
CURLOPT_NOPROGRESS: Set this option to a non-zero value if you don't 
want PHP to display a progress meter for CURL transfers. 
Note: PHP automatically sets this option to a non-zero parameter, this 
should only be changed for debugging purposes. 
CURLOPT_NOBODY: Set this option to a non-zero value if you don't want 
the body included with the output. 
CURLOPT_FAILONERROR: Set this option to a non-zero value if you want PHP 
to fail silently if the HTTP code returned is greater than 300. The 
default behavior is to return the page normally, ignoring the code. 
CURLOPT_UPLOAD: Set this option to a non-zero value if you want PHP to 
prepare for an upload. 
CURLOPT_POST: Set this option to a non-zero value if you want PHP to do 
a regular HTTP POST. This POST is a normal 
application/x-www-form-urlencoded kind, most commonly used by HTML 
forms. 
CURLOPT_FTPLISTONLY: Set this option to a non-zero value and PHP will 
just list the names of an FTP directory. 
CURLOPT_FTPAPPEND: Set this option to a non-zero value and PHP will 
append to the remote file instead of overwriting it. 
CURLOPT_NETRC: Set this option to a non-zero value and PHP will scan 
your ~./netrc file to find your username and password for the remote 
site that you're establishing a connection with. 
CURLOPT_FOLLOWLOCATION: Set this option to a non-zero value to follow 
any "Location: " header that the server sends as a part of the HTTP 
header (note this is recursive, PHP will follow as many "Location: " 
headers that it is sent.) 
CURLOPT_PUT: Set this option to a non-zero value to HTTP PUT a file. The 
file to PUT must be set with the CURLOPT_INFILE and CURLOPT_INFILESIZE. 
CURLOPT_MUTE: Set this option to a non-zero value and PHP will be 
completely silent with regards to the CURL functions. 
CURLOPT_TIMEOUT: Pass a long as a parameter that contains the maximum 
time, in seconds, that you'll allow the CURL functions to take. 
CURLOPT_LOW_SPEED_LIMIT: Pass a long as a parameter that contains the 
transfer speed in bytes per second that the transfer should be below 
during CURLOPT_LOW_SPEED_TIME seconds for PHP to consider too slow and 
abort. 
CURLOPT_LOW_SPEED_TIME: Pass a long as a parameter that contains the 
time in seconds that the transfer should be below the 
CURLOPT_LOW_SPEED_LIMIT for PHP to consider it too slow and abort. 
CURLOPT_RESUME_FROM: Pass a long as a parameter that contains the 
offset, in bytes, that you want the transfer to start from. 
CURLOPT_CAINFO: Pass a filename of a file holding one or more 
certificates to verify the peer with. This only makes sense when used in 
combination with the CURLOPT_SSL_VERIFYPEER option. 
CURLOPT_SSL_VERIFYPEER: Pass a long that is set to a zero value to stop 
curl from verifying the peer's certificate (curl 7.10 starting setting 
this option to TRUE by default). Alternate certificates to verify 
against can be specified with the CURLOPT_CAINFO option (added in curl 
7.9.8) or a certificate directory can be specified with the 
CURLOPT_CAPATH option. As of curl 7.10, curl installs a default bundle. 
CURLOPT_SSL_VERIFYHOST may also need to be set to 1 or 0 if 
CURLOPT_SSL_VERIFYPEER is disabled (it defaults to 2). 
CURLOPT_SSLVERSION: Pass a long as a parameter that contains the SSL 
version (2 or 3) to use. By default PHP will try and determine this by 
itself, although, in some cases you must set this manually. 
CURLOPT_SSL_VERIFYHOST: Pass a long if CURL should verify the Common 
name of the peer certificate in the SSL handshake. A value of 1 denotes 
that we should check for the existence of the common name, a value of 2 
denotes that we should make sure it matches the provided hostname. 
CURLOPT_TIMECONDITION: Pass a long as a parameter that defines how the 
CURLOPT_TIMEVALUE is treated. You can set this parameter to 
TIMECOND_IFMODSINCE or TIMECOND_ISUNMODSINCE. This is a HTTP-only 
feature. 
CURLOPT_TIMEVALUE: Pass a long as a parameter that is the time in 
seconds since January 1st, 1970. The time will be used as specified by 
the CURLOPT_TIMECONDITION option, or by default the TIMECOND_IFMODSINCE 
will be used. 
CURLOPT_RETURNTRANSFER: Pass a non-zero value if you want CURL to 
directly return the transfer instead of printing it out directly. 
The value parameter should be a string for the following values of the 
option parameter: 
CURLOPT_URL: This is the URL that you want PHP to fetch. You can also 
set this option when initializing a session with the curl_init() 
function. 
CURLOPT_USERPWD: Pass a string formatted in the [username]:[password] 
manner, for PHP to use for the connection. 
CURLOPT_PROXYUSERPWD: Pass a string formatted in the 
[username]:[password] format for connection to the HTTP proxy. 
CURLOPT_RANGE: Pass the specified range you want. It should be in the 
"X-Y" format, where X or Y may be left out. The HTTP transfers also 
support several intervals, separated with commas as in X-Y,N-M. 
CURLOPT_POSTFIELDS: Pass a string containing the full data to post in an 
HTTP "POST" operation. 
CURLOPT_REFERER: Pass a string containing the "referer" header to be 
used in an HTTP request. 
CURLOPT_USERAGENT: Pass a string containing the "user-agent" header to 
be used in an HTTP request. 
CURLOPT_FTPPORT: Pass a string containing the value which will be used 
to get the IP address to use for the ftp "POST" instruction. The POST 
instruction tells the remote server to connect to our specified IP 
address. The string may be a plain IP address, a hostname, a network 
interface name (under Unix), or just a plain '-' to use the systems 
default IP address. 
CURLOPT_COOKIE: Pass a string containing the content of the cookie to be 
set in the HTTP header. 
CURLOPT_SSLCERT: Pass a string containing the filename of PEM formatted 
certificate. 
CURLOPT_SSLCERTPASSWD: Pass a string containing the password required to 
use the CURLOPT_SSLCERT certificate. 
CURLOPT_COOKIEFILE: Pass a string containing the name of the file 
containing the cookie data. The cookie file can be in Netscape format, 
or just plain HTTP-style headers dumped into a file. 
CURLOPT_CUSTOMREQUEST: Pass a string to be used instead of GET or HEAD 
when doing an HTTP request. This is useful for doing DELETE or other, 
more obscure, HTTP requests. Valid values are things like GET, POST, and 
so on; i.e. do not enter a whole HTTP request line here. For instance, 
entering 'GET /index.html HTTP/1.0\r\n\r\n' would be incorrect. 
Note: Don't do this without making sure your server supports the 
command first. 
CURLOPT_PROXY: Give the name of the HTTP proxy to tunnel requests 
through. 
CURLOPT_INTERFACE: Pass the name of the outgoing network interface to 
use. This can be an interface name, an IP address or a host name. 
CURLOPT_KRB4LEVEL: Pass the KRB4 (Kerberos 4) security level. Any of the 
following values (in order from least to most powerful) are valid: 
'clear', 'safe', 'confidential', 'private'. If the string does not match 
one of these, then 'private' is used. Setting this Option to NULL, will 
disable KRB4 security. Currently KRB4 security only works with FTP 
transactions. 
CURLOPT_HTTPHEADER: Pass an array of HTTP header fields to set. 
CURLOPT_QUOTE: Pass an array of FTP commands to perform on the server 
prior to the FTP request. 
CURLOPT_POSTQUOTE: Pass an array of FTP commands to execute on the 
server, after the FTP request has been performed. 
The following options expect a file descriptor that is obtained by using 
the fopen() function: 
CURLOPT_FILE: The file where the output of your transfer should be 
placed, the default is STDOUT. 
CURLOPT_INFILE: The file where the input of your transfer comes from. 
CURLOPT_WRITEHEADER: The file to write the header part of the output 
into. 
CURLOPT_STDERR: The file to write errors to instead of stderr.   curl_multi_selectUpcurl_version
#

#T=bool curl_setopt ( resource ch, string option, mixed value)
curl_setopt ( ^!resource ch, string option, mixed value);
#

#T=curl_version - string curl_version ( void )
(PHP 4 >= 4.0.2)
curl_version -- Return the current CURL version
Description
string curl_version ( void )
The curl_version() function returns a string containing the current CURL 
version.   curl_setoptUpCybercash payment functions
#

#T=string curl_version ( void )
curl_version ( ^!void );
#

#T=current - mixed current ( array array)
(PHP 3, PHP 4 )
current -- Return the current element in an array
Description
mixed current ( array array)
Every array has an internal pointer to its "current" element, which is 
initialized to the first element inserted into the array. 
The current() function simply returns the value of the array element 
that's currently being pointed to by the internal pointer. It does not 
move the pointer in any way. If the internal pointer points beyond the end 
of the elements list, current() returns FALSE. 
Warning
If the array contains empty elements (0 or "", the empty string) 
then this function will return FALSE for these elements as well. 
This makes it impossible to determine if you are really at the end 
of the list in such an array using current(). To properly traverse 
an array that may contain empty elements, use the each() function. 

Example 1. Example use of current() and friends
  <?php
  $transport = array('foot', 'bike', 'car', 'plane');
  $mode = current($transport); // $mode = 'foot';
  $mode = next($transport);    // $mode = 'bike';
  $mode = current($transport); // $mode = 'bike';
  $mode = prev($transport);    // $mode = 'foot';
  $mode = end($transport);     // $mode = 'plane';
  $mode = current($transport); // $mode = 'plane';
  ?> 
See also end(), key(), next(), prev(), and reset().   countUpeach
#

#T=mixed current ( array array)
current ( ^!array array);
#

#T=cybercash_base64_decode - string cybercash_base64_decode ( string inbuff)
(PHP 4 <= 4.2.3)
cybercash_base64_decode -- base64 decode data for Cybercash
Description
string cybercash_base64_decode ( string inbuff)

  Cybercash payment functionsUpcybercash_base64_encode
#

#T=string cybercash_base64_decode ( string inbuff)
cybercash_base64_decode ( ^!string inbuff);
#

#T=cybercash_base64_encode - string cybercash_base64_encode ( string inbuff)
(PHP 4 <= 4.2.3)
cybercash_base64_encode -- base64 encode data for Cybercash
Description
string cybercash_base64_encode ( string inbuff)

  cybercash_base64_decodeUpcybercash_decr
#

#T=string cybercash_base64_encode ( string inbuff)
cybercash_base64_encode ( ^!string inbuff);
#

#T=cybercash_decr - array cybercash_decr ( string wmk, string sk, string inbuff)
(PHP 4 <= 4.2.3)
cybercash_decr -- Cybercash decrypt
Description
array cybercash_decr ( string wmk, string sk, string inbuff)
The function returns an associative array with the elements "errcode" and, 
if "errcode" is FALSE, "outbuff" (string), "outLth" (long) and "macbuff" 
(string).   cybercash_base64_encodeUpcybercash_encr
#

#T=array cybercash_decr ( string wmk, string sk, string inbuff)
cybercash_decr ( ^!string wmk, string sk, string inbuff);
#

#T=cybercash_encr - array cybercash_encr ( string wmk, string sk, string inbuff)
(PHP 4 <= 4.2.3)
cybercash_encr -- Cybercash encrypt
Description
array cybercash_encr ( string wmk, string sk, string inbuff)
The function returns an associative array with the elements "errcode" and, 
if "errcode" is FALSE, "outbuff" (string), "outLth" (long) and "macbuff" 
(string).   cybercash_decrUpCyrus IMAP administration functions
cyrus_authenticate
(4.1.0 - 4.3.2 only)
cyrus_authenticate -- Authenticate against a Cyrus IMAP server 
Description
bool cyrus_authenticate ( resource connection [, string mechlist [, string 
service [, string user [, int minssf [, int maxssf]]]]])
Warning
This function is currently not documented; only the argument list is 
available.
  Cyrus IMAP administration functionsUpcyrus_bind
cyrus_bind
(4.1.0 - 4.3.2 only)
cyrus_bind -- Bind callbacks to a Cyrus IMAP connection 
Description
bool cyrus_bind ( resource connection, array callbacks)
Warning
This function is currently not documented; only the argument list is 
available.
  cyrus_authenticateUpcyrus_close
cyrus_close
(4.1.0 - 4.3.2 only)
cyrus_close -- Close connection to a Cyrus IMAP server 
Description
bool cyrus_close ( resource connection)
Warning
This function is currently not documented; only the argument list is 
available.
  cyrus_bindUpcyrus_connect
cyrus_connect
(4.1.0 - 4.3.2 only)
cyrus_connect -- Connect to a Cyrus IMAP server 
Description
resource cyrus_connect ( [string host [, string port [, int flags]]])
Warning
This function is currently not documented; only the argument list is 
available.
  cyrus_closeUpcyrus_query
cyrus_query
(4.1.0 - 4.3.2 only)
cyrus_query -- Send a query to a Cyrus IMAP server 
Description
bool cyrus_query ( resource connection, string query)
Warning
This function is currently not documented; only the argument list is 
available.
  cyrus_connectUpcyrus_unbind
cyrus_unbind
(4.1.0 - 4.3.2 only)
cyrus_unbind -- Unbind ... 
Description
bool cyrus_unbind ( resource connection, string trigger_name)
Warning
This function is currently not documented; only the argument list is 
available.
  cyrus_queryUpCharacter type functions
#

#T=array cybercash_encr ( string wmk, string sk, string inbuff)
cybercash_encr ( ^!string wmk, string sk, string inbuff);
#

#T=date - string date ( string format [, int timestamp])
(PHP 3, PHP 4 )
date -- Format a local time/date
Description
string date ( string format [, int timestamp])
Returns a string formatted according to the given format string using the 
given integer timestamp or the current local time if no timestamp is 
given. In otherwords, timestamp is optional and defaults to the value of 
time(). 
Note: The valid range of a timestamp is typically from Fri, 13 Dec 1901 
20:45:54 GMT to Tue, 19 Jan 2038 03:14:07 GMT. (These are the dates that 
correspond to the minimum and maximum values for a 32-bit signed 
integer). On Windows this range is limited from 01-01-1970 to 
19-01-2038. 
Note: To generate a timestamp from a string representation of the date, 
you may be able to use strtotime(). Additionally, some databases have 
functions to convert their date formats into timestamps (such as MySQL's 
UNIX_TIMESTAMP function). 
Table 1. The following characters are recognized in the format parameter 
string
format characterDescriptionExample returned values
aLowercase Ante meridiem and Post meridiemam or pm
AUppercase Ante meridiem and Post meridiemAM or PM
BSwatch Internet time000 through 999
dDay of the month, 2 digits with leading zeros01 to 31
DA textual representation of a day, three lettersMon through Sun
FA full textual representation of a month, such as January or 
MarchJanuary through December
g12-hour format of an hour without leading zeros1 through 12
G24-hour format of an hour without leading zeros0 through 23
h12-hour format of an hour with leading zeros01 through 12
H24-hour format of an hour with leading zeros00 through 23
iMinutes with leading zeros00 to 59
I (capital i)Whether or not the date is in daylights savings time1 
if Daylight Savings Time, 0 otherwise.
jDay of the month without leading zeros1 to 31
l (lowercase 'L')A full textual representation of the day of the 
weekSunday through Saturday
LWhether it's a leap year1 if it is a leap year, 0 otherwise.
mNumeric representation of a month, with leading zeros01 through 12
MA short textual representation of a month, three lettersJan through 
Dec
nNumeric representation of a month, without leading zeros1 through 
12
ODifference to Greenwich time (GMT) in hoursExample: +0200
rRFC 822 formatted dateExample: Thu, 21 Dec 2000 16:01:07 +0200
sSeconds, with leading zeros00 through 59
SEnglish ordinal suffix for the day of the month, 2 charactersst, 
nd, rd or th. Works well with j 
tNumber of days in the given month28 through 31
TTimezone setting of this machineExamples: EST, MDT ...
USeconds since the Unix Epoch (January 1 1970 00:00:00 GMT)See also 
time()
wNumeric representation of the day of the week0 (for Sunday) through 
6 (for Saturday)
WISO-8601 week number of year, weeks starting on Monday (added in 
PHP 4.1.0)Example: 42 (the 42nd week in the year)
YA full numeric representation of a year, 4 digitsExamples: 1999 or 
2003
yA two digit representation of a yearExamples: 99 or 03
zThe day of the year (starting from 0)0 through 365
ZTimezone offset in seconds. The offset for timezones west of UTC is 
always negative, and for those east of UTC is always positive.-43200 
through 43200

Unrecognized characters in the format string will be printed as-is. The Z 
format will always return 0 when using gmdate(). 
Example 1. date() examples
  <?php
  // Prints something like: Wednesday
  echo date("l");

  // Prints something like: Wednesday 15th of January 2003 
  05:51:38 AM
  echo date ("l dS of F Y h:i:s A");

  // Prints: July 1, 2000 is on a Saturday
  echo "July 1, 2000 is on a " . date ("l", mktime(0, 0, 0, 7, 
  1, 2000));
  ?> 
You can prevent a recognized character in the format string from being 
expanded by escaping it with a preceding backslash. If the character with 
a backslash is already a special sequence, you may need to also escape the 
backslash. Example 2. Escaping characters in date()
  <?php
  // prints something like: Wednesday the 15th
  echo date("l \\t\h\e jS");
  ?> 
It is possible to use date() and mktime() together to find dates in the 
future or the past. Example 3. date() and mktime() example 
  <?php
  $tomorrow  = mktime(0, 0, 0, date("m")  , date("d")+1, 
  date("Y"));
  $lastmonth = mktime(0, 0, 0, date("m")-1, date("d"),   
  date("Y"));
  $nextyear  = mktime(0, 0, 0, date("m"),   date("d"),   
  date("Y")+1);
  ?> 
Note: This can be more reliable than simply adding or subtracting the 
number of seconds in a day or month to a timestamp because of daylight 
savings time. 
Some examples of date() formatting. Note that you should escape any other 
characters, as any which currently have a special meaning will produce 
undesirable results, and other characters may be assigned meaning in 
future PHP versions. When escaping, be sure to use single quotes to 
prevent characters like \n from becoming newlines. Example 4. date() 
Formatting 
  <?php
  // Assuming today is: March 10th, 2001, 5:16:18 pm

  $today = date("F j, Y, g:i a");                 // March 10, 
  2001, 5:16 pm
  $today = date("m.d.y");                         // 03.10.01
  $today = date("j, n, Y");                       // 10, 3, 2001
  $today = date("Ymd");                           // 20010310
  $today = date('h-i-s, j-m-y, it is w Day z ');  // 05-16-17, 
  10-03-01, 1631 1618 6 Fripm01
  $today = date('\i\t \i\s \t\h\e jS \d\a\y.');   // It is the 
  10th day.
  $today = date("D M j G:i:s T Y");               // Sat Mar 10 
  15:16:08 MST 2001
  $today = date('H:m:s \m \i\s\ \m\o\n\t\h');     // 17:03:17 m 
  is month
  $today = date("H:i:s");                         // 17:16:17
  ?> 
To format dates in other languages, you should use the setlocale() and 
strftime() functions. 
See also getlastmod(), gmdate(), mktime(), strftime() and time().   checkdateUpgetdate
#

#T=string date ( string format [, int timestamp])
date ( ^!string format [, int timestamp]);
#

#T=dba_close - void dba_close ( resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_close -- Close database
Description
void dba_close ( resource handle)
dba_close() closes the established database and frees all resources 
specified by handle. 
handle is a database handle returned by dba_open(). 
dba_close() does not return any value. 
See also: dba_open() and dba_popen()   Database (dbm-style) abstraction layer functionsUpdba_delete
#

#T=void dba_close ( resource handle)
dba_close ( ^!resource handle);
#

#T=dba_delete - bool dba_delete ( string key, resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_delete -- Delete entry specified by key
Description
bool dba_delete ( string key, resource handle)
dba_delete() deletes the entry specified by key from the database 
specified with handle. 
key is the key of the entry which is deleted. 
handle is a database handle returned by dba_open(). 
dba_delete() returns TRUE or FALSE, if the entry is deleted or not 
deleted, respectively. 
See also: dba_exists(), dba_fetch(), dba_insert(), and dba_replace().   dba_closeUpdba_exists
#

#T=bool dba_delete ( string key, resource handle)
dba_delete ( ^!string key, resource handle);
#

#T=dba_exists - bool dba_exists ( string key, resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_exists -- Check whether key exists
Description
bool dba_exists ( string key, resource handle)
dba_exists() checks whether the specified key exists in the database 
specified by handle. 
Key is the key the check is performed for. 
Handle is a database handle returned by dba_open(). 
dba_exists() returns TRUE or FALSE, if the key is found or not found, 
respectively. 
See also: dba_fetch(), dba_delete(), dba_insert(), and dba_replace().   dba_deleteUpdba_fetch
#

#T=bool dba_exists ( string key, resource handle)
dba_exists ( ^!string key, resource handle);
#

#T=dba_fetch - string dba_fetch ( string key, resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_fetch -- Fetch data specified by key
Description
string dba_fetch ( string key, resource handle)

string dba_fetch ( string key, int skip, resource handle)
dba_fetch() fetches the data specified by key from the database specified 
with handle. 
Key is the key the data is specified by. 
Skip is the number of key-value pairs to ignore when using cdb databases. 
This value is ignored for all other databases which do not support 
multiple keys with the same name. 
Handle is a database handle returned by dba_open(). 
dba_fetch() returns the associated string or FALSE, if the key/data pair 
is found or not found, respectively. 
See also: dba_exists(), dba_delete(), dba_insert(), dba_replace() and 
dba_key_split(). 
Note: The skip parameter is available since PHP 4.3 to support cdb's 
capability of multiple keys having the same name. 
Note: When working with inifiles this function accepts arrays as keys 
where index 0 is the group and index 1 is the value name. See: 
dba_key_split().   dba_existsUpdba_firstkey
#

#T=string dba_fetch ( string key, resource handle)
dba_fetch ( ^!string key, resource handle);
#

#T=dba_firstkey - string dba_firstkey ( resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_firstkey -- Fetch first key
Description
string dba_firstkey ( resource handle)
dba_firstkey() returns the first key of the database specified by handle 
and resets the internal key pointer. This permits a linear search through 
the whole database. 
Handle is a database handle returned by dba_open(). 
dba_firstkey() returns the key or FALSE depending on whether it succeeds 
or fails, respectively. 
See also: dba_firstkey(), dba_key_split() and example 2 in the DBA 
examples   dba_fetchUpdba_handlers
#

#T=string dba_firstkey ( resource handle)
dba_firstkey ( ^!resource handle);
#

#T=dba_handlers - array dba_handlers ( void )
(PHP 4 >= 4.3.0)
dba_handlers -- List handlers available
Description
array dba_handlers ( void )
dba_handlers() returns an array with all handlers supported by this 
extension. 
When the internal cdb library is used you will see 'cdb' and 'cdb_make'.   dba_firstkeyUpdba_insert
#

#T=array dba_handlers ( void )
dba_handlers ( ^!void );
#

#T=dba_insert - bool dba_insert ( string key, string value, resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_insert -- Insert entry
Description
bool dba_insert ( string key, string value, resource handle)
dba_insert() inserts the entry described with key and value into the 
database specified by handle. It fails, if an entry with the same key 
already exists. 
key is the key of the entry to be inserted. 
value is the value to be inserted. 
handle is a database handle returned by dba_open(). 
dba_insert() returns TRUE or FALSE, depending on whether it succeeds of 
fails, respectively. 
See also: dba_exists() dba_delete() dba_fetch() dba_replace()   dba_handlersUpdba_key_split
dba_key_split
(no version information, might be only in CVS)
dba_key_split -- Splits a key in string representation into array 
representation
Description
mixed dba_key_split ( mixed key)
dba_key_split() returns an array of the form 
array(0=>group,1=>value_name). This function will return FALSE if key is 
NULL or FALSE. 
key is the key in string representation. 
See also dba_firstkey(), dba_nextkey() and dba_fetch().   dba_insertUpdba_list
#

#T=bool dba_insert ( string key, string value, resource handle)
dba_insert ( ^!string key, string value, resource handle);
#

#T=dba_list - array dba_list ( void )
(PHP 4 >= 4.3.0)
dba_list -- List all open database files
Description
array dba_list ( void )
dba_list() returns an associative array with all open database files. This 
array is in the form: resourceid=>filename.   dba_key_splitUpdba_nextkey
#

#T=array dba_list ( void )
dba_list ( ^!void );
#

#T=dba_nextkey - string dba_nextkey ( resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_nextkey -- Fetch next key
Description
string dba_nextkey ( resource handle)
dba_nextkey() returns the next key of the database specified by handle and 
advances the internal key pointer. 
handle is a database handle returned by dba_open(). 
dba_nextkey() returns the key or FALSE depending on whether it succeeds or 
fails, respectively. 
See also: dba_firstkey(), dba_key_split() and example 2 in the DBA 
examples   dba_listUpdba_open
#

#T=string dba_nextkey ( resource handle)
dba_nextkey ( ^!resource handle);
#

#T=dba_open - resource dba_open ( string path, string mode, string handler [, ...])
(PHP 3>= 3.0.8, PHP 4 )
dba_open -- Open database
Description
resource dba_open ( string path, string mode, string handler [, ...])
dba_open() establishes a database instance for path with mode using 
handler. 
path is commonly a regular path in your filesystem. 
mode is "r" for read access, "w" for read/write access to an already 
existing database, "c" for read/write access and database creation if it 
doesn't currently exist, and "n" for create, truncate and read/write 
access. Additional you can set the database lock method with the next 
char. Use "l" to lock the database with an .lck file or "d" to lock the 
databasefile itself. It is important that all of your applications do this 
consistently. If you want to test the access and do not want to wait for 
the lock you can add "t" as third character. When you are absolutely sure 
that you do not require database locking you can do so by using "-" 
instead of "l" or "d". When none of "d", "l" or "-" is used dba will lock 
on the database file as it would with "d". 
handler is the name of the handler which shall be used for accessing path. 
It is passed all optional parameters given to dba_open() and can act on 
behalf of them. 
dba_open() returns a positive handle or FALSE, in the case the database 
was opened successfull or fails, respectively. 
Note: There can only be one writer for one database file. When you use 
dba on a webserver and more than one request requires write operations 
they can only be done one after another. Also read during write is not 
allowed. The dba extension uses locks to prevent this. See the following 
table: 
Table 1. DBA locking
already openmode = "rl"mode = "rlt"mode = "wl"mode = "wlt"mode = 
"rd"mode = "rdt"mode = "wd"mode = "wdt"
not openokokokokokokokok
mode = "rl"okokwaitfalseillegalillegalillegalillegal
mode = "wl"waitfalsewaitfalseillegalillegalillegalillegal
mode = "rd"illegalillegalillegalillegalokokwaitfalse
mode = "wd"illegalillegalillegalillegalwaitfalsewaitfalse

ok: the second call will be successfull.
wait: the second call waits until dba_close() is called for the 
first.
false: the second call returns false.
illegal: you must not mix "l" and "d" modifiers for mode 
parameter.

Note: Since PHP 4.3.0 it is possible to open database files over network 
connection. However in cases a socket connection will be used (as with 
http or ftp) the connection will be locked instead of the resource 
itself. This is important to know since in such cases locking is simply 
ignored on the resource and other solutions have to be found. 
Note: Locking and the mode modifiers "l", "d", "-" and "t" were added in 
PHP 4.3.0. In PHP versions before PHP 4.3.0 you must use semaphores to 
guard against simultaneous database access for any database handler with 
the exception of GDBM. See System V semaphore support. 
Note: Up to PHP 4.3.5 open mode 'c' is broken for several internal 
handlers and truncates the database instead of appending data to an 
existant database. Also dbm and ndbm fail on mode 'c' in typical 
configurations (this cannot be fixed). 
See also: dba_popen() dba_close()   dba_nextkeyUpdba_optimize
#

#T=resource dba_open ( string path, string mode, string handler [, ...])
dba_open ( ^!string path, string mode, string handler [, ...]);
#

#T=dba_optimize - bool dba_optimize ( resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_optimize -- Optimize database
Description
bool dba_optimize ( resource handle)
dba_optimize() optimizes the underlying database specified by handle. 
handle is a database handle returned by dba_open(). 
dba_optimize() returns TRUE or FALSE, if the optimization succeeds or 
fails, respectively. 
See also: dba_sync()   dba_openUpdba_popen
#

#T=bool dba_optimize ( resource handle)
dba_optimize ( ^!resource handle);
#

#T=dba_popen - resource dba_popen ( string path, string mode, string handler [, ...])
(PHP 3>= 3.0.8, PHP 4 )
dba_popen -- Open database persistently
Description
resource dba_popen ( string path, string mode, string handler [, ...])
dba_popen() establishes a persistent database instance for path with mode 
using handler. 
path is commonly a regular path in your filesystem. 
mode is "r" for read access, "w" for read/write access to an already 
existing database, "c" for read/write access and database creation if it 
doesn't currently exist, and "n" for create, truncate and read/write 
access. 
handler is the name of the handler which shall be used for accessing path. 
It is passed all optional parameters given to dba_popen() and can act on 
behalf of them. 
dba_popen() returns a positive handle or FALSE, in the case the open is 
successful or fails, respectively. 
See also: dba_open() dba_close()   dba_optimizeUpdba_replace
#

#T=resource dba_popen ( string path, string mode, string handler [, ...])
dba_popen ( ^!string path, string mode, string handler [, ...]);
#

#T=dba_replace - bool dba_replace ( string key, string value, resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_replace -- Replace or insert entry
Description
bool dba_replace ( string key, string value, resource handle)
dba_replace() replaces or inserts the entry described with key and value 
into the database specified by handle. 
key is the key of the entry to be inserted. 
value is the value to be inserted. 
handle is a database handle returned by dba_open(). 
dba_replace() returns TRUE or FALSE, depending on whether it succeeds of 
fails, respectively. 
See also: dba_exists(), dba_delete(), dba_fetch(), and dba_insert().   dba_popenUpdba_sync
#

#T=bool dba_replace ( string key, string value, resource handle)
dba_replace ( ^!string key, string value, resource handle);
#

#T=dba_sync - bool dba_sync ( resource handle)
(PHP 3>= 3.0.8, PHP 4 )
dba_sync -- Synchronize database
Description
bool dba_sync ( resource handle)
dba_sync() synchronizes the database specified by handle. This will 
probably trigger a physical write to disk, if supported. 
handle is a database handle returned by dba_open(). 
dba_sync() returns TRUE or FALSE, if the synchronization succeeds or 
fails, respectively. 
See also: dba_optimize()   dba_replaceUpDate and Time functions
#

#T=bool dba_sync ( resource handle)
dba_sync ( ^!resource handle);
#

#T=dbase_add_record - bool dbase_add_record ( int dbase_identifier, array record)
(PHP 3, PHP 4 )
dbase_add_record -- Add a record to a dBase database
Description
bool dbase_add_record ( int dbase_identifier, array record)
Adds the data in the record to the database. If the number of items in the 
supplied record isn't equal to the number of fields in the database, the 
operation will fail and FALSE will be returned.   dBase functionsUpdbase_close
#

#T=bool dbase_add_record ( int dbase_identifier, array record)
dbase_add_record ( ^!int dbase_identifier, array record);
#

#T=dbase_close - bool dbase_close ( int dbase_identifier)
(PHP 3, PHP 4 )
dbase_close -- Close a dBase database
Description
bool dbase_close ( int dbase_identifier)
Closes the database associated with dbase_identifier.   dbase_add_recordUpdbase_create
#

#T=bool dbase_close ( int dbase_identifier)
dbase_close ( ^!int dbase_identifier);
#

#T=dbase_create - int dbase_create ( string filename, array fields)
(PHP 3, PHP 4 )
dbase_create -- Creates a dBase database
Description
int dbase_create ( string filename, array fields)
dbase_create() creates a dBase database in the file filename, with the 
fields fields. 
The fields parameter is an array of arrays, each array describing the 
format of one field in the database. Each field consists of a name, a 
character indicating the field type, a length, and a precision. 
The types of fields available are: 
L
Boolean. These do not have a length or precision. 
M
Memo. (Note that these aren't supported by PHP.) These do not have a 
length or precision. 
D
Date (stored as YYYYMMDD). These do not have a length or precision. 
N
Number. These have both a length and a precision (the number of digits 
after the decimal point). 
C
String. 
If the database is successfully created, a dbase_identifier is returned, 
otherwise FALSE is returned. Example 1. Creating a dBase database 
file
  <?php

  // "database" name
  $dbname = "/tmp/test.dbf";

  // database "definition"
  $def =
      array(
	  array("date",     "D"),
	  array("name",     "C",  50),
	  array("age",      "N",   3, 0),
	  array("email",    "C", 128),
	  array("ismember", "L")
      );

  // creation
  if (!dbase_create($dbname, $def))
      echo "<strong>Error!</strong>";

  ?> 

  dbase_closeUpdbase_delete_record
#

#T=int dbase_create ( string filename, array fields)
dbase_create ( ^!string filename, array fields);
#

#T=dbase_delete_record - bool dbase_delete_record ( int dbase_identifier, int record)
(PHP 3, PHP 4 )
dbase_delete_record -- Deletes a record from a dBase database
Description
bool dbase_delete_record ( int dbase_identifier, int record)
Marks record to be deleted from the database. To actually remove the 
record from the database, you must also call dbase_pack().   dbase_createUpdbase_get_header_info
dbase_get_header_info
(no version information, might be only in CVS)
dbase_get_header_info -- Get the header info of a dBase database
Description
array dbase_get_header_info ( int dbase_identifier)
Returns information on the column structure of the database referenced by 
dbase_identifier. For each column in the database, there is an entry in a 
numerically-indexed array. The array index starts at 0. Each array element 
contains an associative array of column information. If the database 
header information cannot be read, FALSE is returned. 
The array elements are: 
name
The name of the column 
type
The human-readable name for the dbase type of the column (i.e. date, 
boolean, etc) 
length
The number of bytes this column can hold 
precision
The number of digits of decimal precision for the column 
format
A suggested printf() format specifier for the column 
offset
The byte offset of the column from the start of the row 
Example 1. Showing header information for a dBase database file
  <?php
  // Path to dbase file
  $db_path = "/tmp/test.dbf";

  // Open dbase file
  $dbh = dbase_open($db_path)
      or die("Error! Could not open dbase database file 
  '$db_path'.");

  // Get column information
  $column_info = dbase_get_header_info($dbh);

  // Display information
  print_r($column_info);
  ?> 

  dbase_delete_recordUpdbase_get_record_with_names
#

#T=bool dbase_delete_record ( int dbase_identifier, int record)
dbase_delete_record ( ^!int dbase_identifier, int record);
#

#T=dbase_get_record_with_names - array dbase_get_record_with_names ( int dbase_identifier, int record)
(PHP 3>= 3.0.4, PHP 4 )
dbase_get_record_with_names --  Gets a record from a dBase database as an 
associative array 
Description
array dbase_get_record_with_names ( int dbase_identifier, int record)
Returns the data from record in an associative array. The array also 
includes an associative member named 'deleted' which is set to 1 if the 
record has been marked for deletion (see dbase_delete_record()). 
Each field is converted to the appropriate PHP type, except: 
Dates are left as strings 
Integers that would have caused an overflow (> 32 bits) are returned as 
strings   dbase_get_header_infoUpdbase_get_record
#

#T=array dbase_get_record_with_names ( int dbase_identifier, int record)
dbase_get_record_with_names ( ^!int dbase_identifier, int record);
#

#T=dbase_get_record - array dbase_get_record ( int dbase_identifier, int record)
(PHP 3, PHP 4 )
dbase_get_record -- Gets a record from a dBase database
Description
array dbase_get_record ( int dbase_identifier, int record)
Returns the data from record in an array. The array is indexed starting at 
0, and includes an associative member named 'deleted' which is set to 1 if 
the record has been marked for deletion (see dbase_delete_record(). 
Each field is converted to the appropriate PHP type, except: 
Dates are left as strings 
Integers that would have caused an overflow (> 32 bits) are returned as 
strings   dbase_get_record_with_namesUpdbase_numfields
#

#T=array dbase_get_record ( int dbase_identifier, int record)
dbase_get_record ( ^!int dbase_identifier, int record);
#

#T=dbase_numfields - int dbase_numfields ( int dbase_identifier)
(PHP 3, PHP 4 )
dbase_numfields --  Find out how many fields are in a dBase database 
Description
int dbase_numfields ( int dbase_identifier)
Returns the number of fields (columns) in the specified database. Field 
numbers are between 0 and dbase_numfields($db)-1, while record numbers are 
between 1 and dbase_numrecords($db). Example 1. Using 
dbase_numfields()
  <?php

  $rec = dbase_get_record($db, $recno);
  $nf  = dbase_numfields($db);
  for ($i=0; $i < $nf; $i++) {
      echo $rec[$i]."<br />\n";
  }

  ?> 

  dbase_get_recordUpdbase_numrecords
#

#T=int dbase_numfields ( int dbase_identifier)
dbase_numfields ( ^!int dbase_identifier);
#

#T=dbase_numrecords - int dbase_numrecords ( int dbase_identifier)
(PHP 3, PHP 4 )
dbase_numrecords --  Find out how many records are in a dBase database 
Description
int dbase_numrecords ( int dbase_identifier)
Returns the number of records (rows) in the specified database. Record 
numbers are between 1 and dbase_numrecords($db), while field numbers are 
between 0 and dbase_numfields($db)-1.   dbase_numfieldsUpdbase_open
#

#T=int dbase_numrecords ( int dbase_identifier)
dbase_numrecords ( ^!int dbase_identifier);
#

#T=dbase_open - int dbase_open ( string filename, int flags)
(PHP 3, PHP 4 )
dbase_open -- Opens a dBase database
Description
int dbase_open ( string filename, int flags)
Returns a dbase_identifier for the opened database, or FALSE if the 
database couldn't be opened. 
Parameter flags correspond to those for the open() system call (Typically 
0 means read-only, 1 means write-only, and 2 means read and write). 
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.  dbase_numrecordsUpdbase_pack
#

#T=int dbase_open ( string filename, int flags)
dbase_open ( ^!string filename, int flags);
#

#T=dbase_pack - bool dbase_pack ( int dbase_identifier)
(PHP 3, PHP 4 )
dbase_pack -- Packs a dBase database
Description
bool dbase_pack ( int dbase_identifier)
Packs the specified database (permanently deleting all records marked for 
deletion using dbase_delete_record()).   dbase_openUpdbase_replace_record
#

#T=bool dbase_pack ( int dbase_identifier)
dbase_pack ( ^!int dbase_identifier);
#

#T=dbase_replace_record - bool dbase_replace_record ( int dbase_identifier, array record, int 
(PHP 3>= 3.0.11, PHP 4 )
dbase_replace_record -- Replace a record in a dBase database
Description
bool dbase_replace_record ( int dbase_identifier, array record, int 
dbase_record_number)
Replaces the data associated with the record record_number with the data 
in the record in the database. If the number of items in the supplied 
record is not equal to the number of fields in the database, the operation 
will fail and FALSE will be returned. 
dbase_record_number is an integer which spans from 1 to the number of 
records in the database (as returned by dbase_numrecords()).   dbase_packUpDBM Functions [deprecated]
#

#T=bool dbase_replace_record ( int dbase_identifier, array record, int 
dbase_replace_record ( ^!int dbase_identifier, array record, int ;
#

#T=dblist - string dblist ( void )
(PHP 3, PHP 4 )
dblist --  Describes the DBM-compatible library being used 
Description
string dblist ( void )
Example 1. Getting the information on the command line
[marcus@zaphod marcus]$ php -r 'echo dblist();'
This is GDBM version 1.8.0, as of May 19, 1999.

  DBM Functions [deprecated]Updbmclose
#

#T=string dblist ( void )
dblist ( ^!void );
#

#T=dbmclose - bool dbmclose ( resource dbm_identifier)
(PHP 3, PHP 4 )
dbmclose -- Closes a dbm database
Description
bool dbmclose ( resource dbm_identifier)
Unlocks and closes the specified database.   dblistUpdbmdelete
#

#T=bool dbmclose ( resource dbm_identifier)
dbmclose ( ^!resource dbm_identifier);
#

#T=dbmdelete - bool dbmdelete ( resource dbm_identifier, string key)
(PHP 3, PHP 4 )
dbmdelete --  Deletes the value for a key from a DBM database 
Description
bool dbmdelete ( resource dbm_identifier, string key)
Deletes the value for key in the database. 
Returns FALSE if the key didn't exist in the database.   dbmcloseUpdbmexists
#

#T=bool dbmdelete ( resource dbm_identifier, string key)
dbmdelete ( ^!resource dbm_identifier, string key);
#

#T=dbmexists - bool dbmexists ( resource dbm_identifier, string key)
(PHP 3, PHP 4 )
dbmexists --  Tells if a value exists for a key in a DBM database 
Description
bool dbmexists ( resource dbm_identifier, string key)
Returns TRUE if there is a value associated with the key.   dbmdeleteUpdbmfetch
#

#T=bool dbmexists ( resource dbm_identifier, string key)
dbmexists ( ^!resource dbm_identifier, string key);
#

#T=dbmfetch - string dbmfetch ( resource dbm_identifier, string key)
(PHP 3, PHP 4 )
dbmfetch --  Fetches a value for a key from a DBM database 
Description
string dbmfetch ( resource dbm_identifier, string key)
Returns the value associated with key.   dbmexistsUpdbmfirstkey
#

#T=string dbmfetch ( resource dbm_identifier, string key)
dbmfetch ( ^!resource dbm_identifier, string key);
#

#T=dbmfirstkey - string dbmfirstkey ( resource dbm_identifier)
(PHP 3, PHP 4 )
dbmfirstkey --  Retrieves the first key from a DBM database 
Description
string dbmfirstkey ( resource dbm_identifier)
Returns the first key in the database. Note that no particular order is 
guaranteed since the database may be built using a hash-table, which 
doesn't guarantee any ordering.   dbmfetchUpdbminsert
#

#T=string dbmfirstkey ( resource dbm_identifier)
dbmfirstkey ( ^!resource dbm_identifier);
#

#T=dbminsert - int dbminsert ( resource dbm_identifier, string key, string value)
(PHP 3, PHP 4 )
dbminsert --  Inserts a value for a key in a DBM database 
Description
int dbminsert ( resource dbm_identifier, string key, string value)
Adds the value to the database with the specified key. 
Returns -1 if the database was opened read-only, 0 if the insert was 
successful, and 1 if the specified key already exists. (To replace the 
value, use dbmreplace().)   dbmfirstkeyUpdbmnextkey
#

#T=int dbminsert ( resource dbm_identifier, string key, string value)
dbminsert ( ^!resource dbm_identifier, string key, string value);
#

#T=dbmnextkey - string dbmnextkey ( resource dbm_identifier, string key)
(PHP 3, PHP 4 )
dbmnextkey --  Retrieves the next key from a DBM database
Description
string dbmnextkey ( resource dbm_identifier, string key)
Returns the next key after key. By calling dbmfirstkey() followed by 
successive calls to dbmnextkey() it is possible to visit every key/value 
pair in the dbm database. For example: Example 1. Visiting every 
key/value pair in a DBM database
  <?php

  $key = dbmfirstkey($dbm_id);
  while ($key) {
      echo "$key = " . dbmfetch($dbm_id, $key) . "\n";
      $key = dbmnextkey($dbm_id, $key);
  }

  ?> 

  dbminsertUpdbmopen
#

#T=string dbmnextkey ( resource dbm_identifier, string key)
dbmnextkey ( ^!resource dbm_identifier, string key);
#

#T=dbmopen - resource dbmopen ( string filename, string flags)
(PHP 3, PHP 4 )
dbmopen -- Opens a DBM database
Description
resource dbmopen ( string filename, string flags)
The first argument is the full-path filename of the DBM file to be opened 
and the second is the file open mode which is one of "r", "n", "c" or "w" 
for read-only, new (implies read-write, and most likely will truncate an 
already-existing database of the same name), create (implies read-write, 
and will not truncate an already-existing database of the same name) and 
read-write respectively. 
Returns an identifier to be passed to the other DBM functions on success, 
or FALSE on failure. 
If NDBM support is used, NDBM will actually create filename.dir and 
filename.pag files. GDBM only uses one file, as does the internal 
flat-file support, and Berkeley DB creates a filename.db file. Note that 
PHP does its own file locking in addition to any file locking that may be 
done by the DBM library itself. PHP does not delete the .lck files it 
creates. It uses these files simply as fixed inodes on which to do the 
file locking. For more information on DBM files, see your Unix man pages, 
or obtain GNU's GDBM. 
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.  dbmnextkeyUpdbmreplace
#

#T=resource dbmopen ( string filename, string flags)
dbmopen ( ^!string filename, string flags);
#

#T=dbmreplace - int dbmreplace ( resource dbm_identifier, string key, string value)
(PHP 3, PHP 4 )
dbmreplace --  Replaces the value for a key in a DBM database 
Description
int dbmreplace ( resource dbm_identifier, string key, string value)
Replaces the value for the specified key in the database. 
This will also add the key to the database if it didn't already exist.   dbmopenUpdbx functions
dbplus_add
(4.1.0 - 4.2.3 only)
dbplus_add -- Add a tuple to a relation
Description
int dbplus_add ( resource relation, array tuple)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function will add a tuple to a relation. The tuple data is an array 
of attribute/value pairs to be inserted into the given relation. After 
successful execution the tuple array will contain the complete data of the 
newly created tuple, including all implicitly set domain fields like 
sequences. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes.   DB++ FunctionsUpdbplus_aql
dbplus_aql
(4.1.0 - 4.2.3 only)
dbplus_aql -- Perform AQL query
Description
resource dbplus_aql ( string query [, string server [, string dbpath]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_aql() will execute an AQL query on the given server and dbpath. 
On success it will return a relation handle. The result data may be 
fetched from this relation by calling dbplus_next() and dbplus_current(). 
Other relation access functions will not work on a result relation. 
Further information on the AQL A... Query Language is provided in the 
original db++ manual.   dbplus_addUpdbplus_chdir
dbplus_chdir
(4.1.0 - 4.2.3 only)
dbplus_chdir -- Get/Set database virtual current directory
Description
string dbplus_chdir ( [string newdir])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_chdir() will change the virtual current directory where relation 
files will be looked for by dbplus_open(). dbplus_chdir() will return the 
absolute path of the current directory. Calling dbplus_chdir() without 
giving any newdir may be used to query the current working directory.   dbplus_aqlUpdbplus_close
dbplus_close
(4.1.0 - 4.2.3 only)
dbplus_close -- Close a relation
Description
int dbplus_close ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Calling dbplus_close() will close a relation previously opened by 
dbplus_open().   dbplus_chdirUpdbplus_curr
dbplus_curr
(4.1.0 - 4.2.3 only)
dbplus_curr -- Get current tuple from relation
Description
int dbplus_curr ( resource relation, array tuple)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_curr() will read the data for the current tuple for the given 
relation and will pass it back as an associative array in tuple. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes. 
See also dbplus_first(), dbplus_prev(), dbplus_next(), and dbplus_last().   dbplus_closeUpdbplus_errcode
dbplus_errcode
(4.1.0 - 4.2.3 only)
dbplus_errcode --  Get error string for given errorcode or last error 
Description
string dbplus_errcode ( int errno)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_errcode() returns a cleartext error string for the error code 
passed as errno of for the result code of the last db++ operation if no 
parameter is given.   dbplus_currUpdbplus_errno
dbplus_errno
(4.1.0 - 4.2.3 only)
dbplus_errno -- Get error code for last operation
Description
int dbplus_errno ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_errno() will return the error code returned by the last db++ 
operation. 
See also dbplus_errcode().   dbplus_errcodeUpdbplus_find
dbplus_find
(4.1.0 - 4.2.3 only)
dbplus_find -- Set a constraint on a relation
Description
int dbplus_find ( resource relation, array constraints, mixed tuple)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_find() will place a constraint on the given relation. Further calls 
to functions like dbplus_curr() or dbplus_next() will only return tuples 
matching the given constraints. 
Constraints are triplets of strings containing of a domain name, a 
comparison operator and a comparison value. The constraints parameter 
array may consist of a collection of string arrays, each of which contains 
a domain, an operator and a value, or of a single string array containing 
a multiple of three elements. 
The comparison operator may be one of the following strings: '==', '>', 
'>=', '<', '<=', '!=', '~' for a regular expression match and 'BAND' or 
'BOR' for bitwise operations. 
See also dbplus_unselect().   dbplus_errnoUpdbplus_first
dbplus_first
(4.1.0 - 4.2.3 only)
dbplus_first -- Get first tuple from relation
Description
int dbplus_first ( resource relation, array tuple)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_curr() will read the data for the first tuple for the given 
relation, make it the current tuple and pass it back as an associative 
array in tuple. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes. 
See also dbplus_curr(), dbplus_prev(), dbplus_next(), and dbplus_last().   dbplus_findUpdbplus_flush
dbplus_flush
(4.1.0 - 4.2.3 only)
dbplus_flush -- Flush all changes made on a relation
Description
int dbplus_flush ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_flush() will write all changes applied to relation since the last 
flush to disk. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes.   dbplus_firstUpdbplus_freealllocks
dbplus_freealllocks
(4.1.0 - 4.2.3 only)
dbplus_freealllocks -- Free all locks held by this client
Description
int dbplus_freealllocks ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_freealllocks() will free all tuple locks held by this client. 
See also dbplus_getlock(), dbplus_freelock(), and dbplus_freerlocks().   dbplus_flushUpdbplus_freelock
dbplus_freelock
(4.1.0 - 4.2.3 only)
dbplus_freelock -- Release write lock on tuple
Description
int dbplus_freelock ( resource relation, string tname)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_freelock() will release a write lock on the given tuple previously 
obtained by dbplus_getlock(). 
See also dbplus_getlock(), dbplus_freerlocks(), and dbplus_freealllocks(). 
  dbplus_freealllocksUpdbplus_freerlocks
dbplus_freerlocks
(4.1.0 - 4.2.3 only)
dbplus_freerlocks -- Free all tuple locks on given relation
Description
int dbplus_freerlocks ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_freerlocks() will free all tuple locks held on the given relation. 
See also dbplus_getlock(), dbplus_freelock(), and dbplus_freealllocks().   dbplus_freelockUpdbplus_getlock
dbplus_getlock
(4.1.0 - 4.2.3 only)
dbplus_getlock -- Get a write lock on a tuple
Description
int dbplus_getlock ( resource relation, string tname)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_getlock() will request a write lock on the specified tuple. It will 
return zero on success or a non-zero error code, especially 
DBPLUS_ERR_WLOCKED, on failure. 
See also dbplus_freelock(), dbplus_freerlocks(), and 
dbplus_freealllocks().   dbplus_freerlocksUpdbplus_getunique
dbplus_getunique
(4.1.0 - 4.2.3 only)
dbplus_getunique -- Get an id number unique to a relation
Description
int dbplus_getunique ( resource relation, int uniqueid)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_getunique() will obtain a number guaranteed to be unique for the 
given relation and will pass it back in the variable given as uniqueid. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes.   dbplus_getlockUpdbplus_info
dbplus_info
(4.1.0 - 4.2.3 only)
dbplus_info -- ???
Description
int dbplus_info ( resource relation, string key, array )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_getuniqueUpdbplus_last
dbplus_last
(4.1.0 - 4.2.3 only)
dbplus_last -- Get last tuple from relation
Description
int dbplus_last ( resource relation, array tuple)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_curr() will read the data for the last tuple for the given 
relation, make it the current tuple and pass it back as an associative 
array in tuple. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes. 
See also dbplus_first(), dbplus_curr(), dbplus_prev(), and dbplus_next().   dbplus_infoUpdbplus_lockrel
dbplus_lockrel
(no version information, might be only in CVS)
dbplus_lockrel -- Request write lock on relation
Description
int dbplus_lockrel ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_lockrel() will request a write lock on the given relation. Other 
clients may still query the relation, but can't alter it while it is 
locked.   dbplus_lastUpdbplus_next
dbplus_next
(4.1.0 - 4.2.3 only)
dbplus_next -- Get next tuple from relation
Description
int dbplus_next ( resource relation, array )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_curr() will read the data for the next tuple for the given 
relation, will make it the current tuple and will pass it back as an 
associative array in tuple. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes. 
See also dbplus_first(), dbplus_curr(), dbplus_prev(), and dbplus_last().   dbplus_lockrelUpdbplus_open
dbplus_open
(4.1.0 - 4.2.3 only)
dbplus_open -- Open relation file
Description
resource dbplus_open ( string name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The relation file name will be opened. name can be either a file name or a 
relative or absolute path name. This will be mapped in any case to an 
absolute relation file path on a specific host machine and server. 
On success a relation file resource (cursor) is returned which must be 
used in any subsequent commands referencing the relation. Failure leads to 
a zero return value, the actual error code may be asked for by calling 
dbplus_errno().   dbplus_nextUpdbplus_prev
dbplus_prev
(4.1.0 - 4.2.3 only)
dbplus_prev -- Get previous tuple from relation
Description
int dbplus_prev ( resource relation, array tuple)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_curr() will read the data for the next tuple for the given 
relation, will make it the current tuple and will pass it back as an 
associative array in tuple. 
The function will return zero (aka. DBPLUS_ERR_NOERR) on success or a db++ 
error code on failure. See dbplus_errcode() or the introduction to this 
chapter for more information on db++ error codes. 
See also dbplus_first(), dbplus_curr(), dbplus_next(), and dbplus_last().   dbplus_openUpdbplus_rchperm
dbplus_rchperm
(4.1.0 - 4.2.3 only)
dbplus_rchperm -- Change relation permissions
Description
int dbplus_rchperm ( resource relation, int mask, string user, string 
group)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rchperm() will change access permissions as specified by mask, user 
and group. The values for these are operating system specific.   dbplus_prevUpdbplus_rcreate
dbplus_rcreate
(4.1.0 - 4.2.3 only)
dbplus_rcreate -- Creates a new DB++ relation
Description
resource dbplus_rcreate ( string name, mixed domlist [, bool overwrite])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rcreate() will create a new relation named name. An existing 
relation by the same name will only be overwritten if the relation is 
currently not in use and overwrite is set to TRUE. 
domlist should contain the domain specification for the new relation 
within an array of domain description strings. ( dbplus_rcreate() will 
also accept a string with space delimited domain description strings, but 
it is recommended to use an array). A domain description string consists 
of a domain name unique to this relation, a slash and a type specification 
character. See the db++ documentation, especially the dbcreate(1) manpage, 
for a description of available type specifiers and their meanings.   dbplus_rchpermUpdbplus_rcrtexact
dbplus_rcrtexact
(4.1.0 - 4.2.3 only)
dbplus_rcrtexact -- Creates an exact but empty copy of a relation 
including indices
Description
resource dbplus_rcrtexact ( string name, resource relation, bool 
overwrite)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rcrtexact() will create an exact but empty copy of the given 
relation under a new name. An existing relation by the same name will only 
be overwritten if overwrite is TRUE and no other process is currently 
using the relation.   dbplus_rcreateUpdbplus_rcrtlike
dbplus_rcrtlike
(4.1.0 - 4.2.3 only)
dbplus_rcrtlike -- Creates an empty copy of a relation with default 
indices
Description
resource dbplus_rcrtlike ( string name, resource relation, int flag)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rcrtexact() will create an empty copy of the given relation under a 
new name, but with default indices. An existing relation by the same name 
will only be overwritten if overwrite is TRUE and no other process is 
currently using the relation.   dbplus_rcrtexactUpdbplus_resolve
dbplus_resolve
(4.1.0 - 4.2.3 only)
dbplus_resolve -- Resolve host information for relation
Description
int dbplus_resolve ( string relation_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_resolve() will try to resolve the given relation_name and find out 
internal server id, real hostname and the database path on this host. The 
function will return an array containing these values under the keys 
'sid', 'host' and 'host_path' or FALSE on error. 
See also dbplus_tcl().   dbplus_rcrtlikeUpdbplus_restorepos
dbplus_restorepos
(4.1.0 - 4.2.3 only)
dbplus_restorepos -- ???
Description
int dbplus_restorepos ( resource relation, array tuple)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_resolveUpdbplus_rkeys
dbplus_rkeys
(4.1.0 - 4.2.3 only)
dbplus_rkeys -- Specify new primary key for a relation
Description
resource dbplus_rkeys ( resource relation, mixed domlist)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rkeys() will replace the current primary key for relation with the 
combination of domains specified by domlist. 
domlist may be passed as a single domain name string or as an array of 
domain names.   dbplus_restoreposUpdbplus_ropen
dbplus_ropen
(4.1.0 - 4.2.3 only)
dbplus_ropen -- Open relation file local
Description
resource dbplus_ropen ( string name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_ropen() will open the relation file locally for quick access 
without any client/server overhead. Access is read only and only 
dbplus_current() and dbplus_next() may be applied to the returned 
relation.   dbplus_rkeysUpdbplus_rquery
dbplus_rquery
(4.1.0 - 4.2.3 only)
dbplus_rquery -- Perform local (raw) AQL query
Description
int dbplus_rquery ( string query, string dbpath)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rquery() performs a local (raw) AQL query using an AQL interpreter 
embedded into the db++ client library. dbplus_rquery() is faster than 
dbplus_aql() but will work on local data only.   dbplus_ropenUpdbplus_rrename
dbplus_rrename
(4.1.0 - 4.2.3 only)
dbplus_rrename -- Rename a relation
Description
int dbplus_rrename ( resource relation, string name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rrename() will change the name of relation to name.   dbplus_rqueryUpdbplus_rsecindex
dbplus_rsecindex
(4.1.0 - 4.2.3 only)
dbplus_rsecindex --  Create a new secondary index for a relation 
Description
resource dbplus_rsecindex ( resource relation, mixed domlist, int type)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rsecindex() will create a new secondary index for relation with 
consists of the domains specified by domlist and is of type type 
domlist may be passed as a single domain name string or as an array of 
domain names.   dbplus_rrenameUpdbplus_runlink
dbplus_runlink
(4.1.0 - 4.2.3 only)
dbplus_runlink -- Remove relation from filesystem
Description
int dbplus_runlink ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_unlink() will close and remove the relation.   dbplus_rsecindexUpdbplus_rzap
dbplus_rzap
(4.1.0 - 4.2.3 only)
dbplus_rzap -- Remove all tuples from relation
Description
int dbplus_rzap ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_rzap() will remove all tuples from relation.   dbplus_runlinkUpdbplus_savepos
dbplus_savepos
(4.1.0 - 4.2.3 only)
dbplus_savepos -- ???
Description
int dbplus_savepos ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_rzapUpdbplus_setindex
dbplus_setindex
(4.1.0 - 4.2.3 only)
dbplus_setindex -- ???
Description
int dbplus_setindex ( resource relation, string idx_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_saveposUpdbplus_setindexbynumber
dbplus_setindexbynumber
(4.1.0 - 4.2.3 only)
dbplus_setindexbynumber -- ???
Description
int dbplus_setindexbynumber ( resource relation, int idx_number)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_setindexUpdbplus_sql
dbplus_sql
(4.1.0 - 4.2.3 only)
dbplus_sql -- Perform SQL query
Description
resource dbplus_sql ( string query, string server, string dbpath)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_setindexbynumberUpdbplus_tcl
dbplus_tcl
(4.1.0 - 4.2.3 only)
dbplus_tcl -- Execute TCL code on server side
Description
int dbplus_tcl ( int sid, string script)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

A db++ server will prepare a TCL interpreter for each client connection. 
This interpreter will enable the server to execute TCL code provided by 
the client as a sort of stored procedures to improve the performance of 
database operations by avoiding client/server data transfers and context 
switches. 
dbplus_tcl() needs to pass the client connection id the TCL script code 
should be executed by. dbplus_resolve() will provide this connection id. 
The function will return whatever the TCL code returns or a TCL error 
message if the TCL code fails. 
See also dbplus_resolve().   dbplus_sqlUpdbplus_tremove
dbplus_tremove
(4.1.0 - 4.2.3 only)
dbplus_tremove -- Remove tuple and return new current tuple
Description
int dbplus_tremove ( resource relation, array tuple [, array current])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_tremove() removes tuple from relation if it perfectly matches a 
tuple within the relation. current, if given, will contain the data of the 
new current tuple after calling dbplus_tremove().   dbplus_tclUpdbplus_undo
dbplus_undo
(4.1.0 - 4.2.3 only)
dbplus_undo -- ???
Description
int dbplus_undo ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_tremoveUpdbplus_undoprepare
dbplus_undoprepare
(4.1.0 - 4.2.3 only)
dbplus_undoprepare -- ???
Description
int dbplus_undoprepare ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Not implemented yet.   dbplus_undoUpdbplus_unlockrel
dbplus_unlockrel
(4.1.0 - 4.2.3 only)
dbplus_unlockrel -- Give up write lock on relation
Description
int dbplus_unlockrel ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_unlockrel() will release a write lock previously obtained by 
dbplus_lockrel().   dbplus_undoprepareUpdbplus_unselect
dbplus_unselect
(4.1.0 - 4.2.3 only)
dbplus_unselect -- Remove a constraint from relation
Description
int dbplus_unselect ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Calling dbplus_unselect() will remove a constraint previously set by 
dbplus_find() on relation.   dbplus_unlockrelUpdbplus_update
dbplus_update
(4.1.0 - 4.2.3 only)
dbplus_update -- Update specified tuple in relation
Description
int dbplus_update ( resource relation, array old, array new)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_update() replaces the tuple given by old with the data from new if 
and only if old completely matches a tuple within relation.   dbplus_unselectUpdbplus_xlockrel
dbplus_xlockrel
(4.1.0 - 4.2.3 only)
dbplus_xlockrel -- Request exclusive lock on relation
Description
int dbplus_xlockrel ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_xlockrel() will request an exclusive lock on relation preventing 
even read access from other clients. 
See also dbplus_xunlockrel().   dbplus_updateUpdbplus_xunlockrel
dbplus_xunlockrel
(4.1.0 - 4.2.3 only)
dbplus_xunlockrel -- Free exclusive lock on relation
Description
int dbplus_xunlockrel ( resource relation)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

dbplus_xunlockrel() will release an exclusive lock on relation previously 
obtained by dbplus_xlockrel().   dbplus_xlockrelUpDirect IO functions
#

#T=int dbmreplace ( resource dbm_identifier, string key, string value)
dbmreplace ( ^!resource dbm_identifier, string key, string value);
#

#T=dbx_close - bool dbx_close ( object link_identifier)
(PHP 4 >= 4.0.6)
dbx_close -- Close an open connection/database
Description
bool dbx_close ( object link_identifier)
Returns TRUE on success or FALSE on failure. 
Example 1. dbx_close() example
  <?php
  $link = dbx_connect(DBX_MYSQL, "localhost", "db", "username", 
  "password")
      or die("Could not connect");

  echo "Connected successfully";
  dbx_close($link);
  ?> 
Note: Always refer to the module-specific documentation as well. 
See also dbx_connect().   dbx functionsUpdbx_compare
#

#T=bool dbx_close ( object link_identifier)
dbx_close ( ^!object link_identifier);
#

#T=dbx_compare - int dbx_compare ( array row_a, array row_b, string column_key [, int 
(PHP 4 >= 4.1.0)
dbx_compare -- Compare two rows for sorting purposes
Description
int dbx_compare ( array row_a, array row_b, string column_key [, int 
flags])
dbx_compare() returns 0 if the row_a[$column_key] is equal to 
row_b[$column_key], and 1 or -1 if the former is greater or is smaller 
than the latter one, respectively, or vice versa if the flag is set to 
DBX_CMP_DESC. dbx_compare() is a helper function for dbx_sort() to ease 
the make and use of the custom sorting function. 
The flags can be set to specify comparison direction: 
DBX_CMP_ASC - ascending order 
DBX_CMP_DESC - descending order 
and the preferred comparison type: 
DBX_CMP_NATIVE - no type conversion 
DBX_CMP_TEXT - compare items as strings 
DBX_CMP_NUMBER - compare items numerically 
One of the direction and one of the type constant can be combined with 
bitwise OR operator (|). The default value for the flags parameter is 
DBX_CMP_ASC | DBX_CMP_NATIVE. 
Example 1. dbx_compare() example
  <?php
  function user_re_order($a, $b) {
      $rv = dbx_compare($a, $b, "parentid", DBX_CMP_DESC);
      if (!$rv) {
	  $rv = dbx_compare($a, $b, "id", DBX_CMP_NUMBER);
      }
      return $rv;
  }

  $link   = dbx_connect(DBX_ODBC, "", "db", "username", 
  "password")
      or die("Could not connect");

  $result = dbx_query($link, "SELECT id, parentid, description 
  FROM table ORDER BY id");
      // data in $result is now ordered by id

  dbx_sort($result, "user_re_order");
      // date in $result is now ordered by parentid 
  (descending), then by id

  dbx_close($link);
  ?> 
See also dbx_sort().   dbx_closeUpdbx_connect
#

#T=int dbx_compare ( array row_a, array row_b, string column_key [, int 
dbx_compare ( ^!array row_a, array row_b, string column_key [, int ;
#

#T=dbx_connect - object dbx_connect ( mixed module, string host, string database, string 
(PHP 4 >= 4.0.6)
dbx_connect -- Open a connection/database
Description
object dbx_connect ( mixed module, string host, string database, string 
username, string password [, int persistent])
dbx_connect() returns an object on success, FALSE on error. If a 
connection has been made but the database could not be selected, the 
connection is closed and FALSE is returned. The persistent parameter can 
be set to DBX_PERSISTENT, if so, a persistent connection will be created. 
The module parameter can be either a string or a constant, though the 
latter form is preferred. The possible values are given below, but keep in 
mind that they only work if the module is actually loaded. 
DBX_MYSQL or "mysql" 
DBX_ODBC or "odbc" 
DBX_PGSQL or "pgsql" 
DBX_MSSQL or "mssql" 
DBX_FBSQL or "fbsql" (available from PHP 4.1.0) 
DBX_SYBASECT or "sybase_ct" (available from PHP 4.2.0) 
DBX_OCI8 or "oci8" (available from PHP 4.3.0) 
DBX_SQLITE or "sqlite" (CVS only) 
The host, database, username and password parameters are expected, but not 
always used depending on the connect functions for the abstracted module. 
The returned object has three properties: 
database
It is the name of the currently selected database. 
handle
It is a valid handle for the connected database, and as such it can be 
used in module-specific functions (if required). 
<?php
$link = dbx_connect(DBX_MYSQL, "localhost", "db", "username", 
"password");
mysql_close($link->handle); // dbx_close($link) would be better 
here
?> 

module
It is used internally by dbx only, and is actually the module number 
mentioned above. 
Example 1. dbx_connect() example
  <?php
  $link = dbx_connect(DBX_ODBC, "", "db", "username", 
  "password", DBX_PERSISTENT)
      or die("Could not connect");

  echo "Connected successfully";
  dbx_close($link);
  ?> 
Note: Always refer to the module-specific documentation as well. 
See also dbx_close().   dbx_compareUpdbx_error
#

#T=object dbx_connect ( mixed module, string host, string database, string 
dbx_connect ( ^!mixed module, string host, string database, string ;
#

#T=dbx_error - string dbx_error ( object link_identifier)
(PHP 4 >= 4.0.6)
dbx_error --  Report the error message of the latest function call in the 
module (not just in the connection) 
Description
string dbx_error ( object link_identifier)
dbx_error() returns a string containing the error message from the last 
function call of the abstracted module (e.g. mysql module). If there are 
multiple connections in the same module, just the last error is given. If 
there are connections on different modules, the latest error is returned 
for the module specified by the link_identifier parameter. 
Example 1. dbx_error() example
  <?php
  $link   = dbx_connect(DBX_MYSQL, "localhost", "db", 
  "username", "password")
      or die("Could not connect");

  $result = dbx_query($link, "select id from 
  non_existing_table");
  if ($result == 0) {
      echo dbx_error($link);
  }
  dbx_close($link);
  ?> 
Note: Always refer to the module-specific documentation as well. 
The error message for Microsoft SQL Server is actually the result of the 
mssql_get_last_message() function. 
The error message for Oracle (oci8) is not implemented (yet).   dbx_connectUpdbx_escape_string
#

#T=string dbx_error ( object link_identifier)
dbx_error ( ^!object link_identifier);
#

#T=dbx_escape_string - string dbx_escape_string ( object link_identifier, string text)
(PHP 4 >= 4.3.0)
dbx_escape_string --  Escape a string so it can safely be used in an 
sql-statement. 
Description
string dbx_escape_string ( object link_identifier, string text)
dbx_escape_string() returns the text, escaped where necessary (such as 
quotes, backslashes etc). It returns NULL on error. 
Example 1. dbx_escape_string() example
  <?php
  $link   = dbx_connect(DBX_MYSQL, "localhost", "db", 
  "username", "password")
      or die("Could not connect");

  $text = dbx_escape_string($link, "It\'s quoted and backslashed 
  (\\).");
  $result = dbx_query($link, "insert into tbl (txt) values ('" . 
  $text . "')");
  if ($result == 0) {
      echo dbx_error($link);
  }
  dbx_close($link);
  ?> 
See also dbx_query().   dbx_errorUpdbx_fetch_row
dbx_fetch_row
(no version information, might be only in CVS)
dbx_fetch_row -- Fetches rows from a query-result that had the 
DBX_RESULT_UNBUFFERED flag set
Description
object dbx_fetch_row ( object result_identifier)
dbx_fetch_row() returns a row on success, and 0 on failure (e.g. when no 
more rows are available). When the DBX_RESULT_UNBUFFERED is not set in the 
query, dbx_fetch_row() will fail as all rows have already been fetched 
into the results data property. 
As a side effect, the rows property of the query-result object is 
incremented for each successful call to dbx_fetch_row(). 
Example 1. How to handle the returned value
  <?php
  $result = dbx_query($link, 'SELECT id, parentid, description 
  FROM table', DBX_RESULT_UNBUFFERED);

  echo "<table>\n";
  while ($row = dbx_fetch_row($result)) {
      echo "<tr>\n";
      foreach ($row as $field) {
	  echo "<td>$field</td>";
      }
      echo "</tr>\n";
  }
  echo "</table>\n";
  ?> 
The result_identifier parameter is the result object returned by a call to 
dbx_query(). 
The returned array contains the same information as any row would have in 
the dbx_query result data property, including columns accessible by index 
or fieldname when the flags for dbx_guery were set that way. 
See also dbx_query().   dbx_escape_stringUpdbx_query
#

#T=string dbx_escape_string ( object link_identifier, string text)
dbx_escape_string ( ^!object link_identifier, string text);
#

#T=dbx_query - object dbx_query ( object link_identifier, string sql_statement [, int 
(PHP 4 >= 4.0.6)
dbx_query -- Send a query and fetch all results (if any)
Description
object dbx_query ( object link_identifier, string sql_statement [, int 
flags])
dbx_query() returns an object or 1 on success, and 0 on failure. The 
result object is returned only if the query given in sql_statement 
produces a result set (i.e. a SELECT query, even if the result set is 
empty). 
Example 1. How to handle the returned value
  <?php
  $link   = dbx_connect(DBX_ODBC, "", "db", "username", 
  "password")
      or die("Could not connect");

  $result = dbx_query($link, 'SELECT id, parentid, description 
  FROM table');

  if (is_object($result) ) {
      // ... do some stuff here, see detailed examples below ...
      // first, print out field names and types 
      // then, draw a table filled with the returned field 
values
  } else {
      exit("Query failed");
  }

  dbx_close($link);
  ?> 
The flags parameter is used to control the amount of information that is 
returned. It may be any combination of the following constants with the 
bitwise OR operator (|). The DBX_COLNAMES_* flags override the 
dbx.colnames_case setting from php.ini. 
DBX_RESULT_INDEX
It is always set, that is, the returned object has a data property which 
is a 2 dimensional array indexed numerically. For example, in the 
expression data[2][3] 2 stands for the row (or record) number and 3 
stands for the column (or field) number. The first row and column are 
indexed at 0. 
If DBX_RESULT_ASSOC is also specified, the returning object contains the 
information related to DBX_RESULT_INFO too, even if it was not 
specified. 
DBX_RESULT_INFO
It provides info about columns, such as field names and field types. 
DBX_RESULT_ASSOC
It effects that the field values can be accessed with the respective 
column names used as keys to the returned object's data property. 
Associated results are actually references to the numerically indexed 
data, so modifying data[0][0] causes that 
data[0]['field_name_for_first_column'] is modified as well. 
DBX_RESULT_UNBUFFERED (CVS only)
This flag will not create the data property, and the rows property will 
initially be 0. Use this flag for large datasets, and use 
dbx_fetch_row() to retrieve the results row by row. 
The dbx_fetch_row() function will return rows that are conformant to the 
flags set with this query. Incidentally, it will also update the rows 
each time it is called. 
DBX_COLNAMES_UNCHANGED (available from PHP 4.3.0)
The case of the returned column names will not be changed. 
DBX_COLNAMES_UPPERCASE (available from PHP 4.3.0)
The case of the returned column names will be changed to uppercase. 
DBX_COLNAMES_LOWERCASE (available from PHP 4.3.0)
The case of the returned column names will be changed to lowercase. 
Note that DBX_RESULT_INDEX is always used, regardless of the actual value 
of flags parameter. This means that only the following combinations are 
effective: 
DBX_RESULT_INDEX 
DBX_RESULT_INDEX | DBX_RESULT_INFO 
DBX_RESULT_INDEX | DBX_RESULT_INFO | DBX_RESULT_ASSOC - this is the 
default, if flags is not specified. 
The returned object has four or five properties depending on flags: 
handle
It is a valid handle for the connected database, and as such it can be 
used in module specific functions (if required). 
<?php
$result = dbx_query($link, "SELECT id FROM table");
mysql_field_len($result->handle, 0);
?> 

cols and rows
These contain the number of columns (or fields) and rows (or records) 
respectively. 
<?php
$result = dbx_query($link, 'SELECT id FROM table');
echo $result->rows; // number of records
echo $result->cols; // number of fields 
?> 

info (optional)
It is returned only if either DBX_RESULT_INFO or DBX_RESULT_ASSOC is 
specified in the flags parameter. It is a 2 dimensional array, that has 
two named rows (name and type) to retrieve column information. 
Example 2. lists each field's name and type
    <?php
    $result = dbx_query($link, 'SELECT id FROM table',
			 DBX_RESULT_INDEX | DBX_RESULT_INFO);

    for ($i = 0; $i < $result->cols; $i++ ) {
	echo $result->info['name'][$i] . "\n";
	echo $result->info['type'][$i] . "\n";  
    }
    ?> 
data
This property contains the actual resulting data, possibly associated 
with column names as well depending on flags. If DBX_RESULT_ASSOC is 
set, it is possible to use $result->data[2]["field_name"]. 
Example 3. outputs the content of data property into HTML table
    <?php
    $result = dbx_query($link, 'SELECT id, parentid, description 
    FROM table');

    echo "<table>\n";
    foreach ($result->data as $row) {
	echo "<tr>\n";
	foreach ($row as $field) {
	    echo "<td>$field</td>";
	}
	echo "</tr>\n";
    }
    echo "</table>\n";
    ?> 

Example 4. How to handle UNBUFFERED queries
    $result = dbx_query ($link, 'SELECT id, parentid, 
    description FROM table', DBX_RESULT_UNBUFFERED);

    echo "<table>\n";
    while ($row = dbx_fetch_row($result)) {
	echo "<tr>\n";
	foreach ($row as $field) {
	    echo "<td>$field</td>";
	}
	echo "</tr>\n";
    }
    echo "</table>\n"; 
Note: Always refer to the module-specific documentation as well. 
Column names for queries on an Oracle database are returned in 
lowercase. 
See also dbx_escape_string(), dbx_fetch_row() and dbx_connect().   dbx_fetch_rowUpdbx_sort
#

#T=object dbx_query ( object link_identifier, string sql_statement [, int 
dbx_query ( ^!object link_identifier, string sql_statement [, int ;
#

#T=dbx_sort - bool dbx_sort ( object result, string user_compare_function)
(PHP 4 >= 4.0.6)
dbx_sort --  Sort a result from a dbx_query by a custom sort function 
Description
bool dbx_sort ( object result, string user_compare_function)
Returns TRUE on success or FALSE on failure. 
Note: It is always better to use ORDER BY SQL clause instead of 
dbx_sort(), if possible. 
Example 1. dbx_sort() example
  <?php
  function user_re_order($a, $b) {
      $rv = dbx_compare($a, $b, "parentid", DBX_CMP_DESC);
      if (!$rv) {
	  $rv = dbx_compare($a, $b, "id", DBX_CMP_NUMBER);
      }
      return $rv;
  }

  $link   = dbx_connect(DBX_ODBC, "", "db", "username", 
  "password")
      or die("Could not connect");

  $result = dbx_query($link, "SELECT id, parentid, description 
  FROM tbl ORDER BY id");
      // data in $result is now ordered by id

  dbx_sort($result, "user_re_order");
      // data in $result is now ordered by parentid 
  (descending), then by id

  dbx_close($link);
  ?> 
See also dbx_compare().   dbx_queryUpDB++ Functions
#

#T=bool dbx_sort ( object result, string user_compare_function)
dbx_sort ( ^!object result, string user_compare_function);
#

#T=dcgettext - string dcgettext ( string domain, string message, int category)
(PHP 3>= 3.0.7, PHP 4 )
dcgettext -- Overrides the domain for a single lookup
Description
string dcgettext ( string domain, string message, int category)
This function allows you to override the current domain for a single 
message lookup. It also allows you to specify a category.   bindtextdomainUpdcngettext
#

#T=string dcgettext ( string domain, string message, int category)
dcgettext ( ^!string domain, string message, int category);
#

#T=dcngettext - string dcngettext ( string domain, string msgid1, string msgid2, int n, 
(PHP 4 >= 4.2.0)
dcngettext -- Plural version of dcgettext
Description
string dcngettext ( string domain, string msgid1, string msgid2, int n, 
int category)
Warning
This function is currently not documented; only the argument list is 
available.
  dcgettextUpdgettext
#

#T=string dcngettext ( string domain, string msgid1, string msgid2, int n, 
dcngettext ( ^!string domain, string msgid1, string msgid2, int n, ;
#

#T=deaggregate - void deaggregate ( object object [, string class_name])
(PHP 4 >= 4.2.0)
deaggregate --  Removes the aggregated methods and properties from an 
object 
Description
void deaggregate ( object object [, string class_name])
Removes the methods and properties from classes that were aggregated to an 
object. If the optional class_name parameters is passed, only those 
methods and properties defined in that class are removed, otherwise all 
aggregated methods and properties are eliminated. 
See also aggregate(), aggregate_methods(), aggregate_methods_by_list(), 
aggregate_methods_by_regexp(), aggregate_properties(), 
aggregate_properties_by_list(), aggregate_properties_by_regexp(), 
aggregate_info()   aggregation_infoUpOracle 8 functions
#

#T=void deaggregate ( object object [, string class_name])
deaggregate ( ^!object object [, string class_name]);
#

#T=debug_backtrace - array debug_backtrace ( void )
(PHP 4 >= 4.3.0)
debug_backtrace --  Generates a backtrace 
Description
array debug_backtrace ( void )
debug_backtrace() generates a PHP backtrace and returns this information 
as an associative array. The possible returned elements are listed in the 
following table: 
Table 1. Possible returned elements from debug_backtrace()
NameTypeDescription
functionstringThe current function name. See also __FUNCTION__. 
lineintegerThe current line number. See also __LINE__. 
filestringThe current file name. See also __FILE__. 
classstringThe current class name. See also __CLASS__ 
typestringThe current class type. 
argsarrayIf inside a function, this lists the functions arguments. 
If inside an included file, this lists the included file name(s). 

The following is a simple example. 
Example 1. debug_backtrace() example 
  // filename: a.php
  <?php

  function a_test($str) {

      echo "\nHi: $str";

      var_dump(debug_backtrace());
  }

  a_test('friend');
  ?>

  // filename: b.php
  <?php
  include_once '/tmp/a.php';
  ?> 

Results when executing /tmp/b.php: 
Hi: friend
array(2) {
[0]=>
array(4) {
["file"] => string(10) "/tmp/a.php"
["line"] => int(10)
["function"] => string(6) "a_test"
["args"]=>
array(1) {
[0] => &string(6) "friend"
}
}
[1]=>
array(4) {
["file"] => string(10) "/tmp/b.php"
["line"] => int(2)
["args"] => 
array(1) {
[0] => string(10) "/tmp/a.php"
}
["function"] => string(12) "include_once"
}
}
See also trigger_error() and debug_print_backtrace().   Error Handling and Logging FunctionsUpdebug_print_backtrace
#

#T=array debug_backtrace ( void )
debug_backtrace ( ^!void );
#

#T=debug_print_backtrace - void debug_print_backtrace ( void )
(PHP 5 CVS only)
debug_print_backtrace --  Prints a backtrace 
Description
void debug_print_backtrace ( void )
debug_print_backtrace() prints a PHP backtrace. 
Warning
This function is currently not documented; only the argument list is 
available.

See also debug_backtrace().   debug_backtraceUperror_log
#

#T=void debug_print_backtrace ( void )
debug_print_backtrace ( ^!void );
#

#T=debugger_off - int debugger_off ( void )
#
(PHP 3)
#T= - int debugger_off ( void )
debugger_off -- Disable internal PHP debugger (PHP 3)
Description
int debugger_off ( void )
Disables the internal PHP debugger. This function is only available in PHP 
3. 
For more information see the appendix on Debugging PHP.   closelogUpdebugger_on
#

#T=int debugger_off ( void )
debugger_off ( ^!void );
#

#T=debugger_on - int debugger_on ( string address)
#
(PHP 3)
#T= - int debugger_on ( string address)
debugger_on -- Enable internal PHP debugger (PHP 3)
Description
int debugger_on ( string address)
Enables the internal PHP debugger, connecting it to address. This function 
is only available in PHP 3. 
For more information see the appendix on Debugging PHP.   debugger_offUpdefine_syslog_variables
#

#T=int debugger_on ( string address)
debugger_on ( ^!string address);
#

#T=decbin - string decbin ( int number)
(PHP 3, PHP 4 )
decbin -- Decimal to binary
Description
string decbin ( int number)
Returns a string containing a binary representation of the given number 
argument. The largest number that can be converted is 4294967295 in 
decimal resulting to a string of 32 1's. 
Example 1. decbin() example
  <?php
  echo decbin(12) . "\n";
  echo decbin(26);
  ?> 

The above example will output: 
1100
11010
See also bindec(), decoct(), dechex() and base_convert().   coshUpdechex
#

#T=string decbin ( int number)
decbin ( ^!int number);
#

#T=dechex - string dechex ( int number)
(PHP 3, PHP 4 )
dechex -- Decimal to hexadecimal
Description
string dechex ( int number)
Returns a string containing a hexadecimal representation of the given 
number argument. The largest number that can be converted is 2147483647 in 
decimal resulting to "7fffffff". 
Example 1. dechex() example
  <?php
  echo dechex(10) . "\n";
  echo dechex(47);
  ?> 

The above example will output: 
a
2f
See also hexdec(), decbin(), decoct() and base_convert().   decbinUpdecoct
#

#T=string dechex ( int number)
dechex ( ^!int number);
#

#T=decoct - string decoct ( int number)
(PHP 3, PHP 4 )
decoct -- Decimal to octal
Description
string decoct ( int number)
Returns a string containing an octal representation of the given number 
argument. The largest number that can be converted is 2147483647 in 
decimal resulting to "17777777777". 
Example 1. decoct() example
  <?php
  echo decoct(15) . "\n";
  echo decoct(264);
  ?> 

The above example will output: 
17
410
See also octdec(), decbin(), dechex() and base_convert().   dechexUpdeg2rad
#

#T=string decoct ( int number)
decoct ( ^!int number);
#

#T=define_syslog_variables - void define_syslog_variables ( void )
(PHP 3, PHP 4 )
define_syslog_variables -- Initializes all syslog related constants
Description
void define_syslog_variables ( void )
Initializes all constants used in the syslog functions. 
See also openlog(), syslog() and closelog().   debugger_onUpdns_check_record
#

#T=void define_syslog_variables ( void )
define_syslog_variables ( ^!void );
#

#T=define - bool define ( string name, mixed value [, bool case_insensitive])
(PHP 3, PHP 4 )
define -- Defines a named constant.
Description
bool define ( string name, mixed value [, bool case_insensitive])
Defines a named constant. See the section on constants for more details. 
The name of the constant is given by name; the value is given by value. 
The optional third parameter case_insensitive is also available. If the 
value TRUE is given, then the constant will be defined case-insensitive. 
The default behaviour is case-sensitive; i.e. CONSTANT and Constant 
represent different values. 
Example 1. Defining Constants
  <?php
  define("CONSTANT", "Hello world.");
  echo CONSTANT; // outputs "Hello world."
  echo Constant; // outputs "Constant" and issues a notice.

  define("GREETING", "Hello you.", true);
  echo GREETING; // outputs "Hello you."
  echo Greeting; // outputs "Hello you."

  ?> 
Returns TRUE on success or FALSE on failure. 
See also defined(), constant() and the section on Constants.   constantUpdefined
#

#T=bool define ( string name, mixed value [, bool case_insensitive])
define ( ^!string name, mixed value [, bool case_insensitive]);
#

#T=defined - bool defined ( string name)
(PHP 3, PHP 4 )
defined --  Checks whether a given named constant exists 
Description
bool defined ( string name)
Returns TRUE if the named constant given by name has been defined, FALSE 
otherwise. 
Example 1. Checking Constants
  <?php
  /* Note the use of quotes, this is important.  This example is 
  checking 
  * if the string 'CONSTANT' is the name of a constant named 
  CONSTANT */
  if (defined('CONSTANT')) {
      echo CONSTANT;
  }
  ?> 
Note: If you want to see if a variable exists, use isset() as defined() 
only applies to constants. If you want to see if a function exists, use 
function_exists(). 
See also define(), constant(), get_defined_constants(), function_exists(), 
and the section on Constants.   defineUpdie
#

#T=bool defined ( string name)
defined ( ^!string name);
#

#T=deg2rad - float deg2rad ( float number)
(PHP 3>= 3.0.4, PHP 4 )
deg2rad --  Converts the number in degrees to the radian equivalent 
Description
float deg2rad ( float number)
This function converts number from degrees to the radian equivalent. 
Example 1. deg2rad() example
  <?php

  echo deg2rad(45); // 0.785398163397
  var_dump(deg2rad(45) === M_PI_4); // bool(true)

  ?> 
See also rad2deg().   decoctUpexp
delete
(no version information, might be only in CVS)
delete -- See unlink() or unset()
Description
void delete ( string file)
This is a dummy manual entry to satisfy those people who are looking for 
unlink() or unset() in the wrong place. 
See also: unlink() to delete files, unset() to delete variables.   copyUpdirname
#

#T=float deg2rad ( float number)
deg2rad ( ^!float number);
#

#T=dgettext - string dgettext ( string domain, string message)
(PHP 3>= 3.0.7, PHP 4 )
dgettext -- Override the current domain
Description
string dgettext ( string domain, string message)
The dgettext() function allows you to override the current domain for a 
single message lookup.   dcngettextUpdngettext
die
die -- Alias of exit()
Description
This function is an alias of exit().   definedUpeval
#

#T=string dgettext ( string domain, string message)
dgettext ( ^!string domain, string message);
#

#T=dio_close - void dio_close ( resource fd)
(PHP 4 >= 4.2.0)
dio_close -- Closes the file descriptor given by fd
Description
void dio_close ( resource fd)
The function dio_close() closes the file descriptor fd.   Direct IO functionsUpdio_fcntl
#

#T=void dio_close ( resource fd)
dio_close ( ^!resource fd);
#

#T=dio_fcntl - mixed dio_fcntl ( resource fd, int cmd [, mixed arg])
(PHP 4 >= 4.2.0)
dio_fcntl -- Performs a c library fcntl on fd
Description
mixed dio_fcntl ( resource fd, int cmd [, mixed arg])
The dio_fcntl() function performs the operation specified by cmd on the 
file descriptor fd. Some commands require additional arguments args to be 
supplied. 
arg is an associative array, when cmd is F_SETLK or F_SETLLW, with the 
following keys: 
"start" - offset where lock begins 
"length" - size of locked area. zero means to end of file 
"wenth" - Where l_start is relative to: can be SEEK_SET, SEEK_END and 
SEEK_CUR 
"type" - type of lock: can be F_RDLCK (read lock), F_WRLCK (write lock) 
or F_UNLCK (unlock) 
cmd can be one of the following operations: 
F_SETLK - Lock is set or cleared. If the lock is held by someone else 
dio_fcntl() returns -1. 
F_SETLKW - like F_SETLK, but in case the lock is held by someone else, 
dio_fcntl() waits until the lock is released. 
F_GETLK - dio_fcntl() returns an associative array (as described above) 
if someone else prevents lock. If there is no obstruction key "type" 
will set to F_UNLCK. 
F_DUPFD - finds the lowest numbered available file descriptor greater or 
equal than arg and returns them. 
F_SETFL - Sets the file descriptors flags to the value specified by arg, 
which can be O_APPEND,O_NONBLOCK or O_ASYNC. To use O_ASYNC you will 
need to use the PCNTL extension.   dio_closeUpdio_open
#

#T=mixed dio_fcntl ( resource fd, int cmd [, mixed arg])
dio_fcntl ( ^!resource fd, int cmd [, mixed arg]);
#

#T=dio_open - resource dio_open ( string filename, int flags [, int mode])
(PHP 4 >= 4.2.0)
dio_open --  Opens a new filename with specified permissions of flags and 
creation permissions of mode 
Description
resource dio_open ( string filename, int flags [, int mode])
dio_open() opens a file and returns a new file descriptor for it, or FALSE 
if any error occurred. If flags is O_CREAT, the optional third parameter 
mode will set the mode of the file (creation permissions). The flags 
parameter can be one of the following options: 
O_RDONLY - opens the file for read access.
O_WRONLY - opens the file for write access.
O_RDWR - opens the file for both reading and writing. 
The flags parameter can also include any combination of the following 
flags: 
O_CREAT - creates the file, if it doesn't already exist. 
O_EXCL - if both, O_CREAT and O_EXCL are set, dio_open() fails, if the 
file already exists. 
O_TRUNC - if the file exists, and its opened for write access, the file 
will be truncated to zero length. 
O_APPEND - write operations write data at the end of the file. 
O_NONBLOCK - sets non blocking mode.   dio_fcntlUpdio_read
#

#T=resource dio_open ( string filename, int flags [, int mode])
dio_open ( ^!string filename, int flags [, int mode]);
#

#T=dio_read - string dio_read ( resource fd [, int n])
(PHP 4 >= 4.2.0)
dio_read --  Reads n bytes from fd and returns them, if n is not 
specified, reads 1k block 
Description
string dio_read ( resource fd [, int n])
The function dio_read() reads and returns n bytes from file with 
descriptor fd. If n is not specified, dio_read() reads 1K sized block and 
returns them.   dio_openUpdio_seek
#

#T=string dio_read ( resource fd [, int n])
dio_read ( ^!resource fd [, int n]);
#

#T=dio_seek - int dio_seek ( resource fd, int pos, int whence)
(PHP 4 >= 4.2.0)
dio_seek -- Seeks to pos on fd from whence
Description
int dio_seek ( resource fd, int pos, int whence)
The function dio_seek() is used to change the file position of the file 
with descriptor fd. The parameter whence specifies how the position pos 
should be interpreted: 
SEEK_SET - specifies that pos is specified from the beginning of the 
file. 
SEEK_CUR - Specifies that pos is a count of characters from the current 
file position. This count may be positive or negative. 
SEEK_END - Specifies that pos is a count of characters from the end of 
the file. A negative count specifies a position within the current 
extent of the file; a positive count specifies a position past the 
current end. If you set the position past the current end, and actually 
write data, you will extend the file with zeros up to that position.   dio_readUpdio_stat
#

#T=int dio_seek ( resource fd, int pos, int whence)
dio_seek ( ^!resource fd, int pos, int whence);
#

#T=dio_stat - array dio_stat ( resource fd)
(PHP 4 >= 4.2.0)
dio_stat --  Gets stat information about the file descriptor fd 
Description
array dio_stat ( resource fd)
Function dio_stat() returns information about the file with file 
descriptor fd. dio_stat() returns an associative array with the following 
keys: 
"device" - device
"inode" - inode
"mode" - mode
"nlink" - number of hard links
"uid" - user id
"gid" - group id
"device_type" - device type (if inode device) 
"size" - total size in bytes
"blocksize" - blocksize
"blocks" - number of blocks allocated
"atime" - time of last access
"mtime" - time of last modification
"ctime" - time of last change
On error dio_stat() returns NULL.   dio_seekUpdio_tcsetattr
#

#T=array dio_stat ( resource fd)
dio_stat ( ^!resource fd);
#

#T=dio_tcsetattr - dio_tcsetattr ( resource fd, array options)
(PHP 4 >= 4.3.0)
dio_tcsetattr --  Sets terminal attributes and baud rate for a serial port 

Description
dio_tcsetattr ( resource fd, array options)
The function dio_tcsetattr() sets the terminal attributes and baud rate of 
the open resource. The currently available options are 
'baud' - baud rate of the port - can be 38400,19200,9600,4800,2400,1800, 
1200,600,300,200,150,134,110,75 or 50, default value is 9600. 
'bits' - data bits - can be 8,7,6 or 5. Default value is 8. 
'stop' - stop bits - can be 1 or 2. Default value is 1. 
'parity' - can be 0,1 or 2. Default value is 0. 
Example 1. Setting the baud rate on a serial port 
  <?php

  $fd = dio_open('/dev/ttyS0', O_RDWR | O_NOCTTY | O_NONBLOCK);

  dio_fcntl($fd, F_SETFL, O_SYNC);

  dio_tcsetattr($fd, array(
    'baud' => 9600,
    'bits' => 8,
    'stop'  => 1,
    'parity' => 0
  )); 

  while (1) {

    $data = dio_read($fd, 256);

    if ($data) {
	echo $data;
    }
  } 

  ?> 

  dio_statUpdio_truncate
#

#T=dio_tcsetattr ( resource fd, array options)
( resource ^!fd, array options);
#

#T=dio_truncate - bool dio_truncate ( resource fd, int offset)
(PHP 4 >= 4.2.0)
dio_truncate --  Truncates file descriptor fd to offset bytes 
Description
bool dio_truncate ( resource fd, int offset)
Function dio_truncate() causes the file referenced by fd to be truncated 
to at most offset bytes in size. If the file previously was larger than 
this size, the extra data is lost. If the file previously was shorter, it 
is unspecified whether the file is left unchanged or is extended. In the 
latter case the extended part reads as zero bytes. Returns TRUE on success 
or FALSE on failure..   dio_tcsetattrUpdio_write
#

#T=bool dio_truncate ( resource fd, int offset)
dio_truncate ( ^!resource fd, int offset);
#

#T=dio_write - int dio_write ( resource fd, string data [, int len])
(PHP 4 >= 4.2.0)
dio_write --  Writes data to fd with optional truncation at length 
Description
int dio_write ( resource fd, string data [, int len])
The function dio_write() writes up to len bytes from data to file fd. If 
len is not specified, dio_write() writes all data to the specified file. 
dio_write() returns the number of bytes written to fd.   dio_truncateUpDirectory functions
#

#T=int dio_write ( resource fd, string data [, int len])
dio_write ( ^!resource fd, string data [, int len]);
#

#T=dirname - string dirname ( string path)
(PHP 3, PHP 4 )
dirname -- Returns directory name component of path
Description
string dirname ( string path)
Given a string containing a path to a file, this function will return the 
name of the directory. 
On Windows, both slash (/) and backslash (\) are used as path separator 
character. In other environments, it is the forward slash (/).
Example 1. dirname() example
  <?php
  $path = "/etc/passwd";
  $file = dirname($path); // $file is set to "/etc"
  ?> 
Note: In PHP 4.0.3, dirname() was fixed to be POSIX-compliant. 
Essentially, this means that if there are no slashes in path , a dot 
('.') is returned, indicating the current directory. Otherwise, the 
returned string is path with any trailing /component removed. Note that 
this means that you will often get a slash or a dot back from dirname() 
in situations where the older functionality would have given you the 
empty string. 
See also basename(), pathinfo(), and realpath().   deleteUpdisk_free_space
#

#T=string dirname ( string path)
dirname ( ^!string path);
#

#T=disk_free_space - float disk_free_space ( string directory)
(PHP 4 >= 4.1.0)
disk_free_space -- Returns available space in directory
Description
float disk_free_space ( string directory)
Given a string containing a directory, this function will return the 
number of bytes available on the corresponding filesystem or disk 
partition. 
Example 1. disk_free_space() example
  <?php
  // $df contains the number of bytes available on "/"
  $df = disk_free_space("/");

  // On Windows:
  disk_free_space("C:");
  disk_free_space("D:");
  ?> 
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.
See also disk_total_space()   dirnameUpdisk_total_space
#

#T=float disk_free_space ( string directory)
disk_free_space ( ^!string directory);
#

#T=disk_total_space - float disk_total_space ( string directory)
(PHP 4 >= 4.1.0)
disk_total_space -- Returns the total size of a directory
Description
float disk_total_space ( string directory)
Given a string containing a directory, this function will return the total 
number of bytes on the corresponding filesystem or disk partition. 
Example 1. disk_total_space() example
  <?php
  // $df contains the total number of bytes available on "/"
  $df = disk_total_space("/");

  // On Windows:
  disk_total_space("C:");
  disk_total_space("D:");
  ?> 
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.
See also disk_free_space()   disk_free_spaceUpdiskfreespace
diskfreespace
diskfreespace -- Alias of disk_free_space()
Description
This function is an alias of disk_free_space().   disk_total_spaceUpfclose
#

#T=float disk_total_space ( string directory)
disk_total_space ( ^!string directory);
#

#T=dl - int dl ( string library)
(PHP 3, PHP 4 )
dl -- Loads a PHP extension at runtime
Description
int dl ( string library)
Loads the PHP extension given by the parameter library. The library 
parameter is only the filename of the extension to load which also depends 
on your platform. For example, the sockets extension (if compiled as a 
shared module, not the default!) would be called sockets.so on Unix 
platforms whereas it is called php_sockets.dll on the Windows platform. 
Returns TRUE on success or FALSE on failure. If the functionality of 
loading modules is not available (see Note) or has been disabled (either 
by turning it off enable_dl or by enabling safe mode in php.ini) an 
E_ERROR is emitted and execution is stopped. If dl() fails because the 
specified library couldn't be loaded, in addition to FALSE an E_WARNING 
message is emitted. 
Use extension_loaded() to test whether a given extension is already 
available or not. This works on both built-in extensions and dynamically 
loaded ones (either through php.ini or dl()). 
Example 1. dl() examples
  <?php
  // Example loading an extension based on OS
  if (!extension_loaded('sqlite')) {
      if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN')) {
	  dl('php_sqlite.dll');
      } else {
	  dl('sqlite.so');
      }
  }

  // Or, the PHP_SHLIB_SUFFIX constant is available as of PHP 
  4.3.0
  if (!extension_loaded('sqlite')) {
      $prefix = (PHP_SHLIB_SUFFIX == 'dll') ? 'php_' : '';
      dl($prefix . 'sqlite.' . PHP_SHLIB_SUFFIX);
  }
  ?> 
The directory where the extension is loaded from depends on your platform: 

Windows - If not explicitly set in the php.ini, the extension is loaded 
from c:\php4\extensions\ by default. 
Unix - If not explicitly set in the php.ini, the default extension 
directory depends on 
whether PHP has been built with --enable-debug or not 
whether PHP has been built with (experimental) ZTS (Zend Thread Safety) 
support or not 
the current internal ZEND_MODULE_API_NO (Zend internal module API 
number, which is basically the date on which a major module API change 
happened, e.g. 20010901) 
Taking into account the above, the directory then defaults to 
<install-dir>/lib/php/extensions/ 
<debug-or-not>-<zts-or-not>-ZEND_MODULE_API_NO, e.g. 
/usr/local/php/lib/php/extensions/debug-non-zts-20010901 or 
/usr/local/php/lib/php/extensions/no-debug-zts-20010901. 
Note: dl() is not supported in multithreaded Web servers. Use the 
extensions statement in your php.ini when operating under such an 
environment. However, the CGI and CLI build are not affected ! 
Note: dl() is case sensitive on Unix platforms. 
Note: This function is disabled in safe mode.
See also Extension Loading Directives and extension_loaded().   assertUpextension_loaded
#

#T=int dl ( string library)
dl ( ^!string library);
#

#T=dngettext - string dngettext ( string domain, string msgid1, string msgid2, int n)
(PHP 4 >= 4.2.0)
dngettext -- Plural version of dgettext
Description
string dngettext ( string domain, string msgid1, string msgid2, int n)
Warning
This function is currently not documented; only the argument list is 
available.
  dgettextUpgettext
#

#T=string dngettext ( string domain, string msgid1, string msgid2, int n)
dngettext ( ^!string domain, string msgid1, string msgid2, int n);
#

#T=dns_check_record - int dns_check_record ( string host [, string type])
(PHP 5 CVS only)
dns_check_record -- Synonym for checkdnsrr()
Description
int dns_check_record ( string host [, string type])
Check DNS records corresponding to a given Internet host name or IP 
address   define_syslog_variablesUpdns_get_mx
#

#T=int dns_check_record ( string host [, string type])
dns_check_record ( ^!string host [, string type]);
#

#T=dns_get_mx - int dns_get_mx ( string hostname, array mxhosts [, array &weight])
(PHP 5 CVS only)
dns_get_mx -- Synonym for getmxrr()
Description
int dns_get_mx ( string hostname, array mxhosts [, array &weight])
Get MX records corresponding to a given Internet host name.   dns_check_recordUpdns_get_record
#

#T=int dns_get_mx ( string hostname, array mxhosts [, array &weight])
dns_get_mx ( ^!string hostname, array mxhosts [, array &weight]);
#

#T=dns_get_record - array dns_get_record ( string hostname [, int type [, array &authns, array 
(PHP 5 CVS only)
dns_get_record --  Fetch DNS Resource Records associated with a hostname 
Description
array dns_get_record ( string hostname [, int type [, array &authns, array 
&addtl]])
Note: This function is not implemented on Windows platforms. Try the 
PEAR class Net_DNS. 
This function returns an array of associative arrays. Each associative 
array contains at minimum the following keys: 
Table 1. Basic DNS attributes
AttributeMeaning
hostThe record in the DNS namespace to which the rest of the 
associated data refers. 
classdns_get_record() only returns Internet class records and as 
such this parameter will always return IN. 
typeString containing the record type. Additional attributes will 
also be contained in the resulting array dependant on the value of 
type. See table below. 
ttlTime To Live remaining for this record. This will not equal the 
record's original ttl, but will rather equal the original ttl minus 
whatever length of time has passed since the authoritative name 
server was queried. 

hostname should be a valid DNS hostname such as "www.example.com". Reverse 
lookups can be generated using in-addr.arpa notation, but gethostbyaddr() 
is more suitable for the majority of reverse lookups. 
By default, dns_get_record() will search for any resource records 
associated with hostname. To limit the query, specify the optional type 
parameter. type may be any one of the following: DNS_A, DNS_CNAME, 
DNS_HINFO, DNS_MX, DNS_NS, DNS_PTR, DNS_SOA, DNS_TXT, DNS_AAAA, DNS_SRV, 
DNS_NAPTR, DNS_ALL or DNS_ANY. The default is DNS_ANY. 
Note: Because of eccentricities in the performance of libresolv between 
platforms, DNS_ANY will not always return every record, the slower 
DNS_ALL will collect all records more reliably. 
The optional third and fourth arguments to this function, authns and addtl 
are passed by reference and, if given, will be populated with Resource 
Records for the Authoritative Name Servers, and any Additional Records 
respectively. See the example below. 
Table 2. Other keys in associative arrays dependant on 'type'
TypeExtra Columns
Aip: An IPv4 addresses in dotted decimal notation. 
MXpri: Priority of mail exchanger. Lower numbers indicate greater 
priority. target: FQDN of the mail exchanger. See also dns_get_mx(). 

CNAMEtarget: FQDN of location in DNS namespace to which the record 
is aliased. 
NStarget: FQDN of the name server which is authoritative for this 
hostname. 
PTRtarget: Location within the DNS namespace to which this record 
points. 
TXTtxt: Arbitrary string data associated with this record. 
HINFOcpu: IANA number designating the CPU of the machine referenced 
by this record. os: IANA number designating the Operating System on 
the machine referenced by this record. See IANA's Operating System 
Names for the meaning of these values. 
SOAmname: FQDN of the machine from which the resource records 
originated. rname: Email address of the administrative contain for 
this domain. serial: Serial # of this revision of the requested 
domain. refresh: Refresh interval (seconds) secondary name servers 
should use when updating remote copies of this domain. retry: Length 
of time (seconds) to wait after a failed refresh before making a 
second attempt. expire: Maximum length of time (seconds) a secondary 
DNS server should retain remote copies of the zone data without a 
successful refresh before discarding. minimum-ttl: Minimum length of 
time (seconds) a client can continue to use a DNS resolution before 
it should request a new resolution from the server. Can be 
overridden by individual resource records. 
AAAAipv6: IPv6 address 
SRVpri: (Priority) lowest priorities should be used first. weight: 
Ranking to weight which of commonly prioritized targets should be 
chosen at random. target and port: hostname and port where the 
requested service can be found. For additional information see: RFC 
2782 
NAPTRorder and pref: Equivalent to pri and weight above. flags, 
services, regex, and replacement: Parameters as defined by RFC 2915. 
Note: Per DNS standards, email addresses are given in user.host format 
(for example: hostmaster.example.com as opposed to 
hostmaster@example.com), be sure to check this value and modify if 
necessary before using it with a functions such as mail(). 
Example 1. Using dns_get_record()
  <?php
  $result = dns_get_record("php.net");
  print_r($result);
  ?> 

Produces output similar to the following: 
Array
(
[0] => Array
(
[host] => php.net
[type] => MX
[pri] => 5
[target] => pair2.php.net
[class] => IN
[ttl] => 6765
)

[1] => Array
(
[host] => php.net
[type] => A
[ip] => 64.246.30.37
[class] => IN
[ttl] => 8125
)

)
Since it's very common to want the IP address of a mail server once the MX 
record has been resolved, dns_get_record() also returns an array in addtl 
which contains associate records. authns is returned as well containing a 
list of authoritative name servers. 
Example 2. Using dns_get_record() and DNS_ANY
  <?php
  /* Request "ANY" record for php.net, 
     and create $authns and $addtl arrays
     containing list of name servers and
     any additional records which go with
     them */
  $result = dns_get_record("php.net", DNS_ANY, $authns, $addtl);
  echo "Result = ";
  print_r($result);
  echo "Auth NS = ";
  print_r($authns);
  echo "Additional = ";
  print_r($addtl);
  ?> 

Produces output similar to the following: 
Result = Array
(
[0] => Array
(
[host] => php.net
[type] => MX
[pri] => 5
[target] => pair2.php.net
[class] => IN
[ttl] => 6765
)

[1] => Array
(
[host] => php.net
[type] => A
[ip] => 64.246.30.37
[class] => IN
[ttl] => 8125
)

)
Auth NS = Array
(
[0] => Array
(
[host] => php.net
[type] => NS
[target] => remote1.easydns.com
[class] => IN
[ttl] => 10722
)

[1] => Array
(
[host] => php.net
[type] => NS
[target] => remote2.easydns.com
[class] => IN
[ttl] => 10722
)

[2] => Array
(
[host] => php.net
[type] => NS
[target] => ns1.easydns.com
[class] => IN
[ttl] => 10722
)

[3] => Array
(
[host] => php.net
[type] => NS
[target] => ns2.easydns.com
[class] => IN
[ttl] => 10722
)

)
Additional = Array
(
[0] => Array
(
[host] => pair2.php.net
[type] => A
[ip] => 216.92.131.5
[class] => IN
[ttl] => 6766
)

[1] => Array
(
[host] => remote1.easydns.com
[type] => A
[ip] => 64.39.29.212
[class] => IN
[ttl] => 100384
)

[2] => Array
(
[host] => remote2.easydns.com
[type] => A
[ip] => 212.100.224.80
[class] => IN
[ttl] => 81241
)

[3] => Array
(
[host] => ns1.easydns.com
[type] => A
[ip] => 216.220.40.243
[class] => IN
[ttl] => 81241
)

[4] => Array
(
[host] => ns2.easydns.com
[type] => A
[ip] => 216.220.40.244
[class] => IN
[ttl] => 81241
)

)
See also dns_get_mx(), and dns_check_record()   dns_get_mxUpfsockopen
DomAttribute->name
(no version information, might be only in CVS)
DomAttribute->name --  Returns name of attribute 
Description
bool DomAttribute->name ( void )
This function returns the name of the attribute. 
See also domattribute_value().   DOM XML functionsUpDomAttribute->specified
DomAttribute->specified
(no version information, might be only in CVS)
DomAttribute->specified --  Checks if attribute is specified 
Description
bool DomAttribute->specified ( void )
Check DOM standard for a detailed explanation.   DomAttribute->nameUpDomAttribute->value
DomAttribute->value
(no version information, might be only in CVS)
DomAttribute->value --  Returns value of attribute 
Description
bool DomAttribute->value ( void )
This function returns the value of the attribute. 
See also domattribute_name().   DomAttribute->specifiedUpDomDocument->add_root [deprecated]
DomDocument->add_root [deprecated]
(no version information, might be only in CVS)
DomDocument->add_root [deprecated] --  Adds a root node 
Description
resource DomDocument->add_root ( string name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Adds a root element node to a dom document and returns the new node. The 
element name is given in the passed parameter. 
Example 1. Creating a simple HTML document header
  <?php
  $doc = domxml_new_doc("1.0");
  $root = $doc->add_root("HTML");
  $head = $root->new_child("HEAD", "");
  $head->new_child("TITLE", "Hier der Titel");
  echo htmlentities($doc->dump_mem());
  ?> 

  DomAttribute->valueUpDomDocument->create_attribute
DomDocument->create_attribute
(no version information, might be only in CVS)
DomDocument->create_attribute -- Create new attribute
Description
object DomDocument->create_attribute ( string name, string value)
This function returns a new instance of class DomAttribute. The name of 
the attribute is the value of the first parameter. The value of the 
attribute is the value of the second parameter. This node will not show up 
in the document unless it is inserted with e.g. domnode_append_child(). 
The return value is FALSE if an error occurred. 
See also domnode_append_child(), domdocument_create_element(), 
domdocument_create_text(), domdocument_create_cdata_section(), 
domdocument_create_processing_instruction(), 
domdocument_create_entity_reference(), and domnode_insert_before().   DomDocument->add_root 
  [deprecated]UpDomDocument->create_cdata_section
DomDocument->create_cdata_section
(no version information, might be only in CVS)
DomDocument->create_cdata_section -- Create new cdata node
Description
string DomDocument->create_cdata_section ( string content)
This function returns a new instance of class DomCData. The content of the 
cdata is the value of the passed parameter. This node will not show up in 
the document unless it is inserted with e.g. domnode_append_child(). 
The return value is FALSE if an error occurred. 
See also domnode_append_child(), domdocument_create_element(), 
domdocument_create_text(), domdocument_create_attribute(), 
domdocument_create_processing_instruction(), 
domdocument_create_entity_reference(), and domnode_insert_before().   DomDocument->create_attributeUpDomDocument->create_comment
DomDocument->create_comment
(no version information, might be only in CVS)
DomDocument->create_comment -- Create new comment node
Description
object DomDocument->create_comment ( string content)
This function returns a new instance of class DomComment. The content of 
the comment is the value of the passed parameter. This node will not show 
up in the document unless it is inserted with e.g. domnode_append_child(). 

The return value is FALSE if an error occurred. 
See also domnode_append_child(), domdocument_create_element(), 
domdocument_create_text(), domdocument_create_attribute(), 
domdocument_create_processing_instruction(), 
domdocument_create_entity_reference() and domnode_insert_before().   DomDocument->create_cdata_sectionUpDomDocument->create_element_ns
DomDocument->create_element
(no version information, might be only in CVS)
DomDocument->create_element -- Create new element node
Description
object DomDocument->create_element ( string name)
This function returns a new instance of class DomElement. The tag name of 
the element is the value of the passed parameter. This node will not show 
up in the document unless it is inserted with e.g. domnode_append_child(). 

The return value is FALSE if an error occurred. 
See also domdocument_create_element_ns(), domnode_append_child(), 
domdocument_create_text(), domdocument_create_comment(), 
domdocument_create_attribute(), 
domdocument_create_processing_instruction(), 
domdocument_create_entity_reference(), and domnode_insert_before().   DomDocument->create_element_nsUpDomDocument->create_entity_reference
DomDocument->create_element_ns
(no version information, might be only in CVS)
DomDocument->create_element_ns --  Create new element node with an 
associated namespace 
Description
object DomDocument->create_element_ns ( string uri, string name [, string 
prefix])
This function returns a new instance of class DomElement. The tag name of 
the element is the value of the passed parameter name. The URI of the 
namespace is the value of the passed parameter uri. If there is already a 
namespace declaration with the same uri in the root-node of the document, 
the prefix of this is taken, otherwise it will take the one provided in 
the optional parameter prefix or generate a random one. This node will not 
show up in the document unless it is inserted with e.g. 
domnode_append_child(). 
The return value is FALSE if an error occurred. 
See also domdocument_create_element_ns(), domnode_add_namespace(), 
domnode_set_namespace(), domnode_append_child(), 
domdocument_create_text(), domdocument_create_comment(), 
domdocument_create_attribute(), 
domdocument_create_processing_instruction(), 
domdocument_create_entity_reference(), and domnode_insert_before().   DomDocument->create_commentUpDomDocument->create_element
DomDocument->create_entity_reference
(no version information, might be only in CVS)
DomDocument->create_entity_reference --  
Description
object DomDocument->create_entity_reference ( string content)
This function returns a new instance of class DomEntityReference. The 
content of the entity reference is the value of the passed parameter. This 
node will not show up in the document unless it is inserted with e.g. 
domnode_append_child(). 
The return value is FALSE if an error occurred. 
See also domnode_append_child(), domdocument_create_element(), 
domdocument_create_text(), domdocument_create_cdata_section(), 
domdocument_create_processing_instruction(), 
domdocument_create_attribute(), and domnode_insert_before().   DomDocument->create_elementUpDomDocument->create_processing_instruction
DomDocument->create_processing_instruction
(no version information, might be only in CVS)
DomDocument->create_processing_instruction -- Creates new PI node
Description
string DomDocument->create_processing_instruction ( string content)
This function returns a new instance of class DomCData. The content of the 
pi is the value of the passed parameter. This node will not show up in the 
document unless it is inserted with e.g. domnode_append_child(). 
The return value is FALSE if an error occurred. 
See also domnode_append_child(), domdocument_create_element(), 
domdocument_create_text(), domdocument_create_cdata_section(), 
domdocument_create_attribute(), domdocument_create_entity_reference(), and 
domnode_insert_before().   DomDocument->create_entity_referenceUpDomDocument->create_text_node
DomDocument->create_text_node
(no version information, might be only in CVS)
DomDocument->create_text_node -- Create new text node
Description
object DomDocument->create_text_node ( string content)
This function returns a new instance of class DomText. The content of the 
text is the value of the passed parameter. This node will not show up in 
the document unless it is inserted with e.g. domnode_append_child(). 
The return value is FALSE if an error occurred. 
See also domnode_append_child(), domdocument_create_element(), 
domdocument_create_comment(), domdocument_create_text(), 
domdocument_create_attribute(), 
domdocument_create_processing_instruction(), 
domdocument_create_entity_reference(), and domnode_insert_before().   DomDocument->create_processing_instructionUpDomDocument->doctype
DomDocument->doctype
(no version information, might be only in CVS)
DomDocument->doctype --  Returns the document type 
Description
object DomDocument->doctype ( void )
This function returns an object of class DomDocumentType. In versions of 
PHP before 4.3 this has been the class Dtd, but the DOM Standard does not 
know such a class. 
See also the methods of class DomDocumentType.   DomDocument->create_text_nodeUpDomDocument->document_element
DomDocument->document_element
(no version information, might be only in CVS)
DomDocument->document_element --  Returns root element node 
Description
object DomDocument->document_element ( void )
This function returns the root element node of a document. 
The following example returns just the element with name CHAPTER and 
prints it. The other node -- the comment -- is not returned. Example 
1. Retrieving root element
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $root = $dom->document_element();
  print_r($root);
  ?> 

  DomDocument->doctypeUpDomDocument->dump_file
DomDocument->dump_file
(no version information, might be only in CVS)
DomDocument->dump_file --  Dumps the internal XML tree back into a file 
Description
string DomDocument->dump_file ( string filename [, bool compressionmode [, 
bool format]])
Creates an XML document from the dom representation. This function usually 
is called after building a new dom document from scratch as in the example 
below. The format specifies whether the output should be neatly formatted, 
or not. The first parameter specifies the name of the filename and the 
second parameter, whether it should be compressed or not. 
Example 1. Creating a simple HTML document header
  <?php
  $doc = domxml_new_doc("1.0");
  $root = $doc->create_element("HTML");
  $root = $doc->append_child($root);
  $head = $doc->create_element("HEAD");
  $head = $root->append_child($head);
  $title = $doc->create_element("TITLE");
  $title = $head->append_child($title);
  $text = $doc->create_text_node("This is the title");
  $text = $title->append_child($text);
  $doc->dump_file("/tmp/test.xml", false, true);
  ?> 
See also domdocument_dump_mem() domdocument_html_dump_mem().   DomDocument->document_elementUpDomDocument->dump_mem
DomDocument->dump_mem
(no version information, might be only in CVS)
DomDocument->dump_mem --  Dumps the internal XML tree back into a string 
Description
string DomDocument->dump_mem ( [bool format [, string encoding]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Creates an XML document from the dom representation. This function usually 
is called after building a new dom document from scratch as in the example 
below. The format specifies whether the output should be neatly formatted, 
or not. 
Example 1. Creating a simple HTML document header
  <?php
  $doc = domxml_new_doc("1.0");
  $root = $doc->create_element("HTML");
  $root = $doc->append_child($root);
  $head = $doc->create_element("HEAD");
  $head = $root->append_child($head);
  $title = $doc->create_element("TITLE");
  $title = $head->append_child($title);
  $text = $doc->create_text_node("This is the title");
  $text = $title->append_child($text);
  echo "<PRE>";
  echo htmlentities($doc->dump_mem(true));
  echo "</PRE>";
  ?> 
Note: The first parameter was added in PHP 4.3.0. 
See also domdocument_dump_file(), domdocument_html_dump_mem().   DomDocument->dump_fileUpDomDocument->get_element_by_id
DomDocument->get_element_by_id
(no version information, might be only in CVS)
DomDocument->get_element_by_id --  Searches for an element with a certain 
id 
Description
object DomDocument->get_element_by_id ( string id)
This function is similar to domdocument_get_elements_by_tagname() but 
searches for an element with a given id. According to the DOM standard 
this requires a DTD which defines the attribute ID to be of type ID, 
though the current implementation simply does an xpath search for "//*[@ID 
= '%s']". This does not comply to the DOM standard which requires to 
return null if it is not known which attribute is of type id. This 
behaviour is likely to be fixed, so do not rely on the current behaviour. 
See also domdocument_get_elements_by_tagname()   DomDocument->dump_memUpDomDocument->get_elements_by_tagname
DomDocument->get_elements_by_tagname
(no version information, might be only in CVS)
DomDocument->get_elements_by_tagname --  
Description
array DomDocument->get_elements_by_tagname ( string name)
See also domdocument_add_root()   DomDocument->get_element_by_idUpDomDocument->html_dump_mem
DomDocument->html_dump_mem
(no version information, might be only in CVS)
DomDocument->html_dump_mem --  Dumps the internal XML tree back into a 
string as HTML 
Description
string DomDocument->html_dump_mem ( void )
Creates an HTML document from the dom representation. This function 
usually is called after building a new dom document from scratch as in the 
example below. 
Example 1. Creating a simple HTML document header
  <?php
  $doc = domxml_new_doc("1.0");
  $root = $doc->create_element("HTML");
  $root = $doc->append_child($root);
  $head = $doc->create_element("HEAD");
  $head = $root->append_child($head);
  $title = $doc->create_element("TITLE");
  $title = $head->append_child($title);
  $text = $doc->create_text_node("This is the title");
  $text = $title->append_child($text);
  echo "<PRE>";
  echo htmlentities($doc->html_dump_mem());
  echo "</PRE>";
  ?> 
See also domdocument_dump_file(), domdocument_html_dump_mem().   DomDocument->get_elements_by_tagnameUpDomDocument->xinclude
DomDocument->xinclude
(no version information, might be only in CVS)
DomDocument->xinclude --  Substitutes XIncludes in a DomDocument Object. 
Description
int DomDocument->xinclude ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  DomDocument->html_dump_memUpDomDocumentType->entities
DomDocumentType->entities
(no version information, might be only in CVS)
DomDocumentType->entities --  Returns list of entities 
Description
array DomDocumentType->entities ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomDocument->xincludeUpDomDocumentType->internal_subset
DomDocumentType->internal_subset
(no version information, might be only in CVS)
DomDocumentType->internal_subset --  Returns internal subset 
Description
bool DomDocumentType->internal_subset ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomDocumentType->entitiesUpDomDocumentType->name
DomDocumentType->name
(no version information, might be only in CVS)
DomDocumentType->name --  Returns name of document type 
Description
string DomDocumentType->name ( void )
This function returns the name of the document type.   DomDocumentType->internal_subsetUpDomDocumentType->notations
DomDocumentType->notations
(no version information, might be only in CVS)
DomDocumentType->notations --  Returns list of notations 
Description
array DomDocumentType->notations ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomDocumentType->nameUpDomDocumentType->public_id
DomDocumentType->public_id
(no version information, might be only in CVS)
DomDocumentType->public_id --  Returns public id of document type 
Description
string DomDocumentType->public_id ( void )
This function returns the public id of the document type. 
The following example echos nothing. Example 1. Retrieving the 
public id
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $doctype = $dom->doctype();
  echo $doctype->public_id();
  ?> 

  DomDocumentType->notationsUpDomDocumentType->system_id
DomDocumentType->system_id
(no version information, might be only in CVS)
DomDocumentType->system_id --  Returns system id of document type 
Description
string DomDocumentType->system_id ( void )
Returns the system id of the document type. 
The following example echos 
'/share/sgml/Norman_Walsh/db3xml10/db3xml10.dtd'. Example 1. 
Retrieving the system id
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $doctype = $dom->doctype();
  echo $doctype->system_id();
  ?> 

  DomDocumentType->public_idUpDomElement->get_attribute_node
DomElement->get_attribute_node
(no version information, might be only in CVS)
DomElement->get_attribute_node --  Returns value of attribute 
Description
object DomElement->get_attribute_node ( object attr)
Warning
This function is currently not documented; only the argument list is 
available.
  DomDocumentType->system_idUpDomElement->get_attribute
DomElement->get_attribute
(no version information, might be only in CVS)
DomElement->get_attribute --  Returns value of attribute 
Description
object DomElement->get_attribute ( string name)
#

#T=array dns_get_record ( string hostname [, int type [, array &authns, array 
dns_get_record ( ^!string hostname [, int type [, array &authns, array ;
#

#T=Returns the attribute with name name of the current node.  - bool DomElement->get_elements_by_tagname ( string name)
(PHP >= 4.3 only) If no attribute with given name is found, an empty 
string is returned. 
See also domelement_set_attribute()   DomElement->get_attribute_nodeUpDomElement->get_elements_by_tagname
DomElement->get_elements_by_tagname
(no version information, might be only in CVS)
DomElement->get_elements_by_tagname --  Gets elements by tagname 
Description
bool DomElement->get_elements_by_tagname ( string name)
This function returns an array with all the elements which has name as his 
tagname. Every element of the array is an DomElement. 
Example 1. Getting a content
  <?php
  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $root = $dom->document_element();

  $node_array = $root->get_elements_by_tagname("element");

  for ($i = 0; $i<count($node_array); $i++) {
      $node = $node_array[$i];
      echo "The element[$i] is: " . $node->get_content();
  }

  ?> 

  DomElement->get_attributeUpDomElement->has_attribute
DomElement->has_attribute
(no version information, might be only in CVS)
DomElement->has_attribute --  Checks to see if attribute exists 
Description
bool DomElement->has_attribute ( string name)
Warning
This function is currently not documented; only the argument list is 
available.
  DomElement->get_elements_by_tagnameUpDomElement->remove_attribute
DomElement->remove_attribute
(no version information, might be only in CVS)
DomElement->remove_attribute --  Removes attribute 
Description
bool DomElement->remove_attribute ( string name)
Warning
This function is currently not documented; only the argument list is 
available.
  DomElement->has_attributeUpDomElement->set_attribute
DomElement->set_attribute
(no version information, might be only in CVS)
DomElement->set_attribute --  Adds new attribute 
Description
bool DomElement->set_attribute ( string name, string value)
Sets an attribute with name name to the given value. If the attribute does 
not exist, it will be created. 
Example 1. Setting an attribute
  <?php
  $doc = domxml_new_doc("1.0");
  $node = $doc->create_element("para");
  $newnode = $doc->append_child($node);
  $newnode->set_attribute("align", "left");
  ?> 
See also domelement_get_attribute()   DomElement->remove_attributeUpDomElement->tagname
DomElement->tagname
(no version information, might be only in CVS)
DomElement->tagname --  Returns name of element 
Description
string DomElement->tagname ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomElement->set_attributeUpDomNode->add_namespace
DomNode->add_namespace
(no version information, might be only in CVS)
DomNode->add_namespace --  Adds a namespace declaration to a node. 
Description
bool DomNode->add_namespace ( string uri, string prefix)
See also domdocument_create_element_ns(), domnode_set_namespace()   DomElement->tagnameUpDomNode->append_child
DomNode->append_child
(no version information, might be only in CVS)
DomNode->append_child --  Adds new child at the end of the children 
Description
object DomNode->append_child ( object newnode)
This functions appends a child to an existing list of children or creates 
a new list of children. The child can be created with e.g. 
domdocument_create_element(), domdocument_create_text() etc. or simply by 
#

#T=bool DomElement->get_elements_by_tagname ( string name)
DomElement->^!get_elements_by_tagname ( string name);
#

#T=using any other node.  - object DomNode->append_sibling ( object newnode)
(PHP < 4.3) Before a new child is appended it is first duplicated. 
Therefore the new child is a completely new copy which can be modified 
without changing the node which was passed to this function. If the node 
passed has children itself, they will be duplicated as well, which makes 
it quite easy to duplicate large parts of an XML document. The return 
value is the appended child. If you plan to do further modifications on 
#

#T=the appended child you must use the returned node.  - object DomNode->append_sibling ( object newnode)
(PHP 4.3.0/4.3.1) The new child newnode is first unlinked from its 
existing context, if it's already a child of DomNode. Therefore the node 
#

#T=is moved and not copies anymore.  - object DomNode->append_sibling ( object newnode)
(PHP >= 4.3.2) The new child newnode is first unlinked from its existing 
context, if it's already in the tree. Therefore the node is moved and not 
copied. This is the behaviour according to the W3C specifications. If you 
want to duplicate large parts of an XML document, use 
DomNode->clone_node() before appending. 
The following example will add a new element node to a fresh document and 
sets the attribute "align" to "left". Example 1. Adding a child
  <?php
  $doc = domxml_new_doc("1.0");
  $node = $doc->create_element("para");
  $newnode = $doc->append_child($node);
  $newnode->set_attribute("align", "left");
  ?> 

The above example could also be written as the following: Example 2. 
Adding a child
  <?php
  $doc = domxml_new_doc("1.0");
  $node = $doc->create_element("para");
  $node->set_attribute("align", "left");
  $newnode = $doc->append_child($node);
  ?> 

A more complex example is the one below. It first searches for a certain 
element, duplicates it including its children and adds it as a sibling. 
Finally a new attribute is added to one of the children of the new sibling 
and the whole document is dumped. Example 3. Adding a child
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $elements = $dom->get_elements_by_tagname("informaltable");
  print_r($elements);
  $element = $elements[0];

  $parent = $element->parent_node();
  $newnode = $parent->append_child($element);
  $children = $newnode->children();
  $attr = $children[1]->set_attribute("align", "left");

  echo "<pre>";
  $xmlfile = $dom->dump_mem();
  echo htmlentities($xmlfile);
  echo "</pre>";
  ?> 

The above example could also be done with domnode_insert_before() instead 
of domnode_append_child(). 
See also domnode_insert_before(), domnode_clone_node().   DomNode->add_namespaceUpDomNode->append_sibling
DomNode->append_sibling
(no version information, might be only in CVS)
DomNode->append_sibling --  Adds new sibling to a node 
Description
object DomNode->append_sibling ( object newnode)
This functions appends a sibling to an existing node. The child can be 
created with e.g. domdocument_create_element(), domdocument_create_text() 
etc. or simply by using any other node. 
Before a new sibling is added it is first duplicated. Therefore the new 
child is a completely new copy which can be modified without changing the 
node which was passed to this function. If the node passed has children 
itself, they will be duplicated as well, which makes it quite easy to 
duplicate large parts of an XML document. The return value is the added 
sibling. If you plan to do further modifications on the added sibling you 
must use the returned node. 
This function has been added to provide the behaviour of 
domnode_append_child() as it works till PHP 4.2. 
See also domnode_append_before().   DomNode->append_childUpDomNode->attributes
DomNode->attributes
(no version information, might be only in CVS)
DomNode->attributes --  Returns list of attributes 
Description
array DomNode->attributes ( void )
This function only returns an array of attributes if the node is of type 
#

#T=object DomNode->append_sibling ( object newnode)
DomNode->^!append_sibling ( object newnode);
#

#T=XML_ELEMENT_NODE.  - array DomNode->child_nodes ( void )
(PHP >= 4.3 only) If no attributes are found, NULL is returned.   DomNode->append_siblingUpDomNode->child_nodes
DomNode->child_nodes
(no version information, might be only in CVS)
DomNode->child_nodes --  Returns children of node 
Description
array DomNode->child_nodes ( void )
Returns all children of the node. 
See also domnode_next_sibling(), domnode_previous_sibling().   DomNode->attributesUpDomNode->clone_node
DomNode->clone_node
(no version information, might be only in CVS)
DomNode->clone_node --  Clones a node 
Description
object DomNode->clone_node ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomNode->child_nodesUpDomNode->dump_node
DomNode->dump_node
(no version information, might be only in CVS)
DomNode->dump_node --  Dumps a single node 
Description
string DomNode->dump_node ( void )
Warning
This function is currently not documented; only the argument list is 
available.

See also domdocument_dump_mem().   DomNode->clone_nodeUpDomNode->first_child
DomNode->first_child
(no version information, might be only in CVS)
DomNode->first_child --  Returns first child of node 
Description
object DomNode->first_child ( void )
#

#T=array DomNode->child_nodes ( void )
DomNode->^!child_nodes ( void );
#

#T=Returns the first child of the node.  - string DomNode->get_content ( void )
(PHP >= 4.3 only) If no first child is found, NULL is returned. 
See also domnode_last_child(), domnode_next_sibling(), 
domnode_previous_sibling().   DomNode->dump_nodeUpDomNode->get_content
DomNode->get_content
(no version information, might be only in CVS)
DomNode->get_content --  Gets content of node 
Description
string DomNode->get_content ( void )
This function returns the content of the actual node. 
Example 1. Getting a content
  <?php
  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $root = $dom->document_element();

  $node_array = $root->get_elements_by_tagname("element");

  for ($i = 0; $i<count($node_array); $i++) {
      $node = $node_array[$i];
      echo "The element[$i] is: " . $node->get_content();
  }

  ?> 

  DomNode->first_childUpDomNode->has_attributes
DomNode->has_attributes
(no version information, might be only in CVS)
DomNode->has_attributes --  Checks if node has attributes 
Description
bool DomNode->has_attributes ( void )
This function checks if the node has attributes. 
See also domnode_has_child_nodes().   DomNode->get_contentUpDomNode->has_child_nodes
DomNode->has_child_nodes
(no version information, might be only in CVS)
DomNode->has_child_nodes --  Checks if node has children 
Description
bool DomNode->has_child_nodes ( void )
This function checks if the node has children. 
See also domnode_child_nodes().   DomNode->has_attributesUpDomNode->insert_before
DomNode->insert_before
(no version information, might be only in CVS)
DomNode->insert_before --  Inserts new node as child 
Description
object DomNode->insert_before ( object newnode, object refnode)
This function inserts the new node newnode right before the node refnode. 
The return value is the inserted node. If you plan to do further 
#

#T=string DomNode->get_content ( void )
DomNode->^!get_content ( void );
#

#T=modifications on the appended child you must use the returned node.  - bool DomNode->is_blank_node ( void )
(PHP >= 4.3 only) If newnode already is part of a document, it will be 
first unlinked from its existing context. If refnode is NULL, then newnode 
will be inserted at the end of the list of children. 
domnode_insert_before() is very similar to domnode_append_child() as the 
following example shows which does the same as the example at 
domnode_append_child(). 
Example 1. Adding a child
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $elements = $dom->get_elements_by_tagname("informaltable");
  print_r($elements);
  $element = $elements[0];

  $newnode = $element->insert_before($element, $element);
  $children = $newnode->children();
  $attr = $children[1]->set_attribute("align", "left");

  echo "<PRE>";
  $xmlfile = $dom->dump_mem();
  echo htmlentities($xmlfile);
  echo "</PRE>";
  ?> 
See also domnode_append_child().   DomNode->has_child_nodesUpDomNode->is_blank_node
DomNode->is_blank_node
(no version information, might be only in CVS)
DomNode->is_blank_node --  Checks if node is blank 
Description
bool DomNode->is_blank_node ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomNode->insert_beforeUpDomNode->last_child
DomNode->last_child
(no version information, might be only in CVS)
DomNode->last_child --  Returns last child of node 
Description
object DomNode->last_child ( void )
#

#T=bool DomNode->is_blank_node ( void )
DomNode->^!is_blank_node ( void );
#

#T=Returns the last child of the node.  - object DomNode->next_sibling ( void )
(PHP >= 4.3 only) If no last child is found, NULL is returned. 
See also domnode_first_child(), domnode_next_sibling(), 
domnode_previous_sibling().   DomNode->is_blank_nodeUpDomNode->next_sibling
DomNode->next_sibling
(no version information, might be only in CVS)
DomNode->next_sibling --  Returns the next sibling of node 
Description
object DomNode->next_sibling ( void )
This function returns the next sibling of the current node. If there is no 
next sibling it returns FALSE (< 4.3) or null (>= 4.3). You can use this 
function to iterate over all children of a node as shown in the example. 
Example 1. Iterate over children
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $elements = $dom->get_elements_by_tagname("tbody");
  $element = $elements[0];
  $child = $element->first_child();

  while ($child) {
     print_r($child);
     $child = $child->next_sibling();
  }
  ?> 
See also domnode_previous_sibling().   DomNode->last_childUpDomNode->node_name
DomNode->node_name
(no version information, might be only in CVS)
DomNode->node_name --  Returns name of node 
Description
string DomNode->node_name ( void )
Returns name of the node. The name has different meanings for the 
different types of nodes as illustrated in the following table. 
Table 1. Meaning of value
TypeMeaning
DomAttributevalue of attribute
DomAttribute 
DomCDataSection#cdata-section
DomComment#comment
DomDocument#document
DomDocumentTypedocument type name
DomElementtag name
DomEntityname of entity
DomEntityReferencename of entity reference
DomNotationnotation name
DomProcessingInstructiontarget
DomText#text
  DomNode->next_siblingUpDomNode->node_type
DomNode->node_type
(no version information, might be only in CVS)
DomNode->node_type --  Returns type of node 
Description
int DomNode->node_type ( void )
Returns the type of the node. All possible types are listed in the table 
in the introduction.   DomNode->node_nameUpDomNode->node_value
DomNode->node_value
(no version information, might be only in CVS)
DomNode->node_value --  Returns value of a node 
Description
string DomNode->node_value ( void )
Returns value of the node. The value has different meanings for the 
different types of nodes as illustrated in the following table. 
Table 1. Meaning of value
TypeMeaning
DomAttributevalue of attribute
DomAttribute 
DomCDataSectioncontent
DomCommentcontent of comment
DomDocumentnull
DomDocumentTypenull
DomElementnull
DomEntitynull
DomEntityReferencenull
DomNotationnull
DomProcessingInstructionentire content without target
DomTextcontent of text
  DomNode->node_typeUpDomNode->owner_document
DomNode->owner_document
(no version information, might be only in CVS)
DomNode->owner_document --  Returns the document this node belongs to 
Description
object DomNode->owner_document ( void )
This function returns the document the current node belongs to. 
The following example will create two identical lists of children. 
Example 1. Finding the document of a node
  <?php
  $doc = domxml_new_doc("1.0");
  $node = $doc->create_element("para");
  $node = $doc->append_child($node);
  $children = $doc->children();
  print_r($children);

  $doc2 = $node->owner_document();
  $children = $doc2->children();
  print_r($children);
  ?> 
See also domnode_insert_before().   DomNode->node_valueUpDomNode->parent_node
DomNode->parent_node
(no version information, might be only in CVS)
DomNode->parent_node --  Returns the parent of the node 
Description
object DomNode->parent_node ( void )
#

#T=object DomNode->next_sibling ( void )
DomNode->^!next_sibling ( void );
#

#T=This function returns the parent node.  - string DomNode->prefix ( void )
(PHP >= 4.3 only) If no parent is found, NULL is returned. 
The following example will show two identical lists of children. 
Example 1. Finding the document of a node
  <?php
  $doc = domxml_new_doc("1.0");
  $node = $doc->create_element("para");
  $node = $doc->append_child($node);
  $children = $doc->children();
  print_r($children);

  $doc2 = $node->parent_node();
  $children = $doc2->children();
  print_r($children);
  ?> 

  DomNode->owner_documentUpDomNode->prefix
DomNode->prefix
(no version information, might be only in CVS)
DomNode->prefix --  Returns name space prefix of node 
Description
string DomNode->prefix ( void )
Returns the name space prefix of the node.   DomNode->parent_nodeUpDomNode->previous_sibling
DomNode->previous_sibling
(no version information, might be only in CVS)
DomNode->previous_sibling --  Returns the previous sibling of node 
Description
object DomNode->previous_sibling ( void )
This function returns the previous sibling of the current node. If there 
is no previous sibling it returns FALSE (< 4.3) or NULL (>= 4.3). You can 
use this function to iterate over all children of a node as shown in the 
example. 
See also domnode_next_sibling().   DomNode->prefixUpDomNode->remove_child
DomNode->remove_child
(no version information, might be only in CVS)
DomNode->remove_child --  Removes child from list of children 
Description
object DomNode->remove_child ( object oldchild)
This functions removes a child from a list of children. If child cannot be 
removed or is not a child the function will return FALSE. If the child 
could be removed the functions returns the old child. 
Example 1. Removing a child
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $elements = $dom->get_elements_by_tagname("tbody");
  $element = $elements[0];
  $children = $element->child_nodes();
  $child = $element->remove_child($children[0]);

  echo "<PRE>";
  $xmlfile = $dom->dump_mem(true);
  echo htmlentities($xmlfile);
  echo "</PRE>";
  ?> 
See also domnode_append_child().   DomNode->previous_siblingUpDomNode->replace_child
DomNode->replace_child
(no version information, might be only in CVS)
DomNode->replace_child --  Replaces a child 
Description
object DomNode->replace_child ( object oldnode, object newnode)

#

#T=string DomNode->prefix ( void )
DomNode->^!prefix ( void );
#

#T= - object DomNode->replace_node ( object newnode)
(PHP 4.2) This function replaces the child oldnode with the passed new 
node. If the new node is already a child it will not be added a second 
time. If the old node cannot be found the function returns FALSE. If the 
#

#T=replacement succeeds the old node is returned.  - object DomNode->replace_node ( object newnode)
(PHP 4.3) This function replaces the child oldnode with the passed 
newnode, even if the new node already is a child of the DomNode. If 
newnode was already inserted in the document it is first unlinked from its 
existing context. If the old node cannot be found the function returns 
FALSE. If the replacement succeeds the old node is returned. (This 
behaviour is according to the W3C specs). 
See also domnode_append_child()   DomNode->remove_childUpDomNode->replace_node
DomNode->replace_node
(no version information, might be only in CVS)
DomNode->replace_node --  Replaces node 
Description
object DomNode->replace_node ( object newnode)

#

#T=object DomNode->replace_node ( object newnode)
DomNode->^!replace_node ( object newnode);
#

#T= - bool DomNode->set_content ( void )
(PHP 4.2) This function replaces an existing node with the passed new 
node. Before the replacement newnode is copied if it has a parent to make 
sure a node which is already in the document will not be inserted a second 
time. This behaviour enforces doing all modifications on the node before 
the replacement or to refetch the inserted node afterwards with functions 
#

#T=like domnode_first_child(), domnode_child_nodes() etc..  - bool DomNode->set_content ( void )
(PHP 4.3) This function replaces an existing node with the passed new 
node. It is not copied anymore. If newnode was already inserted in the 
document it is first unlinked from its existing context. If the 
replacement succeeds the old node is returned. 
See also domnode_append_child()   DomNode->replace_childUpDomNode->set_content
DomNode->set_content
(no version information, might be only in CVS)
DomNode->set_content --  Sets content of node 
Description
bool DomNode->set_content ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomNode->replace_nodeUpDomNode->set_name
DomNode->set_name
(no version information, might be only in CVS)
DomNode->set_name --  Sets name of node 
Description
bool DomNode->set_name ( void )
Sets name of node. 
See also domnode_node_name().   DomNode->set_contentUpDomNode->set_namespace
DomNode->set_namespace
(no version information, might be only in CVS)
DomNode->set_namespace --  Sets namespace of a node. 
Description
void DomNode->set_namespace ( string uri [, string prefix])
Sets the namespace of a node to uri. If there is already a namespace 
declaration with the same uri in one of the parent nodes of the node, the 
prefix of this is taken, otherwise it will take the one provided in the 
optional parameter prefix or generate a random one. 
See also domdocument_create_element_ns(), domnode_add_namespace()   DomNode->set_nameUpDomNode->unlink_node
DomNode->unlink_node
(no version information, might be only in CVS)
DomNode->unlink_node --  Deletes node 
Description
object DomNode->unlink_node ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomNode->set_namespaceUpDomProcessingInstruction->data
DomProcessingInstruction->data
(no version information, might be only in CVS)
DomProcessingInstruction->data --  Returns data of pi node 
Description
string DomProcessingInstruction->data ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomNode->unlink_nodeUpDomProcessingInstruction->target
DomProcessingInstruction->target
(no version information, might be only in CVS)
DomProcessingInstruction->target --  Returns target of pi node 
Description
string DomProcessingInstruction->target ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  DomProcessingInstruction->dataUpDomXsltStylesheet->process
#

#T=bool DomNode->set_content ( void )
DomNode->^!set_content ( void );
#

#T=domxml_new_doc - object domxml_new_doc ( string version)
(PHP 4 >= 4.2.1)
domxml_new_doc --  Creates new empty XML document 
Description
object domxml_new_doc ( string version)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Creates a new dom document from scratch and returns it. 
See also domdocument_add_root()   DomXsltStylesheet->result_dump_memUpdomxml_open_file
#

#T=object domxml_new_doc ( string version)
domxml_new_doc ( ^!string version);
#

#T=domxml_open_file - object domxml_open_file ( string filename)
(PHP 4 >= 4.2.1)
domxml_open_file -- Creates a DOM object from XML file
Description
object domxml_open_file ( string filename)
The function parses the XML document in the file named filename and 
returns an object of class "Dom document", having the properties as listed 
above. The file is accessed read-only. 
Example 1. Opening an XML document from a file
  <?php

  if (!$dom = domxml_open_file("example.xml")) {
    echo "Error while parsing the document\n";
    exit;
  }

  $root = $dom->document_element();
  ?> 
See also domxml_open_mem(), domxml_new_doc().   domxml_new_docUpdomxml_open_mem
#

#T=object domxml_open_file ( string filename)
domxml_open_file ( ^!string filename);
#

#T=domxml_open_mem - object domxml_open_mem ( string str)
(PHP 4 >= 4.2.1)
domxml_open_mem -- Creates a DOM object of an XML document
Description
object domxml_open_mem ( string str)
The function parses the XML document in str and returns an object of class 
"Dom document", having the properties as listed above. This function, 
domxml_open_file() or domxml_new_doc() must be called before any other 
function calls. 
Example 1. Opening an XML document in a string
  <?php
  include("example.inc");

  if (!$dom = domxml_open_mem($xmlstr)) {
    echo "Error while parsing the document\n";
    exit;
  }

  $root = $dom->document_element();
  ?> 
See also domxml_open_file(), domxml_new_doc().   domxml_open_fileUpdomxml_version
#

#T=object domxml_open_mem ( string str)
domxml_open_mem ( ^!string str);
#

#T=domxml_version - string domxml_version ( void )
(PHP 4 >= 4.1.0)
domxml_version --  Get XML library version 
Description
string domxml_version ( void )
This function returns the version of the XML library version currently 
used.   domxml_open_memUpdomxml_xmltree
#

#T=string domxml_version ( void )
domxml_version ( ^!void );
#

#T=domxml_xmltree - object domxml_xmltree ( string str)
(PHP 4 >= 4.2.1)
domxml_xmltree --  Creates a tree of PHP objects from an XML document 
Description
object domxml_xmltree ( string str)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function parses the XML document in str and returns a tree PHP objects 
as the parsed document. This function is isolated from the other 
functions, which means you cannot access the tree with any of the other 
functions. Modifying it, for example by adding nodes, makes no sense since 
there is currently no way to dump it as an XML file. However this function 
may be valuable if you want to read a file and investigate the content.   domxml_versionUpdomxml_xslt_stylesheet_doc
#

#T=object domxml_xmltree ( string str)
domxml_xmltree ( ^!string str);
#

#T=domxml_xslt_stylesheet_doc - object domxml_xslt_stylesheet_doc ( object DocDocument Object)
(PHP 4 >= 4.2.0)
domxml_xslt_stylesheet_doc --  Creates a DomXsltStylesheet Object from a 
DomDocument Object. 
Description
object domxml_xslt_stylesheet_doc ( object DocDocument Object)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

See also domxsltstylesheet->process(), domxml_xslt_stylesheet(), 
domxml_xslt_stylesheet_file()   domxml_xmltreeUpdomxml_xslt_stylesheet_file
#

#T=object domxml_xslt_stylesheet_doc ( object DocDocument Object)
domxml_xslt_stylesheet_doc ( ^!object DocDocument Object);
#

#T=domxml_xslt_stylesheet_file - object domxml_xslt_stylesheet_file ( string xsl file)
(PHP 4 >= 4.2.0)
domxml_xslt_stylesheet_file --  Creates a DomXsltStylesheet Object from an 
XSL document in a file. 
Description
object domxml_xslt_stylesheet_file ( string xsl file)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

See also domxsltstylesheet->process(), domxml_xslt_stylesheet(), 
domxml_xslt_stylesheet_doc()   domxml_xslt_stylesheet_docUpdomxml_xslt_stylesheet
#

#T=object domxml_xslt_stylesheet_file ( string xsl file)
domxml_xslt_stylesheet_file ( ^!string xsl file);
#

#T=domxml_xslt_stylesheet - object domxml_xslt_stylesheet ( string xsl document)
(PHP 4 >= 4.2.0)
domxml_xslt_stylesheet --  Creates a DomXsltStylesheet Object from an XML 
document in a string. 
Description
object domxml_xslt_stylesheet ( string xsl document)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

See also domxsltstylesheet->process(), domxml_xslt_stylesheet_file(), 
domxml_xslt_stylesheet_doc()   domxml_xslt_stylesheet_fileUpxpath_eval_expression
DomXsltStylesheet->process
(no version information, might be only in CVS)
DomXsltStylesheet->process --  Applies the XSLT-Transformation on a 
DomDocument Object. 
Description
object DomXsltStylesheet->process ( object DomDocument [, array 
xslt_parameters [, bool param_is_xpath]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

See also domxml_xslt_stylesheet(), domxml_xslt_stylesheet_file(), 
domxml_xslt_stylesheet_doc()   DomProcessingInstruction->targetUpDomXsltStylesheet->result_dump_file
DomXsltStylesheet->result_dump_file
(no version information, might be only in CVS)
DomXsltStylesheet->result_dump_file --  Dumps the result from a 
XSLT-Transformation into a file 
Description
string DomXsltStylesheet->result_dump_file ( object DomDocument, string 
filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function is only available since PHP 4.3 
Since DomXsltStylesheet->process() always returns a well-formed XML 
DomDocument, no matter what output method was declared in <xsl:output> and 
similar attributes/elements, it's of not much use, if you want to output 
HTML 4 or text data. This function on the contrary honors <xsl:output 
method="html|text"> and other output control directives. See the example 
for instruction of how to use it. 
Example 1. Saving the result of a XSLT transformation in a file
  <?php
  $filename = "stylesheet.xsl";
  $xmldoc = domxml_open_file("data.xml");
  $xsldoc = domxml_xslt_stylesheet_file($filename);
  $result =  $xsldoc->process($xmldoc);
  echo $xsldoc->result_dump_file($result, "filename");     
  ?> 
See also domxml_xslt_result_dump_mem(), domxml_xslt_process()   DomXsltStylesheet->processUpDomXsltStylesheet->result_dump_mem
DomXsltStylesheet->result_dump_mem
(no version information, might be only in CVS)
DomXsltStylesheet->result_dump_mem --  Dumps the result from a 
XSLT-Transformation back into a string 
Description
string DomXsltStylesheet->result_dump_mem ( object DomDocument)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function is only available since PHP 4.3 
Since DomXsltStylesheet->process() always returns a well-formed XML 
DomDocument, no matter what output method was declared in <xsl:output> and 
similar attributes/elements, it's of not much use, if you want to output 
HTML 4 or text data. This function on the contrary honors <xsl:output 
method="html|text"> and other output control directives. See the example 
for instruction of how to use it. 
Example 1. Outputting the result of a XSLT transformation
  <?php
  $filename = "stylesheet.xsl";
  $xmldoc = domxml_open_file("data.xml");
  $xsldoc = domxml_xslt_stylesheet_file($filename);
  $result =  $xsldoc->process($xmldoc);
  echo $xsldoc->result_dump_mem($result);     
  ?> 
See also domxml_xslt_result_dump_file(), domxml_xslt_process()   DomXsltStylesheet->result_dump_fileUpdomxml_new_doc
dotnet_load
(no version information, might be only in CVS)
dotnet_load -- Loads a DOTNET module
Description
int dotnet_load ( string assembly_name [, string datatype_name [, int 
codepage]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  .NET functionsUpError Handling and Logging Functions
doubleval
doubleval -- Alias of floatval()
Description
This function is an alias of floatval(). 
Note: This alias is a left-over from a function-renaming. In older 
versions of PHP you'll need to use this alias of the floatval() 
function, because floatval() wasn't yet available in that version.   Variable FunctionsUpempty
#

#T=object domxml_xslt_stylesheet ( string xsl document)
domxml_xslt_stylesheet ( ^!string xsl document);
#

#T=each - array each ( array array)
(PHP 3, PHP 4 )
each --  Return the current key and value pair from an array and advance 
the array cursor 
Description
array each ( array array)
Returns the current key and value pair from the array array and advances 
the array cursor. This pair is returned in a four-element array, with the 
keys 0, 1, key, and value. Elements 0 and key contain the key name of the 
array element, and 1 and value contain the data. 
If the internal pointer for the array points past the end of the array 
contents, each() returns FALSE. 
Example 1. each() examples
  <?php
  $foo = array("bob", "fred", "jussi", "jouni", "egon", 
  "marliese");
  $bar = each($foo);
  print_r($bar);
  ?> 

$bar now contains the following key/value pairs: 
Array
(
[1] => bob
[value] => bob
[0] => 0
[key] => 0
)
<?php
$foo = array("Robert" => "Bob", "Seppo" => "Sepi");
$bar = each($foo);
print_r($bar);
?> 

$bar now contains the following key/value pairs: 
Array
(
[1] => Bob
[value] => Bob
[0] => Robert
[key] => Robert
)

each() is typically used in conjunction with list() to traverse an array, 
here's an example: Example 2. Traversing an array with each()
  <?php
  $fruit = array('a' => 'apple', 'b' => 'banana', 'c' => 
  'cranberry');

  reset($fruit);
  while (list($key, $val) = each($fruit)) {
      echo "$key => $val\n";
  }
  ?> 

Outputs: 
a => apple
b => banana
c => cranberry
After each() has executed, the array cursor will be left on the next 
element of the array, or past the last element if it hits the end of the 
array. You have to use reset() if you want to traverse the array again 
using each. 
Caution
Because assigning an array to another variable resets the original 
arrays pointer, our example above would cause an endless loop had we 
assigned $fruit to another variable inside the loop. 

See also key(), list(), current(), reset(), next(), prev(), and foreach.   currentUpend
#

#T=array each ( array array)
each ( ^!array array);
#

#T=easter_date - int easter_date ( [int year])
(PHP 3>= 3.0.9, PHP 4 )
easter_date --  Get Unix timestamp for midnight on Easter of a given year 
Description
int easter_date ( [int year])
Returns the Unix timestamp corresponding to midnight on Easter of the 
given year. 
Since PHP 4.3.0, the year parameter is optional and defaults to the 
current year according to the localtime if omitted. 
Example 1. easter_date() example
  <?php

  echo date("M-d-Y", easter_date(1999));        // Apr-04-1999
  echo date("M-d-Y", easter_date(2000));        // Apr-23-2000
  echo date("M-d-Y", easter_date(2001));        // Apr-15-2001

  ?> 
Warning
This function will generate a warning if the year is outside of the 
range for Unix timestamps (i.e. before 1970 or after 2037). 

The date of Easter Day was defined by the Council of Nicaea in AD325 as 
the Sunday after the first full moon which falls on or after the Spring 
Equinox. The Equinox is assumed to always fall on 21st March, so the 
calculation reduces to determining the date of the full moon and the date 
of the following Sunday. The algorithm used here was introduced around the 
year 532 by Dionysius Exiguus. Under the Julian Calendar (for years before 
1753) a simple 19-year cycle is used to track the phases of the Moon. 
Under the Gregorian Calendar (for years after 1753 - devised by Clavius 
and Lilius, and introduced by Pope Gregory XIII in October 1582, and into 
Britain and its then colonies in September 1752) two correction factors 
are added to make the cycle more accurate. 
(The code is based on a C program by Simon Kershaw, <webmaster at 
ely.anglican dot org>) 
See easter_days() for calculating Easter before 1970 or after 2037.   cal_to_jdUpeaster_days
#

#T=int easter_date ( [int year])
easter_date ( ^![int year]);
#

#T=easter_days - int easter_days ( [int year [, int method]])
(PHP 3>= 3.0.9, PHP 4 )
easter_days --  Get number of days after March 21 on which Easter falls 
for a given year 
Description
int easter_days ( [int year [, int method]])
Returns the number of days after March 21 on which Easter falls for a 
given year. If no year is specified, the current year is assumed. 
Since PHP 4.3.0, the year parameter is optional and defaults to the 
current year according to the localtime if omitted. 
The method parameter was also introduced in PHP 4.3.0 and allows to 
calculate easter dates based on the Gregorian calendar during the years 
1582 - 1752 when set to CAL_EASTER_ROMAN. See the calendar constants for 
more valid constants. 
This function can be used instead of easter_date() to calculate Easter for 
years which fall outside the range of Unix timestamps (i.e. before 1970 or 
after 2037). Example 1. easter_days() example
  <?php

  echo easter_days(1999);        // 14, i.e. April 4
  echo easter_days(1492);        // 32, i.e. April 22
  echo easter_days(1913);        //  2, i.e. March 23

  ?> 
The date of Easter Day was defined by the Council of Nicaea in AD325 as 
the Sunday after the first full moon which falls on or after the Spring 
Equinox. The Equinox is assumed to always fall on 21st March, so the 
calculation reduces to determining the date of the full moon and the date 
of the following Sunday. The algorithm used here was introduced around the 
year 532 by Dionysius Exiguus. Under the Julian Calendar (for years before 
1753) a simple 19-year cycle is used to track the phases of the Moon. 
Under the Gregorian Calendar (for years after 1753 - devised by Clavius 
and Lilius, and introduced by Pope Gregory XIII in October 1582, and into 
Britain and its then colonies in September 1752) two correction factors 
are added to make the cycle more accurate. 
(The code is based on a C program by Simon Kershaw, <webmaster at 
ely.anglican dot org>) 
See also easter_date().   easter_dateUpFrenchToJD
#

#T=int easter_days ( [int year [, int method]])
easter_days ( ^![int year [, int method]]);
#

#T=ebcdic2ascii - int ebcdic2ascii ( string ebcdic_str)
(PHP 3>= 3.0.17)
ebcdic2ascii -- Translate string from EBCDIC to ASCII
Description
int ebcdic2ascii ( string ebcdic_str)
ebcdic2ascii() is an Apache-specific function which is available only on 
EBCDIC based operating systems (OS/390, BS2000). It translates the EBCDIC 
encoded string ebcdic_str to its equivalent ASCII representation (binary 
safe), and returns the result. 
See also the reverse function ascii2ebcdic()   ascii2ebcdicUpgetallheaders
#

#T=int ebcdic2ascii ( string ebcdic_str)
ebcdic2ascii ( ^!string ebcdic_str);
#

#T=echo - void echo ( string arg1 [, string argn...])
(PHP 3, PHP 4 )
echo -- Output one or more strings
Description
void echo ( string arg1 [, string argn...])
Outputs all parameters. 
echo() is not actually a function (it is a language construct) so you are 
not required to use parentheses with it. In fact, if you want to pass more 
than one parameter to echo, you must not enclose the parameters within 
parentheses. 
Example 1. echo() examples
  <?php
  echo "Hello World";

  echo "This spans
  multiple lines. The newlines will be 
  output as well";

  echo "This spans\nmultiple lines. The newlines will be\noutput 
  as well.";

  echo "Escaping characters is done \"Like this\".";

  // You can use variables inside of an echo statement
  $foo = "foobar";
  $bar = "barbaz";

  echo "foo is $foo"; // foo is foobar

  // You can also use arrays
  $bar = array("value" => "foo");

  echo "this is {$bar['value']} !"; // this is foo !

  // Using single quotes will print the variable name, not the 
  value
  echo 'foo is $foo'; // foo is $foo

  // If you are not using any other characters, you can just 
  echo variables
  echo $foo;          // foobar
  echo $foo,$bar;     // foobarbarbaz

  // Some people prefer passing multiple parameters to echo over 
  concatenation.
  echo 'This ', 'string ', 'was ', 'made ', 'with multiple 
  parameters.', chr(10);
  echo 'This ' . 'string ' . 'was ' . 'made ' . 'with 
  concatenation.' . "\n";

  echo <<<END
  This uses the "here document" syntax to output
  multiple lines with $variable interpolation. Note
  that the here document terminator must appear on a
  line with just a semicolon. no extra whitespace!
  END;

  // Because echo is not a function, following code is invalid. 
  ($some_var) ? echo 'true' : echo 'false';

  // However, the following examples will work:
  ($some_var) ? print('true'): print('false'); // print is a 
  function
  echo $some_var ? 'true': 'false'; // changing the statement 
  around
  ?> 
echo() also has a shortcut syntax, where you can immediately follow the 
opening tag with an equals sign. This short syntax only works with the 
short_open_tag configuration setting enabled. 
I have <?=$foo?> foo. 

For a short discussion about the differences between print() and echo(), 
see this FAQTs Knowledge Base Article: 
http://www.faqts.com/knowledge_base/view.phtml/aid/1/fid/40 
Note: Because this is a language construct and not a function, it cannot 
be called using variable functions
See also print(), printf(), and flush().   cryptUpexplode
#

#T=void echo ( string arg1 [, string argn...])
echo ( ^!string arg1 [, string argn...]);
#

#T=empty - bool empty ( mixed var)
(PHP 3, PHP 4 )
empty -- Determine whether a variable is empty
Description
bool empty ( mixed var)
empty() returns FALSE if var has a non-empty or non-zero value. In 
otherwords, "", 0, "0", NULL, FALSE, array(), var $var;, and objects with 
empty properties, are all considered empty. TRUE is returned if var is 
empty. 
empty() is the opposite of (boolean) var, except that no warning is 
generated when the variable is not set. See converting to boolean for more 
information. 
Example 1. A simple empty() / isset() comparison. 
  <?php
  $var = 0;

  // Evaluates to true because $var is empty
  if (empty($var)) {
      echo '$var is either 0, empty, or not set at all';
  }

  // Evaluates as true because $var is set
  if (isset($var)) {
      echo '$var is set even though it is empty';
  }
  ?> 
Note: Because this is a language construct and not a function, it cannot 
be called using variable functions
Note: empty() only checks variables as anything else will result in a 
parse error. In otherwords, the following will not work: 
empty(addslashes($name)). 
See also isset(), unset(), array_key_exists(), count(), strlen(), and the 
type comparison tables.   doublevalUpfloatval
#

#T=bool empty ( mixed var)
empty ( ^!mixed var);
#

#T=end - mixed end ( array array)
(PHP 3, PHP 4 )
end --  Set the internal pointer of an array to its last element 
Description
mixed end ( array array)
end() advances array's internal pointer to the last element, and returns 
the value from the last element. 
Example 1. A simple end() example
  <?php

    $fruits = array('apple', 'banana', 'cranberry');
      
    echo end($fruits); // cranberry
	
  ?> 
See also current(), each(), prev(), next() and reset().   eachUpextract
#

#T=mixed end ( array array)
end ( ^!array array);
#

#T=ereg_replace - string ereg_replace ( string pattern, string replacement, string string)
(PHP 3, PHP 4 )
ereg_replace -- Replace regular expression
Description
string ereg_replace ( string pattern, string replacement, string string)
This function scans string for matches to pattern, then replaces the 
matched text with replacement. 
The modified string is returned. (Which may mean that the original string 
is returned if there are no matches to be replaced.) 
If pattern contains parenthesized substrings, replacement may contain 
substrings of the form \\digit, which will be replaced by the text 
matching the digit'th parenthesized substring; \\0 will produce the entire 
contents of string. Up to nine substrings may be used. Parentheses may be 
nested, in which case they are counted by the opening parenthesis. 
If no matches are found in string, then string will be returned unchanged. 

For example, the following code snippet prints "This was a test" three 
times: 
Example 1. ereg_replace() example
  <?php

  $string = "This is a test";
  echo str_replace(" is", " was", $string);
  echo ereg_replace("( )is", "\\1was", $string);
  echo ereg_replace("(( )is)", "\\2was", $string);

  ?> 
One thing to take note of is that if you use an integer value as the 
replacement parameter, you may not get the results you expect. This is 
because ereg_replace() will interpret the number as the ordinal value of a 
character, and apply that. For instance: 
Example 2. ereg_replace() example
  <?php
  /* This will not work as expected. */
  $num = 4;
  $string = "This string has four words.";
  $string = ereg_replace('four', $num, $string);
  echo $string;   /* Output: 'This string has   words.' */

  /* This will work. */
  $num = '4';
  $string = "This string has four words.";
  $string = ereg_replace('four', $num, $string);
  echo $string;   /* Output: 'This string has 4 words.' */
  ?> 
Example 3. Replace URLs with links
  <?php
  $text = 
  ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]",
		       "<a href=\"\\0\">\\0</a>", $text);
  ?> 
Tip: preg_replace(), which uses a Perl-compatible regular expression 
syntax, is often a faster alternative to ereg_replace(). 
See also ereg(), eregi(), eregi_replace(), str_replace(), and 
preg_match().   Regular Expression Functions (POSIX Extended)Upereg
#

#T=string ereg_replace ( string pattern, string replacement, string string)
ereg_replace ( ^!string pattern, string replacement, string string);
#

#T=ereg - bool ereg ( string pattern, string string [, array regs])
(PHP 3, PHP 4 )
ereg -- Regular expression match
Description
bool ereg ( string pattern, string string [, array regs])
Note: preg_match(), which uses a Perl-compatible regular expression 
syntax, is often a faster alternative to ereg(). 
Searches a string for matches to the regular expression given in pattern 
in a case-sensitive way. 
If matches are found for parenthesized substrings of pattern and the 
function is called with the third argument regs, the matches will be 
stored in the elements of the array regs. $regs[1] will contain the 
substring which starts at the first left parenthesis; $regs[2] will 
contain the substring starting at the second, and so on. $regs[0] will 
contain a copy of the complete string matched. 
Note: Up to (and including) PHP 4.1.0 $regs will be filled with exactly 
ten elements, even though more or fewer than ten parenthesized 
substrings may actually have matched. This has no effect on ereg()'s 
ability to match more substrings. If no matches are found, $regs will 
not be altered by ereg(). 
Returns TRUE if a match for pattern was found in string, or FALSE if no 
matches were found or an error occurred. 
The following code snippet takes a date in ISO format (YYYY-MM-DD) and 
prints it in DD.MM.YYYY format: 
Example 1. ereg() example
  <?php
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $date, 
  $regs)) {
      echo "$regs[3].$regs[2].$regs[1]";
  } else {
      echo "Invalid date format: $date";
  }
  ?> 
See also eregi(), ereg_replace(), eregi_replace(), preg_match(), strpos(), 
and strstr().   ereg_replaceUperegi_replace
#

#T=bool ereg ( string pattern, string string [, array regs])
ereg ( ^!string pattern, string string [, array regs]);
#

#T=eregi_replace - string eregi_replace ( string pattern, string replacement, string string)
(PHP 3, PHP 4 )
eregi_replace -- replace regular expression case insensitive
Description
string eregi_replace ( string pattern, string replacement, string string)
This function is identical to ereg_replace() except that this ignores case 
distinction when matching alphabetic characters. 
See also ereg(), eregi(), and ereg_replace().   eregUperegi
#

#T=string eregi_replace ( string pattern, string replacement, string string)
eregi_replace ( ^!string pattern, string replacement, string string);
#

#T=eregi - bool eregi ( string pattern, string string [, array regs])
(PHP 3, PHP 4 )
eregi -- case insensitive regular expression match
Description
bool eregi ( string pattern, string string [, array regs])
This function is identical to ereg() except that this ignores case 
distinction when matching alphabetic characters. 
Example 1. eregi() example
  <?php
  if (eregi("z", $string)) {
      echo "'$string' contains a 'z' or 'Z'!";
  }
  ?> 
See also ereg(), ereg_replace(), eregi_replace(), stripos(), and 
stristr().   eregi_replaceUpsplit
#

#T=bool eregi ( string pattern, string string [, array regs])
eregi ( ^!string pattern, string string [, array regs]);
#

#T=error_log - int error_log ( string message [, int message_type [, string destination 
(PHP 3, PHP 4 )
error_log -- Send an error message somewhere
Description
int error_log ( string message [, int message_type [, string destination 
[, string extra_headers]]])
Sends an error message to the web server's error log, a TCP port or to a 
file. The first parameter, message, is the error message that should be 
logged. The second parameter, message_type says where the message should 
go: 
Table 1. error_log() log types
0message is sent to PHP's system logger, using the Operating 
System's system logging mechanism or a file, depending on what the 
error_log configuration directive is set to. 
1message is sent by email to the address in the destination 
parameter. This is the only message type where the fourth parameter, 
extra_headers is used. This message type uses the same internal 
function as mail() does. 
2message is sent through the PHP debugging connection. This option 
is only available if remote debugging has been enabled. In this 
case, the destination parameter specifies the host name or IP 
address and optionally, port number, of the socket receiving the 
debug information. 
3message is appended to the file destination. 

Warning
Remote debugging via TCP/IP is a PHP 3 feature that is not available 
in PHP 4. 

Example 1. error_log() examples
  <?php
  // Send notification through the server log if we can not
  // connect to the database.
  if (!Ora_Logon($username, $password)) {
      error_log("Oracle database not available!", 0);
  }

  // Notify administrator by email if we run out of FOO
  if (!($foo = allocate_new_foo())) {
      error_log("Big trouble, we're all out of FOOs!", 1,
		 "operator@example.com");
  }

  // other ways of calling error_log():
  error_log("You messed up!", 2, "127.0.0.1:7000");
  error_log("You messed up!", 2, "loghost");
  error_log("You messed up!", 3, "/var/tmp/my-errors.log");
  ?> 

  debug_print_backtraceUperror_reporting
#

#T=int error_log ( string message [, int message_type [, string destination 
error_log ( ^!string message [, int message_type [, string destination ;
#

#T=error_reporting - int error_reporting ( [int level])
(PHP 3, PHP 4 )
error_reporting -- Sets which PHP errors are reported
Description
int error_reporting ( [int level])
The error_reporting() function sets the error_reporting directive at 
runtime. PHP has many levels of errors, using this function sets that 
level for the duration (runtime) of your script. 
error_reporting() sets PHP's error reporting level, and returns the old 
level. The level parameter takes on either a bitmask, or named constants. 
Using named constants is strongly encouraged to ensure compatibility for 
future versions. As error levels are added, the range of integers 
increases, so older integer-based error levels will not always behave as 
expected. 
Some example uses: 
Example 1. error_reporting() examples
  <?php

  // Turn off all error reporting
  error_reporting(0);

  // Report simple running errors
  error_reporting(E_ERROR | E_WARNING | E_PARSE);

  // Reporting E_NOTICE can be good too (to report uninitialized 

  // variables or catch variable name misspellings ...)
  error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

  // Report all errors except E_NOTICE
  // This is the default value set in php.ini
  error_reporting(E_ALL ^ E_NOTICE);

  // Report all PHP errors (bitwise 63 may be used in PHP 3)
  error_reporting(E_ALL);

  // Same as error_reporting(E_ALL);
  ini_set ('error_reporting', E_ALL);

  ?> 
The available error level constants are listed below. The actual meanings 
of these error levels are described in the predefined constants. 
Table 1. error_reporting() level constants and bit values
valueconstant
1E_ERROR 
2E_WARNING 
4E_PARSE 
8E_NOTICE 
16E_CORE_ERROR 
32E_CORE_WARNING 
64E_COMPILE_ERROR 
128E_COMPILE_WARNING 
256E_USER_ERROR 
512E_USER_WARNING 
1024E_USER_NOTICE 
2047E_ALL 
2048E_STRICT 

Warning
With PHP > 5.0.0 E_STRICT with value 2048 is available. E_ALL does 
NOT include error levelE_STRICT. 

See also the display_errors directive and ini_set().   error_logUprestore_error_handler
#

#T=int error_reporting ( [int level])
error_reporting ( ^![int level]);
#

#T=escapeshellarg - string escapeshellarg ( string arg)
(PHP 4 >= 4.0.3)
escapeshellarg -- escape a string to be used as a shell argument
Description
string escapeshellarg ( string arg)
escapeshellarg() adds single quotes around a string and quotes/escapes any 
existing single quotes allowing you to pass a string directly to a shell 
function and having it be treated as a single safe argument. This function 
should be used to escape individual arguments to shell functions coming 
from user input. The shell functions include exec(), system() and the 
backtick operator. A standard use would be:
<?php
system('ls '.escapeshellarg($dir));
?> 

See also escapeshellcmd(), exec(), popen(), system(), and the backtick 
operator.   Program Execution functionsUpescapeshellcmd
#

#T=string escapeshellarg ( string arg)
escapeshellarg ( ^!string arg);
#

#T=escapeshellcmd - string escapeshellcmd ( string command)
(PHP 3, PHP 4 )
escapeshellcmd -- escape shell metacharacters
Description
string escapeshellcmd ( string command)
escapeshellcmd() escapes any characters in a string that might be used to 
trick a shell command into executing arbitrary commands. This function 
should be used to make sure that any data coming from user input is 
escaped before this data is passed to the exec() or system() functions, or 
to the backtick operator. A standard use would be:
<?php
$e = escapeshellcmd($userinput);

// here we don't care if $e has spaces
system("echo $e");
$f = escapeshellcmd($filename);

// and here we do, so we use quotes
system("touch \"/tmp/$f\"; ls -l \"/tmp/$f\"");
?> 

See also escapeshellarg(), exec(), popen(), system(), and the backtick 
operator.   escapeshellargUpexec
#

#T=string escapeshellcmd ( string command)
escapeshellcmd ( ^!string command);
#

#T=eval - mixed eval ( string code_str)
(PHP 3, PHP 4 )
eval -- Evaluate a string as PHP code
Description
mixed eval ( string code_str)
eval() evaluates the string given in code_str as PHP code. Among other 
things, this can be useful for storing code in a database text field for 
later execution. 
There are some factors to keep in mind when using eval(). Remember that 
the string passed must be valid PHP code, including things like 
terminating statements with a semicolon so the parser doesn't die on the 
line after the eval(), and properly escaping things in code_str. 
Also remember that variables given values under eval() will retain these 
values in the main script afterwards. 
A return statement will terminate the evaluation of the string 
immediately. In PHP 4, eval() returns NULL unless return is called in the 
evaluated code, in which case the value passed to return is returned. In 
PHP 3, eval() does not return a value. 
Example 1. eval() example - simple text merge 
  <?php
  $string = 'cup';
  $name = 'coffee';
  $str = 'This is a $string with my $name in it.';
  echo $str. "\n";
  eval("\$str = \"$str\";");
  echo $str. "\n";
  ?> 

The above example will show: 
This is a $string with my $name in it.
This is a cup with my coffee in it.
Tip: As with anything that outputs its result directly to the browser, 
you can use the output-control functions to capture the output of this 
function, and save it in a string (for example).  dieUpexit
#

#T=mixed eval ( string code_str)
eval ( ^!string code_str);
#

#T=exec - string exec ( string command [, array output [, int return_var]])
(PHP 3, PHP 4 )
exec -- Execute an external program
Description
string exec ( string command [, array output [, int return_var]])
exec() executes the given command, however it does not output anything. It 
simply returns the last line from the result of the command. If you need 
to execute a command and have all the data from the command passed 
directly back without any interference, use the passthru() function. 
If the output argument is present, then the specified array will be filled 
with every line of output from the command. Line endings, such as \n, are 
not included in this array. Note that if the array already contains some 
elements, exec() will append to the end of the array. If you do not want 
the function to append elements, call unset() on the array before passing 
it to exec(). 
If the return_var argument is present along with the output argument, then 
the return status of the executed command will be written to this 
variable. 
Warning
If you are going to allow data coming from user input to be passed 
to this function, then you should be using escapeshellarg() or 
escapeshellcmd() to make sure that users cannot trick the system 
into executing arbitrary commands. 

Note: If you start a program using this function and want to leave it 
running in the background, you have to make sure that the output of that 
program is redirected to a file or some other output stream or else PHP 
will hang until the execution of the program ends. 
Note: When safe mode is enabled, you can only execute executables within 
the safe_mode_exec_dir. For practical reasons it's currently not allowed 
to have .. components in the path to the executable. 
See also system(), passthru(), popen(), escapeshellcmd(), and the backtick 
operator.   escapeshellcmdUppassthru
#

#T=string exec ( string command [, array output [, int return_var]])
exec ( ^!string command [, array output [, int return_var]]);
#

#T=exif_imagetype - int exif_imagetype ( string filename)
(PHP 4 >= 4.3.0)
exif_imagetype -- Determine the type of an image
Description
int exif_imagetype ( string filename)
exif_imagetype() reads the first bytes of an image and checks its 
signature. When a correct signature is found a constant will be returned 
otherwise the return value is FALSE. The return value is the same value 
that getimagesize() returns in index 2 but this function is much faster. 
The following constants are defined: 
Table 1. Imagetype Constants
ValueConstant
1IMAGETYPE_GIF
2IMAGETYPE_JPEG
3IMAGETYPE_PNG
4IMAGETYPE_SWF
5IMAGETYPE_PSD
6IMAGETYPE_BMP
7IMAGETYPE_TIFF_II (intel byte order)
8IMAGETYPE_TIFF_MM (motorola byte order) 
9IMAGETYPE_JPC
10IMAGETYPE_JP2
11IMAGETYPE_JPX
12IMAGETYPE_JB2
13IMAGETYPE_SWC
14IMAGETYPE_IFF
15IMAGETYPE_WBMP
16IMAGETYPE_XBM

Note: Support for JPC, JP2, JPX, JB2, XBM, and WBMP became available in 
PHP 4.3.2. Support for SWC as of PHP 4.3.0. 
This function can be used to avoid calls to other exif functions with 
unsupported file types or in conjunction with $_SERVER['HTTP_ACCEPT'] to 
check whether or not the viewer is able to see a specific image in the 
browser. 
Note: This function is only available if PHP is compiled using 
--enable-exif. 
Note: This function does not require the GD image library. 
Example 1. exif_imagetype() example
  <?php

  if (exif_imagetype("image.gif") != IMAGETYPE_GIF) {
      echo "The picture is not a gif";
  }

  ?> 
See also getimagesize().   Image functionsUpexif_read_data
#

#T=int exif_imagetype ( string filename)
exif_imagetype ( ^!string filename);
#

#T=exif_read_data - array exif_read_data ( string filename [, string sections [, bool arrays 
(PHP 4 >= 4.2.0)
exif_read_data -- Reads the EXIF headers from JPEG or TIFF. This way you 
can read meta data generated by digital cameras.
Description
array exif_read_data ( string filename [, string sections [, bool arrays 
[, bool thumbnail]]])
The exif_read_data() function reads the EXIF headers from a JPEG or TIFF 
image file. It returns an associative array where the indexes are the 
header names and the values are the values associated with those headers. 
If no data can be returned the result is FALSE. 
filename is the name of the file to read. This cannot be an url. 
sections is a comma separated list of sections that need to be present in 
file to produce a result array. If none of the requested sections could be 
found the return value is FALSE. 
FILEFileName, FileSize, FileDateTime, SectionsFound
COMPUTEDhtml, Width, Height, IsColor and some more if available. 
ANY_TAGAny information that has a Tag e.g. IFD0, EXIF, ...
IFD0All tagged data of IFD0. In normal imagefiles this contains 
image size and so forth.
THUMBNAILA file is supposed to contain a thumbnail if it has a 
second IFD. All tagged information about the embedded thumbnail is 
stored in this section.
COMMENTComment headers of JPEG images.
EXIFThe EXIF section is a sub section of IFD0. It contains more 
detailed information about an image. Most of these entries are 
digital camera related.

arrays specifies whether or not each section becomes an array. The 
sections COMPUTED, THUMBNAIL and COMMENT allways become arrays as they may 
contain values whose names are conflict with other sections. 
thumbnail whether or not to read the thumbnail itself and not only its 
tagged data. 
Note: Exif headers tend to be present in JPEG/TIFF images generated by 
digital cameras, but unfortunately each digital camera maker has a 
different idea of how to actually tag their images, so you can't always 
rely on a specific Exif header being present. 
Windows ME/XP both can wipe the Exif headers when connecting to a 
camera. More information available at 
http://ww2.canon-europe.com/products/cameras/notices_dig_cam_users.html. 

Example 1. exif_read_data() example
  <?php

  echo "test1.jpg:<br />\n";
  $exif = exif_read_data('tests/test1.jpg', 'IFD0');
  echo $exif===false ? "No header data found.<br />\n" : "Image 
  contains headers<br />";

  $exif = exif_read_data('tests/test2.jpg', 0, true);
  echo "test2.jpg:<br />\n";
  foreach ($exif as $key => $section) {
      foreach ($section as $name => $val) {
	  echo "$key.$name: $val<br />\n";
      }
  }
  ?> 

The first call fails because the image has no header information. 
  test1.jpg:
  No header data found.
  test2.jpg:
  FILE.FileName: test2.jpg
  FILE.FileDateTime: 1017666176
  FILE.FileSize: 1240
  FILE.FileType: 2
  FILE.SectionsFound: ANY_TAG, IFD0, THUMBNAIL, COMMENT
  COMPUTED.html: width="1" height="1"
  COMPUTED.Height: 1
  COMPUTED.Width: 1
  COMPUTED.IsColor: 1
  COMPUTED.ByteOrderMotorola: 1
  COMPUTED.UserComment: Exif test image.
  COMPUTED.UserCommentEncoding: ASCII
  COMPUTED.Copyright: Photo (c) M.Boerger, Edited by M.Boerger.
  COMPUTED.Copyright.Photographer: Photo (c) M.Boerger
  COMPUTED.Copyright.Editor: Edited by M.Boerger.
  IFD0.Copyright: Photo (c) M.Boerger
  IFD0.UserComment: ASCII
  THUMBNAIL.JPEGInterchangeFormat: 134
  THUMBNAIL.JPEGInterchangeFormatLength: 523
  COMMENT.0: Comment #1.
  COMMENT.1: Comment #2.
  COMMENT.2: Comment #3end
  THUMBNAIL.JPEGInterchangeFormat: 134
  THUMBNAIL.Thumbnail.Height: 1
  THUMBNAIL.Thumbnail.Height: 1 
Note: If the image contains any IFD0 data then COMPUTED contains the 
entry ByteOrderMotorola which is 0 for little-endian (intel) and 1 for 
big-endian (motorola) byte order. This was added in PHP 4.3. 
When an Exif header contains a Copyright note this itself can contain 
two values. As the solution is inconsistent in the Exif 2.10 standard 
the COMPUTED section will return both entries Copyright.Photographer and 
Copyright.Editor while the IFD0 sections contains the byte array with 
the NULL character that splits both entries. Or just the first entry if 
the datatype was wrong (normal behaviour of Exif). The COMPUTED will 
contain also an entry Copyright Which is either the original copyright 
string or it is a comma separated list of photo and editor copyright. 
Note: The tag UserComment has the same problem as the Copyright tag. It 
can store two values first the encoding used and second the value 
itself. If so the IFD section only contains the encoding or a byte 
array. The COMPUTED section will store both in the entries 
UserCommentEncoding and UserComment. The entry UserComment is available 
in both cases so it should be used in preference to the value in IFD0 
section. 
If the user comment uses Unicode or JIS encoding and the module mbstring 
is available this encoding will automatically changed according to the 
exif ini settings in the php.ini. This was added in PHP 4.3. 
Note: Height and Width are computed the same way getimagesize() does so 
their values must not be part of any header returned. Also html is a 
height/width text string to be used inside normal HTML. 
Note: Starting from PHP 4.3 the function can read all embedded IFD data 
including arrays (returned as such). Also the size of an embedded 
thumbnail is returned in THUMBNAIL subarray and the function 
exif_read_data() can return thumbnails in TIFF format. Last but not 
least there is no longer a maximum length for returned values (not until 
memory limit is reached). 
Note: This function is only available in PHP 4 compiled using 
--enable-exif. Its functionality and behaviour has changed in PHP 4.2. 
Earlier versions are very unstable. 
Since PHP 4.3 user comment can automatically change encoding if PHP 4 
was compiled using --enable-mbstring. 
This function does not require the GD image library. 
See also exif_thumbnail() and getimagesize().   exif_imagetypeUpexif_thumbnail
#

#T=array exif_read_data ( string filename [, string sections [, bool arrays 
exif_read_data ( ^!string filename [, string sections [, bool arrays ;
#

#T=exif_thumbnail - string exif_thumbnail ( string filename [, int &width [, int &height [, 
(PHP 4 >= 4.2.0)
exif_thumbnail -- Retrieve the embedded thumbnail of a TIFF or JPEG image
Description
string exif_thumbnail ( string filename [, int &width [, int &height [, 
int &imagetype]]])
exif_thumbnail() reads the embedded thumbnail of a TIFF or JPEG image. If 
the image contains no thumbnail FALSE will be returned. 
The parameters width, height and imagetype are available since PHP 4.3.0 
and return the size of the thumbnail as well as its type. It is possible 
that exif_thumbnail() cannot create an image but can determine its size. 
In this case, the return value is FALSE but width and height are set. 
If you want to deliver thumbnails through this function, you should send 
the mimetype information using the header() function. The following 
example demonstrates this: 
Example 1. exif_thumbnail() example
  <?php
  if (array_key_exists('file', $_REQUEST)) {
      $image = exif_thumbnail($_REQUEST['file'], $width, 
  $height, $type);
  } else {
      $image = false;
  }
  if ($image!==false) {
      header("Content-type: " .image_type_to_mime_type($type));
      echo $image;
      exit;
  } else {
      // no thumbnail available, handle the error here
      echo "No thumbnail available";
  }
  ?> 
Starting from version PHP 4.3.0, the function exif_thumbnail() can return 
thumbnails in TIFF format. 
Note: This function is only available in PHP 4 compiled using 
--enable-exif. Its functionality and behaviour has changed in PHP 4.2.0 
Note: This function does not require the GD image library. 
See also exif_read_data() and image_type_to_mime_type().   exif_read_dataUpgd_info
#

#T=string exif_thumbnail ( string filename [, int &width [, int &height [, 
exif_thumbnail ( ^!string filename [, int &width [, int &height [, ;
#

#T=exit - void exit ( [string status])
(PHP 3, PHP 4 )
exit -- Output a message and terminate the current script
Description
void exit ( [string status])

void exit ( int status)
Note: This is not a real function, but a language construct. 
Note: PHP version >= 4.2.0 does NOT print the status if it is an 
integer. 
The exit() function terminates execution of the script. It prints status 
just before exiting. 
If status is an integer, that value will also be used as the exit status. 
Exit statuses should be in the range 1 to 254, the exit status 255 is 
reserved by PHP and shall not be used. 
Example 1. exit() example
  <?php

  $filename = '/path/to/data-file';
  $file = fopen($filename, 'r')
      or exit("unable to open file ($filename)");

  ?> 
Note: The die() function is an alias for exit(). 
See also: register_shutdown_function().   evalUpget_browser
#

#T=void exit ( [string status])
exit ( ^![string status]);
#

#T=exp - float exp ( float arg)
(PHP 3, PHP 4 )
exp -- Calculates the exponent of e (the Neperian or Natural logarithm 
base)
Description
float exp ( float arg)
Returns e raised to the power of arg. 
Note: 'e' is the base of the natural system of logarithms, or 
approximately 2.718282. 
Example 1. exp() example
  <?php
  echo exp(12) . "\n";
  echo exp(5.7);
  ?> 

The above example will output: 
1.6275E+005
298.87
See also log() and pow().   deg2radUpexpm1
#

#T=float exp ( float arg)
exp ( ^!float arg);
#

#T=explode - array explode ( string separator, string string [, int limit])
(PHP 3, PHP 4 )
explode -- Split a string by string
Description
array explode ( string separator, string string [, int limit])
Returns an array of strings, each of which is a substring of string formed 
by splitting it on boundaries formed by the string separator. If limit is 
set, the returned array will contain a maximum of limit elements with the 
last element containing the rest of string. 
If separator is an empty string (""), explode() will return FALSE. If 
separator contains a value that is not contained in string, then explode() 
will return an array containing string. 
Although implode() can, for historical reasons, accept its parameters in 
either order, explode() cannot. You must ensure that the separator 
argument comes before the string argument. 
Note: The limit parameter was added in PHP 4.0.1 
Example 1. explode() examples
  <?php
  // Example 1
  $pizza  = "piece1 piece2 piece3 piece4 piece5 piece6";
  $pieces = explode(" ", $pizza);
  echo $pieces[0]; // piece1
  echo $pieces[1]; // piece2

  // Example 2
  $data = "foo:*:1023:1000::/home/foo:/bin/sh";
  list($user, $pass, $uid, $gid, $gecos, $home, $shell) = 
  explode(":", $data);
  echo $user; // foo
  echo $pass; // *

  ?> 
See also preg_split(), spliti(), split(), and implode().   echoUpfprintf
#

#T=array explode ( string separator, string string [, int limit])
explode ( ^!string separator, string string [, int limit]);
#

#T=expm1 - float expm1 ( float number)
(PHP 4 >= 4.1.0)
expm1 --  Returns exp(number) - 1, computed in a way that is accurate even 
when the value of number is close to zero 
Description
float expm1 ( float number)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

Note: This function is not implemented on Windows platforms.  expUpfloor
#

#T=float expm1 ( float number)
expm1 ( ^!float number);
#

#T=extension_loaded - bool extension_loaded ( string name)
(PHP 3>= 3.0.10, PHP 4 )
extension_loaded -- Find out whether an extension is loaded
Description
bool extension_loaded ( string name)
Returns TRUE if the extension identified by name is loaded, FALSE 
otherwise. 
Example 1. extension_loaded() example
  <?php
  if (!extension_loaded('gd')) {
      if (!dl('gd.so')) {
	  exit;
      }
  }
  ?> 
You can see the names of various extensions by using phpinfo() or if 
you're using the CGI or CLI version of PHP you can use the -m switch to 
list all available extensions: $ php -m
[PHP Modules]
xml
tokenizer
standard
sockets
session
posix
pcre
overload
mysql
mbstring
ctype

[Zend Modules]

Note: extension_loaded() uses the internal extension name to test 
whether a certain extension is available or not. Most internal extension 
names are written in lower case but there may be extension available 
which also use uppercase letters. Be warned that this function compares 
case sensitive ! 
See also get_loaded_extensions(), get_extension_funcs(), phpinfo(), and 
dl().   dlUpget_cfg_var
#

#T=bool extension_loaded ( string name)
extension_loaded ( ^!string name);
#

#T=extract - int extract ( array var_array [, int extract_type [, string prefix]])
(PHP 3>= 3.0.7, PHP 4 )
extract --  Import variables into the current symbol table from an array 
Description
int extract ( array var_array [, int extract_type [, string prefix]])
This function is used to import variables from an array into the current 
symbol table. It takes an associative array var_array and treats keys as 
variable names and values as variable values. For each key/value pair it 
will create a variable in the current symbol table, subject to 
extract_type and prefix parameters. 
Note: Beginning with version 4.0.5, this function returns the number of 
variables extracted. 
Note: EXTR_IF_EXISTS and EXTR_PREFIX_IF_EXISTS was introduced in version 
4.2.0. 
Note: EXTR_REFS was introduced in version 4.3.0. 
extract() checks each key to see whether it has a valid variable name. It 
also checks for collisions with existing variables in the symbol table. 
The way invalid/numeric keys and collisions are treated is determined by 
the extract_type. It can be one of the following values: 
EXTR_OVERWRITE
If there is a collision, overwrite the existing variable. 
EXTR_SKIP
If there is a collision, don't overwrite the existing variable. 
EXTR_PREFIX_SAME
If there is a collision, prefix the variable name with prefix. 
EXTR_PREFIX_ALL
Prefix all variable names with prefix. Beginning with PHP 4.0.5, this 
includes numeric variables as well. 
EXTR_PREFIX_INVALID
Only prefix invalid/numeric variable names with prefix. This flag was 
added in PHP 4.0.5. 
EXTR_IF_EXISTS
Only overwrite the variable if it already exists in the current symbol 
table, otherwise do nothing. This is useful for defining a list of valid 
variables and then extracting only those variables you have defined out 
of $_REQUEST, for example. This flag was added in PHP 4.2.0. 
EXTR_PREFIX_IF_EXISTS
Only create prefixed variable names if the non-prefixed version of the 
same variable exists in the current symbol table. This flag was added in 
PHP 4.2.0. 
EXTR_REFS
Extracts variables as references. This effectively means that the values 
of the imported variables are still referencing the values of the 
var_array parameter. You can use this flag on its own or combine it with 
any other flag by OR'ing the extract_type. This flag was added in PHP 
4.3.0. 
If extract_type is not specified, it is assumed to be EXTR_OVERWRITE. 
Note that prefix is only required if extract_type is EXTR_PREFIX_SAME, 
EXTR_PREFIX_ALL, EXTR_PREFIX_INVALID or EXTR_PREFIX_IF_EXISTS. If the 
prefixed result is not a valid variable name, it is not imported into the 
symbol table. 
extract() returns the number of variables successfully imported into the 
symbol table. 
A possible use for extract() is to import into the symbol table variables 
contained in an associative array returned by wddx_deserialize(). 
Example 1. extract() example
  <?php

  /* Suppose that $var_array is an array returned from
     wddx_deserialize */

  $size = "large";
  $var_array = array("color" => "blue",
		     "size"  => "medium",
		     "shape" => "sphere");
  extract($var_array, EXTR_PREFIX_SAME, "wddx");

  echo "$color, $size, $shape, $wddx_size\n";

  ?> 

The above example will produce: 
blue, large, sphere, medium
The $size wasn't overwritten, because we specified EXTR_PREFIX_SAME, which 
resulted in $wddx_size being created. If EXTR_SKIP was specified, then 
$wddx_size wouldn't even have been created. EXTR_OVERWRITE would have 
caused $size to have value "medium", and EXTR_PREFIX_ALL would result in 
new variables being named $wddx_color, $wddx_size, and $wddx_shape. 
You must use an associative array, a numerically indexed array will not 
produce results unless you use EXTR_PREFIX_ALL or EXTR_PREFIX_INVALID. 
See also compact().   endUpin_array
#

#T=int extract ( array var_array [, int extract_type [, string prefix]])
extract ( ^!array var_array [, int extract_type [, string prefix]]);
#

#T=ezmlm_hash - int ezmlm_hash ( string addr)
(PHP 3>= 3.0.17, PHP 4 >= 4.0.2)
ezmlm_hash -- Calculate the hash value needed by EZMLM
Description
int ezmlm_hash ( string addr)
ezmlm_hash() calculates the hash value needed when keeping EZMLM mailing 
lists in a MySQL database. 
Example 1. Calculating the hash and subscribing a user
  <?php

  $user = "joecool@example.com";
  $hash = ezmlm_hash($user);
  $query = sprintf("INSERT INTO sample VALUES (%s, '%s')", 
  $hash, $user);
  $db->query($query); // using PHPLIB db interface

  ?> 

  Mail functionsUpmail
#

#T=int ezmlm_hash ( string addr)
ezmlm_hash ( ^!string addr);
#

#T=fam_cancel_monitor - bool fam_cancel_monitor ( resource fam, resource fam_monitor)
(PHP 5 CVS only)
fam_cancel_monitor -- Terminate monitoring
Description
bool fam_cancel_monitor ( resource fam, resource fam_monitor)
fam_cancel_monitor() terminates monitoring on a resource previously 
requested using one of the fam_monitor_...(). 
See also fam_monitor_file(), fam_monitor_directory(), 
fam_monitor_collection(), and fam_suspend_monitor()   File alteration monitor functionsUpfam_close
#

#T=bool fam_cancel_monitor ( resource fam, resource fam_monitor)
fam_cancel_monitor ( ^!resource fam, resource fam_monitor);
#

#T=fam_close - void fam_close ( resource fam)
(PHP 5 CVS only)
fam_close -- Close FAM connection
Description
void fam_close ( resource fam)
fam_close() closes a connection to the FAM service previously opened using 
fam_open().   fam_cancel_monitorUpfam_monitor_collection
#

#T=void fam_close ( resource fam)
fam_close ( ^!resource fam);
#

#T=fam_monitor_collection - resource fam_monitor_collection ( resource fam, string dirname, int depth, 
(PHP 5 CVS only)
fam_monitor_collection -- Monitor a collection of files in a directory for 
changes
Description
resource fam_monitor_collection ( resource fam, string dirname, int depth, 
string mask)
fam_monitor_file() requests monitoring for a collection of files within a 
directory. The actual files to be monitored are specified by a directory 
path in dirname, the maximum search depth starting from this directory and 
a shell pattern restricting the file names to look for. 
See also fam_monitor_file(), fam_monitor_directory(), 
fam_cancel_monitor(), fam_suspend_monitor(), and fam_resume_monitor().   fam_closeUpfam_monitor_directory
#

#T=resource fam_monitor_collection ( resource fam, string dirname, int depth, 
fam_monitor_collection ( ^!resource fam, string dirname, int depth, ;
#

#T=fam_monitor_directory - resource fam_monitor_directory ( resource fam, string dirname)
(PHP 5 CVS only)
fam_monitor_directory -- Monitor a directory for changes
Description
resource fam_monitor_directory ( resource fam, string dirname)
fam_monitor_file() requests monitoring for a directory and all contained 
files. A FAM event will be generated whenever the status of the directory 
(i.e. the result of function stat() on that directory) or its content 
(i.e. the results of readdir()) change. 
See also fam_monitor_file(), fam_monitor_collection(), 
fam_cancel_monitor(), fam_suspend_monitor(), and fam_resume_monitor().   fam_monitor_collectionUpfam_monitor_file
#

#T=resource fam_monitor_directory ( resource fam, string dirname)
fam_monitor_directory ( ^!resource fam, string dirname);
#

#T=fam_monitor_file - resource fam_monitor_file ( resource fam, string filename)
(PHP 5 CVS only)
fam_monitor_file -- Monitor a regular file for changes
Description
resource fam_monitor_file ( resource fam, string filename)
fam_monitor_file() requests monitoring for a single file. A FAM event will 
be generated whenever the file status (i.e. the result of function stat() 
on that file) changes. 
See also fam_monitor_directory(), fam_monitor_collection(), 
fam_cancel_monitor(), fam_suspend_monitor(), and fam_resume_monitor().   fam_monitor_directoryUpfam_next_event
#

#T=resource fam_monitor_file ( resource fam, string filename)
fam_monitor_file ( ^!resource fam, string filename);
#

#T=fam_next_event - array fam_next_event ( resource fam)
(PHP 5 CVS only)
fam_next_event -- ...
Description
array fam_next_event ( resource fam)
fam_next_event() returns the next pending FAM event. The function will 
block until an event is available which can be checked for using 
fam_pending(). 
fam_ext_event() will return an array that contains a FAM event code in 
element 'code', the path of the file this event applies to in element 
'filename' and optionally a hostname in element 'hostname'. 
The possible event codes are described in detail in the introduction part 
of this section. 
See also fam_pending().   fam_monitor_fileUpfam_open
#

#T=array fam_next_event ( resource fam)
fam_next_event ( ^!resource fam);
#

#T=fam_open - resource fam_open ( [string appname])
(PHP 5 CVS only)
fam_open -- Open connection to FAM daemon
Description
resource fam_open ( [string appname])
fam_open() opens a connection to the FAM service daemon. The optional 
parameter appname should be set to a string identifying the application 
for logging reasons. 
See also fam_close().   fam_next_eventUpfam_pending
#

#T=resource fam_open ( [string appname])
fam_open ( ^![string appname]);
#

#T=fam_pending - bool fam_pending ( resource fam)
(PHP 5 CVS only)
fam_pending -- Check for pending FAM events
Description
bool fam_pending ( resource fam)
fam_pending() returns TRUE if events are available to be fetched using 
fam_next_event(). 
See also fam_next_event().   fam_openUpfam_resume_monitor
#

#T=bool fam_pending ( resource fam)
fam_pending ( ^!resource fam);
#

#T=fam_resume_monitor - bool fam_resume_monitor ( resource fam, resource fam_monitor)
(PHP 5 CVS only)
fam_resume_monitor -- Resume suspended monitoring
Description
bool fam_resume_monitor ( resource fam, resource fam_monitor)
fam_resume_monitor() resumes monitoring of a resource previously suspend 
using fam_suspend_monitor(). 
See also fam_suspend_monitor().   fam_pendingUpfam_suspend_monitor
#

#T=bool fam_resume_monitor ( resource fam, resource fam_monitor)
fam_resume_monitor ( ^!resource fam, resource fam_monitor);
#

#T=fam_suspend_monitor - bool fam_suspend_monitor ( resource fam, resource fam_monitor)
(PHP 5 CVS only)
fam_suspend_monitor -- Temporarily suspend monitoring
Description
bool fam_suspend_monitor ( resource fam, resource fam_monitor)
fam_suspend_monitor() temporarily suspend monitoring of a resource 
previously requested using one of the fam_monitor_...() functions. 
Monitoring can later be continued using fam_resume_monitor() without the 
need of requesting a complete new monitor. 
See also fam_resume_monitor(), and fam_cancel_monitor().   fam_resume_monitorUpFrontBase Functions
#

#T=bool fam_suspend_monitor ( resource fam, resource fam_monitor)
fam_suspend_monitor ( ^!resource fam, resource fam_monitor);
#

#T=fbsql_affected_rows - int fbsql_affected_rows ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_affected_rows --  Get number of affected rows in previous FrontBase 
operation 
Description
int fbsql_affected_rows ( [resource link_identifier])
fbsql_affected_rows() returns the number of rows affected by the last 
INSERT, UPDATE or DELETE query associated with link_identifier. If the 
link identifier isn't specified, the last link opened by fbsql_connect() 
is assumed. 
Note: If you are using transactions, you need to call 
fbsql_affected_rows() after your INSERT, UPDATE, or DELETE query, not 
after the commit. 
If the last query was a DELETE query with no WHERE clause, all of the 
records will have been deleted from the table but this function will 
return zero. 
Note: When using UPDATE, FrontBase will not update columns where the new 
value is the same as the old value. This creates the possibility that 
fbsql_affected_rows() may not actually equal the number of rows matched, 
only the number of rows that were literally affected by the query. 
If the last query failed, this function will return -1. 
See also: fbsql_num_rows().   FrontBase FunctionsUpfbsql_autocommit
#

#T=int fbsql_affected_rows ( [resource link_identifier])
fbsql_affected_rows ( ^![resource link_identifier]);
#

#T=fbsql_autocommit - bool fbsql_autocommit ( resource link_identifier [, bool OnOff])
(PHP 4 >= 4.0.6)
fbsql_autocommit -- Enable or disable autocommit
Description
bool fbsql_autocommit ( resource link_identifier [, bool OnOff])
fbsql_autocommit() returns the current autocommit status. If the optional 
OnOff parameter is given the auto commit status will be changed. With 
OnOff set to TRUE each statement will be committed automatically, if no 
errors was found. With OnOff set to FALSE the user must commit or rollback 
the transaction using either fbsql_commit() or fbsql_rollback(). 
See also: fbsql_commit() and fbsql_rollback()   fbsql_affected_rowsUpfbsql_change_user
fbsql_change_user
(no version information, might be only in CVS)
fbsql_change_user --  Change logged in user of the active connection 
Description
resource fbsql_change_user ( string user, string password [, string 
database [, resource link_identifier]])
fbsql_change_user() changes the logged in user of the current active 
connection, or the connection given by the optional parameter 
link_identifier. If a database is specified, this will default or current 
database after the user has been changed. If the new user and password 
authorization fails, the current connected user stays active.   fbsql_autocommitUpfbsql_close
#

#T=bool fbsql_autocommit ( resource link_identifier [, bool OnOff])
fbsql_autocommit ( ^!resource link_identifier [, bool OnOff]);
#

#T=fbsql_close - bool fbsql_close ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_close -- Close FrontBase connection
Description
bool fbsql_close ( [resource link_identifier])
Returns: TRUE on success, FALSE on error. 
fbsql_close() closes the connection to the FrontBase server that's 
associated with the specified link identifier. If link_identifier isn't 
specified, the last opened link is used. 
Using fbsql_close() isn't usually necessary, as non-persistent open links 
are automatically closed at the end of the script's execution. 
Example 1. fbsql_close() example
  <?php
      $link = fbsql_connect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      echo "Connected successfully";
      fbsql_close($link);
  ?> 
See also: fbsql_connect() and fbsql_pconnect().   fbsql_change_userUpfbsql_commit
#

#T=bool fbsql_close ( [resource link_identifier])
fbsql_close ( ^![resource link_identifier]);
#

#T=fbsql_commit - bool fbsql_commit ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_commit -- Commits a transaction to the database
Description
bool fbsql_commit ( [resource link_identifier])
Returns TRUE on success or FALSE on failure. 
fbsql_commit() ends the current transaction by writing all inserts, 
updates and deletes to the disk and unlocking all row and table locks held 
by the transaction. This command is only needed if autocommit is set to 
false. 
See also: fbsql_autocommit() and fbsql_rollback()   fbsql_closeUpfbsql_connect
#

#T=bool fbsql_commit ( [resource link_identifier])
fbsql_commit ( ^![resource link_identifier]);
#

#T=fbsql_connect - resource fbsql_connect ( [string hostname [, string username [, string 
(PHP 4 >= 4.0.6)
fbsql_connect -- Open a connection to a FrontBase Server
Description
resource fbsql_connect ( [string hostname [, string username [, string 
password]]])
Returns a positive FrontBase link identifier on success, or an error 
message on failure. 
fbsql_connect() establishes a connection to a FrontBase server. The 
following defaults are assumed for missing optional parameters: hostname = 
'NULL', username = '_SYSTEM' and password = empty password. 
If a second call is made to fbsql_connect() with the same arguments, no 
new link will be established, but instead, the link identifier of the 
already opened link will be returned. 
The link to the server will be closed as soon as the execution of the 
script ends, unless it's closed earlier by explicitly calling 
fbsql_close(). 
Example 1. fbsql_connect() example
  <?php

      $link = fbsql_connect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      echo "Connected successfully";
      fbsql_close($link);

  ?> 
See also fbsql_pconnect() and fbsql_close().   fbsql_commitUpfbsql_create_blob
#

#T=resource fbsql_connect ( [string hostname [, string username [, string 
fbsql_connect ( ^![string hostname [, string username [, string ;
#

#T=fbsql_create_blob - string fbsql_create_blob ( string blob_data [, resource link_identifier])
(PHP 4 >= 4.2.0)
fbsql_create_blob -- Create a BLOB
Description
string fbsql_create_blob ( string blob_data [, resource link_identifier])
Returns: A resource handle to the newly created blob. 
fbsql_create_blob() creates a blob from blob_data. The returned resource 
handle can be used with insert and update commands to store the blob in 
the database. 
Example 1. fbsql_create_blob() example
  <?php
      $link = fbsql_pconnect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      $filename = "blobfile.bin";
      $fp = fopen($filename, "rb");
      $blobdata = fread($fp, filesize($filename));
      fclose($fp);
      
      $blobHandle = fbsql_create_blob($blobdata, $link);
      
      $sql = "INSERT INTO BLOB_TABLE (BLOB_COLUMN) VALUES 
  ($blobHandle);";
      $rs = fbsql_query($sql, $link);
  ?> 
See also: fbsql_create_clob(), fbsql_read_blob(), fbsql_read_clob(), and 
fbsql_set_lob_mode().   fbsql_connectUpfbsql_create_clob
#

#T=string fbsql_create_blob ( string blob_data [, resource link_identifier])
fbsql_create_blob ( ^!string blob_data [, resource link_identifier]);
#

#T=fbsql_create_clob - string fbsql_create_clob ( string clob_data [, resource link_identifier])
(PHP 4 >= 4.2.0)
fbsql_create_clob -- Create a CLOB
Description
string fbsql_create_clob ( string clob_data [, resource link_identifier])
Returns: A resource handle to the newly created CLOB. 
fbsql_create_clob() creates a clob from clob_data. The returned resource 
handle can be used with insert and update commands to store the clob in 
the database. 
Example 1. fbsql_create_clob() example
  <?php
      $link = fbsql_pconnect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      $filename = "clob_file.txt";
      $fp = fopen($filename, "rb");
      $clobdata = fread($fp, filesize($filename));
      fclose($fp);
      
      $clobHandle = fbsql_create_clob($clobdata, $link);
      
      $sql = "INSERT INTO CLOB_TABLE (CLOB_COLUMN) VALUES 
  ($clobHandle);";
      $rs = fbsql_query($sql, $link);
  ?> 
See also: fbsql_create_blob(), fbsql_read_blob(), fbsql_read_clob(), and 
fbsql_set_lob_mode().   fbsql_create_blobUpfbsql_create_db
#

#T=string fbsql_create_clob ( string clob_data [, resource link_identifier])
fbsql_create_clob ( ^!string clob_data [, resource link_identifier]);
#

#T=fbsql_create_db - bool fbsql_create_db ( string database_name [, resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_create_db -- Create a FrontBase database
Description
bool fbsql_create_db ( string database_name [, resource link_identifier])
fbsql_create_db() attempts to create a new database named database_name on 
the server associated with the specified connection link_identifier. 
Example 1. fbsql_create_db() example
  <?php
      $link = fbsql_pconnect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      if (fbsql_create_db("my_db")) {
	  echo "Database created successfully\n";
      } else {
	  printf("Error creating database: %s\n", 
fbsql_error());
      }
  ?> 
See also: fbsql_drop_db().   fbsql_create_clobUpfbsql_data_seek
#

#T=bool fbsql_create_db ( string database_name [, resource link_identifier])
fbsql_create_db ( ^!string database_name [, resource link_identifier]);
#

#T=fbsql_data_seek - bool fbsql_data_seek ( resource result_identifier, int row_number)
(PHP 4 >= 4.0.6)
fbsql_data_seek -- Move internal result pointer
Description
bool fbsql_data_seek ( resource result_identifier, int row_number)
Returns TRUE on success or FALSE on failure. 
fbsql_data_seek() moves the internal row pointer of the FrontBase result 
associated with the specified result identifier to point to the specified 
row number. The next call to fbsql_fetch_row() would return that row. 
Row_number starts at 0. 
Example 1. fbsql_data_seek() example
  <?php
      $link = fbsql_pconnect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");

      fbsql_select_db("samp_db")
	  or die("Could not select database");

      $query = "SELECT last_name, first_name FROM friends;";
      $result = fbsql_query($query)
	  or die("Query failed");

      // fetch rows in reverse order

      for ($i = fbsql_num_rows($result) - 1; $i >=0; $i--) {
	  if (!fbsql_data_seek($result, $i)) {
	      printf("Cannot seek to row %d\n", $i);
	      continue;
	  }

	  if (!($row = fbsql_fetch_object($result)))
	      continue;

	  echo $row->last_name . $row->first_name . "<br />\n";
      }

      fbsql_free_result($result);
  ?> 

  fbsql_create_dbUpfbsql_database_password
#

#T=bool fbsql_data_seek ( resource result_identifier, int row_number)
fbsql_data_seek ( ^!resource result_identifier, int row_number);
#

#T=fbsql_database_password - string fbsql_database_password ( resource link_identifier [, string 
(PHP 4 >= 4.0.6)
fbsql_database_password --  Sets or retrieves the password for a FrontBase 
database 
Description
string fbsql_database_password ( resource link_identifier [, string 
database_password])
Returns: The database password associated with the link identifier. 
fbsql_database_password() sets and retrieves the database password used by 
the connection. if a database is protected by a database password, the 
user must call this function before calling fbsql_select_db(). if the 
second optional parameter is given the function sets the database password 
for the specified link identifier. If no link identifier is specified, the 
last opened link is assumed. If no link is open, the function will try to 
establish a link as if fbsql_connect() was called, and use it. 
This function does not change the database password in the database nor 
can it be used to retrieve the database password for a database. 
Example 1. fbsql_create_clob() example
  <?php
      $link = fbsql_pconnect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      fbsql_database_password($link, "secret db password");
      fbsql_select_db($database, $link);
  ?> 
See also: fbsql_connect(), fbsql_pconnect() and fbsql_select_db().   fbsql_data_seekUpfbsql_database
#

#T=string fbsql_database_password ( resource link_identifier [, string 
fbsql_database_password ( ^!resource link_identifier [, string ;
#

#T=fbsql_database - string fbsql_database ( resource link_identifier [, string database])
(PHP 4 >= 4.0.6)
fbsql_database -- Get or set the database name used with a connection
Description
string fbsql_database ( resource link_identifier [, string database])
Warning
This function is currently not documented; only the argument list is 
available.
  fbsql_database_passwordUpfbsql_db_query
#

#T=string fbsql_database ( resource link_identifier [, string database])
fbsql_database ( ^!resource link_identifier [, string database]);
#

#T=fbsql_db_query - resource fbsql_db_query ( string database, string query [, resource 
(PHP 4 >= 4.0.6)
fbsql_db_query -- Send a FrontBase query
Description
resource fbsql_db_query ( string database, string query [, resource 
link_identifier])
Returns: A positive FrontBase result identifier to the query result, or 
FALSE on error. 
fbsql_db_query() selects a database and executes a query on it. If the 
optional link identifier isn't specified, the function will try to find an 
open link to the FrontBase server and if no such link is found it'll try 
to create one as if fbsql_connect() was called with no arguments 
See also fbsql_connect().   fbsql_databaseUpfbsql_db_status
#

#T=resource fbsql_db_query ( string database, string query [, resource 
fbsql_db_query ( ^!string database, string query [, resource ;
#

#T=fbsql_db_status - int fbsql_db_status ( string database_name [, resource link_identifier])
(PHP 4 >= 4.1.0)
fbsql_db_status -- Get the status for a given database
Description
int fbsql_db_status ( string database_name [, resource link_identifier])
Returns: An integer value with the current status. 
fbsql_db_status() requests the current status of the database specified by 
database_name. If the link_identifier is omitted the default 
link_identifier will be used. 
The return value can be one of the following constants: 
FALSE - The exec handler for the host was invalid. This error will occur 
when the link_identifier connects directly to a database by using a port 
number. FBExec can be available on the server but no connection has been 
made for it. 
FBSQL_UNKNOWN - The Status is unknown. 
FBSQL_STOPPED - The database is not running. Use fbsql_start_db() to 
start the database. 
FBSQL_STARTING - The database is starting. 
FBSQL_RUNNING - The database is running and can be used to perform SQL 
operations. 
FBSQL_STOPPING - The database is stopping. 
FBSQL_NOEXEC - FBExec is not running on the server and it is not 
possible to get the status of the database. 
See also: fbsql_start_db() and fbsql_stop_db().   fbsql_db_queryUpfbsql_drop_db
#

#T=int fbsql_db_status ( string database_name [, resource link_identifier])
fbsql_db_status ( ^!string database_name [, resource link_identifier]);
#

#T=fbsql_drop_db - bool fbsql_drop_db ( string database_name [, resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_drop_db -- Drop (delete) a FrontBase database
Description
bool fbsql_drop_db ( string database_name [, resource link_identifier])
Returns TRUE on success or FALSE on failure. 
fbsql_drop_db() attempts to drop (remove) an entire database from the 
server associated with the specified link identifier.   fbsql_db_statusUpfbsql_errno
#

#T=bool fbsql_drop_db ( string database_name [, resource link_identifier])
fbsql_drop_db ( ^!string database_name [, resource link_identifier]);
#

#T=fbsql_errno - int fbsql_errno ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_errno --  Returns the numerical value of the error message from 
previous FrontBase operation 
Description
int fbsql_errno ( [resource link_identifier])
Returns the error number from the last fbsql function, or 0 (zero) if no 
error occurred. 
Errors coming back from the fbsql database backend don't issue warnings. 
Instead, use fbsql_errno() to retrieve the error code. Note that this 
function only returns the error code from the most recently executed fbsql 
function (not including fbsql_error() and fbsql_errno()), so if you want 
to use it, make sure you check the value before calling another fbsql 
function. 
<?php
fbsql_connect("marliesle");
echo fbsql_errno() . ": " . fbsql_error() . "<br />";
fbsql_select_db("nonexistentdb");
echo fbsql_errno() . ": " . fbsql_error() . "<br />";
$conn = fbsql_query("SELECT * FROM nonexistenttable;");
echo fbsql_errno() . ": " . fbsql_error() . "<br />";
?> 

See also: fbsql_error() and fbsql_warnings().   fbsql_drop_dbUpfbsql_error
#

#T=int fbsql_errno ( [resource link_identifier])
fbsql_errno ( ^![resource link_identifier]);
#

#T=fbsql_error - string fbsql_error ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_error --  Returns the text of the error message from previous 
FrontBase operation 
Description
string fbsql_error ( [resource link_identifier])
Returns the error text from the last fbsql function, or '' (the empty 
string) if no error occurred. 
Errors coming back from the fbsql database backend don't issue warnings. 
Instead, use fbsql_error() to retrieve the error text. Note that this 
function only returns the error text from the most recently executed fbsql 
function (not including fbsql_error() and fbsql_errno()), so if you want 
to use it, make sure you check the value before calling another fbsql 
function. 
<?php
fbsql_connect("marliesle");
echo fbsql_errno() . ": " . fbsql_error() . "<br />";
fbsql_select_db("nonexistentdb");
echo fbsql_errno() . ": " . fbsql_error() . "<br />";
$conn = fbsql_query("SELECT * FROM nonexistenttable;");
echo fbsql_errno() . ": " . fbsql_error() . "<br />";
?> 

See also: fbsql_errno() and fbsql_warnings().   fbsql_errnoUpfbsql_fetch_array
#

#T=string fbsql_error ( [resource link_identifier])
fbsql_error ( ^![resource link_identifier]);
#

#T=fbsql_fetch_array - array fbsql_fetch_array ( resource result [, int result_type])
(PHP 4 >= 4.0.6)
fbsql_fetch_array --  Fetch a result row as an associative array, a 
numeric array, or both 
Description
array fbsql_fetch_array ( resource result [, int result_type])
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
fbsql_fetch_array() is an extended version of fbsql_fetch_row(). In 
addition to storing the data in the numeric indices of the result array, 
it also stores the data in associative indices, using the field names as 
keys. 
If two or more columns of the result have the same field names, the last 
column will take precedence. To access the other column(s) of the same 
name, you must the numeric index of the column or make an alias for the 
column. 
select t1.f1 as foo t2.f1 as bar from t1, t2

An important thing to note is that using fbsql_fetch_array() is NOT 
significantly slower than using fbsql_fetch_row(), while it provides a 
significant added value. 
The optional second argument result_type in fbsql_fetch_array() is a 
constant and can take the following values: FBSQL_ASSOC, FBSQL_NUM, and 
FBSQL_BOTH. 
For further details, see also fbsql_fetch_row() and fbsql_fetch_assoc(). 
Example 1. fbsql_fetch_array() example
  <?php 
  fbsql_connect($host, $user, $password);
  $result = fbsql_db_query("database", "select user_id, fullname 
  from table");
  while ($row = fbsql_fetch_array($result)) {
      echo "user_id: " . $row["user_id"] . "<br />\n";
      echo "user_id: " . $row[0] . "<br />\n";
      echo "fullname: " . $row["fullname"] . "<br />\n";
      echo "fullname: " . $row[1] . "<br />\n";
  }
  fbsql_free_result($result);
  ?> 

  fbsql_errorUpfbsql_fetch_assoc
#

#T=array fbsql_fetch_array ( resource result [, int result_type])
fbsql_fetch_array ( ^!resource result [, int result_type]);
#

#T=fbsql_fetch_assoc - array fbsql_fetch_assoc ( resource result)
(PHP 4 >= 4.0.6)
fbsql_fetch_assoc --  Fetch a result row as an associative array 
Description
array fbsql_fetch_assoc ( resource result)
Returns an associative array that corresponds to the fetched row, or FALSE 
if there are no more rows.
fbsql_fetch_assoc() is equivalent to calling fbsql_fetch_array() with 
FBSQL_ASSOC for the optional second parameter. It only returns an 
associative array. This is the way fbsql_fetch_array() originally worked. 
If you need the numeric indices as well as the associative, use 
fbsql_fetch_array(). 
If two or more columns of the result have the same field names, the last 
column will take precedence. To access the other column(s) of the same 
name, you must use fbsql_fetch_array() and have it return the numeric 
indices as well. 
An important thing to note is that using fbsql_fetch_assoc() is NOT 
significantly slower than using fbsql_fetch_row(), while it provides a 
significant added value. 
For further details, see also fbsql_fetch_row() and fbsql_fetch_array(). 
Example 1. fbsql_fetch_assoc() example
  <?php 
  fbsql_connect($host, $user, $password);
  $result = fbsql_db_query("database", "select * from table");
  while ($row = fbsql_fetch_assoc($result)) {
      echo $row["user_id"];
      echo $row["fullname"];
  }
  fbsql_free_result($result);
  ?> 

  fbsql_fetch_arrayUpfbsql_fetch_field
#

#T=array fbsql_fetch_assoc ( resource result)
fbsql_fetch_assoc ( ^!resource result);
#

#T=fbsql_fetch_field - object fbsql_fetch_field ( resource result [, int field_offset])
(PHP 4 >= 4.0.6)
fbsql_fetch_field --  Get column information from a result and return as 
an object 
Description
object fbsql_fetch_field ( resource result [, int field_offset])
Returns an object containing field information. 
fbsql_fetch_field() can be used in order to obtain information about 
fields in a certain query result. If the field offset isn't specified, the 
next field that wasn't yet retrieved by fbsql_fetch_field() is retrieved. 
The properties of the object are: 
name - column name 
table - name of the table the column belongs to 
max_length - maximum length of the column 
not_null - 1 if the column cannot be NULL 
type - the type of the column 
Example 1. fbsql_fetch_field() example
  <?php 
  fbsql_connect($host, $user, $password)
      or die("Could not connect");
  $result = fbsql_db_query("database", "select * from table")
      or die("Query failed");
  # get column metadata
  $i = 0;
  while ($i < fbsql_num_fields($result)) {
      echo "Information for column $i:<br />\n";
      $meta = fbsql_fetch_field($result);
      if (!$meta) {
	  echo "No information available<br />\n";
      }
      echo "<pre>
  max_length:   $meta->max_length
  name:         $meta->name
  not_null:     $meta->not_null
  table:        $meta->table
  type:         $meta->type
  </pre>";
      $i++;
  }
  fbsql_free_result($result);
  ?> 
See also fbsql_field_seek().   fbsql_fetch_assocUpfbsql_fetch_lengths
#

#T=object fbsql_fetch_field ( resource result [, int field_offset])
fbsql_fetch_field ( ^!resource result [, int field_offset]);
#

#T=fbsql_fetch_lengths - array fbsql_fetch_lengths ( [resource result])
(PHP 4 >= 4.0.6)
fbsql_fetch_lengths --  Get the length of each output in a result 
Description
array fbsql_fetch_lengths ( [resource result])
Returns: An array that corresponds to the lengths of each field in the 
last row fetched by fbsql_fetch_row(), or FALSE on error. 
fbsql_fetch_lengths() stores the lengths of each result column in the last 
row returned by fbsql_fetch_row(), fbsql_fetch_array() and 
fbsql_fetch_object() in an array, starting at offset 0. 
See also: fbsql_fetch_row().   fbsql_fetch_fieldUpfbsql_fetch_object
#

#T=array fbsql_fetch_lengths ( [resource result])
fbsql_fetch_lengths ( ^![resource result]);
#

#T=fbsql_fetch_object - object fbsql_fetch_object ( resource result [, int result_type])
(PHP 4 >= 4.0.6)
fbsql_fetch_object -- Fetch a result row as an object
Description
object fbsql_fetch_object ( resource result [, int result_type])
Returns an object with properties that correspond to the fetched row, or 
FALSE if there are no more rows. 
fbsql_fetch_object() is similar to fbsql_fetch_array(), with one 
difference - an object is returned, instead of an array. Indirectly, that 
means that you can only access the data by the field names, and not by 
their offsets (numbers are illegal property names). 
The optional argument result_type is a constant and can take the following 
values: FBSQL_ASSOC, FBSQL_NUM, and FBSQL_BOTH. 
Speed-wise, the function is identical to fbsql_fetch_array(), and almost 
as quick as fbsql_fetch_row() (the difference is insignificant). 
Example 1. fbsql_fetch_object() example
  <?php 
  fbsql_connect($host, $user, $password);
  $result = fbsql_db_query("database", "select * from table");
  while ($row = fbsql_fetch_object($result)) {
      echo $row->user_id;
      echo $row->fullname;
  }
  fbsql_free_result($result);
  ?> 
See also: fbsql_fetch_array() and fbsql_fetch_row().   fbsql_fetch_lengthsUpfbsql_fetch_row
#

#T=object fbsql_fetch_object ( resource result [, int result_type])
fbsql_fetch_object ( ^!resource result [, int result_type]);
#

#T=fbsql_fetch_row - array fbsql_fetch_row ( resource result)
(PHP 4 >= 4.0.6)
fbsql_fetch_row -- Get a result row as an enumerated array
Description
array fbsql_fetch_row ( resource result)
Returns: An array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
fbsql_fetch_row() fetches one row of data from the result associated with 
the specified result identifier. The row is returned as an array. Each 
result column is stored in an array offset, starting at offset 0. 
Subsequent call to fbsql_fetch_row() would return the next row in the 
result set, or FALSE if there are no more rows. 
See also: fbsql_fetch_array(), fbsql_fetch_object(), fbsql_data_seek(), 
fbsql_fetch_lengths(), and fbsql_result().   fbsql_fetch_objectUpfbsql_field_flags
#

#T=array fbsql_fetch_row ( resource result)
fbsql_fetch_row ( ^!resource result);
#

#T=fbsql_field_flags - string fbsql_field_flags ( resource result, int field_offset)
(PHP 4 >= 4.0.6)
fbsql_field_flags --  Get the flags associated with the specified field in 
a result 
Description
string fbsql_field_flags ( resource result, int field_offset)
fbsql_field_flags() returns the field flags of the specified field. The 
flags are reported as a single word per flag separated by a single space, 
so that you can split the returned value using explode().   fbsql_fetch_rowUpfbsql_field_len
#

#T=string fbsql_field_flags ( resource result, int field_offset)
fbsql_field_flags ( ^!resource result, int field_offset);
#

#T=fbsql_field_len - int fbsql_field_len ( resource result, int field_offset)
(PHP 4 >= 4.0.6)
fbsql_field_len --  Returns the length of the specified field 
Description
int fbsql_field_len ( resource result, int field_offset)
fbsql_field_len() returns the length of the specified field.   fbsql_field_flagsUpfbsql_field_name
#

#T=int fbsql_field_len ( resource result, int field_offset)
fbsql_field_len ( ^!resource result, int field_offset);
#

#T=fbsql_field_name - string fbsql_field_name ( resource result, int field_index)
(PHP 4 >= 4.0.6)
fbsql_field_name --  Get the name of the specified field in a result 
Description
string fbsql_field_name ( resource result, int field_index)
fbsql_field_name() returns the name of the specified field index. result 
must be a valid result identifier and field_index is the numerical offset 
of the field. 
Note: field_index starts at 0. 
e.g. The index of the third field would actually be 2, the index of the 
fourth field would be 3 and so on. 
Example 1. fbsql_field_name() example
  <?php
  // The users table consists of three fields: 
  //   user_id
  //   username
  //   password.

  $res = fbsql_db_query("users", "select * from users", $link);

  echo fbsql_field_name($res, 0) . "\n";
  echo fbsql_field_name($res, 2);
  ?> 

The above example would produce the following output: 
user_id
password

  fbsql_field_lenUpfbsql_field_seek
#

#T=string fbsql_field_name ( resource result, int field_index)
fbsql_field_name ( ^!resource result, int field_index);
#

#T=fbsql_field_seek - bool fbsql_field_seek ( resource result, int field_offset)
(PHP 4 >= 4.0.6)
fbsql_field_seek --  Set result pointer to a specified field offset 
Description
bool fbsql_field_seek ( resource result, int field_offset)
Seeks to the specified field offset. If the next call to 
fbsql_fetch_field() doesn't include a field offset, the field offset 
specified in fbsql_field_seek() will be returned. 
See also: fbsql_fetch_field().   fbsql_field_nameUpfbsql_field_table
#

#T=bool fbsql_field_seek ( resource result, int field_offset)
fbsql_field_seek ( ^!resource result, int field_offset);
#

#T=fbsql_field_table - string fbsql_field_table ( resource result, int field_offset)
(PHP 4 >= 4.0.6)
fbsql_field_table --  Get name of the table the specified field is in 
Description
string fbsql_field_table ( resource result, int field_offset)
Returns the name of the table that the specified field is in.   fbsql_field_seekUpfbsql_field_type
#

#T=string fbsql_field_table ( resource result, int field_offset)
fbsql_field_table ( ^!resource result, int field_offset);
#

#T=fbsql_field_type - string fbsql_field_type ( resource result, int field_offset)
(PHP 4 >= 4.0.6)
fbsql_field_type --  Get the type of the specified field in a result 
Description
string fbsql_field_type ( resource result, int field_offset)
fbsql_field_type() is similar to the fbsql_field_name() function. The 
arguments are identical, but the field type is returned instead. The field 
type will be one of "int", "real", "string", "blob", and others as 
detailed in the FrontBase documentation. Example 1. 
fbsql_field_type() example
  <?php 

  fbsql_connect("localhost", "_SYSTEM", "");
  fbsql_select_db("wisconsin");
  $result = fbsql_query("SELECT * FROM onek;");
  $fields = fbsql_num_fields($result);
  $rows   = fbsql_num_rows($result);
  $i = 0;
  $table = fbsql_field_table($result, $i);
  echo "Your '" . $table . "' table has " . $fields . " fields 
  and " . $rows . " records <br />";
  echo "The table has the following fields <br />"; 
  while ($i < $fields) {
      $type  = fbsql_field_type($result, $i);
      $name  = fbsql_field_name($result, $i);
      $len   = fbsql_field_len($result, $i);
      $flags = fbsql_field_flags($result, $i);
      echo $type . " " . $name . " " . $len . " " . $flags . 
  "<br />";
      $i++;
  }
  fbsql_close();

  ?> 

  fbsql_field_tableUpfbsql_free_result
#

#T=string fbsql_field_type ( resource result, int field_offset)
fbsql_field_type ( ^!resource result, int field_offset);
#

#T=fbsql_free_result - bool fbsql_free_result ( resource result)
(PHP 4 >= 4.0.6)
fbsql_free_result -- Free result memory
Description
bool fbsql_free_result ( resource result)
fbsql_free_result() will free all memory associated with the result 
identifier result. 
fbsql_free_result() only needs to be called if you are concerned about how 
much memory is being used for queries that return large result sets. All 
associated result memory is automatically freed at the end of the script's 
execution.   fbsql_field_typeUpfbsql_get_autostart_info
#

#T=bool fbsql_free_result ( resource result)
fbsql_free_result ( ^!resource result);
#

#T=fbsql_get_autostart_info - 
array fbsql_get_autostart_info
(PHP 4 >= 4.1.0)
fbsql_get_autostart_info -- No description given yet
Description
array fbsql_get_autostart_info ( [resource link_identifier])
Warning
This function is currently not documented; only the argument list is 
available.
  fbsql_free_resultUpfbsql_hostname
#

#T=
array fbsql_get_autostart_info

fbsql_get_autostart_info;^!
#

#T=fbsql_hostname - string fbsql_hostname ( resource link_identifier [, string host_name])
(PHP 4 >= 4.0.6)
fbsql_hostname -- Get or set the host name used with a connection
Description
string fbsql_hostname ( resource link_identifier [, string host_name])
Warning
This function is currently not documented; only the argument list is 
available.
  fbsql_get_autostart_infoUpfbsql_insert_id
#

#T=string fbsql_hostname ( resource link_identifier [, string host_name])
fbsql_hostname ( ^!resource link_identifier [, string host_name]);
#

#T=fbsql_insert_id - int fbsql_insert_id ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_insert_id --  Get the id generated from the previous INSERT 
operation 
Description
int fbsql_insert_id ( [resource link_identifier])
fbsql_insert_id() returns the ID generated for an column defined as 
DEFAULT UNIQUE by the previous INSERT query using the given 
link_identifier. If link_identifier isn't specified, the last opened link 
is assumed. 
fbsql_insert_id() returns 0 if the previous query does not generate an 
DEFAULT UNIQUE value. If you need to save the value for later, be sure to 
call fbsql_insert_id() immediately after the query that generates the 
value. 
Note: The value of the FrontBase SQL function fbsql_insert_id() always 
contains the most recently generated DEFAULT UNIQUE value, and is not 
reset between queries.   fbsql_hostnameUpfbsql_list_dbs
#

#T=int fbsql_insert_id ( [resource link_identifier])
fbsql_insert_id ( ^![resource link_identifier]);
#

#T=fbsql_list_dbs - resource fbsql_list_dbs ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_list_dbs --  List databases available on a FrontBase server 
Description
resource fbsql_list_dbs ( [resource link_identifier])
fbsql_list_dbs() will return a result pointer containing the databases 
available from the current fbsql daemon. Use the fbsql_tablename() 
function to traverse this result pointer. 
Example 1. fbsql_list_dbs() example
  $link = fbsql_connect('localhost', 'myname', 'secret');
  $db_list = fbsql_list_dbs($link);

  while ($row = fbsql_fetch_object($db_list)) {
      echo $row->Database . "\n";
  } 

The above example would produce the following output: 
database1
database2
database3
...
Note: The above code would just as easily work with fbsql_fetch_row() or 
other similar functions.   fbsql_insert_idUpfbsql_list_fields
#

#T=resource fbsql_list_dbs ( [resource link_identifier])
fbsql_list_dbs ( ^![resource link_identifier]);
#

#T=fbsql_list_fields - resource fbsql_list_fields ( string database_name, string table_name [, 
(PHP 4 >= 4.0.6)
fbsql_list_fields -- List FrontBase result fields
Description
resource fbsql_list_fields ( string database_name, string table_name [, 
resource link_identifier])
fbsql_list_fields() retrieves information about the given tablename. 
Arguments are the database name and the table name. A result pointer is 
returned which can be used with fbsql_field_flags(), fbsql_field_len(), 
fbsql_field_name(), and fbsql_field_type(). 
A result identifier is a positive integer. The function returns FALSE if 
an error occurs. A string describing the error will be placed in 
$phperrmsg, and unless the function was called as @fbsql() then this error 
string will also be printed out. 
Example 1. fbsql_list_fields() example
  <?php
  $link = fbsql_connect('localhost', 'myname', 'secret');

  $fields = fbsql_list_fields("database1", "table1", $link);
  $columns = fbsql_num_fields($fields);

  for ($i = 0; $i < $columns; $i++) {
      echo fbsql_field_name($fields, $i) . "\n";;
  }
  ?> 

The above example would produce the following output: 
field1
field2
field3
...

  fbsql_list_dbsUpfbsql_list_tables
#

#T=resource fbsql_list_fields ( string database_name, string table_name [, 
fbsql_list_fields ( ^!string database_name, string table_name [, ;
#

#T=fbsql_list_tables - resource fbsql_list_tables ( string database [, resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_list_tables -- List tables in a FrontBase database
Description
resource fbsql_list_tables ( string database [, resource link_identifier])
fbsql_list_tables() takes a database name and returns a result pointer 
much like the fbsql_db_query() function. The fbsql_tablename() function 
should be used to extract the actual table names from the result pointer.   fbsql_list_fieldsUpfbsql_next_result
#

#T=resource fbsql_list_tables ( string database [, resource link_identifier])
fbsql_list_tables ( ^!string database [, resource link_identifier]);
#

#T=fbsql_next_result - bool fbsql_next_result ( resource result_id)
(PHP 4 >= 4.0.6)
fbsql_next_result --  Move the internal result pointer to the next result 
Description
bool fbsql_next_result ( resource result_id)
When sending more than one SQL statement to the server or executing a 
stored procedure with multiple results will cause the server to return 
multiple result sets. This function will test for additional results 
available form the server. If an additional result set exists it will free 
the existing result set and prepare to fetch the words from the new result 
set. The function will return TRUE if an additional result set was 
available or FALSE otherwise. 
Example 1. fbsql_next_result() example
  <?php
      $link = fbsql_connect("localhost", "_SYSTEM", "secret");
      fbsql_select_db("MyDB", $link);
      $SQL = "Select * from table1; select * from table2;";
      $rs = fbsql_query($SQL, $link);
      do {
	  while ($row = fbsql_fetch_row($rs)) {
	  }
      } while (fbsql_next_result($rs));
      fbsql_free_result($rs);
      fbsql_close($link);
  ?> 

  fbsql_list_tablesUpfbsql_num_fields
#

#T=bool fbsql_next_result ( resource result_id)
fbsql_next_result ( ^!resource result_id);
#

#T=fbsql_num_fields - int fbsql_num_fields ( resource result)
(PHP 4 >= 4.0.6)
fbsql_num_fields -- Get number of fields in result
Description
int fbsql_num_fields ( resource result)
fbsql_num_fields() returns the number of fields in a result set. 
See also: fbsql_db_query(), fbsql_query(), fbsql_fetch_field(), and 
fbsql_num_rows().   fbsql_next_resultUpfbsql_num_rows
#

#T=int fbsql_num_fields ( resource result)
fbsql_num_fields ( ^!resource result);
#

#T=fbsql_num_rows - int fbsql_num_rows ( resource result)
(PHP 4 >= 4.0.6)
fbsql_num_rows -- Get number of rows in result
Description
int fbsql_num_rows ( resource result)
fbsql_num_rows() returns the number of rows in a result set. This command 
is only valid for SELECT statements. To retrieve the number of rows 
returned from a INSERT, UPDATE or DELETE query, use fbsql_affected_rows(). 
Example 1. fbsql_num_rows() example
  <?php

  $link = fbsql_connect("localhost", "username", "password"); 
  fbsql_select_db("database", $link);

  $result = fbsql_query("SELECT * FROM table1;", $link); 
  $num_rows = fbsql_num_rows($result); 

  echo "$num_rows Rows\n";

  ?> 
See also: fbsql_affected_rows(), fbsql_connect(), fbsql_select_db(), and 
fbsql_query().   fbsql_num_fieldsUpfbsql_password
#

#T=int fbsql_num_rows ( resource result)
fbsql_num_rows ( ^!resource result);
#

#T=fbsql_password - string fbsql_password ( resource link_identifier [, string password])
(PHP 4 >= 4.0.6)
fbsql_password -- Get or set the user password used with a connection
Description
string fbsql_password ( resource link_identifier [, string password])
Warning
This function is currently not documented; only the argument list is 
available.
  fbsql_num_rowsUpfbsql_pconnect
#

#T=string fbsql_password ( resource link_identifier [, string password])
fbsql_password ( ^!resource link_identifier [, string password]);
#

#T=fbsql_pconnect - resource fbsql_pconnect ( [string hostname [, string username [, string 
(PHP 4 >= 4.0.6)
fbsql_pconnect --  Open a persistent connection to a FrontBase Server 
Description
resource fbsql_pconnect ( [string hostname [, string username [, string 
password]]])
Returns: A positive FrontBase persistent link identifier on success, or 
FALSE on error. 
fbsql_pconnect() establishes a connection to a FrontBase server. The 
following defaults are assumed for missing optional parameters: host = 
'localhost', username = "_SYSTEM" and password = empty password. 
To set Frontbase server port number, use fbsql_select_db(). 
fbsql_pconnect() acts very much like fbsql_connect() with two major 
differences. 
First, when connecting, the function would first try to find a 
(persistent) link that's already open with the same host, username and 
password. If one is found, an identifier for it will be returned instead 
of opening a new connection. 
Second, the connection to the SQL server will not be closed when the 
execution of the script ends. Instead, the link will remain open for 
future use. 
This type of links is therefore called 'persistent'.   fbsql_passwordUpfbsql_query
#

#T=resource fbsql_pconnect ( [string hostname [, string username [, string 
fbsql_pconnect ( ^![string hostname [, string username [, string ;
#

#T=fbsql_query - resource fbsql_query ( string query [, resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_query -- Send a FrontBase query
Description
resource fbsql_query ( string query [, resource link_identifier])
fbsql_query() sends a query to the currently active database on the server 
that's associated with the specified link identifier. If link_identifier 
isn't specified, the last opened link is assumed. If no link is open, the 
function tries to establish a link as if fbsql_connect() was called with 
no arguments, and use it. 
Note: The query string shall always end with a semicolon. 
fbsql_query() returns TRUE (non-zero) or FALSE to indicate whether or not 
the query succeeded. A return value of TRUE means that the query was legal 
and could be executed by the server. It does not indicate anything about 
the number of rows affected or returned. It is perfectly possible for a 
query to succeed but affect no rows or return no rows. 
The following query is syntactically invalid, so fbsql_query() fails and 
returns FALSE: Example 1. fbsql_query() example
  <?php
  $result = fbsql_query("SELECT * WHERE 1=1")
      or die ("Invalid query");
  ?> 
The following query is semantically invalid if my_col is not a column in 
the table my_tbl, so fbsql_query() fails and returns FALSE: Example 
2. fbsql_query() example
  <?php
  $result = fbsql_query ("SELECT my_col FROM my_tbl")
      or die ("Invalid query");
  ?> 
fbsql_query() will also fail and return FALSE if you don't have permission 
to access the table(s) referenced by the query. 
Assuming the query succeeds, you can call fbsql_num_rows() to find out how 
many rows were returned for a SELECT statement or fbsql_affected_rows() to 
find out how many rows were affected by a DELETE, INSERT, REPLACE, or 
UPDATE statement. 
For SELECT statements, fbsql_query() returns a new result identifier that 
you can pass to fbsql_result(). When you are done with the result set, you 
can free the resources associated with it by calling fbsql_free_result(). 
Although, the memory will automatically be freed at the end of the 
script's execution. 
See also: fbsql_affected_rows(), fbsql_db_query(), fbsql_free_result(), 
fbsql_result(), fbsql_select_db(), and fbsql_connect().   fbsql_pconnectUpfbsql_read_blob
#

#T=resource fbsql_query ( string query [, resource link_identifier])
fbsql_query ( ^!string query [, resource link_identifier]);
#

#T=fbsql_read_blob - string fbsql_read_blob ( string blob_handle [, resource link_identifier])
(PHP 4 >= 4.2.0)
fbsql_read_blob -- Read a BLOB from the database
Description
string fbsql_read_blob ( string blob_handle [, resource link_identifier])
Returns: A string containing the BLOB specified by blob_handle. 
fbsql_read_blob() reads BLOB data from the database. If a select statement 
contains BLOB and/or CLOB columns FrontBase will return the data directly 
when data is fetched. This default behavior can be changed with 
fbsql_set_lob_mode() so the fetch functions will return handles to BLOB 
and CLOB data. If a handle is fetched a user must call fbsql_read_blob() 
to get the actual BLOB data from the database. 
Example 1. fbsql_read_blob() example
  <?php
      $link = fbsql_pconnect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      $sql = "SELECT BLOB_COLUMN FROM BLOB_TABLE;";
      $rs = fbsql_query($sql, $link);
      $row_data = fbsql_fetch_row($rs);
      // $row_data[0] will now contain the blob data for the 
  first row
      fbsql_free_result($rs);
      
      $rs = fbsql_query($sql, $link);
      fbsql_set_lob_mode($rs, FBSQL_LOB_HANDLE);
      $row_data = fbsql_fetch_row($rs);
      // $row_data[0] will now contain a handle to the BLOB data 
  in the first row
      $blob_data = fbsql_read_blob($row_data[0]);
      fbsql_free_result($rs);
      
  ?> 
See also: fbsql_create_blob(), fbsql_read_blob(), fbsql_read_clob(), and 
fbsql_set_lob_mode().   fbsql_queryUpfbsql_read_clob
#

#T=string fbsql_read_blob ( string blob_handle [, resource link_identifier])
fbsql_read_blob ( ^!string blob_handle [, resource link_identifier]);
#

#T=fbsql_read_clob - string fbsql_read_clob ( string clob_handle [, resource link_identifier])
(PHP 4 >= 4.2.0)
fbsql_read_clob -- Read a CLOB from the database
Description
string fbsql_read_clob ( string clob_handle [, resource link_identifier])
Returns: A string containing the CLOB specified by clob_handle. 
fbsql_read_clob() reads CLOB data from the database. If a select statement 
contains BLOB and/or CLOB columns FrontBase will return the data directly 
when data is fetched. This default behavior can be changed with 
fbsql_set_lob_mode() so the fetch functions will return handles to BLOB 
and CLOB data. If a handle is fetched a user must call fbsql_read_clob() 
to get the actual CLOB data from the database. 
Example 1. fbsql_read_clob() example
  <?php
      $link = fbsql_pconnect("localhost", "_SYSTEM", "secret")
	  or die("Could not connect");
      $sql = "SELECT CLOB_COLUMN FROM CLOB_TABLE;";
      $rs = fbsql_query($sql, $link);
      $row_data = fbsql_fetch_row($rs);
      // $row_data[0] will now contain the clob data for the 
  first row
      fbsql_free_result($rs);
      
      $rs = fbsql_query($sql, $link);
      fbsql_set_lob_mode($rs, FBSQL_LOB_HANDLE);
      $row_data = fbsql_fetch_row($rs);
      // $row_data[0] will now contain a handle to the CLOB data 
  in the first row
      $clob_data = fbsql_read_clob($row_data[0]);
      fbsql_free_result($rs);
      
  ?> 
See also: fbsql_create_blob(), fbsql_read_blob(), fbsql_read_clob(), and 
fbsql_set_lob_mode().   fbsql_read_blobUpfbsql_result
#

#T=string fbsql_read_clob ( string clob_handle [, resource link_identifier])
fbsql_read_clob ( ^!string clob_handle [, resource link_identifier]);
#

#T=fbsql_result - mixed fbsql_result ( resource result, int row [, mixed field])
(PHP 4 >= 4.0.6)
fbsql_result -- Get result data
Description
mixed fbsql_result ( resource result, int row [, mixed field])
fbsql_result() returns the contents of one cell from a FrontBase result 
set. The field argument can be the field's offset, or the field's name, or 
the field's table dot field's name (tabledname.fieldname). If the column 
name has been aliased ('select foo as bar from...'), use the alias instead 
of the column name. 
When working on large result sets, you should consider using one of the 
functions that fetch an entire row (specified below). As these functions 
return the contents of multiple cells in one function call, they're MUCH 
quicker than fbsql_result(). Also, note that specifying a numeric offset 
for the field argument is much quicker than specifying a fieldname or 
tablename.fieldname argument. 
Calls to fbsql_result() should not be mixed with calls to other functions 
that deal with the result set. 
Recommended high-performance alternatives: fbsql_fetch_row(), 
fbsql_fetch_array(), and fbsql_fetch_object().   fbsql_read_clobUpfbsql_rollback
#

#T=mixed fbsql_result ( resource result, int row [, mixed field])
fbsql_result ( ^!resource result, int row [, mixed field]);
#

#T=fbsql_rollback - bool fbsql_rollback ( [resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_rollback -- Rollback a transaction to the database
Description
bool fbsql_rollback ( [resource link_identifier])
Returns TRUE on success or FALSE on failure. 
fbsql_rollback() ends the current transaction by rolling back all 
statements issued since last commit. This command is only needed if 
autocommit is set to false. 
See also: fbsql_autocommit() and fbsql_commit()   fbsql_resultUpfbsql_select_db
#

#T=bool fbsql_rollback ( [resource link_identifier])
fbsql_rollback ( ^![resource link_identifier]);
#

#T=fbsql_select_db - bool fbsql_select_db ( string database_name [, resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_select_db -- Select a FrontBase database
Description
bool fbsql_select_db ( string database_name [, resource link_identifier])
fbsql_select_db() sets the current active database on the server that's 
associated with the specified link identifier. If no link identifier is 
specified, the last opened link is assumed. If no link is open, the 
function will try to establish a link as if fbsql_connect() was called, 
and use it. 
Returns TRUE on success or FALSE on failure. 
The client contacts FBExec to obtain the port number to use for the 
connection to the database. If the database name is a number the system 
will use that as a port number and it will not ask FBExec for the port 
number. The FrontBase server can be stared as FRontBase -FBExec=No 
-port=<port number> <database name>. 
Every subsequent call to fbsql_query() will be made on the active 
database. 
if the database is protected with a database password, the user must call 
fbsql_database_password() before selecting the database. 
See also fbsql_connect(), fbsql_pconnect(), fbsql_database_password(), and 
fbsql_query().   fbsql_rollbackUpfbsql_set_lob_mode
#

#T=bool fbsql_select_db ( string database_name [, resource link_identifier])
fbsql_select_db ( ^!string database_name [, resource link_identifier]);
#

#T=fbsql_set_lob_mode - bool fbsql_set_lob_mode ( resource result, string database_name)
(PHP 4 >= 4.2.0)
fbsql_set_lob_mode --  Set the LOB retrieve mode for a FrontBase result 
set 
Description
bool fbsql_set_lob_mode ( resource result, string database_name)
Returns: TRUE on success, FALSE on error. 
fbsql_set_lob_mode() sets the mode for retrieving LOB data from the 
database. When BLOB and CLOB data is stored in FrontBase it can be stored 
direct or indirect. Direct stored LOB data will always be fetched no 
matter the setting of the lob mode. If the LOB data is less than 512 bytes 
it will always be stored directly. 
FBSQL_LOB_DIRECT - LOB data is retrieved directly. When data is fetched 
from the database with fbsql_fetch_row(), and other fetch functions, all 
CLOB and BLOB columns will be returned as ordinary columns. This is the 
default value on a new FrontBase result. 
FBSQL_LOB_HANDLE - LOB data is retrieved as handles to the data. When 
data is fetched from the database with fbsql_fetch_row (), and other 
fetch functions, LOB data will be returned as a handle to the data if 
the data is stored indirect or the data if it is stored direct. If a 
handle is returned it will be a 27 byte string formatted as 
"@'000000000000000000000000'". 
See also: fbsql_create_blob(), fbsql_create_clob(), fbsql_read_blob(), and 
fbsql_read_clob().   fbsql_select_dbUpfbsql_set_transaction
#

#T=bool fbsql_set_lob_mode ( resource result, string database_name)
fbsql_set_lob_mode ( ^!resource result, string database_name);
#

#T=fbsql_set_transaction - void fbsql_set_transaction ( resource link_identifier, int Locking, int 
(PHP 4 >= 4.2.0)
fbsql_set_transaction --  Set the transaction locking and isolation 
Description
void fbsql_set_transaction ( resource link_identifier, int Locking, int 
Isolation)
Warning
This function is currently not documented; only the argument list is 
available.
  fbsql_set_lob_modeUpfbsql_start_db
#

#T=void fbsql_set_transaction ( resource link_identifier, int Locking, int 
fbsql_set_transaction ( ^!resource link_identifier, int Locking, int ;
#

#T=fbsql_start_db - bool fbsql_start_db ( string database_name [, resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_start_db -- Start a database on local or remote server
Description
bool fbsql_start_db ( string database_name [, resource link_identifier])
Returns TRUE on success or FALSE on failure. 
fbsql_start_db() 
See also: fbsql_db_status() and fbsql_stop_db().   fbsql_set_transactionUpfbsql_stop_db
#

#T=bool fbsql_start_db ( string database_name [, resource link_identifier])
fbsql_start_db ( ^!string database_name [, resource link_identifier]);
#

#T=fbsql_stop_db - bool fbsql_stop_db ( string database_name [, resource link_identifier])
(PHP 4 >= 4.0.6)
fbsql_stop_db -- Stop a database on local or remote server
Description
bool fbsql_stop_db ( string database_name [, resource link_identifier])
Returns TRUE on success or FALSE on failure. 
fbsql_stop_db() 
See also: fbsql_db_status() and fbsql_start_db().   fbsql_start_dbUpfbsql_tablename
#

#T=bool fbsql_stop_db ( string database_name [, resource link_identifier])
fbsql_stop_db ( ^!string database_name [, resource link_identifier]);
#

#T=fbsql_tablename - string fbsql_tablename ( resource result, int i)
(PHP 4 >= 4.2.0)
fbsql_tablename -- Get table name of field
Description
string fbsql_tablename ( resource result, int i)
fbsql_tablename() takes a result pointer returned by the 
fbsql_list_tables() function as well as an integer index and returns the 
name of a table. The fbsql_num_rows() function may be used to determine 
the number of tables in the result pointer. Example 1. 
fbsql_tablename() example
  <?php 
  fbsql_connect("localhost", "_SYSTEM", "");
  $result = fbsql_list_tables("wisconsin");
  $i = 0;
  while ($i < fbsql_num_rows($result)) {
      $tb_names[$i] = fbsql_tablename($result, $i);
      echo $tb_names[$i] . "<br />";
      $i++;
  }
  ?> 

  fbsql_stop_dbUpfbsql_username
#

#T=string fbsql_tablename ( resource result, int i)
fbsql_tablename ( ^!resource result, int i);
#

#T=fbsql_username - string fbsql_username ( resource link_identifier [, string username])
(PHP 4 >= 4.0.6)
fbsql_username -- Get or set the host user used with a connection
Description
string fbsql_username ( resource link_identifier [, string username])
Warning
This function is currently not documented; only the argument list is 
available.
  fbsql_tablenameUpfbsql_warnings
#

#T=string fbsql_username ( resource link_identifier [, string username])
fbsql_username ( ^!resource link_identifier [, string username]);
#

#T=fbsql_warnings - bool fbsql_warnings ( [bool OnOff])
(PHP 4 >= 4.0.6)
fbsql_warnings -- Enable or disable FrontBase warnings
Description
bool fbsql_warnings ( [bool OnOff])
Returns TRUE if warnings is turned on otherwise FALSE. 
fbsql_warnings() enables or disables FrontBase warnings.   fbsql_usernameUpfilePro functions
#

#T=bool fbsql_warnings ( [bool OnOff])
fbsql_warnings ( ^![bool OnOff]);
#

#T=fclose - bool fclose ( resource handle)
(PHP 3, PHP 4 )
fclose -- Closes an open file pointer
Description
bool fclose ( resource handle)
The file pointed to by handle is closed. 
Returns TRUE on success or FALSE on failure. 
The file pointer must be valid, and must point to a file successfully 
opened by fopen() or fsockopen(). 
Example 1. A simple fclose() example
  <?php

    $handle = fopen('somefile.txt', 'r');
    
    fclose($handle);
    
  ?> 

  diskfreespaceUpfeof
#

#T=bool fclose ( resource handle)
fclose ( ^!resource handle);
#

#T=fdf_add_doc_javascript - bool fdf_add_doc_javascript ( resource fdfdoc, string script_name, string 
(PHP 4 >= 4.3.0)
fdf_add_doc_javascript -- Adds javascript code to the FDF document
Description
bool fdf_add_doc_javascript ( resource fdfdoc, string script_name, string 
script_code)
Adds a script to the FDF, which Acrobat then adds to the doc-level scripts 
of a document, once the FDF is imported into it. It is strongly suggested 
to use '\r' for linebreaks within script_code. 
Example 1. Adding JavaScript code to a FDF
  <?php
  $fdf = fdf_create();
  fdf_add_doc_javascript($fdf, "PlusOne", "function 
  PlusOne(x)\r{\r  return x+1;\r}\r");
  fdf_save($fdf);
  ?> 

will create a FDF like this:
%FDF-1.2
%
1 0 obj
<< 
/FDF << /JavaScript << /Doc [ (PlusOne)(function PlusOne\(x\)\r{\r  return x+1;\r}\r)] >> >> 
>> 
endobj
trailer
<<
/Root 1 0 R 

>>
%%EOF

  Forms Data Format functionsUpfdf_add_template
#

#T=bool fdf_add_doc_javascript ( resource fdfdoc, string script_name, string 
fdf_add_doc_javascript ( ^!resource fdfdoc, string script_name, string ;
#

#T=fdf_add_template - bool fdf_add_template ( resource fdfdoc, int newpage, string filename, 
(PHP 3>= 3.0.13, PHP 4 )
fdf_add_template -- Adds a template into the FDF document
Description
bool fdf_add_template ( resource fdfdoc, int newpage, string filename, 
string template, int rename)
Warning
This function is currently not documented; only the argument list is 
available.
  fdf_add_doc_javascriptUpfdf_close
#

#T=bool fdf_add_template ( resource fdfdoc, int newpage, string filename, 
fdf_add_template ( ^!resource fdfdoc, int newpage, string filename, ;
#

#T=fdf_close - bool fdf_close ( resource fdf_document)
(PHP 3>= 3.0.6, PHP 4 )
fdf_close -- Close an FDF document
Description
bool fdf_close ( resource fdf_document)
The fdf_close() function closes the FDF document.
See also fdf_open().  fdf_add_templateUpfdf_create
#

#T=bool fdf_close ( resource fdf_document)
fdf_close ( ^!resource fdf_document);
#

#T=fdf_create - resource fdf_create ( void )
(PHP 3>= 3.0.6, PHP 4 )
fdf_create -- Create a new FDF document
Description
resource fdf_create ( void )
The fdf_create() creates a new FDF document. This function is needed if 
one would like to populate input fields in a PDF document with data.
Example 1. Populating a PDF document
  <?php
  $outfdf = fdf_create();
  fdf_set_value($outfdf, "volume", $volume, 0);

  fdf_set_file($outfdf, "http:/testfdf/resultlabel.pdf");
  fdf_save($outfdf, "outtest.fdf");
  fdf_close($outfdf);
  Header("Content-type: application/vnd.fdf");
  $fp = fopen("outtest.fdf", "r");
  fpassthru($fp);
  unlink("outtest.fdf");
  ?> 
See also fdf_close(), fdf_save(), fdf_open().  fdf_closeUpfdf_enum_values
#

#T=resource fdf_create ( void )
fdf_create ( ^!void );
#

#T=fdf_enum_values - bool fdf_enum_values ( resource fdfdoc, callback function [, mixed 
(PHP 4 >= 4.3.0)
fdf_enum_values -- Call a user defined function for each document value 
Description
bool fdf_enum_values ( resource fdfdoc, callback function [, mixed 
userdata])
Warning
This function is currently not documented; only the argument list is 
available.
  fdf_createUpfdf_errno
#

#T=bool fdf_enum_values ( resource fdfdoc, callback function [, mixed 
fdf_enum_values ( ^!resource fdfdoc, callback function [, mixed ;
#

#T=fdf_errno - int fdf_errno ( void )
(PHP 4 >= 4.3.0)
fdf_errno -- Return error code for last fdf operation
Description
int fdf_errno ( void )
fdf_errno() returns the error code set by the last fdf_...() function 
call. This is zero for a successfull operation or a non-zero error code on 
failure. A textual description may be obtained using the fdf_error() 
function. 
See also fdf_error().   fdf_enum_valuesUpfdf_error
#

#T=int fdf_errno ( void )
fdf_errno ( ^!void );
#

#T=fdf_error - 
string fdf_error ( [int e
(PHP 4 >= 4.3.0)
fdf_error -- Return error description for fdf error code
Description
string fdf_error ( [int error_code])
fdf_error() returns a textual description for the fdf error code given in 
error_code. The function uses the internal error code set by the last 
operation if no error_code is given, so fdf_error() is a convenient 
shortcut for fdf_error(fdf_errno()). 
See also fdf_errno().   fdf_errnoUpfdf_get_ap
#

#T=
string fdf_error ( [int e

fdf_error ( ^![int e;
#

#T=fdf_get_ap - bool fdf_get_ap ( resource fdf_document, string field, int face, string 
(PHP 4 >= 4.3.0)
fdf_get_ap -- Get the appearance of a field
Description
bool fdf_get_ap ( resource fdf_document, string field, int face, string 
filename)
The fdf_get_ap() function gets the appearance of a field (i.e. the value 
of the /AP key) and stores it in a file. The possible values of face are 
FDFNormalAP, FDFRolloverAP and FDFDownAP. The appearance is stored in 
filename.   fdf_errorUpfdf_get_attachment
#

#T=bool fdf_get_ap ( resource fdf_document, string field, int face, string 
fdf_get_ap ( ^!resource fdf_document, string field, int face, string ;
#

#T=fdf_get_attachment - array fdf_get_attachment ( resource fdf_document, string fieldname, string 
(PHP 4 >= 4.3.0)
fdf_get_attachment -- Extracts uploaded file embedded in the FDF
Description
array fdf_get_attachment ( resource fdf_document, string fieldname, string 
savepath)
Extracts a file uploaded by means of the "file selection" field fieldname 
and stores it under savepath. savepath may be the name of a plain file or 
an existing directory in which the file is to be created under its 
original name. Any existing file under the same name will be overwritten. 
Note: There seems to be no other way to find out the original filename 
but to store the file using a directory as savepath and check for the 
basename it was stored under. 
The returned array contains the following fields: 
path - path were the file got stored
size - size of the stored file in bytes
type - mimetype if given in the FDF
Example 1. Storing an uploaded file
  <?php 
    $fdf = fdf_open_string($HTTP_FDF_DATA);
    $data = fdf_get_attachment($fdf, "filename", "/tmpdir");
    echo "The uploaded file is stored in $data[path]";
  ?> 

  fdf_get_apUpfdf_get_encoding
#

#T=array fdf_get_attachment ( resource fdf_document, string fieldname, string 
fdf_get_attachment ( ^!resource fdf_document, string fieldname, string ;
#

#T=fdf_get_encoding - string fdf_get_encoding ( resource fdf_document)
(PHP 4 >= 4.3.0)
fdf_get_encoding -- Get the value of the /Encoding key
Description
string fdf_get_encoding ( resource fdf_document)
The fdf_get_encoding() returns the value of the /Encoding key. An empty 
string is returned if the default PDFDocEncoding/Unicode scheme is used. 
See also fdf_set_encoding().   fdf_get_attachmentUpfdf_get_file
#

#T=string fdf_get_encoding ( resource fdf_document)
fdf_get_encoding ( ^!resource fdf_document);
#

#T=fdf_get_file - string fdf_get_file ( resource fdf_document)
(PHP 3>= 3.0.6, PHP 4 )
fdf_get_file -- Get the value of the /F key
Description
string fdf_get_file ( resource fdf_document)
The fdf_set_file() returns the value of the /F key. 
See also fdf_set_file().  fdf_get_encodingUpfdf_get_flags
#

#T=string fdf_get_file ( resource fdf_document)
fdf_get_file ( ^!resource fdf_document);
#

#T=fdf_get_flags - fdf_get_flags ( void )
(PHP 4 >= 4.3.0)
fdf_get_flags -- Gets the flags of a field
Description
fdf_get_flags ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  fdf_get_fileUpfdf_get_opt
#

#T=fdf_get_flags ( void )
( void ^!);
#

#T=fdf_get_opt - mixed fdf_get_opt ( resource fdfdof, string fieldname [, int element])
(PHP 4 >= 4.3.0)
fdf_get_opt -- Gets a value from the opt array of a field
Description
mixed fdf_get_opt ( resource fdfdof, string fieldname [, int element])
Warning
This function is currently not documented; only the argument list is 
available.
  fdf_get_flagsUpfdf_get_status
#

#T=mixed fdf_get_opt ( resource fdfdof, string fieldname [, int element])
fdf_get_opt ( ^!resource fdfdof, string fieldname [, int element]);
#

#T=fdf_get_status - string fdf_get_status ( resource fdf_document)
(PHP 3>= 3.0.6, PHP 4 )
fdf_get_status -- Get the value of the /STATUS key
Description
string fdf_get_status ( resource fdf_document)
The fdf_get_status() returns the value of the /STATUS key. 
See also fdf_set_status().   fdf_get_optUpfdf_get_value
#

#T=string fdf_get_status ( resource fdf_document)
fdf_get_status ( ^!resource fdf_document);
#

#T=fdf_get_value - string fdf_get_value ( resource fdf_document, string fieldname [, int 
(PHP 3>= 3.0.6, PHP 4 )
fdf_get_value -- Get the value of a field
Description
string fdf_get_value ( resource fdf_document, string fieldname [, int 
which])
The fdf_get_value() function returns the value for the requested 
fieldname. 
Elements of an array field can be retrieved by passing the optional which, 
starting at zero. For non-array fields the optional parameter which will 
be ignored. 
Note: Array support and optional which parameter were added in PHP 4.3. 
See also fdf_set_value().   fdf_get_statusUpfdf_get_version
#

#T=string fdf_get_value ( resource fdf_document, string fieldname [, int 
fdf_get_value ( ^!resource fdf_document, string fieldname [, int ;
#

#T=fdf_get_version - string fdf_get_version ( [resource fdf_document])
(PHP 4 >= 4.3.0)
fdf_get_version -- Gets version number for FDF API or file 
Description
string fdf_get_version ( [resource fdf_document])
This function will return the fdf version for the given fdf_document, or 
the toolkit API version number if no parameter is given. 
For the current FDF toolkit 5.0 the API version number is '5.0' and the 
document version number is either '1.2', '1.3' or '1.4'. 
See also fdf_set_version().   fdf_get_valueUpfdf_header
#

#T=string fdf_get_version ( [resource fdf_document])
fdf_get_version ( ^![resource fdf_document]);
#

#T=fdf_header - bool fdf_header ( void )
(PHP 4 >= 4.3.0)
fdf_header -- Sets FDF-specific output headers
Description
bool fdf_header ( void )
This is a convenience function to set appropriate HTTP headers for FDF 
output. It sets the Content-type: to application/vnd.fdf.   fdf_get_versionUpfdf_next_field_name
#

#T=bool fdf_header ( void )
fdf_header ( ^!void );
#

#T=fdf_next_field_name - string fdf_next_field_name ( resource fdf_document [, string fieldname])
(PHP 3>= 3.0.6, PHP 4 )
fdf_next_field_name -- Get the next field name
Description
string fdf_next_field_name ( resource fdf_document [, string fieldname])
The fdf_next_field_name() function returns the name of the field after the 
field in fieldname or the field name of the first field if the second 
parameter is NULL. 
Example 1. Detecting all fieldnames in a FDF
  <?php
    $fdf = fdf_open($HTTP_FDF_DATA);
    for ($field = fdf_next_field_name($fdf); 
       $field != ""; 
       $field = fdf_next_field_name($fdf, $field)) {
      echo "field: $field\n";
    } 
  ?> 
See also fdf_enum_fields() and fdf_get_value().   fdf_headerUpfdf_open_string
#

#T=string fdf_next_field_name ( resource fdf_document [, string fieldname])
fdf_next_field_name ( ^!resource fdf_document [, string fieldname]);
#

#T=fdf_open_string - resource fdf_open_string ( string fdf_data)
(PHP 4 >= 4.3.0)
fdf_open_string -- Read a FDF document from a string
Description
resource fdf_open_string ( string fdf_data)
The fdf_open_string() function reads form data from a string. fdf_data 
must contain the data as returned from a PDF form or created using 
fdf_create() and fdf_save_string(). 
You can fdf_open_string() together with $HTTP_FDF_DATA to process fdf form 
input from a remote client. 
Example 1. Accessing the form data
  <?php
  $fdf = fdf_open_string($HTTP_FDF_DATA);
  /* ... */
  fdf_close($fdf);
  ?> 
See also fdf_open(), fdf_close(), fdf_create() and fdf_save_string().   fdf_next_field_nameUpfdf_open
#

#T=resource fdf_open_string ( string fdf_data)
fdf_open_string ( ^!string fdf_data);
#

#T=fdf_open - resource fdf_open ( string filename)
(PHP 3>= 3.0.6, PHP 4 )
fdf_open -- Open a FDF document
Description
resource fdf_open ( string filename)
The fdf_open() function opens a file with form data. This file must 
contain the data as returned from a PDF form or created using fdf_create() 
and fdf_save(). 
You can process the results of a PDF form POST request by writing the data 
received in $HTTP_FDF_DATA to a file and open it using fdf_open(). 
Starting with PHP 4.3 you can also use fdf_open_string() which handles 
temporary file creation and cleanup for you. 
Example 1. Accessing the form data
  <?php
  // Save the FDF data into a temp file
  $fdffp = fopen("test.fdf", "w");
  fwrite($fdffp, $HTTP_FDF_DATA, strlen($HTTP_FDF_DATA));
  fclose($fdffp);

  // Open temp file and evaluate data
  $fdf = fdf_open("test.fdf");
  /* ... */
  fdf_close($fdf);
  ?> 
See also fdf_open_string(), fdf_close(), fdf_create() and fdf_save().   fdf_open_stringUpfdf_remove_item
#

#T=resource fdf_open ( string filename)
fdf_open ( ^!string filename);
#

#T=fdf_remove_item - bool fdf_remove_item ( resource fdfdoc, string fieldname, int item)
(PHP 4 >= 4.3.0)
fdf_remove_item -- Sets target frame for form
Description
bool fdf_remove_item ( resource fdfdoc, string fieldname, int item)
Warning
This function is currently not documented; only the argument list is 
available.
  fdf_openUpfdf_save_string
#

#T=bool fdf_remove_item ( resource fdfdoc, string fieldname, int item)
fdf_remove_item ( ^!resource fdfdoc, string fieldname, int item);
#

#T=fdf_save_string - string fdf_save_string ( resource fdf_document)
(PHP 4 >= 4.3.0)
fdf_save_string -- Returns the FDF document as a string
Description
string fdf_save_string ( resource fdf_document)
The fdf_save_string() function returns the FDF document as a string. 
Example 1. Retrieving FDF as a string
  <?php
  $fdf = fdf_create();
  fdf_set_value($fdf, "foo", "bar");
  $str = fdf_save_string($fdf);
  fdf_close($fdf);
  echo $str;
  ?> 

will output something like 
%FDF-1.2
%
1 0 obj
<< 
/FDF << /Fields 2 0 R >> 
>> 
endobj
2 0 obj
[ 
<< /T (foo)/V (bar)>> 
]
endobj
trailer
<<
/Root 1 0 R 

>>
%%EOF
See also fdf_save(), fdf_open_string(), fdf_create() and fdf_close().   fdf_remove_itemUpfdf_save
#

#T=string fdf_save_string ( resource fdf_document)
fdf_save_string ( ^!resource fdf_document);
#

#T=fdf_save - bool fdf_save ( resource fdf_document [, string filename])
(PHP 3>= 3.0.6, PHP 4 )
fdf_save -- Save a FDF document
Description
bool fdf_save ( resource fdf_document [, string filename])
The fdf_save() function saves a FDF document. The resulting FDF will be 
written to filename. Without a filename fdf_save() will write the FDF to 
the default PHP output stream. 
See also fdf_save_string(), fdf_create() and fdf_close().   fdf_save_stringUpfdf_set_ap
#

#T=bool fdf_save ( resource fdf_document [, string filename])
fdf_save ( ^!resource fdf_document [, string filename]);
#

#T=fdf_set_ap - bool fdf_set_ap ( resource fdf_document, string field_name, int face, 
(PHP 3>= 3.0.6, PHP 4 )
fdf_set_ap -- Set the appearance of a field
Description
bool fdf_set_ap ( resource fdf_document, string field_name, int face, 
string filename, int page_number)
The fdf_set_ap() function sets the appearance of a field (i.e. the value 
of the /AP key). The possible values of face are FDFNormalAP, 
FDFRolloverAP and FDFDownAP.   fdf_saveUpfdf_set_encoding
#

#T=bool fdf_set_ap ( resource fdf_document, string field_name, int face, 
fdf_set_ap ( ^!resource fdf_document, string field_name, int face, ;
#

#T=fdf_set_encoding - bool fdf_set_encoding ( resource fdf_document, string encoding)
(PHP 4 >= 4.1.0)
fdf_set_encoding -- Sets FDF character encoding
Description
bool fdf_set_encoding ( resource fdf_document, string encoding)
fdf_set_encoding() sets the character encoding in FDF document 
fdf_document. encoding should be the valid encoding name. Currently the 
following values are supported: "Shift-JIS", "UHC", "GBK","BigFive". An 
empty string resets the encoding to the default PDFDocEncoding/Unicode 
scheme.   fdf_set_apUpfdf_set_file
#

#T=bool fdf_set_encoding ( resource fdf_document, string encoding)
fdf_set_encoding ( ^!resource fdf_document, string encoding);
#

#T=fdf_set_file - bool fdf_set_file ( resource fdf_document, string url [, string 
(PHP 3>= 3.0.6, PHP 4 )
fdf_set_file -- Set PDF document to display FDF data in
Description
bool fdf_set_file ( resource fdf_document, string url [, string 
target_frame])
The fdf_set_file() selects a different PDF document to display the form 
results in then the form it originated from. The url needs to be given as 
an absolute URL. 
The frame to display the document in may be selected using the optional 
parameter target_frame or the function fdf_set_target_frame(). 
Example 1. Passing FDF data to a second form
  <?php
    /* set content type for Adobe FDF */
    fdf_header();

    /* start new fdf */
    $fdf = fdf_create();
      
    /* set field "foo" to value "bar" */
    $fdf_set_value($fdf, "foo", "bar");

    /* tell client to display FDF data using "fdf_form.pdf" */
    fdf_set_file($fdf, "http://www.example.com/fdf_form.pdf");

    /* output fdf */
    fdf_save();

    /* clean up */
    fdf_close();
  ?> 
See also fdf_get_file() and fdf_set_target_frame().   fdf_set_encodingUpfdf_set_flags
#

#T=bool fdf_set_file ( resource fdf_document, string url [, string 
fdf_set_file ( ^!resource fdf_document, string url [, string ;
#

#T=fdf_set_flags - bool fdf_set_flags ( resource fdf_document, string fieldname, int 
(PHP 4 >= 4.0.2)
fdf_set_flags -- Sets a flag of a field
Description
bool fdf_set_flags ( resource fdf_document, string fieldname, int 
whichFlags, int newFlags)
The fdf_set_flags() sets certain flags of the given field fieldname. 
See also fdf_set_opt().   fdf_set_fileUpfdf_set_javascript_action
#

#T=bool fdf_set_flags ( resource fdf_document, string fieldname, int 
fdf_set_flags ( ^!resource fdf_document, string fieldname, int ;
#

#T=fdf_set_javascript_action - bool fdf_set_javascript_action ( resource fdf_document, string fieldname, 
(PHP 4 >= 4.0.2)
fdf_set_javascript_action -- Sets an javascript action of a field
Description
bool fdf_set_javascript_action ( resource fdf_document, string fieldname, 
int trigger, string script)
fdf_set_javascript_action() sets a javascript action for the given field 
fieldname. 
See also fdf_set_submit_form_action().   fdf_set_flagsUpfdf_set_opt
#

#T=bool fdf_set_javascript_action ( resource fdf_document, string fieldname, 
fdf_set_javascript_action ( ^!resource fdf_document, string fieldname, ;
#

#T=fdf_set_opt - bool fdf_set_opt ( resource fdf_document, string fieldname, int element, 
(PHP 4 >= 4.0.2)
fdf_set_opt -- Sets an option of a field
Description
bool fdf_set_opt ( resource fdf_document, string fieldname, int element, 
string str1, string str2)
The fdf_set_opt() sets options of the given field fieldname. 
See also fdf_set_flags().   fdf_set_javascript_actionUpfdf_set_status
#

#T=bool fdf_set_opt ( resource fdf_document, string fieldname, int element, 
fdf_set_opt ( ^!resource fdf_document, string fieldname, int element, ;
#

#T=fdf_set_status - bool fdf_set_status ( resource fdf_document, string status)
(PHP 3>= 3.0.6, PHP 4 )
fdf_set_status -- Set the value of the /STATUS key
Description
bool fdf_set_status ( resource fdf_document, string status)
The fdf_set_status() sets the value of the /STATUS key. When a client 
receives a FDF with a status set it will present the value in an alert 
box. 
See also fdf_get_status().   fdf_set_optUpfdf_set_submit_form_action
#

#T=bool fdf_set_status ( resource fdf_document, string status)
fdf_set_status ( ^!resource fdf_document, string status);
#

#T=fdf_set_submit_form_action - bool fdf_set_submit_form_action ( resource fdf_document, string fieldname, 
(PHP 4 >= 4.0.2)
fdf_set_submit_form_action -- Sets a submit form action of a field
Description
bool fdf_set_submit_form_action ( resource fdf_document, string fieldname, 
int trigger, string script, int flags)
The fdf_set_submit_form_action() sets a submit form action for the given 
field fieldname. 
See also fdf_set_javascript_action().   fdf_set_statusUpfdf_set_target_frame
#

#T=bool fdf_set_submit_form_action ( resource fdf_document, string fieldname, 
fdf_set_submit_form_action ( ^!resource fdf_document, string fieldname, ;
#

#T=fdf_set_target_frame - bool fdf_set_target_frame ( resource fdf_document, string frame_name)
(PHP 4 >= 4.3.0)
fdf_set_target_frame -- Set target frame for form display
Description
bool fdf_set_target_frame ( resource fdf_document, string frame_name)
Sets the target frame to display a result PDF defined with fdf_save_file() 
in. 
See also fdf_save_file().   fdf_set_submit_form_actionUpfdf_set_value
#

#T=bool fdf_set_target_frame ( resource fdf_document, string frame_name)
fdf_set_target_frame ( ^!resource fdf_document, string frame_name);
#

#T=fdf_set_value - bool fdf_set_value ( resource fdf_document, string fieldname, mixed value 
(PHP 3>= 3.0.6, PHP 4 )
fdf_set_value -- Set the value of a field
Description
bool fdf_set_value ( resource fdf_document, string fieldname, mixed value 
[, int isName])
The fdf_set_value() function sets the value for a field named fieldname. 
The value will be stored as a string unless it is an array. In this case 
all array elements will be stored as a value array. 
Note: In older versions of the fdf toolkit last parameter determined if 
the field value was to be converted to a PDF Name (isName = 1) or set to 
a PDF String (isName = 0). The value is no longer used in the current 
toolkit version 5.0. For compatibility reasons it is still supported as 
an optional parameter beginning with PHP 4.3, but ignored internally. 
Support for value arrays was added in PHP 4.3. 
See also fdf_get_value() and fdf_remove_item().   fdf_set_target_frameUpfdf_set_version
#

#T=bool fdf_set_value ( resource fdf_document, string fieldname, mixed value 
fdf_set_value ( ^!resource fdf_document, string fieldname, mixed value ;
#

#T=fdf_set_version - string fdf_set_version ( resource fdf_document, string version)
(PHP 4 >= 4.3.0)
fdf_set_version -- Sets version number for a FDF file 
Description
string fdf_set_version ( resource fdf_document, string version)
This function will set the fdf version for the given fdf_document. Some 
features supported by this extension are only available in newer fdf 
versions. For the current FDF toolkit 5.0 version may be either '1.2', 
'1.3' or '1.4'. 
See also fdf_get_version().   fdf_set_valueUpFriBiDi functions
#

#T=string fdf_set_version ( resource fdf_document, string version)
fdf_set_version ( ^!resource fdf_document, string version);
#

#T=feof - bool feof ( resource handle)
(PHP 3, PHP 4 )
feof -- Tests for end-of-file on a file pointer
Description
bool feof ( resource handle)
Returns TRUE if the file pointer is at EOF or an error occurs (including 
socket timeout); otherwise returns FALSE. 
Warning
feof() will return TRUE only if the connection opened by fsockopen() 
is closed. This can cause a script to timeout. The workaround for 
this is to use stream_set_timeout(), so that feof() will return 
FALSE on timeout. 

The file pointer must be valid, and must point to a file successfully 
opened by fopen(), popen(), or fsockopen().   fcloseUpfflush
#

#T=bool feof ( resource handle)
feof ( ^!resource handle);
#

#T=fflush - bool fflush ( resource handle)
(PHP 4 >= 4.0.1)
fflush -- Flushes the output to a file
Description
bool fflush ( resource handle)
This function forces a write of all buffered output to the resource 
pointed to by the file handle handle. Returns TRUE if successful, FALSE 
otherwise. 
The file pointer must be valid, and must point to a file successfully 
opened by fopen(), popen(), or fsockopen().   feofUpfgetc
#

#T=bool fflush ( resource handle)
fflush ( ^!resource handle);
#

#T=fgetc - string fgetc ( resource handle)
(PHP 3, PHP 4 )
fgetc -- Gets character from file pointer
Description
string fgetc ( resource handle)
Returns a string containing a single character read from the file pointed 
to by handle. Returns FALSE on EOF. 
The file pointer must be valid, and must point to a file successfully 
opened by fopen(), popen(), or fsockopen(). 
Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

Example 1. A fgetc() example
  <?php
  $fp = fopen('somefile.txt', 'r');
  if (!$fp) {
      echo 'Could not open file somefile.txt';
  }
  while (false !== ($char = fgetc($fp))) {
      echo "$char\n";
  }
  ?> 
Note: This function is binary-safe.
See also fread(), fopen(), popen(), fsockopen(), and fgets().   fflushUpfgetcsv
#

#T=string fgetc ( resource handle)
fgetc ( ^!resource handle);
#

#T=fgetcsv - array fgetcsv ( resource handle, int length [, string delimiter [, string 
(PHP 3>= 3.0.8, PHP 4 )
fgetcsv -- Gets line from file pointer and parse for CSV fields
Description
array fgetcsv ( resource handle, int length [, string delimiter [, string 
enclosure]])
Similar to fgets() except that fgetcsv() parses the line it reads for 
fields in CSV format and returns an array containing the fields read. The 
optional third delimiter parameter defaults as a comma, and the optional 
enclosure defaults as a double quotation mark. Both delimiter and 
enclosure are limited to one character. If either is more than one 
character, only the first character is used. 
Note: The enclosure parameter was added in PHP 4.3.0. 
The handle parameter must be a valid file pointer to a file successfully 
opened by fopen(), popen(), or fsockopen(). 
The length parameter must be greater than the longest line to be found in 
the CSV file (allowing for trailing line-end characters). 
fgetcsv() returns FALSE on error, including end of file. 
Note: A blank line in a CSV file will be returned as an array comprising 
a single null field, and will not be treated as an error. 
Example 1. Read and print the entire contents of a CSV file
  <?php
  $row = 1;
  $handle = fopen("test.csv", "r");
  while ($data = fgetcsv($handle, 1000, ",")) {
      $num = count($data);
      echo "<p> $num fields in line $row: <br />\n";
      $row++;
      for ($c=0; $c < $num; $c++) {
	  echo $data[$c] . "<br />\n";
      }
  }
  fclose($handle);
  ?> 
See also explode(), file(), and pack()   fgetcUpfgets
#

#T=array fgetcsv ( resource handle, int length [, string delimiter [, string 
fgetcsv ( ^!resource handle, int length [, string delimiter [, string ;
#

#T=fgets - string fgets ( resource handle [, int length])
(PHP 3, PHP 4 )
fgets -- Gets line from file pointer
Description
string fgets ( resource handle [, int length])
Returns a string of up to length - 1 bytes read from the file pointed to 
by handle. Reading ends when length - 1 bytes have been read, on a newline 
(which is included in the return value), or on EOF (whichever comes 
first). If no length is specified, the length defaults to 1k, or 1024 
bytes. 
If an error occurs, returns FALSE. 
Common Pitfalls: 
People used to the 'C' semantics of fgets() should note the difference in 
how EOF is returned. 
The file pointer must be valid, and must point to a file successfully 
opened by fopen(), popen(), or fsockopen(). 
A simple example follows: Example 1. Reading a file line by line
  <?php
  $handle = fopen("/tmp/inputfile.txt", "r");
  while (!feof($handle)) {
      $buffer = fgets($handle, 4096);
      echo $buffer;
  }
  fclose($handle);
  ?> 
Note: The length parameter became optional in PHP 4.2.0, if omitted, it 
would assume 1024 as the line length. As of PHP 4.3, omitting length 
will keep reading from the stream until it reaches the end of the line. 
If the majority of the lines in the file are all larger than 8KB, it is 
more resource efficient for your script to specify the maximum line 
length. 
Note: This function is binary safe as of PHP 4.3. Earlier versions were 
not binary safe. 
Note: If you are having problems with PHP not recognizing the line 
endings when reading files either on or created by a Macintosh computer, 
you might want to enable the auto_detect_line_endings run-time 
configuration option.
See also fread(), fgetc(), stream_get_line(), fopen(), popen(), 
fsockopen(), and stream_set_timeout().   fgetcsvUpfgetss
#

#T=string fgets ( resource handle [, int length])
fgets ( ^!resource handle [, int length]);
#

#T=fgetss - string fgetss ( resource handle, int length [, string allowable_tags])
(PHP 3, PHP 4 )
fgetss -- Gets line from file pointer and strip HTML tags
Description
string fgetss ( resource handle, int length [, string allowable_tags])
Identical to fgets(), except that fgetss attempts to strip any HTML and 
PHP tags from the text it reads. 
You can use the optional third parameter to specify tags which should not 
be stripped. 
Note: allowable_tags was added in PHP 3.0.13, PHP 4.0.0. 
Note: If you are having problems with PHP not recognizing the line 
endings when reading files either on or created by a Macintosh computer, 
you might want to enable the auto_detect_line_endings run-time 
configuration option.
See also fgets(), fopen(), fsockopen(), popen(), and strip_tags().   fgetsUpfile_exists
#

#T=string fgetss ( resource handle, int length [, string allowable_tags])
fgetss ( ^!resource handle, int length [, string allowable_tags]);
#

#T=file_exists - bool file_exists ( string filename)
(PHP 3, PHP 4 )
file_exists -- Checks whether a file or directory exists
Description
bool file_exists ( string filename)
Returns TRUE if the file or directory specified by filename exists; FALSE 
otherwise. 
On windows, use //computername/share/filename or 
\\computername\share\filename to check files on network shares. 
Example 1. Testing whether a file exists
  <?php
  $filename = '/path/to/foo.txt';

  if (file_exists($filename)) {
      echo "The file $filename exists";
  } else {
      echo "The file $filename does not exist";
  }
  ?> 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also is_readable(), is_writable(), is_file() and file().   fgetssUpfile_get_contents
#

#T=bool file_exists ( string filename)
file_exists ( ^!string filename);
#

#T=file_get_contents - string file_get_contents ( string filename [, int use_include_path [, 
(PHP 4 >= 4.3.0)
file_get_contents -- Reads entire file into a string
Description
string file_get_contents ( string filename [, int use_include_path [, 
resource context]])
Identical to file(), except that file_get_contents() returns the file in a 
string. 
file_get_contents() is the preferred way to read the contents of a file 
into a string. It will use memory mapping techniques if supported by your 
OS to enhance performance. 
Note: This function is binary-safe.
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Note: Context support was added with PHP 5.0.0. 
See also: fgets(), file(), fread(), include(), and readfile().   file_existsUpfile_put_contents
#

#T=string file_get_contents ( string filename [, int use_include_path [, 
file_get_contents ( ^!string filename [, int use_include_path [, ;
#

#T=file_put_contents - int file_put_contents ( string filename, string data [, int flags [, 
(PHP 5 CVS only)
file_put_contents -- Write a string to a file
Description
int file_put_contents ( string filename, string data [, int flags [, 
resource context]])
Identical to calling fopen(), fwrite(), and fclose() successively. The 
function returns the amount of bytes that were written to the file. 
flags can take FILE_USE_INCLUDE_PATH and/or FILE_APPEND, however the 
FILE_USE_INCLUDE_PATH option should be used with caution. 
Note: This function is binary-safe.
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
See also: fopen(), fwrite(), fclose(), and file_get_contents().   file_get_contentsUpfile
#

#T=int file_put_contents ( string filename, string data [, int flags [, 
file_put_contents ( ^!string filename, string data [, int flags [, ;
#

#T=file - array file ( string filename [, int use_include_path [, resource 
(PHP 3, PHP 4 )
file -- Reads entire file into an array
Description
array file ( string filename [, int use_include_path [, resource 
context]])
Identical to readfile(), except that file() returns the file in an array. 
Each element of the array corresponds to a line in the file, with the 
newline still attached. Upon failure, file() returns FALSE. 
You can use the optional use_include_path parameter and set it to "1", if 
you want to search for the file in the include_path, too. 
<?php
// Get a file into an array.  In this example we'll go through HTTP 
to get 
// the HTML source of a URL.
$lines = file('http://www.example.com/');

// Loop through our array, show HTML source as HTML source; and line 
numbers too.
foreach ($lines as $line_num => $line) {
echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . 
"<br />\n";
}

// Another example, let's get a web page into a string.  See also 
file_get_contents().
$html = implode('', file('http://www.example.com/'));
?> 

Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Note: Each line in the resulting array will include the line ending, so 
you still need to use rtrim() if you do not want the line ending 
present. 
Note: If you are having problems with PHP not recognizing the line 
endings when reading files either on or created by a Macintosh computer, 
you might want to enable the auto_detect_line_endings run-time 
configuration option.
Note: As of PHP 4.3.0 you can use file_get_contents() to return the 
contents of a file as a string. 
In PHP 4.3.0 file() became binary safe. 
Note: Context support was added with PHP 5.0.0 
See also readfile(), fopen(), fsockopen(), popen(), file_get_contents(), 
and include().   file_put_contentsUpfileatime
#

#T=array file ( string filename [, int use_include_path [, resource 
file ( ^!string filename [, int use_include_path [, resource ;
#

#T=fileatime - int fileatime ( string filename)
(PHP 3, PHP 4 )
fileatime -- Gets last access time of file
Description
int fileatime ( string filename)
Returns the time the file was last accessed, or FALSE in case of an error. 
The time is returned as a Unix timestamp. 
Note: The atime of a file is supposed to change whenever the data blocks 
of a file are being read. This can be costly performancewise when an 
application regularly accesses a very large number of files or 
directories. Some Unix filesystems can be mounted with atime updates 
disabled to increase the performance of such applications; USENET news 
spools are a common example. On such filesystems this function will be 
useless. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
Example 1. fileatime() example
  <?php

  // outputs e.g.  somefile.txt was last accessed: December 29 
  2002 22:16:23.

  $filename = 'somefile.txt';
  if (file_exists($filename)) {
      echo "$filename was last accessed: " . date("F d Y 
  H:i:s.", fileatime($filename));
  }

  ?> 
See also filemtime(), fileinode(), and date().   fileUpfilectime
#

#T=int fileatime ( string filename)
fileatime ( ^!string filename);
#

#T=filectime - int filectime ( string filename)
(PHP 3, PHP 4 )
filectime -- Gets inode change time of file
Description
int filectime ( string filename)
Returns the time the file was last changed, or FALSE in case of an error. 
The time is returned as a Unix timestamp. 
Note: In most Unix filesystems, a file is considered changed when its 
inode data is changed; that is, when the permissions, owner, group, or 
other metadata from the inode is updated. See also filemtime() (which is 
what you want to use when you want to create "Last Modified" footers on 
web pages) and fileatime(). 
Note also that in some Unix texts the ctime of a file is referred to as 
being the creation time of the file. This is wrong. There is no creation 
time for Unix files in most Unix filesystems. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
Example 1. fileatime() example
  <?php

  // outputs e.g.  somefile.txt was last changed: December 29 
  2002 22:16:23.

  $filename = 'somefile.txt';
  if (file_exists($filename)) {
      echo "$filename was last changed: " . date("F d Y H:i:s.", 
  filectime($filename));
  }

  ?> 
See also filemtime()   fileatimeUpfilegroup
#

#T=int filectime ( string filename)
filectime ( ^!string filename);
#

#T=filegroup - int filegroup ( string filename)
(PHP 3, PHP 4 )
filegroup -- Gets file group
Description
int filegroup ( string filename)
Returns the group ID of the file, or FALSE in case of an error. The group 
ID is returned in numerical format, use posix_getgrgid() to resolve it to 
a group name. Upon failure, FALSE is returned along with an error of level 
E_WARNING. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also fileowner(), and safe_mode_gid.   filectimeUpfileinode
#

#T=int filegroup ( string filename)
filegroup ( ^!string filename);
#

#T=fileinode - int fileinode ( string filename)
(PHP 3, PHP 4 )
fileinode -- Gets file inode
Description
int fileinode ( string filename)
Returns the inode number of the file, or FALSE in case of an error. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also stat()   filegroupUpfilemtime
#

#T=int fileinode ( string filename)
fileinode ( ^!string filename);
#

#T=filemtime - int filemtime ( string filename)
(PHP 3, PHP 4 )
filemtime -- Gets file modification time
Description
int filemtime ( string filename)
Returns the time the file was last modified, or FALSE in case of an error. 
The time is returned as a Unix timestamp, which is suitable for the date() 
function. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
This function returns the time when the data blocks of a file were being 
written to, that is, the time when the content of the file was changed. 
Example 1. filemtime() example
  <?php
  // outputs e.g.  somefile.txt was last modified: December 29 
  2002 22:16:23.

  $filename = 'somefile.txt';
  if (file_exists($filename)) {
      echo "$filename was last modified: " . date ("F d Y 
  H:i:s.", filemtime($filename));
  }
  ?> 
See also filectime(), stat(), touch(), and getlastmod().   fileinodeUpfileowner
#

#T=int filemtime ( string filename)
filemtime ( ^!string filename);
#

#T=fileowner - int fileowner ( string filename)
(PHP 3, PHP 4 )
fileowner -- Gets file owner
Description
int fileowner ( string filename)
Returns the user ID of the owner of the file, or FALSE in case of an 
error. The user ID is returned in numerical format, use posix_getpwuid() 
to resolve it to a username. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also stat()   filemtimeUpfileperms
#

#T=int fileowner ( string filename)
fileowner ( ^!string filename);
#

#T=fileperms - int fileperms ( string filename)
(PHP 3, PHP 4 )
fileperms -- Gets file permissions
Description
int fileperms ( string filename)
Returns the permissions on the file, or FALSE in case of an error. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also is_readable(), and stat()   fileownerUpfilesize
#

#T=int fileperms ( string filename)
fileperms ( ^!string filename);
#

#T=filepro_fieldcount - int filepro_fieldcount ( void )
(PHP 3, PHP 4 )
filepro_fieldcount -- Find out how many fields are in a filePro database
Description
int filepro_fieldcount ( void )
Returns the number of fields (columns) in the opened filePro database. 
See also filepro().   filePro functionsUpfilepro_fieldname
#

#T=int filepro_fieldcount ( void )
filepro_fieldcount ( ^!void );
#

#T=filepro_fieldname - string filepro_fieldname ( int field_number)
(PHP 3, PHP 4 )
filepro_fieldname -- Gets the name of a field
Description
string filepro_fieldname ( int field_number)
Returns the name of the field corresponding to field_number.   filepro_fieldcountUpfilepro_fieldtype
#

#T=string filepro_fieldname ( int field_number)
filepro_fieldname ( ^!int field_number);
#

#T=filepro_fieldtype - string filepro_fieldtype ( int field_number)
(PHP 3, PHP 4 )
filepro_fieldtype -- Gets the type of a field
Description
string filepro_fieldtype ( int field_number)
Returns the edit type of the field corresponding to field_number.   filepro_fieldnameUpfilepro_fieldwidth
#

#T=string filepro_fieldtype ( int field_number)
filepro_fieldtype ( ^!int field_number);
#

#T=filepro_fieldwidth - int filepro_fieldwidth ( int field_number)
(PHP 3, PHP 4 )
filepro_fieldwidth -- Gets the width of a field
Description
int filepro_fieldwidth ( int field_number)
Returns the width of the field corresponding to field_number.   filepro_fieldtypeUpfilepro_retrieve
#

#T=int filepro_fieldwidth ( int field_number)
filepro_fieldwidth ( ^!int field_number);
#

#T=filepro_retrieve - string filepro_retrieve ( int row_number, int field_number)
(PHP 3, PHP 4 )
filepro_retrieve -- Retrieves data from a filePro database
Description
string filepro_retrieve ( int row_number, int field_number)
Returns the data from the specified location in the database. The 
row_number parameter must be between zero and the total number of rows 
minus one (0..filepro_rowcount() - 1). Likewise, field_number accepts 
values between zero and the total number of fields minus one 
(0..filepro_fieldcount() - 1) 
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.  filepro_fieldwidthUpfilepro_rowcount
#

#T=string filepro_retrieve ( int row_number, int field_number)
filepro_retrieve ( ^!int row_number, int field_number);
#

#T=filepro_rowcount - int filepro_rowcount ( void )
(PHP 3, PHP 4 )
filepro_rowcount -- Find out how many rows are in a filePro database
Description
int filepro_rowcount ( void )
Returns the number of rows in the opened filePro database. 
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.
See also filepro().   filepro_retrieveUpfilepro
#

#T=int filepro_rowcount ( void )
filepro_rowcount ( ^!void );
#

#T=filepro - bool filepro ( string directory)
(PHP 3, PHP 4 )
filepro -- Read and verify the map file
Description
bool filepro ( string directory)
This reads and verifies the map file, storing the field count and info. 
No locking is done, so you should avoid modifying your filePro database 
while it may be opened in PHP. 
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.  filepro_rowcountUpFilesystem functions
#

#T=bool filepro ( string directory)
filepro ( ^!string directory);
#

#T=filesize - int filesize ( string filename)
(PHP 3, PHP 4 )
filesize -- Gets file size
Description
int filesize ( string filename)
Returns the size of the file in bytes, or FALSE in case of an error. 
Note: Because PHP's integer type is signed and many platforms use 32bit 
integers, filesize() may return unexpected results for files which are 
larger than 2GB. For files between 2GB and 4GB in size this can usually 
be overcome by using sprintf("%u", filesize($file)). 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
Example 1. filesize() example
  <?php

  // outputs e.g.  somefile.txt: 1024 bytes

  $filename = 'somefile.txt';
  echo $filename . ': ' . filesize($filename) . ' bytes';

  ?> 
See also file_exists()   filepermsUpfiletype
#

#T=int filesize ( string filename)
filesize ( ^!string filename);
#

#T=filetype - string filetype ( string filename)
(PHP 3, PHP 4 )
filetype -- Gets file type
Description
string filetype ( string filename)
Returns the type of the file. Possible values are fifo, char, dir, block, 
link, file, and unknown. 
Returns FALSE if an error occurs. filetype() will also produce an E_NOTICE 
message if the stat call fails or if the file type is unknown. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
Example 1. filetype() example
  <?php

  echo filetype('/etc/passwd');  // file
  echo filetype('/etc/');        // dir

  ?> 
See also is_dir(), is_file(), is_link(), file_exists(), stat(), and 
mime_content_type().   filesizeUpflock
#

#T=string filetype ( string filename)
filetype ( ^!string filename);
#

#T=floatval - float floatval ( mixed var)
(PHP 4 >= 4.2.0)
floatval -- Get float value of a variable
Description
float floatval ( mixed var)
Returns the float value of var. 
Var may be any scalar type. You cannot use floatval() on arrays or 
objects. 
<?php
$var = '122.34343The';
$float_value_of_var = floatval($var);
echo $float_value_of_var; // prints 122.34343
?> 

See also intval(), strval(), settype() and Type juggling.   emptyUpget_defined_vars
#

#T=float floatval ( mixed var)
floatval ( ^!mixed var);
#

#T=flock - bool flock ( resource handle, int operation [, int &wouldblock])
(PHP 3>= 3.0.7, PHP 4 )
flock -- Portable advisory file locking
Description
bool flock ( resource handle, int operation [, int &wouldblock])
PHP supports a portable way of locking complete files in an advisory way 
(which means all accessing programs have to use the same way of locking or 
it will not work). 
flock() operates on handle which must be an open file pointer. operation 
is one of the following values: 
To acquire a shared lock (reader), set operation to LOCK_SH (set to 1 
prior to PHP 4.0.1). 
To acquire an exclusive lock (writer), set operation to LOCK_EX (set to 
2 prior to PHP 4.0.1). 
To release a lock (shared or exclusive), set operation to LOCK_UN (set 
to 3 prior to PHP 4.0.1). 
If you don't want flock() to block while locking, add LOCK_NB (4 prior 
to PHP 4.0.1) to operation. 
flock() allows you to perform a simple reader/writer model which can be 
used on virtually every platform (including most Unix derivatives and even 
Windows). The optional third argument is set to TRUE if the lock would 
block (EWOULDBLOCK errno condition) 
Returns TRUE on success or FALSE on failure. 
Example 1. flock() example
  <?php

  $fp = fopen("/tmp/lock.txt", "w+");

  if (flock($fp, LOCK_EX)) { // do an exclusive lock
      fwrite($fp, "Write something here\n");
      flock($fp, LOCK_UN); // release the lock
  } else {
      echo "Couldn't lock the file !";
  }

  fclose($fp);

  ?> 
Note: Because flock() requires a file pointer, you may have to use a 
special lock file to protect access to a file that you intend to 
truncate by opening it in write mode (with a "w" or "w+" argument to 
fopen()). 
Warning
flock() will not work on NFS and many other networked file systems. 
Check your operating system documentation for more details. 
On some operating systems flock() is implemented at the process 
level. When using a multithreaded server API like ISAPI you may not 
be able to rely on flock() to protect files against other PHP 
scripts running in parallel threads of the same server instance! 
flock() is not supported on antiquated filesystems like FAT and its 
derivates and will therefore always return FALSE under this 
environments (this is especially true for Windows 98 users). 
  filetypeUpfnmatch
#

#T=bool flock ( resource handle, int operation [, int &wouldblock])
flock ( ^!resource handle, int operation [, int &wouldblock]);
#

#T=floor - float floor ( float value)
(PHP 3, PHP 4 )
floor -- Round fractions down
Description
float floor ( float value)
Returns the next lowest integer value by rounding down value if necessary. 
The return value of floor() is still of type float because the value range 
of float is usually bigger than that of integer. 
Example 1. floor() example
  <?php
  echo floor(4.3);   // 4
  echo floor(9.999); // 9
  ?> 
See also ceil() and round().   expm1Upfmod
#

#T=float floor ( float value)
floor ( ^!float value);
#

#T=flush - void flush ( void )
(PHP 3, PHP 4 )
flush -- Flush the output buffer
Description
void flush ( void )
Flushes the output buffers of PHP and whatever backend PHP is using (CGI, 
a web server, etc). This effectively tries to push all the output so far 
to the user's browser. 
flush() has no effect on the buffering scheme of your webserver or the 
browser on the client side. 
Several servers, especially on Win32, will still buffer the output from 
your script until it terminates before transmitting the results to the 
browser. 
Server modules for Apache like mod_gzip may do buffering of their own that 
will cause flush() to not result in data being sent immediately to the 
client. 
Even the browser may buffer its input before displaying it. Netscape, for 
example, buffers text until it receives an end-of-line or the beginning of 
a tag, and it won't render tables until the </table> tag of the outermost 
table is seen. 
Some versions of Microsoft Internet Explorer will only start to display 
the page after they have received 256 bytes of output, so you may need to 
send extra whitespace before flushing to get those browsers to display the 
page.   Output Control FunctionsUpob_clean
#

#T=void flush ( void )
flush ( ^!void );
#

#T=fmod - float fmod ( float x, float y)
(PHP 4 >= 4.2.0)
fmod -- Returns the floating point remainder (modulo) of the division of 
the arguments
Description
float fmod ( float x, float y)
Returns the floating point remainder of dividing the dividend (x) by the 
divisor (y). The reminder (r) is defined as: x = i * y + r, for some 
integer i. If y is non-zero, r has the same sign as x and a magnitude less 
than the magnitude of y. 
Example 1. Using fmod()
  <?php
  $x = 5.7;
  $y = 1.3;
  $r = fmod($x, $y);
  // $r equals 0.5, because 4 * 1.3 + 0.5 = 5.7
  ?> 

  floorUpgetrandmax
#

#T=float fmod ( float x, float y)
fmod ( ^!float x, float y);
#

#T=fnmatch - array fnmatch ( string pattern, string string [, int flags])
(PHP 4 >= 4.3.0)
fnmatch -- Match filename against a pattern
Description
array fnmatch ( string pattern, string string [, int flags])
fnmatch() checks if the passed string would match the given shell wildcard 
pattern. 
This is especially useful for filenames, but may also be used on regular 
strings. The average user may be used to shell patterns or at least in 
their simplest form to '?' and '*' wildcards so using fnmatch() instead of 
ereg() or preg_match() for frontend search expression input may be way 
more convenient for non-programming users. 
Example 1. Checking a color name against a shell wildcard pattern. 
  <?php
  if (fnmatch("*gr[ae]y", $color)) {
    echo "some form of gray ...";
  }
  ?> 
See also glob(), ereg(), preg_match() and the Unix manpage on fnmatch(3) 
for flag names (as long as they are not documented here ).   flockUpfopen
#

#T=array fnmatch ( string pattern, string string [, int flags])
fnmatch ( ^!string pattern, string string [, int flags]);
#

#T=fopen - resource fopen ( string filename, string mode [, int use_include_path [, 
(PHP 3, PHP 4 )
fopen -- Opens file or URL
Description
resource fopen ( string filename, string mode [, int use_include_path [, 
resource zcontext]])
fopen() binds a named resource, specified by filename, to a stream. If 
filename is of the form "scheme://...", it is assumed to be a URL and PHP 
will search for a protocol handler (also known as a wrapper) for that 
scheme. If no wrappers for that protocol are registered, PHP will emit a 
notice to help you track potential problems in your script and then 
continue as though filename specifies a regular file. 
If PHP has decided that filename specifies a local file, then it will try 
to open a stream on that file. The file must be accessible to PHP, so you 
need to ensure that the file access permissions allow this access. If you 
have enabled safe mode, or open_basedir further restrictions may apply. 
If PHP has decided that filename specifies a registered protocol, and that 
protocol is registered as a network URL, PHP will check to make sure that 
allow_url_fopen is enabled. If it is switched off, PHP will emit a warning 
and the fopen call will fail. 
Note: The list of supported protocols can be found in Appendix I. Some 
protocols (also referred to as wrappers) support context and/or php.ini 
options. Refer to the specific page for the protocol in use for a list 
of options which can be set. ( i.e. php.ini value user_agent used by the 
http wrapper) For a description of contexts and the zcontext parameter , 
refer to Reference CI, Stream functions. 
The mode parameter specifies the type of access you require to the stream. 
It may be any of the following: 
Table 1. A list of possible modes for fopen() using mode 
modeDescription
'r'Open for reading only; place the file pointer at the beginning of 
the file. 
'r+'Open for reading and writing; place the file pointer at the 
beginning of the file. 
'w'Open for writing only; place the file pointer at the beginning of 
the file and truncate the file to zero length. If the file does not 
exist, attempt to create it. 
'w+'Open for reading and writing; place the file pointer at the 
beginning of the file and truncate the file to zero length. If the 
file does not exist, attempt to create it. 
'a'Open for writing only; place the file pointer at the end of the 
file. If the file does not exist, attempt to create it. 
'a+'Open for reading and writing; place the file pointer at the end 
of the file. If the file does not exist, attempt to create it. 
'x'Create and open for writing only; place the file pointer at the 
beginning of the file. If the file already exists, the fopen() call 
will fail by returning FALSE and generating an error of level 
E_WARNING. If the file does not exist, attempt to create it. This is 
equivalent to specifying O_EXCL|O_CREAT flags for the underlying 
open(2) system call. This option is supported in PHP 4.3.2 and 
later, and only works for local files. 
'x+'Create and open for reading and writing; place the file pointer 
at the beginning of the file. If the file already exists, the 
fopen() call will fail by returning FALSE and generating an error of 
level E_WARNING. If the file does not exist, attempt to create it. 
This is equivalent to specifying O_EXCL|O_CREAT flags for the 
underlying open(2) system call. This option is supported in PHP 
4.3.2 and later, and only works for local files. 

Note: Different operating system families have different line-ending 
conventions. When you write a text file and want to insert a line break, 
you need to use the correct line-ending character(s) for your operating 
system. Unix based systems use \n as the line ending character, Windows 
based systems use \r\n as the line ending characters and Macintosh based 
systems use \r as the the line ending character. 
If you use the wrong line ending characters when writing your files, you 
might find that other applications that open those files will "look 
funny". 
Windows offers a text-mode translation flag ('t') which will 
transparently translate \n to \r\n when working with the file. In 
contrast, you can also use 'b' to force binary mode, which will not 
translate your data. To use these flags, specify either 'b' or 't' as 
the last character of the mode parameter. 
The default translation mode depends on the SAPI and version of PHP that 
you are using, so you are encouraged to always specify the appropriate 
flag for portability reasons. You should use the 't' mode if you are 
working with plain-text files and you use \n to delimit your line 
endings in your script, but expect your files to be readable with 
applications such as notepad. You should use the 'b' in all other cases. 

If you do not specify the 'b' flag when working with binary files, you 
may experience strange problems with your data, including broken image 
files and strange problems with \r\n characters. 
For portability, it is strongly recommended that you always use the 'b' 
flag when opening files with fopen(). 
Again, for portability, it is also strongly recommended that you 
re-write code that uses or relies upon the 't' mode so that it uses the 
correct line endings and 'b' mode instead. 
As of PHP 4.3.2, the default mode is set to binary for all platforms 
that distinguish between binary and text mode. If you are having 
problems with your scripts after upgrading, try using the 't' flag as a 
workaround until you have made your script more portable as mentioned 
above. 
The optional third use_include_path parameter can be set to '1' or TRUE if 
you want to search for the file in the include_path, too. 
If the open fails, the function returns FALSE and an error of level 
E_WARNING is generated. You may use @ to suppress this warning. 
Example 1. fopen() examples
  <?php
  $handle = fopen("/home/rasmus/file.txt", "r");
  $handle = fopen("/home/rasmus/file.gif", "wb");
  $handle = fopen("http://www.example.com/", "r");
  $handle = 
  fopen("ftp://user:password@example.com/somefile.txt", "w");
  ?> 
If you are experiencing problems with reading and writing to files and 
you're using the server module version of PHP, remember to make sure that 
the files and directories you're using are accessible to the server 
process. 
On the Windows platform, be careful to escape any backslashes used in the 
path to the file, or use forward slashes. 
<?php
$handle = fopen("c:\\data\\info.txt", "r");
?> 

Note: When safe mode is enabled, PHP checks whether the directory in 
which you are about to operate has the same UID (owner) as the script 
that is being executed.
See also Appendix I, fclose(), fgets(), fread(), fwrite(), fsockopen(), 
file(), file_exists(), is_readable(), stream_set_timeout(), and popen().   fnmatchUpfpassthru
#

#T=resource fopen ( string filename, string mode [, int use_include_path [, 
fopen ( ^!string filename, string mode [, int use_include_path [, ;
#

#T=fpassthru - int fpassthru ( resource handle)
(PHP 3, PHP 4 )
fpassthru -- Output all remaining data on a file pointer
Description
int fpassthru ( resource handle)
Reads to EOF on the given file pointer from the current position and 
writes the results to the output buffer. 
If an error occurs, fpassthru() returns FALSE. Otherwise, fpassthru() 
returns the number of characters read from handle and passed through to 
the output. 
The file pointer must be valid, and must point to a file successfully 
opened by fopen(), popen(), or fsockopen(). You may need to call rewind() 
to reset the file pointer to the beginning of the file if you have already 
written data to the file. The file is closed when fpassthru() is done 
reading it (leaving handle useless). 
If you just want to dump the contents of a file to the output buffer, 
without first modifying it or seeking to a particular offset, you may want 
to use the readfile(), which saves you the fopen() call. 
Note: When using fpassthru() on a binary file on Windows systems, you 
should make sure to open the file in binary mode by appending a b to the 
mode used in the call to fopen(). 
You are encouraged to use the b flag when dealing with binary files, 
even if your system does not require it, so that your scripts will be 
more portable. 
Example 1. Using fpassthru() with binary files
  <?php

  // open the file in a binary mode
  $name = ".\public\dev\img\ok.png";
  $fp = fopen($name, 'rb');

  // send the right headers
  header("Content-Type: image/png");
  header("Content-Length: " . filesize($name));

  // dump the picture and stop the script
  fpassthru($fp);
  exit;

  ?> 
See also readfile(), fopen(), popen(), and fsockopen()   fopenUpfputs
#

#T=int fpassthru ( resource handle)
fpassthru ( ^!resource handle);
#

#T=fprintf - int fprintf ( resource handle, string format [, mixed args])
(PHP 5 CVS only)
fprintf -- Write a formatted string to a stream
Description
int fprintf ( resource handle, string format [, mixed args])
Write a string produced according to the formatting string format to the 
stream resource specified by handle.. 
The format string is composed of zero or more directives: ordinary 
characters (excluding %) that are copied directly to the result, and 
conversion specifications, each of which results in fetching its own 
parameter. This applies to fprintf(), sprintf(), and printf(). 
Each conversion specification consists of a percent sign (%), followed by 
one or more of these elements, in order: 
An optional padding specifier that says what character will be used for 
padding the results to the right string size. This may be a space 
character or a 0 (zero character). The default is to pad with spaces. An 
alternate padding character can be specified by prefixing it with a 
single quote ('). See the examples below. 
An optional alignment specifier that says if the result should be 
left-justified or right-justified. The default is right-justified; a - 
character here will make it left-justified. 
An optional number, a width specifier that says how many characters 
(minimum) this conversion should result in. 
An optional precision specifier that says how many decimal digits should 
be displayed for floating-point numbers. This option has no effect for 
other types than float. (Another function useful for formatting numbers 
is number_format().) 
A type specifier that says what type the argument data should be treated 
as. Possible types: 
% - a literal percent character. No argument is required. 
b - the argument is treated as an integer, and presented as a 
binary number. 
c - the argument is treated as an integer, and presented as the 
character with that ASCII value. 
d - the argument is treated as an integer, and presented as a 
(signed) decimal number. 
u - the argument is treated as an integer, and presented as an 
unsigned decimal number. 
f - the argument is treated as a float, and presented as a 
floating-point number. 
o - the argument is treated as an integer, and presented as an 
octal number. 
s - the argument is treated as and presented as a string. 
x - the argument is treated as an integer and presented as a 
hexadecimal number (with lowercase letters). 
X - the argument is treated as an integer and presented as a 
hexadecimal number (with uppercase letters). 

See also: printf(), sprintf(), sscanf(), fscanf(), vsprintf(), and 
number_format(). 
Examples
Example 1. sprintf(): zero-padded integers
  <?php
  $isodate = sprintf("%04d-%02d-%02d", $year, $month, $day);
  ?> 

Example 2. sprintf(): formatting currency
  <?php
  $money1 = 68.75;
  $money2 = 54.35;
  $money = $money1 + $money2;
  // echo $money will output "123.1";
  $formatted = sprintf("%01.2f", $money);
  // echo $formatted will output "123.10"
  ?> 

  explodeUpget_html_translation_table
fputs
fputs -- Alias of fwrite()
Description
This function is an alias of fwrite().   fpassthruUpfread
#

#T=int fprintf ( resource handle, string format [, mixed args])
fprintf ( ^!resource handle, string format [, mixed args]);
#

#T=fread - string fread ( resource handle, int length)
(PHP 3, PHP 4 )
fread -- Binary-safe file read
Description
string fread ( resource handle, int length)
fread() reads up to length bytes from the file pointer referenced by 
handle. Reading stops when length bytes have been read, EOF (end of file) 
is reached, or (for network streams) when a packet becomes available, 
whichever comes first. 
<?php
// get contents of a file into a string
$filename = "/usr/local/something.txt";
$handle = fopen($filename, "r");
$contents = fread($handle, filesize($filename));
fclose($handle);
?> 

Warning
On systems which differentiate between binary and text files (i.e. 
Windows) the file must be opened with 'b' included in fopen() mode 
parameter. 

<?php
$filename = "c:\\files\\somepic.gif";
$handle = fopen($filename, "rb");
$contents = fread($handle, filesize($filename));
fclose($handle);
?> 

Warning
When reading from network streams or pipes, such as those returned 
when reading remote files or from popen() and proc_open(), reading 
will stop after a packet is available. This means that you should 
collect the data together in chunks as shown in the example below. 

<?php
$handle = fopen("http://www.example.com/", "rb");
$contents = "";
do {
$data = fread($handle, 8192);
if (strlen($data) == 0) {
    break;
}
$contents .= $data;
} while (true);
fclose($handle);
?> 

Note: The example above has better performance than the traditional 
approach using while(!feof()), as we are saving the overhead of a 
function call per iteration. 
Note: If you just want to get the contents of a file into a string, use 
file_get_contents() as it has much better performance than the code 
above. 
See also fwrite(), fopen(), fsockopen(), popen(), fgets(), fgetss(), 
fscanf(), file(), and fpassthru().   fputsUpfscanf
#

#T=string fread ( resource handle, int length)
fread ( ^!resource handle, int length);
#

#T=FrenchToJD - int frenchtojd ( int month, int day, int year)
(PHP 3, PHP 4 )
FrenchToJD --  Converts a date from the French Republican Calendar to a 
Julian Day Count 
Description
int frenchtojd ( int month, int day, int year)
Converts a date from the French Republican Calendar to a Julian Day Count. 

These routines only convert dates in years 1 through 14 (Gregorian dates 
22 September 1792 through 22 September 1806). This more than covers the 
period when the calendar was in use.   easter_daysUpGregorianToJD
fribidi_log2vis
(4.0.4 - 4.3.2 only)
fribidi_log2vis -- Convert a logical string to a visual one
Description
string fribidi_log2vis ( string str, string direction, int charset)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  FriBiDi functionsUpFTP functions
#

#T=int frenchtojd ( int month, int day, int year)
frenchtojd ( ^!int month, int day, int year);
#

#T=fscanf - mixed fscanf ( resource handle, string format [, string var1])
(PHP 4 >= 4.0.1)
fscanf -- Parses input from a file according to a format
Description
mixed fscanf ( resource handle, string format [, string var1])
The function fscanf() is similar to sscanf(), but it takes its input from 
a file associated with handle and interprets the input according to the 
specified format, which is described in the documentation for sprintf(). 
If only two parameters were passed to this function, the values parsed 
will be returned as an array. Otherwise, if optional parameters are 
passed, the function will return the number of assigned values. The 
optional parameters must be passed by reference. 
Any whitespace in the format string matches any whitespace in the input 
stream. This means that even a tab \t in the format string can match a 
single space character in the input stream. 
Example 1. fscanf() Example
  <?php
  $handle = fopen("users.txt", "r");
  while ($userinfo = fscanf($handle, "%s\t%s\t%s\n")) {
      list ($name, $profession, $countrycode) = $userinfo;
      //... do something with the values
  }
  fclose($handle);
  ?> 

Example 2. users.txt
javier  argonaut        pe
hiroshi sculptor        jp
robert  slacker us
luigi   florist it
Note: Prior to PHP 4.3.0, the maximum number of characters read from the 
file was 512 (or up to the first \n, whichever came first). As of PHP 
4.3.0 arbitrarily long lines will be read and scanned. 
See also fread(), fgets(), fgetss(), sscanf(), printf(), and sprintf().   freadUpfseek
#

#T=mixed fscanf ( resource handle, string format [, string var1])
fscanf ( ^!resource handle, string format [, string var1]);
#

#T=fseek - int fseek ( resource handle, int offset [, int whence])
(PHP 3, PHP 4 )
fseek -- Seeks on a file pointer
Description
int fseek ( resource handle, int offset [, int whence])
Sets the file position indicator for the file referenced by handle.The new 
position, measured in bytes from the beginning of the file, is obtained by 
adding offset to the position specified by whence, whose values are 
defined as follows: 
SEEK_SET - Set position equal to offset bytes.
SEEK_CUR - Set position to current location plus offset.
SEEK_END - Set position to end-of-file plus offset. (To move to a 
position before the end-of-file, you need to pass a negative value 
in offset.)

If whence is not specified, it is assumed to be SEEK_SET. 
Upon success, returns 0; otherwise, returns -1. Note that seeking past EOF 
is not considered an error. 
Example 1. fseek() example
  <?php

  $fp = fopen('somefile.txt');

  // read some data
  $data = fgets($fp, 4096);

  // move back to the beginning of the file
  // same as rewind($fp);
  fseek($fp, 0);

  ?> 
May not be used on file pointers returned by fopen() if they use the 
"http://" or "ftp://" formats. 
Note: The whence argument was added after PHP 4.0.0. 
See also ftell() and rewind().   fscanfUpfstat
#

#T=int fseek ( resource handle, int offset [, int whence])
fseek ( ^!resource handle, int offset [, int whence]);
#

#T=fsockopen - resource fsockopen ( string target, int port [, int errno [, string errstr 
(PHP 3, PHP 4 )
fsockopen --  Open Internet or Unix domain socket connection 
Description
resource fsockopen ( string target, int port [, int errno [, string errstr 
[, float timeout]]])
Initiates a socket connection to the resource specified by target. PHP 
supports targets in the Internet and Unix domains as described in Appendix 
J. A list of supported transports can also be retrieved using 
stream_get_transports(). 
Note: If you need to set a timeout for reading/writing data over the 
socket, use stream_set_timeout(), as the timeout parameter to 
fsockopen() only applies while connecting the socket. 
As of PHP 4.3.0, if you have compiled in OpenSSL support, you may prefix 
the hostname with either 'ssl://' or 'tls://' to use an SSL or TLS client 
connection over TCP/IP to connect to the remote host. 
fsockopen() returns a file pointer which may be used together with the 
other file functions (such as fgets(), fgetss(), fputs(), fclose(), and 
feof()). 
If the call fails, it will return FALSE and if the optional errno and 
errstr arguments are present they will be set to indicate the actual 
system level error that occurred in the system-level connect() call. If 
the value returned in errno is 0 and the function returned FALSE, it is an 
indication that the error occurred before the connect() call. This is most 
likely due to a problem initializing the socket. Note that the errno and 
errstr arguments will always be passed by reference. 
Depending on the environment, the Unix domain or the optional connect 
timeout may not be available. 
The socket will by default be opened in blocking mode. You can switch it 
to non-blocking mode by using stream_set_blocking(). Example 1. 
fsockopen() Example
  <?php
  $fp = fsockopen("www.example.com", 80, $errno, $errstr, 30);
  if (!$fp) {
      echo "$errstr ($errno)<br />\n";
  } else {
      $out = "GET / HTTP/1.1\r\n";
      $out .= "Host: www.example.com\r\n";
      $out .= "Connection: Close\r\n\r\n";

      fputs($fp, $out);
      while (!feof($fp)) {
	  echo fgets($fp, 128);
      }
      fclose($fp);
  }
  ?> 

The example below shows how to retrieve the day and time from the UDP 
service "daytime" (port 13) in your own machine. Example 2. Using 
UDP connection
  <?php
  $fp = fsockopen("udp://127.0.0.1", 13, $errno, $errstr);
  if (!$fp) {
      echo "ERROR: $errno - $errstr<br />\n";
  } else {
      fwrite($fp, "\n");
      echo fread($fp, 26);
      fclose($fp);
  }
  ?> 
Warning
UDP sockets will sometimes appear to have opened without an error, 
even if the remote host is unreachable. The error will only become 
apparent when you read or write data to/from the socket. The reason 
for this is because UDP is a "connectionless" protocol, which means 
that the operating system does not try to establish a link for the 
socket until it actually needs to send or receive data. 

Note: When specifying a numerical IPv6 address (e.g. fe80::1) you must 
enclose the IP in square brackets. For example, tcp://[fe80::1]:80.
Note: The timeout parameter was introduced in PHP 3.0.9 and UDP support 
was added in PHP 4. 
See also pfsockopen(), stream_set_blocking(), stream_set_timeout(), 
fgets(), fgetss(), fputs(), fclose(), feof(), and the Curl extension.   dns_get_recordUpgethostbyaddr
#

#T=resource fsockopen ( string target, int port [, int errno [, string errstr 
fsockopen ( ^!string target, int port [, int errno [, string errstr ;
#

#T=fstat - array fstat ( resource handle)
(PHP 4 )
fstat -- Gets information about a file using an open file pointer
Description
array fstat ( resource handle)
Gathers the statistics of the file opened by the file pointer handle. This 
function is similar to the stat() function except that it operates on an 
open file pointer instead of a filename. 
Returns an array with the statistics of the file; the format of the array 
is described in detail on the stat() manual page. 
Example 1. fstat() example
  <?php

  // open a file
  $fp = fopen("/etc/passwd", "r");

  // gather statistics
  $fstat = fstat($fp);

  // close the file
  fclose($fp);

  // print only the associative part
  print_r(array_slice($fstat, 13));

  ?> 

this will output : 
Array
(
[dev] => 771
[ino] => 488704
[mode] => 33188
[nlink] => 1
[uid] => 0
[gid] => 0
[rdev] => 0
[size] => 1114
[atime] => 1061067181
[mtime] => 1056136526
[ctime] => 1056136526
[blksize] => 4096
[blocks] => 8
)
Note: The results of this function are cached. See clearstatcache() for 
more details.
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.  fseekUpftell
#

#T=array fstat ( resource handle)
fstat ( ^!resource handle);
#

#T=ftell - int ftell ( resource handle)
(PHP 3, PHP 4 )
ftell -- Tells file pointer read/write position
Description
int ftell ( resource handle)
Returns the position of the file pointer referenced by handle; i.e., its 
offset into the file stream. 
If an error occurs, returns FALSE. 
The file pointer must be valid, and must point to a file successfully 
opened by fopen() or popen(). 
Example 1. ftell() example
  <?php

  // opens a file and read some data
  $fp = fopen("/etc/passwd", "r");
  $data = fgets($fp, 12);

  // where are we ?
  echo ftell($fp); // 11

  fclose($fp);

  ?> 
See also fopen(), popen(), fseek(), and rewind().   fstatUpftruncate
#

#T=int ftell ( resource handle)
ftell ( ^!resource handle);
#

#T=ftok - int ftok ( string pathname, string proj)
(PHP 4 >= 4.2.0)
ftok --  Convert a pathname and a project identifier to a System V IPC key 

Description
int ftok ( string pathname, string proj)
The function converts the pathname of an existing accessible file and a 
project identifier (proj) into a integer for use with for example 
shmop_open() and other System V IPC keys. The proj parameter should be a 
one character string. 
On success the return value will be the created key value, otherwise -1 is 
returned. 
See also shmop_open() and sem_get().   Semaphore, Shared Memory and IPC FunctionsUpmsg_get_queue
ftp_alloc
(no version information, might be only in CVS)
ftp_alloc -- Allocates space for a file to be uploaded.
Description
bool ftp_alloc ( resource ftp_stream, int filesize [, string &result])
Sends an ALLO command to the remote FTP server to allocate filesize bytes 
of space. Returns TRUE on success, or FALSE on failure. 
Note: Many FTP servers do not support this command. These servers may 
return a failure code (FALSE) indicating the command is not supported or 
a success code (TRUE) to indicate that pre-allocation is not necessary 
and the client should continue as though the operation were successful. 
Because of this, it may be best to reserve this function for servers 
which explicitly require preallocation. 
A textual representation of the servers response will be returned by 
reference in result is a variable is provided. 
Example 1. ftp_alloc() example
  <?php

  $file = "/home/user/myfile";

  /* connect to the server */
  $conn_id = ftp_connect('ftp.example.com');
  $login_result = ftp_login($conn_id, 'anonymous', 
  'user@example.com');

  if (ftp_alloc($conn_id, filesize($file), $result)) {
    echo "Space successfully allocated on server.  Sending 
  $file.\n";
    ftp_put($conn_id, '/incomming/myfile', $file, FTP_BINARY);
  } else {
    echo "Unable to allocate space on server.  Server said: 
  $result\n";
  }

  ftp_close($conn_id);

  ?> 
See also: ftp_put(), and ftp_fput().   FTP functionsUpftp_cdup
#

#T=int ftok ( string pathname, string proj)
ftok ( ^!string pathname, string proj);
#

#T=ftp_cdup - bool ftp_cdup ( resource ftp_stream)
(PHP 3>= 3.0.13, PHP 4 )
ftp_cdup -- Changes to the parent directory
Description
bool ftp_cdup ( resource ftp_stream)
Changes to the parent directory. 
Example 1. ftp_cdup() example
  <?php
  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // change the current directory to html
  ftp_chdir($conn_id, 'html');

  echo ftp_pwd($conn_id); // /html 

  // return to the parent directory
  if (ftp_cdup($conn_id)) { 
    echo "cdup successful\n";
  } else {
    echo "cdup not successful\n";
  }

  echo ftp_pwd($conn_id); // /

  ftp_close($conn_id);
  ?> 
Returns TRUE on success or FALSE on failure. 
See also ftp_chdir().   ftp_allocUpftp_chdir
#

#T=bool ftp_cdup ( resource ftp_stream)
ftp_cdup ( ^!resource ftp_stream);
#

#T=ftp_chdir - bool ftp_chdir ( resource ftp_stream, string directory)
(PHP 3>= 3.0.13, PHP 4 )
ftp_chdir -- Changes directories on a FTP server
Description
bool ftp_chdir ( resource ftp_stream, string directory)
Changes the current directory to the specified directory. 
Returns TRUE on success or FALSE on failure. 
Example 1. ftp_chdir() example
  <?php

  // set up basic connection
  $conn_id = ftp_connect($ftp_server); 

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass); 

  // check connection
  if ((!$conn_id) || (!$login_result)) {
      die("FTP connection has failed !");
  }

  echo "Current directory: " . ftp_pwd($conn_id) . "\n";

  // try to change the directory to somedir
  if (ftp_chdir($conn_id, "somedir")) {
      echo "Current directory is now: " . ftp_pwd($conn_id) . 
  "\n";
  } else { 
      echo "Couldn't change directory\n";
  }

  // close the connection
  ftp_close($conn_id);
  ?> 
See also ftp_cdup().   ftp_cdupUpftp_chmod
#

#T=bool ftp_chdir ( resource ftp_stream, string directory)
ftp_chdir ( ^!resource ftp_stream, string directory);
#

#T=ftp_chmod - string ftp_chmod ( resource ftp_stream, int mode, string filename)
(PHP 5 CVS only)
ftp_chmod -- Set permissions on a file via FTP
Description
string ftp_chmod ( resource ftp_stream, int mode, string filename)
Sets the permissions on the remote file specified by filename to mode 
given as an octal value. 
Example 1. ftp_chmod() example
  <?php
  $file = 'public_html/index.php';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to chmod $file to 644
  if (ftp_chmod($conn_id, 0644, $file)) {
  echo "$file cdmoded successfully to 644\n";
  } else {
  echo "could not chmod $file\n";
  }

  // close the connection
  ftp_close($conn_id);
  ?> 
Returns the new file permissions on success or FALSE on error. 
See also chmod().   ftp_chdirUpftp_close
#

#T=string ftp_chmod ( resource ftp_stream, int mode, string filename)
ftp_chmod ( ^!resource ftp_stream, int mode, string filename);
#

#T=ftp_close - void ftp_close ( resource ftp_stream)
(PHP 4 >= 4.2.0)
ftp_close -- Closes an FTP connection
Description
void ftp_close ( resource ftp_stream)
ftp_close() closes ftp_stream and releases the resource. After calling 
this function, you can no longer use the FTP connection and must create a 
new one with ftp_connect(). 
Example 1. ftp_close() example
  <?php

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // print the current directory
  echo ftp_pwd($conn_id); // /

  // close this connection
  ftp_close($conn_id);
  ?> 
See also ftp_connect()   ftp_chmodUpftp_connect
#

#T=void ftp_close ( resource ftp_stream)
ftp_close ( ^!resource ftp_stream);
#

#T=ftp_connect - resource ftp_connect ( string host [, int port [, int timeout]])
(PHP 3>= 3.0.13, PHP 4 )
ftp_connect -- Opens an FTP connection
Description
resource ftp_connect ( string host [, int port [, int timeout]])
Returns a FTP stream on success or FALSE on error. 
ftp_connect() opens an FTP connection to the specified host. host 
shouldn't have any trailing slashes and shouldn't be prefixed with ftp://. 
The port parameter specifies an alternate port to connect to. If it is 
omitted or set to zero, then the default FTP port, 21, will be used. 
The timeout parameter specifies the timeout for all subsequent network 
operations. If omitted, the default value is 90 seconds. The timeout can 
be changed and queried at any time with ftp_set_option() and 
ftp_get_option(). 
Note: The timeout parameter became available in PHP 4.2.0. 
Example 1. ftp_connect() example
  <?php

  $ftp_server = "ftp.example.com";

  // set up a connection or die
  $conn_id = ftp_connect($ftp_server) or die("Couldn't connect 
  to $ftp_server"); 

  ?> 
See also ftp_close(), and ftp_ssl_connect().   ftp_closeUpftp_delete
#

#T=resource ftp_connect ( string host [, int port [, int timeout]])
ftp_connect ( ^!string host [, int port [, int timeout]]);
#

#T=ftp_delete - bool ftp_delete ( resource ftp_stream, string path)
(PHP 3>= 3.0.13, PHP 4 )
ftp_delete -- Deletes a file on the FTP server
Description
bool ftp_delete ( resource ftp_stream, string path)
ftp_delete() deletes the file specified by path from the FTP server. 
Example 1. ftp_delete() example
  <?php
  $file = 'public_html/old.txt';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to delete $file
  if (ftp_delete($conn_id, $file)) {
  echo "$file deleted successful\n";
  } else {
  echo "could not delete $file\n";
  }

  // close the connection
  ftp_close($conn_id);
  ?> 
Returns TRUE on success or FALSE on failure.   ftp_connectUpftp_exec
#

#T=bool ftp_delete ( resource ftp_stream, string path)
ftp_delete ( ^!resource ftp_stream, string path);
#

#T=ftp_exec - bool ftp_exec ( resource ftp_stream, string command)
(PHP 4 >= 4.0.3)
ftp_exec -- Requests execution of a program on the FTP server
Description
bool ftp_exec ( resource ftp_stream, string command)
Sends a SITE EXEC command request to the FTP server. Returns TRUE if the 
command was successful (server sent response code: 200); otherwise returns 
FALSE. 
Example 1. ftp_exec() example
  <?php

  $command = 'ls -al';

  $conn_id = ftp_connect($ftp_server);

  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  if ($res = ftp_exec($conn_id, $command)) {
      echo "$command executed successfully<br />\n";
      echo nl2br($res);
  } else {
      echo 'could not execute ' . $command;
  }

  ?> 
See also ftp_raw().   ftp_deleteUpftp_fget
#

#T=bool ftp_exec ( resource ftp_stream, string command)
ftp_exec ( ^!resource ftp_stream, string command);
#

#T=ftp_fget - bool ftp_fget ( resource ftp_stream, resource handle, string remote_file, 
(PHP 3>= 3.0.13, PHP 4 )
ftp_fget -- Downloads a file from the FTP server and saves to an open file
Description
bool ftp_fget ( resource ftp_stream, resource handle, string remote_file, 
int mode [, int resumepos])
ftp_fget() retrieves remote_file from the FTP server, and writes it to the 
given file pointer, handle. The transfer mode specified must be either 
FTP_ASCII or FTP_BINARY. 
Example 1. ftp_fget() example
  <?php

  // open some file for reading
  $file = 'somefile.txt';
  $fp = fopen($file, 'w');

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to download $file
  if (ftp_fget($conn_id, $fp, $file, FTP_ASCII, 1)) {
  echo "successfully written to $file\n";
  } else {
  echo "There was a problem with $file\n";
  }

  // close the connection and the file handler
  ftp_close($conn_id);
  fclose($fp);
  ?> 
Note: The resumepos parameter was added in PHP 4.3.0. 
Returns TRUE on success or FALSE on failure. 
See also ftp_get(), ftp_nb_get() and ftp_nb_fget().   ftp_execUpftp_fput
#

#T=bool ftp_fget ( resource ftp_stream, resource handle, string remote_file, 
ftp_fget ( ^!resource ftp_stream, resource handle, string remote_file, ;
#

#T=ftp_fput - bool ftp_fput ( resource ftp_stream, string remote_file, resource handle, 
(PHP 3>= 3.0.13, PHP 4 )
ftp_fput -- Uploads from an open file to the FTP server
Description
bool ftp_fput ( resource ftp_stream, string remote_file, resource handle, 
int mode [, int startpos])
ftp_fput() uploads the data from the file pointer handle until the end of 
the file is reached. The results are stored in remote_file on the FTP 
server. The transfer mode specified must be either FTP_ASCII or 
FTP_BINARY. 
Example 1. ftp_fput() example
  <?php

  // open some file for reading
  $file = 'somefile.txt';
  $fp = fopen($file, 'r');

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to upload $file
  if (ftp_fput($conn_id, $file, $fp, FTP_ASCII)) {
      echo "Successfully uploaded $file\n";
  } else {
      echo "There was a problem while uploading $file\n";
  }

  // close the connection and the file handler
  ftp_close($conn_id);
  fclose($fp);

  ?> 
Note: The startpos parameter was added in PHP 4.3.0. 
Returns TRUE on success or FALSE on failure. 
See also ftp_put(), ftp_nb_fput(), and ftp_nb_put().   ftp_fgetUpftp_get_option
#

#T=bool ftp_fput ( resource ftp_stream, string remote_file, resource handle, 
ftp_fput ( ^!resource ftp_stream, string remote_file, resource handle, ;
#

#T=ftp_get_option - mixed ftp_get_option ( resource ftp_stream, int option)
(PHP 4 >= 4.2.0)
ftp_get_option -- Retrieves various runtime behaviours of the current FTP 
stream
Description
mixed ftp_get_option ( resource ftp_stream, int option)
Returns the value on success or FALSE if the given option is not 
supported. In the latter case, a warning message is also thrown. 
This function returns the value for the requested option from the 
specified ftp_stream . Currently, the following options are supported: 
Table 1. Supported runtime FTP options
FTP_TIMEOUT_SECReturns the current timeout used for network related 
operations. 

Example 1. ftp_get_option() example
  <?php
  // Get the timeout of the given FTP stream
  $timeout = ftp_get_option($conn_id, FTP_TIMEOUT_SEC);
  ?> 
See also ftp_set_option().   ftp_fputUpftp_get
#

#T=mixed ftp_get_option ( resource ftp_stream, int option)
ftp_get_option ( ^!resource ftp_stream, int option);
#

#T=ftp_get - bool ftp_get ( resource ftp_stream, string local_file, string remote_file, 
(PHP 3>= 3.0.13, PHP 4 )
ftp_get -- Downloads a file from the FTP server
Description
bool ftp_get ( resource ftp_stream, string local_file, string remote_file, 
int mode [, int resumepos])
ftp_get() retrieves remote_file from the FTP server, and saves it to 
local_file locally. The transfer mode specified must be either FTP_ASCII 
or FTP_BINARY. 
Note: The resumepos parameter was added in PHP 4.3.0. 
Returns TRUE on success or FALSE on failure. 
Example 1. ftp_get() example
  <?php

  // define some variables
  $local_file = 'local.zip';
  $server_file = 'server.zip';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to download $server_file and save to $local_file
  if (ftp_get($conn_id, $local_file, $server_file, FTP_BINARY)) 
{
      echo "Successfully written to $local_file\n";
  } else {
      echo "There was a problem\n";
  }

  // close the connection
  ftp_close($conn_id);

  ?> 
See also ftp_fget(), ftp_nb_get() and ftp_nb_fget().   ftp_get_optionUpftp_login
#

#T=bool ftp_get ( resource ftp_stream, string local_file, string remote_file, 
ftp_get ( ^!resource ftp_stream, string local_file, string remote_file, ;
#

#T=ftp_login - bool ftp_login ( resource ftp_stream, string username, string password)
(PHP 3>= 3.0.13, PHP 4 )
ftp_login -- Logs in to an FTP connection
Description
bool ftp_login ( resource ftp_stream, string username, string password)
Logs in to the given FTP stream. 
Returns TRUE on success or FALSE on failure. 
Example 1. ftp_login() example
  <?php
		       
  $ftp_server = "ftp.example.com";
  $ftp_user = "foo";
  $ftp_pass = "bar";

  // set up a connection or die
  $conn_id = ftp_connect($ftp_server) or die("Couldn't connect 
  to $ftp_server"); 

  // try to login
  if (@ftp_login($conn_id, $ftp_user, $ftp_pass)) {
      echo "Connected as $ftp_user@$ftp_server\n";
  } else {
      echo "Couldn't connect as $ftp_user\n";
  }

  // close the connection
  ftp_close($conn_id);  
  ?> 

  ftp_getUpftp_mdtm
#

#T=bool ftp_login ( resource ftp_stream, string username, string password)
ftp_login ( ^!resource ftp_stream, string username, string password);
#

#T=ftp_mdtm - int ftp_mdtm ( resource ftp_stream, string remote_file)
(PHP 3>= 3.0.13, PHP 4 )
ftp_mdtm -- Returns the last modified time of the given file
Description
int ftp_mdtm ( resource ftp_stream, string remote_file)
ftp_mdtm() checks the last modified time for a file, and returns it as a 
Unix timestamp. If an error occurs, or the file does not exist, -1 is 
returned. 
Returns a Unix timestamp on success, or -1 on error. 
Example 1. ftp_mdtm() example
  <?php

  $file = 'somefile.txt';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  //  get the last modified time
  $buff = ftp_mdtm($conn_id, $file);

  if ($buff != -1) {
      // somefile.txt was last modified on: March 26 2003 
  14:16:41.
      echo "$file was last modified on : " . date("F d Y 
  H:i:s.", $buff);
  } else {
      echo "Couldn't get mdtime";
  }

  // close the connection
  ftp_close($conn_id);

  ?> 
Note: Not all servers support this feature! 
Note: ftp_mdtm() does not work with directories.   ftp_loginUpftp_mkdir
#

#T=int ftp_mdtm ( resource ftp_stream, string remote_file)
ftp_mdtm ( ^!resource ftp_stream, string remote_file);
#

#T=ftp_mkdir - string ftp_mkdir ( resource ftp_stream, string directory)
(PHP 3>= 3.0.13, PHP 4 )
ftp_mkdir -- Creates a directory
Description
string ftp_mkdir ( resource ftp_stream, string directory)
Creates the specified directory on the FTP server. 
Returns the newly created directory name on success or FALSE on error. 
Example 1. ftp_mkdir() example
  <?php

  $dir = 'www';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to create the directory $dir
  if (ftp_mkdir($conn_id, $dir)) {
  echo "successfully created $dir\n";
  } else {
  echo "There was a problem while creating $dir\n";
  }

  // close the connection
  ftp_close($conn_id);
  ?> 
See also ftp_rmdir().   ftp_mdtmUpftp_nb_continue
#

#T=string ftp_mkdir ( resource ftp_stream, string directory)
ftp_mkdir ( ^!resource ftp_stream, string directory);
#

#T=ftp_nb_continue - int ftp_nb_continue ( resource ftp_stream)
(PHP 4 >= 4.3.0)
ftp_nb_continue -- Continues retrieving/sending a file (non-blocking)
Description
int ftp_nb_continue ( resource ftp_stream)
Continues retrieving/sending a file non-blocking. 
Example 1. ftp_nb_continue() example
  <?php

  // Initate the download
  $ret = ftp_nb_get($my_connection, "test", "README", 
  FTP_BINARY);
  while ($ret == FTP_MOREDATA) {

     // Continue downloading...
     $ret = ftp_nb_continue($my_connection);
  }
  if ($ret != FTP_FINISHED) {
     echo "There was an error downloading the file...";
     exit(1);
  }
  ?> 
Returns FTP_FAILED or FTP_FINISHED or FTP_MOREDATA.   ftp_mkdirUpftp_nb_fget
#

#T=int ftp_nb_continue ( resource ftp_stream)
ftp_nb_continue ( ^!resource ftp_stream);
#

#T=ftp_nb_fget - int ftp_nb_fget ( resource ftp_stream, resource handle, string 
(PHP 4 >= 4.3.0)
ftp_nb_fget -- Retrieves a file from the FTP server and writes it to an 
open file (non-blocking)
Description
int ftp_nb_fget ( resource ftp_stream, resource handle, string 
remote_file, int mode [, int resumepos])
ftp_nb_fget() retrieves remote_file from the FTP server, and writes it to 
the given file pointer, handle. The transfer mode specified must be either 
FTP_ASCII or FTP_BINARY. The difference between this function and the 
ftp_fget() is that this function retrieves the file asynchronously, so 
your program can perform other operations while the file is being 
downloaded. 
Example 1. ftp_nb_fget() example
  <?php

  // open some file for reading
  $file = 'index.php';
  $fp = fopen($file, 'w');

  $conn_id = ftp_connect($ftp_server);

  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // Initate the download
  $ret = ftp_nb_fget($conn_id, $fp, $file, FTP_BINARY);
  while ($ret == FTP_MOREDATA) {

     // Do whatever you want
     echo ".";

     // Continue downloading...
     $ret = ftp_nb_continue($conn_id);
  }
  if ($ret != FTP_FINISHED) {
     echo "There was an error downloading the file...";
     exit(1);
  }

  // close filepointer
  fclose($fp);
  ?> 
Returns FTP_FAILED, FTP_FINISHED, or FTP_MOREDATA. 
See also ftp_nb_get(), ftp_nb_continue(), ftp_fget(), and ftp_get().   ftp_nb_continueUpftp_nb_fput
#

#T=int ftp_nb_fget ( resource ftp_stream, resource handle, string 
ftp_nb_fget ( ^!resource ftp_stream, resource handle, string ;
#

#T=ftp_nb_fput - int ftp_nb_fput ( resource ftp_stream, string remote_file, resource 
(PHP 4 >= 4.3.0)
ftp_nb_fput -- Stores a file from an open file to the FTP server 
(non-blocking)
Description
int ftp_nb_fput ( resource ftp_stream, string remote_file, resource 
handle, int mode [, int startpos])
ftp_nb_fput() uploads the data from the file pointer handle until it 
reaches the end of the file. The results are stored in remote_file on the 
FTP server. The transfer mode specified must be either FTP_ASCII or 
FTP_BINARY. The difference between this function and the ftp_fput() is 
that this function uploads the file asynchronously, so your program can 
perform other operations while the file is being uploaded. 
Example 1. ftp_nb_fput() example
  <?php

  $file = 'index.php';

  $fp = fopen($file, 'r');

  $conn_id = ftp_connect($ftp_server);

  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // Initate the upload
  $ret = ftp_nb_fput($conn_id, $file, $fp, FTP_BINARY);
  while ($ret == FTP_MOREDATA) {

     // Do whatever you want
     echo ".";

     // Continue upload...
     $ret = ftp_nb_continue($conn_id);
  }
  if ($ret != FTP_FINISHED) {
     echo "There was an error uploading the file...";
     exit(1);
  }

  fclose($fp);
  ?> 
Returns FTP_FAILED, FTP_FINISHED, or FTP_MOREDATA. 
See also ftp_nb_put(), ftp_nb_continue(), ftp_put() and ftp_fput().   ftp_nb_fgetUpftp_nb_get
#

#T=int ftp_nb_fput ( resource ftp_stream, string remote_file, resource 
ftp_nb_fput ( ^!resource ftp_stream, string remote_file, resource ;
#

#T=ftp_nb_get - int ftp_nb_get ( resource ftp_stream, string local_file, string 
(PHP 4 >= 4.3.0)
ftp_nb_get -- Retrieves a file from the FTP server and writes it to a 
local file (non-blocking)
Description
int ftp_nb_get ( resource ftp_stream, string local_file, string 
remote_file, int mode [, int resumepos])
ftp_nb_get() retrieves remote_file from the FTP server, and saves it to 
local_file locally. The transfer mode specified must be either FTP_ASCII 
or FTP_BINARY. The difference between this function and the ftp_get() is 
that this function retrieves the file asynchronously, so your program can 
perform other operations while the file is being downloaded. 
Returns FTP_FAILED, FTP_FINISHED, or FTP_MOREDATA. 
Example 1. ftp_nb_get() example
  <?php

  // Initate the download
  $ret = ftp_nb_get($my_connection, "test", "README", 
  FTP_BINARY);
  while ($ret == FTP_MOREDATA) {
     
     // Do whatever you want
     echo ".";

     // Continue downloading...
     $ret = ftp_nb_continue($my_connection);
  }
  if ($ret != FTP_FINISHED) {
     echo "There was an error downloading the file...";
     exit(1);
  }
  ?> 

Example 2. Resuming a download with ftp_nb_get()
  <?php

  // Initate 
  $ret = ftp_nb_get($my_connection, "test", "README", 
  FTP_BINARY, 
			filesize("test"));
  // OR: $ret = ftp_nb_get($my_connection, "test", "README", 
  //                           FTP_BINARY, FTP_AUTORESUME);
  while ($ret == FTP_MOREDATA) {
     
     // Do whatever you want
     echo ".";

     // Continue downloading...
     $ret = ftp_nb_continue($my_connection);
  }
  if ($ret != FTP_FINISHED) {
     echo "There was an error downloading the file...";
     exit(1);
  }
  ?> 

Example 3. Resuming a download at position 100 to a new file with 
ftp_nb_get() 
  <?php

  // Disable Autoseek
  ftp_set_option($my_connection, FTP_AUTOSEEK, false);

  // Initiate
  $ret = ftp_nb_get($my_connection, "newfile", "README", 
  FTP_BINARY, 100);
  while ($ret == FTP_MOREDATA) {

     /* ... */
     
     // Continue downloading...
     $ret = ftp_nb_continue($my_connection);
  }
  ?> 
In the example above, "newfile" is 100 bytes smaller than "README" on the 
FTP server because we started reading at offset 100. If we have not have 
disabled FTP_AUTOSEEK, the first 100 bytes of "newfile" will be '\0'. 
See also ftp_nb_fget(), ftp_nb_continue(), ftp_get(), and ftp_fget().   ftp_nb_fputUpftp_nb_put
#

#T=int ftp_nb_get ( resource ftp_stream, string local_file, string 
ftp_nb_get ( ^!resource ftp_stream, string local_file, string ;
#

#T=ftp_nb_put - int ftp_nb_put ( resource ftp_stream, string remote_file, string 
(PHP 4 >= 4.3.0)
ftp_nb_put -- Stores a file on the FTP server (non-blocking)
Description
int ftp_nb_put ( resource ftp_stream, string remote_file, string 
local_file, int mode [, int startpos])
ftp_nb_put() stores local_file on the FTP server, as remote_file. The 
transfer mode specified must be either FTP_ASCII or FTP_BINARY. The 
difference between this function and the ftp_put() is that this function 
uploads the file asynchronously, so your program can perform other 
operations while the file is being uploaded. 
Returns FTP_FAILED, FTP_FINISHED, or FTP_MOREDATA. 
Example 1. ftp_nb_put() example
  <?php

  // Initiate the Upload
  $ret = ftp_nb_put($my_connection, "test.remote", "test.local", 
  FTP_BINARY);
  while ($ret == FTP_MOREDATA) {
     
     // Do whatever you want
     echo ".";

     // Continue uploading...
     $ret = ftp_nb_continue($my_connection);
  }
  if ($ret != FTP_FINISHED) {
     echo "There was an error uploading the file...";
     exit(1);
  }
  ?> 

Example 2. Resuming an upload with ftp_nb_put()
  <?php

  // Initiate
  $ret = ftp_nb_put($my_connection, "test.remote", "test.local", 

			FTP_BINARY, ftp_size("test.remote"));
  // OR: $ret = ftp_nb_put($my_connection, "test.remote", 
  "test.local", 
  //                           FTP_BINARY, FTP_AUTORESUME);

  while ($ret == FTP_MOREDATA) {
     
     // Do whatever you want
     echo ".";

     // Continue uploading...
     $ret = ftp_nb_continue($my_connection);
  }
  if ($ret != FTP_FINISHED) {
     echo "There was an error uploading the file...";
     exit(1);
  }
  ?> 
See also ftp_nb_fput(), ftp_nb_continue(), ftp_put(), and ftp_fput().   ftp_nb_getUpftp_nlist
#

#T=int ftp_nb_put ( resource ftp_stream, string remote_file, string 
ftp_nb_put ( ^!resource ftp_stream, string remote_file, string ;
#

#T=ftp_nlist - array ftp_nlist ( resource ftp_stream, string directory)
(PHP 3>= 3.0.13, PHP 4 )
ftp_nlist -- Returns a list of files in the given directory
Description
array ftp_nlist ( resource ftp_stream, string directory)
Returns an array of filenames from the specified directory on success or 
FALSE on error. 
Example 1. ftp_nlist() example
  <?php

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // get contents of the current directory
  $contents = ftp_nlist($conn_id, ".");

  // output $contents
  var_dump($contents);

  ?> 

The above example will output something similar to: 
array(3) {
[0]=>
string(11) "public_html"
[1]=>
string(10) "public_ftp"
[2]=>
string(3) "www"
See also ftp_rawlist().   ftp_nb_putUpftp_pasv
#

#T=array ftp_nlist ( resource ftp_stream, string directory)
ftp_nlist ( ^!resource ftp_stream, string directory);
#

#T=ftp_pasv - bool ftp_pasv ( resource ftp_stream, bool pasv)
(PHP 3>= 3.0.13, PHP 4 )
ftp_pasv -- Turns passive mode on or off
Description
bool ftp_pasv ( resource ftp_stream, bool pasv)
ftp_pasv() turns on passive mode if the pasv parameter is TRUE. It turns 
off passive mode if pasv is FALSE. In passive mode, data connections are 
initiated by the client, rather than by the server. 
Example 1. ftp_pasv() example
  <?php
  $file = 'somefile.txt';
  $remote_file = 'readme.txt';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // turn passive mode on
  ftp_pasv($conn_id, true);

  // upload a file
  if (ftp_put($conn_id, $remote_file, $file, FTP_ASCII)) {
  echo "successfully uploaded $file\n";
  } else {
  echo "There was a problem while uploading $file\n";
  }

  // close the connection
  ftp_close($conn_id);
  ?> 
Returns TRUE on success or FALSE on failure.   ftp_nlistUpftp_put
#

#T=bool ftp_pasv ( resource ftp_stream, bool pasv)
ftp_pasv ( ^!resource ftp_stream, bool pasv);
#

#T=ftp_put - bool ftp_put ( resource ftp_stream, string remote_file, string local_file, 
(PHP 3>= 3.0.13, PHP 4 )
ftp_put -- Uploads a file to the FTP server
Description
bool ftp_put ( resource ftp_stream, string remote_file, string local_file, 
int mode [, int startpos])
ftp_put() stores local_file on the FTP server, as remote_file. The 
transfer mode specified must be either FTP_ASCII or FTP_BINARY. 
Note: The startpos parameter was added in PHP 4.3.0. 
Returns TRUE on success or FALSE on failure. 
Example 1. ftp_put() example
  <?php
  $file = 'somefile.txt';
  $remote_file = 'readme.txt';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // upload a file
  if (ftp_put($conn_id, $remote_file, $file, FTP_ASCII)) {
  echo "successfully uploaded $file\n";
  } else {
  echo "There was a problem while uploading $file\n";
  }

  // close the connection
  ftp_close($conn_id);
  ?> 
See also ftp_fput(), ftp_nb_fput(), and ftp_nb_put().   ftp_pasvUpftp_pwd
#

#T=bool ftp_put ( resource ftp_stream, string remote_file, string local_file, 
ftp_put ( ^!resource ftp_stream, string remote_file, string local_file, ;
#

#T=ftp_pwd - string ftp_pwd ( resource ftp_stream)
(PHP 3>= 3.0.13, PHP 4 )
ftp_pwd -- Returns the current directory name
Description
string ftp_pwd ( resource ftp_stream)
Returns the current directory or FALSE on error. 
Example 1. ftp_pwd() example
  <?php

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // change directory to public_html
  ftp_chdir($conn_id, 'public_html');

  // print current directory
  echo ftp_pwd($conn_id); // /public_html

  // close the connection
  ftp_close($conn_id);
  ?> 

  ftp_putUpftp_quit
ftp_quit
ftp_quit -- Alias of ftp_close()
Description
This function is an alias of ftp_close().   ftp_pwdUpftp_raw
#

#T=string ftp_pwd ( resource ftp_stream)
ftp_pwd ( ^!resource ftp_stream);
#

#T=ftp_raw - array ftp_raw ( resource ftp_stream, string command)
(PHP 5 CVS only)
ftp_raw -- Sends an arbitrary command to an FTP server
Description
array ftp_raw ( resource ftp_stream, string command)
Sends an arbitrary command to the FTP server. Returns the server's 
response as an array of strings. No parsing is performed on the response 
string, nor does ftp_raw() determine if the command succeeded. 
Example 1. Using ftp_raw() to login to an FTP server manually.
  <?php
  $fp = ftp_connect("ftp.example.com");

  /* This is the same as: 
     ftp_login($fp, "joeblow", "secret"); */
  ftp_raw($fp, "USER joeblow");
  ftp_raw($fp, "PASS secret");
  ?> 
See Also: ftp_exec()   ftp_quitUpftp_rawlist
#

#T=array ftp_raw ( resource ftp_stream, string command)
ftp_raw ( ^!resource ftp_stream, string command);
#

#T=ftp_rawlist - array ftp_rawlist ( resource ftp_stream, string directory)
(PHP 3>= 3.0.13, PHP 4 )
ftp_rawlist -- Returns a detailed list of files in the given directory
Description
array ftp_rawlist ( resource ftp_stream, string directory)
ftp_rawlist() executes the FTP LIST command, and returns the result as an 
array. Each array element corresponds to one line of text. The output is 
not parsed in any way. The system type identifier returned by 
ftp_systype() can be used to determine how the results should be 
interpreted. 
Example 1. ftp_rawlist() example
  <?php

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // get the file list for /
  $buff = ftp_rawlist($conn_id, '/');

  // close the connection
  ftp_close($conn_id);

  // output the buffer
  var_dump($buff);
  ?> 

The above example will output something similar to:     
array(3) {
[0]=>
string(65) "drwxr-x---   3 vincent  vincent      4096 Jul 12 12:16 public_ftp"
[1]=>
string(66) "drwxr-x---  15 vincent  vincent      4096 Nov  3 21:31 public_html"
[2]=>
string(73) "lrwxrwxrwx   1 vincent  vincent        11 Jul 12 12:16 www -> public_html"
}
See also ftp_nlist().   ftp_rawUpftp_rename
#

#T=array ftp_rawlist ( resource ftp_stream, string directory)
ftp_rawlist ( ^!resource ftp_stream, string directory);
#

#T=ftp_rename - bool ftp_rename ( resource ftp_stream, string from, string to)
(PHP 3>= 3.0.13, PHP 4 )
ftp_rename -- Renames a file on the FTP server
Description
bool ftp_rename ( resource ftp_stream, string from, string to)
ftp_rename() renames the file or directory that is currently named from to 
the new name to, using the FTP stream ftp_stream. 
Example 1. ftp_rename() example
  <?php
  $old_file = 'somefile.txt.bak';
  $new_file = 'somefile.txt';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to rename $olf_file to $new_file
  if (ftp_rename($conn_id, $old_file, $new_file)) {
  echo "successfully renamed $old_file to $new_file\n";
  } else {
  echo "There was a problem while renaming $old_file to 
  $new_file\n";
  }

  // close the connection
  ftp_close($conn_id);
  ?> 
Returns TRUE on success or FALSE on failure.   ftp_rawlistUpftp_rmdir
#

#T=bool ftp_rename ( resource ftp_stream, string from, string to)
ftp_rename ( ^!resource ftp_stream, string from, string to);
#

#T=ftp_rmdir - bool ftp_rmdir ( resource ftp_stream, string directory)
(PHP 3>= 3.0.13, PHP 4 )
ftp_rmdir -- Removes a directory
Description
bool ftp_rmdir ( resource ftp_stream, string directory)
Removes the specified directory. directory must be either an absolute or 
relative path to an empty directory. 
Returns TRUE on success or FALSE on failure. 
Example 1. ftp_rmdir() example
  <?php

  $dir = 'www/';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // try to delete the directory $dir
  if (ftp_rmdir($conn_id, $dir)) {
      echo "Successfully deleted $dir\n";
  } else {
      echo "There was a problem while deleting $dir\n";
  }

  ftp_close($conn_id);

  ?> 
See also ftp_mkdir().   ftp_renameUpftp_set_option
#

#T=bool ftp_rmdir ( resource ftp_stream, string directory)
ftp_rmdir ( ^!resource ftp_stream, string directory);
#

#T=ftp_set_option - bool ftp_set_option ( resource ftp_stream, int option, mixed value)
(PHP 4 >= 4.2.0)
ftp_set_option -- Set miscellaneous runtime FTP options
Description
bool ftp_set_option ( resource ftp_stream, int option, mixed value)
Returns TRUE if the option could be set; FALSE if not. A warning message 
will be thrown if the option is not supported or the passed value doesn't 
match the expected value for the given option. 
This function controls various runtime options for the specified FTP 
stream. The value parameter depends on which option parameter is chosen to 
be altered. Currently, the following options are supported: 
Table 1. Supported runtime FTP options
FTP_TIMEOUT_SECChanges the timeout in seconds used for all network 
related functions. value must be an integer that is greater than 0. 
The default timeout is 90 seconds.
FTP_AUTOSEEKWhen enabled, GET or PUT requests with a resumepos or 
startpos parameter will first seek to the requested position within 
the file. This is enabled by default. 

Example 1. ftp_set_option() example
  <?php
  // Set the network timeout to 10 seconds
  ftp_set_option($conn_id, FTP_TIMEOUT_SEC, 10);
  ?> 
See also ftp_get_option().   ftp_rmdirUpftp_site
#

#T=bool ftp_set_option ( resource ftp_stream, int option, mixed value)
ftp_set_option ( ^!resource ftp_stream, int option, mixed value);
#

#T=ftp_site - bool ftp_site ( resource ftp_stream, string cmd)
(PHP 3>= 3.0.15, PHP 4 )
ftp_site -- Sends a SITE command to the server
Description
bool ftp_site ( resource ftp_stream, string cmd)
ftp_site() sends the command specified by cmd to the FTP server. SITE 
commands are not standardized, and vary from server to server. They are 
useful for handling such things as file permissions and group membership. 
Example 1. Sending a SITE command to an ftp server
  <?php
  /* Connect to FTP server */
  $conn = ftp_connect('ftp.example.com');
  if (!$conn) die('Unable to connect to ftp.example.com');

  /* Login as "user" with password "pass" */
  if (!ftp_login($conn, 'user', 'pass')) die('Error logging into 
  ftp.example.com');

  /* Issue: "SITE CHMOD 0600 /home/user/privatefile" command to 
  ftp server */
  if (ftp_site($conn, 'CHMOD 0600 /home/user/privatefile')) {
     echo "Command executed successfully.\n";
  } else {
     die('Command failed.');
  }
  ?> 
Returns TRUE on success or FALSE on failure. 
See Also: ftp_raw()   ftp_set_optionUpftp_size
#

#T=bool ftp_site ( resource ftp_stream, string cmd)
ftp_site ( ^!resource ftp_stream, string cmd);
#

#T=ftp_size - int ftp_size ( resource ftp_stream, string remote_file)
(PHP 3>= 3.0.13, PHP 4 )
ftp_size -- Returns the size of the given file
Description
int ftp_size ( resource ftp_stream, string remote_file)
ftp_size() returns the size of a remote_file in bytes. If an error occurs, 
or if the given file does not exist, or is a directory, -1 is returned. 
Not all servers support this feature. 
Returns the file size on success, or -1 on error. 
Example 1. ftp_size() example
  <?php

  $file = 'somefile.txt';

  // set up basic connection
  $conn_id = ftp_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  // get the size of $file
  $res = ftp_size($conn_id, $file);

  if ($res != -1) {
      echo "size of $file is $res bytes";
  } else {
      echo "couldn't get the size";
  }

  // close the connection
  ftp_close($conn_id);

  ?> 
See also ftp_rawlist().   ftp_siteUpftp_ssl_connect
#

#T=int ftp_size ( resource ftp_stream, string remote_file)
ftp_size ( ^!resource ftp_stream, string remote_file);
#

#T=ftp_ssl_connect - resource ftp_ssl_connect ( string host [, int port [, int timeout]])
(PHP 4 >= 4.3.0)
ftp_ssl_connect -- Opens an Secure SSL-FTP connection
Description
resource ftp_ssl_connect ( string host [, int port [, int timeout]])
Returns a SSL-FTP stream on success or FALSE on error. 
ftp_ssl_connect() opens a SSL-FTP connection to the specified host. The 
port parameter specifies an alternate port to connect to. If it's omitted 
or set to zero then the default FTP port 21 will be used. 
The timeout parameter specifies the timeout for all subsequent network 
operations. If omitted, the default value is 90 seconds. The timeout can 
be changed and queried at any time with ftp_set_option() and 
ftp_get_option(). 
Example 1. ftp_ssl_connect() example
  <?php

  // set up basic ssl connection
  $conn_id = ftp_ssl_connect($ftp_server);

  // login with username and password
  $login_result = ftp_login($conn_id, $ftp_user_name, 
  $ftp_user_pass);

  echo ftp_pwd($conn_id); // /

  // close the ssl connection
  ftp_close($conn_id);
  ?> 
Why this function may not exist: ftp_ssl_connect() is only available if 
OpenSSL support is enabled into your version of PHP. If it's undefined 
and you've compiled FTP support then this is why. 
See also ftp_connect().   ftp_sizeUpftp_systype
#

#T=resource ftp_ssl_connect ( string host [, int port [, int timeout]])
ftp_ssl_connect ( ^!string host [, int port [, int timeout]]);
#

#T=ftp_systype - string ftp_systype ( resource ftp_stream)
(PHP 3>= 3.0.13, PHP 4 )
ftp_systype -- Returns the system type identifier of the remote FTP server
Description
string ftp_systype ( resource ftp_stream)
Returns the remote system type, or FALSE on error. 
Example 1. ftp_systype() example
  <?php

  // ftp connection
  $ftp = ftp_connect('ftp.example.com');
  ftp_login($ftp, 'user', 'password');

  // get the system type
  if ($type = ftp_systype($ftp)) {
      echo "Example.com is powered by $type\n";
  } else {
      echo "Couldn't get the systype";
  }

  ?> 

The above example will output something similar to: 
Example.com is powered by UNIX

  ftp_ssl_connectUpFunction Handling functions
#

#T=string ftp_systype ( resource ftp_stream)
ftp_systype ( ^!resource ftp_stream);
#

#T=ftruncate - bool ftruncate ( resource handle, int size)
(PHP 4 )
ftruncate -- Truncates a file to a given length
Description
bool ftruncate ( resource handle, int size)
Takes the filepointer, handle, and truncates the file to length, size. 
Returns TRUE on success or FALSE on failure. 
Note: Prior to PHP 4.3.3, ftruncate() returns an integer value of 1 on 
success, instead of boolean TRUE. 
See also fopen() and fseek().   ftellUpfwrite
#

#T=bool ftruncate ( resource handle, int size)
ftruncate ( ^!resource handle, int size);
#

#T=func_get_arg - mixed func_get_arg ( int arg_num)
(PHP 4 )
func_get_arg -- Return an item from the argument list
Description
mixed func_get_arg ( int arg_num)
Returns the argument which is at the arg_num'th offset into a user-defined 
function's argument list. Function arguments are counted starting from 
zero. func_get_arg() will generate a warning if called from outside of a 
function definition. 
If arg_num is greater than the number of arguments actually passed, a 
warning will be generated and func_get_arg() will return FALSE. 
<?php
function foo() {
 $numargs = func_num_args();
 echo "Number of arguments: $numargs<br />\n";
 if ($numargs >= 2) {
 echo "Second argument is: " . func_get_arg(1) . "<br />\n";
 }
} 

foo (1, 2, 3);
?> 

func_get_arg() may be used in conjunction with func_num_args() and 
func_get_args() to allow user-defined functions to accept variable-length 
argument lists. 
Note: This function was added in PHP 4.   create_functionUpfunc_get_args
#

#T=mixed func_get_arg ( int arg_num)
func_get_arg ( ^!int arg_num);
#

#T=func_get_args - array func_get_args ( void )
(PHP 4 )
func_get_args --  Returns an array comprising a function's argument list 
Description
array func_get_args ( void )
Returns an array in which each element is the corresponding member of the 
current user-defined function's argument list. func_get_args() will 
generate a warning if called from outside of a function definition. 
<?php
function foo() {
$numargs = func_num_args();
echo "Number of arguments: $numargs<br />\n";
if ($numargs >= 2) {
    echo "Second argument is: " . func_get_arg(1) . "<br />\n";
}
$arg_list = func_get_args();
for ($i = 0; $i < $numargs; $i++) {
    echo "Argument $i is: " . $arg_list[$i] . "<br />\n";
}
} 

foo(1, 2, 3);
?> 

func_get_args() may be used in conjunction with func_num_args() and 
func_get_arg() to allow user-defined functions to accept variable-length 
argument lists. 
Note: This function was added in PHP 4.   func_get_argUpfunc_num_args
#

#T=array func_get_args ( void )
func_get_args ( ^!void );
#

#T=func_num_args - int func_num_args ( void )
(PHP 4 )
func_num_args --  Returns the number of arguments passed to the function 
Description
int func_num_args ( void )
Returns the number of arguments passed into the current user-defined 
function. func_num_args() will generate a warning if called from outside 
of a user-defined function. 
<?php
function foo() {
$numargs = func_num_args();
echo "Number of arguments: $numargs\n";
} 

foo(1, 2, 3);    // Prints 'Number of arguments: 3'
?> 

func_num_args() may be used in conjunction with func_get_arg() and 
func_get_args() to allow user-defined functions to accept variable-length 
argument lists.   func_get_argsUpfunction_exists
#

#T=int func_num_args ( void )
func_num_args ( ^!void );
#

#T=function_exists - bool function_exists ( string function_name)
(PHP 3>= 3.0.7, PHP 4 )
function_exists --  Return TRUE if the given function has been defined 
Description
bool function_exists ( string function_name)
Checks the list of defined functions, both built-in (internal) and 
user-defined, for function_name. Returns TRUE on success or FALSE on 
failure. 
<?php
if (function_exists('imap_open')) {
echo "IMAP functions are available.<br />\n";
} else {
echo "IMAP functions are not available.<br />\n";
}
?> 

Note that a function name may exist even if the function itself is 
unusable due to configuration or compiling options (with the image 
functions being an example). Also note that function_exists() will return 
FALSE for constructs, such as include_once() and echo(). 
See also method_exists() and get_defined_functions().   func_num_argsUpget_defined_functions
#

#T=bool function_exists ( string function_name)
function_exists ( ^!string function_name);
#

#T=fwrite - int fwrite ( resource handle, string string [, int length])
(PHP 3, PHP 4 )
fwrite -- Binary-safe file write
Description
int fwrite ( resource handle, string string [, int length])
fwrite() writes the contents of string to the file stream pointed to by 
handle. If the length argument is given, writing will stop after length 
bytes have been written or the end of string is reached, whichever comes 
first. 
fwrite() returns the number of bytes written, or FALSE on error. 
Note that if the length argument is given, then the magic_quotes_runtime 
configuration option will be ignored and no slashes will be stripped from 
string. 
Note: On systems which differentiate between binary and text files (i.e. 
Windows) the file must be opened with 'b' included in fopen() mode 
parameter. 
Example 1. A simple fwrite example
  <?php
  $filename = 'test.txt';
  $somecontent = "Add this to the file\n";

  // Let's make sure the file exists and is writable first.
  if (is_writable($filename)) {

      // In our example we're opening $filename in append mode.
      // The file pointer is at the bottom of the file hence 
      // that's where $somecontent will go when we fwrite() it.
      if (!$handle = fopen($filename, 'a')) {
	   echo "Cannot open file ($filename)";
	   exit;
      }

      // Write $somecontent to our opened file.
      if (!fwrite($handle, $somecontent)) {
	  echo "Cannot write to file ($filename)";
	  exit;
      }
      
      echo "Success, wrote ($somecontent) to file ($filename)";
      
      fclose($handle);
		      
  } else {
      echo "The file $filename is not writable";
  }
  ?> 
See also fread(), fopen(), fsockopen(), popen(), and fputs().   ftruncateUpglob
#

#T=int fwrite ( resource handle, string string [, int length])
fwrite ( ^!resource handle, string string [, int length]);
#

#T=gd_info - array gd_info ( void )
(PHP 4 >= 4.3.0)
gd_info -- Retrieve information about the currently installed GD library
Description
array gd_info ( void )
Returns an associative array describing the version and capabilities of 
the installed GD library. 
Table 1. Elements of array returned by gd_info()
AttributeMeaning
GD Versionstring value describing the installed libgd version.
Freetype Supportboolean value. TRUE if Freetype Support is 
installed.
Freetype Linkagestring value describing the way in which Freetype 
was linked. Expected values are: 'with freetype', 'with TTF 
library', and 'with unknown library'. This element will only be 
defined if Freetype Support evaluated to TRUE.
T1Lib Supportboolean value. TRUE if T1Lib support is included.
GIF Read Supportboolean value. TRUE if support for reading GIF 
images is included.
GIF Create Supportboolean value. TRUE if support for creating GIF 
images is included.
JPG Supportboolean value. TRUE if JPG support is included.
PNG Supportboolean value. TRUE if PNG support is included.
WBMP Supportboolean value. TRUE if WBMP support is included.
XBM Supportboolean value. TRUE if XBM support is included.

Example 1. Using gd_info()
  <?php
  var_dump(gd_info());
  ?> 

The typical output is : 
array(9) {
["GD Version"]=>
string(24) "bundled (2.0 compatible)"
["FreeType Support"]=>
bool(false)
["T1Lib Support"]=>
bool(false)
["GIF Read Support"]=>
bool(true)
["GIF Create Support"]=>
bool(false)
["JPG Support"]=>
bool(false)
["PNG Support"]=>
bool(true)
["WBMP Support"]=>
bool(true)
["XBM Support"]=>
bool(false)
}
See also imagepng(), imagejpeg(), imagegif(), imagewbmp(), and 
imagetypes().   exif_thumbnailUpgetimagesize
#

#T=array gd_info ( void )
gd_info ( ^!void );
#

#T=get_browser - object get_browser ( [string user_agent])
(PHP 3, PHP 4 )
get_browser --  Tells what the user's browser is capable of 
Description
object get_browser ( [string user_agent])
get_browser() attempts to determine the capabilities of the user's 
browser. This is done by looking up the browser's information in the 
browscap.ini file. By default, the value of HTTP_USER_AGENT is used; 
however, you can alter this (i.e., look up another browser's info) by 
passing the optional user_agent parameter to get_browser(). 
The information is returned in an object, which will contain various data 
elements representing, for instance, the browser's major and minor version 
numbers and ID string; TRUE/FALSE values for features such as frames, 
JavaScript, and cookies; and so forth. 
While browscap.ini contains information on many browsers, it relies on 
user updates to keep the database current. The format of the file is 
fairly self-explanatory. 
The following example shows how one might list all available information 
retrieved about the user's browser. Example 1. get_browser() example
  <?php
  echo $_SERVER['HTTP_USER_AGENT'] . "<hr />\n";

  $browser = get_browser();

  foreach ($browser as $name => $value) {
      echo "<b>$name</b> $value <br />\n";
  }

  ?> 

The output of the above script would look something like this: 
Mozilla/4.5 [en] (X11; U; Linux 2.2.9 i586)<hr />
<b>browser_name_pattern:</b> Mozilla/4\.5.*<br />
<b>parent:</b> Netscape 4.0<br />
<b>platform:</b> Linux<br />
<b>majorver:</b> 4<br />
<b>minorver:</b> 5<br />
<b>browser:</b> Netscape<br />
<b>version:</b> 4<br />
<b>frames:</b> 1<br />
<b>tables:</b> 1<br />
<b>cookies:</b> 1<br />
<b>backgroundsounds:</b> <br />
<b>vbscript:</b> <br />
<b>javascript:</b> 1<br />
<b>javaapplets:</b> 1<br />
<b>activexcontrols:</b> <br />
<b>beta:</b> <br />
<b>crawler:</b> <br />
<b>authenticodeupdate:</b> <br />
<b>msn:</b> <br />
In order for this to work, your browscap configuration setting in php.ini 
must point to the correct location of the browscap.ini file on your 
system. browscap.ini is not bundled with PHP but you may find an 
up-to-date browscap.ini file here. By default, the browscap directive is 
commented out. 
The cookies value simply means that the browser itself is capable of 
accepting cookies and does not mean the user has enabled the browser to 
accept cookies or not. The only way to test if cookies are accepted is to 
set one with setcookie(), reload, and check for the value. 
Note: On versions older than PHP 4.0.6, you will have to pass the user 
agent in via the optional user_agent parameter if the PHP directive 
register_globals is off. In this case, you will pass in 
$HTTP_SERVER_VARS['HTTP_USER_AGENT'].   exitUphighlight_file
#

#T=object get_browser ( [string user_agent])
get_browser ( ^![string user_agent]);
#

#T=get_cfg_var - string get_cfg_var ( string varname)
(PHP 3, PHP 4 )
get_cfg_var --  Gets the value of a PHP configuration option 
Description
string get_cfg_var ( string varname)
Returns the current value of the PHP configuration variable specified by 
varname, or FALSE if an error occurs. 
It will not return configuration information set when the PHP was 
compiled, or read from an Apache configuration file (using the 
php3_configuration_option directives). 
To check whether the system is using a configuration file, try retrieving 
the value of the cfg_file_path configuration setting. If this is 
available, a configuration file is being used. 
See also ini_get().   extension_loadedUpget_current_user
#

#T=string get_cfg_var ( string varname)
get_cfg_var ( ^!string varname);
#

#T=get_class_methods - array get_class_methods ( mixed class_name)
(PHP 4 )
get_class_methods -- Returns an array of class methods' names
Description
array get_class_methods ( mixed class_name)
This function returns an array of method names defined for the class 
specified by class_name. 
Note: As of PHP 4.0.6, you can specify the object itself instead of 
class_name. For example: 
<?php
$class_methods = get_class_methods($my_class); // see below the 
full example
?> 

Example 1. get_class_methods() example
  <?php

  class myclass {
      // constructor
      function myclass() {
	  return(true);
      }
      
      // method 1
      function myfunc1() {
	  return(true);
      }

      // method 2
      function myfunc2() {
	  return(true);
      }
  }

  $my_object = new myclass();

  $class_methods = get_class_methods(get_class($my_object));

  foreach ($class_methods as $method_name) {
      echo "$method_name\n";
  }

  ?> 

Will produce: 
myclass
myfunc1
myfunc2
See also get_class_vars() and get_object_vars().   class_existsUpget_class_vars
#

#T=array get_class_methods ( mixed class_name)
get_class_methods ( ^!mixed class_name);
#

#T=get_class_vars - array get_class_vars ( string class_name)
(PHP 4 )
get_class_vars --  Returns an array of default properties of the class 
Description
array get_class_vars ( string class_name)
This function will return an associative array of default properties of 
the class. The resulting array elements are in the form of varname => 
value. 
Note: Prior to PHP 4.2.0, Uninitialized class variables will not be 
reported by get_class_vars(). 
Example 1. get_class_vars() example
  <?php

  class myclass {

      var $var1; // this has no default value...
      var $var2 = "xyz";
      var $var3 = 100;
      
      // constructor
      function myclass() {
	  return(true);
      }

  }

  $my_class = new myclass();

  $class_vars = get_class_vars(get_class($my_class));

  foreach ($class_vars as $name => $value) {
      echo "$name : $value\n";
  }

  ?> 

Will produce: 
// Before PHP 4.2.0
var2 : xyz
var3 : 100

// As of PHP 4.2.0
var1 :
var2 : xyz
var3 : 100
See also get_class_methods(), get_object_vars()   get_class_methodsUpget_class
#

#T=array get_class_vars ( string class_name)
get_class_vars ( ^!string class_name);
#

#T=get_class - string get_class ( object obj)
(PHP 4 )
get_class -- Returns the name of the class of an object
Description
string get_class ( object obj)
This function returns the name of the class of which the object obj is an 
instance. Returns FALSE if obj is not an object. 
Note: get_class() returns a user defined class name in lowercase. A 
class defined in a PHP extension is returned in its original notation. 
Example 1. Using get_class()
  <?php

  class foo {
      function foo() {
      // implements some logic
      }

      function name() {
	  echo "My name is " , get_class($this) , "\n";
      }
  }

  // create an object
  $bar = new foo();

  // external call
  echo "Its name is " , get_class($bar) , "\n";

  // internal call
  $bar->name();

  ?> 

The output is: 
Its name is foo
My name is foo
See also get_parent_class(), gettype(), and is_subclass_of().   get_class_varsUpget_declared_classes
#

#T=string get_class ( object obj)
get_class ( ^!object obj);
#

#T=get_current_user - string get_current_user ( void )
(PHP 3, PHP 4 )
get_current_user --  Gets the name of the owner of the current PHP script 
Description
string get_current_user ( void )
Returns the name of the owner of the current PHP script. 
See also getmyuid(), getmygid(), getmypid(), getmyinode(), and 
getlastmod().   get_cfg_varUpget_defined_constants
#

#T=string get_current_user ( void )
get_current_user ( ^!void );
#

#T=get_declared_classes - array get_declared_classes ( void )
(PHP 4 )
get_declared_classes -- Returns an array with the name of the defined 
classes
Description
array get_declared_classes ( void )
This function returns an array of the names of the declared classes in the 
current script. 
Note: In PHP 4.0.1pl2, three extra classes are returned at the beginning 
of the array: stdClass (defined in Zend/zend.c), OverloadedTestClass 
(defined in ext/standard/basic_functions.c) and Directory (defined in 
ext/standard/dir.c). 
Also note that depending on what libraries you have compiled into PHP, 
additional classes could be present. This means that you will not be 
able to define your own classes using these names. There is a list of 
predefined classes in the Predefined Classes section of the appendices. 
See also class_exists().   get_classUpget_object_vars
#

#T=array get_declared_classes ( void )
get_declared_classes ( ^!void );
#

#T=get_defined_constants - array get_defined_constants ( void )
(PHP 4 >= 4.1.0)
get_defined_constants --  Returns an associative array with the names of 
all the constants and their values 
Description
array get_defined_constants ( void )
This function returns the names and values of all the constants currently 
defined. This includes those created by extensions as well as those 
created with the define() function. 
For example the line below: 
<?php
print_r(get_defined_constants());
?> 

will print a list like: 
Array
(
[E_ERROR] => 1
[E_WARNING] => 2
[E_PARSE] => 4
[E_NOTICE] => 8
[E_CORE_ERROR] => 16
[E_CORE_WARNING] => 32
[E_COMPILE_ERROR] => 64
[E_COMPILE_WARNING] => 128
[E_USER_ERROR] => 256
[E_USER_WARNING] => 512
[E_USER_NOTICE] => 1024
[E_ALL] => 2047
[TRUE] => 1
)

See also get_loaded_extensions(), get_defined_functions(), and 
get_defined_vars().   get_current_userUpget_extension_funcs
#

#T=array get_defined_constants ( void )
get_defined_constants ( ^!void );
#

#T=get_defined_functions - array get_defined_functions ( void )
(PHP 4 >= 4.0.4)
get_defined_functions --  Returns an array of all defined functions 
Description
array get_defined_functions ( void )
This function returns an multidimensional array containing a list of all 
defined functions, both built-in (internal) and user-defined. The internal 
functions will be accessible via $arr["internal"], and the user defined 
ones using $arr["user"] (see example below). 
<?php
function myrow($id, $data) {
return "<tr><th>$id</th><td>$data</td></tr>\n";
}

$arr = get_defined_functions();

print_r($arr);
?> 

Will output something along the lines of: 
Array
(
[internal] => Array
(
[0] => zend_version
[1] => func_num_args
[2] => func_get_arg
[3] => func_get_args
[4] => strlen
[5] => strcmp
[6] => strncmp
...
[750] => bcscale
[751] => bccomp
)

[user] => Array
(
[0] => myrow
)

)

See also get_defined_vars() and get_defined_constants().   function_existsUpregister_shutdown_function
#

#T=array get_defined_functions ( void )
get_defined_functions ( ^!void );
#

#T=get_defined_vars - array get_defined_vars ( void )
(PHP 4 >= 4.0.4)
get_defined_vars --  Returns an array of all defined variables 
Description
array get_defined_vars ( void )
This function returns an multidimensional array containing a list of all 
defined variables, be them environment, server or user-defined variables. 
<?php
$b = array(1, 1, 2, 3, 5, 8);

$arr = get_defined_vars();

// print $b
print_r($arr["b"]);

/* print path to the PHP interpreter (if used as a CGI)
* e.g. /usr/local/bin/php */
echo $arr["_"];

// print the command-line paramaters if any
print_r($arr["argv"]);

// print all the server vars
print_r($arr["_SERVER"]);

// print all the available keys for the arrays of variables
print_r(array_keys(get_defined_vars()));
?> 

See also get_defined_functions() and get_defined_constants().   floatvalUpget_resource_type
#

#T=array get_defined_vars ( void )
get_defined_vars ( ^!void );
#

#T=get_extension_funcs - array get_extension_funcs ( string module_name)
(PHP 4 )
get_extension_funcs --  Returns an array with the names of the functions 
of a module 
Description
array get_extension_funcs ( string module_name)
This function returns the names of all the functions defined in the module 
indicated by module_name. 
For example the lines below 
<?php
print_r(get_extension_funcs("xml"));
print_r(get_extension_funcs("gd"));
?> 

will print a list of the functions in the modules xml and gd respectively. 

See also: get_loaded_extensions()   get_defined_constantsUpget_include_path
#

#T=array get_extension_funcs ( string module_name)
get_extension_funcs ( ^!string module_name);
#

#T=get_html_translation_table - array get_html_translation_table ( int table [, int quote_style])
(PHP 4 )
get_html_translation_table --  Returns the translation table used by 
htmlspecialchars() and htmlentities() 
Description
array get_html_translation_table ( int table [, int quote_style])
get_html_translation_table() will return the translation table that is 
used internally for htmlspecialchars() and htmlentities(). 
There are two new constants (HTML_ENTITIES, HTML_SPECIALCHARS) that allow 
you to specify the table you want. And as in the htmlspecialchars() and 
htmlentities() functions you can optionally specify the quote_style you 
are working with. The default is ENT_COMPAT mode. See the description of 
these modes in htmlspecialchars(). 
Example 1. Translation Table Example
  <?php
  $trans = get_html_translation_table(HTML_ENTITIES);
  $str = "Hallo & <Frau> & Krmer";
  $encoded = strtr($str, $trans);
  ?> 

The $encoded variable will now contain: "Hallo &amp; &lt;Frau&gt; &amp; 
Kr&auml;mer". 
Another interesting use of this function is to, with help of array_flip(), 
change the direction of the translation. 
<?php
$trans = array_flip($trans);
$original = strtr($encoded, $trans);
?> 

The content of $original would be: "Hallo & <Frau> & Krmer". 
See also htmlspecialchars(), htmlentities(), strtr(), and array_flip().   fprintfUphebrev
#

#T=array get_html_translation_table ( int table [, int quote_style])
get_html_translation_table ( ^!int table [, int quote_style]);
#

#T=get_include_path - string get_include_path ( void )
(PHP 4 >= 4.3.0)
get_include_path --  Gets the current include_path configuration option 
Description
string get_include_path ( void )
Gets the current include_path configuration option value. 
Example 1. get_include_path() example
  <?php
  // Works as of PHP 4.3.0
  echo get_include_path();

  // Works in all PHP versions
  echo ini_get('include_path');
  ?> 
See also ini_get(), restore_include_path(), set_include_path(), and 
include().   get_extension_funcsUpget_included_files
#

#T=string get_include_path ( void )
get_include_path ( ^!void );
#

#T=get_included_files - array get_included_files ( void )
(PHP 4 )
get_included_files --  Returns an array with the names of included or 
required files 
Description
array get_included_files ( void )
Returns an array of the names of all files that have been included using 
include(), include_once(), require() or require_once(). 
Files that are included or required multiple times only show up once in 
the returned array. 
Note: Files included using the auto_prepend_file configuration directive 
are not included in the returned array. 
Example 1. get_included_files() example
  <?php

  include("test1.php");
  include_once("test2.php");
  require("test3.php");
  require_once("test4.php");

  $included_files = get_included_files();

  foreach ($included_files as $filename) {
      echo "$filename\n";
  }

  ?> 

will generate the following output: 
test1.php
test2.php
test3.php
test4.php
Note: In PHP 4.0.1pl2 and previous versions get_included_files() assumed 
that the required files ended in the extension .php; other extensions 
would not be returned. The array returned by get_included_files() was an 
associative array and only listed files included by include() and 
include_once(). 
See also include(), include_once(), require(), require_once(), and 
get_required_files().   get_include_pathUpget_loaded_extensions
#

#T=array get_included_files ( void )
get_included_files ( ^!void );
#

#T=get_loaded_extensions - array get_loaded_extensions ( void )
(PHP 4 )
get_loaded_extensions --  Returns an array with the names of all modules 
compiled and loaded 
Description
array get_loaded_extensions ( void )
This function returns the names of all the modules compiled and loaded in 
the PHP interpreter. 
For example the line below 
<?php
print_r(get_loaded_extensions());
?> 

will print a list like: 
Array
(
[0] => xml
[1] => wddx
[2] => standard
[3] => session
[4] => posix
[5] => pgsql
[6] => pcre
[7] => gd
[8] => ftp
[9] => db
[10] => calendar
[11] => bcmath
)

See also get_extension_funcs(), extension_loaded(), dl(), and phpinfo().   get_included_filesUpget_magic_quotes_gpc
#

#T=array get_loaded_extensions ( void )
get_loaded_extensions ( ^!void );
#

#T=get_magic_quotes_gpc - int get_magic_quotes_gpc ( void )
(PHP 3>= 3.0.6, PHP 4 )
get_magic_quotes_gpc --  Gets the current active configuration setting of 
magic quotes gpc 
Description
int get_magic_quotes_gpc ( void )
Returns the current active configuration setting of magic_quotes_gpc (0 
for off, 1 for on). 
Note: If the directive magic_quotes_sybase is ON it will completely 
override magic_quotes_gpc. So even when get_magic_quotes() returns TRUE 
neither double quotes, backslashes or NUL's will be escaped. Only single 
quotes will be escaped. In this case they'll look like: '' 
Keep in mind that magic_quotes_gpc can not be set at runtime. 
Example 1. get_magic_quotes_gpc() example
  <?php
  echo get_magic_quotes_gpc();         // 1
  echo $_POST['lastname'];             // O\'reilly
  echo addslashes($_POST['lastname']); // O\\\'reilly

  if (!get_magic_quotes_gpc()) {
      $lastname = addslashes($_POST['lastname']);
  } else {
      $lastname = $_POST['lastname'];
  }

  echo $lastname; // O\'reilly
  $sql = "INSERT INTO lastnames (lastname) VALUES 
('$lastname')";
  ?> 
See also addslashes(), stripslashes(), get_magic_quotes_runtime(), and 
ini_get().   get_loaded_extensionsUpget_magic_quotes_runtime
#

#T=int get_magic_quotes_gpc ( void )
get_magic_quotes_gpc ( ^!void );
#

#T=get_magic_quotes_runtime - int get_magic_quotes_runtime ( void )
(PHP 3>= 3.0.6, PHP 4 )
get_magic_quotes_runtime --  Gets the current active configuration setting 
of magic_quotes_runtime 
Description
int get_magic_quotes_runtime ( void )
Returns the current active configuration setting of magic_quotes_runtime 
(0 for off, 1 for on). 
See also get_magic_quotes_gpc() and set_magic_quotes_runtime().   get_magic_quotes_gpcUpget_required_files
#

#T=int get_magic_quotes_runtime ( void )
get_magic_quotes_runtime ( ^!void );
#

#T=get_meta_tags - array get_meta_tags ( string filename [, int use_include_path])
(PHP 3>= 3.0.4, PHP 4 )
get_meta_tags --  Extracts all meta tag content attributes from a file and 
returns an array 
Description
array get_meta_tags ( string filename [, int use_include_path])
Opens filename and parses it line by line for <meta> tags in the file. 
This can be a local file or an URL. The parsing stops at </head>. 
Setting use_include_path to 1 will result in PHP trying to open the file 
along the standard include path as per the include_path directive. This is 
used for local files, not URLs. 
Example 1. What get_meta_tags() parses
<meta name="author" content="name">
<meta name="keywords" content="php documentation">
<meta name="DESCRIPTION" content="a php manual">
<meta name="geo.position" content="49.33;-86.59">
</head> <!-- parsing stops here -->

(pay attention to line endings - PHP uses a native function to parse the 
input, so a Mac file won't work on Unix). 
The value of the name property becomes the key, the value of the content 
property becomes the value of the returned array, so you can easily use 
standard array functions to traverse it or access single values. Special 
characters in the value of the name property are substituted with '_', the 
rest is converted to lower case. If two meta tags have the same name, only 
the last one is returned. 
Example 2. What get_meta_tags() returns
  <?php
  // Assuming the above tags are at www.example.com
  $tags = get_meta_tags('http://www.example.com/');

  // Notice how the keys are all lowercase now, and
  // how . was replaced by _ in the key.
  echo $tags['author'];       // name
  echo $tags['keywords'];     // php documentation
  echo $tags['description'];  // a php manual
  echo $tags['geo_position']; // 49.33;-86.59
  ?> 
Note: As of PHP 4.0.5, get_meta_tags() supports unquoted HTML 
attributes. 
See also htmlentities() and urlencode().   base64_encodeUphttp_build_query
#

#T=array get_meta_tags ( string filename [, int use_include_path])
get_meta_tags ( ^!string filename [, int use_include_path]);
#

#T=get_object_vars - array get_object_vars ( object obj)
(PHP 4 )
get_object_vars -- Returns an associative array of object properties
Description
array get_object_vars ( object obj)
This function returns an associative array of defined object properties 
for the specified object obj. 
Note: In versions prior to PHP 4.2.0, if the variables declared in the 
class of which the obj is an instance, have not been assigned a value, 
those will not be returned in the array. In versions after PHP 4.2.0, 
the key will be assigned with a NULL value. 
Example 1. Use of get_object_vars()
  <?php
  class Point2D {
      var $x, $y;
      var $label;

      function Point2D($x, $y) {
	  $this->x = $x;
	  $this->y = $y;
      }

      function setLabel($label) {
	  $this->label = $label;
      }

      function getPoint() {
	  return array("x" => $this->x,
		       "y" => $this->y,
		       "label" => $this->label);
      }
  }

  // "$label" is declared but not defined
  $p1 = new Point2D(1.233, 3.445);
  print_r(get_object_vars($p1));

  $p1->setLabel("point #1");
  print_r(get_object_vars($p1));

  ?> 

The printout of the above program will be: 
Array
(
[x] => 1.233
[y] => 3.445
[label] =>
)

Array
(
[x] => 1.233
[y] => 3.445
[label] => point #1
)
See also get_class_methods() and get_class_vars()!   get_declared_classesUpget_parent_class
#

#T=array get_object_vars ( object obj)
get_object_vars ( ^!object obj);
#

#T=get_parent_class - string get_parent_class ( mixed obj)
(PHP 4 )
get_parent_class -- Retrieves the parent class name for object or class
Description
string get_parent_class ( mixed obj)
If obj is an object, returns the name of the parent class of the class of 
which obj is an instance. 
If obj is a string, returns the name of the parent class of the class with 
that name. This functionality was added in PHP 4.0.5. 
Example 1. Using get_parent_class()
  <?php

  class dad {
      function dad() {
      // implements some logic
      }
  }

  class child extends dad {
      function child() {
	  echo "I'm " , get_parent_class($this) , "'s son\n";
      }
  }

  class child2 extends dad {
      function child2() {
	  echo "I'm " , get_parent_class('child2') , "'s son 
  too\n";
      }
  }

  $foo = new child();
  $bar = new child2();

  ?> 

The output is: 
I'm dad's son
I'm dad's son too
See also get_class() and is_subclass_of().   get_object_varsUpis_a
get_required_files
get_required_files -- Alias of get_included_files()
Description
This function is an alias of get_included_files().   get_magic_quotes_runtimeUpgetenv
#

#T=string get_parent_class ( mixed obj)
get_parent_class ( ^!mixed obj);
#

#T=get_resource_type - string get_resource_type ( resource handle)
(PHP 4 >= 4.0.2)
get_resource_type --  Returns the resource type 
Description
string get_resource_type ( resource handle)
This function returns a string representing the type of the resource 
passed to it. If the paramater is not a valid resource, it generates an 
error. 
<?php
// prints: mysql link
$c = mysql_connect();
echo get_resource_type($c) . "\n";

// prints: file
$fp = fopen("foo", "w");
echo get_resource_type($fp) . "\n";

// prints: domxml document
$doc = new_xmldoc("1.0");
echo get_resource_type($doc->doc) . "\n";
?> 
  get_defined_varsUpgettype
#

#T=string get_resource_type ( resource handle)
get_resource_type ( ^!resource handle);
#

#T=getallheaders - array getallheaders ( void )
(PHP 3, PHP 4 )
getallheaders -- Fetch all HTTP request headers
Description
array getallheaders ( void )
getallheaders() is an alias for apache_request_headers(). It will return 
an associative array of all the HTTP headers in the current request. 
Please read the apache_request_headers() documentation for more 
information on how this function works. 
Note: In PHP 4.3.0, getallheaders() became an alias for 
apache_request_headers(). Essentially, it was renamed. This is because 
this function only works when PHP is compiled as an Apache Module. 
Note: From PHP 4.3.3 on you can use this function with the NSAPI server 
module in Netscape/iPlanet/SunONE webservers, too. 
See also apache_request_headers().   ebcdic2asciiUpvirtual
#

#T=array getallheaders ( void )
getallheaders ( ^!void );
#

#T=getcwd - string getcwd ( void )
(PHP 4 )
getcwd -- gets the current working directory
Description
string getcwd ( void )
Returns the current working directory. 
Example 1. getcwd() example
  <?php

  // current directory
  echo getcwd() . "\n";

  chdir('cvs');

  // current directory
  echo getcwd() . "\n";

  ?> 

This example will output: 
/home/didou
/home/didou/cvs
See also chdir().   closedirUpopendir
#

#T=string getcwd ( void )
getcwd ( ^!void );
#

#T=getdate - array getdate ( [int timestamp])
(PHP 3, PHP 4 )
getdate -- Get date/time information
Description
array getdate ( [int timestamp])
Returns an associative array containing the date information of the 
timestamp, or the current local time if no timestamp is given, as the 
following associative array elements: 
Table 1. Key elements of the returned associative array
KeyDescriptionExample returned values
"seconds"Numeric representation of seconds0 to 59
"minutes"Numeric representation of minutes0 to 59
"hours"Numeric representation of hours0 to 23
"mday"Numeric representation of the day of the month1 to 31
"wday"Numeric representation of the day of the week0 (for Sunday) 
through 6 (for Saturday)
"mon"Numeric representation of a month1 through 12
"year"A full numeric representation of a year, 4 digitsExamples: 
1999 or 2003
"yday"Numeric representation of the day of the year0 through 366
"weekday"A full textual representation of the day of the weekSunday 
through Saturday
"month"A full textual representation of a month, such as January or 
MarchJanuary through December
0Seconds since the Unix Epoch, similar to the values returned by 
time() and used by date().System Dependent, typically -2147483648 
through 2147483647.

Example 1. getdate() example 
  <?php
  $today = getdate(); 
  print_r($today);
  ?> 

The output will look similar to: 
Array
(
[seconds] => 40
[minutes] => 58
[hours]   => 21
[mday]    => 17
[wday]    => 2
[mon]     => 6
[year]    => 2003
[yday]    => 167
[weekday] => Tuesday
[month]   => June
[0]       => 1055901520
)
See also date(), time(), and setlocale().   dateUpgettimeofday
#

#T=array getdate ( [int timestamp])
getdate ( ^![int timestamp]);
#

#T=getenv - string getenv ( string varname)
(PHP 3, PHP 4 )
getenv -- Gets the value of an environment variable
Description
string getenv ( string varname)
Returns the value of the environment variable varname, or FALSE on an 
error. 
<?php
$ip = getenv("REMOTE_ADDR"); // get the ip number of the user
?> 

You can see a list of all the environmental variables by using phpinfo(). 
You can find out what many of them mean by taking a look at the CGI 
specification, specifically the page on environmental variables. 
Note: This function does not work in ISAPI mode. 
See also putenv().   get_required_filesUpgetlastmod
#

#T=string getenv ( string varname)
getenv ( ^!string varname);
#

#T=gethostbyaddr - string gethostbyaddr ( string ip_address)
(PHP 3, PHP 4 )
gethostbyaddr --  Get the Internet host name corresponding to a given IP 
address 
Description
string gethostbyaddr ( string ip_address)
Returns the host name of the Internet host specified by ip_address or a 
string containing the unmodified ip_address on failure. 
Example 1. A simple gethostbyaddr() example
  <?php
  $hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
    
  echo $hostname;
  ?> 
See also gethostbyname().   fsockopenUpgethostbyname
#

#T=string gethostbyaddr ( string ip_address)
gethostbyaddr ( ^!string ip_address);
#

#T=gethostbyname - string gethostbyname ( string hostname)
(PHP 3, PHP 4 )
gethostbyname --  Get the IP address corresponding to a given Internet 
host name 
Description
string gethostbyname ( string hostname)
Returns the IP address of the Internet host specified by hostname or a 
string containing the unmodified hostname on failure. 
Example 1. A simple gethostbyname() example
  <?php
  $ip = gethostbyname('www.example.com');

  echo $ip;
  ?> 
See also gethostbyaddr().   gethostbyaddrUpgethostbynamel
#

#T=string gethostbyname ( string hostname)
gethostbyname ( ^!string hostname);
#

#T=gethostbynamel - array gethostbynamel ( string hostname)
(PHP 3, PHP 4 )
gethostbynamel --  Get a list of IP addresses corresponding to a given 
Internet host name 
Description
array gethostbynamel ( string hostname)
Returns a list of IP addresses to which the Internet host specified by 
hostname resolves. 
Example 1. gethostbynamel() example
  <?php
    $hosts = gethostbynamel('www.example.com');
    print_r($hosts);
  ?> 

The printout of the above program will be: Array
(
[0] => 192.0.34.166
)
See also gethostbyname(), gethostbyaddr(), checkdnsrr(), getmxrr(), and 
the named(8) manual page.   gethostbynameUpgetmxrr
#

#T=array gethostbynamel ( string hostname)
gethostbynamel ( ^!string hostname);
#

#T=getimagesize - array getimagesize ( string filename [, array imageinfo])
(PHP 3, PHP 4 )
getimagesize -- Get the size of an image
Description
array getimagesize ( string filename [, array imageinfo])
The getimagesize() function will determine the size of any GIF, JPG, PNG, 
SWF, SWC, PSD, TIFF, BMP, IFF, JP2, JPX, JB2, JPC, XBM, or WBMP image file 
and return the dimensions along with the file type and a height/width text 
string to be used inside a normal HTML IMG tag. 
Note: Support for JPC, JP2, JPX, JB2, XBM, and WBMP became available in 
PHP 4.3.2. Support for SWC as of PHP 4.3.0. 
Returns an array with 4 elements. Index 0 contains the width of the image 
in pixels. Index 1 contains the height. Index 2 is a flag indicating the 
type of the image: 1 = GIF, 2 = JPG, 3 = PNG, 4 = SWF, 5 = PSD, 6 = BMP, 7 
= TIFF(intel byte order), 8 = TIFF(motorola byte order), 9 = JPC, 10 = 
JP2, 11 = JPX, 12 = JB2, 13 = SWC, 14 = IFF, 15 = WBMP, 16 = XBM. These 
values correspond to the IMAGETYPE constants that were added in PHP 4.3. 
Index 3 is a text string with the correct height="yyy" width="xxx" string 
that can be used directly in an IMG tag. Example 1. getimagesize 
(file)
  <?php
  list($width, $height, $type, $attr) = 
  getimagesize("img/flag.jpg");
  echo "<img src=\"img/flag.jpg\" $attr alt=\"getimagesize() 
  example\" />";
  ?> 
Example 2. getimagesize (URL)
  <?php 
  $size = getimagesize("http://www.example.com/gifs/logo.gif");

  // if the file name has space in it, encode it properly
  $size = 
  getimagesize("http://www.example.com/gifs/lo%20go.gif");

  ?> 
With JPG images, two extra indexes are returned: channels and bits. 
channels will be 3 for RGB pictures and 4 for CMYK pictures. bits is the 
number of bits for each color. 
Beginning with PHP 4.3, bits and channels are present for other image 
types, too. However, the presence of these values can be a bit confusing. 
As an example, GIF always uses 3 channels per pixel, but the number of 
bits per pixel cannot be calculated for an animated GIF with a global 
color table. 
Some formats may contain no image or may contain multiple images. In these 
cases, getimagesize() might not be able to properly determine the image 
size. getimagesize() will return zero for width and height in these cases. 

Beginning with PHP 4.3, getimagesize() also returns an additional 
parameter, mime, that corresponds with the MIME type of the image. This 
information can be used to deliver images with correct HTTP Content-type 
headers: Example 3. getimagesize() and MIME types
  <?php
  $size = getimagesize($filename);
  $fp=fopen($filename, "rb");
  if ($size && $fp) {
    header("Content-type: {$size['mime']}");
    fpassthru($fp);
    exit;
  } else {
    // error
  }
  ?> 
If accessing the filename image is impossible, or if it isn't a valid 
picture, getimagesize() will return FALSE and generate a warning. 
The optional imageinfo parameter allows you to extract some extended 
information from the image file. Currently, this will return the different 
JPG APP markers as an associative array. Some programs use these APP 
markers to embed text information in images. A very common one is to embed 
IPTC http://www.iptc.org/ information in the APP13 marker. You can use the 
iptcparse() function to parse the binary APP13 marker into something 
readable. Example 4. getimagesize() returning IPTC
  <?php
  $size = getimagesize("testimg.jpg", $info);
  if (isset($info["APP13"])) {
      $iptc = iptcparse($info["APP13"]);
      var_dump($iptc);
  }
  ?> 
Note: JPEG 2000 support was added in PHP 4.3.2. Note that JPC and JP2 
are capable of having components with different bit depths. In this 
case, the value for "bits" is the highest bit depth encountered. Also, 
JP2 files may contain multiple JPEG 2000 codestreams. In this case, 
getimagesize() returns the values for the first codestream it encounters 
in the root of the file. 
Note: TIFF support was added in PHP 4.2. 
This function does not require the GD image library. 
See also image_type_to_mime_type(), exif_imagetype(), exif_read_data() 
and exif_thumbnail(). 
URL support was added in PHP 4.0.5.   gd_infoUpimage_type_to_mime_type
#

#T=array getimagesize ( string filename [, array imageinfo])
getimagesize ( ^!string filename [, array imageinfo]);
#

#T=getlastmod - int getlastmod ( void )
(PHP 3, PHP 4 )
getlastmod -- Gets time of last page modification
Description
int getlastmod ( void )
Returns the time of the last modification of the current page. The value 
returned is a Unix timestamp, suitable for feeding to date(). Returns 
FALSE on error. 
Example 1. getlastmod() example
  <?php
  // outputs e.g. 'Last modified: March 04 1998 20:43:59.'
  echo "Last modified: " . date ("F d Y H:i:s.", getlastmod());
  ?> 
Note: If you're interested in getting the last modification time of a 
different file, consider using filemtime(). 
See also date(), getmyuid(), getmygid(), get_current_user(), getmyinode(), 
getmypid(), and filemtime().   getenvUpgetmygid
#

#T=int getlastmod ( void )
getlastmod ( ^!void );
#

#T=getmxrr - int getmxrr ( string hostname, array mxhosts [, array weight])
(PHP 3, PHP 4 )
getmxrr --  Get MX records corresponding to a given Internet host name 
Description
int getmxrr ( string hostname, array mxhosts [, array weight])
Searches DNS for MX records corresponding to hostname. Returns TRUE if any 
records are found; returns FALSE if no records were found or if an error 
occurred. 
A list of the MX records found is placed into the array mxhosts. If the 
weight array is given, it will be filled with the weight information 
gathered. 
Note: This function should not be used for the purposes of address 
verification. Only the mailexchangers found in DNS are returned, 
however, according to RFC 2821 when no mail exchangers are listed, 
hostname itself should be used as the only mail exchanger with a 
priority of 0. 
Note: This function is not implemented on Windows platforms. Try the 
PEAR class Net_DNS. 
See also checkdnsrr(), gethostbyname(), gethostbynamel(), gethostbyaddr(), 
and the named(8) manual page.   gethostbynamelUpgetprotobyname
#

#T=int getmxrr ( string hostname, array mxhosts [, array weight])
getmxrr ( ^!string hostname, array mxhosts [, array weight]);
#

#T=getmygid - int getmygid ( void )
(PHP 4 >= 4.1.0)
getmygid -- Get PHP script owner's GID
Description
int getmygid ( void )
Returns the group ID of the current script, or FALSE on error. 
See also getmyuid(), getmypid(), get_current_user(), getmyinode(), and 
getlastmod().   getlastmodUpgetmyinode
#

#T=int getmygid ( void )
getmygid ( ^!void );
#

#T=getmyinode - int getmyinode ( void )
(PHP 3, PHP 4 )
getmyinode -- Gets the inode of the current script
Description
int getmyinode ( void )
Returns the current script's inode, or FALSE on error. 
See also getmygid(), getmyuid(), get_current_user(), getmypid(), and 
getlastmod(). 
Note: This function is not implemented on Windows platforms.  getmygidUpgetmypid
#

#T=int getmyinode ( void )
getmyinode ( ^!void );
#

#T=getmypid - int getmypid ( void )
(PHP 3, PHP 4 )
getmypid -- Gets PHP's process ID
Description
int getmypid ( void )
Returns the current PHP process ID, or FALSE on error. 
Warning
Process IDs are not unique, thus they are a weak entropy source. We 
recommend against relying on pids in security-dependent contexts. 

See also getmygid(), getmyuid(), get_current_user(), getmyinode(), and 
getlastmod().   getmyinodeUpgetmyuid
#

#T=int getmypid ( void )
getmypid ( ^!void );
#

#T=getmyuid - int getmyuid ( void )
(PHP 3, PHP 4 )
getmyuid -- Gets PHP script owner's UID
Description
int getmyuid ( void )
Returns the user ID of the current script, or FALSE on error. 
See also getmygid(), getmypid(), get_current_user(), getmyinode(), and 
getlastmod().   getmypidUpgetopt
#

#T=int getmyuid ( void )
getmyuid ( ^!void );
#

#T=getopt - array getopt ( string options)
(PHP 4 >= 4.3.0)
getopt -- Gets options from the command line argument list
Description
array getopt ( string options)
Returns an associative array of option / argument pairs based on the 
options format specified in options, or FALSE on an error. 
<?php
// parse the command line ($GLOBALS['argv'])
$options = getopt("f:hp:");
?> 

The options parameter may contain the following elements: individual 
characters, and characters followed by a colon to indicate an option 
argument is to follow. For example, an option string x recognizes an 
option -x, and an option string x: recognizes an option and argument -x 
argument. It does not matter if an argument has leading white space. 
This function will return an array of option / argument pairs. If an 
option does not have an argument, the value will be set to FALSE. 
Note: This function is not implemented on Windows platforms.  getmyuidUpgetrusage
#

#T=array getopt ( string options)
getopt ( ^!string options);
#

#T=getprotobyname - int getprotobyname ( string name)
(PHP 4 )
getprotobyname --  Get protocol number associated with protocol name 
Description
int getprotobyname ( string name)
getprotobyname() returns the protocol number associated with the protocol 
name as per /etc/protocols. 
Example 1. getprotobyname() example
  <?php
  $protocol = 'tcp';
  $get_prot = getprotobyname($protocol);
  if ($get_prot == -1) {
      // if nothing found, returns -1
      echo 'Invalid Protocol';
  } else {
      echo 'Protocol #' . $get_prot;
  }
  ?> 
See also: getprotobynumber().   getmxrrUpgetprotobynumber
#

#T=int getprotobyname ( string name)
getprotobyname ( ^!string name);
#

#T=getprotobynumber - string getprotobynumber ( int number)
(PHP 4 )
getprotobynumber --  Get protocol name associated with protocol number 
Description
string getprotobynumber ( int number)
getprotobynumber() returns the protocol name associated with protocol 
number as per /etc/protocols. 
See also: getprotobyname().   getprotobynameUpgetservbyname
#

#T=string getprotobynumber ( int number)
getprotobynumber ( ^!int number);
#

#T=getrandmax - int getrandmax ( void )
(PHP 3, PHP 4 )
getrandmax -- Show largest possible random value
Description
int getrandmax ( void )
Returns the maximum value that can be returned by a call to rand(). 
See also rand(), srand() and mt_getrandmax().   fmodUphexdec
#

#T=int getrandmax ( void )
getrandmax ( ^!void );
#

#T=getrusage - array getrusage ( [int who])
(PHP 3>= 3.0.7, PHP 4 )
getrusage -- Gets the current resource usages
Description
array getrusage ( [int who])
This is an interface to getrusage(2). It returns an associative array 
containing the data returned from the system call. If who is 1, getrusage 
will be called with RUSAGE_CHILDREN. 
All entries are accessible by using their documented field names. 
Example 1. getrusage() example
  <?php
  $dat = getrusage();
  echo $dat["ru_nswap"];         // number of swaps
  echo $dat["ru_majflt"];        // number of page faults
  echo $dat["ru_utime.tv_sec"];  // user time used (seconds)
  echo $dat["ru_utime.tv_usec"]; // user time used 
(microseconds)
  ?> 

See your system's man page on getrusage(2) for more details. 
Note: This function is not implemented on Windows platforms.  getoptUpini_alter
#

#T=array getrusage ( [int who])
getrusage ( ^![int who]);
#

#T=getservbyname - int getservbyname ( string service, string protocol)
(PHP 4 )
getservbyname --  Get port number associated with an Internet service and 
protocol 
Description
int getservbyname ( string service, string protocol)
getservbyname() returns the Internet port which corresponds to service for 
the specified protocol as per /etc/services. protocol is either "tcp" or 
"udp" (in lowercase). 
Example 1. getservbyname() example
  <?php
  $services = array('http', 'ftp', 'ssh', 'telnet', 'imap', 
  'smtp', 'nicname', 'gopher', 'finger', 'pop3', 'www');

  foreach ($services as $service) {                    
      $port = getservbyname($service, 'tcp');
      echo $service . ": " . $port . "<br />\n";
  }
  ?> 
For complete list of port numbers see: 
http://www.iana.org/assignments/port-numbers. 
See also: getservbyport().   getprotobynumberUpgetservbyport
#

#T=int getservbyname ( string service, string protocol)
getservbyname ( ^!string service, string protocol);
#

#T=getservbyport - string getservbyport ( int port, string protocol)
(PHP 4 )
getservbyport --  Get Internet service which corresponds to port and 
protocol 
Description
string getservbyport ( int port, string protocol)
getservbyport() returns the Internet service associated with port for the 
specified protocol as per /etc/services. protocol is either "tcp" or "udp" 
(in lowercase). 
See also: getservbyname().   getservbynameUpip2long
#

#T=string getservbyport ( int port, string protocol)
getservbyport ( ^!int port, string protocol);
#

#T=gettext - string gettext ( string message)
(PHP 3>= 3.0.7, PHP 4 )
gettext -- Lookup a message in the current domain
Description
string gettext ( string message)
This function returns a translated string if one is found in the 
translation table, or the submitted message if not found. You may use the 
underscore character '_' as an alias to this function. 
Example 1. gettext()-check
  <?php
  // Set language to German
  setlocale(LC_ALL, 'de');

  // Specify location of translation tables
  bindtextdomain("myPHPApp", "./locale");

  // Choose domain
  textdomain("myPHPApp");

  // Print a test message
  echo gettext("Welcome to My PHP Application");

  // Or use the alias _() for gettext()
  echo _("Have a nice day");
  ?> 

  dngettextUpngettext
#

#T=string gettext ( string message)
gettext ( ^!string message);
#

#T=gettimeofday - array gettimeofday ( void )
(PHP 3>= 3.0.7, PHP 4 )
gettimeofday -- Get current time
Description
array gettimeofday ( void )
This is an interface to gettimeofday(2). It returns an associative array 
containing the data returned from the system call. 
"sec" - seconds 
"usec" - microseconds 
"minuteswest" - minutes west of Greenwich 
"dsttime" - type of dst correction   getdateUpgmdate
#

#T=array gettimeofday ( void )
gettimeofday ( ^!void );
#

#T=gettype - string gettype ( mixed var)
(PHP 3, PHP 4 )
gettype -- Get the type of a variable
Description
string gettype ( mixed var)
Returns the type of the PHP variable var. 
Warning
Never use gettype() to test for a certain type, since the returned 
string may be subject to change in a future version. In addition, it 
is slow too, as it involves string comparison. 
Instead, use the is_* functions. 

Possibles values for the returned string are: 
"boolean" (since PHP 4)
"integer"
"double" (for historical reasons "double" is returned in case of a 
float, and not simply "float")
"string"
"array"
"object"
"resource" (since PHP 4)
#

#T=string gettype ( mixed var)
gettype ( ^!mixed var);
#
"NULL" (since PH
#T=P 4) - array glob ( string pattern [, int flags])
"user function" (PHP 3 only, deprecated)
"unknown type"
For PHP 4, you should use function_exists() and method_exists() to replace 
the prior usage of gettype() on a function. 
See also settype(), is_array(), is_bool(), is_float(), is_integer(), 
is_null(), is_numeric(), is_object(), is_resource(), is_scalar(), and 
is_string().   get_resource_typeUpimport_request_variables
#

#T=glob - array glob ( string pattern [, int flags])
(PHP 4 >= 4.3.0)
glob -- Find pathnames matching a pattern
Description
array glob ( string pattern [, int flags])
The glob() function searches for all the pathnames matching pattern 
according to the rules used by the shell. No tilde expansion or parameter 
substitution is done. 
Returns an array containing the matched files/directories or FALSE on 
error. 
Valid flags: 
GLOB_MARK - Adds a slash to each item returned 
GLOB_NOSORT - Return files as they appear in the directory (no sorting) 
GLOB_NOCHECK - Return the search pattern if no files matching it were 
found 
GLOB_NOESCAPE - Backslashes do not quote metacharacters 
GLOB_BRACE - Expands {a,b,c} to match 'a', 'b', or 'c' 
GLOB_ONLYDIR - Return only directory entries which match the pattern 
Note: Before PHP 4.3.3 GLOB_ONLYDIR was not available on Windows and 
other systems not using the GNU C library. 
Example 1. Convenient way how glob() can replace opendir() and 
friends. 
  <?php
  foreach (glob("*.txt") as $filename) {
      echo "$filename size " . filesize($filename) . "\n";
  } 

Output will look something like: 
funclist.txt size 44686
funcsummary.txt size 267625
quickref.txt size 137820
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.
See also opendir(), readdir(), closedir(), and fnmatch().   fwriteUpis_dir
#

#T=array glob ( string pattern [, int flags])
glob ( ^!string pattern [, int flags]);
#

#T=gmdate - string gmdate ( string format [, int timestamp])
(PHP 3, PHP 4 )
gmdate -- Format a GMT/UTC date/time
Description
string gmdate ( string format [, int timestamp])
Identical to the date() function except that the time returned is 
Greenwich Mean Time (GMT). For example, when run in Finland (GMT +0200), 
the first line below prints "Jan 01 1998 00:00:00", while the second 
prints "Dec 31 1997 22:00:00". Example 1. gmdate() example
  <?php
  echo date("M d Y H:i:s", mktime(0, 0, 0, 1, 1, 1998));
  echo gmdate("M d Y H:i:s", mktime(0, 0, 0, 1, 1, 1998));
  ?> 
Note: In the Microsoft Windows series of Operating Systems the system 
libraries implementing this function are broken, so gmdate() does not 
support negative values for the timestamp. For details see bug reports: 
#22620, #22457, and #14391. 
This problem does not occur in Unix/Linux Operating Systems, as the 
system libraries behave as expected. 
PHP cannot fix broken system libraries. Contact your OS vendor for a fix 
to this and similar problems. 
See also date(), mktime(), gmmktime() and strftime().   gettimeofdayUpgmmktime
#

#T=string gmdate ( string format [, int timestamp])
gmdate ( ^!string format [, int timestamp]);
#

#T=gmmktime - int gmmktime ( [int hour [, int minute [, int second [, int month [, int 
(PHP 3, PHP 4 )
gmmktime -- Get Unix timestamp for a GMT date
Description
int gmmktime ( [int hour [, int minute [, int second [, int month [, int 
day [, int year [, int is_dst]]]]]]])
Identical to mktime() except the passed parameters represents a GMT date. 
Like mktime(), arguments may be left out in order from right to left, with 
any omitted arguments being set to the current corresponding GMT value.   gmdateUpgmstrftime
#

#T=int gmmktime ( [int hour [, int minute [, int second [, int month [, int 
gmmktime ( ^![int hour [, int minute [, int second [, int month [, int ;
#

#T=gmp_abs - resource gmp_abs ( resource a)
(PHP 4 >= 4.0.4)
gmp_abs -- Absolute value
Description
resource gmp_abs ( resource a)
Returns absolute value of a.   GMP functionsUpgmp_add
#

#T=resource gmp_abs ( resource a)
gmp_abs ( ^!resource a);
#

#T=gmp_add - resource gmp_add ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_add -- Add numbers
Description
resource gmp_add ( resource a, resource b)
Add two GMP numbers. The result will be a GMP number representing the sum 
of the arguments.   gmp_absUpgmp_and
#

#T=resource gmp_add ( resource a, resource b)
gmp_add ( ^!resource a, resource b);
#

#T=gmp_and - resource gmp_and ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_and -- Logical AND
Description
resource gmp_and ( resource a, resource b)
Calculates logical AND of two GMP numbers.   gmp_addUpgmp_clrbit
#

#T=resource gmp_and ( resource a, resource b)
gmp_and ( ^!resource a, resource b);
#

#T=gmp_clrbit - resource gmp_clrbit ( resource &a, int index)
(PHP 4 >= 4.0.4)
gmp_clrbit -- Clear bit
Description
resource gmp_clrbit ( resource &a, int index)
Clears (sets to 0) bit index in a.   gmp_andUpgmp_cmp
#

#T=resource gmp_clrbit ( resource &a, int index)
gmp_clrbit ( ^!resource &a, int index);
#

#T=gmp_cmp - int gmp_cmp ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_cmp -- Compare numbers
Description
int gmp_cmp ( resource a, resource b)
Returns a positive value if a > b, zero if a = b and negative value if a < 
b.   gmp_clrbitUpgmp_com
#

#T=int gmp_cmp ( resource a, resource b)
gmp_cmp ( ^!resource a, resource b);
#

#T=gmp_com - resource gmp_com ( resource a)
(PHP 4 >= 4.0.4)
gmp_com -- Calculates one's complement of a
Description
resource gmp_com ( resource a)
Warning
This function is currently not documented; only the argument list is 
available.
  gmp_cmpUpgmp_div_q
#

#T=resource gmp_com ( resource a)
gmp_com ( ^!resource a);
#

#T=gmp_div_q - resource gmp_div_q ( resource a, resource b [, int round])
(PHP 4 >= 4.0.4)
gmp_div_q -- Divide numbers
Description
resource gmp_div_q ( resource a, resource b [, int round])
Divides a by b and returns the integer result. The result rounding is 
defined by the round, which can have the following values: 
GMP_ROUND_ZERO: The result is truncated towards 0. 
GMP_ROUND_PLUSINF: The result is rounded towards +infinity. 
GMP_ROUND_MINUSINF: The result is rounded towards -infinity. 
This function can also be called as gmp_div(). 
See also gmp_div_r(), gmp_div_qr()   gmp_comUpgmp_div_qr
#

#T=resource gmp_div_q ( resource a, resource b [, int round])
gmp_div_q ( ^!resource a, resource b [, int round]);
#

#T=gmp_div_qr - array gmp_div_qr ( resource n, resource d [, int round])
(PHP 4 >= 4.0.4)
gmp_div_qr -- Divide numbers and get quotient and remainder
Description
array gmp_div_qr ( resource n, resource d [, int round])
The function divides n by d and returns array, with the first element 
being [n/d] (the integer result of the division) and the second being (n - 
[n/d] * d) (the remainder of the division). 
See the gmp_div_q() function for description of the round argument. 
Example 1. Division of GMP numbers
  <?php
      $a = gmp_init("0x41682179fbf5");
      $res = gmp_div_qr($a, "0xDEFE75");
      printf("Result is: q - %s, r - %s", 
	      gmp_strval($res[0]), gmp_strval($res[1]));
  ?> 
See also gmp_div_q(), gmp_div_r().   gmp_div_qUpgmp_div_r
#

#T=array gmp_div_qr ( resource n, resource d [, int round])
gmp_div_qr ( ^!resource n, resource d [, int round]);
#

#T=gmp_div_r - resource gmp_div_r ( resource n, resource d [, int round])
(PHP 4 >= 4.0.4)
gmp_div_r -- Remainder of the division of numbers
Description
resource gmp_div_r ( resource n, resource d [, int round])
Calculates remainder of the integer division of n by d. The remainder has 
the sign of the n argument, if not zero. 
See the gmp_div_q() function for description of the round argument. 
See also gmp_div_q(), gmp_div_qr()   gmp_div_qrUpgmp_div
gmp_div
gmp_div -- Alias of gmp_div_q()
Description
This function is an alias of gmp_div_q().   gmp_div_rUpgmp_divexact
#

#T=resource gmp_div_r ( resource n, resource d [, int round])
gmp_div_r ( ^!resource n, resource d [, int round]);
#

#T=gmp_divexact - resource gmp_divexact ( resource n, resource d)
(PHP 4 >= 4.0.4)
gmp_divexact -- Exact division of numbers
Description
resource gmp_divexact ( resource n, resource d)
Divides n by d, using fast "exact division" algorithm. This function 
produces correct results only when it is known in advance that d divides 
n.   gmp_divUpgmp_fact
#

#T=resource gmp_divexact ( resource n, resource d)
gmp_divexact ( ^!resource n, resource d);
#

#T=gmp_fact - resource gmp_fact ( int a)
(PHP 4 >= 4.0.4)
gmp_fact -- Factorial
Description
resource gmp_fact ( int a)
Calculates factorial (a!) of a.   gmp_divexactUpgmp_gcd
#

#T=resource gmp_fact ( int a)
gmp_fact ( ^!int a);
#

#T=gmp_gcd - resource gmp_gcd ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_gcd -- Calculate GCD
Description
resource gmp_gcd ( resource a, resource b)
Calculate greatest common divisor of a and b. The result is always 
positive even if either of, or both, input operands are negative.   gmp_factUpgmp_gcdext
#

#T=resource gmp_gcd ( resource a, resource b)
gmp_gcd ( ^!resource a, resource b);
#

#T=gmp_gcdext - array gmp_gcdext ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_gcdext -- Calculate GCD and multipliers
Description
array gmp_gcdext ( resource a, resource b)
Calculates g, s, and t, such that a*s + b*t = g = gcd(a,b), where gcd is 
the greatest common divisor. Returns an array with respective elements g, 
s and t. 
This function can be used to solve linear Diophantine equations in two 
variables. These are equations that allow only integer solutions and have 
the form: a*x + b*y = c. For more information, go to the "Diophantine 
Equation" page at MathWorld 
Example 1. Solving a linear Diophantine equation
  <?php
  // Solve the equation a*s + b*t = g
  // where a = 12, b = 21, g = gcd(12, 21) = 3
  $a = gmp_init(12);
  $b = gmp_init(21);
  $g = gmp_gcd($a, $b);
  $r = gmp_gcdext($a, $b);

  $check_gcd = (gmp_strval($g) == gmp_strval($r['g']));
  $eq_res = gmp_add(gmp_mul($a, $r['s']), gmp_mul($b, $r['t']));
  $check_res = (gmp_strval($g) == gmp_strval($eq_res));

  if ($check_gcd && $check_res) {
      $fmt = "Solution: %d*%d + %d*%d = %d\n";
      printf($fmt, gmp_strval($a), gmp_strval($r['s']), 
  gmp_strval($b),
      gmp_strval($r['t']), gmp_strval($r['g']));
  } else {
      echo "Error while solving the equation\n";
  }
      
  // output: Solution: 12*2 + 21*-1 = 3
  ?> 

  gmp_gcdUpgmp_hamdist
#

#T=array gmp_gcdext ( resource a, resource b)
gmp_gcdext ( ^!resource a, resource b);
#

#T=gmp_hamdist - int gmp_hamdist ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_hamdist -- Hamming distance
Description
int gmp_hamdist ( resource a, resource b)
Returns the hamming distance between a and b. Both operands should be 
non-negative.   gmp_gcdextUpgmp_init
#

#T=int gmp_hamdist ( resource a, resource b)
gmp_hamdist ( ^!resource a, resource b);
#

#T=gmp_init - resource gmp_init ( mixed number)
(PHP 4 >= 4.0.4)
gmp_init -- Create GMP number
Description
resource gmp_init ( mixed number)
Creates a GMP number from an integer or string. String representation can 
be decimal or hexadecimal. In the latter case, the string should start 
with 0x. 
Example 1. Creating GMP number
  <?php
      $a = gmp_init(123456);
      $b = gmp_init("0xFFFFDEBACDFEDF7200");
  ?> 
Note: It is not necessary to call this function if you want to use 
integer or string in place of GMP number in GMP functions, like 
gmp_add(). Function arguments are automatically converted to GMP 
numbers, if such conversion is possible and needed, using the same rules 
as gmp_init().   gmp_hamdistUpgmp_intval
#

#T=resource gmp_init ( mixed number)
gmp_init ( ^!mixed number);
#

#T=gmp_intval - int gmp_intval ( resource gmpnumber)
(PHP 4 >= 4.0.4)
gmp_intval -- Convert GMP number to integer
Description
int gmp_intval ( resource gmpnumber)
This function allows to convert GMP number to integer. 
Warning
This function returns a useful result only if the number actually 
fits the PHP integer (i.e., signed long type). If you want just to 
print the GMP number, use gmp_strval(). 
  gmp_initUpgmp_invert
#

#T=int gmp_intval ( resource gmpnumber)
gmp_intval ( ^!resource gmpnumber);
#

#T=gmp_invert - resource gmp_invert ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_invert -- Inverse by modulo
Description
resource gmp_invert ( resource a, resource b)
Computes the inverse of a modulo b. Returns FALSE if an inverse does not 
exist.   gmp_intvalUpgmp_jacobi
#

#T=resource gmp_invert ( resource a, resource b)
gmp_invert ( ^!resource a, resource b);
#

#T=gmp_jacobi - int gmp_jacobi ( resource a, resource p)
(PHP 4 >= 4.0.4)
gmp_jacobi -- Jacobi symbol
Description
int gmp_jacobi ( resource a, resource p)
Computes Jacobi symbol of a and p. p should be odd and must be positive.   gmp_invertUpgmp_legendre
#

#T=int gmp_jacobi ( resource a, resource p)
gmp_jacobi ( ^!resource a, resource p);
#

#T=gmp_legendre - int gmp_legendre ( resource a, resource p)
(PHP 4 >= 4.0.4)
gmp_legendre -- Legendre symbol
Description
int gmp_legendre ( resource a, resource p)
Compute the Legendre symbol of a and p. p should be odd and must be 
positive.   gmp_jacobiUpgmp_mod
#

#T=int gmp_legendre ( resource a, resource p)
gmp_legendre ( ^!resource a, resource p);
#

#T=gmp_mod - resource gmp_mod ( resource n, resource d)
(PHP 4 >= 4.0.4)
gmp_mod -- Modulo operation
Description
resource gmp_mod ( resource n, resource d)
Calculates n modulo d. The result is always non-negative, the sign of d is 
ignored.   gmp_legendreUpgmp_mul
#

#T=resource gmp_mod ( resource n, resource d)
gmp_mod ( ^!resource n, resource d);
#

#T=gmp_mul - resource gmp_mul ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_mul -- Multiply numbers
Description
resource gmp_mul ( resource a, resource b)
Multiplies a by b and returns the result.   gmp_modUpgmp_neg
#

#T=resource gmp_mul ( resource a, resource b)
gmp_mul ( ^!resource a, resource b);
#

#T=gmp_neg - resource gmp_neg ( resource a)
(PHP 4 >= 4.0.4)
gmp_neg -- Negate number
Description
resource gmp_neg ( resource a)
Returns -a.   gmp_mulUpgmp_or
#

#T=resource gmp_neg ( resource a)
gmp_neg ( ^!resource a);
#

#T=gmp_or - resource gmp_or ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_or -- Logical OR
Description
resource gmp_or ( resource a, resource b)
Calculates logical inclusive OR of two GMP numbers.   gmp_negUpgmp_perfect_square
#

#T=resource gmp_or ( resource a, resource b)
gmp_or ( ^!resource a, resource b);
#

#T=gmp_perfect_square - bool gmp_perfect_square ( resource a)
(PHP 4 >= 4.0.4)
gmp_perfect_square -- Perfect square check
Description
bool gmp_perfect_square ( resource a)
Returns TRUE if a is a perfect square, FALSE otherwise. 
See also: gmp_sqrt(), gmp_sqrtrm().   gmp_orUpgmp_popcount
#

#T=bool gmp_perfect_square ( resource a)
gmp_perfect_square ( ^!resource a);
#

#T=gmp_popcount - int gmp_popcount ( resource a)
(PHP 4 >= 4.0.4)
gmp_popcount -- Population count
Description
int gmp_popcount ( resource a)
Return the population count of a.   gmp_perfect_squareUpgmp_pow
#

#T=int gmp_popcount ( resource a)
gmp_popcount ( ^!resource a);
#

#T=gmp_pow - resource gmp_pow ( resource base, int exp)
(PHP 4 >= 4.0.4)
gmp_pow -- Raise number into power
Description
resource gmp_pow ( resource base, int exp)
Raise base into power exp. The case of 0^0 yields 1. exp cannot be 
negative.   gmp_popcountUpgmp_powm
#

#T=resource gmp_pow ( resource base, int exp)
gmp_pow ( ^!resource base, int exp);
#

#T=gmp_powm - resource gmp_powm ( resource base, resource exp, resource mod)
(PHP 4 >= 4.0.4)
gmp_powm -- Raise number into power with modulo
Description
resource gmp_powm ( resource base, resource exp, resource mod)
Calculate (base raised into power exp) modulo mod. If exp is negative, 
result is undefined.   gmp_powUpgmp_prob_prime
#

#T=resource gmp_powm ( resource base, resource exp, resource mod)
gmp_powm ( ^!resource base, resource exp, resource mod);
#

#T=gmp_prob_prime - int gmp_prob_prime ( resource a [, int reps])
(PHP 4 >= 4.0.4)
gmp_prob_prime -- Check if number is "probably prime"
Description
int gmp_prob_prime ( resource a [, int reps])
If this function returns 0, a is definitely not prime. If it returns 1, 
then a is "probably" prime. If it returns 2, then a is surely prime. 
Reasonable values of reps vary from 5 to 10 (default being 10); a higher 
value lowers the probability for a non-prime to pass as a "probable" 
prime. 
The function uses Miller-Rabin's probabilistic test.   gmp_powmUpgmp_random
#

#T=int gmp_prob_prime ( resource a [, int reps])
gmp_prob_prime ( ^!resource a [, int reps]);
#

#T=gmp_random - resource gmp_random ( int limiter)
(PHP 4 >= 4.0.4)
gmp_random -- Random number
Description
resource gmp_random ( int limiter)
Generate a random number. The number will be between limiter and zero in 
value. If limiter is negative, negative numbers are generated.   gmp_prob_primeUpgmp_scan0
#

#T=resource gmp_random ( int limiter)
gmp_random ( ^!int limiter);
#

#T=gmp_scan0 - int gmp_scan0 ( resource a, int start)
(PHP 4 >= 4.0.4)
gmp_scan0 -- Scan for 0
Description
int gmp_scan0 ( resource a, int start)
Scans a, starting with bit start, towards more significant bits, until the 
first clear bit is found. Returns the index of the found bit.   gmp_randomUpgmp_scan1
#

#T=int gmp_scan0 ( resource a, int start)
gmp_scan0 ( ^!resource a, int start);
#

#T=gmp_scan1 - int gmp_scan1 ( resource a, int start)
(PHP 4 >= 4.0.4)
gmp_scan1 -- Scan for 1
Description
int gmp_scan1 ( resource a, int start)
Scans a, starting with bit start, towards more significant bits, until the 
first set bit is found. Returns the index of the found bit.   gmp_scan0Upgmp_setbit
#

#T=int gmp_scan1 ( resource a, int start)
gmp_scan1 ( ^!resource a, int start);
#

#T=gmp_setbit - resource gmp_setbit ( resource &a, int index [, bool set_clear])
(PHP 4 >= 4.0.4)
gmp_setbit -- Set bit
Description
resource gmp_setbit ( resource &a, int index [, bool set_clear])
Sets bit index in a. set_clear defines if the bit is set to 0 or 1. By 
default the bit is set to 1.   gmp_scan1Upgmp_sign
#

#T=resource gmp_setbit ( resource &a, int index [, bool set_clear])
gmp_setbit ( ^!resource &a, int index [, bool set_clear]);
#

#T=gmp_sign - int gmp_sign ( resource a)
(PHP 4 >= 4.0.4)
gmp_sign -- Sign of number
Description
int gmp_sign ( resource a)
Return sign of a - 1 if a is positive and -1 if it's negative.   gmp_setbitUpgmp_sqrt
#

#T=int gmp_sign ( resource a)
gmp_sign ( ^!resource a);
#

#T=gmp_sqrt - resource gmp_sqrt ( resource a)
(PHP 4 >= 4.0.4)
gmp_sqrt -- Square root
Description
resource gmp_sqrt ( resource a)
Calculates square root of a.   gmp_signUpgmp_sqrtrm
gmp_sqrtrm
(no version information, might be only in CVS)
gmp_sqrtrm -- Square root with remainder
Description
array gmp_sqrtrm ( resource a)
Returns array where first element is the integer square root of a (see 
also gmp_sqrt()), and the second is the remainder (i.e., the difference 
between a and the first element squared).   gmp_sqrtUpgmp_strval
#

#T=resource gmp_sqrt ( resource a)
gmp_sqrt ( ^!resource a);
#

#T=gmp_strval - string gmp_strval ( resource gmpnumber [, int base])
(PHP 4 >= 4.0.4)
gmp_strval -- Convert GMP number to string
Description
string gmp_strval ( resource gmpnumber [, int base])
Convert GMP number to string representation in base base. The default base 
is 10. Allowed values for the base are from 2 to 36. 
Example 1. Converting a GMP number to a string
  <?php
      $a = gmp_init("0x41682179fbf5");
      printf("Decimal: %s, 36-based: %s", gmp_strval($a), 
  gmp_strval($a,36));
  ?> 

  gmp_sqrtrmUpgmp_sub
#

#T=string gmp_strval ( resource gmpnumber [, int base])
gmp_strval ( ^!resource gmpnumber [, int base]);
#

#T=gmp_sub - resource gmp_sub ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_sub -- Subtract numbers
Description
resource gmp_sub ( resource a, resource b)
Subtracts b from a and returns the result.   gmp_strvalUpgmp_xor
#

#T=resource gmp_sub ( resource a, resource b)
gmp_sub ( ^!resource a, resource b);
#

#T=gmp_xor - resource gmp_xor ( resource a, resource b)
(PHP 4 >= 4.0.4)
gmp_xor -- Logical XOR
Description
resource gmp_xor ( resource a, resource b)
Calculates logical exclusive OR (XOR) of two GMP numbers.   gmp_subUpHTTP functions
#

#T=resource gmp_xor ( resource a, resource b)
gmp_xor ( ^!resource a, resource b);
#

#T=gmstrftime - string gmstrftime ( string format [, int timestamp])
(PHP 3>= 3.0.12, PHP 4 )
gmstrftime --  Format a GMT/UTC time/date according to locale settings 
Description
string gmstrftime ( string format [, int timestamp])
Behaves the same as strftime() except that the time returned is Greenwich 
Mean Time (GMT). For example, when run in Eastern Standard Time (GMT 
-0500), the first line below prints "Dec 31 1998 20:00:00", while the 
second prints "Jan 01 1999 01:00:00". Example 1. gmstrftime() 
example
  <?php
  setlocale(LC_TIME, 'en_US');
  echo strftime("%b %d %Y %H:%M:%S", mktime(20, 0, 0, 12, 31, 
  98)) . "\n";
  echo gmstrftime("%b %d %Y %H:%M:%S", mktime(20, 0, 0, 12, 31, 
  98)) . "\n";
  ?> 
See also strftime().   gmmktimeUplocaltime
#

#T=string gmstrftime ( string format [, int timestamp])
gmstrftime ( ^!string format [, int timestamp]);
#

#T=GregorianToJD - int gregoriantojd ( int month, int day, int year)
(PHP 3, PHP 4 )
GregorianToJD --  Converts a Gregorian date to Julian Day Count 
Description
int gregoriantojd ( int month, int day, int year)
Valid Range for Gregorian Calendar 4714 B.C. to 9999 A.D.
Although this function can handle dates all the way back to 4714 B.C., 
such use may not be meaningful. The Gregorian calendar was not instituted 
until October 15, 1582 (or October 5, 1582 in the Julian calendar). Some 
countries did not accept it until much later. For example, Britain 
converted in 1752, The USSR in 1918 and Greece in 1923. Most European 
countries used the Julian calendar prior to the Gregorian. Example 
1. Calendar functions
  <?php
  $jd = GregorianToJD(10, 11, 1970);
  echo "$jd\n";
  $gregorian = JDToGregorian($jd);
  echo "$gregorian\n";
  ?> 

  FrenchToJDUpJDDayOfWeek
#

#T=int gregoriantojd ( int month, int day, int year)
gregoriantojd ( ^!int month, int day, int year);
#

#T=gzclose - int gzclose ( resource zp)
(PHP 3, PHP 4 )
gzclose -- Close an open gz-file pointer
Description
int gzclose ( resource zp)
The gz-file pointed to by zp is closed. 
Returns TRUE on success or FALSE on failure. 
The gz-file pointer must be valid, and must point to a file successfully 
opened by gzopen().   Zlib Compression FunctionsUpgzcompress
#

#T=int gzclose ( resource zp)
gzclose ( ^!resource zp);
#

#T=gzcompress - string gzcompress ( string data [, int level])
(PHP 4 >= 4.0.1)
gzcompress -- Compress a string
Description
string gzcompress ( string data [, int level])
This function returns a compressed version of the input data using the 
ZLIB data format, or FALSE if an error is encountered. The optional 
parameter level can be given as 0 for no compression up to 9 for maximum 
compression. 
For details on the ZLIB compression algorithm see the document "ZLIB 
Compressed Data Format Specification version 3.3" (RFC 1950). 
Note: This is not the same as gzip compression, which includes some 
header data. See gzencode() for gzip compression. 
See also gzdeflate(), gzinflate(), gzuncompress(), gzencode().   gzcloseUpgzdeflate
#

#T=string gzcompress ( string data [, int level])
gzcompress ( ^!string data [, int level]);
#

#T=gzdeflate - string gzdeflate ( string data [, int level])
(PHP 4 >= 4.0.4)
gzdeflate -- Deflate a string
Description
string gzdeflate ( string data [, int level])
This function returns a compressed version of the input data using the 
DEFLATE data format, or FALSE if an error is encountered. The optional 
parameter level can be given as 0 for no compression up to 9 for maximum 
compression. 
For details on the DEFLATE compression algorithm see the document "DEFLATE 
Compressed Data Format Specification version 1.3" (RFC 1951). 
See also gzinflate(), gzcompress(), gzuncompress(), gzencode().   gzcompressUpgzencode
#

#T=string gzdeflate ( string data [, int level])
gzdeflate ( ^!string data [, int level]);
#

#T=gzencode - string gzencode ( string data [, int level [, int encoding_mode]])
(PHP 4 >= 4.0.4)
gzencode -- Create a gzip compressed string
Description
string gzencode ( string data [, int level [, int encoding_mode]])
This function returns a compressed version of the input data compatible 
with the output of the gzip program, or FALSE if an error is encountered. 
The optional parameter level can be given as 0 for no compression up to 9 
for maximum compression, if not given the default compression level will 
be the default compression level of the zlib library. 
You can also give FORCE_GZIP (the default) or FORCE_DEFLATE as optional 
third parameter encoding_mode. If you use FORCE_DEFLATE, you get a 
standard zlib deflated string (inclusive zlib headers) after the gzip file 
header but without the trailing crc32 checksum. 
Note: level was added in PHP 4.2, before PHP 4.2 gzencode() only had the 
data and (optional) encoding_mode parameters.. 
The resulting data contains the appropriate headers and data structure to 
make a standard .gz file, e.g.: Example 1. Creating a gzip file
  <?php
      $data = implode("", file("bigfile.txt"));
      $gzdata = gzencode($data, 9);
      $fp = fopen("bigfile.txt.gz", "w");
      fwrite($fp, $gzdata);
      fclose($fp);
  ?> 
For more information on the GZIP file format, see the document: GZIP file 
format specification version 4.3 (RFC 1952). 
See also gzcompress(). gzuncompress(), gzdeflate(), gzinflate().   gzdeflateUpgzeof
#

#T=string gzencode ( string data [, int level [, int encoding_mode]])
gzencode ( ^!string data [, int level [, int encoding_mode]]);
#

#T=gzeof - int gzeof ( resource zp)
(PHP 3, PHP 4 )
gzeof -- Test for end-of-file on a gz-file pointer
Description
int gzeof ( resource zp)
Returns TRUE if the gz-file pointer is at EOF or an error occurs; 
otherwise returns FALSE. 
The gz-file pointer must be valid, and must point to a file successfully 
opened by gzopen().   gzencodeUpgzfile
#

#T=int gzeof ( resource zp)
gzeof ( ^!resource zp);
#

#T=gzfile - array gzfile ( string filename [, int use_include_path])
(PHP 3, PHP 4 )
gzfile -- Read entire gz-file into an array
Description
array gzfile ( string filename [, int use_include_path])
Identical to readgzfile(), except that gzfile() returns the file in an 
array. 
You can use the optional second parameter and set it to "1", if you want 
to search for the file in the include_path, too. 
See also readgzfile(), and gzopen().   gzeofUpgzgetc
#

#T=array gzfile ( string filename [, int use_include_path])
gzfile ( ^!string filename [, int use_include_path]);
#

#T=gzgetc - string gzgetc ( resource zp)
(PHP 3, PHP 4 )
gzgetc -- Get character from gz-file pointer
Description
string gzgetc ( resource zp)
Returns a string containing a single (uncompressed) character read from 
the file pointed to by zp. Returns FALSE on EOF (unlike gzeof()). 
The gz-file pointer must be valid, and must point to a file successfully 
opened by gzopen(). 
See also gzopen(), and gzgets().   gzfileUpgzgets
#

#T=string gzgetc ( resource zp)
gzgetc ( ^!resource zp);
#

#T=gzgets - string gzgets ( resource zp, int length)
(PHP 3, PHP 4 )
gzgets -- Get line from file pointer
Description
string gzgets ( resource zp, int length)
Returns a (uncompressed) string of up to length - 1 bytes read from the 
file pointed to by fp. Reading ends when length - 1 bytes have been read, 
on a newline, or on EOF (whichever comes first). 
If an error occurs, returns FALSE. 
The file pointer must be valid, and must point to a file successfully 
opened by gzopen(). 
See also gzopen(), gzgetc(), and fgets().   gzgetcUpgzgetss
#

#T=string gzgets ( resource zp, int length)
gzgets ( ^!resource zp, int length);
#

#T=gzgetss - string gzgetss ( resource zp, int length [, string allowable_tags])
(PHP 3, PHP 4 )
gzgetss --  Get line from gz-file pointer and strip HTML tags 
Description
string gzgetss ( resource zp, int length [, string allowable_tags])
Identical to gzgets(), except that gzgetss() attempts to strip any HTML 
and PHP tags from the text it reads. 
You can use the optional third parameter to specify tags which should not 
be stripped. 
Note: Allowable_tags was added in PHP 3.0.13, PHP 4.0b3. 
See also gzgets(), gzopen(), and strip_tags().   gzgetsUpgzinflate
#

#T=string gzgetss ( resource zp, int length [, string allowable_tags])
gzgetss ( ^!resource zp, int length [, string allowable_tags]);
#

#T=gzinflate - string gzinflate ( string data [, int length])
(PHP 4 >= 4.0.4)
gzinflate -- Inflate a deflated string
Description
string gzinflate ( string data [, int length])
This function takes data compressed by gzdeflate() and returns the 
original uncompressed data or FALSE on error. The function will return an 
error if the uncompressed data is more than 32768 times the length of the 
compressed input data or more than the optional parameter length. 
See also gzcompress(). gzuncompress(), gzdeflate(), gzencode().   gzgetssUpgzopen
#

#T=string gzinflate ( string data [, int length])
gzinflate ( ^!string data [, int length]);
#

#T=gzopen - resource gzopen ( string filename, string mode [, int use_include_path])
(PHP 3, PHP 4 )
gzopen -- Open gz-file
Description
resource gzopen ( string filename, string mode [, int use_include_path])
Opens a gzip (.gz) file for reading or writing. The mode parameter is as 
in fopen() ("rb" or "wb") but can also include a compression level ("wb9") 
or a strategy: 'f' for filtered data as in "wb6f", 'h' for Huffman only 
compression as in "wb1h". (See the description of deflateInit2 in zlib.h 
for more information about the strategy parameter.) 
gzopen() can be used to read a file which is not in gzip format; in this 
case gzread() will directly read from the file without decompression. 
gzopen() returns a file pointer to the file opened, after that, everything 
you read from this file descriptor will be transparently decompressed and 
what you write gets compressed. 
If the open fails, the function returns FALSE. 
You can use the optional third parameter and set it to "1", if you want to 
search for the file in the include_path, too. 
Example 1. gzopen() Example
  <?php
  $fp = gzopen("/tmp/file.gz", "r");
  ?> 
See also gzclose().   gzinflateUpgzpassthru
#

#T=resource gzopen ( string filename, string mode [, int use_include_path])
gzopen ( ^!string filename, string mode [, int use_include_path]);
#

#T=gzpassthru - int gzpassthru ( resource zp)
(PHP 3, PHP 4 )
gzpassthru --  Output all remaining data on a gz-file pointer 
Description
int gzpassthru ( resource zp)
Reads to EOF on the given gz-file pointer and writes the (uncompressed) 
results to standard output. 
If an error occurs, returns FALSE. 
The file pointer must be valid, and must point to a file successfully 
opened by gzopen().   gzopenUpgzputs
gzputs
gzputs -- Alias for gzwrite()
Description
This function is an alias of gzwrite().   gzpassthruUpgzread
#

#T=int gzpassthru ( resource zp)
gzpassthru ( ^!resource zp);
#

#T=gzread - string gzread ( resource zp, int length)
(PHP 3, PHP 4 )
gzread -- Binary-safe gz-file read
Description
string gzread ( resource zp, int length)
gzread() reads up to length bytes from the gz-file pointer referenced by 
zp. Reading stops when length (uncompressed) bytes have been read or EOF 
is reached, whichever comes first. 
Example 1. gzread() example
  <?php
  // get contents of a gz-file into a string
  $filename = "/usr/local/something.txt.gz";
  $zd = gzopen($filename, "r");
  $contents = gzread($zd, 10000);
  gzclose($zd);
  ?> 
See also gzwrite(), gzopen(), gzgets(), gzgetss(), gzfile(), and 
gzpassthru().   gzputsUpgzrewind
#

#T=string gzread ( resource zp, int length)
gzread ( ^!resource zp, int length);
#

#T=gzrewind - int gzrewind ( resource zp)
(PHP 3, PHP 4 )
gzrewind -- Rewind the position of a gz-file pointer
Description
int gzrewind ( resource zp)
Sets the file position indicator for zp to the beginning of the file 
stream. 
If an error occurs, returns 0. 
The file pointer must be valid, and must point to a file successfully 
opened by gzopen(). 
See also gzseek() and gztell().   gzreadUpgzseek
#

#T=int gzrewind ( resource zp)
gzrewind ( ^!resource zp);
#

#T=gzseek - int gzseek ( resource zp, int offset)
(PHP 3, PHP 4 )
gzseek -- Seek on a gz-file pointer
Description
int gzseek ( resource zp, int offset)
Sets the file position indicator for the file referenced by zp to offset 
bytes into the file stream. Equivalent to calling (in C) gzseek(zp, 
offset, SEEK_SET). 
If the file is opened for reading, this function is emulated but can be 
extremely slow. If the file is opened for writing, only forward seeks are 
supported; gzseek then compresses a sequence of zeroes up to the new 
starting position. 
Upon success, returns 0; otherwise, returns -1. Note that seeking past EOF 
is not considered an error. 
See also gztell() and gzrewind().   gzrewindUpgztell
#

#T=int gzseek ( resource zp, int offset)
gzseek ( ^!resource zp, int offset);
#

#T=gztell - int gztell ( resource zp)
(PHP 3, PHP 4 )
gztell -- Tell gz-file pointer read/write position
Description
int gztell ( resource zp)
Returns the position of the file pointer referenced by zp; i.e., its 
offset into the file stream. 
If an error occurs, returns FALSE. 
The file pointer must be valid, and must point to a file successfully 
opened by gzopen(). 
See also gzopen(), gzseek() and gzrewind().   gzseekUpgzuncompress
#

#T=int gztell ( resource zp)
gztell ( ^!resource zp);
#

#T=gzuncompress - string gzuncompress ( string data [, int length])
(PHP 4 >= 4.0.1)
gzuncompress -- Uncompress a deflated string
Description
string gzuncompress ( string data [, int length])
This function takes data compressed by gzcompress() and returns the 
original uncompressed data or FALSE on error. The function will return an 
error if the uncompressed data is more than 32768 times the length of the 
compressed input data or more than the optional parameter length. 
See also gzdeflate(), gzinflate(), gzcompress(), gzencode().   gztellUpgzwrite
#

#T=string gzuncompress ( string data [, int length])
gzuncompress ( ^!string data [, int length]);
#

#T=gzwrite - int gzwrite ( resource zp, string string [, int length])
(PHP 3, PHP 4 )
gzwrite -- Binary-safe gz-file write
Description
int gzwrite ( resource zp, string string [, int length])
gzwrite() writes the contents of string to the gz-file stream pointed to 
by zp. If the length argument is given, writing will stop after length 
(uncompressed) bytes have been written or the end of string is reached, 
whichever comes first. 
gzwrite() returns the number of (uncompressed) bytes written to the 
gz-file stream pointed to by zp. 
Note that if the length argument is given, then the magic_quotes_runtime 
configuration option will be ignored and no slashes will be stripped from 
string. 
See also gzread(), gzopen(), and gzputs().   gzuncompressUpreadgzfile
#

#T=int gzwrite ( resource zp, string string [, int length])
gzwrite ( ^!resource zp, string string [, int length]);
#

#T=header - void header ( string string [, bool replace [, int http_response_code]])
(PHP 3, PHP 4 )
header -- Send a raw HTTP header
Description
void header ( string string [, bool replace [, int http_response_code]])
header() is used to send raw HTTP headers. See the HTTP/1.1 specification 
for more information on HTTP headers. 
The optional replace parameter indicates whether the header should replace 
a previous similar header, or add a second header of the same type. By 
default it will replace, but if you pass in FALSE as the second argument 
you can force multiple headers of the same type. For example: 
<?php
header('WWW-Authenticate: Negotiate');
header('WWW-Authenticate: NTLM', false);
?> 

The second optional http_response_code force the HTTP response code to the 
specified value. (This parameter is available in PHP 4.3.0 and higher.) 
There are two special-case header calls. The first is a header that starts 
with the string "HTTP/" (case is not significant), which will be used to 
figure out the HTTP status code to send. For example, if you have 
configured Apache to use a PHP script to handle requests for missing files 
(using the ErrorDocument directive), you may want to make sure that your 
script generates the proper status code. 
<?php
header("HTTP/1.0 404 Not Found");
?> 

Note: The HTTP status header line will always be the first sent to the 
client, regardless of the actual header() call being the first or not. 
The status may be overridden by calling header() with a new status line 
at any time unless the HTTP headers have already been sent. 
Note: In PHP 3, this only works when PHP is compiled as an Apache 
module. You can achieve the same effect using the Status header. 
<?php
header("Status: 404 Not Found");
?> 

The second special case is the "Location:" header. Not only does it send 
this header back to the browser, but it also returns a REDIRECT (302) 
status code to the browser unless some 3xx status code has already been 
set. 
<?php
header("Location: http://www.example.com/"); /* Redirect browser */

/* Make sure that code below does not get executed when we redirect. 
*/
exit;
?> 

Note: HTTP/1.1 requires an absolute URI as argument to Location: 
including the scheme, hostname and absolute path, but some clients 
accept relative URIs. You can usually use $_SERVER['HTTP_HOST'], 
$_SERVER['PHP_SELF'] and dirname() to make an absolute URI from a 
relative one yourself: 
<?php
header("Location: http://" . $_SERVER['HTTP_HOST']
		    . dirname($_SERVER['PHP_SELF'])
		    . "/" . $relative_url);
?> 

PHP scripts often generate dynamic content that must not be cached by the 
client browser or any proxy caches between the server and the client 
browser. Many proxies and clients can be forced to disable caching with: 
<?php
// Date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

// always modified
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");

// HTTP/1.1
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);

// HTTP/1.0
header("Pragma: no-cache");
?> 

Note: You may find that your pages aren't cached even if you don't 
output all of the headers above. There are a number of options that 
users may be able to set for their browser that change its default 
caching behavior. By sending the headers above, you should override any 
settings that may otherwise cause the output of your script to be 
cached. 
Additionally, session_cache_limiter() and the session.cache_limiter 
configuration setting can be used to automatically generate the correct 
caching-related headers when sessions are being used. 
Remember that header() must be called before any actual output is sent, 
either by normal HTML tags, blank lines in a file, or from PHP. It is a 
very common error to read code with include(), or require(), functions, or 
another file access function, and have spaces or empty lines that are 
output before header() is called. The same problem exists when using a 
single PHP/HTML file. 
<html>
<?php
/* This will give an error. Note the output
* above, which is before the header() call */
header('Location: http://www.example.com/');
?> 

Note: In PHP 4, you can use output buffering to get around this problem, 
with the overhead of all of your output to the browser being buffered in 
the server until you send it. You can do this by calling ob_start() and 
ob_end_flush() in your script, or setting the output_buffering 
configuration directive on in your php.ini or server configuration 
files. 
If you want the user to be prompted to save the data you are sending, such 
as a generated PDF file, you can use the Content-Disposition header to 
supply a recommended filename and force the browser to display the save 
dialog. 
<?php
// We'll be outputting a PDF
header("Content-type: application/pdf");

// It will be called downloaded.pdf
header("Content-Disposition: attachment; filename=downloaded.pdf");

// The PDF source is in original.pdf
readfile('original.pdf');
?> 

Note: There is a bug in Microsoft Internet Explorer 4.01 that prevents 
this from working. There is no workaround. There is also a bug in 
Microsoft Internet Explorer 5.5 that interferes with this, which can be 
resolved by upgrading to Service Pack 2 or later. 
Note: If safe mode is enabled the uid of the script is added to the 
realm part of the WWW-Authenticate header if you set this header (used 
for HTTP Authentication). 
See also headers_sent(), setcookie(), and the section on HTTP 
authentication.   HTTP functionsUpheaders_list
headers_list
(no version information, might be only in CVS)
headers_list -- Returns a list of response headers sent (or ready to send)
Description
array headers_list ( void )
headers_list() will return a numerically indexed array of headers to be 
sent to the browser / client. To determine whether or not these headers 
have been sent yet, use headers_sent(). 
Example 1. Examples using headers_list()
  <?php

  /* setcookie() will add a response header on its own */
  setcookie('foo', 'bar');

  /* Define a custom response header
     This will be ignored by most clients */
  header("X-Sample-Test: foo");

  /* Specify plain text content in our response */
  header('Content-type: text/plain');

  /* What headers are going to be sent? */
  var_dump(headers_list());

  ?> 

this will output : 
array(4) {
[0]=>
string(29) "X-Powered-By: PHP/5.0.0"
[1]=>
string(19) "Set-Cookie: foo=bar"
[2]=>
string(18) "X-Sample-Test: foo"
[3]=>
string(24) "Content-type: text/plain"
}
See Also: headers_sent(), header(), and setcookie().   headerUpheaders_sent
#

#T=void header ( string string [, bool replace [, int http_response_code]])
header ( ^!string string [, bool replace [, int http_response_code]]);
#

#T=headers_sent - bool headers_sent ( [string &file [, int &line]])
(PHP 3>= 3.0.8, PHP 4 )
headers_sent -- Checks if or where headers have been sent
Description
bool headers_sent ( [string &file [, int &line]])
headers_sent() will return FALSE if no HTTP headers have already been sent 
or TRUE otherwise. If the optional file and line parameters are set, 
headers_sent() will put the PHP source file name and line number where 
output started in the file and line variables. 
You can't add any more header lines using the header() function once the 
header block has already been sent. Using this function you can at least 
prevent getting HTTP header related error messages. Another option is to 
use Output Buffering. 
Note: The optional file and line parameters where added in PHP 4.3.0. 
Example 1. Examples using headers_sent()
  <?php

  // If no headers are sent, send one
  if (!headers_sent()) {
      header('Location: http://www.example.com/');
      exit;
  }
    
  // An example using the optional file and line parameters, as 
  of PHP 4.3.0
  // Note that $filename and $linenum are passed in for later 
  use.
  // Do not assign them values beforehand.
  if (!headers_sent($filename, $linenum)) {
      header('Location: http://www.example.com/');
      exit;

  // You would most likely trigger an error here.
  } else {

      echo "Headers already sent in $filename on line 
  $linenum\n" .
	    "Cannot redirect, for now please click this <a " .
	    "href=\"http://www.example.com\">link</a> 
instead\n";
      exit;
  }

  ?> 
See also ob_start(), trigger_error(), and header() for a more detailed 
discussion of the matters involved.   headers_listUpsetcookie
#

#T=bool headers_sent ( [string &file [, int &line]])
headers_sent ( ^![string &file [, int &line]]);
#

#T=hebrev - string hebrev ( string hebrew_text [, int max_chars_per_line])
(PHP 3, PHP 4 )
hebrev --  Convert logical Hebrew text to visual text 
Description
string hebrev ( string hebrew_text [, int max_chars_per_line])
The optional parameter max_chars_per_line indicates maximum number of 
characters per line will be output. The function tries to avoid breaking 
words. 
See also hebrevc()   get_html_translation_tableUphebrevc
#

#T=string hebrev ( string hebrew_text [, int max_chars_per_line])
hebrev ( ^!string hebrew_text [, int max_chars_per_line]);
#

#T=hebrevc - string hebrevc ( string hebrew_text [, int max_chars_per_line])
(PHP 3, PHP 4 )
hebrevc --  Convert logical Hebrew text to visual text with newline 
conversion 
Description
string hebrevc ( string hebrew_text [, int max_chars_per_line])
This function is similar to hebrev() with the difference that it converts 
newlines (\n) to "<br>\n". The optional parameter max_chars_per_line 
indicates maximum number of characters per line will be output. The 
function tries to avoid breaking words. 
See also hebrev()   hebrevUphtml_entity_decode
#

#T=string hebrevc ( string hebrew_text [, int max_chars_per_line])
hebrevc ( ^!string hebrew_text [, int max_chars_per_line]);
#

#T=hexdec - int hexdec ( string hex_string)
(PHP 3, PHP 4 )
hexdec -- Hexadecimal to decimal
Description
int hexdec ( string hex_string)
Returns the decimal equivalent of the hexadecimal number represented by 
the hex_string argument. hexdec() converts a hexadecimal string to a 
decimal number. The largest number that can be converted is 7fffffff or 
2147483647 in decimal. 
hexdec() will replace of any non-hexadecimal characters it encounters by 
0. This way, all left zeros are ignored, but right zeros will be valued. 
Example 1. hexdec() example
  <?php
  var_dump(hexdec("See"));
  var_dump(hexdec("ee"));
  // both print "int(238)"

  var_dump(hexdec("that"));
  var_dump(hexdec("a0"));
  // both print "int(160)"
  ?> 
See also dechex(), bindec(), octdec() and base_convert().   getrandmaxUphypot
#

#T=int hexdec ( string hex_string)
hexdec ( ^!string hex_string);
#

#T=highlight_file - mixed highlight_file ( string filename [, bool return])
(PHP 4 )
highlight_file -- Syntax highlighting of a file
Description
mixed highlight_file ( string filename [, bool return])
The highlight_file() function prints out a syntax highlighted version of 
the code contained in filename using the colors defined in the built-in 
syntax highlighter for PHP. 
If the second parameter return is set to TRUE then highlight_file() will 
return the highlighted code as a string instead of printing it out. If the 
second parameter is not set to TRUE then highlight_file() will return TRUE 
on success, FALSE on failure. 
Note: The return parameter became available in PHP 4.2.0. Before this 
time it behaved like the default, which is FALSE 
Caution
Care should be taken when using the show_source() and 
highlight_file() functions to make sure that you do not 
inadvertently reveal sensitive information such as passwords or any 
other type of information that might create a potential security 
risk. 

Note: Since PHP 4.2.1 this function is also affected by safe_mode and 
open_basedir. 
To setup a URL that can code hightlight any script that you pass to it, we 
will make use of the "ForceType" directive in Apache to generate a nice 
URL pattern, and use the function highlight_file() to show a nice looking 
code list. 
In your httpd.conf you can add the following: 
Example 1. Creating a source highlighting URL
<Location /source>
ForceType application/x-httpd-php
</Location>

And then make a file named "source" and put it in your web root 
directory. 
  <html>
  <head>
  <title>Source Display</title>
  </head>
  <body bgcolor="white">
  <?php
      $script = getenv("PATH_TRANSLATED");
      if (!$script) {
	  echo "<br /><b>ERROR: Script Name needed</b><br />";
      } else {
	  if (ereg("(\\.php|\\.inc)$", $script)) {
	      echo "<h1>Source of: " . getenv("PATH_INFO") . 
  "</h1>\n<hr />\n";
	      highlight_file($script);
	  } else {
	      echo "<h1>ERROR: Only PHP or include script names 
  are allowed</h1>"; 
	  }
      }
      echo "<hr />Processed: " . date("Y/M/d H:i:s", time());
  ?>
  </BODY>
  </HTML> 

Then you can use an URL like the one below to display a colorized 
version of a script located in "/path/to/script.php" in your web 
site. 
http://www.example.com/source/path/to/script.php
See also highlight_string().   get_browserUphighlight_string
#

#T=mixed highlight_file ( string filename [, bool return])
highlight_file ( ^!string filename [, bool return]);
#

#T=highlight_string - mixed highlight_string ( string str [, bool return])
(PHP 4 )
highlight_string -- Syntax highlighting of a string
Description
mixed highlight_string ( string str [, bool return])
The highlight_string() function outputs a syntax highlighted version of 
str using the colors defined in the built-in syntax highlighter for PHP. 
If the second parameter return is set to TRUE then highlight_string() will 
return the highlighted code as a string instead of printing it out. If the 
second parameter is not set to TRUE then highlight_string() will return 
TRUE on success, FALSE on failure. 
Note: The return parameter became available in PHP 4.2.0. Before this 
time it behaved like the default, which is FALSE 
See also highlight_file().   highlight_fileUpignore_user_abort
#

#T=mixed highlight_string ( string str [, bool return])
highlight_string ( ^!string str [, bool return]);
#

#T=html_entity_decode - string html_entity_decode ( string string [, int quote_style [, string 
(PHP 4 >= 4.3.0)
html_entity_decode --  Convert all HTML entities to their applicable 
characters 
Description
string html_entity_decode ( string string [, int quote_style [, string 
charset]])
html_entity_decode() is the opposite of htmlentities() in that it converts 
all HTML entities to their applicable characters from string. 
The optional second quote_style parameter lets you define what will be 
done with 'single' and "double" quotes. It takes on one of three constants 
with the default being ENT_COMPAT: 
Table 1. Available quote_style constants
Constant NameDescription
ENT_COMPATWill convert double-quotes and leave single-quotes alone.
ENT_QUOTESWill convert both double and single quotes.
ENT_NOQUOTESWill leave both double and single quotes unconverted.

The ISO-8859-1 character set is used as default for the optional third 
charset. This defines the character set used in conversion. Support for 
this third argument was added in PHP 4.1.0. 
Following character sets are supported in PHP 4.3.0 and later. 
Table 2. Supported charsets
CharsetAliasesDescription
ISO-8859-1ISO8859-1Western European, Latin-1 
ISO-8859-15ISO8859-15Western European, Latin-9. Adds the Euro sign, 
French and Finnish letters missing in Latin-1(ISO-8859-1). 
UTF-8 ASCII compatible multi-byte 8-bit Unicode. 
cp866ibm866, 866DOS-specific Cyrillic charset. This charset is 
supported in 4.3.2. 
cp1251Windows-1251, win-1251, 1251Windows-specific Cyrillic charset. 
This charset is supported in 4.3.2. 
cp1252Windows-1252, 1252Windows specific charset for Western 
European. 
KOI8-Rkoi8-ru, koi8rRussian. This charset is supported in 4.3.2. 
BIG5950Traditional Chinese, mainly used in Taiwan. 
GB2312936Simplified Chinese, national standard character set. 
BIG5-HKSCS Big5 with Hong Kong extensions, Traditional Chinese. 
Shift_JISSJIS, 932Japanese 
EUC-JPEUCJPJapanese 

Note: Any other character sets are not recognized and ISO-8859-1 will be 
used instead. 
Example 1. Decoding HTML entities
  <?php
  $orig = "I'll \"walk\" the <b>dog</b> now";

  $a = htmlentities($orig);

  $b = html_entity_decode($a);

  echo $a; // I'll &quot;walk&quot; the &lt;b&gt;dog&lt;/b&gt; 
  now

  echo $b; // I'll "walk" the <b>dog</b> now
  // For users prior to PHP 4.3.0 you may do this:
  function unhtmlentities($string) {
      $trans_tbl = get_html_translation_table(HTML_ENTITIES);
      $trans_tbl = array_flip($trans_tbl);
      return strtr($string, $trans_tbl);
  }

  $c = unhtmlentities($a);

  echo $c; // I'll "walk" the <b>dog</b> now

  ?> 
Note: You might wonder why trim(html_entity_decode('&nbsp;')); doesn't 
reduce the string to an empty string, that's because the '&nbsp;' entity 
is not ASCII code 32 (which is stripped by trim()) but ASCII code 160 
(0xa0) in the default ISO 8859-1 characterset. 
See also htmlentities(), htmlspecialchars(), get_html_translation_table(), 
htmlspecialchars() and urldecode().   hebrevcUphtmlentities
#

#T=string html_entity_decode ( string string [, int quote_style [, string 
html_entity_decode ( ^!string string [, int quote_style [, string ;
#

#T=htmlentities - string htmlentities ( string string [, int quote_style [, string 
(PHP 3, PHP 4 )
htmlentities --  Convert all applicable characters to HTML entities 
Description
string htmlentities ( string string [, int quote_style [, string 
charset]])
This function is identical to htmlspecialchars() in all ways, except with 
htmlentities(), all characters which have HTML character entity 
equivalents are translated into these entities. 
Like htmlspecialchars(), the optional second quote_style parameter lets 
you define what will be done with 'single' and "double" quotes. It takes 
on one of three constants with the default being ENT_COMPAT: 
Table 1. Available quote_style constants
Constant NameDescription
ENT_COMPATWill convert double-quotes and leave single-quotes alone.
ENT_QUOTESWill convert both double and single quotes.
ENT_NOQUOTESWill leave both double and single quotes unconverted.

Support for the optional quote parameter was added in PHP 4.0.3. 
Like htmlspecialchars(), it takes an optional third argument charset which 
defines character set used in conversion. Support for this argument was 
added in PHP 4.1.0. Presently, the ISO-8859-1 character set is used as the 
default. 
Following character sets are supported in PHP 4.3.0 and later. 
Table 2. Supported charsets
CharsetAliasesDescription
ISO-8859-1ISO8859-1Western European, Latin-1 
ISO-8859-15ISO8859-15Western European, Latin-9. Adds the Euro sign, 
French and Finnish letters missing in Latin-1(ISO-8859-1). 
UTF-8 ASCII compatible multi-byte 8-bit Unicode. 
cp866ibm866, 866DOS-specific Cyrillic charset. This charset is 
supported in 4.3.2. 
cp1251Windows-1251, win-1251, 1251Windows-specific Cyrillic charset. 
This charset is supported in 4.3.2. 
cp1252Windows-1252, 1252Windows specific charset for Western 
European. 
KOI8-Rkoi8-ru, koi8rRussian. This charset is supported in 4.3.2. 
BIG5950Traditional Chinese, mainly used in Taiwan. 
GB2312936Simplified Chinese, national standard character set. 
BIG5-HKSCS Big5 with Hong Kong extensions, Traditional Chinese. 
Shift_JISSJIS, 932Japanese 
EUC-JPEUCJPJapanese 

Note: Any other character sets are not recognized and ISO-8859-1 will be 
used instead. 
If you're wanting to decode instead (the reverse) you can use 
html_entity_decode(). 
Example 1. A htmlentities() example
  <?php
  $str = "A 'quote' is <b>bold</b>";

  // Outputs: A 'quote' is &lt;b&gt;bold&lt;/b&gt;
  echo htmlentities($str);

  // Outputs: A &#039;quote&#039; is &lt;b&gt;bold&lt;/b&gt;
  echo htmlentities($str, ENT_QUOTES);
  ?> 
See also html_entity_decode(), get_html_translation_table(), 
htmlspecialchars(), nl2br(), and urlencode().   html_entity_decodeUphtmlspecialchars
#

#T=string htmlentities ( string string [, int quote_style [, string 
htmlentities ( ^!string string [, int quote_style [, string ;
#

#T=htmlspecialchars - string htmlspecialchars ( string string [, int quote_style [, string 
(PHP 3, PHP 4 )
htmlspecialchars --  Convert special characters to HTML entities 
Description
string htmlspecialchars ( string string [, int quote_style [, string 
charset]])
Certain characters have special significance in HTML, and should be 
represented by HTML entities if they are to preserve their meanings. This 
function returns a string with some of these conversions made; the 
translations made are those most useful for everyday web programming. If 
you require all HTML character entities to be translated, use 
htmlentities() instead. 
This function is useful in preventing user-supplied text from containing 
HTML markup, such as in a message board or guest book application. The 
optional second argument, quote_style, tells the function what to do with 
single and double quote characters. The default mode, ENT_COMPAT, is the 
backwards compatible mode which only translates the double-quote character 
and leaves the single-quote untranslated. If ENT_QUOTES is set, both 
single and double quotes are translated and if ENT_NOQUOTES is set neither 
single nor double quotes are translated. 
The translations performed are: 
'&' (ampersand) becomes '&amp;' 
'"' (double quote) becomes '&quot;' when ENT_NOQUOTES is not set. 
''' (single quote) becomes '&#039;' only when ENT_QUOTES is set. 
'<' (less than) becomes '&lt;' 
'>' (greater than) becomes '&gt;' 
Example 1. htmlspecialchars() example
  <?php
  $new = htmlspecialchars("<a href='test'>Test</a>", 
ENT_QUOTES);
  echo $new; // &lt;a href=&#039;test&#039;&gt;Test&lt;/a&gt;
  ?> 
Note that this function does not translate anything beyond what is listed 
above. For full entity translation, see htmlentities(). Support for the 
optional second argument was added in PHP 3.0.17 and PHP 4.0.3. 
The third argument charset defines character set used in conversion. The 
default character set is ISO-8859-1. Support for this third argument was 
added in PHP 4.1.0. 
Following character sets are supported in PHP 4.3.0 and later. 
Table 1. Supported charsets
CharsetAliasesDescription
ISO-8859-1ISO8859-1Western European, Latin-1 
ISO-8859-15ISO8859-15Western European, Latin-9. Adds the Euro sign, 
French and Finnish letters missing in Latin-1(ISO-8859-1). 
UTF-8 ASCII compatible multi-byte 8-bit Unicode. 
cp866ibm866, 866DOS-specific Cyrillic charset. This charset is 
supported in 4.3.2. 
cp1251Windows-1251, win-1251, 1251Windows-specific Cyrillic charset. 
This charset is supported in 4.3.2. 
cp1252Windows-1252, 1252Windows specific charset for Western 
European. 
KOI8-Rkoi8-ru, koi8rRussian. This charset is supported in 4.3.2. 
BIG5950Traditional Chinese, mainly used in Taiwan. 
GB2312936Simplified Chinese, national standard character set. 
BIG5-HKSCS Big5 with Hong Kong extensions, Traditional Chinese. 
Shift_JISSJIS, 932Japanese 
EUC-JPEUCJPJapanese 

Note: Any other character sets are not recognized and ISO-8859-1 will be 
used instead. 
See also get_html_translation_table(), strip_tags(), htmlentities(), and 
nl2br().   htmlentitiesUpimplode
http_build_query
(no version information, might be only in CVS)
http_build_query -- Generate url-encoded query string
Description
string http_build_query ( array formdata [, string numeric_prefix])
Generates a url-encoded query string from the associative (or indexed) 
array provided. formdata may be an array or object containing properties. 
A formdata array may be a simple one-dimensional structure, or an array of 
arrays (who in turn may contain other arrays). If numeric indices are used 
in the base array and a numeric_prefix is provided, it will be prepended 
to the numeric index for elements in the base array only. This is to allow 
for legal variable names when the data is decoded by PHP or another CGI 
application later on. 
Example 1. Simple usage of http_build_query()
  <?php
  $data = array('foo'=>'bar',
		'baz'=>'boom',
		'cow'=>'milk',
		'php'=>'hypertext processor');
		
  echo http_build_query($data);
  /* Outputs:
	foo=bar&baz=boom&cow=milk&php=hypertext+processor
  */
  ?> 

Example 2. http_build_query() with numerically index elements.
  <?php
  $data = array('foo', 'bar', 'baz', 'boom', 'cow' => 'milk', 
  'php' =>'hypertext processor');
		
  echo http_build_query($data);
  /* Outputs:
	
0=foo&1=bar&2=baz&3=boom&cow=milk&php=hypertext+processor
  */

  echo http_build_query($data, 'myvar_');
  /* Outputs:
	
  myvar_0=foo&myvar_1=bar&myvar_2=baz&myvar_3=boom&cow=milk&php=hypertext+processor
  */
  ?> 

Example 3. http_build_query() with complex arrays
  <?php
  $data = array('user'=>array('name'=>'Bob Smith',
			      'age'=>47,
			      'sex'=>'M',
			      'dob'=>'5/12/1956'),
		'pastimes'=>array('golf', 'opera', 'poker', 
  'rap'),
		'children'=>array('bobby'=>array('age'=>12,
						 'sex'=>'M'),
				  'sally'=>array('age'=>8,
						 'sex'=>'F')),
		'CEO');
						 
  echo http_build_query($data, 'flags_');
  ?> 

this will output : (word wrapped for readability) 
user[name]=Bob+Smith&user[age]=47&user[sex]=M&user[dob]=5%1F12%1F1956&
pastimes[0]=golf&pastimes[1]=opera&pastimes[2]=poker&pastimes[3]=rap&
children[bobby][age]=12&children[bobby][sex]=M&children[sally][age]=8&
children[sally][sex]=F&flags_0=CEO

Note: Only the numerically indexed element in the base array "CEO" 
received a prefix. The other numeric indices, found under 
pastimes, do not require a string prefix to be legal variable 
names. 
Example 4. Using http_build_query() with an object
  <?php
  class myClass {
    var $foo;
    var $baz;
    
    function myClass() {
      $this->foo = 'bar';
      $this->baz = 'boom';
    }
  }

  $data = new myClass();

  echo http_build_query($data);
  /* Outputs:
	foo=bar&baz=boom
  */
  ?> 
See also: parse_str(), parse_url(), urlencode(), and array_walk()   get_meta_tagsUpparse_url
#

#T=string htmlspecialchars ( string string [, int quote_style [, string 
htmlspecialchars ( ^!string string [, int quote_style [, string ;
#

#T=hw_Array2Objrec - string hw_array2objrec ( array object_array)
(PHP 3>= 3.0.4, PHP 4 )
hw_Array2Objrec -- convert attributes from object array to object record
Description
string hw_array2objrec ( array object_array)
Converts an object_array into an object record. Multiple attributes like 
'Title' in different languages are treated properly. 
See also hw_objrec2array().   Hyperwave functionsUphw_changeobject
#

#T=string hw_array2objrec ( array object_array)
hw_array2objrec ( ^!array object_array);
#

#T=hw_changeobject - void hw_changeobject ( int link, int objid, array attributes)
(PHP 3>= 3.0.3, PHP 4 )
hw_changeobject --  Changes attributes of an object (obsolete) 
Description
void hw_changeobject ( int link, int objid, array attributes)
Warning
This function is currently not documented; only the argument list is 
available.
  hw_Array2ObjrecUphw_Children
#

#T=void hw_changeobject ( int link, int objid, array attributes)
hw_changeobject ( ^!int link, int objid, array attributes);
#

#T=hw_Children - array hw_children ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_Children -- object ids of children
Description
array hw_children ( int connection, int objectID)
Returns an array of object ids. Each id belongs to a child of the 
collection with ID objectID. The array contains all children both 
documents and collections.  hw_changeobjectUphw_ChildrenObj
#

#T=array hw_children ( int connection, int objectID)
hw_children ( ^!int connection, int objectID);
#

#T=hw_ChildrenObj - array hw_childrenobj ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_ChildrenObj -- object records of children
Description
array hw_childrenobj ( int connection, int objectID)
Returns an array of object records. Each object record belongs to a child 
of the collection with ID objectID. The array contains all children both 
documents and collections.  hw_ChildrenUphw_Close
#

#T=array hw_childrenobj ( int connection, int objectID)
hw_childrenobj ( ^!int connection, int objectID);
#

#T=hw_Close - int hw_close ( int connection)
(PHP 3>= 3.0.3, PHP 4 )
hw_Close -- closes the Hyperwave connection
Description
int hw_close ( int connection)
Returns FALSE if connection is not a valid connection index, otherwise 
TRUE. Closes down the connection to a Hyperwave server with the given 
connection index.   hw_ChildrenObjUphw_Connect
#

#T=int hw_close ( int connection)
hw_close ( ^!int connection);
#

#T=hw_Connect - int hw_connect ( string host, int port, string username, string password)
(PHP 3>= 3.0.3, PHP 4 )
hw_Connect -- opens a connection
Description
int hw_connect ( string host, int port, string username, string password)
Opens a connection to a Hyperwave server and returns a connection index on 
success, or FALSE if the connection could not be made. Each of the 
arguments should be a quoted string, except for the port number. The 
username and password arguments are optional and can be left out. In such 
a case no identification with the server will be done. It is similar to 
identify as user anonymous. This function returns a connection index that 
is needed by other Hyperwave functions. You can have multiple connections 
open at once. Keep in mind, that the password is not encrypted. 
See also hw_pconnect().   hw_CloseUphw_connection_info
#

#T=int hw_connect ( string host, int port, string username, string password)
hw_connect ( ^!string host, int port, string username, string password);
#

#T=hw_connection_info - void hw_connection_info ( int link)
(PHP 3>= 3.0.3, PHP 4 )
hw_connection_info --  Prints information about the connection to 
Hyperwave server 
Description
void hw_connection_info ( int link)
Warning
This function is currently not documented; only the argument list is 
available.
  hw_ConnectUphw_cp
#

#T=void hw_connection_info ( int link)
hw_connection_info ( ^!int link);
#

#T=hw_cp - int hw_cp ( int connection, array object_id_array, int destination_id)
(PHP 3>= 3.0.3, PHP 4 )
hw_cp -- Copies objects
Description
int hw_cp ( int connection, array object_id_array, int destination_id)
Copies the objects with object ids as specified in the second parameter to 
the collection with the id destination id. 
The value return is the number of copied objects. 
See also hw_mv().   hw_connection_infoUphw_Deleteobject
#

#T=int hw_cp ( int connection, array object_id_array, int destination_id)
hw_cp ( ^!int connection, array object_id_array, int destination_id);
#

#T=hw_Deleteobject - int hw_deleteobject ( int connection, int object_to_delete)
(PHP 3>= 3.0.3, PHP 4 )
hw_Deleteobject -- deletes object
Description
int hw_deleteobject ( int connection, int object_to_delete)
Deletes the object with the given object id in the second parameter. It 
will delete all instances of the object. 
Returns TRUE if no error occurs otherwise FALSE. 
See also hw_mv().   hw_cpUphw_DocByAnchor
#

#T=int hw_deleteobject ( int connection, int object_to_delete)
hw_deleteobject ( ^!int connection, int object_to_delete);
#

#T=hw_DocByAnchor - int hw_docbyanchor ( int connection, int anchorID)
(PHP 3>= 3.0.3, PHP 4 )
hw_DocByAnchor -- object id object belonging to anchor
Description
int hw_docbyanchor ( int connection, int anchorID)
Returns an th object id of the document to which anchorID belongs.   hw_DeleteobjectUphw_DocByAnchorObj
#

#T=int hw_docbyanchor ( int connection, int anchorID)
hw_docbyanchor ( ^!int connection, int anchorID);
#

#T=hw_DocByAnchorObj - string hw_docbyanchorobj ( int connection, int anchorID)
(PHP 3>= 3.0.3, PHP 4 )
hw_DocByAnchorObj -- object record object belonging to anchor
Description
string hw_docbyanchorobj ( int connection, int anchorID)
Returns an th object record of the document to which anchorID belongs.   hw_DocByAnchorUphw_Document_Attributes
#

#T=string hw_docbyanchorobj ( int connection, int anchorID)
hw_docbyanchorobj ( ^!int connection, int anchorID);
#

#T=hw_Document_Attributes - string hw_document_attributes ( int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_Document_Attributes -- object record of hw_document
Description
string hw_document_attributes ( int hw_document)
Returns the object record of the document. 
For backward compatibility, hw_documentattributes() is also accepted. This 
is deprecated, however. 
See also hw_document_bodytag(), and hw_document_size().   hw_DocByAnchorObjUphw_Document_BodyTag
#

#T=string hw_document_attributes ( int hw_document)
hw_document_attributes ( ^!int hw_document);
#

#T=hw_Document_BodyTag - string hw_document_bodytag ( int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_Document_BodyTag -- body tag of hw_document
Description
string hw_document_bodytag ( int hw_document)
Returns the BODY tag of the document. If the document is an HTML document 
the BODY tag should be printed before the document. 
See also hw_document_attributes(), and hw_document_size(). 
For backward compatibility, hw_documentbodytag() is also accepted. This is 
deprecated, however.   hw_Document_AttributesUphw_Document_Content
#

#T=string hw_document_bodytag ( int hw_document)
hw_document_bodytag ( ^!int hw_document);
#

#T=hw_Document_Content - string hw_document_content ( int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_Document_Content -- returns content of hw_document
Description
string hw_document_content ( int hw_document)
Returns the content of the document. If the document is an HTML document 
the content is everything after the BODY tag. Information from the HEAD 
and BODY tag is in the stored in the object record. 
See also hw_document_attributes(), hw_document_size(), and 
hw_document_setcontent().   hw_Document_BodyTagUphw_Document_SetContent
#

#T=string hw_document_content ( int hw_document)
hw_document_content ( ^!int hw_document);
#

#T=hw_Document_SetContent - string hw_document_setcontent ( int hw_document, string content)
(PHP 4 )
hw_Document_SetContent -- sets/replaces content of hw_document
Description
string hw_document_setcontent ( int hw_document, string content)
Sets or replaces the content of the document. If the document is an HTML 
document the content is everything after the BODY tag. Information from 
the HEAD and BODY tag is in the stored in the object record. If you 
provide this information in the content of the document too, the Hyperwave 
server will change the object record accordingly when the document is 
inserted. Probably not a very good idea. If this functions fails the 
document will retain its old content. 
See also hw_document_attributes(), hw_document_size(), and 
hw_document_content().   hw_Document_ContentUphw_Document_Size
#

#T=string hw_document_setcontent ( int hw_document, string content)
hw_document_setcontent ( ^!int hw_document, string content);
#

#T=hw_Document_Size - int hw_document_size ( int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_Document_Size -- size of hw_document
Description
int hw_document_size ( int hw_document)
Returns the size in bytes of the document.
See also hw_document_bodytag(), and hw_document_attributes(). 
For backward compatibility, hw_documentsize() is also accepted. This is 
deprecated, however.   hw_Document_SetContentUphw_dummy
#

#T=int hw_document_size ( int hw_document)
hw_document_size ( ^!int hw_document);
#

#T=hw_dummy - string hw_dummy ( int link, int id, int msgid)
(PHP 3>= 3.0.3, PHP 4 )
hw_dummy --  Hyperwave dummy function 
Description
string hw_dummy ( int link, int id, int msgid)
Warning
This function is currently not documented; only the argument list is 
available.
  hw_Document_SizeUphw_EditText
#

#T=string hw_dummy ( int link, int id, int msgid)
hw_dummy ( ^!int link, int id, int msgid);
#

#T=hw_EditText - int hw_edittext ( int connection, int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_EditText -- retrieve text document
Description
int hw_edittext ( int connection, int hw_document)
Uploads the text document to the server. The object record of the document 
may not be modified while the document is edited. This function will only 
works for pure text documents. It will not open a special data connection 
and therefore blocks the control connection during the transfer. 
See also hw_pipedocument(), hw_free_document(), hw_document_bodytag(), 
hw_document_size(), hw_output_document(), and hw_gettext().   hw_dummyUphw_Error
#

#T=int hw_edittext ( int connection, int hw_document)
hw_edittext ( ^!int connection, int hw_document);
#

#T=hw_Error - int hw_error ( int connection)
(PHP 3>= 3.0.3, PHP 4 )
hw_Error -- error number
Description
int hw_error ( int connection)
Returns the last error number. If the return value is 0 no error has 
occurred. The error relates to the last command.   hw_EditTextUphw_ErrorMsg
#

#T=int hw_error ( int connection)
hw_error ( ^!int connection);
#

#T=hw_ErrorMsg - string hw_errormsg ( int connection)
(PHP 3>= 3.0.3, PHP 4 )
hw_ErrorMsg -- returns error message
Description
string hw_errormsg ( int connection)
Returns a string containing the last error message or 'No Error'. If FALSE 
is returned, this function failed. The message relates to the last 
command.   hw_ErrorUphw_Free_Document
#

#T=string hw_errormsg ( int connection)
hw_errormsg ( ^!int connection);
#

#T=hw_Free_Document - int hw_free_document ( int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_Free_Document -- frees hw_document
Description
int hw_free_document ( int hw_document)
Frees the memory occupied by the Hyperwave document.   hw_ErrorMsgUphw_GetAnchors
#

#T=int hw_free_document ( int hw_document)
hw_free_document ( ^!int hw_document);
#

#T=hw_GetAnchors - array hw_getanchors ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetAnchors -- object ids of anchors of document
Description
array hw_getanchors ( int connection, int objectID)
Returns an array of object ids with anchors of the document with object ID 
objectID.   hw_Free_DocumentUphw_GetAnchorsObj
#

#T=array hw_getanchors ( int connection, int objectID)
hw_getanchors ( ^!int connection, int objectID);
#

#T=hw_GetAnchorsObj - array hw_getanchorsobj ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetAnchorsObj -- object records of anchors of document
Description
array hw_getanchorsobj ( int connection, int objectID)
Returns an array of object records with anchors of the document with 
object ID objectID.   hw_GetAnchorsUphw_GetAndLock
#

#T=array hw_getanchorsobj ( int connection, int objectID)
hw_getanchorsobj ( ^!int connection, int objectID);
#

#T=hw_GetAndLock - string hw_getandlock ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetAndLock -- return object record and lock object
Description
string hw_getandlock ( int connection, int objectID)
Returns the object record for the object with ID objectID. It will also 
lock the object, so other users cannot access it until it is unlocked. 
See also hw_unlock(), and hw_getobject().   hw_GetAnchorsObjUphw_GetChildColl
#

#T=string hw_getandlock ( int connection, int objectID)
hw_getandlock ( ^!int connection, int objectID);
#

#T=hw_GetChildColl - array hw_getchildcoll ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetChildColl -- object ids of child collections
Description
array hw_getchildcoll ( int connection, int objectID)
Returns an array of object ids. Each object ID belongs to a child 
collection of the collection with ID objectID. The function will not 
return child documents.
See also hw_children(), and hw_getchilddoccoll().   hw_GetAndLockUphw_GetChildCollObj
#

#T=array hw_getchildcoll ( int connection, int objectID)
hw_getchildcoll ( ^!int connection, int objectID);
#

#T=hw_GetChildCollObj - array hw_getchildcollobj ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetChildCollObj -- object records of child collections
Description
array hw_getchildcollobj ( int connection, int objectID)
Returns an array of object records. Each object records belongs to a child 
collection of the collection with ID objectID. The function will not 
return child documents. 
See also hw_childrenobj(), and hw_getchilddoccollobj().   hw_GetChildCollUphw_GetChildDocColl
#

#T=array hw_getchildcollobj ( int connection, int objectID)
hw_getchildcollobj ( ^!int connection, int objectID);
#

#T=hw_GetChildDocColl - array hw_getchilddoccoll ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetChildDocColl -- object ids of child documents of collection
Description
array hw_getchilddoccoll ( int connection, int objectID)
Returns array of object ids for child documents of a collection. 
See also hw_children(), and hw_getchildcoll().   hw_GetChildCollObjUphw_GetChildDocCollObj
#

#T=array hw_getchilddoccoll ( int connection, int objectID)
hw_getchilddoccoll ( ^!int connection, int objectID);
#

#T=hw_GetChildDocCollObj - array hw_getchilddoccollobj ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetChildDocCollObj -- object records of child documents of collection
Description
array hw_getchilddoccollobj ( int connection, int objectID)
Returns an array of object records for child documents of a collection.
See also hw_childrenobj(), and hw_getchildcollobj().   hw_GetChildDocCollUphw_GetObject
#

#T=array hw_getchilddoccollobj ( int connection, int objectID)
hw_getchilddoccollobj ( ^!int connection, int objectID);
#

#T=hw_GetObject - array hw_getobject ( int connection, mixed objectID, string query)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetObject -- object record
Description
array hw_getobject ( int connection, mixed objectID, string query)
Returns the object record for the object with ID objectID if the second 
parameter is an integer. If the second parameter is an array of integer 
the function will return an array of object records. In such a case the 
last parameter is also evaluated which is a query string. 
The query string has the following syntax:
<expr> ::= "(" <expr> ")" |
"!" <expr> | /* NOT */
<expr> "||" <expr> | /* OR */
<expr> "&&" <expr> | /* AND */
<attribute> <operator> <value>
<attribute> ::= /* any attribute name (Title, Author, DocumentType ...) */
<operator> ::= "=" | /* equal */
"<" | /* less than (string compare) */
">" | /* greater than (string compare) */
"~" /* regular expression matching */
The query allows to further select certain objects from the list of given 
objects. Unlike the other query functions, this query may use not indexed 
attributes. How many object records are returned depends on the query and 
if access to the object is allowed. 
See also hw_getandlock(), and hw_getobjectbyquery().   hw_GetChildDocCollObjUphw_GetObjectByQuery
#

#T=array hw_getobject ( int connection, mixed objectID, string query)
hw_getobject ( ^!int connection, mixed objectID, string query);
#

#T=hw_GetObjectByQuery - array hw_getobjectbyquery ( int connection, string query, int max_hits)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetObjectByQuery -- search object
Description
array hw_getobjectbyquery ( int connection, string query, int max_hits)
Searches for objects on the whole server and returns an array of object 
ids. The maximum number of matches is limited to max_hits. If max_hits is 
set to -1 the maximum number of matches is unlimited. 
The query will only work with indexed attributes. 
See also hw_getobjectbyqueryobj().   hw_GetObjectUphw_GetObjectByQueryColl
#

#T=array hw_getobjectbyquery ( int connection, string query, int max_hits)
hw_getobjectbyquery ( ^!int connection, string query, int max_hits);
#

#T=hw_GetObjectByQueryColl - array hw_getobjectbyquerycoll ( int connection, int objectID, string 
(PHP 3>= 3.0.3, PHP 4 )
hw_GetObjectByQueryColl -- search object in collection
Description
array hw_getobjectbyquerycoll ( int connection, int objectID, string 
query, int max_hits)
Searches for objects in collection with ID objectID and returns an array 
of object ids. The maximum number of matches is limited to max_hits. If 
max_hits is set to -1 the maximum number of matches is unlimited. 
The query will only work with indexed attributes.
See also hw_getobjectbyquerycollobj().   hw_GetObjectByQueryUphw_GetObjectByQueryCollObj
#

#T=array hw_getobjectbyquerycoll ( int connection, int objectID, string 
hw_getobjectbyquerycoll ( ^!int connection, int objectID, string ;
#

#T=hw_GetObjectByQueryCollObj - array hw_getobjectbyquerycollobj ( int connection, int objectID, string 
(PHP 3>= 3.0.3, PHP 4 )
hw_GetObjectByQueryCollObj -- search object in collection
Description
array hw_getobjectbyquerycollobj ( int connection, int objectID, string 
query, int max_hits)
Searches for objects in collection with ID objectID and returns an array 
of object records. The maximum number of matches is limited to max_hits. 
If max_hits is set to -1 the maximum number of matches is unlimited. 
The query will only work with indexed attributes. 
See also hw_getobjectbyquerycoll().   hw_GetObjectByQueryCollUphw_GetObjectByQueryObj
#

#T=array hw_getobjectbyquerycollobj ( int connection, int objectID, string 
hw_getobjectbyquerycollobj ( ^!int connection, int objectID, string ;
#

#T=hw_GetObjectByQueryObj - array hw_getobjectbyqueryobj ( int connection, string query, int max_hits)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetObjectByQueryObj -- search object
Description
array hw_getobjectbyqueryobj ( int connection, string query, int max_hits)
Searches for objects on the whole server and returns an array of object 
records. The maximum number of matches is limited to max_hits. If max_hits 
is set to -1 the maximum number of matches is unlimited. 
The query will only work with indexed attributes. 
See also hw_getobjectbyquery().   hw_GetObjectByQueryCollObjUphw_GetParents
#

#T=array hw_getobjectbyqueryobj ( int connection, string query, int max_hits)
hw_getobjectbyqueryobj ( ^!int connection, string query, int max_hits);
#

#T=hw_GetParents - array hw_getparents ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetParents -- object ids of parents
Description
array hw_getparents ( int connection, int objectID)
Returns an indexed array of object ids. Each object id belongs to a parent 
of the object with ID objectID.   hw_GetObjectByQueryObjUphw_GetParentsObj
#

#T=array hw_getparents ( int connection, int objectID)
hw_getparents ( ^!int connection, int objectID);
#

#T=hw_GetParentsObj - array hw_getparentsobj ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetParentsObj -- object records of parents
Description
array hw_getparentsobj ( int connection, int objectID)
Returns an indexed array of object records plus an associated array with 
statistical information about the object records. The associated array is 
the last entry of the returned array. Each object record belongs to a 
parent of the object with ID objectID.   hw_GetParentsUphw_getrellink
#

#T=array hw_getparentsobj ( int connection, int objectID)
hw_getparentsobj ( ^!int connection, int objectID);
#

#T=hw_getrellink - string hw_getrellink ( int link, int rootid, int sourceid, int destid)
(PHP 3>= 3.0.3, PHP 4 )
hw_getrellink --  Get link from source to dest relative to rootid 
Description
string hw_getrellink ( int link, int rootid, int sourceid, int destid)
Warning
This function is currently not documented; only the argument list is 
available.
  hw_GetParentsObjUphw_GetRemote
#

#T=string hw_getrellink ( int link, int rootid, int sourceid, int destid)
hw_getrellink ( ^!int link, int rootid, int sourceid, int destid);
#

#T=hw_GetRemote - int hw_getremote ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetRemote -- Gets a remote document
Description
int hw_getremote ( int connection, int objectID)
Returns a remote document. Remote documents in Hyperwave notation are 
documents retrieved from an external source. Common remote documents are 
for example external web pages or queries in a database. In order to be 
able to access external sources through remote documents Hyperwave 
introduces the HGI (Hyperwave Gateway Interface) which is similar to the 
CGI. Currently, only ftp, http-servers and some databases can be accessed 
by the HGI. Calling hw_getremote() returns the document from the external 
source. If you want to use this function you should be very familiar with 
HGIs. You should also consider to use PHP instead of Hyperwave to access 
external sources. Adding database support by a Hyperwave gateway should be 
more difficult than doing it in PHP. 
See also hw_getremotechildren().   hw_getrellinkUphw_getremotechildren
#

#T=int hw_getremote ( int connection, int objectID)
hw_getremote ( ^!int connection, int objectID);
#

#T=hw_getremotechildren - int hw_getremotechildren ( int connection, string object_record)
(PHP 3>= 3.0.3, PHP 4 )
hw_getremotechildren -- Gets children of remote document
Description
int hw_getremotechildren ( int connection, string object_record)
Returns the children of a remote document. Children of a remote document 
are remote documents itself. This makes sense if a database query has to 
be narrowed and is explained in Hyperwave Programmers' Guide. If the 
number of children is 1 the function will return the document itself 
formated by the Hyperwave Gateway Interface (HGI). If the number of 
children is greater than 1 it will return an array of object record with 
each maybe the input value for another call to hw_getremotechildren(). 
Those object records are virtual and do not exist in the Hyperwave server, 
therefore they do not have a valid object ID. How exactly such an object 
record looks like is up to the HGI. If you want to use this function you 
should be very familiar with HGIs. You should also consider to use PHP 
instead of Hyperwave to access external sources. Adding database support 
by a Hyperwave gateway should be more difficult than doing it in PHP. 
See also hw_getremote().   hw_GetRemoteUphw_GetSrcByDestObj
#

#T=int hw_getremotechildren ( int connection, string object_record)
hw_getremotechildren ( ^!int connection, string object_record);
#

#T=hw_GetSrcByDestObj - array hw_getsrcbydestobj ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_GetSrcByDestObj -- Returns anchors pointing at object
Description
array hw_getsrcbydestobj ( int connection, int objectID)
Returns the object records of all anchors pointing to the object with ID 
objectID. The object can either be a document or an anchor of type 
destination.
See also hw_getanchors().   hw_getremotechildrenUphw_GetText
#

#T=array hw_getsrcbydestobj ( int connection, int objectID)
hw_getsrcbydestobj ( ^!int connection, int objectID);
#

#T=hw_GetText - int hw_gettext ( int connection, int objectID [, mixed rootID/prefix])
(PHP 3>= 3.0.3, PHP 4 )
hw_GetText -- retrieve text document
Description
int hw_gettext ( int connection, int objectID [, mixed rootID/prefix])
Returns the document with object ID objectID. If the document has anchors 
which can be inserted, they will be inserted already. The optional 
parameter rootID/prefix can be a string or an integer. If it is an integer 
it determines how links are inserted into the document. The default is 0 
and will result in links that are constructed from the name of the link's 
destination object. This is useful for web applications. If a link points 
to an object with name 'internet_movie' the HTML link will be <A 
HREF="/internet_movie">. The actual location of the source and destination 
object in the document hierarchy is disregarded. You will have to set up 
your web browser, to rewrite that URL to for example 
'/my_script.php3/internet_movie'. 'my_script.php3' will have to evaluate 
$PATH_INFO and retrieve the document. All links will have the prefix 
'/my_script.php3/'. If you do not want this you can set the optional 
parameter rootID/prefix to any prefix which is used instead. Is this case 
it has to be a string. 
If rootID/prefix is an integer and unequal to 0 the link is constructed 
from all the names starting at the object with the id rootID/prefix 
separated by a slash relative to the current object. If for example the 
above document 'internet_movie' is located at 'a-b-c-internet_movie' with 
'-' being the separator between hierarchy levels on the Hyperwave server 
and the source document is located at 'a-b-d-source' the resulting HTML 
link would be: <A HREF="../c/internet_movie">. This is useful if you want 
to download the whole server content onto disk and map the document 
hierarchy onto the file system. 
This function will only work for pure text documents. It will not open a 
special data connection and therefore blocks the control connection during 
the transfer. 
See also hw_pipedocument(), hw_free_document(), hw_document_bodytag(), 
hw_document_size(), and hw_output_document().   hw_GetSrcByDestObjUphw_getusername
#

#T=int hw_gettext ( int connection, int objectID [, mixed rootID/prefix])
hw_gettext ( ^!int connection, int objectID [, mixed rootID/prefix]);
#

#T=hw_getusername - string hw_getusername ( int connection)
(PHP 3>= 3.0.3, PHP 4 )
hw_getusername -- name of currently logged in user
Description
string hw_getusername ( int connection)
Returns the username of the connection.   hw_GetTextUphw_Identify
#

#T=string hw_getusername ( int connection)
hw_getusername ( ^!int connection);
#

#T=hw_Identify - int hw_identify ( string username, string password)
(PHP 3>= 3.0.3, PHP 4 )
hw_Identify -- identifies as user
Description
int hw_identify ( string username, string password)
Identifies as user with username and password. Identification is only 
valid for the current session. I do not thing this function will be needed 
very often. In most cases it will be easier to identify with the opening 
of the connection. 
See also hw_connect().   hw_getusernameUphw_InCollections
#

#T=int hw_identify ( string username, string password)
hw_identify ( ^!string username, string password);
#

#T=hw_InCollections - array hw_incollections ( int connection, array object_id_array, array 
(PHP 3>= 3.0.3, PHP 4 )
hw_InCollections -- check if object ids in collections
Description
array hw_incollections ( int connection, array object_id_array, array 
collection_id_array, int return_collections)
Checks whether a set of objects (documents or collections) specified by 
the object_id_array is part of the collections listed in 
collection_id_array. When the fourth parameter return_collections is 0, 
the subset of object ids that is part of the collections (i.e., the 
documents or collections that are children of one or more collections of 
collection ids or their subcollections, recursively) is returned as an 
array. When the fourth parameter is 1, however, the set of collections 
that have one or more objects of this subset as children are returned as 
an array. This option allows a client to, e.g., highlight the part of the 
collection hierarchy that contains the matches of a previous query, in a 
graphical overview.   hw_IdentifyUphw_Info
#

#T=array hw_incollections ( int connection, array object_id_array, array 
hw_incollections ( ^!int connection, array object_id_array, array ;
#

#T=hw_Info - string hw_info ( int connection)
(PHP 3>= 3.0.3, PHP 4 )
hw_Info -- info about connection
Description
string hw_info ( int connection)
Returns information about the current connection. The returned string has 
the following format: <Serverstring>, <Host>, <Port>, <Username>, <Port of 
Client>, <Byte swapping>   hw_InCollectionsUphw_InsColl
#

#T=string hw_info ( int connection)
hw_info ( ^!int connection);
#

#T=hw_InsColl - int hw_inscoll ( int connection, int objectID, array object_array)
(PHP 3>= 3.0.3, PHP 4 )
hw_InsColl -- insert collection
Description
int hw_inscoll ( int connection, int objectID, array object_array)
Inserts a new collection with attributes as in object_array into 
collection with object ID objectID.   hw_InfoUphw_InsDoc
#

#T=int hw_inscoll ( int connection, int objectID, array object_array)
hw_inscoll ( ^!int connection, int objectID, array object_array);
#

#T=hw_InsDoc - int hw_insdoc ( int connection, int parentID, string object_record, string 
(PHP 3>= 3.0.3, PHP 4 )
hw_InsDoc -- insert document
Description
int hw_insdoc ( int connection, int parentID, string object_record, string 
text)
Inserts a new document with attributes as in object_record into collection 
with object ID parentID. This function inserts either an object record 
only or an object record and a pure ascii text in text if text is given. 
If you want to insert a general document of any kind use 
hw_insertdocument() instead. 
See also hw_insertdocument(), and hw_inscoll().   hw_InsCollUphw_insertanchors
#

#T=int hw_insdoc ( int connection, int parentID, string object_record, string 
hw_insdoc ( ^!int connection, int parentID, string object_record, string ;
#

#T=hw_insertanchors - string hw_insertanchors ( int hwdoc, array anchorecs, array dest [, array 
(PHP 4 >= 4.0.4)
hw_insertanchors --  Inserts only anchors into text 
Description
string hw_insertanchors ( int hwdoc, array anchorecs, array dest [, array 
urlprefixes])
Warning
This function is currently not documented; only the argument list is 
available.
  hw_InsDocUphw_InsertDocument
#

#T=string hw_insertanchors ( int hwdoc, array anchorecs, array dest [, array 
hw_insertanchors ( ^!int hwdoc, array anchorecs, array dest [, array ;
#

#T=hw_InsertDocument - int hw_insertdocument ( int connection, int parent_id, int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_InsertDocument -- upload any document
Description
int hw_insertdocument ( int connection, int parent_id, int hw_document)
Uploads a document into the collection with parent_id. The document has to 
be created before with hw_new_document(). Make sure that the object record 
of the new document contains at least the attributes: Type, DocumentType, 
Title and Name. Possibly you also want to set the MimeType. The functions 
returns the object id of the new document or FALSE. 
See also hw_pipedocument().   hw_insertanchorsUphw_InsertObject
#

#T=int hw_insertdocument ( int connection, int parent_id, int hw_document)
hw_insertdocument ( ^!int connection, int parent_id, int hw_document);
#

#T=hw_InsertObject - int hw_insertobject ( int connection, string object_rec, string parameter)
(PHP 3>= 3.0.3, PHP 4 )
hw_InsertObject -- inserts an object record
Description
int hw_insertobject ( int connection, string object_rec, string parameter)
Inserts an object into the server. The object can be any valid hyperwave 
object. See the HG-CSP documentation for a detailed information on how the 
parameters have to be. 
Note: If you want to insert an Anchor, the attribute Position has always 
been set either to a start/end value or to 'invisible'. Invisible 
positions are needed if the annotation has no corresponding link in the 
annotation text. 
See also hw_pipedocument(), hw_insertdocument(), hw_insdoc(), and 
hw_inscoll().   hw_InsertDocumentUphw_mapid
#

#T=int hw_insertobject ( int connection, string object_rec, string parameter)
hw_insertobject ( ^!int connection, string object_rec, string parameter);
#

#T=hw_mapid - int hw_mapid ( int connection, int server_id, int object_id)
(PHP 3>= 3.0.13, PHP 4 )
hw_mapid -- Maps global id on virtual local id
Description
int hw_mapid ( int connection, int server_id, int object_id)
Maps a global object id on any hyperwave server, even those you did not 
connect to with hw_connect(), onto a virtual object id. This virtual 
object id can then be used as any other object id, e.g. to obtain the 
object record with hw_getobject(). The server id is the first part of the 
global object id (GOid) of the object which is actually the IP number as 
an integer. 
Note: In order to use this function you will have to set the F_DISTRIBUTED 
flag, which can currently only be set at compile time in hg_comm.c. It is 
not set by default. Read the comment at the beginning of hg_comm.c   hw_InsertObjectUphw_Modifyobject
#

#T=int hw_mapid ( int connection, int server_id, int object_id)
hw_mapid ( ^!int connection, int server_id, int object_id);
#

#T=hw_Modifyobject - int hw_modifyobject ( int connection, int object_to_change, array remove, 
(PHP 3>= 3.0.7, PHP 4 )
hw_Modifyobject -- modifies object record
Description
int hw_modifyobject ( int connection, int object_to_change, array remove, 
array add, int mode)
This command allows to remove, add, or modify individual attributes of an 
object record. The object is specified by the Object ID object_to_change. 
The first array remove is a list of attributes to remove. The second array 
add is a list of attributes to add. In order to modify an attribute one 
will have to remove the old one and add a new one. hw_modifyobject() will 
always remove the attributes before it adds attributes unless the value of 
the attribute to remove is not a string or array. 
The last parameter determines if the modification is performed 
recursively. 1 means recursive modification. If some of the objects cannot 
be modified they will be skipped without notice. hw_error() may not 
indicate an error though some of the objects could not be modified. 
The keys of both arrays are the attributes name. The value of each array 
element can either be an array, a string or anything else. If it is an 
array each attribute value is constructed by the key of each element plus 
a colon and the value of each element. If it is a string it is taken as 
the attribute value. An empty string will result in a complete removal of 
that attribute. If the value is neither a string nor an array but 
something else, e.g. an integer, no operation at all will be performed on 
the attribute. This is necessary if you want to to add a completely new 
attribute not just a new value for an existing attribute. If the remove 
array contained an empty string for that attribute, the attribute would be 
tried to be removed which would fail since it doesn't exist. The following 
addition of a new value for that attribute would also fail. Setting the 
value for that attribute to e.g. 0 would not even try to remove it and the 
addition will work. 
If you would like to change the attribute 'Name' with the current value 
'books' into 'articles' you will have to create two arrays and call 
hw_modifyobject(). Example 1. modifying an attribute
  <?php
	 // $connect is an existing connection to the Hyperwave 
  server
	 // $objid is the ID of the object to modify
	 $remarr = array("Name" => "books");
	 $addarr = array("Name" => "articles");
	 $hw_modifyobject($connect, $objid, $remarr, $addarr);
  ?> 

In order to delete/add a name=value pair from/to the object record just 
pass the remove/add array and set the last/third parameter to an empty 
array. If the attribute is the first one with that name to add, set 
attribute value in the remove array to an integer. Example 2. adding 
a completely new attribute
  <?php
	 // $connect is an existing connection to the Hyperwave 
  server
	 // $objid is the ID of the object to modify
	 $remarr = array("Name" => 0);
	 $addarr = array("Name" => "articles");
	 $hw_modifyobject($connect, $objid, $remarr, $addarr);
  ?> 
Note: Multilingual attributes, e.g. 'Title', can be modified in two 
ways. Either by providing the attributes value in its native form 
'language':'title' or by providing an array with elements for each 
language as described above. The above example would than be: 
Example 3. modifying Title attribute
  <?php
	 $remarr = array("Title" => "en:Books");
	 $addarr = array("Title" => "en:Articles");
	 $hw_modifyobject($connect, $objid, $remarr, $addarr);
  ?> 

or Example 4. modifying Title attribute
  <?php
	 $remarr = array("Title" => array("en" => "Books"));
	 $addarr = array("Title" => array("en" => "Articles", 
  "ge"=>"Artikel"));
	 $hw_modifyobject($connect, $objid, $remarr, $addarr);
  ?> 

This removes the English title 'Books' and adds the English title 
'Articles' and the German title 'Artikel'. Example 5. removing 
attribute
  <?php
	 $remarr = array("Title" => "");
	 $addarr = array("Title" => "en:Articles");
	 $hw_modifyobject($connect, $objid, $remarr, $addarr);
  ?> 
Note: This will remove all attributes with the name 'Title' and adds a 
new 'Title' attribute. This comes in handy if you want to remove 
attributes recursively. 
Note: If you need to delete all attributes with a certain name you will 
have to pass an empty string as the attribute value. 
Note: Only the attributes 'Title', 'Description' and 'Keyword' will 
properly handle the language prefix. If those attributes don't carry a 
language prefix, the prefix 'xx' will be assigned. 
Note: The 'Name' attribute is somewhat special. In some cases it cannot 
be complete removed. You will get an error message 'Change of base 
attribute' (not clear when this happens). Therefore you will always have 
to add a new Name first and than remove the old one. 
Note: You may not surround this function by calls to hw_getandlock() and 
hw_unlock(). hw_modifyobject() does this internally. 
Returns TRUE on success or FALSE on failure.   hw_mapidUphw_mv
#

#T=int hw_modifyobject ( int connection, int object_to_change, array remove, 
hw_modifyobject ( ^!int connection, int object_to_change, array remove, ;
#

#T=hw_mv - int hw_mv ( int connection, array object_id_array, int source_id, int 
(PHP 3>= 3.0.3, PHP 4 )
hw_mv -- Moves objects
Description
int hw_mv ( int connection, array object_id_array, int source_id, int 
destination_id)
Moves the objects with object ids as specified in the second parameter 
from the collection with id source_id to the collection with the id 
destination_id. If the destination id is 0 the objects will be unlinked 
from the source collection. If this is the last instance of that object it 
will be deleted. If you want to delete all instances at once, use 
hw_deleteobject(). 
The value returned is the number of moved objects. 
See also hw_cp(), and hw_deleteobject().   hw_ModifyobjectUphw_New_Document
#

#T=int hw_mv ( int connection, array object_id_array, int source_id, int 
hw_mv ( ^!int connection, array object_id_array, int source_id, int ;
#

#T=hw_New_Document - int hw_new_document ( string object_record, string document_data, int 
(PHP 3>= 3.0.3, PHP 4 )
hw_New_Document -- create new document
Description
int hw_new_document ( string object_record, string document_data, int 
document_size)
Returns a new Hyperwave document with document data set to document_data 
and object record set to object_record. The length of the document_data 
has to passed in document_sizeThis function does not insert the document 
into the Hyperwave server. 
See also hw_free_document(), hw_document_size(), hw_document_bodytag(), 
hw_output_document(), and hw_insertdocument().   hw_mvUphw_objrec2array
#

#T=int hw_new_document ( string object_record, string document_data, int 
hw_new_document ( ^!string object_record, string document_data, int ;
#

#T=hw_objrec2array - array hw_objrec2array ( string object_record [, array format])
(PHP 3>= 3.0.3, PHP 4 )
hw_objrec2array -- Convert attributes from object record to object array
Description
array hw_objrec2array ( string object_record [, array format])
Converts an object_record into an object array. The keys of the resulting 
array are the attributes names. Multi-value attributes like 'Title' in 
different languages form its own array. The keys of this array are the 
left part to the colon of the attribute value. This left part must be two 
characters long. Other multi-value attributes without a prefix form an 
indexed array. If the optional parameter is missing the attributes 
'Title', 'Description' and 'Keyword' are treated as language attributes 
and the attributes 'Group', 'Parent' and 'HtmlAttr' as non-prefixed 
multi-value attributes. By passing an array holding the type for each 
attribute you can alter this behaviour. The array is an associated array 
with the attribute name as its key and the value being one of HW_ATTR_LANG 
or HW_ATTR_NONE. 
See also hw_array2objrec().   hw_New_DocumentUphw_Output_Document
#

#T=array hw_objrec2array ( string object_record [, array format])
hw_objrec2array ( ^!string object_record [, array format]);
#

#T=hw_Output_Document - int hw_output_document ( int hw_document)
(PHP 3>= 3.0.3, PHP 4 )
hw_Output_Document -- prints hw_document
Description
int hw_output_document ( int hw_document)
Prints the document without the BODY tag. 
For backward compatibility, hw_outputdocument() is also accepted. This is 
deprecated, however.   hw_objrec2arrayUphw_pConnect
#

#T=int hw_output_document ( int hw_document)
hw_output_document ( ^!int hw_document);
#

#T=hw_pConnect - int hw_pconnect ( string host, int port, string username, string password)
(PHP 3>= 3.0.3, PHP 4 )
hw_pConnect -- make a persistent database connection
Description
int hw_pconnect ( string host, int port, string username, string password)
Returns a connection index on success, or FALSE if the connection could 
not be made. Opens a persistent connection to a Hyperwave server. Each of 
the arguments should be a quoted string, except for the port number. The 
username and password arguments are optional and can be left out. In such 
a case no identification with the server will be done. It is similar to 
identify as user anonymous. This function returns a connection index that 
is needed by other Hyperwave functions. You can have multiple persistent 
connections open at once.
See also hw_connect().   hw_Output_DocumentUphw_PipeDocument
#

#T=int hw_pconnect ( string host, int port, string username, string password)
hw_pconnect ( ^!string host, int port, string username, string password);
#

#T=hw_PipeDocument - int hw_pipedocument ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_PipeDocument -- retrieve any document
Description
int hw_pipedocument ( int connection, int objectID)
Returns the Hyperwave document with object ID objectID. If the document 
has anchors which can be inserted, they will have been inserted already. 
The document will be transferred via a special data connection which does 
not block the control connection.
See also hw_gettext() for more on link insertion, hw_free_document(), 
hw_document_size(), hw_document_bodytag(), and hw_output_document().   hw_pConnectUphw_Root
#

#T=int hw_pipedocument ( int connection, int objectID)
hw_pipedocument ( ^!int connection, int objectID);
#

#T=hw_Root - int hw_root ( )
(PHP 3>= 3.0.3, PHP 4 )
hw_Root -- root object id
Description
int hw_root ( )
Returns the object ID of the hyperroot collection. Currently this is 
always 0. The child collection of the hyperroot is the root collection of 
the connected server.   hw_PipeDocumentUphw_setlinkroot
#

#T=int hw_root ( )
hw_root ( ^!);
#

#T=hw_setlinkroot - void hw_setlinkroot ( int link, int rootid)
(PHP 3>= 3.0.3, PHP 4 )
hw_setlinkroot --  Set the id to which links are calculated 
Description
void hw_setlinkroot ( int link, int rootid)
Warning
This function is currently not documented; only the argument list is 
available.
  hw_RootUphw_stat
#

#T=void hw_setlinkroot ( int link, int rootid)
hw_setlinkroot ( ^!int link, int rootid);
#

#T=hw_stat - string hw_stat ( int link)
(PHP 3>= 3.0.3, PHP 4 )
hw_stat --  Returns status string 
Description
string hw_stat ( int link)
Warning
This function is currently not documented; only the argument list is 
available.
  hw_setlinkrootUphw_Unlock
#

#T=string hw_stat ( int link)
hw_stat ( ^!int link);
#

#T=hw_Unlock - int hw_unlock ( int connection, int objectID)
(PHP 3>= 3.0.3, PHP 4 )
hw_Unlock -- unlock object
Description
int hw_unlock ( int connection, int objectID)
Unlocks a document, so other users regain access. 
See also hw_getandlock().   hw_statUphw_Who
#

#T=int hw_unlock ( int connection, int objectID)
hw_unlock ( ^!int connection, int objectID);
#

#T=hw_Who - int hw_who ( int connection)
(PHP 3>= 3.0.3, PHP 4 )
hw_Who -- List of currently logged in users
Description
int hw_who ( int connection)
Returns an array of users currently logged into the Hyperwave server. Each 
entry in this array is an array itself containing the elements id, name, 
system, onSinceDate, onSinceTime, TotalTime and self. 'self' is 1 if this 
entry belongs to the user who initiated the request.   hw_UnlockUpHyperwave API functions
hw_api_attribute->key
(no version information, might be only in CVS)
hw_api_attribute->key -- Returns key of the attribute
Description
string key ( void )
Returns the name of the attribute. 
See also hwapi_attribute_value().   Hyperwave API functionsUphw_api_attribute->langdepvalue
hw_api_attribute->langdepvalue
(no version information, might be only in CVS)
hw_api_attribute->langdepvalue -- Returns value for a given language
Description
string langdepvalue ( string language)
Returns the value in the given language of the attribute. 
See also hwapi_attribute_value().   hw_api_attribute->keyUphw_api_attribute->value
hw_api_attribute->value
(no version information, might be only in CVS)
hw_api_attribute->value -- Returns value of the attribute
Description
string value ( void )
Returns the value of the attribute. 
See also hwapi_attribute_key(), hwapi_attribute_values().   hw_api_attribute->langdepvalueUphw_api_attribute->values
hw_api_attribute->values
(no version information, might be only in CVS)
hw_api_attribute->values -- Returns all values of the attribute
Description
array values ( void )
Returns all values of the attribute as an array of strings. 
See also hwapi_attribute_value().   hw_api_attribute->valueUphw_api_attribute
hw_api_attribute
(no version information, might be only in CVS)
hw_api_attribute -- Creates instance of class hw_api_attribute
Description
object attribute ( [string name [, string value]])
Creates a new instance of hw_api_attribute with the given name and value.   hw_api_attribute->valuesUphw_api->checkin
hw_api->checkin
(no version information, might be only in CVS)
hw_api->checkin -- Checks in an object
Description
object checkin ( array parameter)
This function checks in an object or a whole hiearchie of objects. The 
parameters array contains the required element 'objectIdentifier' and the 
optional element 'version', 'comment', 'mode' and 'objectQuery'. 'version' 
sets the version of the object. It consists of the major and minor version 
separated by a period. If the version is not set, the minor version is 
incremented. 'mode' can be one of the following values: 
HW_API_CHECKIN_NORMAL
Checks in and commits the object. The object must be a document. 
HW_API_CHECKIN_RECURSIVE
If the object to check in is a collection, all children will be checked 
in recursively if they are documents. Trying to check in a collection 
would result in an error. 
HW_API_CHECKIN_FORCE_VERSION_CONTROL
Checks in an object even if it is not under version control. 
HW_API_CHECKIN_REVERT_IF_NOT_CHANGED
Check if the new version is different from the last version. Unless this 
is the case the object will be checked in. 
HW_API_CHECKIN_KEEP_TIME_MODIFIED
Keeps the time modified from the most recent object. 
HW_API_CHECKIN_NO_AUTO_COMMIT
The object is not automatically committed on check-in. 
See also hwapi_checkout().   hw_api_attributeUphw_api->checkout
hw_api->checkout
(no version information, might be only in CVS)
hw_api->checkout -- Checks out an object
Description
object checkout ( array parameter)
This function checks out an object or a whole hiearchie of objects. The 
parameters array contains the required element 'objectIdentifier' and the 
optional element 'version', 'mode' and 'objectQuery'. 'mode' can be one of 
the following values: 
HW_API_CHECKIN_NORMAL
Checks out an object. The object must be a document. 
HW_API_CHECKIN_RECURSIVE
If the object to check out is a collection, all children will be checked 
out recursively if they are documents. Trying to check out a collection 
would result in an error. 
See also hwapi_checkin().   hw_api->checkinUphw_api->children
hw_api->children
(no version information, might be only in CVS)
hw_api->children -- Returns children of an object
Description
array children ( array parameter)
Retrieves the children of a collection or the attributes of a document. 
The children can be further filtered by specifying an object query. The 
parameter array contains the required elements 'objectIdentifier' and the 
optional elements 'attributeSelector' and 'objectQuery'. 
The return value is an array of objects of type HW_API_Object or 
HW_API_Error. 
See also hwapi_parents().   hw_api->checkoutUphw_api_content->mimetype
hw_api_content->mimetype
(no version information, might be only in CVS)
hw_api_content->mimetype -- Returns mimetype
Description
string mimetype ( void )
Returns the mimetype of the content.   hw_api->childrenUphw_api_content->read
hw_api_content->read
(no version information, might be only in CVS)
hw_api_content->read -- Read content
Description
string read ( string buffer, integer len)
Reads len bytes from the content into the given buffer.   hw_api_content->mimetypeUphw_api->content
hw_api->content
(no version information, might be only in CVS)
hw_api->content -- Returns content of an object
Description
object content ( array parameter)
This function returns the content of a document as an object of type 
hw_api_content. The parameter array contains the required elements 
'objectidentifier' and the optional element 'mode'. The mode can be one of 
the constants HW_API_CONTENT_ALLLINKS, HW_API_CONTENT_REACHABLELINKS or 
HW_API_CONTENT_PLAIN. HW_API_CONTENT_ALLLINKS means to insert all anchors 
even if the destination is not reachable. HW_API_CONTENT_REACHABLELINKS 
tells hw_api_content() to insert only reachable links and 
HW_API_CONTENT_PLAIN will lead to document without any links.   hw_api_content->readUphw_api->copy
hw_api->copy
(no version information, might be only in CVS)
hw_api->copy -- Copies physically
Description
object copy ( array parameter)
This function will make a physical copy including the content if it exists 
and returns the new object or an error object. The parameter array 
contains the required elements 'objectIdentifier' and 
'destinationParentIdentifier'. The optional parameter is 
'attributeSelector'` 
See also hwapi_move(), hwapi_link().   hw_api->contentUphw_api->dbstat
hw_api->dbstat
(no version information, might be only in CVS)
hw_api->dbstat -- Returns statistics about database server
Description
object dbstat ( array parameter)
See also hwapi_dcstat(), hwapi_hwstat(), hwapi_ftstat().   hw_api->copyUphw_api->dcstat
hw_api->dcstat
(no version information, might be only in CVS)
hw_api->dcstat -- Returns statistics about document cache server
Description
object dcstat ( array parameter)
See also hwapi_hwstat(), hwapi_dbstat(), hwapi_ftstat().   hw_api->dbstatUphw_api->dstanchors
hw_api->dstanchors
(no version information, might be only in CVS)
hw_api->dstanchors -- Returns a list of all destination anchors
Description
object dstanchors ( array parameter)
Retrieves all destination anchors of an object. The parameter array 
contains the required element 'objectIdentifier' and the optional elements 
'attributeSelector' and 'objectQuery'. 
See also hwapi_srcanchors().   hw_api->dcstatUphw_api->dstofsrcanchors
hw_api->dstofsrcanchors
(no version information, might be only in CVS)
hw_api->dstofsrcanchors -- Returns destination of a source anchor
Description
object dstofsrcanchors ( array parameter)
Retrieves the destination object pointed by the specified source anchors. 
The destination object can either be a destination anchor or a whole 
document. The parameters array contains the required element 
'objectIdentifier' and the optional element 'attributeSelector'. 
See also hwapi_srcanchors(), hwapi_dstanchors(), hwapi_objectbyanchor().   hw_api->dstanchorsUphw_api_error->count
hw_api_error->count
(no version information, might be only in CVS)
hw_api_error->count -- Returns number of reasons
Description
int count ( void )
Returns the number of error reasons. 
See also hwapi_error_reason().   hw_api->dstofsrcanchorsUphw_api_error->reason
hw_api_error->reason
(no version information, might be only in CVS)
hw_api_error->reason -- Returns reason of error
Description
object reason ( void )
Returns the first error reason. 
See also hwapi_error_count().   hw_api_error->countUphw_api->find
hw_api->find
(no version information, might be only in CVS)
hw_api->find -- Search for objects
Description
array find ( array parameter)
This functions searches for objects either by executing a key or/and full 
text query. The found objects can further be filtered by an optional 
object query. They are sorted by their importance. The second search 
operation is relatively slow and its result can be limited to a certain 
number of hits. This allows to perform an incremental search, each 
returning just a subset of all found documents, starting at a given index. 
The parameter array contains the 'keyquery' or/and 'fulltextquery' 
depending on who you would like to search. Optional parameters are 
'objectquery', 'scope', 'languages' and 'attributeselector'. In case of an 
incremental search the optional parameters 'startIndex', 
numberOfObjectsToGet' and 'exactMatchUnit' can be passed.   hw_api_error->reasonUphw_api->ftstat
hw_api->ftstat
(no version information, might be only in CVS)
hw_api->ftstat -- Returns statistics about fulltext server
Description
object ftstat ( array parameter)
See also hwapi_dcstat(), hwapi_dbstat(), hwapi_hwstat().   hw_api->findUphwapi_hgcsp
hwapi_hgcsp
(no version information, might be only in CVS)
hwapi_hgcsp -- Returns object of class hw_api
Description
object hwapi_hgcsp ( string hostname [, int port])
Opens a connection to the Hyperwave server on host hostname. The protocol 
used is HGCSP. If you do not pass a port number, 418 is used. 
See also hwapi_hwtp().   hw_api->ftstatUphw_api->hwstat
hw_api->hwstat
(no version information, might be only in CVS)
hw_api->hwstat -- Returns statistics about Hyperwave server
Description
object hwstat ( array parameter)
See also hwapi_dcstat(), hwapi_dbstat(), hwapi_ftstat().   hwapi_hgcspUphw_api->identify
hw_api->identify
(no version information, might be only in CVS)
hw_api->identify -- Log into Hyperwave Server
Description
object identify ( array parameter)
Logs into the Hyperwave Server. The parameter array must contain the 
elements 'username' and 'password'. 
The return value will be an object of type HW_API_Error if identification 
failed or TRUE if it was successful.   hw_api->hwstatUphw_api->info
hw_api->info
(no version information, might be only in CVS)
hw_api->info -- Returns information about server configuration
Description
object info ( array parameter)
See also hwapi_dcstat(), hwapi_dbstat(), hwapi_ftstat(), hwapi_hwstat().   hw_api->identifyUphw_api->insert
hw_api->insert
(no version information, might be only in CVS)
hw_api->insert -- Inserts a new object
Description
object insert ( array parameter)
Insert a new object. The object type can be user, group, document or 
anchor. Depending on the type other object attributes has to be set. The 
parameter array contains the required elements 'object' and 'content' (if 
the object is a document) and the optional parameters 'parameters', 'mode' 
and 'attributeSelector'. The 'object' must contain all attributes of the 
object. 'parameters' is an object as well holding further attributes like 
the destination (attribute key is 'Parent'). 'content' is the content of 
the document. 'mode' can be a combination of the following flags: 
HW_API_INSERT_NORMAL
The object in inserted into the server. 
HW_API_INSERT_FORCE_VERSION_CONTROL
HW_API_INSERT_AUTOMATIC_CHECKOUT
HW_API_INSERT_PLAIN
HW_API_INSERT_KEEP_TIME_MODIFIED
HW_API_INSERT_DELAY_INDEXING
See also hwapi_replace().   hw_api->infoUphw_api->insertanchor
hw_api->insertanchor
(no version information, might be only in CVS)
hw_api->insertanchor -- Inserts a new object of type anchor
Description
object insertanchor ( array parameter)
This function is a shortcut for hwapi_insert(). It inserts an object of 
type anchor and sets some of the attributes required for an anchor. The 
parameter array contains the required elements 'object' and 
'documentIdentifier' and the optional elements 'destinationIdentifier', 
'parameter', 'hint' and 'attributeSelector'. The 'documentIdentifier' 
specifies the document where the anchor shall be inserted. The target of 
the anchor is set in 'destinationIdentifier' if it already exists. If the 
target does not exists the element 'hint' has to be set to the name of 
object which is supposed to be inserted later. Once it is inserted the 
anchor target is resolved automatically. 
See also hwapi_insertdocument(), hwapi_insertcollection(), hwapi_insert(). 
  hw_api->insertUphw_api->insertcollection
hw_api->insertcollection
(no version information, might be only in CVS)
hw_api->insertcollection -- Inserts a new object of type collection
Description
object insertcollection ( array parameter)
This function is a shortcut for hwapi_insert(). It inserts an object of 
type collection and sets some of the attributes required for a collection. 
The parameter array contains the required elements 'object' and 
'parentIdentifier' and the optional elements 'parameter' and 
'attributeSelector'. See hwapi_insert() for the meaning of each element. 
See also hwapi_insertdocument(), hwapi_insertanchor(), hwapi_insert().   hw_api->insertanchorUphw_api->insertdocument
hw_api->insertdocument
(no version information, might be only in CVS)
hw_api->insertdocument -- Inserts a new object of type document
Description
object insertdocument ( array parameter)
This function is a shortcut for hwapi_insert(). It inserts an object with 
content and sets some of the attributes required for a document. The 
parameter array contains the required elements 'object', 
'parentIdentifier' and 'content' and the optional elements 'mode', 
'parameter' and 'attributeSelector'. See hwapi_insert() for the meaning of 
each element. 
See also hwapi_insert() hwapi_insertanchor(), hwapi_insertcollection().   hw_api->insertcollectionUphw_api->link
hw_api->link
(no version information, might be only in CVS)
hw_api->link -- Creates a link to an object
Description
object link ( array parameter)
Creates a link to an object. Accessing this link is like accessing the 
object to links points to. The parameter array contains the required 
elements 'objectIdentifier' and 'destinationParentIdentifier'. 
'destinationParentIdentifier' is the target collection. 
The function returns TRUE on success or an error object. 
See also hwapi_copy().   hw_api->insertdocumentUphw_api->lock
hw_api->lock
(no version information, might be only in CVS)
hw_api->lock -- Locks an object
Description
object lock ( array parameter)
Locks an object for exclusive editing by the user calling this function. 
The object can be only unlocked by this user or the system user. The 
parameter array contains the required element 'objectIdentifier' and the 
optional parameters 'mode' and 'objectquery'. 'mode' determines how an 
object is locked. HW_API_LOCK_NORMAL means, an object is locked until it 
is unlocked. HW_API_LOCK_RECURSIVE is only valid for collection and locks 
all objects within the collection and possible subcollections. 
HW_API_LOCK_SESSION means, an object is locked only as long as the session 
is valid. 
See also hwapi_unlock().   hw_api->linkUphw_api->move
hw_api->move
(no version information, might be only in CVS)
hw_api->move -- Moves object between collections
Description
object move ( array parameter)
See also hw_objrec2array().   hw_api->lockUphw_api_content
hw_api_content
(no version information, might be only in CVS)
hw_api_content -- Create new instance of class hw_api_content
Description
string content ( string content, string mimetype)
Creates a new content object from the string content. The mimetype is set 
to mimetype.   hw_api->moveUphw_api_object->assign
hw_api_object->assign
(no version information, might be only in CVS)
hw_api_object->assign -- Clones object
Description
object assign ( array parameter)
Clones the attributes of an object.   hw_api_contentUphw_api_object->attreditable
hw_api_object->attreditable
(no version information, might be only in CVS)
hw_api_object->attreditable -- Checks whether an attribute is editable
Description
bool attreditable ( array parameter)

  hw_api_object->assignUphw_api_object->count
hw_api_object->count
(no version information, might be only in CVS)
hw_api_object->count -- Returns number of attributes
Description
int count ( array parameter)

  hw_api_object->attreditableUphw_api_object->insert
hw_api_object->insert
(no version information, might be only in CVS)
hw_api_object->insert -- Inserts new attribute
Description
bool insert ( object attribute)
Adds an attribute to the object. Returns TRUE on success and otherwise 
FALSE. 
See also hwapi_object_remove().   hw_api_object->countUphw_api_object
hw_api_object
(no version information, might be only in CVS)
hw_api_object -- Creates a new instance of class hw_api_object
Description
object hw_api_object ( array parameter)
See also hwapi_lock().   hw_api_object->insertUphw_api_object->remove
hw_api_object->remove
(no version information, might be only in CVS)
hw_api_object->remove -- Removes attribute
Description
bool remove ( string name)
Removes the attribute with the given name. Returns TRUE on success and 
otherwise FALSE. 
See also hwapi_object_insert().   hw_api_objectUphw_api_object->title
hw_api_object->title
(no version information, might be only in CVS)
hw_api_object->title -- Returns the title attribute
Description
string title ( array parameter)

  hw_api_object->removeUphw_api_object->value
hw_api_object->value
(no version information, might be only in CVS)
hw_api_object->value -- Returns value of attribute
Description
string value ( string name)
Returns the value of the attribute with the given name or FALSE if an 
error occurred.   hw_api_object->titleUphw_api->object
hw_api->object
(no version information, might be only in CVS)
hw_api->object -- Retrieve attribute information
Description
object hw_api->object ( array parameter)
This function retrieves the attribute information of an object of any 
version. It will not return the document content. The parameter array 
contains the required elements 'objectIdentifier' and the optional 
elements 'attributeSelector' and 'version'. 
The returned object is an instance of class HW_API_Object on success or 
HW_API_Error if an error occurred. 
This simple example retrieves an object and checks for errors. 
Example 1. Retrieve an object
  <?php
  function handle_error($error) {
    $reason = $error->reason(0);
    echo "Type: <b>";
    switch ($reason->type()) {
      case 0:
	echo "Error";
	break;
      case 1:
	echo "Warning";
	break;
      case 2:
	echo "Message";
	break;
    }
    echo "</b><br />\n";
    echo "Description: " . $reason->description("en") . "<br 
  />\n";
  }

  function list_attr($obj) {
    echo "<table>\n";
    $count = $obj->count();
    for ($i=0; $i<$count; $i++) {
      $attr = $obj->attribute($i);
      printf("<tr><td align=\"right\" 
  bgcolor=\"#c0c0c0\"><b>%s</b></td><td 
  bgcolor\="#F0F0F0\">%s</td></tr>\n",
	       $attr->key(), $attr->value());
    }
    echo "</table>\n";
  }

  $hwapi = hwapi_hgcsp($g_config[HOSTNAME]);
  $parms = array("objectIdentifier"=>"rootcollection", 
  "attributeSelector"=>array("Title", "Name", "DocumentType"));
  $root = $hwapi->object($parms);
  if (get_class($root) == "HW_API_Error") {
    handle_error($root);
    exit;
  }
  list_attr($root);
  ?> 
See also hwapi_content().   hw_api_object->valueUphw_api->objectbyanchor
hw_api->objectbyanchor
(no version information, might be only in CVS)
hw_api->objectbyanchor -- Returns the object an anchor belongs to
Description
object objectbyanchor ( array parameter)
This function retrieves an object the specified anchor belongs to. The 
parameter array contains the required element 'objectIdentifier' and the 
optional element 'attributeSelector'. 
See also hwapi_dstofsrcanchor(), hwapi_srcanchors(), hwapi_dstanchors().   hw_api->objectUphw_api->parents
hw_api->parents
(no version information, might be only in CVS)
hw_api->parents -- Returns parents of an object
Description
array parents ( array parameter)
Retrieves the parents of an object. The parents can be further filtered by 
specifying an object query. The parameter array contains the required 
elements 'objectidentifier' and the optional elements 'attributeselector' 
and 'objectquery'. 
The return value is an array of objects of type HW_API_Object or 
HW_API_Error. 
See also hwapi_children().   hw_api->objectbyanchorUphw_api_reason->description
hw_api_reason->description
(no version information, might be only in CVS)
hw_api_reason->description -- Returns description of reason
Description
string description ( void )
Returns the description of a reason   hw_api->parentsUphw_api_reason->type
hw_api_reason->type
(no version information, might be only in CVS)
hw_api_reason->type -- Returns type of reason
Description
object type ( void )
Returns the type of a reason.   hw_api_reason->descriptionUphw_api->remove
hw_api->remove
(no version information, might be only in CVS)
hw_api->remove -- Delete an object
Description
object remove ( array parameter)
Removes an object from the specified parent. Collections will be removed 
recursively. You can pass an optional object query to remove only those 
objects which match the query. An object will be deleted physically if it 
is the last instance. The parameter array contains the required elements 
'objectidentifier' and 'parentidentifier'. If you want to remove a user or 
group 'parentidentifier' can be skipped. The optional parameter 'mode' 
determines how the deletion is performed. In normal mode the object will 
not be removed physically until all instances are removed. In physical 
mode all instances of the object will be deleted immediately. In 
removelinks mode all references to and from the objects will be deleted as 
well. In nonrecursive the deletion is not performed recursive. Removing a 
collection which is not empty will cause an error. 
See also hwapi_move().   hw_api_reason->typeUphw_api->replace
hw_api->replace
(no version information, might be only in CVS)
hw_api->replace -- Replaces an object
Description
object replace ( array parameter)
Replaces the attributes and the content of an object The parameter array 
contains the required elements 'objectIdentifier' and 'object' and the 
optional parameters 'content', 'parameters', 'mode' and 
'attributeSelector'. 'objectIdentifier' contains the object to be 
replaced. 'object' contains the new object. 'content' contains the new 
content. 'parameters' contain extra information for HTML documents. 
HTML_Language is the letter abbreviation of the language of the title. 
HTML_Base sets the base attribute of the HTML document. 'mode' can be a 
combination of the following flags: 
HW_API_REPLACE_NORMAL
The object on the server is replace with the object passed. 
HW_API_REPLACE_FORCE_VERSION_CONTROL
HW_API_REPLACE_AUTOMATIC_CHECKOUT
HW_API_REPLACE_AUTOMATIC_CHECKIN
HW_API_REPLACE_PLAIN
HW_API_REPLACE_REVERT_IF_NOT_CHANGED
HW_API_REPLACE_KEEP_TIME_MODIFIED
See also hwapi_insert().   hw_api->removeUphw_api->setcommitedversion
hw_api->setcommitedversion
(no version information, might be only in CVS)
hw_api->setcommitedversion -- Commits version other than last version
Description
object setcommitedversion ( array parameter)
Commits a version of a document. The committed version is the one which is 
visible to users with read access. By default the last version is the 
committed version. 
See also hwapi_checkin(), hwapi_checkout(), hwapi_revert().   hw_api->replaceUphw_api->srcanchors
hw_api->srcanchors
(no version information, might be only in CVS)
hw_api->srcanchors -- Returns a list of all source anchors
Description
object srcanchors ( array parameter)
Retrieves all source anchors of an object. The parameter array contains 
the required element 'objectIdentifier' and the optional elements 
'attributeSelector' and 'objectQuery'. 
See also hwapi_dstanchors().   hw_api->setcommitedversionUphw_api->srcsofdst
hw_api->srcsofdst
(no version information, might be only in CVS)
hw_api->srcsofdst -- Returns source of a destination object
Description
object srcsofdst ( array parameter)
Retrieves all the source anchors pointing to the specified destination. 
The destination object can either be a destination anchor or a whole 
document. The parameters array contains the required element 
'objectIdentifier' and the optional element 'attributeSelector' and 
'objectQuery'. The function returns an array of objects or an error. 
See also hwapi_dstofsrcanchor().   hw_api->srcanchorsUphw_api->unlock
hw_api->unlock
(no version information, might be only in CVS)
hw_api->unlock -- Unlocks a locked object
Description
object unlock ( array parameter)
Unlocks a locked object. Only the user who has locked the object and the 
system user may unlock an object. The parameter array contains the 
required element 'objectIdentifier' and the optional parameters 'mode' and 
'objectquery'. The meaning of 'mode' is the same as in function 
hwapi_lock(). 
Returns TRUE on success or an object of class HW_API_Error. 
See also hwapi_lock().   hw_api->srcsofdstUphw_api->user
hw_api->user
(no version information, might be only in CVS)
hw_api->user -- Returns the own user object
Description
object user ( array parameter)
See also hwapi_userlist().   hw_api->unlockUphw_api->userlist
hw_api->userlist
(no version information, might be only in CVS)
hw_api->userlist -- Returns a list of all logged in users
Description
object userlist ( array parameter)
See also hwapi_user().   hw_api->userUpiconv functions
#

#T=int hw_who ( int connection)
hw_who ( ^!int connection);
#

#T=hypot - float hypot ( float num1, float num2)
(PHP 4 >= 4.1.0)
hypot --  Returns sqrt(num1*num1 + num2*num2) 
Description
float hypot ( float num1, float num2)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  hexdecUpis_finite
#

#T=float hypot ( float num1, float num2)
hypot ( ^!float num1, float num2);
#

#T=ibase_add_user - bool ibase_add_user ( string server, string dba_user_name, string 
(PHP 4 >= 4.2.0)
ibase_add_user --  Add a user to a security database (only for IB6 or 
later) 
Description
bool ibase_add_user ( string server, string dba_user_name, string 
dba_user_password, string user_name, string password [, string first_name 
[, string middle_name [, string last_name]]])
Warning
This function is currently not documented; only the argument list is 
available.

See also ibase_modify_user() and ibase_delete_user().   InterBase functionsUpibase_affected_rows
ibase_affected_rows
(no version information, might be only in CVS)
ibase_affected_rows --  Return the number of rows that were affected by 
the previous query 
Description
int ibase_affected_rows ( resource link_identifier)
This function returns the number of rows that were affected by the 
previous query that was executed from within the transaction context 
specified by link_identifier. If link_identifier is a connection resource, 
its default transaction is used. 
See also ibase_query() and ibase_execute().   ibase_add_userUpibase_blob_add
#

#T=bool ibase_add_user ( string server, string dba_user_name, string 
ibase_add_user ( ^!string server, string dba_user_name, string ;
#

#T=ibase_blob_add - bool ibase_blob_add ( resource blob_handle, string data)
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_add --  Add data into a newly created blob 
Description
bool ibase_blob_add ( resource blob_handle, string data)
ibase_blob_add() adds data into a blob created with ibase_blob_create(). 
Returns TRUE on success or FALSE on failure. 
See also ibase_blob_cancel(), ibase_blob_close(), ibase_blob_create() and 
ibase_blob_import().   ibase_affected_rowsUpibase_blob_cancel
#

#T=bool ibase_blob_add ( resource blob_handle, string data)
ibase_blob_add ( ^!resource blob_handle, string data);
#

#T=ibase_blob_cancel - bool ibase_blob_cancel ( resource blob_handle)
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_cancel --  Cancel creating blob 
Description
bool ibase_blob_cancel ( resource blob_handle)
This function will discard a BLOB created by ibase_create_blob() if it has 
not yet been closed by ibase_blob_close(). Returns TRUE on success or 
FALSE on failure. 
See also ibase_blob_close(), ibase_blob_create() and ibase_blob_import().   ibase_blob_addUpibase_blob_close
#

#T=bool ibase_blob_cancel ( resource blob_handle)
ibase_blob_cancel ( ^!resource blob_handle);
#

#T=ibase_blob_close - mixed ibase_blob_close ( resource blob_handle)
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_close --  Close blob 
Description
mixed ibase_blob_close ( resource blob_handle)
This function closes a BLOB that has either been opened for reading by 
ibase_open_blob() or has been opened for writing by ibase_create_blob(). 
If the BLOB was being read, this function returns TRUE on success, if the 
BLOB was being written to, this function returns a string containing the 
BLOB id that has been assigned to it by the database. On failure, this 
function returns FALSE. 
See also ibase_blob_cancel() and ibase_blob_open().   ibase_blob_cancelUpibase_blob_create
#

#T=mixed ibase_blob_close ( resource blob_handle)
ibase_blob_close ( ^!resource blob_handle);
#

#T=ibase_blob_create - resource ibase_blob_create ( [resource link_identifier])
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_create --  Create a new blob for adding data 
Description
resource ibase_blob_create ( [resource link_identifier])
ibase_blob_create() creates a new BLOB for filling with data. It returns a 
BLOB handle for later use with ibase_blob_add() or FALSE on failure. 
See also ibase_blob_add(), ibase_blob_cancel(), ibase_blob_close() and 
ibase_blob_import().   ibase_blob_closeUpibase_blob_echo
#

#T=resource ibase_blob_create ( [resource link_identifier])
ibase_blob_create ( ^![resource link_identifier]);
#

#T=ibase_blob_echo - bool ibase_blob_echo ( string blob_id)
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_echo --  Output blob contents to browser 
Description
bool ibase_blob_echo ( string blob_id)
This function opens a BLOB for reading and sends its contents directly to 
standard output (the browser, in most cases). Returns TRUE on success or 
FALSE on failure. 
See also ibase_blob_open(), ibase_blob_close() and ibase_blob_get().   ibase_blob_createUpibase_blob_get
#

#T=bool ibase_blob_echo ( string blob_id)
ibase_blob_echo ( ^!string blob_id);
#

#T=ibase_blob_get - string ibase_blob_get ( resource blob_handle, int len)
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_get --  Get len bytes data from open blob 
Description
string ibase_blob_get ( resource blob_handle, int len)
This function returns at most len bytes from a BLOB that has been opened 
for reading by ibase_blob_open(). Returns FALSE on failure. 
<?php
$sql       = "SELECT blob_value FROM table";
$result    = ibase_query($sql);
$data      = ibase_fetch_object($result);
$blob_data = ibase_blob_info($data->BLOB_VALUE);
$blob_hndl = ibase_blob_open($data->BLOB_VALUE);
echo         ibase_blob_get($blob_hndl, $blob_data[0]);
?> 

Whilst this example doesn't do much more than a 
'ibase_blob_echo($data->BLOB_VALUE)' would do, it does show you how to get 
information into a $variable to manipulate as you please. 
Note: It is not possible to read from a BLOB that has been opened for 
writing by ibase_blob_create(). 
See also ibase_blob_open(), ibase_blob_close() and ibase_blob_echo().   ibase_blob_echoUpibase_blob_import
#

#T=string ibase_blob_get ( resource blob_handle, int len)
ibase_blob_get ( ^!resource blob_handle, int len);
#

#T=ibase_blob_import - string ibase_blob_import ( [resource link_identifier, resource 
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_import --  Create blob, copy file in it, and close it 
Description
string ibase_blob_import ( [resource link_identifier, resource 
file_handle])
This function creates a BLOB, reads an entire file into it, closes it and 
returns the assigned BLOB id. The file handle is a handle returned by 
fopen(). Returns FALSE on failure. 
See also ibase_blob_add(), ibase_blob_cancel(), ibase_blob_close() and 
ibase_blob_create().   ibase_blob_getUpibase_blob_info
#

#T=string ibase_blob_import ( [resource link_identifier, resource 
ibase_blob_import ( ^![resource link_identifier, resource ;
#

#T=ibase_blob_info - array ibase_blob_info ( string blob_id)
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_info --  Return blob length and other useful info 
Description
array ibase_blob_info ( string blob_id)
Returns an array containing information about a BLOB. The information 
returned consists of the length of the BLOB, the number of segments it 
contains, the size of the largest segment, and whether it is a stream BLOB 
or a segmented BLOB.   ibase_blob_importUpibase_blob_open
#

#T=array ibase_blob_info ( string blob_id)
ibase_blob_info ( ^!string blob_id);
#

#T=ibase_blob_open - resource ibase_blob_open ( string blob_id)
(PHP 3>= 3.0.7, PHP 4 )
ibase_blob_open --  Open blob for retrieving data parts 
Description
resource ibase_blob_open ( string blob_id)
ibase_blob_open() opens an existing BLOB for reading. It returns a BLOB 
handle for later use with ibase_blob_get() or FALSE on failure. 
See also ibase_blob_close(), ibase_blob_echo() and ibase_blob_get().   ibase_blob_infoUpibase_close
#

#T=resource ibase_blob_open ( string blob_id)
ibase_blob_open ( ^!string blob_id);
#

#T=ibase_close - bool ibase_close ( [resource connection_id])
(PHP 3>= 3.0.6, PHP 4 )
ibase_close --  Close a connection to an InterBase database 
Description
bool ibase_close ( [resource connection_id])
Closes the link to an InterBase database that's associated with a 
connection id returned from ibase_connect(). If the connection id is 
omitted, the last opened link is assumed. Default transaction on link is 
committed, other transactions are rolled back. Returns TRUE on success or 
FALSE on failure. 
See also ibase_connect() and ibase_pconnect().   ibase_blob_openUpibase_commit_ret
ibase_commit_ret
(no version information, might be only in CVS)
ibase_commit_ret -- Commit a transaction without closing it
Description
bool ibase_commit_ret ( [resource link_identifier])
If called without an argument, this function commits the default 
transaction of the default link. If the argument is a connection 
identifier, the default transaction of the corresponding connection will 
be committed. If the argument is a transaction identifier, the 
corresponding transaction will be committed. The transaction context will 
be retained, so statements executed from within this transaction will not 
be invalidated. Returns TRUE on success or FALSE on failure.   ibase_closeUpibase_commit
#

#T=bool ibase_close ( [resource connection_id])
ibase_close ( ^![resource connection_id]);
#

#T=ibase_commit - bool ibase_commit ( [resource link_identifier])
(PHP 3>= 3.0.7, PHP 4 )
ibase_commit -- Commit a transaction
Description
bool ibase_commit ( [resource link_identifier])
If called without an argument, this function commits the default 
transaction of the default link. If the argument is a connection 
identifier, the default transaction of the corresponding connection will 
be committed. If the argument is a transaction identifier, the 
corresponding transaction will be committed. Returns TRUE on success or 
FALSE on failure.   ibase_commit_retUpibase_connect
#

#T=bool ibase_commit ( [resource link_identifier])
ibase_commit ( ^![resource link_identifier]);
#

#T=ibase_connect - resource ibase_connect ( string database [, string username [, string 
(PHP 3>= 3.0.6, PHP 4 )
ibase_connect --  Open a connection to an InterBase database 
Description
resource ibase_connect ( string database [, string username [, string 
password [, string charset [, int buffers [, int dialect [, string 
role]]]]]])
Establishes a connection to an InterBase server. The database argument has 
to be a valid path to database file on the server it resides on. If the 
server is not local, it must be prefixed with either 'hostname:' (TCP/IP), 
'//hostname/' (NetBEUI) or 'hostname@' (IPX/SPX), depending on the 
connection protocol used. username and password can also be specified with 
PHP configuration directives ibase.default_user and 
ibase.default_password. charset is the default character set for a 
database. buffers is the number of database buffers to allocate for the 
server-side cache. If 0 or omitted, server chooses its own default. 
dialect selects the default SQL dialect for any statement executed within 
a connection, and it defaults to the highest one supported by client 
libraries. 
In case a second call is made to ibase_connect() with the same arguments, 
no new link will be established, but instead, the link identifier of the 
already opened link will be returned. The link to the server will be 
closed as soon as the execution of the script ends, unless it's closed 
earlier by explicitly calling ibase_close(). Example 1. 
ibase_connect() example
  <?php
      $host = 'localhost:/path/to/your.gdb';

      $dbh = ibase_connect($host, $username, $password);
      $stmt = 'SELECT * FROM tblname';
      $sth = ibase_query($dbh, $stmt);
      while ($row = ibase_fetch_object($sth)) {
	  echo $row->email, "\n";
      }
      ibase_free_result($sth);
      ibase_close($dbh);
  ?> 
Note: The optional buffers parameter was added in PHP 4.0.0. 
Note: The optional dialect parameter was added in PHP 4.0.0 and is 
functional only with InterBase 6 and up. 
Note: The optional role parameter was added in PHP 4.0.0 and is 
functional only with InterBase 5 and up. 
Note: If you get some error like "arithmetic exception, numeric 
overflow, or string truncation. Cannot transliterate character between 
character sets" (this occurs when you try use some character with 
accents) when using this and after ibase_query() you must set the 
character set (i.e. ISO8859_1 or your current character set). 
See also ibase_pconnect() and ibase_close().   ibase_commitUpibase_delete_user
#

#T=resource ibase_connect ( string database [, string username [, string 
ibase_connect ( ^!string database [, string username [, string ;
#

#T=ibase_delete_user - bool ibase_delete_user ( string server, string dba_user_name, string 
(PHP 4 >= 4.2.0)
ibase_delete_user --  Delete a user from a security database (only for IB6 
or later) 
Description
bool ibase_delete_user ( string server, string dba_user_name, string 
dba_user_password, string user_name)
Warning
This function is currently not documented; only the argument list is 
available.

See also ibase_add_user() and ibase_modify_user().   ibase_connectUpibase_drop_db
ibase_drop_db
(no version information, might be only in CVS)
ibase_drop_db --  Drops a database 
Description
bool ibase_drop_db ( resource connection)
This functions drops a database that was opened by either ibase_connect() 
or ibase_pconnect(). The database is closed and deleted from the server. 
Returns TRUE on success or FALSE on failure. 
See also ibase_connect() and ibase_pconnect().   ibase_delete_userUpibase_errcode
ibase_errcode
(no version information, might be only in CVS)
ibase_errcode --  Return an error code 
Description
int ibase_errcode ( void )
Returns the error code that resulted from the most recent InterBase 
function call. Returns FALSE if no error occurred. 
See also ibase_errmsg().   ibase_drop_dbUpibase_errmsg
#

#T=bool ibase_delete_user ( string server, string dba_user_name, string 
ibase_delete_user ( ^!string server, string dba_user_name, string ;
#

#T=ibase_errmsg - string ibase_errmsg ( void )
(PHP 3>= 3.0.7, PHP 4 )
ibase_errmsg --  Return error messages 
Description
string ibase_errmsg ( void )
Returns the error message that resulted from the most recent InterBase 
function call. Returns FALSE if no error occurred. 
See also ibase_errcode().   ibase_errcodeUpibase_execute
#

#T=string ibase_errmsg ( void )
ibase_errmsg ( ^!void );
#

#T=ibase_execute - resource ibase_execute ( resource query [, int bind_args])
(PHP 3>= 3.0.6, PHP 4 )
ibase_execute -- Execute a previously prepared query
Description
resource ibase_execute ( resource query [, int bind_args])
Execute a query prepared by ibase_prepare(). If the query raises an error, 
returns FALSE. If it is successful and there is a (possibly empty) result 
set (such as with a SELECT query), returns a result identifier. If the 
query was successful and there were no results, returns TRUE. 
This is a lot more effective than using ibase_query() if you are repeating 
a same kind of query several times with only some parameters changing. 
Example 1. ibase_execute() example
  <?php
     
      $dbh = ibase_connect($host, $username, $password); 

      $updates = array(
	  1 => 'Eric',
	  5 => 'Filip',
	  7 => 'Larry'
      );

      $query = ibase_prepare($dbh, "UPDATE FOO SET BAR = ? WHERE 
  BAZ = ?");

      while (list($baz, $bar) = each($updates)) {
	  ibase_execute($query, $bar, $baz);
      }
  ?> 
Note: In PHP 5.0.0 and up, this function returns the number of rows 
affected by the query (if > 0 and applicable to the statement type). A 
query that succeeded, but did not affect any rows (e.g. an UPDATE of a 
non-existent record) will return TRUE. 
See also ibase_query().   ibase_errmsgUpibase_fetch_assoc
#

#T=resource ibase_execute ( resource query [, int bind_args])
ibase_execute ( ^!resource query [, int bind_args]);
#

#T=ibase_fetch_assoc - array ibase_fetch_assoc ( resource result [, int fetch_flag])
(PHP 4 >= 4.3.0)
ibase_fetch_assoc --  Fetch a result row from a query as an associative 
array 
Description
array ibase_fetch_assoc ( resource result [, int fetch_flag])
ibase_fetch_assoc() returns an associative array that corresponds to the 
fetched row. Subsequent calls will return the next row in the result set, 
or FALSE if there are no more rows. 
ibase_fetch_assoc() fetches one row of data from the result. If two or 
more columns of the result have the same field names, the last column will 
take precedence. To access the other column(s) of the same name, you 
either need to access the result with numeric indices by using 
ibase_fetch_row() or use alias names in your query. 
fetch_flag is a combination of the constants IBASE_TEXT and IBASE_UNIXTIME 
ORed together. Passing IBASE_TEXT will cause this function to return BLOB 
contents instead of BLOB ids. Passing IBASE_UNIXTIME will cause this 
function to return date/time values as Unix timestamps instead of as 
formatted strings. 
See also ibase_fetch_row() and ibase_fetch_object().   ibase_executeUpibase_fetch_object
#

#T=array ibase_fetch_assoc ( resource result [, int fetch_flag])
ibase_fetch_assoc ( ^!resource result [, int fetch_flag]);
#

#T=ibase_fetch_object - object ibase_fetch_object ( resource result_id [, int fetch_flag])
(PHP 3>= 3.0.7, PHP 4 )
ibase_fetch_object -- Get an object from a InterBase database
Description
object ibase_fetch_object ( resource result_id [, int fetch_flag])
Fetches a row as a pseudo-object from a result_id obtained either by 
ibase_query() or ibase_execute(). 
<?php
$dbh = ibase_connect($host, $username, $password);
$stmt = 'SELECT * FROM tblname';
$sth = ibase_query($dbh, $stmt);
while ($row = ibase_fetch_object($sth)) {
    echo $row->email . "\n";
}
ibase_close($dbh);
?> 

Subsequent calls to ibase_fetch_object() return the next row in the result 
set, or FALSE if there are no more rows. 
fetch_flag is a combination of the constants IBASE_TEXT and IBASE_UNIXTIME 
ORed together. Passing IBASE_TEXT will cause this function to return BLOB 
contents instead of BLOB ids. Passing IBASE_UNIXTIME will cause this 
function to return date/time values as Unix timestamps instead of as 
formatted strings. 
See also ibase_fetch_row() and ibase_fetch_assoc().   ibase_fetch_assocUpibase_fetch_row
#

#T=object ibase_fetch_object ( resource result_id [, int fetch_flag])
ibase_fetch_object ( ^!resource result_id [, int fetch_flag]);
#

#T=ibase_fetch_row - array ibase_fetch_row ( resource result_identifier [, int fetch_flag])
(PHP 3>= 3.0.6, PHP 4 )
ibase_fetch_row -- Fetch a row from an InterBase database
Description
array ibase_fetch_row ( resource result_identifier [, int fetch_flag])
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
ibase_fetch_row() fetches one row of data from the result associated with 
the specified result_identifier. The row is returned as an array. Each 
result column is stored in an array offset, starting at offset 0. 
Subsequent calls to ibase_fetch_row() return the next row in the result 
set, or FALSE if there are no more rows. 
fetch_flag is a combination of the constants IBASE_TEXT and IBASE_UNIXTIME 
ORed together. Passing IBASE_TEXT will cause this function to return BLOB 
contents instead of BLOB ids. Passing IBASE_UNIXTIME will cause this 
function to return date/time values as Unix timestamps instead of as 
formatted strings. 
See also ibase_fetch_assoc() and ibase_fetch_object().   ibase_fetch_objectUpibase_field_info
#

#T=array ibase_fetch_row ( resource result_identifier [, int fetch_flag])
ibase_fetch_row ( ^!resource result_identifier [, int fetch_flag]);
#

#T=ibase_field_info - array ibase_field_info ( resource result, int field_number)
(PHP 3>= 3.0.7, PHP 4 )
ibase_field_info --  Get information about a field 
Description
array ibase_field_info ( resource result, int field_number)
Returns an array with information about a field after a select query has 
been run. The array is in the form of name, alias, relation, length, type. 

<?php
$rs = ibase_query("SELECT * FROM tablename"); 
$coln = ibase_num_fields($rs);
for ($i = 0; $i < $coln; $i++) {
    $col_info = ibase_field_info($rs, $i); 
    echo "name: ". $col_info['name']. "\n"; 
    echo "alias: ". $col_info['alias']. "\n"; 
    echo "relation: ". $col_info['relation']. "\n"; 
    echo "length: ". $col_info['length']. "\n"; 
    echo "type: ". $col_info['type']. "\n"; 
}
?> 

See also: ibase_num_fields().   ibase_fetch_rowUpibase_free_event_handler
ibase_free_event_handler
(no version information, might be only in CVS)
ibase_free_event_handler --  Cancels a registered event handler 
Description
bool ibase_free_event_handler ( resource event)
This function causes the registered event handler specified by event to be 
cancelled. The callback function will no longer be called for the events 
it was registered to handle. Returns TRUE on success or FALSE on failure. 
See also ibase_set_event_handler().   ibase_field_infoUpibase_free_query
#

#T=array ibase_field_info ( resource result, int field_number)
ibase_field_info ( ^!resource result, int field_number);
#

#T=ibase_free_query - bool ibase_free_query ( resource query)
(PHP 3>= 3.0.6, PHP 4 )
ibase_free_query --  Free memory allocated by a prepared query 
Description
bool ibase_free_query ( resource query)
Free a query prepared by ibase_prepare(). Returns TRUE on success or FALSE 
on failure.   ibase_free_event_handlerUpibase_free_result
#

#T=bool ibase_free_query ( resource query)
ibase_free_query ( ^!resource query);
#

#T=ibase_free_result - bool ibase_free_result ( resource result_identifier)
(PHP 3>= 3.0.6, PHP 4 )
ibase_free_result -- Free a result set
Description
bool ibase_free_result ( resource result_identifier)
Frees a result set that has been created by ibase_query() or 
ibase_execute(). Returns TRUE on success or FALSE on failure.   ibase_free_queryUpibase_gen_id
ibase_gen_id
(no version information, might be only in CVS)
ibase_gen_id --  Increments the named generator and returns its new value 
Description
int ibase_gen_id ( [resource link_identifier [, string generator [, int 
increment]]])
Warning
This function is currently not documented; only the argument list is 
available.
  ibase_free_resultUpibase_modify_user
#

#T=bool ibase_free_result ( resource result_identifier)
ibase_free_result ( ^!resource result_identifier);
#

#T=ibase_modify_user - bool ibase_modify_user ( string server, string dba_user_name, string 
(PHP 4 >= 4.2.0)
ibase_modify_user --  Modify a user to a security database (only for IB6 
or later) 
Description
bool ibase_modify_user ( string server, string dba_user_name, string 
dba_user_password, string user_name, string password [, string first_name 
[, string middle_name [, string last_name]]])
Warning
This function is currently not documented; only the argument list is 
available.

See also ibase_add_user() and ibase_delete_user().   ibase_gen_idUpibase_name_result
ibase_name_result
(no version information, might be only in CVS)
ibase_name_result --  Assigns a name to a result set 
Description
bool ibase_name_result ( resource result, string name)
This function assigns a name to a result set. This name can be used later 
in UPDATE|DELETE ... WHERE CURRENT OF name statements. Returns TRUE on 
success or FALSE on failure. 
<?php
$result = ibase_query("SELECT field1,field2 FROM table FOR UPDATE");
ibase_name_result($result, "my_cursor");

$updateqry = ibase_prepare("UPDATE table SET field2 = ? WHERE 
CURRENT OF my_cursor");

for ($i = 0; ibase_fetch_row($result); ++$i) {
    ibase_execute($updateqry, $i);
}
?> 

See also ibase_prepare() and ibase_execute().   ibase_modify_userUpibase_num_fields
#

#T=bool ibase_modify_user ( string server, string dba_user_name, string 
ibase_modify_user ( ^!string server, string dba_user_name, string ;
#

#T=ibase_num_fields - int ibase_num_fields ( resource result_id)
(PHP 3>= 3.0.7, PHP 4 )
ibase_num_fields --  Get the number of fields in a result set 
Description
int ibase_num_fields ( resource result_id)
Returns an integer containing the number of fields in a result set. 
<?php
$rs = ibase_query("SELECT * FROM tablename"); 
$coln = ibase_num_fields($rs);
for ($i = 0; $i < $coln; $i++) {
    $col_info = ibase_field_info($rs, $i); 
    echo "name: " . $col_info['name'] . "\n"; 
    echo "alias: " . $col_info['alias'] . "\n"; 
    echo "relation: " . $col_info['relation'] . "\n"; 
    echo "length: " . $col_info['length'] . "\n"; 
    echo "type: " . $col_info['type'] . "\n"; 
}
?> 

See also: ibase_field_info().   ibase_name_resultUpibase_num_params
ibase_num_params
(no version information, might be only in CVS)
ibase_num_params --  Return the number of parameters in a prepared query 
Description
int ibase_num_params ( resource query)
This function returns the number of parameters in the prepared query 
specified by query. This is the number of binding arguments that must be 
present when calling ibase_execute(). 
See also ibase_prepare() and ibase_param_info().   ibase_num_fieldsUpibase_param_info
ibase_param_info
(no version information, might be only in CVS)
ibase_param_info --  Return information about a parameter in a prepared 
query 
Description
array ibase_param_info ( resource query, int param_number)
Returns an array with information about a parameter after a query has been 
prepared. The array is in the form of name, alias, relation, length, type. 

See also ibase_field_info() and ibase_num_params().   ibase_num_paramsUpibase_pconnect
#

#T=int ibase_num_fields ( resource result_id)
ibase_num_fields ( ^!resource result_id);
#

#T=ibase_pconnect - resource ibase_pconnect ( string database [, string username [, string 
(PHP 3>= 3.0.6, PHP 4 )
ibase_pconnect --  Open a persistent connection to an InterBase database 
Description
resource ibase_pconnect ( string database [, string username [, string 
password [, string charset [, int buffers [, int dialect [, string 
role]]]]]])
ibase_pconnect() acts very much like ibase_connect() with two major 
differences. First, when connecting, the function will first try to find a 
(persistent) link that's already opened with the same parameters. If one 
is found, an identifier for it will be returned instead of opening a new 
connection. Second, the connection to the InterBase server will not be 
closed when the execution of the script ends. Instead, the link will 
remain open for future use (ibase_close() will not close links established 
by ibase_pconnect()). This type of link is therefore called 'persistent'. 
Note: buffers was added in PHP4-RC2. 
Note: dialect was added in PHP4-RC2. It is functional only with 
InterBase 6 and versions higher than that. 
Note: role was added in PHP4-RC2. It is functional only with InterBase 5 
and versions higher than that. 
See also ibase_close() and ibase_connect() for the meaning of parameters 
passed to this function. They are exactly the same.   ibase_param_infoUpibase_prepare
#

#T=resource ibase_pconnect ( string database [, string username [, string 
ibase_pconnect ( ^!string database [, string username [, string ;
#

#T=ibase_prepare - resource ibase_prepare ( [resource link_identifier, string query])
(PHP 3>= 3.0.6, PHP 4 )
ibase_prepare --  Prepare a query for later binding of parameter 
placeholders and execution 
Description
resource ibase_prepare ( [resource link_identifier, string query])
Prepare a query for later binding of parameter placeholders and execution 
(via ibase_execute()).   ibase_pconnectUpibase_query
#

#T=resource ibase_prepare ( [resource link_identifier, string query])
ibase_prepare ( ^![resource link_identifier, string query]);
#

#T=ibase_query - resource ibase_query ( [resource link_identifier, string query [, int 
(PHP 3>= 3.0.6, PHP 4 )
ibase_query -- Execute a query on an InterBase database
Description
resource ibase_query ( [resource link_identifier, string query [, int 
bind_args]])
Performs a query on an InterBase database. If the query raises an error, 
returns FALSE. If it is successful and there is a (possibly empty) result 
set (such as with a SELECT query), returns a result identifier. If the 
query was successful and there were no results, returns TRUE. 
Example 1. ibase_query() example
  <?php

      $host = 'localhost:/path/to/your.gdb';

      $dbh = ibase_connect($host, $username, $password);
      $stmt = 'SELECT * FROM tblname';

      $sth = ibase_query($dbh, $stmt) or die(ibase_errmsg());

  ?> 
Note: In PHP 5.0.0 and up, this function returns the number of rows 
affected by the query (if > 0 and applicable to the statement type). A 
query that succeeded, but did not affect any rows (e.g. an UPDATE of a 
non-existent record) will return TRUE. 
Note: If you get some error like "arithmetic exception, numeric 
overflow, or string truncation. Cannot transliterate character between 
character sets" (this occurs when you try use some character with 
accents) when using this and after ibase_query() you must set the 
character set (i.e. ISO8859_1 or your current character set). 
See also ibase_errmsg(), ibase_fetch_row(), ibase_fetch_object(), and 
ibase_free_result().   ibase_prepareUpibase_rollback_ret
ibase_rollback_ret
(no version information, might be only in CVS)
ibase_rollback_ret -- Roll back a transaction without closing it
Description
bool ibase_rollback_ret ( [resource link_identifier])
If called without an argument, this function rolls back the default 
transaction of the default link. If the argument is a connection 
identifier, the default transaction of the corresponding connection will 
be rolled back. If the argument is a transaction identifier, the 
corresponding transaction will be rolled back. The transaction context 
will be retained, so statements executed from within this transaction will 
not be invalidated. Returns TRUE on success or FALSE on failure.   ibase_queryUpibase_rollback
#

#T=resource ibase_query ( [resource link_identifier, string query [, int 
ibase_query ( ^![resource link_identifier, string query [, int ;
#

#T=ibase_rollback - bool ibase_rollback ( [resource link_identifier])
(PHP 3>= 3.0.7, PHP 4 )
ibase_rollback -- Roll back a transaction
Description
bool ibase_rollback ( [resource link_identifier])
If called without an argument, this function rolls back the default 
transaction of the default link. If the argument is a connection 
identifier, the default transaction of the corresponding connection will 
be rolled back. If the argument is a transaction identifier, the 
corresponding transaction will be rolled back. Returns TRUE on success or 
FALSE on failure.   ibase_rollback_retUpibase_set_event_handler
ibase_set_event_handler
(no version information, might be only in CVS)
ibase_set_event_handler --  Register a callback function to be called when 
events are posted 
Description
resource ibase_set_event_handler ( [resource connection, callback 
event_handler, string event_name1 [, string event_name2 [, string ...]]])
This function registers a PHP user function as event handler for the 
specified events. The callback is called with the event name and the link 
resource as arguments whenever one of the specified events is posted by 
the database. The callback must return FALSE if the event handler should 
be canceled. Any other return value is ignored. 
<?php

function event_handler($event_name, $link) {
    if ($event_name=="NEW ORDER") {
	// process new order
	ibase_query($link, "UPDATE orders SET 
status='handled'");
    } else if ($event_name=="DB_SHUTDOWN") {
	// free event handler 
	return false;
    }
}

ibase_set_event_handler($link, "event_handler", "NEW_ORDER", 
"DB_SHUTDOWN");
?> 

The return value is an event resource. This resource can be used to free 
the event handler using ibase_free_event_handler(). 
See also ibase_free_event_handler() and ibase_wait_event().   ibase_rollbackUpibase_timefmt
#

#T=bool ibase_rollback ( [resource link_identifier])
ibase_rollback ( ^![resource link_identifier]);
#

#T=ibase_timefmt - int ibase_timefmt ( string format [, int columntype])
(PHP 3>= 3.0.6, PHP 4 )
ibase_timefmt --  Sets the format of timestamp, date and time type columns 
returned from queries 
Description
int ibase_timefmt ( string format [, int columntype])
Sets the format of timestamp, date or time type columns returned from 
queries. Internally, the columns are formatted by c-function strftime(), 
so refer to it's documentation regarding to the format of the string. 
columntype is one of the constants IBASE_TIMESTAMP, IBASE_DATE and 
IBASE_TIME. If omitted, defaults to IBASE_TIMESTAMP for backwards 
compatibility. 
<?php
/* InterBase 6 TIME-type columns will be returned in
 * the form '05 hours 37 minutes'. */
ibase_timefmt("%H hours %M minutes", IBASE_TIME);
?> 

You can also set defaults for these formats with PHP configuration 
directives ibase.timestampformat, ibase.dateformat and ibase.timeformat. 
Note: columntype was added in PHP 4.0. It has any meaning only with 
InterBase version 6 and higher. 
Note: A backwards incompatible change happened in PHP 4.0 when PHP 
configuration directive ibase.timeformat was renamed to 
ibase.timestampformat and directives ibase.dateformat and 
ibase.timeformat were added, so that the names would match better their 
functionality.   ibase_set_event_handlerUpibase_trans
#

#T=int ibase_timefmt ( string format [, int columntype])
ibase_timefmt ( ^!string format [, int columntype]);
#

#T=ibase_trans - resource ibase_trans ( [int trans_args [, resource link_identifier]])
(PHP 3>= 3.0.7, PHP 4 )
ibase_trans -- Begin a transaction
Description
resource ibase_trans ( [int trans_args [, resource link_identifier]])
Begins a transaction. 
trans_args can be a combination of IBASE_READ, IBASE_WRITE, 
IBASE_COMMITED, IBASE_CONSISTENCY, IBASE_CONCURRENCY, IBASE_REC_VERSION, 
IBASE_REC_NO_VERSION, IBASE_WAIT and IBASE_NOWAIT. 
Note: The behaviour of this function has been changed in PHP 5.0.0. The 
first call to ibase_trans() will not return the default transaction of a 
connection. All transactions started by ibase_trans() will be rolled 
back at the end of the script if they were not committed or rolled back 
by either ibase_commit() or ibase_rollback(). 
Note: In PHP 5.0.0. and up, this function will accept multiple 
trans_args and link_identifier arguments. This allows transactions over 
multiple database connections, which are committed using a 2-phase 
commit algorithm. This means you can rely on the updates to either 
succeed in every database, or fail in every database. It does NOT mean 
you can use tables from different databases in the same query! 
If you use transactions over multiple databases, you will have to 
specify both the link_id and transaction_id in calls to ibase_query() 
and ibase_prepare().   ibase_timefmtUpibase_wait_event
ibase_wait_event
(no version information, might be only in CVS)
ibase_wait_event --  Wait for an event to be posted by the database 
Description
string ibase_wait_event ( [resource connection, string event_name1 [, 
string event_name2 [, string ...]]])
This function suspends execution of the script until one of the specified 
events is posted by the database. The name of the event that was posted is 
returned. This function accepts up to 15 event arguments. 
See also ibase_set_event_handler() and ibase_free_event_handler().   ibase_transUpIngres II functions
#

#T=resource ibase_trans ( [int trans_args [, resource link_identifier]])
ibase_trans ( ^![int trans_args [, resource link_identifier]]);
#

#T=iconv_get_encoding - mixed iconv_get_encoding ( [string type])
(PHP 4 >= 4.0.5)
iconv_get_encoding -- Retrieve internal configuration variables of iconv 
extension
Description
mixed iconv_get_encoding ( [string type])
iconv_get_encoding() returns the current value of the internal 
configuration variable if successful, or FALSE on failure. 
The value of the optional type can be: 
all
input_encoding
output_encoding
internal_encoding

If type is omitted or set to "all", iconv_get_encoding() returns an array 
that stores all these variables. 
Example 1. iconv_get_encoding() example
  <pre>
  <?php
  iconv_set_encoding("internal_encoding", "UTF-8");
  iconv_set_encoding("output_encoding", "ISO-8859-1");
  var_dump(iconv_get_encoding('all'));
  ?>
  </pre> 

The printout of the above program will be: 
Array
(
[input_encoding] => ISO-8859-1
[output_encoding] => ISO-8859-1
[internal_encoding] => UTF-8
)
See also iconv_set_encoding() and ob_iconv_handler().   iconv functionsUpiconv_mime_decode_headers
iconv_mime_decode_headers
(no version information, might be only in CVS)
iconv_mime_decode_headers --  Decodes multiple MIME header fields at once 
Description
array iconv_mime_decode_headers ( string encoded_headers [, int mode [, 
string charset]])
Returns an associative array that holds a whole set of MIME header fields 
specified by encoded_headers on success, or FALSE if an error occurs 
during the decoding. 
Each key of the return value represents an individual field name and the 
corresponding element represents a field value. If more than one field of 
the same name are present, iconv_mime_decode_headers() automatically 
incorporates them into a numerically indexed array in the order of 
occurrence. 
mode determines the behaviour in the event iconv_mime_decode_headers() 
encounters a malformed MIME header field. You can specify any combination 
of the following bitmasks. 
Table 1. Bitmasks acceptable to iconv_mime_decode_headers()
ValueConstantDescription
1ICONV_MIME_DECODE_STRICTIf set, the given header is decoded in full 
conformance with the standards defined in RFC2047. This option is 
disabled by default because there are a lot of broken mail user 
agents that don't follow the specification and don't produce correct 
MIME headers. 
2ICONV_MIME_DECODE_CONTINUE_ON_ERRORIf set, 
iconv_mime_decode_headers() attempts to ignore any grammatical 
errors and continue to process a given header. 

The optional charset parameter specifies the character set to represent 
the result by. If omitted, iconv.internal_charset will be used. 
Example 1. iconv_mime_decode_function() example
  <?php
  $headers_string = <<<EOF
  Subject: =?UTF-8?B?UHLDvGZ1bmcgUHLDvGZ1bmc=?=
  To: example@example.com
  Date: Thu, 1 Jan 1970 00:00:00 +0000
  Message-Id: <example@example.com>
  Received: from localhost (localhost [127.0.0.1]) by localhost
      with SMTP id example for <example@example.com>
      Thu, 1 Jan 1970 00:00:00 +0000 (UTC)
      (envelope-from 
  example-return-0000-example=example.com@example.com)
  Received: (qmail 0 invoked by uid 65534); 1 Thu 2003 00:00:00 
  +0000

  EOF;

  $headers =  iconv_mime_decode_headers($headers_string, 0, 
  "ISO-8859-1");
  print_r($headers);
  ?> 

The output of this script should look like: 
Array
(
[Subject] => Prfung Prfung
[To] => example@example.com
[Date] => Thu, 1 Jan 1970 00:00:00 +0000
[Message-Id] => <example@example.com>
[Received] => Array
(
[0] => from localhost (localhost [127.0.0.1]) by localhost with SMTP id example for <example@example.com>; Thu, 1 Jan 1970 00:00:00 +0000 (UTC) (envelope-from example-return-0000-example=example.com@example.com)
[1] => (qmail 0 invoked by uid 65534); 1 Thu 2003 00:00:00 +0000
)

)
See also iconv_mime_decode(), mb_decode_mimeheader(), 
imap_mime_header_decode(), imap_base64() and imap_qprint().   iconv_get_encodingUpiconv_mime_decode
#

#T=mixed iconv_get_encoding ( [string type])
iconv_get_encoding ( ^![string type]);
#

#T=iconv_mime_decode - string iconv_mime_decode ( string encoded_header [, int mode [, string 
(PHP 5 CVS only)
iconv_mime_decode --  Decodes a MIME header field 
Description
string iconv_mime_decode ( string encoded_header [, int mode [, string 
charset]])
Returns a decoded MIME field on success, or FALSE if an error occurs 
during the decoding. 
mode determines the behaviour in the event iconv_mime_decode() encounters 
a malformed MIME header field. You can specify any combination of the 
following bitmasks. 
Table 1. Bitmasks acceptable to iconv_mime_decode()
ValueConstantDescription
1ICONV_MIME_DECODE_STRICTIf set, the given header is decoded in full 
conformance with the standards defined in RFC2047. This option is 
disabled by default because there are a lot of broken mail user 
agents that don't follow the specification and don't produce correct 
MIME headers. 
2ICONV_MIME_DECODE_CONTINUE_ON_ERRORIf set, iconv_mime_decode() 
attempts to continue to process the given header even though an 
error occurs. 

The optional charset parameter specifies the character set to represent 
the result by. If omitted, iconv.internal_charset will be used. 
Example 1. iconv_mime_decode() example
  <?php
  // This yields "Subject: Prfung Prfung"
  echo iconv_mime_decode("Subject: 
  =?UTF-8?B?UHLDvGZ1bmcgUHLDvGZ1bmc=?=",
			 0, "ISO-8859-1");
  ?> 
See also iconv_mime_decode_headers(), mb_decode_mimeheader(), 
imap_mime_header_decode(), imap_base64() and imap_qprint().   iconv_mime_decode_headersUpiconv_mime_encode
#

#T=string iconv_mime_decode ( string encoded_header [, int mode [, string 
iconv_mime_decode ( ^!string encoded_header [, int mode [, string ;
#

#T=iconv_mime_encode - string iconv_mime_encode ( string field_name, string field_value [, array 
(PHP 5 CVS only)
iconv_mime_encode --  Composes a MIME header field 
Description
string iconv_mime_encode ( string field_name, string field_value [, array 
preferences])
Composes and returns a string that represents a valid MIME header field, 
which looks like the following: Subject: =?ISO-8859-1?Q?Pr=FCfung_f=FCr?= Entwerfen von einer MIME kopfzeile
In the above example, "Subject" is the field name and the portion that 
begins with "=?ISO-8859-1?..." is the field value. 
You can control the behaviour of iconv_mime_encode() by specifying an 
associative array that contains configuration items to the optional third 
parameter preferences. The items supported by iconv_mime_encode() are 
listed below. Note that item names are treated case-sensitive. 
Table 1. Configuration items supported by iconv_mime_encode()
ItemTypeDescriptionDefault valueExample
schemebooleanSpecifies the method to encode a field value by. The 
value of this item may be either "B" or "Q", where "B" stands for 
base64 encoding scheme and "Q" stands for quoted-printable encoding 
scheme. BB
input-charsetstringSpecifies the character set in which the first 
parameter field_name and the second parameter field_value are 
presented. If not given, iconv_mime_encode() assumes those 
parameters are presented to it in the iconv.internal_charset ini 
setting. iconv.internal_charset ISO-8859-1
output-charsetstringSpecifies the character set to use to compose 
the MIME header. If not given, the same value as input-charset will 
be used. the same value as input-charset UTF-8
line-lengthintegerSpecifies the maximum length of the header lines. 
The resulting header is "folded" to a set of multiple lines in case 
the resulting header field would be longer than the value of this 
parameter, according to RFC2822 - Internet Message Format. If not 
given, the length will be limited to 76 characters. 76996
line-break-charsstringSpecifies the sequence of characters to append 
to each line as an end-of-line sign when "folding" is performed on a 
long header field. If not given, this defaults to "\r\n" (CR LF). 
Note that this parameter is always treated as an ASCII string 
regardless of the value of input-charset. \r\n\n

Example 1. iconv_mime_encode() example:
  <?php
  $preferences = array(
      "input-charset" => "ISO-8859-1",
      "output-charset" => "UTF-8",
      "line-length" => 76,
      "line-break-chars" => "\n"
  );
  $preferences["scheme"] = "Q";
  // This yields "Subject: 
=?UTF-8?Q?Pr=C3=BCfung_Pr=C3=BCfung?="
  echo iconv_mime_encode("Subject", "Prfung Prfung", 
  $preferences);

  $preferences["scheme"] = "B";
  // This yields "Subject: =?UTF-8?B?UHLDvGZ1bmcgUHLDvGZ1bmc=?="
  echo iconv_mime_encode("Subject", "Prfung Prfung", 
  $preferences);
  ?> 
See also imap_binary(), mb_encode_mimeheader() and imap_8bit().   iconv_mime_decodeUpiconv_set_encoding
#

#T=string iconv_mime_encode ( string field_name, string field_value [, array 
iconv_mime_encode ( ^!string field_name, string field_value [, array ;
#

#T=iconv_set_encoding - bool iconv_set_encoding ( string type, string charset)
(PHP 4 >= 4.0.5)
iconv_set_encoding -- Set current setting for character encoding 
conversion
Description
bool iconv_set_encoding ( string type, string charset)
iconv_set_encoding() changes the value of the internal configuration 
variable specified by type to charset. Returns TRUE on success or FALSE on 
failure. 
The value of type can be any one of those: 
input_encoding
output_encoding
internal_encoding

Example 1. iconv_set_encoding() example:
  <?php
  iconv_set_encoding("internal_encoding", "UTF-8");
  iconv_set_encoding("output_encoding", "ISO-8859-1");
  ?> 
See also iconv_get_encoding() and ob_iconv_handler().   iconv_mime_encodeUpiconv_strlen
#

#T=bool iconv_set_encoding ( string type, string charset)
iconv_set_encoding ( ^!string type, string charset);
#

#T=iconv_strlen - int iconv_strlen ( string str [, string charset])
(PHP 5 CVS only)
iconv_strlen --  Returns the character count of string 
Description
int iconv_strlen ( string str [, string charset])
Returns the character count of str. 
In contrast to strlen(), iconv_strlen() counts the occurrences of 
characters in the given byte sequence str on the basis of the specified 
character set, the result of which is not necessarily identical to the 
length of the string in byte. 
If charset parameter is omitted, str is assumed to be encoded in 
iconv.internal_charset. 
See also strlen() and mb_strlen().   iconv_set_encodingUpiconv_strpos
#

#T=int iconv_strlen ( string str [, string charset])
iconv_strlen ( ^!string str [, string charset]);
#

#T=iconv_strpos - int iconv_strpos ( string haystack, string needle, int offset [, string 
(PHP 5 CVS only)
iconv_strpos --  Finds position of first occurrence of a needle within a 
haystack. 
Description
int iconv_strpos ( string haystack, string needle, int offset [, string 
charset])
Returns the numeric position of the first occurrence of needle in 
haystack. 
The optional offset parameter specifies the position from which the search 
should be performed. 
If needle is not found, iconv_strpos() will return FALSE. 
Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

If haystack or needle is not a string, it is converted to a string and 
applied as the ordinal value of a character. 
In contrast to strpos(), the return value of iconv_strpos() is the number 
of characters that appear before the needle, rather than the offset in 
bytes to the position where the needle has been found. The characters are 
counted on the basis of the specified character set charset. 
If charset parameter is omitted, string are assumed to be encoded in 
iconv.internal_charset. 
See also strpos(), iconv_strrpos() and mb_strpos().   iconv_strlenUpiconv_strrpos
#

#T=int iconv_strpos ( string haystack, string needle, int offset [, string 
iconv_strpos ( ^!string haystack, string needle, int offset [, string ;
#

#T=iconv_strrpos - string iconv_strrpos ( string haystack, string needle [, string charset])
(PHP 5 CVS only)
iconv_strrpos --  Finds the last occurrence of a needle within the 
specified range of haystack. 
Description
string iconv_strrpos ( string haystack, string needle [, string charset])
Returns the numeric position of the last occurrence of needle in haystack. 

If needle is not found, iconv_strrpos() will return FALSE. 
Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

If haystack or needle is not a string, it is converted to a string and 
applied as the ordinal value of a character. 
In contrast to strpos(), the return value of iconv_strrpos() is the number 
of characters that appear before the needle, rather than the offset in 
bytes to the position where the needle has been found. The characters are 
counted on the basis of the specified character set charset. 
See also strrpos(), iconv_strpos() and mb_strrpos().   iconv_strposUpiconv_substr
#

#T=string iconv_strrpos ( string haystack, string needle [, string charset])
iconv_strrpos ( ^!string haystack, string needle [, string charset]);
#

#T=iconv_substr - string iconv_substr ( string str, int offset [, int length [, string 
(PHP 5 CVS only)
iconv_substr --  Cut out part of a string 
Description
string iconv_substr ( string str, int offset [, int length [, string 
charset]])
Returns the portion of str specified by the start and length parameters. 
If start is non-negative, iconv_substr() cuts the portion out of str 
beginning at start'th character, counting from zero. 
If start is negative, iconv_substr() cuts out the portion beginning at the 
position, start characters away from the end of str. 
If length is given and is positive, the return value will contain at most 
length characters of the portion that begins at start (depending on the 
length of string). If str is shorter than start characters long, FALSE 
will be returned. 
If negative length is passed, iconv_substr() cuts the portion out of str 
from the start'th character up to the character that is length characters 
away from the end of the string. In case start is also negative, the start 
position is calculated beforehand according to the rule explained above. 
Note that offset and length parameters are always deemed to represent 
offsets that are calculated on the basis of the character set determined 
by charset, whilst the counterpart substr() always takes these for byte 
offsets. If charset is not given, the character set is determined by the 
iconv.internal_charset ini setting. 
See also substr(), mb_substr() and mb_strcut().   iconv_strrposUpiconv
#

#T=string iconv_substr ( string str, int offset [, int length [, string 
iconv_substr ( ^!string str, int offset [, int length [, string ;
#

#T=iconv - string iconv ( string in_charset, string out_charset, string str)
(PHP 4 >= 4.0.5)
iconv -- Convert string to requested character encoding
Description
string iconv ( string in_charset, string out_charset, string str)
Performs a character set conversion on the string str from in_charset to 
out_charset. Returns the converted string or FALSE on failure. 
Example 1. iconv() example:
  <?php
  echo iconv("ISO-8859-1", "UTF-8", "This is a test.");
  ?> 

  iconv_substrUpob_iconv_handler
#

#T=string iconv ( string in_charset, string out_charset, string str)
iconv ( ^!string in_charset, string out_charset, string str);
#

#T=ifx_affected_rows - int ifx_affected_rows ( int result_id)
(PHP 3>= 3.0.3, PHP 4 )
ifx_affected_rows -- Get number of rows affected by a query
Description
int ifx_affected_rows ( int result_id)
result_id is a valid result id returned by ifx_query() or ifx_prepare(). 
Returns the number of rows affected by a query associated with result_id. 
For inserts, updates and deletes the number is the real number 
(sqlerrd[2]) of affected rows. For selects it is an estimate (sqlerrd[0]). 
Don't rely on it. The database server can never return the actual number 
of rows that will be returned by a SELECT because it has not even begun 
fetching them at this stage (just after the "PREPARE" when the optimizer 
has determined the query plan). 
Useful after ifx_prepare() to limit queries to reasonable result sets. 
Example 1. Informix affected rows
  <?php
  $rid = ifx_prepare("select * from emp 
		       where name like " . $name, $connid);
  if (! $rid) {
      /* ... error ... */
  }
  $rowcount = ifx_affected_rows($rid);
  if ($rowcount > 1000) {
      printf ("Too many rows in result set (%d)\n<br />", 
  $rowcount);
      die ("Please restrict your query<br />\n");
  }
  ?> 
See also ifx_num_rows().   Informix functionsUpifx_blobinfile_mode
#

#T=int ifx_affected_rows ( int result_id)
ifx_affected_rows ( ^!int result_id);
#

#T=ifx_blobinfile_mode - void ifx_blobinfile_mode ( int mode)
(PHP 3>= 3.0.4, PHP 4 )
ifx_blobinfile_mode -- Set the default blob mode for all select queries
Description
void ifx_blobinfile_mode ( int mode)
Set the default blob mode for all select queries. Mode "0" means save 
Byte-Blobs in memory, and mode "1" means save Byte-Blobs in a file.   ifx_affected_rowsUpifx_byteasvarchar
#

#T=void ifx_blobinfile_mode ( int mode)
ifx_blobinfile_mode ( ^!int mode);
#

#T=ifx_byteasvarchar - void ifx_byteasvarchar ( int mode)
(PHP 3>= 3.0.4, PHP 4 )
ifx_byteasvarchar -- Set the default byte mode
Description
void ifx_byteasvarchar ( int mode)
Sets the default byte mode for all select-queries. Mode "0" will return a 
blob id, and mode "1" will return a varchar with text content.   ifx_blobinfile_modeUpifx_close
#

#T=void ifx_byteasvarchar ( int mode)
ifx_byteasvarchar ( ^!int mode);
#

#T=ifx_close - int ifx_close ( [int link_identifier])
(PHP 3>= 3.0.3, PHP 4 )
ifx_close -- Close Informix connection
Description
int ifx_close ( [int link_identifier])
Returns: always TRUE. 
ifx_close() closes the link to an Informix database that's associated with 
the specified link identifier. If the link identifier isn't specified, the 
last opened link is assumed. 
Note that this isn't usually necessary, as non-persistent open links are 
automatically closed at the end of the script's execution. 
ifx_close() will not close persistent links generated by ifx_pconnect(). 
Example 1. Closing a Informix connection
  <?php
  $conn_id = ifx_connect ("mydb@ol_srv", "itsme", "mypassword");
  /* ... some queries and stuff ... */
  ifx_close($conn_id);
  ?> 
See also ifx_connect() and ifx_pconnect().   ifx_byteasvarcharUpifx_connect
#

#T=int ifx_close ( [int link_identifier])
ifx_close ( ^![int link_identifier]);
#

#T=ifx_connect - int ifx_connect ( [string database [, string userid [, string password]]])
(PHP 3>= 3.0.3, PHP 4 )
ifx_connect -- Open Informix server connection
Description
int ifx_connect ( [string database [, string userid [, string password]]])
Returns a connection identifier on success, or FALSE on error. 
ifx_connect() establishes a connection to an Informix server. All of the 
arguments are optional, and if they're missing, defaults are taken from 
values supplied in configuration file (ifx.default_host for the host 
(Informix libraries will use INFORMIXSERVER environment value if not 
defined), ifx.default_user for user, ifx.default_password for the password 
(none if not defined). 
In case a second call is made to ifx_connect() with the same arguments, no 
new link will be established, but instead, the link identifier of the 
already opened link will be returned. 
The link to the server will be closed as soon as the execution of the 
script ends, unless it's closed earlier by explicitly calling ifx_close(). 

Example 1. Connect to a Informix database
  <?php
  $conn_id = ifx_connect ("mydb@ol_srv1", "imyself", 
  "mypassword");
  ?> 
See also ifx_pconnect() and ifx_close().   ifx_closeUpifx_copy_blob
#

#T=int ifx_connect ( [string database [, string userid [, string password]]])
ifx_connect ( ^![string database [, string userid [, string password]]]);
#

#T=ifx_copy_blob - int ifx_copy_blob ( int bid)
(PHP 3>= 3.0.4, PHP 4 )
ifx_copy_blob -- Duplicates the given blob object
Description
int ifx_copy_blob ( int bid)
Duplicates the given blob object. bid is the ID of the blob object. 
Returns FALSE on error otherwise the new blob object-id.   ifx_connectUpifx_create_blob
#

#T=int ifx_copy_blob ( int bid)
ifx_copy_blob ( ^!int bid);
#

#T=ifx_create_blob - int ifx_create_blob ( int type, int mode, string param)
(PHP 3>= 3.0.4, PHP 4 )
ifx_create_blob -- Creates an blob object
Description
int ifx_create_blob ( int type, int mode, string param)
Creates an blob object. 
type: 1 = TEXT, 0 = BYTE 
mode: 0 = blob-object holds the content in memory, 1 = blob-object holds 
the content in file. 
param: if mode = 0: pointer to the content, if mode = 1: pointer to the 
filestring. 
Return FALSE on error, otherwise the new blob object-id.   ifx_copy_blobUpifx_create_char
#

#T=int ifx_create_blob ( int type, int mode, string param)
ifx_create_blob ( ^!int type, int mode, string param);
#

#T=ifx_create_char - int ifx_create_char ( string param)
(PHP 3>= 3.0.6, PHP 4 )
ifx_create_char -- Creates an char object
Description
int ifx_create_char ( string param)
Creates an char object. param should be the char content.   ifx_create_blobUpifx_do
#

#T=int ifx_create_char ( string param)
ifx_create_char ( ^!string param);
#

#T=ifx_do - int ifx_do ( int result_id)
(PHP 3>= 3.0.4, PHP 4 )
ifx_do --  Execute a previously prepared SQL-statement 
Description
int ifx_do ( int result_id)
Returns TRUE on success or FALSE on failure. 
Executes a previously prepared query or opens a cursor for it. 
Does NOT free result_id on error. 
Also sets the real number of ifx_affected_rows() for non-select statements 
for retrieval by ifx_affected_rows() 
See also: ifx_prepare().   ifx_create_charUpifx_error
#

#T=int ifx_do ( int result_id)
ifx_do ( ^!int result_id);
#

#T=ifx_error - string ifx_error ( void )
(PHP 3>= 3.0.3, PHP 4 )
ifx_error -- Returns error code of last Informix call
Description
string ifx_error ( void )
The Informix error codes (SQLSTATE & SQLCODE) formatted as follows : 
x [SQLSTATE = aa bbb SQLCODE=cccc] 
where x = space : no error 
E : error 
N : no more data 
W : warning 
? : undefined 
If the "x" character is anything other than space, SQLSTATE and SQLCODE 
describe the error in more detail. 
See the Informix manual for the description of SQLSTATE and SQLCODE 
Returns in a string one character describing the general results of a 
statement and both SQLSTATE and SQLCODE associated with the most recent 
SQL statement executed. The format of the string is "(char) [SQLSTATE=(two 
digits) (three digits) SQLCODE=(one digit)]". The first character can be ' 
' (space) (success), 'W' (the statement caused some warning), 'E' (an 
error happened when executing the statement) or 'N' (the statement didn't 
return any data). 
See also: ifx_errormsg()   ifx_doUpifx_errormsg
#

#T=string ifx_error ( void )
ifx_error ( ^!void );
#

#T=ifx_errormsg - string ifx_errormsg ( [int errorcode])
(PHP 3>= 3.0.4, PHP 4 )
ifx_errormsg -- Returns error message of last Informix call
Description
string ifx_errormsg ( [int errorcode])
Returns the Informix error message associated with the most recent 
Informix error, or, when the optional "errorcode" parameter is present, 
the error message corresponding to "errorcode". 
Example 1. ifx_errormsg() example
  printf("%s\n&lt;br>", ifx_errormsg(-201)); 
See also ifx_error().   ifx_errorUpifx_fetch_row
#

#T=string ifx_errormsg ( [int errorcode])
ifx_errormsg ( ^![int errorcode]);
#

#T=ifx_fetch_row - array ifx_fetch_row ( int result_id [, mixed position])
(PHP 3>= 3.0.3, PHP 4 )
ifx_fetch_row -- Get row as enumerated array
Description
array ifx_fetch_row ( int result_id [, mixed position])
Returns an associative array that corresponds to the fetched row, or FALSE 
if there are no more rows. 
Blob columns are returned as integer blob id values for use in 
ifx_get_blob() unless you have used ifx_textasvarchar(1) or 
ifx_byteasvarchar(1), in which case blobs are returned as string values. 
Returns FALSE on error 
result_id is a valid resultid returned by ifx_query() or ifx_prepare() 
(select type queries only!). 
position is an optional parameter for a "fetch" operation on "scroll" 
cursors: "NEXT", "PREVIOUS", "CURRENT", "FIRST", "LAST" or a number. If 
you specify a number, an "absolute" row fetch is executed. This parameter 
is optional, and only valid for SCROLL cursors. 
ifx_fetch_row() fetches one row of data from the result associated with 
the specified result identifier. The row is returned as an array. Each 
result column is stored in an array offset, starting at offset 0, with the 
column name as key. 
Subsequent calls to ifx_fetch_row() would return the next row in the 
result set, or FALSE if there are no more rows. 
Example 1. Informix fetch rows
  <?php
  $rid = ifx_prepare ("select * from emp where name like " . 
  $name,
		       $connid, IFX_SCROLL);
  if (! $rid) {
      /* ... error ... */
  }
  $rowcount = ifx_affected_rows($rid);
  if ($rowcount > 1000) {
      printf ("Too many rows in result set (%d)\n<br />", 
  $rowcount);
      die ("Please restrict your query<br />\n");
  }
  if (! ifx_do ($rid)) {
     /* ... error ... */
  }
  $row = ifx_fetch_row ($rid, "NEXT");
  while (is_array($row)) {
      for (reset($row); $fieldname=key($row); next($row)) {
	  $fieldvalue = $row[$fieldname];
	  printf ("%s = %s,", $fieldname, $fieldvalue);
      }
      printf("\n<br />");
      $row = ifx_fetch_row($rid, "NEXT");
  }
  ifx_free_result ($rid);
  ?> 

  ifx_errormsgUpifx_fieldproperties
#

#T=array ifx_fetch_row ( int result_id [, mixed position])
ifx_fetch_row ( ^!int result_id [, mixed position]);
#

#T=ifx_fieldproperties - array ifx_fieldproperties ( int result_id)
(PHP 3>= 3.0.3, PHP 4 )
ifx_fieldproperties -- List of SQL fieldproperties
Description
array ifx_fieldproperties ( int result_id)
Returns an associative array with fieldnames as key and the SQL 
fieldproperties as data for a query with result_id. Returns FALSE on 
error. 
Returns the Informix SQL fieldproperties of every field in the query as an 
associative array. Properties are encoded as: 
"SQLTYPE;length;precision;scale;ISNULLABLE" where SQLTYPE = the Informix 
type like "SQLVCHAR" etc. and ISNULLABLE = "Y" or "N". 
Example 1. Informix SQL fieldproperties
  <?php
  $properties = ifx_fieldproperties ($resultid);
  if (! isset($properties)) {
      /* ... error ... */
  }
  for ($i = 0; $i < count($properties); $i++) {
      $fname = key ($properties);
      printf ("%s:\t type =  %s\n", $fname, 
$properties[$fname]);
      next ($properties);
  }
  ?> 

  ifx_fetch_rowUpifx_fieldtypes
#

#T=array ifx_fieldproperties ( int result_id)
ifx_fieldproperties ( ^!int result_id);
#

#T=ifx_fieldtypes - array ifx_fieldtypes ( int result_id)
(PHP 3>= 3.0.3, PHP 4 )
ifx_fieldtypes -- List of Informix SQL fields
Description
array ifx_fieldtypes ( int result_id)
Returns an associative array with fieldnames as key and the SQL fieldtypes 
as data for query with result_id. Returns FALSE on error. 
Example 1. Fieldnames and SQL fieldtypes
  <?php
  $types = ifx_fieldtypes ($resultid);
  if (! isset ($types)) {
      /* ... error ... */
  }
  for ($i = 0; $i < count($types); $i++) {
      $fname = key($types);
      printf("%s :\t type =  %s\n", $fname, $types[$fname]);
      next($types);
  }
  ?> 

  ifx_fieldpropertiesUpifx_free_blob
#

#T=array ifx_fieldtypes ( int result_id)
ifx_fieldtypes ( ^!int result_id);
#

#T=ifx_free_blob - int ifx_free_blob ( int bid)
(PHP 3>= 3.0.4, PHP 4 )
ifx_free_blob -- Deletes the blob object
Description
int ifx_free_blob ( int bid)
Deletes the blobobject for the given blob object-id bid. Returns TRUE on 
success or FALSE on failure.   ifx_fieldtypesUpifx_free_char
#

#T=int ifx_free_blob ( int bid)
ifx_free_blob ( ^!int bid);
#

#T=ifx_free_char - int ifx_free_char ( int bid)
(PHP 3>= 3.0.6, PHP 4 )
ifx_free_char -- Deletes the char object
Description
int ifx_free_char ( int bid)
Deletes the charobject for the given char object-id bid. Returns TRUE on 
success or FALSE on failure.   ifx_free_blobUpifx_free_result
#

#T=int ifx_free_char ( int bid)
ifx_free_char ( ^!int bid);
#

#T=ifx_free_result - int ifx_free_result ( int result_id)
(PHP 3>= 3.0.3, PHP 4 )
ifx_free_result -- Releases resources for the query
Description
int ifx_free_result ( int result_id)
Releases resources for the query associated with result_id. Returns TRUE 
on success or FALSE on failure.   ifx_free_charUpifx_get_blob
#

#T=int ifx_free_result ( int result_id)
ifx_free_result ( ^!int result_id);
#

#T=ifx_get_blob - int ifx_get_blob ( int bid)
(PHP 3>= 3.0.4, PHP 4 )
ifx_get_blob -- Return the content of a blob object
Description
int ifx_get_blob ( int bid)
Returns the content of the blob object for the given blob object-id bid.   ifx_free_resultUpifx_get_char
#

#T=int ifx_get_blob ( int bid)
ifx_get_blob ( ^!int bid);
#

#T=ifx_get_char - int ifx_get_char ( int bid)
(PHP 3>= 3.0.6, PHP 4 )
ifx_get_char -- Return the content of the char object
Description
int ifx_get_char ( int bid)
Returns the content of the char object for the given char object-id bid.   ifx_get_blobUpifx_getsqlca
#

#T=int ifx_get_char ( int bid)
ifx_get_char ( ^!int bid);
#

#T=ifx_getsqlca - array ifx_getsqlca ( int result_id)
(PHP 3>= 3.0.8, PHP 4 )
ifx_getsqlca --  Get the contents of sqlca.sqlerrd[0..5] after a query 
Description
array ifx_getsqlca ( int result_id)
result_id is a valid result id returned by ifx_query() or ifx_prepare(). 
Returns a pseudo-row (associative array) with sqlca.sqlerrd[0] ... 
sqlca.sqlerrd[5] after the query associated with result_id. 
For inserts, updates and deletes the values returned are those as set by 
the server after executing the query. This gives access to the number of 
affected rows and the serial insert value. For SELECTs the values are 
those saved after the PREPARE statement. This gives access to the 
*estimated* number of affected rows. The use of this function saves the 
overhead of executing a "select dbinfo('sqlca.sqlerrdx')" query, as it 
retrieves the values that were saved by the ifx driver at the appropriate 
moment. 
Example 1. Retrieve Informix sqlca.sqlerrd[x] values
  <?php
  /* assume the first column of 'sometable' is a serial */
  $qid = ifx_query("insert into sometable 
		    values (0, '2nd column', 'another column') 
  ", $connid);
  if (!$qid) {
      /* ... error ... */
  }
  $sqlca = ifx_getsqlca($qid);
  $serial_value = $sqlca["sqlerrd1"];
  echo "The serial value of the inserted row is : 
  $serial_value<br />\n"; 
  ?> 

  ifx_get_charUpifx_htmltbl_result
#

#T=array ifx_getsqlca ( int result_id)
ifx_getsqlca ( ^!int result_id);
#

#T=ifx_htmltbl_result - int ifx_htmltbl_result ( int result_id [, string html_table_options])
(PHP 3>= 3.0.3, PHP 4 )
ifx_htmltbl_result --  Formats all rows of a query into a HTML table 
Description
int ifx_htmltbl_result ( int result_id [, string html_table_options])
Returns the number of rows fetched or FALSE on error. 
Formats all rows of the result_id query into a HTML table. The optional 
second argument is a string of <table> tag options 
Example 1. Informix results as HTML table
  <?php
  $rid = ifx_prepare ("select * from emp where name like " . 
  $name,
		       $connid, IFX_SCROLL);
  if (! $rid) {
      /* ... error ... */
  }
  $rowcount = ifx_affected_rows ($rid);
  if ($rowcount > 1000) {
      printf ("Too many rows in result set (%d)\n<br />", 
  $rowcount);
      die ("Please restrict your query<br />\n");
  }
  if (! ifx_do($rid)) {
      /* ... error ... */
  }

  ifx_htmltbl_result ($rid, "border=\"2\"");

  ifx_free_result($rid);
  ?> 

  ifx_getsqlcaUpifx_nullformat
#

#T=int ifx_htmltbl_result ( int result_id [, string html_table_options])
ifx_htmltbl_result ( ^!int result_id [, string html_table_options]);
#

#T=ifx_nullformat - void ifx_nullformat ( int mode)
(PHP 3>= 3.0.4, PHP 4 )
ifx_nullformat --  Sets the default return value on a fetch row 
Description
void ifx_nullformat ( int mode)
Sets the default return value of a NULL-value on a fetch row. Mode "0" 
returns "", and mode "1" returns "NULL".   ifx_htmltbl_resultUpifx_num_fields
#

#T=void ifx_nullformat ( int mode)
ifx_nullformat ( ^!int mode);
#

#T=ifx_num_fields - int ifx_num_fields ( int result_id)
(PHP 3>= 3.0.3, PHP 4 )
ifx_num_fields -- Returns the number of columns in the query
Description
int ifx_num_fields ( int result_id)
Returns the number of columns in query for result_id or FALSE on error 
After preparing or executing a query, this call gives you the number of 
columns in the query.   ifx_nullformatUpifx_num_rows
#

#T=int ifx_num_fields ( int result_id)
ifx_num_fields ( ^!int result_id);
#

#T=ifx_num_rows - int ifx_num_rows ( int result_id)
(PHP 3>= 3.0.3, PHP 4 )
ifx_num_rows -- Count the rows already fetched from a query
Description
int ifx_num_rows ( int result_id)
Gives the number of rows fetched so far for a query with result_id after a 
ifx_query() or ifx_do() query.   ifx_num_fieldsUpifx_pconnect
#

#T=int ifx_num_rows ( int result_id)
ifx_num_rows ( ^!int result_id);
#

#T=ifx_pconnect - int ifx_pconnect ( [string database [, string userid [, string 
(PHP 3>= 3.0.3, PHP 4 )
ifx_pconnect -- Open persistent Informix connection
Description
int ifx_pconnect ( [string database [, string userid [, string 
password]]])
Returns: A positive Informix persistent link identifier on success, or 
FALSE on error 
ifx_pconnect() acts very much like ifx_connect() with two major 
differences. 
This function behaves exactly like ifx_connect() when PHP is not running 
as an Apache module. First, when connecting, the function would first try 
to find a (persistent) link that's already open with the same host, 
username and password. If one is found, an identifier for it will be 
returned instead of opening a new connection. 
Second, the connection to the SQL server will not be closed when the 
execution of the script ends. Instead, the link will remain open for 
future use (ifx_close() will not close links established by 
ifx_pconnect()). 
This type of links is therefore called 'persistent'. 
See also: ifx_connect().   ifx_num_rowsUpifx_prepare
#

#T=int ifx_pconnect ( [string database [, string userid [, string 
ifx_pconnect ( ^![string database [, string userid [, string ;
#

#T=ifx_prepare - int ifx_prepare ( string query, int conn_id [, int cursor_def, mixed 
(PHP 3>= 3.0.4, PHP 4 )
ifx_prepare -- Prepare an SQL-statement for execution
Description
int ifx_prepare ( string query, int conn_id [, int cursor_def, mixed 
blobidarray])
Returns an integer result_id for use by ifx_do(). Sets affected_rows for 
retrieval by the ifx_affected_rows() function. 
Prepares query on connection conn_id. For "select-type" queries a cursor 
is declared and opened. The optional cursor_type parameter allows you to 
make this a "scroll" and/or "hold" cursor. It's a bitmask and can be 
either IFX_SCROLL, IFX_HOLD, or both or'ed together. 
For either query type the estimated number of affected rows is saved for 
retrieval by ifx_affected_rows(). 
If you have BLOB (BYTE or TEXT) columns in the query, you can add a 
blobidarray parameter containing the corresponding "blob ids", and you 
should replace those columns with a "?" in the query text. 
If the contents of the TEXT (or BYTE) column allow it, you can also use 
"ifx_textasvarchar(1)" and "ifx_byteasvarchar(1)". This allows you to 
treat TEXT (or BYTE) columns just as if they were ordinary (but long) 
VARCHAR columns for select queries, and you don't need to bother with blob 
id's. 
With ifx_textasvarchar(0) or ifx_byteasvarchar(0) (the default situation), 
select queries will return BLOB columns as blob id's (integer value). You 
can get the value of the blob as a string or file with the blob functions 
(see below). 
See also: ifx_do().   ifx_pconnectUpifx_query
#

#T=int ifx_prepare ( string query, int conn_id [, int cursor_def, mixed 
ifx_prepare ( ^!string query, int conn_id [, int cursor_def, mixed ;
#

#T=ifx_query - int ifx_query ( string query, int link_identifier [, int cursor_type [, 
(PHP 3>= 3.0.3, PHP 4 )
ifx_query -- Send Informix query
Description
int ifx_query ( string query, int link_identifier [, int cursor_type [, 
mixed blobidarray]])
Returns a positive Informix result identifier on success, or FALSE on 
error. 
A "result_id" resource used by other functions to retrieve the query 
results. Sets "affected_rows" for retrieval by the ifx_affected_rows() 
function. 
ifx_query() sends a query to the currently active database on the server 
that's associated with the specified link identifier. 
Executes query on connection conn_id. For "select-type" queries a cursor 
is declared and opened. The optional cursor_type parameter allows you to 
make this a "scroll" and/or "hold" cursor. It's a bitmask and can be 
either IFX_SCROLL, IFX_HOLD, or both or'ed together. Non-select queries 
are "execute immediate". IFX_SCROLL and IFX_HOLD are symbolic constants 
and as such shouldn't be between quotes. I you omit this parameter the 
cursor is a normal sequential cursor. 
For either query type the number of (estimated or real) affected rows is 
saved for retrieval by ifx_affected_rows(). 
If you have BLOB (BYTE or TEXT) columns in an update query, you can add a 
blobidarray parameter containing the corresponding "blob ids", and you 
should replace those columns with a "?" in the query text. 
If the contents of the TEXT (or BYTE) column allow it, you can also use 
"ifx_textasvarchar(1)" and "ifx_byteasvarchar(1)". This allows you to 
treat TEXT (or BYTE) columns just as if they were ordinary (but long) 
VARCHAR columns for select queries, and you don't need to bother with blob 
id's. 
With ifx_textasvarchar(0) or ifx_byteasvarchar(0) (the default situation), 
select queries will return BLOB columns as blob id's (integer value). You 
can get the value of the blob as a string or file with the blob functions 
(see below). 
Example 1. Show all rows of the "orders" table as a HTML table 
  <?php
  ifx_textasvarchar(1);      // use "text mode" for blobs
  $res_id = ifx_query("select * from orders", $conn_id);
  if (! $res_id) {
      printf("Can't select orders : %s\n<br />%s<br />\n", 
  ifx_error());
      ifx_errormsg();
      die;
  }
  ifx_htmltbl_result($res_id, "border=\"1\"");
  ifx_free_result($res_id);
  ?> 

Example 2. Insert some values into the "catalog" table
  <?php

  // create blob id's for a byte and text column
  $textid = ifx_create_blob(0, 0, "Text column in memory");
  $byteid = ifx_create_blob(1, 0, "Byte column in memory");

  // store blob id's in a blobid array
  $blobidarray[] = $textid;
  $blobidarray[] = $byteid;

  // launch query
  $query = "insert into catalog (stock_num, manu_code, " .
	   "cat_descr,cat_picture) values(1,'HRO',?,?)";
  $res_id = ifx_query($query, $conn_id, $blobidarray);
  if (! $res_id) {
      /* ... error ... */
  }

  // free result id
  ifx_free_result($res_id);
  ?> 
See also ifx_connect().   ifx_prepareUpifx_textasvarchar
#

#T=int ifx_query ( string query, int link_identifier [, int cursor_type [, 
ifx_query ( ^!string query, int link_identifier [, int cursor_type [, ;
#

#T=ifx_textasvarchar - void ifx_textasvarchar ( int mode)
(PHP 3>= 3.0.4, PHP 4 )
ifx_textasvarchar -- Set the default text mode
Description
void ifx_textasvarchar ( int mode)
Sets the default text mode for all select-queries. Mode "0" will return a 
blob id, and mode "1" will return a varchar with text content.   ifx_queryUpifx_update_blob
#

#T=void ifx_textasvarchar ( int mode)
ifx_textasvarchar ( ^!int mode);
#

#T=ifx_update_blob - bool ifx_update_blob ( int bid, string content)
(PHP 3>= 3.0.4, PHP 4 )
ifx_update_blob -- Updates the content of the blob object
Description
bool ifx_update_blob ( int bid, string content)
Updates the content of the blob object for the given blob object bid. 
content is a string with new data. Returns TRUE on success or FALSE on 
failure.   ifx_textasvarcharUpifx_update_char
#

#T=bool ifx_update_blob ( int bid, string content)
ifx_update_blob ( ^!int bid, string content);
#

#T=ifx_update_char - int ifx_update_char ( int bid, string content)
(PHP 3>= 3.0.6, PHP 4 )
ifx_update_char -- Updates the content of the char object
Description
int ifx_update_char ( int bid, string content)
Updates the content of the char object for the given char object bid. 
content is a string with new data. Returns TRUE on success or FALSE on 
failure.   ifx_update_blobUpifxus_close_slob
#

#T=int ifx_update_char ( int bid, string content)
ifx_update_char ( ^!int bid, string content);
#

#T=ifxus_close_slob - int ifxus_close_slob ( int bid)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_close_slob -- Deletes the slob object
Description
int ifxus_close_slob ( int bid)
Deletes the slob object on the given slob object-id bid. Returns TRUE on 
success or FALSE on failure.   ifx_update_charUpifxus_create_slob
#

#T=int ifxus_close_slob ( int bid)
ifxus_close_slob ( ^!int bid);
#

#T=ifxus_create_slob - int ifxus_create_slob ( int mode)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_create_slob -- Creates an slob object and opens it
Description
int ifxus_create_slob ( int mode)
Creates an slob object and opens it. Modes: 1 = LO_RDONLY, 2 = LO_WRONLY, 
4 = LO_APPEND, 8 = LO_RDWR, 16 = LO_BUFFER, 32 = LO_NOBUFFER -> or-mask. 
You can also use constants named IFX_LO_RDONLY, IFX_LO_WRONLY etc. Return 
FALSE on error otherwise the new slob object-id.   ifxus_close_slobUpifxus_free_slob
#

#T=int ifxus_create_slob ( int mode)
ifxus_create_slob ( ^!int mode);
#

#T=ifxus_free_slob - int ifxus_free_slob ( int bid)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_free_slob -- Deletes the slob object
Description
int ifxus_free_slob ( int bid)
Deletes the slob object. bid is the Id of the slob object. Returns TRUE on 
success or FALSE on failure.   ifxus_create_slobUpifxus_open_slob
#

#T=int ifxus_free_slob ( int bid)
ifxus_free_slob ( ^!int bid);
#

#T=ifxus_open_slob - int ifxus_open_slob ( long bid, int mode)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_open_slob -- Opens an slob object
Description
int ifxus_open_slob ( long bid, int mode)
Opens an slob object. bid should be an existing slob id. Modes: 1 = 
LO_RDONLY, 2 = LO_WRONLY, 4 = LO_APPEND, 8 = LO_RDWR, 16 = LO_BUFFER, 32 = 
LO_NOBUFFER -> or-mask. Returns FALSE on error otherwise the new slob 
object-id.   ifxus_free_slobUpifxus_read_slob
#

#T=int ifxus_open_slob ( long bid, int mode)
ifxus_open_slob ( ^!long bid, int mode);
#

#T=ifxus_read_slob - int ifxus_read_slob ( long bid, long nbytes)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_read_slob -- Reads nbytes of the slob object
Description
int ifxus_read_slob ( long bid, long nbytes)
Reads nbytes of the slob object. bid is a existing slob id and nbytes is 
the number of bytes read. Return FALSE on error otherwise the string.   ifxus_open_slobUpifxus_seek_slob
#

#T=int ifxus_read_slob ( long bid, long nbytes)
ifxus_read_slob ( ^!long bid, long nbytes);
#

#T=ifxus_seek_slob - int ifxus_seek_slob ( long bid, int mode, long offset)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_seek_slob -- Sets the current file or seek position
Description
int ifxus_seek_slob ( long bid, int mode, long offset)
Sets the current file or seek position of an open slob object. bid should 
be an existing slob id. Modes: 0 = LO_SEEK_SET, 1 = LO_SEEK_CUR, 2 = 
LO_SEEK_END and offset is an byte offset. Return FALSE on error otherwise 
the seek position.   ifxus_read_slobUpifxus_tell_slob
#

#T=int ifxus_seek_slob ( long bid, int mode, long offset)
ifxus_seek_slob ( ^!long bid, int mode, long offset);
#

#T=ifxus_tell_slob - int ifxus_tell_slob ( long bid)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_tell_slob -- Returns the current file or seek position
Description
int ifxus_tell_slob ( long bid)
Returns the current file or seek position of an open slob object bid 
should be an existing slob id. Return FALSE on error otherwise the seek 
position.   ifxus_seek_slobUpifxus_write_slob
#

#T=int ifxus_tell_slob ( long bid)
ifxus_tell_slob ( ^!long bid);
#

#T=ifxus_write_slob - int ifxus_write_slob ( long bid, string content)
(PHP 3>= 3.0.4, PHP 4 )
ifxus_write_slob -- Writes a string into the slob object
Description
int ifxus_write_slob ( long bid, string content)
Writes a string into the slob object. bid is an existing slob id and 
content the content to write. Return FALSE on error otherwise bytes 
written.   ifxus_tell_slobUpInterBase functions
#

#T=int ifxus_write_slob ( long bid, string content)
ifxus_write_slob ( ^!long bid, string content);
#

#T=ignore_user_abort - int ignore_user_abort ( [bool setting])
(PHP 3>= 3.0.7, PHP 4 )
ignore_user_abort --  Set whether a client disconnect should abort script 
execution 
Description
int ignore_user_abort ( [bool setting])
This function sets whether a client disconnect should cause a script to be 
aborted. It will return the previous setting and can be called without an 
argument to not change the current setting and only return the current 
setting. See the Connection Handling section in the Features chapter for a 
complete description of connection handling in PHP. 
See also connection_aborted(), and connection_status().   highlight_stringUppack
#

#T=int ignore_user_abort ( [bool setting])
ignore_user_abort ( ^![bool setting]);
#

#T=image_type_to_mime_type - string image_type_to_mime_type ( int imagetype)
(PHP 4 >= 4.3.0)
image_type_to_mime_type -- Get Mime-Type for image-type returned by 
getimagesize, exif_read_data, exif_thumbnail, exif_imagetype
Description
string image_type_to_mime_type ( int imagetype)
The image_type_to_mime_type() function will determine the Mime-Type for an 
IMAGETYPE constant. Example 1. image_type_to_mime_type (file)
  <?php
  header("Content-type: " . 
  image_type_to_mime_type(IMAGETYPE_PNG));
  ?> 
The returned values are as follows 
Table 1. Returned values Constants
imagetypeReturned value
IMAGETYPE_GIFimage/gif
IMAGETYPE_JPEGimage/jpeg
IMAGETYPE_PNGimage/png
IMAGETYPE_SWFapplication/x-shockwave-flash
IMAGETYPE_PSDimage/psd
IMAGETYPE_BMPimage/bmp
IMAGETYPE_TIFF_II (intel byte order)image/tiff
IMAGETYPE_TIFF_MM (motorola byte order) image/tiff
IMAGETYPE_JPCapplication/octet-stream
IMAGETYPE_JP2image/jp2
IMAGETYPE_JPXapplication/octet-stream
IMAGETYPE_JB2application/octet-stream
IMAGETYPE_SWCapplication/x-shockwave-flash
IMAGETYPE_IFFimage/iff
IMAGETYPE_WBMPimage/vnd.wap.wbmp
IMAGETYPE_XBMimage/xbm

Note: This function does not require the GD image library. 
See also getimagesize(), exif_imagetype(), exif_read_data() and 
exif_thumbnail().   getimagesizeUpimage2wbmp
#

#T=string image_type_to_mime_type ( int imagetype)
image_type_to_mime_type ( ^!int imagetype);
#

#T=image2wbmp - int image2wbmp ( resource image [, string filename [, int threshold]])
(PHP 4 >= 4.0.5)
image2wbmp -- Output image to browser or file
Description
int image2wbmp ( resource image [, string filename [, int threshold]])
image2wbmp() creates the WBMP file in filename from the image image. The 
image argument is the return from imagecreate(). 
The filename argument is optional, and if left off, the raw image stream 
will be output directly. By sending an image/vnd.wap.wbmp content-type 
using header(), you can create a PHP script that outputs WBMP images 
directly. 
Example 1. image2wbmp() example
  <?php

  $file = 'php.jpg';

  header('Content-type: ' . 
  image_type_to_mime_type(IMAGETYPE_WBMP));
  image2wbmp($file); // output the stream directly

  ?> 
Note: WBMP support is only available if PHP was compiled against GD-1.8 
or later. 
See also imagewbmp().   image_type_to_mime_typeUpimagealphablending
#

#T=int image2wbmp ( resource image [, string filename [, int threshold]])
image2wbmp ( ^!resource image [, string filename [, int threshold]]);
#

#T=imagealphablending - bool imagealphablending ( resource image, bool blendmode)
(PHP 4 >= 4.0.6)
imagealphablending -- Set the blending mode for an image
Description
bool imagealphablending ( resource image, bool blendmode)
imagealphablending() allows for two different modes of drawing on 
truecolor images. In blending mode, the alpha channel component of the 
color supplied to all drawing function, such as imagesetpixel() determines 
how much of the underlying color should be allowed to shine through. As a 
result, gd automatically blends the existing color at that point with the 
drawing color, and stores the result in the image. The resulting pixel is 
opaque. In non-blending mode, the drawing color is copied literally with 
its alpha channel information, replacing the destination pixel. Blending 
mode is not available when drawing on palette images. If blendmode is 
TRUE, then blending mode is enabled, otherwise disabled. Returns TRUE on 
success or FALSE on failure. 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1   image2wbmpUpimageantialias
#

#T=bool imagealphablending ( resource image, bool blendmode)
imagealphablending ( ^!resource image, bool blendmode);
#

#T=imageantialias - bool imageantialias ( resource im, bool on)
(PHP 4 >= 4.3.2)
imageantialias --  Should antialias functions be used or not 
Description
bool imageantialias ( resource im, bool on)
Warning
This function is currently not documented; only the argument list is 
available.

See also imagecreatetruecolor().   imagealphablendingUpimagearc
#

#T=bool imageantialias ( resource im, bool on)
imageantialias ( ^!resource im, bool on);
#

#T=imagearc - int imagearc ( resource image, int cx, int cy, int w, int h, int s, int e, 
(PHP 3, PHP 4 )
imagearc -- Draw a partial ellipse
Description
int imagearc ( resource image, int cx, int cy, int w, int h, int s, int e, 
int color)
imagearc() draws a partial ellipse centered at cx, cy (top left is 0, 0) 
in the image represented by image. W and h specifies the ellipse's width 
and height respectively while the start and end points are specified in 
degrees indicated by the s and e arguments. 0 is located at the 
three-o'clock position, and the arc is drawn counter-clockwise. 
Example 1. Drawing a circle with imagearc()
  <?php

  // create a 200*200 image
  $img = imagecreate(200, 200);

  // allocate some colors
  $white = imagecolorallocate($img, 255, 255, 255);
     
  // draw a white circle 
  imagearc($img, 100, 100, 150, 150, 0, 360, $white);

  // output image in the browser
  header("Content-type: image/png");
  imagepng($img);
     
  // free memory
  imagedestroy($img);

  ?> 
See also imageellipse(), imagefilledellipse(), and imagefilledarc().   imageantialiasUpimagechar
#

#T=int imagearc ( resource image, int cx, int cy, int w, int h, int s, int e, 
imagearc ( ^!resource image, int cx, int cy, int w, int h, int s, int e, ;
#

#T=imagechar - int imagechar ( resource image, int font, int x, int y, string c, int 
(PHP 3, PHP 4 )
imagechar -- Draw a character horizontally
Description
int imagechar ( resource image, int font, int x, int y, string c, int 
color)
imagechar() draws the first character of c in the image identified by 
image with its upper-left at x,y (top left is 0, 0) with the color color. 
If font is 1, 2, 3, 4 or 5, a built-in font is used (with higher numbers 
corresponding to larger fonts). 
Example 1. imagechar() example
  <?php

  $im = imagecreate(100, 100);

  $string = 'PHP';

  $bg = imagecolorallocate($im, 255, 255, 255);
  $black = imagecolorallocate($im, 0, 0, 0);

  // prints a black "P" in the top left corner
  imagechar($im, 1, 0, 0, $string, $black);

  header('Content-type: image/png');
  imagepng($im);

  ?> 
See also imagecharup() and imageloadfont().   imagearcUpimagecharup
#

#T=int imagechar ( resource image, int font, int x, int y, string c, int 
imagechar ( ^!resource image, int font, int x, int y, string c, int ;
#

#T=imagecharup - int imagecharup ( resource image, int font, int x, int y, string c, int 
(PHP 3, PHP 4 )
imagecharup -- Draw a character vertically
Description
int imagecharup ( resource image, int font, int x, int y, string c, int 
color)
imagecharup() draws the character c vertically in the image identified by 
image at coordinates x, y (top left is 0, 0) with the color color. If font 
is 1, 2, 3, 4 or 5, a built-in font is used. 
Example 1. imagecharup() example
  <?php

  $im = imagecreate(100, 100);

  $string = 'Note that the first letter is a N';

  $bg = imagecolorallocate($im, 255, 255, 255);
  $black = imagecolorallocate($im, 0, 0, 0);

  // prints a black "Z" on a white background
  imagecharup($im, 3, 10, 10, $string, $black);

  header('Content-type: image/png');
  imagepng($im);

  ?> 
See also imagechar() and imageloadfont().   imagecharUpimagecolorallocate
#

#T=int imagecharup ( resource image, int font, int x, int y, string c, int 
imagecharup ( ^!resource image, int font, int x, int y, string c, int ;
#

#T=imagecolorallocate - int imagecolorallocate ( resource image, int red, int green, int blue)
(PHP 3, PHP 4 )
imagecolorallocate -- Allocate a color for an image
Description
int imagecolorallocate ( resource image, int red, int green, int blue)
imagecolorallocate() returns a color identifier representing the color 
composed of the given RGB components. The image argument is the return 
from the imagecreate() function. red, green and blue are the values of the 
red, green and blue component of the requested color respectively. These 
parameters are integers between 0 and 255 or hexadecimals between 0x00 and 
0xFF. imagecolorallocate() must be called to create each color that is to 
be used in the image represented by image. 
Note: The first call to imagecolorallocate() fills the background color. 

<?php

// sets background to red
$background = imagecolorallocate($im, 255, 0, 0);

// sets some colors
$white = imagecolorallocate($im, 255, 255, 255);
$black = imagecolorallocate($im, 0, 0, 0);

// hexadecimal way
$white = imagecolorallocate($im, 0xFF, 0xFF, 0xFF);
$black = imagecolorallocate($im, 0x00, 0x00, 0x00);

?> 

Returns -1 if the allocation failed. 
See also imagecolorallocatealpha() and imagecolordeallocate().   imagecharupUpimagecolorallocatealpha
#

#T=int imagecolorallocate ( resource image, int red, int green, int blue)
imagecolorallocate ( ^!resource image, int red, int green, int blue);
#

#T=imagecolorallocatealpha - int imagecolorallocatealpha ( resource image, int red, int green, int 
(PHP 4 >= 4.3.2)
imagecolorallocatealpha -- Allocate a color for an image
Description
int imagecolorallocatealpha ( resource image, int red, int green, int 
blue, int alpha)
imagecolorallocatealpha() behaves identically to imagecolorallocate() with 
the addition of the transparency parameter alpha which may have a value 
between 0 and 127. 0 indicates completely opaque while 127 indicates 
completely transparent. 
Returns FALSE if the allocation failed. 
Example 1. Example of using imagecolorallocatealpha()
  <?php
  $size = 300;
  $image=imagecreatetruecolor($size, $size);

  // something to get a white background with black border
  $back = imagecolorallocate($image, 255, 255, 255);
  $border = imagecolorallocate($image, 0, 0, 0);
  imagefilledrectangle($image, 0, 0, $size - 1, $size - 1, 
  $back);
  imagerectangle($image, 0, 0, $size - 1, $size - 1, $border);

  $yellow_x = 100;
  $yellow_y = 75;
  $red_x    = 120;
  $red_y    = 165; 
  $blue_x   = 187;
  $blue_y   = 125; 
  $radius   = 150;

  // allocate colors with alpha values
  $yellow = imagecolorallocatealpha($image, 255, 255, 0, 75);
  $red    = imagecolorallocatealpha($image, 255, 0, 0, 75);
  $blue   = imagecolorallocatealpha($image, 0, 0, 255, 75);

  // drawing 3 overlapped circle
  imagefilledellipse($image, $yellow_x, $yellow_y, $radius, 
  $radius, $yellow);
  imagefilledellipse($image, $red_x, $red_y, $radius, $radius, 
  $red);   
  imagefilledellipse($image, $blue_x, $blue_y, $radius, $radius, 
  $blue);

  // don't forget to output a correct header!
  header('Content-type: image/png');

  // and finally, output the result
  imagepng($image);
  imagedestroy($image);
  ?> 
See also imagecolorallocate() and imagecolordeallocate().   imagecolorallocateUpimagecolorat
#

#T=int imagecolorallocatealpha ( resource image, int red, int green, int 
imagecolorallocatealpha ( ^!resource image, int red, int green, int ;
#

#T=imagecolorat - int imagecolorat ( resource image, int x, int y)
(PHP 3, PHP 4 )
imagecolorat -- Get the index of the color of a pixel
Description
int imagecolorat ( resource image, int x, int y)
Returns the index of the color of the pixel at the specified location in 
the image specified by image. 
If PHP is compiled against GD library 2.0 or higher and the image is a 
truecolor image, this function returns the RGB value of that pixel as 
integer. Use bitshifting and masking to access the distinct red, green and 
blue component values: Example 1. Access distinct RGB values
  <?php
  $im = ImageCreateFromPng("rockym.png");
  $rgb = ImageColorAt($im, 100, 100);
  $r = ($rgb >> 16) & 0xFF;
  $g = ($rgb >> 8) & 0xFF;
  $b = $rgb & 0xFF;
  ?> 
See also imagecolorset() and imagecolorsforindex().   imagecolorallocatealphaUpimagecolorclosest
#

#T=int imagecolorat ( resource image, int x, int y)
imagecolorat ( ^!resource image, int x, int y);
#

#T=imagecolorclosest - int imagecolorclosest ( resource image, int red, int green, int blue)
(PHP 3, PHP 4 )
imagecolorclosest -- Get the index of the closest color to the specified 
color
Description
int imagecolorclosest ( resource image, int red, int green, int blue)
Returns the index of the color in the palette of the image which is 
"closest" to the specified RGB value. 
The "distance" between the desired color and each color in the palette is 
calculated as if the RGB values represented points in three-dimensional 
space. 
See also imagecolorexact().   imagecoloratUpimagecolorclosestalpha
#

#T=int imagecolorclosest ( resource image, int red, int green, int blue)
imagecolorclosest ( ^!resource image, int red, int green, int blue);
#

#T=imagecolorclosestalpha - int imagecolorclosestalpha ( resource image, int red, int green, int blue, 
(PHP 4 >= 4.0.6)
imagecolorclosestalpha -- Get the index of the closest color to the 
specified color + alpha
Description
int imagecolorclosestalpha ( resource image, int red, int green, int blue, 
int alpha)
Returns the index of the color in the palette of the image which is 
"closest" to the specified RGB value and alpha level. 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1 
See also imagecolorexactalpha().   imagecolorclosestUpimagecolorclosesthwb
#

#T=int imagecolorclosestalpha ( resource image, int red, int green, int blue, 
imagecolorclosestalpha ( ^!resource image, int red, int green, int blue, ;
#

#T=imagecolorclosesthwb - int imagecolorclosesthwb ( resource image, int red, int green, int blue)
(PHP 4 >= 4.0.1)
imagecolorclosesthwb --  Get the index of the color which has the hue, 
white and blackness nearest to the given color 
Description
int imagecolorclosesthwb ( resource image, int red, int green, int blue)
Warning
This function is currently not documented; only the argument list is 
available.
  imagecolorclosestalphaUpimagecolordeallocate
#

#T=int imagecolorclosesthwb ( resource image, int red, int green, int blue)
imagecolorclosesthwb ( ^!resource image, int red, int green, int blue);
#

#T=imagecolordeallocate - int imagecolordeallocate ( resource image, int color)
(PHP 3>= 3.0.6, PHP 4 )
imagecolordeallocate -- De-allocate a color for an image
Description
int imagecolordeallocate ( resource image, int color)
The imagecolordeallocate() function de-allocates a color previously 
allocated with imagecolorallocate() or imagecolorallocatealpha(). 
<?php
$white = imagecolorallocate($im, 255, 255, 255);
imagecolordeallocate($im, $white);
?> 

See also imagecolorallocate() and imagecolorallocatealpha().   imagecolorclosesthwbUpimagecolorexact
#

#T=int imagecolordeallocate ( resource image, int color)
imagecolordeallocate ( ^!resource image, int color);
#

#T=imagecolorexact - int imagecolorexact ( resource image, int red, int green, int blue)
(PHP 3, PHP 4 )
imagecolorexact -- Get the index of the specified color
Description
int imagecolorexact ( resource image, int red, int green, int blue)
Returns the index of the specified color in the palette of the image. 
If the color does not exist in the image's palette, -1 is returned. 
See also imagecolorclosest().   imagecolordeallocateUpimagecolorexactalpha
#

#T=int imagecolorexact ( resource image, int red, int green, int blue)
imagecolorexact ( ^!resource image, int red, int green, int blue);
#

#T=imagecolorexactalpha - int imagecolorexactalpha ( resource image, int red, int green, int blue, 
(PHP 4 >= 4.0.6)
imagecolorexactalpha -- Get the index of the specified color + alpha
Description
int imagecolorexactalpha ( resource image, int red, int green, int blue, 
int alpha)
Returns the index of the specified color+alpha in the palette of the 
image. 
If the color does not exist in the image's palette, -1 is returned. 
See also imagecolorclosestalpha(). 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1 or 
later  imagecolorexactUpimagecolormatch
#

#T=int imagecolorexactalpha ( resource image, int red, int green, int blue, 
imagecolorexactalpha ( ^!resource image, int red, int green, int blue, ;
#

#T=imagecolormatch - bool imagecolormatch ( resource image1, resource image2)
(PHP 4 >= 4.3.0)
imagecolormatch --  Makes the colors of the palette version of an image 
more closely match the true color version 
Description
bool imagecolormatch ( resource image1, resource image2)
Warning
This function is currently not documented; only the argument list is 
available.

image1 must be Truecolor, image2 must be Palette, and both image1 and 
image2 must be the same size. 
Returns TRUE on success or FALSE on failure. 
See also imagecreatetruecolor().   imagecolorexactalphaUpimagecolorresolve
#

#T=bool imagecolormatch ( resource image1, resource image2)
imagecolormatch ( ^!resource image1, resource image2);
#

#T=imagecolorresolve - int imagecolorresolve ( resource image, int red, int green, int blue)
(PHP 3>= 3.0.2, PHP 4 )
imagecolorresolve --  Get the index of the specified color or its closest 
possible alternative 
Description
int imagecolorresolve ( resource image, int red, int green, int blue)
This function is guaranteed to return a color index for a requested color, 
either the exact color or the closest possible alternative. 
See also imagecolorclosest().   imagecolormatchUpimagecolorresolvealpha
#

#T=int imagecolorresolve ( resource image, int red, int green, int blue)
imagecolorresolve ( ^!resource image, int red, int green, int blue);
#

#T=imagecolorresolvealpha - int imagecolorresolvealpha ( resource image, int red, int green, int blue, 
(PHP 4 >= 4.0.6)
imagecolorresolvealpha --  Get the index of the specified color + alpha or 
its closest possible alternative 
Description
int imagecolorresolvealpha ( resource image, int red, int green, int blue, 
int alpha)
This function is guaranteed to return a color index for a requested color, 
either the exact color or the closest possible alternative. 
See also imagecolorclosestalpha(). 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1  imagecolorresolveUpimagecolorset
#

#T=int imagecolorresolvealpha ( resource image, int red, int green, int blue, 
imagecolorresolvealpha ( ^!resource image, int red, int green, int blue, ;
#

#T=imagecolorset - bool imagecolorset ( resource image, int index, int red, int green, int 
(PHP 3, PHP 4 )
imagecolorset -- Set the color for the specified palette index
Description
bool imagecolorset ( resource image, int index, int red, int green, int 
blue)
This sets the specified index in the palette to the specified color. This 
is useful for creating flood-fill-like effects in palleted images without 
the overhead of performing the actual flood-fill. 
See also imagecolorat().   imagecolorresolvealphaUpimagecolorsforindex
#

#T=bool imagecolorset ( resource image, int index, int red, int green, int 
imagecolorset ( ^!resource image, int index, int red, int green, int ;
#

#T=imagecolorsforindex - array imagecolorsforindex ( resource image, int index)
(PHP 3, PHP 4 )
imagecolorsforindex -- Get the colors for an index
Description
array imagecolorsforindex ( resource image, int index)
This returns an associative array with red, green, blue and alpha keys 
that contain the appropriate values for the specified color index. 
Example 1. imagecolorsforindex() example
  <?php

  // open an image
  $im = imagecreatefrompng('nexen.png');

  // get a color
  $start_x = 40;
  $start_y = 50;
  $color_index = imagecolorat($im, $start_x, $start_y);

  // make it human readable
  $color_tran = imagecolorsforindex($im, $color_index);

  // what is it ?
  echo '<pre>';
  print_r($color_tran);
  echo '</pre>';

  ?> 

This example will output : 
Array
(
[red] => 226
[green] => 222
[blue] => 252
[alpha] => 0
)
See also imagecolorat() and imagecolorexact().   imagecolorsetUpimagecolorstotal
#

#T=array imagecolorsforindex ( resource image, int index)
imagecolorsforindex ( ^!resource image, int index);
#

#T=imagecolorstotal - int imagecolorstotal ( resource image)
(PHP 3, PHP 4 )
imagecolorstotal -- Find out the number of colors in an image's palette
Description
int imagecolorstotal ( resource image)
This returns the number of colors in the specified image's palette. 
See also imagecolorat() and imagecolorsforindex().   imagecolorsforindexUpimagecolortransparent
#

#T=int imagecolorstotal ( resource image)
imagecolorstotal ( ^!resource image);
#

#T=imagecolortransparent - int imagecolortransparent ( resource image [, int color])
(PHP 3, PHP 4 )
imagecolortransparent -- Define a color as transparent
Description
int imagecolortransparent ( resource image [, int color])
imagecolortransparent() sets the transparent color in the image image to 
color. image is the image identifier returned by imagecreate() and color 
is a color identifier returned by imagecolorallocate(). 
Note: The transparent color is a property of the image, transparency is 
not a property of the color. Once you have a set a color to be the 
transparent color, any regions of the image in that color that were 
drawn previously will be transparent. 
The identifier of the new (or current, if none is specified) transparent 
color is returned.   imagecolorstotalUpimagecopy
#

#T=int imagecolortransparent ( resource image [, int color])
imagecolortransparent ( ^!resource image [, int color]);
#

#T=imagecopy - int imagecopy ( resource dst_im, resource src_im, int dst_x, int dst_y, 
(PHP 3>= 3.0.6, PHP 4 )
imagecopy -- Copy part of an image
Description
int imagecopy ( resource dst_im, resource src_im, int dst_x, int dst_y, 
int src_x, int src_y, int src_w, int src_h)
Copy a part of src_im onto dst_im starting at the x,y coordinates src_x, 
src_y with a width of src_w and a height of src_h. The portion defined 
will be copied onto the x,y coordinates, dst_x and dst_y.   imagecolortransparentUpimagecopymerge
#

#T=int imagecopy ( resource dst_im, resource src_im, int dst_x, int dst_y, 
imagecopy ( ^!resource dst_im, resource src_im, int dst_x, int dst_y, ;
#

#T=imagecopymerge - int imagecopymerge ( resource dst_im, resource src_im, int dst_x, int 
(PHP 4 >= 4.0.1)
imagecopymerge -- Copy and merge part of an image
Description
int imagecopymerge ( resource dst_im, resource src_im, int dst_x, int 
dst_y, int src_x, int src_y, int src_w, int src_h, int pct)
Copy a part of src_im onto dst_im starting at the x,y coordinates src_x, 
src_y with a width of src_w and a height of src_h. The portion defined 
will be copied onto the x,y coordinates, dst_x and dst_y. The two images 
will be merged according to pct which can range from 0 to 100. When pct = 
0, no action is taken, when 100 this function behaves identically to 
imagecopy(). 
Note: This function was added in PHP 4.0.6  imagecopyUpimagecopymergegray
#

#T=int imagecopymerge ( resource dst_im, resource src_im, int dst_x, int 
imagecopymerge ( ^!resource dst_im, resource src_im, int dst_x, int ;
#

#T=imagecopymergegray - int imagecopymergegray ( resource dst_im, resource src_im, int dst_x, int 
(PHP 4 >= 4.0.6)
imagecopymergegray -- Copy and merge part of an image with gray scale
Description
int imagecopymergegray ( resource dst_im, resource src_im, int dst_x, int 
dst_y, int src_x, int src_y, int src_w, int src_h, int pct)
imagecopymergegray() copy a part of src_im onto dst_im starting at the x,y 
coordinates src_x, src_y with a width of src_w and a height of src_h. The 
portion defined will be copied onto the x,y coordinates, dst_x and dst_y. 
The two images will be merged according to pct which can range from 0 to 
100. When pct = 0, no action is taken, when 100 this function behaves 
identically to imagecopy(). 
This function is identical to imagecopymerge() except that when merging it 
preserves the hue of the source by converting the destination pixels to 
gray scale before the copy operation. 
Note: This function was added in PHP 4.0.6  imagecopymergeUpimagecopyresampled
#

#T=int imagecopymergegray ( resource dst_im, resource src_im, int dst_x, int 
imagecopymergegray ( ^!resource dst_im, resource src_im, int dst_x, int ;
#

#T=imagecopyresampled - bool imagecopyresampled ( resource dst_im, resource src_im, int dstX, int 
(PHP 4 >= 4.0.6)
imagecopyresampled -- Copy and resize part of an image with resampling
Description
bool imagecopyresampled ( resource dst_im, resource src_im, int dstX, int 
dstY, int srcX, int srcY, int dstW, int dstH, int srcW, int srcH)
imagecopyresampled() copies a rectangular portion of one image to another 
image, smoothly interpolating pixel values so that, in particular, 
reducing the size of an image still retains a great deal of clarity. 
Returns TRUE on success or FALSE on failure. dst_im is the destination 
image, src_im is the source image identifier. If the source and 
destination coordinates and width and heights differ, appropriate 
stretching or shrinking of the image fragment will be performed. The 
coordinates refer to the upper left corner. This function can be used to 
copy regions within the same image (if dst_im is the same as src_im) but 
if the regions overlap the results will be unpredictable. 
Note: There is a problem due to palette image limitations (255+1 
colors). Resampling or filtering an image commonly needs more colors 
than 255, a kind of approximation is used to calculate the new resampled 
pixel and its color. With a palette image we try to allocate a new 
color, if that failed, we choose the closest (in theory) computed color. 
This is not always the closest visual color. That may produce a weird 
result, like blank (or visually blank) images. To skip this problem, 
please use a truecolor image as a destination image, such as one created 
by imagecreatetruecolor(). 
Note: imagecopyresampled() requires GD 2.0.l or greater. 
See also imagecopyresized().   imagecopymergegrayUpimagecopyresized
#

#T=bool imagecopyresampled ( resource dst_im, resource src_im, int dstX, int 
imagecopyresampled ( ^!resource dst_im, resource src_im, int dstX, int ;
#

#T=imagecopyresized - int imagecopyresized ( resource dst_im, resource src_im, int dstX, int 
(PHP 3, PHP 4 )
imagecopyresized -- Copy and resize part of an image
Description
int imagecopyresized ( resource dst_im, resource src_im, int dstX, int 
dstY, int srcX, int srcY, int dstW, int dstH, int srcW, int srcH)
imagecopyresized() copies a rectangular portion of one image to another 
image. Dst_im is the destination image, src_im is the source image 
identifier. If the source and destination coordinates and width and 
heights differ, appropriate stretching or shrinking of the image fragment 
will be performed. The coordinates refer to the upper left corner. This 
function can be used to copy regions within the same image (if dst_im is 
the same as src_im) but if the regions overlap the results will be 
unpredictable. 
Note: There is a problem due to palette image limitations (255+1 
colors). Resampling or filtering an image commonly needs more colors 
than 255, a kind of approximation is used to calculate the new resampled 
pixel and its color. With a palette image we try to allocate a new 
color, if that failed, we choose the closest (in theory) computed color. 
This is not always the closest visual color. That may produce a weird 
result, like blank (or visually blank) images. To skip this problem, 
please use a truecolor image as a destination image, such as one created 
by imagecreatetruecolor(). 
See also imagecopyresampled().   imagecopyresampledUpimagecreate
#

#T=int imagecopyresized ( resource dst_im, resource src_im, int dstX, int 
imagecopyresized ( ^!resource dst_im, resource src_im, int dstX, int ;
#

#T=imagecreate - resource imagecreate ( int x_size, int y_size)
(PHP 3, PHP 4 )
imagecreate -- Create a new palette based image
Description
resource imagecreate ( int x_size, int y_size)
imagecreate() returns an image identifier representing a blank image of 
size x_size by y_size. 
We recommend the use of imagecreatetruecolor(). 
Example 1. Creating a new GD image stream and outputting an image. 
  <?php
  header("Content-type: image/png");
  $im = @imagecreate(50, 100)
      or die("Cannot Initialize new GD image stream");
  $background_color = imagecolorallocate($im, 255, 255, 255);
  $text_color = imagecolorallocate($im, 233, 14, 91);
  imagestring($im, 1, 5, 5,  "A Simple Text String", 
  $text_color);
  imagepng($im);
  imagedestroy($im);
  ?> 
See also imagedestroy() and imagecreatetruecolor().   imagecopyresizedUpimagecreatefromgd2
#

#T=resource imagecreate ( int x_size, int y_size)
imagecreate ( ^!int x_size, int y_size);
#

#T=imagecreatefromgd - resource imagecreatefromgd ( string filename)
(PHP 4 >= 4.1.0)
imagecreatefromgd -- Create a new image from GD file or URL
Description
resource imagecreatefromgd ( string filename)
Warning
This function is currently not documented; only the argument list is 
available.

Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromgd2partUpimagecreatefromgif
#

#T=resource imagecreatefromgd ( string filename)
imagecreatefromgd ( ^!string filename);
#

#T=imagecreatefromgd2 - resource imagecreatefromgd2 ( string filename)
(PHP 4 >= 4.1.0)
imagecreatefromgd2 -- Create a new image from GD2 file or URL
Description
resource imagecreatefromgd2 ( string filename)
Warning
This function is currently not documented; only the argument list is 
available.

Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreateUpimagecreatefromgd2part
#

#T=resource imagecreatefromgd2 ( string filename)
imagecreatefromgd2 ( ^!string filename);
#

#T=imagecreatefromgd2part - resource imagecreatefromgd2part ( string filename, int srcX, int srcY, int 
(PHP 4 >= 4.1.0)
imagecreatefromgd2part -- Create a new image from a given part of GD2 file 
or URL
Description
resource imagecreatefromgd2part ( string filename, int srcX, int srcY, int 
width, int height)
Warning
This function is currently not documented; only the argument list is 
available.

Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromgd2Upimagecreatefromgd
#

#T=resource imagecreatefromgd2part ( string filename, int srcX, int srcY, int 
imagecreatefromgd2part ( ^!string filename, int srcX, int srcY, int ;
#

#T=imagecreatefromgif - resource imagecreatefromgif ( string filename)
(PHP 3, PHP 4 )
imagecreatefromgif -- Create a new image from file or URL
Description
resource imagecreatefromgif ( string filename)
imagecreatefromgif() returns an image identifier representing the image 
obtained from the given filename. 
imagecreatefromgif() returns an empty string on failure. It also outputs 
an error message, which unfortunately displays as a broken link in a 
browser. To ease debugging the following example will produce an error 
GIF: Example 1. Example to handle an error during creation (courtesy 
vic at zymsys dot com) 
  <?php
  function LoadGif ($imgname) {
      $im = @imagecreatefromgif ($imgname); /* Attempt to open 
*/
      if (!$im) { /* See if it failed */
	  $im = imagecreate (150, 30); /* Create a blank image 
*/
	  $bgc = imagecolorallocate ($im, 255, 255, 255);
	  $tc = imagecolorallocate ($im, 0, 0, 0);
	  imagefilledrectangle ($im, 0, 0, 150, 30, $bgc);
	  /* Output an errmsg */
	  imagestring ($im, 1, 5, 5, "Error loading $imgname", 
  $tc);
      }
      return $im;
  }
  ?> 
Note: Since all GIF support was removed from the GD library in version 
1.6, this function is not available if you are using that version of the 
GD library. 
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromgdUpimagecreatefromjpeg
#

#T=resource imagecreatefromgif ( string filename)
imagecreatefromgif ( ^!string filename);
#

#T=imagecreatefromjpeg - resource imagecreatefromjpeg ( string filename)
(PHP 3>= 3.0.16, PHP 4 )
imagecreatefromjpeg -- Create a new image from file or URL
Description
resource imagecreatefromjpeg ( string filename)
imagecreatefromjpeg() returns an image identifier representing the image 
obtained from the given filename. 
imagecreatefromjpeg() returns an empty string on failure. It also outputs 
an error message, which unfortunately displays as a broken link in a 
browser. To ease debugging the following example will produce an error 
JPEG: Example 1. Example to handle an error during creation 
(courtesy vic at zymsys dot com ) 
  <?php
  function LoadJpeg($imgname) {
      $im = @imagecreatefromjpeg($imgname); /* Attempt to open 
*/
      if (!$im) { /* See if it failed */
	  $im  = imagecreate(150, 30); /* Create a blank image 
*/
	  $bgc = imagecolorallocate($im, 255, 255, 255);
	  $tc  = imagecolorallocate($im, 0, 0, 0);
	  imagefilledrectangle($im, 0, 0, 150, 30, $bgc);
	  /* Output an errmsg */
	  imagestring($im, 1, 5, 5, "Error loading $imgname", 
  $tc);
      }
      return $im;
  }
  ?> 
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromgifUpimagecreatefrompng
#

#T=resource imagecreatefromjpeg ( string filename)
imagecreatefromjpeg ( ^!string filename);
#

#T=imagecreatefrompng - resource imagecreatefrompng ( string filename)
(PHP 3>= 3.0.13, PHP 4 )
imagecreatefrompng -- Create a new image from file or URL
Description
resource imagecreatefrompng ( string filename)
imagecreatefrompng() returns an image identifier representing the image 
obtained from the given filename. 
imagecreatefrompng() returns an empty string on failure. It also outputs 
an error message, which unfortunately displays as a broken link in a 
browser. To ease debugging the following example will produce an error 
PNG: Example 1. Example to handle an error during creation (courtesy 
vic at zymsys dot com) 
  <?php
  function LoadPNG($imgname) {
      $im = @imagecreatefrompng($imgname); /* Attempt to open */
      if (!$im) { /* See if it failed */
	  $im  = imagecreate(150, 30); /* Create a blank image 
*/
	  $bgc = imagecolorallocate($im, 255, 255, 255);
	  $tc  = imagecolorallocate($im, 0, 0, 0);
	  imagefilledrectangle($im, 0, 0, 150, 30, $bgc);
	  /* Output an errmsg */
	  imagestring($im, 1, 5, 5, "Error loading $imgname", 
  $tc);
      }
      return $im;
  }
  ?> 
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromjpegUpimagecreatefromstring
#

#T=resource imagecreatefrompng ( string filename)
imagecreatefrompng ( ^!string filename);
#

#T=imagecreatefromstring - resource imagecreatefromstring ( string image)
(PHP 4 >= 4.0.4)
imagecreatefromstring -- Create a new image from the image stream in the 
string
Description
resource imagecreatefromstring ( string image)
imagecreatefromstring() returns an image identifier representing the image 
obtained from the given string.   imagecreatefrompngUpimagecreatefromwbmp
#

#T=resource imagecreatefromstring ( string image)
imagecreatefromstring ( ^!string image);
#

#T=imagecreatefromwbmp - resource imagecreatefromwbmp ( string filename)
(PHP 4 >= 4.0.1)
imagecreatefromwbmp -- Create a new image from file or URL
Description
resource imagecreatefromwbmp ( string filename)
imagecreatefromwbmp() returns an image identifier representing the image 
obtained from the given filename. 
imagecreatefromwbmp() returns an empty string on failure. It also outputs 
an error message, which unfortunately displays as a broken link in a 
browser. To ease debugging the following example will produce an error 
WBMP: Example 1. Example to handle an error during creation 
(courtesy vic at zymsys dot com) 
  <?php
  function LoadWBMP($imgname) {
      $im = @imagecreatefromwbmp($imgname); /* Attempt to open 
*/
      if (!$im) { /* See if it failed */
	  $im  = imagecreate (20, 20); /* Create a blank image 
*/
	  $bgc = imagecolorallocate($im, 255, 255, 255);
	  $tc  = imagecolorallocate($im, 0, 0, 0);
	  imagefilledrectangle($im, 0, 0, 10, 10, $bgc);
	  /* Output an errmsg */
	  imagestring($im, 1, 5, 5, "Error loading $imgname", 
  $tc);
      }
      return $im;
  }
  ?> 
Note: WBMP support is only available if PHP was compiled against GD-1.8 
or later. 
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromstringUpimagecreatefromxbm
#

#T=resource imagecreatefromwbmp ( string filename)
imagecreatefromwbmp ( ^!string filename);
#

#T=imagecreatefromxbm - resource imagecreatefromxbm ( string filename)
(PHP 4 >= 4.0.1)
imagecreatefromxbm -- Create a new image from file or URL
Description
resource imagecreatefromxbm ( string filename)
imagecreatefromxbm() returns an image identifier representing the image 
obtained from the given filename. 
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromwbmpUpimagecreatefromxpm
#

#T=resource imagecreatefromxbm ( string filename)
imagecreatefromxbm ( ^!string filename);
#

#T=imagecreatefromxpm - resource imagecreatefromxpm ( string filename)
(PHP 4 >= 4.0.1)
imagecreatefromxpm -- Create a new image from file or URL
Description
resource imagecreatefromxpm ( string filename)
imagecreatefromxpm() returns an image identifier representing the image 
obtained from the given filename. 
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 
  imagecreatefromxbmUpimagecreatetruecolor
#

#T=resource imagecreatefromxpm ( string filename)
imagecreatefromxpm ( ^!string filename);
#

#T=imagecreatetruecolor - resource imagecreatetruecolor ( int x_size, int y_size)
(PHP 4 >= 4.0.6)
imagecreatetruecolor -- Create a new true color image
Description
resource imagecreatetruecolor ( int x_size, int y_size)
imagecreatetruecolor() returns an image identifier representing a black 
image of size x_size by y_size. 
Example 1. Creating a new GD image stream and outputting an image. 
  <?php
  header ("Content-type: image/png");
  $im = @imagecreatetruecolor(50, 100)
	or die("Cannot Initialize new GD image stream");
  $text_color = imagecolorallocate($im, 233, 14, 91);
  imagestring($im, 1, 5, 5,  "A Simple Text String", 
  $text_color);
  imagepng($im);
  imagedestroy($im);
  ?> 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1 or 
later. 
Note: This function will not work with GIF file formats. 
See also imagedestroy() and imagecreate().   imagecreatefromxpmUpimagedashedline
#

#T=resource imagecreatetruecolor ( int x_size, int y_size)
imagecreatetruecolor ( ^!int x_size, int y_size);
#

#T=imagedashedline - int imagedashedline ( resource image, int x1, int y1, int x2, int y2, int 
(PHP 3, PHP 4 )
imagedashedline -- Draw a dashed line
Description
int imagedashedline ( resource image, int x1, int y1, int x2, int y2, int 
color)
This function is deprecated. Use combination of imagesetstyle() and 
imageline() instead.   imagecreatetruecolorUpimagedestroy
#

#T=int imagedashedline ( resource image, int x1, int y1, int x2, int y2, int 
imagedashedline ( ^!resource image, int x1, int y1, int x2, int y2, int ;
#

#T=imagedestroy - int imagedestroy ( resource image)
(PHP 3, PHP 4 )
imagedestroy -- Destroy an image
Description
int imagedestroy ( resource image)
imagedestroy() frees any memory associated with image image. image is the 
image identifier returned by the imagecreate() function.   imagedashedlineUpimageellipse
#

#T=int imagedestroy ( resource image)
imagedestroy ( ^!resource image);
#

#T=imageellipse - int imageellipse ( resource image, int cx, int cy, int w, int h, int 
(PHP 4 >= 4.0.6)
imageellipse -- Draw an ellipse
Description
int imageellipse ( resource image, int cx, int cy, int w, int h, int 
color)
imageellipse() draws an ellipse centered at cx, cy (top left is 0, 0) in 
the image represented by image. W and h specifies the ellipse's width and 
height respectively. The color of the ellipse is specified by color. 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.2 or 
later which can be obtained at http://www.boutell.com/gd/ 
Example 1. imageellipse() example
  <?php

  // create a blank image
  $image = imagecreate(400, 300);

  // fill the background color
  $bg = imagecolorallocate($image, 0, 0, 0);

  // choose a color for the ellipse
  $col_ellipse = imagecolorallocate($image, 255, 255, 255);

  // draw the ellipse
  imageellipse($image, 200, 150, 300, 200, $col_ellipse);

  // output the picture
  header("Content-type: image/png");
  imagepng($image);

  ?> 
See also imagefilledellipse() and imagearc().   imagedestroyUpimagefill
#

#T=int imageellipse ( resource image, int cx, int cy, int w, int h, int 
imageellipse ( ^!resource image, int cx, int cy, int w, int h, int ;
#

#T=imagefill - int imagefill ( resource image, int x, int y, int color)
(PHP 3, PHP 4 )
imagefill -- Flood fill
Description
int imagefill ( resource image, int x, int y, int color)
imagefill() performs a flood fill starting at coordinate x, y (top left is 
0, 0) with color color in the image image.   imageellipseUpimagefilledarc
#

#T=int imagefill ( resource image, int x, int y, int color)
imagefill ( ^!resource image, int x, int y, int color);
#

#T=imagefilledarc - bool imagefilledarc ( resource image, int cx, int cy, int w, int h, int s, 
(PHP 4 >= 4.0.6)
imagefilledarc -- Draw a partial ellipse and fill it
Description
bool imagefilledarc ( resource image, int cx, int cy, int w, int h, int s, 
int e, int color, int style)
imagefilledarc() draws a partial ellipse centered at cx, cy (top left is 
0, 0) in the image represented by image. Returns TRUE on success or FALSE 
on failure. W and h specifies the ellipse's width and height respectively 
while the start and end points are specified in degrees indicated by the s 
and e arguments. style is a bitwise OR of the following possibilities: 
IMG_ARC_PIE
IMG_ARC_CHORD
IMG_ARC_NOFILL
IMG_ARC_EDGED
IMG_ARC_PIE and IMG_ARC_CHORD are mutually exclusive; IMG_ARC_CHORD just 
connects the starting and ending angles with a straight line, while 
IMG_ARC_PIE produces a rounded edge. IMG_ARC_NOFILL indicates that the arc 
or chord should be outlined, not filled. IMG_ARC_EDGED, used together with 
IMG_ARC_NOFILL, indicates that the beginning and ending angles should be 
connected to the center - this is a good way to outline (rather than fill) 
a 'pie slice'. 
Example 1. Creating a 3D looking pie
  <?php

  // this example is provided by poxy at klam dot is

  // create image
  $image = imagecreate(100, 100);

  // allocate some solors
  $white    = imagecolorallocate($image, 0xFF, 0xFF, 0xFF);
  $gray     = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);
  $darkgray = imagecolorallocate($image, 0x90, 0x90, 0x90);
  $navy     = imagecolorallocate($image, 0x00, 0x00, 0x80);
  $darknavy = imagecolorallocate($image, 0x00, 0x00, 0x50);
  $red      = imagecolorallocate($image, 0xFF, 0x00, 0x00);
  $darkred  = imagecolorallocate($image, 0x90, 0x00, 0x00);

  // make the 3D effect
  for ($i = 60; $i > 50; $i--) {
     imagefilledarc($image, 50, $i, 100, 50, 0, 45, $darknavy, 
  IMG_ARC_PIE);
    imagefilledarc($image, 50, $i, 100, 50, 45, 75 , $darkgray, 
  IMG_ARC_PIE);
    imagefilledarc($image, 50, $i, 100, 50, 75, 360 , $darkred, 
  IMG_ARC_PIE);
  }

  imagefilledarc($image, 50, 50, 100, 50, 0, 45, $navy, 
  IMG_ARC_PIE);
  imagefilledarc($image, 50, 50, 100, 50, 45, 75 , $gray, 
  IMG_ARC_PIE);
  imagefilledarc($image, 50, 50, 100, 50, 75, 360 , $red, 
  IMG_ARC_PIE);
  // flush image
  header('Content-type: image/png');
  imagepng($image);
  imagedestroy($image);
  ?> 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1   imagefillUpimagefilledellipse
#

#T=bool imagefilledarc ( resource image, int cx, int cy, int w, int h, int s, 
imagefilledarc ( ^!resource image, int cx, int cy, int w, int h, int s, ;
#

#T=imagefilledellipse - bool imagefilledellipse ( resource image, int cx, int cy, int w, int h, 
(PHP 4 >= 4.0.6)
imagefilledellipse -- Draw a filled ellipse
Description
bool imagefilledellipse ( resource image, int cx, int cy, int w, int h, 
int color)
imagefilledellipse() draws an ellipse centered at cx, cy (top left is 0, 
0) in the image represented by image. W and h specifies the ellipse's 
width and height respectively. The ellipse is filled using color. Returns 
TRUE on success or FALSE on failure. 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1 or 
later 
Example 1. imagefilledellipse() example
  <?php

  // create a blank image
  $image = imagecreate(400, 300);

  // fill the background color
  $bg = imagecolorallocate($image, 0, 0, 0);

  // choose a color for the ellipse
  $col_ellipse = imagecolorallocate($image, 255, 255, 255);

  // draw the white ellipse
  imagefilledellipse($image, 200, 150, 300, 200, $col_ellipse);

  // output the picture
  header("Content-type: image/png");
  imagepng($image);

  ?> 
See also imageellipse() and imagefilledarc().   imagefilledarcUpimagefilledpolygon
#

#T=bool imagefilledellipse ( resource image, int cx, int cy, int w, int h, 
imagefilledellipse ( ^!resource image, int cx, int cy, int w, int h, ;
#

#T=imagefilledpolygon - int imagefilledpolygon ( resource image, array points, int num_points, int 
(PHP 3, PHP 4 )
imagefilledpolygon -- Draw a filled polygon
Description
int imagefilledpolygon ( resource image, array points, int num_points, int 
color)
imagefilledpolygon() creates a filled polygon in image image. points is a 
PHP array containing the polygon's vertices, i.e. points[0] = x0, 
points[1] = y0, points[2] = x1, points[3] = y1, etc. num_points is the 
total number of vertices. 
Example 1. imagefilledpolygon() example
  <?php

  // this example is provided by ecofarm at mullum dot com dot 
au

  // set up array of points for polygon
  $values = array(
    0  => 40,    // x1
    1  => 50,    // y1
    2  => 20,    // x2
    3  => 240,   // y2
    4  => 60,    // x3
    5  => 60,    // y3
    6  => 240,   // x4
    7  => 20,    // y4
    8  => 50,    // x5
    9  => 40,    // y5
    10 => 10,    // x6
    11 => 10,    // y6
  );

  // create image
  $im = imagecreate(250, 250);

  // some colors
  $bg   = imagecolorallocate($im, 255, 255, 255);
  $blue = imagecolorallocate($im, 0, 0, 255);

  // draw a polygon
  imagefilledpolygon($im, $values, 6, $blue );

  // flush image
  header('Content-type: image/png');
  imagepng($im);
  imagedestroy($im);

  ?> 

  imagefilledellipseUpimagefilledrectangle
#

#T=int imagefilledpolygon ( resource image, array points, int num_points, int 
imagefilledpolygon ( ^!resource image, array points, int num_points, int ;
#

#T=imagefilledrectangle - int imagefilledrectangle ( resource image, int x1, int y1, int x2, int y2, 
(PHP 3, PHP 4 )
imagefilledrectangle -- Draw a filled rectangle
Description
int imagefilledrectangle ( resource image, int x1, int y1, int x2, int y2, 
int color)
imagefilledrectangle() creates a filled rectangle of color color in image 
image starting at upper left coordinates x1, y1 and ending at bottom right 
coordinates x2, y2. 0, 0 is the top left corner of the image.   imagefilledpolygonUpimagefilltoborder
#

#T=int imagefilledrectangle ( resource image, int x1, int y1, int x2, int y2, 
imagefilledrectangle ( ^!resource image, int x1, int y1, int x2, int y2, ;
#

#T=imagefilltoborder - int imagefilltoborder ( resource image, int x, int y, int border, int 
(PHP 3, PHP 4 )
imagefilltoborder -- Flood fill to specific color
Description
int imagefilltoborder ( resource image, int x, int y, int border, int 
color)
imagefilltoborder() performs a flood fill whose border color is defined by 
border. The starting point for the fill is x, y (top left is 0, 0) and the 
region is filled with color color.   imagefilledrectangleUpimagefontheight
#

#T=int imagefilltoborder ( resource image, int x, int y, int border, int 
imagefilltoborder ( ^!resource image, int x, int y, int border, int ;
#

#T=imagefontheight - int imagefontheight ( int font)
(PHP 3, PHP 4 )
imagefontheight -- Get font height
Description
int imagefontheight ( int font)
Returns the pixel height of a character in the specified font. 
See also imagefontwidth() and imageloadfont().   imagefilltoborderUpimagefontwidth
#

#T=int imagefontheight ( int font)
imagefontheight ( ^!int font);
#

#T=imagefontwidth - int imagefontwidth ( int font)
(PHP 3, PHP 4 )
imagefontwidth -- Get font width
Description
int imagefontwidth ( int font)
Returns the pixel width of a character in font. 
See also imagefontheight() and imageloadfont().   imagefontheightUpimageftbbox
#

#T=int imagefontwidth ( int font)
imagefontwidth ( ^!int font);
#

#T=imageftbbox - array imageftbbox ( int size, int angle, string font_file, string text [, 
(PHP 4 >= 4.1.0)
imageftbbox -- Give the bounding box of a text using fonts via freetype2
Description
array imageftbbox ( int size, int angle, string font_file, string text [, 
array extrainfo])
Warning
This function is currently not documented; only the argument list is 
available.
  imagefontwidthUpimagefttext
#

#T=array imageftbbox ( int size, int angle, string font_file, string text [, 
imageftbbox ( ^!int size, int angle, string font_file, string text [, ;
#

#T=imagefttext - array imagefttext ( resource image, int size, int angle, int x, int y, int 
(PHP 4 >= 4.1.0)
imagefttext -- Write text to the image using fonts using FreeType 2
Description
array imagefttext ( resource image, int size, int angle, int x, int y, int 
col, string font_file, string text [, array extrainfo])
Warning
This function is currently not documented; only the argument list is 
available.
  imageftbboxUpimagegammacorrect
#

#T=array imagefttext ( resource image, int size, int angle, int x, int y, int 
imagefttext ( ^!resource image, int size, int angle, int x, int y, int ;
#

#T=imagegammacorrect - int imagegammacorrect ( resource image, float inputgamma, float 
(PHP 3>= 3.0.13, PHP 4 )
imagegammacorrect -- Apply a gamma correction to a GD image
Description
int imagegammacorrect ( resource image, float inputgamma, float 
outputgamma)
The imagegammacorrect() function applies gamma correction to a gd image 
stream (image) given an input gamma, the parameter inputgamma and an 
output gamma, the parameter outputgamma.   imagefttextUpimagegd2
#

#T=int imagegammacorrect ( resource image, float inputgamma, float 
imagegammacorrect ( ^!resource image, float inputgamma, float ;
#

#T=imagegd - int imagegd ( resource image [, string filename])
(PHP 4 >= 4.1.0)
imagegd -- Output GD image to browser or file
Description
int imagegd ( resource image [, string filename])
Warning
This function is currently not documented; only the argument list is 
available.
  imagegd2Upimagegif
#

#T=int imagegd ( resource image [, string filename])
imagegd ( ^!resource image [, string filename]);
#

#T=imagegd2 - int imagegd2 ( resource image [, string filename [, int chunk_size [, int 
(PHP 4 >= 4.1.0)
imagegd2 -- Output GD2 image
Description
int imagegd2 ( resource image [, string filename [, int chunk_size [, int 
type]]])
imagegd2() outputs GD2 image to browser or file. 
The optional type parameter is either IMG_GD2_RAW or IMG_GD2_COMPRESSED. 
Default is IMG_GD2_RAW. 
Note: The optional chunk_size and type parameters became available in 
PHP 4.3.2.   imagegammacorrectUpimagegd
#

#T=int imagegd2 ( resource image [, string filename [, int chunk_size [, int 
imagegd2 ( ^!resource image [, string filename [, int chunk_size [, int ;
#

#T=imagegif - int imagegif ( resource image [, string filename])
(PHP 3, PHP 4 )
imagegif -- Output image to browser or file
Description
int imagegif ( resource image [, string filename])
imagegif() creates the GIF file in filename from the image image. The 
image argument is the return from the imagecreate() function. 
The image format will be GIF87a unless the image has been made transparent 
with imagecolortransparent(), in which case the image format will be 
GIF89a. 
The filename argument is optional, and if left off, the raw image stream 
will be output directly. By sending an image/gif content-type using 
header(), you can create a PHP script that outputs GIF images directly. 
Note: Since all GIF support was removed from the GD library in version 
1.6, this function is not available if you are using that version of the 
GD library. Support is expected to return in a version subsequent to the 
rerelease of GIF support in the GD library in mid 2004. For more 
information, see the GD Project site. 
The following code snippet allows you to write more portable PHP 
applications by auto-detecting the type of GD support which is 
available. Replace the sequence header ("Content-type: image/gif"); 
imagegif ($im); by the more flexible sequence: 
<?php
if (function_exists("imagegif")) {
  header("Content-type: image/gif");
  imagegif($im);
} elseif (function_exists("imagejpeg")) {
  header("Content-type: image/jpeg");
  imagejpeg($im, "", 0.5);
} elseif (function_exists("imagepng")) {
  header("Content-type: image/png");
  imagepng($im);
} elseif (function_exists("imagewbmp")) {
  header("Content-type: image/vnd.wap.wbmp");
  imagewbmp($im);
} else {
  die("No image support in this PHP server");
}
?> 

Note: As of version 3.0.18 and 4.0.2 you can use the function 
imagetypes() in place of function_exists() for checking the presence of 
the various supported image formats: 
<?php
if (imagetypes() & IMG_GIF) {
  header ("Content-type: image/gif");
  imagegif ($im);
} elseif (imagetypes() & IMG_JPG) {
  /* ... etc. */
}
?> 

See also imagepng(), imagewbmp(), imagejpeg() and imagetypes().   imagegdUpimageinterlace
#

#T=int imagegif ( resource image [, string filename])
imagegif ( ^!resource image [, string filename]);
#

#T=imageinterlace - int imageinterlace ( resource image [, int interlace])
(PHP 3, PHP 4 )
imageinterlace -- Enable or disable interlace
Description
int imageinterlace ( resource image [, int interlace])
imageinterlace() turns the interlace bit on or off. If interlace is 1 the 
image will be interlaced, and if interlace is 0 the interlace bit is 
turned off. 
If the interlace bit is set and the image is used as a JPEG image, the 
image is created as a progressive JPEG. 
This function returns whether the interlace bit is set for the image.   imagegifUpimageistruecolor
#

#T=int imageinterlace ( resource image [, int interlace])
imageinterlace ( ^!resource image [, int interlace]);
#

#T=imageistruecolor - bool imageistruecolor ( resource image)
(PHP 4 >= 4.3.2)
imageistruecolor -- Finds whether an image is a truecolor image.
Description
bool imageistruecolor ( resource image)
imageistruecolor() finds whether the image image is a truecolor image. 
See also imagecreatetruecolor().   imageinterlaceUpimagejpeg
#

#T=bool imageistruecolor ( resource image)
imageistruecolor ( ^!resource image);
#

#T=imagejpeg - int imagejpeg ( resource image [, string filename [, int quality]])
(PHP 3>= 3.0.16, PHP 4 )
imagejpeg -- Output image to browser or file
Description
int imagejpeg ( resource image [, string filename [, int quality]])
imagejpeg() creates the JPEG file in filename from the image image. The 
image argument is the return from the imagecreate() function. 
The filename argument is optional, and if left off, the raw image stream 
will be output directly. To skip the filename argument in order to provide 
a quality argument just use an empty string (''). By sending an image/jpeg 
content-type using header(), you can create a PHP script that outputs JPEG 
images directly. 
Note: JPEG support is only available if PHP was compiled against GD-1.8 
or later. 
quality is optional, and ranges from 0 (worst quality, smaller file) to 
100 (best quality, biggest file). The default is the default IJG quality 
value (about 75). 
If you want to output Progressive JPEGs, you need to set interlacing on 
with imageinterlace(). 
See also imagepng(), imagegif(), imagewbmp(), imageinterlace() and 
imagetypes().   imageistruecolorUpimageline
#

#T=int imagejpeg ( resource image [, string filename [, int quality]])
imagejpeg ( ^!resource image [, string filename [, int quality]]);
#

#T=imageline - int imageline ( resource image, int x1, int y1, int x2, int y2, int color)
(PHP 3, PHP 4 )
imageline -- Draw a line
Description
int imageline ( resource image, int x1, int y1, int x2, int y2, int color)
imageline() draws a line from x1, y1 to x2, y2 (top left is 0, 0) in image 
image of color color. 
Example 1. Drawing a thick line
  <?php

  function imagelinethick($image, $x1, $y1, $x2, $y2, $color, 
  $thick = 1) {
      /* this way it works well only for orthogonal lines
      imagesetthickness($image, $thick);
      return imageline($image, $x1, $y1, $x2, $y2, $color);
      */
      if ($thick == 1) {
	  return imageline($image, $x1, $y1, $x2, $y2, $color);
      }
      $t = $thick / 2 - 0.5;
      if ($x1 == $x2 || $y1 == $y2) {
	  return imagefilledrectangle($image, round(min($x1, 
  $x2) - $t), round(min($y1, $y2) - $t), round(max($x1, $x2) + 
  $t), round(max($y1, $y2) + $t), $color);
      }
      $k = ($y2 - $y1) / ($x2 - $x1); //y = kx + q
      $a = $t / sqrt(1 + pow($k, 2));
      $points = array(
	  round($x1 - (1+$k)*$a), round($y1 + (1-$k)*$a),
	  round($x1 - (1-$k)*$a), round($y1 - (1+$k)*$a),
	  round($x2 + (1+$k)*$a), round($y2 - (1-$k)*$a),
	  round($x2 + (1-$k)*$a), round($y2 + (1+$k)*$a),
      );    
      imagefilledpolygon($image, $points, 4, $color);
      return imagepolygon($image, $points, 4, $color);
  }

  ?> 
See also imagecreate() and imagecolorallocate().   imagejpegUpimageloadfont
#

#T=int imageline ( resource image, int x1, int y1, int x2, int y2, int color)
imageline ( ^!resource image, int x1, int y1, int x2, int y2, int color);
#

#T=imageloadfont - int imageloadfont ( string file)
(PHP 3, PHP 4 )
imageloadfont -- Load a new font
Description
int imageloadfont ( string file)
imageloadfont() loads a user-defined bitmap font and returns an identifier 
for the font (that is always greater than 5, so it will not conflict with 
the built-in fonts). 
The font file format is currently binary and architecture dependent. This 
means you should generate the font files on the same type of CPU as the 
machine you are running PHP on. 
Table 1. Font file format
byte positionC data typedescription
byte 0-3intnumber of characters in the font
byte 4-7intvalue of first character in the font (often 32 for space) 

byte 8-11intpixel width of each character
byte 12-15intpixel height of each character
byte 16-chararray with character data, one byte per pixel in each 
character, for a total of (nchars*width*height) bytes. 

See also imagefontwidth() and imagefontheight().   imagelineUpimagepalettecopy
#

#T=int imageloadfont ( string file)
imageloadfont ( ^!string file);
#

#T=imagepalettecopy - int imagepalettecopy ( resource destination, resource source)
(PHP 4 >= 4.0.1)
imagepalettecopy -- Copy the palette from one image to another
Description
int imagepalettecopy ( resource destination, resource source)
imagepalettecopy() copies the palette from the source image to the 
destination image.   imageloadfontUpimagepng
#

#T=int imagepalettecopy ( resource destination, resource source)
imagepalettecopy ( ^!resource destination, resource source);
#

#T=imagepng - int imagepng ( resource image [, string filename])
(PHP 3>= 3.0.13, PHP 4 )
imagepng -- Output a PNG image to either the browser or a file
Description
int imagepng ( resource image [, string filename])
The imagepng() outputs a GD image stream (image) in PNG format to standard 
output (usually the browser) or, if a filename is given by the filename it 
outputs the image to the file. 
<?php
$im = imagecreatefrompng("test.png");
imagepng($im);
?> 

See also imagegif(), imagewbmp(), imagejpeg(), imagetypes().   imagepalettecopyUpimagepolygon
#

#T=int imagepng ( resource image [, string filename])
imagepng ( ^!resource image [, string filename]);
#

#T=imagepolygon - int imagepolygon ( resource image, array points, int num_points, int 
(PHP 3, PHP 4 )
imagepolygon -- Draw a polygon
Description
int imagepolygon ( resource image, array points, int num_points, int 
color)
imagepolygon() creates a polygon in image id. points is a PHP array 
containing the polygon's vertices, i.e. points[0] = x0, points[1] = y0, 
points[2] = x1, points[3] = y1, etc. num_points is the total number of 
points (vertices). 
Example 1. imagepolygon() example
  <?php
  // create a blank image
  $image = imagecreate(400, 300);

  // fill the background color
  $bg = imagecolorallocate($image, 0, 0, 0);

  // choose a color for the polygon
  $col_poly = imagecolorallocate($image, 255, 255, 255);

  // draw the polygon
  imagepolygon($image, 
	       array (
		      0, 0,
		      100, 200,
		      300, 200
	       ),
	       3,
	       $col_poly);

  // output the picture
  header("Content-type: image/png");
  imagepng($image);

  ?> 
See also imagecreate() and imagecreatetruecolor().   imagepngUpimagepsbbox
#

#T=int imagepolygon ( resource image, array points, int num_points, int 
imagepolygon ( ^!resource image, array points, int num_points, int ;
#

#T=imagepsbbox - array imagepsbbox ( string text, int font, int size [, int space [, int 
(PHP 3>= 3.0.9, PHP 4 )
imagepsbbox --  Give the bounding box of a text rectangle using PostScript 
Type1 fonts 
Description
array imagepsbbox ( string text, int font, int size [, int space [, int 
tightness [, float angle]]])
size is expressed in pixels. 
space allows you to change the default value of a space in a font. This 
amount is added to the normal value and can also be negative. 
tightness allows you to control the amount of white space between 
characters. This amount is added to the normal character width and can 
also be negative. 
angle is in degrees. 
Parameters space and tightness are expressed in character space units, 
where 1 unit is 1/1000th of an em-square. 
Parameters space, tightness, and angle are optional. 
The bounding box is calculated using information available from character 
metrics, and unfortunately tends to differ slightly from the results 
achieved by actually rasterizing the text. If the angle is 0 degrees, you 
can expect the text to need 1 pixel more to every direction. 
Note: This function is only available if PHP is compiled using 
--enable-t1lib. 
This function returns an array containing the following elements: 
0lower left x-coordinate
1lower left y-coordinate
2upper right x-coordinate
3upper right y-coordinate

See also imagepstext().   imagepolygonUpimagepscopyfont
#

#T=array imagepsbbox ( string text, int font, int size [, int space [, int 
imagepsbbox ( ^!string text, int font, int size [, int space [, int ;
#

#T=imagepscopyfont - int imagepscopyfont ( int fontindex)
(PHP 3>= 3.0.9, PHP 4 )
imagepscopyfont --  Make a copy of an already loaded font for further 
modification 
Description
int imagepscopyfont ( int fontindex)
Use this function if you need make further modifications to the font, for 
example extending/condensing, slanting it or changing it's character 
encoding vector, but need to keep the original along as well. Note that 
the font you want to copy must be one obtained using imagepsloadfont(), 
not a font that is itself a copied one. You can although make 
modifications to it before copying. 
If you use this function, you must free the fonts obtained this way 
yourself and in reverse order. Otherwise your script will hang. 
In the case everything went right, a valid font index will be returned and 
can be used for further purposes. Otherwise the function returns FALSE and 
prints a message describing what went wrong. 
Note: This function is only available if PHP is compiled using 
--enable-t1lib. 
See also imagepsloadfont().   imagepsbboxUpimagepsencodefont
#

#T=int imagepscopyfont ( int fontindex)
imagepscopyfont ( ^!int fontindex);
#

#T=imagepsencodefont - int imagepsencodefont ( int font_index, string encodingfile)
(PHP 3>= 3.0.9, PHP 4 )
imagepsencodefont -- Change the character encoding vector of a font
Description
int imagepsencodefont ( int font_index, string encodingfile)
Loads a character encoding vector from a file and changes the fonts 
encoding vector to it. As a PostScript fonts default vector lacks most of 
the character positions above 127, you'll definitely want to change this 
if you use an other language than English. The exact format of this file 
is described in T1libs documentation. T1lib comes with two ready-to-use 
files, IsoLatin1.enc and IsoLatin2.enc. 
If you find yourself using this function all the time, a much better way 
to define the encoding is to set ps.default_encoding in the configuration 
file to point to the right encoding file and all fonts you load will 
automatically have the right encoding. 
Note: This function is only available if PHP is compiled using 
--enable-t1lib.   imagepscopyfontUpimagepsextendfont
#

#T=int imagepsencodefont ( int font_index, string encodingfile)
imagepsencodefont ( ^!int font_index, string encodingfile);
#

#T=imagepsextendfont - bool imagepsextendfont ( int font_index, float extend)
(PHP 3>= 3.0.9, PHP 4 )
imagepsextendfont -- Extend or condense a font
Description
bool imagepsextendfont ( int font_index, float extend)
Extend or condense a font (font_index), if the value of the extend 
parameter is less than one you will be condensing the font. 
Note: This function is only available if PHP is compiled using 
--enable-t1lib.   imagepsencodefontUpimagepsfreefont
#

#T=bool imagepsextendfont ( int font_index, float extend)
imagepsextendfont ( ^!int font_index, float extend);
#

#T=imagepsfreefont - void imagepsfreefont ( int fontindex)
(PHP 3>= 3.0.9, PHP 4 )
imagepsfreefont -- Free memory used by a PostScript Type 1 font
Description
void imagepsfreefont ( int fontindex)
imagepsfreefont() frees memory used by a PostScript Type 1 font. 
Note: This function is only available if PHP is compiled using 
--enable-t1lib. 
See also imagepsloadfont().   imagepsextendfontUpimagepsloadfont
#

#T=void imagepsfreefont ( int fontindex)
imagepsfreefont ( ^!int fontindex);
#

#T=imagepsloadfont - int imagepsloadfont ( string filename)
(PHP 3>= 3.0.9, PHP 4 )
imagepsloadfont -- Load a PostScript Type 1 font from file
Description
int imagepsloadfont ( string filename)
In the case everything went right, a valid font index will be returned and 
can be used for further purposes. Otherwise the function returns FALSE and 
prints a message describing what went wrong, which you cannot read 
directly, while the output type is image. 
Example 1. imagepsloadfont() example
  <?php
  header("Content-type: image/jpeg");
  $im = imagecreate(350, 45);
  $black = imagecolorallocate($im, 0, 0, 0);
  $white = imagecolorallocate($im, 255, 255, 255);
  $font = imagepsloadfont("bchbi.pfb"); // or locate your .pfb 
  files on your machine
  imagepstext($im, "Testing... It worked!", $font, 32, $white, 
  $black, 32, 32);
  imagepsfreefont($font);
  imagejpeg($im, "", 100); //for best quality...your mileage may 
  vary
  imagedestroy($im);
  ?> 
Note: This function is only available if PHP is compiled using 
--enable-t1lib. 
See also imagepsfreefont().   imagepsfreefontUpimagepsslantfont
#

#T=int imagepsloadfont ( string filename)
imagepsloadfont ( ^!string filename);
#

#T=imagepsslantfont - bool imagepsslantfont ( int font_index, float slant)
(PHP 3>= 3.0.9, PHP 4 )
imagepsslantfont -- Slant a font
Description
bool imagepsslantfont ( int font_index, float slant)
Slant a font given by the font_index parameter with a slant of the value 
of the slant parameter. 
Note: This function is only available if PHP is compiled using 
--enable-t1lib.   imagepsloadfontUpimagepstext
#

#T=bool imagepsslantfont ( int font_index, float slant)
imagepsslantfont ( ^!int font_index, float slant);
#

#T=imagepstext - array imagepstext ( resource image, string text, int font, int size, int 
(PHP 3>= 3.0.9, PHP 4 )
imagepstext -- To draw a text string over an image using PostScript Type1 
fonts
Description
array imagepstext ( resource image, string text, int font, int size, int 
foreground, int background, int x, int y [, int space [, int tightness [, 
float angle [, int antialias_steps]]]])
foreground is the color in which the text will be painted. Background is 
the color to which the text will try to fade in with antialiasing. No 
pixels with the color background are actually painted, so the background 
image does not need to be of solid color. 
The coordinates given by x, y will define the origin (or reference point) 
of the first character (roughly the lower-left corner of the character). 
This is different from the imagestring(), where x, y define the 
upper-right corner of the first character. Refer to PostScript 
documentation about fonts and their measuring system if you have trouble 
understanding how this works. 
space allows you to change the default value of a space in a font. This 
amount is added to the normal value and can also be negative. 
tightness allows you to control the amount of white space between 
characters. This amount is added to the normal character width and can 
also be negative. 
angle is in degrees. 
size is expressed in pixels. 
antialias_steps allows you to control the number of colours used for 
antialiasing text. Allowed values are 4 and 16. The higher value is 
recommended for text sizes lower than 20, where the effect in text quality 
is quite visible. With bigger sizes, use 4. It's less computationally 
intensive. 
Parameters space and tightness are expressed in character space units, 
where 1 unit is 1/1000th of an em-square. 
Parameters space, tightness, angle and antialias_steps are optional. 
Note: This function is only available if PHP is compiled using 
--enable-t1lib. 
This function returns an array containing the following elements: 
0lower left x-coordinate
1lower left y-coordinate
2upper right x-coordinate
3upper right y-coordinate

See also imagepsbbox().   imagepsslantfontUpimagerectangle
#

#T=array imagepstext ( resource image, string text, int font, int size, int 
imagepstext ( ^!resource image, string text, int font, int size, int ;
#

#T=imagerectangle - int imagerectangle ( resource image, int x1, int y1, int x2, int y2, int 
(PHP 3, PHP 4 )
imagerectangle -- Draw a rectangle
Description
int imagerectangle ( resource image, int x1, int y1, int x2, int y2, int 
col)
imagerectangle() creates a rectangle of color col in image image starting 
at upper left coordinate x1, y1 and ending at bottom right coordinate x2, 
y2. 0, 0 is the top left corner of the image.   imagepstextUpimagerotate
#

#T=int imagerectangle ( resource image, int x1, int y1, int x2, int y2, int 
imagerectangle ( ^!resource image, int x1, int y1, int x2, int y2, int ;
#

#T=imagerotate - resource imagerotate ( resource src_im, float angle, int bgd_color)
(PHP 4 >= 4.3.0)
imagerotate -- Rotate an image with a given angle
Description
resource imagerotate ( resource src_im, float angle, int bgd_color)
Rotates the src_im image using a given angle in degree. bgd_color 
specifies the color of the uncovered zone after the rotation.   imagerectangleUpimagesavealpha
#

#T=resource imagerotate ( resource src_im, float angle, int bgd_color)
imagerotate ( ^!resource src_im, float angle, int bgd_color);
#

#T=imagesavealpha - bool imagesavealpha ( resource image, bool saveflag)
(PHP 4 >= 4.3.2)
imagesavealpha --  Set the flag to save full alpha channel information (as 
opposed to single-color transparency) when saving PNG images. 
Description
bool imagesavealpha ( resource image, bool saveflag)
imagesavealpha() sets the flag to attempt to save full alpha channel 
information (as opposed to single-color transparency) when saving PNG 
images. 
You have to unset alphablending (imagealphablending($im, FALSE)), to use 
it. 
Alpha channel is not supported by all browsers, if you have problem with 
your browser, try to load your script with an alpha channel compliant 
browser, e.g. latest Mozilla. 
See also imagealphablending().   imagerotateUpimagesetbrush
#

#T=bool imagesavealpha ( resource image, bool saveflag)
imagesavealpha ( ^!resource image, bool saveflag);
#

#T=imagesetbrush - int imagesetbrush ( resource image, resource brush)
(PHP 4 >= 4.0.6)
imagesetbrush -- Set the brush image for line drawing
Description
int imagesetbrush ( resource image, resource brush)
imagesetbrush() sets the brush image to be used by all line drawing 
functions (such as imageline() and imagepolygon()) when drawing with the 
special colors IMG_COLOR_BRUSHED or IMG_COLOR_STYLEDBRUSHED. 
Note: You need not take special action when you are finished with a 
brush, but if you destroy the brush image, you must not use the 
IMG_COLOR_BRUSHED or IMG_COLOR_STYLEDBRUSHED colors until you have set a 
new brush image! 
Note: This function was added in PHP 4.0.6  imagesavealphaUpimagesetpixel
#

#T=int imagesetbrush ( resource image, resource brush)
imagesetbrush ( ^!resource image, resource brush);
#

#T=imagesetpixel - int imagesetpixel ( resource image, int x, int y, int color)
(PHP 3, PHP 4 )
imagesetpixel -- Set a single pixel
Description
int imagesetpixel ( resource image, int x, int y, int color)
imagesetpixel() draws a pixel at x, y (top left is 0, 0) in image image of 
color color. 
See also imagecreate() and imagecolorallocate().   imagesetbrushUpimagesetstyle
#

#T=int imagesetpixel ( resource image, int x, int y, int color)
imagesetpixel ( ^!resource image, int x, int y, int color);
#

#T=imagesetstyle - bool imagesetstyle ( resource image, array style)
(PHP 4 >= 4.0.6)
imagesetstyle -- Set the style for line drawing
Description
bool imagesetstyle ( resource image, array style)
imagesetstyle() sets the style to be used by all line drawing functions 
(such as imageline() and imagepolygon()) when drawing with the special 
color IMG_COLOR_STYLED or lines of images with color 
IMG_COLOR_STYLEDBRUSHED. Returns TRUE on success or FALSE on failure. 
The style parameter is an array of pixels. Following example script draws 
a dashed line from upper left to lower right corner of the canvas: 
Example 1. imagesetstyle() example
  <?php
  header("Content-type: image/jpeg");
  $im  = imagecreate(100, 100);
  $w   = imagecolorallocate($im, 255, 255, 255);
  $red = imagecolorallocate($im, 255, 0, 0);

  /* Draw a dashed line, 5 red pixels, 5 white pixels */
  $style = array($red, $red, $red, $red, $red, $w, $w, $w, $w, 
  $w);
  imagesetstyle($im, $style);
  imageline($im, 0, 0, 100, 100, IMG_COLOR_STYLED);

  /* Draw a line of happy faces using imagesetbrush() with 
  imagesetstyle */
  $style = array($w, $w, $w, $w, $w, $w, $w, $w, $w, $w, $w, $w, 
  $red);
  imagesetstyle($im, $style);

  $brush = 
  imagecreatefrompng("http://www.libpng.org/pub/png/images/smile.happy.png");
  $w2 = imagecolorallocate($brush, 255, 255, 255);
  imagecolortransparent($brush, $w2);
  imagesetbrush($im, $brush);
  imageline($im, 100, 0, 0, 100, IMG_COLOR_STYLEDBRUSHED);

  imagejpeg($im);
  imagedestroy($im);
  ?> 
See also imagesetbrush(), imageline(). 
Note: This function was added in PHP 4.0.6  imagesetpixelUpimagesetthickness
#

#T=bool imagesetstyle ( resource image, array style)
imagesetstyle ( ^!resource image, array style);
#

#T=imagesetthickness - bool imagesetthickness ( resource image, int thickness)
(PHP 4 >= 4.0.6)
imagesetthickness -- Set the thickness for line drawing
Description
bool imagesetthickness ( resource image, int thickness)
imagesetthickness() sets the thickness of the lines drawn when drawing 
rectangles, polygons, ellipses etc. etc. to thickness pixels. Returns TRUE 
on success or FALSE on failure. 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1 or 
later  imagesetstyleUpimagesettile
#

#T=bool imagesetthickness ( resource image, int thickness)
imagesetthickness ( ^!resource image, int thickness);
#

#T=imagesettile - int imagesettile ( resource image, resource tile)
(PHP 4 >= 4.0.6)
imagesettile -- Set the tile image for filling
Description
int imagesettile ( resource image, resource tile)
imagesettile() sets the tile image to be used by all region filling 
functions (such as imagefill() and imagefilledpolygon()) when filling with 
the special color IMG_COLOR_TILED. 
A tile is an image used to fill an area with a repeated pattern. Any GD 
image can be used as a tile, and by setting the transparent color index of 
the tile image with imagecolortransparent(), a tile allows certain parts 
of the underlying area to shine through can be created. 
Note: You need not take special action when you are finished with a 
tile, but if you destroy the tile image, you must not use the 
IMG_COLOR_TILED color until you have set a new tile image!   imagesetthicknessUpimagestring
#

#T=int imagesettile ( resource image, resource tile)
imagesettile ( ^!resource image, resource tile);
#

#T=imagestring - int imagestring ( resource image, int font, int x, int y, string s, int 
(PHP 3, PHP 4 )
imagestring -- Draw a string horizontally
Description
int imagestring ( resource image, int font, int x, int y, string s, int 
col)
imagestring() draws the string s in the image identified by image at 
coordinates x, y (top left is 0, 0) in color col. If font is 1, 2, 3, 4 or 
5, a built-in font is used. 
Example 1. imagestring() example
  <?php

    // create a 100*30 image
    $im = imagecreate(100, 30);

    // white background and blue text
    $bg = imagecolorallocate($im, 255, 255, 255);
    $textcolor = imagecolorallocate($im, 0, 0, 255);
    
    // write the string at the top left
    imagestring($im, 5, 0, 0, "Hello world!", $textcolor);
    
    // output the image
    header("Content-type: image/jpg");
    imagejpeg($im);
  ?> 
See also imageloadfont().   imagesettileUpimagestringup
#

#T=int imagestring ( resource image, int font, int x, int y, string s, int 
imagestring ( ^!resource image, int font, int x, int y, string s, int ;
#

#T=imagestringup - int imagestringup ( resource image, int font, int x, int y, string s, int 
(PHP 3, PHP 4 )
imagestringup -- Draw a string vertically
Description
int imagestringup ( resource image, int font, int x, int y, string s, int 
col)
imagestringup() draws the string s vertically in the image identified by 
image at coordinates x, y (top left is 0, 0) in color col. If font is 1, 
2, 3, 4 or 5, a built-in font is used. 
See also imageloadfont().   imagestringUpimagesx
#

#T=int imagestringup ( resource image, int font, int x, int y, string s, int 
imagestringup ( ^!resource image, int font, int x, int y, string s, int ;
#

#T=imagesx - int imagesx ( resource image)
(PHP 3, PHP 4 )
imagesx -- Get image width
Description
int imagesx ( resource image)
imagesx() returns the width of the image identified by image. 
Example 1. Using imagesx()
  <?php

  // create a 300*200 image
  $img = imagecreate(300, 200);

  echo imagesx($img); // 300

  ?> 
See also imagecreate(), getimagesize() and imagesy().   imagestringupUpimagesy
#

#T=int imagesx ( resource image)
imagesx ( ^!resource image);
#

#T=imagesy - int imagesy ( resource image)
(PHP 3, PHP 4 )
imagesy -- Get image height
Description
int imagesy ( resource image)
imagesy() returns the height of the image identified by image. 
Example 1. Using imagesy()
  <?php

  // create a 300*200 image
  $img = imagecreate(300, 200);

  echo imagesy($img); // 200

  ?> 
See also imagecreate(), getimagesize() and imagesx().   imagesxUpimagetruecolortopalette
#

#T=int imagesy ( resource image)
imagesy ( ^!resource image);
#

#T=imagetruecolortopalette - void imagetruecolortopalette ( resource image, bool dither, int ncolors)
(PHP 4 >= 4.0.6)
imagetruecolortopalette -- Convert a true color image to a palette image
Description
void imagetruecolortopalette ( resource image, bool dither, int ncolors)
imagetruecolortopalette() converts a truecolor image to a palette image. 
The code for this function was originally drawn from the Independent JPEG 
Group library code, which is excellent. The code has been modified to 
preserve as much alpha channel information as possible in the resulting 
palette, in addition to preserving colors as well as possible. This does 
not work as well as might be hoped. It is usually best to simply produce a 
truecolor output image instead, which guarantees the highest output 
quality. 
dither indicates if the image should be dithered - if it is TRUE then 
dithering will be used which will result in a more speckled image but with 
better color approximation. 
ncolors sets the maximum number of colors that should be retained in the 
palette. 
Note: This function was added in PHP 4.0.6 and requires GD 2.0.1 or 
later   imagesyUpimagettfbbox
#

#T=void imagetruecolortopalette ( resource image, bool dither, int ncolors)
imagetruecolortopalette ( ^!resource image, bool dither, int ncolors);
#

#T=imagettfbbox - array imagettfbbox ( int size, int angle, string fontfile, string text)
(PHP 3>= 3.0.1, PHP 4 )
imagettfbbox -- Give the bounding box of a text using TrueType fonts
Description
array imagettfbbox ( int size, int angle, string fontfile, string text)
This function calculates and returns the bounding box in pixels for a 
TrueType text. 
text
The string to be measured.
size
The font size in pixels.
fontfile
The name of the TrueType font file. (Can also be an URL.) Depending on 
which version of the GD library that PHP is using, it may attempt to 
search for files that do not begin with a leading '/' by appending 
'.ttf' to the filename and searching along a library-defined font path. 
angle
Angle in degrees in which text will be measured. 
imagettfbbox() returns an array with 8 elements representing four points 
making the bounding box of the text: 
0lower left corner, X position
1lower left corner, Y position
2lower right corner, X position
3lower right corner, Y position
4upper right corner, X position
5upper right corner, Y position
6upper left corner, X position
7upper left corner, Y position

The points are relative to the text regardless of the angle, so "upper 
left" means in the top left-hand corner seeing the text horizontally. 
This function requires both the GD library and the FreeType library. 
See also imagettftext().   imagetruecolortopaletteUpimagettftext
#

#T=array imagettfbbox ( int size, int angle, string fontfile, string text)
imagettfbbox ( ^!int size, int angle, string fontfile, string text);
#

#T=imagettftext - array imagettftext ( resource image, int size, int angle, int x, int y, 
(PHP 3, PHP 4 )
imagettftext -- Write text to the image using TrueType fonts
Description
array imagettftext ( resource image, int size, int angle, int x, int y, 
int color, string fontfile, string text)
imagettftext() draws the string text in the image identified by image, 
starting at coordinates x, y (top left is 0, 0), at an angle of angle in 
color color, using the TrueType font file identified by fontfile. 
Depending on which version of the GD library that PHP is using, when 
fontfile does not begin with a leading '/', '.ttf' will be appended to the 
filename and the library will attempt to search for that filename along a 
library-defined font path. 
The coordinates given by x, y will define the basepoint of the first 
character (roughly the lower-left corner of the character). This is 
different from the imagestring(), where x, y define the upper-right corner 
of the first character. 
angle is in degrees, with 0 degrees being left-to-right reading text (3 
o'clock direction), and higher values representing a counter-clockwise 
rotation. (i.e., a value of 90 would result in bottom-to-top reading 
text). 
fontfile is the path to the TrueType font you wish to use. 
text is the text string which may include UTF-8 character sequences (of 
the form: &#123;) to access characters in a font beyond the first 255. 
color is the color index. Using the negative of a color index has the 
effect of turning off antialiasing. 
imagettftext() returns an array with 8 elements representing four points 
making the bounding box of the text. The order of the points is lower 
left, lower right, upper right, upper left. The points are relative to the 
text regardless of the angle, so "upper left" means in the top left-hand 
corner when you see the text horizontally. 
This example script will produce a black JPEG 400x30 pixels, with the 
words "Testing..." in white in the font Arial. Example 1. 
imagettftext() example
  <?php
    header("Content-type: image/jpeg");
    $im = imagecreate(400, 30);
    $white = imagecolorallocate($im, 255, 255, 255);
    $black = imagecolorallocate($im, 0, 0, 0);
    
    // Replace path by your own font path
    imagettftext($im, 20, 0, 10, 20, $black, "/path/arial.ttf",
    "Testing... Omega: &amp;#937;");
    imagejpeg($im);
    imagedestroy($im);
  ?> 
This function requires both the GD library and the FreeType library. 
See also imagettfbbox().   imagettfbboxUpimagetypes
#

#T=array imagettftext ( resource image, int size, int angle, int x, int y, 
imagettftext ( ^!resource image, int size, int angle, int x, int y, ;
#

#T=imagetypes - int imagetypes ( void )
(PHP 3 CVS only, PHP 4 >= 4.0.2)
imagetypes -- Return the image types supported by this PHP build
Description
int imagetypes ( void )
This function returns a bit-field corresponding to the image formats 
supported by the version of GD linked into PHP. The following bits are 
returned, IMG_GIF | IMG_JPG | IMG_PNG | IMG_WBMP. To check for PNG 
support, for example, do this: Example 1. imagetypes() example
  <?php
  if (imagetypes() & IMG_PNG) {
      echo "PNG Support is enabled";
  }
  ?> 

  imagettftextUpimagewbmp
#

#T=int imagetypes ( void )
imagetypes ( ^!void );
#

#T=imagewbmp - int imagewbmp ( resource image [, string filename [, int foreground]])
(PHP 3>= 3.0.15, PHP 4 >= 4.0.1)
imagewbmp -- Output image to browser or file
Description
int imagewbmp ( resource image [, string filename [, int foreground]])
imagewbmp() creates the WBMP file in filename from the image image. The 
image argument is the return from the imagecreate() function. 
The filename argument is optional, and if left off, the raw image stream 
will be output directly. By sending an image/vnd.wap.wbmp content-type 
using header(), you can create a PHP script that outputs WBMP images 
directly. 
Note: WBMP support is only available if PHP was compiled against GD-1.8 
or later. 
Using the optional foreground parameter, you can set the foreground color. 
Use an identifier obtained from imagecolorallocate(). The default 
foreground color is black. 
See also image2wbmp(), imagepng(), imagegif(), imagejpeg(), imagetypes().   imagetypesUpiptcembed
#

#T=int imagewbmp ( resource image [, string filename [, int foreground]])
imagewbmp ( ^!resource image [, string filename [, int foreground]]);
#

#T=imap_8bit - string imap_8bit ( string string)
(PHP 3, PHP 4 )
imap_8bit --  Convert an 8bit string to a quoted-printable string 
Description
string imap_8bit ( string string)
Convert an 8bit string to a quoted-printable string (according to RFC2045, 
section 6.7). 
Returns a quoted-printable string. 
See also imap_qprint().   IMAP, POP3 and NNTP functionsUpimap_alerts
#

#T=string imap_8bit ( string string)
imap_8bit ( ^!string string);
#

#T=imap_alerts - array imap_alerts ( void )
(PHP 3>= 3.0.12, PHP 4 )
imap_alerts --  This function returns all IMAP alert messages (if any) 
that have occurred during this page request or since the alert stack was 
reset 
Description
array imap_alerts ( void )
This function returns an array of all of the IMAP alert messages generated 
since the last imap_alerts() call, or the beginning of the page. When 
imap_alerts() is called, the alert stack is subsequently cleared. The IMAP 
specification requires that these messages be passed to the user.   imap_8bitUpimap_append
#

#T=array imap_alerts ( void )
imap_alerts ( ^!void );
#

#T=imap_append - bool imap_append ( resource imap_stream, string mbox, string message [, 
(PHP 3, PHP 4 )
imap_append --  Append a string message to a specified mailbox 
Description
bool imap_append ( resource imap_stream, string mbox, string message [, 
string options])
imap_append() appends a string message to the specified mailbox mbox. If 
the optional options is specified, writes the options to that mailbox 
also. 
Returns TRUE on success or FALSE on failure. 
When talking to the Cyrus IMAP server, you must use "\r\n" as your 
end-of-line terminator instead of "\n" or the operation will fail. 
Example 1. imap_append() example
  <?php
  $stream = imap_open("{your.imap.host}INBOX.Drafts", 
  "username", "password");

  $check = imap_check($stream);
  echo "Msg Count before append: ". $check->Nmsgs."\n";

  imap_append($stream, "{your.imap.host}INBOX.Drafts"
		     , "From: me@example.com\r\n"
		     . "To: you@example.com\r\n"
		     . "Subject: test\r\n"
		     . "\r\n"
		     . "this is a test message, please 
  ignore\r\n"
		     );

  $check = imap_check($stream);
  echo "Msg Count after append : ". $check->Nmsgs."\n";

  imap_close($stream);
  ?> 

  imap_alertsUpimap_base64
#

#T=bool imap_append ( resource imap_stream, string mbox, string message [, 
imap_append ( ^!resource imap_stream, string mbox, string message [, ;
#

#T=imap_base64 - string imap_base64 ( string text)
(PHP 3, PHP 4 )
imap_base64 -- Decode BASE64 encoded text
Description
string imap_base64 ( string text)
imap_base64() function decodes BASE-64 encoded text (see RFC2045, Section 
6.8). The decoded message is returned as a string. 
See also imap_binary(), base64_encode() and base64_decode().   imap_appendUpimap_binary
#

#T=string imap_base64 ( string text)
imap_base64 ( ^!string text);
#

#T=imap_binary - string imap_binary ( string string)
(PHP 3>= 3.0.2, PHP 4 )
imap_binary --  Convert an 8bit string to a base64 string 
Description
string imap_binary ( string string)
Convert an 8bit string to a base64 string (according to RFC2045, Section 
6.8). 
Returns a base64 string. 
See also imap_base64().   imap_base64Upimap_body
#

#T=string imap_binary ( string string)
imap_binary ( ^!string string);
#

#T=imap_body - string imap_body ( resource imap_stream, int msg_number [, int options])
(PHP 3, PHP 4 )
imap_body -- Read the message body
Description
string imap_body ( resource imap_stream, int msg_number [, int options])
imap_body() returns the body of the message, numbered msg_number in the 
current mailbox. The optional flags are a bit mask with one or more of the 
following: 
FT_UID - The msgno is a UID 
FT_PEEK - Do not set the \Seen flag if not already set 
FT_INTERNAL - The return string is in internal format, will not 
canonicalize to CRLF. 
imap_body() will only return a verbatim copy of the message body. To 
extract single parts of a multipart MIME-encoded message you have to use 
imap_fetchstructure() to analyze its structure and imap_fetchbody() to 
extract a copy of a single body component.   imap_binaryUpimap_bodystruct
#

#T=string imap_body ( resource imap_stream, int msg_number [, int options])
imap_body ( ^!resource imap_stream, int msg_number [, int options]);
#

#T=imap_bodystruct - object imap_bodystruct ( resource stream_id, int msg_no, int section)
(PHP 3>= 3.0.4, PHP 4 )
imap_bodystruct --  Read the structure of a specified body section of a 
specific message 
Description
object imap_bodystruct ( resource stream_id, int msg_no, int section)
Warning
This function is currently not documented; only the argument list is 
available.
  imap_bodyUpimap_check
#

#T=object imap_bodystruct ( resource stream_id, int msg_no, int section)
imap_bodystruct ( ^!resource stream_id, int msg_no, int section);
#

#T=imap_check - object imap_check ( resource imap_stream)
(PHP 3, PHP 4 )
imap_check -- Check current mailbox
Description
object imap_check ( resource imap_stream)
Returns information about the current mailbox. Returns FALSE on failure. 
The imap_check() function checks the current mailbox status on the server 
and returns the information in an object with following properties: 
Date - current system time formatted according to RFC822 
Driver - protocol used to access this mailbox: POP3, IMAP, NNTP 
Mailbox - the mailbox name 
Nmsgs - number of messages in the mailbox 
Recent - number of recent messages in the mailbox 
Example 1. imap_check() example
  <?php

  $imap_obj = imap_check($imap_stream);
  var_dump($imap_obj);

  ?> 

this will output : 
object(stdClass)(5) {
["Date"]=>
string(37) "Wed, 10 Dec 2003 17:56:54 +0100 (CET)"
["Driver"]=>
string(4) "imap"
["Mailbox"]=>
string(54)
"{www.example.com:143/imap/user="foo@example.com"}INBOX"
["Nmsgs"]=>
int(1)
["Recent"]=>
int(0)
}

  imap_bodystructUpimap_clearflag_full
#

#T=object imap_check ( resource imap_stream)
imap_check ( ^!resource imap_stream);
#

#T=imap_clearflag_full - bool imap_clearflag_full ( resource stream, string sequence, string flag, 
(PHP 3>= 3.0.3, PHP 4 )
imap_clearflag_full -- Clears flags on messages
Description
bool imap_clearflag_full ( resource stream, string sequence, string flag, 
string options)
This function causes a store to delete the specified flag to the flags set 
for the messages in the specified sequence. The flags which you can unset 
are "\\Seen", "\\Answered", "\\Flagged", "\\Deleted", and "\\Draft" (as 
defined by RFC2060). 
The options are a bit mask with one or more of the following: 

ST_UID          The sequence argument contains UIDs instead of
      sequence numbers
  imap_checkUpimap_close
#

#T=bool imap_clearflag_full ( resource stream, string sequence, string flag, 
imap_clearflag_full ( ^!resource stream, string sequence, string flag, ;
#

#T=imap_close - bool imap_close ( resource imap_stream [, int flag])
(PHP 3, PHP 4 )
imap_close -- Close an IMAP stream
Description
bool imap_close ( resource imap_stream [, int flag])
Closes the imap stream. Takes an optional flag CL_EXPUNGE, which will 
silently expunge the mailbox before closing, removing all messages marked 
for deletion.   imap_clearflag_fullUpimap_createmailbox
#

#T=bool imap_close ( resource imap_stream [, int flag])
imap_close ( ^!resource imap_stream [, int flag]);
#

#T=imap_createmailbox - bool imap_createmailbox ( resource imap_stream, string mbox)
(PHP 3, PHP 4 )
imap_createmailbox -- Create a new mailbox
Description
bool imap_createmailbox ( resource imap_stream, string mbox)
imap_createmailbox() creates a new mailbox specified by mbox. Names 
containing international characters should be encoded by 
imap_utf7_encode() 
Returns TRUE on success and FALSE on error. 
See also imap_renamemailbox(), imap_deletemailbox() and imap_open() for 
the format of mbox names. 
Example 1. imap_createmailbox() example
  <?php
  $mbox = imap_open("{your.imap.host}", "username", "password", 
  OP_HALFOPEN)
       or die("can't connect: " . imap_last_error());

  $name1 = "phpnewbox";
  $name2 = imap_utf7_encode("phpnewb&ouml;x");

  $newname = $name1;

  echo "Newname will be '$name1'<br />\n";

  # we will now create a new mailbox "phptestbox" in your inbox 
  folder,
  # check its status after creation and finaly remove it to 
  restore
  # your inbox to its initial state 
  if (@imap_createmailbox($mbox, 
  imap_utf7_encode("{your.imap.host}INBOX.$newname"))) {
    $status = @imap_status($mbox, 
  "{your.imap.host}INBOX.$newname", SA_ALL);
    if ($status) {
      echo "your new mailbox '$name1' has the following 
  status:<br />\n";
      echo "Messages:   " . $status->messages    . "<br />\n";
      echo "Recent:     " . $status->recent      . "<br />\n";
      echo "Unseen:     " . $status->unseen      . "<br />\n";
      echo "UIDnext:    " . $status->uidnext     . "<br />\n";
      echo "UIDvalidity:" . $status->uidvalidity . "<br />\n";
      
      if (imap_renamemailbox($mbox, 
  "{your.imap.host}INBOX.$newname", 
  "{your.imap.host}INBOX.$name2")) {
	echo "renamed new mailbox from '$name1' to '$name2'<br 
  />\n";
	$newname=$name2;
      } else {
	echo "imap_renamemailbox on new mailbox failed: " . 
  imap_last_error() . "<br />\n";
      }
    } else {
      echo "imap_status on new mailbox failed: " . 
  imap_last_error() . "<br />\n";
    }
    if (@imap_deletemailbox($mbox, 
  "{your.imap.host}INBOX.$newname")) {
      echo "new mailbox removed to restore initial state<br 
  />\n";
    } else {
      echo "imap_deletemailbox on new mailbox failed: " . 
  implode("<br />\n", imap_errors()) . "<br />\n";
    }
    
  } else {
    echo "could not create new mailbox: " . implode("<br />\n", 
  imap_errors()) . "<br />\n";
  }

  imap_close($mbox);
  ?> 

  imap_closeUpimap_delete
#

#T=bool imap_createmailbox ( resource imap_stream, string mbox)
imap_createmailbox ( ^!resource imap_stream, string mbox);
#

#T=imap_delete - bool imap_delete ( int imap_stream, int msg_number [, int options])
(PHP 3, PHP 4 )
imap_delete --  Mark a message for deletion from current mailbox 
Description
bool imap_delete ( int imap_stream, int msg_number [, int options])
Returns TRUE. 
imap_delete() marks messages listed in msg_number for deletion. The 
optional flags parameter only has a single option, FT_UID, which tells the 
function to treat the msg_number argument as a UID. Messages marked for 
deletion will stay in the mailbox until either imap_expunge() is called or 
imap_close() is called with the optional parameter CL_EXPUNGE. 
Note: POP3 mailboxes do not have their message flags saved between 
connections, so imap_expunge() must be called during the same connection 
in order for messages marked for deletion to actually be purged. 
Example 1. imap_delete() example
  <?php
  $mbox = imap_open("{your.imap.host}INBOX", "username", 
  "password")
      or die("Can't connect: " . imap_last_error());

  $check = imap_mailboxmsginfo($mbox);
  echo "Messages before delete: " . $check->Nmsgs . "<br />\n";
  imap_delete($mbox, 1);
  $check = imap_mailboxmsginfo($mbox);
  echo "Messages after  delete: " . $check->Nmsgs . "<br />\n";
  imap_expunge($mbox);
  $check = imap_mailboxmsginfo($mbox);
  echo "Messages after expunge: " . $check->Nmsgs . "<br />\n";
  imap_close($mbox);
  ?> 

  imap_createmailboxUpimap_deletemailbox
#

#T=bool imap_delete ( int imap_stream, int msg_number [, int options])
imap_delete ( ^!int imap_stream, int msg_number [, int options]);
#

#T=imap_deletemailbox - bool imap_deletemailbox ( resource imap_stream, string mbox)
(PHP 3, PHP 4 )
imap_deletemailbox -- Delete a mailbox
Description
bool imap_deletemailbox ( resource imap_stream, string mbox)
imap_deletemailbox() deletes the specified mailbox (see imap_open() for 
the format of mbox names). 
Returns TRUE on success and FALSE on error. 
See also imap_createmailbox(), imap_renamemailbox(), and imap_open() for 
the format of mbox.   imap_deleteUpimap_errors
#

#T=bool imap_deletemailbox ( resource imap_stream, string mbox)
imap_deletemailbox ( ^!resource imap_stream, string mbox);
#

#T=imap_errors - array imap_errors ( void )
(PHP 3>= 3.0.12, PHP 4 )
imap_errors --  This function returns all of the IMAP errors (if any) that 
have occurred during this page request or since the error stack was reset. 

Description
array imap_errors ( void )
This function returns an array of all of the IMAP error messages generated 
since the last imap_errors() call, or the beginning of the page. When 
imap_errors() is called, the error stack is subsequently cleared.   imap_deletemailboxUpimap_expunge
#

#T=array imap_errors ( void )
imap_errors ( ^!void );
#

#T=imap_expunge - bool imap_expunge ( resource imap_stream)
(PHP 3, PHP 4 )
imap_expunge -- Delete all messages marked for deletion
Description
bool imap_expunge ( resource imap_stream)
imap_expunge() deletes all the messages marked for deletion by 
imap_delete(), imap_mail_move(), or imap_setflag_full(). 
Returns TRUE.   imap_errorsUpimap_fetch_overview
#

#T=bool imap_expunge ( resource imap_stream)
imap_expunge ( ^!resource imap_stream);
#

#T=imap_fetch_overview - array imap_fetch_overview ( resource imap_stream, string sequence [, int 
(PHP 3>= 3.0.4, PHP 4 )
imap_fetch_overview --  Read an overview of the information in the headers 
of the given message 
Description
array imap_fetch_overview ( resource imap_stream, string sequence [, int 
options])
This function fetches mail headers for the given sequence and returns an 
overview of their contents. sequence will contain a sequence of message 
indices or UIDs, if flags contains FT_UID. The returned value is an array 
of objects describing one message header each: 
subject - the messages subject 
from - who sent it 
date - when was it sent 
message_id - Message-ID 
references - is a reference to this message id 
size - size in bytes 
uid - UID the message has in the mailbox 
msgno - message sequence number in the maibox 
recent - this message is flagged as recent 
flagged - this message is flagged 
answered - this message is flagged as answered 
deleted - this message is flagged for deletion 
seen - this message is flagged as already read 
draft - this message is flagged as being a draft 
Example 1. imap_fetch_overview() example
  <?php
  $mbox = imap_open("{your.imap.host:143}", "username", 
  "password")
       or die("can't connect: " . imap_last_error());

  $overview = imap_fetch_overview($mbox, "2,4:6", 0);

  if (is_array($overview)) {
	  reset($overview);
	  while (list($key, $val) = each($overview)) {
		  echo      $val->msgno
		  . " - " . $val->date
		  . " - " . $val->subject
		  . "\n";
	  }
  }

  imap_close($mbox);
  ?> 

  imap_expungeUpimap_fetchbody
#

#T=array imap_fetch_overview ( resource imap_stream, string sequence [, int 
imap_fetch_overview ( ^!resource imap_stream, string sequence [, int ;
#

#T=imap_fetchbody - string imap_fetchbody ( resource imap_stream, int msg_number, string 
(PHP 3, PHP 4 )
imap_fetchbody --  Fetch a particular section of the body of the message 
Description
string imap_fetchbody ( resource imap_stream, int msg_number, string 
part_number [, flags options])
This function causes a fetch of a particular section of the body of the 
specified messages as a text string and returns that text string. The 
section specification is a string of integers delimited by period which 
index into a body part list as per the IMAP4 specification. Body parts are 
not decoded by this function. 
The options for imap_fetchbody() is a bitmask with one or more of the 
following: 
FT_UID - The msg_number is a UID 
FT_PEEK - Do not set the \Seen flag if not already set 
FT_INTERNAL - The return string is in "internal" format, without any 
attempt to canonicalize CRLF. 
See also: imap_fetchstructure().   imap_fetch_overviewUpimap_fetchheader
#

#T=string imap_fetchbody ( resource imap_stream, int msg_number, string 
imap_fetchbody ( ^!resource imap_stream, int msg_number, string ;
#

#T=imap_fetchheader - string imap_fetchheader ( resource imap_stream, int msgno, int options)
(PHP 3>= 3.0.3, PHP 4 )
imap_fetchheader -- Returns header for a message
Description
string imap_fetchheader ( resource imap_stream, int msgno, int options)
This function causes a fetch of the complete, unfiltered RFC2822 format 
header of the specified message as a text string and returns that text 
string. 
The options are: 

FT_UID          The msgno argument is a UID 
FT_INTERNAL     The return string is in "internal" format,
      without any attempt to canonicalize to CRLF
      newlines
FT_PREFETCHTEXT The RFC822.TEXT should be pre-fetched at the
      same time.  This avoids an extra RTT on an
      IMAP connection if a full message text is
      desired (e.g. in a "save to local file"
      operation)
  imap_fetchbodyUpimap_fetchstructure
#

#T=string imap_fetchheader ( resource imap_stream, int msgno, int options)
imap_fetchheader ( ^!resource imap_stream, int msgno, int options);
#

#T=imap_fetchstructure - object imap_fetchstructure ( resource imap_stream, int msg_number [, int 
(PHP 3, PHP 4 )
imap_fetchstructure --  Read the structure of a particular message 
Description
object imap_fetchstructure ( resource imap_stream, int msg_number [, int 
options])
This function fetches all the structured information for a given message. 
The optional flags parameter only has a single option, FT_UID, which tells 
the function to treat the msg_number argument as a UID. The returned 
object includes the envelope, internal date, size, flags and body 
structure along with a similar object for each mime attachment. The 
structure of the returned objects is as follows: 
Table 1. Returned Objects for imap_fetchstructure() 
typePrimary body type
encodingBody transfer encoding
ifsubtypeTRUE if there is a subtype string
subtypeMIME subtype
ifdescriptionTRUE if there is a description string
descriptionContent description string
ifidTRUE if there is an identification string
idIdentification string
linesNumber of lines
bytesNumber of bytes
ifdispositionTRUE if there is a disposition string
dispositionDisposition string
ifdparametersTRUE if the dparameters array exists
dparametersAn array of objects where each object has an "attribute" 
and a "value" property corresponding to the parameters on the 
Content-disposition MIMEheader.
ifparametersTRUE if the parameters array exists
parametersAn array of objects where each object has an "attribute" 
and a "value" property.
partsAn array of objects identical in structure to the top-level 
object, each of which corresponds to a MIME body part.

Table 2. Primary body type
0text
1multipart
2message
3application
4audio
5image
6video
7other

Table 3. Transfer encodings
07BIT
18BIT
2BINARY
3BASE64
4QUOTED-PRINTABLE
5OTHER

See also: imap_fetchbody().   imap_fetchheaderUpimap_get_quota
#

#T=object imap_fetchstructure ( resource imap_stream, int msg_number [, int 
imap_fetchstructure ( ^!resource imap_stream, int msg_number [, int ;
#

#T=imap_get_quota - array imap_get_quota ( resource imap_stream, string quota_root)
(PHP 4 >= 4.0.5)
imap_get_quota --  Retrieve the quota level settings, and usage statics 
per mailbox 
Description
array imap_get_quota ( resource imap_stream, string quota_root)
Returns an array with integer values limit and usage for the given 
mailbox. The value of limit represents the total amount of space allowed 
for this mailbox. The usage value represents the mailboxes current level 
of capacity. Will return FALSE in the case of failure. 
This function is currently only available to users of the c-client2000 or 
greater library. 
NOTE: For this function to work, the mail stream is required to be opened 
as the mail-admin user. For a non-admin user version of this function, 
please see the imap_get_quotaroot() function of PHP. 
imap_stream should be the value returned from an imap_open() call. NOTE: 
This stream is required to be opened as the mail admin user for the 
get_quota function to work. quota_root should normally be in the form of 
user.name where name is the mailbox you wish to retrieve information 
about. 
Example 1. imap_get_quota() example
  <?php
  $mbox = imap_open("{your.imap.host}", "mailadmin", "password", 
  OP_HALFOPEN)
	or die("can't connect: " . imap_last_error());

  $quota_value = imap_get_quota($mbox, "user.kalowsky");
  if (is_array($quota_value)) {
      echo "Usage level is: " . $quota_value['usage'];
      echo "Limit level is: " . $quota_value['limit'];
  } 

  imap_close($mbox); 
  ?> 
As of PHP version 4.3, the function more properly reflects the 
functionality as dictated by the RFC 2087. The array return value has 
changed to support an unlimited number of returned resources (i.e. 
messages, or sub-folders) with each named resource receiving an individual 
array key. Each key value then contains an another array with the usage 
and limit values within it. The example below shows the updated returned 
output. 
For backwards compatibility reasons, the originial access methods are 
still available for use, although it is suggested to update. 
Example 2. imap_get_quota() 4.3 or greater example
  <?php
  $mbox = imap_open("{your.imap.host}", "mailadmin", "password", 
  OP_HALFOPEN)
	or die("can't connect: " . imap_last_error());
	 
  $quota_values = imap_get_quota($mbox, "user.kalowsky");
  if (is_array($quota_values)) {
     $storage = $quota_values['STORAGE'];
     echo "STORAGE usage level is: " .  $storage['usage'];
     echo "STORAGE limit level is: " .  $storage['limit'];

     $message = $quota_values['MESSAGE']; 
     echo "MESSAGE usage level is: " .  $message['usage'];
     echo "MESSAGE limit is: " .  $message['limit'];

     /* ...  */ 
  } 

  imap_close($mbox); 
  ?> 
See also imap_open(), imap_set_quota() and imap_get_quotaroot().   imap_fetchstructureUpimap_get_quotaroot
#

#T=array imap_get_quota ( resource imap_stream, string quota_root)
imap_get_quota ( ^!resource imap_stream, string quota_root);
#

#T=imap_get_quotaroot - array imap_get_quotaroot ( resource imap_stream, string quota_root)
(PHP 4 >= 4.3.0)
imap_get_quotaroot --  Retrieve the quota settings per user 
Description
array imap_get_quotaroot ( resource imap_stream, string quota_root)
Returns an array of integer values pertaining to the specified user 
mailbox. All values contain a key based upon the resource name, and a 
corresponding array with the usage and limit values within. 
The limit value represents the total amount of space allowed for this 
user's total mailbox usage. The usage value represents the user's current 
total mailbox capacity. This function will return FALSE in the case of 
call failure, and an array of information about the connection upon an 
un-parsable response from the server. 
This function is currently only available to users of the c-client2000 or 
greater library. 
imap_stream should be the value returned from an imap_open() call. This 
stream should be opened as the user whose mailbox you wish to check. 
quota_root should normally be in the form of which mailbox (i.e. INBOX). 
Example 1. imap_get_quotaroot() example
  <?php
  $mbox = imap_open("{your.imap.host}", "kalowsky", "password", 
  OP_HALFOPEN)
	or die("can't connect: " . imap_last_error());

  $quota = imap_get_quotaroot($mbox, "INBOX");
  if (is_array($quota)) {
     $storage = $quota_values['STORAGE'];
     echo "STORAGE usage level is: " .  $storage['usage'];
     echo "STORAGE limit level is: " .  $storage['limit'];

     $message = $quota_values['MESSAGE']; 
     echo "MESSAGE usage level is: " .  $message['usage'];
     echo "MESSAGE usage level is: " .  $message['limit'];

     /* ...  */ 

  } 

  imap_close($mbox); 
  ?> 
See also imap_open(), imap_set_quota() and imap_get_quota().   imap_get_quotaUpimap_getacl
#

#T=array imap_get_quotaroot ( resource imap_stream, string quota_root)
imap_get_quotaroot ( ^!resource imap_stream, string quota_root);
#

#T=imap_getacl - array imap_getacl ( resource stream_id, string mailbox)
(PHP 5 CVS only)
imap_getacl --  Gets the ACL for a given mailbox 
Description
array imap_getacl ( resource stream_id, string mailbox)
Warning
This function is currently not documented; only the argument list is 
available.
  imap_get_quotarootUpimap_getmailboxes
#

#T=array imap_getacl ( resource stream_id, string mailbox)
imap_getacl ( ^!resource stream_id, string mailbox);
#

#T=imap_getmailboxes - array imap_getmailboxes ( resource imap_stream, string ref, string 
(PHP 3>= 3.0.12, PHP 4 )
imap_getmailboxes --  Read the list of mailboxes, returning detailed 
information on each one 
Description
array imap_getmailboxes ( resource imap_stream, string ref, string 
pattern)
Returns an array of objects containing mailbox information. Each object 
has the attributes name, specifying the full name of the mailbox; 
delimiter, which is the hierarchy delimiter for the part of the hierarchy 
this mailbox is in; and attributes. Attributes is a bitmask that can be 
tested against: 
LATT_NOINFERIORS - This mailbox has no "children" (there are no 
mailboxes below this one). 
LATT_NOSELECT - This is only a container, not a mailbox - you cannot 
open it. 
LATT_MARKED - This mailbox is marked. Only used by UW-IMAPD. 
LATT_UNMARKED - This mailbox is not marked. Only used by UW-IMAPD. 
Mailbox names containing international Characters outside the printable 
ASCII range will be encoded and may be decoded by imap_utf7_decode(). 
ref should normally be just the server specification as described in 
imap_open(), and pattern specifies where in the mailbox hierarchy to start 
searching. If you want all mailboxes, pass '*' for pattern. 
There are two special characters you can pass as part of the pattern: '*' 
and '%'. '*' means to return all mailboxes. If you pass pattern as '*', 
you will get a list of the entire mailbox hierarchy. '%' means to return 
the current level only. '%' as the pattern parameter will return only the 
top level mailboxes; '~/mail/%' on UW_IMAPD will return every mailbox in 
the ~/mail directory, but none in subfolders of that directory. 
Example 1. imap_getmailboxes() example
  <?php
  $mbox = imap_open("{your.imap.host}", "username", "password", 
  OP_HALFOPEN)
	or die("can't connect: " . imap_last_error());

  $list = imap_getmailboxes($mbox, "{your.imap.host}", "*");
  if (is_array($list)) {
    reset($list);
    while (list($key, $val) = each($list)) {
      echo "($key) ";
      echo imap_utf7_decode($val->name) . ",";
      echo "'" . $val->delimiter . "',";
      echo $val->attributes . "<br />\n";
    }
  } else {
    echo "imap_getmailboxes failed: " . imap_last_error() . 
"\n";
  }

  imap_close($mbox);
  ?> 
See also imap_getsubscribed().   imap_getaclUpimap_getsubscribed
#

#T=array imap_getmailboxes ( resource imap_stream, string ref, string 
imap_getmailboxes ( ^!resource imap_stream, string ref, string ;
#

#T=imap_getsubscribed - array imap_getsubscribed ( resource imap_stream, string ref, string 
(PHP 3>= 3.0.12, PHP 4 )
imap_getsubscribed -- List all the subscribed mailboxes
Description
array imap_getsubscribed ( resource imap_stream, string ref, string 
pattern)
This function is identical to imap_getmailboxes(), except that it only 
returns mailboxes that the user is subscribed to.   imap_getmailboxesUpimap_header
imap_header
imap_header -- Alias of imap_headerinfo()
Description
This function is an alias of imap_headerinfo().   imap_getsubscribedUpimap_headerinfo
#

#T=array imap_getsubscribed ( resource imap_stream, string ref, string 
imap_getsubscribed ( ^!resource imap_stream, string ref, string ;
#

#T=imap_headerinfo - object imap_headerinfo ( resource imap_stream, int msg_number [, int 
(PHP 3, PHP 4 )
imap_headerinfo -- Read the header of the message
Description
object imap_headerinfo ( resource imap_stream, int msg_number [, int 
fromlength [, int subjectlength [, string defaulthost]]])
This function returns an object of various header elements. 

remail, date, Date, subject, Subject, in_reply_to, message_id,
newsgroups, followup_to, references

message flags:
Recent -  'R' if recent and seen, 
   'N' if recent and not seen, 
   ' ' if not recent
Unseen -  'U' if not seen AND not recent, 
   ' ' if seen OR not seen and recent
Answered -'A' if answered, 
   ' ' if unanswered
Deleted - 'D' if deleted, 
   ' ' if not deleted
Draft -   'X' if draft, 
   ' ' if not draft
Flagged - 'F' if flagged, 
   ' ' if not flagged

NOTE that the Recent/Unseen behavior is a little odd. If you want to
know if a message is Unseen, you must check for

Unseen == 'U' || Recent == 'N'

toaddress (full to: line, up to 1024 characters)

to[] (returns an array of objects from the To line, containing):
personal
adl
mailbox
host

fromaddress (full from: line, up to 1024 characters)

from[] (returns an array of objects from the From line, containing):
personal
adl
mailbox
host

ccaddress (full cc: line, up to 1024 characters)
cc[] (returns an array of objects from the Cc line, containing):
personal
adl
mailbox
host

bccaddress (full bcc line, up to 1024 characters)
bcc[] (returns an array of objects from the Bcc line, containing):
personal
adl
mailbox
host

reply_toaddress (full reply_to: line, up to 1024 characters)
reply_to[] (returns an array of objects from the Reply_to line,
containing):
personal
adl
mailbox
host

senderaddress (full sender: line, up to 1024 characters)
sender[] (returns an array of objects from the sender line, containing):
personal
adl
mailbox
host

return_path (full return-path: line, up to 1024 characters)
return_path[] (returns an array of objects from the return_path line,
containing):
personal
adl
mailbox
host

udate (mail message date in unix time)

fetchfrom (from line formatted to fit fromlength 
characters)

fetchsubject (subject line formatted to fit subjectlength characters)
  imap_headerUpimap_headers
#

#T=object imap_headerinfo ( resource imap_stream, int msg_number [, int 
imap_headerinfo ( ^!resource imap_stream, int msg_number [, int ;
#

#T=imap_headers - array imap_headers ( resource imap_stream)
(PHP 3, PHP 4 )
imap_headers --  Returns headers for all messages in a mailbox 
Description
array imap_headers ( resource imap_stream)
Returns an array of string formatted with header info. One element per 
mail message.   imap_headerinfoUpimap_last_error
#

#T=array imap_headers ( resource imap_stream)
imap_headers ( ^!resource imap_stream);
#

#T=imap_last_error - string imap_last_error ( void )
(PHP 3>= 3.0.12, PHP 4 )
imap_last_error --  This function returns the last IMAP error (if any) 
that occurred during this page request 
Description
string imap_last_error ( void )
This function returns the full text of the last IMAP error message that 
occurred on the current page. The error stack is untouched; calling 
imap_last_error() subsequently, with no intervening errors, will return 
the same error.   imap_headersUpimap_list
#

#T=string imap_last_error ( void )
imap_last_error ( ^!void );
#

#T=imap_list - array imap_list ( resource imap_stream, string ref, string pattern)
(PHP 3>= 3.0.4, PHP 4 )
imap_list -- Read the list of mailboxes
Description
array imap_list ( resource imap_stream, string ref, string pattern)
Returns an array containing the names of the mailboxes. See 
imap_getmailboxes() for a description of ref and pattern. 
Example 1. imap_list() example
  <?php
  $mbox = imap_open("{your.imap.host}", "username", "password", 
  OP_HALFOPEN)
	or die("can't connect: " . imap_last_error());

  $list = imap_list($mbox, "{your.imap.host}", "*");
  if (is_array($list)) {
    reset($list);
    while (list($key, $val) = each($list))
      echo imap_utf7_decode($val) . "<br />\n";
  } else {
    echo "imap_list failed: " . imap_last_error() . "\n";
  }

  imap_close($mbox);
  ?> 

  imap_last_errorUpimap_listmailbox
imap_listmailbox
imap_listmailbox -- Alias of imap_list()
Description
This function is an alias of imap_list().   imap_listUpimap_listscan
imap_listscan
(no version information, might be only in CVS)
imap_listscan --  Read the list of mailboxes, takes a string to search for 
in the text of the mailbox 
Description
array imap_listscan ( resource imap_stream, string ref, string pattern, 
string content)
Returns an array containing the names of the mailboxes that have content 
in the text of the mailbox. This function is similar to 
imap_listmailbox(), but it will additionally check for the presence of the 
string content inside the mailbox data. See imap_getmailboxes() for a 
description of ref and pattern.   imap_listmailboxUpimap_listsubscribed
imap_listsubscribed
imap_listsubscribed -- Alias of imap_lsub()
Description
This function is an alias of imap_lsub().   imap_listscanUpimap_lsub
#

#T=array imap_list ( resource imap_stream, string ref, string pattern)
imap_list ( ^!resource imap_stream, string ref, string pattern);
#

#T=imap_lsub - array imap_lsub ( resource imap_stream, string ref, string pattern)
(PHP 3>= 3.0.4, PHP 4 )
imap_lsub -- List all the subscribed mailboxes
Description
array imap_lsub ( resource imap_stream, string ref, string pattern)
Returns an array of all the mailboxes that you have subscribed.   imap_listsubscribedUpimap_mail_compose
#

#T=array imap_lsub ( resource imap_stream, string ref, string pattern)
imap_lsub ( ^!resource imap_stream, string ref, string pattern);
#

#T=imap_mail_compose - string imap_mail_compose ( array envelope, array body)
(PHP 3>= 3.0.5, PHP 4 )
imap_mail_compose --  Create a MIME message based on given envelope and 
body sections 
Description
string imap_mail_compose ( array envelope, array body)
Example 1. imap_mail_compose() example
  <?php

  $envelope["from"]="joe@example.com";
  $envelope["to"]="foo@example.com";
  $envelope["cc"]="bar@example.com";

  $part1["type"]=TYPEMULTIPART;
  $part1["subtype"]="mixed";

  $filename="/tmp/imap.c.gz";
  $fp=fopen($filename, "r");
  $contents=fread($fp, filesize($filename));
  fclose($fp);

  $part2["type"]=TYPEAPPLICATION;
  $part2["encoding"]=ENCBINARY;
  $part2["subtype"]="octet-stream";
  $part2["description"]=basename($filename);
  $part2["contents.data"]=$contents;

  $part3["type"]=TYPETEXT;
  $part3["subtype"]="plain";
  $part3["description"]="description3";
  $part3["contents.data"]="contents.data3\n\n\n\t";

  $body[1]=$part1;
  $body[2]=$part2;
  $body[3]=$part3;

  echo nl2br(imap_mail_compose($envelope, $body));

  ?> 

  imap_lsubUpimap_mail_copy
#

#T=string imap_mail_compose ( array envelope, array body)
imap_mail_compose ( ^!array envelope, array body);
#

#T=imap_mail_copy - bool imap_mail_copy ( resource imap_stream, string msglist, string mbox [, 
(PHP 3, PHP 4 )
imap_mail_copy -- Copy specified messages to a mailbox
Description
bool imap_mail_copy ( resource imap_stream, string msglist, string mbox [, 
int options])
Returns TRUE on success and FALSE on error. 
Copies mail messages specified by msglist to specified mailbox. msglist is 
a range not just message numbers (as described in RFC2060). 
Flags is a bitmask of one or more of 
CP_UID - the sequence numbers contain UIDS 
CP_MOVE - Delete the messages from the current mailbox after copying   imap_mail_composeUpimap_mail_move
#

#T=bool imap_mail_copy ( resource imap_stream, string msglist, string mbox [, 
imap_mail_copy ( ^!resource imap_stream, string msglist, string mbox [, ;
#

#T=imap_mail_move - bool imap_mail_move ( resource imap_stream, string msglist, string mbox [, 
(PHP 3, PHP 4 )
imap_mail_move -- Move specified messages to a mailbox
Description
bool imap_mail_move ( resource imap_stream, string msglist, string mbox [, 
int options])
Moves mail messages specified by msglist to specified mailbox mbox. 
msglist is a range not just message numbers (as described in RFC2060). 
Returns TRUE on success or FALSE on failure. 
options is a bitmask and may contain the single option 
CP_UID - the sequence numbers contain UIDS   imap_mail_copyUpimap_mail
#

#T=bool imap_mail_move ( resource imap_stream, string msglist, string mbox [, 
imap_mail_move ( ^!resource imap_stream, string msglist, string mbox [, ;
#

#T=imap_mail - bool imap_mail ( string to, string subject, string message [, string 
(PHP 3>= 3.0.14, PHP 4 )
imap_mail --  Send an email message 
Description
bool imap_mail ( string to, string subject, string message [, string 
additional_headers [, string cc [, string bcc [, string rpath]]]])
This function allows sending of emails with correct handling of Cc and Bcc 
receivers. The parameters to, cc and bcc are all strings and are all 
parsed as rfc822 address lists. The receivers specified in bcc will get 
the mail, but are excluded from the headers. Use the rpath parameter to 
specify return path. This is useful when using PHP as a mail client for 
multiple users.   imap_mail_moveUpimap_mailboxmsginfo
#

#T=bool imap_mail ( string to, string subject, string message [, string 
imap_mail ( ^!string to, string subject, string message [, string ;
#

#T=imap_mailboxmsginfo - object imap_mailboxmsginfo ( resource imap_stream)
(PHP 3>= 3.0.2, PHP 4 )
imap_mailboxmsginfo -- Get information about the current mailbox
Description
object imap_mailboxmsginfo ( resource imap_stream)
Returns information about the current mailbox. Returns FALSE on failure. 
The imap_mailboxmsginfo() function checks the current mailbox status on 
the server. It is similar to imap_status(), but will additionally sum up 
the size of all messages in the mailbox, which will take some additional 
time to execute. It returns the information in an object with following 
properties. 
Table 1. Mailbox properties
Datedate of last change
Driverdriver
Mailboxname of the mailbox
Nmsgsnumber of messages
Recentnumber of recent messages
Unreadnumber of unread messages
Deletednumber of deleted messages
Sizemailbox size

Example 1. imap_mailboxmsginfo() example
  <?php

  $mbox = imap_open("{your.imap.host}INBOX", "username", 
  "password")
	or die("can't connect: " . imap_last_error());

  $check = imap_mailboxmsginfo($mbox);

  if ($check) {
      echo "Date: "     . $check->Date    . "<br />\n" ;
      echo "Driver: "   . $check->Driver  . "<br />\n" ;
      echo "Mailbox: "  . $check->Mailbox . "<br />\n" ;
      echo "Messages: " . $check->Nmsgs   . "<br />\n" ;
      echo "Recent: "   . $check->Recent  . "<br />\n" ;
      echo "Unread: "   . $check->Unread  . "<br />\n" ;
      echo "Deleted: "  . $check->Deleted . "<br />\n" ;
      echo "Size: "     . $check->Size    . "<br />\n" ;
  } else {
      echo "imap_check() failed: " . imap_last_error() . "<br 
  />\n";
  }

  imap_close($mbox);

  ?> 

  imap_mailUpimap_mime_header_decode
#

#T=object imap_mailboxmsginfo ( resource imap_stream)
imap_mailboxmsginfo ( ^!resource imap_stream);
#

#T=imap_mime_header_decode - array imap_mime_header_decode ( string text)
(PHP 3>= 3.0.17, PHP 4 )
imap_mime_header_decode -- Decode MIME header elements
Description
array imap_mime_header_decode ( string text)
imap_mime_header_decode() function decodes MIME message header extensions 
that are non ASCII text (see RFC2047) The decoded elements are returned in 
an array of objects, where each object has two properties, "charset" & 
"text". If the element hasn't been encoded, and in other words is in plain 
US-ASCII,the "charset" property of that element is set to "default". 
Example 1. imap_mime_header_decode() example
  <?php
  $text = "=?ISO-8859-1?Q?Keld_J=F8rn_Simonsen?= 
  <keld@example.com>";

  $elements = imap_mime_header_decode($text);
  for ($i=0; $i<count($elements); $i++) {
      echo "Charset: {$elements[$i]->charset}\n";
      echo "Text: {$elements[$i]->text}\n\n";
  }
  ?> 
In the above example we would have two elements, whereas the first element 
had previously been encoded with ISO-8859-1, and the second element would 
be plain US-ASCII.   imap_mailboxmsginfoUpimap_msgno
#

#T=array imap_mime_header_decode ( string text)
imap_mime_header_decode ( ^!string text);
#

#T=imap_msgno - int imap_msgno ( resource imap_stream, int uid)
(PHP 3>= 3.0.3, PHP 4 )
imap_msgno --  This function returns the message sequence number for the 
given UID 
Description
int imap_msgno ( resource imap_stream, int uid)
This function returns the message sequence number for the given UID. It is 
the inverse of imap_uid().   imap_mime_header_decodeUpimap_num_msg
#

#T=int imap_msgno ( resource imap_stream, int uid)
imap_msgno ( ^!resource imap_stream, int uid);
#

#T=imap_num_msg - int imap_num_msg ( resource imap_stream)
(PHP 3, PHP 4 )
imap_num_msg --  Gives the number of messages in the current mailbox 
Description
int imap_num_msg ( resource imap_stream)
Return the number of messages in the current mailbox. 
See also: imap_num_recent() and imap_status().   imap_msgnoUpimap_num_recent
#

#T=int imap_num_msg ( resource imap_stream)
imap_num_msg ( ^!resource imap_stream);
#

#T=imap_num_recent - int imap_num_recent ( resource imap_stream)
(PHP 3, PHP 4 )
imap_num_recent -- Gives the number of recent messages in current mailbox
Description
int imap_num_recent ( resource imap_stream)
Returns the number of recent messages in the current mailbox. 
See also: imap_num_msg() and imap_status().   imap_num_msgUpimap_open
#

#T=int imap_num_recent ( resource imap_stream)
imap_num_recent ( ^!resource imap_stream);
#

#T=imap_open - resource imap_open ( string mailbox, string username, string password [, 
(PHP 3, PHP 4 )
imap_open -- Open an IMAP stream to a mailbox
Description
resource imap_open ( string mailbox, string username, string password [, 
int options])
Returns an IMAP stream on success and FALSE on error. This function can 
also be used to open streams to POP3 and NNTP servers, but some functions 
and features are only available on IMAP servers. 
A mailbox name consists of a server part and a mailbox path on this 
server. The special name INBOX stands for the current users personal 
mailbox. The server part, which is enclosed in '{' and '}', consists of 
the servers name or ip address, an optional port (prefixed by ':'), and an 
optional protocol specification (prefixed by '/'). The server part is 
mandatory in all mailbox parameters. Mailbox names that contain 
international characters besides those in the printable ASCII space have 
to be encoded with imap_utf7_encode(). 
The options are a bit mask with one or more of the following: 
OP_READONLY - Open mailbox read-only 
OP_ANONYMOUS - Don't use or update a .newsrc for news (NNTP only) 
OP_HALFOPEN - For IMAP and NNTP names, open a connection but don't open 
a mailbox 
CL_EXPUNGE - Expunge mailbox automatically upon mailbox close 
To connect to an IMAP server running on port 143 on the local machine, do 
the following: 
<?php
$mbox = imap_open("{localhost:143}INBOX", "user_id", "password");
?> 

To connect to a POP3 server on port 110 on the local server, use: 
<?php
$mbox = imap_open ("{localhost:110/pop3}INBOX", "user_id", 
"password");
?> 

To connect to an SSL IMAP or POP3 server, add /ssl after the protocol 
specification: 
<?php
$mbox = imap_open ("{localhost:993/imap/ssl}INBOX", "user_id", 
"password");
?> 

To connect to an SSL IMAP or POP3 server with a self-signed certificate, 
add /ssl/novalidate-cert after the protocol specification: 
<?php
$mbox = imap_open ("{localhost:995/pop3/ssl/novalidate-cert}", 
"user_id", "password");
?> 

To connect to an NNTP server on port 119 on the local server, use: 
<?php
$nntp = imap_open ("{localhost:119/nntp}comp.test", "", "");
?> 

To connect to a remote server replace "localhost" with the name or the IP 
address of the server you want to connect to. 
Example 1. imap_open() example
  <?php
  $mbox = imap_open("{your.imap.host:143}", "username", 
  "password");

  echo "<p><h1>Mailboxes</h1>\n";
  $folders = imap_listmailbox($mbox, "{your.imap.host:143}", 
  "*");

  if ($folders == false) {
      echo "Call failed<br />\n";
  } else {
      while (list ($key, $val) = each($folders)) {
	  echo $val . "<br />\n";
      }
  }

  echo "<p><h1>Headers in INBOX</h1>\n";
  $headers = imap_headers($mbox);

  if ($headers == false) {
      echo "Call failed<br />\n";
  } else {
      while (list ($key, $val) = each ($headers)) {
	  echo $val . "<br />\n";
      }
  }

  imap_close($mbox);
  ?> 

  imap_num_recentUpimap_ping
#

#T=resource imap_open ( string mailbox, string username, string password [, 
imap_open ( ^!string mailbox, string username, string password [, ;
#

#T=imap_ping - bool imap_ping ( resource imap_stream)
(PHP 3, PHP 4 )
imap_ping -- Check if the IMAP stream is still active
Description
bool imap_ping ( resource imap_stream)
Returns TRUE if the stream is still alive, FALSE otherwise. 
imap_ping() function pings the stream to see it is still active. It may 
discover new mail; this is the preferred method for a periodic "new mail 
check" as well as a "keep alive" for servers which have inactivity 
timeout. (As PHP scripts do not tend to run that long, I can hardly 
imagine that this function will be useful to anyone.)   imap_openUpimap_qprint
#

#T=bool imap_ping ( resource imap_stream)
imap_ping ( ^!resource imap_stream);
#

#T=imap_qprint - string imap_qprint ( string string)
(PHP 3, PHP 4 )
imap_qprint -- Convert a quoted-printable string to an 8 bit string
Description
string imap_qprint ( string string)
Convert a quoted-printable string to an 8 bit string (according to 
RFC2045, section 6.7). 
Returns an 8 bit (binary) string. 
See also imap_8bit().   imap_pingUpimap_renamemailbox
#

#T=string imap_qprint ( string string)
imap_qprint ( ^!string string);
#

#T=imap_renamemailbox - bool imap_renamemailbox ( resource imap_stream, string old_mbox, string 
(PHP 3, PHP 4 )
imap_renamemailbox -- Rename an old mailbox to new mailbox
Description
bool imap_renamemailbox ( resource imap_stream, string old_mbox, string 
new_mbox)
This function renames on old mailbox to new mailbox (see imap_open() for 
the format of mbox names). 
Returns TRUE on success or FALSE on failure. 
See also imap_createmailbox(), imap_deletemailbox(), and imap_open() for 
the format of mbox.   imap_qprintUpimap_reopen
#

#T=bool imap_renamemailbox ( resource imap_stream, string old_mbox, string 
imap_renamemailbox ( ^!resource imap_stream, string old_mbox, string ;
#

#T=imap_reopen - bool imap_reopen ( resource imap_stream, string mailbox [, string 
(PHP 3, PHP 4 )
imap_reopen -- Reopen IMAP stream to new mailbox
Description
bool imap_reopen ( resource imap_stream, string mailbox [, string 
options])
This function reopens the specified stream to a new mailbox on an IMAP or 
NNTP server. 
The options are a bit mask with one or more of the following: 
OP_READONLY - Open mailbox read-only 
OP_ANONYMOUS - Don't use or update a .newsrc for news (NNTP only) 
OP_HALFOPEN - For IMAP and NNTP names, open a connection but don't open 
a mailbox. 
CL_EXPUNGE - Expunge mailbox automatically upon mailbox close (see also 
imap_delete() and imap_expunge()) 
Returns TRUE on success or FALSE on failure.   imap_renamemailboxUpimap_rfc822_parse_adrlist
#

#T=bool imap_reopen ( resource imap_stream, string mailbox [, string 
imap_reopen ( ^!resource imap_stream, string mailbox [, string ;
#

#T=imap_rfc822_parse_adrlist - array imap_rfc822_parse_adrlist ( string address, string default_host)
(PHP 3>= 3.0.2, PHP 4 )
imap_rfc822_parse_adrlist -- Parses an address string
Description
array imap_rfc822_parse_adrlist ( string address, string default_host)
This function parses the address string as defined in RFC2822 and for each 
address, returns an array of objects. The objects properties are: 
mailbox - the mailbox name (username) 
host - the host name 
personal - the personal name 
adl - at domain source route 
Example 1. imap_rfc822_parse_adrlist() example
  <?php
  $address_string = "Joe Doe <doe@example.com>, 
  postmaster@example.com, root";
  $address_array  = imap_rfc822_parse_adrlist($address_string, 
  "example.com");
  if (!is_array($address_array) || count($address_array) < 1) 
  die("something is wrong\n");

  foreach ($address_array as $val) {
    echo "mailbox : " . $val->mailbox . "<br />\n";
    echo "host    : " . $val->host . "<br />\n";
    echo "personal: " . $val->personal . "<br />\n";
    echo "adl     : " . $val->adl . "<br />\n";
  } 
  ?> 

  imap_reopenUpimap_rfc822_parse_headers
#

#T=array imap_rfc822_parse_adrlist ( string address, string default_host)
imap_rfc822_parse_adrlist ( ^!string address, string default_host);
#

#T=imap_rfc822_parse_headers - object imap_rfc822_parse_headers ( string headers [, string defaulthost])
(PHP 4 )
imap_rfc822_parse_headers -- Parse mail headers from a string
Description
object imap_rfc822_parse_headers ( string headers [, string defaulthost])
This function returns an object of various header elements, similar to 
imap_header(), except without the flags and other elements that come from 
the IMAP server.   imap_rfc822_parse_adrlistUpimap_rfc822_write_address
#

#T=object imap_rfc822_parse_headers ( string headers [, string defaulthost])
imap_rfc822_parse_headers ( ^!string headers [, string defaulthost]);
#

#T=imap_rfc822_write_address - string imap_rfc822_write_address ( string mailbox, string host, string 
(PHP 3>= 3.0.2, PHP 4 )
imap_rfc822_write_address --  Returns a properly formatted email address 
given the mailbox, host, and personal info. 
Description
string imap_rfc822_write_address ( string mailbox, string host, string 
personal)
Returns a properly formatted email address as defined in RFC2822 given the 
mailbox, host, and personal info. 
Example 1. imap_rfc822_write_address() example
  <?php
  echo imap_rfc822_write_address("hartmut", "cvs.php.net", 
  "Hartmut Holzgraefe") . "\n";      
  ?> 

  imap_rfc822_parse_headersUpimap_scanmailbox
imap_scanmailbox
imap_scanmailbox -- Alias of imap_listscan()
Description
This function is an alias of imap_listscan().   imap_rfc822_write_addressUpimap_search
#

#T=string imap_rfc822_write_address ( string mailbox, string host, string 
imap_rfc822_write_address ( ^!string mailbox, string host, string ;
#

#T=imap_search - array imap_search ( resource imap_stream, string criteria, int options)
(PHP 3>= 3.0.12, PHP 4 )
imap_search --  This function returns an array of messages matching the 
given search criteria 
Description
array imap_search ( resource imap_stream, string criteria, int options)
This function performs a search on the mailbox currently opened in the 
given imap stream. criteria is a string, delimited by spaces, in which the 
following keywords are allowed. Any multi-word arguments (e.g. FROM "joey 
smith") must be quoted. 
ALL - return all messages matching the rest of the criteria 
ANSWERED - match messages with the \\ANSWERED flag set 
BCC "string" - match messages with "string" in the Bcc: field 
BEFORE "date" - match messages with Date: before "date" 
BODY "string" - match messages with "string" in the body of the message 
CC "string" - match messages with "string" in the Cc: field 
DELETED - match deleted messages 
FLAGGED - match messages with the \\FLAGGED (sometimes referred to as 
Important or Urgent) flag set 
FROM "string" - match messages with "string" in the From: field 
KEYWORD "string" - match messages with "string" as a keyword 
NEW - match new messages 
OLD - match old messages 
ON "date" - match messages with Date: matching "date" 
RECENT - match messages with the \\RECENT flag set 
SEEN - match messages that have been read (the \\SEEN flag is set) 
SINCE "date" - match messages with Date: after "date" 
SUBJECT "string" - match messages with "string" in the Subject: 
TEXT "string" - match messages with text "string" 
TO "string" - match messages with "string" in the To: 
UNANSWERED - match messages that have not been answered 
UNDELETED - match messages that are not deleted 
UNFLAGGED - match messages that are not flagged 
UNKEYWORD "string" - match messages that do not have the keyword 
"string" 
UNSEEN - match messages which have not been read yet 
For example, to match all unanswered messages sent by Mom, you'd use: 
"UNANSWERED FROM mom". Searches appear to be case insensitive. This list 
of criteria is from a reading of the UW c-client source code and may be 
incomplete or inaccurate (see also RFC2060, section 6.4.4). 
Valid values for flags are SE_UID, which causes the returned array to 
contain UIDs instead of messages sequence numbers.   imap_scanmailboxUpimap_set_quota
#

#T=array imap_search ( resource imap_stream, string criteria, int options)
imap_search ( ^!resource imap_stream, string criteria, int options);
#

#T=imap_set_quota - bool imap_set_quota ( resource imap_stream, string quota_root, int 
(PHP 4 >= 4.0.5)
imap_set_quota -- Sets a quota for a given mailbox
Description
bool imap_set_quota ( resource imap_stream, string quota_root, int 
quota_limit)
Sets an upper limit quota on a per mailbox basis. This function requires 
the imap_stream to have been opened as the mail administrator account. It 
will not work if opened as any other user. 
This function is currently only available to users of the c-client2000 or 
greater library. 
imap_stream is the stream pointer returned from a imap_open() call. This 
stream must be opened as the mail administrator, other wise this function 
will fail. quota_root is the mailbox to have a quota set. This should 
follow the IMAP standard format for a mailbox, 'user.name'. quota_limit is 
the maximum size (in KB) for the quota_root. 
Returns TRUE on success and FALSE on error. 
Example 1. imap_set_quota() example
  <?php
  $mbox = imap_open("{your.imap.host:143}", "mailadmin", 
  "password");

  if (!imap_set_quota($mbox, "user.kalowsky", 3000)) {
      echo "Error in setting quota\n";
      return;
  }

  imap_close($mbox);
  ?> 
See also imap_open() and imap_set_quota().   imap_searchUpimap_setacl
#

#T=bool imap_set_quota ( resource imap_stream, string quota_root, int 
imap_set_quota ( ^!resource imap_stream, string quota_root, int ;
#

#T=imap_setacl - bool imap_setacl ( resource stream_id, string mailbox, string id, string 
(PHP 4 >= 4.1.0)
imap_setacl --  Sets the ACL for a giving mailbox 
Description
bool imap_setacl ( resource stream_id, string mailbox, string id, string 
rights)
Warning
This function is currently not documented; only the argument list is 
available.
  imap_set_quotaUpimap_setflag_full
#

#T=bool imap_setacl ( resource stream_id, string mailbox, string id, string 
imap_setacl ( ^!resource stream_id, string mailbox, string id, string ;
#

#T=imap_setflag_full - bool imap_setflag_full ( resource stream, string sequence, string flag, 
(PHP 3>= 3.0.3, PHP 4 )
imap_setflag_full -- Sets flags on messages
Description
bool imap_setflag_full ( resource stream, string sequence, string flag, 
string options)
This function causes a store to add the specified flag to the flags set 
for the messages in the specified sequence. 
The flags which you can set are "\\Seen", "\\Answered", "\\Flagged", 
"\\Deleted", and "\\Draft" (as defined by RFC2060). 
The options are a bit mask with one or more of the following: 

ST_UID          The sequence argument contains UIDs instead of
      sequence numbers

Example 1. imap_setflag_full() example
  <?php
  $mbox = imap_open("{your.imap.host:143}", "username", 
  "password")
       or die("can't connect: " . imap_last_error());

  $status = imap_setflag_full($mbox, "2,5", "\\Seen \\Flagged");

  echo gettype($status) . "\n";
  echo $status . "\n";

  imap_close($mbox);
  ?> 

  imap_setaclUpimap_sort
#

#T=bool imap_setflag_full ( resource stream, string sequence, string flag, 
imap_setflag_full ( ^!resource stream, string sequence, string flag, ;
#

#T=imap_sort - array imap_sort ( resource stream, int criteria, int reverse [, int 
(PHP 3>= 3.0.3, PHP 4 )
imap_sort -- Sort an array of message headers
Description
array imap_sort ( resource stream, int criteria, int reverse [, int 
options [, string search_criteria]])
Returns an array of message numbers sorted by the given parameters. 
Reverse is 1 for reverse-sorting. 
Criteria can be one (and only one) of the following: 

SORTDATE        message Date
SORTARRIVAL     arrival date
SORTFROM        mailbox in first From address
SORTSUBJECT     message Subject
SORTTO          mailbox in first To address 
SORTCC          mailbox in first cc address 
SORTSIZE        size of message in octets

The flags are a bitmask of one or more of the following: 

SE_UID          Return UIDs instead of sequence numbers
SE_NOPREFETCH   Don't prefetch searched messages.
  imap_setflag_fullUpimap_status
#

#T=array imap_sort ( resource stream, int criteria, int reverse [, int 
imap_sort ( ^!resource stream, int criteria, int reverse [, int ;
#

#T=imap_status - object imap_status ( resource imap_stream, string mailbox, int options)
(PHP 3>= 3.0.4, PHP 4 )
imap_status --  This function returns status information on a mailbox 
other than the current one 
Description
object imap_status ( resource imap_stream, string mailbox, int options)
This function returns an object containing status information. Valid flags 
are: 
SA_MESSAGES - set status->messages to the number of messages in the 
mailbox 
SA_RECENT - set status->recent to the number of recent messages in the 
mailbox 
SA_UNSEEN - set status->unseen to the number of unseen (new) messages in 
the mailbox 
SA_UIDNEXT - set status->uidnext to the next uid to be used in the 
mailbox 
SA_UIDVALIDITY - set status->uidvalidity to a constant that changes when 
uids for the mailbox may no longer be valid 
SA_ALL - set all of the above 
status->flags is also set, which contains a bitmask which can be checked 
against any of the above constants. 
Example 1. imap_status() example
  <?php
  $mbox = imap_open("{your.imap.host}", "username", "password", 
  OP_HALFOPEN)
	or die("can't connect: " . imap_last_error());

  $status = imap_status($mbox, "{your.imap.host}INBOX", SA_ALL);
  if ($status) {
    echo "Messages:   " . $status->messages    . "<br />\n";
    echo "Recent:     " . $status->recent      . "<br />\n";
    echo "Unseen:     " . $status->unseen      . "<br />\n";
    echo "UIDnext:    " . $status->uidnext     . "<br />\n";
    echo "UIDvalidity:" . $status->uidvalidity . "<br />\n"; 
  } else
    echo "imap_status failed: " . imap_last_error() . "\n";

  imap_close($mbox);
  ?> 

  imap_sortUpimap_subscribe
#

#T=object imap_status ( resource imap_stream, string mailbox, int options)
imap_status ( ^!resource imap_stream, string mailbox, int options);
#

#T=imap_subscribe - bool imap_subscribe ( resource imap_stream, string mbox)
(PHP 3, PHP 4 )
imap_subscribe -- Subscribe to a mailbox
Description
bool imap_subscribe ( resource imap_stream, string mbox)
Subscribe to a new mailbox. 
Returns TRUE on success or FALSE on failure.   imap_statusUpimap_thread
#

#T=bool imap_subscribe ( resource imap_stream, string mbox)
imap_subscribe ( ^!resource imap_stream, string mbox);
#

#T=imap_thread - array imap_thread ( resource stream_id [, int options])
(PHP 4 >= 4.1.0)
imap_thread --  Return threaded by REFERENCES tree 
Description
array imap_thread ( resource stream_id [, int options])
Warning
This function is currently not documented; only the argument list is 
available.
  imap_subscribeUpimap_timeout
imap_timeout
(no version information, might be only in CVS)
imap_timeout --  Set or fetch imap timeout 
Description
mixed imap_timeout ( int timeout_type [, int timeout])
Warning
This function is currently not documented; only the argument list is 
available.
  imap_threadUpimap_uid
#

#T=array imap_thread ( resource stream_id [, int options])
imap_thread ( ^!resource stream_id [, int options]);
#

#T=imap_uid - int imap_uid ( resource imap_stream, int msgno)
(PHP 3>= 3.0.3, PHP 4 )
imap_uid --  This function returns the UID for the given message sequence 
number 
Description
int imap_uid ( resource imap_stream, int msgno)
This function returns the UID for the given message sequence number. An 
UID is an unique identifier that will not change over time while a message 
sequence number may change whenever the content of the mailbox changes. 
This function is the inverse of imap_msgno(). 
Note: This is not supported by POP3 mailboxes.   imap_timeoutUpimap_undelete
#

#T=int imap_uid ( resource imap_stream, int msgno)
imap_uid ( ^!resource imap_stream, int msgno);
#

#T=imap_undelete - bool imap_undelete ( resource imap_stream, int msg_number)
(PHP 3, PHP 4 )
imap_undelete --  Unmark the message which is marked deleted 
Description
bool imap_undelete ( resource imap_stream, int msg_number)
This function removes the deletion flag for a specified message, which is 
set by imap_delete() or imap_mail_move(). 
Returns TRUE on success or FALSE on failure.   imap_uidUpimap_unsubscribe
#

#T=bool imap_undelete ( resource imap_stream, int msg_number)
imap_undelete ( ^!resource imap_stream, int msg_number);
#

#T=imap_unsubscribe - bool imap_unsubscribe ( string imap_stream, string mbox)
(PHP 3, PHP 4 )
imap_unsubscribe -- Unsubscribe from a mailbox
Description
bool imap_unsubscribe ( string imap_stream, string mbox)
Unsubscribe from a specified mailbox. 
Returns TRUE on success or FALSE on failure.   imap_undeleteUpimap_utf7_decode
#

#T=bool imap_unsubscribe ( string imap_stream, string mbox)
imap_unsubscribe ( ^!string imap_stream, string mbox);
#

#T=imap_utf7_decode - string imap_utf7_decode ( string text)
(PHP 3>= 3.0.15, PHP 4 )
imap_utf7_decode --  Decodes a modified UTF-7 encoded string. 
Description
string imap_utf7_decode ( string text)
Decodes modified UTF-7 text into ISO-8859-1 string. 
Returns a string that is encoded in ISO-8859-1 and consists of the same 
sequence of characters in text, or FALSE if text contains invalid modified 
UTF-7 sequence or text contains a character that is not part of ISO-8859-1 
character set. This function is needed to decode mailbox names that 
contain certain characters which are not in range of printable ASCII 
characters. The modified UTF-7 encoding is defined in RFC 2060, section 
5.1.3 (original UTF-7 was defined in RFC1642).   imap_unsubscribeUpimap_utf7_encode
#

#T=string imap_utf7_decode ( string text)
imap_utf7_decode ( ^!string text);
#

#T=imap_utf7_encode - string imap_utf7_encode ( string data)
(PHP 3>= 3.0.15, PHP 4 )
imap_utf7_encode --  Converts ISO-8859-1 string to modified UTF-7 text. 
Description
string imap_utf7_encode ( string data)
Converts data to modified UTF-7 text. This is needed to encode mailbox 
names that contain certain characters which are not in range of printable 
ASCII characters. Note that data is expected to be encoded in ISO-8859-1. 
The modified UTF-7 encoding is defined in RFC 2060, section 5.1.3 
(original UTF-7 was defined in RFC1642). 
Returns the modified UTF-7 text.   imap_utf7_decodeUpimap_utf8
#

#T=string imap_utf7_encode ( string data)
imap_utf7_encode ( ^!string data);
#

#T=imap_utf8 - string imap_utf8 ( string mime_encoded_text)
(PHP 3>= 3.0.13, PHP 4 )
imap_utf8 --  Converts MIME-encoded text to UTF-8 
Description
string imap_utf8 ( string mime_encoded_text)
Converts the given mime_encoded_text to UTF-8. MIME encoding method and 
the UTF-8 specification are described in RFC2047 and RFC2044 respectively. 
  imap_utf7_encodeUpInformix functions
#

#T=string imap_utf8 ( string mime_encoded_text)
imap_utf8 ( ^!string mime_encoded_text);
#

#T=implode - string implode ( string glue, array pieces)
(PHP 3, PHP 4 )
implode -- Join array elements with a string
Description
string implode ( string glue, array pieces)
Returns a string containing a string representation of all the array 
elements in the same order, with the glue string between each element. 
Example 1. implode() example
  <?php

  $array = array('lastname', 'email', 'phone');
  $comma_separated = implode(",", $array);

  echo $comma_separated; // lastname,email,phone

  ?> 
Note: implode() can, for historical reasons, accept its parameters in 
either order. For consistency with explode(), however, it may be less 
confusing to use the documented order of arguments. 
Note: As of PHP 4.3.0, the glue parameter of implode() is optional and 
defaults to the empty string(''). This is not the preferred usage of 
implode(). We recommend to always use two parameters for compatibility 
with older versions. 
See also explode(), and split().   htmlspecialcharsUpjoin
#

#T=string implode ( string glue, array pieces)
implode ( ^!string glue, array pieces);
#

#T=import_request_variables - bool import_request_variables ( string types [, string prefix])
(PHP 4 >= 4.1.0)
import_request_variables -- Import GET/POST/Cookie variables into the 
global scope
Description
bool import_request_variables ( string types [, string prefix])
Imports GET/POST/Cookie variables into the global scope. It is useful if 
you disabled register_globals, but would like to see some variables in the 
global scope. 
Using the types parameter, you can specify which request variables to 
import. You can use 'G', 'P' and 'C' characters respectively for GET, POST 
and Cookie. These characters are not case sensitive, so you can also use 
any combination of 'g', 'p' and 'c'. POST includes the POST uploaded file 
information. Note that the order of the letters matters, as when using 
"gp", the POST variables will overwrite GET variables with the same name. 
Any other letters than GPC are discarded. 
The prefix parameter is used as a variable name prefix, prepended before 
all variable's name imported into the global scope. So if you have a GET 
value named "userid", and provide a prefix "pref_", then you'll get a 
global variable named $pref_userid. 
If you're interested in importing other variables into the global scope, 
such as SERVER, consider using extract(). 
Note: Although the prefix parameter is optional, you will get an 
E_NOTICE level error if you specify no prefix, or specify an empty 
string as a prefix. This is a possible security hazard. Notice level 
errors are not displayed using the default error reporting level. 
<?php
// This will import GET and POST vars
// with an "rvar_" prefix
import_request_variables("gP", "rvar_");

echo $rvar_foo;
?> 

See also $_REQUEST, register_globals, Predefined Variables, and extract(). 
  gettypeUpintval
#

#T=bool import_request_variables ( string types [, string prefix])
import_request_variables ( ^!string types [, string prefix]);
#

#T=in_array - bool in_array ( mixed needle, array haystack [, bool strict])
(PHP 4 )
in_array -- Checks if a value exists in an array
Description
bool in_array ( mixed needle, array haystack [, bool strict])
Searches haystack for needle and returns TRUE if it is found in the array, 
FALSE otherwise. 
If the third parameter strict is set to TRUE then the in_array() function 
will also check the types of the needle in the haystack. 
Note: If needle is a string, the comparison is done in a case-sensitive 
manner. 
Note: In PHP versions before 4.2.0 needle was not allowed to be an 
array. 
Example 1. in_array() example
  <?php
  $os = array("Mac", "NT", "Irix", "Linux");
  if (in_array("Irix", $os)) {
      echo "Got Irix";
  }
  if (in_array("mac", $os)) {
      echo "Got mac";
  }
  ?> 

The second condition fails because in_array() is case-sensitive, so 
the program above will display: 
Got Irix
Example 2. in_array() with strict example
  <?php
  $a = array('1.10', 12.4, 1.13);

  if (in_array('12.4', $a, true)) {
      echo "'12.4' found with strict check\n";
  }

  if (in_array(1.13, $a, true)) {
      echo "1.13 found with strict check\n";
  }
  ?> 

This will display: 
1.13 found with strict check
Example 3. in_array() with an array as needle
  <?php
  $a = array(array('p', 'h'), array('p', 'r'), 'o');

  if (in_array(array('p', 'h'), $a)) {
      echo "'ph' was found\n";
  }

  if (in_array(array('f', 'i'), $a)) {
      echo "'fi' was found\n";
  }

  if (in_array('o', $a)) {
      echo "'o' was found\n";
  }
  ?> 

Outputs: 
'ph' was found
'o' was found
See also array_search(), array_key_exists(), and isset().   extractUpkey

  PrevChapter 11. Control StructuresNext

include_once()
The include_once() statement includes and evaluates the specified file 
during the execution of the script. This is a behavior similar to the 
include() statement, with the only difference being that if the code from 
a file has already been included, it will not be included again. As the 
name suggests, it will be included just once. 
include_once() should be used in cases where the same file might be 
included and evaluated more than once during a particular execution of a 
script, and you want to be sure that it is included exactly once to avoid 
problems with function redefinitions, variable value reassignments, etc. 
For more examples on using require_once() and include_once(), look at the 
PEAR code included in the latest PHP source code distributions. 
Note: include_once() was added in PHP 4.0.1pl2 
Note: Be aware, that the behaviour of include_once() and require_once() 
may not be what you expect on a non case sensitive operating system 
(such as Windows). Example 11-9. include_once() is case 
insensitive on Windows
    <?php
    include_once("a.php"); // this will include a.php
    include_once("A.php"); // this will include a.php again on 
    Windows!
    ?> 
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 

See also include(), require(), require_once(), get_required_files(), 
get_included_files(), readfile(), and virtual().   require_once()UpFunctions

  PrevChapter 11. Control StructuresNext

include()
The include() statement includes and evaluates the specified file. 
The documentation below also applies to require(). The two constructs are 
identical in every way except how they handle failure. include() produces 
a Warning while require() results in a Fatal Error. In other words, use 
require() if you want a missing file to halt processing of the page. 
include() does not behave this way, the script will continue regardless. 
Be sure to have an appropriate include_path setting as well. 
When a file is included, the code it contains inherits the variable scope 
of the line on which the include occurs. Any variables available at that 
line in the calling file will be available within the called file, from 
that point forward. 
Example 11-3. Basic include() example
  vars.php
  <?php

  $color = 'green';
  $fruit = 'apple';

  ?>

  test.php
  <?php

  echo "A $color $fruit"; // A

  include 'vars.php';

  echo "A $color $fruit"; // A green apple

  ?> 
If the include occurs inside a function within the calling file, then all 
of the code contained in the called file will behave as though it had been 
defined inside that function. So, it will follow the variable scope of 
that function. 
Example 11-4. Including within functions
  <?php

  function foo()
  {
      global $color;

      include 'vars.php';

      echo "A $color $fruit";
  }

  /* vars.php is in the scope of foo() so     *
  * $fruit is NOT available outside of this  *
  * scope.  $color is because we declared it *
  * as global.                               */

  foo();                    // A green apple
  echo "A $color $fruit";   // A green

  ?> 
When a file is included, parsing drops out of PHP mode and into HTML mode 
at the beginning of the target file, and resumes again at the end. For 
this reason, any code inside the target file which should be executed as 
PHP code must be enclosed within valid PHP start and end tags. 
If "URL fopen wrappers" are enabled in PHP (which they are in the default 
configuration), you can specify the file to be included using an URL (via 
HTTP or other supported wrapper - see Appendix I for a list of protocols) 
instead of a local pathname. If the target server interprets the target 
file as PHP code, variables may be passed to the included file using an 
URL request string as used with HTTP GET. This is not strictly speaking 
the same thing as including the file and having it inherit the parent 
file's variable scope; the script is actually being run on the remote 
server and the result is then being included into the local script. 
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 

Example 11-5. include() through HTTP
  <?php

  /* This example assumes that www.example.com is configured to 
  parse .php
  * files and not .txt files. Also, 'Works' here means that the 
  variables
  * $foo and $bar are available within the included file. */

  // Won't work; file.txt wasn't handled by www.example.com as 
  PHP
  include 'http://www.example.com/file.txt?foo=1&bar=2';

  // Won't work; looks for a file named 'file.php?foo=1&bar=2' 
  on the
  // local filesystem.
  include 'file.php?foo=1&bar=2';

  // Works.
  include 'http://www.example.com/file.php?foo=1&bar=2';

  $foo = 1;
  $bar = 2;
  include 'file.txt';  // Works.
  include 'file.php';  // Works.

  ?> 

See also Remote files, fopen() and file() for related information. 
Because include() and require() are special language constructs, you must 
enclose them within a statement block if it's inside a conditional block. 
Example 11-6. include() and conditional blocks
  <?php

  // This is WRONG and will not work as desired.
  if ($condition)
      include $file;
  else
      include $other;
  // This is CORRECT.
  if ($condition) {
      include $file;
  } else {
      include $other;
  }

  ?> 
Handling Returns: It is possible to execute a return() statement inside an 
included file in order to terminate processing in that file and return to 
the script which called it. Also, it's possible to return values from 
included files. You can take the value of the include call as you would a 
normal function. 
Note: In PHP 3, the return may not appear inside a block unless it's a 
function block, in which case the return() applies to that function and 
not the whole file. 
Example 11-7. include() and the return() statement
  return.php
  <?php

  $var = 'PHP';

  return $var;

  ?>

  noreturn.php
  <?php

  $var = 'PHP';

  ?>

  testreturns.php
  <?php

  $foo = include 'return.php';

  echo $foo; // prints 'PHP'

  $bar = include 'noreturn.php';

  echo $bar; // prints 1

  ?> 
$bar is the value 1 because the include was successful. Notice the 
difference between the above examples. The first uses return() within the 
included file while the other does not. A few other ways to "include" 
files into variables are with fopen(), file() or by using include() along 
with Output Control Functions. 
Note: Because this is a language construct and not a function, it cannot 
be called using variable functions
See also require(), require_once(), include_once(), readfile(), virtual(), 
and include_path.   require()Uprequire_once()
#

#T=bool in_array ( mixed needle, array haystack [, bool strict])
in_array ( ^!mixed needle, array haystack [, bool strict]);
#

#T=ingres_autocommit - bool ingres_autocommit ( [resource link])
(PHP 4 >= 4.0.2)
ingres_autocommit -- Switch autocommit on or off
Description
bool ingres_autocommit ( [resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_autocommit() is called before opening a transaction (before the 
first call to ingres_query() or just after a call to ingres_rollback() or 
ingres_commit()) to switch the "autocommit" mode of the server on or off 
(when the script begins the autocommit mode is off). 
When the autocommit mode is on, every query is automatically committed by 
the server, as if ingres_commit() was called after every call to 
ingres_query(). 
See also ingres_query(), ingres_rollback(), and ingres_commit().   Ingres II functionsUpingres_close
#

#T=bool ingres_autocommit ( [resource link])
ingres_autocommit ( ^![resource link]);
#

#T=ingres_close - bool ingres_close ( [resource link])
(PHP 4 >= 4.0.2)
ingres_close -- Close an Ingres II database connection
Description
bool ingres_close ( [resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Returns TRUE on success, or FALSE on failure. 
ingres_close() closes the connection to the Ingres server that's 
associated with the specified link. If the link parameter isn't specified, 
the last opened link is used. 
ingres_close() isn't usually necessary, as it won't close persistent 
connections and all non-persistent connections are automatically closed at 
the end of the script. 
See also ingres_connect() and ingres_pconnect().   ingres_autocommitUpingres_commit
#

#T=bool ingres_close ( [resource link])
ingres_close ( ^![resource link]);
#

#T=ingres_commit - bool ingres_commit ( [resource link])
(PHP 4 >= 4.0.2)
ingres_commit -- Commit a transaction
Description
bool ingres_commit ( [resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_commit() commits the currently open transaction, making all changes 
made to the database permanent. 
This closes the transaction. A new one can be open by sending a query with 
ingres_query(). 
You can also have the server commit automatically after every query by 
calling ingres_autocommit() before opening the transaction. 
See also ingres_query(), ingres_rollback(), and ingres_autocommit().   ingres_closeUpingres_connect
#

#T=bool ingres_commit ( [resource link])
ingres_commit ( ^![resource link]);
#

#T=ingres_connect - resource ingres_connect ( [string database [, string username [, string 
(PHP 4 >= 4.0.2)
ingres_connect --  Open a connection to an Ingres II database 
Description
resource ingres_connect ( [string database [, string username [, string 
password]]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Returns a Ingres II link resource on success, or FALSE on failure. 
ingres_connect() opens a connection with the Ingres database designated by 
database, which follows the syntax [node_id::]dbname[/svr_class]. 
If some parameters are missing, ingres_connect() uses the values in 
php.ini for ingres.default_database, ingres.default_user, and 
ingres.default_password. 
The connection is closed when the script ends or when ingres_close() is 
called on this link. 
All the other ingres functions use the last opened link as a default, so 
you need to store the returned value only if you use more than one link at 
a time. 
Example 1. ingres_connect() example
  <?php
      $link = ingres_connect("mydb", "user", "pass")
	  or die("Could not connect");
      echo "Connected successfully";
      ingres_close($link);
  ?> 

Example 2. ingres_connect() example using default link 
  <?php
      ingres_connect("mydb", "user", "pass")
	  or die("Could not connect");
      echo "Connected successfully";
      ingres_close();
  ?> 
See also ingres_pconnect() and ingres_close().   ingres_commitUpingres_fetch_array
#

#T=resource ingres_connect ( [string database [, string username [, string 
ingres_connect ( ^![string database [, string username [, string ;
#

#T=ingres_fetch_array - array ingres_fetch_array ( [int result_type [, resource link]])
(PHP 4 >= 4.0.2)
ingres_fetch_array -- Fetch a row of result into an array
Description
array ingres_fetch_array ( [int result_type [, resource link]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_fetch_array() Returns an array that corresponds to the fetched row, 
or FALSE if there are no more rows. 
This function is an extended version of ingres_fetch_row(). In addition to 
storing the data in the numeric indices of the result array, it also 
stores the data in associative indices, using the field names as keys. 
If two or more columns of the result have the same field names, the last 
column will take precedence. To access the other column(s) of the same 
name, you must use the numeric index of the column or make an alias for 
the column. 
<?php

ingres_query("select t1.f1 as foo t2.f1 as bar from t1, t2");
$result = ingres_fetch_array();
$foo = $result["foo"];
$bar = $result["bar"];

?> 

result_type can be INGRES_NUM for enumerated array, INGRES_ASSOC for 
associative array, or INGRES_BOTH (default). 
Speed-wise, the function is identical to ingres_fetch_object(), and almost 
as quick as ingres_fetch_row() (the difference is insignificant). 
Example 1. ingres_fetch_array() example
  <?php
  ingres_connect($database, $user, $password);

  ingres_query("select * from table");
  while ($row = ingres_fetch_array()) {
      echo $row["user_id"];  // using associative array
      echo $row["fullname"];
      echo $row[1];          // using enumerated array
      echo $row[2];
  }
  ?> 
See also ingres_query(), ingres_num_fields(), ingres_field_name(), 
ingres_fetch_object(), and ingres_fetch_row().   ingres_connectUpingres_fetch_object
#

#T=array ingres_fetch_array ( [int result_type [, resource link]])
ingres_fetch_array ( ^![int result_type [, resource link]]);
#

#T=ingres_fetch_object - object ingres_fetch_object ( [int result_type [, resource link]])
(PHP 4 >= 4.0.2)
ingres_fetch_object -- Fetch a row of result into an object.
Description
object ingres_fetch_object ( [int result_type [, resource link]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_fetch_object() Returns an object that corresponds to the fetched 
row, or FALSE if there are no more rows. 
This function is similar to ingres_fetch_array(), with one difference - an 
object is returned, instead of an array. Indirectly, that means that you 
can only access the data by the field names, and not by their offsets 
(numbers are illegal property names). 
The optional argument result_type is a constant and can take the following 
values: INGRES_ASSOC, INGRES_NUM, and INGRES_BOTH. 
Speed-wise, the function is identical to ingres_fetch_array(), and almost 
as quick as ingres_fetch_row() (the difference is insignificant). 
Example 1. ingres_fetch_object() example
  <?php
  ingres_connect($database, $user, $password);
  ingres_query("select * from table");
  while ($row = ingres_fetch_object()) {
      echo $row->user_id;
      echo $row->fullname;
  }
  ?> 
See also ingres_query(), ingres_num_fields(), ingres_field_name(), 
ingres_fetch_array(), and ingres_fetch_row().   ingres_fetch_arrayUpingres_fetch_row
#

#T=object ingres_fetch_object ( [int result_type [, resource link]])
ingres_fetch_object ( ^![int result_type [, resource link]]);
#

#T=ingres_fetch_row - array ingres_fetch_row ( [resource link])
(PHP 4 >= 4.0.2)
ingres_fetch_row --  Fetch a row of result into an enumerated array 
Description
array ingres_fetch_row ( [resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_fetch_row() returns an array that corresponds to the fetched row, 
or FALSE if there are no more rows. Each result column is stored in an 
array offset, starting at offset 1. 
Subsequent call to ingres_fetch_row() would return the next row in the 
result set, or FALSE if there are no more rows. 
Example 1. ingres_fetch_row() example
  <?php
  ingres_connect($database, $user, $password);

  ingres_query("select * from table");
  while ($row = ingres_fetch_row()) {
      echo $row[1];
      echo $row[2];
  }
  ?> 
See also ingres_num_fields(), ingres_query(), ingres_fetch_array(), and 
ingres_fetch_object().   ingres_fetch_objectUpingres_field_length
#

#T=array ingres_fetch_row ( [resource link])
ingres_fetch_row ( ^![resource link]);
#

#T=ingres_field_length - int ingres_field_length ( int index [, resource link])
(PHP 4 >= 4.0.2)
ingres_field_length -- Get the length of a field
Description
int ingres_field_length ( int index [, resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_field_length() returns the length of a field. This is the number of 
bytes used by the server to store the field. For detailed information, see 
the Ingres/OpenAPI User Guide - Appendix C. 
index is the number of the field and must be between 1 and the value given 
by ingres_num_fields(). 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object(), and 
ingres_fetch_row().   ingres_fetch_rowUpingres_field_name
#

#T=int ingres_field_length ( int index [, resource link])
ingres_field_length ( ^!int index [, resource link]);
#

#T=ingres_field_name - string ingres_field_name ( int index [, resource link])
(PHP 4 >= 4.0.2)
ingres_field_name -- Get the name of a field in a query result.
Description
string ingres_field_name ( int index [, resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_field_name() returns the name of a field in a query result, or 
FALSE on failure. 
index is the number of the field and must be between 1 and the value given 
by ingres_num_fields(). 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object() and 
ingres_fetch_row().   ingres_field_lengthUpingres_field_nullable
#

#T=string ingres_field_name ( int index [, resource link])
ingres_field_name ( ^!int index [, resource link]);
#

#T=ingres_field_nullable - bool ingres_field_nullable ( int index [, resource link])
(PHP 4 >= 4.0.2)
ingres_field_nullable -- Test if a field is nullable
Description
bool ingres_field_nullable ( int index [, resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_field_nullable() returns TRUE if the field can be set to the NULL 
value and FALSE if it can't. 
index is the number of the field and must be between 1 and the value given 
by ingres_num_fields(). 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object(), and 
ingres_fetch_row().   ingres_field_nameUpingres_field_precision
#

#T=bool ingres_field_nullable ( int index [, resource link])
ingres_field_nullable ( ^!int index [, resource link]);
#

#T=ingres_field_precision - int ingres_field_precision ( int index [, resource link])
(PHP 4 >= 4.0.2)
ingres_field_precision -- Get the precision of a field
Description
int ingres_field_precision ( int index [, resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_field_precision() returns the precision of a field. This value is 
used only for decimal, float and money SQL data types. For detailed 
information, see the Ingres/OpenAPI User Guide - Appendix C. 
index is the number of the field and must be between 1 and the value given 
by ingres_num_fields(). 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object(), and 
ingres_fetch_row().   ingres_field_nullableUpingres_field_scale
#

#T=int ingres_field_precision ( int index [, resource link])
ingres_field_precision ( ^!int index [, resource link]);
#

#T=ingres_field_scale - int ingres_field_scale ( int index [, resource link])
(PHP 4 >= 4.0.2)
ingres_field_scale -- Get the scale of a field
Description
int ingres_field_scale ( int index [, resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_field_scale() returns the scale of a field. This value is used only 
for the decimal SQL data type. For detailed information, see the 
Ingres/OpenAPI User Guide - Appendix C. 
index is the number of the field and must be between 1 and the value given 
by ingres_num_fields(). 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object(), and 
ingres_fetch_row().   ingres_field_precisionUpingres_field_type
#

#T=int ingres_field_scale ( int index [, resource link])
ingres_field_scale ( ^!int index [, resource link]);
#

#T=ingres_field_type - string ingres_field_type ( int index [, resource link])
(PHP 4 >= 4.0.2)
ingres_field_type --  Get the type of a field in a query result 
Description
string ingres_field_type ( int index [, resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_field_type() returns the type of a field in a query result, or 
FALSE on failure. Examples of types returned are "IIAPI_BYTE_TYPE", 
"IIAPI_CHA_TYPE", "IIAPI_DTE_TYPE", "IIAPI_FLT_TYPE", "IIAPI_INT_TYPE", 
"IIAPI_VCH_TYPE". Some of these types can map to more than one SQL type 
depending on the length of the field (see ingres_field_length()). For 
example "IIAPI_FLT_TYPE" can be a float4 or a float8. For detailed 
information, see the Ingres/OpenAPI User Guide - Appendix C. 
index is the number of the field and must be between 1 and the value given 
by ingres_num_fields(). 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object(), and 
ingres_fetch_row().   ingres_field_scaleUpingres_num_fields
#

#T=string ingres_field_type ( int index [, resource link])
ingres_field_type ( ^!int index [, resource link]);
#

#T=ingres_num_fields - int ingres_num_fields ( [resource link])
(PHP 4 >= 4.0.2)
ingres_num_fields --  Get the number of fields returned by the last query 
Description
int ingres_num_fields ( [resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_num_fields() returns the number of fields in the results returned 
by the Ingres server after a call to ingres_query() 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object(), and 
ingres_fetch_row().   ingres_field_typeUpingres_num_rows
#

#T=int ingres_num_fields ( [resource link])
ingres_num_fields ( ^![resource link]);
#

#T=ingres_num_rows - int ingres_num_rows ( [resource link])
(PHP 4 >= 4.0.2)
ingres_num_rows --  Get the number of rows affected or returned by the 
last query 
Description
int ingres_num_rows ( [resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

For delete, insert or update queries, ingres_num_rows() returns the number 
of rows affected by the query. For other queries, ingres_num_rows() 
returns the number of rows in the query's result. 
Note: This function is mainly meant to get the number of rows modified 
in the database. If this function is called before using 
ingres_fetch_array(), ingres_fetch_object() or ingres_fetch_row() the 
server will delete the result's data and the script won't be able to get 
them. 
You should instead retrieve the result's data using one of these fetch 
functions in a loop until it returns FALSE, indicating that no more 
results are available. 
See also ingres_query(), ingres_fetch_array(), ingres_fetch_object(), and 
ingres_fetch_row().   ingres_num_fieldsUpingres_pconnect
#

#T=int ingres_num_rows ( [resource link])
ingres_num_rows ( ^![resource link]);
#

#T=ingres_pconnect - resource ingres_pconnect ( [string database [, string username [, string 
(PHP 4 >= 4.0.2)
ingres_pconnect --  Open a persistent connection to an Ingres II database 
Description
resource ingres_pconnect ( [string database [, string username [, string 
password]]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Returns a Ingres II link resource on success, or FALSE on failure. 
See ingres_connect() for parameters details and examples. There are only 2 
differences between ingres_pconnect() and ingres_connect() : First, when 
connecting, the function will first try to find a (persistent) link that's 
already opened with the same parameters. If one is found, an identifier 
for it will be returned instead of opening a new connection. Second, the 
connection to the Ingres server will not be closed when the execution of 
the script ends. Instead, the link will remain open for future use 
(ingres_close() will not close links established by ingres_pconnect()). 
This type of link is therefore called 'persistent'. 
See also ingres_connect() and ingres_close().   ingres_num_rowsUpingres_query
#

#T=resource ingres_pconnect ( [string database [, string username [, string 
ingres_pconnect ( ^![string database [, string username [, string ;
#

#T=ingres_query - bool ingres_query ( string query [, resource link])
(PHP 4 >= 4.0.2)
ingres_query -- Send a SQL query to Ingres II
Description
bool ingres_query ( string query [, resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Returns TRUE on success, or FALSE on failure. 
ingres_query() sends the given query to the Ingres server. This query must 
be a valid SQL query (see the Ingres SQL reference guide) 
The query becomes part of the currently open transaction. If there is no 
open transaction, ingres_query() opens a new transaction. To close the 
transaction, you can either call ingres_commit() to commit the changes 
made to the database or ingres_rollback() to cancel these changes. When 
the script ends, any open transaction is rolled back (by calling 
ingres_rollback()). You can also use ingres_autocommit() before opening a 
new transaction to have every SQL query immediately committed. 
Some types of SQL queries can't be sent with this function: 
close (see ingres_close()) 
commit (see ingres_commit()) 
connect (see ingres_connect()) 
disconnect (see ingres_close()) 
get dbevent
prepare to commit
rollback (see ingres_rollback()) 
savepoint
set autocommit (see ingres_autocommit()) 
all cursor related queries are unsupported
Example 1. ingres_query() example
  <?php
  ingres_connect($database, $user, $password);

  ingres_query("select * from table");
  while ($row = ingres_fetch_row()) {
      echo $row[1];
      echo $row[2];
  }
  ?> 
See also ingres_fetch_array(), ingres_fetch_object(), ingres_fetch_row(), 
ingres_commit(), ingres_rollback(), and ingres_autocommit().   ingres_pconnectUpingres_rollback
#

#T=bool ingres_query ( string query [, resource link])
ingres_query ( ^!string query [, resource link]);
#

#T=ingres_rollback - bool ingres_rollback ( [resource link])
(PHP 4 >= 4.0.2)
ingres_rollback -- Roll back a transaction
Description
bool ingres_rollback ( [resource link])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ingres_rollback() rolls back the currently open transaction, actually 
canceling all changes made to the database during the transaction. 
This closes the transaction. A new one can be open by sending a query with 
ingres_query(). 
See also ingres_query(), ingres_commit(), and ingres_autocommit().   ingres_queryUpIRC Gateway Functions
ini_alter
ini_alter -- Alias of ini_set()
Description
This function is an alias of ini_set().   getrusageUpini_get_all
#

#T=bool ingres_rollback ( [resource link])
ingres_rollback ( ^![resource link]);
#

#T=ini_get_all - array ini_get_all ( [string extension])
(PHP 4 >= 4.2.0)
ini_get_all -- Gets all configuration options
Description
array ini_get_all ( [string extension])
Returns all the registered configuration options as an associative array. 
If the optional extension parameter is set, returns only options specific 
for that extension. 
The returned array uses the directive name as the array key, with elements 
of that array being global_value (set in php.ini), local_value (perhaps 
set with ini_set() or .htaccess), and access (the access level). See the 
manual section on configuration changes for information on what access 
levels mean. 
Note: It's possible for a directive to have multiple access levels, 
which is why access shows the appropriate bitmask values. 
Example 1. A ini_get_all() example
  <?php
  $inis = ini_get_all();

  print_r($inis);

  ?> 

Partial output may look like: 
Array
(
[allow_call_time_pass_reference] => Array
(
[global_value] => 1
[local_value] => 1
[access] => 6
)
[allow_url_fopen] => Array
(
[global_value] => 1
[local_value] => 1
[access] => 7
)

...

)
See also: ini_get(), ini_restore(), ini_set(), get_loaded_extensions(), 
and phpinfo().   ini_alterUpini_get
#

#T=array ini_get_all ( [string extension])
ini_get_all ( ^![string extension]);
#

#T=ini_get - string ini_get ( string varname)
(PHP 4 )
ini_get -- Gets the value of a configuration option
Description
string ini_get ( string varname)
Returns the value of the configuration option on success. Failure, such as 
querying for a non-existant value, will return an empty string. 
When querying boolean values: A boolean ini value of off will be 
returned as an empty string while a boolean ini value of on will be 
returned as "1". 
When querying memory size values: Many ini memory size values, such as 
upload_max_filesize are stored in the php.ini file in shorthand 
notation. ini_get() will return the exact string stored in the php.ini 
file, NOT its integer equivalent. Attempting normal arithmetic functions 
on these values will not have otherwise expected results. 
<?php
/*
Our php.ini contains the following settings:

display_errors = On
register_globals = Off
post_max_size = 8M
*/

echo 'display_errors = ' . ini_get('display_errors') . "\n";
echo 'register_globals = ' . ini_get('register_globals') . "\n";
echo 'post_max_size = ' . ini_get('post_max_size') . "\n";
echo 'post_max_size+1 = ' . (ini_get('post_max_size')+1) . "\n"; 

?> 

This script will produce: 
display_errors = 1
register_globals = 0
post_max_size = 8M
post_max_size+1 = 9

See also get_cfg_var(), ini_get_all(), ini_restore(), and ini_set().   ini_get_allUpini_restore
#

#T=string ini_get ( string varname)
ini_get ( ^!string varname);
#

#T=ini_restore - string ini_restore ( string varname)
(PHP 4 )
ini_restore -- Restores the value of a configuration option
Description
string ini_restore ( string varname)
Restores a given configuration option to its original value. 
See also ini_get(), ini_get_all(), and ini_set().   ini_getUpini_set
#

#T=string ini_restore ( string varname)
ini_restore ( ^!string varname);
#

#T=ini_set - string ini_set ( string varname, string newvalue)
(PHP 4 )
ini_set -- Sets the value of a configuration option
Description
string ini_set ( string varname, string newvalue)
Sets the value of the given configuration option. Returns the old value on 
success, FALSE on failure. The configuration option will keep this new 
value during the script's execution, and will be restored at the script's 
ending. 
Not all the available options can be changed using ini_set(). Below is a 
table with a list of all PHP options (as of PHP 4.2.0), indicating which 
ones can be changed/set and at what level. 
Table 1. Configuration options
NameDefaultChangeable
com.allow_dcom"0"PHP_INI_SYSTEM
com.autoregister_typelib"0"PHP_INI_SYSTEM
com.autoregister_verbose"0"PHP_INI_SYSTEM
com.autoregister_casesensitive"1"PHP_INI_SYSTEM
com.typelib_file""PHP_INI_SYSTEM
crack.default_dictionaryNULLPHP_INI_SYSTEM
exif.encode_unicode"ISO-8859-15"PHP_INI_ALL
exif.decode_unicode_motorola"UCS-2BE"PHP_INI_ALL
exif.decode_unicode_intel"UCS-2LE"PHP_INI_ALL
exif.encode_jis""PHP_INI_ALL
exif.decode_jis_motorola"JIS"PHP_INI_ALL
exif.decode_jis_intel"JIS"PHP_INI_ALL
fbsql.allow_persistent"1"PHP_INI_SYSTEM
fbsql.generate_warnings"0"PHP_INI_SYSTEM
fbsql.autocommit"1"PHP_INI_SYSTEM
fbsql.max_persistent"-1"PHP_INI_SYSTEM
fbsql.max_links"128"PHP_INI_SYSTEM
fbsql.max_connections"128"PHP_INI_SYSTEM
fbsql.max_results"128"PHP_INI_SYSTEM
fbsql.batchSize"1000"PHP_INI_SYSTEM
fbsql.default_hostNULLPHP_INI_SYSTEM
fbsql.default_user"_SYSTEM"PHP_INI_SYSTEM
fbsql.default_password""PHP_INI_SYSTEM
fbsql.default_database""PHP_INI_SYSTEM
fbsql.default_database_password""PHP_INI_SYSTEM
hwapi.allow_persistent"0"PHP_INI_SYSTEM
hyperwave.allow_persistent"0"PHP_INI_SYSTEM
hyperwave.default_port"418"PHP_INI_ALL
iconv.input_encodingICONV_INPUT_ENCODINGPHP_INI_ALL
iconv.output_encodingICONV_OUTPUT_ENCODINGPHP_INI_ALL
iconv.internal_encodingICONV_INTERNAL_ENCODINGPHP_INI_ALL
ifx.allow_persistent"1"PHP_INI_SYSTEM
ifx.max_persistent"-1"PHP_INI_SYSTEM
ifx.max_links"-1"PHP_INI_SYSTEM
ifx.default_hostNULLPHP_INI_SYSTEM
ifx.default_userNULLPHP_INI_SYSTEM
ifx.default_passwordNULLPHP_INI_SYSTEM
ifx.blobinfile"1"PHP_INI_ALL
ifx.textasvarchar"0"PHP_INI_ALL
ifx.byteasvarchar"0"PHP_INI_ALL
ifx.charasvarchar"0"PHP_INI_ALL
ifx.nullformat"0"PHP_INI_ALL
ingres.allow_persistent"1"PHP_INI_SYSTEM
ingres.max_persistent"-1"PHP_INI_SYSTEM
ingres.max_links"-1"PHP_INI_SYSTEM
ingres.default_databaseNULLPHP_INI_ALL
ingres.default_userNULLPHP_INI_ALL
ingres.default_passwordNULLPHP_INI_ALL
ibase.allow_persistent"1"PHP_INI_SYSTEM
ibase.max_persistent"-1"PHP_INI_SYSTEM
ibase.max_links"-1"PHP_INI_SYSTEM
ibase.default_userNULLPHP_INI_ALL
ibase.default_passwordNULLPHP_INI_ALL
ibase.timestampformat"%m/%d/%Y%H:%M:%S"PHP_INI_ALL
ibase.dateformat"%m/%d/%Y"PHP_INI_ALL
ibase.timeformat"%H:%M:%S"PHP_INI_ALL
java.class.pathNULLPHP_INI_ALL
java.homeNULLPHP_INI_ALL
java.library.pathNULLPHP_INI_ALL
java.libraryJAVALIBPHP_INI_ALL
java.libraryNULLPHP_INI_ALL
ldap.max_links"-1"PHP_INI_SYSTEM
mbstring.detect_orderNULLPHP_INI_ALL
mbstring.http_inputNULLPHP_INI_ALL
mbstring.http_outputNULLPHP_INI_ALL
mbstring.internal_encodingNULLPHP_INI_ALL
mbstring.substitute_characterNULLPHP_INI_ALL
mbstring.func_overload"0"PHP_INI_SYSTEM
mcrypt.algorithms_dirNULLPHP_INI_ALL
mcrypt.modes_dirNULLPHP_INI_ALL
mime_magic.magicfile"/usr/share/misc/magic.mime"PHP_INI_SYSTEM
mssql.allow_persistent"1"PHP_INI_SYSTEM
mssql.max_persistent"-1"PHP_INI_SYSTEM
mssql.max_links"-1"PHP_INI_SYSTEM
mssql.max_procs"25"PHP_INI_ALL
mssql.min_error_severity"10"PHP_INI_ALL
mssql.min_message_severity"10"PHP_INI_ALL
mssql.compatability_mode"0"PHP_INI_ALL
mssql.connect_timeout"5"PHP_INI_ALL
mssql.timeout"60"PHP_INI_ALL
mssql.textsize"-1"PHP_INI_ALL
mssql.textlimit"-1"PHP_INI_ALL
mssql.batchsize"0"PHP_INI_ALL
mssql.datetimeconvert"1"PHP_INI_ALL
mssql.secure_connection"0"PHP_INI_SYSTEM
mysql.allow_persistent"1"PHP_INI_SYSTEM
mysql.max_persistent"-1"PHP_INI_SYSTEM
mysql.max_links"-1"PHP_INI_SYSTEM
mysql.default_hostNULLPHP_INI_ALL
mysql.default_userNULLPHP_INI_ALL
mysql.default_passwordNULLPHP_INI_ALL
mysql.default_portNULLPHP_INI_ALL
mysql.default_socketNULLPHP_INI_ALL
ncurses.value"42"PHP_INI_ALL
ncurses.string"foobar"PHP_INI_ALL
odbc.allow_persistent"1"PHP_INI_SYSTEM
odbc.max_persistent"-1"PHP_INI_SYSTEM
odbc.max_links"-1"PHP_INI_SYSTEM
odbc.default_dbNULLPHP_INI_ALL
odbc.default_userNULLPHP_INI_ALL
odbc.default_pwNULLPHP_INI_ALL
odbc.defaultlrl"4096"PHP_INI_ALL
odbc.defaultbinmode"1"PHP_INI_ALL
odbc.check_persistent"1"PHP_INI_SYSTEM
pfpro.defaulthost"test.signio.com" 
pfpro.defaulthost"test-payflow.verisign.com" 
pfpro.defaultport"443"PHP_INI_ALL
pfpro.defaulttimeout"30"PHP_INI_ALL
pfpro.proxyaddress""PHP_INI_ALL
pfpro.proxyport""PHP_INI_ALL
pfpro.proxylogon""PHP_INI_ALL
pfpro.proxypassword""PHP_INI_ALL
pgsql.allow_persistent"1"PHP_INI_SYSTEM
pgsql.max_persistent"-1"PHP_INI_SYSTEM
pgsql.max_links"-1"PHP_INI_SYSTEM
pgsql.auto_reset_persistent"0"PHP_INI_SYSTEM
pgsql.ignore_notice"0"PHP_INI_ALL
pgsql.log_notice"0"PHP_INI_ALL
session.save_path"/tmp"PHP_INI_ALL
session.name"PHPSESSID"PHP_INI_ALL
session.save_handler"files"PHP_INI_ALL
session.auto_start"0"PHP_INI_ALL
session.gc_probability"1"PHP_INI_ALL
session.gc_maxlifetime"1440"PHP_INI_ALL
session.serialize_handler"php"PHP_INI_ALL
session.cookie_lifetime"0"PHP_INI_ALL
session.cookie_path"/"PHP_INI_ALL
session.cookie_domain""PHP_INI_ALL
session.cookie_secure""PHP_INI_ALL
session.use_cookies"1"PHP_INI_ALL
session.use_only_cookies"0"PHP_INI_ALL
session.referer_check""PHP_INI_ALL
session.entropy_file""PHP_INI_ALL
session.entropy_length"0"PHP_INI_ALL
session.cache_limiter"nocache"PHP_INI_ALL
session.cache_expire"180"PHP_INI_ALL
session.use_trans_sid"0"PHP_INI_SYSTEM|PHP_INI_PERDIR
session.encode_sources"globals,track"PHP_INI_ALL
assert.active"1"PHP_INI_ALL
assert.bail"0"PHP_INI_ALL
assert.warning"1"PHP_INI_ALL
assert.callbackNULLPHP_INI_ALL
assert.quiet_eval"0"PHP_INI_ALL
safe_mode_protected_env_varsSAFE_MODE_PROTECTED_ENV_VARSPHP_INI_SYSTEM
safe_mode_allowed_env_varsSAFE_MODE_ALLOWED_ENV_VARSPHP_INI_SYSTEM
url_rewriter.tags"a=href,area=href,frame=src,form=fakeentry"PHP_INI_ALL
sybct.allow_persistent"1"PHP_INI_SYSTEM
sybct.max_persistent"-1"PHP_INI_SYSTEM
sybct.max_links"-1"PHP_INI_SYSTEM
sybct.min_server_severity"10"PHP_INI_ALL
sybct.min_client_severity"10"PHP_INI_ALL
sybct.hostnameNULLPHP_INI_ALL
vpopmail.directory""PHP_INI_ALL
zlib.output_compression"0"PHP_INI_SYSTEM|PHP_INI_PERDIR
zlib.output_compression_level"-1"PHP_INI_ALL
define_syslog_variables"0"PHP_INI_ALL
highlight.bgHL_BG_COLORPHP_INI_ALL
highlight.commentHL_COMMENT_COLORPHP_INI_ALL
highlight.defaultHL_DEFAULT_COLORPHP_INI_ALL
highlight.htmlHL_HTML_COLORPHP_INI_ALL
highlight.keywordHL_KEYWORD_COLORPHP_INI_ALL
highlight.stringHL_STRING_COLORPHP_INI_ALL
allow_call_time_pass_reference"1"PHP_INI_SYSTEM|PHP_INI_PERDIR
asp_tags"0"PHP_INI_SYSTEM|PHP_INI_PERDIR
display_errors"1"PHP_INI_ALL
display_startup_errors"0"PHP_INI_ALL
enable_dl"1"PHP_INI_SYSTEM
expose_php"1"PHP_INI_SYSTEM
html_errors"1"PHP_INI_SYSTEM
xmlrpc_errors"0"PHP_INI_SYSTEM
xmlrpc_error_number"0"PHP_INI_ALL
ignore_user_abort"0"PHP_INI_ALL
implicit_flush"0"PHP_INI_PERDIR|PHP_INI_SYSTEM
log_errors"0"PHP_INI_ALL
log_errors_max_len"1024"PHP_INI_ALL
ignore_repeated_errors"0"PHP_INI_ALL
ignore_repeated_source"0"PHP_INI_ALL
magic_quotes_gpc"1"PHP_INI_PERDIR|PHP_INI_SYSTEM
magic_quotes_runtime"0"PHP_INI_ALL
magic_quotes_sybase"0"PHP_INI_ALL
output_buffering"0"PHP_INI_PERDIR|PHP_INI_SYSTEM
output_handlerNULLPHP_INI_PERDIR|PHP_INI_SYSTEM
register_argc_argv"1"PHP_INI_PERDIR|PHP_INI_SYSTEM
register_globals"0"PHP_INI_PERDIR|PHP_INI_SYSTEM
safe_mode"1"PHP_INI_SYSTEM
safe_mode"0"PHP_INI_SYSTEM
safe_mode_include_dirNULLPHP_INI_SYSTEM
safe_mode_gid"0"PHP_INI_SYSTEM
short_open_tagDEFAULT_SHORT_OPEN_TAGPHP_INI_SYSTEM|PHP_INI_PERDIR
sql.safe_mode"0"PHP_INI_SYSTEM
track_errors"0"PHP_INI_ALL
y2k_compliance"0"PHP_INI_ALL
unserialize_callback_funcNULLPHP_INI_ALL
arg_separator.output"&"PHP_INI_ALL
arg_separator.input"&"PHP_INI_SYSTEM|PHP_INI_PERDIR
auto_append_fileNULLPHP_INI_SYSTEM|PHP_INI_PERDIR
auto_prepend_fileNULLPHP_INI_SYSTEM|PHP_INI_PERDIR
doc_rootNULLPHP_INI_SYSTEM
default_charsetSAPI_DEFAULT_CHARSETPHP_INI_ALL
default_mimetypeSAPI_DEFAULT_MIMETYPEPHP_INI_ALL
error_logNULLPHP_INI_ALL
extension_dirPHP_EXTENSION_DIRPHP_INI_SYSTEM
gpc_order"GPC"PHP_INI_ALL
include_pathPHP_INCLUDE_PATHPHP_INI_ALL
max_execution_time"30"PHP_INI_ALL
open_basedirNULLPHP_INI_SYSTEM
safe_mode_exec_dir"1"PHP_INI_SYSTEM
upload_max_filesize"2M"PHP_INI_SYSTEM
file_uploads"1"PHP_INI_SYSTEM
post_max_size"8M"PHP_INI_SYSTEM
upload_tmp_dirNULLPHP_INI_SYSTEM
user_dirNULLPHP_INI_SYSTEM
variables_orderNULLPHP_INI_ALL
error_append_stringNULLPHP_INI_ALL
error_prepend_stringNULLPHP_INI_ALL
SMTP"localhost"PHP_INI_ALL
smtp_port25PHP_INI_ALL
browscapNULLPHP_INI_SYSTEM
error_reportingNULLPHP_INI_ALL
memory_limit"8M"PHP_INI_ALL
precision"14"PHP_INI_ALL
sendmail_fromNULLPHP_INI_ALL
sendmail_pathDEFAULT_SENDMAIL_PATHPHP_INI_SYSTEM
disable_functions""PHP_INI_SYSTEM
allow_url_fopen"1"PHP_INI_ALL
always_populate_raw_post_data"0"PHP_INI_ALL
xbithack"0"PHP_INI_ALL
engine"1"PHP_INI_ALL
last_modified"0"PHP_INI_ALL
child_terminate"0"PHP_INI_ALL
async_send"0"PHP_INI_ALL

Table 2. Definition of PHP_INI_* constants
ConstantValueMeaning
PHP_INI_USER1Entry can be set in user scripts
PHP_INI_PERDIR2Entry can be set in php.ini, .htaccess or httpd.conf 
PHP_INI_SYSTEM4Entry can be set in php.ini or httpd.conf 
PHP_INI_ALL7Entry can be set anywhere

See also: get_cfg_var(), ini_get(), ini_get_all(), and ini_restore()   ini_restoreUpmain
#

#T=string ini_set ( string varname, string newvalue)
ini_set ( ^!string varname, string newvalue);
#

#T=intval - int intval ( mixed var [, int base])
(PHP 3, PHP 4 )
intval -- Get integer value of a variable
Description
int intval ( mixed var [, int base])
Returns the integer value of var, using the specified base for the 
conversion (the default is base 10). 
var may be any scalar type. You cannot use intval() on arrays or objects. 
Note: The base argument for intval() has no effect unless the var 
argument is a string. 
See also floatval(), strval(), settype() and Type juggling.   import_request_variablesUpis_array
#

#T=int intval ( mixed var [, int base])
intval ( ^!mixed var [, int base]);
#

#T=ip2long - int ip2long ( string ip_address)
(PHP 4 )
ip2long --  Converts a string containing an (IPv4) Internet Protocol 
dotted address into a proper address. 
Description
int ip2long ( string ip_address)
The function ip2long() generates an IPv4 Internet network address from its 
Internet standard format (dotted string) representation. If ip_address is 
invalid than -1 is returned. Note that -1 does not evaluate as FALSE in 
PHP. Example 1. ip2long() Example
  <?php
  $ip = gethostbyname("www.example.com");
  $out = "The following URLs are equivalent:<br />\n";
  $out .= "http://www.example.com/, http://" . $ip . "/, and 
  http://" . sprintf("%u", ip2long($ip)) . "/<br />\n";
  echo $out;
  ?> 
Note: Because PHP's integer type is signed, and many IP addresses will 
result in negative integers, you need to use the "%u" formatter of 
sprintf() or printf() to get the string representation of the unsigned 
IP address. 
This second example shows how to print a converted address with the 
printf() function : Example 2. Displaying an IP address
  <?php
  $ip   = gethostbyname("www.example.com");
  $long = ip2long($ip);

  if ($long === -1) {
      echo "Invalid IP, please try again";
  } else {
      echo $ip   . "\n";           // 192.0.34.166
      echo $long . "\n";           // -1073732954
      printf("%u\n", ip2long($ip)); // 3221234342
  }
  ?> 
Note: ip2long() will return -1 for the ip 255.255.255.255 
See also long2ip() and sprintf().   getservbyportUplong2ip
#

#T=int ip2long ( string ip_address)
ip2long ( ^!string ip_address);
#

#T=iptcembed - array iptcembed ( string iptcdata, string jpeg_file_name [, int spool])
(PHP 3>= 3.0.7, PHP 4 )
iptcembed -- Embed binary IPTC data into a JPEG image
Description
array iptcembed ( string iptcdata, string jpeg_file_name [, int spool])
Warning
This function is currently not documented; only the argument list is 
available.
  imagewbmpUpiptcparse
#

#T=array iptcembed ( string iptcdata, string jpeg_file_name [, int spool])
iptcembed ( ^!string iptcdata, string jpeg_file_name [, int spool]);
#

#T=iptcparse - array iptcparse ( string iptcblock)
(PHP 3>= 3.0.6, PHP 4 )
iptcparse --  Parse a binary IPTC http://www.iptc.org/ block into single 
tags. 
Description
array iptcparse ( string iptcblock)
This function parses a binary IPTC block into its single tags. It returns 
an array using the tagmarker as an index and the value as the value. It 
returns FALSE on error or if no IPTC data was found. See getimagesize() 
for a sample.   iptcembedUpjpeg2wbmp
#

#T=array iptcparse ( string iptcblock)
iptcparse ( ^!string iptcblock);
#

#T=ircg_channel_mode - bool ircg_channel_mode ( resource connection, string channel, string 
(PHP 4 >= 4.0.5)
ircg_channel_mode --  Set channel mode flags for user 
Description
bool ircg_channel_mode ( resource connection, string channel, string 
mode_spec, string nick)
Set channel mode flags for channel on server connected to by connection. 
Mode flags are passed in mode_spec and are applied to the user specified 
by nick. 
Mode flags are set or cleared by specifying a mode character and 
prepending it with a plus or minus character, respectively. E.g. operator 
mode is granted by '+o' and revoked by '-o', as passed as mode_spec.   IRC Gateway FunctionsUpircg_disconnect
#

#T=bool ircg_channel_mode ( resource connection, string channel, string 
ircg_channel_mode ( ^!resource connection, string channel, string ;
#

#T=ircg_disconnect - bool ircg_disconnect ( resource connection, string reason)
(PHP 4 >= 4.0.4)
ircg_disconnect --  Close connection to server 
Description
bool ircg_disconnect ( resource connection, string reason)
ircg_disconnect() will close a connection to a server previously 
established with ircg_pconnect(). 
See also: ircg_pconnect().   ircg_channel_modeUpircg_fetch_error_msg
#

#T=bool ircg_disconnect ( resource connection, string reason)
ircg_disconnect ( ^!resource connection, string reason);
#

#T=ircg_fetch_error_msg - array ircg_fetch_error_msg ( resource connection)
(PHP 4 >= 4.1.0)
ircg_fetch_error_msg --  Returns the error from previous IRCG operation 
Description
array ircg_fetch_error_msg ( resource connection)
ircg_fetch_error_msg() returns the error from a failed connection. 
Note: Error code is stored in first array element, error text in second. 
The error code is equivalent to IRC reply codes as defined by RFC 2812. 
Example 1. ircg_fetch_error_msg() example
  <?php
  if (!ircg_join ($id, "#php")) {
      $error = ircg_fetch_error_msg($id);
      echo "Can't join channel #php. Error code: 
	    $error[0] Description: $error[1]";
  }
  ?> 

  ircg_disconnectUpircg_get_username
#

#T=array ircg_fetch_error_msg ( resource connection)
ircg_fetch_error_msg ( ^!resource connection);
#

#T=ircg_get_username - string ircg_get_username ( resource connection)
(PHP 4 >= 4.1.0)
ircg_get_username --  Get username for connection 
Description
string ircg_get_username ( resource connection)
Function ircg_get_username() returns the username for the specified 
connection connection. Returns FALSE if connection died or is not valid.   ircg_fetch_error_msgUpircg_html_encode
#

#T=string ircg_get_username ( resource connection)
ircg_get_username ( ^!resource connection);
#

#T=ircg_html_encode - bool ircg_html_encode ( string html_string)
(PHP 4 >= 4.0.5)
ircg_html_encode --  Encodes HTML preserving output 
Description
bool ircg_html_encode ( string html_string)
Encodes a HTML string html_string for output. This exposes the interface 
which the IRCG extension uses internally to reformat data coming from an 
IRC link. The function causes IRC color/font codes to be encoded in HTML 
and escapes certain entities.   ircg_get_usernameUpircg_ignore_add
#

#T=bool ircg_html_encode ( string html_string)
ircg_html_encode ( ^!string html_string);
#

#T=ircg_ignore_add - bool ircg_ignore_add ( resource connection, string nick)
(PHP 4 >= 4.0.5)
ircg_ignore_add --  Add a user to your ignore list on a server 
Description
bool ircg_ignore_add ( resource connection, string nick)
This function adds user nick to the ignore list of connection connection. 
Afterwards, IRCG will suppress all messages from this user through the 
associated connection. 
See also: ircg_ignore_del().   ircg_html_encodeUpircg_ignore_del
#

#T=bool ircg_ignore_add ( resource connection, string nick)
ircg_ignore_add ( ^!resource connection, string nick);
#

#T=ircg_ignore_del - bool ircg_ignore_del ( resource connection, string nick)
(PHP 4 >= 4.0.5)
ircg_ignore_del --  Remove a user from your ignore list on a server 
Description
bool ircg_ignore_del ( resource connection, string nick)
This function removes user nick from the IRCG ignore list associated with 
connection. 
See also: ircg_ignore_add().   ircg_ignore_addUpircg_is_conn_alive
#

#T=bool ircg_ignore_del ( resource connection, string nick)
ircg_ignore_del ( ^!resource connection, string nick);
#

#T=ircg_is_conn_alive - bool ircg_is_conn_alive ( resource connection)
(PHP 4 >= 4.0.5)
ircg_is_conn_alive --  Check connection status 
Description
bool ircg_is_conn_alive ( resource connection)
ircg_is_conn_alive() returns TRUE if connection is still alive and working 
or FALSE, if the connection has died for some reason.   ircg_ignore_delUpircg_join
#

#T=bool ircg_is_conn_alive ( resource connection)
ircg_is_conn_alive ( ^!resource connection);
#

#T=ircg_join - bool ircg_join ( resource connection, string channel [, string key])
(PHP 4 >= 4.0.4)
ircg_join --  Join a channel on a connected server 
Description
bool ircg_join ( resource connection, string channel [, string key])
Join the channel channel on the server connected to by connection. IRCG 
will optionally pass the room key key.   ircg_is_conn_aliveUpircg_kick
#

#T=bool ircg_join ( resource connection, string channel [, string key])
ircg_join ( ^!resource connection, string channel [, string key]);
#

#T=ircg_kick - bool ircg_kick ( resource connection, string channel, string nick, string 
(PHP 4 >= 4.0.5)
ircg_kick --  Kick a user out of a channel on server 
Description
bool ircg_kick ( resource connection, string channel, string nick, string 
reason)
Kick user nick from channel on server connected to by connection. reason 
should give a short message describing why this action was performed.   ircg_joinUpircg_lookup_format_messages
#

#T=bool ircg_kick ( resource connection, string channel, string nick, string 
ircg_kick ( ^!resource connection, string channel, string nick, string ;
#

#T=ircg_lookup_format_messages - bool ircg_lookup_format_messages ( string name)
(PHP 4 >= 4.0.5)
ircg_lookup_format_messages --  Check for the existence of a format 
message set 
Description
bool ircg_lookup_format_messages ( string name)
Check for the existence of the format message set name. Sets may be 
registered with ircg_register_format_messages(), a default set named ircg 
is always available. Returns TRUE, if the set exists and FALSE otherwise. 
See also: ircg_register_format_messages()   ircg_kickUpircg_msg
#

#T=bool ircg_lookup_format_messages ( string name)
ircg_lookup_format_messages ( ^!string name);
#

#T=ircg_msg - bool ircg_msg ( resource connection, string recipient, string message [, 
(PHP 4 >= 4.0.4)
ircg_msg --  Send message to channel or user on server 
Description
bool ircg_msg ( resource connection, string recipient, string message [, 
boolean suppress])
ircg_msg() will send the message to a channel or user on the server 
connected to by connection. A recipient starting with # or & will send the 
message to a channel, anything else will be interpreted as a username. 
Setting the optional parameter suppress to a TRUE value will suppress 
output of your message to your own connection. This so-called loopback is 
necessary, because the IRC server does not echo PRIVMSG commands back to 
us.   ircg_lookup_format_messagesUpircg_nick
#

#T=bool ircg_msg ( resource connection, string recipient, string message [, 
ircg_msg ( ^!resource connection, string recipient, string message [, ;
#

#T=ircg_nick - bool ircg_nick ( resource connection, string nick)
(PHP 4 >= 4.0.5)
ircg_nick --  Change nickname on server 
Description
bool ircg_nick ( resource connection, string nick)
Change your nickname on the given connection to the one given in nick, if 
possible. 
Will return TRUE on success and FALSE on failure.   ircg_msgUpircg_nickname_escape
#

#T=bool ircg_nick ( resource connection, string nick)
ircg_nick ( ^!resource connection, string nick);
#

#T=ircg_nickname_escape - string ircg_nickname_escape ( string nick)
(PHP 4 >= 4.0.6)
ircg_nickname_escape --  Encode special characters in nickname to be 
IRC-compliant 
Description
string ircg_nickname_escape ( string nick)
Function ircg_nickname_escape() returns an encoded nickname specified by 
nick which is IRC-compliant. 
See also: ircg_nickname_unescape()   ircg_nickUpircg_nickname_unescape
#

#T=string ircg_nickname_escape ( string nick)
ircg_nickname_escape ( ^!string nick);
#

#T=ircg_nickname_unescape - string ircg_nickname_unescape ( string nick)
(PHP 4 >= 4.0.6)
ircg_nickname_unescape --  Decodes encoded nickname 
Description
string ircg_nickname_unescape ( string nick)
Function ircg_nickname_unescape() returns a decoded nickname, which is 
specified in nick. 
See also: ircg_nickname_escape()   ircg_nickname_escapeUpircg_notice
#

#T=string ircg_nickname_unescape ( string nick)
ircg_nickname_unescape ( ^!string nick);
#

#T=ircg_notice - bool ircg_notice ( resource connection, string , string message)
(PHP 4 >= 4.0.5)
ircg_notice --  Send a notice to a user on server 
Description
bool ircg_notice ( resource connection, string , string message)
This function will send the message text to the user nick on the server 
connected to by connection. IRC servers and other software will not 
automatically generate replies to NOTICEs in contrast to other message 
types.   ircg_nickname_unescapeUpircg_part
#

#T=bool ircg_notice ( resource connection, string , string message)
ircg_notice ( ^!resource connection, string , string message);
#

#T=ircg_part - bool ircg_part ( resource connection, string channel)
(PHP 4 >= 4.0.4)
ircg_part --  Leave a channel on server 
Description
bool ircg_part ( resource connection, string channel)
Leave the channel channel on the server connected to by connection.   ircg_noticeUpircg_pconnect
#

#T=bool ircg_part ( resource connection, string channel)
ircg_part ( ^!resource connection, string channel);
#

#T=ircg_pconnect - resource ircg_pconnect ( string username [, string server_ip [, int 
(PHP 4 >= 4.0.4)
ircg_pconnect --  Connect to an IRC server 
Description
resource ircg_pconnect ( string username [, string server_ip [, int 
server_port [, string msg_format [, array ctcp_messages [, array 
user_settings]]]]])
ircg_pconnect() will try to establish a connection to an IRC server and 
return a connection resource handle for further use. 
The only mandatory parameter is username, this will set your initial 
nickname on the server. server_ip and server_port are optional and default 
to 127.0.0.1 and 6667. 
Note: For now parameter server_ip will not do any hostname lookups and 
will only accept IP addresses in numerical form. DNS lookups are 
expensive and should be done in the context of IRCG. 
You can customize the output of IRC messages and events by selecting a 
format message set previously created with ircg_register_format_messages() 
by specifying the set's name in msg_format. 
If you want to handle CTCP messages such as ACTION (/me), you need to 
define a mapping from CTCP type (e.g. ACTION) to a custom format string. 
Do this by passing an associative array as ctcp_messages. The keys of the 
array are the CTCP type and the respective value is the format message. 
You can define "ident", "password", and "realname" tokens which are sent 
to the IRC server by setting these in an associative array. Pass that 
array as user_settings. 
See also: ircg_disconnect(), ircg_is_conn_alive(), 
ircg_register_format_messages().   ircg_partUpircg_register_format_messages
#

#T=resource ircg_pconnect ( string username [, string server_ip [, int 
ircg_pconnect ( ^!string username [, string server_ip [, int ;
#

#T=ircg_register_format_messages - bool ircg_register_format_messages ( string name, array messages)
(PHP 4 >= 4.0.5)
ircg_register_format_messages --  Register a format message set 
Description
bool ircg_register_format_messages ( string name, array messages)
With ircg_register_format_messages() you can customize the way your IRC 
output looks like or which script functions are invoked on the client 
side. 
Plain channel message
Private message received
Private message sent
Some user leaves channel
Some user enters channel
Some user was kicked from the channel
Topic has been changed
Error
Fatal error
Join list end(?)
Self part(?)
Some user changes his nick
Some user quits his connection
Mass join begin
Mass join element
Mass join end
Whois user
Whois server
Whois idle
Whois channel
Whois end
Voice status change on user
Operator status change on user
Banlist
Banlist end
%f - from
%t - to
%c - channel
%r - plain message
%m - encoded message
%j - js encoded message
1 - mod encode
2 - nickname decode
See also: ircg_lookup_format_messages().   ircg_pconnectUpircg_set_current
#

#T=bool ircg_register_format_messages ( string name, array messages)
ircg_register_format_messages ( ^!string name, array messages);
#

#T=ircg_set_current - bool ircg_set_current ( resource connection)
(PHP 4 >= 4.0.4)
ircg_set_current --  Set current connection for output 
Description
bool ircg_set_current ( resource connection)
Select the current HTTP connection for output in this execution context. 
Every output sent from the server connected to by connection will be 
copied to standard output while using default formatting or a format 
message set specified by ircg_register_format_messages(). 
See also: ircg_register_format_messages().   ircg_register_format_messagesUpircg_set_file
#

#T=bool ircg_set_current ( resource connection)
ircg_set_current ( ^!resource connection);
#

#T=ircg_set_file - bool ircg_set_file ( resource connection, string path)
(PHP 4 >= 4.2.0)
ircg_set_file --  Set logfile for connection 
Description
bool ircg_set_file ( resource connection, string path)
Function ircg_set_file() specifies a logfile path in which all output from 
connection connection will be logged. Returns TRUE on success, otherwise 
FALSE.   ircg_set_currentUpircg_set_on_die
#

#T=bool ircg_set_file ( resource connection, string path)
ircg_set_file ( ^!resource connection, string path);
#

#T=ircg_set_on_die - bool ircg_set_on_die ( resource connection, string host, int port, string 
(PHP 4 >= 4.2.0)
ircg_set_on_die --  Set action to be executed when connection dies 
Description
bool ircg_set_on_die ( resource connection, string host, int port, string 
data)
In case of the termination of connection connection IRCG will connect to 
host at port (Note: host must be an IPv4 address, IRCG does not resolve 
host-names due to blocking issues), send data to the new host connection 
and will wait until the remote part closes connection. This can be used to 
trigger a PHP script for example. 
This feature requires IRCG 3.   ircg_set_fileUpircg_topic
#

#T=bool ircg_set_on_die ( resource connection, string host, int port, string 
ircg_set_on_die ( ^!resource connection, string host, int port, string ;
#

#T=ircg_topic - bool ircg_topic ( resource connection, string channel, string new_topic)
(PHP 4 >= 4.0.5)
ircg_topic --  Set topic for channel on server 
Description
bool ircg_topic ( resource connection, string channel, string new_topic)
Change the topic for channel channel on the server connected to by 
connection to new_topic.   ircg_set_on_dieUpircg_whois
#

#T=bool ircg_topic ( resource connection, string channel, string new_topic)
ircg_topic ( ^!resource connection, string channel, string new_topic);
#

#T=ircg_whois - bool ircg_whois ( resource connection, string nick)
(PHP 4 >= 4.0.5)
ircg_whois --  Query server for user information 
Description
bool ircg_whois ( resource connection, string nick)
Sends a query to the connected server connection to ask for information 
about the specified user nick.   ircg_topicUpPHP / Java Integration
#

#T=bool ircg_whois ( resource connection, string nick)
ircg_whois ( ^!resource connection, string nick);
#

#T=is_a - bool is_a ( object object, string class_name)
(PHP 4 >= 4.2.0)
is_a --  Returns TRUE if the object is of this class or has this class as 
one of its parents 
Description
bool is_a ( object object, string class_name)
This function returns TRUE if the object is of this class or has this 
class as one of its parents, FALSE otherwise. 
See also get_class(), get_parent_class(), and is_subclass_of().   get_parent_classUpis_subclass_of
#

#T=bool is_a ( object object, string class_name)
is_a ( ^!object object, string class_name);
#

#T=is_array - bool is_array ( mixed var)
(PHP 3, PHP 4 )
is_array -- Finds whether a variable is an array
Description
bool is_array ( mixed var)
Returns TRUE if var is an array, FALSE otherwise. 
See also is_float(), is_int(), is_integer(), is_string(), and is_object(). 
  intvalUpis_bool
#

#T=bool is_array ( mixed var)
is_array ( ^!mixed var);
#

#T=is_bool - bool is_bool ( mixed var)
(PHP 4 )
is_bool --  Finds out whether a variable is a boolean 
Description
bool is_bool ( mixed var)
Returns TRUE if the var parameter is a boolean. 
Example 1. is_bool() examples
  <?php
  $a = false;
  $b = 0;

  // Since $a is a boolean, this is true
  if (is_bool($a)) {
      echo "Yes, this is a boolean";
  }

  // Since $b is not a boolean, this is not true
  if (is_bool($b)) {
      echo "Yes, this is a boolean";
  }
  ?> 
See also is_array(), is_float(), is_int(), is_integer(), is_string(), and 
is_object().   is_arrayUpis_callable
#

#T=bool is_bool ( mixed var)
is_bool ( ^!mixed var);
#

#T=is_callable - bool is_callable ( mixed var [, bool syntax_only [, string 
(PHP 4 >= 4.0.6)
is_callable --  Verify that the contents of a variable can be called as a 
function 
Description
bool is_callable ( mixed var [, bool syntax_only [, string 
callable_name]])
Verify that the contents of a variable can be called as a function. This 
can check that a simple variable contains the name of a valid function, or 
that an array contains a properly encoded object and function name. 
The var parameter can be either the name of a function stored in a string 
variable, or an object and the name of a method within the object, like 
this: array($SomeObject, 'MethodName')

If the syntax_only argument is TRUE the function only verifies that var 
might be a function or method. It will only reject simple variables that 
are not strings, or an array that does not have a valid structure to be 
used as a callback. The valid ones are supposed to have only 2 entries, 
the first of which is an object or a string, and the second a string. 
The callable_name argument receives the "callable name". In the example 
below it's "someClass:someMethod". Note, however, that despite the 
implication that someClass::SomeMethod() is a callable static method, this 
is not the case. 
<?php
//  How to check a variable to see if it can be called
//  as a function.

//
//  Simple variable containing a function
//

function someFunction() {
}

$functionVariable = 'someFunction';

var_dump(is_callable($functionVariable, false, $callable_name));  // 
bool(true)

echo $callable_name, "\n";  // someFunction

//
//  Array containing a method
//

class someClass {

function someMethod() {
}

}

$anObject = new someClass();

$methodVariable = array($anObject, 'someMethod');

var_dump(is_callable($methodVariable, true, $callable_name));  //  
bool(true)

echo $callable_name, "\n";  //  someClass:someMethod

?> 
  is_boolUpis_double
#

#T=bool is_callable ( mixed var [, bool syntax_only [, string 
is_callable ( ^!mixed var [, bool syntax_only [, string ;
#

#T=is_dir - bool is_dir ( string filename)
(PHP 3, PHP 4 )
is_dir -- Tells whether the filename is a directory
Description
bool is_dir ( string filename)
Returns TRUE if the filename exists and is a directory. If filename is a 
relative filename, it will be checked relative to the current working 
directory. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Example 1. is_dir() example
  <?
  var_dump(is_dir('a_file.txt')) . "\n";
  var_dump(is_dir('bogus_dir/abc')) . "\n";

  var_dump(is_dir('..')); //one dir up
  ?> 

The above example will output: 
bool(false)
bool(false)
bool(true)
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also chdir(), dir, opendir(), is_file() and is_link().   globUpis_executable
is_double
is_double -- Alias of is_float()
Description
This function is an alias of is_float().   is_callableUpis_float
#

#T=bool is_dir ( string filename)
is_dir ( ^!string filename);
#

#T=is_executable - bool is_executable ( string filename)
(PHP 3, PHP 4 )
is_executable -- Tells whether the filename is executable
Description
bool is_executable ( string filename)
Returns TRUE if the filename exists and is executable. 
is_executable() became available with Windows in PHP version 5.0.0. 
Example 1. is_executable() example
  <?php

  $file = '/home/vincent/somefile.sh';

  if (is_executable($file)) {
      echo $file.' is executable';
  } else {
      echo $file.' is not executable';
  }

  ?> 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also is_file() and is_link().   is_dirUpis_file
#

#T=bool is_executable ( string filename)
is_executable ( ^!string filename);
#

#T=is_file - bool is_file ( string filename)
(PHP 3, PHP 4 )
is_file -- Tells whether the filename is a regular file
Description
bool is_file ( string filename)
Returns TRUE if the filename exists and is a regular file. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also is_dir() and is_link().   is_executableUpis_link
#

#T=bool is_file ( string filename)
is_file ( ^!string filename);
#

#T=is_finite - bool is_finite ( float val)
(PHP 4 >= 4.2.0)
is_finite -- Finds whether a value is a legal finite number
Description
bool is_finite ( float val)
Returns TRUE if val is a legal finite number within the allowed range for 
a PHP float on this platform. 
See also is_infinite() and is_nan().   hypotUpis_infinite
#

#T=bool is_finite ( float val)
is_finite ( ^!float val);
#

#T=is_float - bool is_float ( mixed var)
(PHP 3, PHP 4 )
is_float -- Finds whether a variable is a float
Description
bool is_float ( mixed var)
Returns TRUE if var is a float, FALSE otherwise. 
Note: To test if a variable is a number or a numeric string (such as 
form input, which is always a string), you must use is_numeric(). 
See also is_bool(), is_int(), is_integer(), is_numeric(), is_string(), 
is_array(), and is_object(),   is_doubleUpis_int
#

#T=bool is_float ( mixed var)
is_float ( ^!mixed var);
#

#T=is_infinite - bool is_infinite ( float val)
(PHP 4 >= 4.2.0)
is_infinite -- Finds whether a value is infinite
Description
bool is_infinite ( float val)
Returns TRUE if val is infinite (positive or negative), like the result of 
log(0) or any value too big to fit into a float on this platform. 
See also is_finite() and is_nan().   is_finiteUpis_nan
#

#T=bool is_infinite ( float val)
is_infinite ( ^!float val);
#

#T=is_int - bool is_int ( mixed var)
(PHP 3, PHP 4 )
is_int -- Find whether a variable is an integer
Description
bool is_int ( mixed var)
Returns TRUE if var is an integer FALSE otherwise. 
Note: To test if a variable is a number or a numeric string (such as 
form input, which is always a string), you must use is_numeric(). 
See also is_bool(), is_float(), is_integer(), is_numeric(), is_string(), 
is_array(), and is_object().   is_floatUpis_integer
is_integer
is_integer -- Alias of is_int()
Description
This function is an alias of is_int().   is_intUpis_long
#

#T=bool is_int ( mixed var)
is_int ( ^!mixed var);
#

#T=is_link - bool is_link ( string filename)
(PHP 3, PHP 4 )
is_link -- Tells whether the filename is a symbolic link
Description
bool is_link ( string filename)
Returns TRUE if the filename exists and is a symbolic link. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also is_dir(), is_file(), and readlink().   is_fileUpis_readable
is_long
is_long -- Alias of is_int()
Description
This function is an alias of is_int().   is_integerUpis_null
#

#T=bool is_link ( string filename)
is_link ( ^!string filename);
#

#T=is_nan - bool is_nan ( float val)
(PHP 4 >= 4.2.0)
is_nan -- Finds whether a value is not a number
Description
bool is_nan ( float val)
Returns TRUE if val is 'not a number', like the result of acos(1.01). 
See also is_finite() and is_infinite().   is_infiniteUplcg_value
#

#T=bool is_nan ( float val)
is_nan ( ^!float val);
#

#T=is_null - bool is_null ( mixed var)
(PHP 4 >= 4.0.4)
is_null --  Finds whether a variable is NULL 
Description
bool is_null ( mixed var)
Returns TRUE if var is null, FALSE otherwise. 
See the NULL type when a variable is considered to be NULL and when not. 
See also NULL, is_bool(), is_numeric(), is_float(), is_int(), is_string(), 
is_object(), is_array(), is_integer(), and is_real().   is_longUpis_numeric
#

#T=bool is_null ( mixed var)
is_null ( ^!mixed var);
#

#T=is_numeric - bool is_numeric ( mixed var)
(PHP 4 )
is_numeric --  Finds whether a variable is a number or a numeric string 
Description
bool is_numeric ( mixed var)
Returns TRUE if var is a number or a numeric string, FALSE otherwise. 
See also is_bool(), is_float(), is_int(), is_string(), is_object(), 
is_array(), and is_integer().   is_nullUpis_object
#

#T=bool is_numeric ( mixed var)
is_numeric ( ^!mixed var);
#

#T=is_object - bool is_object ( mixed var)
(PHP 3, PHP 4 )
is_object -- Finds whether a variable is an object
Description
bool is_object ( mixed var)
Returns TRUE if var is an object, FALSE otherwise. 
See also is_bool(), is_int(), is_integer(), is_float(), is_string(), and 
is_array().   is_numericUpis_real
#

#T=bool is_object ( mixed var)
is_object ( ^!mixed var);
#

#T=is_readable - bool is_readable ( string filename)
(PHP 3, PHP 4 )
is_readable -- Tells whether the filename is readable
Description
bool is_readable ( string filename)
Returns TRUE if the filename exists and is readable. 
Keep in mind that PHP may be accessing the file as the user id that the 
web server runs as (often 'nobody'). Safe mode limitations are not taken 
into account. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also is_writable(), file_exists(), and fgets().   is_linkUpis_uploaded_file
is_real
is_real -- Alias of is_float()
Description
This function is an alias of is_float().   is_objectUpis_resource
#

#T=bool is_readable ( string filename)
is_readable ( ^!string filename);
#

#T=is_resource - bool is_resource ( mixed var)
(PHP 4 )
is_resource --  Finds whether a variable is a resource 
Description
bool is_resource ( mixed var)
is_resource() returns TRUE if the variable given by the var parameter is a 
resource, otherwise it returns FALSE. 
Example 1. using is_resource()
  <?php

  $db_link = @mysql_connect('localhost', 'mysql_user', 
  'mysql_pass');
  if (!is_resource($db_link)) {
      die('Can\'t connect : ' . mysql_error());
  }

  ?> 
See the documentation on the resource-type for more information.   is_realUpis_scalar
#

#T=bool is_resource ( mixed var)
is_resource ( ^!mixed var);
#

#T=is_scalar - bool is_scalar ( mixed var)
(PHP 4 >= 4.0.5)
is_scalar --  Finds whether a variable is a scalar 
Description
bool is_scalar ( mixed var)
is_scalar() returns TRUE if the variable given by the var parameter is a 
scalar, otherwise it returns FALSE. 
Scalar variables are those containing an integer, float, string or 
boolean. Types array, object and resource are not scalar. 
<?php
function show_var($var) {
if (is_scalar($var)) {
    echo $var;
} else {
    var_dump($var);
}
}
$pi = 3.1416;
$proteins = array("hemoglobin", "cytochrome c oxidase", 
"ferredoxin");

show_var($pi);
// prints: 3.1416

show_var($proteins)
// prints:
// array(3) {
//   [0]=>
//   string(10) "hemoglobin"
//   [1]=>
//   string(20) "cytochrome c oxidase"
//   [2]=>
//   string(10) "ferredoxin"
// }
?> 

Note: is_scalar() does not consider resource type values to be scalar as 
resources are abstract datatypes which are currently based on integers. 
This implementation detail should not be relied upon, as it may change. 
See also is_bool(), is_numeric(), is_float(), is_int(), is_real(), 
is_string(), is_object(), is_array(), and is_integer().   is_resourceUpis_string
#

#T=bool is_scalar ( mixed var)
is_scalar ( ^!mixed var);
#

#T=is_string - bool is_string ( mixed var)
(PHP 3, PHP 4 )
is_string -- Finds whether a variable is a string
Description
bool is_string ( mixed var)
Returns TRUE if var is a string, FALSE otherwise. 
See also is_bool(), is_int(), is_integer(), is_float(), is_real(), 
is_object(), and is_array().   is_scalarUpisset
#

#T=bool is_string ( mixed var)
is_string ( ^!mixed var);
#

#T=is_subclass_of - bool is_subclass_of ( object object, string class_name)
(PHP 4 )
is_subclass_of --  Returns TRUE if the object has this class as one of its 
parents 
Description
bool is_subclass_of ( object object, string class_name)
This function returns TRUE if the object object, belongs to a class which 
is a subclass of class_name, FALSE otherwise. 
See also get_class(), get_parent_class() and is_a().   is_aUpmethod_exists
#

#T=bool is_subclass_of ( object object, string class_name)
is_subclass_of ( ^!object object, string class_name);
#

#T=is_uploaded_file - bool is_uploaded_file ( string filename)
(PHP 3>= 3.0.17, PHP 4 >= 4.0.3)
is_uploaded_file -- Tells whether the file was uploaded via HTTP POST
Description
bool is_uploaded_file ( string filename)
Returns TRUE if the file named by filename was uploaded via HTTP POST. 
This is useful to help ensure that a malicious user hasn't tried to trick 
the script into working on files upon which it should not be working--for 
instance, /etc/passwd. 
This sort of check is especially important if there is any chance that 
anything done with uploaded files could reveal their contents to the user, 
or even to other users on the same system. 
is_uploaded_file() is available only in versions of PHP 3 after PHP 
3.0.16, and in versions of PHP 4 after 4.0.2. If you are stuck using an 
earlier version, you can use the following function to help protect 
yourself: 
Note: The following example will not work in versions of PHP 4 after 
4.0.2. It depends on internal functionality of PHP which changed after 
that version. 
<?php
/* Userland test for uploaded file. */
function is_uploaded_file($filename) {
if (!$tmp_file = get_cfg_var('upload_tmp_dir')) {
    $tmp_file = dirname(tempnam('', ''));
}
$tmp_file .= '/' . basename($filename);
/* User might have trailing slash in php.ini... */
return (ereg_replace('/+', '/', $tmp_file) == $filename);
}

/* This is how to use it, since you also don't have
* move_uploaded_file() in these older versions: */
if (is_uploaded_file($HTTP_POST_FILES['userfile'])) {
copy($HTTP_POST_FILES['userfile'], 
"/place/to/put/uploaded/file");
} else {
echo "Possible file upload attack: filename 
'$HTTP_POST_FILES[userfile]'.";
}
?> 

See also move_uploaded_file(), and the section Handling file uploads for a 
simple usage example.   is_readableUpis_writable
#

#T=bool is_uploaded_file ( string filename)
is_uploaded_file ( ^!string filename);
#

#T=is_writable - bool is_writable ( string filename)
(PHP 4 )
is_writable -- Tells whether the filename is writable
Description
bool is_writable ( string filename)
Returns TRUE if the filename exists and is writable. The filename argument 
may be a directory name allowing you to check if a directory is writeable. 

Keep in mind that PHP may be accessing the file as the user id that the 
web server runs as (often 'nobody'). Safe mode limitations are not taken 
into account. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also is_readable(), file_exists(), and fwrite().   is_uploaded_fileUpis_writeable
is_writeable
is_writeable -- Alias of is_writable()
Description
This function is an alias of is_writable().   is_writableUplink
#

#T=bool is_writable ( string filename)
is_writable ( ^!string filename);
#

#T=isset - bool isset ( mixed var [, mixed var [, ...]])
(PHP 3, PHP 4 )
isset -- Determine whether a variable is set
Description
bool isset ( mixed var [, mixed var [, ...]])
Returns TRUE if var exists; FALSE otherwise. 
If a variable has been unset with unset(), it will no longer be set. 
isset() will return FALSE if testing a variable that has been set to NULL. 
Also note that a NULL byte ("\0") is not equivalent to the PHP NULL 
constant. 
Warning: isset() only works with variables as passing anything else will 
result in a parse error. For checking if constants are set use the 
defined() function. 
<?php

$var = '';

// This will evaluate to &true; so the text will be printed.
if (isset($var)) {
echo "This var is set set so I will print.";
}

// In the next examples we'll use var_dump to output
// the return value of isset().

$a = "test";
$b = "anothertest";

var_dump(isset($a));      // TRUE
var_dump(isset($a, $b)); // TRUE

unset ($a);

var_dump(isset($a));     // FALSE
var_dump(isset($a, $b)); // FALSE

$foo = NULL;
var_dump(isset($foo));   // FALSE

?> 

This also work for elements in arrays: 
<?php

$a = array ('test' => 1, 'hello' => NULL);

var_dump(isset($a['test']));            // TRUE
var_dump(isset($a['foo']));             // FALSE
var_dump(isset($a['hello']));           // FALSE

// The key 'hello' equals NULL so is considered unset
// If you want to check for NULL key values then try: 
var_dump(array_key_exists('hello', $a)); // TRUE

?> 

Note: Because this is a language construct and not a function, it cannot 
be called using variable functions
See also empty(), unset(), defined(), the type comparison tables, 
array_key_exists(), and the error control @ operator.   is_stringUpprint_r
#

#T=bool isset ( mixed var [, mixed var [, ...]])
isset ( ^!mixed var [, mixed var [, ...]]);
#

#T=java_last_exception_clear - void java_last_exception_clear ( void )
(PHP 4 >= 4.0.2)
java_last_exception_clear -- Clear last Java exception
Description
void java_last_exception_clear ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See java_last_exception_get() for an example.   PHP / Java IntegrationUpjava_last_exception_get
#

#T=void java_last_exception_clear ( void )
java_last_exception_clear ( ^!void );
#

#T=java_last_exception_get - exception java_last_exception_get ( void )
(PHP 4 >= 4.0.2)
java_last_exception_get -- Get last Java exception
Description
exception java_last_exception_get ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The following example demonstrates the usage of Java's exception handler 
from within PHP: Example 1. Java exception handler
  <?php
    $stack = new Java('java.util.Stack');
    $stack->push(1);

    // This should succeed
    $result = $stack->pop();
    $ex = java_last_exception_get();
    if (!$ex) {
      echo "$result\n";
    }

    // This should fail (error suppressed by @)
    $result = @$stack->pop();
    $ex = java_last_exception_get();
    if ($ex) {
      echo $ex->toString();
    }

    // Clear last exception
    java_last_exception_clear();
  ?> 

  java_last_exception_clearUpLDAP functions
#

#T=exception java_last_exception_get ( void )
java_last_exception_get ( ^!void );
#

#T=JDDayOfWeek - mixed jddayofweek ( int julianday, int mode)
(PHP 3, PHP 4 )
JDDayOfWeek -- Returns the day of the week
Description
mixed jddayofweek ( int julianday, int mode)
Returns the day of the week. Can return a string or an integer depending 
on the mode. 
Table 1. Calendar week modes
ModeMeaning
0Returns the day number as an int (0=Sunday, 1=Monday, etc) 
1Returns string containing the day of week (English-Gregorian) 
2Returns a string containing the abbreviated day of week 
(English-Gregorian) 
  GregorianToJDUpJDMonthName
#

#T=mixed jddayofweek ( int julianday, int mode)
jddayofweek ( ^!int julianday, int mode);
#

#T=JDMonthName - string jdmonthname ( int julianday, int mode)
(PHP 3, PHP 4 )
JDMonthName -- Returns a month name
Description
string jdmonthname ( int julianday, int mode)
Returns a string containing a month name. mode tells this function which 
calendar to convert the Julian Day Count to, and what type of month names 
are to be returned. 
Table 1. Calendar modes
ModeMeaningValues
0Gregorian - abbreviatedJan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, 
Oct, Nov, Dec
1GregorianJanuary, February, March, April, May, June, July, August, 
September, October, November, December
2Julian - abbreviatedJan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, 
Oct, Nov, Dec
3JulianJanuary, February, March, April, May, June, July, August, 
September, October, November, December
4JewishTishri, Heshvan, Kislev, Tevet, Shevat, AdarI, AdarII, Nisan, 
Iyyar, Sivan, Tammuz, Av, Elul
5French RepublicanVendemiaire, Brumaire, Frimaire, Nivose, Pluviose, 
Ventose, Germinal, Floreal, Prairial, Messidor, Thermidor, 
Fructidor, Extra
  JDDayOfWeekUpJDToFrench
#

#T=string jdmonthname ( int julianday, int mode)
jdmonthname ( ^!int julianday, int mode);
#

#T=JDToFrench - string jdtofrench ( int juliandaycount)
(PHP 3, PHP 4 )
JDToFrench --  Converts a Julian Day Count to the French Republican 
Calendar 
Description
string jdtofrench ( int juliandaycount)
Converts a Julian Day Count to the French Republican Calendar.   JDMonthNameUpJDToGregorian
#

#T=string jdtofrench ( int juliandaycount)
jdtofrench ( ^!int juliandaycount);
#

#T=JDToGregorian - string jdtogregorian ( int julianday)
(PHP 3, PHP 4 )
JDToGregorian -- Converts Julian Day Count to Gregorian date
Description
string jdtogregorian ( int julianday)
Converts Julian Day Count to a string containing the Gregorian date in the 
format of "month/day/year".   JDToFrenchUpjdtojewish
#

#T=string jdtogregorian ( int julianday)
jdtogregorian ( ^!int julianday);
#

#T=jdtojewish - string jdtojewish ( int juliandaycount [, bool hebrew [, int fl]])
(PHP 3, PHP 4 )
jdtojewish --  Converts a Julian day count to a Jewish calendar date 
Description
string jdtojewish ( int juliandaycount [, bool hebrew [, int fl]])
Converts a Julian Day Count the the Jewish Calendar. 
The optional hebrew and fl parameters became available in PHP 5.0.0 
If the the hebrew parameter is set to TRUE, the fl parameter is used for 
Hebrew, string based, output format. The available formats are: 
CAL_JEWISH_ADD_ALAFIM_GERESH, CAL_JEWISH_ADD_ALAFIM, 
CAL_JEWISH_ADD_GERESHAYIM. 
Example 1. jdtojewish() Example
  <?php
  echo jdtojewish(gregoriantojd(10, 8, 2002), true,
	 CAL_JEWISH_ADD_GERESHAYIM + CAL_JEWISH_ADD_ALAFIM + 
  CAL_JEWISH_ADD_ALAFIM_GERESH); 
  ?> 

  JDToGregorianUpJDToJulian
#

#T=string jdtojewish ( int juliandaycount [, bool hebrew [, int fl]])
jdtojewish ( ^!int juliandaycount [, bool hebrew [, int fl]]);
#

#T=JDToJulian - string jdtojulian ( int julianday)
(PHP 3, PHP 4 )
JDToJulian --  Converts a Julian Day Count to a Julian Calendar Date 
Description
string jdtojulian ( int julianday)
Converts Julian Day Count to a string containing the Julian Calendar Date 
in the format of "month/day/year".   jdtojewishUpjdtounix
#

#T=string jdtojulian ( int julianday)
jdtojulian ( ^!int julianday);
#

#T=jdtounix - int jdtounix ( int jday)
(PHP 4 )
jdtounix -- Convert Julian Day to Unix timestamp
Description
int jdtounix ( int jday)
This function will return a Unix timestamp corresponding to the Julian Day 
given in jday or FALSE if jday is not inside the Unix epoch (Gregorian 
years between 1970 and 2037 or 2440588 <= jday <= 2465342 ). The time 
returned is localtime (and not GMT). 
See also unixtojd().   JDToJulianUpJewishToJD
#

#T=int jdtounix ( int jday)
jdtounix ( ^!int jday);
#

#T=JewishToJD - int jewishtojd ( int month, int day, int year)
(PHP 3, PHP 4 )
JewishToJD --  Converts a date in the Jewish Calendar to Julian Day Count 
Description
int jewishtojd ( int month, int day, int year)
Although this function can handle dates all the way back to the year 1 
(3761 B.C.), such use may not be meaningful. The Jewish calendar has been 
in use for several thousand years, but in the early days there was no 
formula to determine the start of a month. A new month was started when 
the new moon was first observed.   jdtounixUpJulianToJD
join
join -- Alias for implode()
Description
This function is an alias of implode().   implodeUplevenshtein
#

#T=int jewishtojd ( int month, int day, int year)
jewishtojd ( ^!int month, int day, int year);
#

#T=jpeg2wbmp - int jpeg2wbmp ( string jpegname, string wbmpname, int d_height, int 
(PHP 4 >= 4.0.5)
jpeg2wbmp -- Convert JPEG image file to WBMP image file
Description
int jpeg2wbmp ( string jpegname, string wbmpname, int d_height, int 
d_width, int threshold)
Converts the jpegname JPEG file to WBMP format, and saves it as wbmpname. 
With the d_height and d_width you specify the height and width of the 
destination image. 
Note: WBMP support is only available if PHP was compiled against GD-1.8 
or later. 
See also png2wbmp().   iptcparseUppng2wbmp
#

#T=int jpeg2wbmp ( string jpegname, string wbmpname, int d_height, int 
jpeg2wbmp ( ^!string jpegname, string wbmpname, int d_height, int ;
#

#T=JulianToJD - int juliantojd ( int month, int day, int year)
(PHP 3, PHP 4 )
JulianToJD --  Converts a Julian Calendar date to Julian Day Count 
Description
int juliantojd ( int month, int day, int year)
Valid Range for Julian Calendar 4713 B.C. to 9999 A.D. 
Although this function can handle dates all the way back to 4713 B.C., 
such use may not be meaningful. The calendar was created in 46 B.C., but 
the details did not stabilize until at least 8 A.D., and perhaps as late 
at the 4th century. Also, the beginning of a year varied from one culture 
to another - not all accepted January as the first month. 
Caution
Remember, the current calendar system being used worldwide is the 
Gregorian calendar. gregoriantojd() can be used to convert such 
dates to their Julian Day count. 
  JewishToJDUpunixtojd
#

#T=int juliantojd ( int month, int day, int year)
juliantojd ( ^!int month, int day, int year);
#

#T=key - mixed key ( array array)
(PHP 3, PHP 4 )
key -- Fetch a key from an associative array
Description
mixed key ( array array)
key() returns the index element of the current array position. 
Example 1. key() example
  <?php
  $array = array(
      'fruit1' => 'apple',
      'fruit2' => 'orange',
      'fruit3' => 'grape',
      'fruit4' => 'apple',
      'fruit5' => 'apple');

  // this cycle echoes all associative array
  // key where value equals "apple"
  while ($fruit_name = current($array)) {
      if ($fruit_name == 'apple') {
	  echo key($array).'<br />';
      }
      next($array);
  }
  ?> 
See also current() and next().   in_arrayUpkrsort
#

#T=mixed key ( array array)
key ( ^!array array);
#

#T=krsort - bool krsort ( array array [, int sort_flags])
(PHP 3>= 3.0.13, PHP 4 )
krsort -- Sort an array by key in reverse order
Description
bool krsort ( array array [, int sort_flags])
Sorts an array by key in reverse order, maintaining key to data 
correlations. This is useful mainly for associative arrays. 
Returns TRUE on success or FALSE on failure. 
Example 1. krsort() example
  <?php
  $fruits = array("d"=>"lemon", "a"=>"orange", "b"=>"banana", 
  "c"=>"apple");
  krsort($fruits);
  reset($fruits);
  while (list($key, $val) = each($fruits)) {
      echo "$key = $val\n";
  }
  ?> 

This example would display: 
d = lemon
c = apple
b = banana
a = orange
You may modify the behavior of the sort using the optional parameter 
sort_flags, for details see sort(). 
See also asort(), arsort(), ksort(), sort(), natsort(), and rsort().   keyUpksort
#

#T=bool krsort ( array array [, int sort_flags])
krsort ( ^!array array [, int sort_flags]);
#

#T=ksort - bool ksort ( array array [, int sort_flags])
(PHP 3, PHP 4 )
ksort -- Sort an array by key
Description
bool ksort ( array array [, int sort_flags])
Sorts an array by key, maintaining key to data correlations. This is 
useful mainly for associative arrays. 
Returns TRUE on success or FALSE on failure. 
Example 1. ksort() example
  <?php
  $fruits = array("d"=>"lemon", "a"=>"orange", "b"=>"banana", 
  "c"=>"apple");
  ksort($fruits);
  reset($fruits);
  while (list($key, $val) = each($fruits)) {
      echo "$key = $val\n";
  }
  ?> 

This example would display: 
a = orange
b = banana
c = apple
d = lemon
You may modify the behavior of the sort using the optional parameter 
sort_flags, for details see sort(). 
See also asort(), arsort(), krsort(), uksort(), sort(), natsort(), and 
rsort(). 
Note: The second parameter was added in PHP 4.   krsortUplist
#

#T=bool ksort ( array array [, int sort_flags])
ksort ( ^!array array [, int sort_flags]);
#

#T=lcg_value - float lcg_value ( void )
(PHP 4 )
lcg_value -- Combined linear congruential generator
Description
float lcg_value ( void )
lcg_value() returns a pseudo random number in the range of (0, 1). The 
function combines two CGs with periods of 2^31 - 85 and 2^31 - 249. The 
period of this function is equal to the product of both primes.   is_nanUplog10
#

#T=float lcg_value ( void )
lcg_value ( ^!void );
#

#T=ldap_8859_to_t61 - string ldap_8859_to_t61 ( string value)
(PHP 4 >= 4.0.2)
ldap_8859_to_t61 --  Translate 8859 characters to t61 characters 
Description
string ldap_8859_to_t61 ( string value)
Warning
This function is currently not documented; only the argument list is 
available.
  LDAP functionsUpldap_add
#

#T=string ldap_8859_to_t61 ( string value)
ldap_8859_to_t61 ( ^!string value);
#

#T=ldap_add - bool ldap_add ( resource link_identifier, string dn, array entry)
(PHP 3, PHP 4 )
ldap_add -- Add entries to LDAP directory
Description
bool ldap_add ( resource link_identifier, string dn, array entry)
Returns TRUE on success or FALSE on failure. 
The ldap_add() function is used to add entries in the LDAP directory. The 
DN of the entry to be added is specified by dn. Array entry specifies the 
information about the entry. The values in the entries are indexed by 
individual attributes. In case of multiple values for an attribute, they 
are indexed using integers starting with 0. 

entry["attribute1"] = value
entry["attribute2"][0] = value1
entry["attribute2"][1] = value2

Example 1. Complete example with authenticated bind
  <?php
  $ds=ldap_connect("localhost");  // assuming the LDAP server is 
  on this host

  if ($ds) {
      // bind with appropriate dn to give update access
      $r=ldap_bind($ds, "cn=root, o=My Company, c=US", 
"secret");

      // prepare data
      $info["cn"]="John Jones";
      $info["sn"]="Jones";
      $info["mail"]="jonj@example.com";
      $info["objectclass"]="person";

      // add data to directory
      $r=ldap_add($ds, "cn=John Jones, o=My Company, c=US", 
  $info);

      ldap_close($ds);
  } else {
      echo "Unable to connect to LDAP server"; 
  }
  ?> 

  ldap_8859_to_t61Upldap_bind
#

#T=bool ldap_add ( resource link_identifier, string dn, array entry)
ldap_add ( ^!resource link_identifier, string dn, array entry);
#

#T=ldap_bind - bool ldap_bind ( resource link_identifier [, string bind_rdn [, string 
(PHP 3, PHP 4 )
ldap_bind -- Bind to LDAP directory
Description
bool ldap_bind ( resource link_identifier [, string bind_rdn [, string 
bind_password]])
Binds to the LDAP directory with specified RDN and password. Returns TRUE 
on success or FALSE on failure.
ldap_bind() does a bind operation on the directory. bind_rdn and 
bind_password are optional. If not specified, anonymous bind is attempted. 

Example 1. Using LDAP Bind
  <?php

  // using ldap bind
  $ldaprdn  = 'uname';     // ldap rdn or dn
  $ldappass = 'password';  // associated password

  // connect to ldap server
  $ldapconn = ldap_connect("ldap.example.com")
      or die("Could not connect to LDAP server.");

  if ($ldapconn) {

      // binding to ldap server
      $ldapbind = ldap_bind($ldapconn, $ldaprdn, $ldappass);

      // verify binding
      if ($ldapbind) {
	  echo "LDAP bind successful...";
      } else {
	  echo "LDAP bind failed...";
      }
	  
  }

  ?> 

Example 2. Using LDAP Bind Anonymously
  <?php

  //using ldap bind anonymously

  // connect to ldap server
  $ldapconn = ldap_connect("ldap.example.com")
      or die("Could not connect to LDAP server.");

  if ($ldapconn) {

      // binding anonymously
      $ldapbind = ldap_bind($ldapconn);

      if ($ldapbind) {
	  echo "LDAP bind anonymous successful...";
      } else {
	  echo "LDAP bind anonymous failed...";
      }

  }
      
  ?> 

  ldap_addUpldap_close
#

#T=bool ldap_bind ( resource link_identifier [, string bind_rdn [, string 
ldap_bind ( ^!resource link_identifier [, string bind_rdn [, string ;
#

#T=ldap_close - bool ldap_close ( resource link_identifier)
(PHP 3, PHP 4 )
ldap_close -- Close link to LDAP server
Description
bool ldap_close ( resource link_identifier)
Returns TRUE on success or FALSE on failure. 
ldap_close() closes the link to the LDAP server that's associated with the 
specified link_identifier.
This call is internally identical to ldap_unbind(). The LDAP API uses the 
call ldap_unbind(), so perhaps you should use this in preference to 
ldap_close().
Note: This function is an alias of ldap_unbind().   ldap_bindUpldap_compare
#

#T=bool ldap_close ( resource link_identifier)
ldap_close ( ^!resource link_identifier);
#

#T=ldap_compare - bool ldap_compare ( resource link_identifier, string dn, string attribute, 
(PHP 4 >= 4.0.2)
ldap_compare -- Compare value of attribute found in entry specified with 
DN
Description
bool ldap_compare ( resource link_identifier, string dn, string attribute, 
string value)
Returns TRUE if value matches otherwise returns FALSE. Returns -1 on 
error. 
ldap_compare() is used to compare value of attribute to value of same 
attribute in LDAP directory entry specified with dn. 
The following example demonstrates how to check whether or not given 
password matches the one defined in DN specified entry. 
Example 1. Complete example of password check
  <?php

  $ds=ldap_connect("localhost");  // assuming the LDAP server is 
  on this host
	
  if ($ds) {

      // bind 
      if (ldap_bind($ds)) {

	  // prepare data
	  $dn = "cn=Matti Meikku, ou=My Unit, o=My Company, 
  c=FI";
	  $value = "secretpassword";
	  $attr = "password"; 

	  // compare value
	  $r=ldap_compare($ds, $dn, $attr, $value);

	  if ($r === -1) {
	      echo "Error: " . ldap_error($ds);
	  } elseif ($r === true) {
	      echo "Password correct.";
	  } elseif ($r === false) {
	      echo "Wrong guess! Password incorrect.";
	  }

      } else {
	  echo "Unable to bind to LDAP server.";
      }          

      ldap_close($ds);

  } else {
      echo "Unable to connect to LDAP server.";
  }
  ?> 
Warning
ldap_compare() can NOT be used to compare BINARY values! 

Note: This function was added in 4.0.2.   ldap_closeUpldap_connect
#

#T=bool ldap_compare ( resource link_identifier, string dn, string attribute, 
ldap_compare ( ^!resource link_identifier, string dn, string attribute, ;
#

#T=ldap_connect - resource ldap_connect ( [string hostname [, int port]])
(PHP 3, PHP 4 )
ldap_connect -- Connect to an LDAP server
Description
resource ldap_connect ( [string hostname [, int port]])
Returns a positive LDAP link identifier on success, or FALSE on error.
ldap_connect() establishes a connection to a LDAP server on a specified 
hostname and port. Both the arguments are optional. If no arguments are 
specified then the link identifier of the already opened link will be 
returned. If only hostname is specified, then the port defaults to 389.
If you are using OpenLDAP 2.x.x you can specify a URL instead of the 
hostname. To use LDAP with SSL, compile OpenLDAP 2.x.x with SSL support, 
configure PHP with SSL, and use ldaps://hostname/ as host parameter. The 
port parameter is not used when using URLs. 
Note: URL and SSL support were added in 4.0.4. 
Example 1. Example of connecting to LDAP server.
  <?php

  // LDAP variables
  $ldaphost = "ldap.example.com";  // your ldap servers
  $ldapport = 389;                 // your ldap server's port 
  number

  // Connecting to LDAP
  $ldapconn = ldap_connect($ldaphost, $ldapport) 
	    or die("Could not connect to $ldaphost");

  ?> 

Example 2. Example of connecting securely to LDAP server.
  <?php

  // make sure your host is the correct one
  // that you issued your secure certificate to
  $ldaphost = "ldaps://ldap.example.com/";

  // Connecting to LDAP
  $ldapconn = ldap_connect($ldaphost) 
	    or die("Could not connect to {$ldaphost}");

  ?> 

  ldap_compareUpldap_count_entries
#

#T=resource ldap_connect ( [string hostname [, int port]])
ldap_connect ( ^![string hostname [, int port]]);
#

#T=ldap_count_entries - int ldap_count_entries ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_count_entries -- Count the number of entries in a search
Description
int ldap_count_entries ( resource link_identifier, resource 
result_identifier)
Returns number of entries in the result or FALSE on error.
ldap_count_entries() returns the number of entries stored in the result of 
previous search operations. result_identifier identifies the internal ldap 
result.  ldap_connectUpldap_delete
#

#T=int ldap_count_entries ( resource link_identifier, resource 
ldap_count_entries ( ^!resource link_identifier, resource ;
#

#T=ldap_delete - bool ldap_delete ( resource link_identifier, string dn)
(PHP 3, PHP 4 )
ldap_delete -- Delete an entry from a directory
Description
bool ldap_delete ( resource link_identifier, string dn)
Returns TRUE on success or FALSE on failure.
ldap_delete() function delete a particular entry in LDAP directory 
specified by dn.   ldap_count_entriesUpldap_dn2ufn
#

#T=bool ldap_delete ( resource link_identifier, string dn)
ldap_delete ( ^!resource link_identifier, string dn);
#

#T=ldap_dn2ufn - string ldap_dn2ufn ( string dn)
(PHP 3, PHP 4 )
ldap_dn2ufn -- Convert DN to User Friendly Naming format
Description
string ldap_dn2ufn ( string dn)
ldap_dn2ufn() function is used to turn a DN, specified by dn, into a more 
user-friendly form, stripping off type names.   ldap_deleteUpldap_err2str
#

#T=string ldap_dn2ufn ( string dn)
ldap_dn2ufn ( ^!string dn);
#

#T=ldap_err2str - string ldap_err2str ( int errno)
(PHP 3>= 3.0.13, PHP 4 )
ldap_err2str --  Convert LDAP error number into string error message 
Description
string ldap_err2str ( int errno)
Returns string error message.
This function returns the string error message explaining the error number 
errno. While LDAP errno numbers are standardized, different libraries 
return different or even localized textual error messages. Never check for 
a specific error message text, but always use an error number to check.
See also ldap_errno() and ldap_error(). Example 1. Enumerating all 
LDAP error messages
  <?php
    for ($i=0; $i<100; $i++) {
      printf("Error $i: %s<br />\n", ldap_err2str($i));
    }
  ?> 

  ldap_dn2ufnUpldap_errno
#

#T=string ldap_err2str ( int errno)
ldap_err2str ( ^!int errno);
#

#T=ldap_errno - int ldap_errno ( resource link_identifier)
(PHP 3>= 3.0.12, PHP 4 )
ldap_errno --  Return the LDAP error number of the last LDAP command 
Description
int ldap_errno ( resource link_identifier)
Return the LDAP error number of the last LDAP command for this link.
This function returns the standardized error number returned by the last 
LDAP command for the given link_identifier. This number can be converted 
into a textual error message using ldap_err2str().
Unless you lower your warning level in your php.ini sufficiently or prefix 
your LDAP commands with @ (at) characters to suppress warning output, the 
errors generated will also show up in your HTML output. Example 1. 
Generating and catching an error
  <?php
  // This example contains an error, which we will catch.
  $ld = ldap_connect("localhost");
  $bind = ldap_bind($ld);
  // syntax error in filter expression (errno 87),
  // must be "objectclass=*" to work.
  $res =  @ldap_search($ld, "o=Myorg, c=DE", "objectclass");
  if (!$res) {
      echo "LDAP-Errno: " . ldap_errno($ld) . "<br />\n";
      echo "LDAP-Error: " . ldap_error($ld) . "<br />\n";
      die("Argh!<br />\n");
  }
  $info = ldap_get_entries($ld, $res);
  echo $info["count"] . " matching entries.<br />\n";
  ?> 
See also ldap_err2str() and ldap_error().  ldap_err2strUpldap_error
#

#T=int ldap_errno ( resource link_identifier)
ldap_errno ( ^!resource link_identifier);
#

#T=ldap_error - string ldap_error ( resource link_identifier)
(PHP 3>= 3.0.12, PHP 4 )
ldap_error --  Return the LDAP error message of the last LDAP command 
Description
string ldap_error ( resource link_identifier)
Returns string error message.
This function returns the string error message explaining the error 
generated by the last LDAP command for the given link_identifier While 
LDAP errno numbers are standardized, different libraries return different 
or even localized textual error messages. Never check for a specific error 
message text, but always use an error number to check.
Unless you lower your warning level in your php.ini sufficiently or prefix 
your LDAP commands with @ (at) characters to suppress warning output, the 
errors generated will also show up in your HTML output.
See also ldap_err2str() and ldap_errno().  ldap_errnoUpldap_explode_dn
#

#T=string ldap_error ( resource link_identifier)
ldap_error ( ^!resource link_identifier);
#

#T=ldap_explode_dn - array ldap_explode_dn ( string dn, int with_attrib)
(PHP 3, PHP 4 )
ldap_explode_dn -- Splits DN into its component parts
Description
array ldap_explode_dn ( string dn, int with_attrib)
ldap_explode_dn() function is used to split the DN returned by 
ldap_get_dn() and breaks it up into its component parts. Each part is 
known as Relative Distinguished Name, or RDN. ldap_explode_dn() returns an 
array of all those components. with_attrib is used to request if the RDNs 
are returned with only values or their attributes as well. To get RDNs 
with the attributes (i.e. in attribute=value format) set with_attrib to 0 
and to get only values set it to 1.  ldap_errorUpldap_first_attribute
#

#T=array ldap_explode_dn ( string dn, int with_attrib)
ldap_explode_dn ( ^!string dn, int with_attrib);
#

#T=ldap_first_attribute - string ldap_first_attribute ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_first_attribute -- Return first attribute
Description
string ldap_first_attribute ( resource link_identifier, resource 
result_entry_identifier, int ber_identifier)
Returns the first attribute in the entry on success and FALSE on error. 
Similar to reading entries, attributes are also read one by one from a 
particular entry. ldap_first_attribute() returns the first attribute in 
the entry pointed by the result_entry_identifier. Remaining attributes are 
retrieved by calling ldap_next_attribute() successively. ber_identifier is 
the identifier to internal memory location pointer. It is passed by 
reference. The same ber_identifier is passed to the ldap_next_attribute() 
function, which modifies that pointer. 
See also ldap_get_attributes()  ldap_explode_dnUpldap_first_entry
#

#T=string ldap_first_attribute ( resource link_identifier, resource 
ldap_first_attribute ( ^!resource link_identifier, resource ;
#

#T=ldap_first_entry - resource ldap_first_entry ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_first_entry -- Return first result id
Description
resource ldap_first_entry ( resource link_identifier, resource 
result_identifier)
Returns the result entry identifier for the first entry on success and 
FALSE on error.
Entries in the LDAP result are read sequentially using the 
ldap_first_entry() and ldap_next_entry() functions. ldap_first_entry() 
returns the entry identifier for first entry in the result. This entry 
identifier is then supplied to ldap_next_entry() routine to get successive 
entries from the result.
See also ldap_get_entries().  ldap_first_attributeUpldap_first_reference
#

#T=resource ldap_first_entry ( resource link_identifier, resource 
ldap_first_entry ( ^!resource link_identifier, resource ;
#

#T=ldap_first_reference - resource ldap_first_reference ( resource link, resource result)
(PHP 4 >= 4.0.5)
ldap_first_reference --  Return first reference 
Description
resource ldap_first_reference ( resource link, resource result)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_first_entryUpldap_free_result
#

#T=resource ldap_first_reference ( resource link, resource result)
ldap_first_reference ( ^!resource link, resource result);
#

#T=ldap_free_result - bool ldap_free_result ( resource result_identifier)
(PHP 3, PHP 4 )
ldap_free_result -- Free result memory
Description
bool ldap_free_result ( resource result_identifier)
Returns TRUE on success or FALSE on failure.
ldap_free_result() frees up the memory allocated internally to store the 
result and pointed by the result_identifier. All result memory will be 
automatically freed when the script terminates.
Typically all the memory allocated for the ldap result gets freed at the 
end of the script. In case the script is making successive searches which 
return large result sets, ldap_free_result() could be called to keep the 
runtime memory usage by the script low.  ldap_first_referenceUpldap_get_attributes
#

#T=bool ldap_free_result ( resource result_identifier)
ldap_free_result ( ^!resource result_identifier);
#

#T=ldap_get_attributes - array ldap_get_attributes ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_get_attributes -- Get attributes from a search result entry
Description
array ldap_get_attributes ( resource link_identifier, resource 
result_entry_identifier)
Returns a complete entry information in a multi-dimensional array on 
success and FALSE on error.
ldap_get_attributes() function is used to simplify reading the attributes 
and values from an entry in the search result. The return value is a 
multi-dimensional array of attributes and values.
Having located a specific entry in the directory, you can find out what 
information is held for that entry by using this call. You would use this 
call for an application which "browses" directory entries and/or where you 
do not know the structure of the directory entries. In many applications 
you will be searching for a specific attribute such as an email address or 
a surname, and won't care what other data is held.

return_value["count"] = number of attributes in the entry
return_value[0] = first attribute
return_value[n] = nth attribute

return_value["attribute"]["count"] = number of values for attribute
return_value["attribute"][0] = first value of the attribute
return_value["attribute"][i] = (i+1)th value of the attribute

Example 1. Show the list of attributes held for a particular 
directory entry 
  <?php
  // $ds is the link identifier for the directory

  // $sr is a valid search result from a prior call to
  // one of the ldap directory search calls

  $entry = ldap_first_entry($ds, $sr);

  $attrs = ldap_get_attributes($ds, $entry);

  echo $attrs["count"] . " attributes held for this entry:<p>";

  for ($i=0; $i<$attrs["count"]; $i++)
      echo $attrs[$i] . "<br />";
  ?> 
See also ldap_first_attribute() and ldap_next_attribute().   ldap_free_resultUpldap_get_dn
#

#T=array ldap_get_attributes ( resource link_identifier, resource 
ldap_get_attributes ( ^!resource link_identifier, resource ;
#

#T=ldap_get_dn - string ldap_get_dn ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_get_dn -- Get the DN of a result entry
Description
string ldap_get_dn ( resource link_identifier, resource 
result_entry_identifier)
Returns the DN of the result entry and FALSE on error.
ldap_get_dn() function is used to find out the DN of an entry in the 
result.  ldap_get_attributesUpldap_get_entries
#

#T=string ldap_get_dn ( resource link_identifier, resource 
ldap_get_dn ( ^!resource link_identifier, resource ;
#

#T=ldap_get_entries - array ldap_get_entries ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_get_entries -- Get all result entries
Description
array ldap_get_entries ( resource link_identifier, resource 
result_identifier)
Returns a complete result information in a multi-dimensional array on 
success and FALSE on error.
ldap_get_entries() function is used to simplify reading multiple entries 
from the result, specified with result_identifier, and then reading the 
attributes and multiple values. The entire information is returned by one 
function call in a multi-dimensional array. The structure of the array is 
as follows.
The attribute index is converted to lowercase. (Attributes are 
case-insensitive for directory servers, but not when used as array 
indices.) 

return_value["count"] = number of entries in the result
return_value[0] : refers to the details of first entry

return_value[i]["dn"] =  DN of the ith entry in the result

return_value[i]["count"] = number of attributes in ith entry
return_value[i][j] = jth attribute in the ith entry in the result

return_value[i]["attribute"]["count"] = number of values for 
			      attribute in ith entry
return_value[i]["attribute"][j] = jth value of attribute in ith entry

See also ldap_first_entry() and ldap_next_entry()  ldap_get_dnUpldap_get_option
#

#T=array ldap_get_entries ( resource link_identifier, resource 
ldap_get_entries ( ^!resource link_identifier, resource ;
#

#T=ldap_get_option - bool ldap_get_option ( resource link_identifier, int option, mixed retval)
(PHP 4 >= 4.0.4)
ldap_get_option -- Get the current value for given option
Description
bool ldap_get_option ( resource link_identifier, int option, mixed retval)
Sets retval to the value of the specified option. Returns TRUE on success 
or FALSE on failure. 
The parameter option can be one of: LDAP_OPT_DEREF, LDAP_OPT_SIZELIMIT, 
LDAP_OPT_TIMELIMIT, LDAP_OPT_PROTOCOL_VERSION, LDAP_OPT_ERROR_NUMBER, 
LDAP_OPT_REFERRALS, LDAP_OPT_RESTART, LDAP_OPT_HOST_NAME, 
LDAP_OPT_ERROR_STRING, LDAP_OPT_MATCHED_DN. These are described in 
draft-ietf-ldapext-ldap-c-api-xx.txt 
Note: This function is only available when using OpenLDAP 2.x.x OR 
Netscape Directory SDK x.x, and was added in PHP 4.0.4 
Example 1. Check protocol version
  <?php
  // $ds is a valid link identifier for a directory server
  if (ldap_get_option($ds, LDAP_OPT_PROTOCOL_VERSION, $version)) 
  {
      echo "Using protocol version $version\n";
  } else {
      echo "Unable to determine protocol version\n";
  }
  ?> 
See also ldap_set_option().   ldap_get_entriesUpldap_get_values_len
#

#T=bool ldap_get_option ( resource link_identifier, int option, mixed retval)
ldap_get_option ( ^!resource link_identifier, int option, mixed retval);
#

#T=ldap_get_values_len - array ldap_get_values_len ( resource link_identifier, resource 
(PHP 3>= 3.0.13, PHP 4 )
ldap_get_values_len -- Get all binary values from a result entry
Description
array ldap_get_values_len ( resource link_identifier, resource 
result_entry_identifier, string attribute)
Returns an array of values for the attribute on success and FALSE on 
error.
ldap_get_values_len() function is used to read all the values of the 
attribute in the entry in the result. entry is specified by the 
result_entry_identifier. The number of values can be found by indexing 
"count" in the resultant array. Individual values are accessed by integer 
index in the array. The first index is 0.
This function is used exactly like ldap_get_values() except that it 
handles binary data and not string data.
Note: This function was added in 4.0.   ldap_get_optionUpldap_get_values
#

#T=array ldap_get_values_len ( resource link_identifier, resource 
ldap_get_values_len ( ^!resource link_identifier, resource ;
#

#T=ldap_get_values - array ldap_get_values ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_get_values -- Get all values from a result entry
Description
array ldap_get_values ( resource link_identifier, resource 
result_entry_identifier, string attribute)
Returns an array of values for the attribute on success and FALSE on 
error.
ldap_get_values() function is used to read all the values of the attribute 
in the entry in the result. entry is specified by the 
result_entry_identifier. The number of values can be found by indexing 
"count" in the resultant array. Individual values are accessed by integer 
index in the array. The first index is 0.
This call needs a result_entry_identifier, so needs to be preceded by one 
of the ldap search calls and one of the calls to get an individual entry.
You application will either be hard coded to look for certain attributes 
(such as "surname" or "mail") or you will have to use the 
ldap_get_attributes() call to work out what attributes exist for a given 
entry.
LDAP allows more than one entry for an attribute, so it can, for example, 
store a number of email addresses for one person's directory entry all 
labeled with the attribute "mail" 

return_value["count"] = number of values for attribute
return_value[0] = first value of attribute
return_value[i] = ith value of attribute

Example 1. List all values of the "mail" attribute for a directory 
entry 
  <?php
  // $ds is a valid link identifier for a directory server

  // $sr is a valid search result from a prior call to
  //     one of the ldap directory search calls

  // $entry is a valid entry identifier from a prior call to
  //        one of the calls that returns a directory entry

  $values = ldap_get_values($ds, $entry, "mail");

  echo $values["count"] . " email addresses for this entry.<p>";

  for ($i=0; $i < $values["count"]; $i++)
      echo $values[$i] . "<br />";
  ?> 

  ldap_get_values_lenUpldap_list
#

#T=array ldap_get_values ( resource link_identifier, resource 
ldap_get_values ( ^!resource link_identifier, resource ;
#

#T=ldap_list - resource ldap_list ( resource link_identifier, string base_dn, string 
(PHP 3, PHP 4 )
ldap_list -- Single-level search
Description
resource ldap_list ( resource link_identifier, string base_dn, string 
filter [, array attributes [, int attrsonly [, int sizelimit [, int 
timelimit [, int deref]]]]])
Returns a search result identifier or FALSE on error.
ldap_list() performs the search for a specified filter on the directory 
with the scope LDAP_SCOPE_ONELEVEL.
LDAP_SCOPE_ONELEVEL means that the search should only return information 
that is at the level immediately below the base_dn given in the call. 
(Equivalent to typing "ls" and getting a list of files and folders in the 
current working directory.)
This call takes 5 optional parameters. See ldap_search() notes. 
Note: These optional parameters were added in 4.0.2: attrsonly, 
sizelimit, timelimit, deref. 
Example 1. Produce a list of all organizational units of an 
organization 
// $ds is a valid link identifier for a directory server

$basedn = "o=My Company, c=US";
$justthese = array("ou");

$sr=ldap_list($ds, $basedn, "ou=*", $justthese);

$info = ldap_get_entries($ds, $sr);

for ($i=0; $i<$info["count"]; $i++)
echo $info[$i]["ou"][0] ;
Note: From 4.0.5 on it's also possible to do parallel searches. See 
ldap_search() for details.   ldap_get_valuesUpldap_mod_add
#

#T=resource ldap_list ( resource link_identifier, string base_dn, string 
ldap_list ( ^!resource link_identifier, string base_dn, string ;
#

#T=ldap_mod_add - bool ldap_mod_add ( resource link_identifier, string dn, array entry)
(PHP 3>= 3.0.8, PHP 4 )
ldap_mod_add -- Add attribute values to current attributes
Description
bool ldap_mod_add ( resource link_identifier, string dn, array entry)
Returns TRUE on success or FALSE on failure.
This function adds attribute(s) to the specified dn. It performs the 
modification at the attribute level as opposed to the object level. 
Object-level additions are done by the ldap_add() function.   ldap_listUpldap_mod_del
#

#T=bool ldap_mod_add ( resource link_identifier, string dn, array entry)
ldap_mod_add ( ^!resource link_identifier, string dn, array entry);
#

#T=ldap_mod_del - bool ldap_mod_del ( resource link_identifier, string dn, array entry)
(PHP 3>= 3.0.8, PHP 4 )
ldap_mod_del -- Delete attribute values from current attributes
Description
bool ldap_mod_del ( resource link_identifier, string dn, array entry)
Returns TRUE on success or FALSE on failure.
This function removes attribute(s) from the specified dn. It performs the 
modification at the attribute level as opposed to the object level. 
Object-level deletions are done by the ldap_delete() function.   ldap_mod_addUpldap_mod_replace
#

#T=bool ldap_mod_del ( resource link_identifier, string dn, array entry)
ldap_mod_del ( ^!resource link_identifier, string dn, array entry);
#

#T=ldap_mod_replace - bool ldap_mod_replace ( resource link_identifier, string dn, array entry)
(PHP 3>= 3.0.8, PHP 4 )
ldap_mod_replace -- Replace attribute values with new ones
Description
bool ldap_mod_replace ( resource link_identifier, string dn, array entry)
Returns TRUE on success or FALSE on failure.
This function replaces attribute(s) from the specified dn. It performs the 
modification at the attribute level as opposed to the object level. 
Object-level modifications are done by the ldap_modify() function.   ldap_mod_delUpldap_modify
#

#T=bool ldap_mod_replace ( resource link_identifier, string dn, array entry)
ldap_mod_replace ( ^!resource link_identifier, string dn, array entry);
#

#T=ldap_modify - bool ldap_modify ( resource link_identifier, string dn, array entry)
(PHP 3, PHP 4 )
ldap_modify -- Modify an LDAP entry
Description
bool ldap_modify ( resource link_identifier, string dn, array entry)
Returns TRUE on success or FALSE on failure.
ldap_modify() function is used to modify the existing entries in the LDAP 
directory. The structure of the entry is same as in ldap_add().  ldap_mod_replaceUpldap_next_attribute
#

#T=bool ldap_modify ( resource link_identifier, string dn, array entry)
ldap_modify ( ^!resource link_identifier, string dn, array entry);
#

#T=ldap_next_attribute - string ldap_next_attribute ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_next_attribute -- Get the next attribute in result
Description
string ldap_next_attribute ( resource link_identifier, resource 
result_entry_identifier, resource ber_identifier)
Returns the next attribute in an entry on success and FALSE on error.
ldap_next_attribute() is called to retrieve the attributes in an entry. 
The internal state of the pointer is maintained by the ber_identifier. It 
is passed by reference to the function. The first call to 
ldap_next_attribute() is made with the result_entry_identifier returned 
from ldap_first_attribute().
See also ldap_get_attributes()  ldap_modifyUpldap_next_entry
#

#T=string ldap_next_attribute ( resource link_identifier, resource 
ldap_next_attribute ( ^!resource link_identifier, resource ;
#

#T=ldap_next_entry - resource ldap_next_entry ( resource link_identifier, resource 
(PHP 3, PHP 4 )
ldap_next_entry -- Get next result entry
Description
resource ldap_next_entry ( resource link_identifier, resource 
result_entry_identifier)
Returns entry identifier for the next entry in the result whose entries 
are being read starting with ldap_first_entry(). If there are no more 
entries in the result then it returns FALSE.
ldap_next_entry() function is used to retrieve the entries stored in the 
result. Successive calls to the ldap_next_entry() return entries one by 
one till there are no more entries. The first call to ldap_next_entry() is 
made after the call to ldap_first_entry() with the result_entry_identifier 
as returned from the ldap_first_entry(). 
See also ldap_get_entries()  ldap_next_attributeUpldap_next_reference
#

#T=resource ldap_next_entry ( resource link_identifier, resource 
ldap_next_entry ( ^!resource link_identifier, resource ;
#

#T=ldap_next_reference - resource ldap_next_reference ( resource link, resource entry)
(PHP 4 >= 4.0.5)
ldap_next_reference --  Get next reference 
Description
resource ldap_next_reference ( resource link, resource entry)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_next_entryUpldap_parse_reference
#

#T=resource ldap_next_reference ( resource link, resource entry)
ldap_next_reference ( ^!resource link, resource entry);
#

#T=ldap_parse_reference - bool ldap_parse_reference ( resource link, resource entry, array 
(PHP 4 >= 4.0.5)
ldap_parse_reference --  Extract information from reference entry 
Description
bool ldap_parse_reference ( resource link, resource entry, array 
referrals)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_next_referenceUpldap_parse_result
#

#T=bool ldap_parse_reference ( resource link, resource entry, array 
ldap_parse_reference ( ^!resource link, resource entry, array ;
#

#T=ldap_parse_result - bool ldap_parse_result ( resource link, resource result, int errcode, 
(PHP 4 >= 4.0.5)
ldap_parse_result --  Extract information from result 
Description
bool ldap_parse_result ( resource link, resource result, int errcode, 
string matcheddn, string errmsg, array referrals)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_parse_referenceUpldap_read
#

#T=bool ldap_parse_result ( resource link, resource result, int errcode, 
ldap_parse_result ( ^!resource link, resource result, int errcode, ;
#

#T=ldap_read - resource ldap_read ( resource link_identifier, string base_dn, string 
(PHP 3, PHP 4 )
ldap_read -- Read an entry
Description
resource ldap_read ( resource link_identifier, string base_dn, string 
filter [, array attributes [, int attrsonly [, int sizelimit [, int 
timelimit [, int deref]]]]])
Returns a search result identifier or FALSE on error.
ldap_read() performs the search for a specified filter on the directory 
with the scope LDAP_SCOPE_BASE. So it is equivalent to reading an entry 
from the directory.
An empty filter is not allowed. If you want to retrieve absolutely all 
information for this entry, use a filter of "objectClass=*". If you know 
which entry types are used on the directory server, you might use an 
appropriate filter such as "objectClass=inetOrgPerson".
This call takes 5 optional parameters. See ldap_search() notes. 
Note: These optional parameters were added in 4.0.2: attrsonly, 
sizelimit, timelimit, deref. 
From 4.0.5 on it's also possible to do parallel searches. See 
ldap_search() for details.   ldap_parse_resultUpldap_rename
#

#T=resource ldap_read ( resource link_identifier, string base_dn, string 
ldap_read ( ^!resource link_identifier, string base_dn, string ;
#

#T=ldap_rename - bool ldap_rename ( resource link_identifier, string dn, string newrdn, 
(PHP 4 >= 4.0.5)
ldap_rename -- Modify the name of an entry
Description
bool ldap_rename ( resource link_identifier, string dn, string newrdn, 
string newparent, bool deleteoldrdn)
The entry specified by dn is renamed/moved. The new RDN is specified by 
newrdn and the new parent/superior entry is specified by newparent. If the 
parameter deleteoldrdn is TRUE the old RDN value(s) is removed, else the 
old RDN value(s) is retained as non-distinguished values of the entry. 
Returns TRUE on success or FALSE on failure. 
Note: This function currently only works with LDAPv3. You may have to 
use ldap_set_option() prior to binding to use LDAPv3. This function is 
only available when using OpenLDAP 2.x.x OR Netscape Directory SDK x.x, 
and was added in PHP 4.0.5.   ldap_readUpldap_search
#

#T=bool ldap_rename ( resource link_identifier, string dn, string newrdn, 
ldap_rename ( ^!resource link_identifier, string dn, string newrdn, ;
#

#T=ldap_search - resource ldap_search ( resource link_identifier, string base_dn, string 
(PHP 3, PHP 4 )
ldap_search -- Search LDAP tree
Description
resource ldap_search ( resource link_identifier, string base_dn, string 
filter [, array attributes [, int attrsonly [, int sizelimit [, int 
timelimit [, int deref]]]]])
Returns a search result identifier or FALSE on error.
ldap_search() performs the search for a specified filter on the directory 
with the scope of LDAP_SCOPE_SUBTREE. This is equivalent to searching the 
entire directory. base_dn specifies the base DN for the directory.
There is an optional fourth parameter, that can be added to restrict the 
attributes and values returned by the server to just those required. This 
is much more efficient than the default action (which is to return all 
attributes and their associated values). The use of the fourth parameter 
should therefore be considered good practice.
The fourth parameter is a standard PHP string array of the required 
attributes, e.g. array("mail", "sn", "cn") Note that the "dn" is always 
returned irrespective of which attributes types are requested.
Note too that some directory server hosts will be configured to return no 
more than a preset number of entries. If this occurs, the server will 
indicate that it has only returned a partial results set. This occurs also 
if the sixth parameter sizelimit has been used to limit the count of 
fetched entries. 
The fifth parameter attrsonly should be set to 1 if only attribute types 
are wanted. If set to 0 both attributes types and attribute values are 
fetched which is the default behaviour. 
With the sixth parameter sizelimit it is possible to limit the count of 
entries fetched. Setting this to 0 means no limit. NOTE: This parameter 
can NOT override server-side preset sizelimit. You can set it lower 
though. 
The seventh parameter timelimit sets the number of seconds how long is 
spend on the search. Setting this to 0 means no limit. NOTE: This 
parameter can NOT override server-side preset timelimit. You can set it 
lower though. 
The eighth parameter deref specifies how aliases should be handled during 
the search. It can be one of the following: 
LDAP_DEREF_NEVER - (default) aliases are never dereferenced. 
LDAP_DEREF_SEARCHING - aliases should be dereferenced during the search 
but not when locating the base object of the search. 
LDAP_DEREF_FINDING - aliases should be dereferenced when locating the 
base object but not during the search. 
LDAP_DEREF_ALWAYS - aliases should be dereferenced always. 
Note: These optional parameters were added in 4.0.2: attrsonly, 
sizelimit, timelimit, deref. 
The search filter can be simple or advanced, using boolean operators in 
the format described in the LDAP documentation (see the Netscape Directory 
SDK for full information on filters).
The example below retrieves the organizational unit, surname, given name 
and email address for all people in "My Company" where the surname or 
given name contains the substring $person. This example uses a boolean 
filter to tell the server to look for information in more than one 
attribute. Example 1. LDAP search
  <?php
  // $ds is a valid link identifier for a directory server

  // $person is all or part of a person's name, eg "Jo"

  $dn = "o=My Company, c=US";
  $filter="(|(sn=$person*)(givenname=$person*))";
  $justthese = array("ou", "sn", "givenname", "mail");

  $sr=ldap_search($ds, $dn, $filter, $justthese);

  $info = ldap_get_entries($ds, $sr);

  echo $info["count"]." entries returned\n";
  ?> 
From 4.0.5 on it's also possible to do parallel searches. To do this you 
use an array of link identifiers, rather than a single identifier, as the 
first argument. If you don't want the same base DN and the same filter for 
all the searches, you can also use an array of base DNs and/or an array of 
filters. Those arrays must be of the same size as the link identifier 
array since the first entries of the arrays are used for one search, the 
second entries are used for another, and so on. When doing parallel 
searches an array of search result identifiers is returned, except in case 
of error, then the entry corresponding to the search will be FALSE. This 
is very much like the value normally returned, except that a result 
identifier is always returned when a search was made. There are some rare 
cases where the normal search returns FALSE while the parallel search 
returns an identifier.   ldap_renameUpldap_set_option
#

#T=resource ldap_search ( resource link_identifier, string base_dn, string 
ldap_search ( ^!resource link_identifier, string base_dn, string ;
#

#T=ldap_set_option - bool ldap_set_option ( resource link_identifier, int option, mixed newval)
(PHP 4 >= 4.0.4)
ldap_set_option -- Set the value of the given option
Description
bool ldap_set_option ( resource link_identifier, int option, mixed newval)
Sets the value of the specified option to be newval. Returns TRUE on 
success or FALSE on failure. on error.
The parameter option can be one of: LDAP_OPT_DEREF, LDAP_OPT_SIZELIMIT, 
LDAP_OPT_TIMELIMIT, LDAP_OPT_PROTOCOL_VERSION, LDAP_OPT_ERROR_NUMBER, 
LDAP_OPT_REFERRALS, LDAP_OPT_RESTART, LDAP_OPT_HOST_NAME, 
LDAP_OPT_ERROR_STRING, LDAP_OPT_MATCHED_DN, LDAP_OPT_SERVER_CONTROLS, 
LDAP_OPT_CLIENT_CONTROLS. Here's a brief description, see 
draft-ietf-ldapext-ldap-c-api-xx.txt for details.
The options LDAP_OPT_DEREF, LDAP_OPT_SIZELIMIT, LDAP_OPT_TIMELIMIT, 
LDAP_OPT_PROTOCOL_VERSION and LDAP_OPT_ERROR_NUMBER have integer value, 
LDAP_OPT_REFERRALS and LDAP_OPT_RESTART have boolean value, and the 
options LDAP_OPT_HOST_NAME, LDAP_OPT_ERROR_STRING and LDAP_OPT_MATCHED_DN 
have string value. The first example illustrates their use. The options 
LDAP_OPT_SERVER_CONTROLS and LDAP_OPT_CLIENT_CONTROLS require a list of 
controls, this means that the value must be an array of controls. A 
control consists of an oid identifying the control, an optional value, and 
an optional flag for criticality. In PHP a control is given by an array 
containing an element with the key oid and string value, and two optional 
elements. The optional elements are key value with string value and key 
iscritical with boolean value. iscritical defaults to FALSE if not 
supplied. See also the second example below. 
Note: This function is only available when using OpenLDAP 2.x.x OR 
Netscape Directory SDK x.x, and was added in PHP 4.0.4. 
Example 1. Set protocol version
  <?php
  // $ds is a valid link identifier for a directory server
  if (ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3)) {
      echo "Using LDAPv3";
  } else {
      echo "Failed to set protocol version to 3";
  }
  ?> 

Example 2. Set server controls
  <?php
  // $ds is a valid link identifier for a directory server
  // control with no value
  $ctrl1 = array("oid" => "1.2.752.58.10.1", "iscritical" => 
  true);
  // iscritical defaults to FALSE
  $ctrl2 = array("oid" => "1.2.752.58.1.10", "value" => 
"magic");
  // try to set both controls
  if (!ldap_set_option($ds, LDAP_OPT_SERVER_CONTROLS, 
  array($ctrl1, $ctrl2)))
      echo "Failed to set server controls";
  ?> 
See also ldap_get_option().   ldap_searchUpldap_set_rebind_proc
#

#T=bool ldap_set_option ( resource link_identifier, int option, mixed newval)
ldap_set_option ( ^!resource link_identifier, int option, mixed newval);
#

#T=ldap_set_rebind_proc - bool ldap_set_rebind_proc ( resource link, string callback)
(PHP 4 >= 4.2.0)
ldap_set_rebind_proc --  Set a callback function to do re-binds on 
referral chasing. 
Description
bool ldap_set_rebind_proc ( resource link, string callback)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_set_optionUpldap_sort
#

#T=bool ldap_set_rebind_proc ( resource link, string callback)
ldap_set_rebind_proc ( ^!resource link, string callback);
#

#T=ldap_sort - bool ldap_sort ( resource link, resource result, string sortfilter)
(PHP 4 >= 4.2.0)
ldap_sort --  Sort LDAP result entries 
Description
bool ldap_sort ( resource link, resource result, string sortfilter)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_set_rebind_procUpldap_start_tls
#

#T=bool ldap_sort ( resource link, resource result, string sortfilter)
ldap_sort ( ^!resource link, resource result, string sortfilter);
#

#T=ldap_start_tls - bool ldap_start_tls ( resource link)
(PHP 4 >= 4.2.0)
ldap_start_tls --  Start TLS 
Description
bool ldap_start_tls ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_sortUpldap_t61_to_8859
#

#T=bool ldap_start_tls ( resource link)
ldap_start_tls ( ^!resource link);
#

#T=ldap_t61_to_8859 - string ldap_t61_to_8859 ( string value)
(PHP 4 >= 4.0.2)
ldap_t61_to_8859 --  Translate t61 characters to 8859 characters 
Description
string ldap_t61_to_8859 ( string value)
Warning
This function is currently not documented; only the argument list is 
available.
  ldap_start_tlsUpldap_unbind
#

#T=string ldap_t61_to_8859 ( string value)
ldap_t61_to_8859 ( ^!string value);
#

#T=ldap_unbind - bool ldap_unbind ( resource link_identifier)
(PHP 3, PHP 4 )
ldap_unbind -- Unbind from LDAP directory
Description
bool ldap_unbind ( resource link_identifier)
Returns TRUE on success or FALSE on failure.
ldap_unbind() function unbinds from the LDAP directory.  ldap_t61_to_8859UpMail functions
#

#T=bool ldap_unbind ( resource link_identifier)
ldap_unbind ( ^!resource link_identifier);
#

#T=levenshtein - int levenshtein ( string str1, string str2)
(PHP 3>= 3.0.17, PHP 4 >= 4.0.1)
levenshtein --  Calculate Levenshtein distance between two strings 
Description
int levenshtein ( string str1, string str2)

int levenshtein ( string str1, string str2, int cost_ins, int cost_rep, 
int cost_del)

int levenshtein ( string str1, string str2, function cost)
This function returns the Levenshtein-Distance between the two argument 
strings or -1, if one of the argument strings is longer than the limit of 
255 characters (255 should be more than enough for name or dictionary 
comparison, and nobody serious would be doing genetic analysis with PHP). 
The Levenshtein distance is defined as the minimal number of characters 
you have to replace, insert or delete to transform str1 into str2. The 
complexity of the algorithm is O(m*n), where n and m are the length of 
str1 and str2 (rather good when compared to similar_text(), which is 
O(max(n,m)**3), but still expensive). 
In its simplest form the function will take only the two strings as 
parameter and will calculate just the number of insert, replace and delete 
operations needed to transform str1 into str2. 
A second variant will take three additional parameters that define the 
cost of insert, replace and delete operations. This is more general and 
adaptive than variant one, but not as efficient. 
The third variant (which is not implemented yet) will be the most general 
and adaptive, but also the slowest alternative. It will call a 
user-supplied function that will determine the cost for every possible 
operation. 
The user-supplied function will be called with the following arguments: 
operation to apply: 'I', 'R' or 'D' 
actual character in string 1 
actual character in string 2 
position in string 1 
position in string 2 
remaining characters in string 1 
remaining characters in string 2 
The user-supplied function has to return a positive integer describing the 
cost for this particular operation, but it may decide to use only some of 
the supplied arguments. 
The user-supplied function approach offers the possibility to take into 
account the relevance of and/or difference between certain symbols 
(characters) or even the context those symbols appear in to determine the 
cost of insert, replace and delete operations, but at the cost of losing 
all optimizations done regarding cpu register utilization and cache misses 
that have been worked into the other two variants. 
See also soundex(), similar_text(), and metaphone().   joinUplocaleconv
#

#T=int levenshtein ( string str1, string str2)
levenshtein ( ^!string str1, string str2);
#

#T=link - bool link ( string target, string link)
(PHP 3, PHP 4 )
link -- Create a hard link
Description
bool link ( string target, string link)
link() creates a hard link. Returns TRUE on success or FALSE on failure. 
Note: This function will not work on remote files as the file to be 
examined must be accessible via the servers filesystem.
See also the symlink() to create soft links, and readlink() along with 
linkinfo().   is_writeableUplinkinfo
#

#T=bool link ( string target, string link)
link ( ^!string target, string link);
#

#T=linkinfo - int linkinfo ( string path)
(PHP 3, PHP 4 )
linkinfo -- Gets information about a link
Description
int linkinfo ( string path)
linkinfo() returns the st_dev field of the Unix C stat structure returned 
by the lstat system call. This function is used to verify if a link 
(pointed to by path) really exists (using the same method as the S_ISLNK 
macro defined in stat.h). Returns 0 or FALSE in case of error. 
Example 1. linkinfo() example
  <?php

  echo linkinfo('/vmlinuz'); // 835

  ?> 
See also symlink(), link(), and readlink().   linkUplstat
#

#T=int linkinfo ( string path)
linkinfo ( ^!string path);
#

#T=list - void list ( mixed ...)
(PHP 3, PHP 4 )
list --  Assign variables as if they were an array 
Description
void list ( mixed ...)
Like array(), this is not really a function, but a language construct. 
list() is used to assign a list of variables in one operation. 
Note: list() only works on numerical arrays and assumes the numerical 
indices start at 0. 
Example 1. list() examples
  <?php

  $info = array('coffee', 'brown', 'caffeine');

  // Listing all the variables
  list($drink, $color, $power) = $info;
  echo "$drink is $color and $power makes it special.\n";

  // Listing some of them
  list($drink, , $power) = $info;
  echo "$drink has $power.\n";

  // Or let's skip to only the third one
  list( , , $power) = $info;
  echo "I need $power!\n";

  ?> 
Example 2. An example use of list()
  <table>
  <tr>
    <th>Employee name</th>
    <th>Salary</th>
  </tr>

  <?php

  $result = mysql_query("SELECT id, name, salary FROM 
  employees", $conn);
  while (list($id, $name, $salary) = mysql_fetch_row($result)) {
      echo " <tr>\n" .
	    "  <td><a href=\"info.php?id=$id\">$name</a></td>\n" 
  .
	    "  <td>$salary</td>\n" .
	    " </tr>\n";
  }

  ?>

  </table> 
Warning
list() assigns the values starting with the right-most parameter. If 
you are using plain variables, you don't have to worry about this. 
But if you are using arrays with indices you usually expect the 
order of the indices in the array the same you wrote in the list() 
from left to right; which it isn't. It's assigned in the reverse 
order. 

Example 3. Using list() with array indices
  <?php

  $info = array('coffee', 'brown', 'caffeine');

  list($a[0], $a[1], $a[2]) = $info;

  var_dump($a);

  ?> 

Gives the following output (note the order of the elements compared 
in which order they were written in the list() syntax): 
array(3) {
[2]=>
string(8) "caffeine"
[1]=>
string(5) "brown"
[0]=>
string(6) "coffee"
}
See also each(), array() and extract().   ksortUpnatcasesort
#

#T=void list ( mixed ...)
list ( ^!mixed ...);
#

#T=localeconv - array localeconv ( void )
(PHP 4 >= 4.0.5)
localeconv -- Get numeric formatting information
Description
array localeconv ( void )
Returns an associative array containing localized numeric and monetary 
formatting information. 
localeconv() returns data based upon the current locale as set by 
setlocale(). The associative array that is returned contains the following 
fields: 
Array elementDescription
decimal_pointDecimal point character
thousands_sepThousands separator
groupingArray containing numeric groupings
int_curr_symbolInternational currency symbol (i.e. USD)
currency_symbolLocal currency symbol (i.e. $)
mon_decimal_pointMonetary decimal point character
mon_thousands_sepMonetary thousands separator
mon_groupingArray containing monetary groupings
positive_signSign for positive values
negative_signSign for negative values
int_frac_digitsInternational fractional digits
frac_digitsLocal fractional digits
p_cs_precedesTRUE if currency_symbol precedes a positive value, 
FALSE if it succeeds one 
p_sep_by_spaceTRUE if a space separates currency_symbol from a 
positive value, FALSE otherwise 
n_cs_precedesTRUE if currency_symbol precedes a negative value, 
FALSE if it succeeds one 
n_sep_by_spaceTRUE if a space separates currency_symbol from a 
negative value, FALSE otherwise 
p_sign_posn0Parentheses surround the quantity and 
  currency_symbol
  1The sign string precedes the quantity and currency_symbol 
  2The sign string succeeds the quantity and currency_symbol 
  3The sign string immediately precedes the currency_symbol 
  4The sign string immediately succeeds the currency_symbol 

n_sign_posn0Parentheses surround the quantity and 
  currency_symbol 
  1The sign string precedes the quantity and currency_symbol 
  2The sign string succeeds the quantity and currency_symbol 
  3The sign string immediately precedes the currency_symbol 
  4The sign string immediately succeeds the currency_symbol 
The grouping fields contain arrays that define the way numbers should be 
grouped. For example, the grouping field for the en_US locale, would 
contain a 2 item array with the values 3 and 3. The higher the index in 
the array, the farther left the grouping is. If an array element is equal 
to CHAR_MAX, no further grouping is done. If an array element is equal to 
0, the previous element should be used. 
Example 1. localeconv() example
  <?php
  setlocale(LC_ALL, "en_US");

  $locale_info = localeconv();

  echo "<PRE>\n";
  echo "--------------------------------------------\n";
  echo "  Monetary information for current locale:  \n";
  echo "--------------------------------------------\n\n";

  echo "int_curr_symbol:   {$locale_info["int_curr_symbol"]}\n";
  echo "currency_symbol:   {$locale_info["currency_symbol"]}\n";
  echo "mon_decimal_point: 
  {$locale_info["mon_decimal_point"]}\n";
  echo "mon_thousands_sep: 
  {$locale_info["mon_thousands_sep"]}\n";
  echo "positive_sign:     {$locale_info["positive_sign"]}\n";
  echo "negative_sign:     {$locale_info["negative_sign"]}\n";
  echo "int_frac_digits:   {$locale_info["int_frac_digits"]}\n";
  echo "frac_digits:       {$locale_info["frac_digits"]}\n";
  echo "p_cs_precedes:     {$locale_info["p_cs_precedes"]}\n";
  echo "p_sep_by_space:    {$locale_info["p_sep_by_space"]}\n";
  echo "n_cs_precedes:     {$locale_info["n_cs_precedes"]}\n";
  echo "n_sep_by_space:    {$locale_info["n_sep_by_space"]}\n";
  echo "p_sign_posn:       {$locale_info["p_sign_posn"]}\n";
  echo "n_sign_posn:       {$locale_info["n_sign_posn"]}\n";
  echo "</PRE>\n";
  ?> 
The constant CHAR_MAX is also defined for the use mentioned above. 
See also setlocale().   levenshteinUpltrim
#

#T=array localeconv ( void )
localeconv ( ^!void );
#

#T=localtime - array localtime ( [int timestamp [, bool is_associative]])
(PHP 4 )
localtime -- Get the local time
Description
array localtime ( [int timestamp [, bool is_associative]])
The localtime() function returns an array identical to that of the 
structure returned by the C function call. The first argument to 
localtime() is the timestamp, if this is not given the current time as 
returned from time() is used. The second argument to the localtime() is 
the is_associative, if this is set to 0 or not supplied than the array is 
returned as a regular, numerically indexed array. If the argument is set 
to 1 then localtime() is an associative array containing all the different 
elements of the structure returned by the C function call to localtime. 
The names of the different keys of the associative array are as follows: 
"tm_sec" - seconds 
"tm_min" - minutes 
"tm_hour" - hour 
"tm_mday" - day of the month 
"tm_mon" - month of the year, starting with 0 for January 
"tm_year" - Years since 1900 
"tm_wday" - Day of the week 
"tm_yday" - Day of the year 
"tm_isdst" - Is daylight savings time in effect   gmstrftimeUpmicrotime
#

#T=array localtime ( [int timestamp [, bool is_associative]])
localtime ( ^![int timestamp [, bool is_associative]]);
#

#T=log - float log ( float arg [, float base])
(PHP 3, PHP 4 )
log -- Natural logarithm
Description
float log ( float arg [, float base])
If the optional base parameter is specified, log() returns logbase arg, 
otherwise log() returns the natural logarithm of arg. 
Note: The base parameter became available with PHP version 4.3.0. 
As always you can calculate the logarithm in base b of a number n, but 
using the mathematical identity: logb(n) = log(n)/log(b), where log is 
the neperian (or natural) logarithm. 
See also exp().   log1pUpmax
#

#T=float log ( float arg [, float base])
log ( ^!float arg [, float base]);
#

#T=log10 - float log10 ( float arg)
(PHP 3, PHP 4 )
log10 -- Base-10 logarithm
Description
float log10 ( float arg)
Returns the base-10 logarithm of arg. 
See Also: log()   lcg_valueUplog1p
#

#T=float log10 ( float arg)
log10 ( ^!float arg);
#

#T=log1p - float log1p ( float number)
(PHP 4 >= 4.1.0)
log1p --  Returns log(1 + number), computed in a way that accurate even 
when the value of number is close to zero 
Description
float log1p ( float number)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

Note: This function is not implemented on Windows platforms.  log10Uplog
#

#T=float log1p ( float number)
log1p ( ^!float number);
#

#T=long2ip - string long2ip ( int proper_address)
(PHP 4 )
long2ip --  Converts an (IPv4) Internet network address into a string in 
Internet standard dotted format 
Description
string long2ip ( int proper_address)
The function long2ip() generates an Internet address in dotted format 
(i.e.: aaa.bbb.ccc.ddd) from the proper address representation. 
See also: ip2long()   ip2longUpopenlog
#

#T=string long2ip ( int proper_address)
long2ip ( ^!int proper_address);
#

#T=lstat - array lstat ( string filename)
(PHP 3>= 3.0.4, PHP 4 )
lstat -- Gives information about a file or symbolic link
Description
array lstat ( string filename)
Gathers the statistics of the file or symbolic link named by filename. 
This function is identical to the stat() function except that if the 
filename parameter is a symbolic link, the status of the symbolic link is 
returned, not the status of the file pointed to by the symbolic link. 
See the manual page for stat() for information on the structure of the 
array that lstat() returns. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also stat().   linkinfoUpmkdir
#

#T=array lstat ( string filename)
lstat ( ^!string filename);
#

#T=ltrim - string ltrim ( string str [, string charlist])
(PHP 3, PHP 4 )
ltrim --  Strip whitespace from the beginning of a string 
Description
string ltrim ( string str [, string charlist])
Note: The second parameter was added in PHP 4.1.0 
This function returns a string with whitespace stripped from the beginning 
of str. Without the second parameter, ltrim() will strip these characters: 

" " (ASCII 32 (0x20)), an ordinary space. 
"\t" (ASCII 9 (0x09)), a tab. 
"\n" (ASCII 10 (0x0A)), a new line (line feed). 
"\r" (ASCII 13 (0x0D)), a carriage return. 
"\0" (ASCII 0 (0x00)), the NUL-byte. 
"\x0B" (ASCII 11 (0x0B)), a vertical tab. 
You can also specify the characters you want to strip, by means of the 
charlist parameter. Simply list all characters that you want to be 
stripped. With .. you can specify a range of characters. 
Example 1. Usage example of ltrim()
  <?php

  $text = "\t\tThese are a few words :) ...  ";
  $trimmed = ltrim($text);
  // $trimmed = "These are a few words :) ...  "
  $trimmed = ltrim($text, " \t.");
  // $trimmed = "These are a few words :) ...  "
  $clean = ltrim($binary, "\0x00..\0x1F");
  // trim the ASCII control characters at the beginning of 
  $binary 
  // (from 0 to 31 inclusive)

  ?> 
See also trim() and rtrim().   localeconvUpmd5_file
#

#T=string ltrim ( string str [, string charlist])
ltrim ( ^!string str [, string charlist]);
#

#T=mail - bool mail ( string to, string subject, string message [, string 
(PHP 3, PHP 4 )
mail -- send mail
Description
bool mail ( string to, string subject, string message [, string 
additional_headers [, string additional_parameters]])
mail() automatically mails the message specified in message to the 
receiver specified in to. Multiple recipients can be specified by putting 
a comma between each address in to. Email with attachments and special 
types of content can be sent using this function. This is accomplished via 
MIME-encoding - for more information, see this Zend article or the PEAR 
Mime Classes. 
The following RFC's may also be useful: RFC 1896, RFC 2045, RFC 2046, RFC 
2047, RFC 2048, and RFC 2049. 
mail() returns TRUE if the mail was successfully accepted for delivery, 
FALSE otherwise. 
Warning
The Windows implementation of mail() differs in many ways from the 
Unix implementation. First, it doesn't use a local binary for 
composing messages but only operates on direct sockets which means a 
MTA is needed listening on a network socket (which can either on the 
localhost or a remote machine). Second, the custom headers like 
From:, Cc:, Bcc: and Date: are not interpreted by the MTA in the 
first place, but are parsed by PHP. PHP < 4.3 only supported the Cc: 
header element (and was case-sensitive). PHP >= 4.3 supports all the 
mentioned header elements and is no longer case-sensitive. 

Example 1. Sending mail.
  <?php
  mail("joecool@example.com", "My Subject", "Line 1\nLine 
  2\nLine 3");
  ?> 
If a fourth string argument is passed, this string is inserted at the end 
of the header. This is typically used to add extra headers. Multiple extra 
headers are separated with a carriage return and newline. 
Note: You must use \r\n to separate headers, although some Unix mail 
transfer agents may work with just a single newline (\n). 
Example 2. Sending mail with extra headers.
  <?php
  mail("nobody@example.com", "the subject", $message,
       "From: webmaster@{$_SERVER['SERVER_NAME']}\r\n" .
       "Reply-To: webmaster@{$_SERVER['SERVER_NAME']}\r\n" .
       "X-Mailer: PHP/" . phpversion());
  ?> 
The additional_parameters parameter can be used to pass an additional 
parameter to the program configured to use when sending mail using the 
sendmail_path configuration setting. For example, this can be used to set 
the envelope sender address when using sendmail with the -f sendmail 
option. You may need to add the user that your web server runs as to your 
sendmail configuration to prevent a 'X-Warning' header from being added to 
the message when you set the envelope sender using this method. 
Example 3. Sending mail with extra headers and setting an additional 
command line parameter.
  <?php
  mail("nobody@example.com", "the subject", $message,
       "From: webmaster@{$_SERVER['SERVER_NAME']}", 
  "-fwebmaster@{$_SERVER['SERVER_NAME']}");
  ?> 
Note: This fifth parameter was added in PHP 4.0.5. Since PHP 4.2.3 this 
parameter is disabled in safe_mode and the mail() function will expose a 
warning message and return FALSE if you're trying to use it. 
You can also use simple string building techniques to build complex email 
messages. Example 4. Sending complex email.
  <?php
  /* recipients */
  $to  = "mary@example.com" . ", " ; // note the comma
  $to .= "kelly@example.com";

  /* subject */
  $subject = "Birthday Reminders for August";

  /* message */
  $message = '
  <html>
  <head>
  <title>Birthday Reminders for August</title>
  </head>
  <body>
  <p>Here are the birthdays upcoming in August!</p>
  <table>
  <tr>
    <th>Person</th><th>Day</th><th>Month</th><th>Year</th>
  </tr>
  <tr>
    <td>Joe</td><td>3rd</td><td>August</td><td>1970</td>
  </tr>
  <tr>
    <td>Sally</td><td>17th</td><td>August</td><td>1973</td>
  </tr>
  </table>
  </body>
  </html>
  ';

  /* To send HTML mail, you can set the Content-type header. */
  $headers  = "MIME-Version: 1.0\r\n";
  $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";

  /* additional headers */
  $headers .= "To: Mary <mary@example.com>, Kelly 
  <kelly@example.com>\r\n";
  $headers .= "From: Birthday Reminder 
  <birthday@example.com>\r\n";
  $headers .= "Cc: birthdayarchive@example.com\r\n";
  $headers .= "Bcc: birthdaycheck@example.com\r\n";

  /* and now mail it */
  mail($to, $subject, $message, $headers);
  ?> 
Note: Make sure you do not have any newline characters in the to or 
subject, or the mail may not be sent properly. 
Note: The to parameter should not be an address in the form of 
"Something <someone@example.com>". The mail command may not parse this 
properly while talking with the MTA (Particularly under Windows). 
See also imap_mail().   ezmlm_hashUpmailparse functions
mailparse_determine_best_xfer_encoding
(4.1.0 - 4.1.2 only)
mailparse_determine_best_xfer_encoding --  Figures out the best way of 
encoding the content read from the file pointer fp, which must be 
seek-able 
Description
int mailparse_determine_best_xfer_encoding ( resource fp)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse functionsUpmailparse_msg_create
mailparse_msg_create
(4.1.0 - 4.1.2 only)
mailparse_msg_create -- Returns a handle that can be used to parse a 
message 
Description
int mailparse_msg_create ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_determine_best_xfer_encodingUpmailparse_msg_extract_part_file
mailparse_msg_extract_part_file
(4.1.0 - 4.1.2 only)
mailparse_msg_extract_part_file -- Extracts/decodes a message section, 
decoding the transfer encoding 
Description
string mailparse_msg_extract_part_file ( resource rfc2045, string filename 
[, string callbackfunc])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_createUpmailparse_msg_extract_part
mailparse_msg_extract_part
(4.1.0 - 4.1.2 only)
mailparse_msg_extract_part --  Extracts/decodes a message section. If 
callbackfunc is not specified, the contents will be sent to "stdout" 
Description
void mailparse_msg_extract_part ( resource rfc2045, string msgbody [, 
string callbackfunc])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_extract_part_fileUpmailparse_msg_free
mailparse_msg_free
(4.1.0 - 4.1.2 only)
mailparse_msg_free -- Frees a handle allocated by mailparse_msg_create()
Description
void mailparse_msg_free ( resource rfc2045buf)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_extract_partUpmailparse_msg_get_part_data
mailparse_msg_get_part_data
(4.1.0 - 4.1.2 only)
mailparse_msg_get_part_data -- Returns an associative array of info about 
the message 
Description
array mailparse_msg_get_part_data ( resource rfc2045)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_freeUpmailparse_msg_get_part
mailparse_msg_get_part
(4.1.0 - 4.1.2 only)
mailparse_msg_get_part -- Returns a handle on a given section in a 
mimemessage 
Description
int mailparse_msg_get_part ( resource rfc2045, string mimesection)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_get_part_dataUpmailparse_msg_get_structure
mailparse_msg_get_structure
(4.1.0 - 4.1.2 only)
mailparse_msg_get_structure -- Returns an array of mime section names in 
the supplied message 
Description
array mailparse_msg_get_structure ( resource rfc2045)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_get_partUpmailparse_msg_parse_file
mailparse_msg_parse_file
(4.1.0 - 4.1.2 only)
mailparse_msg_parse_file -- Parse file and return a resource representing 
the structure 
Description
resource mailparse_msg_parse_file ( string filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_get_structureUpmailparse_msg_parse
mailparse_msg_parse
(4.1.0 - 4.1.2 only)
mailparse_msg_parse -- Incrementally parse data into buffer 
Description
void mailparse_msg_parse ( resource rfc2045buf, string data)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_parse_fileUpmailparse_rfc822_parse_addresses
mailparse_rfc822_parse_addresses
(4.1.0 - 4.1.2 only)
mailparse_rfc822_parse_addresses --  Parse addresses and returns a hash 
containing that data 
Description
array mailparse_rfc822_parse_addresses ( string addresses)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_msg_parseUpmailparse_stream_encode
mailparse_stream_encode
(4.1.0 - 4.1.2 only)
mailparse_stream_encode --  Streams data from source file pointer, apply 
encoding and write to destfp 
Description
bool mailparse_stream_encode ( resource sourcefp, resource destfp, string 
encoding)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_rfc822_parse_addressesUpmailparse_uudecode_all
mailparse_uudecode_all
(no version information, might be only in CVS)
mailparse_uudecode_all --  Scans the data from fp and extract each 
embedded uuencoded file. Returns an array listing filename information 
Description
array mailparse_uudecode_all ( resource fp)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  mailparse_stream_encodeUpMathematical Functions
main
main -- Dummy for main()
Description
There is no function named main() except in the PHP source. In PHP 4.3.0, 
a new type of error handling in the PHP source (php_error_docref) was 
introduced. One feature is to provide links to a manual page in PHP error 
messages when the PHP directives html_errors (on by default) and 
docref_root (on by default until PHP 4.3.2) are set. 
Sometimes error messages refer to a manual page for the function main() 
which is why this page exists. Please add a user comment below that 
mentions what PHP function caused the error that linked to main() and it 
will be fixed and properly documented. 
Table 1. Known errors that point to main()
Function nameNo longer points here as of
include()4.3.2
include_once()4.3.2
require()4.3.2
require_once()4.3.2

See also html_errors and display_errors.   ini_setUpmemory_get_usage
#

#T=bool mail ( string to, string subject, string message [, string 
mail ( ^!string to, string subject, string message [, string ;
#

#T=max - mixed max ( number arg1, number arg2 [, number ...])
(PHP 3, PHP 4 )
max -- Find highest value
Description
mixed max ( number arg1, number arg2 [, number ...])

mixed max ( array numbers [, array ...])
max() returns the numerically highest of the parameter values. 
If the first and only parameter is an array, max() returns the highest 
value in that array. If the first parameter is an integer, string or 
float, you need at least two parameters and max() returns the biggest of 
these values. You can compare an unlimited number of values. 
Note: PHP will evaluate a non-numeric string as 0, but still return the 
string if it's seen as the numerically highest value. If multiple 
arguments evaluate to 0, max() will use the first one it sees (the 
leftmost value). 
Example 1. Example uses of max()
  <?php
  echo max(1, 3, 5, 6, 7);  // 7
  echo max(array(2, 4, 5)); // 5

  echo max(0, 'hello');     // 0
  echo max('hello', 0);     // hello
  echo max(-1, 'hello');    // hello

  // With multiple arrays, max compares from left to right
  // so in our example: 2 == 2, but 4 < 5
  $val = max(array(2, 4, 8), array(2, 5, 7)); // array(2, 5, 7)

  // If both an array and non-array are given, the array
  // is always returned as it's seen as the largest
  $val = max('string', array(2, 5, 7), 42);   // array(2, 5, 7)
  ?> 
See also min() and count().   logUpmin
#

#T=mixed max ( number arg1, number arg2 [, number ...])
max ( ^!number arg1, number arg2 [, number ...]);
#

#T=mb_convert_case - string mb_convert_case ( string str, int mode [, string encoding])
(PHP 4 >= 4.3.0)
mb_convert_case -- Perform case folding on a string
Description
string mb_convert_case ( string str, int mode [, string encoding])
mb_convert_case() returns case folded version of string converted in the 
way specified by mode. 
mode can be one of MB_CASE_UPPER, MB_CASE_LOWER or MB_CASE_TITLE. 
encoding specifies the encoding of str; if omitted, the internal character 
encoding value will be used. 
The return value is str with the appropriate case folding applied. 
By contrast to the standard case folding functions such as strtolower() 
and strtoupper(), case folding is performed on the basis of the Unicode 
character properties. Thus the behaviour of this function is not affected 
by locale settings and it can convert any characters that have 
'alphabetic' property, such as A-umlaut (). 
For more information about the Unicode properties, please see 
http://www.unicode.org/unicode/reports/tr21/. 
Example 1. mb_convert_case() example
  <?php
  $str = "mary had a Little lamb and she loved it so";
  $str = mb_convert_case($str, MB_CASE_UPPER, "UTF-8");
  echo $str; // Prints MARY HAD A LITTLE LAMB AND SHE LOVED IT 
SO
  $str = mb_convert_case($str, MB_CASE_TITLE, "UTF-8");
  echo $str; // Prints Mary Had A Little Lamb And She Loved It 
So
  ?> 
See also mb_strtolower(), mb_strtoupper(), strtolower() and strtoupper().   Multi-Byte String FunctionsUpmb_convert_encoding
#

#T=string mb_convert_case ( string str, int mode [, string encoding])
mb_convert_case ( ^!string str, int mode [, string encoding]);
#

#T=mb_convert_encoding - string mb_convert_encoding ( string str, string to-encoding [, mixed 
(PHP 4 >= 4.0.6)
mb_convert_encoding -- Convert character encoding
Description
string mb_convert_encoding ( string str, string to-encoding [, mixed 
from-encoding])
mb_convert_encoding() converts character encoding of string str from 
from-encoding to to-encoding. 
str : String to be converted. 
from-encoding is specified by character code name before conversion. it 
can be array or string - comma separated enumerated list. If it is not 
specified, the internal encoding will be used. 
Example 1. mb_convert_encoding() example
  <?php
  /* Convert internal character encoding to SJIS */
  $str = mb_convert_encoding($str, "SJIS");

  /* Convert EUC-JP to UTF-7 */
  $str = mb_convert_encoding($str, "UTF-7", "EUC-JP");

  /* Auto detect encoding from JIS, eucjp-win, sjis-win, then 
  convert str to UCS-2LE */
  $str = mb_convert_encoding($str, "UCS-2LE", "JIS, eucjp-win, 
  sjis-win");

  /* "auto" is expanded to "ASCII,JIS,UTF-8,EUC-JP,SJIS" */
  $str = mb_convert_encoding($str, "EUC-JP", "auto");
  ?> 
See also mb_detect_order().   mb_convert_caseUpmb_convert_kana
#

#T=string mb_convert_encoding ( string str, string to-encoding [, mixed 
mb_convert_encoding ( ^!string str, string to-encoding [, mixed ;
#

#T=mb_convert_kana - string mb_convert_kana ( string str, string option [, mixed encoding])
(PHP 4 >= 4.0.6)
mb_convert_kana --  Convert "kana" one from another ("zen-kaku", 
"han-kaku" and more) 
Description
string mb_convert_kana ( string str, string option [, mixed encoding])
mb_convert_kana() performs "han-kaku" - "zen-kaku" conversion for string 
str. It returns converted string. This function is only useful for 
Japanese. 
option is conversion option. Default value is "KV". 
encoding is character encoding. If it is omitted, internal character 
encoding is used. 
Specify with combination of following options. Default value is KV. 
Table 1. Applicable Conversion Options
OptionMeaning
rConvert "zen-kaku" alphabets to "han-kaku" 
RConvert "han-kaku" alphabets to "zen-kaku" 
nConvert "zen-kaku" numbers to "han-kaku" 
NConvert "han-kaku" numbers to "zen-kaku" 
aConvert "zen-kaku" alphabets and numbers to "han-kaku" 
AConvert "han-kaku" alphabets and numbers to "zen-kaku" (Characters 
included in "a", "A" options are U+0021 - U+007E excluding U+0022, 
U+0027, U+005C, U+007E) 
sConvert "zen-kaku" space to "han-kaku" (U+3000 -> U+0020) 
SConvert "han-kaku" space to "zen-kaku" (U+0020 -> U+3000) 
kConvert "zen-kaku kata-kana" to "han-kaku kata-kana" 
KConvert "han-kaku kata-kana" to "zen-kaku kata-kana" 
hConvert "zen-kaku hira-gana" to "han-kaku kata-kana" 
HConvert "han-kaku kata-kana" to "zen-kaku hira-gana" 
cConvert "zen-kaku kata-kana" to "zen-kaku hira-gana" 
CConvert "zen-kaku hira-gana" to "zen-kaku kata-kana" 
VCollapse voiced sound notation and convert them into a character. 
Use with "K","H" 

Example 1. mb_convert_kana() example
  <?php
  /* Convert all "kana" to "zen-kaku" "kata-kana" */
  $str = mb_convert_kana($str, "KVC");

  /* Convert "han-kaku" "kata-kana" to "zen-kaku" "kata-kana" 
     and "zen-kaku" alpha-numeric to "han-kaku" */
  $str = mb_convert_kana($str, "KVa");
  ?> 

  mb_convert_encodingUpmb_convert_variables
#

#T=string mb_convert_kana ( string str, string option [, mixed encoding])
mb_convert_kana ( ^!string str, string option [, mixed encoding]);
#

#T=mb_convert_variables - string mb_convert_variables ( string to-encoding, mixed from-encoding, 
(PHP 4 >= 4.0.6)
mb_convert_variables -- Convert character code in variable(s)
Description
string mb_convert_variables ( string to-encoding, mixed from-encoding, 
mixed vars)
mb_convert_variables() convert character encoding of variables vars in 
encoding from-encoding to encoding to-encoding. It returns character 
encoding before conversion for success, FALSE for failure. 
mb_convert_variables() join strings in Array or Object to detect encoding, 
since encoding detection tends to fail for short strings. Therefore, it is 
impossible to mix encoding in single array or object. 
It from-encoding is specified by array or comma separated string, it tries 
to detect encoding from from-coding. When encoding is omitted, 
detect_order is used. 
vars (3rd and larger) is reference to variable to be converted. String, 
Array and Object are accepted. mb_convert_variables() assumes all 
parameters have the same encoding. 
Example 1. mb_convert_variables() example
  <?php
  /* Convert variables $post1, $post2 to internal encoding */
  $interenc = mb_internal_encoding();
  $inputenc = mb_convert_variables($interenc, 
  "ASCII,UTF-8,SJIS-win", $post1, $post2);
  ?> 

  mb_convert_kanaUpmb_decode_mimeheader
#

#T=string mb_convert_variables ( string to-encoding, mixed from-encoding, 
mb_convert_variables ( ^!string to-encoding, mixed from-encoding, ;
#

#T=mb_decode_mimeheader - string mb_decode_mimeheader ( string str)
(PHP 4 >= 4.0.6)
mb_decode_mimeheader -- Decode string in MIME header field
Description
string mb_decode_mimeheader ( string str)
mb_decode_mimeheader() decodes encoded-word string str in MIME header. 
It returns decoded string in internal character encoding. 
See also mb_encode_mimeheader().   mb_convert_variablesUpmb_decode_numericentity
#

#T=string mb_decode_mimeheader ( string str)
mb_decode_mimeheader ( ^!string str);
#

#T=mb_decode_numericentity - string mb_decode_numericentity ( string str, array convmap [, string 
(PHP 4 >= 4.0.6)
mb_decode_numericentity --  Decode HTML numeric string reference to 
character 
Description
string mb_decode_numericentity ( string str, array convmap [, string 
encoding])
Convert numeric string reference of string str in specified block to 
character. It returns converted string. 
convmap is array to specifies code area to convert. 
encoding is character encoding. If it is omitted, internal character 
encoding is used. 
Example 1. convmap example
  $convmap = array (
     int start_code1, int end_code1, int offset1, int mask1,
     int start_code2, int end_code2, int offset2, int mask2,
     ........
     int start_codeN, int end_codeN, int offsetN, int maskN );
  // Specify Unicode value for start_codeN and end_codeN
  // Add offsetN to value and take bit-wise 'AND' with maskN, 
  // then convert value to numeric string reference. 
See also mb_encode_numericentity().   mb_decode_mimeheaderUpmb_detect_encoding
#

#T=string mb_decode_numericentity ( string str, array convmap [, string 
mb_decode_numericentity ( ^!string str, array convmap [, string ;
#

#T=mb_detect_encoding - string mb_detect_encoding ( string str [, mixed encoding-list])
(PHP 4 >= 4.0.6)
mb_detect_encoding -- Detect character encoding
Description
string mb_detect_encoding ( string str [, mixed encoding-list])
mb_detect_encoding() detects character encoding in string str. It returns 
detected character encoding. 
encoding-list is list of character encoding. Encoding order may be 
specified by array or comma separated list string. 
If encoding_list is omitted, detect_order is used. 
Example 1. mb_detect_encoding() example
  <?php
  /* Detect character encoding with current detect_order */
  echo mb_detect_encoding($str);

  /* "auto" is expanded to "ASCII,JIS,UTF-8,EUC-JP,SJIS" */
  echo mb_detect_encoding($str, "auto");

  /* Specify encoding_list character encoding by comma separated 
  list */
  echo mb_detect_encoding($str, "JIS, eucjp-win, sjis-win");

  /* Use array to specify encoding_list  */
  $ary[] = "ASCII";
  $ary[] = "JIS";
  $ary[] = "EUC-JP";
  echo mb_detect_encoding($str, $ary);
  ?> 
See also mb_detect_order().   mb_decode_numericentityUpmb_detect_order
#

#T=string mb_detect_encoding ( string str [, mixed encoding-list])
mb_detect_encoding ( ^!string str [, mixed encoding-list]);
#

#T=mb_detect_order - array mb_detect_order ( [mixed encoding-list])
(PHP 4 >= 4.0.6)
mb_detect_order --  Set/Get character encoding detection order 
Description
array mb_detect_order ( [mixed encoding-list])
mb_detect_order() sets automatic character encoding detection order to 
encoding-list. It returns TRUE for success, FALSE for failure. 
encoding-list is array or comma separated list of character encoding. 
("auto" is expanded to "ASCII, JIS, UTF-8, EUC-JP, SJIS") 
If encoding-list is omitted, it returns current character encoding 
detection order as array. 
This setting affects mb_detect_encoding() and mb_send_mail(). 
Note: mbstring currently implements following encoding detection 
filters. If there is an invalid byte sequence for following encoding, 
encoding detection will fail. 
Note: UTF-8, UTF-7, ASCII, EUC-JP,SJIS, eucJP-win, SJIS-win, JIS, 
ISO-2022-JP 
For ISO-8859-*, mbstring always detects as ISO-8859-*. 
For UTF-16, UTF-32, UCS2 and UCS4, encoding detection will fail always. 
Example 1. Useless detect order example
; Always detect as ISO-8859-1
detect_order = ISO-8859-1, UTF-8

; Always detect as UTF-8, since ASCII/UTF-7 values are 
; valid for UTF-8
detect_order = UTF-8, ASCII, UTF-7
Example 2. mb_detect_order() examples
  <?php
  /* Set detection order by enumerated list */
  mb_detect_order("eucjp-win,sjis-win,UTF-8");

  /* Set detection order by array */
  $ary[] = "ASCII";
  $ary[] = "JIS";
  $ary[] = "EUC-JP";
  mb_detect_order($ary);

  /* Display current detection order */
  echo implode(", ", mb_detect_order());
  ?> 
See also mb_internal_encoding(), mb_http_input(), mb_http_output() and 
mb_send_mail().   mb_detect_encodingUpmb_encode_mimeheader
#

#T=array mb_detect_order ( [mixed encoding-list])
mb_detect_order ( ^![mixed encoding-list]);
#

#T=mb_encode_mimeheader - string mb_encode_mimeheader ( string str [, string charset [, string 
(PHP 4 >= 4.0.6)
mb_encode_mimeheader -- Encode string for MIME header
Description
string mb_encode_mimeheader ( string str [, string charset [, string 
transfer-encoding [, string linefeed]]])
mb_encode_mimeheader() converts string str to encoded-word for header 
field. It returns converted string in ASCII encoding. 
charset is character encoding name. Default is ISO-2022-JP. 
transfer-encoding is transfer encoding. It should be one of "B" (Base64) 
or "Q" (Quoted-Printable). Default is "B". 
linefeed is end of line marker. Default is "\r\n" (CRLF). 
Example 1. mb_encode_mimeheader() example
  <?php
  $name = ""; // kanji
  $mbox = "kru";
  $doma = "gtinn.mon";
  $addr = mb_encode_mimeheader($name, "UTF-7", "Q") . " <" . 
  $mbox . "@" . $doma . ">";
  echo $addr;
  ?> 
See also mb_decode_mimeheader().   mb_detect_orderUpmb_encode_numericentity
#

#T=string mb_encode_mimeheader ( string str [, string charset [, string 
mb_encode_mimeheader ( ^!string str [, string charset [, string ;
#

#T=mb_encode_numericentity - string mb_encode_numericentity ( string str, array convmap [, string 
(PHP 4 >= 4.0.6)
mb_encode_numericentity --  Encode character to HTML numeric string 
reference 
Description
string mb_encode_numericentity ( string str, array convmap [, string 
encoding])
mb_encode_numericentity() converts specified character codes in string str 
from HTML numeric character reference to character code. It returns 
converted string. 
convmap is array specifies code area to convert. 
encoding is character encoding. 
Example 1. convmap example
  $convmap = array (
  int start_code1, int end_code1, int offset1, int mask1,
  int start_code2, int end_code2, int offset2, int mask2,
  ........
  int start_codeN, int end_codeN, int offsetN, int maskN );
  // Specify Unicode value for start_codeN and end_codeN
  // Add offsetN to value and take bit-wise 'AND' with maskN, 
  then
  // it converts value to numeric string reference. 
Example 2. mb_encode_numericentity() example 
  <?php
  /* Convert Left side of ISO-8859-1 to HTML numeric character 
  reference */
  $convmap = array(0x80, 0xff, 0, 0xff);
  $str = mb_encode_numericentity($str, $convmap, "ISO-8859-1");

  /* Convert user defined SJIS-win code in block 95-104 to 
  numeric
     string reference */
  $convmap = array(
	 0xe000, 0xe03e, 0x1040, 0xffff,
	 0xe03f, 0xe0bb, 0x1041, 0xffff,
	 0xe0bc, 0xe0fa, 0x1084, 0xffff,
	 0xe0fb, 0xe177, 0x1085, 0xffff,
	 0xe178, 0xe1b6, 0x10c8, 0xffff,
	 0xe1b7, 0xe233, 0x10c9, 0xffff,
	 0xe234, 0xe272, 0x110c, 0xffff,
	 0xe273, 0xe2ef, 0x110d, 0xffff,
	 0xe2f0, 0xe32e, 0x1150, 0xffff,
	 0xe32f, 0xe3ab, 0x1151, 0xffff );
  $str = mb_encode_numericentity($str, $convmap, "sjis-win");
  ?> 
See also mb_decode_numericentity().   mb_encode_mimeheaderUpmb_ereg_match
mb_ereg_match
(4.2.0 - 4.3.2 only)
mb_ereg_match --  Regular expression match for multibyte string 
Description
bool mb_ereg_match ( string pattern, string string [, string option])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_match() returns TRUE if string matches regular expression pattern, 
FALSE if not. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg().   mb_encode_numericentityUpmb_ereg_replace
mb_ereg_replace
(4.2.0 - 4.3.2 only)
mb_ereg_replace -- Replace regular expression with multibyte support
Description
string mb_ereg_replace ( string pattern, string replacement, string string 
[, array option])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_replace() scans string for matches to pattern, then replaces the 
matched text with replacement and returns the result string or FALSE on 
error. Multibyte character can be used in pattern. 
Matching condition can be set by option parameter. If i is specified for 
this parameter, the case will be ignored. If x is specified, white space 
will be ignored. If m is specified, match will be executed in multiline 
mode and line break will be included in '.'. If p is specified, match will 
be executed in POSIX mode, line break will be considered as normal 
character. If e is specified, replacement string will be evaluated as PHP 
expression. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_eregi_replace().   mb_ereg_matchUpmb_ereg_search_getpos
mb_ereg_search_getpos
(4.2.0 - 4.3.2 only)
mb_ereg_search_getpos --  Returns start point for next regular expression 
match 
Description
array mb_ereg_search_getpos ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_search_getpos() returns the point to start regular expression 
match for mb_ereg_search(), mb_ereg_search_pos(), mb_ereg_search_regs(). 
The position is represented by bytes from the head of string. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_search_setpos().   mb_ereg_replaceUpmb_ereg_search_getregs
mb_ereg_search_getregs
(4.2.0 - 4.3.2 only)
mb_ereg_search_getregs --  Retrieve the result from the last multibyte 
regular expression match 
Description
array mb_ereg_search_getregs ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_search_getregs() returns an array including the sub-string of 
matched part by last mb_ereg_search(), mb_ereg_search_pos(), 
mb_ereg_search_regs(). If there are some maches, the first element will 
have the matched sub-string, the second element will have the first part 
grouped with brackets, the third element will have the second part grouped 
with brackets, and so on. It returns FALSE on error; 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_search_init().   mb_ereg_search_getposUpmb_ereg_search_init
mb_ereg_search_init
(4.2.0 - 4.3.2 only)
mb_ereg_search_init --  Setup string and regular expression for multibyte 
regular expression match 
Description
array mb_ereg_search_init ( string string [, string pattern [, string 
option]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_search_init() sets string and pattern for multibyte regular 
expression. These values are used for mb_ereg_search(), 
mb_ereg_search_pos(), mb_ereg_search_regs(). It returns TRUE for success, 
FALSE for error. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_search_regs().   mb_ereg_search_getregsUpmb_ereg_search_pos
mb_ereg_search_pos
(4.2.0 - 4.3.2 only)
mb_ereg_search_pos --  Return position and length of matched part of 
multibyte regular expression for predefined multibyte string 
Description
array mb_ereg_search_pos ( [string pattern [, string option]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_search_pos() returns an array including position of matched part 
for multibyte regular expression. The first element of the array will be 
the beginning of matched part, the second element will be length (bytes) 
of matched part. It returns FALSE on error. 
The string for match is specified by mb_ereg_search_init(). It it is not 
specified, the previous one will be used. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_search_init().   mb_ereg_search_initUpmb_ereg_search_regs
mb_ereg_search_regs
(4.2.0 - 4.3.2 only)
mb_ereg_search_regs --  Returns the matched part of multibyte regular 
expression 
Description
array mb_ereg_search_regs ( [string pattern [, string option]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_search_regs() executes the multibyte regular expression match, and 
if there are some matched part, it returns an array including substring of 
matched part as first element, the first grouped part with brackets as 
second element, the second grouped part as third element, and so on. It 
returns FALSE on error. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_search_init().   mb_ereg_search_posUpmb_ereg_search_setpos
mb_ereg_search_setpos
(4.2.0 - 4.3.2 only)
mb_ereg_search_setpos --  Set start point of next regular expression match 

Description
array mb_ereg_search_setpos ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_search_setpos() sets the starting point of match for 
mb_ereg_search(). 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_search_init().   mb_ereg_search_regsUpmb_ereg_search
mb_ereg_search
(4.2.0 - 4.3.2 only)
mb_ereg_search --  Multibyte regular expression match for predefined 
multibyte string 
Description
bool mb_ereg_search ( [string pattern [, string option]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_search() returns TRUE if the multibyte string matches with the 
regular expression, FALSE for otherwise. The string for matching is set by 
mb_ereg_search_init(). If pattern is not specified, the previous one is 
used. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_search_init().   mb_ereg_search_setposUpmb_ereg
mb_ereg
(4.2.0 - 4.3.2 only)
mb_ereg -- Regular expression match with multibyte support
Description
int mb_ereg ( string pattern, string string [, array regs])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg() executes the regular expression match with multibyte support, 
and returns 1 if matches are found. If the optional third parameter was 
specified, the function returns the byte length of matched part, and the 
array regs will contain the substring of matched string. The functions 
returns 1 if it matches with the empty string. If no matches found or 
error happend, FALSE will be returned. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_eregi()   mb_ereg_searchUpmb_eregi_replace
mb_eregi_replace
(4.2.0 - 4.3.2 only)
mb_eregi_replace --  Replace regular expression with multibyte support 
ignoring case 
Description
string mb_eregi_replace ( string pattern, string replace, string string)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_ereg_replace() scans string for matches to pattern, then replaces the 
matched text with replacement and returns the result string or FALSE on 
error. Multibyte character can be used in pattern. The case will be 
ignored. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg_replace().   mb_eregUpmb_eregi
mb_eregi
(4.2.0 - 4.3.2 only)
mb_eregi --  Regular expression match ignoring case with multibyte support 

Description
int mb_eregi ( string pattern, string string [, array regs])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_eregi() executes the regular expression match with multibyte support, 
and returns 1 if matches are found. This function ignore case. If the 
optional third parameter was specified, the function returns the byte 
length of matched part, and the array regs will contain the substring of 
matched string. The functions returns 1 if it matches with the empty 
string. If no matches found or error happend, FALSE will be returned. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg().   mb_eregi_replaceUpmb_get_info
#

#T=string mb_encode_numericentity ( string str, array convmap [, string 
mb_encode_numericentity ( ^!string str, array convmap [, string ;
#

#T=mb_get_info - string mb_get_info ( [string type])
(PHP 4 >= 4.2.0)
mb_get_info -- Get internal settings of mbstring
Description
string mb_get_info ( [string type])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_get_info() returns internal setting parameter of mbstring. 
If type isn't specified or is specified to "all", an array having the 
elements "internal_encoding", "http_output", "http_input", "func_overload" 
will be returned. 
If type is specified for "http_output", "http_input", "internal_encoding", 
"func_overload", the specified setting parameter will be returned. 
See also mb_internal_encoding(), mb_http_output().   mb_eregiUpmb_http_input
#

#T=string mb_get_info ( [string type])
mb_get_info ( ^![string type]);
#

#T=mb_http_input - string mb_http_input ( [string type])
(PHP 4 >= 4.0.6)
mb_http_input -- Detect HTTP input character encoding
Description
string mb_http_input ( [string type])
mb_http_input() returns result of HTTP input character encoding detection. 

type: Input string specifies input type. "G" for GET, "P" for POST, "C" 
for COOKIE. If type is omitted, it returns last input type processed. 
Return Value: Character encoding name. If mb_http_input() does not process 
specified HTTP input, it returns FALSE. 
See also mb_internal_encoding(), mb_http_output(), mb_detect_order().   mb_get_infoUpmb_http_output
#

#T=string mb_http_input ( [string type])
mb_http_input ( ^![string type]);
#

#T=mb_http_output - string mb_http_output ( [string encoding])
(PHP 4 >= 4.0.6)
mb_http_output -- Set/Get HTTP output character encoding
Description
string mb_http_output ( [string encoding])
If encoding is set, mb_http_output() sets HTTP output character encoding 
to encoding. Output after this function is converted to encoding. 
mb_http_output() returns TRUE for success and FALSE for failure. 
If encoding is omitted, mb_http_output() returns current HTTP output 
character encoding. 
See also mb_internal_encoding(), mb_http_input(), mb_detect_order().   mb_http_inputUpmb_internal_encoding
#

#T=string mb_http_output ( [string encoding])
mb_http_output ( ^![string encoding]);
#

#T=mb_internal_encoding - string mb_internal_encoding ( [string encoding])
(PHP 4 >= 4.0.6)
mb_internal_encoding --  Set/Get internal character encoding 
Description
string mb_internal_encoding ( [string encoding])
mb_internal_encoding() sets internal character encoding to encoding If 
parameter is omitted, it returns current internal encoding. 
encoding is used for HTTP input character encoding conversion, HTTP output 
character encoding conversion and default character encoding for string 
functions defined by mbstring module. 
encoding: Character encoding name 
Return Value: If encoding is set,mb_internal_encoding() returns TRUE for 
success, otherwise returns FALSE. If encoding is omitted, it returns 
current character encoding name. 
Example 1. mb_internal_encoding() example
  <?php
  /* Set internal character encoding to UTF-8 */
  mb_internal_encoding("UTF-8");

  /* Display current internal character encoding */
  echo mb_internal_encoding();
  ?> 
See also mb_http_input(), mb_http_output() and mb_detect_order().   mb_http_outputUpmb_language
#

#T=string mb_internal_encoding ( [string encoding])
mb_internal_encoding ( ^![string encoding]);
#

#T=mb_language - string mb_language ( [string language])
(PHP 4 >= 4.0.6)
mb_language --  Set/Get current language 
Description
string mb_language ( [string language])
mb_language() sets language. If language is omitted, it returns current 
language as string. 
language setting is used for encoding e-mail messages. Valid languages are 
"Japanese", "ja","English","en" and "uni" (UTF-8). mb_send_mail() uses 
this setting to encode e-mail. 
Language and its setting is ISO-2022-JP/Base64 for Japanese, UTF-8/Base64 
for uni, ISO-8859-1/quoted printable for English. 
Return Value: If language is set and language is valid, it returns TRUE. 
Otherwise, it returns FALSE. When language is omitted, it returns language 
name as string. If no language is set previously, it returns FALSE. 
See also mb_send_mail().   mb_internal_encodingUpmb_output_handler
#

#T=string mb_language ( [string language])
mb_language ( ^![string language]);
#

#T=mb_output_handler - string mb_output_handler ( string contents, int status)
(PHP 4 >= 4.0.6)
mb_output_handler --  Callback function converts character encoding in 
output buffer 
Description
string mb_output_handler ( string contents, int status)
mb_output_handler() is ob_start() callback function. mb_output_handler() 
converts characters in output buffer from internal character encoding to 
HTTP output character encoding. 
4.1.0 or later version, this handler adds charset HTTP header when 
following conditions are met: 
Does not set Content-Type by header()
Default MIME type begins with text/
http_output setting is other than pass
contents : Output buffer contents 
status : Output buffer status 
Return Value: String converted 
Example 1. mb_output_handler() example
  <?php
  mb_http_output("UTF-8");
  ob_start("mb_output_handler");
  ?> 
Note: If you want to output some binary data such as image from PHP 
script with PHP 4.3.0 or later, Content-Type: header must be send using 
header() before any binary data was send to client (e.g. 
header("Content-Type: image/png")). If Content-Type: header was send, 
output character encoding conversion will not be performed. 
Note that if 'Content-Type: text/*' was send using header(), the sending 
data is regarded as text, encoding conversion will be performed using 
character encoding settings. 
If you want to output some binary data such as image from PHP script 
with PHP 4.2.x or earlier, you must set output encoding to "pass" using 
mb_http_output(). 
See also ob_start().   mb_languageUpmb_parse_str
#

#T=string mb_output_handler ( string contents, int status)
mb_output_handler ( ^!string contents, int status);
#

#T=mb_parse_str - bool mb_parse_str ( string encoded_string [, array result])
(PHP 4 >= 4.0.6)
mb_parse_str --  Parse GET/POST/COOKIE data and set global variable 
Description
bool mb_parse_str ( string encoded_string [, array result])
mb_parse_str() parses GET/POST/COOKIE data and sets global variables. 
Since PHP does not provide raw POST/COOKIE data, it can only used for GET 
data for now. It preses URL encoded data, detects encoding, converts 
coding to internal encoding and set values to result array or global 
variables. 
encoded_string: URL encoded data. 
result: Array contains decoded and character encoding converted values. 
Return Value: It returns TRUE for success or FALSE for failure. 
See also mb_detect_order(), mb_internal_encoding().   mb_output_handlerUpmb_preferred_mime_name
#

#T=bool mb_parse_str ( string encoded_string [, array result])
mb_parse_str ( ^!string encoded_string [, array result]);
#

#T=mb_preferred_mime_name - string mb_preferred_mime_name ( string encoding)
(PHP 4 >= 4.0.6)
mb_preferred_mime_name -- Get MIME charset string
Description
string mb_preferred_mime_name ( string encoding)
mb_preferred_mime_name() returns MIME charset string for character 
encoding encoding. It returns charset string. 
Example 1. mb_preferred_mime_string() example
  <?php
  $outputenc = "sjis-win";
  mb_http_output($outputenc);
  ob_start("mb_output_handler");
  header("Content-Type: text/html; charset=" . 
  mb_preferred_mime_name($outputenc));
  ?> 

  mb_parse_strUpmb_regex_encoding
mb_regex_encoding
(4.2.0 - 4.3.2 only)
mb_regex_encoding --  Returns current encoding for multibyte regex as 
string 
Description
string mb_regex_encoding ( [string encoding])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_regex_encoding() returns the character encoding used by multibyte regex 
functions. 
If the optional parameter encoding is specified, it is set to the 
character encoding for multibyte regex. The default value is the internal 
character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_internal_encoding(), mb_ereg()   mb_preferred_mime_nameUpmb_regex_set_options
mb_regex_set_options
(4.3.0 - 4.3.2 only)
mb_regex_set_options --  Set/Get the default options for mbregex functions 

Description
string mb_regex_set_options ( [string options])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_regex_set_options() sets the default options described by options for 
multibyte regex functions. 
Returns the previous options. If options is omitted, it returns the string 
that describes the current options. 
Note: This function is supported in PHP 4.3.0 or higher. 
See also mb_split(), mb_ereg() and mb_eregi()   mb_regex_encodingUpmb_send_mail
#

#T=string mb_preferred_mime_name ( string encoding)
mb_preferred_mime_name ( ^!string encoding);
#

#T=mb_send_mail - bool mb_send_mail ( string to, string subject, string message [, string 
(PHP 4 >= 4.0.6)
mb_send_mail --  Send encoded mail. 
Description
bool mb_send_mail ( string to, string subject, string message [, string 
additional_headers [, string additional_parameter]])
mb_send_mail() sends email. Headers and message are converted and encoded 
according to mb_language() setting. mb_send_mail() is wrapper function of 
mail(). See mail() for details. 
to is mail addresses send to. Multiple recipients can be specified by 
putting a comma between each address in to. This parameter is not 
automatically encoded. 
subject is subject of mail. 
message is mail message. 
additional_headers is inserted at the end of the header. This is typically 
used to add extra headers. Multiple extra headers are separated with a 
newline ("\n"). 
additional_parameter is a MTA command line parameter. It is useful when 
setting the correct Return-Path header when using sendmail. 
Returns TRUE on success or FALSE on failure. 
See also mail(), mb_encode_mimeheader(), and mb_language().   mb_regex_set_optionsUpmb_split
mb_split
(4.2.0 - 4.3.2 only)
mb_split -- Split multibyte string using regular expression
Description
array mb_split ( string pattern, string string [, int limit])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

mb_split() split multibyte string using regular expression pattern and 
returns the result as an array. 
If optional parameter limit is specified, it will be split in limit 
elements as maximum. 
The internal encoding or the character encoding specified in 
mb_regex_encoding() will be used as character encoding. 
Note: This function is supported in PHP 4.2.0 or higher. 
See also: mb_regex_encoding(), mb_ereg().   mb_send_mailUpmb_strcut
#

#T=bool mb_send_mail ( string to, string subject, string message [, string 
mb_send_mail ( ^!string to, string subject, string message [, string ;
#

#T=mb_strcut - string mb_strcut ( string str, int start [, int length [, string 
(PHP 4 >= 4.0.6)
mb_strcut -- Get part of string
Description
string mb_strcut ( string str, int start [, int length [, string 
encoding]])
mb_strcut() returns the portion of str specified by the start and length 
parameters. 
mb_strcut() performs equivalent operation as mb_substr() with different 
method. If start position is multi-byte character's second byte or larger, 
it starts from first byte of multi-byte character. 
It subtracts string from str that is shorter than length AND character 
that is not part of multi-byte string or not being middle of shift 
sequence. 
encoding is character encoding. If it is not set, internal character 
encoding is used. 
See also mb_substr(), mb_internal_encoding().   mb_splitUpmb_strimwidth
#

#T=string mb_strcut ( string str, int start [, int length [, string 
mb_strcut ( ^!string str, int start [, int length [, string ;
#

#T=mb_strimwidth - string mb_strimwidth ( string str, int start, int width, string trimmarker 
(PHP 4 >= 4.0.6)
mb_strimwidth -- Get truncated string with specified width
Description
string mb_strimwidth ( string str, int start, int width, string trimmarker 
[, string encoding])
mb_strimwidth() truncates string str to specified width. It returns 
truncated string. 
If trimmarker is set, trimmarker is appended to return value. 
start is start position offset. Number of characters from the beginning of 
string. (First character is 0) 
trimmarker is string that is added to the end of string when string is 
truncated. 
encoding is character encoding. If it is omitted, internal encoding is 
used. 
Example 1. mb_strimwidth() example
  <?php
  $str = mb_strimwidth($str, 0, 40, "..>");
  ?> 
See also mb_strwidth() and mb_internal_encoding().   mb_strcutUpmb_strlen
#

#T=string mb_strimwidth ( string str, int start, int width, string trimmarker 
mb_strimwidth ( ^!string str, int start, int width, string trimmarker ;
#

#T=mb_strlen - string mb_strlen ( string str [, string encoding])
(PHP 4 >= 4.0.6)
mb_strlen -- Get string length
Description
string mb_strlen ( string str [, string encoding])
mb_strlen() returns number of characters in string str having character 
encoding encoding. A multi-byte character is counted as 1. 
encoding is character encoding for str. If encoding is omitted, internal 
character encoding is used. 
See also mb_internal_encoding(), strlen().   mb_strimwidthUpmb_strpos
#

#T=string mb_strlen ( string str [, string encoding])
mb_strlen ( ^!string str [, string encoding]);
#

#T=mb_strpos - int mb_strpos ( string haystack, string needle [, int offset [, string 
(PHP 4 >= 4.0.6)
mb_strpos --  Find position of first occurrence of string in a string 
Description
int mb_strpos ( string haystack, string needle [, int offset [, string 
encoding]])
mb_strpos() returns the numeric position of the first occurrence of needle 
in the haystack string. If needle is not found, it returns FALSE. 
mb_strpos() performs multi-byte safe strpos() operation based on number of 
characters. needle position is counted from the beginning of the haystack. 
First character's position is 0. Second character position is 1, and so 
on. 
If encoding is omitted, internal character encoding is used. mb_strrpos() 
accepts string for needle where strrpos() accepts only character. 
offset is search offset. If it is not specified, 0 is used. 
encoding is character encoding name. If it is omitted, internal character 
encoding is used. 
See also mb_strpos(), mb_internal_encoding(), strpos()   mb_strlenUpmb_strrpos
#

#T=int mb_strpos ( string haystack, string needle [, int offset [, string 
mb_strpos ( ^!string haystack, string needle [, int offset [, string ;
#

#T=mb_strrpos - int mb_strrpos ( string haystack, string needle [, string encoding])
(PHP 4 >= 4.0.6)
mb_strrpos --  Find position of last occurrence of a string in a string 
Description
int mb_strrpos ( string haystack, string needle [, string encoding])
mb_strrpos() returns the numeric position of the last occurrence of needle 
in the haystack string. If needle is not found, it returns FALSE. 
mb_strrpos() performs multi-byte safe strrpos() operation based on number 
of characters. needle position is counted from the beginning of haystack. 
First character's position is 0. Second character position is 1. 
If encoding is omitted, internal encoding is assumed. mb_strrpos() accepts 
string for needle where strrpos() accepts only character. 
encoding is character encoding. If it is not specified, internal character 
encoding is used. 
See also mb_strpos(), mb_internal_encoding(), strrpos().   mb_strposUpmb_strtolower
#

#T=int mb_strrpos ( string haystack, string needle [, string encoding])
mb_strrpos ( ^!string haystack, string needle [, string encoding]);
#

#T=mb_strtolower - string mb_strtolower ( string str [, string encoding])
(PHP 4 >= 4.3.0)
mb_strtolower -- Make a string lowercase
Description
string mb_strtolower ( string str [, string encoding])
mb_strtolower() returns str with all alphabetic characters converted to 
lowercase. 
encoding specifies the encoding of str; if omitted, the internal character 
encoding value will be used. 
For more information about the Unicode properties, please see 
http://www.unicode.org/unicode/reports/tr21/. 
By contrast to strtolower(), 'alphabetic' is determined by the Unicode 
character properties. Thus the behaviour of this function is not affected 
by locale settings and it can convert any characters that have 
'alphabetic' property, such as A-umlaut (). 
Example 1. mb_strtolower() example
  <?php
  $str = "Mary Had A Little Lamb and She LOVED It So";
  $str = mb_strtolower($str);
  echo $str; // Prints mary had a little lamb and she loved it 
so
  ?> 
See also strtolower(), mb_strtoupper() and mb_convert_case().   mb_strrposUpmb_strtoupper
#

#T=string mb_strtolower ( string str [, string encoding])
mb_strtolower ( ^!string str [, string encoding]);
#

#T=mb_strtoupper - string mb_strtoupper ( string str [, string encoding])
(PHP 4 >= 4.3.0)
mb_strtoupper -- Make a string uppercase
Description
string mb_strtoupper ( string str [, string encoding])
mb_strtoupper() returns str with all alphabetic characters converted to 
uppercase. 
encoding specifies the encoding of str; if omitted, the internal character 
encoding value will be used. 
By contrast to strtoupper(), 'alphabetic' is determined by the Unicode 
character properties. Thus the behaviour of this function is not affected 
by locale settings and it can convert any characters that have 
'alphabetic' property, such as a-umlaut (). 
For more information about the Unicode properties, please see 
http://www.unicode.org/unicode/reports/tr21/. 
Example 1. mb_strtoupper() example
  <?php
  $str = "Mary Had A Little Lamb and She LOVED It So";
  $str = mb_strtoupper($str);
  echo $str; // Prints MARY HAD A LITTLE LAMB AND SHE LOVED IT 
SO
  ?> 
See also strtoupper(), mb_strtolower() and mb_convert_case().   mb_strtolowerUpmb_strwidth
#

#T=string mb_strtoupper ( string str [, string encoding])
mb_strtoupper ( ^!string str [, string encoding]);
#

#T=mb_strwidth - int mb_strwidth ( string str [, string encoding])
(PHP 4 >= 4.0.6)
mb_strwidth -- Return width of string
Description
int mb_strwidth ( string str [, string encoding])
mb_strwidth() returns width of string str. 
Multi-byte character usually twice of width compare to single byte 
character. 
Table 1. Characters width
CharsWidth
U+0000 - U+00190
U+0020 - U+1FFF1
U+2000 - U+FF602
U+FF61 - U+FF9F1
U+FFA0 - 2

encoding is character encoding. If it is omitted, internal encoding is 
used. 
See also: mb_strimwidth(), mb_internal_encoding().   mb_strtoupperUpmb_substitute_character
#

#T=int mb_strwidth ( string str [, string encoding])
mb_strwidth ( ^!string str [, string encoding]);
#

#T=mb_substitute_character - mixed mb_substitute_character ( [mixed substrchar])
(PHP 4 >= 4.0.6)
mb_substitute_character -- Set/Get substitution character
Description
mixed mb_substitute_character ( [mixed substrchar])
mb_substitute_character() specifies substitution character when input 
character encoding is invalid or character code is not exist in output 
character encoding. Invalid characters may be substituted NULL(no output), 
string or integer value (Unicode character code value). 
This setting affects mb_detect_encoding() and mb_send_mail(). 
substchar : Specify Unicode value as integer or specify as string as 
follows 
"none" : no output 
"long" : Output character code value (Example: U+3000,JIS+7E7E) 
Return Value: If substchar is set, it returns TRUE for success, otherwise 
returns FALSE. If substchar is not set, it returns Unicode value or 
"none"/"long". 
Example 1. mb_substitute_character() example
  <?php
  /* Set with Unicode U+3013 (GETA MARK) */
  mb_substitute_character(0x3013);

  /* Set hex format */
  mb_substitute_character("long");

  /* Display current setting */
  echo mb_substitute_character();
  ?> 

  mb_strwidthUpmb_substr_count
#

#T=mixed mb_substitute_character ( [mixed substrchar])
mb_substitute_character ( ^![mixed substrchar]);
#

#T=mb_substr_count - int mb_substr_count ( string haystack, string needle [, string encoding])
(PHP 4 >= 4.3.0)
mb_substr_count -- Count the number of substring occurrences
Description
int mb_substr_count ( string haystack, string needle [, string encoding])
mb_substr_count() returns the number of times the needle substring occurs 
in the haystack string. 
encoding specifies the encoding for needle and haystack. If omitted, 
internal character encoding is used. 
Example 1. mb_substr_count() example
  <?php
  echo mb_substr_count("This is a test", "is"); // prints out 2
  ?> 
See also substr_count(), mb_strpos(), mb_substr().   mb_substitute_characterUpmb_substr
#

#T=int mb_substr_count ( string haystack, string needle [, string encoding])
mb_substr_count ( ^!string haystack, string needle [, string encoding]);
#

#T=mb_substr - string mb_substr ( string str, int start [, int length [, string 
(PHP 4 >= 4.0.6)
mb_substr -- Get part of string
Description
string mb_substr ( string str, int start [, int length [, string 
encoding]])
mb_substr() returns the portion of str specified by the start and length 
parameters. 
mb_substr() performs multi-byte safe substr() operation based on number of 
characters. Position is counted from the beginning of str. First 
character's position is 0. Second character position is 1, and so on. 
If encoding is omitted, internal encoding is assumed. 
encoding is character encoding. If it is omitted, internal character 
encoding is used. 
See also mb_strcut(), mb_internal_encoding().   mb_substr_countUpMCAL functions
#

#T=string mb_substr ( string str, int start [, int length [, string 
mb_substr ( ^!string str, int start [, int length [, string ;
#

#T=mcal_append_event - int mcal_append_event ( int mcal_stream)
(PHP 4 )
mcal_append_event -- Store a new event into an MCAL calendar
Description
int mcal_append_event ( int mcal_stream)
mcal_append_event() stores the global event into an MCAL calendar for the 
stream mcal_stream. 
Returns the id of the newly inserted event.   MCAL functionsUpmcal_close
#

#T=int mcal_append_event ( int mcal_stream)
mcal_append_event ( ^!int mcal_stream);
#

#T=mcal_close - int mcal_close ( int mcal_stream, int flags)
(PHP 3>= 3.0.13, PHP 4 )
mcal_close -- Close an MCAL stream
Description
int mcal_close ( int mcal_stream, int flags)
Closes the given mcal stream.   mcal_append_eventUpmcal_create_calendar
#

#T=int mcal_close ( int mcal_stream, int flags)
mcal_close ( ^!int mcal_stream, int flags);
#

#T=mcal_create_calendar - bool mcal_create_calendar ( int stream, string calendar)
(PHP 3>= 3.0.13, PHP 4 )
mcal_create_calendar -- Create a new MCAL calendar 
Description
bool mcal_create_calendar ( int stream, string calendar)
Creates a new calendar named calendar.   mcal_closeUpmcal_date_compare
#

#T=bool mcal_create_calendar ( int stream, string calendar)
mcal_create_calendar ( ^!int stream, string calendar);
#

#T=mcal_date_compare - int mcal_date_compare ( int a_year, int a_month, int a_day, int b_year, 
(PHP 3>= 3.0.13, PHP 4 )
mcal_date_compare -- Compares two dates
Description
int mcal_date_compare ( int a_year, int a_month, int a_day, int b_year, 
int b_month, int b_day)
mcal_date_compare() Compares the two given dates, returns <0, 0, >0 if 
a<b, a==b, a>b respectively.   mcal_create_calendarUpmcal_date_valid
#

#T=int mcal_date_compare ( int a_year, int a_month, int a_day, int b_year, 
mcal_date_compare ( ^!int a_year, int a_month, int a_day, int b_year, ;
#

#T=mcal_date_valid - int mcal_date_valid ( int year, int month, int day)
(PHP 3>= 3.0.13, PHP 4 )
mcal_date_valid --  Returns TRUE if the given year, month, day is a valid 
date 
Description
int mcal_date_valid ( int year, int month, int day)
mcal_date_valid() Returns TRUE if the given year, month and day is a valid 
date, FALSE if not.   mcal_date_compareUpmcal_day_of_week
#

#T=int mcal_date_valid ( int year, int month, int day)
mcal_date_valid ( ^!int year, int month, int day);
#

#T=mcal_day_of_week - int mcal_day_of_week ( int year, int month, int day)
(PHP 3>= 3.0.13, PHP 4 )
mcal_day_of_week --  Returns the day of the week of the given date 
Description
int mcal_day_of_week ( int year, int month, int day)
mcal_day_of_week() returns the day of the week of the given date. Possible 
return values range from 0 for Sunday through 6 for Saturday.   mcal_date_validUpmcal_day_of_year
#

#T=int mcal_day_of_week ( int year, int month, int day)
mcal_day_of_week ( ^!int year, int month, int day);
#

#T=mcal_day_of_year - int mcal_day_of_year ( int year, int month, int day)
(PHP 3>= 3.0.13, PHP 4 )
mcal_day_of_year --  Returns the day of the year of the given date 
Description
int mcal_day_of_year ( int year, int month, int day)
mcal_day_of_year() returns the day of the year of the given date.   mcal_day_of_weekUpmcal_days_in_month
#

#T=int mcal_day_of_year ( int year, int month, int day)
mcal_day_of_year ( ^!int year, int month, int day);
#

#T=mcal_days_in_month - int mcal_days_in_month ( int month, int leap_year)
(PHP 3>= 3.0.13, PHP 4 )
mcal_days_in_month --  Returns the number of days in a month 
Description
int mcal_days_in_month ( int month, int leap_year)
mcal_days_in_month() returns the number of days in the month month, taking 
into account if the considered year is a leap year or not.   mcal_day_of_yearUpmcal_delete_calendar
#

#T=int mcal_days_in_month ( int month, int leap_year)
mcal_days_in_month ( ^!int month, int leap_year);
#

#T=mcal_delete_calendar - string mcal_delete_calendar ( int stream, string calendar)
(PHP 3>= 3.0.13, PHP 4 )
mcal_delete_calendar -- Delete an MCAL calendar
Description
string mcal_delete_calendar ( int stream, string calendar)
Deletes the calendar named calendar.   mcal_days_in_monthUpmcal_delete_event
#

#T=string mcal_delete_calendar ( int stream, string calendar)
mcal_delete_calendar ( ^!int stream, string calendar);
#

#T=mcal_delete_event - int mcal_delete_event ( int mcal_stream [, int event_id])
(PHP 3>= 3.0.13, PHP 4 )
mcal_delete_event -- Delete an event from an MCAL calendar
Description
int mcal_delete_event ( int mcal_stream [, int event_id])
mcal_delete_event() deletes the calendar event specified by the event_id.
Returns TRUE.   mcal_delete_calendarUpmcal_event_add_attribute
#

#T=int mcal_delete_event ( int mcal_stream [, int event_id])
mcal_delete_event ( ^!int mcal_stream [, int event_id]);
#

#T=mcal_event_add_attribute - void mcal_event_add_attribute ( int stream, string attribute, string 
(PHP 3>= 3.0.15, PHP 4 )
mcal_event_add_attribute --  Adds an attribute and a value to the streams 
global event structure 
Description
void mcal_event_add_attribute ( int stream, string attribute, string 
value)
mcal_event_add_attribute() adds an attribute to the stream's global event 
structure with the value given by "value".   mcal_delete_eventUpmcal_event_init
#

#T=void mcal_event_add_attribute ( int stream, string attribute, string 
mcal_event_add_attribute ( ^!int stream, string attribute, string ;
#

#T=mcal_event_init - int mcal_event_init ( int stream)
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_init --  Initializes a streams global event structure 
Description
int mcal_event_init ( int stream)
mcal_event_init() initializes a streams global event structure. this 
effectively sets all elements of the structure to 0, or the default 
settings. 
Returns TRUE.   mcal_event_add_attributeUpmcal_event_set_alarm
#

#T=int mcal_event_init ( int stream)
mcal_event_init ( ^!int stream);
#

#T=mcal_event_set_alarm - int mcal_event_set_alarm ( int stream, int alarm)
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_alarm --  Sets the alarm of the streams global event 
structure 
Description
int mcal_event_set_alarm ( int stream, int alarm)
mcal_event_set_alarm() sets the streams global event structure's alarm to 
the given minutes before the event. 
Returns TRUE.   mcal_event_initUpmcal_event_set_category
#

#T=int mcal_event_set_alarm ( int stream, int alarm)
mcal_event_set_alarm ( ^!int stream, int alarm);
#

#T=mcal_event_set_category - int mcal_event_set_category ( int stream, string category)
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_category --  Sets the category of the streams global event 
structure 
Description
int mcal_event_set_category ( int stream, string category)
mcal_event_set_category() sets the streams global event structure's 
category to the given string. 
Returns TRUE.   mcal_event_set_alarmUpmcal_event_set_class
#

#T=int mcal_event_set_category ( int stream, string category)
mcal_event_set_category ( ^!int stream, string category);
#

#T=mcal_event_set_class - int mcal_event_set_class ( int stream, int class)
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_class --  Sets the class of the streams global event 
structure 
Description
int mcal_event_set_class ( int stream, int class)
mcal_event_set_class() sets the streams global event structure's class to 
the given value. The class is either 1 for public, or 0 for private. 
Returns TRUE.   mcal_event_set_categoryUpmcal_event_set_description
#

#T=int mcal_event_set_class ( int stream, int class)
mcal_event_set_class ( ^!int stream, int class);
#

#T=mcal_event_set_description - HP 4 )
mcal_event_set_de
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_description --  Sets the description of the streams global 
event structure 
Description
int mcal_event_set_description ( int stream, string description)
mcal_event_set_description() sets the streams global event structure's 
description to the given string. 
Returns TRUE.   mcal_event_set_classUpmcal_event_set_end
#

#T=
(PHP 3>= 3.0.13, 

PHP 3^!>= 3.0.13, ;
#

#T=mcal_event_set_end - int mcal_event_set_end ( int stream, int year, int month [, int day [, int 
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_end --  Sets the end date and time of the streams global 
event structure 
Description
int mcal_event_set_end ( int stream, int year, int month [, int day [, int 
hour [, int min [, int sec]]]])
mcal_event_set_end() sets the streams global event structure's end date 
and time to the given values. 
Returns TRUE.   mcal_event_set_descriptionUpmcal_event_set_recur_daily
#

#T=int mcal_event_set_end ( int stream, int year, int month [, int day [, int 
mcal_event_set_end ( ^!int stream, int year, int month [, int day [, int ;
#

#T=mcal_event_set_recur_daily - int mcal_event_set_recur_daily ( int stream, int year, int month, int day, 
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_recur_daily --  Sets the recurrence of the streams global 
event structure 
Description
int mcal_event_set_recur_daily ( int stream, int year, int month, int day, 
int interval)
mcal_event_set_recur_daily() sets the streams global event structure's 
recurrence to the given value to be reoccurring on a daily basis, ending 
at the given date.   mcal_event_set_endUpmcal_event_set_recur_monthly_mday
#

#T=int mcal_event_set_recur_daily ( int stream, int year, int month, int day, 
mcal_event_set_recur_daily ( ^!int stream, int year, int month, int day, ;
#

#T=mcal_event_set_recur_monthly_mday - int mcal_event_set_recur_monthly_mday ( int stream, int year, int month, 
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_recur_monthly_mday --  Sets the recurrence of the streams 
global event structure 
Description
int mcal_event_set_recur_monthly_mday ( int stream, int year, int month, 
int day, int interval)
mcal_event_set_recur_monthly_mday() sets the streams global event 
structure's recurrence to the given value to be reoccurring on a monthly 
by month day basis, ending at the given date.   mcal_event_set_recur_dailyUpmcal_event_set_recur_monthly_wday
#

#T=int mcal_event_set_recur_monthly_mday ( int stream, int year, int month, 
mcal_event_set_recur_monthly_mday ( ^!int stream, int year, int month, ;
#

#T=mcal_event_set_recur_monthly_wday - int mcal_event_set_recur_monthly_wday ( int stream, int year, int month, 
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_recur_monthly_wday --  Sets the recurrence of the streams 
global event structure 
Description
int mcal_event_set_recur_monthly_wday ( int stream, int year, int month, 
int day, int interval)
mcal_event_set_recur_monthly_wday() sets the streams global event 
structure's recurrence to the given value to be reoccurring on a monthly 
by week basis, ending at the given date.   mcal_event_set_recur_monthly_mdayUpmcal_event_set_recur_none
#

#T=int mcal_event_set_recur_monthly_wday ( int stream, int year, int month, 
mcal_event_set_recur_monthly_wday ( ^!int stream, int year, int month, ;
#

#T=mcal_event_set_recur_none - int mcal_event_set_recur_none ( int stream)
(PHP 3>= 3.0.15, PHP 4 )
mcal_event_set_recur_none --  Sets the recurrence of the streams global 
event structure 
Description
int mcal_event_set_recur_none ( int stream)
mcal_event_set_recur_none() sets the streams global event structure to not 
recur (event->recur_type is set to MCAL_RECUR_NONE).   mcal_event_set_recur_monthly_wdayUpmcal_event_set_recur_weekly
#

#T=int mcal_event_set_recur_none ( int stream)
mcal_event_set_recur_none ( ^!int stream);
#

#T=mcal_event_set_recur_weekly - int mcal_event_set_recur_weekly ( int stream, int year, int month, int 
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_recur_weekly --  Sets the recurrence of the streams global 
event structure 
Description
int mcal_event_set_recur_weekly ( int stream, int year, int month, int 
day, int interval, int weekdays)
mcal_event_set_recur_weekly() sets the streams global event structure's 
recurrence to the given value to be reoccurring on a weekly basis, ending 
at the given date.   mcal_event_set_recur_noneUpmcal_event_set_recur_yearly
#

#T=int mcal_event_set_recur_weekly ( int stream, int year, int month, int 
mcal_event_set_recur_weekly ( ^!int stream, int year, int month, int ;
#

#T=mcal_event_set_recur_yearly - int mcal_event_set_recur_yearly ( int stream, int year, int month, int 
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_recur_yearly --  Sets the recurrence of the streams global 
event structure 
Description
int mcal_event_set_recur_yearly ( int stream, int year, int month, int 
day, int interval)
mcal_event_set_recur_yearly() sets the streams global event structure's 
recurrence to the given value to be reoccurring on a yearly basis,ending 
at the given date.   mcal_event_set_recur_weeklyUpmcal_event_set_start
#

#T=int mcal_event_set_recur_yearly ( int stream, int year, int month, int 
mcal_event_set_recur_yearly ( ^!int stream, int year, int month, int ;
#

#T=mcal_event_set_start - int mcal_event_set_start ( int stream, int year, int month [, int day [, 
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_start --  Sets the start date and time of the streams 
global event structure 
Description
int mcal_event_set_start ( int stream, int year, int month [, int day [, 
int hour [, int min [, int sec]]]])
mcal_event_set_start() sets the streams global event structure's start 
date and time to the given values. 
Returns TRUE.   mcal_event_set_recur_yearlyUpmcal_event_set_title
#

#T=int mcal_event_set_start ( int stream, int year, int month [, int day [, 
mcal_event_set_start ( ^!int stream, int year, int month [, int day [, ;
#

#T=mcal_event_set_title - int mcal_event_set_title ( int stream, string title)
(PHP 3>= 3.0.13, PHP 4 )
mcal_event_set_title --  Sets the title of the streams global event 
structure 
Description
int mcal_event_set_title ( int stream, string title)
mcal_event_set_title() sets the streams global event structure's title to 
the given string. 
Returns TRUE.   mcal_event_set_startUpmcal_expunge
mcal_expunge
(no version information, might be only in CVS)
mcal_expunge --  Deletes all events marked for being expunged. 
Description
int mcal_expunge ( int stream)
mcal_expunge() deletes all events which have been previously marked for 
deletion.   mcal_event_set_titleUpmcal_fetch_current_stream_event
#

#T=int mcal_event_set_title ( int stream, string title)
mcal_event_set_title ( ^!int stream, string title);
#

#T=mcal_fetch_current_stream_event - object mcal_fetch_current_stream_event ( int stream)
(PHP 3>= 3.0.13, PHP 4 )
mcal_fetch_current_stream_event --  Returns an object containing the 
current streams event structure 
Description
object mcal_fetch_current_stream_event ( int stream)
mcal_fetch_current_stream_event() returns the current stream's event 
structure as an object containing: 
int id - ID of that event.
int public - TRUE if the event if public, FALSE if it is private.
string category - Category string of the event.
string title - Title string of the event.
string description - Description string of the event.
int alarm - number of minutes before the event to send an 
alarm/reminder.
object start - Object containing a datetime entry.
object end - Object containing a datetime entry.
int recur_type - recurrence type
int recur_interval - recurrence interval
datetime recur_enddate - recurrence end date
int recur_data - recurrence data
All datetime entries consist of an object that contains: 
int year - year
int month - month
int mday - day of month
int hour - hour
int min - minutes
int sec - seconds
int alarm - minutes before event to send an alarm  mcal_expungeUpmcal_fetch_event
#

#T=object mcal_fetch_current_stream_event ( int stream)
mcal_fetch_current_stream_event ( ^!int stream);
#

#T=mcal_fetch_event - object mcal_fetch_event ( int mcal_stream, int event_id [, int options])
(PHP 3>= 3.0.13, PHP 4 )
mcal_fetch_event --  Fetches an event from the calendar stream 
Description
object mcal_fetch_event ( int mcal_stream, int event_id [, int options])
mcal_fetch_event() fetches an event from the calendar stream specified by 
id. 
Returns an event object consisting of: 
int id - ID of that event.
int public - TRUE if the event if public, FALSE if it is private.
string category - Category string of the event.
string title - Title string of the event.
string description - Description string of the event.
int alarm - number of minutes before the event to send an 
alarm/reminder.
object start - Object containing a datetime entry.
object end - Object containing a datetime entry.
int recur_type - recurrence type
int recur_interval - recurrence interval
datetime recur_enddate - recurrence end date
int recur_data - recurrence data
All datetime entries consist of an object that contains: 
int year - year
int month - month
int mday - day of month
int hour - hour
int min - minutes
int sec - seconds
int alarm - minutes before event to send an alarm
The possible values for recur_type are: 
0 - Indicates that this event does not recur
1 - This event recurs daily
2 - This event recurs on a weekly basis
3 - This event recurs monthly on a specific day of the month (e.g. the 
10th of the month)
4 - This event recurs monthly on a sequenced day of the week (e.g. the 
3rd Saturday) 
5 - This event recurs on an annual basis  mcal_fetch_current_stream_eventUpmcal_is_leap_year
#

#T=object mcal_fetch_event ( int mcal_stream, int event_id [, int options])
mcal_fetch_event ( ^!int mcal_stream, int event_id [, int options]);
#

#T=mcal_is_leap_year - int mcal_is_leap_year ( int year)
(PHP 3>= 3.0.13, PHP 4 )
mcal_is_leap_year --  Returns if the given year is a leap year or not 
Description
int mcal_is_leap_year ( int year)
mcal_is_leap_year() returns 1 if the given year is a leap year, 0 if not.   mcal_fetch_eventUpmcal_list_alarms
#

#T=int mcal_is_leap_year ( int year)
mcal_is_leap_year ( ^!int year);
#

#T=mcal_list_alarms - array mcal_list_alarms ( int mcal_stream [, int begin_year [, int 
(PHP 3>= 3.0.13, PHP 4 )
mcal_list_alarms --  Return a list of events that has an alarm triggered 
at the given datetime 
Description
array mcal_list_alarms ( int mcal_stream [, int begin_year [, int 
begin_month [, int begin_day [, int end_year [, int end_month [, int 
end_day]]]]]])
Returns an array of event ID's that has an alarm going off between the 
start and end dates, or if just a stream is given, uses the start and end 
dates in the global event structure. 
mcal_list_events() function takes in an optional beginning date and an end 
date for a calendar stream. An array of event id's that are between the 
given dates or the internal event dates are returned.   mcal_is_leap_yearUpmcal_list_events
#

#T=array mcal_list_alarms ( int mcal_stream [, int begin_year [, int 
mcal_list_alarms ( ^!int mcal_stream [, int begin_year [, int ;
#

#T=mcal_list_events - array mcal_list_events ( int mcal_stream, object begin_date [, object 
(PHP 3>= 3.0.13, PHP 4 )
mcal_list_events --  Return a list of IDs for a date or a range of dates 
Description
array mcal_list_events ( int mcal_stream, object begin_date [, object 
end_date])
Returns an array of ID's that are between the start and end dates, or if 
just a stream is given, uses the start and end dates in the global event 
structure. 
mcal_list_events() takes in an beginning date and an optional end date for 
a calendar stream. An array of event id's that are between the given dates 
or the internal event dates are returned.   mcal_list_alarmsUpmcal_next_recurrence
#

#T=array mcal_list_events ( int mcal_stream, object begin_date [, object 
mcal_list_events ( ^!int mcal_stream, object begin_date [, object ;
#

#T=mcal_next_recurrence - int mcal_next_recurrence ( int stream, int weekstart, array next)
(PHP 3>= 3.0.13, PHP 4 )
mcal_next_recurrence -- Returns the next recurrence of the event
Description
int mcal_next_recurrence ( int stream, int weekstart, array next)
mcal_next_recurrence() returns an object filled with the next date the 
event occurs, on or after the supplied date. Returns empty date field if 
event does not occur or something is invalid. Uses weekstart to determine 
what day is considered the beginning of the week.   mcal_list_eventsUpmcal_open
#

#T=int mcal_next_recurrence ( int stream, int weekstart, array next)
mcal_next_recurrence ( ^!int stream, int weekstart, array next);
#

#T=mcal_open - int mcal_open ( string calendar, string username, string password [, int 
(PHP 3>= 3.0.13, PHP 4 )
mcal_open -- Opens up an MCAL connection
Description
int mcal_open ( string calendar, string username, string password [, int 
options])
Returns an MCAL stream on success, FALSE on error. 
mcal_open() opens up an MCAL connection to the specified calendar store. 
If the optional options is specified, passes the options to that mailbox 
also. The streams internal event structure is also initialized upon 
connection.   mcal_next_recurrenceUpmcal_popen
#

#T=int mcal_open ( string calendar, string username, string password [, int 
mcal_open ( ^!string calendar, string username, string password [, int ;
#

#T=mcal_popen - int mcal_popen ( string calendar, string username, string password [, int 
(PHP 3>= 3.0.13, PHP 4 )
mcal_popen -- Opens up a persistent MCAL connection
Description
int mcal_popen ( string calendar, string username, string password [, int 
options])
Returns an MCAL stream on success, FALSE on error. 
mcal_popen() opens up an MCAL connection to the specified calendar store. 
If the optional options is specified, passes the options to that mailbox 
also. The streams internal event structure is also initialized upon 
connection.   mcal_openUpmcal_rename_calendar
#

#T=int mcal_popen ( string calendar, string username, string password [, int 
mcal_popen ( ^!string calendar, string username, string password [, int ;
#

#T=mcal_rename_calendar - string mcal_rename_calendar ( int stream, string old_name, string 
(PHP 3>= 3.0.13, PHP 4 )
mcal_rename_calendar -- Rename an MCAL calendar 
Description
string mcal_rename_calendar ( int stream, string old_name, string 
new_name)
Renames the calendar old_name to new_name.   mcal_popenUpmcal_reopen
#

#T=string mcal_rename_calendar ( int stream, string old_name, string 
mcal_rename_calendar ( ^!int stream, string old_name, string ;
#

#T=mcal_reopen - int mcal_reopen ( string calendar [, int options])
(PHP 3>= 3.0.13, PHP 4 )
mcal_reopen -- Reopens an MCAL connection
Description
int mcal_reopen ( string calendar [, int options])
Reopens an MCAL stream to a new calendar. 
mcal_reopen() reopens an MCAL connection to the specified calendar store. 
If the optional options is specified, passes the options to that mailbox 
also.   mcal_rename_calendarUpmcal_snooze
#

#T=int mcal_reopen ( string calendar [, int options])
mcal_reopen ( ^!string calendar [, int options]);
#

#T=mcal_snooze - bool mcal_snooze ( int stream_id, int event_id)
(PHP 3>= 3.0.13, PHP 4 )
mcal_snooze -- Turn off an alarm for an event
Description
bool mcal_snooze ( int stream_id, int event_id)
mcal_snooze() turns off an alarm for a calendar event specified by the 
stream_id and event_id. 
Returns TRUE on success or FALSE on failure.   mcal_reopenUpmcal_store_event
#

#T=bool mcal_snooze ( int stream_id, int event_id)
mcal_snooze ( ^!int stream_id, int event_id);
#

#T=mcal_store_event - int mcal_store_event ( int mcal_stream)
(PHP 3>= 3.0.13, PHP 4 )
mcal_store_event -- Modify an existing event in an MCAL calendar
Description
int mcal_store_event ( int mcal_stream)
mcal_store_event() stores the modifications to the current global event 
for the given stream. 
Returns the event id of the modified event on success and FALSE on error.   mcal_snoozeUpmcal_time_valid
#

#T=int mcal_store_event ( int mcal_stream)
mcal_store_event ( ^!int mcal_stream);
#

#T=mcal_time_valid - int mcal_time_valid ( int hour, int minutes, int seconds)
(PHP 3>= 3.0.13, PHP 4 )
mcal_time_valid --  Returns TRUE if the given year, month, day is a valid 
time 
Description
int mcal_time_valid ( int hour, int minutes, int seconds)
mcal_time_valid() Returns TRUE if the given hour, minutes and seconds is a 
valid time, FALSE if not.   mcal_store_eventUpmcal_week_of_year
#

#T=int mcal_time_valid ( int hour, int minutes, int seconds)
mcal_time_valid ( ^!int hour, int minutes, int seconds);
#

#T=mcal_week_of_year - int mcal_week_of_year ( int day, int month, int year)
(PHP 4 )
mcal_week_of_year --  Returns the week number of the given date 
Description
int mcal_week_of_year ( int day, int month, int year)
Warning
This function is currently not documented; only the argument list is 
available.
  mcal_time_validUpMcrypt Encryption Functions
#

#T=int mcal_week_of_year ( int day, int month, int year)
mcal_week_of_year ( ^!int day, int month, int year);
#

#T=mcrypt_cbc - string mcrypt_cbc ( int cipher, string key, string data, int mode [, 
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_cbc -- Encrypt/decrypt data in CBC mode
Description
string mcrypt_cbc ( int cipher, string key, string data, int mode [, 
string iv])

string mcrypt_cbc ( string cipher, string key, string data, int mode [, 
string iv])
The first prototype is when linked against libmcrypt 2.2.x, the second 
when linked against libmcrypt 2.4.x or higher. The mode should be either 
MCRYPT_ENCRYPT or MCRYPT_DECRYPT. 
This function should not be used anymore, see mcrypt_generic() and 
mdecrypt_generic() for replacements.   Mcrypt Encryption FunctionsUpmcrypt_cfb
#

#T=string mcrypt_cbc ( int cipher, string key, string data, int mode [, 
mcrypt_cbc ( ^!int cipher, string key, string data, int mode [, ;
#

#T=mcrypt_cfb - string mcrypt_cfb ( int cipher, string key, string data, int mode, string 
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_cfb -- Encrypt/decrypt data in CFB mode
Description
string mcrypt_cfb ( int cipher, string key, string data, int mode, string 
iv)

string mcrypt_cfb ( string cipher, string key, string data, int mode [, 
string iv])
The first prototype is when linked against libmcrypt 2.2.x, the second 
when linked against libmcrypt 2.4.x or higher. The mode should be either 
MCRYPT_ENCRYPT or MCRYPT_DECRYPT. 
This function should not be used anymore, see mcrypt_generic() and 
mdecrypt_generic() for replacements.   mcrypt_cbcUpmcrypt_create_iv
#

#T=string mcrypt_cfb ( int cipher, string key, string data, int mode, string 
mcrypt_cfb ( ^!int cipher, string key, string data, int mode, string ;
#

#T=mcrypt_create_iv - string mcrypt_create_iv ( int size, int source)
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_create_iv --  Create an initialization vector (IV) from a random 
source 
Description
string mcrypt_create_iv ( int size, int source)
mcrypt_create_iv() is used to create an IV. 
mcrypt_create_iv() takes two arguments, size determines the size of the 
IV, source specifies the source of the IV. 
The source can be MCRYPT_RAND (system random number generator), 
MCRYPT_DEV_RANDOM (read data from /dev/random) and MCRYPT_DEV_URANDOM 
(read data from /dev/urandom). If you use MCRYPT_RAND, make sure to call 
srand() before to initialize the random number generator. 
Example 1. mcrypt_create_iv() example
  <?php
      $size = mcrypt_get_iv_size(MCRYPT_CAST_256, 
  MCRYPT_MODE_CFB);
      $iv = mcrypt_create_iv($size, MCRYPT_DEV_RANDOM);
  ?> 
The IV is only meant to give an alternative seed to the encryption 
routines. This IV does not need to be secret at all, though it can be 
desirable. You even can send it along with your ciphertext without loosing 
security. 
More information can be found at 
http://www.ciphersbyritter.com/GLOSSARY.HTM#IV, 
http://fn2.freenet.edmonton.ab.ca/~jsavard/crypto/co0409.htm and in 
chapter 9.3 of Applied Cryptography by Schneier (ISBN 0-471-11709-9) for a 
discussion of this topic.   mcrypt_cfbUpmcrypt_decrypt
#

#T=string mcrypt_create_iv ( int size, int source)
mcrypt_create_iv ( ^!int size, int source);
#

#T=mcrypt_decrypt - string mcrypt_decrypt ( string cipher, string key, string data, string 
(PHP 4 >= 4.0.2)
mcrypt_decrypt -- Decrypts crypttext with given parameters
Description
string mcrypt_decrypt ( string cipher, string key, string data, string 
mode [, string iv])
mcrypt_decrypt() decrypts the data and returns the unencrypted data. 
Cipher is one of the MCRYPT_ciphername constants of the name of the 
algorithm as string. 
Key is the key with which the data is encrypted. If it's smaller that the 
required keysize, it is padded with '\0'. 
Data is the data that will be decrypted with the given cipher and mode. If 
the size of the data is not n * blocksize, the data will be padded with 
'\0'. 
Mode is one of the MCRYPT_MODE_modename constants of one of "ecb", "cbc", 
"cfb", "ofb", "nofb" or "stream". 
The IV parameter is used for the initialisation in CBC, CFB, OFB modes, 
and in some algorithms in STREAM mode. If you do not supply an IV, while 
it is needed for an algorithm, the function issues a warning and uses an 
IV with all bytes set to '\0'.   mcrypt_create_ivUpmcrypt_ecb
#

#T=string mcrypt_decrypt ( string cipher, string key, string data, string 
mcrypt_decrypt ( ^!string cipher, string key, string data, string ;
#

#T=mcrypt_ecb - string mcrypt_ecb ( int cipher, string key, string data, int mode)
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_ecb -- Encrypt/decrypt data in ECB mode
Description
string mcrypt_ecb ( int cipher, string key, string data, int mode)

string mcrypt_ecb ( string cipher, string key, string data, int mode [, 
string iv])
The first prototype is when linked against libmcrypt 2.2.x, the second 
when linked against libmcrypt 2.4.x or higher. The mode should be either 
MCRYPT_ENCRYPT or MCRYPT_DECRYPT. 
This function should not be used anymore, see mcrypt_generic() and 
mdecrypt_generic() for replacements.   mcrypt_decryptUpmcrypt_enc_get_algorithms_name
#

#T=string mcrypt_ecb ( int cipher, string key, string data, int mode)
mcrypt_ecb ( ^!int cipher, string key, string data, int mode);
#

#T=mcrypt_enc_get_algorithms_name - string mcrypt_enc_get_algorithms_name ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_get_algorithms_name -- Returns the name of the opened algorithm
Description
string mcrypt_enc_get_algorithms_name ( resource td)
This function returns the name of the algorithm. 
Example 1. mcrypt_enc_get_algorithms_name() example
  <?php
      $td = mcrypt_module_open(MCRYPT_CAST_256, '', 
  MCRYPT_MODE_CFB, '');
      echo mcrypt_enc_get_algorithms_name($td). "\n";
    
      $td = mcrypt_module_open('cast-256', '', MCRYPT_MODE_CFB, 
  '');
      echo mcrypt_enc_get_algorithms_name($td). "\n";
  ?>

  Prints:
  CAST-256
  CAST-256 

  mcrypt_ecbUpmcrypt_enc_get_block_size
#

#T=string mcrypt_enc_get_algorithms_name ( resource td)
mcrypt_enc_get_algorithms_name ( ^!resource td);
#

#T=mcrypt_enc_get_block_size - int mcrypt_enc_get_block_size ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_get_block_size -- Returns the blocksize of the opened algorithm
Description
int mcrypt_enc_get_block_size ( resource td)
This function returns the block size of the algorithm specified by the 
encryption descriptor td in bytes.   mcrypt_enc_get_algorithms_nameUpmcrypt_enc_get_iv_size
#

#T=int mcrypt_enc_get_block_size ( resource td)
mcrypt_enc_get_block_size ( ^!resource td);
#

#T=mcrypt_enc_get_iv_size - int mcrypt_enc_get_iv_size ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_get_iv_size -- Returns the size of the IV of the opened 
algorithm
Description
int mcrypt_enc_get_iv_size ( resource td)
This function returns the size of the iv of the algorithm specified by the 
encryption descriptor in bytes. If it returns '0' then the IV is ignored 
in the algorithm. An IV is used in cbc, cfb and ofb modes, and in some 
algorithms in stream mode.   mcrypt_enc_get_block_sizeUpmcrypt_enc_get_key_size
#

#T=int mcrypt_enc_get_iv_size ( resource td)
mcrypt_enc_get_iv_size ( ^!resource td);
#

#T=mcrypt_enc_get_key_size - int mcrypt_enc_get_key_size ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_get_key_size -- Returns the maximum supported keysize of the 
opened mode
Description
int mcrypt_enc_get_key_size ( resource td)
This function returns the maximum supported key size of the algorithm 
specified by the encryption descriptor td in bytes.   mcrypt_enc_get_iv_sizeUpmcrypt_enc_get_modes_name
#

#T=int mcrypt_enc_get_key_size ( resource td)
mcrypt_enc_get_key_size ( ^!resource td);
#

#T=mcrypt_enc_get_modes_name - string mcrypt_enc_get_modes_name ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_get_modes_name -- Returns the name of the opened mode
Description
string mcrypt_enc_get_modes_name ( resource td)
This function returns the name of the mode. 
Example 1. mcrypt_enc_get_modes_name() example
  <?php
      $td = mcrypt_module_open (MCRYPT_CAST_256, '', 
  MCRYPT_MODE_CFB, '');
      echo mcrypt_enc_get_modes_name($td). "\n";
    
      $td = mcrypt_module_open ('cast-256', '', 'ecb', '');
      echo mcrypt_enc_get_modes_name($td). "\n";
  ?> 

Prints: 
CFB
ECB

  mcrypt_enc_get_key_sizeUpmcrypt_enc_get_supported_key_sizes
#

#T=string mcrypt_enc_get_modes_name ( resource td)
mcrypt_enc_get_modes_name ( ^!resource td);
#

#T=mcrypt_enc_get_supported_key_sizes - array mcrypt_enc_get_supported_key_sizes ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_get_supported_key_sizes -- Returns an array with the supported 
keysizes of the opened algorithm
Description
array mcrypt_enc_get_supported_key_sizes ( resource td)
Returns an array with the key sizes supported by the algorithm specified 
by the encryption descriptor. If it returns an empty array then all key 
sizes between 1 and mcrypt_enc_get_key_size() are supported by the 
algorithm. 
Example 1. mcrypt_enc_get_supported_key_sizes() example
  <?php
      $td = mcrypt_module_open('rijndael-256', '', 'ecb', '');
      var_dump(mcrypt_enc_get_supported_key_sizes($td));
  ?> 

This will print: 
array(3) {
[0]=>
int(16)
[1]=>
int(24)
[2]=>
int(32)
}

  mcrypt_enc_get_modes_nameUpmcrypt_enc_is_block_algorithm_mode
#

#T=array mcrypt_enc_get_supported_key_sizes ( resource td)
mcrypt_enc_get_supported_key_sizes ( ^!resource td);
#

#T=mcrypt_enc_is_block_algorithm_mode - bool mcrypt_enc_is_block_algorithm_mode ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_is_block_algorithm_mode -- Checks whether the encryption of the 
opened mode works on blocks
Description
bool mcrypt_enc_is_block_algorithm_mode ( resource td)
This function returns TRUE if the mode is for use with block algorithms, 
otherwise it returns FALSE. (e.g. FALSE for stream, and TRUE for cbc, cfb, 
ofb).   mcrypt_enc_get_supported_key_sizesUpmcrypt_enc_is_block_algorithm
#

#T=bool mcrypt_enc_is_block_algorithm_mode ( resource td)
mcrypt_enc_is_block_algorithm_mode ( ^!resource td);
#

#T=mcrypt_enc_is_block_algorithm - bool mcrypt_enc_is_block_algorithm ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_is_block_algorithm -- Checks whether the algorithm of the 
opened mode is a block algorithm
Description
bool mcrypt_enc_is_block_algorithm ( resource td)
This function returns TRUE if the algorithm is a block algorithm, or FALSE 
if it is a stream algorithm.   mcrypt_enc_is_block_algorithm_modeUpmcrypt_enc_is_block_mode
#

#T=bool mcrypt_enc_is_block_algorithm ( resource td)
mcrypt_enc_is_block_algorithm ( ^!resource td);
#

#T=mcrypt_enc_is_block_mode - bool mcrypt_enc_is_block_mode ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_is_block_mode -- Checks whether the opened mode outputs blocks
Description
bool mcrypt_enc_is_block_mode ( resource td)
This function returns TRUE if the mode outputs blocks of bytes or FALSE if 
it outputs bytes. (e.g. TRUE for cbc and ecb, and FALSE for cfb and 
stream).   mcrypt_enc_is_block_algorithmUpmcrypt_enc_self_test
#

#T=bool mcrypt_enc_is_block_mode ( resource td)
mcrypt_enc_is_block_mode ( ^!resource td);
#

#T=mcrypt_enc_self_test - bool mcrypt_enc_self_test ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_enc_self_test -- This function runs a self test on the opened 
module
Description
bool mcrypt_enc_self_test ( resource td)
This function runs the self test on the algorithm specified by the 
descriptor td. If the self test succeeds it returns FALSE. In case of an 
error, it returns TRUE.   mcrypt_enc_is_block_modeUpmcrypt_encrypt
#

#T=bool mcrypt_enc_self_test ( resource td)
mcrypt_enc_self_test ( ^!resource td);
#

#T=mcrypt_encrypt - string mcrypt_encrypt ( string cipher, string key, string data, string 
(PHP 4 >= 4.0.2)
mcrypt_encrypt -- Encrypts plaintext with given parameters
Description
string mcrypt_encrypt ( string cipher, string key, string data, string 
mode [, string iv])
mcrypt_encrypt() encrypts the data and returns the encrypted data. 
Cipher is one of the MCRYPT_ciphername constants of the name of the 
algorithm as string. 
Key is the key with which the data will be encrypted. If it's smaller that 
the required keysize, it is padded with '\0'. It is better not to use 
ASCII strings for keys. It is recommended to use the mhash functions to 
create a key from a string. 
Data is the data that will be encrypted with the given cipher and mode. If 
the size of the data is not n * blocksize, the data will be padded with 
'\0'. The returned crypttext can be larger that the size of the data that 
is given by data. 
Mode is one of the MCRYPT_MODE_modename constants of one of "ecb", "cbc", 
"cfb", "ofb", "nofb" or "stream". 
The IV parameter is used for the initialisation in CBC, CFB, OFB modes, 
and in some algorithms in STREAM mode. If you do not supply an IV, while 
it is needed for an algorithm, the function issues a warning and uses an 
IV with all bytes set to '\0'. 
Example 1. mcrypt_encrypt() Example
  <?php
      $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, 
  MCRYPT_MODE_ECB);
      $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
      $key = "This is a very secret key";
      $text = "Meet me at 11 o'clock behind the monument.";
      echo strlen($text) . "\n";

      $crypttext = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $key, 
  $text, MCRYPT_MODE_ECB, $iv);
      echo strlen($crypttext) . "\n";
  ?> 

The above example will print out: 42
64
See also mcrypt_module_open() for a more advanced API and an example.   mcrypt_enc_self_testUpmcrypt_generic_deinit
#

#T=string mcrypt_encrypt ( string cipher, string key, string data, string 
mcrypt_encrypt ( ^!string cipher, string key, string data, string ;
#

#T=mcrypt_generic_deinit - bool mcrypt_generic_deinit ( resource td)
(PHP 4 >= 4.1.1)
mcrypt_generic_deinit --  This function deinitializes an encryption module 

Description
bool mcrypt_generic_deinit ( resource td)
This function terminates encryption specified by the encryption descriptor 
(td). It clears all buffers, but does not close the module. You need to 
call mcrypt_module_close() yourself. (But PHP does this for you at the end 
of the script.) Returns FALSE on error, or TRUE on success. 
See for an example mcrypt_module_open() and the entry on 
mcrypt_generic_init().   mcrypt_encryptUpmcrypt_generic_end
#

#T=bool mcrypt_generic_deinit ( resource td)
mcrypt_generic_deinit ( ^!resource td);
#

#T=mcrypt_generic_end - bool mcrypt_generic_end ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_generic_end -- This function terminates encryption
Description
bool mcrypt_generic_end ( resource td)
Warning
This function is deprecated, use mcrypt_generic_deinit() instead. It 
can cause crashes when used with mcrypt_module_close() due to 
multiple buffer frees. 

This function terminates encryption specified by the encryption descriptor 
(td). Actually it clears all buffers, and closes all the modules used. 
Returns FALSE on error, or TRUE on success.   mcrypt_generic_deinitUpmcrypt_generic_init
#

#T=bool mcrypt_generic_end ( resource td)
mcrypt_generic_end ( ^!resource td);
#

#T=mcrypt_generic_init - int mcrypt_generic_init ( resource td, string key, string iv)
(PHP 4 >= 4.0.2)
mcrypt_generic_init -- This function initializes all buffers needed for 
encryption
Description
int mcrypt_generic_init ( resource td, string key, string iv)
The maximum length of the key should be the one obtained by calling 
mcrypt_enc_get_key_size() and every value smaller than this is legal. The 
IV should normally have the size of the algorithms block size, but you 
must obtain the size by calling mcrypt_enc_get_iv_size(). IV is ignored in 
ECB. IV MUST exist in CFB, CBC, STREAM, nOFB and OFB modes. It needs to be 
random and unique (but not secret). The same IV must be used for 
encryption/decryption. If you do not want to use it you should set it to 
zeros, but this is not recommended. 
The function returns a negative value on error, -3 when the key length was 
incorrect, -4 when there was a memory allocation problem and any other 
return value is an unknown error. If an error occurs a warning will be 
displayed accordingly. 
You need to call this function before every call to mcrypt_generic() or 
mdecrypt_generic(). 
See for an example mcrypt_module_open() and the entry on 
mcrypt_generic_deinit().   mcrypt_generic_endUpmcrypt_generic
#

#T=int mcrypt_generic_init ( resource td, string key, string iv)
mcrypt_generic_init ( ^!resource td, string key, string iv);
#

#T=mcrypt_generic - string mcrypt_generic ( resource td, string data)
(PHP 4 >= 4.0.2)
mcrypt_generic -- This function encrypts data
Description
string mcrypt_generic ( resource td, string data)
This function encrypts data. The data is padded with "\0" to make sure the 
length of the data is n * blocksize. This function returns the encrypted 
data. Note that the length of the returned string can in fact be longer 
then the input, due to the padding of the data. 
If you want to store the encrypted data in a database make sure to store 
the entire string as returned by mcrypt_generic, or the string will not 
entirely decrypt properly. If your original string is 10 characters long 
and the block size is 8 (use mcrypt_enc_get_block_size() to determine the 
blocksize), you would need at least 16 characters in your database field. 
Note the string returned by mdecrypt_generic() will be 16 characters as 
well...use rtrim()($str, "\0") to remove the padding. 
If you are for example storing the data in a MySQL database remember that 
varchar fields automatically have trailing spaces removed during 
insertion. As encrypted data can end in a space (ASCII 32), the data will 
be damaged by this removal. Store data in a tinyblob/tinytext (or larger) 
field instead. 
The encryption handle should always be initialized with 
mcrypt_generic_init() with a key and an IV before calling this function. 
Where the encryption is done, you should free the encryption buffers by 
calling mcrypt_generic_deinit(). See mcrypt_module_open() for an example. 
See also mdecrypt_generic(), mcrypt_generic_init(), and 
mcrypt_generic_deinit().   mcrypt_generic_initUpmcrypt_get_block_size
#

#T=string mcrypt_generic ( resource td, string data)
mcrypt_generic ( ^!resource td, string data);
#

#T=mcrypt_get_block_size - int mcrypt_get_block_size ( int cipher)
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_get_block_size -- Get the block size of the specified cipher
Description
int mcrypt_get_block_size ( int cipher)

int mcrypt_get_block_size ( string cipher, string module)
The first prototype is when linked against libmcrypt 2.2.x, the second 
when linked against libmcrypt 2.4.x or 2.5.x. 
mcrypt_get_block_size() is used to get the size of a block of the 
specified cipher (in combination with an encryption mode). 
This example shows how to use this function when linked against libmcrypt 
2.4.x and 2.5.x. Example 1. mcrypt_get_block_size() example
  <?php
      echo mcrypt_get_block_size('tripledes', 'ecb');
  ?>

  Prints:
  8 
See also: mcrypt_get_key_size() and mcrypt_encrypt().   mcrypt_genericUpmcrypt_get_cipher_name
#

#T=int mcrypt_get_block_size ( int cipher)
mcrypt_get_block_size ( ^!int cipher);
#

#T=mcrypt_get_cipher_name - string mcrypt_get_cipher_name ( int cipher)
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_get_cipher_name -- Get the name of the specified cipher
Description
string mcrypt_get_cipher_name ( int cipher)

string mcrypt_get_cipher_name ( string cipher)
mcrypt_get_cipher_name() is used to get the name of the specified cipher. 
mcrypt_get_cipher_name() takes the cipher number as an argument (libmcrypt 
2.2.x) or takes the cipher name as an argument (libmcrypt 2.4.x or higher) 
and returns the name of the cipher or FALSE, if the cipher does not exist. 

Example 1. mcrypt_get_cipher_name() Example
  <?php
     $cipher = MCRYPT_TripleDES;

     echo mcrypt_get_cipher_name($cipher);
  ?> 

The above example will produce: 3DES

  mcrypt_get_block_sizeUpmcrypt_get_iv_size
#

#T=string mcrypt_get_cipher_name ( int cipher)
mcrypt_get_cipher_name ( ^!int cipher);
#

#T=mcrypt_get_iv_size - int mcrypt_get_iv_size ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_get_iv_size --  Returns the size of the IV belonging to a specific 
cipher/mode combination 
Description
int mcrypt_get_iv_size ( resource td)

int mcrypt_get_iv_size ( string cipher, string mode)
The first prototype is when linked against libmcrypt 2.2.x, the second 
when linked against libmcrypt 2.4.x or higher. 
mcrypt_get_iv_size() returns the size of the Initialisation Vector (IV) in 
bytes. On error the function returns FALSE. If the IV is ignored in the 
specified cipher/mode combination zero is returned. 
cipher is one of the MCRYPT_ciphername constants of the name of the 
algorithm as string. 
mode is one of the MCRYPT_MODE_modename constants or one of "ecb", "cbc", 
"cfb", "ofb", "nofb" or "stream". The IV is ignored in ECB mode as this 
mode does not require it. You will need to have the same IV (think: 
starting point) both at encryption and decryption stages, otherwise your 
encryption will fail. 
td is the resource that is returned by mcrypt_module_open(). 
Example 1. mcrypt_create_iv() example
  <?php
      $size = mcrypt_get_iv_size(MCRYPT_CAST_256, 
  MCRYPT_MODE_CFB);

      $size = mcrypt_get_iv_size('des', 'ecb');
  ?> 
See also mcrypt_get_block_size(), and mcrypt_create_iv().   mcrypt_get_cipher_nameUpmcrypt_get_key_size
#

#T=int mcrypt_get_iv_size ( resource td)
mcrypt_get_iv_size ( ^!resource td);
#

#T=mcrypt_get_key_size - int mcrypt_get_key_size ( int cipher)
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_get_key_size -- Get the key size of the specified cipher
Description
int mcrypt_get_key_size ( int cipher)

int mcrypt_get_key_size ( string cipher, string module)
The first prototype is when linked against libmcrypt 2.2.x, the second 
when linked against libmcrypt 2.4.x or 2.5.x. 
mcrypt_get_key_size() is used to get the size of a key of the specified 
cipher (in combination with an encryption mode). 
This example shows how to use this function when linked against libmcrypt 
2.4.x and 2.5.x. Example 1. mcrypt_get_block_size() example
  <?php
      echo mcrypt_get_key_size('tripledes', 'ecb');
  ?>

  Prints:
  24 
See also: mcrypt_get_block_size() and mcrypt_encrypt().   mcrypt_get_iv_sizeUpmcrypt_list_algorithms
#

#T=int mcrypt_get_key_size ( int cipher)
mcrypt_get_key_size ( ^!int cipher);
#

#T=mcrypt_list_algorithms - array mcrypt_list_algorithms ( [string lib_dir])
(PHP 4 >= 4.0.2)
mcrypt_list_algorithms -- Get an array of all supported ciphers
Description
array mcrypt_list_algorithms ( [string lib_dir])
mcrypt_list_algorithms() is used to get an array of all supported 
algorithms in the lib_dir parameter. 
mcrypt_list_algorithms() takes an optional lib_dir parameter which 
specifies the directory where all algorithms are located. If not 
specifies, the value of the mcrypt.algorithms_dir php.ini directive is 
used. 
Example 1. mcrypt_list_algorithms() Example
  <?php
      $algorithms = 
  mcrypt_list_algorithms("/usr/local/lib/libmcrypt");

      foreach ($algorithms as $cipher) {
	  echo "$cipher<br />\n";
      }
  ?> 

The above example will produce a list with all supported algorithms 
in the "/usr/local/lib/libmcrypt" directory. 
  mcrypt_get_key_sizeUpmcrypt_list_modes
#

#T=array mcrypt_list_algorithms ( [string lib_dir])
mcrypt_list_algorithms ( ^![string lib_dir]);
#

#T=mcrypt_list_modes - array mcrypt_list_modes ( [string lib_dir])
(PHP 4 >= 4.0.2)
mcrypt_list_modes -- Get an array of all supported modes
Description
array mcrypt_list_modes ( [string lib_dir])
mcrypt_list_modes() is used to get an array of all supported modes in the 
lib_dir. 
mcrypt_list_modes() takes as optional parameter a directory which 
specifies the directory where all modes are located. If not specifies, the 
value of the mcrypt.modes_dir php.ini directive is used. 
Example 1. mcrypt_list_modes() Example
  <?php
      $modes = mcrypt_list_modes();

      foreach ($modes as $mode) {
	  echo "$mode <br />\n";
      }
  ?> 

The above example will produce a list with all supported algorithms 
in the default mode directory. If it is not set with the ini 
directive mcrypt.modes_dir, the default directory of mcrypt is used 
(which is /usr/local/lib/libmcrypt). 
  mcrypt_list_algorithmsUpmcrypt_module_close
#

#T=array mcrypt_list_modes ( [string lib_dir])
mcrypt_list_modes ( ^![string lib_dir]);
#

#T=mcrypt_module_close - bool mcrypt_module_close ( resource td)
(PHP 4 >= 4.0.2)
mcrypt_module_close --  Close the mcrypt module 
Description
bool mcrypt_module_close ( resource td)
This function closes the specified encryption handle. 
See mcrypt_module_open() for an example.   mcrypt_list_modesUpmcrypt_module_get_algo_block_size
#

#T=bool mcrypt_module_close ( resource td)
mcrypt_module_close ( ^!resource td);
#

#T=mcrypt_module_get_algo_block_size - int mcrypt_module_get_algo_block_size ( string algorithm [, string 
(PHP 4 >= 4.0.2)
mcrypt_module_get_algo_block_size -- Returns the blocksize of the 
specified algorithm
Description
int mcrypt_module_get_algo_block_size ( string algorithm [, string 
lib_dir])
This function returns the block size of the algorithm specified in bytes. 
The optional lib_dir parameter can contain the location where the mode 
module is on the system.   mcrypt_module_closeUpmcrypt_module_get_algo_key_size
#

#T=int mcrypt_module_get_algo_block_size ( string algorithm [, string 
mcrypt_module_get_algo_block_size ( ^!string algorithm [, string ;
#

#T=mcrypt_module_get_algo_key_size - int mcrypt_module_get_algo_key_size ( string algorithm [, string lib_dir])
(PHP 4 >= 4.0.2)
mcrypt_module_get_algo_key_size -- Returns the maximum supported keysize 
of the opened mode
Description
int mcrypt_module_get_algo_key_size ( string algorithm [, string lib_dir])
This function returns the maximum supported key size of the algorithm 
specified in bytes. The optional lib_dir parameter can contain the 
location where the mode module is on the system.   mcrypt_module_get_algo_block_sizeUpmcrypt_module_get_supported_key_sizes
#

#T=int mcrypt_module_get_algo_key_size ( string algorithm [, string lib_dir])
mcrypt_module_get_algo_key_size ( ^!string algorithm [, string lib_dir]);
#

#T=mcrypt_module_get_supported_key_sizes - array mcrypt_module_get_supported_key_sizes ( string algorithm [, string 
(PHP 4 >= 4.0.2)
mcrypt_module_get_supported_key_sizes -- Returns an array with the 
supported keysizes of the opened algorithm
Description
array mcrypt_module_get_supported_key_sizes ( string algorithm [, string 
lib_dir])
Returns an array with the key sizes supported by the specified algorithm. 
If it returns an empty array then all key sizes between 1 and 
mcrypt_module_get_algo_key_size() are supported by the algorithm. The 
optional lib_dir parameter can contain the location where the mode module 
is on the system. 
See also mcrypt_enc_get_supported_key_sizes() which is used on open 
encryption modules.   mcrypt_module_get_algo_key_sizeUpmcrypt_module_is_block_algorithm_mode
#

#T=array mcrypt_module_get_supported_key_sizes ( string algorithm [, string 
mcrypt_module_get_supported_key_sizes ( ^!string algorithm [, string ;
#

#T=mcrypt_module_is_block_algorithm_mode - bool mcrypt_module_is_block_algorithm_mode ( string mode [, string 
(PHP 4 >= 4.0.2)
mcrypt_module_is_block_algorithm_mode -- This function returns if the the 
specified module is a block algorithm or not
Description
bool mcrypt_module_is_block_algorithm_mode ( string mode [, string 
lib_dir])
This function returns TRUE if the mode is for use with block algorithms, 
otherwise it returns FALSE. (e.g. FALSE for stream, and TRUE for cbc, cfb, 
ofb). The optional lib_dir parameter can contain the location where the 
mode module is on the system.   mcrypt_module_get_supported_key_sizesUpmcrypt_module_is_block_algorithm
#

#T=bool mcrypt_module_is_block_algorithm_mode ( string mode [, string 
mcrypt_module_is_block_algorithm_mode ( ^!string mode [, string ;
#

#T=mcrypt_module_is_block_algorithm - bool mcrypt_module_is_block_algorithm ( string algorithm [, string 
(PHP 4 >= 4.0.2)
mcrypt_module_is_block_algorithm -- This function checks whether the 
specified algorithm is a block algorithm
Description
bool mcrypt_module_is_block_algorithm ( string algorithm [, string 
lib_dir])
This function returns TRUE if the specified algorithm is a block 
algorithm, or FALSE is it is a stream algorithm. The optional lib_dir 
parameter can contain the location where the algorithm module is on the 
system.   mcrypt_module_is_block_algorithm_modeUpmcrypt_module_is_block_mode
#

#T=bool mcrypt_module_is_block_algorithm ( string algorithm [, string 
mcrypt_module_is_block_algorithm ( ^!string algorithm [, string ;
#

#T=mcrypt_module_is_block_mode - bool mcrypt_module_is_block_mode ( string mode [, string lib_dir])
(PHP 4 >= 4.0.2)
mcrypt_module_is_block_mode -- This function returns if the the specified 
mode outputs blocks or not
Description
bool mcrypt_module_is_block_mode ( string mode [, string lib_dir])
This function returns TRUE if the mode outputs blocks of bytes or FALSE if 
it outputs just bytes. (e.g. TRUE for cbc and ecb, and FALSE for cfb and 
stream). The optional lib_dir parameter can contain the location where the 
mode module is on the system.   mcrypt_module_is_block_algorithmUpmcrypt_module_open
#

#T=bool mcrypt_module_is_block_mode ( string mode [, string lib_dir])
mcrypt_module_is_block_mode ( ^!string mode [, string lib_dir]);
#

#T=mcrypt_module_open - resource mcrypt_module_open ( string algorithm, string 
(PHP 4 >= 4.0.2)
mcrypt_module_open -- Opens the module of the algorithm and the mode to be 
used
Description
resource mcrypt_module_open ( string algorithm, string 
algorithm_directory, string mode, string mode_directory)
This function opens the module of the algorithm and the mode to be used. 
The name of the algorithm is specified in algorithm, e.g. "twofish" or is 
one of the MCRYPT_ciphername constants. The module is closed by calling 
mcrypt_module_close(). Normally it returns an encryption descriptor, or 
FALSE on error. 
The algorithm_directory and mode_directory are used to locate the 
encryption modules. When you supply a directory name, it is used. When you 
set one of these to the empty string (""), the value set by the 
mcrypt.algorithms_dir or mcrypt.modes_dir ini-directive is used. When 
these are not set, the default directories that are used are the ones that 
were compiled in into libmcrypt (usually /usr/local/lib/libmcrypt). 
Example 1. mcrypt_module_open() examples
  <?php
      $td = mcrypt_module_open(MCRYPT_DES, '',
	  MCRYPT_MODE_ECB, '/usr/lib/mcrypt-modes');

      $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');
  ?> 
The first line in the example above will try to open the DES cipher from 
the default directory and the EBC mode from the directory 
/usr/lib/mcrypt-modes. The second example uses strings as name for the 
cipher an dmode, this only works when the extension is linked against 
libmcrypt 2.4.x or 2.5.x. 
Example 2. Using mcrypt_module_open() in encryption
  <?php
      /* Open the cipher */
      $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');

      /* Create the IV and determine the keysize length */
      $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), 
  MCRYPT_DEV_RANDOM);
      $ks = mcrypt_enc_get_key_size($td);

      /* Create key */
      $key = substr(md5('very secret key'), 0, $ks);

      /* Intialize encryption */
      mcrypt_generic_init($td, $key, $iv);

      /* Encrypt data */
      $encrypted = mcrypt_generic($td, 'This is very important 
  data');

      /* Terminate encryption handler */
      mcrypt_generic_deinit($td);

      /* Initialize encryption module for decryption */
      mcrypt_generic_init($td, $key, $iv);

      /* Decrypt encrypted string */
      $decrypted = mdecrypt_generic($td, $encrypted);

      /* Terminate decryption handle and close module */
      mcrypt_generic_deinit($td);
      mcrypt_module_close($td);

      /* Show string */
      echo trim($decrypted) . "\n";
  ?> 
The first line in the example above will try to open the DES cipher from 
the default directory and the EBC mode from the directory 
/usr/lib/mcrypt-modes. The second example uses strings as name for the 
cipher and mode, this only works when the extension is linked against 
libmcrypt 2.4.x or 2.5.x. 
See also mcrypt_module_close(), mcrypt_generic(), mdecrypt_generic(), 
mcrypt_generic_init(), and mcrypt_generic_deinit().   mcrypt_module_is_block_modeUpmcrypt_module_self_test
#

#T=resource mcrypt_module_open ( string algorithm, string 
mcrypt_module_open ( ^!string algorithm, string ;
#

#T=mcrypt_module_self_test - bool mcrypt_module_self_test ( string algorithm [, string lib_dir])
(PHP 4 >= 4.0.2)
mcrypt_module_self_test -- This function runs a self test on the specified 
module
Description
bool mcrypt_module_self_test ( string algorithm [, string lib_dir])
This function runs the self test on the algorithm specified. The optional 
lib_dir parameter can contain the location of where the algorithm module 
is on the system. 
The function returns TRUE if the self test succeeds, or FALSE when if 
fails. 
Example 1. mcrypt_module_self_test() example
  <?php
  var_dump(mcrypt_module_self_test(MCRYPT_RIJNDAEL_128)) . "\n";
  var_dump(mcrypt_module_self_test(MCRYPT_BOGUS_CYPHER));
  ?> 

The above example will output: 
bool(true)
bool(false)

  mcrypt_module_openUpmcrypt_ofb
#

#T=bool mcrypt_module_self_test ( string algorithm [, string lib_dir])
mcrypt_module_self_test ( ^!string algorithm [, string lib_dir]);
#

#T=mcrypt_ofb - string mcrypt_ofb ( int cipher, string key, string data, int mode, string 
(PHP 3>= 3.0.8, PHP 4 )
mcrypt_ofb -- Encrypt/decrypt data in OFB mode
Description
string mcrypt_ofb ( int cipher, string key, string data, int mode, string 
iv)

string mcrypt_ofb ( string cipher, string key, string data, int mode [, 
string iv])
The first prototype is when linked against libmcrypt 2.2.x, the second 
when linked against libmcrypt 2.4.x or higher. The mode should be either 
MCRYPT_ENCRYPT or MCRYPT_DECRYPT. 
This function should not be used anymore, see mcrypt_generic() and 
mdecrypt_generic() for replacements.   mcrypt_module_self_testUpmdecrypt_generic
#

#T=string mcrypt_ofb ( int cipher, string key, string data, int mode, string 
mcrypt_ofb ( ^!int cipher, string key, string data, int mode, string ;
#

#T=mcve_adduser - int mcve_adduser ( resource conn, string admin_password, int usersetup)
(PHP 4 >= 4.2.0)
mcve_adduser --  Add an MCVE user using usersetup structure 
Description
int mcve_adduser ( resource conn, string admin_password, int usersetup)
Warning
This function is currently not documented; only the argument list is 
available.
  MCVE Payment FunctionsUpmcve_adduserarg
#

#T=int mcve_adduser ( resource conn, string admin_password, int usersetup)
mcve_adduser ( ^!resource conn, string admin_password, int usersetup);
#

#T=mcve_adduserarg - int mcve_adduserarg ( resource usersetup, int argtype, string argval)
(PHP 4 >= 4.2.0)
mcve_adduserarg --  Add a value to user configuration structure 
Description
int mcve_adduserarg ( resource usersetup, int argtype, string argval)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_adduserUpmcve_bt
#

#T=int mcve_adduserarg ( resource usersetup, int argtype, string argval)
mcve_adduserarg ( ^!resource usersetup, int argtype, string argval);
#

#T=mcve_bt - int mcve_bt ( resource conn, string username, string password)
(PHP 4 >= 4.2.0)
mcve_bt --  Get unsettled batch totals 
Description
int mcve_bt ( resource conn, string username, string password)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_adduserargUpmcve_checkstatus
#

#T=int mcve_bt ( resource conn, string username, string password)
mcve_bt ( ^!resource conn, string username, string password);
#

#T=mcve_checkstatus - int mcve_checkstatus ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_checkstatus --  Check to see if a transaction has completed 
Description
int mcve_checkstatus ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_btUpmcve_chkpwd
#

#T=int mcve_checkstatus ( resource conn, int identifier)
mcve_checkstatus ( ^!resource conn, int identifier);
#

#T=mcve_chkpwd - int mcve_chkpwd ( resource conn, string username, string password)
(PHP 4 >= 4.2.0)
mcve_chkpwd --  Verify Password 
Description
int mcve_chkpwd ( resource conn, string username, string password)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_checkstatusUpmcve_chngpwd
#

#T=int mcve_chkpwd ( resource conn, string username, string password)
mcve_chkpwd ( ^!resource conn, string username, string password);
#

#T=mcve_chngpwd - int mcve_chngpwd ( resource conn, string admin_password, string 
(PHP 4 >= 4.2.0)
mcve_chngpwd --  Change the system administrator's password 
Description
int mcve_chngpwd ( resource conn, string admin_password, string 
new_password)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_chkpwdUpmcve_completeauthorizations
#

#T=int mcve_chngpwd ( resource conn, string admin_password, string 
mcve_chngpwd ( ^!resource conn, string admin_password, string ;
#

#T=mcve_completeauthorizations - int mcve_completeauthorizations ( resource conn, int &array)
(PHP 4 >= 4.2.0)
mcve_completeauthorizations --  Number of complete authorizations in 
queue, returning an array of their identifiers 
Description
int mcve_completeauthorizations ( resource conn, int &array)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_chngpwdUpmcve_connect
#

#T=int mcve_completeauthorizations ( resource conn, int &array)
mcve_completeauthorizations ( ^!resource conn, int &array);
#

#T=mcve_connect - int mcve_connect ( resource conn)
(PHP 4 >= 4.2.0)
mcve_connect --  Establish the connection to MCVE 
Description
int mcve_connect ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_completeauthorizationsUpmcve_connectionerror
#

#T=int mcve_connect ( resource conn)
mcve_connect ( ^!resource conn);
#

#T=mcve_connectionerror - string mcve_connectionerror ( resource conn)
(PHP 4 >= 4.3.0)
mcve_connectionerror --  Get a textual representation of why a connection 
failed 
Description
string mcve_connectionerror ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_connectUpmcve_deleteresponse
#

#T=string mcve_connectionerror ( resource conn)
mcve_connectionerror ( ^!resource conn);
#

#T=mcve_deleteresponse - bool mcve_deleteresponse ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_deleteresponse --  Delete specified transaction from MCVE_CONN 
structure 
Description
bool mcve_deleteresponse ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_connectionerrorUpmcve_deletetrans
#

#T=bool mcve_deleteresponse ( resource conn, int identifier)
mcve_deleteresponse ( ^!resource conn, int identifier);
#

#T=mcve_deletetrans - bool mcve_deletetrans ( resource conn, int identifier)
(PHP 4 >= 4.3.0)
mcve_deletetrans --  Delete specified transaction from MCVE_CONN structure 

Description
bool mcve_deletetrans ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_deleteresponseUpmcve_deleteusersetup
#

#T=bool mcve_deletetrans ( resource conn, int identifier)
mcve_deletetrans ( ^!resource conn, int identifier);
#

#T=mcve_deleteusersetup - void mcve_deleteusersetup ( resource usersetup)
(PHP 4 >= 4.2.0)
mcve_deleteusersetup --  Deallocate data associated with usersetup 
structure 
Description
void mcve_deleteusersetup ( resource usersetup)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_deletetransUpmcve_deluser
#

#T=void mcve_deleteusersetup ( resource usersetup)
mcve_deleteusersetup ( ^!resource usersetup);
#

#T=mcve_deluser - int mcve_deluser ( resource conn, string admin_password, string username)
(PHP 4 >= 4.2.0)
mcve_deluser --  Delete an MCVE user account 
Description
int mcve_deluser ( resource conn, string admin_password, string username)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_deleteusersetupUpmcve_destroyconn
#

#T=int mcve_deluser ( resource conn, string admin_password, string username)
mcve_deluser ( ^!resource conn, string admin_password, string username);
#

#T=mcve_destroyconn - void mcve_destroyconn ( resource conn)
(PHP 4 >= 4.2.0)
mcve_destroyconn --  Destroy the connection and MCVE_CONN structure 
Description
void mcve_destroyconn ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_deluserUpmcve_destroyengine
#

#T=void mcve_destroyconn ( resource conn)
mcve_destroyconn ( ^!resource conn);
#

#T=mcve_destroyengine - void mcve_destroyengine ( void )
(PHP 4 >= 4.2.0)
mcve_destroyengine --  Free memory associated with IP/SSL connectivity 
Description
void mcve_destroyengine ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_destroyconnUpmcve_disableuser
#

#T=void mcve_destroyengine ( void )
mcve_destroyengine ( ^!void );
#

#T=mcve_disableuser - int mcve_disableuser ( resource conn, string admin_password, string 
(PHP 4 >= 4.2.0)
mcve_disableuser --  Disable an active MCVE user account 
Description
int mcve_disableuser ( resource conn, string admin_password, string 
username)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_destroyengineUpmcve_edituser
#

#T=int mcve_disableuser ( resource conn, string admin_password, string 
mcve_disableuser ( ^!resource conn, string admin_password, string ;
#

#T=mcve_edituser - int mcve_edituser ( resource conn, string admin_password, int usersetup)
(PHP 4 >= 4.2.0)
mcve_edituser --  Edit MCVE user using usersetup structure 
Description
int mcve_edituser ( resource conn, string admin_password, int usersetup)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_disableuserUpmcve_enableuser
#

#T=int mcve_edituser ( resource conn, string admin_password, int usersetup)
mcve_edituser ( ^!resource conn, string admin_password, int usersetup);
#

#T=mcve_enableuser - int mcve_enableuser ( resource conn, string admin_password, string 
(PHP 4 >= 4.2.0)
mcve_enableuser --  Enable an inactive MCVE user account 
Description
int mcve_enableuser ( resource conn, string admin_password, string 
username)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_edituserUpmcve_force
#

#T=int mcve_enableuser ( resource conn, string admin_password, string 
mcve_enableuser ( ^!resource conn, string admin_password, string ;
#

#T=mcve_force - int mcve_force ( resource conn, string username, string password, string 
(PHP 4 >= 4.2.0)
mcve_force --  Send a FORCE to MCVE. (typically, a phone-authorization) 
Description
int mcve_force ( resource conn, string username, string password, string 
trackdata, string account, string expdate, float amount, string authcode, 
string comments, string clerkid, string stationid, int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_enableuserUpmcve_getcell
#

#T=int mcve_force ( resource conn, string username, string password, string 
mcve_force ( ^!resource conn, string username, string password, string ;
#

#T=mcve_getcell - string mcve_getcell ( resource conn, int identifier, string column, int 
(PHP 4 >= 4.2.0)
mcve_getcell --  Get a specific cell from a comma delimited response by 
column name 
Description
string mcve_getcell ( resource conn, int identifier, string column, int 
row)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_forceUpmcve_getcellbynum
#

#T=string mcve_getcell ( resource conn, int identifier, string column, int 
mcve_getcell ( ^!resource conn, int identifier, string column, int ;
#

#T=mcve_getcellbynum - string mcve_getcellbynum ( resource conn, int identifier, int column, int 
(PHP 4 >= 4.2.0)
mcve_getcellbynum --  Get a specific cell from a comma delimited response 
by column number 
Description
string mcve_getcellbynum ( resource conn, int identifier, int column, int 
row)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_getcellUpmcve_getcommadelimited
#

#T=string mcve_getcellbynum ( resource conn, int identifier, int column, int 
mcve_getcellbynum ( ^!resource conn, int identifier, int column, int ;
#

#T=mcve_getcommadelimited - string mcve_getcommadelimited ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_getcommadelimited --  Get the RAW comma delimited data returned from 
MCVE 
Description
string mcve_getcommadelimited ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_getcellbynumUpmcve_getheader
#

#T=string mcve_getcommadelimited ( resource conn, int identifier)
mcve_getcommadelimited ( ^!resource conn, int identifier);
#

#T=mcve_getheader - string mcve_getheader ( resource conn, int identifier, int column_num)
(PHP 4 >= 4.2.0)
mcve_getheader --  Get the name of the column in a comma-delimited 
response 
Description
string mcve_getheader ( resource conn, int identifier, int column_num)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_getcommadelimitedUpmcve_getuserarg
#

#T=string mcve_getheader ( resource conn, int identifier, int column_num)
mcve_getheader ( ^!resource conn, int identifier, int column_num);
#

#T=mcve_getuserarg - string mcve_getuserarg ( resource usersetup, int argtype)
(PHP 4 >= 4.2.0)
mcve_getuserarg --  Grab a value from usersetup structure 
Description
string mcve_getuserarg ( resource usersetup, int argtype)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_getheaderUpmcve_getuserparam
#

#T=string mcve_getuserarg ( resource usersetup, int argtype)
mcve_getuserarg ( ^!resource usersetup, int argtype);
#

#T=mcve_getuserparam - string mcve_getuserparam ( resource conn, long identifier, int key)
(PHP 4 >= 4.3.0)
mcve_getuserparam --  Get a user response parameter 
Description
string mcve_getuserparam ( resource conn, long identifier, int key)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_getuserargUpmcve_gft
#

#T=string mcve_getuserparam ( resource conn, long identifier, int key)
mcve_getuserparam ( ^!resource conn, long identifier, int key);
#

#T=mcve_gft - int mcve_gft ( resource conn, string username, string password, int type, 
(PHP 4 >= 4.2.0)
mcve_gft --  Audit MCVE for Failed transactions 
Description
int mcve_gft ( resource conn, string username, string password, int type, 
string account, string clerkid, string stationid, string comments, int 
ptrannum, string startdate, string enddate)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_getuserparamUpmcve_gl
#

#T=int mcve_gft ( resource conn, string username, string password, int type, 
mcve_gft ( ^!resource conn, string username, string password, int type, ;
#

#T=mcve_gl - int mcve_gl ( int conn, string username, string password, int type, string 
(PHP 4 >= 4.2.0)
mcve_gl --  Audit MCVE for settled transactions 
Description
int mcve_gl ( int conn, string username, string password, int type, string 
account, string batch, string clerkid, string stationid, string comments, 
int ptrannum, string startdate, string enddate)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_gftUpmcve_gut
#

#T=int mcve_gl ( int conn, string username, string password, int type, string 
mcve_gl ( ^!int conn, string username, string password, int type, string ;
#

#T=mcve_gut - int mcve_gut ( resource conn, string username, string password, int type, 
(PHP 4 >= 4.2.0)
mcve_gut --  Audit MCVE for Unsettled Transactions 
Description
int mcve_gut ( resource conn, string username, string password, int type, 
string account, string clerkid, string stationid, string comments, int 
ptrannum, string startdate, string enddate)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_glUpmcve_initconn
#

#T=int mcve_gut ( resource conn, string username, string password, int type, 
mcve_gut ( ^!resource conn, string username, string password, int type, ;
#

#T=mcve_initconn - resource mcve_initconn ( void )
(PHP 4 >= 4.2.0)
mcve_initconn --  Create and initialize an MCVE_CONN structure 
Description
resource mcve_initconn ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_gutUpmcve_initengine
#

#T=resource mcve_initconn ( void )
mcve_initconn ( ^!void );
#

#T=mcve_initengine - int mcve_initengine ( string location)
(PHP 4 >= 4.2.0)
mcve_initengine --  Ready the client for IP/SSL Communication 
Description
int mcve_initengine ( string location)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_initconnUpmcve_initusersetup
#

#T=int mcve_initengine ( string location)
mcve_initengine ( ^!string location);
#

#T=mcve_initusersetup - resource mcve_initusersetup ( void )
(PHP 4 >= 4.2.0)
mcve_initusersetup --  Initialize structure to store user data 
Description
resource mcve_initusersetup ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_initengineUpmcve_iscommadelimited
#

#T=resource mcve_initusersetup ( void )
mcve_initusersetup ( ^!void );
#

#T=mcve_iscommadelimited - int mcve_iscommadelimited ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_iscommadelimited --  Checks to see if response is comma delimited 
Description
int mcve_iscommadelimited ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_initusersetupUpmcve_liststats
#

#T=int mcve_iscommadelimited ( resource conn, int identifier)
mcve_iscommadelimited ( ^!resource conn, int identifier);
#

#T=mcve_liststats - int mcve_liststats ( resource conn, string admin_password)
(PHP 4 >= 4.2.0)
mcve_liststats --  List statistics for all users on MCVE system 
Description
int mcve_liststats ( resource conn, string admin_password)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_iscommadelimitedUpmcve_listusers
#

#T=int mcve_liststats ( resource conn, string admin_password)
mcve_liststats ( ^!resource conn, string admin_password);
#

#T=mcve_listusers - int mcve_listusers ( resource conn, string admin_password)
(PHP 4 >= 4.2.0)
mcve_listusers --  List all users on MCVE system 
Description
int mcve_listusers ( resource conn, string admin_password)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_liststatsUpmcve_maxconntimeout
#

#T=int mcve_listusers ( resource conn, string admin_password)
mcve_listusers ( ^!resource conn, string admin_password);
#

#T=mcve_maxconntimeout - bool mcve_maxconntimeout ( resource conn, int secs)
(PHP 4 >= 4.3.0)
mcve_maxconntimeout --  The maximum amount of time the API will attempt a 
connection to MCVE 
Description
bool mcve_maxconntimeout ( resource conn, int secs)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_listusersUpmcve_monitor
#

#T=bool mcve_maxconntimeout ( resource conn, int secs)
mcve_maxconntimeout ( ^!resource conn, int secs);
#

#T=mcve_monitor - int mcve_monitor ( resource conn)
(PHP 4 >= 4.2.0)
mcve_monitor --  Perform communication with MCVE (send/receive data) 
Non-blocking 
Description
int mcve_monitor ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_maxconntimeoutUpmcve_numcolumns
#

#T=int mcve_monitor ( resource conn)
mcve_monitor ( ^!resource conn);
#

#T=mcve_numcolumns - int mcve_numcolumns ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_numcolumns --  Number of columns returned in a comma delimited 
response 
Description
int mcve_numcolumns ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_monitorUpmcve_numrows
#

#T=int mcve_numcolumns ( resource conn, int identifier)
mcve_numcolumns ( ^!resource conn, int identifier);
#

#T=mcve_numrows - int mcve_numrows ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_numrows --  Number of rows returned in a comma delimited response 
Description
int mcve_numrows ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_numcolumnsUpmcve_override
#

#T=int mcve_numrows ( resource conn, int identifier)
mcve_numrows ( ^!resource conn, int identifier);
#

#T=mcve_override - int mcve_override ( resource conn, string username, string password, 
(PHP 4 >= 4.2.0)
mcve_override --  Send an OVERRIDE to MCVE 
Description
int mcve_override ( resource conn, string username, string password, 
string trackdata, string account, string expdate, float amount, string 
street, string zip, string cv, string comments, string clerkid, string 
stationid, int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_numrowsUpmcve_parsecommadelimited
#

#T=int mcve_override ( resource conn, string username, string password, 
mcve_override ( ^!resource conn, string username, string password, ;
#

#T=mcve_parsecommadelimited - int mcve_parsecommadelimited ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_parsecommadelimited --  Parse the comma delimited response so 
mcve_getcell, etc will work 
Description
int mcve_parsecommadelimited ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_overrideUpmcve_ping
#

#T=int mcve_parsecommadelimited ( resource conn, int identifier)
mcve_parsecommadelimited ( ^!resource conn, int identifier);
#

#T=mcve_ping - int mcve_ping ( resource conn)
(PHP 4 >= 4.3.0)
mcve_ping --  Send a ping request to MCVE 
Description
int mcve_ping ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_parsecommadelimitedUpmcve_preauth
#

#T=int mcve_ping ( resource conn)
mcve_ping ( ^!resource conn);
#

#T=mcve_preauth - int mcve_preauth ( resource conn, string username, string password, string 
(PHP 4 >= 4.2.0)
mcve_preauth --  Send a PREAUTHORIZATION to MCVE 
Description
int mcve_preauth ( resource conn, string username, string password, string 
trackdata, string account, string expdate, float amount, string street, 
string zip, string cv, string comments, string clerkid, string stationid, 
int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_pingUpmcve_preauthcompletion
#

#T=int mcve_preauth ( resource conn, string username, string password, string 
mcve_preauth ( ^!resource conn, string username, string password, string ;
#

#T=mcve_preauthcompletion - int mcve_preauthcompletion ( resource conn, string username, string 
(PHP 4 >= 4.2.0)
mcve_preauthcompletion --  Complete a PREAUTHORIZATION... Ready it for 
settlement 
Description
int mcve_preauthcompletion ( resource conn, string username, string 
password, float finalamount, int sid, int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_preauthUpmcve_qc
#

#T=int mcve_preauthcompletion ( resource conn, string username, string 
mcve_preauthcompletion ( ^!resource conn, string username, string ;
#

#T=mcve_qc - int mcve_qc ( resource conn, string username, string password, string 
(PHP 4 >= 4.2.0)
mcve_qc --  Audit MCVE for a list of transactions in the outgoing queue 
Description
int mcve_qc ( resource conn, string username, string password, string 
clerkid, string stationid, string comments, int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_preauthcompletionUpmcve_responseparam
#

#T=int mcve_qc ( resource conn, string username, string password, string 
mcve_qc ( ^!resource conn, string username, string password, string ;
#

#T=mcve_responseparam - string mcve_responseparam ( resource conn, long identifier, string key)
(PHP 4 >= 4.3.0)
mcve_responseparam --  Get a custom response parameter 
Description
string mcve_responseparam ( resource conn, long identifier, string key)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_qcUpmcve_return
#

#T=string mcve_responseparam ( resource conn, long identifier, string key)
mcve_responseparam ( ^!resource conn, long identifier, string key);
#

#T=mcve_return - int mcve_return ( int conn, string username, string password, string 
(PHP 4 >= 4.2.0)
mcve_return --  Issue a RETURN or CREDIT to MCVE 
Description
int mcve_return ( int conn, string username, string password, string 
trackdata, string account, string expdate, float amount, string comments, 
string clerkid, string stationid, int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_responseparamUpmcve_returncode
#

#T=int mcve_return ( int conn, string username, string password, string 
mcve_return ( ^!int conn, string username, string password, string ;
#

#T=mcve_returncode - int mcve_returncode ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_returncode --  Grab the exact return code from the transaction 
Description
int mcve_returncode ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_returnUpmcve_returnstatus
#

#T=int mcve_returncode ( resource conn, int identifier)
mcve_returncode ( ^!resource conn, int identifier);
#

#T=mcve_returnstatus - int mcve_returnstatus ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_returnstatus --  Check to see if the transaction was successful 
Description
int mcve_returnstatus ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_returncodeUpmcve_sale
#

#T=int mcve_returnstatus ( resource conn, int identifier)
mcve_returnstatus ( ^!resource conn, int identifier);
#

#T=mcve_sale - int mcve_sale ( resource conn, string username, string password, string 
(PHP 4 >= 4.2.0)
mcve_sale --  Send a SALE to MCVE 
Description
int mcve_sale ( resource conn, string username, string password, string 
trackdata, string account, string expdate, float amount, string street, 
string zip, string cv, string comments, string clerkid, string stationid, 
int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_returnstatusUpmcve_setblocking
#

#T=int mcve_sale ( resource conn, string username, string password, string 
mcve_sale ( ^!resource conn, string username, string password, string ;
#

#T=mcve_setblocking - int mcve_setblocking ( resource conn, int tf)
(PHP 4 >= 4.3.0)
mcve_setblocking --  Set blocking/non-blocking mode for connection 
Description
int mcve_setblocking ( resource conn, int tf)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_saleUpmcve_setdropfile
#

#T=int mcve_setblocking ( resource conn, int tf)
mcve_setblocking ( ^!resource conn, int tf);
#

#T=mcve_setdropfile - int mcve_setdropfile ( resource conn, string directory)
(PHP 4 >= 4.2.0)
mcve_setdropfile --  Set the connection method to Drop-File 
Description
int mcve_setdropfile ( resource conn, string directory)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_setblockingUpmcve_setip
#

#T=int mcve_setdropfile ( resource conn, string directory)
mcve_setdropfile ( ^!resource conn, string directory);
#

#T=mcve_setip - int mcve_setip ( resource conn, string host, int port)
(PHP 4 >= 4.2.0)
mcve_setip --  Set the connection method to IP 
Description
int mcve_setip ( resource conn, string host, int port)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_setdropfileUpmcve_setssl_files
mcve_setssl_files
(no version information, might be only in CVS)
mcve_setssl_files --  Set certificate key files and certificates if server 
requires client certificate verification 
Description
int mcve_setssl_files ( string sslkeyfile, string sslcertfile)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_setipUpmcve_setssl
#

#T=int mcve_setip ( resource conn, string host, int port)
mcve_setip ( ^!resource conn, string host, int port);
#

#T=mcve_setssl - int mcve_setssl ( resource conn, string host, int port)
(PHP 4 >= 4.2.0)
mcve_setssl --  Set the connection method to SSL 
Description
int mcve_setssl ( resource conn, string host, int port)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_setssl_filesUpmcve_settimeout
#

#T=int mcve_setssl ( resource conn, string host, int port)
mcve_setssl ( ^!resource conn, string host, int port);
#

#T=mcve_settimeout - int mcve_settimeout ( resource conn, int seconds)
(PHP 4 >= 4.2.0)
mcve_settimeout --  Set maximum transaction time (per trans) 
Description
int mcve_settimeout ( resource conn, int seconds)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_setsslUpmcve_settle
#

#T=int mcve_settimeout ( resource conn, int seconds)
mcve_settimeout ( ^!resource conn, int seconds);
#

#T=mcve_settle - int mcve_settle ( resource conn, string username, string password, string 
(PHP 4 >= 4.2.0)
mcve_settle --  Issue a settlement command to do a batch deposit 
Description
int mcve_settle ( resource conn, string username, string password, string 
batch)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_settimeoutUpmcve_text_avs
#

#T=int mcve_settle ( resource conn, string username, string password, string 
mcve_settle ( ^!resource conn, string username, string password, string ;
#

#T=mcve_text_avs - string mcve_text_avs ( string code)
(PHP 4 >= 4.3.0)
mcve_text_avs --  Get a textual representation of the return_avs 
Description
string mcve_text_avs ( string code)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_settleUpmcve_text_code
#

#T=string mcve_text_avs ( string code)
mcve_text_avs ( ^!string code);
#

#T=mcve_text_code - string mcve_text_code ( string code)
(PHP 4 >= 4.3.0)
mcve_text_code --  Get a textual representation of the return_code 
Description
string mcve_text_code ( string code)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_text_avsUpmcve_text_cv
#

#T=string mcve_text_code ( string code)
mcve_text_code ( ^!string code);
#

#T=mcve_text_cv - string mcve_text_cv ( int code)
(PHP 4 >= 4.3.0)
mcve_text_cv --  Get a textual representation of the return_cv 
Description
string mcve_text_cv ( int code)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_text_codeUpmcve_transactionauth
#

#T=string mcve_text_cv ( int code)
mcve_text_cv ( ^!int code);
#

#T=mcve_transactionauth - string mcve_transactionauth ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_transactionauth --  Get the authorization number returned for the 
transaction (alpha-numeric) 
Description
string mcve_transactionauth ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_text_cvUpmcve_transactionavs
#

#T=string mcve_transactionauth ( resource conn, int identifier)
mcve_transactionauth ( ^!resource conn, int identifier);
#

#T=mcve_transactionavs - int mcve_transactionavs ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_transactionavs --  Get the Address Verification return status 
Description
int mcve_transactionavs ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactionauthUpmcve_transactionbatch
#

#T=int mcve_transactionavs ( resource conn, int identifier)
mcve_transactionavs ( ^!resource conn, int identifier);
#

#T=mcve_transactionbatch - int mcve_transactionbatch ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_transactionbatch --  Get the batch number associated with the 
transaction 
Description
int mcve_transactionbatch ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactionavsUpmcve_transactioncv
#

#T=int mcve_transactionbatch ( resource conn, int identifier)
mcve_transactionbatch ( ^!resource conn, int identifier);
#

#T=mcve_transactioncv - int mcve_transactioncv ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_transactioncv --  Get the CVC2/CVV2/CID return status 
Description
int mcve_transactioncv ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactionbatchUpmcve_transactionid
#

#T=int mcve_transactioncv ( resource conn, int identifier)
mcve_transactioncv ( ^!resource conn, int identifier);
#

#T=mcve_transactionid - int mcve_transactionid ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_transactionid --  Get the unique system id for the transaction 
Description
int mcve_transactionid ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactioncvUpmcve_transactionitem
#

#T=int mcve_transactionid ( resource conn, int identifier)
mcve_transactionid ( ^!resource conn, int identifier);
#

#T=mcve_transactionitem - int mcve_transactionitem ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_transactionitem --  Get the ITEM number in the associated batch for 
this transaction 
Description
int mcve_transactionitem ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactionidUpmcve_transactionssent
#

#T=int mcve_transactionitem ( resource conn, int identifier)
mcve_transactionitem ( ^!resource conn, int identifier);
#

#T=mcve_transactionssent - int mcve_transactionssent ( resource conn)
(PHP 4 >= 4.2.0)
mcve_transactionssent --  Check to see if outgoing buffer is clear 
Description
int mcve_transactionssent ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactionitemUpmcve_transactiontext
#

#T=int mcve_transactionssent ( resource conn)
mcve_transactionssent ( ^!resource conn);
#

#T=mcve_transactiontext - string mcve_transactiontext ( resource conn, int identifier)
(PHP 4 >= 4.2.0)
mcve_transactiontext --  Get verbiage (text) return from MCVE or 
processing institution 
Description
string mcve_transactiontext ( resource conn, int identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactionssentUpmcve_transinqueue
#

#T=string mcve_transactiontext ( resource conn, int identifier)
mcve_transactiontext ( ^!resource conn, int identifier);
#

#T=mcve_transinqueue - int mcve_transinqueue ( resource conn)
(PHP 4 >= 4.2.0)
mcve_transinqueue --  Number of transactions in client-queue 
Description
int mcve_transinqueue ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transactiontextUpmcve_transnew
#

#T=int mcve_transinqueue ( resource conn)
mcve_transinqueue ( ^!resource conn);
#

#T=mcve_transnew - int mcve_transnew ( resource conn)
(PHP 4 >= 4.3.0)
mcve_transnew --  Start a new transaction 
Description
int mcve_transnew ( resource conn)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transinqueueUpmcve_transparam
#

#T=int mcve_transnew ( resource conn)
mcve_transnew ( ^!resource conn);
#

#T=mcve_transparam - int mcve_transparam ( resource conn, long identifier, int key)
(PHP 4 >= 4.3.0)
mcve_transparam --  Add a parameter to a transaction 
Description
int mcve_transparam ( resource conn, long identifier, int key)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transnewUpmcve_transsend
#

#T=int mcve_transparam ( resource conn, long identifier, int key)
mcve_transparam ( ^!resource conn, long identifier, int key);
#

#T=mcve_transsend - int mcve_transsend ( resource conn, long identifier)
(PHP 4 >= 4.3.0)
mcve_transsend --  Finalize and send the transaction 
Description
int mcve_transsend ( resource conn, long identifier)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transparamUpmcve_ub
#

#T=int mcve_transsend ( resource conn, long identifier)
mcve_transsend ( ^!resource conn, long identifier);
#

#T=mcve_ub - int mcve_ub ( resource conn, string username, string password)
(PHP 4 >= 4.2.0)
mcve_ub --  Get a list of all Unsettled batches 
Description
int mcve_ub ( resource conn, string username, string password)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_transsendUpmcve_uwait
#

#T=int mcve_ub ( resource conn, string username, string password)
mcve_ub ( ^!resource conn, string username, string password);
#

#T=mcve_uwait - int mcve_uwait ( long microsecs)
(PHP 4 >= 4.3.0)
mcve_uwait --  Wait x microsecs 
Description
int mcve_uwait ( long microsecs)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_ubUpmcve_verifyconnection
#

#T=int mcve_uwait ( long microsecs)
mcve_uwait ( ^!long microsecs);
#

#T=mcve_verifyconnection - bool mcve_verifyconnection ( resource conn, int tf)
(PHP 4 >= 4.3.0)
mcve_verifyconnection --  Set whether or not to PING upon connect to 
verify connection 
Description
bool mcve_verifyconnection ( resource conn, int tf)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_uwaitUpmcve_verifysslcert
#

#T=bool mcve_verifyconnection ( resource conn, int tf)
mcve_verifyconnection ( ^!resource conn, int tf);
#

#T=mcve_verifysslcert - bool mcve_verifysslcert ( resource conn, int tf)
(PHP 4 >= 4.3.0)
mcve_verifysslcert --  Set whether or not to verify the server ssl 
certificate 
Description
bool mcve_verifysslcert ( resource conn, int tf)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_verifyconnectionUpmcve_void
#

#T=bool mcve_verifysslcert ( resource conn, int tf)
mcve_verifysslcert ( ^!resource conn, int tf);
#

#T=mcve_void - int mcve_void ( resource conn, string username, string password, int sid, 
(PHP 4 >= 4.2.0)
mcve_void --  VOID a transaction in the settlement queue 
Description
int mcve_void ( resource conn, string username, string password, int sid, 
int ptrannum)
Warning
This function is currently not documented; only the argument list is 
available.
  mcve_verifysslcertUpMhash Functions
#

#T=int mcve_void ( resource conn, string username, string password, int sid, 
mcve_void ( ^!resource conn, string username, string password, int sid, ;
#

#T=md5_file - string md5_file ( string filename [, bool raw_output])
(PHP 4 >= 4.2.0)
md5_file -- Calculates the md5 hash of a given filename
Description
string md5_file ( string filename [, bool raw_output])
Calculates the MD5 hash of the specified filename using the RSA Data 
Security, Inc. MD5 Message-Digest Algorithm, and returns that hash. The 
hash is a 32-character hexadecimal number. If the optional raw_output is 
set to TRUE, then the md5 digest is instead returned in raw binary format 
with a length of 16. 
Note: The optional raw_output parameter was added in PHP 5.0.0 and 
defaults to FALSE 
This function has the same purpose of the command line utility md5sum. 
See also md5(), crc32(), and sha1_file().   ltrimUpmd5
#

#T=string md5_file ( string filename [, bool raw_output])
md5_file ( ^!string filename [, bool raw_output]);
#

#T=md5 - string md5 ( string str [, bool raw_output])
(PHP 3, PHP 4 )
md5 -- Calculate the md5 hash of a string
Description
string md5 ( string str [, bool raw_output])
Calculates the MD5 hash of str using the RSA Data Security, Inc. MD5 
Message-Digest Algorithm, and returns that hash. The hash is a 
32-character hexadecimal number. If the optional raw_output is set to 
TRUE, then the md5 digest is instead returned in raw binary format with a 
length of 16. 
Note: The optional raw_output parameter was added in PHP 5.0.0 and 
defaults to FALSE 
Example 1. A md5() example
  <?php
  $str = 'apple';

  if (md5($str) === '1f3870be274f6c49b3e31a0c6728957f') {
      echo "Would you like a green or red apple?";
      exit;
  }
  ?> 
See also crc32(), md5_file(), and sha1().   md5_fileUpmetaphone
#

#T=string md5 ( string str [, bool raw_output])
md5 ( ^!string str [, bool raw_output]);
#

#T=mdecrypt_generic - string mdecrypt_generic ( resource td, string data)
(PHP 4 >= 4.0.2)
mdecrypt_generic -- Decrypt data
Description
string mdecrypt_generic ( resource td, string data)
This function decrypts data. Note that the length of the returned string 
can in fact be longer then the unencrypted string, due to the padding of 
the data. 
Example 1. mdecrypt_generic() example
  <?php
      /* Data */
      $key = 'this is a very long key, even too long for the 
  cipher';
      $plain_text = 'very important data';
     
      /* Open module, and create IV */ 
      $td = mcrypt_module_open('des', '', 'ecb', '');
      $key = substr($key, 0, mcrypt_enc_get_key_size($td));
      $iv_size = mcrypt_enc_get_iv_size($td);
      $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);

      /* Initialize encryption handle */
      if (mcrypt_generic_init($td, $key, $iv) != -1) {

	  /* Encrypt data */
	  $c_t = mcrypt_generic($td, $plain_text);
	  mcrypt_generic_deinit($td);

	  /* Reinitialize buffers for decryption */
	  mcrypt_generic_init($td, $key, $iv);
	  $p_t = mdecrypt_generic($td, $c_t);

	  /* Clean up */
	  mcrypt_generic_deinit($td);
	  mcrypt_module_close($td);
      }

      if (strncmp($p_t, $plain_text, strlen($plain_text)) == 0) 
{
	  echo "ok\n";
      } else {
	  echo "error\n";
      }
  ?> 
The above example shows how to check if the data before the encryption is 
the same as the data after the decryption. It is very important to 
reinitialize the encryption buffer with mcrypt_generic_init() before you 
try to decrypt the data. 
The decryption handle should always be initialized with 
mcrypt_generic_init() with a key and an IV before calling this function. 
Where the encryption is done, you should free the encryption buffers by 
calling mcrypt_generic_deinit(). See mcrypt_module_open() for an example. 
See also mcrypt_generic(), mcrypt_generic_init(), and 
mcrypt_generic_deinit().   mcrypt_ofbUpMCVE Payment Functions
#

#T=string mdecrypt_generic ( resource td, string data)
mdecrypt_generic ( ^!resource td, string data);
#

#T=memory_get_usage - int memory_get_usage ( void )
(PHP 4 >= 4.3.2)
memory_get_usage -- Returns the amount of memory allocated to PHP
Description
int memory_get_usage ( void )
Returns the amount of memory, in bytes, that's currently being allocated 
to your PHP script. 
memory_get_usage() will only be defined if your PHP is compiled with the 
--enable-memory-limit configuration option. 
Example 1. A memory_get_usage() example
  <?php
  // This is only an example, the numbers below will 
  // differ depending on your system

  echo memory_get_usage() . "\n"; // 36640

  $a = str_repeat("Hello", 4242);

  echo memory_get_usage() . "\n"; // 57960

  unset($a);

  echo memory_get_usage() . "\n"; // 36744

  ?> 
See also memory_limit.   mainUpphp_ini_scanned_files
#

#T=int memory_get_usage ( void )
memory_get_usage ( ^!void );
#

#T=metaphone - string metaphone ( string str)
(PHP 4 )
metaphone -- Calculate the metaphone key of a string
Description
string metaphone ( string str)
Calculates the metaphone key of str. 
Similar to soundex() metaphone creates the same key for similar sounding 
words. It's more accurate than soundex() as it knows the basic rules of 
English pronunciation. The metaphone generated keys are of variable 
length. 
Metaphone was developed by Lawrence Philips <lphilips at verity dot com>. 
It is described in ["Practical Algorithms for Programmers", Binstock & 
Rex, Addison Wesley, 1995].   md5Upmoney_format
#

#T=string metaphone ( string str)
metaphone ( ^!string str);
#

#T=method_exists - bool method_exists ( object object, string method_name)
(PHP 4 )
method_exists -- Checks if the class method exists
Description
bool method_exists ( object object, string method_name)
This function returns TRUE if the method given by method_name has been 
defined for the given object, FALSE otherwise.   is_subclass_ofUpClibPDF functions
#

#T=bool method_exists ( object object, string method_name)
method_exists ( ^!object object, string method_name);
#

#T=mhash_count - int mhash_count ( void )
(PHP 3>= 3.0.9, PHP 4 )
mhash_count -- Get the highest available hash id
Description
int mhash_count ( void )
mhash_count() returns the highest available hash id. Hashes are numbered 
from 0 to this hash id. 
Example 1. Traversing all hashes
  <?php

  $nr = mhash_count();

  for ($i = 0; $i <= $nr; $i++) {
      echo sprintf("The blocksize of %s is %d\n", 
	  mhash_get_hash_name($i),
	  mhash_get_block_size($i));
  }
  ?> 

  Mhash FunctionsUpmhash_get_block_size
#

#T=int mhash_count ( void )
mhash_count ( ^!void );
#

#T=mhash_get_block_size - int mhash_get_block_size ( int hash)
(PHP 3>= 3.0.9, PHP 4 )
mhash_get_block_size -- Get the block size of the specified hash
Description
int mhash_get_block_size ( int hash)
mhash_get_block_size() is used to get the size of a block of the specified 
hash. 
mhash_get_block_size() takes one argument, the hash and returns the size 
in bytes or FALSE, if the hash does not exist.   mhash_countUpmhash_get_hash_name
#

#T=int mhash_get_block_size ( int hash)
mhash_get_block_size ( ^!int hash);
#

#T=mhash_get_hash_name - string mhash_get_hash_name ( int hash)
(PHP 3>= 3.0.9, PHP 4 )
mhash_get_hash_name -- Get the name of the specified hash
Description
string mhash_get_hash_name ( int hash)
mhash_get_hash_name() is used to get the name of the specified hash. 
mhash_get_hash_name() takes the hash id as an argument and returns the 
name of the hash or FALSE, if the hash does not exist. 
Example 1. mhash_get_hash_name() example
  <?php
  $hash = MHASH_MD5;

  echo mhash_get_hash_name($hash);
  ?> 

The above example will print out: 
MD5

  mhash_get_block_sizeUpmhash_keygen_s2k
#

#T=string mhash_get_hash_name ( int hash)
mhash_get_hash_name ( ^!int hash);
#

#T=mhash_keygen_s2k - string mhash_keygen_s2k ( int hash, string password, string salt, int 
(PHP 4 >= 4.0.4)
mhash_keygen_s2k -- Generates a key
Description
string mhash_keygen_s2k ( int hash, string password, string salt, int 
bytes)
mhash_keygen_s2k() generates a key that is bytes long, from a user given 
password. This is the Salted S2K algorithm as specified in the OpenPGP 
document (RFC 2440). That algorithm will use the specified hash algorithm 
to create the key. The salt must be different and random enough for every 
key you generate in order to create different keys. That salt must be 
known when you check the keys, thus it is a good idea to append the key to 
it. Salt has a fixed length of 8 bytes and will be padded with zeros if 
you supply less bytes. 
Keep in mind that user supplied passwords are not really suitable to be 
used as keys in cryptographic algorithms, since users normally choose keys 
they can write on keyboard. These passwords use only 6 to 7 bits per 
character (or less). It is highly recommended to use some kind of 
transformation (like this function) to the user supplied key.   mhash_get_hash_nameUpmhash
#

#T=string mhash_keygen_s2k ( int hash, string password, string salt, int 
mhash_keygen_s2k ( ^!int hash, string password, string salt, int ;
#

#T=mhash - string mhash ( int hash, string data [, string key])
(PHP 3>= 3.0.9, PHP 4 )
mhash -- Compute hash
Description
string mhash ( int hash, string data [, string key])
mhash() applies a hash function specified by hash to the data and returns 
the resulting hash (also called digest). If the key is specified it will 
return the resulting HMAC. HMAC is keyed hashing for message 
authentication, or simply a message digest that depends on the specified 
key. Not all algorithms supported in mhash can be used in HMAC mode. In 
case of an error returns FALSE.   mhash_keygen_s2kUpMimetype Functions
#

#T=string mhash ( int hash, string data [, string key])
mhash ( ^!int hash, string data [, string key]);
#

#T=microtime - mixed microtime ( [bool get_as_float])
(PHP 3, PHP 4 )
microtime --  Return current Unix timestamp with microseconds 
Description
mixed microtime ( [bool get_as_float])
microtime() returns the current Unix timestamp with microseconds. This 
function is only available on operating systems that support the 
gettimeofday() system call. 
When called without the optional argument, this function returns the 
string "msec sec" where sec is the current time measured in the number of 
seconds since the Unix Epoch (0:00:00 January 1, 1970 GMT), and msec is 
the microseconds part. Both portions of the string are returned in units 
of seconds. 
When get_as_float is given, and evaluates to TRUE, microtime() will return 
a float. 
Note: The get_as_float parameter was added as of PHP 5.0.0. 
Example 1. microtime() example
  <?php

  function getmicrotime() { 
      list($usec, $sec) = explode(" ", microtime()); 
      return ((float)$usec + (float)$sec); 
  } 

  $time_start = getmicrotime();
      
  for ($i=0; $i < 1000; $i++){
      // do nothing, 1000 times
  }

  $time_end = getmicrotime();
  $time = $time_end - $time_start;

  echo "Did nothing in $time seconds\n";

  // with PHP 5 you can do the same this way:

  $time_start = microtime(1);

  for ($i=0; $i < 1000; $i++){
       // do nothing, 1000 times
  }

  $time_end = microtime(1);
  $time = $time_end - $time_start;

  echo "Did nothing in $time seconds\n";

  ?> 
See also time().   localtimeUpmktime
#

#T=mixed microtime ( [bool get_as_float])
microtime ( ^![bool get_as_float]);
#

#T=mime_content_type - string mime_content_type ( string filename)
(PHP 4 >= 4.3.0)
mime_content_type -- Detect MIME Content-type for a file
Description
string mime_content_type ( string filename)
Returns the MIME content type for a file as determined by using 
information from the magic.mime file. Content types are returned in MIME 
format, like text/plain or application/octet-stream. 
Example 1. mime_content_type() example
  <?php
  echo mime_content_type('php.gif') . "\n";
  echo mime_content_type('test.php');
  ?> 

The above example will output: 
image/gif
text/plain

  Mimetype FunctionsUpMicrosoft SQL Server functions
#

#T=string mime_content_type ( string filename)
mime_content_type ( ^!string filename);
#

#T=min - mixed min ( number arg1, number arg2 [, number ...])
(PHP 3, PHP 4 )
min -- Find lowest value
Description
mixed min ( number arg1, number arg2 [, number ...])

mixed min ( array numbers [, array ...])
min() returns the numerically lowest of the parameter values. 
If the first and only parameter is an array, min() returns the lowest 
value in that array. If the first parameter is an integer, string or 
float, you need at least two parameters and min() returns the smallest of 
these values. You can compare an unlimited number of values. 
Note: PHP will evaluate a non-numeric string as 0, but still return the 
string if it's seen as the numerically lowest value. If multiple 
arguments evaluate to 0, min() will use the first one it sees (the 
leftmost value). 
Example 1. Example uses of min()
  <?php
  echo min(2, 3, 1, 6, 7);  // 1
  echo min(array(2, 4, 5)); // 2

  echo min(0, 'hello');     // 0
  echo min('hello', 0);     // hello
  echo min('hello', -1);    // -1

  // With multiple arrays, min compares from left to right
  // so in our example: 2 == 2, but 4 < 5
  $val = min(array(2, 4, 8), array(2, 5, 1)); // array(2, 4, 8)

  // If both an array and non-array are given, the array
  // is never returned as it's considered the largest
  $val = min('string', array(2, 5, 7), 42);   // string
  ?> 
See also max() and count().   maxUpmt_getrandmax
#

#T=mixed min ( number arg1, number arg2 [, number ...])
min ( ^!number arg1, number arg2 [, number ...]);
#

#T=ming_setcubicthreshold - void ming_setcubicthreshold ( int threshold)
(PHP 4 >= 4.0.5)
ming_setcubicthreshold --  Set cubic threshold (?) 
Description
void ming_setcubicthreshold ( int threshold)
Warning
This function is currently not documented; only the argument list is 
available.
  Ming functions for FlashUpming_setscale
#

#T=void ming_setcubicthreshold ( int threshold)
ming_setcubicthreshold ( ^!int threshold);
#

#T=ming_setscale - void ming_setscale ( int scale)
(PHP 4 >= 4.0.5)
ming_setscale --  Set scale (?) 
Description
void ming_setscale ( int scale)
Warning
This function is currently not documented; only the argument list is 
available.
  ming_setcubicthresholdUpming_useswfversion
#

#T=void ming_setscale ( int scale)
ming_setscale ( ^!int scale);
#

#T=ming_useswfversion - void ming_useswfversion ( int version)
(PHP 4 >= 4.2.0)
ming_useswfversion --  Use SWF version (?) 
Description
void ming_useswfversion ( int version)
Warning
This function is currently not documented; only the argument list is 
available.
  ming_setscaleUpSWFAction
#

#T=void ming_useswfversion ( int version)
ming_useswfversion ( ^!int version);
#

#T=mkdir - bool mkdir ( string pathname [, int mode [, resource context]])
(PHP 3, PHP 4 )
mkdir -- Makes directory
Description
bool mkdir ( string pathname [, int mode [, resource context]])
Attempts to create the directory specified by pathname. 
Note that you probably want to specify the mode as an octal number, which 
means it should have a leading zero. The mode is also modified by the 
current umask, which you can change using umask(). 
Note: Mode is ignored on Windows, and became optional in PHP 4.2.0. 
The mode is 0777 by default, which means the widest possible access. For 
more information on modes, read the details on the chmod() page. 
<?php
mkdir("/path/to/my/dir", 0700);
?> 

Returns TRUE on success or FALSE on failure. 
Note: As of PHP 5.0.0 mkdir() can also be used with some url wrappers. 
Refer to Appendix I for a listing of which wrappers support mkdir(). 
Note: The context parameter was added as of PHP 5.0.0. 
Note: When safe mode is enabled, PHP checks whether the directory in 
which you are about to operate has the same UID (owner) as the script 
that is being executed.
See also rmdir().   lstatUpmove_uploaded_file
#

#T=bool mkdir ( string pathname [, int mode [, resource context]])
mkdir ( ^!string pathname [, int mode [, resource context]]);
#

#T=mktime - int mktime ( [int hour [, int minute [, int second [, int month [, int day 
(PHP 3, PHP 4 )
mktime -- Get Unix timestamp for a date
Description
int mktime ( [int hour [, int minute [, int second [, int month [, int day 
[, int year [, int is_dst]]]]]]])
Warning: Note the strange order of arguments, which differs from the order 
of arguments in a regular Unix mktime() call and which does not lend 
itself well to leaving out parameters from right to left (see below). It 
is a common error to mix these values up in a script. 
Returns the Unix timestamp corresponding to the arguments given. This 
timestamp is a long integer containing the number of seconds between the 
Unix Epoch (January 1 1970) and the time specified. 
Arguments may be left out in order from right to left; any arguments thus 
omitted will be set to the current value according to the local date and 
time. 
is_dst can be set to 1 if the time is during daylight savings time, 0 if 
it is not, or -1 (the default) if it is unknown whether the time is within 
daylight savings time or not. If it's unknown, PHP tries to figure it out 
itself. This can cause unexpected (but not incorrect) results. 
Note: is_dst was added in 3.0.10. 
mktime() is useful for doing date arithmetic and validation, as it will 
automatically calculate the correct value for out-of-range input. For 
example, each of the following lines produces the string "Jan-01-1998". 
Example 1. mktime() example
  <?php
  echo date("M-d-Y", mktime(0, 0, 0, 12, 32, 1997));
  echo date("M-d-Y", mktime(0, 0, 0, 13, 1, 1997));
  echo date("M-d-Y", mktime(0, 0, 0, 1, 1, 1998));
  echo date("M-d-Y", mktime(0, 0, 0, 1, 1, 98));
  ?> 

Year may be a two or four digit value, with values between 0-69 mapping to 
2000-2069 and 70-99 to 1970-1999 (on systems where time_t is a 32bit 
signed integer, as most common today, the valid range for year is 
somewhere between 1901 and 2038). 
Windows: Negative timestamps are not supported under any known version 
of Windows. Therefore the range of valid years includes only 1970 
through 2038. 
The last day of any given month can be expressed as the "0" day of the 
next month, not the -1 day. Both of the following examples will produce 
the string "The last day in Feb 2000 is: 29". Example 2. Last day of 
next month
  <?php
  $lastday = mktime(0, 0, 0, 3, 0, 2000);
  echo strftime("Last day in Feb 2000 is: %d", $lastday);
       
  $lastday = mktime(0, 0, 0, 4, -31, 2000);
  echo strftime("Last day in Feb 2000 is: %d", $lastday);
  ?> 
Date with year, month and day equal to zero is considered illegal 
(otherwise it what be regarded as 30.11.1999, which would be strange 
behavior). 
See also date() and time().   microtimeUpstrftime
#

#T=int mktime ( [int hour [, int minute [, int second [, int month [, int day 
mktime ( ^![int hour [, int minute [, int second [, int month [, int day ;
#

#T=money_format - string money_format ( string format, float number)
(PHP 4 >= 4.3.0)
money_format -- Formats a number as a currency string
Description
string money_format ( string format, float number)
money_format() returns a formatted version of number. This function wraps 
the C library function strfmon(), with the difference that this 
implementation converts only one number at a time. 
Note: The function money_format() is only defined if the system has 
strfmon capabilities. For example, Windows does not, so money_format() 
is undefined in Windows. 
The format specification consists of the following sequence: 
a % character
optional flags
optional field width
optional left precision
optional right precision
a required conversion character
Flags. One or more of the optional flags below can be used: 
=f
The character = followed by a a (single byte) character f to be used as 
the numeric fill character. The default fill character is space. 
^
Disable the use of grouping characters (as defined by the current 
locale). 
+ or (
Specify the formatting style for positive and negative numbers. If + is 
used, the locale's equivalent for + and - will be used. If ( is used, 
negative amounts are enclosed in parenthesis. If no specification is 
given, the default is +. 
!
Suppress the currency symbol from the output string. 
-
If present, it will make all fields left-justified (padded to the 
right), as opposed to the default which is for the fields to be 
right-justified (padded to the left). 
Field width. 
w
A decimal digit string specifying a minimum field width. Field will be 
right-justified unless the flag - is used. Default value is 0 (zero). 
Left precision. 
#n
The maximum number of digits (n) expected to the left of the decimal 
character (e.g. the decimal point). It is used usually to keep formatted 
output aligned in the same columns, using the fill character if the 
number of digits is less than n. If the number of actual digits is 
bigger than n, then this specification is ignored. 
If grouping has not been suppressed using the ^ flag, grouping 
separators will be inserted before the fill characters (if any) are 
added. Grouping separators will not be applied to fill characters, even 
if the fill character is a digit. 
To ensure alignment, any characters appearing before or after the number 
in the formatted output such as currency or sign symbols are padded as 
necessary with space characters to make their positive and negative 
formats an equal length. 
Right precision . 
.p
A period followed by the number of digits (p) after the decimal 
character. If the value of p is 0 (zero), the decimal character and the 
digits to its right will be omitted. If no right precision is included, 
the default will dictated by the current local in use. The amount being 
formatted is rounded to the specified number of digits prior to 
formatting. 
Conversion characters . 
i
The number is formatted according to the locale's international currency 
format (e.g. for the USA locale: USD 1,234.56). 
n
The number is formatted according to the locale's national currency 
format (e.g. for the de_DE locale: DM1.234,56). 
%
Returns the the % character. 
Note: The LC_MONETARY category of the locale settings, affects the 
behavior of this function. Use setlocale() to set to the appropriate 
default locale before using this function. 
Characters before and after the formatting string will be returned 
unchanged. 
Example 1. money_format() Example
We will use different locales and format specifications to 
illustrate the use of this function. 
  <?php

  $number = 1234.56;

  // let's print the international format for the en_US locale
  setlocale(LC_MONETARY, 'en_US');
  echo money_format('%i', $number) . "\n";  
  // USD 1,234.56

  // Italian national format with 2 decimals`
  setlocale(LC_MONETARY, 'it_IT');
  echo money_format('%.2n', $number) . "\n";
  // L. 1.234,56

  // Using a negative number
  $number = -1234.5672;

  // US national format, using () for negative numbers
  // and 10 digits for left precision
  setlocale(LC_MONETARY, 'en_US');
  echo money_format('%(#10n', $number) . "\n";
  // ($        1,234.57)

  // Similar format as above, adding the use of 2 digits of 
  right 
  // precision and '*' as a fill character
  echo money_format('%=*(#10.2n', $number) . "\n";
  // ($********1,234.57)
      
  // Let's justify to the left, with 14 positions of width, 8 
  digits of
  // left precision, 2 of right precision, withouth grouping 
  character
  // and using the international format for the de_DE locale.
  setlocale(LC_MONETARY, 'de_DE');
  echo money_format('%=*^-14#8.2i', 1234.56) . "\n";
  // DEM 1234,56****

  // Let's add some blurb before and after the conversion 
  specification
  setlocale(LC_MONETARY, 'en_GB');
  $fmt = 'The final value is %i (after a 10%% discount)';
  echo money_format($fmt, 1234.56) . "\n";
  // The final value is  GBP 1,234.56 (after a 10% discount)

  ?> 
See also: setlocale(), number_format(),sprintf(), printf() and sscanf().   metaphoneUpnl_langinfo
#

#T=string money_format ( string format, float number)
money_format ( ^!string format, float number);
#

#T=move_uploaded_file - bool move_uploaded_file ( string filename, string destination)
(PHP 4 >= 4.0.3)
move_uploaded_file -- Moves an uploaded file to a new location
Description
bool move_uploaded_file ( string filename, string destination)
This function checks to ensure that the file designated by filename is a 
valid upload file (meaning that it was uploaded via PHP's HTTP POST upload 
mechanism). If the file is valid, it will be moved to the filename given 
by destination. 
If filename is not a valid upload file, then no action will occur, and 
move_uploaded_file() will return FALSE. 
If filename is a valid upload file, but cannot be moved for some reason, 
no action will occur, and move_uploaded_file() will return FALSE. 
Additionally, a warning will be issued. 
This sort of check is especially important if there is any chance that 
anything done with uploaded files could reveal their contents to the user, 
or even to other users on the same system. 
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.
Note: move_uploaded_file() is not affected by the normal safe mode 
UID-restrictions. This is not unsafe because move_uploaded_file() only 
operates on files uploaded via PHP. 
Warning
If the destination file already exists, it will be overwritten. 

See also is_uploaded_file(), and the section Handling file uploads for a 
simple usage example.   mkdirUpparse_ini_file
#

#T=bool move_uploaded_file ( string filename, string destination)
move_uploaded_file ( ^!string filename, string destination);
#

#T=msession_connect - bool msession_connect ( string host, string port)
(PHP 4 >= 4.2.0)
msession_connect -- Connect to msession server 
Description
bool msession_connect ( string host, string port)
Warning
This function is currently not documented; only the argument list is 
available.
  Mohawk Software session handler functionsUpmsession_count
#

#T=bool msession_connect ( string host, string port)
msession_connect ( ^!string host, string port);
#

#T=msession_count - int msession_count ( void )
(PHP 4 >= 4.2.0)
msession_count -- Get session count 
Description
int msession_count ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  msession_connectUpmsession_create
#

#T=int msession_count ( void )
msession_count ( ^!void );
#

#T=msession_create - bool msession_create ( string session)
(PHP 4 >= 4.2.0)
msession_create -- Create a session 
Description
bool msession_create ( string session)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_countUpmsession_destroy
#

#T=bool msession_create ( string session)
msession_create ( ^!string session);
#

#T=msession_destroy - bool msession_destroy ( string name)
(PHP 4 >= 4.2.0)
msession_destroy -- Destroy a session 
Description
bool msession_destroy ( string name)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_createUpmsession_disconnect
#

#T=bool msession_destroy ( string name)
msession_destroy ( ^!string name);
#

#T=msession_disconnect - void msession_disconnect ( void )
(PHP 4 >= 4.2.0)
msession_disconnect -- Close connection to msession server 
Description
void msession_disconnect ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  msession_destroyUpmsession_find
#

#T=void msession_disconnect ( void )
msession_disconnect ( ^!void );
#

#T=msession_find - array msession_find ( string name, string value)
(PHP 4 >= 4.2.0)
msession_find -- Find value 
Description
array msession_find ( string name, string value)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_disconnectUpmsession_get_array
#

#T=array msession_find ( string name, string value)
msession_find ( ^!string name, string value);
#

#T=msession_get_array - array msession_get_array ( string session)
(PHP 4 >= 4.2.0)
msession_get_array -- Get array of ... ? 
Description
array msession_get_array ( string session)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_findUpmsession_get
#

#T=array msession_get_array ( string session)
msession_get_array ( ^!string session);
#

#T=msession_get - string msession_get ( string session, string name, string value)
(PHP 4 >= 4.2.0)
msession_get -- Get value from session 
Description
string msession_get ( string session, string name, string value)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_get_arrayUpmsession_getdata
msession_getdata
(no version information, might be only in CVS)
msession_getdata -- Get data ... ? 
Description
string msession_getdata ( string session)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_getUpmsession_inc
#

#T=string msession_get ( string session, string name, string value)
msession_get ( ^!string session, string name, string value);
#

#T=msession_inc - string msession_inc ( string session, string name)
(PHP 4 >= 4.2.0)
msession_inc -- Increment value in session 
Description
string msession_inc ( string session, string name)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_getdataUpmsession_list
#

#T=string msession_inc ( string session, string name)
msession_inc ( ^!string session, string name);
#

#T=msession_list - array msession_list ( void )
(PHP 4 >= 4.2.0)
msession_list -- List ... ? 
Description
array msession_list ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  msession_incUpmsession_listvar
#

#T=array msession_list ( void )
msession_list ( ^!void );
#

#T=msession_listvar - array msession_listvar ( string name)
(PHP 4 >= 4.2.0)
msession_listvar -- List sessions with variable
Description
array msession_listvar ( string name)
Returns an associative array of value/session for all sessions with a 
variable named name. 
Used for searching sessions with common attributes.   msession_listUpmsession_lock
#

#T=array msession_listvar ( string name)
msession_listvar ( ^!string name);
#

#T=msession_lock - int msession_lock ( string name)
(PHP 4 >= 4.2.0)
msession_lock -- Lock a session 
Description
int msession_lock ( string name)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_listvarUpmsession_plugin
#

#T=int msession_lock ( string name)
msession_lock ( ^!string name);
#

#T=msession_plugin - string msession_plugin ( string session, string val [, string param])
(PHP 4 >= 4.2.0)
msession_plugin -- Call an escape function within the msession personality 
plugin
Description
string msession_plugin ( string session, string val [, string param])
Warning
This function is currently not documented; only the argument list is 
available.
  msession_lockUpmsession_randstr
#

#T=string msession_plugin ( string session, string val [, string param])
msession_plugin ( ^!string session, string val [, string param]);
#

#T=msession_randstr - string msession_randstr ( int param)
(PHP 4 >= 4.2.0)
msession_randstr -- Get random string 
Description
string msession_randstr ( int param)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_pluginUpmsession_set_array
#

#T=string msession_randstr ( int param)
msession_randstr ( ^!int param);
#

#T=msession_set_array - bool msession_set_array ( string session, array tuples)
(PHP 4 >= 4.2.0)
msession_set_array -- Set array of ... 
Description
bool msession_set_array ( string session, array tuples)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_randstrUpmsession_set
#

#T=bool msession_set_array ( string session, array tuples)
msession_set_array ( ^!string session, array tuples);
#

#T=msession_set - bool msession_set ( string session, string name, string value)
(PHP 4 >= 4.2.0)
msession_set -- Set value in session 
Description
bool msession_set ( string session, string name, string value)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_set_arrayUpmsession_setdata
msession_setdata
(no version information, might be only in CVS)
msession_setdata -- Set data ... ?
Description
bool msession_setdata ( string session, string value)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_setUpmsession_timeout
#

#T=bool msession_set ( string session, string name, string value)
msession_set ( ^!string session, string name, string value);
#

#T=msession_timeout - int msession_timeout ( string session [, int param])
(PHP 4 >= 4.2.0)
msession_timeout -- Set/get session timeout 
Description
int msession_timeout ( string session [, int param])
Warning
This function is currently not documented; only the argument list is 
available.
  msession_setdataUpmsession_uniq
#

#T=int msession_timeout ( string session [, int param])
msession_timeout ( ^!string session [, int param]);
#

#T=msession_uniq - string msession_uniq ( int param)
(PHP 4 >= 4.2.0)
msession_uniq -- Get uniq id 
Description
string msession_uniq ( int param)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_timeoutUpmsession_unlock
#

#T=string msession_uniq ( int param)
msession_uniq ( ^!int param);
#

#T=msession_unlock - int msession_unlock ( string session, int key)
(PHP 4 >= 4.2.0)
msession_unlock -- Unlock a session 
Description
int msession_unlock ( string session, int key)
Warning
This function is currently not documented; only the argument list is 
available.
  msession_uniqUpmuscat functions
#

#T=int msession_unlock ( string session, int key)
msession_unlock ( ^!string session, int key);
#

#T=msg_get_queue - int msg_get_queue ( int key [, int perms])
(PHP 4 >= 4.3.0)
msg_get_queue --  Create or attach to a message queue 
Description
int msg_get_queue ( int key [, int perms])
msg_get_queue() returns an id that can be used to access the System V 
message queue with the given key. The first call creates the message queue 
with the optional perms (default: 0666). A second call to msg_get_queue() 
for the same key will return a different message queue identifier, but 
both identifiers access the same underlying message queue. If the message 
queue already exists, the perms will be ignored. 
See also: msg_remove_queue(), msg_receive(), msg_send(), msg_stat_queue() 
and msg_set_queue().   ftokUpmsg_receive
#

#T=int msg_get_queue ( int key [, int perms])
msg_get_queue ( ^!int key [, int perms]);
#

#T=msg_receive - bool msg_receive ( int queue, int desiredmsgtype, int msgtype, int 
(PHP 4 >= 4.3.0)
msg_receive --  Receive a message from a message queue 
Description
bool msg_receive ( int queue, int desiredmsgtype, int msgtype, int 
maxsize, mixed message [, bool unserialize [, int flags [, int 
errorcode]]])
msg_receive() will receive the first message from the specified queue of 
the type specified by desiredmsgtype. The type of the message that was 
received will be stored in msgtype. The maximum size of message to be 
accepted is specified by the maxsize; if the message in the queue is 
larger than this size the function will fail (unless you set flags as 
described below). The received message will be stored in message, unless 
there were errors receiving the message, in which case the optional 
errorcode will be set to the value of the system errno variable to help 
you identify the cause. 
If desiredmsgtype is 0, the message from the front of the queue is 
returned. If desiredmsgtype is greater than 0, then the first message of 
that type is returned. If desiredmsgtype is less than 0, the first message 
on the queue with the lowest type less than or equal to the absolute value 
of desiredmsgtype will be read. If no messages match the criteria, your 
script will wait until a suitable message arrives on the queue. You can 
prevent the script from blocking by specifying MSG_IPC_NOWAIT in the flags 
parameter. 
unserialize defaults to TRUE; if it is set to TRUE, the message is treated 
as though it was serialized using the same mechanism as the session 
module. The message will be unserialized and then returned to your script. 
This allows you to easily receive arrays or complex object structures from 
other PHP scripts, or if you are using the WDDX serializer, from any WDDX 
compatible source. If unserialize is FALSE, the message will be returned 
as a binary-safe string. 
The optional flags allows you to pass flags to the low-level msgrcv system 
call. It defaults to 0, but you may specify one or more of the following 
values (by adding or ORing them together). 
Table 1. Flag values for msg_receive
MSG_IPC_NOWAITIf there are no messages of the desiredmsgtype, return 
immediately and do not wait. The function will fail and return an 
integer value corresponding to ENOMSG. 
MSG_EXCEPTUsing this flag in combination with a desiredmsgtype 
greater than 0 will cause the function to receive the first message 
that is not equal to desiredmsgtype.
MSG_NOERRORIf the message is longer than maxsize, setting this flag 
will truncate the message to maxsize and will not signal an error. 

Upon successful completion the message queue data structure is updated as 
follows: msg_lrpid is set to the process-ID of the calling process, 
msg_qnum is decremented by 1 and msg_rtime is set to the current time. 
msg_receive() returns TRUE on success or FALSE on failure. If the function 
fails, the optional errorcode will be set to the value of the system errno 
variable. 
See also: msg_remove_queue(), msg_send(), msg_stat_queue() and 
msg_set_queue().   msg_get_queueUpmsg_remove_queue
#

#T=bool msg_receive ( int queue, int desiredmsgtype, int msgtype, int 
msg_receive ( ^!int queue, int desiredmsgtype, int msgtype, int ;
#

#T=msg_remove_queue - bool msg_remove_queue ( int queue)
(PHP 4 >= 4.3.0)
msg_remove_queue --  Destroy a message queue 
Description
bool msg_remove_queue ( int queue)
msg_remove_queue() destroys the message queue specified by the queue. Only 
use this function when all processes have finished working with the 
message queue and you need to release the system resources held by it. 
See also: msg_remove_queue(), msg_receive(), msg_stat_queue() and 
msg_set_queue().   msg_receiveUpmsg_send
#

#T=bool msg_remove_queue ( int queue)
msg_remove_queue ( ^!int queue);
#

#T=msg_send - bool msg_send ( int queue, int msgtype, mixed message [, bool serialize [, 
(PHP 4 >= 4.3.0)
msg_send --  Send a message to a message queue 
Description
bool msg_send ( int queue, int msgtype, mixed message [, bool serialize [, 
bool blocking [, int errorcode]]])
msg_send() sends a message of type msgtype (which MUST be greater than 0) 
to a the message queue specified by queue. 
If the message is too large to fit in the queue, your script will wait 
until another process reads messages from the queue and frees enough space 
for your message to be sent. This is called blocking; you can prevent 
blocking by setting the optional blocking parameter to FALSE, in which 
case msg_send() will immediately return FALSE if the message is too big 
for the queue, and set the optional errorcode to EAGAIN, indicating that 
you should try to send your message again a little later on. 
The optional serialize controls how the message is sent. serialize 
defaults to TRUE which means that the message is serialized using the same 
mechanism as the session module before being sent to the queue. This 
allows complex arrays and objects to be sent to other PHP scripts, or if 
you are using the WDDX serializer, to any WDDX compatible client. 
Upon successful completion the message queue data structure is updated as 
follows: msg_lspid is set to the process-ID of the calling process, 
msg_qnum is incremented by 1 and msg_stime is set to the current time. 
See also: msg_remove_queue(), msg_receive(), msg_stat_queue() and 
msg_set_queue().   msg_remove_queueUpmsg_set_queue
#

#T=bool msg_send ( int queue, int msgtype, mixed message [, bool serialize [, 
msg_send ( ^!int queue, int msgtype, mixed message [, bool serialize [, ;
#

#T=msg_set_queue - bool msg_set_queue ( int queue, array data)
(PHP 4 >= 4.3.0)
msg_set_queue --  Set information in the message queue data structure 
Description
bool msg_set_queue ( int queue, array data)
msg_set_queue() allows you to change the values of the msg_perm.uid, 
msg_perm.gid, msg_perm.mode and msg_qbytes fields of the underlying 
message queue data structure. You specify the values you require by 
setting the value of the keys that you require in the data array. 
Changing the data structure will require that PHP be running as the same 
user that created the the queue, owns the queue (as determined by the 
existing msg_perm.xxx fields), or be running with root privileges. root 
privileges are required to raise the msg_qbytes values above the system 
defined limit. 
See also: msg_remove_queue(), msg_receive(), msg_stat_queue() and 
msg_set_queue().   msg_sendUpmsg_stat_queue
#

#T=bool msg_set_queue ( int queue, array data)
msg_set_queue ( ^!int queue, array data);
#

#T=msg_stat_queue - array msg_stat_queue ( int queue)
(PHP 4 >= 4.3.0)
msg_stat_queue --  Returns information from the message queue data 
structure 
Description
array msg_stat_queue ( int queue)
msg_stat_queue() returns the message queue meta data for the message queue 
specified by the queue. This is useful, for example, to determine which 
process sent the message that was just received. 
The return value is an array whose keys and values have the following 
meanings: 
Table 1. Array structure for msg_stat_queue
msg_perm.uidThe uid of the owner of the queue. 
msg_perm.gidThe gid of the owner of the queue. 
msg_perm.modeThe file access mode of the queue. 
msg_stimeThe time that the last message was sent to the queue. 
msg_rtimeThe time that the last message was received from the queue. 

msg_ctimeThe time that the queue was last changed. 
msg_qnumThe number of messages waiting to be read from the queue. 
msg_qbytesThe number of bytes of space currently available in the 
queue to hold sent messages until they are received. 
msg_lspidThe pid of the process that sent the last message to the 
queue. 
msg_lrpidThe pid of the process that received the last message from 
the queue. 

See also: msg_remove_queue(), msg_receive(), msg_stat_queue() and 
msg_set_queue().   msg_set_queueUpsem_acquire
#

#T=array msg_stat_queue ( int queue)
msg_stat_queue ( ^!int queue);
#

#T=msql_affected_rows - int msql_affected_rows ( int query_identifier)
(PHP 3>= 3.0.6, PHP 4 )
msql_affected_rows -- Returns number of affected rows
Description
int msql_affected_rows ( int query_identifier)
Returns number of affected ("touched") rows by a specific query (i.e. the 
number of rows returned by a SELECT, the number of rows modified by an 
update, or the number of rows removed by a delete). 
See also: msql_query().   mSQL functionsUpmsql_close
#

#T=int msql_affected_rows ( int query_identifier)
msql_affected_rows ( ^!int query_identifier);
#

#T=msql_close - int msql_close ( int link_identifier)
(PHP 3, PHP 4 )
msql_close -- Close mSQL connection
Description
int msql_close ( int link_identifier)
Returns TRUE on success, FALSE on error. 
msql_close() closes the link to a mSQL database that's associated with the 
specified link identifier. If the link identifier isn't specified, the 
last opened link is assumed. 
Note that this isn't usually necessary, as non-persistent open links are 
automatically closed at the end of the script's execution. 
msql_close() will not close persistent links generated by msql_pconnect(). 

See also: msql_connect() and msql_pconnect().   msql_affected_rowsUpmsql_connect
#

#T=int msql_close ( int link_identifier)
msql_close ( ^!int link_identifier);
#

#T=msql_connect - int msql_connect ( [string hostname [, string server [, string username [, 
(PHP 3, PHP 4 )
msql_connect -- Open mSQL connection
Description
int msql_connect ( [string hostname [, string server [, string username [, 
string password]]]])
msql_connect() establishes a connection to a mSQL server. The server 
parameter can also include a port number. e.g. "hostname:port". It 
defaults to 'localhost'. 
Returns a positive mSQL link identifier on success, or FALSE on error. 
In case a second call is made to msql_connect() with the same arguments, 
no new link will be established, but instead, the link identifier of the 
already opened link will be returned. 
The link to the server will be closed as soon as the execution of the 
script ends, unless it's closed earlier by explicitly calling 
msql_close(). 
See also msql_pconnect() and msql_close().   msql_closeUpmsql_create_db
#

#T=int msql_connect ( [string hostname [, string server [, string username [, 
msql_connect ( ^![string hostname [, string server [, string username [, ;
#

#T=msql_create_db - int msql_create_db ( string database_name [, int link_identifier])
(PHP 3, PHP 4 )
msql_create_db -- Create mSQL database
Description
int msql_create_db ( string database_name [, int link_identifier])
msql_create_db() attempts to create a new database on the server 
associated with the specified link identifier. 
See also msql_drop_db().   msql_connectUpmsql_createdb
#

#T=int msql_create_db ( string database_name [, int link_identifier])
msql_create_db ( ^!string database_name [, int link_identifier]);
#

#T=msql_createdb - int msql_createdb ( string database_name [, int link_identifier])
(PHP 3, PHP 4 )
msql_createdb -- Create mSQL database
Description
int msql_createdb ( string database_name [, int link_identifier])
Identical to msql_create_db().   msql_create_dbUpmsql_data_seek
#

#T=int msql_createdb ( string database_name [, int link_identifier])
msql_createdb ( ^!string database_name [, int link_identifier]);
#

#T=msql_data_seek - int msql_data_seek ( int query_identifier, int row_number)
(PHP 3, PHP 4 )
msql_data_seek -- Move internal row pointer
Description
int msql_data_seek ( int query_identifier, int row_number)
msql_data_seek() moves the internal row pointer of the mSQL result 
associated with the specified query identifier to point to the specified 
row number. The next call to msql_fetch_row() would return that row. 
Returns TRUE on success or FALSE on failure. 
See also msql_fetch_row().   msql_createdbUpmsql_dbname
#

#T=int msql_data_seek ( int query_identifier, int row_number)
msql_data_seek ( ^!int query_identifier, int row_number);
#

#T=msql_dbname - string msql_dbname ( int query_identifier, int i)
(PHP 3, PHP 4 )
msql_dbname -- Get current mSQL database name
Description
string msql_dbname ( int query_identifier, int i)
msql_dbname() returns the database name stored in position i of the result 
pointer returned from the msql_listdbs() function. The msql_numrows() 
function can be used to determine how many database names are available.   msql_data_seekUpmsql_drop_db
#

#T=string msql_dbname ( int query_identifier, int i)
msql_dbname ( ^!int query_identifier, int i);
#

#T=msql_drop_db - int msql_drop_db ( string database_name, int link_identifier)
(PHP 3, PHP 4 )
msql_drop_db -- Drop (delete) mSQL database
Description
int msql_drop_db ( string database_name, int link_identifier)
Returns TRUE on success or FALSE on failure. 
msql_drop_db() attempts to drop (remove) an entire database from the 
server associated with the specified link identifier. 
See also: msql_create_db().   msql_dbnameUpmsql_dropdb
msql_dropdb
msql_dropdb -- Drop (delete) mSQL database
Description
See msql_drop_db().   msql_drop_dbUpmsql_error
#

#T=int msql_drop_db ( string database_name, int link_identifier)
msql_drop_db ( ^!string database_name, int link_identifier);
#

#T=msql_error - string msql_error ( [int link_identifier])
(PHP 3, PHP 4 )
msql_error -- Returns error message of last msql call
Description
string msql_error ( [int link_identifier])
Errors coming back from the mSQL database backend no longer issue 
warnings. Instead, use these functions to retrieve the error string.   msql_dropdbUpmsql_fetch_array
#

#T=string msql_error ( [int link_identifier])
msql_error ( ^![int link_identifier]);
#

#T=msql_fetch_array - int msql_fetch_array ( int query_identifier [, int result_type])
(PHP 3, PHP 4 )
msql_fetch_array -- Fetch row as array
Description
int msql_fetch_array ( int query_identifier [, int result_type])
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
msql_fetch_array() is an extended version of msql_fetch_row(). In addition 
to storing the data in the numeric indices of the result array, it also 
stores the data in associative indices, using the field names as keys. 
The second optional argument result_type in msql_fetch_array() is a 
constant and can take the following values: MSQL_ASSOC, MSQL_NUM, and 
MSQL_BOTH. 
Be careful if you are retrieving results from a query that may return a 
record that contains only one field that has a value of 0 (or an empty 
string, or NULL). 
An important thing to note is that using msql_fetch_array() is NOT 
significantly slower than using msql_fetch_row(), while it provides a 
significant added value. 
See also msql_fetch_row().   msql_errorUpmsql_fetch_field
#

#T=int msql_fetch_array ( int query_identifier [, int result_type])
msql_fetch_array ( ^!int query_identifier [, int result_type]);
#

#T=msql_fetch_field - object msql_fetch_field ( int query_identifier, int field_offset)
(PHP 3, PHP 4 )
msql_fetch_field -- Get field information
Description
object msql_fetch_field ( int query_identifier, int field_offset)
Returns an object containing field information 
msql_fetch_field() can be used in order to obtain information about fields 
in a certain query result. If the field offset isn't specified, the next 
field that wasn't yet retrieved by msql_fetch_field() is retrieved. 
The properties of the object are: 
name - column name 
table - name of the table the column belongs to 
not_null - 1 if the column cannot be NULL 
primary_key - 1 if the column is a primary key 
unique - 1 if the column is a unique key 
type - the type of the column 
See also msql_field_seek().   msql_fetch_arrayUpmsql_fetch_object
#

#T=object msql_fetch_field ( int query_identifier, int field_offset)
msql_fetch_field ( ^!int query_identifier, int field_offset);
#

#T=msql_fetch_object - int msql_fetch_object ( int query_identifier [, int result_type])
(PHP 3, PHP 4 )
msql_fetch_object -- Fetch row as object
Description
int msql_fetch_object ( int query_identifier [, int result_type])
Returns an object with properties that correspond to the fetched row, or 
FALSE if there are no more rows. 
msql_fetch_object() is similar to msql_fetch_array(), with one difference 
- an object is returned, instead of an array. Indirectly, that means that 
you can only access the data by the field names, and not by their offsets 
(numbers are illegal property names). 
The optional second argument result_type in msql_fetch_array() is a 
constant and can take the following values: MSQL_ASSOC, MSQL_NUM, and 
MSQL_BOTH. 
Speed-wise, the function is identical to msql_fetch_array(), and almost as 
quick as msql_fetch_row() (the difference is insignificant). 
See also: msql_fetch_array() and msql_fetch_row().   msql_fetch_fieldUpmsql_fetch_row
#

#T=int msql_fetch_object ( int query_identifier [, int result_type])
msql_fetch_object ( ^!int query_identifier [, int result_type]);
#

#T=msql_fetch_row - array msql_fetch_row ( int query_identifier)
(PHP 3, PHP 4 )
msql_fetch_row -- Get row as enumerated array
Description
array msql_fetch_row ( int query_identifier)
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
msql_fetch_row() fetches one row of data from the result associated with 
the specified query identifier. The row is returned as an array. Each 
result column is stored in an array offset, starting at offset 0. 
Subsequent call to msql_fetch_row() would return the next row in the 
result set, or FALSE if there are no more rows. 
See also: msql_fetch_array(), msql_fetch_object(), msql_data_seek(), and 
msql_result().   msql_fetch_objectUpmsql_field_seek
#

#T=array msql_fetch_row ( int query_identifier)
msql_fetch_row ( ^!int query_identifier);
#

#T=msql_field_seek - int msql_field_seek ( int query_identifier, int field_offset)
(PHP 3, PHP 4 )
msql_field_seek -- Set field offset
Description
int msql_field_seek ( int query_identifier, int field_offset)
Seeks to the specified field offset. If the next call to 
msql_fetch_field() won't include a field offset, this field would be 
returned. 
See also: msql_fetch_field().   msql_fetch_rowUpmsql_fieldflags
#

#T=int msql_field_seek ( int query_identifier, int field_offset)
msql_field_seek ( ^!int query_identifier, int field_offset);
#

#T=msql_fieldflags - string msql_fieldflags ( int query_identifier, int i)
(PHP 3, PHP 4 )
msql_fieldflags -- Get field flags
Description
string msql_fieldflags ( int query_identifier, int i)
msql_fieldflags() returns the field flags of the specified field. 
Currently this is either, "not NULL", "primary key", a combination of the 
two or "" (an empty string).   msql_field_seekUpmsql_fieldlen
#

#T=string msql_fieldflags ( int query_identifier, int i)
msql_fieldflags ( ^!int query_identifier, int i);
#

#T=msql_fieldlen - int msql_fieldlen ( int query_identifier, int i)
(PHP 3, PHP 4 )
msql_fieldlen -- Get field length
Description
int msql_fieldlen ( int query_identifier, int i)
msql_fieldlen() returns the length of the specified field.   msql_fieldflagsUpmsql_fieldname
#

#T=int msql_fieldlen ( int query_identifier, int i)
msql_fieldlen ( ^!int query_identifier, int i);
#

#T=msql_fieldname - string msql_fieldname ( int query_identifier, int field)
(PHP 3, PHP 4 )
msql_fieldname -- Get field name
Description
string msql_fieldname ( int query_identifier, int field)
msql_fieldname() returns the name of the specified field. query_identifier 
is the query identifier, and field is the field index. 
msql_fieldname($result, 2); will return the name of the second field in 
the result associated with the result identifier.   msql_fieldlenUpmsql_fieldtable
#

#T=string msql_fieldname ( int query_identifier, int field)
msql_fieldname ( ^!int query_identifier, int field);
#

#T=msql_fieldtable - int msql_fieldtable ( int query_identifier, int field)
(PHP 3, PHP 4 )
msql_fieldtable -- Get table name for field
Description
int msql_fieldtable ( int query_identifier, int field)
Returns the name of the table field was fetched from.   msql_fieldnameUpmsql_fieldtype
#

#T=int msql_fieldtable ( int query_identifier, int field)
msql_fieldtable ( ^!int query_identifier, int field);
#

#T=msql_fieldtype - string msql_fieldtype ( int query_identifier, int i)
(PHP 3, PHP 4 )
msql_fieldtype -- Get field type
Description
string msql_fieldtype ( int query_identifier, int i)
msql_fieldtype() is similar to the msql_fieldname() function. The 
arguments are identical, but the field type is returned. This will be one 
of "int", "char" or "real".   msql_fieldtableUpmsql_free_result
#

#T=string msql_fieldtype ( int query_identifier, int i)
msql_fieldtype ( ^!int query_identifier, int i);
#

#T=msql_free_result - int msql_free_result ( int query_identifier)
(PHP 3, PHP 4 )
msql_free_result -- Free result memory
Description
int msql_free_result ( int query_identifier)
msql_free_result() frees the memory associated with query_identifier. When 
PHP completes a request, this memory is freed automatically, so you only 
need to call this function when you want to make sure you don't use too 
much memory while the script is running.   msql_fieldtypeUpmsql_freeresult
msql_freeresult
msql_freeresult -- Free result memory
Description
See msql_free_result()  msql_free_resultUpmsql_list_dbs
#

#T=int msql_free_result ( int query_identifier)
msql_free_result ( ^!int query_identifier);
#

#T=msql_list_dbs - int msql_list_dbs ( void )
(PHP 3, PHP 4 )
msql_list_dbs -- List mSQL databases on server
Description
int msql_list_dbs ( void )
msql_list_dbs() will return a result pointer containing the databases 
available from the current msql daemon. Use the msql_dbname() function to 
traverse this result pointer.   msql_freeresultUpmsql_list_fields
#

#T=int msql_list_dbs ( void )
msql_list_dbs ( ^!void );
#

#T=msql_list_fields - int msql_list_fields ( string database, string tablename)
(PHP 3, PHP 4 )
msql_list_fields -- List result fields
Description
int msql_list_fields ( string database, string tablename)
msql_list_fields() retrieves information about the given tablename. 
Arguments are the database name and the table name. A result pointer is 
returned which can be used with msql_fieldflags(), msql_fieldlen(), 
msql_fieldname(), and msql_fieldtype(). A query identifier is a positive 
integer. The function returns -1 if a error occurs. A string describing 
the error will be placed in $phperrmsg, and unless the function was called 
as @msql_list_fields() then this error string will also be printed out. 
See also msql_error().   msql_list_dbsUpmsql_list_tables
#

#T=int msql_list_fields ( string database, string tablename)
msql_list_fields ( ^!string database, string tablename);
#

#T=msql_list_tables - int msql_list_tables ( string database)
(PHP 3, PHP 4 )
msql_list_tables -- List tables in an mSQL database
Description
int msql_list_tables ( string database)
msql_list_tables() takes a database name and result pointer much like the 
msql() function. The msql_tablename() function should be used to extract 
the actual table names from the result pointer.   msql_list_fieldsUpmsql_listdbs
msql_listdbs
msql_listdbs -- List mSQL databases on server
Description
See msql_list_dbs().   msql_list_tablesUpmsql_listfields
msql_listfields
msql_listfields -- List result fields
Description
See msql_list_fields().   msql_listdbsUpmsql_listtables
msql_listtables
msql_listtables -- List tables in an mSQL database
Description
See msql_list_tables().   msql_listfieldsUpmsql_num_fields
#

#T=int msql_list_tables ( string database)
msql_list_tables ( ^!string database);
#

#T=msql_num_fields - int msql_num_fields ( int query_identifier)
(PHP 3, PHP 4 )
msql_num_fields -- Get number of fields in result
Description
int msql_num_fields ( int query_identifier)
msql_num_fields() returns the number of fields in a result set. 
See also: msql(), msql_query(), msql_fetch_field(), and msql_num_rows().   msql_listtablesUpmsql_num_rows
#

#T=int msql_num_fields ( int query_identifier)
msql_num_fields ( ^!int query_identifier);
#

#T=msql_num_rows - int msql_num_rows ( resource query_identifier)
(PHP 3, PHP 4 )
msql_num_rows -- Get number of rows in result
Description
int msql_num_rows ( resource query_identifier)
msql_num_rows() returns the number of rows in a result set. 
See also: msql(), msql_query(), and msql_fetch_row().   msql_num_fieldsUpmsql_numfields
#

#T=int msql_num_rows ( resource query_identifier)
msql_num_rows ( ^!resource query_identifier);
#

#T=msql_numfields - int msql_numfields ( int query_identifier)
(PHP 3, PHP 4 )
msql_numfields -- Get number of fields in result
Description
int msql_numfields ( int query_identifier)
Identical to msql_num_fields().   msql_num_rowsUpmsql_numrows
#

#T=int msql_numfields ( int query_identifier)
msql_numfields ( ^!int query_identifier);
#

#T=msql_numrows - int msql_numrows ( void )
(PHP 3, PHP 4 )
msql_numrows -- Get number of rows in result
Description
int msql_numrows ( void )
Identical to msql_num_rows().   msql_numfieldsUpmsql_pconnect
#

#T=int msql_numrows ( void )
msql_numrows ( ^!void );
#

#T=msql_pconnect - int msql_pconnect ( [string server [, string username [, string 
(PHP 3, PHP 4 )
msql_pconnect -- Open persistent mSQL connection
Description
int msql_pconnect ( [string server [, string username [, string 
password]]])
msql_pconnect() acts very much like msql_connect() with two major 
differences. 
First, when connecting, the function would first try to find a 
(persistent) link that's already open with the same host. If one is found, 
an identifier for it will be returned instead of opening a new connection. 

Second, the connection to the SQL server will not be closed when the 
execution of the script ends. Instead, the link will remain open for 
future use (msql_close() will not close links established by 
msql_pconnect()). 
Returns a positive mSQL persistent link identifier on success, or FALSE on 
error. 
This type of links is therefore called 'persistent'.   msql_numrowsUpmsql_query
#

#T=int msql_pconnect ( [string server [, string username [, string 
msql_pconnect ( ^![string server [, string username [, string ;
#

#T=msql_query - int msql_query ( string query, int link_identifier)
(PHP 3, PHP 4 )
msql_query -- Send mSQL query
Description
int msql_query ( string query, int link_identifier)
msql_query() sends a query to the currently active database on the server 
that's associated with the specified link identifier. If the link 
identifier isn't specified, the last opened link is assumed. If no link is 
open, the function tries to establish a link as if msql_connect() was 
called, and use it. 
Returns a positive mSQL query identifier on success, or FALSE on error. 
Example 1. msql_query() example
  <?php 
  $link = msql_connect("dbserver")
     or die("unable to connect to msql server: " . 
msql_error());
  msql_select_db("db", $link)
     or die("unable to select database 'db': " . msql_error());

  $result = msql_query("SELECT * FROM table WHERE id=1", $link);
  if (!$result) {
     die("query failed: " . msql_error());
  }

  while ($row = msql_fetch_array($result)) {
      echo $row["id"];
  }
  ?> 
See also msql(), msql_select_db(), and msql_connect().   msql_pconnectUpmsql_regcase
msql_regcase
msql_regcase --  Make regular expression for case insensitive match 
Description
See sql_regcase().   msql_queryUpmsql_result
#

#T=int msql_query ( string query, int link_identifier)
msql_query ( ^!string query, int link_identifier);
#

#T=msql_result - int msql_result ( int query_identifier, int i, mixed field)
(PHP 3, PHP 4 )
msql_result -- Get result data
Description
int msql_result ( int query_identifier, int i, mixed field)
Returns the contents of the cell at the row and offset in the specified 
mSQL result set. 
msql_result() returns the contents of one cell from a mSQL result set. The 
field argument can be the field's offset, or the field's name, or the 
field's table dot field's name (fieldname.tablename). If the column name 
has been aliased ('select foo as bar from ...'), use the alias instead of 
the column name. 
When working on large result sets, you should consider using one of the 
functions that fetch an entire row (specified below). As these functions 
return the contents of multiple cells in one function call, they're MUCH 
quicker than msql_result(). Also, note that specifying a numeric offset 
for the field argument is much quicker than specifying a fieldname or 
tablename.fieldname argument. 
Recommended high-performance alternatives: msql_fetch_row(), 
msql_fetch_array(), and msql_fetch_object().   msql_regcaseUpmsql_select_db
#

#T=int msql_result ( int query_identifier, int i, mixed field)
msql_result ( ^!int query_identifier, int i, mixed field);
#

#T=msql_select_db - int msql_select_db ( string database_name, int link_identifier)
(PHP 3, PHP 4 )
msql_select_db -- Select mSQL database
Description
int msql_select_db ( string database_name, int link_identifier)
Returns TRUE on success, FALSE on error. 
msql_select_db() sets the current active database on the server that's 
associated with the specified link identifier. If no link identifier is 
specified, the last opened link is assumed. If no link is open, the 
function will try to establish a link as if msql_connect() was called, and 
use it. 
Every subsequent call to msql_query() will be made on the active database. 

See also msql_connect(), msql_pconnect(), and msql_query().   msql_resultUpmsql_selectdb
msql_selectdb
msql_selectdb -- Select mSQL database
Description
See msql_select_db().   msql_select_dbUpmsql_tablename
#

#T=int msql_select_db ( string database_name, int link_identifier)
msql_select_db ( ^!string database_name, int link_identifier);
#

#T=msql_tablename - string msql_tablename ( int query_identifier, int field)
(PHP 3, PHP 4 )
msql_tablename -- Get table name of field
Description
string msql_tablename ( int query_identifier, int field)
msql_tablename() takes a result pointer returned by the msql_list_tables() 
function as well as an integer index and returns the name of a table. The 
msql_numrows() function may be used to determine the number of tables in 
the result pointer. Example 1. msql_tablename() example
  <?php 
  msql_connect("localhost");
  $result = msql_list_tables("wisconsin");
  $i = 0;
  while ($i < msql_numrows($result)) {
      $tb_names[$i] = msql_tablename($result, $i);
      echo $tb_names[$i] . "<br />";
      $i++; 
  }
  ?> 

  msql_selectdbUpmsql
#

#T=string msql_tablename ( int query_identifier, int field)
msql_tablename ( ^!int query_identifier, int field);
#

#T=msql - int msql ( string database, string query, int link_identifier)
(PHP 3, PHP 4 )
msql -- Send mSQL query
Description
int msql ( string database, string query, int link_identifier)
Returns a positive mSQL query identifier to the query result, or FALSE on 
error. 
msql() selects a database and executes a query on it. If the optional link 
identifier isn't specified, the function will try to find an open link to 
the mSQL server and if no such link is found it'll try to create one as if 
msql_connect() was called with no arguments (see msql_connect()).   msql_tablenameUpMySQL Functions
#

#T=int msql ( string database, string query, int link_identifier)
msql ( ^!string database, string query, int link_identifier);
#

#T=mssql_bind - bool mssql_bind ( resource stmt, string param_name, mixed var, int type [, 
(PHP 4 >= 4.1.0)
mssql_bind --  Adds a parameter to a stored procedure or a remote stored 
procedure 
Description
bool mssql_bind ( resource stmt, string param_name, mixed var, int type [, 
int is_output [, int is_null [, int maxlen]]])
Warning
This function is currently not documented; only the argument list is 
available.

See also mssql_execute(), mssql_free_statement(), and mssql_init().   Microsoft SQL Server functionsUpmssql_close
#

#T=bool mssql_bind ( resource stmt, string param_name, mixed var, int type [, 
mssql_bind ( ^!resource stmt, string param_name, mixed var, int type [, ;
#

#T=mssql_close - bool mssql_close ( [resource link_identifier])
(PHP 3, PHP 4 )
mssql_close -- Close MS SQL Server connection
Description
bool mssql_close ( [resource link_identifier])
mssql_close() closes the link to a MS SQL Server database that's 
associated with the specified link identifier. If the link identifier 
isn't specified, the last opened link is assumed. 
Returns TRUE on success or FALSE on failure. 
Note that this isn't usually necessary, as non-persistent open links are 
automatically closed at the end of the script's execution. 
mssql_close() will not close persistent links generated by 
mssql_pconnect(). 
See also mssql_connect(), and mssql_pconnect().   mssql_bindUpmssql_connect
#

#T=bool mssql_close ( [resource link_identifier])
mssql_close ( ^![resource link_identifier]);
#

#T=mssql_connect - int mssql_connect ( [string servername [, string username [, string 
(PHP 3, PHP 4 )
mssql_connect -- Open MS SQL server connection
Description
int mssql_connect ( [string servername [, string username [, string 
password]]])
Returns: A positive MS SQL link identifier on success, or FALSE on error. 
mssql_connect() establishes a connection to a MS SQL server. The 
servername argument has to be a valid servername that is defined in the 
'interfaces' file. 
In case a second call is made to mssql_connect() with the same arguments, 
no new link will be established, but instead, the link identifier of the 
already opened link will be returned. 
The link to the server will be closed as soon as the execution of the 
script ends, unless it's closed earlier by explicitly calling 
mssql_close(). 
See also mssql_pconnect(), mssql_close().   mssql_closeUpmssql_data_seek
#

#T=int mssql_connect ( [string servername [, string username [, string 
mssql_connect ( ^![string servername [, string username [, string ;
#

#T=mssql_data_seek - bool mssql_data_seek ( resource result_identifier, int row_number)
(PHP 3, PHP 4 )
mssql_data_seek -- Moves internal row pointer
Description
bool mssql_data_seek ( resource result_identifier, int row_number)
Returns TRUE on success or FALSE on failure. 
mssql_data_seek() moves the internal row pointer of the MS SQL result 
associated with the specified result identifier to point to the specified 
row number, first row being number 0. The next call to mssql_fetch_row() 
would return that row. 
See also mssql_data_seek().   mssql_connectUpmssql_execute
#

#T=bool mssql_data_seek ( resource result_identifier, int row_number)
mssql_data_seek ( ^!resource result_identifier, int row_number);
#

#T=mssql_execute - mixed mssql_execute ( resource stmt [, bool skip_results])
(PHP 4 >= 4.1.0)
mssql_execute --  Executes a stored procedure on a MS SQL server database 
Description
mixed mssql_execute ( resource stmt [, bool skip_results])
Warning
This function is currently not documented; only the argument list is 
available.

Note: If the stored procedure returns parameters or a return value these 
will be available after the call to mssql_execute() unless the stored 
procedure returns more than one result set. In that case use 
mssql_next_result() to shift through the results. When the last result 
has been processed the output parameters and return values will be 
available. 
See also mssql_bind(), mssql_free_statement(), and mssql_init().   mssql_data_seekUpmssql_fetch_array
#

#T=mixed mssql_execute ( resource stmt [, bool skip_results])
mssql_execute ( ^!resource stmt [, bool skip_results]);
#

#T=mssql_fetch_array - array mssql_fetch_array ( resource result [, int result_type])
(PHP 3, PHP 4 )
mssql_fetch_array --  Fetch a result row as an associative array, a 
numeric array, or both 
Description
array mssql_fetch_array ( resource result [, int result_type])
Returns: An array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
mssql_fetch_array() is an extended version of mssql_fetch_row(). In 
addition to storing the data in the numeric indices of the result array, 
it also stores the data in associative indices, using the field names as 
keys. 
An important thing to note is that using mssql_fetch_array() is NOT 
significantly slower than using mssql_fetch_row(), while it provides a 
significant added value. 
Note: Field names returned by this function are case-sensitive.
For further details, also see mssql_fetch_row().   mssql_executeUpmssql_fetch_assoc
#

#T=array mssql_fetch_array ( resource result [, int result_type])
mssql_fetch_array ( ^!resource result [, int result_type]);
#

#T=mssql_fetch_assoc - array mssql_fetch_assoc ( resource result_id)
(PHP 4 >= 4.2.0)
mssql_fetch_assoc --  Returns an associative array of the current row in 
the result set specified by result_id 
Description
array mssql_fetch_assoc ( resource result_id)
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_fetch_arrayUpmssql_fetch_batch
#

#T=array mssql_fetch_assoc ( resource result_id)
mssql_fetch_assoc ( ^!resource result_id);
#

#T=mssql_fetch_batch - int mssql_fetch_batch ( resource result_index)
(PHP 4 >= 4.0.4)
mssql_fetch_batch --  Returns the next batch of records 
Description
int mssql_fetch_batch ( resource result_index)
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_fetch_assocUpmssql_fetch_field
#

#T=int mssql_fetch_batch ( resource result_index)
mssql_fetch_batch ( ^!resource result_index);
#

#T=mssql_fetch_field - object mssql_fetch_field ( resource result [, int field_offset])
(PHP 3, PHP 4 )
mssql_fetch_field -- Get field information
Description
object mssql_fetch_field ( resource result [, int field_offset])
Returns an object containing field information. 
mssql_fetch_field() can be used in order to obtain information about 
fields in a certain query result. If the field offset isn't specified, the 
next field that wasn't yet retrieved by mssql_fetch_field() is retrieved. 
The properties of the object are: 
name - column name. if the column is a result of a function, this 
property is set to computed#N, where #N is a serial number. 
column_source - the table from which the column was taken 
max_length - maximum length of the column 
numeric - 1 if the column is numeric 
type - the column type. 
See also mssql_field_seek().   mssql_fetch_batchUpmssql_fetch_object
#

#T=object mssql_fetch_field ( resource result [, int field_offset])
mssql_fetch_field ( ^!resource result [, int field_offset]);
#

#T=mssql_fetch_object - object mssql_fetch_object ( resource result)
(PHP 3)
mssql_fetch_object -- Fetch row as object
Description
object mssql_fetch_object ( resource result)
Returns: An object with properties that correspond to the fetched row, or 
FALSE if there are no more rows. 
mssql_fetch_object() is similar to mssql_fetch_array(), with one 
difference - an object is returned, instead of an array. Indirectly, that 
means that you can only access the data by the field names, and not by 
their offsets (numbers are illegal property names). 
Note: Field names returned by this function are case-sensitive.
Speed-wise, the function is identical to mssql_fetch_array(), and almost 
as quick as mssql_fetch_row() (the difference is insignificant). 
See also mssql_fetch_array(), and mssql_fetch_row().   mssql_fetch_fieldUpmssql_fetch_row
#

#T=object mssql_fetch_object ( resource result)
mssql_fetch_object ( ^!resource result);
#

#T=mssql_fetch_row - array mssql_fetch_row ( resource result)
(PHP 3, PHP 4 )
mssql_fetch_row -- Get row as enumerated array
Description
array mssql_fetch_row ( resource result)
Returns: An array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
mssql_fetch_row() fetches one row of data from the result associated with 
the specified result identifier. The row is returned as an array. Each 
result column is stored in an array offset, starting at offset 0. 
Subsequent call to mssql_fetch_row() would return the next row in the 
result set, or FALSE if there are no more rows. 
See also mssql_fetch_array(), mssql_fetch_object(), mssql_data_seek(), 
mssql_fetch_lengths(), and mssql_result().   mssql_fetch_objectUpmssql_field_length
#

#T=array mssql_fetch_row ( resource result)
mssql_fetch_row ( ^!resource result);
#

#T=mssql_field_length - int mssql_field_length ( resource result [, int offset])
(PHP 3>= 3.0.3, PHP 4 )
mssql_field_length -- Get the length of a field
Description
int mssql_field_length ( resource result [, int offset])
This function returns the length of field no. offset in result result. If 
offset is omitted, the current field is used. 
Note to Win32 Users: Due to a limitation in the underlying API used by 
PHP (MS DbLib C API), the length of VARCHAR fields is limited to 255. If 
you need to store more data, use a TEXT field instead.   mssql_fetch_rowUpmssql_field_name
#

#T=int mssql_field_length ( resource result [, int offset])
mssql_field_length ( ^!resource result [, int offset]);
#

#T=mssql_field_name - string mssql_field_name ( resource result [, int offset])
(PHP 3>= 3.0.3, PHP 4 )
mssql_field_name -- Get the name of a field
Description
string mssql_field_name ( resource result [, int offset])
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_field_lengthUpmssql_field_seek
#

#T=string mssql_field_name ( resource result [, int offset])
mssql_field_name ( ^!resource result [, int offset]);
#

#T=mssql_field_seek - bool mssql_field_seek ( resource result, int field_offset)
(PHP 3, PHP 4 )
mssql_field_seek -- Seeks to the specified field offset
Description
bool mssql_field_seek ( resource result, int field_offset)
Seeks to the specified field offset. If the next call to 
mssql_fetch_field() won't include a field offset, this field would be 
returned.
Returns TRUE on success or FALSE on failure. 
See also mssql_fetch_field().   mssql_field_nameUpmssql_field_type
#

#T=bool mssql_field_seek ( resource result, int field_offset)
mssql_field_seek ( ^!resource result, int field_offset);
#

#T=mssql_field_type - string mssql_field_type ( resource result [, int offset])
(PHP 3>= 3.0.3, PHP 4 )
mssql_field_type -- Gets the type of a field
Description
string mssql_field_type ( resource result [, int offset])
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_field_seekUpmssql_free_result
#

#T=string mssql_field_type ( resource result [, int offset])
mssql_field_type ( ^!resource result [, int offset]);
#

#T=mssql_free_result - bool mssql_free_result ( resource result)
(PHP 3, PHP 4 )
mssql_free_result -- Free result memory
Description
bool mssql_free_result ( resource result)
mssql_free_result() only needs to be called if you are worried about using 
too much memory while your script is running. All result memory will 
automatically be freed when the script ends. You may call 
mssql_free_result() with the result identifier as an argument and the 
associated result memory will be freed.   mssql_field_typeUpmssql_free_statement
#

#T=bool mssql_free_result ( resource result)
mssql_free_result ( ^!resource result);
#

#T=mssql_free_statement - bool mssql_free_statement ( resource statement)
(PHP 4 >= 4.3.2)
mssql_free_statement -- Free statement memory
Description
bool mssql_free_statement ( resource statement)
mssql_free_statement() only needs to be called if you are worried about 
using too much memory while your script is running. All statement memory 
will automatically be freed when the script ends. You may call 
mssql_free_statement() with the statement identifier as an argument and 
the associated statement memory will be freed. 
See also mssql_bind(), mssql_execute(), and mssql_init()   mssql_free_resultUpmssql_get_last_message
#

#T=bool mssql_free_statement ( resource statement)
mssql_free_statement ( ^!resource statement);
#

#T=mssql_get_last_message - string mssql_get_last_message ( void )
(PHP 3, PHP 4 )
mssql_get_last_message --  Returns the last message from the server 
Description
string mssql_get_last_message ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_free_statementUpmssql_guid_string
#

#T=string mssql_get_last_message ( void )
mssql_get_last_message ( ^!void );
#

#T=mssql_guid_string - string mssql_guid_string ( string binary [, int short_format])
(PHP 4 >= 4.1.0)
mssql_guid_string --  Converts a 16 byte binary GUID to a string 
Description
string mssql_guid_string ( string binary [, int short_format])
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_get_last_messageUpmssql_init
#

#T=string mssql_guid_string ( string binary [, int short_format])
mssql_guid_string ( ^!string binary [, int short_format]);
#

#T=mssql_init - int mssql_init ( string sp_name [, resource conn_id])
(PHP 4 >= 4.1.0)
mssql_init --  Initializes a stored procedure or a remote stored procedure 

Description
int mssql_init ( string sp_name [, resource conn_id])
Warning
This function is currently not documented; only the argument list is 
available.

See also mssql_bind(), mssql_execute(), and mssql_free_statement()   mssql_guid_stringUpmssql_min_error_severity
#

#T=int mssql_init ( string sp_name [, resource conn_id])
mssql_init ( ^!string sp_name [, resource conn_id]);
#

#T=mssql_min_error_severity - void mssql_min_error_severity ( int severity)
(PHP 3, PHP 4 )
mssql_min_error_severity -- Sets the lower error severity
Description
void mssql_min_error_severity ( int severity)
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_initUpmssql_min_message_severity
#

#T=void mssql_min_error_severity ( int severity)
mssql_min_error_severity ( ^!int severity);
#

#T=mssql_min_message_severity - void mssql_min_message_severity ( int severity)
(PHP 3, PHP 4 )
mssql_min_message_severity -- Sets the lower message severity
Description
void mssql_min_message_severity ( int severity)
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_min_error_severityUpmssql_next_result
#

#T=void mssql_min_message_severity ( int severity)
mssql_min_message_severity ( ^!int severity);
#

#T=mssql_next_result - bool mssql_next_result ( resource result_id)
(PHP 4 >= 4.0.5)
mssql_next_result -- Move the internal result pointer to the next result
Description
bool mssql_next_result ( resource result_id)
When sending more than one SQL statement to the server or executing a 
stored procedure with multiple results, it will cause the server to return 
multiple result sets. This function will test for additional results 
available form the server. If an additional result set exists it will free 
the existing result set and prepare to fetch the rows from the new result 
set. The function will return TRUE if an additional result set was 
available or FALSE otherwise. 
Example 1. mssql_next_result() example
  <?php
      $link = mssql_connect("localhost", "userid", "secret");
      mssql_select_db("MyDB", $link);
      $SQL = "Select * from table1 select * from table2";
      $rs = mssql_query($SQL, $link);
      do {
	  while ($row = mssql_fetch_row($rs)) {
	  }
      } while (mssql_next_result($rs));
      mssql_free_result($rs);
      mssql_close($link);
  ?> 

  mssql_min_message_severityUpmssql_num_fields
#

#T=bool mssql_next_result ( resource result_id)
mssql_next_result ( ^!resource result_id);
#

#T=mssql_num_fields - int mssql_num_fields ( resource result)
(PHP 3, PHP 4 )
mssql_num_fields -- Gets the number of fields in result
Description
int mssql_num_fields ( resource result)
mssql_num_fields() returns the number of fields in a result set. 
See also mssql_query(), mssql_fetch_field(), and mssql_num_rows().   mssql_next_resultUpmssql_num_rows
#

#T=int mssql_num_fields ( resource result)
mssql_num_fields ( ^!resource result);
#

#T=mssql_num_rows - int mssql_num_rows ( resource result)
(PHP 3, PHP 4 )
mssql_num_rows -- Gets the number of rows in result
Description
int mssql_num_rows ( resource result)
mssql_num_rows() returns the number of rows in a result set. 
See also mssql_query() and mssql_fetch_row().   mssql_num_fieldsUpmssql_pconnect
#

#T=int mssql_num_rows ( resource result)
mssql_num_rows ( ^!resource result);
#

#T=mssql_pconnect - int mssql_pconnect ( [string servername [, string username [, string 
(PHP 3, PHP 4 )
mssql_pconnect -- Open persistent MS SQL connection
Description
int mssql_pconnect ( [string servername [, string username [, string 
password]]])
Returns: A positive MS SQL persistent link identifier on success, or FALSE 
on error. 
mssql_pconnect() acts very much like mssql_connect() with two major 
differences. 
First, when connecting, the function would first try to find a 
(persistent) link that's already open with the same host, username and 
password. If one is found, an identifier for it will be returned instead 
of opening a new connection. 
Second, the connection to the SQL server will not be closed when the 
execution of the script ends. Instead, the link will remain open for 
future use (mssql_close() will not close links established by 
mssql_pconnect()). 
This type of links is therefore called 'persistent'.   mssql_num_rowsUpmssql_query
#

#T=int mssql_pconnect ( [string servername [, string username [, string 
mssql_pconnect ( ^![string servername [, string username [, string ;
#

#T=mssql_query - resource mssql_query ( string query [, resource link_identifier [, int 
(PHP 3, PHP 4 )
mssql_query -- Send MS SQL query
Description
resource mssql_query ( string query [, resource link_identifier [, int 
batch_size]])
Returns: A positive MS SQL result identifier on success, or FALSE on 
error. 
mssql_query() sends a query to the currently active database on the server 
that's associated with the specified link identifier. If the link 
identifier isn't specified, the last opened link is assumed. If no link is 
open, the function tries to establish a link as if mssql_connect() was 
called, and use it. 
See also mssql_select_db() and mssql_connect().   mssql_pconnectUpmssql_result
#

#T=resource mssql_query ( string query [, resource link_identifier [, int 
mssql_query ( ^!string query [, resource link_identifier [, int ;
#

#T=mssql_result - string mssql_result ( resource result, int row, mixed field)
(PHP 3, PHP 4 )
mssql_result -- Get result data
Description
string mssql_result ( resource result, int row, mixed field)
mssql_result() returns the contents of one cell from a MS SQL result set. 
The field argument can be the field's offset, the field's name or the 
field's table dot field's name (tablename.fieldname). If the column name 
has been aliased ('select foo as bar from...'), it uses the alias instead 
of the column name. 
When working on large result sets, you should consider using one of the 
functions that fetch an entire row (specified below). As these functions 
return the contents of multiple cells in one function call, they're MUCH 
quicker than mssql_result(). Also, note that specifying a numeric offset 
for the field argument is much quicker than specifying a fieldname or 
tablename.fieldname argument. 
Recommended high-performance alternatives: mssql_fetch_row(), 
mssql_fetch_array(), and mssql_fetch_object().   mssql_queryUpmssql_rows_affected
#

#T=string mssql_result ( resource result, int row, mixed field)
mssql_result ( ^!resource result, int row, mixed field);
#

#T=mssql_rows_affected - int mssql_rows_affected ( resource conn_id)
(PHP 4 >= 4.0.4)
mssql_rows_affected --  Returns the number of records affected by the 
query 
Description
int mssql_rows_affected ( resource conn_id)
Warning
This function is currently not documented; only the argument list is 
available.
  mssql_resultUpmssql_select_db
#

#T=int mssql_rows_affected ( resource conn_id)
mssql_rows_affected ( ^!resource conn_id);
#

#T=mssql_select_db - bool mssql_select_db ( string database_name [, resource link_identifier])
(PHP 3, PHP 4 )
mssql_select_db -- Select MS SQL database
Description
bool mssql_select_db ( string database_name [, resource link_identifier])
Returns TRUE on success or FALSE on failure. 
mssql_select_db() sets the current active database on the server that's 
associated with the specified link identifier. If no link identifier is 
specified, the last opened link is assumed. If no link is open, the 
function will try to establish a link as if mssql_connect() was called, 
and use it. 
Every subsequent call to mssql_query() will be made on the active 
database. 
In order to select a database containing a space or a hyphen ("-") you 
need to enclose the database name in brackets, like is shown in the 
example below: 
Example 1. mssql_select_db() example
  <?php
      $conn = mssql_connect('MYSQLSERVER', 'sa', 'password');
      mssql_select_db('[my data-base]', $conn);
  ?> 
See also: mssql_connect(), mssql_pconnect(), and mssql_query()   mssql_rows_affectedUpMing functions for Flash
#

#T=bool mssql_select_db ( string database_name [, resource link_identifier])
mssql_select_db ( ^!string database_name [, resource link_identifier]);
#

#T=mt_getrandmax - int mt_getrandmax ( void )
(PHP 3>= 3.0.6, PHP 4 )
mt_getrandmax -- Show largest possible random value
Description
int mt_getrandmax ( void )
Returns the maximum value that can be returned by a call to mt_rand(). 
See also mt_rand(), mt_srand() and getrandmax().   minUpmt_rand
#

#T=int mt_getrandmax ( void )
mt_getrandmax ( ^!void );
#

#T=mt_rand - int mt_rand ( [int min, int max])
(PHP 3>= 3.0.6, PHP 4 )
mt_rand -- Generate a better random value
Description
int mt_rand ( [int min, int max])
Many random number generators of older libcs have dubious or unknown 
characteristics and are slow. By default, PHP uses the libc random number 
generator with the rand() function. The mt_rand() function is a drop-in 
replacement for this. It uses a random number generator with known 
characteristics using the Mersenne Twister, which will produce random 
numbers that should be suitable for seeding some kinds of cryptography 
(see the home page for details) and is four times faster than what the 
average libc provides. 
If called without the optional min, max arguments mt_rand() returns a 
pseudo-random value between 0 and RAND_MAX. If you want a random number 
between 5 and 15 (inclusive), for example, use mt_rand (5, 15). 
Example 1. mt_rand() example
  <?php
  echo mt_rand() . "\n";
  echo mt_rand() . "\n";

  echo mt_rand(5, 15);
  ?> 

The above example will output something similar to: 
1604716014
1478613278
6
Note: As of PHP 4.2.0, there is no need to seed the random number 
generator with srand() or mt_srand() as this is now done automatically. 
Note: In versions before 3.0.7 the meaning of max was range. To get the 
same results in these versions the short example should be mt_rand (5, 
11) to get a random number between 5 and 15. 
See also mt_srand(), mt_getrandmax() and rand().   mt_getrandmaxUpmt_srand
#

#T=int mt_rand ( [int min, int max])
mt_rand ( ^![int min, int max]);
#

#T=mt_srand - void mt_srand ( [int seed])
(PHP 3>= 3.0.6, PHP 4 )
mt_srand -- Seed the better random number generator
Description
void mt_srand ( [int seed])
Seeds the random number generator with seed. Since PHP 4.2.0, the seed 
becomes optional and defaults to a random value if omitted. 
<?php
// seed with microseconds
function make_seed() {
list($usec, $sec) = explode(' ', microtime());
return (float) $sec + ((float) $usec * 100000);
}
mt_srand(make_seed());
$randval = mt_rand();
?> 

Note: As of PHP 4.2.0, there is no need to seed the random number 
generator with srand() or mt_srand() as this is now done automatically. 
See also mt_rand(), mt_getrandmax() and srand().   mt_randUpoctdec
muscat_close
(4.0.5 - 4.2.3 only)
muscat_close -- Shuts down the muscat session and releases any memory back 
to PHP.
Description
int muscat_close ( resource muscat_handle)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

[Not back to the system, note!]   muscat functionsUpmuscat_get
muscat_get
(4.0.5 - 4.2.3 only)
muscat_get -- Gets a line back from the core muscat API. 
Description
string muscat_get ( resource muscat_handle)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

Returns a literal FALSE when there is no more to get (as opposed to ""). 
Use === FALSE or !== FALSE to check for this.   muscat_closeUpmuscat_give
muscat_give
(4.0.5 - 4.2.3 only)
muscat_give -- Sends string to the core muscat API
Description
int muscat_give ( resource muscat_handle, string string)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  muscat_getUpmuscat_setup_net
muscat_setup_net
(4.0.5 - 4.2.3 only)
muscat_setup_net -- Creates a new muscat session and returns the handle.
Description
resource muscat_setup_net ( string muscat_host, int port)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

muscat_host is the hostname to connect to port is the port number to 
connect to - actually takes exactly the same args as fsockopen   muscat_giveUpmuscat_setup
muscat_setup
(4.0.5 - 4.2.3 only)
muscat_setup -- Creates a new muscat session and returns the handle.
Description
resource muscat_setup ( int size [, string muscat_dir])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

Size is the amount of memory in bytes to allocate for muscat muscat_dir is 
the muscat installation dir e.g. "/usr/local/empower", it defaults to the 
compile time muscat directory   muscat_setup_netUpNetwork Functions
#

#T=void mt_srand ( [int seed])
mt_srand ( ^![int seed]);
#

#T=mysql_affected_rows - int mysql_affected_rows ( [resource link_identifier])
(PHP 3, PHP 4 )
mysql_affected_rows -- Get number of affected rows in previous MySQL 
operation
Description
int mysql_affected_rows ( [resource link_identifier])
mysql_affected_rows() returns the number of rows affected by the last 
INSERT, UPDATE or DELETE query associated with link_identifier. If the 
link identifier isn't specified, the last link opened by mysql_connect() 
is assumed. 
Note: If you are using transactions, you need to call 
mysql_affected_rows() after your INSERT, UPDATE, or DELETE query, not 
after the commit. 
If the last query was a DELETE query with no WHERE clause, all of the 
records will have been deleted from the table but this function will 
return zero. 
Note: When using UPDATE, MySQL will not update columns where the new 
value is the same as the old value. This creates the possibility that 
mysql_affected_rows() may not actually equal the number of rows matched, 
only the number of rows that were literally affected by the query. 
mysql_affected_rows() does not work with SELECT statements; only on 
statements which modify records. To retrieve the number of rows returned 
by a SELECT, use mysql_num_rows(). 
If the last query failed, this function will return -1. Example 1. 
Delete-Query
  <?php
      /* connect to database */
      mysql_pconnect("localhost", "mysql_user", 
  "mysql_password") or
	  die("Could not connect: " . mysql_error());
      mysql_select_db("mydb");
	  
      /* this should return the correct numbers of deleted 
  records */
      mysql_query("DELETE FROM mytable WHERE id < 10");
      printf("Records deleted: %d\n", mysql_affected_rows());

      /* without a where clause in a delete statement, it should 
  return 0 */
      mysql_query("DELETE FROM mytable");
      printf("Records deleted: %d\n", mysql_affected_rows());
  ?> 

The above example would produce the following output: 
Records deleted: 10
Records deleted: 0
Example 2. Update-Query
  <?php
      /* connect to database */
      mysql_pconnect("localhost", "mysql_user", 
  "mysql_password") or
	  die("Could not connect: " . mysql_error());
      mysql_select_db("mydb");

      /* Update records */
      mysql_query("UPDATE mytable SET used=1 WHERE id < 10");
      printf ("Updated records: %d\n", mysql_affected_rows());
      mysql_query("COMMIT");
  ?> 

The above example would produce the following output: 
Updated Records: 10
See also mysql_num_rows(), mysql_info().   MySQL FunctionsUpmysql_change_user
#

#T=int mysql_affected_rows ( [resource link_identifier])
mysql_affected_rows ( ^![resource link_identifier]);
#

#T=mysql_change_user - int mysql_change_user ( string user, string password [, string database [, 
(PHP 3>= 3.0.13)
mysql_change_user --  Change logged in user of the active connection 
Description
int mysql_change_user ( string user, string password [, string database [, 
resource link_identifier]])
mysql_change_user() changes the logged in user of the current active 
connection, or the connection given by the optional link_identifier 
parameter. If a database is specified, this will be the current database 
after the user has been changed. If the new user and password 
authorization fails, the current connected user stays active. Returns TRUE 
on success or FALSE on failure. 
Note: This function was introduced in PHP 3.0.13 and requires MySQL 
3.23.3 or higher. It is not available in PHP 4.   mysql_affected_rowsUpmysql_client_encoding
#

#T=int mysql_change_user ( string user, string password [, string database [, 
mysql_change_user ( ^!string user, string password [, string database [, ;
#

#T=mysql_client_encoding - string mysql_client_encoding ( [resource link_identifier])
(PHP 4 >= 4.3.0)
mysql_client_encoding -- Returns the name of the character set
Description
string mysql_client_encoding ( [resource link_identifier])
mysql_client_encoding() returns the default character set name for the 
current connection. 
Example 1. mysql_client_encoding() example
  <?php
  $link = mysql_connect('localhost', 'mysql_user', 
  'mysql_password');
  $charset = mysql_client_encoding($link);
  printf("current character set is %s\n", $charset);
  ?> 

The above example would produce the following output: 
current character set is latin1
See also mysql_real_escape_string()   mysql_change_userUpmysql_close
#

#T=string mysql_client_encoding ( [resource link_identifier])
mysql_client_encoding ( ^![resource link_identifier]);
#

#T=mysql_close - bool mysql_close ( [resource link_identifier])
(PHP 3, PHP 4 )
mysql_close -- Close MySQL connection
Description
bool mysql_close ( [resource link_identifier])
Returns TRUE on success or FALSE on failure. 
mysql_close() closes the connection to the MySQL server that's associated 
with the specified link identifier. If link_identifier isn't specified, 
the last opened link is used. 
Using mysql_close() isn't usually necessary, as non-persistent open links 
are automatically closed at the end of the script's execution. See also 
freeing resources. 
Note: mysql_close() will not close persistent links created by 
mysql_pconnect(). 
Example 1. MySQL close example
  <?php
      $link = mysql_connect("localhost", "mysql_user", 
  "mysql_password")
	  or die("Could not connect: " . mysql_error());
      echo "Connected successfully";
      mysql_close($link);
  ?> 
See also mysql_connect() and mysql_pconnect().   mysql_client_encodingUpmysql_connect
#

#T=bool mysql_close ( [resource link_identifier])
mysql_close ( ^![resource link_identifier]);
#

#T=mysql_connect - resource mysql_connect ( [string server [, string username [, string 
(PHP 3, PHP 4 )
mysql_connect -- Open a connection to a MySQL Server
Description
resource mysql_connect ( [string server [, string username [, string 
password [, bool new_link [, int client_flags]]]]])
Returns a MySQL link identifier on success, or FALSE on failure. 
mysql_connect() establishes a connection to a MySQL server. The following 
defaults are assumed for missing optional parameters: server = 
'localhost:3306', username = name of the user that owns the server process 
and password = empty password. 
The server parameter can also include a port number. e.g. "hostname:port" 
or a path to a local socket e.g. ":/path/to/socket" for the localhost. 
Note: Whenever you specify "localhost" or "localhost:port" as server, 
the MySQL client library will override this and try to connect to a 
local socket (named pipe on Windows). If you want to use TCP/IP, use 
"127.0.0.1" instead of "localhost". If the MySQL client library tries to 
connect to the wrong local socket, you should set the correct path as 
mysql.default_host in your PHP configuration and leave the server field 
blank. 
Support for ":port" was added in PHP 3.0B4. 
Support for ":/path/to/socket" was added in PHP 3.0.10. 
You can suppress the error message on failure by prepending a @ to the 
function name. 
If a second call is made to mysql_connect() with the same arguments, no 
new link will be established, but instead, the link identifier of the 
already opened link will be returned. The new_link parameter modifies this 
behavior and makes mysql_connect() always open a new link, even if 
mysql_connect() was called before with the same parameters. The 
client_flags parameter can be a combination of the constants 
MYSQL_CLIENT_COMPRESS, MYSQL_CLIENT_IGNORE_SPACE or 
MYSQL_CLIENT_INTERACTIVE. 
Note: The new_link parameter became available in PHP 4.2.0 
The client_flags parameter became available in PHP 4.3.0 
The link to the server will be closed as soon as the execution of the 
script ends, unless it's closed earlier by explicitly calling 
mysql_close(). 
Example 1. mysql_connect() example
  <?php
      $link = mysql_connect("localhost", "mysql_user", 
  "mysql_password")
	  or die("Could not connect: " . mysql_error());
      echo "Connected successfully";
      mysql_close($link);
  ?> 
See also mysql_pconnect() and mysql_close().   mysql_closeUpmysql_create_db
#

#T=resource mysql_connect ( [string server [, string username [, string 
mysql_connect ( ^![string server [, string username [, string ;
#

#T=mysql_create_db - bool mysql_create_db ( string database_name [, resource link_identifier])
(PHP 3, PHP 4 )
mysql_create_db -- Create a MySQL database
Description
bool mysql_create_db ( string database_name [, resource link_identifier])
mysql_create_db() attempts to create a new database on the server 
associated with the specified link identifier. 
Returns TRUE on success or FALSE on failure. 
Example 1. MySQL create database example
  <?php
      $link = mysql_pconnect("localhost", "mysql_user", 
  "mysql_password")
	  or die("Could not connect: " . mysql_error());

      if (mysql_create_db("my_db")) {
	  echo "Database created successfully\n";
      } else {
	  echo "Error creating database: " . mysql_error() . 
  "\n";
      }
  ?> 
For downwards compatibility mysql_createdb() can also be used. This is 
deprecated, however. 
Note: The function mysql_create_db() is deprecated. It is preferable to 
use mysql_query() to issue a SQL CREATE DATABASE Statement instead. 
Warning
This function will not be available if the MySQL extension was built 
against a MySQL 4.x client library. 

See also mysql_drop_db() and mysql_query().   mysql_connectUpmysql_data_seek
#

#T=bool mysql_create_db ( string database_name [, resource link_identifier])
mysql_create_db ( ^!string database_name [, resource link_identifier]);
#

#T=mysql_data_seek - bool mysql_data_seek ( resource result_identifier, int row_number)
(PHP 3, PHP 4 )
mysql_data_seek -- Move internal result pointer
Description
bool mysql_data_seek ( resource result_identifier, int row_number)
Returns TRUE on success or FALSE on failure. 
mysql_data_seek() moves the internal row pointer of the MySQL result 
associated with the specified result identifier to point to the specified 
row number. The next call to mysql_fetch_row() would return that row. 
Row_number starts at 0. The row_number should be a value in the range from 
0 to mysql_num_rows - 1. 
Note: The function mysql_data_seek() can be used in conjunction only 
with mysql_query(), not with mysql_unbuffered_query(). 
Example 1. mysql_data_seek() example
  <?php
      $link = mysql_pconnect("localhost", "mysql_user", 
  "mysql_password")
	  or die("Could not connect: " . mysql_error());

      mysql_select_db("samp_db")
	  or die("Could not select database: " . mysql_error());

      $query = "SELECT last_name, first_name FROM friends";
      $result = mysql_query($query)
	  or die("Query failed: " . mysql_error());

      /* fetch rows in reverse order */
      for ($i = mysql_num_rows($result) - 1; $i >= 0; $i--) {
	  if (!mysql_data_seek($result, $i)) {
	      echo "Cannot seek to row $i: " . mysql_error() . 
  "\n";
	      continue;
	  }

	  if (!($row = mysql_fetch_object($result)))
	      continue;

	  echo "$row->last_name $row->first_name<br />\n";
      }

      mysql_free_result($result);
  ?> 
See also mysql_query() and mysql_num_rows().   mysql_create_dbUpmysql_db_name
#

#T=bool mysql_data_seek ( resource result_identifier, int row_number)
mysql_data_seek ( ^!resource result_identifier, int row_number);
#

#T=mysql_db_name - string mysql_db_name ( resource result, int row [, mixed field])
(PHP 3>= 3.0.6, PHP 4 )
mysql_db_name -- Get result data
Description
string mysql_db_name ( resource result, int row [, mixed field])
mysql_db_name() takes as its first parameter the result pointer from a 
call to mysql_list_dbs(). The row parameter is an index into the result 
set. 
If an error occurs, FALSE is returned. Use mysql_errno() and mysql_error() 
to determine the nature of the error. 
Example 1. mysql_db_name() example
  <?php
      error_reporting(E_ALL);

      mysql_connect('dbhost', 'username', 'password');
      $db_list = mysql_list_dbs();

      $i = 0;
      $cnt = mysql_num_rows($db_list);
      while ($i < $cnt) {
	  echo mysql_db_name($db_list, $i) . "\n";
	  $i++;
      }
  ?> 
For backward compatibility, mysql_dbname() is also accepted. This is 
deprecated, however.   mysql_data_seekUpmysql_db_query
#

#T=string mysql_db_name ( resource result, int row [, mixed field])
mysql_db_name ( ^!resource result, int row [, mixed field]);
#

#T=mysql_db_query - resource mysql_db_query ( string database, string query [, resource 
(PHP 3, PHP 4 )
mysql_db_query -- Send a MySQL query
Description
resource mysql_db_query ( string database, string query [, resource 
link_identifier])
Returns a positive MySQL result resource to the query result, or FALSE on 
error. The function also returns TRUE/FALSE for INSERT/UPDATE/DELETE 
queries to indicate success/failure. 
mysql_db_query() selects a database and executes a query on it. If the 
optional link identifier isn't specified, the function will try to find an 
open link to the MySQL server and if no such link is found it'll try to 
create one as if mysql_connect() was called with no arguments. 
Be aware that this function does NOT switch back to the database you were 
connected before. In other words, you can't use this function to 
temporarily run a sql query on another database, you would have to 
manually switch back. Users are strongly encouraged to use the 
database.table syntax in their sql queries instead of this function. 
See also mysql_connect() and mysql_query(). 
Note: This function has been deprecated since PHP 4.0.6. Do not use this 
function. Use mysql_select_db() and mysql_query() instead.   mysql_db_nameUpmysql_drop_db
#

#T=resource mysql_db_query ( string database, string query [, resource 
mysql_db_query ( ^!string database, string query [, resource ;
#

#T=mysql_drop_db - bool mysql_drop_db ( string database_name [, resource link_identifier])
(PHP 3, PHP 4 )
mysql_drop_db -- Drop (delete) a MySQL database
Description
bool mysql_drop_db ( string database_name [, resource link_identifier])
mysql_drop_db() attempts to drop (remove) an entire database from the 
server associated with the specified link identifier. 
Returns TRUE on success or FALSE on failure. 
For downward compatibility mysql_dropdb() can also be used. This is 
deprecated, however. 
Note: The function mysql_drop_db() is deprecated. It is preferable to 
use mysql_query() to issue a SQL DROP DATABASE statement instead. 
Warning
This function will not be available if the MySQL extension was built 
against a MySQL 4.x client library 

See also mysql_create_db() and mysql_query().   mysql_db_queryUpmysql_errno
#

#T=bool mysql_drop_db ( string database_name [, resource link_identifier])
mysql_drop_db ( ^!string database_name [, resource link_identifier]);
#

#T=mysql_errno - int mysql_errno ( [resource link_identifier])
(PHP 3, PHP 4 )
mysql_errno --  Returns the numerical value of the error message from 
previous MySQL operation 
Description
int mysql_errno ( [resource link_identifier])
Returns the error number from the last MySQL function, or 0 (zero) if no 
error occurred. 
Errors coming back from the MySQL database backend no longer issue 
warnings. Instead, use mysql_errno() to retrieve the error code. Note that 
this function only returns the error code from the most recently executed 
MySQL function (not including mysql_error() and mysql_errno()), so if you 
want to use it, make sure you check the value before calling another MySQL 
function. Example 1. mysql_errno() example
  <?php
      mysql_connect("localhost", "mysql_user", 
"mysql_password");

      mysql_select_db("nonexistentdb");
      echo mysql_errno() . ": " . mysql_error(). "\n";

      mysql_select_db("kossu");
      mysql_query("SELECT * FROM nonexistenttable");
      echo mysql_errno() . ": " . mysql_error() . "\n";
  ?> 

The above example would produce the following output: 
1049: Unknown database 'nonexistentdb'
1146: Table 'kossu.nonexistenttable' doesn't exist
Note: If the optional argument is specified the given link is used to 
retrieve the error code. If not, the last opened link is used. 
See also mysql_error().   mysql_drop_dbUpmysql_error
#

#T=int mysql_errno ( [resource link_identifier])
mysql_errno ( ^![resource link_identifier]);
#

#T=mysql_error - string mysql_error ( [resource link_identifier])
(PHP 3, PHP 4 )
mysql_error --  Returns the text of the error message from previous MySQL 
operation 
Description
string mysql_error ( [resource link_identifier])
Returns the error text from the last MySQL function, or '' (the empty 
string) if no error occurred. If no link is explicitly passed to the 
function, the last successful open link will be used to retrieve the error 
message from the MySQL server. 
Errors coming back from the MySQL database backend no longer issue 
warnings. Instead, use mysql_error() to retrieve the error text. Note that 
this function only returns the error text from the most recently executed 
MySQL function (not including mysql_error() and mysql_errno()), so if you 
want to use it, make sure you check the value before calling another MySQL 
function. Example 1. mysql_error Example
  <?php
      mysql_connect("localhost", "mysql_user", 
"mysql_password");

      mysql_select_db("nonexistentdb");
      echo mysql_errno() . ": " . mysql_error(). "\n";

      mysql_select_db("kossu");
      mysql_query("SELECT * FROM nonexistenttable");
      echo mysql_errno() . ": " . mysql_error() . "\n";
  ?> 

The above example would produce the following output: 
1049: Unknown database 'nonexistentdb'
1146: Table 'kossu.nonexistenttable' doesn't exist
See also mysql_errno().   mysql_errnoUpmysql_escape_string
#

#T=string mysql_error ( [resource link_identifier])
mysql_error ( ^![resource link_identifier]);
#

#T=mysql_escape_string - string mysql_escape_string ( string unescaped_string)
(PHP 4 >= 4.0.3)
mysql_escape_string --  Escapes a string for use in a mysql_query. 
Description
string mysql_escape_string ( string unescaped_string)
This function will escape the unescaped_string, so that it is safe to 
place it in a mysql_query(). 
Note: mysql_escape_string() does not escape % and _. 
This function is identical to mysql_real_escape_string() except that 
mysql_real_escape_string() takes a connection handler and escapes the 
string according to the current character set. mysql_escape_string() 
does not take a connection argument and does not respect the current 
charset setting. 
Example 1. mysql_escape_string() example
  <?php
      $item = "Zak's Laptop";
      $escaped_item = mysql_escape_string($item);
      printf("Escaped string: %s\n", $escaped_item);
  ?> 

The above example would produce the following output: 
Escaped string: Zak\'s Laptop
See also mysql_real_escape_string(), addslashes() and the magic_quotes_gpc 
directive.   mysql_errorUpmysql_fetch_array
#

#T=string mysql_escape_string ( string unescaped_string)
mysql_escape_string ( ^!string unescaped_string);
#

#T=mysql_fetch_array - array mysql_fetch_array ( resource result [, int result_type])
(PHP 3, PHP 4 )
mysql_fetch_array --  Fetch a result row as an associative array, a 
numeric array, or both. 
Description
array mysql_fetch_array ( resource result [, int result_type])
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows.
mysql_fetch_array() is an extended version of mysql_fetch_row(). In 
addition to storing the data in the numeric indices of the result array, 
it also stores the data in associative indices, using the field names as 
keys. 
If two or more columns of the result have the same field names, the last 
column will take precedence. To access the other column(s) of the same 
name, you must use the numeric index of the column or make an alias for 
the column. For aliased columns, you cannot access the contents with the 
original column name (by using 'field' in this example). Example 1. 
Query with duplicate field names
select table1.field as foo, table2.field as bar from table1, table2
An important thing to note is that using mysql_fetch_array() is not 
significantly slower than using mysql_fetch_row(), while it provides a 
significant added value. 
The optional second argument result_type in mysql_fetch_array() is a 
constant and can take the following values: MYSQL_ASSOC, MYSQL_NUM, and 
MYSQL_BOTH. This feature was added in PHP 3.0.7. MYSQL_BOTH is the default 
for this argument. 
By using MYSQL_BOTH, you'll get an array with both associative and number 
indices. Using MYSQL_ASSOC, you only get associative indices (as 
mysql_fetch_assoc() works), using MYSQL_NUM, you only get number indices 
(as mysql_fetch_row() works). 
Note: Field names returned by this function are case-sensitive.
Example 2. mysql_fetch_array() with MYSQL_NUM
  <?php
      mysql_connect("localhost", "mysql_user", "mysql_password") 
  or
	  die("Could not connect: " . mysql_error());
      mysql_select_db("mydb");

      $result = mysql_query("SELECT id, name FROM mytable");

      while ($row = mysql_fetch_array($result, MYSQL_NUM)) {
	  printf("ID: %s  Name: %s", $row[0], $row[1]);  
      }

      mysql_free_result($result);
  ?> 

Example 3. mysql_fetch_array() with MYSQL_ASSOC
  <?php
      mysql_connect("localhost", "mysql_user", "mysql_password") 
  or
	  die("Could not connect: " . mysql_error());
      mysql_select_db("mydb");

      $result = mysql_query("SELECT id, name FROM mytable");

      while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	  printf("ID: %s  Name: %s", $row["id"], $row["name"]);
      }

      mysql_free_result($result);
  ?> 

Example 4. mysql_fetch_array() with MYSQL_BOTH
  <?php
      mysql_connect("localhost", "mysql_user", "mysql_password") 
  or
	  die("Could not connect: " . mysql_error());
      mysql_select_db("mydb");

      $result = mysql_query("SELECT id, name FROM mytable");

      while ($row = mysql_fetch_array($result, MYSQL_BOTH)) {
	  printf ("ID: %s  Name: %s", $row[0], $row["name"]);
      }

      mysql_free_result($result);
  ?> 
See also mysql_fetch_row() and mysql_fetch_assoc().   mysql_escape_stringUpmysql_fetch_assoc
#

#T=array mysql_fetch_array ( resource result [, int result_type])
mysql_fetch_array ( ^!resource result [, int result_type]);
#

#T=mysql_fetch_assoc - array mysql_fetch_assoc ( resource result)
(PHP 4 >= 4.0.3)
mysql_fetch_assoc --  Fetch a result row as an associative array 
Description
array mysql_fetch_assoc ( resource result)
Returns an associative array that corresponds to the fetched row, or FALSE 
if there are no more rows.
mysql_fetch_assoc() is equivalent to calling mysql_fetch_array() with 
MYSQL_ASSOC for the optional second parameter. It only returns an 
associative array. This is the way mysql_fetch_array() originally worked. 
If you need the numeric indices as well as the associative, use 
mysql_fetch_array(). 
If two or more columns of the result have the same field names, the last 
column will take precedence. To access the other column(s) of the same 
name, you either need to access the result with numeric indices by using 
mysql_fetch_row() or add alias names. See the example at the 
mysql_fetch_array() description about aliases. 
An important thing to note is that using mysql_fetch_assoc() is not 
significantly slower than using mysql_fetch_row(), while it provides a 
significant added value. 
Note: Field names returned by this function are case-sensitive.
Example 1. An expanded mysql_fetch_assoc() example
  <?php

      $conn = mysql_connect("localhost", "mysql_user", 
  "mysql_password");
      
      if (!$conn) {
	  echo "Unable to connect to DB: " . mysql_error();
	  exit;
      }
      
      if (!mysql_select_db("mydbname")) {
	  echo "Unable to select mydbname: " . mysql_error();
	  exit;
      }
      
      $sql = "SELECT id as userid, fullname, userstatus 
	      FROM   sometable
	      WHERE  userstatus = 1";

      $result = mysql_query($sql);

      if (!$result) {
	  echo "Could not successfully run query ($sql) from DB: 
  " . mysql_error();
	  exit;
      }
      
      if (mysql_num_rows($result) == 0) {
	  echo "No rows found, nothing to print so am exiting";
	  exit;
      }

      // While a row of data exists, put that row in $row as an 
  associative array
      // Note: If you're expecting just one row, no need to use 
  a loop
      // Note: If you put extract($row); inside the following 
  loop, you'll
      //       then create $userid, $fullname, and $userstatus
      while ($row = mysql_fetch_assoc($result)) {
	  echo $row["userid"];
	  echo $row["fullname"];
	  echo $row["userstatus"];
      }
	  
      mysql_free_result($result);

  ?> 
See also mysql_fetch_row(), mysql_fetch_array(), mysql_query() and 
mysql_error().   mysql_fetch_arrayUpmysql_fetch_field
#

#T=array mysql_fetch_assoc ( resource result)
mysql_fetch_assoc ( ^!resource result);
#

#T=mysql_fetch_field - object mysql_fetch_field ( resource result [, int field_offset])
(PHP 3, PHP 4 )
mysql_fetch_field --  Get column information from a result and return as 
an object 
Description
object mysql_fetch_field ( resource result [, int field_offset])
Returns an object containing field information. 
mysql_fetch_field() can be used in order to obtain information about 
fields in a certain query result. If the field offset isn't specified, the 
next field that wasn't yet retrieved by mysql_fetch_field() is retrieved. 
The properties of the object are: 
name - column name 
table - name of the table the column belongs to 
max_length - maximum length of the column 
not_null - 1 if the column cannot be NULL 
primary_key - 1 if the column is a primary key 
unique_key - 1 if the column is a unique key 
multiple_key - 1 if the column is a non-unique key 
numeric - 1 if the column is numeric 
blob - 1 if the column is a BLOB 
type - the type of the column 
unsigned - 1 if the column is unsigned 
zerofill - 1 if the column is zero-filled 
Note: Field names returned by this function are case-sensitive.
Example 1. mysql_fetch_field() example
  <?php
  mysql_connect('localhost:3306', $user, $password)
      or die("Could not connect: " . mysql_error());
  mysql_select_db("database");
  $result = mysql_query("select * from table")
      or die("Query failed: " . mysql_error());
  /* get column metadata */
  $i = 0;
  while ($i < mysql_num_fields($result)) {
      echo "Information for column $i:<br />\n";
      $meta = mysql_fetch_field($result, $i);
      if (!$meta) {
	  echo "No information available<br />\n";
      }
      echo "<pre>
  blob:         $meta->blob
  max_length:   $meta->max_length
  multiple_key: $meta->multiple_key
  name:         $meta->name
  not_null:     $meta->not_null
  numeric:      $meta->numeric
  primary_key:  $meta->primary_key
  table:        $meta->table
  type:         $meta->type
  unique_key:   $meta->unique_key
  unsigned:     $meta->unsigned
  zerofill:     $meta->zerofill
  </pre>";
      $i++;
  }
  mysql_free_result($result);
  ?> 
See also mysql_field_seek().   mysql_fetch_assocUpmysql_fetch_lengths
#

#T=object mysql_fetch_field ( resource result [, int field_offset])
mysql_fetch_field ( ^!resource result [, int field_offset]);
#

#T=mysql_fetch_lengths - array mysql_fetch_lengths ( resource result)
(PHP 3, PHP 4 )
mysql_fetch_lengths --  Get the length of each output in a result 
Description
array mysql_fetch_lengths ( resource result)
Returns an array that corresponds to the lengths of each field in the last 
row fetched by mysql_fetch_row(), or FALSE on error. 
mysql_fetch_lengths() stores the lengths of each result column in the last 
row returned by mysql_fetch_row(), mysql_fetch_array(), and 
mysql_fetch_object() in an array, starting at offset 0. 
See also mysql_fetch_row().   mysql_fetch_fieldUpmysql_fetch_object
#

#T=array mysql_fetch_lengths ( resource result)
mysql_fetch_lengths ( ^!resource result);
#

#T=mysql_fetch_object - object mysql_fetch_object ( resource result)
(PHP 3, PHP 4 )
mysql_fetch_object -- Fetch a result row as an object
Description
object mysql_fetch_object ( resource result)
Returns an object with properties that correspond to the fetched row, or 
FALSE if there are no more rows. 
mysql_fetch_object() is similar to mysql_fetch_array(), with one 
difference - an object is returned, instead of an array. Indirectly, that 
means that you can only access the data by the field names, and not by 
their offsets (numbers are illegal property names). 
Note: Field names returned by this function are case-sensitive.
<?php

/* this is valid */
echo $row->field;
/* this is invalid */
echo $row->0;

?> 

Speed-wise, the function is identical to mysql_fetch_array(), and almost 
as quick as mysql_fetch_row() (the difference is insignificant). 
Example 1. mysql_fetch_object() example
  <?php
  mysql_connect("hostname", "user", "password");
  mysql_select_db("mydb");
  $result = mysql_query("select * from mytable");
  while ($row = mysql_fetch_object($result)) {
      echo $row->user_id;
      echo $row->fullname;
  }
  mysql_free_result($result);
  ?> 
See also mysql_fetch_array(), mysql_fetch_assoc() and mysql_fetch_row().   mysql_fetch_lengthsUpmysql_fetch_row
#

#T=object mysql_fetch_object ( resource result)
mysql_fetch_object ( ^!resource result);
#

#T=mysql_fetch_row - array mysql_fetch_row ( resource result)
(PHP 3, PHP 4 )
mysql_fetch_row -- Get a result row as an enumerated array
Description
array mysql_fetch_row ( resource result)
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
mysql_fetch_row() fetches one row of data from the result associated with 
the specified result identifier. The row is returned as an array. Each 
result column is stored in an array offset, starting at offset 0. 
Subsequent call to mysql_fetch_row() would return the next row in the 
result set, or FALSE if there are no more rows. 
Note: Field names returned by this function are case-sensitive.
See also mysql_fetch_array(), mysql_fetch_assoc(), mysql_fetch_object(), 
mysql_data_seek(), mysql_fetch_lengths() and mysql_result().   mysql_fetch_objectUpmysql_field_flags
#

#T=array mysql_fetch_row ( resource result)
mysql_fetch_row ( ^!resource result);
#

#T=mysql_field_flags - string mysql_field_flags ( resource result, int field_offset)
(PHP 3, PHP 4 )
mysql_field_flags --  Get the flags associated with the specified field in 
a result 
Description
string mysql_field_flags ( resource result, int field_offset)
mysql_field_flags() returns the field flags of the specified field. The 
flags are reported as a single word per flag separated by a single space, 
so that you can split the returned value using explode(). 
The following flags are reported, if your version of MySQL is current 
enough to support them: "not_null", "primary_key", "unique_key", 
"multiple_key", "blob", "unsigned", "zerofill", "binary", "enum", 
"auto_increment", "timestamp". 
For downward compatibility mysql_fieldflags() can also be used. This is 
deprecated, however.   mysql_fetch_rowUpmysql_field_len
#

#T=string mysql_field_flags ( resource result, int field_offset)
mysql_field_flags ( ^!resource result, int field_offset);
#

#T=mysql_field_len - int mysql_field_len ( resource result, int field_offset)
(PHP 3, PHP 4 )
mysql_field_len --  Returns the length of the specified field 
Description
int mysql_field_len ( resource result, int field_offset)
mysql_field_len() returns the length of the specified field. 
For downward compatibility mysql_fieldlen() can also be used. This is 
deprecated, however.   mysql_field_flagsUpmysql_field_name
#

#T=int mysql_field_len ( resource result, int field_offset)
mysql_field_len ( ^!resource result, int field_offset);
#

#T=mysql_field_name - string mysql_field_name ( resource result, int field_index)
(PHP 3, PHP 4 )
mysql_field_name --  Get the name of the specified field in a result 
Description
string mysql_field_name ( resource result, int field_index)
mysql_field_name() returns the name of the specified field index. result 
must be a valid result identifier and field_index is the numerical offset 
of the field. 
Note: field_index starts at 0. 
e.g. The index of the third field would actually be 2, the index of the 
fourth field would be 3 and so on. 
Note: Field names returned by this function are case-sensitive.
Example 1. mysql_field_name() example
  <?php
  /* The users table consists of three fields:
  *   user_id
  *   username
  *   password.
  */
  $link = mysql_connect('localhost', "mysql_user", 
  "mysql_password");
  $dbname = "mydb";
  mysql_select_db($dbname, $link)
      or die("Could not set $dbname: " . mysql_error());
  $res = mysql_query("select * from users", $link);

  echo mysql_field_name($res, 0) . "\n";
  echo mysql_field_name($res, 2);
  ?> 

The above example would produce the following output: 
user_id
password
For downwards compatibility mysql_fieldname() can also be used. This is 
deprecated, however.   mysql_field_lenUpmysql_field_seek
#

#T=string mysql_field_name ( resource result, int field_index)
mysql_field_name ( ^!resource result, int field_index);
#

#T=mysql_field_seek - int mysql_field_seek ( resource result, int field_offset)
(PHP 3, PHP 4 )
mysql_field_seek --  Set result pointer to a specified field offset 
Description
int mysql_field_seek ( resource result, int field_offset)
Seeks to the specified field offset. If the next call to 
mysql_fetch_field() doesn't include a field offset, the field offset 
specified in mysql_field_seek() will be returned. 
See also mysql_fetch_field().   mysql_field_nameUpmysql_field_table
#

#T=int mysql_field_seek ( resource result, int field_offset)
mysql_field_seek ( ^!resource result, int field_offset);
#

#T=mysql_field_table - string mysql_field_table ( resource result, int field_offset)
(PHP 3, PHP 4 )
mysql_field_table --  Get name of the table the specified field is in 
Description
string mysql_field_table ( resource result, int field_offset)
Returns the name of the table that the specified field is in. 
For downward compatibility mysql_fieldtable() can also be used. This is 
deprecated, however.   mysql_field_seekUpmysql_field_type
#

#T=string mysql_field_table ( resource result, int field_offset)
mysql_field_table ( ^!resource result, int field_offset);
#

#T=mysql_field_type - string mysql_field_type ( resource result, int field_offset)
(PHP 3, PHP 4 )
mysql_field_type --  Get the type of the specified field in a result 
Description
string mysql_field_type ( resource result, int field_offset)
mysql_field_type() is similar to the mysql_field_name() function. The 
arguments are identical, but the field type is returned instead. The field 
type will be one of "int", "real", "string", "blob", and others as 
detailed in the MySQL documentation. Example 1. mysql_field_type() 
example
  <?php
      mysql_connect("localhost", "mysql_username", 
  "mysql_password");
      mysql_select_db("mysql");
      $result = mysql_query("SELECT * FROM func");
      $fields = mysql_num_fields($result);
      $rows   = mysql_num_rows($result);
      $table = mysql_field_table($result, 0);
      echo "Your '" . $table . "' table has " . $fields . " 
  fields and " . $rows . " record(s)\n";
      echo "The table has the following fields:\n";
      for ($i=0; $i < $fields; $i++) {
	  $type  = mysql_field_type($result, $i);
	  $name  = mysql_field_name($result, $i);
	  $len   = mysql_field_len($result, $i);
	  $flags = mysql_field_flags($result, $i);
	  echo $type . " " . $name . " " . $len . " " . $flags . 
  "\n";
      }
      mysql_free_result($result);
      mysql_close();
  ?> 

The above example would produce the following output: 
Your 'func' table has 4 fields and 1 record(s)
The table has the following fields:
string name 64 not_null primary_key binary
int ret 1 not_null
string dl 128 not_null
string type 9 not_null enum
For downward compatibility mysql_fieldtype() can also be used. This is 
deprecated, however.   mysql_field_tableUpmysql_free_result
#

#T=string mysql_field_type ( resource result, int field_offset)
mysql_field_type ( ^!resource result, int field_offset);
#

#T=mysql_free_result - bool mysql_free_result ( resource result)
(PHP 3, PHP 4 )
mysql_free_result -- Free result memory
Description
bool mysql_free_result ( resource result)
mysql_free_result() will free all memory associated with the result 
identifier result. 
mysql_free_result() only needs to be called if you are concerned about how 
much memory is being used for queries that return large result sets. All 
associated result memory is automatically freed at the end of the script's 
execution. 
Returns TRUE on success or FALSE on failure. 
For downward compatibility mysql_freeresult() can also be used. This is 
deprecated, however.   mysql_field_typeUpmysql_get_client_info
#

#T=bool mysql_free_result ( resource result)
mysql_free_result ( ^!resource result);
#

#T=mysql_get_client_info - string mysql_get_client_info ( void )
(PHP 4 >= 4.0.5)
mysql_get_client_info -- Get MySQL client info
Description
string mysql_get_client_info ( void )
mysql_get_client_info() returns a string that represents the client 
library version. 
Example 1. mysql_get_client_info() example
  <?php
      printf("MySQL client info: %s\n", 
mysql_get_client_info());
  ?> 

The above example would produce the following output: 
MySQL client info: 3.23.39
See also mysql_get_host_info(), mysql_get_proto_info() and 
mysql_get_server_info().   mysql_free_resultUpmysql_get_host_info
#

#T=string mysql_get_client_info ( void )
mysql_get_client_info ( ^!void );
#

#T=mysql_get_host_info - string mysql_get_host_info ( [resource link_identifier])
(PHP 4 >= 4.0.5)
mysql_get_host_info -- Get MySQL host info
Description
string mysql_get_host_info ( [resource link_identifier])
mysql_get_host_info() returns a string describing the type of connection 
in use for the connection link_identifier, including the server host name. 
If link_identifier is omitted, the last opened connection will be used. 
Example 1. mysql_get_host_info() example
  <?php
      mysql_connect("localhost", "mysql_user", "mysql_password") 
  or
	  die("Could not connect: " . mysql_error());
      printf("MySQL host info: %s\n", mysql_get_host_info());
  ?> 

The above example would produce the following output: 
MySQL host info: Localhost via UNIX socket
See also mysql_get_client_info(), mysql_get_proto_info() and 
mysql_get_server_info().   mysql_get_client_infoUpmysql_get_proto_info
#

#T=string mysql_get_host_info ( [resource link_identifier])
mysql_get_host_info ( ^![resource link_identifier]);
#

#T=mysql_get_proto_info - int mysql_get_proto_info ( [resource link_identifier])
(PHP 4 >= 4.0.5)
mysql_get_proto_info -- Get MySQL protocol info
Description
int mysql_get_proto_info ( [resource link_identifier])
mysql_get_proto_info() returns the protocol version used by connection 
link_identifier. If link_identifier is omitted, the last opened connection 
will be used. 
Example 1. mysql_get_proto_info() example
  <?php
      mysql_connect("localhost", "mysql_user", "mysql_password") 
  or
	  die("Could not connect: " . mysql_error());
      printf("MySQL protocol version: %s\n", 
  mysql_get_proto_info());
  ?> 

The above example would produce the following output: 
MySQL protocol version: 10
See also mysql_get_client_info(), mysql_get_host_info() and 
mysql_get_server_info().   mysql_get_host_infoUpmysql_get_server_info
#

#T=int mysql_get_proto_info ( [resource link_identifier])
mysql_get_proto_info ( ^![resource link_identifier]);
#

#T=mysql_get_server_info - string mysql_get_server_info ( [resource link_identifier])
(PHP 4 >= 4.0.5)
mysql_get_server_info -- Get MySQL server info
Description
string mysql_get_server_info ( [resource link_identifier])
mysql_get_server_info() returns the server version used by connection 
link_identifier. If link_identifier is omitted, the last opened connection 
will be used. 
Example 1. mysql_get_server_info() example
  <?php
      mysql_connect("localhost", "mysql_user", "mysql_password") 
  or
	  die("Could not connect: " . mysql_error());
      printf("MySQL server version: %s\n", 
  mysql_get_server_info());
  ?> 

The above example would produce the following output: 
MySQL server version: 4.0.1-alpha
See also mysql_get_client_info(), mysql_get_host_info() and 
mysql_get_proto_info().   mysql_get_proto_infoUpmysql_info
#

#T=string mysql_get_server_info ( [resource link_identifier])
mysql_get_server_info ( ^![resource link_identifier]);
#

#T=mysql_info - string mysql_info ( [resource link_identifier])
(PHP 4 >= 4.3.0)
mysql_info --  Get information about the most recent query 
Description
string mysql_info ( [resource link_identifier])
mysql_info() returns detailed information about the last query using the 
given link_identifier. If link_identifier isn't specified, the last opened 
link is assumed. 
mysql_info() returns a string for all statements listed below. For 
everything else, it returns FALSE. The string format depends on the given 
statement. Example 1. Relevant MySQL Statements
INSERT INTO ... SELECT ...
String format: Records: 23 Duplicates: 0 Warnings: 0 
INSERT INTO ... VALUES (...),(...),(...)...
String format: Records: 37 Duplicates: 0 Warnings: 0 
LOAD DATA INFILE ...
String format: Records: 42 Deleted: 0 Skipped: 0 Warnings: 0 
ALTER TABLE
String format: Records: 60 Duplicates: 0 Warnings: 0 
UPDATE
String format: Rows matched: 65 Changed: 65 Warnings: 0

The numbers are only for illustrating purpose; their values will 
correspond to the query. 
Note: mysql_info() returns a non-FALSE value for the INSERT ... VALUES 
statement only if multiple value lists are specified in the statement. 
See also mysql_affected_rows().   mysql_get_server_infoUpmysql_insert_id
#

#T=string mysql_info ( [resource link_identifier])
mysql_info ( ^![resource link_identifier]);
#

#T=mysql_insert_id - int mysql_insert_id ( [resource link_identifier])
(PHP 3, PHP 4 )
mysql_insert_id --  Get the ID generated from the previous INSERT 
operation 
Description
int mysql_insert_id ( [resource link_identifier])
mysql_insert_id() returns the ID generated for an AUTO_INCREMENT column by 
the previous INSERT query using the given link_identifier. If 
link_identifier isn't specified, the last opened link is assumed. 
mysql_insert_id() returns 0 if the previous query does not generate an 
AUTO_INCREMENT value. If you need to save the value for later, be sure to 
call mysql_insert_id() immediately after the query that generates the 
value. 
Note: The value of the MySQL SQL function LAST_INSERT_ID() always 
contains the most recently generated AUTO_INCREMENT value, and is not 
reset between queries. 
Warning
mysql_insert_id() converts the return type of the native MySQL C API 
function mysql_insert_id() to a type of long (named int in PHP). If 
your AUTO_INCREMENT column has a column type of BIGINT, the value 
returned by mysql_insert_id() will be incorrect. Instead, use the 
internal MySQL SQL function LAST_INSERT_ID() in an SQL query. 

Example 1. mysql_insert_id() example
  <?php
      mysql_connect("localhost", "mysql_user", "mysql_password") 
  or
	  die("Could not connect: " . mysql_error());
      mysql_select_db("mydb");

      mysql_query("INSERT INTO mytable (product) values 
  ('kossu')");
      printf("Last inserted record has id %d\n", 
  mysql_insert_id());
  ?> 
See also mysql_query().   mysql_infoUpmysql_list_dbs
#

#T=int mysql_insert_id ( [resource link_identifier])
mysql_insert_id ( ^![resource link_identifier]);
#

#T=mysql_list_dbs - resource mysql_list_dbs ( [resource link_identifier])
(PHP 3, PHP 4 )
mysql_list_dbs --  List databases available on a MySQL server 
Description
resource mysql_list_dbs ( [resource link_identifier])
mysql_list_dbs() will return a result pointer containing the databases 
available from the current mysql daemon. Use the mysql_tablename() 
function to traverse this result pointer, or any function for result 
tables, such as mysql_fetch_array(). 
Example 1. mysql_list_dbs() example
  <?php
  $link = mysql_connect('localhost', 'mysql_user', 
  'mysql_password');
  $db_list = mysql_list_dbs($link);

  while ($row = mysql_fetch_object($db_list)) {
      echo $row->Database . "\n";
  }
  ?> 

The above example would produce the following output: 
database1
database2
database3
...
Note: The above code would just as easily work with mysql_fetch_row() or 
other similar functions. 
For downward compatibility mysql_listdbs() can also be used. This is 
deprecated however. 
See also mysql_db_name().   mysql_insert_idUpmysql_list_fields
#

#T=resource mysql_list_dbs ( [resource link_identifier])
mysql_list_dbs ( ^![resource link_identifier]);
#

#T=mysql_list_fields - resource mysql_list_fields ( string database_name, string table_name [, 
(PHP 3, PHP 4 )
mysql_list_fields -- List MySQL table fields
Description
resource mysql_list_fields ( string database_name, string table_name [, 
resource link_identifier])
mysql_list_fields() retrieves information about the given table name. 
Arguments are the database and the table name. A result pointer is 
returned which can be used with mysql_field_flags(), mysql_field_len(), 
mysql_field_name(), and mysql_field_type(). 
Example 1. mysql_list_fields() example
  <?php
  $link = mysql_connect('localhost', 'mysql_user', 
  'mysql_password');

  $fields = mysql_list_fields("database1", "table1", $link);
  $columns = mysql_num_fields($fields);

  for ($i = 0; $i < $columns; $i++) {
      echo mysql_field_name($fields, $i) . "\n";
  }
  ?> 

The above example would produce the following output: 
field1
field2
field3
...
For downward compatibility mysql_listfields() can also be used. This is 
deprecated however. 
Note: The function mysql_list_fields() is deprecated. It is preferable 
to use mysql_query() to issue a SQL SHOW COLUMNS FROM table [LIKE 
'name'] Statement instead.   mysql_list_dbsUpmysql_list_processes
#

#T=resource mysql_list_fields ( string database_name, string table_name [, 
mysql_list_fields ( ^!string database_name, string table_name [, ;
#

#T=mysql_list_processes - resource mysql_list_processes ( [resource link_identifier])
(PHP 4 >= 4.3.0)
mysql_list_processes -- List MySQL processes
Description
resource mysql_list_processes ( [resource link_identifier])
mysql_list_processes() returns a result pointer describing the current 
server threads. 
Example 1. mysql_list_processes() example
  <?php
  $link = mysql_connect('localhost', 'mysql_user', 
  'mysql_password');

  $result = mysql_list_processes($link);
  while ($row = mysql_fetch_assoc($result)){
      printf("%s %s %s %s %s\n", $row["Id"], $row["Host"], 
  $row["db"],
	 $row["Command"], $row["Time"]);
  }
  mysql_free_result($result);
  ?> 

The above example would produce the following output: 
1 localhost test Processlist 0
4 localhost mysql sleep 5
See also mysql_thread_id().   mysql_list_fieldsUpmysql_list_tables
#

#T=resource mysql_list_processes ( [resource link_identifier])
mysql_list_processes ( ^![resource link_identifier]);
#

#T=mysql_list_tables - resource mysql_list_tables ( string database [, resource link_identifier])
(PHP 3, PHP 4 )
mysql_list_tables -- List tables in a MySQL database
Description
resource mysql_list_tables ( string database [, resource link_identifier])
mysql_list_tables() takes a database name and returns a result pointer 
much like the mysql_query() function. Use the mysql_tablename() function 
to traverse this result pointer, or any function for result tables, such 
as mysql_fetch_array(). 
The database parameter is the name of the database to retrieve the list of 
tables from. Upon failure, mysql_list_tables() returns FALSE. 
For downward compatibility, the function alias named mysql_listtables() 
can be used. This is deprecated however and is not recommended. 
Note: This function has been deprecated. Do not use this function. Use 
the command SHOW TABLES FROM DATABASE instead. 
Example 1. mysql_list_tables() example
  <?php
      $dbname = 'mysql_dbname';

      if (!mysql_connect('mysql_host', 'mysql_user', 
  'mysql_password')) {
	  echo 'Could not connect to mysql';
	  exit;
      }

      $result = mysql_list_tables($dbname);
      
      if (!$result) {
	  echo "DB Error, could not list tables\n";
	  echo 'MySQL Error: ' . mysql_error();
	  exit;
      }
      
      while ($row = mysql_fetch_row($result)) {
	  echo "Table: $row[0]\n";
      }

      mysql_free_result($result);
  ?> 
See also mysql_list_dbs() and mysql_tablename().   mysql_list_processesUpmysql_num_fields
#

#T=resource mysql_list_tables ( string database [, resource link_identifier])
mysql_list_tables ( ^!string database [, resource link_identifier]);
#

#T=mysql_num_fields - int mysql_num_fields ( resource result)
(PHP 3, PHP 4 )
mysql_num_fields -- Get number of fields in result
Description
int mysql_num_fields ( resource result)
mysql_num_fields() returns the number of fields in the result set result. 
See also mysql_select_db(), mysql_query(), mysql_fetch_field() and 
mysql_num_rows(). 
For downward compatibility mysql_numfields() can also be used. This is 
deprecated however.   mysql_list_tablesUpmysql_num_rows
#

#T=int mysql_num_fields ( resource result)
mysql_num_fields ( ^!resource result);
#

#T=mysql_num_rows - int mysql_num_rows ( resource result)
(PHP 3, PHP 4 )
mysql_num_rows -- Get number of rows in result
Description
int mysql_num_rows ( resource result)
mysql_num_rows() returns the number of rows in a result set. This command 
is only valid for SELECT statements. To retrieve the number of rows 
affected by a INSERT, UPDATE or DELETE query, use mysql_affected_rows(). 
Example 1. mysql_num_rows() example
  <?php

  $link = mysql_connect("localhost", "mysql_user", 
  "mysql_password");
  mysql_select_db("database", $link);

  $result = mysql_query("SELECT * FROM table1", $link);
  $num_rows = mysql_num_rows($result);

  echo "$num_rows Rows\n";

  ?> 
Note: If you use mysql_unbuffered_query(), mysql_num_rows() will not 
return the correct value until all the rows in the result set have been 
retrieved. 
See also mysql_affected_rows(), mysql_connect(), mysql_data_seek(), 
mysql_select_db() and mysql_query(). 
For downward compatibility mysql_numrows() can also be used. This is 
deprecated however.   mysql_num_fieldsUpmysql_pconnect
#

#T=int mysql_num_rows ( resource result)
mysql_num_rows ( ^!resource result);
#

#T=mysql_pconnect - resource mysql_pconnect ( [string server [, string username [, string 
(PHP 3, PHP 4 )
mysql_pconnect --  Open a persistent connection to a MySQL server 
Description
resource mysql_pconnect ( [string server [, string username [, string 
password [, int client_flags]]]])
Returns a positive MySQL persistent link identifier on success, or FALSE 
on error. 
mysql_pconnect() establishes a connection to a MySQL server. The following 
defaults are assumed for missing optional parameters: server = 
'localhost:3306', username = name of the user that owns the server process 
and password = empty password. The client_flags parameter can be a 
combination of the constants MYSQL_CLIENT_COMPRESS, 
MYSQL_CLIENT_IGNORE_SPACE or MYSQL_CLIENT_INTERACTIVE. 
The server parameter can also include a port number. e.g. "hostname:port" 
or a path to a socket e.g. ":/path/to/socket" for the localhost. 
Note: Support for ":port" was added in 3.0B4. 
Support for the ":/path/to/socket" was added in 3.0.10. 
mysql_pconnect() acts very much like mysql_connect() with two major 
differences. 
First, when connecting, the function would first try to find a 
(persistent) link that's already open with the same host, username and 
password. If one is found, an identifier for it will be returned instead 
of opening a new connection. 
Second, the connection to the SQL server will not be closed when the 
execution of the script ends. Instead, the link will remain open for 
future use (mysql_close() will not close links established by 
mysql_pconnect()). 
The optional client_flags parameter became available in PHP 4.3.0. 
This type of link is therefore called 'persistent'. 
Note: Note, that these kind of links only work if you are using a module 
version of PHP. See the Persistent Database Connections section for more 
information. 
Warning
Using persistent connections can require a bit of tuning of your 
Apache and MySQL configurations to ensure that you do not exceed the 
number of connections allowed by MySQL. 
  mysql_num_rowsUpmysql_ping
#

#T=resource mysql_pconnect ( [string server [, string username [, string 
mysql_pconnect ( ^![string server [, string username [, string ;
#

#T=mysql_ping - bool mysql_ping ( [resource link_identifier])
(PHP 4 >= 4.3.0)
mysql_ping -- Ping a server connection or reconnect if there is no 
connection
Description
bool mysql_ping ( [resource link_identifier])
mysql_ping() checks whether or not the connection to the server is 
working. If it has gone down, an automatic reconnection is attempted. This 
function can be used by scripts that remain idle for a long while, to 
check whether or not the server has closed the connection and reconnect if 
necessary. mysql_ping() returns TRUE if the connection to the server is 
working, otherwise FALSE. 
See also mysql_thread_id() and mysql_list_processes().   mysql_pconnectUpmysql_query
#

#T=bool mysql_ping ( [resource link_identifier])
mysql_ping ( ^![resource link_identifier]);
#

#T=mysql_query - resource mysql_query ( string query [, resource link_identifier])
(PHP 3, PHP 4 )
mysql_query -- Send a MySQL query
Description
resource mysql_query ( string query [, resource link_identifier])
mysql_query() sends a query to the currently active database on the server 
that's associated with the specified link identifier. If link_identifier 
isn't specified, the last opened link is assumed. If no link is open, the 
function tries to establish a link as if mysql_connect() was called with 
no arguments, and use it. The result of the query is buffered. 
Note: The query string should not end with a semicolon. 
Only for SELECT,SHOW,EXPLAIN or DESCRIBE statements mysql_query() returns 
a resource identifier or FALSE if the query was not executed correctly. 
For other type of SQL statements, mysql_query() returns TRUE on success 
and FALSE on error. A non-FALSE return value means that the query was 
legal and could be executed by the server. It does not indicate anything 
about the number of rows affected or returned. It is perfectly possible 
for a query to succeed but affect no rows or return no rows. 
The following query is syntactically invalid, so mysql_query() fails and 
returns FALSE: Example 1. mysql_query() example
  <php
  $result = mysql_query("SELECT * WHERE 1=1")
      or die("Invalid query: " . mysql_error());
  ?> 
The following query is semantically invalid if my_col is not a column in 
the table my_tbl, so mysql_query() fails and returns FALSE: Example 
2. mysql_query()
  <?php
  $result = mysql_query("SELECT my_col FROM my_tbl")
      or die("Invalid query: " . mysql_error());
  ?> 
mysql_query() will also fail and return FALSE if you don't have permission 
to access the table(s) referenced by the query. 
Assuming the query succeeds, you can call mysql_num_rows() to find out how 
many rows were returned for a SELECT statement or mysql_affected_rows() to 
find out how many rows were affected by a DELETE, INSERT, REPLACE, or 
UPDATE statement. 
Only for SELECT,SHOW,DESCRIBE or EXPLAIN statements, mysql_query() returns 
a new result identifier that you can pass to mysql_fetch_array() and other 
functions dealing with result tables. When you are done with the result 
set, you can free the resources associated with it by calling 
mysql_free_result(). Although, the memory will automatically be freed at 
the end of the script's execution. 
See also mysql_num_rows(), mysql_affected_rows(), 
mysql_unbuffered_query(), mysql_free_result(), mysql_fetch_array(), 
mysql_fetch_row(), mysql_fetch_assoc(), mysql_result(), mysql_select_db() 
and mysql_connect().   mysql_pingUpmysql_real_escape_string
#

#T=resource mysql_query ( string query [, resource link_identifier])
mysql_query ( ^!string query [, resource link_identifier]);
#

#T=mysql_real_escape_string - string mysql_real_escape_string ( string unescaped_string [, resource 
(PHP 4 >= 4.3.0)
mysql_real_escape_string --  Escapes special characters in a string for 
use in a SQL statement, taking into account the current charset of the 
connection. 
Description
string mysql_real_escape_string ( string unescaped_string [, resource 
link_identifier])
This function will escape special characters in the unescaped_string, 
taking into account the current charset of the connection so that it is 
safe to place it in a mysql_query(). 
Note: mysql_real_escape_string() does not escape % and _. 
Example 1. mysql_real_escape_string() example
  <?php
  $item = "Zak's and Derick's Laptop";
  $escaped_item = mysql_real_escape_string($item);
  printf("Escaped string: %s\n", $escaped_item);
  ?> 

The above example would produce the following output: 
Escaped string: Zak\'s and Derick\'s Laptop
See also mysql_escape_string() and mysql_character_set_name().   mysql_queryUpmysql_result
#

#T=string mysql_real_escape_string ( string unescaped_string [, resource 
mysql_real_escape_string ( ^!string unescaped_string [, resource ;
#

#T=mysql_result - mixed mysql_result ( resource result, int row [, mixed field])
(PHP 3, PHP 4 )
mysql_result -- Get result data
Description
mixed mysql_result ( resource result, int row [, mixed field])
mysql_result() returns the contents of one cell from a MySQL result set. 
The field argument can be the field's offset, or the field's name, or the 
field's table dot field name (tablename.fieldname). If the column name has 
been aliased ('select foo as bar from...'), use the alias instead of the 
column name. 
When working on large result sets, you should consider using one of the 
functions that fetch an entire row (specified below). As these functions 
return the contents of multiple cells in one function call, they're MUCH 
quicker than mysql_result(). Also, note that specifying a numeric offset 
for the field argument is much quicker than specifying a fieldname or 
tablename.fieldname argument. 
Calls to mysql_result() should not be mixed with calls to other functions 
that deal with the result set. 
Example 1. mysql_result() example
  <?php
      $link = mysql_connect("localhost", "mysql_user", 
  "mysql_password")
	      or die("Could not connect: " . mysql_error());

      $result = mysql_query("SELECT name FROM work.employee")
	      or die("Could not query:" . mysql_error());
	      
      echo mysql_result($result, 2); // outputs third employee's 
  name
      
      mysql_close($link);
  ?> 
Recommended high-performance alternatives : mysql_fetch_row(), 
mysql_fetch_array(), mysql_fetch_assoc() and mysql_fetch_object().   mysql_real_escape_stringUpmysql_select_db
#

#T=mixed mysql_result ( resource result, int row [, mixed field])
mysql_result ( ^!resource result, int row [, mixed field]);
#

#T=mysql_select_db - bool mysql_select_db ( string database_name [, resource link_identifier])
(PHP 3, PHP 4 )
mysql_select_db -- Select a MySQL database
Description
bool mysql_select_db ( string database_name [, resource link_identifier])
Returns TRUE on success or FALSE on failure. 
mysql_select_db() sets the current active database on the server that's 
associated with the specified link identifier. If no link identifier is 
specified, the last opened link is assumed. If no link is open, the 
function will try to establish a link as if mysql_connect() was called 
without arguments, and use it. 
Every subsequent call to mysql_query() will be made on the active 
database. 
Example 1. mysql_select_db() example
  <?php

  $lnk = mysql_connect('localhost', 'mysql_user', 
  'mysql_password')
	 or die('Not connected : ' . mysql_error());

  // make foo the current db
  mysql_select_db('foo', $lnk) or die ('Can\'t use foo : ' . 
  mysql_error());

  ?> 
See also mysql_connect(), mysql_pconnect() and mysql_query(). 
For downward compatibility mysql_selectdb() can also be used. This is 
deprecated however.   mysql_resultUpmysql_stat
#

#T=bool mysql_select_db ( string database_name [, resource link_identifier])
mysql_select_db ( ^!string database_name [, resource link_identifier]);
#

#T=mysql_stat - string mysql_stat ( [resource link_identifier])
(PHP 4 >= 4.3.0)
mysql_stat -- Get current system status
Description
string mysql_stat ( [resource link_identifier])
mysql_stat() returns the current server status. 
Note: mysql_stat() currently only returns status for uptime, threads, 
queries, open tables, flush tables and queries per second. For a 
complete list of other status variables you have to use the SHOW STATUS 
SQL command. 
Example 1. mysql_stat() example
  <?php
  $link = mysql_connect('localhost', "mysql_user", 
  "mysql_password");
  $status = explode('  ', mysql_stat($link));
  print_r($status);
  ?> 

The above example would produce the following output: 
Array
(
[0] => Uptime: 5380
[1] => Threads: 2
[2] => Questions: 1321299
[3] => Slow queries: 0
[4] => Opens: 26
[5] => Flush tables: 1
[6] => Open tables: 17
[7] => Queries per second avg: 245.595
)

  mysql_select_dbUpmysql_tablename
#

#T=string mysql_stat ( [resource link_identifier])
mysql_stat ( ^![resource link_identifier]);
#

#T=mysql_tablename - string mysql_tablename ( resource result, int i)
(PHP 3, PHP 4 )
mysql_tablename -- Get table name of field
Description
string mysql_tablename ( resource result, int i)
mysql_tablename() takes a result pointer returned by the 
mysql_list_tables() function as well as an integer index and returns the 
name of a table. The mysql_num_rows() function may be used to determine 
the number of tables in the result pointer. Use the mysql_tablename() 
function to traverse this result pointer, or any function for result 
tables, such as mysql_fetch_array(). Example 1. mysql_tablename() 
example
  <?php
      mysql_connect("localhost", "mysql_user", 
"mysql_password");
      $result = mysql_list_tables("mydb");

      for ($i = 0; $i < mysql_num_rows($result); $i++)
	  printf("Table: %s\n", mysql_tablename($result, $i));

      mysql_free_result($result);
  ?> 
See also mysql_list_tables().   mysql_statUpmysql_thread_id
#

#T=string mysql_tablename ( resource result, int i)
mysql_tablename ( ^!resource result, int i);
#

#T=mysql_thread_id - int mysql_thread_id ( [resource link_identifier])
(PHP 4 >= 4.3.0)
mysql_thread_id -- Return the current thread ID
Description
int mysql_thread_id ( [resource link_identifier])
mysql_thread_id() returns the current thread ID. If the connection is lost 
and you reconnect with mysql_ping(), the thread ID will change. This means 
you should not get the thread ID and store it for later. You should get it 
when you need it. 
Example 1. mysql_thread_id() example
  <?php
  $link = mysql_connect('localhost', 'mysql_user', 
  'mysql_password');
  $thread_id = mysql_thread_id($link);
  if ($thread_id){
      printf("current thread id is %d\n", $thread_id);
  }
  ?> 

The above example would produce the following output: 
current thread id is 73
See also mysql_ping() and mysql_list_processes().   mysql_tablenameUpmysql_unbuffered_query
#

#T=int mysql_thread_id ( [resource link_identifier])
mysql_thread_id ( ^![resource link_identifier]);
#

#T=mysql_unbuffered_query - resource mysql_unbuffered_query ( string query [, resource 
(PHP 4 >= 4.0.6)
mysql_unbuffered_query --  Send an SQL query to MySQL, without fetching 
and buffering the result rows 
Description
resource mysql_unbuffered_query ( string query [, resource 
link_identifier])
mysql_unbuffered_query() sends a SQL query query to MySQL, without 
fetching and buffering the result rows automatically, as mysql_query() 
does. On the one hand, this saves a considerable amount of memory with SQL 
queries that produce large result sets. On the other hand, you can start 
working on the result set immediately after the first row has been 
retrieved: you don't have to wait until the complete SQL query has been 
performed. When using multiple DB-connects, you have to specify the 
optional parameter link_identifier. 
Note: The benefits of mysql_unbuffered_query() come at a cost: You 
cannot use mysql_num_rows() and mysql_data_seek() on a result set 
returned from mysql_unbuffered_query(). You also have to fetch all 
result rows from an unbuffered SQL query, before you can send a new SQL 
query to MySQL. 
See also mysql_query().   mysql_thread_idUpImproved MySQL Extension
#

#T=resource mysql_unbuffered_query ( string query [, resource 
mysql_unbuffered_query ( ^!string query [, resource ;
#

#T=mysqli_affected_rows - mixed mysqli_affected_rows ( object link)
(PHP 5 CVS only)
mysqli_affected_rows -- Gets the number of affected rows in a previous 
MySQL operation
Description
mixed mysqli_affected_rows ( object link)
mysqli_affected_rows() returns the number of rows affected by the last 
INSERT, UPDATE, or DELETE query associated with the provided link 
parameter. If the last query was invalid, this function will return -1. 
Note: When deleting the entire contents of a table (i.e. 'DELETE FROM 
foo'), this function will not return the number of rows that were 
actually deleted. 
The mysqli_affected_rows() function only works with queries which modify a 
table. In order to return the number of rows from a SELECT query, use the 
mysqli_num_rows() function instead. 
Example 1. Delete-Query
Procedural style:
  <?php
      /* connect to database */
      $link = mysqli_connect("localhost", "mysql_user", 
  "mysql_password", "mydb") or
	  die("Could not connect: " . mysqli_connect_error());
      
      /* this should return the correct numbers of deleted 
  records */
      mysqli_query($link, "DELETE FROM mytable WHERE id < 10");
      printf("Records deleted: %2d\n", 
  mysqli_affected_rows($link));

      /* without a where clause in a delete statement, it should 
  return 0 */
      mysqli_query($link, "DELETE FROM mytable");
      printf("Records deleted: %2d\n", 
  mysqli_affected_rows($link));

      /* close connection */
      mysqli_close($link);
  ?> 

Object oriented style:
  <?php
      /* connect to database */
      $mysql = mysqli_connect("localhost", "mysql_user", 
  "mysql_password", "mydb") or
	  die("Could not connect: " . mysqli_connect_error());
      
      /* this should return the correct numbers of deleted 
  records */
      $mysql->query("DELETE FROM mytable WHERE id < 10");
      printf ("Records deleted: %2d\n", 
$mysql->affected_rows());

      /* without a where clause in a delete statement, it should 
  return 0 */
      $mysql->query("DELETE FROM mytable");
      printf ("Records deleted: %2d\n", 
$mysql->affected_rows());

      /* close connection */
      $mysql->close();
  ?> 

The above examples would produce the following output: Records deleted: 10
Records deleted:  0

Example 2. Update-Query
Procedural style:
  <?php
      /* connect to database */
      $link = mysqli_connect("localhost", "mysql_user", 
  "mysql_password", "mydb") or
	  die("Could not connect: " . mysqli_connect_error());
	  
      /* Update records */
      mysqli_query($link, "UPDATE mytable SET used=1 WHERE id < 
  10");
      printf ("Updated records: %d\n", 
  mysqli_affected_rows($link));

      /* close connection */
      mysqli_close($link);
  ?> 

Object oriented style:
  <?php
      /* connect to database */
      $mysql = mysqli_connect("localhost", "mysql_user", 
  "mysql_password", "mydb") or
	  die("Could not connect: " . mysqli_connect_error());
	  
      /* Update records */
      $mysql->query("UPDATE mytable SET used=1 WHERE id < 10");
      printf ("Updated records: %d\n", 
  $mysql->affected_rows($link));

      /* close connection */
      $mysql->close($link);
  ?> 

The above examples would produce the following output: Updated Records: 10
See also: mysqli_num_rows(), mysqli_info().   Improved MySQL ExtensionUpmysqli_autocommit
#

#T=mixed mysqli_affected_rows ( object link)
mysqli_affected_rows ( ^!object link);
#

#T=mysqli_autocommit - bool mysqli_autocommit ( object link, bool mode)
(PHP 5 CVS only)
mysqli_autocommit -- Turns on or off auto-committing database 
modifications
Description
bool mysqli_autocommit ( object link, bool mode)
mysqli_autocommit() is used to turn on or off auto-commit mode on queries 
for the database connection represented by the link resource. 
Returns TRUE on success or FALSE on failure. 
Note: mysqli_autocommit() doesn't work with non transactional table 
types (like MyISAM or ISAM). 
To determine the current state of autocommit use the SQL command 'SELECT 
@@autocommit'. 
Example 1. Using the mysqli_autocommit function
Procedural style:
  <?php

      /* Open a connection */
      $link = mysqli_connect("localhost", "user", "pass", 
  "mydb");
      
      /* Turn on autocommit */
      mysqli_autocommit($link, true);

      /* determine current autocommit status */
      if ($result = mysqli_query($link, "SELECT @@autocommit")) 
{
	  $row = mysqli_fetch_row($result);
	  mysqli_free_result($result);
	  printf("Autocommit is %d\n", $row[0]);
      }

      /* close connection */
      mysqli_close($link);
  ?> 

Object oriented style:
  <?php

      /* Open a connection */
      $mysql = mysqli_connect("localhost", "user", "pass", 
  "mydb");
      
      /* Turn on autocommit */
      $mysql->autocommit(true);

      /* determine current autocommit status */
      if ($result = $mysql->query($link, "SELECT @@autocommit")) 
  {
	  $row = $result->fetch_row($result);
	  printf ("Autocommit is %d\n", $row[0]);
	  $result->free();
      }

      /* close connection */
      $mysql->close();
  ?> 

The above examples would produce the following output: Autocommit is 1
See also mysqli_commit(), mysqli_rollback().   mysqli_affected_rowsUpmysqli_bind_param
#

#T=bool mysqli_autocommit ( object link, bool mode)
mysqli_autocommit ( ^!object link, bool mode);
#

#T=mysqli_bind_param - bool mysqli_bind_param ( object stmt, array types, mixed var1 [, mixed 
(PHP 5 CVS only)
mysqli_bind_param -- Binds variables to a prepared statement as parameters
Description
bool mysqli_bind_param ( object stmt, array types, mixed var1 [, mixed 
var2, ...])
mysql_bind_param() is used to bind variables for the parameter markers in 
the SQL statement that was passed to mysql_prepare(). The array types 
specifies the types for the diffrent bind variables. Valid array values 
are MYSQLI_BIND_INT, MYSQLI_BIND_DOUBLE, MYSQLI_BIND_STRING and 
MYSQLI_SEND_DATA. 
Note: If data size of a variable exceeds max. allowed package size 
(max_allowed_package), you have to specify MYSQLI_SEND_DATA and use 
mysqli_send_long_data() to send the data in packages. 
The number of variables and array values must match the number of 
parameters in the statement. 
Example 1. Prepared statements
Procedural style:
  <?php
      /* connect to database */
      $link = mysqli_connect("localhost", "mysql_user", 
  "mysql_password", "mydb") or
	  die("Could not connect: " . mysqli_connect_error());

      /* create mytable */
      mysqli_query($link, "CREATE TABLE mytable (a int, b int, c 
  varchar(30))");
      
      /* prepare statement and bind variables for insert 
  statements */
      $stmt = mysqli_prepare($link, "INSERT INTO mytable VALUES 
  (?, ?, ?)");
      mysqli_bind_param($stmt, array(MYSQLI_BIND_INT, 
  MYSQLI_BIND_INT,
			MYSQLI_BIND_STRING), $a, $b, $c);

      $a = 1;
      $b = 2;
      $c = "I prefer OpenSource software";

      /* execute prepared statement */
      mysqli_execute($stmt);

      /* close statement and connection */
      mysqli_close_stmt(stmt);
      mysqli_close(link);

  ?> 

Object oriented style:
  <?php
      /* connect to database */
      $mysql = mysqli_connect("localhost", "mysql_user", 
  "mysql_password", "mydb") or
	  die("Could not connect: " . mysqli_connect_error());

      /* create mytable */
      $mysql->query("CREATE TABLE mytable (a int, b int, c 
  varchar(30))");
      
      /* prepare statement and bind parameters */
      $stmt = $mysql->prepare("INSERT INTO mytable VALUES (?, ?, 
  ?)");
      $stmt->bind_param(array(MYSQLI_BIND_INT, MYSQLI_BIND_INT,
			MYSQLI_BIND_STRING), $a, $b, $c);

      $a = 1;
      $b = 2;
      $c = "I prefer opensource software";

      /* execute prepared statement */
      $stmt->execute();

      /* close statement and connection */
      $stmt->close();
      $mysql->close();
  ?> 
See also: mysqli_bind_result(), mysqli_execute(), mysqli_fetch() 
mysqli_prepare() mysqli_send_long_data()   mysqli_autocommitUpmysqli_bind_result
#

#T=bool mysqli_bind_param ( object stmt, array types, mixed var1 [, mixed 
mysqli_bind_param ( ^!object stmt, array types, mixed var1 [, mixed ;
#

#T=mysqli_bind_result - bool mysqli_bind_result ( resource stmt, mixed var, int len)
(PHP 5 CVS only)
mysqli_bind_result -- Binds variables to a prepared statement for result 
storage
Description
bool mysqli_bind_result ( resource stmt, mixed var, int len)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_bind_paramUpmysqli_change_user
#

#T=bool mysqli_bind_result ( resource stmt, mixed var, int len)
mysqli_bind_result ( ^!resource stmt, mixed var, int len);
#

#T=mysqli_change_user - bool mysqli_change_user ( resource link, string user, string password, 
(PHP 5 CVS only)
mysqli_change_user -- Changes the user of the specified database 
connection
Description
bool mysqli_change_user ( resource link, string user, string password, 
string database)
mysqli_change_user() is used to change the user of the specified database 
connection as given by the link parameter and to set the current database 
to that specified by the database parameter. 
Returns TRUE on success or FALSE on failure. 
If desired, the NULL value may be passed in place of the database 
parameter resulting in only changing the user and not selecting a 
database. To select a database in this case use the mysqli_select_db() 
function. 
In order to successfully change users a valid username and password 
parameters must be provided and that user must have sufficient permissions 
to access the desired database. If for any reason authorization fails, the 
current user authentication will remain. 
Note: Using this command will always cause the current database 
connection to behave as if was a completely new database connection, 
regardless of if the operation was completed successfully. This reset 
includes performing a rollback on any active transactions, closing all 
temporary tables, and unlocking all locked tables. 
Example 1. Using the mysqli_change_user function
  <?php
			      
      /* Open a connection as foo@localhost and select foo_db */
      $link = mysqli_connect("localhost", "foo", "pass");
      mysqli_select_db("foo_db");
					   
      /* Change user to bar@localhost and default database to 
  bar_db */
      mysqli_change_user($link, "bar", "otherpass", "bar_db");

  ?> 

  mysqli_bind_resultUpmysqli_character_set_name
#

#T=bool mysqli_change_user ( resource link, string user, string password, 
mysqli_change_user ( ^!resource link, string user, string password, ;
#

#T=mysqli_character_set_name - string mysqli_character_set_name ( resource link)
(PHP 5 CVS only)
mysqli_character_set_name -- Returns the default character set for the 
database connection
Description
string mysqli_character_set_name ( resource link)
Returns the current character set for the database connection specified by 
the link parameter. 
Example 1. Using the mysqli_character_set_name function
  <?php
						       
      /* Open a connection */
      $link = mysqli_connect("localhost", "username", 
  "password");
								 
		 
      /* Print current character set */
      $charset = mysqli_character_set_name($link);
      echo "Current character set is $charset\n";

  ?> 
See also mysqli_real_escape_string().   mysqli_change_userUpmysqli_close
#

#T=string mysqli_character_set_name ( resource link)
mysqli_character_set_name ( ^!resource link);
#

#T=mysqli_close - bool mysqli_close ( resource link)
(PHP 5 CVS only)
mysqli_close -- Closes a previously opened database connection
Description
bool mysqli_close ( resource link)
The mysqli_close() function closes a previously opened database connection 
specified by the link parameter. 
See also mysqli_connect() and mysqli_real_connect().   mysqli_character_set_nameUpmysqli_commit
#

#T=bool mysqli_close ( resource link)
mysqli_close ( ^!resource link);
#

#T=mysqli_commit - bool mysqli_commit ( resource link)
(PHP 5 CVS only)
mysqli_commit -- Commits the current transaction
Description
bool mysqli_commit ( resource link)
Commits the current transaction for the database specified by the link 
parameter. 
See also mysqli_autocommit(), mysqli_rollback().   mysqli_closeUpmysqli_connect
#

#T=bool mysqli_commit ( resource link)
mysqli_commit ( ^!resource link);
#

#T=mysqli_connect - resource mysqli_connect ( [string hostname [, string username [, string 
(PHP 5 CVS only)
mysqli_connect -- Open a new connection to the MySQL server
Description
resource mysqli_connect ( [string hostname [, string username [, string 
passwd [, string dbname [, int port [, string socket]]]]]])
The mysqli_connect() function attempts to open a connection to the MySQL 
Server running on host which can be either a hostname or an IP address. 
Passing the NULL value or the string "localhost" to this parameter, the 
local host is assumed. When possible, pipes will be used instead of the 
TCP/IP protocol. If successful, the mysqli_connect() will return a 
resource representing the connection to the database, or FALSE on failure. 

The username and password parameters specify the username and password 
under which to connect to the MySQL server. If the password is not 
provided (the NULL value is passed), the MySQL server will attempt to 
authenticate the user against those user records which have no password 
only. This allows one username to be used with different permissions 
(depending on if a password as provided or not). 
The dbname parameter if provided will specify the default database to be 
used when performing queries. 
The port and socket parameters are used in conjunction with the hostname 
parameter to further control how to connect to the database server. The 
port parameter specifies the port number to attempt to connect to the 
MySQL server on, while the socket parameter specifies the socket or named 
pipe that should be used. 
Note: Specifying the socket parameter will not explicitly determine the 
type of connection to be used when connecting to the MySQL server. How 
the connection is made to the MySQL database is determined by the host 
parameter. 
Example 1. Using the mysqli_connect function
  <?php
								 
		     
  /* Open a connection as foo@localhost and make bar the default 
  database */
  $link = mysqli_connect("localhost", "foo", "password", "bar");

  ?> 
See also mysqli_close() and mysqli_real_connect().   mysqli_commitUpmysqli_data_seek
#

#T=resource mysqli_connect ( [string hostname [, string username [, string 
mysqli_connect ( ^![string hostname [, string username [, string ;
#

#T=mysqli_data_seek - void mysqli_data_seek ( resource result, int offset)
(PHP 5 CVS only)
mysqli_data_seek -- Adjusts the result pointer to an arbitrary row in the 
result
Description
void mysqli_data_seek ( resource result, int offset)
The mysqli_data_seek() function seeks to an arbitrary result pointer 
specified by the offset in the result set represented by result. The 
offset parameter must be between zero and the total number of rows minus 
one (0..mysqli_num_rows() - 1). 
Note: This function can only be used with results attained from the use 
of the mysqli_store_result() function. 
Example 1. Using the mysqli_data_seek function
  <?php
								 
		 
      /* Open a connection */
      $link = mysqli_connect("localhost", "username", 
  "password");
      mysqli_select_db("mydb");
								 
						  
      /* Get some rows and store them */
      $query = "SELECT DINSTINCT name FROM employee ORDER BY 
  name";
      $result = mysqli_query($query) or die(mysqli_error());

      $rows = mysqli_store_result($result);

      $total = mysqli_num_fields($rows);

      if ($total > 0) { // there is at least one row
	  /* Get the last employee */
	  mysqli_data_seek($rows, mysqli_num_rows($result) -1);
	  $employee = mysqli_fetch_row($rows);
	  printf("Employee name : %s\n", $employee[0]);
      }
	  
      mysqli_free_result($rows);

  ?> 
See also mysqli_store_result(), mysqli_fetch_row() and mysqli_num_rows().   mysqli_connectUpmysqli_debug
#

#T=void mysqli_data_seek ( resource result, int offset)
mysqli_data_seek ( ^!resource result, int offset);
#

#T=mysqli_debug - void mysqli_debug ( string debug)
(PHP 5 CVS only)
mysqli_debug -- Performs debugging operations
Description
void mysqli_debug ( string debug)
The mysqli_debug() function is used to perform debugging operations using 
the Fred Fish debugging library. The debug parameter is a string 
representing the debugging operation to perform. 
Example 1. Generating a Trace File
  <?php
      
      /* Create a trace file in '/tmp/client.trace' on the local 
  (client) machine: */
      mysqli_debug("d:t:0,/tmp/client.trace");
      
  ?> 

  mysqli_data_seekUpmysqli_disable_reads_from_master
#

#T=void mysqli_debug ( string debug)
mysqli_debug ( ^!string debug);
#

#T=mysqli_disable_reads_from_master - void mysqli_disable_reads_from_master ( resource link)
(PHP 5 CVS only)
mysqli_disable_reads_from_master -- 
Description
void mysqli_disable_reads_from_master ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_debugUpmysqli_disable_rpl_parse
#

#T=void mysqli_disable_reads_from_master ( resource link)
mysqli_disable_reads_from_master ( ^!resource link);
#

#T=mysqli_disable_rpl_parse - void mysqli_disable_rpl_parse ( resource link)
(PHP 5 CVS only)
mysqli_disable_rpl_parse -- 
Description
void mysqli_disable_rpl_parse ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_disable_reads_from_masterUpmysqli_dump_debug_info
#

#T=void mysqli_disable_rpl_parse ( resource link)
mysqli_disable_rpl_parse ( ^!resource link);
#

#T=mysqli_dump_debug_info - bool mysqli_dump_debug_info ( resource link)
(PHP 5 CVS only)
mysqli_dump_debug_info -- Dump debugging information into the log
Description
bool mysqli_dump_debug_info ( resource link)
This function is designed to be executed by an user with the SUPER 
privilege and is used to dump debugging information into the log for the 
MySQL Server relating to the connection specified by the link parameter. 
Returns TRUE on success or FALSE on failure.   mysqli_disable_rpl_parseUpmysqli_enable_reads_from_master
#

#T=bool mysqli_dump_debug_info ( resource link)
mysqli_dump_debug_info ( ^!resource link);
#

#T=mysqli_enable_reads_from_master - void mysqli_enable_reads_from_master ( resource link)
(PHP 5 CVS only)
mysqli_enable_reads_from_master -- 
Description
void mysqli_enable_reads_from_master ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_dump_debug_infoUpmysqli_enable_rpl_parse
#

#T=void mysqli_enable_reads_from_master ( resource link)
mysqli_enable_reads_from_master ( ^!resource link);
#

#T=mysqli_enable_rpl_parse - void mysqli_enable_rpl_parse ( resource link)
(PHP 5 CVS only)
mysqli_enable_rpl_parse -- 
Description
void mysqli_enable_rpl_parse ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_enable_reads_from_masterUpmysqli_errno
#

#T=void mysqli_enable_rpl_parse ( resource link)
mysqli_enable_rpl_parse ( ^!resource link);
#

#T=mysqli_errno - int mysqli_errno ( resource link)
(PHP 5 CVS only)
mysqli_errno -- Returns the error code for the most recent function call
Description
int mysqli_errno ( resource link)
The mysqli_errno() function will return the last error code for the most 
recent MySQLi function call that can succeed or fail with respect to the 
database link defined by the link parameter. If no errors have occurred, 
this function will return zero. 
Note: A complete list of the error codes and their meanings can be found 
in the constants section of the MySQLi documentation 
See also mysqli_error().   mysqli_enable_rpl_parseUpmysqli_error
#

#T=int mysqli_errno ( resource link)
mysqli_errno ( ^!resource link);
#

#T=mysqli_error - 
string mysqli_error ( resource l
(PHP 5 CVS only)
mysqli_error -- Returns a string description of the last error
Description
string mysqli_error ( resource link)
The mysqli_error() function is identical to the corresponding 
mysqli_errno() function in every way, except instead of returning an 
integer error code the mysqli_error() function will return a string 
representation of the last error to occur for the database connection 
represented by the link parameter. If no error has occurred, this function 
will return an empty string. 
Example 1. Using the mysqli_error function
  <?php
								 
	    
      /* Fail to open a connection */
      $host = "no_such_host";
      $link = mysqli_connect($host, "username", "password") or 
	      die("Couldn't connect : " . mysqli_error());
								 
					     
  ?> 
See also mysqli_errno().   mysqli_errnoUpmysqli_execute
#

#T=
string mysqli_error ( resource l

mysqli_error ( ^!resource l;
#

#T=mysqli_execute - int mysqli_execute ( resource stmt)
(PHP 5 CVS only)
mysqli_execute -- Executes a prepared Query
Description
int mysqli_execute ( resource stmt)
The mysqli_execute() function executes a query that has been previously 
prepared using the mysqli_prepare() function represented by the stmt 
resource. When executed any parameter markers which exist will 
automatically be replaced with the appropriate data. 
If the statement is UPDATE, DELETE, or INSERT, the total number of 
affected rows can be determined by using the mysqli_stmt_affected_rows() 
function. Likewise, if the query yields a result set the mysqli_fetch() 
function is used. 
Note: When using mysqli_execute(), the mysqli_fetch() function must be 
used to fetch the data prior to preforming any additional queries. 
Example 1. Using the mysqli_execute function
  <?php
      
      /* Open a connection */
      $link = mysqli_connect("localhost", "user", "pass");
      mysqli_select_db("mydb");
      
      /* Turn on autocommit */
      mysqli_autocommit($link, true);
      
      /* Prepare an insert statement */
      $query = "INSERT INTO mytable VALUES(?, ?)";
      $stmt = mysqli_prepare($link, $query);
      
      $value_one = "hello";
      $value_two = "world";
      
      mysqli_bind_param($link, $value_one, $value_two);
      
      /* Execute the statement */
      mysqli_execute($stmt);
      
      /* Return the affected rows for the statement */
      $affected_rows = mysqli_stmt_affected_rows($stmt);
      
      /* Close the statement */
      
      mysqli_stmt_close($stmt);
      
      echo "The total affected rows was $affected_rows";
      
  ?> 
See also mysqli_prepare() and mysqli_bind_param().   mysqli_errorUpmysqli_fetch_array
#

#T=int mysqli_execute ( resource stmt)
mysqli_execute ( ^!resource stmt);
#

#T=mysqli_fetch_array - array mysqli_fetch_array ( resource result [, int resulttype])
(PHP 5 CVS only)
mysqli_fetch_array -- Fetch a result row as an associative, a numeric 
array, or both.
Description
array mysqli_fetch_array ( resource result [, int resulttype])
Returns an array that corresponds to the fetched row or FALSE if there are 
no more rows for the database connection represented by the link 
parameter. 
mysqli_fetch_array() is an extended version of the mysqli_fetch_row() 
function. In addition to storing the data in the numeric indices of the 
result array, the mysqli_fetch_array() function can also store the data in 
associative indices, using the field names of the result set as keys. 
Note: Field names returned by this function are case-sensitive.
If two or more columns of the result have the same field names, the last 
column will take precedence and overwrite the earlier data. In order to 
access multiple columns with the same name, the numerically indexed 
version of the row must be used. 
The optional second argument result_type is a constant indicating what 
type of array should be produced from the current row data. The possible 
values for this parameter are the constants MYSQLI_ASSOC, MYSQLI_NUM, or 
MYSQLI_BOTH. By default the mysqli_fetch_array() function will assume 
MYSQLI_BOTH for this parameter. 
By using the MYSQLI_ASSOC constant this function will behave identically 
to the mysqli_fetch_assoc(), while MYSQLI_NUM will behave identically to 
the mysqli_fetch_row() function. The final option MYSQLI_BOTH will create 
a single array with the attributes of both. 
Example 1. mysqli_fetch_array with MYSQLI_NUM
  <?php
      mysqli_connect("localhost", "mysql_user", 
  "mysql_password") or
	  die("Could not connect: " . mysqli_error());
      mysqli_select_db("mydb");

      $result = mysqli_query("SELECT id, name FROM mytable");

      while ($row = mysqli_fetch_array($result, MYSQLI_NUM)) {
	  printf("ID: %s  Name: %s", $row[0], $row[1]);  
      }

      mysqli_free_result($result);
  ?> 

Example 2. mysqli_fetch_array with MYSQLI_ASSOC
  <?php
      mysqli_connect("localhost", "mysql_user", 
  "mysql_password") or
	  die("Could not connect: " . mysqli_error());
      mysqli_select_db("mydb");

      $result = mysqli_query("SELECT id, name FROM mytable");

      while ($row = mysqli_fetch_array($result, MYSQLI_ASSOC)) {
	  printf ("ID: %s  Name: %s", $row["id"], $row["name"]);
      }

      mysqli_free_result($result);
  ?> 

Example 3. mysqli_fetch_array with MYSQLI_BOTH
  <?php
      mysqli_connect("localhost", "mysql_user", 
  "mysql_password") or
	  die("Could not connect: " . mysqli_error());
      mysqli_select_db("mydb");

      $result = mysqli_query("SELECT id, name FROM mytable");

      while ($row = mysqli_fetch_array($result, MYSQLI_BOTH)) {
	  printf ("ID: %s  Name: %s", $row[0], $row["name"]);
      }

      mysqli_free_result($result);
  ?> 
See also mysqli_fetch_assoc(), mysqli_fetch_row() and 
mysqli_fetch_object().   mysqli_executeUpmysqli_fetch_assoc
#

#T=array mysqli_fetch_array ( resource result [, int resulttype])
mysqli_fetch_array ( ^!resource result [, int resulttype]);
#

#T=mysqli_fetch_assoc - array mysqli_fetch_assoc ( resource result)
(PHP 5 CVS only)
mysqli_fetch_assoc -- Fetch a result row as an associative array
Description
array mysqli_fetch_assoc ( resource result)
Returns an associative array that corresponds to the fetched row or FALSE 
if there are no more rows. 
The mysqli_fetch_assoc() function is used to return an associative array 
representing the next row in the result set for the result represented by 
the result parameter, where each key in the array represents the name of 
one of the result set's columns. 
If two or more columns in the result set have the same column name, the 
associative array returned by the mysqli_fetch_assoc() function will 
contain the value of the last column of that name. If you must work with 
result sets with this property, the mysqli_fetch_row() should be used 
which returns an numerically-indexed array instead. 
Note: Field names returned by this function are case-sensitive.
Example 1. An expanded mysqli_fetch_assoc() example
  <?php

      $conn = mysqli_connect("localhost", "mysql_user", 
  "mysql_password");
      
      if (!$conn) {
	  echo "Unable to connect to DB: " . mysqli_error();
	  exit;
      }
      
      if (!mysqli_select_db("mydbname")) {
	  echo "Unable to select mydbname: " . mysqli_error();
	  exit;
      }
      
      $sql = "SELECT id as userid, fullname, userstatus 
	      FROM   sometable
	      WHERE  userstatus = 1";

      $result = mysqli_query($sql);

      if (!$result) {
	  echo "Could not successfully run query ($sql) from DB: 
  " . mysqli_error();
	  exit;
      }
      
      if (mysqli_num_rows($result) == 0) {
	  echo "No rows found, nothing to print so am exiting";
	  exit;
      }

      // While a row of data exists, put that row in $row as an 
  associative array
      // Note: If you're expecting just one row, no need to use 
  a loop
      // Note: If you put extract($row); inside the following 
  loop, you'll
      //       then create $userid, $fullname, and $userstatus
      while ($row = mysqli_fetch_assoc($result)) {
	  echo $row["userid"];
	  echo $row["fullname"];
	  echo $row["userstatus"];
      }
	  
      mysqli_free_result($result);

  ?> 
See also mysqli_fetch_array(), mysqli_fetch_row() and 
mysqli_fetch_object().   mysqli_fetch_arrayUpmysqli_fetch_field_direct
#

#T=array mysqli_fetch_assoc ( resource result)
mysqli_fetch_assoc ( ^!resource result);
#

#T=mysqli_fetch_field_direct - int mysqli_fetch_field_direct ( resource result, int offset)
(PHP 5 CVS only)
mysqli_fetch_field_direct --  Fetch meta-data for a single field 
Description
int mysqli_fetch_field_direct ( resource result, int offset)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_fetch_assocUpmysqli_fetch_field
#

#T=int mysqli_fetch_field_direct ( resource result, int offset)
mysqli_fetch_field_direct ( ^!resource result, int offset);
#

#T=mysqli_fetch_field - object mysqli_fetch_field ( resource result)
(PHP 5 CVS only)
mysqli_fetch_field -- Returns the next field in the result set
Description
object mysqli_fetch_field ( resource result)
The mysqli_fetch_field() function is used to return the attributes of the 
next column in the result set represented by the result parameter as an 
object. When executed this function will return an object containing the 
attributes of the current column or FALSE if there are no more columns in 
the result set. 
Table 1. Object attributes
AttributeDescription
nameThe name of the column
orgname?
tableThe name of the table this field belongs to (if not calculated)
orgtable?
defThe default value for this field, represented as a string
max_lengthThe maximum width of the field for the result set.
flagsAn integer representing the bit-flags for the field.
typeThe data type used for this field
decimalsThe number of decimals used (for integer fields)
  mysqli_fetch_field_directUpmysqli_fetch_fields
#

#T=object mysqli_fetch_field ( resource result)
mysqli_fetch_field ( ^!resource result);
#

#T=mysqli_fetch_fields - array mysqli_fetch_fields ( resource result)
(PHP 5 CVS only)
mysqli_fetch_fields -- Returns an array of objects representing the fields 
in a result set
Description
array mysqli_fetch_fields ( resource result)
This function serves an identical purpose to the mysqli_fetch_field() 
function with the single difference that, instead of returning one object 
at a time for each field, the columns are returned as an array of objects. 
For a description of the attributes of each object and their meaning, see 
the mysqli_fetch_field() function.   mysqli_fetch_fieldUpmysqli_fetch_lengths
#

#T=array mysqli_fetch_fields ( resource result)
mysqli_fetch_fields ( ^!resource result);
#

#T=mysqli_fetch_lengths - array mysqli_fetch_lengths ( resource result)
(PHP 5 CVS only)
mysqli_fetch_lengths -- Returns the lengths of the columns of the current 
row in the result set
Description
array mysqli_fetch_lengths ( resource result)
The mysqli_fetch_lengths() function returns an array containing the 
lengths of every column of the current row within the result set 
represented by the result parameter. If successful, a numerically indexed 
array representing the lengths of each column is returned or FALSE on 
failure.   mysqli_fetch_fieldsUpmysqli_fetch_object
#

#T=array mysqli_fetch_lengths ( resource result)
mysqli_fetch_lengths ( ^!resource result);
#

#T=mysqli_fetch_object - object mysqli_fetch_object ( resource result)
(PHP 5 CVS only)
mysqli_fetch_object -- Returns the current row of a result set as an 
object
Description
object mysqli_fetch_object ( resource result)
The mysqli_fetch_object() will return the current row result set as an 
object where the attributes of the object represent the names of the 
fields found within the result set. If no more rows exist in the current 
result set, FALSE is returned. 
Note: Field names returned by this function are case-sensitive.
See also mysqli_fetch_array(), mysqli_fetch_assoc() and 
mysqli_fetch_row().   mysqli_fetch_lengthsUpmysqli_fetch_row
#

#T=object mysqli_fetch_object ( resource result)
mysqli_fetch_object ( ^!resource result);
#

#T=mysqli_fetch_row - array mysqli_fetch_row ( resource result)
(PHP 5 CVS only)
mysqli_fetch_row -- Get a result row as an enumerated array
Description
array mysqli_fetch_row ( resource result)
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
mysqli_fetch_row() fetches one row of data from the result set represented 
by result and returns it as an enumerated array, where each column is 
stored in an array offset starting from 0 (zero). Each subsequent call to 
the mysqli_fetch_row() function will return the next row within the result 
set, or FALSE if there are no more rows. 
See also mysqli_fetch_array(), mysqli_fetch_assoc() and 
mysqli_fetch_object().   mysqli_fetch_objectUpmysqli_fetch
#

#T=array mysqli_fetch_row ( resource result)
mysqli_fetch_row ( ^!resource result);
#

#T=mysqli_fetch - int mysqli_fetch ( resource stmt)
(PHP 5 CVS only)
mysqli_fetch --  Fetch results from a prepared statement into the bound 
variables 
Description
int mysqli_fetch ( resource stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_fetch_rowUpmysqli_field_count
#

#T=int mysqli_fetch ( resource stmt)
mysqli_fetch ( ^!resource stmt);
#

#T=mysqli_field_count - int mysqli_field_count ( resource link)
(PHP 5 CVS only)
mysqli_field_count -- Returns the number of columns for the most recent 
query
Description
int mysqli_field_count ( resource link)
Returns the number of columns for the most recent query on the connection 
represented by the link parameter. This function can be useful when using 
the mysqli_store_result() function to determine if the query should have 
produced a non-empty result set or not without knowing the nature of the 
query.   mysqli_fetchUpmysqli_field_seek
#

#T=int mysqli_field_count ( resource link)
mysqli_field_count ( ^!resource link);
#

#T=mysqli_field_seek - int mysqli_field_seek ( resource link, int fieldnr)
(PHP 5 CVS only)
mysqli_field_seek --  Set result pointer to a specified field offset 
Description
int mysqli_field_seek ( resource link, int fieldnr)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_field_countUpmysqli_field_tell
#

#T=int mysqli_field_seek ( resource link, int fieldnr)
mysqli_field_seek ( ^!resource link, int fieldnr);
#

#T=mysqli_field_tell - int mysqli_field_tell ( resource result)
(PHP 5 CVS only)
mysqli_field_tell --  Get current field offset of a result pointer 
Description
int mysqli_field_tell ( resource result)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_field_seekUpmysqli_free_result
#

#T=int mysqli_field_tell ( resource result)
mysqli_field_tell ( ^!resource result);
#

#T=mysqli_free_result - int mysqli_free_result ( resource result)
(PHP 5 CVS only)
mysqli_free_result -- Frees the memory associated with a result
Description
int mysqli_free_result ( resource result)
The mysqli_free_result() function frees the memory associated with the 
result represented by the result parameter.   mysqli_field_tellUpmysqli_get_client_info
#

#T=int mysqli_free_result ( resource result)
mysqli_free_result ( ^!resource result);
#

#T=mysqli_get_client_info - string mysqli_get_client_info ( void )
(PHP 5 CVS only)
mysqli_get_client_info -- Returns the MySQL client version as a string
Description
string mysqli_get_client_info ( void )
The mysqli_get_client_info() function is used to return a string 
representing the client version being used in the MySQLi extension.   mysqli_free_resultUpmysqli_get_host_info
#

#T=string mysqli_get_client_info ( void )
mysqli_get_client_info ( ^!void );
#

#T=mysqli_get_host_info - string mysqli_get_host_info ( resource link)
(PHP 5 CVS only)
mysqli_get_host_info -- Returns a string representing the type of 
connection used
Description
string mysqli_get_host_info ( resource link)
The mysqli_get_host_info() function returns a string describing the 
connection represented by the link parameter is using (including the 
server host name).   mysqli_get_client_infoUpmysqli_get_proto_info
#

#T=string mysqli_get_host_info ( resource link)
mysqli_get_host_info ( ^!resource link);
#

#T=mysqli_get_proto_info - int mysqli_get_proto_info ( resource link)
(PHP 5 CVS only)
mysqli_get_proto_info -- Returns the version of the MySQL protocol used
Description
int mysqli_get_proto_info ( resource link)
Returns an integer representing the MySQL protocol version used by the 
connection represented by the link parameter.   mysqli_get_host_infoUpmysqli_get_server_info
#

#T=int mysqli_get_proto_info ( resource link)
mysqli_get_proto_info ( ^!resource link);
#

#T=mysqli_get_server_info - string mysqli_get_server_info ( resource link)
(PHP 5 CVS only)
mysqli_get_server_info -- Returns the version of the MySQL server
Description
string mysqli_get_server_info ( resource link)
Returns a string representing the version of the MySQL server that the 
MySQLi extension is connected to (represented by the link parameter).   mysqli_get_proto_infoUpmysqli_get_server_version
#

#T=string mysqli_get_server_info ( resource link)
mysqli_get_server_info ( ^!resource link);
#

#T=mysqli_get_server_version - int mysqli_get_server_version ( resource link)
(PHP 5 CVS only)
mysqli_get_server_version -- Returns the version of the MySQL server as an 
integer
Description
int mysqli_get_server_version ( resource link)
The mysqli_get_server_version() function returns the version of the server 
connected to (represented by the link parameter) as an integer. The form 
of this version number is main_version * 10000 + minor_version * 100 + 
sub_version (i.e. version 4.1.0 is 40100).   mysqli_get_server_infoUpmysqli_info
#

#T=int mysqli_get_server_version ( resource link)
mysqli_get_server_version ( ^!resource link);
#

#T=mysqli_info - string mysqli_info ( resource link)
(PHP 5 CVS only)
mysqli_info -- Retrieves information about the most recently executed 
query
Description
string mysqli_info ( resource link)
The mysqli_info() function returns a string providing information about 
the last query executed. The nature of this string is provided below: 
Table 1. Possible mysqli_info return values
Query typeExample result string
INSERT INTO...SELECT...Records: 100 Duplicates: 0 Warnings: 0
INSERT INTO...VALUES (...),(...),(...)Records: 3 Duplicates: 0 
Warnings: 0
LOAD DATA INFILE ...Records: 1 Deleted: 0 Skipped: 0 Warnings: 0
ALTER TABLE ...Records: 3 Duplicates: 0 Warnings: 0
UPDATE ...Rows matched: 40 Changed: 40 Warnings: 0

Note: Queries which do not fall into one of the above formats are not 
supported. In these situations, mysqli_info() will return FALSE   mysqli_get_server_versionUpmysqli_init
#

#T=string mysqli_info ( resource link)
mysqli_info ( ^!resource link);
#

#T=mysqli_init - resource mysqli_init ( void )
(PHP 5 CVS only)
mysqli_init --  Initializes MySQLi and returns a resource for use with 
mysqli_real_connect 
Description
resource mysqli_init ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_infoUpmysqli_insert_id
#

#T=resource mysqli_init ( void )
mysqli_init ( ^!void );
#

#T=mysqli_insert_id - mixed mysqli_insert_id ( resource link)
(PHP 5 CVS only)
mysqli_insert_id -- Returns the auto generated id used in the last query
Description
mixed mysqli_insert_id ( resource link)
The mysqli_insert_id() function returns the ID generated by a query on a 
table with a column having the AUTO_INCREMENT attribute. If the last query 
wasn't an INSERT or UPDATE statement or if the modified table does not 
have a column with the AUTO_INCREMENT attribute, this function will return 
zero. 
Note: Performing an INSERT or UPDATE statement using the 
LAST_INSERT_ID() function will also modify the value returned by the 
mysqli_insert_id() function.   mysqli_initUpmysqli_kill
#

#T=mixed mysqli_insert_id ( resource link)
mysqli_insert_id ( ^!resource link);
#

#T=mysqli_kill - bool mysqli_kill ( resource link, int processid)
(PHP 5 CVS only)
mysqli_kill -- Asks the server to kill a MySQL thread
Description
bool mysqli_kill ( resource link, int processid)
This function is used to ask the server to kill a MySQL thread specified 
by the processid parameter. This value must be retrieved by calling the 
mysqli_thread_id() function.   mysqli_insert_idUpmysqli_master_query
#

#T=bool mysqli_kill ( resource link, int processid)
mysqli_kill ( ^!resource link, int processid);
#

#T=mysqli_master_query - bool mysqli_master_query ( resource link, string query)
(PHP 5 CVS only)
mysqli_master_query --  Enforce execution of a query on the master in a 
master/slave setup 
Description
bool mysqli_master_query ( resource link, string query)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_killUpmysqli_num_fields
#

#T=bool mysqli_master_query ( resource link, string query)
mysqli_master_query ( ^!resource link, string query);
#

#T=mysqli_num_fields - int mysqli_num_fields ( resource result)
(PHP 5 CVS only)
mysqli_num_fields --  Get the number of fields in a result 
Description
int mysqli_num_fields ( resource result)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_master_queryUpmysqli_num_rows
#

#T=int mysqli_num_fields ( resource result)
mysqli_num_fields ( ^!resource result);
#

#T=mysqli_num_rows - int mysqli_num_rows ( resource result)
(PHP 5 CVS only)
mysqli_num_rows --  Gets the number of rows in a result 
Description
int mysqli_num_rows ( resource result)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_num_fieldsUpmysqli_options
#

#T=int mysqli_num_rows ( resource result)
mysqli_num_rows ( ^!resource result);
#

#T=mysqli_options - bool mysqli_options ( resource link, int flags, mixed values)
(PHP 5 CVS only)
mysqli_options -- set options
Description
bool mysqli_options ( resource link, int flags, mixed values)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_num_rowsUpmysqli_param_count
#

#T=bool mysqli_options ( resource link, int flags, mixed values)
mysqli_options ( ^!resource link, int flags, mixed values);
#

#T=mysqli_param_count - int mysqli_param_count ( resource stmt)
(PHP 5 CVS only)
mysqli_param_count -- Returns the number of parameter for the given 
statement
Description
int mysqli_param_count ( resource stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_optionsUpmysqli_ping
#

#T=int mysqli_param_count ( resource stmt)
mysqli_param_count ( ^!resource stmt);
#

#T=mysqli_ping - int mysqli_ping ( resource link)
(PHP 5 CVS only)
mysqli_ping --  Ping a server connection, or reconnect if there is no 
connection 
Description
int mysqli_ping ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_param_countUpmysqli_prepare_result
#

#T=int mysqli_ping ( resource link)
mysqli_ping ( ^!resource link);
#

#T=mysqli_prepare_result - resource mysqli_prepare_result ( resource stmt)
(PHP 5 CVS only)
mysqli_prepare_result -- 
Description
resource mysqli_prepare_result ( resource stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_pingUpmysqli_prepare
#

#T=resource mysqli_prepare_result ( resource stmt)
mysqli_prepare_result ( ^!resource stmt);
#

#T=mysqli_prepare - resource mysqli_prepare ( resource link, string query)
(PHP 5 CVS only)
mysqli_prepare --  Prepare a SQL statement for execution 
Description
resource mysqli_prepare ( resource link, string query)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_prepare_resultUpmysqli_profiler
#

#T=resource mysqli_prepare ( resource link, string query)
mysqli_prepare ( ^!resource link, string query);
#

#T=mysqli_profiler - bool mysqli_profiler ( int flags, string info, int port)
(PHP 5 CVS only)
mysqli_profiler -- 
Description
bool mysqli_profiler ( int flags, string info, int port)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_prepareUpmysqli_query
#

#T=bool mysqli_profiler ( int flags, string info, int port)
mysqli_profiler ( ^!int flags, string info, int port);
#

#T=mysqli_query - resource mysqli_query ( resource link, string query [, int resultmode])
(PHP 5 CVS only)
mysqli_query -- Performs a query on the database
Description
resource mysqli_query ( resource link, string query [, int resultmode])
The mysqli_query() function is used to simplify the act of performing a 
query against the database represented by the link parameter. 
Functionally, using this function is identical to calling 
mysqli_real_query() followed either by mysqli_use_result() or 
mysqli_store_result() where query is the query string itself and 
resultmode is either the constant MYSQLI_USE_RESULT or MYSQLI_STORE_RESULT 
depending on the desired behavior. By default, if the resultmode is not 
provided MYSQLI_STORE_RESULT is used.   mysqli_profilerUpmysqli_read_query_result
#

#T=resource mysqli_query ( resource link, string query [, int resultmode])
mysqli_query ( ^!resource link, string query [, int resultmode]);
#

#T=mysqli_read_query_result - bool mysqli_read_query_result ( resource link)
(PHP 5 CVS only)
mysqli_read_query_result -- 
Description
bool mysqli_read_query_result ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_queryUpmysqli_real_connect
#

#T=bool mysqli_read_query_result ( resource link)
mysqli_read_query_result ( ^!resource link);
#

#T=mysqli_real_connect - bool mysqli_real_connect ( resource link [, string hostname [, string 
(PHP 5 CVS only)
mysqli_real_connect -- Opens a connection to a mysql server
Description
bool mysqli_real_connect ( resource link [, string hostname [, string 
username [, string passwd [, string dbname [, int port [, string 
socket]]]]]])
Warning
This function is currently not documented; only the argument list is 
available.

See also mysqli_connect() and mysqli_close().   mysqli_read_query_resultUpmysqli_real_escape_string
#

#T=bool mysqli_real_connect ( resource link [, string hostname [, string 
mysqli_real_connect ( ^!resource link [, string hostname [, string ;
#

#T=mysqli_real_escape_string - string mysqli_real_escape_string ( resource link, string escapestr)
(PHP 5 CVS only)
mysqli_real_escape_string --  Escapes special characters in a string for 
use in a SQL statement, taking into account the current charset of the 
connection 
Description
string mysqli_real_escape_string ( resource link, string escapestr)
Warning
This function is currently not documented; only the argument list is 
available.

See also mysqli_character_set_name().   mysqli_real_connectUpmysqli_real_query
#

#T=string mysqli_real_escape_string ( resource link, string escapestr)
mysqli_real_escape_string ( ^!resource link, string escapestr);
#

#T=mysqli_real_query - bool mysqli_real_query ( resource link, string query)
(PHP 5 CVS only)
mysqli_real_query -- Execute an SQL query
Description
bool mysqli_real_query ( resource link, string query)
The mysqli_real_query() function is used to execute only a query against 
the database represented by the link whose result can then be retrieved or 
stored using the mysqli_store_result() or mysqli_use_result() functions. 
Note: In order to determine if a given query should return a result set 
or not, see mysqli_field_count().   mysqli_real_escape_stringUpmysqli_reload
#

#T=bool mysqli_real_query ( resource link, string query)
mysqli_real_query ( ^!resource link, string query);
#

#T=mysqli_reload - bool mysqli_reload ( resource link)
(PHP 5 CVS only)
mysqli_reload -- 
Description
bool mysqli_reload ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_real_queryUpmysqli_rollback
#

#T=bool mysqli_reload ( resource link)
mysqli_reload ( ^!resource link);
#

#T=mysqli_rollback - bool mysqli_rollback ( resource link)
(PHP 5 CVS only)
mysqli_rollback -- 
Description
bool mysqli_rollback ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_reloadUpmysqli_rpl_parse_enabled
#

#T=bool mysqli_rollback ( resource link)
mysqli_rollback ( ^!resource link);
#

#T=mysqli_rpl_parse_enabled - int mysqli_rpl_parse_enabled ( resource link)
(PHP 5 CVS only)
mysqli_rpl_parse_enabled -- 
Description
int mysqli_rpl_parse_enabled ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_rollbackUpmysqli_rpl_probe
#

#T=int mysqli_rpl_parse_enabled ( resource link)
mysqli_rpl_parse_enabled ( ^!resource link);
#

#T=mysqli_rpl_probe - bool mysqli_rpl_probe ( resource link)
(PHP 5 CVS only)
mysqli_rpl_probe -- 
Description
bool mysqli_rpl_probe ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_rpl_parse_enabledUpmysqli_rpl_query_type
#

#T=bool mysqli_rpl_probe ( resource link)
mysqli_rpl_probe ( ^!resource link);
#

#T=mysqli_rpl_query_type - int mysqli_rpl_query_type ( string query)
(PHP 5 CVS only)
mysqli_rpl_query_type -- 
Description
int mysqli_rpl_query_type ( string query)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_rpl_probeUpmysqli_select_db
#

#T=int mysqli_rpl_query_type ( string query)
mysqli_rpl_query_type ( ^!string query);
#

#T=mysqli_select_db - bool mysqli_select_db ( resource link, string dbname)
(PHP 5 CVS only)
mysqli_select_db -- Selects the default database for database queries
Description
bool mysqli_select_db ( resource link, string dbname)
The mysqli_select_db() function selects the default database (specified by 
the dbname parameter) to be used when performing queries against the 
database connection represented by the link parameter. 
Returns TRUE on success or FALSE on failure.   mysqli_rpl_query_typeUpmysqli_send_long_data
#

#T=bool mysqli_select_db ( resource link, string dbname)
mysqli_select_db ( ^!resource link, string dbname);
#

#T=mysqli_send_long_data - bool mysqli_send_long_data ( resource stmt, int param_nr, string data)
(PHP 5 CVS only)
mysqli_send_long_data -- 
Description
bool mysqli_send_long_data ( resource stmt, int param_nr, string data)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_select_dbUpmysqli_send_query
#

#T=bool mysqli_send_long_data ( resource stmt, int param_nr, string data)
mysqli_send_long_data ( ^!resource stmt, int param_nr, string data);
#

#T=mysqli_send_query - bool mysqli_send_query ( resource link, string query)
(PHP 5 CVS only)
mysqli_send_query -- 
Description
bool mysqli_send_query ( resource link, string query)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_send_long_dataUpmysqli_slave_query
#

#T=bool mysqli_send_query ( resource link, string query)
mysqli_send_query ( ^!resource link, string query);
#

#T=mysqli_slave_query - bool mysqli_slave_query ( resource link, string query)
(PHP 5 CVS only)
mysqli_slave_query --  Enforces execution of a query on a slave in a 
master/slave setup 
Description
bool mysqli_slave_query ( resource link, string query)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_send_queryUpmysqli_ssl_set
#

#T=bool mysqli_slave_query ( resource link, string query)
mysqli_slave_query ( ^!resource link, string query);
#

#T=mysqli_ssl_set - string mysqli_ssl_set ( resource link [, string key [, string cert [, 
(PHP 5 CVS only)
mysqli_ssl_set -- 
Description
string mysqli_ssl_set ( resource link [, string key [, string cert [, 
string ca [, string capath [, string cipher]]]]])
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_slave_queryUpmysqli_stat
#

#T=string mysqli_ssl_set ( resource link [, string key [, string cert [, 
mysqli_ssl_set ( ^!resource link [, string key [, string cert [, ;
#

#T=mysqli_stat - string mysqli_stat ( resource link)
(PHP 5 CVS only)
mysqli_stat --  Gets the current system status 
Description
string mysqli_stat ( resource link)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_ssl_setUpmysqli_stmt_affected_rows
#

#T=string mysqli_stat ( resource link)
mysqli_stat ( ^!resource link);
#

#T=mysqli_stmt_affected_rows - mixed mysqli_stmt_affected_rows ( object stmt)
(PHP 5 CVS only)
mysqli_stmt_affected_rows -- 
Description
mixed mysqli_stmt_affected_rows ( object stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_statUpmysqli_stmt_close
#

#T=mixed mysqli_stmt_affected_rows ( object stmt)
mysqli_stmt_affected_rows ( ^!object stmt);
#

#T=mysqli_stmt_close - bool mysqli_stmt_close ( resource stmt)
(PHP 5 CVS only)
mysqli_stmt_close -- close statement
Description
bool mysqli_stmt_close ( resource stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_stmt_affected_rowsUpmysqli_stmt_errno
#

#T=bool mysqli_stmt_close ( resource stmt)
mysqli_stmt_close ( ^!resource stmt);
#

#T=mysqli_stmt_errno - int mysqli_stmt_errno ( resource stmt)
(PHP 5 CVS only)
mysqli_stmt_errno -- 
Description
int mysqli_stmt_errno ( resource stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_stmt_closeUpmysqli_stmt_error
#

#T=int mysqli_stmt_errno ( resource stmt)
mysqli_stmt_errno ( ^!resource stmt);
#

#T=mysqli_stmt_error - string mysqli_stmt_error ( resource stmt)
(PHP 5 CVS only)
mysqli_stmt_error -- 
Description
string mysqli_stmt_error ( resource stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_stmt_errnoUpmysqli_stmt_store_result
#

#T=string mysqli_stmt_error ( resource stmt)
mysqli_stmt_error ( ^!resource stmt);
#

#T=mysqli_stmt_store_result - resource mysqli_stmt_store_result ( resource stmt)
(PHP 5 CVS only)
mysqli_stmt_store_result -- 
Description
resource mysqli_stmt_store_result ( resource stmt)
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_stmt_errorUpmysqli_store_result
#

#T=resource mysqli_stmt_store_result ( resource stmt)
mysqli_stmt_store_result ( ^!resource stmt);
#

#T=mysqli_store_result - resource mysqli_store_result ( resource link)
(PHP 5 CVS only)
mysqli_store_result -- Transfers a result set from the last query
Description
resource mysqli_store_result ( resource link)
Transfers the result set from the last query on the database connection 
represented by the link parameter to be used with the mysqli_data_seek() 
function. 
Note: Although it is always good practice to free the memory used by the 
result of a query using the mysqli_free_result() function, when 
transferring large result sets using the mysqli_store_result() this 
becomes particularly important.   mysqli_stmt_store_resultUpmysqli_thread_id
#

#T=resource mysqli_store_result ( resource link)
mysqli_store_result ( ^!resource link);
#

#T=mysqli_thread_id - int mysqli_thread_id ( resource link)
(PHP 5 CVS only)
mysqli_thread_id -- Returns the thread ID for the current connection
Description
int mysqli_thread_id ( resource link)
The mysqli_thread_id() function returns the thread ID for the current 
connection which can then be killed using the mysqli_kill() function. 
Note: The thread ID is assigned on a connection-by-connection basis. 
Hence, if the connection is broken and then re-established a new thread 
ID will be assigned.   mysqli_store_resultUpmysqli_thread_safe
#

#T=int mysqli_thread_id ( resource link)
mysqli_thread_id ( ^!resource link);
#

#T=mysqli_thread_safe - bool mysqli_thread_safe ( void )
(PHP 5 CVS only)
mysqli_thread_safe --  Returns whether thread safety is given or not 
Description
bool mysqli_thread_safe ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  mysqli_thread_idUpmysqli_use_result
#

#T=bool mysqli_thread_safe ( void )
mysqli_thread_safe ( ^!void );
#

#T=mysqli_use_result - resource mysqli_use_result ( resource link)
(PHP 5 CVS only)
mysqli_use_result -- Initiate a result set retrieval
Description
resource mysqli_use_result ( resource link)
mysqli_use_result() is used to initiate the retrieval of a result set from 
the last query executed using the mysqli_real_query() function on the 
database connection specified by the link parameter. Either this or the 
mysqli_store_result() function must be called before the results of a 
query can be retrieved, and one or the other must be called to prevent the 
next query on that database connection from failing. 
Note: The mysqli_use_result() function does not transfer the entire 
result set from the database and hence cannot be used functions such as 
mysqli_data_seek() to move to a particular row within the set. To use 
this functionality, the result set must be stored using 
mysqli_store_result() 
See also mysqli_real_query() and mysqli_store_result().   mysqli_thread_safeUpmysqli_warning_count
#

#T=resource mysqli_use_result ( resource link)
mysqli_use_result ( ^!resource link);
#

#T=mysqli_warning_count - resource mysqli_warning_count ( resource link)
(PHP 5 CVS only)
mysqli_warning_count --  Returns the number of warnings from the last 
query for the given link 
Description
resource mysqli_warning_count ( resource link)
mysqli_warning_count() returns the number of warnings from the last query 
in the connection represented by the link parameter.   mysqli_use_resultUpMohawk Software session handler functions
#

#T=resource mysqli_warning_count ( resource link)
mysqli_warning_count ( ^!resource link);
#

#T=natcasesort - void natcasesort ( array array)
(PHP 4 )
natcasesort --  Sort an array using a case insensitive "natural order" 
algorithm 
Description
void natcasesort ( array array)
This function implements a sort algorithm that orders alphanumeric strings 
in the way a human being would. This is described as a "natural ordering". 

natcasesort() is a case insensitive version of natsort(). See natsort() 
for an example of the difference between this algorithm and the regular 
computer string sorting algorithms. 
For more information see: Martin Pool's Natural Order String Comparison 
page. 
See also sort(), natsort(), strnatcmp(), and strnatcasecmp().   listUpnatsort
#

#T=void natcasesort ( array array)
natcasesort ( ^!array array);
#

#T=natsort - void natsort ( array array)
(PHP 4 )
natsort --  Sort an array using a "natural order" algorithm 
Description
void natsort ( array array)
This function implements a sort algorithm that orders alphanumeric strings 
in the way a human being would. This is described as a "natural ordering". 
An example of the difference between this algorithm and the regular 
computer string sorting algorithms (used in sort()) can be seen below: 
Example 1. natsort() example
  <?php
  $array1 = $array2 = array("img12.png", "img10.png", 
  "img2.png", "img1.png");

  sort($array1);
  echo "Standard sorting\n";
  print_r($array1);

  natsort($array2);
  echo "\nNatural order sorting\n";
  print_r($array2);
  ?> 

The code above will generate the following output: 
Standard sorting
Array
(
[0] => img1.png
[1] => img10.png
[2] => img12.png
[3] => img2.png
)

Natural order sorting
Array
(
[3] => img1.png
[2] => img2.png
[1] => img10.png
[0] => img12.png
)

For more information see: Martin Pool's Natural Order String 
Comparison page. 

Note: If you're wanting to maintain index/value associations, consider 
using uasort($arr, 'strnatcmp'). 
See also natcasesort(), strnatcmp(), and strnatcasecmp().   natcasesortUpnext
#

#T=void natsort ( array array)
natsort ( ^!array array);
#

#T=ncurses_addch - int ncurses_addch ( int ch)
(PHP 4 >= 4.1.0)
ncurses_addch -- Add character at current position and advance cursor 
Description
int ncurses_addch ( int ch)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  Ncurses terminal screen control functionsUpncurses_addchnstr
#

#T=int ncurses_addch ( int ch)
ncurses_addch ( ^!int ch);
#

#T=ncurses_addchnstr - int ncurses_addchnstr ( string s, int n)
(PHP 4 >= 4.2.0)
ncurses_addchnstr -- Add attributed string with specified length at 
current position 
Description
int ncurses_addchnstr ( string s, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_addchUpncurses_addchstr
#

#T=int ncurses_addchnstr ( string s, int n)
ncurses_addchnstr ( ^!string s, int n);
#

#T=ncurses_addchstr - int ncurses_addchstr ( string s)
(PHP 4 >= 4.2.0)
ncurses_addchstr -- Add attributed string at current position 
Description
int ncurses_addchstr ( string s)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_addchnstrUpncurses_addnstr
#

#T=int ncurses_addchstr ( string s)
ncurses_addchstr ( ^!string s);
#

#T=ncurses_addnstr - int ncurses_addnstr ( string s, int n)
(PHP 4 >= 4.2.0)
ncurses_addnstr -- Add string with specified length at current position 
Description
int ncurses_addnstr ( string s, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_addchstrUpncurses_addstr
#

#T=int ncurses_addnstr ( string s, int n)
ncurses_addnstr ( ^!string s, int n);
#

#T=ncurses_addstr - int ncurses_addstr ( string text)
(PHP 4 >= 4.2.0)
ncurses_addstr -- Output text at current position 
Description
int ncurses_addstr ( string text)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_addnstrUpncurses_assume_default_colors
#

#T=int ncurses_addstr ( string text)
ncurses_addstr ( ^!string text);
#

#T=ncurses_assume_default_colors - int ncurses_assume_default_colors ( int fg, int bg)
(PHP 4 >= 4.2.0)
ncurses_assume_default_colors -- Define default colors for color 0 
Description
int ncurses_assume_default_colors ( int fg, int bg)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_addstrUpncurses_attroff
#

#T=int ncurses_assume_default_colors ( int fg, int bg)
ncurses_assume_default_colors ( ^!int fg, int bg);
#

#T=ncurses_attroff - int ncurses_attroff ( int attributes)
(PHP 4 >= 4.1.0)
ncurses_attroff -- Turn off the given attributes 
Description
int ncurses_attroff ( int attributes)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_assume_default_colorsUpncurses_attron
#

#T=int ncurses_attroff ( int attributes)
ncurses_attroff ( ^!int attributes);
#

#T=ncurses_attron - int ncurses_attron ( int attributes)
(PHP 4 >= 4.1.0)
ncurses_attron -- Turn on the given attributes 
Description
int ncurses_attron ( int attributes)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_attroffUpncurses_attrset
#

#T=int ncurses_attron ( int attributes)
ncurses_attron ( ^!int attributes);
#

#T=ncurses_attrset - int ncurses_attrset ( int attributes)
(PHP 4 >= 4.1.0)
ncurses_attrset -- Set given attributes 
Description
int ncurses_attrset ( int attributes)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_attronUpncurses_baudrate
#

#T=int ncurses_attrset ( int attributes)
ncurses_attrset ( ^!int attributes);
#

#T=ncurses_baudrate - int ncurses_baudrate ( void )
(PHP 4 >= 4.1.0)
ncurses_baudrate -- Returns baudrate of terminal 
Description
int ncurses_baudrate ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_attrsetUpncurses_beep
#

#T=int ncurses_baudrate ( void )
ncurses_baudrate ( ^!void );
#

#T=ncurses_beep - int ncurses_beep ( void )
(PHP 4 >= 4.1.0)
ncurses_beep -- Let the terminal beep 
Description
int ncurses_beep ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_beep() sends an audible alert (bell) and if its not possible 
flashes the screen. Returns TRUE on success or FALSE on failure. 
See also ncurses_flash()   ncurses_baudrateUpncurses_bkgd
#

#T=int ncurses_beep ( void )
ncurses_beep ( ^!void );
#

#T=ncurses_bkgd - int ncurses_bkgd ( int attrchar)
(PHP 4 >= 4.1.0)
ncurses_bkgd -- Set background property for terminal screen 
Description
int ncurses_bkgd ( int attrchar)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_beepUpncurses_bkgdset
#

#T=int ncurses_bkgd ( int attrchar)
ncurses_bkgd ( ^!int attrchar);
#

#T=ncurses_bkgdset - void ncurses_bkgdset ( int attrchar)
(PHP 4 >= 4.1.0)
ncurses_bkgdset -- Control screen background 
Description
void ncurses_bkgdset ( int attrchar)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_bkgdUpncurses_border
#

#T=void ncurses_bkgdset ( int attrchar)
ncurses_bkgdset ( ^!int attrchar);
#

#T=ncurses_border - int ncurses_border ( int left, int right, int top, int bottom, int 
(PHP 4 >= 4.2.0)
ncurses_border -- Draw a border around the screen using attributed 
characters 
Description
int ncurses_border ( int left, int right, int top, int bottom, int 
tl_corner, int tr_corner, int bl_corner, int br_corner)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_bkgdsetUpncurses_bottom_panel
#

#T=int ncurses_border ( int left, int right, int top, int bottom, int 
ncurses_border ( ^!int left, int right, int top, int bottom, int ;
#

#T=ncurses_bottom_panel - int ncurses_bottom_panel ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_bottom_panel --  Moves a visible panel to the bottom of the stack 
Description
int ncurses_bottom_panel ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_borderUpncurses_can_change_color
#

#T=int ncurses_bottom_panel ( resource panel)
ncurses_bottom_panel ( ^!resource panel);
#

#T=ncurses_can_change_color - bool ncurses_can_change_color ( void )
(PHP 4 >= 4.1.0)
ncurses_can_change_color -- Check if we can change terminals colors 
Description
bool ncurses_can_change_color ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function ncurses_can_change_color() returns TRUE or FALSE, depending 
on whether the terminal has color capabilities and whether the programmer 
can change the colors.   ncurses_bottom_panelUpncurses_cbreak
#

#T=bool ncurses_can_change_color ( void )
ncurses_can_change_color ( ^!void );
#

#T=ncurses_cbreak - bool ncurses_cbreak ( void )
(PHP 4 >= 4.1.0)
ncurses_cbreak -- Switch of input buffering 
Description
bool ncurses_cbreak ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_cbreak() disables line buffering and character processing 
(interrupt and flow control characters are unaffected), making characters 
typed by the user immediately available to the program. 
ncurses_cbreak() returns TRUE or NCURSES_ERR if any error occurred. 
See also: ncurses_nocbreak()   ncurses_can_change_colorUpncurses_clear
#

#T=bool ncurses_cbreak ( void )
ncurses_cbreak ( ^!void );
#

#T=ncurses_clear - bool ncurses_clear ( void )
(PHP 4 >= 4.1.0)
ncurses_clear -- Clear screen 
Description
bool ncurses_clear ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_clear() clears the screen completely without setting blanks. 
Returns TRUE on success or FALSE on failure. 
Note: ncurses_clear() clears the screen without setting blanks, which have 
the current background rendition. To clear screen with blanks, use 
ncurses_erase(). 
See also ncurses_erase().   ncurses_cbreakUpncurses_clrtobot
#

#T=bool ncurses_clear ( void )
ncurses_clear ( ^!void );
#

#T=ncurses_clrtobot - bool ncurses_clrtobot ( void )
(PHP 4 >= 4.1.0)
ncurses_clrtobot -- Clear screen from current position to bottom 
Description
bool ncurses_clrtobot ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_clrtobot() erases all lines from cursor to end of screen and 
creates blanks. Blanks created by ncurses_clrtobot() have the current 
background rendition. Returns TRUE on success or FALSE on failure. 
See also ncurses_clear(), and ncurses_clrtoeol()   ncurses_clearUpncurses_clrtoeol
#

#T=bool ncurses_clrtobot ( void )
ncurses_clrtobot ( ^!void );
#

#T=ncurses_clrtoeol - bool ncurses_clrtoeol ( void )
(PHP 4 >= 4.1.0)
ncurses_clrtoeol -- Clear screen from current position to end of line 
Description
bool ncurses_clrtoeol ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_clrtoeol() erases the current line from cursor position to the 
end. Blanks created by ncurses_clrtoeol() have the current background 
rendition. Returns TRUE on success or FALSE on failure. 
See also ncurses_clear(), and ncurses_clrtobot()   ncurses_clrtobotUpncurses_color_content
#

#T=bool ncurses_clrtoeol ( void )
ncurses_clrtoeol ( ^!void );
#

#T=ncurses_color_content - int ncurses_color_content ( int color, int &r, int &g, int &b)
(PHP 4 >= 4.3.0)
ncurses_color_content --  Gets the RGB value for color 
Description
int ncurses_color_content ( int color, int &r, int &g, int &b)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_clrtoeolUpncurses_color_set
#

#T=int ncurses_color_content ( int color, int &r, int &g, int &b)
ncurses_color_content ( ^!int color, int &r, int &g, int &b);
#

#T=ncurses_color_set - int ncurses_color_set ( int pair)
(PHP 4 >= 4.1.0)
ncurses_color_set -- Set fore- and background color 
Description
int ncurses_color_set ( int pair)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_color_contentUpncurses_curs_set
#

#T=int ncurses_color_set ( int pair)
ncurses_color_set ( ^!int pair);
#

#T=ncurses_curs_set - int ncurses_curs_set ( int visibility)
(PHP 4 >= 4.1.0)
ncurses_curs_set -- Set cursor state 
Description
int ncurses_curs_set ( int visibility)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_color_setUpncurses_def_prog_mode
#

#T=int ncurses_curs_set ( int visibility)
ncurses_curs_set ( ^!int visibility);
#

#T=ncurses_def_prog_mode - bool ncurses_def_prog_mode ( void )
(PHP 4 >= 4.1.0)
ncurses_def_prog_mode -- Saves terminals (program) mode
Description
bool ncurses_def_prog_mode ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_def_prog_mode() saves the current terminal modes for program (in 
curses) for use by ncurses_reset_prog_mode(). Returns FALSE on success, 
otherwise TRUE. 
See also: ncurses_reset_prog_mode()   ncurses_curs_setUpncurses_def_shell_mode
#

#T=bool ncurses_def_prog_mode ( void )
ncurses_def_prog_mode ( ^!void );
#

#T=ncurses_def_shell_mode - bool ncurses_def_shell_mode ( void )
(PHP 4 >= 4.1.0)
ncurses_def_shell_mode -- Saves terminals (shell) mode
Description
bool ncurses_def_shell_mode ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_def_shell_mode() saves the current terminal modes for shell (not 
in curses) for use by ncurses_reset_shell_mode(). Returns FALSE on 
success, otherwise TRUE. 
See also: ncurses_reset_shell_mode()   ncurses_def_prog_modeUpncurses_define_key
#

#T=bool ncurses_def_shell_mode ( void )
ncurses_def_shell_mode ( ^!void );
#

#T=ncurses_define_key - int ncurses_define_key ( string definition, int keycode)
(PHP 4 >= 4.2.0)
ncurses_define_key -- Define a keycode 
Description
int ncurses_define_key ( string definition, int keycode)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_def_shell_modeUpncurses_del_panel
#

#T=int ncurses_define_key ( string definition, int keycode)
ncurses_define_key ( ^!string definition, int keycode);
#

#T=ncurses_del_panel - int ncurses_del_panel ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_del_panel --  Remove panel from the stack and delete it (but not 
the associated window) 
Description
int ncurses_del_panel ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_define_keyUpncurses_delay_output
#

#T=int ncurses_del_panel ( resource panel)
ncurses_del_panel ( ^!resource panel);
#

#T=ncurses_delay_output - int ncurses_delay_output ( int milliseconds)
(PHP 4 >= 4.1.0)
ncurses_delay_output -- Delay output on terminal using padding characters 
Description
int ncurses_delay_output ( int milliseconds)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_del_panelUpncurses_delch
#

#T=int ncurses_delay_output ( int milliseconds)
ncurses_delay_output ( ^!int milliseconds);
#

#T=ncurses_delch - bool ncurses_delch ( void )
(PHP 4 >= 4.1.0)
ncurses_delch -- Delete character at current position, move rest of line 
left 
Description
bool ncurses_delch ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_delch() deletes the character under the cursor. All characters to 
the right of the cursor on the same line are moved to the left one 
position and the last character on the line is filled with a blank. The 
cursor position does not change. Returns FALSE on success, otherwise TRUE. 

See also: ncurses_deleteln()   ncurses_delay_outputUpncurses_deleteln
#

#T=bool ncurses_delch ( void )
ncurses_delch ( ^!void );
#

#T=ncurses_deleteln - bool ncurses_deleteln ( void )
(PHP 4 >= 4.1.0)
ncurses_deleteln -- Delete line at current position, move rest of screen 
up 
Description
bool ncurses_deleteln ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_deleteln() deletes the current line under cursorposition. All 
lines below the current line are moved up one line. The bottom line of 
window is cleared. Cursor position does not change. Returns FALSE on 
success, otherwise TRUE. 
See also: ncurses_delch()   ncurses_delchUpncurses_delwin
#

#T=bool ncurses_deleteln ( void )
ncurses_deleteln ( ^!void );
#

#T=ncurses_delwin - int ncurses_delwin ( resource window)
(PHP 4 >= 4.1.0)
ncurses_delwin -- Delete a ncurses window 
Description
int ncurses_delwin ( resource window)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_deletelnUpncurses_doupdate
#

#T=int ncurses_delwin ( resource window)
ncurses_delwin ( ^!resource window);
#

#T=ncurses_doupdate - bool ncurses_doupdate ( void )
(PHP 4 >= 4.1.0)
ncurses_doupdate -- Write all prepared refreshes to terminal 
Description
bool ncurses_doupdate ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_doupdate()() compares the virtual screen to the physical screen 
and updates the physical screen. This way is more effective than using 
multiple refresh calls. Returns TRUE on success or FALSE on failure.   ncurses_delwinUpncurses_echo
#

#T=bool ncurses_doupdate ( void )
ncurses_doupdate ( ^!void );
#

#T=ncurses_echo - bool ncurses_echo ( void )
(PHP 4 >= 4.1.0)
ncurses_echo -- Activate keyboard input echo 
Description
bool ncurses_echo ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_echo() enables echo mode. All characters typed by user are echoed 
by ncurses_getch(). Returns FALSE on success, TRUE if any error occurred. 
To disable echo mode use ncurses_noecho().   ncurses_doupdateUpncurses_echochar
#

#T=bool ncurses_echo ( void )
ncurses_echo ( ^!void );
#

#T=ncurses_echochar - int ncurses_echochar ( int character)
(PHP 4 >= 4.1.0)
ncurses_echochar -- Single character output including refresh 
Description
int ncurses_echochar ( int character)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_echoUpncurses_end
#

#T=int ncurses_echochar ( int character)
ncurses_echochar ( ^!int character);
#

#T=ncurses_end - int ncurses_end ( void )
(PHP 4 >= 4.1.0)
ncurses_end -- Stop using ncurses, clean up the screen 
Description
int ncurses_end ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_echocharUpncurses_erase
#

#T=int ncurses_end ( void )
ncurses_end ( ^!void );
#

#T=ncurses_erase - bool ncurses_erase ( void )
(PHP 4 >= 4.1.0)
ncurses_erase -- Erase terminal screen 
Description
bool ncurses_erase ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_erase() fills the terminal screen with blanks. Created blanks have 
the current background rendition, set by ncurses_bkgd(). Returns TRUE on 
success or FALSE on failure. 
See also ncurses_bkgd(), and ncurses_clear()   ncurses_endUpncurses_erasechar
#

#T=bool ncurses_erase ( void )
ncurses_erase ( ^!void );
#

#T=ncurses_erasechar - string ncurses_erasechar ( void )
(PHP 4 >= 4.1.0)
ncurses_erasechar -- Returns current erase character 
Description
string ncurses_erasechar ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_erasechar() returns the current erase char character. 
See also: ncurses_killchar()   ncurses_eraseUpncurses_filter
#

#T=string ncurses_erasechar ( void )
ncurses_erasechar ( ^!void );
#

#T=ncurses_filter - int ncurses_filter ( void )
(PHP 4 >= 4.1.0)
ncurses_filter -- 
Description
int ncurses_filter ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_erasecharUpncurses_flash
#

#T=int ncurses_filter ( void )
ncurses_filter ( ^!void );
#

#T=ncurses_flash - bool ncurses_flash ( void )
(PHP 4 >= 4.1.0)
ncurses_flash -- Flash terminal screen (visual bell) 
Description
bool ncurses_flash ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_flash() flashes the screen, and if its not possible, sends an 
audible alert (bell). Returns FALSE on success, otherwise TRUE. 
See also: ncurses_beep()   ncurses_filterUpncurses_flushinp
#

#T=bool ncurses_flash ( void )
ncurses_flash ( ^!void );
#

#T=ncurses_flushinp - bool ncurses_flushinp ( void )
(PHP 4 >= 4.1.0)
ncurses_flushinp -- Flush keyboard input buffer 
Description
bool ncurses_flushinp ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The ncurses_flushinp() throws away any typeahead that has been typed and 
has not yet been read by your program. Returns FALSE on success, otherwise 
TRUE.   ncurses_flashUpncurses_getch
#

#T=bool ncurses_flushinp ( void )
ncurses_flushinp ( ^!void );
#

#T=ncurses_getch - int ncurses_getch ( void )
(PHP 4 >= 4.1.0)
ncurses_getch -- Read a character from keyboard 
Description
int ncurses_getch ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_flushinpUpncurses_getmaxyx
#

#T=int ncurses_getch ( void )
ncurses_getch ( ^!void );
#

#T=ncurses_getmaxyx - void ncurses_getmaxyx ( resource window, int &y, int &x)
(PHP 4 >= 4.3.0)
ncurses_getmaxyx --  Returns the size of a window 
Description
void ncurses_getmaxyx ( resource window, int &y, int &x)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_getchUpncurses_getmouse
#

#T=void ncurses_getmaxyx ( resource window, int &y, int &x)
ncurses_getmaxyx ( ^!resource window, int &y, int &x);
#

#T=ncurses_getmouse - bool ncurses_getmouse ( array mevent)
(PHP 4 >= 4.2.0)
ncurses_getmouse -- Reads mouse event
Description
bool ncurses_getmouse ( array mevent)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_getmouse() reads mouse event out of queue. Function 
ncurses_getmouse() will return ;FALSE if a mouse event is actually visible 
in the given window, otherwise it will return TRUE. Event options will be 
delivered in parameter mevent, which has to be an array, passed by 
reference (see example below). On success an associative array with 
following keys will be delivered: 
"id" : Id to distinguish multiple devices
"x" : screen relative x-position in character cells
"y" : screen relative y-position in character cells
"z" : currently not supported
"mmask" : Mouse action
Example 1. ncurses_getmouse() example
  <?php
  switch (ncurses_getch()){
    case NCURSES_KEY_MOUSE:
      if (!ncurses_getmouse(&$mevent)){
	if ($mevent["mmask"] & NCURSES_MOUSE_BUTTON1_PRESSED){
	  $mouse_x = $mevent["x"]; // Save mouse position
	  $mouse_y = $mevent["y"];
	}
      }
    break;

    default:
      /* .... */
  }
  ?> 
See also ncurses_ungetmouse()   ncurses_getmaxyxUpncurses_getyx
#

#T=bool ncurses_getmouse ( array mevent)
ncurses_getmouse ( ^!array mevent);
#

#T=ncurses_getyx - void ncurses_getyx ( resource window, int &y, int &x)
(PHP 4 >= 4.3.0)
ncurses_getyx --  Returns the current cursor position for a window 
Description
void ncurses_getyx ( resource window, int &y, int &x)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_getmouseUpncurses_halfdelay
#

#T=void ncurses_getyx ( resource window, int &y, int &x)
ncurses_getyx ( ^!resource window, int &y, int &x);
#

#T=ncurses_halfdelay - int ncurses_halfdelay ( int tenth)
(PHP 4 >= 4.1.0)
ncurses_halfdelay -- Put terminal into halfdelay mode 
Description
int ncurses_halfdelay ( int tenth)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_getyxUpncurses_has_colors
#

#T=int ncurses_halfdelay ( int tenth)
ncurses_halfdelay ( ^!int tenth);
#

#T=ncurses_has_colors - bool ncurses_has_colors ( void )
(PHP 4 >= 4.1.0)
ncurses_has_colors -- Check if terminal has colors 
Description
bool ncurses_has_colors ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_has_colors() returns TRUE or FALSE depending on whether the 
terminal has color capacities. 
See also: ncurses_can_change_color()   ncurses_halfdelayUpncurses_has_ic
#

#T=bool ncurses_has_colors ( void )
ncurses_has_colors ( ^!void );
#

#T=ncurses_has_ic - bool ncurses_has_ic ( void )
(PHP 4 >= 4.1.0)
ncurses_has_ic -- Check for insert- and delete-capabilities 
Description
bool ncurses_has_ic ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_has_ic() checks terminals insert- and delete capabilities. It 
returns TRUE when terminal has insert/delete-capabilities, otherwise 
FALSE. 
See also: ncurses_has_il()   ncurses_has_colorsUpncurses_has_il
#

#T=bool ncurses_has_ic ( void )
ncurses_has_ic ( ^!void );
#

#T=ncurses_has_il - bool ncurses_has_il ( void )
(PHP 4 >= 4.1.0)
ncurses_has_il -- Check for line insert- and delete-capabilities 
Description
bool ncurses_has_il ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_has_il() checks terminals insert- and delete-line-capabilities. It 
returns TRUE when terminal has insert/delete-line capabilities, otherwise 
FALSE 
See also: ncurses_has_ic()   ncurses_has_icUpncurses_has_key
#

#T=bool ncurses_has_il ( void )
ncurses_has_il ( ^!void );
#

#T=ncurses_has_key - int ncurses_has_key ( int keycode)
(PHP 4 >= 4.1.0)
ncurses_has_key -- Check for presence of a function key on terminal 
keyboard 
Description
int ncurses_has_key ( int keycode)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_has_ilUpncurses_hide_panel
#

#T=int ncurses_has_key ( int keycode)
ncurses_has_key ( ^!int keycode);
#

#T=ncurses_hide_panel - int ncurses_hide_panel ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_hide_panel --  Remove panel from the stack, making it invisible 
Description
int ncurses_hide_panel ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_has_keyUpncurses_hline
#

#T=int ncurses_hide_panel ( resource panel)
ncurses_hide_panel ( ^!resource panel);
#

#T=ncurses_hline - int ncurses_hline ( int charattr, int n)
(PHP 4 >= 4.2.0)
ncurses_hline -- Draw a horizontal line at current position using an 
attributed character and max. n characters long 
Description
int ncurses_hline ( int charattr, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_hide_panelUpncurses_inch
#

#T=int ncurses_hline ( int charattr, int n)
ncurses_hline ( ^!int charattr, int n);
#

#T=ncurses_inch - string ncurses_inch ( void )
(PHP 4 >= 4.1.0)
ncurses_inch -- Get character and attribute at current position 
Description
string ncurses_inch ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_inch() returns the character from the current position.   ncurses_hlineUpncurses_init_color
#

#T=string ncurses_inch ( void )
ncurses_inch ( ^!void );
#

#T=ncurses_init_color - int ncurses_init_color ( int color, int r, int g, int b)
(PHP 4 >= 4.2.0)
ncurses_init_color -- Set new RGB value for color 
Description
int ncurses_init_color ( int color, int r, int g, int b)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_inchUpncurses_init_pair
#

#T=int ncurses_init_color ( int color, int r, int g, int b)
ncurses_init_color ( ^!int color, int r, int g, int b);
#

#T=ncurses_init_pair - int ncurses_init_pair ( int pair, int fg, int bg)
(PHP 4 >= 4.1.0)
ncurses_init_pair -- Allocate a color pair 
Description
int ncurses_init_pair ( int pair, int fg, int bg)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_init_colorUpncurses_init
#

#T=int ncurses_init_pair ( int pair, int fg, int bg)
ncurses_init_pair ( ^!int pair, int fg, int bg);
#

#T=ncurses_init - int ncurses_init ( void )
(PHP 4 >= 4.1.0)
ncurses_init -- Initialize ncurses 
Description
int ncurses_init ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_init_pairUpncurses_insch
#

#T=int ncurses_init ( void )
ncurses_init ( ^!void );
#

#T=ncurses_insch - int ncurses_insch ( int character)
(PHP 4 >= 4.1.0)
ncurses_insch -- Insert character moving rest of line including character 
at current position 
Description
int ncurses_insch ( int character)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_initUpncurses_insdelln
#

#T=int ncurses_insch ( int character)
ncurses_insch ( ^!int character);
#

#T=ncurses_insdelln - int ncurses_insdelln ( int count)
(PHP 4 >= 4.1.0)
ncurses_insdelln -- Insert lines before current line scrolling down 
(negative numbers delete and scroll up) 
Description
int ncurses_insdelln ( int count)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_inschUpncurses_insertln
#

#T=int ncurses_insdelln ( int count)
ncurses_insdelln ( ^!int count);
#

#T=ncurses_insertln - bool ncurses_insertln ( void )
(PHP 4 >= 4.1.0)
ncurses_insertln -- Insert a line, move rest of screen down 
Description
bool ncurses_insertln ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_insertln() inserts a new line above the current line. The bottom 
line will be lost.   ncurses_insdellnUpncurses_insstr
#

#T=bool ncurses_insertln ( void )
ncurses_insertln ( ^!void );
#

#T=ncurses_insstr - int ncurses_insstr ( string text)
(PHP 4 >= 4.2.0)
ncurses_insstr -- Insert string at current position, moving rest of line 
right 
Description
int ncurses_insstr ( string text)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_insertlnUpncurses_instr
#

#T=int ncurses_insstr ( string text)
ncurses_insstr ( ^!string text);
#

#T=ncurses_instr - int ncurses_instr ( string buffer)
(PHP 4 >= 4.2.0)
ncurses_instr -- Reads string from terminal screen 
Description
int ncurses_instr ( string buffer)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_instr() returns the number of characters read from the current 
character position until end of line. buffer contains the characters. 
Attributes are stripped from the characters.   ncurses_insstrUpncurses_isendwin
#

#T=int ncurses_instr ( string buffer)
ncurses_instr ( ^!string buffer);
#

#T=ncurses_isendwin - bool ncurses_isendwin ( void )
(PHP 4 >= 4.1.0)
ncurses_isendwin -- Ncurses is in endwin mode, normal screen output may be 
performed 
Description
bool ncurses_isendwin ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_isendwin() returns TRUE, if ncurses_endwin() has been called 
without any subsequent calls to ncurses_wrefresh(), otherwise FALSE. 
See also ncurses_endwin() and ncurses_wrefresh().   ncurses_instrUpncurses_keyok
#

#T=bool ncurses_isendwin ( void )
ncurses_isendwin ( ^!void );
#

#T=ncurses_keyok - int ncurses_keyok ( int keycode, bool enable)
(PHP 4 >= 4.2.0)
ncurses_keyok -- Enable or disable a keycode 
Description
int ncurses_keyok ( int keycode, bool enable)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_isendwinUpncurses_keypad
#

#T=int ncurses_keyok ( int keycode, bool enable)
ncurses_keyok ( ^!int keycode, bool enable);
#

#T=ncurses_keypad - int ncurses_keypad ( resource window, bool bf)
(PHP 4 >= 4.2.0)
ncurses_keypad --  Turns keypad on or off 
Description
int ncurses_keypad ( resource window, bool bf)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_keyokUpncurses_killchar
#

#T=int ncurses_keypad ( resource window, bool bf)
ncurses_keypad ( ^!resource window, bool bf);
#

#T=ncurses_killchar - bool ncurses_killchar ( void )
(PHP 4 >= 4.1.0)
ncurses_killchar -- Returns current line kill character 
Description
bool ncurses_killchar ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_killchar() returns the current line kill character. 
See also: ncurses_erasechar()   ncurses_keypadUpncurses_longname
#

#T=bool ncurses_killchar ( void )
ncurses_killchar ( ^!void );
#

#T=ncurses_longname - 
string ncurses_longname ( void 
(PHP 4 >= 4.2.0)
ncurses_longname -- Returns terminals description
Description
string ncurses_longname ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_longname() returns a verbose description of the terminal. The 
description is truncated to 128 characters. On Error ncurses_longname() 
returns NULL. 
See also: ncurses_termname()   ncurses_killcharUpncurses_meta
#

#T=
string ncurses_longname ( void 

ncurses_longname ( ^!void ;
#

#T=ncurses_meta - long ncurses_meta ( resource window, bool 8bit)
(PHP 4 >= 4.3.0)
ncurses_meta --  Enables/Disable 8-bit meta key information 
Description
long ncurses_meta ( resource window, bool 8bit)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_longnameUpncurses_mouse_trafo
#

#T=long ncurses_meta ( resource window, bool 8bit)
ncurses_meta ( ^!resource window, bool 8bit);
#

#T=ncurses_mouse_trafo - bool ncurses_mouse_trafo ( int &y, int &x, bool toscreen)
(PHP 4 >= 4.2.0)
ncurses_mouse_trafo --  Transforms coordinates 
Description
bool ncurses_mouse_trafo ( int &y, int &x, bool toscreen)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_metaUpncurses_mouseinterval
#

#T=bool ncurses_mouse_trafo ( int &y, int &x, bool toscreen)
ncurses_mouse_trafo ( ^!int &y, int &x, bool toscreen);
#

#T=ncurses_mouseinterval - int ncurses_mouseinterval ( int milliseconds)
(PHP 4 >= 4.1.0)
ncurses_mouseinterval -- Set timeout for mouse button clicks 
Description
int ncurses_mouseinterval ( int milliseconds)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mouse_trafoUpncurses_mousemask
#

#T=int ncurses_mouseinterval ( int milliseconds)
ncurses_mouseinterval ( ^!int milliseconds);
#

#T=ncurses_mousemask - int ncurses_mousemask ( int newmask, int oldmask)
(PHP 4 >= 4.2.0)
ncurses_mousemask -- Sets mouse options
Description
int ncurses_mousemask ( int newmask, int oldmask)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Function ncurses_mousemask() will set mouse events to be reported. By 
default no mouse events will be reported. The function ncurses_mousemask() 
will return a mask to indicated which of the in parameter newmask 
specified mouse events can be reported. On complete failure, it returns 0. 
In parameter oldmask, which is passed by reference ncurses_mousemask() 
returns the previous value of mouse event mask. Mouse events are 
represented by NCURSES_KEY_MOUSE in the ncurses_wgetch() input stream. To 
read the event data and pop the event of of queue, call 
ncurses_getmouse(). 
As a side effect, setting a zero mousemask in newmask turns off the mouse 
pointer. Setting a non zero value turns mouse pointer on. 
mouse mask options can be set with the following predefined constants: 
NCURSES_BUTTON1_PRESSED
NCURSES_BUTTON1_RELEASED
NCURSES_BUTTON1_CLICKED
NCURSES_BUTTON1_DOUBLE_CLICKED
NCURSES_BUTTON1_TRIPLE_CLICKED
NCURSES_BUTTON2_PRESSED
NCURSES_BUTTON2_RELEASED
NCURSES_BUTTON2_CLICKED
NCURSES_BUTTON2_DOUBLE_CLICKED
NCURSES_BUTTON2_TRIPLE_CLICKED
NCURSES_BUTTON3_PRESSED
NCURSES_BUTTON3_RELEASED
NCURSES_BUTTON3_CLICKED
NCURSES_BUTTON3_DOUBLE_CLICKED
NCURSES_BUTTON3_TRIPLE_CLICKED
NCURSES_BUTTON4_PRESSED
NCURSES_BUTTON4_RELEASED
NCURSES_BUTTON4_CLICKED
NCURSES_BUTTON4_DOUBLE_CLICKED
NCURSES_BUTTON4_TRIPLE_CLICKED
NCURSES_BUTTON_SHIFT>
NCURSES_BUTTON_CTRL
NCURSES_BUTTON_ALT
NCURSES_ALL_MOUSE_EVENTS
NCURSES_REPORT_MOUSE_POSITION
Example 1. ncurses_mousemask() example
  <?php
  $newmask = NCURSES_BUTTON1_CLICKED + NCURSES_BUTTON1_RELEASED;
  $mask = ncurses_mousemask($newmask, &$oldmask);
  if ($mask & $newmask){
    printf ("All specified mouse options will be supported\n");
  }
  ?> 
See also ncurses_getmouse(), ncurses_ungetmouse() and ncurese_getch().   ncurses_mouseintervalUpncurses_move_panel
#

#T=int ncurses_mousemask ( int newmask, int oldmask)
ncurses_mousemask ( ^!int newmask, int oldmask);
#

#T=ncurses_move_panel - int ncurses_move_panel ( resource panel, int startx, int starty)
(PHP 4 >= 4.3.0)
ncurses_move_panel --  Moves a panel so that it's upper-left corner is at 
[startx, starty] 
Description
int ncurses_move_panel ( resource panel, int startx, int starty)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mousemaskUpncurses_move
#

#T=int ncurses_move_panel ( resource panel, int startx, int starty)
ncurses_move_panel ( ^!resource panel, int startx, int starty);
#

#T=ncurses_move - int ncurses_move ( int y, int x)
(PHP 4 >= 4.1.0)
ncurses_move -- Move output position 
Description
int ncurses_move ( int y, int x)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_move_panelUpncurses_mvaddch
#

#T=int ncurses_move ( int y, int x)
ncurses_move ( ^!int y, int x);
#

#T=ncurses_mvaddch - int ncurses_mvaddch ( int y, int x, int c)
(PHP 4 >= 4.2.0)
ncurses_mvaddch -- Move current position and add character 
Description
int ncurses_mvaddch ( int y, int x, int c)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_moveUpncurses_mvaddchnstr
#

#T=int ncurses_mvaddch ( int y, int x, int c)
ncurses_mvaddch ( ^!int y, int x, int c);
#

#T=ncurses_mvaddchnstr - int ncurses_mvaddchnstr ( int y, int x, string s, int n)
(PHP 4 >= 4.2.0)
ncurses_mvaddchnstr -- Move position and add attributed string with 
specified length 
Description
int ncurses_mvaddchnstr ( int y, int x, string s, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvaddchUpncurses_mvaddchstr
#

#T=int ncurses_mvaddchnstr ( int y, int x, string s, int n)
ncurses_mvaddchnstr ( ^!int y, int x, string s, int n);
#

#T=ncurses_mvaddchstr - int ncurses_mvaddchstr ( int y, int x, string s)
(PHP 4 >= 4.2.0)
ncurses_mvaddchstr -- Move position and add attributed string 
Description
int ncurses_mvaddchstr ( int y, int x, string s)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvaddchnstrUpncurses_mvaddnstr
#

#T=int ncurses_mvaddchstr ( int y, int x, string s)
ncurses_mvaddchstr ( ^!int y, int x, string s);
#

#T=ncurses_mvaddnstr - int ncurses_mvaddnstr ( int y, int x, string s, int n)
(PHP 4 >= 4.2.0)
ncurses_mvaddnstr -- Move position and add string with specified length 
Description
int ncurses_mvaddnstr ( int y, int x, string s, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvaddchstrUpncurses_mvaddstr
#

#T=int ncurses_mvaddnstr ( int y, int x, string s, int n)
ncurses_mvaddnstr ( ^!int y, int x, string s, int n);
#

#T=ncurses_mvaddstr - int ncurses_mvaddstr ( int y, int x, string s)
(PHP 4 >= 4.2.0)
ncurses_mvaddstr -- Move position and add string 
Description
int ncurses_mvaddstr ( int y, int x, string s)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvaddnstrUpncurses_mvcur
#

#T=int ncurses_mvaddstr ( int y, int x, string s)
ncurses_mvaddstr ( ^!int y, int x, string s);
#

#T=ncurses_mvcur - int ncurses_mvcur ( int old_y, int old_x, int new_y, int new_x)
(PHP 4 >= 4.2.0)
ncurses_mvcur -- Move cursor immediately 
Description
int ncurses_mvcur ( int old_y, int old_x, int new_y, int new_x)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvaddstrUpncurses_mvdelch
#

#T=int ncurses_mvcur ( int old_y, int old_x, int new_y, int new_x)
ncurses_mvcur ( ^!int old_y, int old_x, int new_y, int new_x);
#

#T=ncurses_mvdelch - int ncurses_mvdelch ( int y, int x)
(PHP 4 >= 4.2.0)
ncurses_mvdelch -- Move position and delete character, shift rest of line 
left 
Description
int ncurses_mvdelch ( int y, int x)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvcurUpncurses_mvgetch
#

#T=int ncurses_mvdelch ( int y, int x)
ncurses_mvdelch ( ^!int y, int x);
#

#T=ncurses_mvgetch - int ncurses_mvgetch ( int y, int x)
(PHP 4 >= 4.2.0)
ncurses_mvgetch -- Move position and get character at new position 
Description
int ncurses_mvgetch ( int y, int x)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvdelchUpncurses_mvhline
#

#T=int ncurses_mvgetch ( int y, int x)
ncurses_mvgetch ( ^!int y, int x);
#

#T=ncurses_mvhline - int ncurses_mvhline ( int y, int x, int attrchar, int n)
(PHP 4 >= 4.2.0)
ncurses_mvhline -- Set new position and draw a horizontal line using an 
attributed character and max. n characters long 
Description
int ncurses_mvhline ( int y, int x, int attrchar, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvgetchUpncurses_mvinch
#

#T=int ncurses_mvhline ( int y, int x, int attrchar, int n)
ncurses_mvhline ( ^!int y, int x, int attrchar, int n);
#

#T=ncurses_mvinch - int ncurses_mvinch ( int y, int x)
(PHP 4 >= 4.2.0)
ncurses_mvinch -- Move position and get attributed character at new 
position 
Description
int ncurses_mvinch ( int y, int x)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvhlineUpncurses_mvvline
ncurses_mvvline
(no version information, might be only in CVS)
ncurses_mvvline -- Set new position and draw a vertical line using an 
attributed character and max. n characters long 
Description
int ncurses_mvvline ( int y, int x, int attrchar, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvinchUpncurses_mvwaddstr
#

#T=int ncurses_mvinch ( int y, int x)
ncurses_mvinch ( ^!int y, int x);
#

#T=ncurses_mvwaddstr - int ncurses_mvwaddstr ( resource window, int y, int x, string text)
(PHP 4 >= 4.2.0)
ncurses_mvwaddstr -- Add string at new position in window 
Description
int ncurses_mvwaddstr ( resource window, int y, int x, string text)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvvlineUpncurses_napms
#

#T=int ncurses_mvwaddstr ( resource window, int y, int x, string text)
ncurses_mvwaddstr ( ^!resource window, int y, int x, string text);
#

#T=ncurses_napms - int ncurses_napms ( int milliseconds)
(PHP 4 >= 4.1.0)
ncurses_napms -- Sleep 
Description
int ncurses_napms ( int milliseconds)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_mvwaddstrUpncurses_new_panel
#

#T=int ncurses_napms ( int milliseconds)
ncurses_napms ( ^!int milliseconds);
#

#T=ncurses_new_panel - resource ncurses_new_panel ( resource window)
(PHP 4 >= 4.3.0)
ncurses_new_panel --  Create a new panel and associate it with window 
Description
resource ncurses_new_panel ( resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_napmsUpncurses_newpad
#

#T=resource ncurses_new_panel ( resource window)
ncurses_new_panel ( ^!resource window);
#

#T=ncurses_newpad - resource ncurses_newpad ( int rows, int cols)
(PHP 4 >= 4.3.0)
ncurses_newpad --  Creates a new pad (window) 
Description
resource ncurses_newpad ( int rows, int cols)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_new_panelUpncurses_newwin
#

#T=resource ncurses_newpad ( int rows, int cols)
ncurses_newpad ( ^!int rows, int cols);
#

#T=ncurses_newwin - int ncurses_newwin ( int rows, int cols, int y, int x)
(PHP 4 >= 4.1.0)
ncurses_newwin -- Create a new window 
Description
int ncurses_newwin ( int rows, int cols, int y, int x)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_newpadUpncurses_nl
#

#T=int ncurses_newwin ( int rows, int cols, int y, int x)
ncurses_newwin ( ^!int rows, int cols, int y, int x);
#

#T=ncurses_nl - bool ncurses_nl ( void )
(PHP 4 >= 4.1.0)
ncurses_nl -- Translate newline and carriage return / line feed 
Description
bool ncurses_nl ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_newwinUpncurses_nocbreak
#

#T=bool ncurses_nl ( void )
ncurses_nl ( ^!void );
#

#T=ncurses_nocbreak - bool ncurses_nocbreak ( void )
(PHP 4 >= 4.1.0)
ncurses_nocbreak -- Switch terminal to cooked mode 
Description
bool ncurses_nocbreak ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_nocbreak() routine returns terminal to normal (cooked) mode. 
Initially the terminal may or may not in cbreak mode as the mode is 
inherited. Therefore a program should call ncurses_cbreak() and 
ncurses_nocbreak() explicitly. Returns TRUE if any error occurred, 
otherwise FALSE. 
See also: ncurses_cbreak()   ncurses_nlUpncurses_noecho
#

#T=bool ncurses_nocbreak ( void )
ncurses_nocbreak ( ^!void );
#

#T=ncurses_noecho - bool ncurses_noecho ( void )
(PHP 4 >= 4.1.0)
ncurses_noecho -- Switch off keyboard input echo 
Description
bool ncurses_noecho ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_noecho() prevents echoing of user typed characters. Returns TRUE 
if any error occurred, otherwise FALSE. 
See also: ncurses_echo(), ncurses_getch()   ncurses_nocbreakUpncurses_nonl
#

#T=bool ncurses_noecho ( void )
ncurses_noecho ( ^!void );
#

#T=ncurses_nonl - bool ncurses_nonl ( void )
(PHP 4 >= 4.1.0)
ncurses_nonl -- Do not translate newline and carriage return / line feed 
Description
bool ncurses_nonl ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_noechoUpncurses_noqiflush
#

#T=bool ncurses_nonl ( void )
ncurses_nonl ( ^!void );
#

#T=ncurses_noqiflush - int ncurses_noqiflush ( void )
(PHP 4 >= 4.1.0)
ncurses_noqiflush -- Do not flush on signal characters
Description
int ncurses_noqiflush ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_nonlUpncurses_noraw
#

#T=int ncurses_noqiflush ( void )
ncurses_noqiflush ( ^!void );
#

#T=ncurses_noraw - bool ncurses_noraw ( void )
(PHP 4 >= 4.1.0)
ncurses_noraw -- Switch terminal out of raw mode 
Description
bool ncurses_noraw ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_noraw() switches the terminal out of raw mode. Raw mode is similar 
to cbreak mode, in that characters typed are immediately passed through to 
the user program. The differences that are that in raw mode, the 
interrupt, quit, suspend and flow control characters are all passed 
through uninterpreted, instead of generating a signal. Returns TRUE if any 
error occurred, otherwise FALSE. 
See also: ncurses_raw(), ncurses_cbreak(), ncurses_nocbreak()   ncurses_noqiflushUpncurses_pair_content
#

#T=bool ncurses_noraw ( void )
ncurses_noraw ( ^!void );
#

#T=ncurses_pair_content - int ncurses_pair_content ( int pair, int &f, int &b)
(PHP 4 >= 4.3.0)
ncurses_pair_content --  Gets the RGB value for color 
Description
int ncurses_pair_content ( int pair, int &f, int &b)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_norawUpncurses_panel_above
#

#T=int ncurses_pair_content ( int pair, int &f, int &b)
ncurses_pair_content ( ^!int pair, int &f, int &b);
#

#T=ncurses_panel_above - int ncurses_panel_above ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_panel_above --  Returns the panel above panel. If panel is null, 
returns the bottom panel in the stack 
Description
int ncurses_panel_above ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_pair_contentUpncurses_panel_below
#

#T=int ncurses_panel_above ( resource panel)
ncurses_panel_above ( ^!resource panel);
#

#T=ncurses_panel_below - int ncurses_panel_below ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_panel_below --  Returns the panel below panel. If panel is null, 
returns the top panel in the stack 
Description
int ncurses_panel_below ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_panel_aboveUpncurses_panel_window
#

#T=int ncurses_panel_below ( resource panel)
ncurses_panel_below ( ^!resource panel);
#

#T=ncurses_panel_window - int ncurses_panel_window ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_panel_window --  Returns the window associated with panel 
Description
int ncurses_panel_window ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_panel_belowUpncurses_pnoutrefresh
#

#T=int ncurses_panel_window ( resource panel)
ncurses_panel_window ( ^!resource panel);
#

#T=ncurses_pnoutrefresh - int ncurses_pnoutrefresh ( resource pad, int pminrow, int pmincol, int 
(PHP 4 >= 4.3.0)
ncurses_pnoutrefresh --  Copies a region from a pad into the virtual 
screen 
Description
int ncurses_pnoutrefresh ( resource pad, int pminrow, int pmincol, int 
sminrow, int smincol, int smaxrow, int smaxcol)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_panel_windowUpncurses_prefresh
#

#T=int ncurses_pnoutrefresh ( resource pad, int pminrow, int pmincol, int 
ncurses_pnoutrefresh ( ^!resource pad, int pminrow, int pmincol, int ;
#

#T=ncurses_prefresh - int ncurses_prefresh ( resource pad, int pminrow, int pmincol, int 
(PHP 4 >= 4.3.0)
ncurses_prefresh --  Copies a region from a pad into the virtual screen 
Description
int ncurses_prefresh ( resource pad, int pminrow, int pmincol, int 
sminrow, int smincol, int smaxrow, int smaxcol)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_pnoutrefreshUpncurses_putp
#

#T=int ncurses_prefresh ( resource pad, int pminrow, int pmincol, int 
ncurses_prefresh ( ^!resource pad, int pminrow, int pmincol, int ;
#

#T=ncurses_putp - int ncurses_putp ( string text)
(PHP 4 >= 4.2.0)
ncurses_putp -- 
Description
int ncurses_putp ( string text)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_prefreshUpncurses_qiflush
#

#T=int ncurses_putp ( string text)
ncurses_putp ( ^!string text);
#

#T=ncurses_qiflush - int ncurses_qiflush ( void )
(PHP 4 >= 4.1.0)
ncurses_qiflush -- Flush on signal characters 
Description
int ncurses_qiflush ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_putpUpncurses_raw
#

#T=int ncurses_qiflush ( void )
ncurses_qiflush ( ^!void );
#

#T=ncurses_raw - bool ncurses_raw ( void )
(PHP 4 >= 4.1.0)
ncurses_raw -- Switch terminal into raw mode 
Description
bool ncurses_raw ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_raw() places the terminal in raw mode. Raw mode is similar to 
cbreak mode, in that characters typed are immediately passed through to 
the user program. The differences that are that in raw mode, the 
interrupt, quit, suspend and flow control characters are all passed 
through uninterpreted, instead of generating a signal. Returns TRUE if any 
error occurred, otherwise FALSE. 
See also: ncurses_noraw(), ncurses_cbreak(), ncurses_nocbreak()   ncurses_qiflushUpncurses_refresh
#

#T=bool ncurses_raw ( void )
ncurses_raw ( ^!void );
#

#T=ncurses_refresh - int ncurses_refresh ( int ch)
(PHP 4 >= 4.1.0)
ncurses_refresh -- Refresh screen 
Description
int ncurses_refresh ( int ch)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_rawUpncurses_replace_panel
#

#T=int ncurses_refresh ( int ch)
ncurses_refresh ( ^!int ch);
#

#T=ncurses_replace_panel - int ncurses_replace_panel ( resource panel, resource window)
(PHP 4 >= 4.3.0)
ncurses_replace_panel --  Replaces the window associated with panel 
Description
int ncurses_replace_panel ( resource panel, resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_refreshUpncurses_reset_prog_mode
#

#T=int ncurses_replace_panel ( resource panel, resource window)
ncurses_replace_panel ( ^!resource panel, resource window);
#

#T=ncurses_reset_prog_mode - int ncurses_reset_prog_mode ( void )
(PHP 4 >= 4.3.0)
ncurses_reset_prog_mode --  Resets the prog mode saved by def_prog_mode 
Description
int ncurses_reset_prog_mode ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_replace_panelUpncurses_reset_shell_mode
#

#T=int ncurses_reset_prog_mode ( void )
ncurses_reset_prog_mode ( ^!void );
#

#T=ncurses_reset_shell_mode - int ncurses_reset_shell_mode ( void )
(PHP 4 >= 4.3.0)
ncurses_reset_shell_mode --  Resets the shell mode saved by def_shell_mode 

Description
int ncurses_reset_shell_mode ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_reset_prog_modeUpncurses_resetty
#

#T=int ncurses_reset_shell_mode ( void )
ncurses_reset_shell_mode ( ^!void );
#

#T=ncurses_resetty - bool ncurses_resetty ( void )
(PHP 4 >= 4.1.0)
ncurses_resetty -- Restores saved terminal state 
Description
bool ncurses_resetty ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Function ncurses_resetty() restores the terminal state, which was 
previously saved by calling ncurses_savetty(). This function always 
returns FALSE. 
See also: ncurses_savetty()   ncurses_reset_shell_modeUpncurses_savetty
#

#T=bool ncurses_resetty ( void )
ncurses_resetty ( ^!void );
#

#T=ncurses_savetty - bool ncurses_savetty ( void )
(PHP 4 >= 4.1.0)
ncurses_savetty -- Saves terminal state 
Description
bool ncurses_savetty ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Function ncurses_savetty() saves the current terminal state. The saved 
terminal state can be restored with function ncurses_resetty(). 
ncurses_savetty() always returns FALSE. 
See also: ncurses_resetty()   ncurses_resettyUpncurses_scr_dump
#

#T=bool ncurses_savetty ( void )
ncurses_savetty ( ^!void );
#

#T=ncurses_scr_dump - int ncurses_scr_dump ( string filename)
(PHP 4 >= 4.2.0)
ncurses_scr_dump -- Dump screen content to file 
Description
int ncurses_scr_dump ( string filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_savettyUpncurses_scr_init
#

#T=int ncurses_scr_dump ( string filename)
ncurses_scr_dump ( ^!string filename);
#

#T=ncurses_scr_init - int ncurses_scr_init ( string filename)
(PHP 4 >= 4.2.0)
ncurses_scr_init -- Initialize screen from file dump 
Description
int ncurses_scr_init ( string filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_scr_dumpUpncurses_scr_restore
#

#T=int ncurses_scr_init ( string filename)
ncurses_scr_init ( ^!string filename);
#

#T=ncurses_scr_restore - int ncurses_scr_restore ( string filename)
(PHP 4 >= 4.2.0)
ncurses_scr_restore -- Restore screen from file dump 
Description
int ncurses_scr_restore ( string filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_scr_initUpncurses_scr_set
#

#T=int ncurses_scr_restore ( string filename)
ncurses_scr_restore ( ^!string filename);
#

#T=ncurses_scr_set - int ncurses_scr_set ( string filename)
(PHP 4 >= 4.2.0)
ncurses_scr_set -- Inherit screen from file dump 
Description
int ncurses_scr_set ( string filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_scr_restoreUpncurses_scrl
#

#T=int ncurses_scr_set ( string filename)
ncurses_scr_set ( ^!string filename);
#

#T=ncurses_scrl - int ncurses_scrl ( int count)
(PHP 4 >= 4.1.0)
ncurses_scrl -- Scroll window content up or down without changing current 
position 
Description
int ncurses_scrl ( int count)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_scr_setUpncurses_show_panel
#

#T=int ncurses_scrl ( int count)
ncurses_scrl ( ^!int count);
#

#T=ncurses_show_panel - int ncurses_show_panel ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_show_panel --  Places an invisible panel on top of the stack, 
making it visible 
Description
int ncurses_show_panel ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_scrlUpncurses_slk_attr
#

#T=int ncurses_show_panel ( resource panel)
ncurses_show_panel ( ^!resource panel);
#

#T=ncurses_slk_attr - bool ncurses_slk_attr ( void )
(PHP 4 >= 4.1.0)
ncurses_slk_attr -- Returns current soft label key attribute
Description
bool ncurses_slk_attr ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_slk_attr() returns the current soft label key attribute. On error 
returns TRUE, otherwise FALSE.   ncurses_show_panelUpncurses_slk_attroff
#

#T=bool ncurses_slk_attr ( void )
ncurses_slk_attr ( ^!void );
#

#T=ncurses_slk_attroff - int ncurses_slk_attroff ( int intarg)
(PHP 4 >= 4.1.0)
ncurses_slk_attroff -- 
Description
int ncurses_slk_attroff ( int intarg)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_slk_attrUpncurses_slk_attron
#

#T=int ncurses_slk_attroff ( int intarg)
ncurses_slk_attroff ( ^!int intarg);
#

#T=ncurses_slk_attron - int ncurses_slk_attron ( int intarg)
(PHP 4 >= 4.1.0)
ncurses_slk_attron -- 
Description
int ncurses_slk_attron ( int intarg)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_slk_attroffUpncurses_slk_attrset
#

#T=int ncurses_slk_attron ( int intarg)
ncurses_slk_attron ( ^!int intarg);
#

#T=ncurses_slk_attrset - int ncurses_slk_attrset ( int intarg)
(PHP 4 >= 4.1.0)
ncurses_slk_attrset -- 
Description
int ncurses_slk_attrset ( int intarg)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_slk_attronUpncurses_slk_clear
#

#T=int ncurses_slk_attrset ( int intarg)
ncurses_slk_attrset ( ^!int intarg);
#

#T=ncurses_slk_clear - bool ncurses_slk_clear ( void )
(PHP 4 >= 4.1.0)
ncurses_slk_clear -- Clears soft labels from screen
Description
bool ncurses_slk_clear ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function ncurses_slk_clear() clears soft label keys from screen. 
Returns TRUE on error, otherwise FALSE.   ncurses_slk_attrsetUpncurses_slk_color
#

#T=bool ncurses_slk_clear ( void )
ncurses_slk_clear ( ^!void );
#

#T=ncurses_slk_color - int ncurses_slk_color ( int intarg)
(PHP 4 >= 4.1.0)
ncurses_slk_color -- Sets color for soft label keys
Description
int ncurses_slk_color ( int intarg)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_slk_clearUpncurses_slk_init
#

#T=int ncurses_slk_color ( int intarg)
ncurses_slk_color ( ^!int intarg);
#

#T=ncurses_slk_init - bool ncurses_slk_init ( int format)
(PHP 4 >= 4.1.0)
ncurses_slk_init -- Initializes soft label key functions
Description
bool ncurses_slk_init ( int format)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Function ncurses_slk_init() must be called before ncurses_initscr() or 
ncurses_newterm() is called. If ncurses_initscr() eventually uses a line 
from stdscr to emulate the soft labels, then format determines how the 
labels are arranged of the screen. Setting format to 0 indicates a 3-2-3 
arrangement of the labels, 1 indicates a 4-4 arrangement and 2 indicates 
the PC like 4-4-4 mode, but in addition an index line will be created.   ncurses_slk_colorUpncurses_slk_noutrefresh
#

#T=bool ncurses_slk_init ( int format)
ncurses_slk_init ( ^!int format);
#

#T=ncurses_slk_noutrefresh - bool ncurses_slk_noutrefresh ( void )
(PHP 4 >= 4.1.0)
ncurses_slk_noutrefresh -- Copies soft label keys to virtual screen
Description
bool ncurses_slk_noutrefresh ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_slk_initUpncurses_slk_refresh
#

#T=bool ncurses_slk_noutrefresh ( void )
ncurses_slk_noutrefresh ( ^!void );
#

#T=ncurses_slk_refresh - bool ncurses_slk_refresh ( void )
(PHP 4 >= 4.1.0)
ncurses_slk_refresh -- Copies soft label keys to screen
Description
bool ncurses_slk_refresh ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_slk_refresh() copies soft label keys from virtual screen to 
physical screen. Returns TRUE on error, otherwise FALSE.   ncurses_slk_noutrefreshUpncurses_slk_restore
#

#T=bool ncurses_slk_refresh ( void )
ncurses_slk_refresh ( ^!void );
#

#T=ncurses_slk_restore - bool ncurses_slk_restore ( void )
(PHP 4 >= 4.1.0)
ncurses_slk_restore -- Restores soft label keys
Description
bool ncurses_slk_restore ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function ncurses_slk_restore() restores the soft label keys after 
ncurses_slk_clear() has been performed.   ncurses_slk_refreshUpncurses_slk_set
#

#T=bool ncurses_slk_restore ( void )
ncurses_slk_restore ( ^!void );
#

#T=ncurses_slk_set - bool ncurses_slk_set ( int labelnr, string label, int format)
(PHP 4 >= 4.2.0)
ncurses_slk_set --  Sets function key labels 
Description
bool ncurses_slk_set ( int labelnr, string label, int format)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_slk_restoreUpncurses_slk_touch
#

#T=bool ncurses_slk_set ( int labelnr, string label, int format)
ncurses_slk_set ( ^!int labelnr, string label, int format);
#

#T=ncurses_slk_touch - bool ncurses_slk_touch ( void )
(PHP 4 >= 4.1.0)
ncurses_slk_touch -- Forces output when ncurses_slk_noutrefresh is 
performed
Description
bool ncurses_slk_touch ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The ncurses_slk_touch() function forces all the soft labels to be output 
the next time a ncurses_slk_noutrefresh() is performed.   ncurses_slk_setUpncurses_standend
#

#T=bool ncurses_slk_touch ( void )
ncurses_slk_touch ( ^!void );
#

#T=ncurses_standend - int ncurses_standend ( void )
(PHP 4 >= 4.1.0)
ncurses_standend -- Stop using 'standout' attribute 
Description
int ncurses_standend ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_slk_touchUpncurses_standout
#

#T=int ncurses_standend ( void )
ncurses_standend ( ^!void );
#

#T=ncurses_standout - int ncurses_standout ( void )
(PHP 4 >= 4.1.0)
ncurses_standout -- Start using 'standout' attribute 
Description
int ncurses_standout ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_standendUpncurses_start_color
#

#T=int ncurses_standout ( void )
ncurses_standout ( ^!void );
#

#T=ncurses_start_color - int ncurses_start_color ( void )
(PHP 4 >= 4.1.0)
ncurses_start_color -- Start using colors 
Description
int ncurses_start_color ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_standoutUpncurses_termattrs
#

#T=int ncurses_start_color ( void )
ncurses_start_color ( ^!void );
#

#T=ncurses_termattrs - bool ncurses_termattrs ( void )
(PHP 4 >= 4.1.0)
ncurses_termattrs -- Returns a logical OR of all attribute flags supported 
by terminal 
Description
bool ncurses_termattrs ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_start_colorUpncurses_termname
#

#T=bool ncurses_termattrs ( void )
ncurses_termattrs ( ^!void );
#

#T=ncurses_termname - string ncurses_termname ( void )
(PHP 4 >= 4.2.0)
ncurses_termname -- Returns terminals (short)-name
Description
string ncurses_termname ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_termname() returns terminals shortname. The shortname is truncated 
to 14 characters. On error ncurses_termname() returns NULL. 
See also: ncurses_longname()   ncurses_termattrsUpncurses_timeout
#

#T=string ncurses_termname ( void )
ncurses_termname ( ^!void );
#

#T=ncurses_timeout - void ncurses_timeout ( int millisec)
(PHP 4 >= 4.1.0)
ncurses_timeout -- Set timeout for special key sequences 
Description
void ncurses_timeout ( int millisec)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_termnameUpncurses_top_panel
#

#T=void ncurses_timeout ( int millisec)
ncurses_timeout ( ^!int millisec);
#

#T=ncurses_top_panel - int ncurses_top_panel ( resource panel)
(PHP 4 >= 4.3.0)
ncurses_top_panel --  Moves a visible panel to the top of the stack 
Description
int ncurses_top_panel ( resource panel)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_timeoutUpncurses_typeahead
#

#T=int ncurses_top_panel ( resource panel)
ncurses_top_panel ( ^!resource panel);
#

#T=ncurses_typeahead - int ncurses_typeahead ( int fd)
(PHP 4 >= 4.1.0)
ncurses_typeahead -- Specify different filedescriptor for typeahead 
checking 
Description
int ncurses_typeahead ( int fd)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_top_panelUpncurses_ungetch
#

#T=int ncurses_typeahead ( int fd)
ncurses_typeahead ( ^!int fd);
#

#T=ncurses_ungetch - int ncurses_ungetch ( int keycode)
(PHP 4 >= 4.1.0)
ncurses_ungetch -- Put a character back into the input stream 
Description
int ncurses_ungetch ( int keycode)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_typeaheadUpncurses_ungetmouse
#

#T=int ncurses_ungetch ( int keycode)
ncurses_ungetch ( ^!int keycode);
#

#T=ncurses_ungetmouse - bool ncurses_ungetmouse ( array mevent)
(PHP 4 >= 4.2.0)
ncurses_ungetmouse -- Pushes mouse event to queue
Description
bool ncurses_ungetmouse ( array mevent)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

ncurses_getmouse() pushes a KEY_MOUSE event onto the unput queue and 
associates with this event the given state sata and screen-relative 
character cell coordinates, specified in mevent. Event options will be 
specified in associative array mevent: 
"id" : Id to distinguish multiple devices
"x" : screen relative x-position in character cells
"y" : screen relative y-position in character cells
"z" : currently not supported
"mmask" : Mouse action
ncurses_ungetmouse() returns FALSE on success, otherwise TRUE. 
See also: ncurses_getmouse()   ncurses_ungetchUpncurses_update_panels
#

#T=bool ncurses_ungetmouse ( array mevent)
ncurses_ungetmouse ( ^!array mevent);
#

#T=ncurses_update_panels - void ncurses_update_panels ( void )
(PHP 4 >= 4.3.0)
ncurses_update_panels --  Refreshes the virtual screen to reflect the 
relations between panels in the stack. 
Description
void ncurses_update_panels ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_ungetmouseUpncurses_use_default_colors
#

#T=void ncurses_update_panels ( void )
ncurses_update_panels ( ^!void );
#

#T=ncurses_use_default_colors - bool ncurses_use_default_colors ( void )
(PHP 4 >= 4.1.0)
ncurses_use_default_colors -- Assign terminal default colors to color id 
-1 
Description
bool ncurses_use_default_colors ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_update_panelsUpncurses_use_env
#

#T=bool ncurses_use_default_colors ( void )
ncurses_use_default_colors ( ^!void );
#

#T=ncurses_use_env - void ncurses_use_env ( bool flag)
(PHP 4 >= 4.1.0)
ncurses_use_env -- Control use of environment information about terminal 
size 
Description
void ncurses_use_env ( bool flag)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_use_default_colorsUpncurses_use_extended_names
#

#T=void ncurses_use_env ( bool flag)
ncurses_use_env ( ^!bool flag);
#

#T=ncurses_use_extended_names - Description
(PHP 4 >= 4.1.0)
ncurses_use_extended_names -- Control use of extended names in terminfo 
descriptions 
Description
int ncurses_use_extended_names ( bool flag)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_use_envUpncurses_vidattr
#

#T=
ncurses_use_extended_names -- C

-- C^!;
#

#T=ncurses_vidattr - int ncurses_vidattr ( int intarg)
(PHP 4 >= 4.1.0)
ncurses_vidattr -- 
Description
int ncurses_vidattr ( int intarg)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_use_extended_namesUpncurses_vline
#

#T=int ncurses_vidattr ( int intarg)
ncurses_vidattr ( ^!int intarg);
#

#T=ncurses_vline - int ncurses_vline ( int charattr, int n)
(PHP 4 >= 4.2.0)
ncurses_vline -- Draw a vertical line at current position using an 
attributed character and max. n characters long 
Description
int ncurses_vline ( int charattr, int n)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_vidattrUpncurses_waddch
#

#T=int ncurses_vline ( int charattr, int n)
ncurses_vline ( ^!int charattr, int n);
#

#T=ncurses_waddch - int ncurses_waddch ( resource window, int ch)
(PHP 4 >= 4.3.0)
ncurses_waddch --  Adds character at current position in a window and 
advance cursor 
Description
int ncurses_waddch ( resource window, int ch)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_vlineUpncurses_waddstr
#

#T=int ncurses_waddch ( resource window, int ch)
ncurses_waddch ( ^!resource window, int ch);
#

#T=ncurses_waddstr - int ncurses_waddstr ( resource window, string str [, int n])
(PHP 4 >= 4.2.0)
ncurses_waddstr --  Outputs text at current postion in window 
Description
int ncurses_waddstr ( resource window, string str [, int n])
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_waddchUpncurses_wattroff
#

#T=int ncurses_waddstr ( resource window, string str [, int n])
ncurses_waddstr ( ^!resource window, string str [, int n]);
#

#T=ncurses_wattroff - int ncurses_wattroff ( resource window, int attrs)
(PHP 4 >= 4.3.0)
ncurses_wattroff --  Turns off attributes for a window 
Description
int ncurses_wattroff ( resource window, int attrs)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_waddstrUpncurses_wattron
#

#T=int ncurses_wattroff ( resource window, int attrs)
ncurses_wattroff ( ^!resource window, int attrs);
#

#T=ncurses_wattron - int ncurses_wattron ( resource window, int attrs)
(PHP 4 >= 4.3.0)
ncurses_wattron --  Turns on attributes for a window 
Description
int ncurses_wattron ( resource window, int attrs)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wattroffUpncurses_wattrset
#

#T=int ncurses_wattron ( resource window, int attrs)
ncurses_wattron ( ^!resource window, int attrs);
#

#T=ncurses_wattrset - int ncurses_wattrset ( resource window, int attrs)
(PHP 4 >= 4.3.0)
ncurses_wattrset --  Set the attributes for a window 
Description
int ncurses_wattrset ( resource window, int attrs)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wattronUpncurses_wborder
#

#T=int ncurses_wattrset ( resource window, int attrs)
ncurses_wattrset ( ^!resource window, int attrs);
#

#T=ncurses_wborder - int ncurses_wborder ( resource window, int left, int right, int top, int 
(PHP 4 >= 4.3.0)
ncurses_wborder --  Draws a border around the window using attributed 
characters 
Description
int ncurses_wborder ( resource window, int left, int right, int top, int 
bottom, int tl_corner, int tr_corner, int bl_corner, int br_corner)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wattrsetUpncurses_wclear
#

#T=int ncurses_wborder ( resource window, int left, int right, int top, int 
ncurses_wborder ( ^!resource window, int left, int right, int top, int ;
#

#T=ncurses_wclear - int ncurses_wclear ( resource window)
(PHP 4 >= 4.2.0)
ncurses_wclear --  Clears window 
Description
int ncurses_wclear ( resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wborderUpncurses_wcolor_set
#

#T=int ncurses_wclear ( resource window)
ncurses_wclear ( ^!resource window);
#

#T=ncurses_wcolor_set - int ncurses_wcolor_set ( resource window, int color_pair)
(PHP 4 >= 4.2.0)
ncurses_wcolor_set --  Sets windows color pairings 
Description
int ncurses_wcolor_set ( resource window, int color_pair)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wclearUpncurses_werase
#

#T=int ncurses_wcolor_set ( resource window, int color_pair)
ncurses_wcolor_set ( ^!resource window, int color_pair);
#

#T=ncurses_werase - long ncurses_werase ( resource window)
(PHP 4 >= 4.3.0)
ncurses_werase --  Erase window contents 
Description
long ncurses_werase ( resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wcolor_setUpncurses_wgetch
#

#T=long ncurses_werase ( resource window)
ncurses_werase ( ^!resource window);
#

#T=ncurses_wgetch - int ncurses_wgetch ( resource window)
(PHP 4 >= 4.2.0)
ncurses_wgetch --  Reads a character from keyboard (window) 
Description
int ncurses_wgetch ( resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_weraseUpncurses_whline
#

#T=int ncurses_wgetch ( resource window)
ncurses_wgetch ( ^!resource window);
#

#T=ncurses_whline - int ncurses_whline ( resource window, int charattr, int n)
(PHP 4 >= 4.3.0)
ncurses_whline --  Draws a horizontal line in a window at current position 
using an attributed character and max. n characters long 
Description
int ncurses_whline ( resource window, int charattr, int n)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wgetchUpncurses_wmouse_trafo
#

#T=int ncurses_whline ( resource window, int charattr, int n)
ncurses_whline ( ^!resource window, int charattr, int n);
#

#T=ncurses_wmouse_trafo - bool ncurses_wmouse_trafo ( resource window, int &y, int &x, bool 
(PHP 4 >= 4.2.0)
ncurses_wmouse_trafo --  Transforms window/stdscr coordinates 
Description
bool ncurses_wmouse_trafo ( resource window, int &y, int &x, bool 
toscreen)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_whlineUpncurses_wmove
#

#T=bool ncurses_wmouse_trafo ( resource window, int &y, int &x, bool 
ncurses_wmouse_trafo ( ^!resource window, int &y, int &x, bool ;
#

#T=ncurses_wmove - int ncurses_wmove ( resource window, int y, int x)
(PHP 4 >= 4.2.0)
ncurses_wmove --  Moves windows output position 
Description
int ncurses_wmove ( resource window, int y, int x)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wmouse_trafoUpncurses_wnoutrefresh
#

#T=int ncurses_wmove ( resource window, int y, int x)
ncurses_wmove ( ^!resource window, int y, int x);
#

#T=ncurses_wnoutrefresh - int ncurses_wnoutrefresh ( resource window)
(PHP 4 >= 4.2.0)
ncurses_wnoutrefresh --  Copies window to virtual screen 
Description
int ncurses_wnoutrefresh ( resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wmoveUpncurses_wrefresh
#

#T=int ncurses_wnoutrefresh ( resource window)
ncurses_wnoutrefresh ( ^!resource window);
#

#T=ncurses_wrefresh - int ncurses_wrefresh ( resource window)
(PHP 4 >= 4.2.0)
ncurses_wrefresh -- Refresh window on terminal screen 
Description
int ncurses_wrefresh ( resource window)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wnoutrefreshUpncurses_wstandend
#

#T=int ncurses_wrefresh ( resource window)
ncurses_wrefresh ( ^!resource window);
#

#T=ncurses_wstandend - int ncurses_wstandend ( resource window)
(PHP 4 >= 4.3.0)
ncurses_wstandend --  End standout mode for a window 
Description
int ncurses_wstandend ( resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wrefreshUpncurses_wstandout
#

#T=int ncurses_wstandend ( resource window)
ncurses_wstandend ( ^!resource window);
#

#T=ncurses_wstandout - int ncurses_wstandout ( resource window)
(PHP 4 >= 4.3.0)
ncurses_wstandout --  Enter standout mode for a window 
Description
int ncurses_wstandout ( resource window)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wstandendUpncurses_wvline
#

#T=int ncurses_wstandout ( resource window)
ncurses_wstandout ( ^!resource window);
#

#T=ncurses_wvline - int ncurses_wvline ( resource window, int charattr, int n)
(PHP 4 >= 4.3.0)
ncurses_wvline --  Draws a vertical line in a window at current position 
using an attributed character and max. n characters long 
Description
int ncurses_wvline ( resource window, int charattr, int n)
Warning
This function is currently not documented; only the argument list is 
available.
  ncurses_wstandoutUpLotus Notes functions
#

#T=int ncurses_wvline ( resource window, int charattr, int n)
ncurses_wvline ( ^!resource window, int charattr, int n);
#

#T=next - mixed next ( array array)
(PHP 3, PHP 4 )
next --  Advance the internal array pointer of an array 
Description
mixed next ( array array)
Returns the array value in the next place that's pointed to by the 
internal array pointer, or FALSE if there are no more elements. 
next() behaves like current(), with one difference. It advances the 
internal array pointer one place forward before returning the element 
value. That means it returns the next array value and advances the 
internal array pointer by one. If advancing the internal array pointer 
results in going beyond the end of the element list, next() returns FALSE. 

Warning
If the array contains empty elements, or elements that have a key 
value of 0 then this function will return FALSE for these elements 
as well. To properly traverse an array which may contain empty 
elements or elements with key values of 0 see the each() function. 

Example 1. Example use of next() and friends
  <?php
  $transport = array('foot', 'bike', 'car', 'plane');
  $mode = current($transport); // $mode = 'foot';
  $mode = next($transport);    // $mode = 'bike';
  $mode = next($transport);    // $mode = 'car';
  $mode = prev($transport);    // $mode = 'bike';
  $mode = end($transport);     // $mode = 'plane';
  ?> 
See also current(), end(), prev(), and reset().   natsortUppos
#

#T=mixed next ( array array)
next ( ^!array array);
#

#T=ngettext - string ngettext ( string msgid1, string msgid2, int n)
(PHP 4 >= 4.2.0)
ngettext -- Plural version of gettext
Description
string ngettext ( string msgid1, string msgid2, int n)
Warning
This function is currently not documented; only the argument list is 
available.
  gettextUptextdomain
#

#T=string ngettext ( string msgid1, string msgid2, int n)
ngettext ( ^!string msgid1, string msgid2, int n);
#

#T=nl_langinfo - string nl_langinfo ( int item)
(PHP 4 >= 4.1.0)
nl_langinfo --  Query language and locale information 
Description
string nl_langinfo ( int item)
Warning
This function is currently not documented; only the argument list is 
available.
  money_formatUpnl2br
#

#T=string nl_langinfo ( int item)
nl_langinfo ( ^!int item);
#

#T=nl2br - string nl2br ( string string)
(PHP 3, PHP 4 )
nl2br --  Inserts HTML line breaks before all newlines in a string 
Description
string nl2br ( string string)
Returns string with '<br />' inserted before all newlines. 
Note: Starting with PHP 4.0.5, nl2br() is now XHTML compliant. All 
versions before 4.0.5 will return string with '<br>' inserted before 
newlines instead of '<br />'. 
Example 1. using nl2br()
  <?php
  echo nl2br("foo isn't\n bar");
  ?> 

this will output : 
foo isn't<br />
bar
See also htmlspecialchars(), htmlentities(), wordwrap(), and 
str_replace().   nl_langinfoUpnumber_format
#

#T=string nl2br ( string string)
nl2br ( ^!string string);
#

#T=notes_body - array notes_body ( string server, string mailbox, int msg_number)
(PHP 4 >= 4.0.5)
notes_body -- Open the message msg_number in the specified mailbox on the 
specified server (leave serv
Description
array notes_body ( string server, string mailbox, int msg_number)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  Lotus Notes functionsUpnotes_copy_db
#

#T=array notes_body ( string server, string mailbox, int msg_number)
notes_body ( ^!string server, string mailbox, int msg_number);
#

#T=notes_copy_db - string notes_copy_db ( string from_database_name, string to_database_name)
(PHP 4 >= 4.0.5)
notes_copy_db -- Create a note using form form_name 
Description
string notes_copy_db ( string from_database_name, string to_database_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_bodyUpnotes_create_db
#

#T=string notes_copy_db ( string from_database_name, string to_database_name)
notes_copy_db ( ^!string from_database_name, string to_database_name);
#

#T=notes_create_db - bool notes_create_db ( string database_name)
(PHP 4 >= 4.0.5)
notes_create_db -- Create a Lotus Notes database 
Description
bool notes_create_db ( string database_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_copy_dbUpnotes_create_note
#

#T=bool notes_create_db ( string database_name)
notes_create_db ( ^!string database_name);
#

#T=notes_create_note - string notes_create_note ( string database_name, string form_name)
(PHP 4 >= 4.0.5)
notes_create_note -- Create a note using form form_name 
Description
string notes_create_note ( string database_name, string form_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_create_dbUpnotes_drop_db
#

#T=string notes_create_note ( string database_name, string form_name)
notes_create_note ( ^!string database_name, string form_name);
#

#T=notes_drop_db - bool notes_drop_db ( string database_name)
(PHP 4 >= 4.0.5)
notes_drop_db -- Drop a Lotus Notes database 
Description
bool notes_drop_db ( string database_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_create_noteUpnotes_find_note
#

#T=bool notes_drop_db ( string database_name)
notes_drop_db ( ^!string database_name);
#

#T=notes_find_note - bool notes_find_note ( string database_name, string name [, string type])
(PHP 4 >= 4.0.5)
notes_find_note -- Returns a note id found in database_name. Specify the 
name of the note. Leaving type bla
Description
bool notes_find_note ( string database_name, string name [, string type])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_drop_dbUpnotes_header_info
#

#T=bool notes_find_note ( string database_name, string name [, string type])
notes_find_note ( ^!string database_name, string name [, string type]);
#

#T=notes_header_info - object notes_header_info ( string server, string mailbox, int msg_number)
(PHP 4 >= 4.0.5)
notes_header_info -- Open the message msg_number in the specified mailbox 
on the specified server (leave serv
Description
object notes_header_info ( string server, string mailbox, int msg_number)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_find_noteUpnotes_list_msgs
#

#T=object notes_header_info ( string server, string mailbox, int msg_number)
notes_header_info ( ^!string server, string mailbox, int msg_number);
#

#T=notes_list_msgs - bool notes_list_msgs ( string db)
(PHP 4 >= 4.0.5)
notes_list_msgs -- Returns the notes from a selected database_name
Description
bool notes_list_msgs ( string db)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_header_infoUpnotes_mark_read
#

#T=bool notes_list_msgs ( string db)
notes_list_msgs ( ^!string db);
#

#T=notes_mark_read - string notes_mark_read ( string database_name, string user_name, string 
(PHP 4 >= 4.0.5)
notes_mark_read -- Mark a note_id as read for the User user_name
Description
string notes_mark_read ( string database_name, string user_name, string 
note_id)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_list_msgsUpnotes_mark_unread
#

#T=string notes_mark_read ( string database_name, string user_name, string 
notes_mark_read ( ^!string database_name, string user_name, string ;
#

#T=notes_mark_unread - string notes_mark_unread ( string database_name, string user_name, string 
(PHP 4 >= 4.0.5)
notes_mark_unread -- Mark a note_id as unread for the User user_name
Description
string notes_mark_unread ( string database_name, string user_name, string 
note_id)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_mark_readUpnotes_nav_create
#

#T=string notes_mark_unread ( string database_name, string user_name, string 
notes_mark_unread ( ^!string database_name, string user_name, string ;
#

#T=notes_nav_create - bool notes_nav_create ( string database_name, string name)
(PHP 4 >= 4.0.5)
notes_nav_create -- Create a navigator name, in database_name 
Description
bool notes_nav_create ( string database_name, string name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_mark_unreadUpnotes_search
#

#T=bool notes_nav_create ( string database_name, string name)
notes_nav_create ( ^!string database_name, string name);
#

#T=notes_search - string notes_search ( string database_name, string keywords)
(PHP 4 >= 4.0.5)
notes_search -- Find notes that match keywords in database_name
Description
string notes_search ( string database_name, string keywords)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_nav_createUpnotes_unread
#

#T=string notes_search ( string database_name, string keywords)
notes_search ( ^!string database_name, string keywords);
#

#T=notes_unread - string notes_unread ( string database_name, string user_name)
(PHP 4 >= 4.0.5)
notes_unread -- Returns the unread note id's for the current User 
user_name
Description
string notes_unread ( string database_name, string user_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_searchUpnotes_version
#

#T=string notes_unread ( string database_name, string user_name)
notes_unread ( ^!string database_name, string user_name);
#

#T=notes_version - string notes_version ( string database_name)
(PHP 4 >= 4.0.5)
notes_version -- Get the version Lotus Notes 
Description
string notes_version ( string database_name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  notes_unreadUpNSAPI-specific Functions
nsapi_request_headers
(no version information, might be only in CVS)
nsapi_request_headers -- Fetch all HTTP request headers
Description
array nsapi_request_headers ( void )
nsapi_request_headers() returns an associative array of all the HTTP 
headers in the current request. This is only supported when PHP runs as a 
NSAPI module. 
Example 1. nsapi_request_headers() example
  <?php
  $headers = nsapi_request_headers();

  foreach ($headers as $header => $value) {
      echo "$header: $value <br />\n";
  }
  ?> 
Note: Prior to PHP 4.3.3, getallheaders() was only available for the 
Apache servers. After PHP 4.3.3, getallheaders() is an alias for 
nsapi_request_headers() if you use the NSAPI module. 
Note: You can also get at the value of the common CGI variables by 
reading them from the $_SERVER superglobal, which works whether or not 
you are using PHP as a NSAPI module.   NSAPI-specific FunctionsUpnsapi_response_headers
nsapi_response_headers
(no version information, might be only in CVS)
nsapi_response_headers --  Fetch all HTTP response headers 
Description
array nsapi_response_headers ( void )
Returns an array of all NSAPI response headers. This functionality is only 
available in PHP version 4.3.3 and greater. 
See also nsapi_request_headers() and headers_sent().   nsapi_request_headersUpnsapi_virtual
nsapi_virtual
(no version information, might be only in CVS)
nsapi_virtual -- Perform an NSAPI sub-request
Description
int nsapi_virtual ( string uri)
nsapi_virtual() is an NSAPI-specific function which is equivalent to 
<!--#include virtual...--> in SSI (.shtml files). It does an NSAPI 
sub-request. It is useful for including CGI scripts or .shtml files, or 
anything else that you'd parse through webserver. 
To run the sub-request, all buffers are terminated and flushed to the 
browser, pending headers are sent too. 
You cannot make recursive requests with this function to other PHP 
scripts. If you want to include PHP scripts, use include() or require(). 
Note: This function depends on a undocumented feature of the 
Netscape/iPlanet/SunONE webservers. Use phpinfo() to determine if it is 
available. In the Unix environment it should always work, in windows it 
depends on the name of a ns-httpdXX.dll file. Read the note about 
subrequests in the install section if you experience this problem.   nsapi_response_headersUpUnified ODBC functions
#

#T=string notes_version ( string database_name)
notes_version ( ^!string database_name);
#

#T=number_format - string number_format ( float number [, int decimals])
(PHP 3, PHP 4 )
number_format -- Format a number with grouped thousands
Description
string number_format ( float number [, int decimals])

string number_format ( float number, int decimals, string dec_point, 
string thousands_sep)
number_format() returns a formatted version of number. This function 
accepts either one, two or four parameters (not three): 
If only one parameter is given, number will be formatted without decimals, 
but with a comma (",") between every group of thousands. 
If two parameters are given, number will be formatted with decimals 
decimals with a dot (".") in front, and a comma (",") between every group 
of thousands. 
If all four parameters are given, number will be formatted with decimals 
decimals, dec_point instead of a dot (".") before the decimals and 
thousands_sep instead of a comma (",") between every group of thousands. 
Only the first character of thousands_sep is used. For example, if you use 
foo as thousands_sep on the number 1000, number_format() will return 
1f000. 
Example 1. number_format() Example
For instance, French notation usually use two decimals, comma (',') 
as decimal separator, and space (' ') as thousand separator. This is 
achieved with this line : 
  <?php

  $number = 1234.56;

  // english notation (default)
  $english_format_number = number_format($number);
  // 1,234

  // French notation
  $nombre_format_francais = number_format($number, 2, ',', ' ');
  // 1 234,56

  $number = 1234.5678;

  // english notation without thousands seperator
  $english_format_number = number_format($number, 2, '.', '');
  // 1234.57

  ?> 
See also: sprintf(), printf() and sscanf().   nl2brUpord
#

#T=string number_format ( float number [, int decimals])
number_format ( ^!float number [, int decimals]);
#

#T=ob_clean - void ob_clean ( void )
(PHP 4 >= 4.2.0)
ob_clean --  Clean (erase) the output buffer 
Description
void ob_clean ( void )
This function discards the contents of the output buffer. 
This function does not destroy the output buffer like ob_end_clean() does. 

See also ob_flush(), ob_end_flush() and ob_end_clean().   flushUpob_end_clean
#

#T=void ob_clean ( void )
ob_clean ( ^!void );
#

#T=ob_end_clean - bool ob_end_clean ( void )
(PHP 4 )
ob_end_clean --  Clean (erase) the output buffer and turn off output 
buffering 
Description
bool ob_end_clean ( void )
This function discards the contents of the topmost output buffer and turns 
off this output buffering. If you want to further process the buffer's 
contents you have to call ob_get_contents() before ob_end_clean() as the 
buffer contents are discarded when ob_end_flush() is called. The function 
returns TRUE when it successfully discarded one buffer and FALSE 
otherwise. Reasons for failure are first that you called the function 
without an active buffer or that for some reason a buffer could not be 
deleted (possible for special buffer). 
The following example shows an easy way to get rid of all output buffers: 
Example 1. ob_end_clean() example
  <?php
  while (@ob_end_clean());
  ?> 
Note: If the function fails it generates an E_NOTICE. 
The boolean return value was added in PHP 4.2.0. 
See also ob_start(), ob_get_contents(), and ob_flush().   ob_cleanUpob_end_flush
#

#T=bool ob_end_clean ( void )
ob_end_clean ( ^!void );
#

#T=ob_end_flush - bool ob_end_flush ( void )
(PHP 4 )
ob_end_flush --  Flush (send) the output buffer and turn off output 
buffering 
Description
bool ob_end_flush ( void )
This function will send the contents of the topmost output buffer (if any) 
and turn this output buffer off. If you want to further process the 
buffer's contents you have to call ob_get_contents() before ob_end_flush() 
as the buffer contents are discarded after ob_end_flush() is called. The 
function returns TRUE when it successfully discarded one buffer and FALSE 
otherwise. Reasons for failure are first that you called the function 
without an active buffer or that for some reason a buffer could not be 
deleted (possible for special buffer). 
Note: This function is similar to ob_get_flush(), except that 
ob_get_flush() returns the buffer as a string. 
The following example shows an easy way to flush and end all output 
buffers: 
Example 1. ob_end_flush() example
  <?php
    while (@ob_end_flush());
  ?> 
Note: If the function fails it generates an E_NOTICE. 
The boolean return value was added in PHP 4.2.0. 
See also ob_start(), ob_get_contents(), ob_get_flush(), ob_flush() and 
ob_end_clean().   ob_end_cleanUpob_flush
#

#T=bool ob_end_flush ( void )
ob_end_flush ( ^!void );
#

#T=ob_flush - void ob_flush ( void )
(PHP 4 >= 4.2.0)
ob_flush --  Flush (send) the output buffer 
Description
void ob_flush ( void )
This function will send the contents of the output buffer (if any). If you 
want to further process the buffer's contents you have to call 
ob_get_contents() before ob_flush() as the buffer contents are discarded 
after ob_flush() is called. 
This function does not destroy the output buffer like ob_end_flush() does. 

See also ob_get_contents(), ob_clean(), ob_end_flush() and ob_end_clean(). 
  ob_end_flushUpob_get_clean
#

#T=void ob_flush ( void )
ob_flush ( ^!void );
#

#T=ob_get_clean - string ob_get_clean ( void )
(PHP 4 >= 4.3.0)
ob_get_clean --  Get current buffer contents and delete current output 
buffer 
Description
string ob_get_clean ( void )
This will return the contents of the output buffer and end output 
buffering. If output buffering isn't active then FALSE is returned. 
ob_get_clean() essentially executes both ob_get_contents() and 
ob_end_clean(). 
Example 1. A simple ob_get_clean() example
  <?php

  ob_start();

  echo "Hello World";

  $out = ob_get_clean();
  $out = strtolower($out);

  var_dump($out);
  ?> 

Our example will output: 
string(11) "hello world"
See also ob_start() and ob_get_contents().   ob_flushUpob_get_contents
#

#T=string ob_get_clean ( void )
ob_get_clean ( ^!void );
#

#T=ob_get_contents - string ob_get_contents ( void )
(PHP 4 )
ob_get_contents --  Return the contents of the output buffer 
Description
string ob_get_contents ( void )
This will return the contents of the output buffer or FALSE, if output 
buffering isn't active. 
See also ob_start() and ob_get_length().   ob_get_cleanUpob_get_flush
#

#T=string ob_get_contents ( void )
ob_get_contents ( ^!void );
#

#T=ob_get_flush - string ob_get_flush ( void )
(PHP 4 >= 4.3.0)
ob_get_flush --  Flush the output buffer, return it as a string and turn 
off output buffering 
Description
string ob_get_flush ( void )
ob_get_flush() flushs the output buffer, return it as a string and turns 
off output buffering. ob_get_flush() returns FALSE if no buffering is 
active. 
Note: This function is similar to ob_end_flush(), except that this 
function returns the buffer as a string. 
Example 1. ob_get_flush() example
  <?php
  //using output_buffering=On
  print_r(ob_list_handlers());

  //save buffer in a file
  $buffer = ob_get_flush();
  file_put_contents('buffer.txt', $buffer);

  print_r(ob_list_handlers());
  ?> 

The above example will output: 
Array
(
[0] => default output handler
)
Array
(
)
See also ob_end_clean(), ob_end_flush() and ob_list_handlers().   ob_get_contentsUpob_get_length
#

#T=string ob_get_flush ( void )
ob_get_flush ( ^!void );
#

#T=ob_get_length - int ob_get_length ( void )
(PHP 4 >= 4.0.2)
ob_get_length --  Return the length of the output buffer 
Description
int ob_get_length ( void )
This will return the length of the contents in the output buffer or FALSE, 
if output buffering isn't active. 
See also ob_start() and ob_get_contents().   ob_get_flushUpob_get_level
#

#T=int ob_get_length ( void )
ob_get_length ( ^!void );
#

#T=ob_get_level - int ob_get_level ( void )
(PHP 4 >= 4.2.0)
ob_get_level --  Return the nesting level of the output buffering 
mechanism 
Description
int ob_get_level ( void )
This will return the level of nested output buffering handlers. 
See also ob_start() and ob_get_contents().   ob_get_lengthUpob_get_status
#

#T=int ob_get_level ( void )
ob_get_level ( ^!void );
#

#T=ob_get_status - array ob_get_status ( [bool full_status])
(PHP 4 >= 4.2.0)
ob_get_status --  Get status of output buffers 
Description
array ob_get_status ( [bool full_status])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This will return the current status of output buffers. It returns array 
contains buffer status or FALSE for error. 
See also ob_get_level().   ob_get_levelUpob_gzhandler
#

#T=array ob_get_status ( [bool full_status])
ob_get_status ( ^![bool full_status]);
#

#T=ob_gzhandler - string ob_gzhandler ( string buffer [, int mode])
(PHP 4 >= 4.0.4)
ob_gzhandler --  ob_start callback function to gzip output buffer 
Description
string ob_gzhandler ( string buffer [, int mode])
Note: mode was added in PHP 4.0.5. 
ob_gzhandler() is intended to be used as a callback function for 
ob_start() to help facilitate sending gz-encoded data to web browsers that 
support compressed web pages. Before ob_gzhandler() actually sends 
compressed data, it determines what type of content encoding the browser 
will accept ("gzip", "deflate" or none at all) and will return it's output 
accordingly. All browsers are supported since it's up to the browser to 
send the correct header saying that it accepts compressed web pages. 
Example 1. ob_gzhandler() Example
  <?php

  ob_start("ob_gzhandler");

  ?>
  <html>
  <body>
  <p>This should be a compressed page.
  </html>
  <body> 
See also ob_start() and ob_end_flush(). 
Note: You cannot use both ob_gzhandler() and 
ini.zlib.output_compression. Also note that using 
ini.zlib.output_compression is preferred over ob_gzhandler().   ob_get_statusUpob_implicit_flush
#

#T=string ob_gzhandler ( string buffer [, int mode])
ob_gzhandler ( ^!string buffer [, int mode]);
#

#T=ob_iconv_handler - array ob_iconv_handler ( string contents, int status)
(PHP 4 >= 4.0.5)
ob_iconv_handler -- Convert character encoding as output buffer handler
Description
array ob_iconv_handler ( string contents, int status)
It converts the string encoded in internal_encoding to output_encoding. 
internal_encoding and output_encoding should be defined by 
iconv_set_encoding() or in the configuration file php.ini. 
Example 1. ob_iconv_handler() example:
  <?php
  ob_start("ob_iconv_handler"); // start output buffering
  ?> 
See also iconv_get_encoding(), iconv_set_encoding() and output-control 
functions.   iconvUpImage functions
#

#T=array ob_iconv_handler ( string contents, int status)
ob_iconv_handler ( ^!string contents, int status);
#

#T=ob_implicit_flush - void ob_implicit_flush ( [int flag])
(PHP 4 )
ob_implicit_flush --  Turn implicit flush on/off 
Description
void ob_implicit_flush ( [int flag])
ob_implicit_flush() will turn implicit flushing on or off (if no flag is 
given, it defaults to on). Implicit flushing will result in a flush 
operation after every output call, so that explicit calls to flush() will 
no longer be needed. 
Turning implicit flushing on will disable output buffering, the output 
buffers current output will be sent as if ob_end_flush() had been called. 
See also flush(), ob_start(), and ob_end_flush().   ob_gzhandlerUpob_list_handlers
#

#T=void ob_implicit_flush ( [int flag])
ob_implicit_flush ( ^![int flag]);
#

#T=ob_list_handlers - array ob_list_handlers ( void )
(PHP 4 >= 4.3.0)
ob_list_handlers --  List all output handlers in use 
Description
array ob_list_handlers ( void )
This will return an array with the output handlers in use (if any). If 
output_buffering is enabled, ob_list_handlers() will return "default 
output handler". 
Example 1. ob_list_handlers() example
  <?php
  //using output_buffering=On
  print_r(ob_list_handlers());
  ob_end_flush();

  ob_start("ob_gzhandler");
  print_r(ob_list_handlers());
  ob_end_flush();
  ?> 

The above example will output: 
Array
(
[0] => default output handler
)
Array
(
[0] => ob_gzhandler
)
See also ob_end_clean(), ob_end_flush(), ob_get_flush(), and ob_start().   ob_implicit_flushUpob_start
#

#T=array ob_list_handlers ( void )
ob_list_handlers ( ^!void );
#

#T=ob_start - bool ob_start ( [callback output_callback])
(PHP 4 )
ob_start -- Turn on output buffering
Description
bool ob_start ( [callback output_callback])
This function will turn output buffering on. While output buffering is 
active no output is sent from the script (other than headers), instead the 
output is stored in an internal buffer. 
The contents of this internal buffer may be copied into a string variable 
using ob_get_contents(). To output what is stored in the internal buffer, 
use ob_end_flush(). Alternatively, ob_end_clean() will silently discard 
the buffer contents. 
An optional output_callback function may be specified. This function takes 
a string as a parameter and should return a string. The function will be 
called when ob_end_flush() is called, or when the output buffer is flushed 
to the browser at the end of the request. When output_callback is called, 
it will receive the contents of the output buffer as its parameter and is 
expected to return a new output buffer as a result, which will be sent to 
the browser. If the output_callback is not a callable function, this 
function will return FALSE. 
Note: In PHP 4.0.4, ob_gzhandler() was introduced to facilitate sending 
gz-encoded data to web browsers that support compressed web pages. 
ob_gzhandler() determines what type of content encoding the browser will 
accept and will return it's output accordingly. 
Note: Before PHP 4.3.2 this function did not return FALSE in case the 
passed output_callback can not be executed. 
Output buffers are stackable, that is, you may call ob_start() while 
another ob_start() is active. Just make sure that you call ob_end_flush() 
the appropriate number of times. If multiple output callback functions are 
active, output is being filtered sequentially through each of them in 
nesting order. 
ob_end_clean(), ob_end_flush(), ob_clean(), ob_flush() and ob_start() may 
not be called from a callback function. If you call them from callback 
function, the behavior is undefined. If you would like to delete the 
contents of a buffer, return "" (a null string) from callback function. 
Example 1. User defined callback function example
  <?php

  function callback($buffer) {
    // replace all the apples with oranges
    return (str_replace("apples", "oranges", $buffer));
  }

  ob_start("callback");

  ?>

  <html>
  <body>
  <p>It's like comparing apples to oranges.
  </body>
  </html>

  <?php

  ob_end_flush();

  ?> 

Would produce: 
<html>
<body>
<p>It's like comparing oranges to oranges.
</body>
</html>
See also ob_get_contents(), ob_end_flush(), ob_end_clean(), 
ob_implicit_flush() and ob_gzhandler().   ob_list_handlersUpObject property and method call overloading
#

#T=bool ob_start ( [callback output_callback])
ob_start ( ^![callback output_callback]);
#

#T=ocibindbyname - bool ocibindbyname ( resource stmt, string ph_name, mixed &variable [, int 
(PHP 3>= 3.0.4, PHP 4 )
ocibindbyname --  Bind a PHP variable to an Oracle Placeholder 
Description
bool ocibindbyname ( resource stmt, string ph_name, mixed &variable [, int 
maxlength [, int type]])
ocibindbyname() binds the PHP variable variable to the Oracle placeholder 
ph_name. Whether it will be used for input or output will be determined 
run-time, and the necessary storage space will be allocated. The length 
parameter sets the maximum length for the bind. If you set length to -1 
ocibindbyname() will use the current length of variable to set the maximum 
length. 
If you need to bind an abstract Datatype (LOB/ROWID/BFILE) you need to 
allocate it first using ocinewdescriptor() function. The length is not 
used for abstract Datatypes and should be set to -1. The type variable 
tells oracle, what kind of descriptor we want to use. Possible values are: 
OCI_B_FILE (Binary-File), OCI_B_CFILE (Character-File), OCI_B_CLOB 
(Character-LOB), OCI_B_BLOB (Binary-LOB) and OCI_B_ROWID (ROWID). 
Example 1. ocibindbyname() example
  <?php
  /* OCIBindByPos example thies at thieso dot net (980221)
    inserts 3 records into emp, and uses the ROWID for updating 
  the 
    records just after the insert.
  */

  $conn = OCILogon("scott", "tiger");

  $stmt = OCIParse($conn, "insert into emp (empno, ename) " .
			 "values (:empno,:ename) " .
			 "returning ROWID into :rid");

  $data = array(1111 => "Larry", 2222 => "Bill", 3333 => "Jim");

  $rowid = OCINewDescriptor($conn, OCI_D_ROWID);

  OCIBindByName($stmt, ":empno", $empno, 32);
  OCIBindByName($stmt, ":ename", $ename, 32);
  OCIBindByName($stmt, ":rid", $rowid, -1, OCI_B_ROWID);

  $update = OCIParse($conn, "update emp set sal = :sal where 
  ROWID = :rid");
  OCIBindByName($update, ":rid", $rowid, -1, OCI_B_ROWID);
  OCIBindByName($update, ":sal", $sal, 32);

  $sal = 10000;

  while (list($empno, $ename) = each($data)) {
      OCIExecute($stmt);
      OCIExecute($update);
  } 

  $rowid->free();

  OCIFreeStatement($update);
  OCIFreeStatement($stmt);

  $stmt = OCIParse($conn, "select * from emp where empno in 
  (1111,2222,3333)");
  OCIExecute($stmt);
  while (OCIFetchInto($stmt, &$arr, OCI_ASSOC)) {
      var_dump($arr);
  }
  OCIFreeStatement($stmt);

  /* delete our "junk" from the emp table.... */
  $stmt = OCIParse($conn, "delete from emp where empno in 
  (1111,2222,3333)");
  OCIExecute($stmt);
  OCIFreeStatement($stmt);

  OCILogoff($conn);
  ?> 
Warning
It is a bad idea to use magic quotes and ocibindbyname() 
simultaneously as no quoting is needed on quoted variables and any 
quotes magically applied will be written into your database as 
ocibindbyname() is not able to distinguish magically added quotings 
from those added by intention. 
  Oracle 8 functionsUpocicancel
#

#T=bool ocibindbyname ( resource stmt, string ph_name, mixed &variable [, int 
ocibindbyname ( ^!resource stmt, string ph_name, mixed &variable [, int ;
#

#T=ocicancel - bool ocicancel ( resource stmt)
(PHP 3>= 3.0.8, PHP 4 )
ocicancel -- Cancel reading from cursor
Description
bool ocicancel ( resource stmt)
If you do not want read more data from a cursor, then call ocicancel().   ocibindbynameUpocicloselob
ocicloselob
(no version information, might be only in CVS)
ocicloselob -- Closes lob descriptor
Description
bool ocicloselob ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ocicancelUpocicollappend
#

#T=bool ocicancel ( resource stmt)
ocicancel ( ^!resource stmt);
#

#T=ocicollappend - bool ocicollappend ( string value)
(PHP 4 >= 4.0.6)
ocicollappend -- Append an object to the collection
Description
bool ocicollappend ( string value)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicloselobUpocicollassign
#

#T=bool ocicollappend ( string value)
ocicollappend ( ^!string value);
#

#T=ocicollassign - bool ocicollassign ( object from)
(PHP 4 >= 4.0.6)
ocicollassign -- Assign a collection from another existing collection
Description
bool ocicollassign ( object from)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicollappendUpocicollassignelem
#

#T=bool ocicollassign ( object from)
ocicollassign ( ^!object from);
#

#T=ocicollassignelem - bool ocicollassignelem ( int ndx, string val)
(PHP 4 >= 4.0.6)
ocicollassignelem -- Assign element val to collection at index ndx
Description
bool ocicollassignelem ( int ndx, string val)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicollassignUpocicollgetelem
#

#T=bool ocicollassignelem ( int ndx, string val)
ocicollassignelem ( ^!int ndx, string val);
#

#T=ocicollgetelem - string ocicollgetelem ( int ndx)
(PHP 4 >= 4.0.6)
ocicollgetelem -- Retrieve the value at collection index ndx
Description
string ocicollgetelem ( int ndx)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicollassignelemUpocicollmax
#

#T=string ocicollgetelem ( int ndx)
ocicollgetelem ( ^!int ndx);
#

#T=ocicollmax - int ocicollmax ( void )
(PHP 4 >= 4.0.6)
ocicollmax --  Return the max value of a collection. For a varray this is 
the maximum length of the array 
Description
int ocicollmax ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ocicollgetelemUpocicollsize
#

#T=int ocicollmax ( void )
ocicollmax ( ^!void );
#

#T=ocicollsize - int ocicollsize ( void )
(PHP 4 >= 4.0.6)
ocicollsize -- Return the size of a collection
Description
int ocicollsize ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ocicollmaxUpocicolltrim
#

#T=int ocicollsize ( void )
ocicollsize ( ^!void );
#

#T=ocicolltrim - bool ocicolltrim ( int num)
(PHP 4 >= 4.0.6)
ocicolltrim -- Trim num elements from the end of a collection
Description
bool ocicolltrim ( int num)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicollsizeUpocicolumnisnull
#

#T=bool ocicolltrim ( int num)
ocicolltrim ( ^!int num);
#

#T=ocicolumnisnull - bool ocicolumnisnull ( resource stmt, mixed col)
(PHP 3>= 3.0.4, PHP 4 )
ocicolumnisnull -- Test whether a result column is NULL
Description
bool ocicolumnisnull ( resource stmt, mixed col)
ocicolumnisnull() returns TRUE if the returned column column in the result 
from the statement stmt is NULL. You can either use the column-number 
(1-Based) or the column-name, in uppercase, for the col parameter.   ocicolltrimUpocicolumnname
#

#T=bool ocicolumnisnull ( resource stmt, mixed col)
ocicolumnisnull ( ^!resource stmt, mixed col);
#

#T=ocicolumnname - string ocicolumnname ( resource stmt, int col)
(PHP 3>= 3.0.4, PHP 4 )
ocicolumnname -- Returns the name of a column
Description
string ocicolumnname ( resource stmt, int col)
ocicolumnname() returns the name of the column corresponding to the column 
number (1-based) that is passed in. 
Example 1. ocicolumnname() example
  <?php   
      $conn = OCILogon("scott", "tiger");
      $stmt = OCIParse($conn, "select * from emp");
      OCIExecute($stmt);
      echo "<table border=\"1\">";
      echo "<tr>";
      echo "<th>Name</th>";
      echo "<th>Type</th>";
      echo "<th>Length</th>";
      echo "</tr>";
      $ncols = OCINumCols($stmt);
      for ($i = 1; $i <= $ncols; $i++) {
	  $column_name  = OCIColumnName($stmt, $i);
	  $column_type  = OCIColumnType($stmt, $i);
	  $column_size  = OCIColumnSize($stmt, $i);
	  echo "<tr>";
	  echo "<td>$column_name</td>";
	  echo "<td>$column_type</td>";
	  echo "<td>$column_size</td>";
	  echo "</tr>";
      }
      echo "</table>\n"; 
      OCIFreeStatement($stmt);  
      OCILogoff($conn);   
  ?> 
See also ocinumcols(), ocicolumntype(), and ocicolumnsize().   ocicolumnisnullUpocicolumnprecision
#

#T=string ocicolumnname ( resource stmt, int col)
ocicolumnname ( ^!resource stmt, int col);
#

#T=ocicolumnprecision - int ocicolumnprecision ( resource stmt, int col)
(PHP 4 )
ocicolumnprecision -- Tell the precision of a column
Description
int ocicolumnprecision ( resource stmt, int col)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicolumnnameUpocicolumnscale
#

#T=int ocicolumnprecision ( resource stmt, int col)
ocicolumnprecision ( ^!resource stmt, int col);
#

#T=ocicolumnscale - int ocicolumnscale ( resource stmt, int col)
(PHP 4 )
ocicolumnscale -- Tell the scale of a column
Description
int ocicolumnscale ( resource stmt, int col)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicolumnprecisionUpocicolumnsize
#

#T=int ocicolumnscale ( resource stmt, int col)
ocicolumnscale ( ^!resource stmt, int col);
#

#T=ocicolumnsize - int ocicolumnsize ( resource stmt, mixed column)
(PHP 3>= 3.0.4, PHP 4 )
ocicolumnsize -- Return result column size
Description
int ocicolumnsize ( resource stmt, mixed column)
ocicolumnsize() returns the size of the column as given by Oracle. You can 
either use the column-number (1-Based) or the column-name for the column 
parameter. 
Example 1. ocicolumnsize() example
  <?php   
      $conn = OCILogon("scott", "tiger");
      $stmt = OCIParse($conn, "select * from emp");
      OCIExecute($stmt);
      echo "<table border=\"1\">";
      echo "<tr>";
      echo "<th>Name</th>";
      echo "<th>Type</th>";
      echo "<th>Length</th>";
      echo "</tr>";
      $ncols = OCINumCols($stmt);
      for ($i = 1; $i <= $ncols; $i++) {
	  $column_name  = OCIColumnName($stmt, $i);
	  $column_type  = OCIColumnType($stmt, $i);
	  $column_size  = OCIColumnSize($stmt, $i);
	  echo "<tr>";
	  echo "<td>$column_name</td>";
	  echo "<td>$column_type</td>";
	  echo "<td>$column_size</td>";
	  echo "</tr>";
      }
      echo "</table>";
      OCIFreeStatement($stmt);  
      OCILogoff($conn);   
  ?> 
See also ocinumcols() and ocicolumnname().   ocicolumnscaleUpocicolumntype
#

#T=int ocicolumnsize ( resource stmt, mixed column)
ocicolumnsize ( ^!resource stmt, mixed column);
#

#T=ocicolumntype - mixed ocicolumntype ( resource stmt, int col)
(PHP 3>= 3.0.4, PHP 4 )
ocicolumntype -- Returns the data type of a column
Description
mixed ocicolumntype ( resource stmt, int col)
ocicolumntype() returns the data type of the column corresponding to the 
column number (1-based) that is passed in. 
Example 1. ocicolumntype() example
  <?php   
      $conn = OCILogon("scott", "tiger");
      $stmt = OCIParse($conn, "select * from emp");
      OCIExecute($stmt);
      echo "<table border=\"1\">";
      echo "<tr>";
      echo "<th>Name</th>";
      echo "<th>Type</th>";
      echo "<th>Length</th>";
      echo "</tr>";
      $ncols = OCINumCols($stmt);
      for ($i = 1; $i <= $ncols; $i++) {
	  $column_name  = OCIColumnName($stmt, $i);
	  $column_type  = OCIColumnType($stmt, $i);
	  $column_size  = OCIColumnSize($stmt, $i);
	  echo "<tr>";
	  echo "<td>$column_name</td>";
	  echo "<td>$column_type</td>";
	  echo "<td>$column_size</td>";
	  echo "</tr>";
      }
      echo "</table>\n"; 
      OCIFreeStatement($stmt);  
      OCILogoff($conn);   
  ?> 
See also ocinumcols(), ocicolumnname(), and ocicolumnsize().   ocicolumnsizeUpocicolumntyperaw
#

#T=mixed ocicolumntype ( resource stmt, int col)
ocicolumntype ( ^!resource stmt, int col);
#

#T=ocicolumntyperaw - mixed ocicolumntyperaw ( resource stmt, int col)
(PHP 4 )
ocicolumntyperaw -- Tell the raw oracle data type of a column
Description
mixed ocicolumntyperaw ( resource stmt, int col)
Warning
This function is currently not documented; only the argument list is 
available.
  ocicolumntypeUpocicommit
#

#T=mixed ocicolumntyperaw ( resource stmt, int col)
ocicolumntyperaw ( ^!resource stmt, int col);
#

#T=ocicommit - bool ocicommit ( resource connection)
(PHP 3>= 3.0.7, PHP 4 )
ocicommit -- Commits outstanding transactions
Description
bool ocicommit ( resource connection)
ocicommit() commits all outstanding statements for the active transaction 
on Oracle connection connection. 
This example demonstrates how ocicommit() is used. Example 1. 
ocicommit() example
  <?php
      // Login to Oracle server
      $conn = OCILogon('scott', 'tiger');
       
      // Parse SQL
      $stmt = OCIParse($conn, "INSERT INTO employees (name, 
  surname) VALUES ('Maxim', 'Maletsky')");

      // Execute statement
      OCIExecute($stmt);

      // Commit transaction
      $committed = OCICommit($conn);

      // Test whether commit was successful. If error occurred, 
  return error message
      if (!$committed) {
	  $error = OCIError($conn);
	  echo 'Commit failed. Oracle reports: ' . 
  $error['message'];
      }

      // Close connection
      OCILogoff($conn);
  ?> 
See also ocirollback().   ocicolumntyperawUpocidefinebyname
#

#T=bool ocicommit ( resource connection)
ocicommit ( ^!resource connection);
#

#T=ocidefinebyname - bool ocidefinebyname ( resource stmt, string column_name, mixed &variable 
(PHP 3>= 3.0.7, PHP 4 )
ocidefinebyname --  Use a PHP variable for the define-step during a SELECT 

Description
bool ocidefinebyname ( resource stmt, string column_name, mixed &variable 
[, int type])
ocidefinebyname() binds PHP variables for fetches of SQL-Columns. Be 
careful that Oracle uses ALL-UPPERCASE column-names, whereby in your 
select you can also write lowercase. ocidefinebyname() expects the 
column_name to be in uppercase. If you define a variable that doesn't 
exists in your select statement, no error will be given! 
If you need to define an abstract datatype (LOB/ROWID/BFILE) you need to 
allocate it first using ocinewdescriptor(). See also the ocibindbyname() 
function. 
Example 1. ocidefinebyname() example
  <?php
  /* OCIDefineByName example - thies at thieso dot net (980219) 
  */

  $conn = OCILogon("scott", "tiger");

  $stmt = OCIParse($conn, "select empno, ename from emp");

  /* the define MUST be done BEFORE ociexecute! */

  OCIDefineByName($stmt, "EMPNO", $empno);
  OCIDefineByName($stmt, "ENAME", $ename);

  OCIExecute($stmt);

  while (OCIFetch($stmt)) {
      echo "empno:" . $empno . "\n";
      echo "ename:" . $ename . "\n";
  }

  OCIFreeStatement($stmt);
  OCILogoff($conn);
  ?> 

  ocicommitUpocierror
#

#T=bool ocidefinebyname ( resource stmt, string column_name, mixed &variable 
ocidefinebyname ( ^!resource stmt, string column_name, mixed &variable ;
#

#T=ocierror - array ocierror ( [resource stmt|conn|global])
(PHP 3>= 3.0.7, PHP 4 )
ocierror -- Return the last error of stmt|conn|global
Description
array ocierror ( [resource stmt|conn|global])
ocierror() returns the last error found. If the optional stmt|conn|global 
is not provided, the last error encountered is returned. If no error is 
found, ocierror() returns FALSE. ocierror() returns the error as an 
associative array. In this array, code consists the oracle error code and 
message the oracle errorstring. 
As of PHP 4.3: offset and sqltext will also be included in the return 
array to indicate the location of the error and the original SQL text 
which caused it.   ocidefinebynameUpociexecute
#

#T=array ocierror ( [resource stmt|conn|global])
ocierror ( ^![resource stmt|conn|global]);
#

#T=ociexecute - bool ociexecute ( resource stmt [, int mode])
(PHP 3>= 3.0.4, PHP 4 )
ociexecute -- Execute a statement
Description
bool ociexecute ( resource stmt [, int mode])
ociexecute() executes a previously parsed statement. (see ociparse()). The 
optional mode allows you to specify the execution-mode (default is 
OCI_COMMIT_ON_SUCCESS). If you don't want statements to be committed 
automatically specify OCI_DEFAULT as your mode. 
Returns TRUE on success or FALSE on failure.   ocierrorUpocifetch
#

#T=bool ociexecute ( resource stmt [, int mode])
ociexecute ( ^!resource stmt [, int mode]);
#

#T=ocifetch - bool ocifetch ( resource stmt)
(PHP 3>= 3.0.4, PHP 4 )
ocifetch -- Fetches the next row into result-buffer
Description
bool ocifetch ( resource stmt)
ocifetch() fetches the next row (for SELECT statements) into the internal 
result-buffer. Returns TRUE on success or FALSE on failure.   ociexecuteUpocifetchinto
#

#T=bool ocifetch ( resource stmt)
ocifetch ( ^!resource stmt);
#

#T=ocifetchinto - int ocifetchinto ( resource stmt, array &result [, int mode])
(PHP 3>= 3.0.4, PHP 4 )
ocifetchinto -- Fetches the next row into an array
Description
int ocifetchinto ( resource stmt, array &result [, int mode])
ocifetchinto() fetches the next row (for SELECT statements) into the 
result array. ocifetchinto() will overwrite the previous content of 
result. By default result will contain a zero-based array of all columns 
that are not NULL. 
The mode parameter allows you to change the default behaviour. You can 
specify more than one flag by simply adding them up (e.g. 
OCI_ASSOC+OCI_RETURN_NULLS). The known flags are: 
OCI_ASSOC Return an associative array. 
OCI_NUM Return an numbered array starting with zero. (DEFAULT) 
OCI_RETURN_NULLS Return empty columns. 
OCI_RETURN_LOBS Return the value of a LOB instead of the descriptor. 
Example 1. A simple ocifetchinto() example
  <?php
  $conn = ocilogon("username", "password");

  $query = "SELECT apples FROM oranges";

  $statement = OCIParse ($conn, $query);
  OCIExecute ($statement);

  while (OCIFetchInto ($statement, $row, OCI_ASSOC)) {
      echo $row['apples'];
  }
  ?> 
See also ocifetch() and ociexecute().   ocifetchUpocifetchstatement
#

#T=int ocifetchinto ( resource stmt, array &result [, int mode])
ocifetchinto ( ^!resource stmt, array &result [, int mode]);
#

#T=ocifetchstatement - int ocifetchstatement ( resource stmt, array &output [, int skip [, int 
(PHP 3>= 3.0.8, PHP 4 )
ocifetchstatement -- Fetch all rows of result data into an array
Description
int ocifetchstatement ( resource stmt, array &output [, int skip [, int 
maxrows [, int flags]]])
ocifetchstatement() fetches all the rows from a result into a user-defined 
array. ocifetchstatement() returns the number of rows fetched. skip is the 
number of initial rows to ignore when fetching the result (default value 
of 0, to start at the first line). maxrows is the number of rows to read, 
starting at the skipth row (Default to -1, meaning all the rows). 
flags represents the available options for, which can be any combination 
of the following : 
OCI_FETCHSTATEMENT_BY_ROW 
OCI_FETCHSTATEMENT_BY_COLUMN (default value) 
OCI_NUM 
OCI_ASSOC 

Example 1. ocifetchstatement() example
  <?php
  /* OCIFetchStatement example mbritton at verinet dot com 
  (990624) */

  $conn = OCILogon("scott", "tiger");

  $stmt = OCIParse($conn, "select * from emp");

  OCIExecute($stmt);

  $nrows = OCIFetchStatement($stmt, $results);
  if ($nrows > 0) {
     echo "<table border=\"1\">\n";
     echo "<tr>\n";
     while (list($key, $val) = each($results)) {
	echo "<th>$key</th>\n";
     }
     echo "</tr>\n";
     
     for ($i = 0; $i < $nrows; $i++) {
	reset($results);
	echo "<tr>\n";
	while ($column = each($results)) {   
	   $data = $column['value'];
	   echo "<td>$data[$i]</td>\n";
	}
	echo "</tr>\n";
     }
     echo "</table>\n";
  } else {
     echo "No data found<br />\n";
  }      
  echo "$nrows Records Selected<br />\n";

  OCIFreeStatement($stmt);
  OCILogoff($conn);
  ?> 

  ocifetchintoUpocifreecollection
#

#T=int ocifetchstatement ( resource stmt, array &output [, int skip [, int 
ocifetchstatement ( ^!resource stmt, array &output [, int skip [, int ;
#

#T=ocifreecollection - bool ocifreecollection ( void )
(PHP 4 >= 4.1.0)
ocifreecollection -- Deletes collection object
Description
bool ocifreecollection ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ocifetchstatementUpocifreecursor
#

#T=bool ocifreecollection ( void )
ocifreecollection ( ^!void );
#

#T=ocifreecursor - bool ocifreecursor ( resource stmt)
(PHP 3>= 3.0.8, PHP 4 )
ocifreecursor --  Free all resources associated with a cursor 
Description
bool ocifreecursor ( resource stmt)
ocifreecursor() frees all resources associated with the cursor stmt. 
Returns TRUE on success or FALSE on failure.   ocifreecollectionUpocifreedesc
#

#T=bool ocifreecursor ( resource stmt)
ocifreecursor ( ^!resource stmt);
#

#T=ocifreedesc - bool ocifreedesc ( void )
(PHP 4 )
ocifreedesc -- Deletes a large object descriptor
Description
bool ocifreedesc ( void )
ocifreedesc() deletes a large object descriptor. Returns TRUE on success 
or FALSE on failure.   ocifreecursorUpocifreestatement
#

#T=bool ocifreedesc ( void )
ocifreedesc ( ^!void );
#

#T=ocifreestatement - bool ocifreestatement ( resource stmt)
(PHP 3>= 3.0.5, PHP 4 )
ocifreestatement --  Free all resources associated with a statement 
Description
bool ocifreestatement ( resource stmt)
ocifreestatement() free all resources associated with the statement stmt. 
Returns TRUE on success or FALSE on failure.   ocifreedescUpociinternaldebug
#

#T=bool ocifreestatement ( resource stmt)
ocifreestatement ( ^!resource stmt);
#

#T=ociinternaldebug - void ociinternaldebug ( int onoff)
(PHP 3>= 3.0.4, PHP 4 )
ociinternaldebug --  Enables or disables internal debug output 
Description
void ociinternaldebug ( int onoff)
ociinternaldebug() enables internal debug output. Set onoff to 0 to turn 
debug output off, 1 to turn it on.   ocifreestatementUpociloadlob
#

#T=void ociinternaldebug ( int onoff)
ociinternaldebug ( ^!int onoff);
#

#T=ociloadlob - string ociloadlob ( void )
(PHP 4 )
ociloadlob -- Loads a large object
Description
string ociloadlob ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ociinternaldebugUpocilogoff
#

#T=string ociloadlob ( void )
ociloadlob ( ^!void );
#

#T=ocilogoff - bool ocilogoff ( resource connection)
(PHP 3>= 3.0.4, PHP 4 )
ocilogoff -- Disconnects from Oracle server
Description
bool ocilogoff ( resource connection)
ocilogoff() closes the Oracle connection connection. 
Using ocilogoff() isn't usually necessary, as non-persistent open links 
are automatically closed at the end of the script's execution. See also 
freeing resources.   ociloadlobUpocilogon
#

#T=bool ocilogoff ( resource connection)
ocilogoff ( ^!resource connection);
#

#T=ocilogon - resource ocilogon ( string username, string password [, string db])
(PHP 3>= 3.0.4, PHP 4 )
ocilogon -- Establishes a connection to Oracle
Description
resource ocilogon ( string username, string password [, string db])
ocilogon() returns an connection identifier needed for most other OCI 
calls. The optional third parameter can either contain the name of the 
local Oracle instance or the name of the entry in tnsnames.ora to which 
you want to connect. If the optional third parameter is not specified, PHP 
uses the environment variables ORACLE_SID (Oracle instance) or TWO_TASK 
(tnsnames.ora) to determine which database to connect to. 
Connections are shared at the page level when using ocilogon(). This means 
that commits and rollbacks apply to all open transactions in the page, 
even if you have created multiple connections. 
This example demonstrates how the connections are shared. Example 1. 
ocilogon() example
  <?php
  echo "<pre>";
  $db = "";

  $c1 = ocilogon("scott", "tiger", $db);
  $c2 = ocilogon("scott", "tiger", $db);

  function create_table($conn) {
    $stmt = ociparse($conn, "create table scott.hallo (test 
  varchar2(64))");
    ociexecute($stmt);
    echo $conn . " created table\n\n";
  }

  function drop_table($conn) {
    $stmt = ociparse($conn, "drop table scott.hallo");
    ociexecute($stmt);
    echo $conn . " dropped table\n\n";
  }

  function insert_data($conn) {
    $stmt = ociparse($conn, "insert into scott.hallo 
	      values('$conn' || ' ' || 
  to_char(sysdate,'DD-MON-YY HH24:MI:SS'))");
    ociexecute($stmt, OCI_DEFAULT);
    echo $conn . " inserted hallo\n\n";
  }

  function delete_data($conn) {
    $stmt = ociparse($conn, "delete from scott.hallo");
    ociexecute($stmt, OCI_DEFAULT);
    echo $conn . " deleted hallo\n\n";
  }

  function commit($conn) {
    ocicommit($conn);
    echo $conn . " committed\n\n";
  }

  function rollback($conn) {
    ocirollback($conn);
    echo $conn . " rollback\n\n";
  }

  function select_data($conn) {
    $stmt = ociparse($conn, "select * from scott.hallo");
    ociexecute($stmt, OCI_DEFAULT);
    echo $conn."----selecting\n\n";
    while (ocifetch($stmt)) {
      echo $conn . " [" . ociresult($stmt, "TEST") . "]\n\n";
    }
    echo $conn . "----done\n\n";
  }

  create_table($c1);
  insert_data($c1);   // Insert a row using c1
  insert_data($c2);   // Insert a row using c2

  select_data($c1);   // Results of both inserts are returned
  select_data($c2);   

  rollback($c1);      // Rollback using c1

  select_data($c1);   // Both inserts have been rolled back
  select_data($c2);   

  insert_data($c2);   // Insert a row using c2
  commit($c2);        // Commit using c2

  select_data($c1);   // Result of c2 insert is returned

  delete_data($c1);   // Delete all rows in table using c1
  select_data($c1);   // No rows returned
  select_data($c2);   // No rows returned
  commit($c1);        // Commit using c1

  select_data($c1);   // No rows returned
  select_data($c2);   // No rows returned

  drop_table($c1);
  echo "</pre>";
  ?> 
See also ociplogon() and ocinlogon().  ocilogoffUpocinewcollection
#

#T=resource ocilogon ( string username, string password [, string db])
ocilogon ( ^!string username, string password [, string db]);
#

#T=ocinewcollection - object ocinewcollection ( resource connection, string tdo [, string 
(PHP 4 >= 4.0.6)
ocinewcollection -- Initialize a new collection
Description
object ocinewcollection ( resource connection, string tdo [, string 
schema])
Warning
This function is currently not documented; only the argument list is 
available.
  ocilogonUpocinewcursor
#

#T=object ocinewcollection ( resource connection, string tdo [, string 
ocinewcollection ( ^!resource connection, string tdo [, string ;
#

#T=ocinewcursor - resource ocinewcursor ( resource conn)
(PHP 3>= 3.0.8, PHP 4 )
ocinewcursor --  Return a new cursor (Statement-Handle) 
Description
resource ocinewcursor ( resource conn)
ocinewcursor() allocates a new statement handle on the specified 
connection. 
Example 1. Using a REF CURSOR from a stored procedure in Oracle
  <?php   
  // suppose your stored procedure info.output returns a ref 
  cursor in :data

  $conn = OCILogon("scott", "tiger");
  $curs = OCINewCursor($conn);
  $stmt = OCIParse($conn, "begin info.output(:data); end;");

  ocibindbyname($stmt, "data", &$curs, -1, OCI_B_CURSOR);
  ociexecute($stmt);
  ociexecute($curs);

  while (OCIFetchInto($curs, &$data)) {
      var_dump($data);
  }

  OCIFreeStatement($stmt);
  OCIFreeCursor($curs);
  OCILogoff($conn);
  ?> 
Example 2. Using a REF CURSOR in a select statement in Oracle
  <?php   
  echo "<html><body>";
  $conn = OCILogon("scott", "tiger");
  $count_cursor = "CURSOR(select count(empno) num_emps from emp 
  " .
		  "where emp.deptno = dept.deptno) as EMPCNT 
  from dept";
  $stmt = OCIParse($conn, "select deptno,dname,$count_cursor");

  ociexecute($stmt);
  echo "<table border=\"1\">";
  echo "<tr>";
  echo "<th>DEPT NAME</th>";
  echo "<th>DEPT #</th>";
  echo "<th># EMPLOYEES</th>";
  echo "</tr>";

  while (OCIFetchInto($stmt, &$data, OCI_ASSOC)) {
      echo "<tr>";
      $dname  = $data["DNAME"];
      $deptno = $data["DEPTNO"];
      echo "<td>$dname</td>";
      echo "<td>$deptno</td>";
      ociexecute($data["EMPCNT"]);
      while (OCIFetchInto($data["EMPCNT"], &$subdata, 
  OCI_ASSOC)) {
	  $num_emps = $subdata["NUM_EMPS"];
	  echo  "<td>$num_emps</td>";
      }
      echo "</tr>";
  }
  echo "</table>";
  echo "</body></html>";
  OCIFreeStatement($stmt);
  OCILogoff($conn);
  ?> 

  ocinewcollectionUpocinewdescriptor
#

#T=resource ocinewcursor ( resource conn)
ocinewcursor ( ^!resource conn);
#

#T=ocinewdescriptor - object ocinewdescriptor ( resource connection [, int type])
(PHP 3>= 3.0.7, PHP 4 )
ocinewdescriptor --  Initialize a new empty LOB or FILE descriptor 
Description
object ocinewdescriptor ( resource connection [, int type])
ocinewdescriptor() allocates storage to hold descriptors or LOB locators. 
Valid values for type are OCI_D_FILE, OCI_D_LOB and OCI_D_ROWID. For LOB 
descriptors, the methods load, save, and savefile are associated with the 
descriptor, for BFILE only the load method exists. See the second example 
usage hints. 
Example 1. ocinewdescriptor() example
  <?php   
      /* This script is designed to be called from a HTML form.
       * It expects $user, $password, $table, $where, and 
  $commitsize
       * to be passed in from the form.  The script then deletes
       * the selected rows using the ROWID and commits after 
each
       * set of $commitsize rows. (Use with care, there is no 
  rollback)
       */
      $conn = OCILogon($user, $password);
      $stmt = OCIParse($conn, "select rowid from $table 
$where");
      $rowid = OCINewDescriptor($conn, OCI_D_ROWID);
      OCIDefineByName($stmt, "ROWID", &$rowid);   
      OCIExecute($stmt);
      while (OCIFetch($stmt)) {
	 $nrows = OCIRowCount($stmt);
	 $delete = OCIParse($conn, "delete from $table where 
  ROWID = :rid");
	 OCIBindByName($delete, ":rid", &$rowid, -1, 
  OCI_B_ROWID);
	 OCIExecute($delete);      
	 echo "$nrows\n";
	 if (($nrows % $commitsize) == 0) {
	     OCICommit($conn);      
	 }   
      }
      $nrows = OCIRowCount($stmt);   
      echo "$nrows deleted...\n";
      OCIFreeStatement($stmt);  
      OCILogoff($conn);
  ?> 
  <?php
      /* This script demonstrates file upload to LOB columns
       * The formfield used for this example looks like this
       * <form action="upload.php" method="post" 
  enctype="multipart/form-data">
       * <input type="file" name="lob_upload" />
       * ...
       */
    if (!isset($lob_upload) || $lob_upload == 'none'){
  ?>
  <form action="upload.php" method="post" 
  enctype="multipart/form-data">
  Upload file: <input type="file" name="lob_upload" /><br />
  <input type="submit" value="Upload" /> - <input type="reset" 
  value="Reset" />
  </form>
  <?php
    } else {

       // $lob_upload contains the temporary filename of the 
  uploaded file

       // see also the features section on file upload,
       // if you would like to use secure uploads
       
       $conn = OCILogon($user, $password);
       $lob = OCINewDescriptor($conn, OCI_D_LOB);
       $stmt = OCIParse($conn, "insert into $table (id, 
  the_blob) 
		 values(my_seq.NEXTVAL, EMPTY_BLOB()) returning 
  the_blob into :the_blob");
       OCIBindByName($stmt, ':the_blob', &$lob, -1, OCI_B_BLOB);
       OCIExecute($stmt, OCI_DEFAULT);
       if ($lob->savefile($lob_upload)){
	  OCICommit($conn);
	  echo "Blob successfully uploaded\n";
       }else{
	  echo "Couldn't upload Blob\n";
       }
       OCIFreeDesc($lob);
       OCIFreeStatement($stmt);
       OCILogoff($conn);
    }
  ?> 

Example 2. ocinewdescriptor() second example
  <?php   
      /* Calling PL/SQL stored procedures which contain clobs as 
  #

  #T=object ocinewdescriptor ( resource connection [, int type])
object ocinewdescriptor ^!( resource connection [, int type]);
  #
  input
#T= - resource ocinlogon ( string username, string password [, string db])
       * parameters (PHP 4 >= 4.0.6). 
       * Example PL/SQL stored procedure signature is:
       *
       * PROCEDURE save_data
       *   Argument Name                  Type                   
   In/Out Default?
       *   ------------------------------ 
  ----------------------- ------ --------
       *   KEY                            NUMBER(38)             
   IN
       *   DATA                           CLOB                   
   IN
       *
       */

      $conn = OCILogon($user, $password);
      $stmt = OCIParse($conn, "begin save_data(:key, :data); 
  end;");
      $clob = OCINewDescriptor($conn, OCI_D_LOB);
	 OCIBindByName($stmt, ':key', $key);
      OCIBindByName($stmt, ':data', $clob, -1, OCI_B_CLOB);
	 $clob->WriteTemporary($data);
	 OCIExecute($stmt, OCI_DEFAULT);
	 OCICommit($conn);
	 $clob->close();
	 $clob->free();
      OCIFreeStatement($stmt);
  ?> 

  ocinewcursorUpocinlogon
#

#T=ocinlogon - resource ocinlogon ( string username, string password [, string db])
(PHP 3>= 3.0.8, PHP 4 )
ocinlogon -- Establishes a new connection to Oracle
Description
resource ocinlogon ( string username, string password [, string db])
ocinlogon() creates a new connection to an Oracle 8 database and logs on. 
The optional third parameter can either contain the name of the local 
Oracle instance or the name of the entry in tnsnames.ora to which you want 
to connect. If the optional third parameter is not specified, PHP uses the 
environment variables ORACLE_SID (Oracle instance) or TWO_TASK 
(tnsnames.ora) to determine which database to connect to. 
ocinlogon() forces a new connection. This should be used if you need to 
isolate a set of transactions. By default, connections are shared at the 
page level if using ocilogon() or at the web server process level if using 
ociplogon(). If you have multiple connections open using ocinlogon(), all 
commits and rollbacks apply to the specified connection only. 
This example demonstrates how the connections are separated. Example 
1. ocinlogon() example
  <?php
  echo "<html><pre>";
  $db = "";

  $c1 = ocilogon("scott", "tiger", $db);
  $c2 = ocinlogon("scott", "tiger", $db);

  function create_table($conn) {
    $stmt = ociparse($conn, "create table scott.hallo (test
  varchar2(64))");
    ociexecute($stmt);
    echo $conn . " created table\n\n";
  }

  function drop_table($conn) {
    $stmt = ociparse($conn, "drop table scott.hallo");
    ociexecute($stmt);
    echo $conn . " dropped table\n\n";
  }

  function insert_data($conn) {
    $stmt = ociparse($conn, "insert into scott.hallo 
	      values('$conn' || ' ' || 
  to_char(sysdate,'DD-MON-YY HH24:MI:SS'))");
    ociexecute($stmt, OCI_DEFAULT);
    echo $conn . " inserted hallo\n\n";
  }

  function delete_data($conn) {
    $stmt = ociparse($conn, "delete from scott.hallo");
    ociexecute($stmt, OCI_DEFAULT);
    echo $conn . " deleted hallo\n\n";
  }

  function commit($conn) {
    ocicommit($conn);
    echo $conn . " committed\n\n";
  }

  function rollback($conn) {
    ocirollback($conn);
    echo $conn . " rollback\n\n";
  }

  function select_data($conn) {
    $stmt = ociparse($conn, "select * from scott.hallo");
    ociexecute($stmt, OCI_DEFAULT);
    echo $conn . "----selecting\n\n";
    while (ocifetch($stmt)) {
      echo $conn . " <" . ociresult($stmt, "TEST") . ">\n\n";
    }
    echo $conn . "----done\n\n";
  }

  create_table($c1);
  insert_data($c1);

  select_data($c1);   
  select_data($c2);   

  rollback($c1);      

  select_data($c1);   
  select_data($c2);   

  insert_data($c2);   
  commit($c2);        

  select_data($c1);   

  delete_data($c1);   
  select_data($c1);   
  select_data($c2);   
  commit($c1);        

  select_data($c1);
  select_data($c2);

  drop_table($c1);
  echo "</pre></html>";
  ?> 
See also ocilogon() and ociplogon().   ocinewdescriptorUpocinumcols
#

#T=resource ocinlogon ( string username, string password [, string db])
ocinlogon ( ^!string username, string password [, string db]);
#

#T=ocinumcols - int ocinumcols ( resource stmt)
(PHP 3>= 3.0.4, PHP 4 )
ocinumcols --  Return the number of result columns in a statement 
Description
int ocinumcols ( resource stmt)
ocinumcols() returns the number of columns in the statement stmt. 
Example 1. ocinumcols() example
  <?php   
      echo "<pre>\n";   
      $conn = OCILogon("scott", "tiger");
      $stmt = OCIParse($conn, "select * from emp");
      OCIExecute($stmt);
      while (OCIFetch($stmt)) {
	  echo "\n";   
	  $ncols = OCINumCols($stmt);
	  for ($i = 1; $i <= $ncols; $i++) {
	      $column_name  = OCIColumnName($stmt, $i);
	      $column_value = OCIResult($stmt, $i);
	      echo $column_name . ': ' . $column_value . "\n";
	  }
	  echo "\n";
      }
      OCIFreeStatement($stmt);  
      OCILogoff($conn);   
      echo "</pre>";
  ?> 

  ocinlogonUpociparse
#

#T=int ocinumcols ( resource stmt)
ocinumcols ( ^!resource stmt);
#

#T=ociparse - resource ociparse ( resource conn, string query)
(PHP 3>= 3.0.4, PHP 4 )
ociparse -- Parse a query and return an Oracle statement
Description
resource ociparse ( resource conn, string query)
ociparse() parses the query using conn. It returns the statement identity 
if the query is valid, FALSE if not. The query can be any valid SQL 
statement or PL/SQL block.   ocinumcolsUpociplogon
#

#T=resource ociparse ( resource conn, string query)
ociparse ( ^!resource conn, string query);
#

#T=ociplogon - resource ociplogon ( string username, string password [, string db])
(PHP 3>= 3.0.8, PHP 4 )
ociplogon --  Connect to an Oracle database using a persistent connection 
Description
resource ociplogon ( string username, string password [, string db])
ociplogon() creates a persistent connection to an Oracle 8 database and 
logs on. The optional third parameter can either contain the name of the 
local Oracle instance or the name of the entry in tnsnames.ora to which 
you want to connect. If the optional third parameter is not specified, PHP 
uses the environment variables ORACLE_SID (Oracle instance) or TWO_TASK 
(tnsnames.ora) to determine which database to connect to. 
See also ocilogon() and ocinlogon().   ociparseUpociresult
#

#T=resource ociplogon ( string username, string password [, string db])
ociplogon ( ^!string username, string password [, string db]);
#

#T=ociresult - mixed ociresult ( resource statement, mixed col)
(PHP 3>= 3.0.4, PHP 4 )
ociresult -- Returns column value for fetched row
Description
mixed ociresult ( resource statement, mixed col)
ociresult() returns the data for column column in the current row (see 
ocifetch()). ociresult() will return everything as strings except for 
abstract types (ROWIDs, LOBs and FILEs). 
You can either use the column-number (1-Based) or the column-name, in 
uppercase, for the col parameter.   ociplogonUpocirollback
#

#T=mixed ociresult ( resource statement, mixed col)
ociresult ( ^!resource statement, mixed col);
#

#T=ocirollback - bool ocirollback ( resource connection)
(PHP 3>= 3.0.7, PHP 4 )
ocirollback -- Rolls back outstanding transactions
Description
bool ocirollback ( resource connection)
ocirollback() rolls back all outstanding statements for Oracle connection 
connection. Returns TRUE on success or FALSE on failure. 
See also ocicommit().   ociresultUpocirowcount
#

#T=bool ocirollback ( resource connection)
ocirollback ( ^!resource connection);
#

#T=ocirowcount - int ocirowcount ( resource stmt)
(PHP 3>= 3.0.7, PHP 4 )
ocirowcount -- Gets the number of affected rows
Description
int ocirowcount ( resource stmt)
ocirowcount() returns the number of rows affected for e.g. 
update-statements. This function will not tell you the number of rows that 
a select will return! 
Example 1. ocirowcount() example
  <?php
      echo "<pre>";
      $conn = OCILogon("scott", "tiger");
      $stmt = OCIParse($conn, "create table emp2 as select * 
  from emp");
      OCIExecute($stmt);
      echo OCIRowCount($stmt) . " rows inserted.<br />";
      OCIFreeStatement($stmt);
      $stmt = OCIParse($conn, "delete from emp2");
      OCIExecute($stmt);
      echo OCIRowCount($stmt) . " rows deleted.<br />";
      OCICommit($conn);
      OCIFreeStatement($stmt);
      $stmt = OCIParse($conn, "drop table emp2");
      OCIExecute($stmt);
      OCIFreeStatement($stmt);
      OCILogOff($conn);
      echo "</pre>";
  ?> 

  ocirollbackUpocisavelob
#

#T=int ocirowcount ( resource stmt)
ocirowcount ( ^!resource stmt);
#

#T=ocisavelob - bool ocisavelob ( void )
(PHP 4 )
ocisavelob -- Saves a large object 
Description
bool ocisavelob ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ocirowcountUpocisavelobfile
#

#T=bool ocisavelob ( void )
ocisavelob ( ^!void );
#

#T=ocisavelobfile - bool ocisavelobfile ( void )
(PHP 4 )
ocisavelobfile -- Saves a large object file
Description
bool ocisavelobfile ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  ocisavelobUpociserverversion
#

#T=bool ocisavelobfile ( void )
ocisavelobfile ( ^!void );
#

#T=ociserverversion - string ociserverversion ( resource conn)
(PHP 3>= 3.0.4, PHP 4 )
ociserverversion -- Return a string containing server version information
Description
string ociserverversion ( resource conn)
Example 1. ociserverversion() example
  <?php
     $conn = OCILogon("scott", "tiger");
     echo "Server Version: " . OCIServerVersion($conn);
     OCILogOff($conn);
  ?> 

  ocisavelobfileUpocisetprefetch
#

#T=string ociserverversion ( resource conn)
ociserverversion ( ^!resource conn);
#

#T=ocisetprefetch - bool ocisetprefetch ( resource stmt, int rows)
(PHP 3>= 3.0.12, PHP 4 )
ocisetprefetch -- Sets number of rows to be prefetched
Description
bool ocisetprefetch ( resource stmt, int rows)
Sets the number of top level rows to be prefetched to rows. The default 
value for rows is 1 row.   ociserverversionUpocistatementtype
#

#T=bool ocisetprefetch ( resource stmt, int rows)
ocisetprefetch ( ^!resource stmt, int rows);
#

#T=ocistatementtype - string ocistatementtype ( resource stmt)
(PHP 3>= 3.0.5, PHP 4 )
ocistatementtype -- Return the type of an OCI statement
Description
string ocistatementtype ( resource stmt)
ocistatementtype() returns one of the following values: 
SELECT
UPDATE
DELETE
INSERT
CREATE
DROP
ALTER
BEGIN
DECLARE
UNKNOWN
Example 1. ocistatementtype() examples
  <?php
      $conn = OCILogon("scott", "tiger");
      $sql  = "delete from emp where deptno = 10";
     
      $stmt = OCIParse($conn, $sql);
      if (OCIStatementType($stmt) == "DELETE") {
	  die("You are not allowed to delete from this table<br 
  />");
      }
     
      OCILogoff($conn);
  ?> 

  ocisetprefetchUpociwritelobtofile
#

#T=string ocistatementtype ( resource stmt)
ocistatementtype ( ^!resource stmt);
#

#T=ociwritelobtofile - bool ociwritelobtofile ( [string filename [, int start [, int length]]])
(PHP 4 )
ociwritelobtofile -- Saves a large object file
Description
bool ociwritelobtofile ( [string filename [, int start [, int length]]])
Warning
This function is currently not documented; only the argument list is 
available.
  ocistatementtypeUpociwritetemporarylob
ociwritetemporarylob
(no version information, might be only in CVS)
ociwritetemporarylob -- Writes temporary blob
Description
bool ociwritetemporarylob ( string var [, int lob_type])
Warning
This function is currently not documented; only the argument list is 
available.
  ociwritelobtofileUpOpenSSL functions
#

#T=bool ociwritelobtofile ( [string filename [, int start [, int length]]])
ociwritelobtofile ( ^![string filename [, int start [, int length]]]);
#

#T=octdec - int octdec ( string octal_string)
(PHP 3, PHP 4 )
octdec -- Octal to decimal
Description
int octdec ( string octal_string)
Returns the decimal equivalent of the octal number represented by the 
octal_string argument. The largest number that can be converted is 
17777777777 or 2147483647 in decimal. 
Example 1. octdec() example
  <?php
  echo octdec('77') . "\n";
  echo octdec(decoct(45));
  ?> 

The above example will output: 
63
45
See also decoct(), bindec(), hexdec() and base_convert().   mt_srandUppi
#

#T=int octdec ( string octal_string)
octdec ( ^!string octal_string);
#

#T=odbc_autocommit - bool odbc_autocommit ( resource connection_id [, bool OnOff])
(PHP 3>= 3.0.6, PHP 4 )
odbc_autocommit -- Toggle autocommit behaviour
Description
bool odbc_autocommit ( resource connection_id [, bool OnOff])
Without the OnOff parameter, this function returns auto-commit status for 
connection_id. TRUE is returned if auto-commit is on, FALSE if it is off 
or an error occurs. 
If OnOff is TRUE, auto-commit is enabled, if it is FALSE auto-commit is 
disabled. Returns TRUE on success, FALSE on failure. 
By default, auto-commit is on for a connection. Disabling auto-commit is 
equivalent with starting a transaction. 
See also odbc_commit() and odbc_rollback().   Unified ODBC functionsUpodbc_binmode
#

#T=bool odbc_autocommit ( resource connection_id [, bool OnOff])
odbc_autocommit ( ^!resource connection_id [, bool OnOff]);
#

#T=odbc_binmode - int odbc_binmode ( resource result_id, int mode)
(PHP 3>= 3.0.6, PHP 4 )
odbc_binmode -- Handling of binary column data
Description
int odbc_binmode ( resource result_id, int mode)
(ODBC SQL types affected: BINARY, VARBINARY, LONGVARBINARY) 
ODBC_BINMODE_PASSTHRU: Passthru BINARY data 
ODBC_BINMODE_RETURN: Return as is 
ODBC_BINMODE_CONVERT: Convert to char and return 
When binary SQL data is converted to character C data, each byte (8 bits) 
of source data is represented as two ASCII characters. These characters 
are the ASCII character representation of the number in its hexadecimal 
form. For example, a binary 00000001 is converted to "01" and a binary 
11111111 is converted to "FF". 
Table 1. LONGVARBINARY handling
binmodelongreadlenresult
ODBC_BINMODE_PASSTHRU0passthru
ODBC_BINMODE_RETURN0passthru
ODBC_BINMODE_CONVERT0passthru
ODBC_BINMODE_PASSTHRU0passthru
ODBC_BINMODE_PASSTHRU>0passthru
ODBC_BINMODE_RETURN>0return as is
ODBC_BINMODE_CONVERT>0return as char

If odbc_fetch_into() is used, passthru means that an empty string is 
returned for these columns. 
If result_id is 0, the settings apply as default for new results. 
Note: Default for longreadlen is 4096 and binmode defaults to 
ODBC_BINMODE_RETURN. Handling of binary long columns is also affected by 
odbc_longreadlen()   odbc_autocommitUpodbc_close_all
#

#T=int odbc_binmode ( resource result_id, int mode)
odbc_binmode ( ^!resource result_id, int mode);
#

#T=odbc_close_all - void odbc_close_all ( void )
(PHP 3>= 3.0.6, PHP 4 )
odbc_close_all -- Close all ODBC connections
Description
void odbc_close_all ( void )
odbc_close_all() will close down all connections to database server(s). 
Note: This function will fail if there are open transactions on a 
connection. This connection will remain open in this case.   odbc_binmodeUpodbc_close
#

#T=void odbc_close_all ( void )
odbc_close_all ( ^!void );
#

#T=odbc_close - void odbc_close ( resource connection_id)
(PHP 3>= 3.0.6, PHP 4 )
odbc_close -- Close an ODBC connection
Description
void odbc_close ( resource connection_id)
odbc_close() will close down the connection to the database server 
associated with the given connection identifier. 
Note: This function will fail if there are open transactions on this 
connection. The connection will remain open in this case.   odbc_close_allUpodbc_columnprivileges
#

#T=void odbc_close ( resource connection_id)
odbc_close ( ^!resource connection_id);
#

#T=odbc_columnprivileges - int odbc_columnprivileges ( resource connection_id [, string qualifier [, 
(PHP 4 )
odbc_columnprivileges --  Returns a result identifier that can be used to 
fetch a list of columns and associated privileges 
Description
int odbc_columnprivileges ( resource connection_id [, string qualifier [, 
string owner [, string table_name [, string column_name]]]])
Lists columns and associated privileges for the given table. Returns an 
ODBC result identifier or FALSE on failure. 
The result set has the following columns: 
TABLE_QUALIFIER
TABLE_OWNER
TABLE_NAME
GRANTOR
GRANTEE
PRIVILEGE
IS_GRANTABLE
The result set is ordered by TABLE_QUALIFIER, TABLE_OWNER and TABLE_NAME. 
The column_name argument accepts search patterns ('%' to match zero or 
more characters and '_' to match a single character).   odbc_closeUpodbc_columns
#

#T=int odbc_columnprivileges ( resource connection_id [, string qualifier [, 
odbc_columnprivileges ( ^!resource connection_id [, string qualifier [, ;
#

#T=odbc_columns - resource odbc_columns ( resource connection_id [, string qualifier [, 
(PHP 4 )
odbc_columns --  Lists the column names in specified tables. Returns a 
result identifier containing the information. 
Description
resource odbc_columns ( resource connection_id [, string qualifier [, 
string schema [, string table_name [, string column_name]]]])
Lists all columns in the requested range. Returns an ODBC result 
identifier or FALSE on failure. 
The result set has the following columns: 
TABLE_QUALIFIER
TABLE_SCHEM
TABLE_NAME
COLUMN_NAME
DATA_TYPE
TYPE_NAME
PRECISION
LENGTH
SCALE
RADIX
NULLABLE
REMARKS
The result set is ordered by TABLE_QUALIFIER, TABLE_SCHEM and TABLE_NAME. 
The schema, table_name and column_name arguments accept search patterns 
('%' to match zero or more characters and '_' to match a single 
character). 
See also odbc_columnprivileges() to retrieve associated privileges.   odbc_columnprivilegesUpodbc_commit
#

#T=resource odbc_columns ( resource connection_id [, string qualifier [, 
odbc_columns ( ^!resource connection_id [, string qualifier [, ;
#

#T=odbc_commit - bool odbc_commit ( resource connection_id)
(PHP 3>= 3.0.6, PHP 4 )
odbc_commit -- Commit an ODBC transaction
Description
bool odbc_commit ( resource connection_id)
odbc_commit() commits all pending transactions on the connection_id 
connection. Returns TRUE on success or FALSE on failure.   odbc_columnsUpodbc_connect
#

#T=bool odbc_commit ( resource connection_id)
odbc_commit ( ^!resource connection_id);
#

#T=odbc_connect - resource odbc_connect ( string dsn, string user, string password [, int 
(PHP 3>= 3.0.6, PHP 4 )
odbc_connect -- Connect to a datasource
Description
resource odbc_connect ( string dsn, string user, string password [, int 
cursor_type])
Returns an ODBC connection id or 0 (FALSE) on error. 
The connection id returned by this functions is needed by other ODBC 
functions. You can have multiple connections open at once. The optional 
fourth parameter sets the type of cursor to be used for this connection. 
This parameter is not normally needed, but can be useful for working 
around problems with some ODBC drivers. 
With some ODBC drivers, executing a complex stored procedure may fail with 
an error similar to: "Cannot open a cursor on a stored procedure that has 
anything other than a single select statement in it". Using 
SQL_CUR_USE_ODBC may avoid that error. Also, some drivers don't support 
the optional row_number parameter in odbc_fetch_row(). SQL_CUR_USE_ODBC 
might help in that case, too. 
The following constants are defined for cursortype: 
SQL_CUR_USE_IF_NEEDED 
SQL_CUR_USE_ODBC 
SQL_CUR_USE_DRIVER 
SQL_CUR_DEFAULT 
For persistent connections see odbc_pconnect().   odbc_commitUpodbc_cursor
#

#T=resource odbc_connect ( string dsn, string user, string password [, int 
odbc_connect ( ^!string dsn, string user, string password [, int ;
#

#T=odbc_cursor - string odbc_cursor ( resource result_id)
(PHP 3>= 3.0.6, PHP 4 )
odbc_cursor -- Get cursorname
Description
string odbc_cursor ( resource result_id)
odbc_cursor will return a cursorname for the given result_id.   odbc_connectUpodbc_data_source
#

#T=string odbc_cursor ( resource result_id)
odbc_cursor ( ^!resource result_id);
#

#T=odbc_data_source - resource odbc_data_source ( resource connection_id, constant fetch_type)
(PHP 4 >= 4.3.0)
odbc_data_source -- Returns information about a current connection
Description
resource odbc_data_source ( resource connection_id, constant fetch_type)
Returns FALSE on error, and an array upon success. 
This function will return information about the active connection 
following the information from within the DSN. The connection_id is 
required to be a valid ODBC connection. The fetch_type can be one of two 
constant types: SQL_FETCH_FIRST, SQL_FETCH_NEXT. Use SQL_FETCH_FIRST the 
first time this function is called, thereafter use the SQL_FETCH_NEXT.   odbc_cursorUpodbc_do
#

#T=resource odbc_data_source ( resource connection_id, constant fetch_type)
odbc_data_source ( ^!resource connection_id, constant fetch_type);
#

#T=odbc_do - resource odbc_do ( resource conn_id, string query)
(PHP 3>= 3.0.6, PHP 4 )
odbc_do -- Synonym for odbc_exec()
Description
resource odbc_do ( resource conn_id, string query)
odbc_do() will execute a query on the given connection.   odbc_data_sourceUpodbc_error
#

#T=resource odbc_do ( resource conn_id, string query)
odbc_do ( ^!resource conn_id, string query);
#

#T=odbc_error - string odbc_error ( [resource connection_id])
(PHP 4 >= 4.0.5)
odbc_error -- Get the last error code
Description
string odbc_error ( [resource connection_id])
Returns a six-digit ODBC state, or an empty string if there has been no 
errors. If connection_id is specified, the last state of that connection 
is returned, else the last state of any connection is returned. 
See also: odbc_errormsg() and odbc_exec().   odbc_doUpodbc_errormsg
#

#T=string odbc_error ( [resource connection_id])
odbc_error ( ^![resource connection_id]);
#

#T=odbc_errormsg - string odbc_errormsg ( [resource connection_id])
(PHP 4 >= 4.0.5)
odbc_errormsg -- Get the last error message
Description
string odbc_errormsg ( [resource connection_id])
Returns a string containing the last ODBC error message, or an empty 
string if there has been no errors. If connection_id is specified, the 
last state of that connection is returned, else the last state of any 
connection is returned. 
See also: odbc_error() and odbc_exec().   odbc_errorUpodbc_exec
#

#T=string odbc_errormsg ( [resource connection_id])
odbc_errormsg ( ^![resource connection_id]);
#

#T=odbc_exec - resource odbc_exec ( resource connection_id, string query_string)
(PHP 3>= 3.0.6, PHP 4 )
odbc_exec -- Prepare and execute a SQL statement
Description
resource odbc_exec ( resource connection_id, string query_string)
Returns FALSE on error. Returns an ODBC result identifier if the SQL 
command was executed successfully. 
odbc_exec() will send an SQL statement to the database server specified by 
connection_id. This parameter must be a valid identifier returned by 
odbc_connect() or odbc_pconnect(). 
See also: odbc_prepare() and odbc_execute() for multiple execution of SQL 
statements.   odbc_errormsgUpodbc_execute
#

#T=resource odbc_exec ( resource connection_id, string query_string)
odbc_exec ( ^!resource connection_id, string query_string);
#

#T=odbc_execute - bool odbc_execute ( resource result_id [, array parameters_array])
(PHP 3>= 3.0.6, PHP 4 )
odbc_execute -- Execute a prepared statement
Description
bool odbc_execute ( resource result_id [, array parameters_array])
Executes a statement prepared with odbc_prepare().Returns TRUE on success 
or FALSE on failure. The array parameters_array only needs to be given if 
you really have parameters in your statement. 
Parameters in parameter_array will be substituted for placeholders in the 
prepared statement in order. 
Any parameters in parameter_array which start and end with single quotes 
will be taken as the name of a file to read and send to the database 
server as the data for the appropriate placeholder. 
Note: As of PHP 4.1.1, this file reading functionality has the following 
restrictions: 
File reading is not subject to any safe mode or open-basedir 
restrictions. This is fixed in PHP 4.2.0. 
Remote files are not supported. 
If you wish to store a string which actually begins and ends with 
single quotes, you must escape them or add a space or other 
non-single-quote character to the beginning or end of the parameter, 
which will prevent the parameter's being taken as a file name. If this 
is not an option, then you must use another mechanism to store the 
string, such as executing the query directly with odbc_exec()).   odbc_execUpodbc_fetch_array
#

#T=bool odbc_execute ( resource result_id [, array parameters_array])
odbc_execute ( ^!resource result_id [, array parameters_array]);
#

#T=odbc_fetch_array - array odbc_fetch_array ( resource result [, int rownumber])
(PHP 4 >= 4.0.2)
odbc_fetch_array --  Fetch a result row as an associative array 
Description
array odbc_fetch_array ( resource result [, int rownumber])
Warning
This function is currently not documented; only the argument list is 
available.
  odbc_executeUpodbc_fetch_into
#

#T=array odbc_fetch_array ( resource result [, int rownumber])
odbc_fetch_array ( ^!resource result [, int rownumber]);
#

#T=odbc_fetch_into - bool odbc_fetch_into ( resource result_id [, int rownumber, array 
(PHP 3>= 3.0.6, PHP 4 )
odbc_fetch_into -- Fetch one result row into array
Description
bool odbc_fetch_into ( resource result_id [, int rownumber, array 
result_array])

resource odbc_fetch_into ( resource result_id, array result_array [, int 
rownumber])
Returns the number of columns in the result; FALSE on error. result_array 
must be passed by reference, but it can be of any type since it will be 
converted to type array. The array will contain the column values starting 
at array index 0. 
As of PHP 4.0.5 the result_array does not need to be passed by reference 
any longer. 
As of PHP 4.0.6 the rownumber cannot be passed as a constant, but rather 
as a variable. 
As of PHP 4.2.0 the result_array and rownumber have been swapped. This 
allows the rownumber to be a constant again. This change will also be the 
last one to this function. 
Example 1. odbc_fetch_into() pre 4.0.6 example 
  <?php
  $rc = odbc_fetch_into($res_id, $my_array);
  ?> 

or 
  <?php
  $rc = odbc_fetch_into($res_id, $row, $my_array);
	 
  $rc = odbc_fetch_into($res_id, 1, $my_array);
  ?> 
Example 2. odbc_fetch_into() 4.0.6 example
  <?php
  $rc = odbc_fetch_into($res_id, $my_array);
  ?> 

or 
  <?php
  $row = 1;
  $rc = odbc_fetch_into($res_id, $row, $my_array);
  ?> 
Example 3. odbc_fetch_into() 4.2.0 example
  <?php
  $rc = odbc_fetch_into($res_id, $my_array);
  ?> 

or 
  <?php
  $rc = odbc_fetch_into($res_id, $my_array, 2);
  ?> 

  odbc_fetch_arrayUpodbc_fetch_object
#

#T=bool odbc_fetch_into ( resource result_id [, int rownumber, array 
odbc_fetch_into ( ^!resource result_id [, int rownumber, array ;
#

#T=odbc_fetch_object - object odbc_fetch_object ( resource result [, int rownumber])
(PHP 4 >= 4.0.2)
odbc_fetch_object --  Fetch a result row as an object 
Description
object odbc_fetch_object ( resource result [, int rownumber])
Warning
This function is currently not documented; only the argument list is 
available.
  odbc_fetch_intoUpodbc_fetch_row
#

#T=object odbc_fetch_object ( resource result [, int rownumber])
odbc_fetch_object ( ^!resource result [, int rownumber]);
#

#T=odbc_fetch_row - bool odbc_fetch_row ( resource result_id [, int row_number])
(PHP 3>= 3.0.6, PHP 4 )
odbc_fetch_row -- Fetch a row
Description
bool odbc_fetch_row ( resource result_id [, int row_number])
If odbc_fetch_row() was successful (there was a row), TRUE is returned. If 
there are no more rows, FALSE is returned. 
odbc_fetch_row() fetches a row of the data that was returned by odbc_do() 
/ odbc_exec(). After odbc_fetch_row() is called, the fields of that row 
can be accessed with odbc_result(). 
If row_number is not specified, odbc_fetch_row() will try to fetch the 
next row in the result set. Calls to odbc_fetch_row() with and without 
row_number can be mixed. 
To step through the result more than once, you can call odbc_fetch_row() 
with row_number 1, and then continue doing odbc_fetch_row() without 
row_number to review the result. If a driver doesn't support fetching rows 
by number, the row_number parameter is ignored.   odbc_fetch_objectUpodbc_field_len
#

#T=bool odbc_fetch_row ( resource result_id [, int row_number])
odbc_fetch_row ( ^!resource result_id [, int row_number]);
#

#T=odbc_field_len - int odbc_field_len ( resource result_id, int field_number)
(PHP 3>= 3.0.6, PHP 4 )
odbc_field_len -- Get the length (precision) of a field
Description
int odbc_field_len ( resource result_id, int field_number)
odbc_field_len() will return the length of the field referenced by number 
in the given ODBC result identifier. Field numbering starts at 1. 
See also: odbc_field_scale() to get the scale of a floating point number.   odbc_fetch_rowUpodbc_field_name
#

#T=int odbc_field_len ( resource result_id, int field_number)
odbc_field_len ( ^!resource result_id, int field_number);
#

#T=odbc_field_name - string odbc_field_name ( resource result_id, int field_number)
(PHP 3>= 3.0.6, PHP 4 )
odbc_field_name -- Get the columnname
Description
string odbc_field_name ( resource result_id, int field_number)
odbc_field_name() will return the name of the field occupying the given 
column number in the given ODBC result identifier. Field numbering starts 
at 1. FALSE is returned on error.   odbc_field_lenUpodbc_field_num
#

#T=string odbc_field_name ( resource result_id, int field_number)
odbc_field_name ( ^!resource result_id, int field_number);
#

#T=odbc_field_num - int odbc_field_num ( resource result_id, string field_name)
(PHP 3>= 3.0.6, PHP 4 )
odbc_field_num -- Return column number
Description
int odbc_field_num ( resource result_id, string field_name)
odbc_field_num() will return the number of the column slot that 
corresponds to the named field in the given ODBC result identifier. Field 
numbering starts at 1. FALSE is returned on error.   odbc_field_nameUpodbc_field_precision
#

#T=int odbc_field_num ( resource result_id, string field_name)
odbc_field_num ( ^!resource result_id, string field_name);
#

#T=odbc_field_precision - string odbc_field_precision ( resource result_id, int field_number)
(PHP 4 )
odbc_field_precision -- Synonym for odbc_field_len()
Description
string odbc_field_precision ( resource result_id, int field_number)
odbc_field_precision() will return the precision of the field referenced 
by number in the given ODBC result identifier. 
See also: odbc_field_scale() to get the scale of a floating point number.   odbc_field_numUpodbc_field_scale
#

#T=string odbc_field_precision ( resource result_id, int field_number)
odbc_field_precision ( ^!resource result_id, int field_number);
#

#T=odbc_field_scale - string odbc_field_scale ( resource result_id, int field_number)
(PHP 4 )
odbc_field_scale -- Get the scale of a field
Description
string odbc_field_scale ( resource result_id, int field_number)
odbc_field_precision() will return the scale of the field referenced by 
number in the given ODBC result identifier.   odbc_field_precisionUpodbc_field_type
#

#T=string odbc_field_scale ( resource result_id, int field_number)
odbc_field_scale ( ^!resource result_id, int field_number);
#

#T=odbc_field_type - string odbc_field_type ( resource result_id, int field_number)
(PHP 3>= 3.0.6, PHP 4 )
odbc_field_type -- Datatype of a field
Description
string odbc_field_type ( resource result_id, int field_number)
odbc_field_type() will return the SQL type of the field referenced by 
number in the given ODBC result identifier. Field numbering starts at 1.   odbc_field_scaleUpodbc_foreignkeys
#

#T=string odbc_field_type ( resource result_id, int field_number)
odbc_field_type ( ^!resource result_id, int field_number);
#

#T=odbc_foreignkeys - resource odbc_foreignkeys ( resource connection_id, string pk_qualifier, 
(PHP 4 )
odbc_foreignkeys --  Returns a list of foreign keys in the specified table 
or a list of foreign keys in other tables that refer to the primary key in 
the specified table 
Description
resource odbc_foreignkeys ( resource connection_id, string pk_qualifier, 
string pk_owner, string pk_table, string fk_qualifier, string fk_owner, 
string fk_table)
odbc_foreignkeys() retrieves information about foreign keys. Returns an 
ODBC result identifier or FALSE on failure. 
The result set has the following columns: 
PKTABLE_QUALIFIER
PKTABLE_OWNER
PKTABLE_NAME
PKCOLUMN_NAME
FKTABLE_QUALIFIER
FKTABLE_OWNER
FKTABLE_NAME
FKCOLUMN_NAME
KEY_SEQ
UPDATE_RULE
DELETE_RULE
FK_NAME
PK_NAME
If pk_table contains a table name, odbc_foreignkeys() returns a result set 
containing the primary key of the specified table and all of the foreign 
keys that refer to it. 
If fk_table contains a table name, odbc_foreignkeys() returns a result set 
containing all of the foreign keys in the specified table and the primary 
keys (in other tables) to which they refer. 
If both pk_table and fk_table contain table names, odbc_foreignkeys() 
returns the foreign keys in the table specified in fk_table that refer to 
the primary key of the table specified in pk_table. This should be one key 
at most.   odbc_field_typeUpodbc_free_result
#

#T=resource odbc_foreignkeys ( resource connection_id, string pk_qualifier, 
odbc_foreignkeys ( ^!resource connection_id, string pk_qualifier, ;
#

#T=odbc_free_result - bool odbc_free_result ( resource result_id)
(PHP 3>= 3.0.6, PHP 4 )
odbc_free_result -- Free resources associated with a result
Description
bool odbc_free_result ( resource result_id)
Always returns TRUE. 
odbc_free_result() only needs to be called if you are worried about using 
too much memory while your script is running. All result memory will 
automatically be freed when the script is finished. But, if you are sure 
you are not going to need the result data anymore in a script, you may 
call odbc_free_result(), and the memory associated with result_id will be 
freed. 
Note: If auto-commit is disabled (see odbc_autocommit()) and you call 
odbc_free_result() before committing, all pending transactions are 
rolled back.   odbc_foreignkeysUpodbc_gettypeinfo
#

#T=bool odbc_free_result ( resource result_id)
odbc_free_result ( ^!resource result_id);
#

#T=odbc_gettypeinfo - int odbc_gettypeinfo ( resource connection_id [, int data_type])
(PHP 4 )
odbc_gettypeinfo --  Returns a result identifier containing information 
about data types supported by the data source. 
Description
int odbc_gettypeinfo ( resource connection_id [, int data_type])
Retrieves information about data types supported by the data source. 
Returns an ODBC result identifier or FALSE on failure. The optional 
argument data_type can be used to restrict the information to a single 
data type. 
The result set has the following columns: 
TYPE_NAME
DATA_TYPE
PRECISION
LITERAL_PREFIX
LITERAL_SUFFIX
CREATE_PARAMS
NULLABLE
CASE_SENSITIVE
SEARCHABLE
UNSIGNED_ATTRIBUTE
MONEY
AUTO_INCREMENT
LOCAL_TYPE_NAME
MINIMUM_SCALE
MAXIMUM_SCALE
The result set is ordered by DATA_TYPE and TYPE_NAME.   odbc_free_resultUpodbc_longreadlen
#

#T=int odbc_gettypeinfo ( resource connection_id [, int data_type])
odbc_gettypeinfo ( ^!resource connection_id [, int data_type]);
#

#T=odbc_longreadlen - int odbc_longreadlen ( resource result_id, int length)
(PHP 3>= 3.0.6, PHP 4 )
odbc_longreadlen -- Handling of LONG columns
Description
int odbc_longreadlen ( resource result_id, int length)
(ODBC SQL types affected: LONG, LONGVARBINARY) The number of bytes 
returned to PHP is controlled by the parameter length. If it is set to 0, 
Long column data is passed through to the client. 
Note: Handling of LONGVARBINARY columns is also affected by 
odbc_binmode().   odbc_gettypeinfoUpodbc_next_result
#

#T=int odbc_longreadlen ( resource result_id, int length)
odbc_longreadlen ( ^!resource result_id, int length);
#

#T=odbc_next_result - bool odbc_next_result ( resource result_id)
(PHP 4 >= 4.0.5)
odbc_next_result --  Checks if multiple results are available 
Description
bool odbc_next_result ( resource result_id)
Warning
This function is currently not documented; only the argument list is 
available.
  odbc_longreadlenUpodbc_num_fields
#

#T=bool odbc_next_result ( resource result_id)
odbc_next_result ( ^!resource result_id);
#

#T=odbc_num_fields - int odbc_num_fields ( resource result_id)
(PHP 3>= 3.0.6, PHP 4 )
odbc_num_fields -- Number of columns in a result
Description
int odbc_num_fields ( resource result_id)
odbc_num_fields() will return the number of fields (columns) in an ODBC 
result. This function will return -1 on error. The argument is a valid 
result identifier returned by odbc_exec().   odbc_next_resultUpodbc_num_rows
#

#T=int odbc_num_fields ( resource result_id)
odbc_num_fields ( ^!resource result_id);
#

#T=odbc_num_rows - int odbc_num_rows ( resource result_id)
(PHP 3>= 3.0.6, PHP 4 )
odbc_num_rows -- Number of rows in a result
Description
int odbc_num_rows ( resource result_id)
odbc_num_rows() will return the number of rows in an ODBC result. This 
function will return -1 on error. For INSERT, UPDATE and DELETE statements 
odbc_num_rows() returns the number of rows affected. For a SELECT clause 
this can be the number of rows available. 
Note: Using odbc_num_rows() to determine the number of rows available 
after a SELECT will return -1 with many drivers.   odbc_num_fieldsUpodbc_pconnect
#

#T=int odbc_num_rows ( resource result_id)
odbc_num_rows ( ^!resource result_id);
#

#T=odbc_pconnect - resource odbc_pconnect ( string dsn, string user, string password [, int 
(PHP 3>= 3.0.6, PHP 4 )
odbc_pconnect -- Open a persistent database connection
Description
resource odbc_pconnect ( string dsn, string user, string password [, int 
cursor_type])
Returns an ODBC connection id or 0 (FALSE) on error. This function is much 
like odbc_connect(), except that the connection is not really closed when 
the script has finished. Future requests for a connection with the same 
dsn, user, password combination (via odbc_connect() and odbc_pconnect()) 
can reuse the persistent connection. 
Note: Persistent connections have no effect if PHP is used as a CGI 
program. 
For information about the optional cursor_type parameter see the 
odbc_connect() function. For more information on persistent connections, 
refer to the PHP FAQ.   odbc_num_rowsUpodbc_prepare
#

#T=resource odbc_pconnect ( string dsn, string user, string password [, int 
odbc_pconnect ( ^!string dsn, string user, string password [, int ;
#

#T=odbc_prepare - resource odbc_prepare ( resource connection_id, string query_string)
(PHP 3>= 3.0.6, PHP 4 )
odbc_prepare -- Prepares a statement for execution
Description
resource odbc_prepare ( resource connection_id, string query_string)
Returns FALSE on error. 
Returns an ODBC result identifier if the SQL command was prepared 
successfully. The result identifier can be used later to execute the 
statement with odbc_execute().   odbc_pconnectUpodbc_primarykeys
#

#T=resource odbc_prepare ( resource connection_id, string query_string)
odbc_prepare ( ^!resource connection_id, string query_string);
#

#T=odbc_primarykeys - resource odbc_primarykeys ( resource connection_id, string qualifier, 
(PHP 4 )
odbc_primarykeys --  Returns a result identifier that can be used to fetch 
the column names that comprise the primary key for a table 
Description
resource odbc_primarykeys ( resource connection_id, string qualifier, 
string owner, string table)
Returns the column names that comprise the primary key for a table. 
Returns an ODBC result identifier or FALSE on failure. 
The result set has the following columns: 
TABLE_QUALIFIER
TABLE_OWNER
TABLE_NAME
COLUMN_NAME
KEY_SEQ
PK_NAME  odbc_prepareUpodbc_procedurecolumns
#

#T=resource odbc_primarykeys ( resource connection_id, string qualifier, 
odbc_primarykeys ( ^!resource connection_id, string qualifier, ;
#

#T=odbc_procedurecolumns - resource odbc_procedurecolumns ( resource connection_id [, string 
(PHP 4 )
odbc_procedurecolumns --  Retrieve information about parameters to 
procedures 
Description
resource odbc_procedurecolumns ( resource connection_id [, string 
qualifier [, string owner [, string proc [, string column]]]])
Returns the list of input and output parameters, as well as the columns 
that make up the result set for the specified procedures. Returns an ODBC 
result identifier or FALSE on failure. 
The result set has the following columns: 
PROCEDURE_QUALIFIER
PROCEDURE_OWNER
PROCEDURE_NAME
COLUMN_NAME
COLUMN_TYPE
DATA_TYPE
TYPE_NAME
PRECISION
LENGTH
SCALE
RADIX
NULLABLE
REMARKS
The result set is ordered by PROCEDURE_QUALIFIER, PROCEDURE_OWNER, 
PROCEDURE_NAME and COLUMN_TYPE. 
The owner, proc and column arguments accept search patterns ('%' to match 
zero or more characters and '_' to match a single character).   odbc_primarykeysUpodbc_procedures
#

#T=resource odbc_procedurecolumns ( resource connection_id [, string 
odbc_procedurecolumns ( ^!resource connection_id [, string ;
#

#T=odbc_procedures - resource odbc_procedures ( resource connection_id [, string qualifier [, 
(PHP 4 )
odbc_procedures --  Get the list of procedures stored in a specific data 
source. Returns a result identifier containing the information. 
Description
resource odbc_procedures ( resource connection_id [, string qualifier [, 
string owner [, string name]]])
Lists all procedures in the requested range. Returns an ODBC result 
identifier or FALSE on failure. 
The result set has the following columns: 
PROCEDURE_QUALIFIER
PROCEDURE_OWNER
PROCEDURE_NAME
NUM_INPUT_PARAMS
NUM_OUTPUT_PARAMS
NUM_RESULT_SETS
REMARKS
PROCEDURE_TYPE
The owner and name arguments accept search patterns ('%' to match zero or 
more characters and '_' to match a single character).   odbc_procedurecolumnsUpodbc_result_all
#

#T=resource odbc_procedures ( resource connection_id [, string qualifier [, 
odbc_procedures ( ^!resource connection_id [, string qualifier [, ;
#

#T=odbc_result_all - int odbc_result_all ( resource result_id [, string format])
(PHP 3>= 3.0.6, PHP 4 )
odbc_result_all -- Print result as HTML table
Description
int odbc_result_all ( resource result_id [, string format])
Returns the number of rows in the result or FALSE on error. 
odbc_result_all() will print all rows from a result identifier produced by 
odbc_exec(). The result is printed in HTML table format. With the optional 
string argument format, additional overall table formatting can be done.   odbc_proceduresUpodbc_result
#

#T=int odbc_result_all ( resource result_id [, string format])
odbc_result_all ( ^!resource result_id [, string format]);
#

#T=odbc_result - string odbc_result ( resource result_id, mixed field)
(PHP 3>= 3.0.6, PHP 4 )
odbc_result -- Get result data
Description
string odbc_result ( resource result_id, mixed field)
Returns the contents of the field. 
field can either be an integer containing the column number of the field 
you want; or it can be a string containing the name of the field. For 
example: 
$item_3 = odbc_result($Query_ID, 3);
$item_val = odbc_result($Query_ID, "val"); 

The first call to odbc_result() returns the value of the third field in 
the current record of the query result. The second function call to 
odbc_result() returns the value of the field whose field name is "val" in 
the current record of the query result. An error occurs if a column number 
parameter for a field is less than one or exceeds the number of columns 
(or fields) in the current record. Similarly, an error occurs if a field 
with a name that is not one of the fieldnames of the table(s) that is(are) 
being queried. 
Field indices start from 1. Regarding the way binary or long column data 
is returned refer to odbc_binmode() and odbc_longreadlen().   odbc_result_allUpodbc_rollback
#

#T=string odbc_result ( resource result_id, mixed field)
odbc_result ( ^!resource result_id, mixed field);
#

#T=odbc_rollback - int odbc_rollback ( resource connection_id)
(PHP 3>= 3.0.6, PHP 4 )
odbc_rollback -- Rollback a transaction
Description
int odbc_rollback ( resource connection_id)
Rolls back all pending statements on connection_id. Returns TRUE on 
success, FALSE on failure.   odbc_resultUpodbc_setoption
#

#T=int odbc_rollback ( resource connection_id)
odbc_rollback ( ^!resource connection_id);
#

#T=odbc_setoption - int odbc_setoption ( resource id, int function, int option, int param)
(PHP 3>= 3.0.6, PHP 4 )
odbc_setoption --  Adjust ODBC settings. Returns FALSE if an error occurs, 
otherwise TRUE. 
Description
int odbc_setoption ( resource id, int function, int option, int param)
This function allows fiddling with the ODBC options for a particular 
connection or query result. It was written to help find work around to 
problems in quirky ODBC drivers. You should probably only use this 
function if you are an ODBC programmer and understand the effects the 
various options will have. You will certainly need a good ODBC reference 
to explain all the different options and values that can be used. 
Different driver versions support different options. 
Because the effects may vary depending on the ODBC driver, use of this 
function in scripts to be made publicly available is strongly discouraged. 
Also, some ODBC options are not available to this function because they 
must be set before the connection is established or the query is prepared. 
However, if on a particular job it can make PHP work so your boss doesn't 
tell you to use a commercial product, that's all that really matters. 
id is a connection id or result id on which to change the settings.For 
SQLSetConnectOption(), this is a connection id. For SQLSetStmtOption(), 
this is a result id. 
Function is the ODBC function to use. The value should be 1 for 
SQLSetConnectOption() and 2 for SQLSetStmtOption(). 
Parameter option is the option to set.
Parameter param is the value for the given option. Example 1. ODBC 
Setoption Examples
  <?php
  // 1. Option 102 of SQLSetConnectOption() is SQL_AUTOCOMMIT.
  //    Value 1 of SQL_AUTOCOMMIT is SQL_AUTOCOMMIT_ON.
  //    This example has the same effect as
  //    odbc_autocommit($conn, true);

  odbc_setoption($conn, 1, 102, 1);

  // 2. Option 0 of SQLSetStmtOption() is SQL_QUERY_TIMEOUT.
  //    This example sets the query to timeout after 30 seconds.

  $result = odbc_prepare($conn, $sql);
  odbc_setoption($result, 2, 0, 30);
  odbc_execute($result);
  ?> 

  odbc_rollbackUpodbc_specialcolumns
#

#T=int odbc_setoption ( resource id, int function, int option, int param)
odbc_setoption ( ^!resource id, int function, int option, int param);
#

#T=odbc_specialcolumns - resource odbc_specialcolumns ( resource connection_id, int type, string 
(PHP 4 )
odbc_specialcolumns --  Returns either the optimal set of columns that 
uniquely identifies a row in the table or columns that are automatically 
updated when any value in the row is updated by a transaction 
Description
resource odbc_specialcolumns ( resource connection_id, int type, string 
qualifier, string owner, string table, int scope, int nullable)
When the type argument is SQL_BEST_ROWID, odbc_specialcolumns() returns 
the column or columns that uniquely identify each row in the table. 
When the type argument is SQL_ROWVER, odbc_specialcolumns() returns the 
optimal column or set of columns that, by retrieving values from the 
column or columns, allows any row in the specified table to be uniquely 
identified. 
Returns an ODBC result identifier or FALSE on failure. 
The result set has the following columns: 
SCOPE
COLUMN_NAME
DATA_TYPE
TYPE_NAME
PRECISION
LENGTH
SCALE
PSEUDO_COLUMN
The result set is ordered by SCOPE.   odbc_setoptionUpodbc_statistics
#

#T=resource odbc_specialcolumns ( resource connection_id, int type, string 
odbc_specialcolumns ( ^!resource connection_id, int type, string ;
#

#T=odbc_statistics - resource odbc_statistics ( resource connection_id, string qualifier, 
(PHP 4 )
odbc_statistics -- Retrieve statistics about a table
Description
resource odbc_statistics ( resource connection_id, string qualifier, 
string owner, string table_name, int unique, int accuracy)
Get statistics about a table and it's indexes. Returns an ODBC result 
identifier or FALSE on failure. 
The result set has the following columns: 
TABLE_QUALIFIER
TABLE_OWNER
TABLE_NAME
NON_UNIQUE
INDEX_QUALIFIER
INDEX_NAME
TYPE
SEQ_IN_INDEX
COLUMN_NAME
COLLATION
CARDINALITY
PAGES
FILTER_CONDITION
The result set is ordered by NON_UNIQUE, TYPE, INDEX_QUALIFIER, INDEX_NAME 
and SEQ_IN_INDEX.   odbc_specialcolumnsUpodbc_tableprivileges
#

#T=resource odbc_statistics ( resource connection_id, string qualifier, 
odbc_statistics ( ^!resource connection_id, string qualifier, ;
#

#T=odbc_tableprivileges - int odbc_tableprivileges ( resource connection_id [, string qualifier [, 
(PHP 4 )
odbc_tableprivileges --  Lists tables and the privileges associated with 
each table 
Description
int odbc_tableprivileges ( resource connection_id [, string qualifier [, 
string owner [, string name]]])
Lists tables in the requested range and the privileges associated with 
each table. Returns an ODBC result identifier or FALSE on failure. 
The result set has the following columns: 
TABLE_QUALIFIER
TABLE_OWNER
TABLE_NAME
GRANTOR
GRANTEE
PRIVILEGE
IS_GRANTABLE
The result set is ordered by TABLE_QUALIFIER, TABLE_OWNER and TABLE_NAME. 
The owner and name arguments accept search patterns ('%' to match zero or 
more characters and '_' to match a single character).   odbc_statisticsUpodbc_tables
#

#T=int odbc_tableprivileges ( resource connection_id [, string qualifier [, 
odbc_tableprivileges ( ^!resource connection_id [, string qualifier [, ;
#

#T=odbc_tables - int odbc_tables ( resource connection_id [, string qualifier [, string 
(PHP 3>= 3.0.17, PHP 4 )
odbc_tables --  Get the list of table names stored in a specific data 
source. Returns a result identifier containing the information. 
Description
int odbc_tables ( resource connection_id [, string qualifier [, string 
owner [, string name [, string types]]]])
Lists all tables in the requested range. Returns an ODBC result identifier 
or FALSE on failure. 
The result set has the following columns: 
TABLE_QUALIFIER
TABLE_OWNER
TABLE_NAME
TABLE_TYPE
REMARKS
The result set is ordered by TABLE_TYPE, TABLE_QUALIFIER, TABLE_OWNER and 
TABLE_NAME. 
The owner and name arguments accept search patterns ('%' to match zero or 
more characters and '_' to match a single character). 
To support enumeration of qualifiers, owners, and table types, the 
following special semantics for the qualifier, owner, name, and table_type 
are available: 
If qualifier is a single percent character (%) and owner and name are 
empty strings, then the result set contains a list of valid qualifiers 
for the data source. (All columns except the TABLE_QUALIFIER column 
contain NULLs.) 
If owner is a single percent character (%) and qualifier and name are 
empty strings, then the result set contains a list of valid owners for 
the data source. (All columns except the TABLE_OWNER column contain 
NULLs.) 
If table_type is a single percent character (%) and qualifier, owner and 
name are empty strings, then the result set contains a list of valid 
table types for the data source. (All columns except the TABLE_TYPE 
column contain NULLs.) 
If table_type is not an empty string, it must contain a list of 
comma-separated values for the types of interest; each value may be 
enclosed in single quotes (') or unquoted. For example, "'TABLE','VIEW'" 
or "TABLE, VIEW". If the data source does not support a specified table 
type, odbc_tables() does not return any results for that type. 
See also odbc_tableprivileges() to retrieve associated privileges.   odbc_tableprivilegesUpObject Aggregation/Composition Functions
#

#T=int odbc_tables ( resource connection_id [, string qualifier [, string 
odbc_tables ( ^!resource connection_id [, string qualifier [, string ;
#

#T=opendir - resource opendir ( string path)
(PHP 3, PHP 4 )
opendir -- open directory handle
Description
resource opendir ( string path)
Returns a directory handle to be used in subsequent closedir(), readdir(), 
and rewinddir() calls. 
If path is not a valid directory or the directory can not be opened due to 
permission restrictions or filesystem errors, opendir() returns FALSE and 
generates a PHP error of level E_WARNING. You can suppress the error 
output of opendir() by prepending '@' to the front of the function name. 
Example 1. opendir() example
  <?php
  $dir = "/tmp/";

  // Open a known directory, and proceed to read its contents
  if (is_dir($dir)) {
      if ($dh = opendir($dir)) {
	  while (($file = readdir($dh)) !== false) {
	      echo "filename: $file : filetype: " . 
  filetype($dir . $file) . "\n";
	  }
	  closedir($dh);
      }
  }
  ?> 
As of PHP 4.3.0 path can also be any URL which supports directory listing, 
however only the file:// url wrapper supports this in PHP 4.3. As of PHP 
5.0.0, support for the ftp:// url wrapper is included as well. 
See also is_dir(), readdir(), and Dir   getcwdUpreaddir
#

#T=resource opendir ( string path)
opendir ( ^!string path);
#

#T=openlog - int openlog ( string ident, int option, int facility)
(PHP 3, PHP 4 )
openlog -- Open connection to system logger
Description
int openlog ( string ident, int option, int facility)
openlog() opens a connection to the system logger for a program. The 
string ident is added to each message. Values for option and facility are 
given below. The option argument is used to indicate what logging options 
will be used when generating a log message. The facility argument is used 
to specify what type of program is logging the message. This allows you to 
specify (in your machine's syslog configuration) how messages coming from 
different facilities will be handled. The use of openlog() is optional. It 
will automatically be called by syslog() if necessary, in which case ident 
will default to FALSE. 
Table 1. openlog() Options
ConstantDescription
LOG_CONSif there is an error while sending data to the system 
logger, write directly to the system console 
LOG_NDELAYopen the connection to the logger immediately 
LOG_ODELAY(default) delay opening the connection until the first 
message is logged 
LOG_PERRORprint log message also to standard error
LOG_PIDinclude PID with each message

You can use one or more of this options. When using multiple options you 
need to OR them, i.e. to open the connection immediately, write to the 
console and include the PID in each message, you will use: LOG_CONS | 
LOG_NDELAY | LOG_PID 
Table 2. openlog() Facilities
ConstantDescription
LOG_AUTHsecurity/authorization messages (use LOG_AUTHPRIV instead in 
systems where that constant is defined) 
LOG_AUTHPRIVsecurity/authorization messages (private)
LOG_CRONclock daemon (cron and at)
LOG_DAEMONother system daemons
LOG_KERNkernel messages
LOG_LOCAL0 ... LOG_LOCAL7reserved for local use, these are not 
available in Windows
LOG_LPRline printer subsystem
LOG_MAILmail subsystem
LOG_NEWSUSENET news subsystem
LOG_SYSLOGmessages generated internally by syslogd
LOG_USERgeneric user-level messages
LOG_UUCPUUCP subsystem

Note: LOG_USER is the only valid log type under Windows operating 
systems 
See also define_syslog_variables(), syslog() and closelog().   long2ipUppfsockopen
#

#T=int openlog ( string ident, int option, int facility)
openlog ( ^!string ident, int option, int facility);
#

#T=openssl_csr_export_to_file - bool openssl_csr_export_to_file ( resource csr, string outfilename [, bool 
(PHP 4 >= 4.2.0)
openssl_csr_export_to_file -- Exports a CSR to a file
Description
bool openssl_csr_export_to_file ( resource csr, string outfilename [, bool 
notext])
openssl_csr_export_to_file() takes the Certificate Signing Request 
represented by csr and saves it as ascii-armoured text into the file named 
by outfilename. 
The optional parameter notext affects the verbosity of the output; if it 
is FALSE then additional human-readable information is included in the 
output. The default value of notext is TRUE. 
Returns TRUE on success or FALSE on failure. 
See also openssl_csr_export(), openssl_csr_new() and openssl_csr_sign().   OpenSSL functionsUpopenssl_csr_export
#

#T=bool openssl_csr_export_to_file ( resource csr, string outfilename [, bool 
openssl_csr_export_to_file ( ^!resource csr, string outfilename [, bool ;
#

#T=openssl_csr_export - bool openssl_csr_export ( resource csr, string &out [, bool notext])
(PHP 4 >= 4.2.0)
openssl_csr_export -- Exports a CSR as a string
Description
bool openssl_csr_export ( resource csr, string &out [, bool notext])
openssl_csr_export() takes the Certificate Signing Request represented by 
csr and stores it as ascii-armoured text into out, which is passed by 
reference. 
The optional parameter notext affects the verbosity of the output; if it 
is FALSE then additional human-readable information is included in the 
output. The default value of notext is TRUE. 
Returns TRUE on success or FALSE on failure. 
See also openssl_csr_export_to_file(), openssl_csr_new() and 
openssl_csr_sign().   openssl_csr_export_to_fileUpopenssl_csr_new
#

#T=bool openssl_csr_export ( resource csr, string &out [, bool notext])
openssl_csr_export ( ^!resource csr, string &out [, bool notext]);
#

#T=openssl_csr_new - bool openssl_csr_new ( array dn, resource privkey [, array configargs [, 
(PHP 4 >= 4.2.0)
openssl_csr_new -- Generates a CSR
Description
bool openssl_csr_new ( array dn, resource privkey [, array configargs [, 
array extraattribs]])
openssl_csr_new() generates a new CSR (Certificate Signing Request) based 
on the information provided by dn, which represents the Distinguished Name 
to be used in the certificate. 
privkey should be set to a private key that was previously generated by 
openssl_pkey_new() (or otherwise obtained from the other openssl_pkey 
family of functions). The corresponding public portion of the key will be 
used to sign the CSR. 
extraattribs is used to specify additional configuration options for the 
CSR. Both dn and extraattribs are associative arrays whose keys are 
converted to OIDs and applied to the relevant part of the request. 
Note: You need to have a valid openssl.cnf installed for this function 
to operate correctly. See the notes under the installation section for 
more information. 
By default, the information in your system openssl.conf is used to 
initialize the request; you can specify a configuration file section by 
setting the config_section_section key of configargs. You can also specify 
an alternative openssl configuration file by setting the value of the 
config key to the path of the file you want to use. The following keys, if 
present in configargs behave as their equivalents in the openssl.conf, as 
listed in the table below. 
Table 1. Configuration overrides
configargs keytypeopenssl.conf equivalentdescription
digest_algstringdefault_mdSelects which digest method to use
x509_extensionsstringx509_extensionsSelects which extensions should 
be used when creating an x509 certificate
req_extensionsstringreq_extensionsSelects which extensions should be 
used when creating a CSR
private_key_bitsstringdefault_bitsSpecifies how many bits should be 
used to generate a private key
private_key_typeintegernoneSpecifies the type of private key to 
create. This can be one of OPENSSL_KEYTYPE_DSA, OPENSSL_KEYTYPE_DH 
or OPENSSL_KEYTYPE_RSA. The default value is OPENSSL_KEYTYPE_RSA 
which is currently the only supported key type. 
encrypt_keybooleanencrypt_keyShould an exported key (with 
passphrase) be encrypted?

Returns TRUE on success or FALSE on failure. 
Example 1. openssl_csr_new() example - creating a 
self-signed-certificate
  <?php
  // Fill in data for the distinguished name to be used in the 
  cert
  // You must change the values of these keys to match your name 
  and
  // company, or more precisely, the name and company of the 
  person/site
  // that you are generating the certificate for.
  // For SSL certificates, the commonName is usually the domain 
  name of
  // that will be using the certificate, but for S/MIME 
  certificates,
  // the commonName will be the name of the individual who will 
  use the
  // certificate.
  $dn = array(
      "countryName" => "UK",
      "stateOrProvinceName" => "Somerset",
      "localityName" => "Glastonbury",
      "organizationName" => "The Brain Room Limited",
      "organizationalUnitName" => "PHP Documentation Team",
      "commonName" => "Wez Furlong",
      "emailAddress" => "wez@example.com"
  );

  // Generate a new private (and public) key pair
  $privkey = openssl_pkey_new();

  // Generate a certificate signing request
  $csr = openssl_csr_new($dn, $privkey);

  // You will usually want to create a self-signed certificate 
  at this
  // point until your CA fulfills your request.
  // This creates a self-signed cert that is valid for 365 days
  $sscert = openssl_csr_sign($csr, null, $privkey, 365);

  // Now you will want to preserve your private key, CSR and 
  self-signed
  // cert so that they can be installed into your web server, 
  mail server
  // or mail client (depending on the intended use of the 
  certificate).
  // This example shows how to get those things into variables, 
  but you
  // can also store them directly into files.
  // Typically, you will send the CSR on to your CA who will 
  then issue
  // you with the "real" certificate.
  openssl_csr_export($csr, $csrout) and 
debug_zval_dump($csrout);
  openssl_x509_export($sscert, $certout) and 
  debug_zval_dump($certout);
  openssl_pkey_export($privkey, $pkeyout, "mypassword") and 
  debug_zval_dump($pkeyout);

  // Show any errors that occurred here
  while (($e = openssl_error_string()) !== false) {
      echo $e . "\n";
  }
  ?> 

  openssl_csr_exportUpopenssl_csr_sign
#

#T=bool openssl_csr_new ( array dn, resource privkey [, array configargs [, 
openssl_csr_new ( ^!array dn, resource privkey [, array configargs [, ;
#

#T=openssl_csr_sign - resource openssl_csr_sign ( mixed csr, mixed cacert, mixed priv_key, int 
(PHP 4 >= 4.2.0)
openssl_csr_sign -- Sign a CSR with another certificate (or itself) and 
generate a certificate
Description
resource openssl_csr_sign ( mixed csr, mixed cacert, mixed priv_key, int 
days [, array configargs [, int serial]])
openssl_csr_sign() generates an x509 certificate resource from the csr 
previously generated by openssl_csr_new(), but it can also be the path to 
a PEM encoded CSR when specified as file://path/to/csr or an exported 
string generated by openssl_csr_export(). The generated certificate will 
be signed by cacert. If cacert is NULL, the generated certificate will be 
a self-signed certificate. priv_key is the private key that corresponds to 
cacert. days specifies the length of time for which the generated 
certificate will be valid, in days. You can finetune the CSR signing by 
configargs. See openssl_csr_new() for more information about configargs. 
Since PHP 4.3.3 you can specify the serial number of issued certificate by 
serial. In earlier versions, it was always 0. 
Returns an x509 certificate resource on success, FALSE on failure. 
Note: You need to have a valid openssl.cnf installed for this function 
to operate correctly. See the notes under the installation section for 
more information. 
Example 1. openssl_csr_sign() example - signing a CSR (how to 
implement your own CA)
  <?php
  // Let's assume that this script is set to receive a CSR that 
  has
  // been pasted into a textarea from another page
  $csrdata = $_POST["CSR"];

  // We will sign the request using our own "certificate 
  authority"
  // certificate.  You can use any certificate to sign another, 
  but
  // the process is worthless unless the signing certificate is 
  trusted
  // by the software/users that will deal with the newly signed 
  certificate

  // We need our CA cert and it's private key
  $cacert = "file://path/to/ca.crt";
  $privkey = array("file://path/to/ca.key", 
  "your_ca_key_passphrase");

  $userscert = openssl_csr_sign($csrdata, $cacert, $privkey, 
  365);

  // Now display the generated certificate so that the user can
  // copy and paste it into their local configuration (such as a 
  file
  // to hold the certificate for their SSL server)
  openssl_x509_export($usercert, $certout);
  echo $certout;

  // Show any errors that occurred here
  while (($e = openssl_error_string()) !== false) {
      echo $e . "\n";
  }
  ?> 

  openssl_csr_newUpopenssl_error_string
#

#T=resource openssl_csr_sign ( mixed csr, mixed cacert, mixed priv_key, int 
openssl_csr_sign ( ^!mixed csr, mixed cacert, mixed priv_key, int ;
#

#T=openssl_error_string - mixed openssl_error_string ( void )
(PHP 4 >= 4.0.6)
openssl_error_string -- Return openSSL error message
Description
mixed openssl_error_string ( void )
Returns an error message string, or FALSE if there are no more error 
messages to return. 
openssl_error_string() returns the last error from the openSSL library. 
Error messages are stacked, so this function should be called multiple 
times to collect all of the information. 
Example 1. openssl_error_string() example
  <?php
  // lets assume you just called an openssl function that failed
  while ($msg = openssl_error_string())
      echo $msg . "<br />\n";
  ?> 
Note: This function was added in 4.0.6.   openssl_csr_signUpopenssl_free_key
#

#T=mixed openssl_error_string ( void )
openssl_error_string ( ^!void );
#

#T=openssl_free_key - void openssl_free_key ( resource key_identifier)
(PHP 4 >= 4.0.4)
openssl_free_key -- Free key resource
Description
void openssl_free_key ( resource key_identifier)
openssl_free_key() frees the key associated with the specified 
key_identifier from memory.   openssl_error_stringUpopenssl_get_privatekey
#

#T=void openssl_free_key ( resource key_identifier)
openssl_free_key ( ^!resource key_identifier);
#

#T=openssl_get_privatekey - resource openssl_get_privatekey ( mixed key [, string passphrase])
(PHP 4 >= 4.0.4)
openssl_get_privatekey -- Get a private key
Description
resource openssl_get_privatekey ( mixed key [, string passphrase])
This is an alias for openssl_pkey_get_private().   openssl_free_keyUpopenssl_get_publickey
#

#T=resource openssl_get_privatekey ( mixed key [, string passphrase])
openssl_get_privatekey ( ^!mixed key [, string passphrase]);
#

#T=openssl_get_publickey - resource openssl_get_publickey ( mixed certificate)
(PHP 4 >= 4.0.4)
openssl_get_publickey -- Extract public key from certificate and prepare 
it for use
Description
resource openssl_get_publickey ( mixed certificate)
This is an alias for openssl_pkey_get_public().   openssl_get_privatekeyUpopenssl_open
#

#T=resource openssl_get_publickey ( mixed certificate)
openssl_get_publickey ( ^!mixed certificate);
#

#T=openssl_open - bool openssl_open ( string sealed_data, string open_data, string env_key, 
(PHP 4 >= 4.0.4)
openssl_open -- Open sealed data
Description
bool openssl_open ( string sealed_data, string open_data, string env_key, 
mixed priv_key_id)
Returns TRUE on success or FALSE on failure. If successful the opened data 
is returned in open_data. 
openssl_open() opens (decrypts) sealed_data using the private key 
associated with the key identifier priv_key_id and the envelope key 
env_key, and fills open_data with the decrypted data. The envelope key is 
generated when the data are sealed and can only be used by one specific 
private key. See openssl_seal() for more information. 
Example 1. openssl_open() example
  <?php
  // $sealed and $env_key are assumed to contain the sealed data
  // and our envelope key, both given to us by the sealer.

  // fetch private key from file and ready it
  $fp = fopen("/src/openssl-0.9.6/demos/sign/key.pem", "r");
  $priv_key = fread($fp, 8192);
  fclose($fp);
  $pkeyid = openssl_get_privatekey($priv_key);

  // decrypt the data and store it in $open
  if (openssl_open($sealed, $open, $env_key, $pkeyid)) {
      echo "here is the opened data: ", $open;
  } else {
      echo "failed to open data";
  }

  // free the private key from memory
  openssl_free_key($pkeyid);
  ?> 
See also openssl_seal().   openssl_get_publickeyUpopenssl_pkcs7_decrypt
#

#T=bool openssl_open ( string sealed_data, string open_data, string env_key, 
openssl_open ( ^!string sealed_data, string open_data, string env_key, ;
#

#T=openssl_pkcs7_decrypt - bool openssl_pkcs7_decrypt ( string infilename, string outfilename, mixed 
(PHP 4 >= 4.0.6)
openssl_pkcs7_decrypt -- Decrypts an S/MIME encrypted message
Description
bool openssl_pkcs7_decrypt ( string infilename, string outfilename, mixed 
recipcert [, mixed recipkey])
Decrypts the S/MIME encrypted message contained in the file specified by 
infilename using the certificate and it's associated private key specified 
by recipcert and recipkey. 
The decrypted message is output to the file specified by outfilename 
Example 1. openssl_pkcs7_decrypt() example
  <?php
  // $cert and $key are assumed to contain your personal 
  certificate and private
  // key pair, and that you are the recipient of an S/MIME 
  message
  $infilename = "encrypted.msg";  // this file holds your 
  encrypted message
  $outfilename = "decrypted.msg"; // make sure you can write to 
  this file

  if (openssl_pkcs7_decrypt($infilename, $outfilename, $cert, 
  $key)) {
      echo "decrypted!";
  } else {
      echo "failed to decrypt!";
  }
  ?> 
Note: This function was added in 4.0.6.  openssl_openUpopenssl_pkcs7_encrypt
#

#T=bool openssl_pkcs7_decrypt ( string infilename, string outfilename, mixed 
openssl_pkcs7_decrypt ( ^!string infilename, string outfilename, mixed ;
#

#T=openssl_pkcs7_encrypt - bool openssl_pkcs7_encrypt ( string infile, string outfile, mixed 
(PHP 4 >= 4.0.6)
openssl_pkcs7_encrypt -- Encrypt an S/MIME message
Description
bool openssl_pkcs7_encrypt ( string infile, string outfile, mixed 
recipcerts, array headers [, int flags])
openssl_pkcs7_encrypt() takes the contents of the file named infile and 
encrypts them using an RC2 40-bit cipher so that they can only be read by 
the intended recipients specified by recipcerts, which is either a lone 
X.509 certificate, or an array of X.509 certificates. headers is an array 
of headers that will be prepended to the data after it has been encrypted. 
flags can be used to specify options that affect the encoding process - 
see PKCS7 constants. headers can be either an associative array keyed by 
header name, or an indexed array, where each element contains a single 
header line. 
Example 1. openssl_pkcs7_encrypt() example
  <?php
  // the message you want to encrypt and send to your secret 
  agent
  // in the field, known as nighthawk.  You have his certificate
  // in the file nighthawk.pem
  $data = <<<EOD
  Nighthawk,

  Top secret, for your eyes only!

  The enemy is closing in! Meet me at the cafe at 8.30am
  to collect your forged passport!

  HQ
  EOD;

  // load key
  $key = file_get_contents("nighthawk.pem");

  // save message to file
  $fp = fopen("msg.txt", "w");
  fwrite($fp, $data);
  fclose($fp);

  // encrypt it
  if (openssl_pkcs7_encrypt("msg.txt", "enc.txt", $key,
      array("To" => "nighthawk@example.com", // keyed syntax
	    "From: HQ <hq@example.com>", // indexed syntax
	    "Subject" => "Eyes only"))) {
      // message encrypted - send it!
      exec(ini_get("sendmail_path") . " < enc.txt");
  }
  ?> 

  openssl_pkcs7_decryptUpopenssl_pkcs7_sign
#

#T=bool openssl_pkcs7_encrypt ( string infile, string outfile, mixed 
openssl_pkcs7_encrypt ( ^!string infile, string outfile, mixed ;
#

#T=openssl_pkcs7_sign - bool openssl_pkcs7_sign ( string infilename, string outfilename, mixed 
(PHP 4 >= 4.0.6)
openssl_pkcs7_sign -- sign an S/MIME message
Description
bool openssl_pkcs7_sign ( string infilename, string outfilename, mixed 
signcert, mixed privkey, array headers [, int flags [, string 
extracerts]])
openssl_pkcs7_sign() takes the contents of the file named infilename and 
signs them using the certificate and it's matching private key specified 
by signcert and privkey parameters. 
headers is an array of headers that will be prepended to the data after it 
has been signed (see openssl_pkcs7_encrypt() for more information about 
the format of this parameter. 
flags can be used to alter the output - see PKCS7 constants - if not 
specified, it defaults to PKCS7_DETACHED. 
extracerts specifies the name of a file containing a bunch of extra 
certificates to include in the signature which can for example be used to 
help the recipient to verify the certificate that you used. 
Example 1. openssl_pkcs7_sign() example
  <?php
  // the message you want to sign so that recipient can be sure 
  it was you that
  // sent it
  $data = <<<EOD

  You have my authorization to spend $10,000 on dinner expenses.

  The CEO
  EOD;
  // save message to file
  $fp = fopen("msg.txt", "w");
  fwrite($fp, $data);
  fclose($fp);
  // encrypt it
  if (openssl_pkcs7_sign("msg.txt", "signed.txt", "mycert.pem",
      array("mycert.pem", "mypassphrase"),
      array("To" => "joes@example.com", // keyed syntax
	    "From" => "HQ <ceo@example.com>", // indexed syntax
	    "Subject" => "Eyes only")
      )) {
      // message signed - send it!
      exec(ini_get("sendmail_path") . " < signed.txt");
  }
  ?> 
Note: This function was added in 4.0.6.  openssl_pkcs7_encryptUpopenssl_pkcs7_verify
#

#T=bool openssl_pkcs7_sign ( string infilename, string outfilename, mixed 
openssl_pkcs7_sign ( ^!string infilename, string outfilename, mixed ;
#

#T=openssl_pkcs7_verify - bool openssl_pkcs7_verify ( string filename, int flags [, string 
(PHP 4 >= 4.0.6)
openssl_pkcs7_verify -- Verifies the signature of an S/MIME signed message
Description
bool openssl_pkcs7_verify ( string filename, int flags [, string 
outfilename [, array cainfo [, string extracerts]]])
openssl_pkcs7_verify() reads the S/MIME message contained in the filename 
specified by filename and examines the digital signature. It returns TRUE 
if the signature is verified, FALSE if it is not correct (the message has 
been tampered with, or the signing certificate is invalid), or -1 on 
error. 
flags can be used to affect how the signature is verified - see PKCS7 
constants for more information. 
If the outfilename is specified, it should be a string holding the name of 
a file into which the certificates of the persons that signed the messages 
will be stored in PEM format. 
If the cainfo is specified, it should hold information about the trusted 
CA certificates to use in the verification process - see certificate 
verification for more information about this parameter. 
If the extracerts is specified, it is the filename of a file containing a 
bunch of certificates to use as untrusted CAs. 
Note: This function was added in 4.0.6.  openssl_pkcs7_signUpopenssl_pkey_export_to_file
#

#T=bool openssl_pkcs7_verify ( string filename, int flags [, string 
openssl_pkcs7_verify ( ^!string filename, int flags [, string ;
#

#T=openssl_pkey_export_to_file - bool openssl_pkey_export_to_file ( mixed key, string outfilename [, string 
(PHP 4 >= 4.2.0)
openssl_pkey_export_to_file -- Gets an exportable representation of a key 
into a file 
Description
bool openssl_pkey_export_to_file ( mixed key, string outfilename [, string 
passphrase [, array configargs]])
openssl_pkey_export_to_file() saves an ascii-armoured (PEM encoded) 
rendition of key into the file named by outfilename. The key can be 
optionally protected by a passphrase. configargs can be used to fine-tune 
the export process by specifying and/or overriding options for the openssl 
configuration file. See openssl_csr_new() for more information about 
configargs. Returns TRUE on success or FALSE on failure. 
Note: You need to have a valid openssl.cnf installed for this function 
to operate correctly. See the notes under the installation section for 
more information.   openssl_pkcs7_verifyUpopenssl_pkey_export
#

#T=bool openssl_pkey_export_to_file ( mixed key, string outfilename [, string 
openssl_pkey_export_to_file ( ^!mixed key, string outfilename [, string ;
#

#T=openssl_pkey_export - bool openssl_pkey_export ( mixed key, string &out [, string passphrase [, 
(PHP 4 >= 4.2.0)
openssl_pkey_export -- Gets an exportable representation of a key into a 
string
Description
bool openssl_pkey_export ( mixed key, string &out [, string passphrase [, 
array configargs]])
openssl_pkey_export() exports key as a PEM encoded string and stores it 
into out (which is passed by reference). The key is optionally protected 
by passphrase. configargs can be used to fine-tune the export process by 
specifying and/or overriding options for the openssl configuration file. 
See openssl_csr_new() for more information about configargs. Returns TRUE 
on success or FALSE on failure. 
Note: You need to have a valid openssl.cnf installed for this function 
to operate correctly. See the notes under the installation section for 
more information.   openssl_pkey_export_to_fileUpopenssl_pkey_get_private
#

#T=bool openssl_pkey_export ( mixed key, string &out [, string passphrase [, 
openssl_pkey_export ( ^!mixed key, string &out [, string passphrase [, ;
#

#T=openssl_pkey_get_private - resource openssl_get_privatekey ( mixed key [, string passphrase])
(PHP 4 >= 4.2.0)
openssl_pkey_get_private -- Get a private key
Description
resource openssl_get_privatekey ( mixed key [, string passphrase])
Returns a positive key resource identifier on success, or FALSE on error. 
openssl_get_privatekey() parses key and prepares it for use by other 
functions. key can be one of the following: 
a string having the format file://path/to/file.pem. The named file must 
contain a PEM encoded certificate/private key (it may contain both). 
A PEM formatted private key.
The optional parameter passphrase must be used if the specified key is 
encrypted (protected by a passphrase).   openssl_pkey_exportUpopenssl_pkey_get_public
#

#T=resource openssl_get_privatekey ( mixed key [, string passphrase])
openssl_get_privatekey ( ^!mixed key [, string passphrase]);
#

#T=openssl_pkey_get_public - resource openssl_pkey_get_public ( mixed certificate)
(PHP 4 >= 4.2.0)
openssl_pkey_get_public -- Extract public key from certificate and prepare 
it for use
Description
resource openssl_pkey_get_public ( mixed certificate)
Returns a positive key resource identifier on success, or FALSE on error. 
openssl_get_publickey() extracts the public key from certificate and 
prepares it for use by other functions. certificate can be one of the 
following: 
an X.509 certificate resource
a string having the format file://path/to/file.pem. The named file must 
contain a PEM encoded certificate/private key (it may contain both). 
A PEM formatted private key.  openssl_pkey_get_privateUpopenssl_pkey_new
#

#T=resource openssl_pkey_get_public ( mixed certificate)
openssl_pkey_get_public ( ^!mixed certificate);
#

#T=openssl_pkey_new - resource openssl_pkey_new ( [array configargs])
(PHP 4 >= 4.2.0)
openssl_pkey_new -- Generates a new private key 
Description
resource openssl_pkey_new ( [array configargs])
openssl_pkey_new() generates a new private and public key pair. The public 
component of the key can be obtained using openssl_pkey_get_public(). You 
can finetune the key generation (such as specifying the number of bits) 
using configargs. See openssl_csr_new() for more information about 
configargs. 
Note: You need to have a valid openssl.cnf installed for this function 
to operate correctly. See the notes under the installation section for 
more information.   openssl_pkey_get_publicUpopenssl_private_decrypt
#

#T=resource openssl_pkey_new ( [array configargs])
openssl_pkey_new ( ^![array configargs]);
#

#T=openssl_private_decrypt - bool openssl_private_decrypt ( string data, string &decrypted, mixed key 
(PHP 4 >= 4.0.6)
openssl_private_decrypt -- Decrypts data with private key 
Description
bool openssl_private_decrypt ( string data, string &decrypted, mixed key 
[, int padding])
openssl_private_decrypt() decrypts data that was previous encrypted via 
openssl_private_encrypt() and stores the result into decrypted. key must 
be the private key corresponding that was used to encrypt the data. 
padding defaults to OPENSSL_PKCS1_PADDING, but can also be one of 
OPENSSL_SSLV23_PADDING, OPENSSL_PKCS1_OAEP_PADDING OPENSSL_NO_PADDING.   openssl_pkey_newUpopenssl_private_encrypt
#

#T=bool openssl_private_decrypt ( string data, string &decrypted, mixed key 
openssl_private_decrypt ( ^!string data, string &decrypted, mixed key ;
#

#T=openssl_private_encrypt - bool openssl_private_encrypt ( string data, string crypted, mixed key [, 
(PHP 4 >= 4.0.6)
openssl_private_encrypt -- Encrypts data with private key 
Description
bool openssl_private_encrypt ( string data, string crypted, mixed key [, 
int padding])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  openssl_private_decryptUpopenssl_public_decrypt
#

#T=bool openssl_private_encrypt ( string data, string crypted, mixed key [, 
openssl_private_encrypt ( ^!string data, string crypted, mixed key [, ;
#

#T=openssl_public_decrypt - bool openssl_public_decrypt ( string data, string crypted, resource key [, 
(PHP 4 >= 4.0.6)
openssl_public_decrypt -- Decrypts data with public key 
Description
bool openssl_public_decrypt ( string data, string crypted, resource key [, 
int padding])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  openssl_private_encryptUpopenssl_public_encrypt
#

#T=bool openssl_public_decrypt ( string data, string crypted, resource key [, 
openssl_public_decrypt ( ^!string data, string crypted, resource key [, ;
#

#T=openssl_public_encrypt - bool openssl_public_encrypt ( string data, string crypted, mixed key [, 
(PHP 4 >= 4.0.6)
openssl_public_encrypt -- Encrypts data with public key 
Description
bool openssl_public_encrypt ( string data, string crypted, mixed key [, 
int padding])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  openssl_public_decryptUpopenssl_seal
#

#T=bool openssl_public_encrypt ( string data, string crypted, mixed key [, 
openssl_public_encrypt ( ^!string data, string crypted, mixed key [, ;
#

#T=openssl_seal - int openssl_seal ( string data, string sealed_data, array env_keys, array 
(PHP 4 >= 4.0.4)
openssl_seal -- Seal (encrypt) data
Description
int openssl_seal ( string data, string sealed_data, array env_keys, array 
pub_key_ids)
Returns the length of the sealed data on success, or FALSE on error. If 
successful the sealed data is returned in sealed_data, and the envelope 
keys in env_keys. 
openssl_seal() seals (encrypts) data by using RC4 with a randomly 
generated secret key. The key is encrypted with each of the public keys 
associated with the identifiers in pub_key_ids and each encrypted key is 
returned in env_keys. This means that one can send sealed data to multiple 
recipients (provided one has obtained their public keys). Each recipient 
must receive both the sealed data and the envelope key that was encrypted 
with the recipient's public key. 
Example 1. openssl_seal() example
  <?php
  // $data is assumed to contain the data to be sealed

  // fetch public keys for our recipients, and ready them
  $fp = fopen("/src/openssl-0.9.6/demos/maurice/cert.pem", "r");
  $cert = fread($fp, 8192);
  fclose($fp);
  $pk1 = openssl_get_publickey($cert);
  // Repeat for second recipient
  $fp = fopen("/src/openssl-0.9.6/demos/sign/cert.pem", "r");
  $cert = fread($fp, 8192);
  fclose($fp);
  $pk2 = openssl_get_publickey($cert);

  // seal message, only owners of $pk1 and $pk2 can decrypt 
  $sealed with keys
  // $ekeys[0] and $ekeys[1] respectively.
  openssl_seal($data, $sealed, $ekeys, array($pk1, $pk2));

  // free the keys from memory
  openssl_free_key($pk1);
  openssl_free_key($pk2);
  ?> 
See also openssl_open().   openssl_public_encryptUpopenssl_sign
#

#T=int openssl_seal ( string data, string sealed_data, array env_keys, array 
openssl_seal ( ^!string data, string sealed_data, array env_keys, array ;
#

#T=openssl_sign - bool openssl_sign ( string data, string signature, mixed priv_key_id)
(PHP 4 >= 4.0.4)
openssl_sign -- Generate signature
Description
bool openssl_sign ( string data, string signature, mixed priv_key_id)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Returns TRUE on success or FALSE on failure. If successful the signature 
is returned in signature. 
openssl_sign() computes a signature for the specified data by using SHA1 
for hashing followed by encryption using the private key associated with 
priv_key_id. Note that the data itself is not encrypted. 
Example 1. openssl_sign() example
  <?php
  // $data is assumed to contain the data to be signed

  // fetch private key from file and ready it
  $fp = fopen("/src/openssl-0.9.6/demos/sign/key.pem", "r");
  $priv_key = fread($fp, 8192);
  fclose($fp);
  $pkeyid = openssl_get_privatekey($priv_key);

  // compute signature
  openssl_sign($data, $signature, $pkeyid);

  // free the key from memory
  openssl_free_key($pkeyid);
  ?> 
See also openssl_verify().   openssl_sealUpopenssl_verify
#

#T=bool openssl_sign ( string data, string signature, mixed priv_key_id)
openssl_sign ( ^!string data, string signature, mixed priv_key_id);
#

#T=openssl_verify - int openssl_verify ( string data, string signature, mixed pub_key_id)
(PHP 4 >= 4.0.4)
openssl_verify -- Verify signature
Description
int openssl_verify ( string data, string signature, mixed pub_key_id)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Returns 1 if the signature is correct, 0 if it is incorrect, and -1 on 
error. 
openssl_verify() verifies that the signature is correct for the specified 
data using the public key associated with pub_key_id. This must be the 
public key corresponding to the private key used for signing. 
Example 1. openssl_verify() example
  <?php
  // $data and $signature are assumed to contain the data and 
  the signature

  // fetch public key from certificate and ready it
  $fp = fopen("/src/openssl-0.9.6/demos/sign/cert.pem", "r");
  $cert = fread($fp, 8192);
  fclose($fp);
  $pubkeyid = openssl_get_publickey($cert);

  // state whether signature is okay or not
  $ok = openssl_verify($data, $signature, $pubkeyid);
  if ($ok == 1) {
      echo "good";
  } elseif ($ok == 0) {
      echo "bad";
  } else {
      echo "ugly, error checking signature";
  }
  // free the key from memory
  openssl_free_key($pubkeyid);
  ?> 
See also openssl_sign().   openssl_signUpopenssl_x509_check_private_key
#

#T=int openssl_verify ( string data, string signature, mixed pub_key_id)
openssl_verify ( ^!string data, string signature, mixed pub_key_id);
#

#T=openssl_x509_check_private_key - bool openssl_x509_check_private_key ( mixed cert, mixed key)
(PHP 4 >= 4.2.0)
openssl_x509_check_private_key -- Checks if a private key corresponds to a 
certificate
Description
bool openssl_x509_check_private_key ( mixed cert, mixed key)
openssl_x509_check_private_key() returns TRUE if key is the private key 
that corresponds to cert, or FALSE otherwise.   openssl_verifyUpopenssl_x509_checkpurpose
#

#T=bool openssl_x509_check_private_key ( mixed cert, mixed key)
openssl_x509_check_private_key ( ^!mixed cert, mixed key);
#

#T=openssl_x509_checkpurpose - bool openssl_x509_checkpurpose ( mixed x509cert, int purpose, array cainfo 
(PHP 4 >= 4.0.6)
openssl_x509_checkpurpose -- Verifies if a certificate can be used for a 
particular purpose
Description
bool openssl_x509_checkpurpose ( mixed x509cert, int purpose, array cainfo 
[, string untrustedfile])
Returns TRUE if the certificate can be used for the intended purpose, 
FALSE if it cannot, or -1 on error. 
openssl_x509_checkpurpose() examines the certificate specified by x509cert 
to see if it can be used for the purpose specified by purpose. 
cainfo should be an array of trusted CA files/dirs as described in 
Certificate Verification. 
untrustedfile, if specified, is the name of a PEM encoded file holding 
certificates that can be used to help verify the certificate, although no 
trust in placed in the certificates that come from that file. 
Table 1. openssl_x509_checkpurpose() purposes
ConstantDescription
X509_PURPOSE_SSL_CLIENTCan the certificate be used for the client 
side of an SSL connection?
X509_PURPOSE_SSL_SERVERCan the certificate be used for the server 
side of an SSL connection?
X509_PURPOSE_NS_SSL_SERVERCan the cert be used for Netscape SSL 
server?
X509_PURPOSE_SMIME_SIGNCan the cert be used to sign S/MIME email?
X509_PURPOSE_SMIME_ENCRYPTCan the cert be used to encrypt S/MIME 
email?
X509_PURPOSE_CRL_SIGNCan the cert be used to sign a certificate 
revocation list (CRL)?
X509_PURPOSE_ANYCan the cert be used for Any/All purposes?

These options are not bitfields - you may specify one only! 
Note: This function was added in 4.0.6.  openssl_x509_check_private_keyUpopenssl_x509_export_to_file
#

#T=bool openssl_x509_checkpurpose ( mixed x509cert, int purpose, array cainfo 
openssl_x509_checkpurpose ( ^!mixed x509cert, int purpose, array cainfo ;
#

#T=openssl_x509_export_to_file - bool openssl_x509_export_to_file ( mixed x509, string outfilename [, bool 
(PHP 4 >= 4.2.0)
openssl_x509_export_to_file -- Exports a certificate to file
Description
bool openssl_x509_export_to_file ( mixed x509, string outfilename [, bool 
notext])
openssl_x509_export_to_file() stores x509 into a file named by outfilename 
in a PEM encoded format. 
The optional parameter notext affects the verbosity of the output; if it 
is FALSE then additional human-readable information is included in the 
output. The default value of notext is TRUE. 
Returns TRUE on success or FALSE on failure.   openssl_x509_checkpurposeUpopenssl_x509_export
#

#T=bool openssl_x509_export_to_file ( mixed x509, string outfilename [, bool 
openssl_x509_export_to_file ( ^!mixed x509, string outfilename [, bool ;
#

#T=openssl_x509_export - bool openssl_x509_export ( mixed x509, string &output [, bool notext])
(PHP 4 >= 4.2.0)
openssl_x509_export -- Exports a certificate as a string
Description
bool openssl_x509_export ( mixed x509, string &output [, bool notext])
openssl_x509_export() stores x509 into a string named by output in a PEM 
encoded format. 
The optional parameter notext affects the verbosity of the output; if it 
is FALSE then additional human-readable information is included in the 
output. The default value of notext is TRUE. 
Returns TRUE on success or FALSE on failure.   openssl_x509_export_to_fileUpopenssl_x509_free
#

#T=bool openssl_x509_export ( mixed x509, string &output [, bool notext])
openssl_x509_export ( ^!mixed x509, string &output [, bool notext]);
#

#T=openssl_x509_free - void openssl_x509_free ( resource x509cert)
(PHP 4 >= 4.0.6)
openssl_x509_free -- Free certificate resource
Description
void openssl_x509_free ( resource x509cert)
openssl_x509_free() frees the certificate associated with the specified 
x509cert resource from memory. 
Note: This function was added in 4.0.6.  openssl_x509_exportUpopenssl_x509_parse
#

#T=void openssl_x509_free ( resource x509cert)
openssl_x509_free ( ^!resource x509cert);
#

#T=openssl_x509_parse - array openssl_x509_parse ( mixed x509cert [, bool shortnames])
(PHP 4 >= 4.0.6)
openssl_x509_parse -- Parse an X509 certificate and return the information 
as an array
Description
array openssl_x509_parse ( mixed x509cert [, bool shortnames])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

openssl_x509_parse() returns information about the supplied x509cert, 
including fields such as subject name, issuer name, purposes, valid from 
and valid to dates etc. shortnames controls how the data is indexed in the 
array - if shortnames is TRUE (the default) then fields will be indexed 
with the short name form, otherwise, the long name form will be used - 
e.g.: CN is the shortname form of commonName. 
The structure of the returned data is (deliberately) not yet documented, 
as it is still subject to change.
Note: This function was added in 4.0.6.  openssl_x509_freeUpopenssl_x509_read
#

#T=array openssl_x509_parse ( mixed x509cert [, bool shortnames])
openssl_x509_parse ( ^!mixed x509cert [, bool shortnames]);
#

#T=openssl_x509_read - resource openssl_x509_read ( mixed x509certdata)
(PHP 4 >= 4.0.6)
openssl_x509_read -- Parse an X.509 certificate and return a resource 
identifier for it
Description
resource openssl_x509_read ( mixed x509certdata)
openssl_x509_read() parses the certificate supplied by x509certdata and 
returns a resource identifier for it. 
Note: This function was added in 4.0.6.  openssl_x509_parseUpOracle functions
#

#T=resource openssl_x509_read ( mixed x509certdata)
openssl_x509_read ( ^!mixed x509certdata);
#

#T=ora_bind - bool ora_bind ( resource cursor, string PHP_variable_name, string 
(PHP 3, PHP 4 )
ora_bind -- Binds a PHP variable to an Oracle parameter
Description
bool ora_bind ( resource cursor, string PHP_variable_name, string 
SQL_parameter_name, int length [, int type])
This function binds the named PHP variable with a SQL parameter. The SQL 
parameter must be in the form ":name". With the optional type parameter, 
you can define whether the SQL parameter is an in/out (0, default), in (1) 
or out (2) parameter. As of PHP 3.0.1, you can use the constants 
ORA_BIND_INOUT, ORA_BIND_IN and ORA_BIND_OUT instead of the numbers. 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions. 
ora_bind() must be called after ora_parse() and before ora_exec(). Input 
values can be given by assignment to the bound PHP variables, after 
calling ora_exec() the bound PHP variables contain the output values if 
available. Example 1. ora_bind() example
  <?php
    ora_parse($curs, "declare tmp INTEGER; begin tmp := :in; 
  :out := tmp; :x := 7.77; end;");
    ora_bind($curs, "result", ":x", $len, 2);
    ora_bind($curs, "input", ":in", 5, 1);
    ora_bind($curs, "output", ":out", 5, 2);
    $input = 765;
    ora_exec($curs);
    echo "Result: $result<br />Out: $output<br />In: $input";
  ?> 

  Oracle functionsUpora_close
#

#T=bool ora_bind ( resource cursor, string PHP_variable_name, string 
ora_bind ( ^!resource cursor, string PHP_variable_name, string ;
#

#T=ora_close - bool ora_close ( resource cursor)
(PHP 3, PHP 4 )
ora_close -- Closes an Oracle cursor
Description
bool ora_close ( resource cursor)
This function closes a data cursor opened with ora_open(). 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions.   ora_bindUpora_columnname
#

#T=bool ora_close ( resource cursor)
ora_close ( ^!resource cursor);
#

#T=ora_columnname - string ora_columnname ( resource cursor, int column)
(PHP 3, PHP 4 )
ora_columnname -- Gets the name of an Oracle result column
Description
string ora_columnname ( resource cursor, int column)
Returns the name of the field/column column on the cursor cursor. The 
returned name is in all uppercase letters. Column 0 is the first column.   ora_closeUpora_columnsize
#

#T=string ora_columnname ( resource cursor, int column)
ora_columnname ( ^!resource cursor, int column);
#

#T=ora_columnsize - int ora_columnsize ( resource cursor, int column)
(PHP 3, PHP 4 )
ora_columnsize -- Returns the size of an Oracle result column
Description
int ora_columnsize ( resource cursor, int column)
Returns the size of the Oracle column column on the cursor cursor. Column 
0 is the first column.   ora_columnnameUpora_columntype
#

#T=int ora_columnsize ( resource cursor, int column)
ora_columnsize ( ^!resource cursor, int column);
#

#T=ora_columntype - string ora_columntype ( resource cursor, int column)
(PHP 3, PHP 4 )
ora_columntype -- Gets the type of an Oracle result column
Description
string ora_columntype ( resource cursor, int column)
Returns the Oracle data type name of the field/column column on the cursor 
cursor. Column 0 is the first column. The returned type will be one of the 
following: 
"VARCHAR2"
"VARCHAR"
"CHAR"
"NUMBER"
"LONG"
"LONG RAW"
"ROWID"
"DATE"
"CURSOR"
  ora_columnsizeUpora_commit
#

#T=string ora_columntype ( resource cursor, int column)
ora_columntype ( ^!resource cursor, int column);
#

#T=ora_commit - bool ora_commit ( resource conn)
(PHP 3, PHP 4 )
ora_commit -- Commit an Oracle transaction
Description
bool ora_commit ( resource conn)
This function commits an Oracle transaction. A transaction is defined as 
all the changes on a given connection since the last commit/rollback, 
autocommit was turned off or when the connection was established. 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions. 
See also ora_commiton() and ora_commitoff().   ora_columntypeUpora_commitoff
#

#T=bool ora_commit ( resource conn)
ora_commit ( ^!resource conn);
#

#T=ora_commitoff - bool ora_commitoff ( resource conn)
(PHP 3, PHP 4 )
ora_commitoff -- Disable automatic commit
Description
bool ora_commitoff ( resource conn)
This function turns off automatic commit after each ora_exec() on the 
given connection. 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions. 
See also ora_commiton() and ora_commit().   ora_commitUpora_commiton
#

#T=bool ora_commitoff ( resource conn)
ora_commitoff ( ^!resource conn);
#

#T=ora_commiton - bool ora_commiton ( resource conn)
(PHP 3, PHP 4 )
ora_commiton -- Enable automatic commit
Description
bool ora_commiton ( resource conn)
This function turns on automatic commit after each ora_exec() on the given 
connection. 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions. 
See also ora_commitoff() and ora_commit().   ora_commitoffUpora_do
#

#T=bool ora_commiton ( resource conn)
ora_commiton ( ^!resource conn);
#

#T=ora_do - resource ora_do ( resource conn, string query)
(PHP 3, PHP 4 )
ora_do -- Parse, Exec, Fetch
Description
resource ora_do ( resource conn, string query)
ora_do() is quick combination of ora_parse(), ora_exec() and ora_fetch(). 
It will parse and execute a statement, then fetch the first result row. 
This function returns a cursor index or FALSE on failure. Details about 
the error can be retrieved using the ora_error() and ora_errorcode() 
functions. 
See also ora_parse(),ora_exec(), and ora_fetch().   ora_commitonUpora_error
#

#T=resource ora_do ( resource conn, string query)
ora_do ( ^!resource conn, string query);
#

#T=ora_error - string ora_error ( resource cursor_or_connection)
(PHP 3, PHP 4 )
ora_error -- Gets an Oracle error message
Description
string ora_error ( resource cursor_or_connection)
Returns an error message of the form XXX-NNNNN where XXX is where the 
error comes from and NNNNN identifies the error message. 
Note: Support for connection ids was added in 3.0.4.
On Unix versions of Oracle, you can find details about an error message 
like this: $ oerr ora 00001 00001, 00000, "unique constraint (%s.%s) 
violated" // *Cause: An update or insert statement attempted to insert a 
duplicate key // For Trusted ORACLE configured in DBMS MAC mode, you may 
see // this message if a duplicate entry exists at a different level. // 
*Action: Either remove the unique restriction or do not insert the key   ora_doUpora_errorcode
#

#T=string ora_error ( resource cursor_or_connection)
ora_error ( ^!resource cursor_or_connection);
#

#T=ora_errorcode - int ora_errorcode ( resource cursor_or_connection)
(PHP 3, PHP 4 )
ora_errorcode -- Gets an Oracle error code
Description
int ora_errorcode ( resource cursor_or_connection)
Returns the numeric error code of the last executed statement on the 
specified cursor or connection. 
Note: Support for connection ids was added in 3.0.4.  ora_errorUpora_exec
#

#T=int ora_errorcode ( resource cursor_or_connection)
ora_errorcode ( ^!resource cursor_or_connection);
#

#T=ora_exec - bool ora_exec ( resource cursor)
(PHP 3, PHP 4 )
ora_exec -- Execute a parsed statement on an Oracle cursor
Description
bool ora_exec ( resource cursor)
ora_exec() execute the parsed statement cursor, already parsed by 
ora_parse(). 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions. 
See also ora_parse(), ora_fetch(), and ora_do().   ora_errorcodeUpora_fetch_into
#

#T=bool ora_exec ( resource cursor)
ora_exec ( ^!resource cursor);
#

#T=ora_fetch_into - int ora_fetch_into ( resource cursor, array result [, int flags])
(PHP 3, PHP 4 )
ora_fetch_into -- Fetch a row into the specified result array
Description
int ora_fetch_into ( resource cursor, array result [, int flags])
Fetches a row of data into an array. The flags has two flag values: if the 
ORA_FETCHINTO_NULLS flag is set, columns with NULL values are set in the 
array; and if the ORA_FETCHINTO_ASSOC flag is set, an associative array is 
created. 
Returns the number of columns fetched. 
Example 1. ora_fetch_into()
  <?php
  $results = array();
  ora_fetch_into($cursor, $results);
  echo $results[0];
  echo $results[1];
  $results = array();
  ora_fetch_into($cursor, $results, 
  ORA_FETCHINTO_NULLS|ORA_FETCHINTO_ASSOC);
  echo $results['MyColumn'];
  ?> 
See also ora_parse(),ora_exec(), ora_fetch(), and ora_do().   ora_execUpora_fetch
#

#T=int ora_fetch_into ( resource cursor, array result [, int flags])
ora_fetch_into ( ^!resource cursor, array result [, int flags]);
#

#T=ora_fetch - bool ora_fetch ( resource cursor)
(PHP 3, PHP 4 )
ora_fetch -- Fetch a row of data from a cursor
Description
bool ora_fetch ( resource cursor)
Retrieves a row of data from the specified cursor. 
Returns TRUE (a row was fetched) or FALSE (no more rows, or an error 
occurred). If an error occurred, details can be retrieved using the 
ora_error() and ora_errorcode() functions. If there was no error, 
ora_errorcode() will return 0. 
See also ora_parse(),ora_exec(), and ora_do().   ora_fetch_intoUpora_getcolumn
#

#T=bool ora_fetch ( resource cursor)
ora_fetch ( ^!resource cursor);
#

#T=ora_getcolumn - mixed ora_getcolumn ( resource cursor, int column)
(PHP 3, PHP 4 )
ora_getcolumn -- Get data from a fetched column
Description
mixed ora_getcolumn ( resource cursor, int column)
Fetches the data for a column or function result. 
Returns the column data. If an error occurs, FALSE is returned and 
ora_errorcode() will return a non-zero value. Note, however, that a test 
for FALSE on the results from this function may be TRUE in cases where 
there is not error as well (NULL result, empty string, the number 0, the 
string "0").   ora_fetchUpora_logoff
#

#T=mixed ora_getcolumn ( resource cursor, int column)
ora_getcolumn ( ^!resource cursor, int column);
#

#T=ora_logoff - bool ora_logoff ( resource connection)
(PHP 3, PHP 4 )
ora_logoff -- Close an Oracle connection
Description
bool ora_logoff ( resource connection)
Logs out the user and disconnects from the server. 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions. 
See also ora_logon().   ora_getcolumnUpora_logon
#

#T=bool ora_logoff ( resource connection)
ora_logoff ( ^!resource connection);
#

#T=ora_logon - resource ora_logon ( string user, string password)
(PHP 3, PHP 4 )
ora_logon -- Open an Oracle connection
Description
resource ora_logon ( string user, string password)
Establishes a connection between PHP and an Oracle database with the given 
username user and password password. 
Connections can be made using SQL*Net by supplying the TNS name to user 
like this: 
<?php
$conn = Ora_Logon("user@TNSNAME", "pass");
?> 

If you have character data with non-ASCII characters, you should make sure 
that NLS_LANG is set in your environment. For server modules, you should 
set it in the server's environment before starting the server. 
Returns a connection index on success, or FALSE on failure. Details about 
the error can be retrieved using the ora_error() and ora_errorcode() 
functions.   ora_logoffUpora_numcols
#

#T=resource ora_logon ( string user, string password)
ora_logon ( ^!string user, string password);
#

#T=ora_numcols - int ora_numcols ( resource cursor)
(PHP 3, PHP 4 )
ora_numcols -- Returns the number of columns
Description
int ora_numcols ( resource cursor)
ora_numcols() returns the number of columns in a result. Only returns 
meaningful values after an parse/exec/fetch sequence. 
See also ora_parse(),ora_exec(), ora_fetch(), and ora_do().   ora_logonUpora_numrows
#

#T=int ora_numcols ( resource cursor)
ora_numcols ( ^!resource cursor);
#

#T=ora_numrows - int ora_numrows ( resource cursor)
(PHP 3, PHP 4 )
ora_numrows -- Returns the number of rows
Description
int ora_numrows ( resource cursor)
ora_numrows() returns the number of rows in a result.   ora_numcolsUpora_open
#

#T=int ora_numrows ( resource cursor)
ora_numrows ( ^!resource cursor);
#

#T=ora_open - resource ora_open ( resource connection)
(PHP 3, PHP 4 )
ora_open -- Opens an Oracle cursor
Description
resource ora_open ( resource connection)
Opens an Oracle cursor associated with connection. 
Returns a cursor index or FALSE on failure. Details about the error can be 
retrieved using the ora_error() and ora_errorcode() functions.   ora_numrowsUpora_parse
#

#T=resource ora_open ( resource connection)
ora_open ( ^!resource connection);
#

#T=ora_parse - bool ora_parse ( resource cursor, string sql_statement, int defer)
(PHP 3, PHP 4 )
ora_parse -- Parse an SQL statement with Oracle
Description
bool ora_parse ( resource cursor, string sql_statement, int defer)
This function parses an SQL statement or a PL/SQL block and associates it 
with the given cursor. 
Returns TRUE on success or FALSE on failure. 
See also ora_exec(), ora_fetch(), and ora_do().   ora_openUpora_plogon
#

#T=bool ora_parse ( resource cursor, string sql_statement, int defer)
ora_parse ( ^!resource cursor, string sql_statement, int defer);
#

#T=ora_plogon - resource ora_plogon ( string user, string password)
(PHP 3, PHP 4 )
ora_plogon --  Open a persistent Oracle connection 
Description
resource ora_plogon ( string user, string password)
Establishes a persistent connection between PHP and an Oracle database 
with the username user and password password. 
See also ora_logon().   ora_parseUpora_rollback
#

#T=resource ora_plogon ( string user, string password)
ora_plogon ( ^!string user, string password);
#

#T=ora_rollback - bool ora_rollback ( resource connection)
(PHP 3, PHP 4 )
ora_rollback -- Rolls back a transaction
Description
bool ora_rollback ( resource connection)
This function undoes an Oracle transaction. (See ora_commit() for the 
definition of a transaction.) 
Returns TRUE on success or FALSE on failure. Details about the error can 
be retrieved using the ora_error() and ora_errorcode() functions.   ora_plogonUpOvrimos SQL functions
#

#T=bool ora_rollback ( resource connection)
ora_rollback ( ^!resource connection);
#

#T=ord - int ord ( string string)
(PHP 3, PHP 4 )
ord -- Return ASCII value of character
Description
int ord ( string string)
Returns the ASCII value of the first character of string. This function 
complements chr(). Example 1. ord() example
  <?php
  if (ord($str) == 10) {
      echo "The first character of \$str is a line feed.\n";
  }
  ?> 
You can find an ASCII-table over here: http://www.asciitable.com. 
See also chr().   number_formatUpparse_str
overload
(4.2.0 - 4.3.2 only)
overload -- Enable property and method call overloading for a class
Description
void overload ( [string class_name])
The overload() function will enable property and method call overloading 
for a class identified by class_name. See an example in the introductory 
section of this part.   Object property and method call overloadingUpPDF functions
#

#T=int ord ( string string)
ord ( ^!string string);
#

#T=ovrimos_close - void ovrimos_close ( int connection)
(PHP 4 >= 4.0.3)
ovrimos_close -- Closes the connection to ovrimos
Description
void ovrimos_close ( int connection)
ovrimos_close() is used to close the specified connection to Ovrimos. This 
has the effect of rolling back uncommitted transactions.   Ovrimos SQL functionsUpovrimos_commit
#

#T=void ovrimos_close ( int connection)
ovrimos_close ( ^!int connection);
#

#T=ovrimos_commit - bool ovrimos_commit ( int connection_id)
(PHP 4 >= 4.0.3)
ovrimos_commit -- Commits the transaction
Description
bool ovrimos_commit ( int connection_id)
ovrimos_commit() is used to commit the transaction. Returns TRUE on 
success or FALSE on failure.   ovrimos_closeUpovrimos_connect
#

#T=bool ovrimos_commit ( int connection_id)
ovrimos_commit ( ^!int connection_id);
#

#T=ovrimos_connect - int ovrimos_connect ( string host, string db, string user, string 
(PHP 4 >= 4.0.3)
ovrimos_connect -- Connect to the specified database
Description
int ovrimos_connect ( string host, string db, string user, string 
password)
ovrimos_connect() is used to connect to the specified database. 
ovrimos_connect() returns a connection id (greater than 0) or 0 for 
failure. The meaning of host and db are those used everywhere in Ovrimos 
APIs. host is a host name or IP address and db is either a database name, 
or a string containing the port number. 
Example 1. ovrimos_connect() Example
  <?php
  $conn = ovrimos_connect("server.domain.com", "8001", "admin", 
  "password");
  if ($conn != 0) {
      echo "Connection ok!";
      $res=ovrimos_exec($conn, "select table_id, table_name from 
  sys.tables");
      if ($res != 0) {
	  echo "Statement ok!";
	  ovrimos_result_all($res);
	  ovrimos_free_result($res);
      }
      ovrimos_close($conn);
  }
  ?> 

The above example will connect to the database and print out the specified 
table.   ovrimos_commitUpovrimos_cursor
#

#T=int ovrimos_connect ( string host, string db, string user, string 
ovrimos_connect ( ^!string host, string db, string user, string ;
#

#T=ovrimos_cursor - string ovrimos_cursor ( int result_id)
(PHP 4 >= 4.0.3)
ovrimos_cursor -- Returns the name of the cursor
Description
string ovrimos_cursor ( int result_id)
ovrimos_cursor() returns the name of the cursor. Useful when wishing to 
perform positioned updates or deletes.   ovrimos_connectUpovrimos_exec
#

#T=string ovrimos_cursor ( int result_id)
ovrimos_cursor ( ^!int result_id);
#

#T=ovrimos_exec - int ovrimos_exec ( int connection_id, string query)
(PHP 4 >= 4.0.3)
ovrimos_exec -- Executes an SQL statement
Description
int ovrimos_exec ( int connection_id, string query)
ovrimos_exec() executes an SQL statement (query or update) and returns a 
result_id or FALSE. Evidently, the SQL statement should not contain 
parameters.   ovrimos_cursorUpovrimos_execute
#

#T=int ovrimos_exec ( int connection_id, string query)
ovrimos_exec ( ^!int connection_id, string query);
#

#T=ovrimos_execute - bool ovrimos_execute ( int result_id [, array parameters_array])
(PHP 4 >= 4.0.3)
ovrimos_execute -- Executes a prepared SQL statement
Description
bool ovrimos_execute ( int result_id [, array parameters_array])
ovrimos_execute() executes a prepared statement. Returns TRUE on success 
or FALSE on failure. If the prepared statement contained parameters 
(question marks in the statement), the correct number of parameters should 
be passed in an array. Notice that I don't follow the PHP convention of 
placing just the name of the optional parameter inside square brackets. I 
couldn't bring myself on liking it.   ovrimos_execUpovrimos_fetch_into
#

#T=bool ovrimos_execute ( int result_id [, array parameters_array])
ovrimos_execute ( ^!int result_id [, array parameters_array]);
#

#T=ovrimos_fetch_into - bool ovrimos_fetch_into ( int result_id, array result_array [, string how 
(PHP 4 >= 4.0.3)
ovrimos_fetch_into -- Fetches a row from the result set
Description
bool ovrimos_fetch_into ( int result_id, array result_array [, string how 
[, int rownumber]])
ovrimos_fetch_into() fetches a row from the result set into result_array, 
which should be passed by reference. Which row is fetched is determined by 
the two last parameters. how is one of Next (default), Prev, First, Last, 
Absolute, corresponding to forward direction from current position, 
backward direction from current position, forward direction from the 
start, backward direction from the end and absolute position from the 
start (essentially equivalent to 'first' but needs 'rownumber'). Case is 
not significant. rownumber is optional except for absolute positioning. 
Returns TRUE on success or FALSE on failure. 
Example 1. A fetch into example
  <?php
  $conn=ovrimos_connect("neptune", "8001", "admin", "password");
  if ($conn!=0) {
      echo "Connection ok!";
      $res=ovrimos_exec($conn, "select table_id, table_name from 
  sys.tables");
      if ($res != 0) {
	  echo "Statement ok!";
	  if (ovrimos_fetch_into($res, &$row)) {
	      list($table_id, $table_name) = $row;
	      echo "table_id=" . $table_id . ", table_name=" . 
  $table_name . "\n";
	      if (ovrimos_fetch_into($res, &$row)) {
		  list($table_id, $table_name) = $row;
		  echo "table_id=" . $table_id . ", table_name=" 
  . $table_name . "\n";
	      } else {
		  echo "Next: error\n";
	      }
	  } else {
	      echo "First: error\n";
	  }
	  ovrimos_free_result($res);
      }
      ovrimos_close($conn);
  }
  ?> 

This example will fetch a row.   ovrimos_executeUpovrimos_fetch_row
#

#T=bool ovrimos_fetch_into ( int result_id, array result_array [, string how 
ovrimos_fetch_into ( ^!int result_id, array result_array [, string how ;
#

#T=ovrimos_fetch_row - bool ovrimos_fetch_row ( int result_id [, int how [, int row_number]])
(PHP 4 >= 4.0.3)
ovrimos_fetch_row -- Fetches a row from the result set
Description
bool ovrimos_fetch_row ( int result_id [, int how [, int row_number]])
ovrimos_fetch_row() fetches a row from the result set. Column values 
should be retrieved with other calls. Returns TRUE on success or FALSE on 
failure. 
Example 1. A fetch row example
  <?php
  $conn = ovrimos_connect("remote.host", "8001", "admin", 
  "password");
  if ($conn != 0) {
      echo "Connection ok!";
      $res=ovrimos_exec($conn, "select table_id, table_name from 
  sys.tables");
      if ($res != 0) {
	  echo "Statement ok!";
	  if (ovrimos_fetch_row($res, "First")) {
	      $table_id = ovrimos_result($res, 1);
	      $table_name = ovrimos_result($res, 2);
	      echo "table_id=" . $table_id . ", table_name=" . 
  $table_name . "\n";
	      if (ovrimos_fetch_row($res, "Next")) {
		  $table_id = ovrimos_result($res, "table_id");
		  $table_name = ovrimos_result($res, 
  "table_name");
		  echo "table_id=" . $table_id . ", table_name=" 
  . $table_name . "\n";
	      } else {
		  echo "Next: error\n";
	      }
	  } else {
	      echo "First: error\n";
	  }
	  ovrimos_free_result($res);
      }
      ovrimos_close($conn);
  }
  ?> 

This will fetch a row and print the result.   ovrimos_fetch_intoUpovrimos_field_len
#

#T=bool ovrimos_fetch_row ( int result_id [, int how [, int row_number]])
ovrimos_fetch_row ( ^!int result_id [, int how [, int row_number]]);
#

#T=ovrimos_field_len - int ovrimos_field_len ( int result_id, int field_number)
(PHP 4 >= 4.0.3)
ovrimos_field_len -- Returns the length of the output column
Description
int ovrimos_field_len ( int result_id, int field_number)
ovrimos_field_len() is used to get the length of the output column with 
number field_number (1-based), in result result_id.   ovrimos_fetch_rowUpovrimos_field_name
#

#T=int ovrimos_field_len ( int result_id, int field_number)
ovrimos_field_len ( ^!int result_id, int field_number);
#

#T=ovrimos_field_name - string ovrimos_field_name ( int result_id, int field_number)
(PHP 4 >= 4.0.3)
ovrimos_field_name -- Returns the output column name
Description
string ovrimos_field_name ( int result_id, int field_number)
ovrimos_field_name() returns the output column name at the (1-based) index 
specified.   ovrimos_field_lenUpovrimos_field_num
#

#T=string ovrimos_field_name ( int result_id, int field_number)
ovrimos_field_name ( ^!int result_id, int field_number);
#

#T=ovrimos_field_num - int ovrimos_field_num ( int result_id, string field_name)
(PHP 4 >= 4.0.3)
ovrimos_field_num --  Returns the (1-based) index of the output column 
Description
int ovrimos_field_num ( int result_id, string field_name)
ovrimos_field_num() returns the (1-based) index of the output column 
specified by field_name, or FALSE.   ovrimos_field_nameUpovrimos_field_type
#

#T=int ovrimos_field_num ( int result_id, string field_name)
ovrimos_field_num ( ^!int result_id, string field_name);
#

#T=ovrimos_field_type - int ovrimos_field_type ( int result_id, int field_number)
(PHP 4 >= 4.0.3)
ovrimos_field_type --  Returns the (numeric) type of the output column 
Description
int ovrimos_field_type ( int result_id, int field_number)
ovrimos_field_type() returns the (numeric) type of the output column at 
the (1-based) index specified by field_number.   ovrimos_field_numUpovrimos_free_result
#

#T=int ovrimos_field_type ( int result_id, int field_number)
ovrimos_field_type ( ^!int result_id, int field_number);
#

#T=ovrimos_free_result - bool ovrimos_free_result ( int result_id)
(PHP 4 >= 4.0.3)
ovrimos_free_result -- Frees the specified result_id
Description
bool ovrimos_free_result ( int result_id)
ovrimos_free_result() frees the specified result_id. Returns TRUE.   ovrimos_field_typeUpovrimos_longreadlen
#

#T=bool ovrimos_free_result ( int result_id)
ovrimos_free_result ( ^!int result_id);
#

#T=ovrimos_longreadlen - bool ovrimos_longreadlen ( int result_id, int length)
(PHP 4 >= 4.0.3)
ovrimos_longreadlen --  Specifies how many bytes are to be retrieved from 
long datatypes 
Description
bool ovrimos_longreadlen ( int result_id, int length)
ovrimos_longreadlen() specifies how many bytes are to be retrieved from 
long datatypes (long varchar and long varbinary). Default is zero. It 
currently sets this parameter the specified result set. Returns TRUE.   ovrimos_free_resultUpovrimos_num_fields
#

#T=bool ovrimos_longreadlen ( int result_id, int length)
ovrimos_longreadlen ( ^!int result_id, int length);
#

#T=ovrimos_num_fields - int ovrimos_num_fields ( int result_id)
(PHP 4 >= 4.0.3)
ovrimos_num_fields -- Returns the number of columns
Description
int ovrimos_num_fields ( int result_id)
ovrimos_num_fields() returns the number of columns in a result_id 
resulting from a query.   ovrimos_longreadlenUpovrimos_num_rows
#

#T=int ovrimos_num_fields ( int result_id)
ovrimos_num_fields ( ^!int result_id);
#

#T=ovrimos_num_rows - int ovrimos_num_rows ( int result_id)
(PHP 4 >= 4.0.3)
ovrimos_num_rows --  Returns the number of rows affected by update 
operations 
Description
int ovrimos_num_rows ( int result_id)
ovrimos_num_rows() returns the number of rows affected by update 
operations.   ovrimos_num_fieldsUpovrimos_prepare
#

#T=int ovrimos_num_rows ( int result_id)
ovrimos_num_rows ( ^!int result_id);
#

#T=ovrimos_prepare - int ovrimos_prepare ( int connection_id, string query)
(PHP 4 >= 4.0.3)
ovrimos_prepare -- Prepares an SQL statement
Description
int ovrimos_prepare ( int connection_id, string query)
ovrimos_prepare() prepares an SQL statement and returns a result_id (or 
FALSE on failure). 
Example 1. Connect to Ovrimos SQL Server and prepare a statement
  <?php
  $conn=ovrimos_connect("db_host", "8001", "admin", "password");
  if ($conn!=0) {
      echo "Connection ok!";
      $res=ovrimos_prepare($conn, "select table_id, table_name 
				    from sys.tables where 
  table_id=1");
      if ($res != 0) {
	  echo "Prepare ok!";
	  if (ovrimos_execute($res)) {
	      echo "Execute ok!\n";
	      ovrimos_result_all($res);
	  } else {
	      echo "Execute not ok!";
	  }
	  ovrimos_free_result($res);
      } else {
	  echo "Prepare not ok!\n";
      }
      ovrimos_close($conn);
  }
  ?> 

This will connect to Ovrimos SQL Server, prepare a statement and the 
execute it.   ovrimos_num_rowsUpovrimos_result_all
#

#T=int ovrimos_prepare ( int connection_id, string query)
ovrimos_prepare ( ^!int connection_id, string query);
#

#T=ovrimos_result_all - int ovrimos_result_all ( int result_id [, string format])
(PHP 4 >= 4.0.3)
ovrimos_result_all --  Prints the whole result set as an HTML table 
Description
int ovrimos_result_all ( int result_id [, string format])
ovrimos_result_all() prints the whole result set as an HTML table. Returns 
the number of rows in the generated table. 
Example 1. Prepare a statement, execute, and view the result
  <?php
  $conn = ovrimos_connect("db_host", "8001", "admin", 
  "password");
  if ($conn != 0) {
      echo "Connection ok!";
      $res = ovrimos_prepare($conn, "select table_id, table_name 

				      from sys.tables where 
  table_id = 7");
      if ($res != 0) {
	  echo "Prepare ok!";
	  if (ovrimos_execute($res, array(3))) {
	      echo "Execute ok!\n";
	      ovrimos_result_all($res);
	  } else {
	      echo "Execute not ok!";
	  }
	  ovrimos_free_result($res);
      } else {
	  echo "Prepare not ok!\n";
      }
      ovrimos_close($conn);
  }
  ?> 

This will execute an SQL statement and print the result in an HTML table. 
Example 2. ovrimos_result_all() with meta-information
  <?php
  $conn = ovrimos_connect("db_host", "8001", "admin", 
  "password");
  if ($conn != 0) {
      echo "Connection ok!";
      $res = ovrimos_exec($conn, "select table_id, table_name 
				   from sys.tables where 
  table_id = 1");
      if ($res != 0) {
	  echo "Statement ok! cursor=" . ovrimos_cursor($res) . 
  "\n";
	  $colnb = ovrimos_num_fields($res);
	  echo "Output columns=" . $colnb . "\n";
	  for ($i=1; $i <= $colnb; $i++) {
	      $name = ovrimos_field_name($res, $i);
	      $type = ovrimos_field_type($res, $i);
	      $len = ovrimos_field_len($res, $i);  
	      echo "Column " . $i . " name=" . $name . " type=" 
  . $type . " len=" . $len . "\n";
	  }
	  ovrimos_result_all($res);
	  ovrimos_free_result($res);
      }
      ovrimos_close($conn);
  }
  ?> 
Example 3. ovrimos_result_all() example
  <?php
  $conn = ovrimos_connect("db_host", "8001", "admin", 
  "password");
  if ($conn != 0) {
      echo "Connection ok!";
      $res = ovrimos_exec($conn, "update test set i=5");
      if ($res != 0) {
	  echo "Statement ok!";
	  echo ovrimos_num_rows($res)." rows affected\n";
	  ovrimos_free_result($res);
      }
      ovrimos_close($conn);
  }
  ?> 

  ovrimos_prepareUpovrimos_result
#

#T=int ovrimos_result_all ( int result_id [, string format])
ovrimos_result_all ( ^!int result_id [, string format]);
#

#T=ovrimos_result - string ovrimos_result ( int result_id, mixed field)
(PHP 4 >= 4.0.3)
ovrimos_result -- Retrieves the output column
Description
string ovrimos_result ( int result_id, mixed field)
ovrimos_result() retrieves the output column specified by field, either as 
a string or as an 1-based index. Returns FALSE on failure.   ovrimos_result_allUpovrimos_rollback
#

#T=string ovrimos_result ( int result_id, mixed field)
ovrimos_result ( ^!int result_id, mixed field);
#

#T=ovrimos_rollback - bool ovrimos_rollback ( int connection_id)
(PHP 4 >= 4.0.3)
ovrimos_rollback -- Rolls back the transaction
Description
bool ovrimos_rollback ( int connection_id)
ovrimos_rollback() is used to roll back the transaction. Returns TRUE on 
success or FALSE on failure.   ovrimos_resultUpOutput Control Functions
#

#T=bool ovrimos_rollback ( int connection_id)
ovrimos_rollback ( ^!int connection_id);
#

#T=pack - string pack ( string format [, mixed args])
(PHP 3, PHP 4 )
pack -- Pack data into binary string.
Description
string pack ( string format [, mixed args])
Pack given arguments into binary string according to format. Returns 
binary string containing data. 
The idea to this function was taken from Perl and all formatting codes 
work the same as there, however, there are some formatting codes that are 
missing such as Perl's "u" format code. The format string consists of 
format codes followed by an optional repeater argument. The repeater 
argument can be either an integer value or * for repeating to the end of 
the input data. For a, A, h, H the repeat count specifies how many 
characters of one data argument are taken, for @ it is the absolute 
position where to put the next data, for everything else the repeat count 
specifies how many data arguments are consumed and packed into the 
resulting binary string. Currently implemented are 
Table 1. pack() format characters
CodeDescription
aNUL-padded string
ASPACE-padded string
hHex string, low nibble first
HHex string, high nibble first
csigned char
Cunsigned char
ssigned short (always 16 bit, machine byte order)
Sunsigned short (always 16 bit, machine byte order)
nunsigned short (always 16 bit, big endian byte order)
vunsigned short (always 16 bit, little endian byte order)
isigned integer (machine dependent size and byte order)
Iunsigned integer (machine dependent size and byte order)
lsigned long (always 32 bit, machine byte order)
Lunsigned long (always 32 bit, machine byte order)
Nunsigned long (always 32 bit, big endian byte order)
Vunsigned long (always 32 bit, little endian byte order)
ffloat (machine dependent size and representation)
ddouble (machine dependent size and representation)
xNUL byte
XBack up one byte
@NUL-fill to absolute position

Example 1. pack() example
  <?php
  $binarydata = pack("nvc*", 0x1234, 0x5678, 65, 66);
  ?> 

The resulting binary string will be 6 bytes long and contain the 
byte sequence 0x12, 0x34, 0x78, 0x56, 0x41, 0x42. 

Note that the distinction between signed and unsigned values only affects 
the function unpack(), where as function pack() gives the same result for 
signed and unsigned format codes. 
Also note that PHP internally stores integer values as signed values of a 
machine dependent size. If you give it an unsigned integer value too large 
to be stored that way it is converted to a float which often yields an 
undesired result.   ignore_user_abortUpshow_source
#

#T=string pack ( string format [, mixed args])
pack ( ^!string format [, mixed args]);
#

#T=parse_ini_file - array parse_ini_file ( string filename [, bool process_sections])
(PHP 4 )
parse_ini_file -- Parse a configuration file
Description
array parse_ini_file ( string filename [, bool process_sections])
parse_ini_file() loads in the ini file specified in filename, and returns 
the settings in it in an associative array. By setting the last 
process_sections parameter to TRUE, you get a multidimensional array, with 
the section names and settings included. The default for process_sections 
is FALSE 
Note: This function has nothing to do with the php.ini file. It is 
already processed, the time you run your script. This function can be 
used to read in your own application's configuration files. 
Note: If a value in the ini file contains any non-alphanumeric 
characters it needs to be enclosed in double-quotes ("). 
Note: Since PHP 4.2.1 this function is also affected by safe mode and 
open_basedir. 
Note: There are reserved words which must not be used as keys for ini 
files. These include: null, yes, no, true, and false. 
The structure of the ini file is similar to that of the php.ini's. 
Constants may also be parsed in the ini file so if you define a constant 
as an ini value before running parse_ini_file(), it will be integrated 
into the results. Only ini values are evaluated. For example: 
Example 1. Contents of sample.ini
; This is a sample configuration file
; Comments start with ';', as in php.ini

[first_section]
one = 1
five = 5
animal = BIRD

[second_section]
path = /usr/local/bin
URL = "http://www.example.com/~username"
Example 2. parse_ini_file() example
  <?php

  define('BIRD', 'Dodo bird');

  // Parse without sections
  $ini_array = parse_ini_file("sample.ini");
  print_r($ini_array);

  // Parse with sections
  $ini_array = parse_ini_file("sample.ini", true);
  print_r($ini_array);

  ?> 

Would produce: 
Array
(
[one] => 1
[five] => 5
[animal] => Dodo bird
[path] => /usr/local/bin
[URL] => http://www.example.com/~username
)
Array
(
[first_section] => Array
(
[one] => 1
[five] => 5
[animal] = Dodo bird
)

[second_section] => Array
(
[path] => /usr/local/bin
[URL] => http://www.example.com/~username
)

)

  move_uploaded_fileUppathinfo
#

#T=array parse_ini_file ( string filename [, bool process_sections])
parse_ini_file ( ^!string filename [, bool process_sections]);
#

#T=parse_str - void parse_str ( string str [, array arr])
(PHP 3, PHP 4 )
parse_str -- Parses the string into variables
Description
void parse_str ( string str [, array arr])
Parses str as if it were the query string passed via an URL and sets 
variables in the current scope. If the second parameter arr is present, 
variables are stored in this variable as array elements instead. 
Note: Support for the optional second parameter was added in PHP 4.0.3. 
Note: To get the current QUERY_STRING, you may use the variable 
$_SERVER['QUERY_STRING']. Also, you may want to read the section on 
variables from outside of PHP. 
Example 1. Using parse_str()
  <?php
  $str = "first=value&arr[]=foo+bar&arr[]=baz";
  parse_str($str);
  echo $first;  // value
  echo $arr[0]; // foo bar
  echo $arr[1]; // baz

  parse_str($str, $output);
  echo $output['first'];  // value
  echo $output['arr'][0]; // foo bar
  echo $output['arr'][1]; // baz

  ?> 
See also parse_url(), pathinfo(), set_magic_quotes_runtime(), and 
urldecode().   ordUpprint
#

#T=void parse_str ( string str [, array arr])
parse_str ( ^!string str [, array arr]);
#

#T=parse_url - array parse_url ( string url)
(PHP 3, PHP 4 )
parse_url -- Parse a URL and return its components
Description
array parse_url ( string url)
This function returns an associative array containing any of the various 
components of the URL that are present. If one of them is missing, no 
entry will be created for it. The components are : 
scheme - e.g. http 
host 
port 
user 
pass 
path 
query - after the question mark ? 
fragment - after the hashmark # 
This function is not meant to validate the given URL, it only breaks it up 
into the above listed parts. Partial URLs are also accepted, parse_url() 
tries its best to parse them correctly. 
Note: This function doesn't work with relative URLs. 
Example 1. parse_url() example
$ php -r 'print_r(parse_url("http://username:password@hostname/path?arg=value#anchor"));'
Array
(
[scheme] => http
[host] => hostname
[user] => username
[pass] => password
[path] => /path
[query] => arg=value
[fragment] => anchor
)

$ php -r 'print_r(parse_url("http://invalid_host..name/"));'
Array
(
[scheme] => http
[host] => invalid_host..name
[path] => /
)
See also pathinfo(), parse_str(), dirname(), and basename().   http_build_queryUprawurldecode
#

#T=array parse_url ( string url)
parse_url ( ^!string url);
#

#T=passthru - void passthru ( string command [, int return_var])
(PHP 3, PHP 4 )
passthru --  Execute an external program and display raw output 
Description
void passthru ( string command [, int return_var])
The passthru() function is similar to the exec() function in that it 
executes a command. If the return_var argument is present, the return 
status of the Unix command will be placed here. This function should be 
used in place of exec() or system() when the output from the Unix command 
is binary data which needs to be passed directly back to the browser. A 
common use for this is to execute something like the pbmplus utilities 
that can output an image stream directly. By setting the Content-type to 
image/gif and then calling a pbmplus program to output a gif, you can 
create PHP scripts that output images directly. 
Warning
If you are going to allow data coming from user input to be passed 
to this function, then you should be using escapeshellarg() or 
escapeshellcmd() to make sure that users cannot trick the system 
into executing arbitrary commands. 

Note: If you start a program using this function and want to leave it 
running in the background, you have to make sure that the output of that 
program is redirected to a file or some other output stream or else PHP 
will hang until the execution of the program ends. 
Note: When safe mode is enabled, you can only execute executables within 
the safe_mode_exec_dir. For practical reasons it's currently not allowed 
to have .. components in the path to the executable. 
See also exec(), system(), popen(), escapeshellcmd(), and the backtick 
operator.   execUpproc_close
#

#T=void passthru ( string command [, int return_var])
passthru ( ^!string command [, int return_var]);
#

#T=pathinfo - array pathinfo ( string path)
(PHP 4 >= 4.0.3)
pathinfo -- Returns information about a file path
Description
array pathinfo ( string path)
pathinfo() returns an associative array containing information about path. 
The following array elements are returned: dirname, basename and 
extension. 
Example 1. pathinfo() Example
  <?php

  $path_parts = pathinfo("/www/htdocs/index.html");

  echo $path_parts["dirname"] . "\n";
  echo $path_parts["basename"] . "\n";
  echo $path_parts["extension"] . "\n";

  ?> 

Would produce: 
/www/htdocs
index.html
html
Note: For information on retrieving the current path info, read the 
section on predefined reserved variables. 
See also dirname(), basename(), parse_url() and realpath().   parse_ini_fileUppclose
#

#T=array pathinfo ( string path)
pathinfo ( ^!string path);
#

#T=pclose - int pclose ( resource handle)
(PHP 3, PHP 4 )
pclose -- Closes process file pointer
Description
int pclose ( resource handle)
Closes a file pointer to a pipe opened by popen(). 
The file pointer must be valid, and must have been returned by a 
successful call to popen(). 
Returns the termination status of the process that was run. 
See also popen().   pathinfoUppopen
#

#T=int pclose ( resource handle)
pclose ( ^!resource handle);
#

#T=pcntl_exec - bool pcntl_exec ( string path [, array args [, array envs]])
(PHP 4 >= 4.2.0)
pcntl_exec --  Executes specified program in current process space 
Description
bool pcntl_exec ( string path [, array args [, array envs]])
Warning
This function is currently not documented; only the argument list is 
available.
  Process Control FunctionsUppcntl_fork
#

#T=bool pcntl_exec ( string path [, array args [, array envs]])
pcntl_exec ( ^!string path [, array args [, array envs]]);
#

#T=pcntl_fork - int pcntl_fork ( void )
(PHP 4 >= 4.1.0)
pcntl_fork -- Forks the currently running process
Description
int pcntl_fork ( void )
The pcntl_fork() function creates a child process that differs from the 
parent process only in it's PID and PPID. Please see your system's fork(2) 
man page for specific details as to how fork works on your system. 
On success, the PID of the child process is returned in the parent's 
thread of execution, and a 0 is returned in the child's thread of 
execution. On failure, a -1 will be returned in the parent's context, no 
child process will be created, and a PHP error is raised. 
Example 1. pcntl_fork() example
  <?php

  $pid = pcntl_fork();
  if ($pid == -1) {
       die("could not fork");
  } else if ($pid) {
       // we are the parent
  } else {
       // we are the child
  }

  ?> 
See also pcntl_waitpid() and pcntl_signal().   pcntl_execUppcntl_signal
#

#T=int pcntl_fork ( void )
pcntl_fork ( ^!void );
#

#T=pcntl_signal - bool pcntl_signal ( int signo, callback handle [, bool restart_syscalls])
(PHP 4 >= 4.1.0)
pcntl_signal -- Installs a signal handler
Description
bool pcntl_signal ( int signo, callback handle [, bool restart_syscalls])
The pcntl_signal() function installs a new signal handler for the signal 
indicated by signo. The signal handler is set to handler which may be the 
name of a user created function, or either of the two global constants 
SIG_IGN or SIG_DFL. The optional restart_syscalls specifies whether system 
call restarting should be used when this signal arrives and defaults to 
TRUE. 
Returns TRUE on success or FALSE on failure. 
Note: The optional restart_syscalls parameter became available in PHP 
4.3.0. 
Note: The ability to use an object method as a callback became available 
in PHP 4.3.0. Note that when you set a handler to an object method, that 
object's reference count is increased which makes it persist until you 
either change the handler to something else, or your script ends. 
Example 1. pcntl_signal() example
  <?php
  // tick use required as of PHP 4.3.0
  declare(ticks = 1);

  // signal handler function
  function sig_handler($signo) {

       switch ($signo) {
	   case SIGTERM:
	       // handle shutdown tasks
	       exit;
	       break;
	   case SIGHUP:
	       // handle restart tasks
	       break;
	   case SIGUSR1:
	       echo "Caught SIGUSR1...\n";
	       break;
	   default:
	       // handle all other signals
       }

  }

  echo "Installing signal handler...\n";

  // setup signal handlers
  pcntl_signal(SIGTERM, "sig_handler");
  pcntl_signal(SIGHUP,  "sig_handler");
  pcntl_signal(SIGUSR1, "sig_handler");

  // or use an object, available as of PHP 4.3.0
  // pcntl_signal(SIGUSR1, array($obj, "do_something");

  echo"Generating signal SIGTERM to self...\n";

  // send SIGUSR1 to current process id
  posix_kill(posix_getpid(), SIGUSR1);

  echo "Done\n"

  ?> 
See also pcntl_fork() and pcntl_waitpid().   pcntl_forkUppcntl_waitpid
#

#T=bool pcntl_signal ( int signo, callback handle [, bool restart_syscalls])
pcntl_signal ( ^!int signo, callback handle [, bool restart_syscalls]);
#

#T=pcntl_waitpid - int pcntl_waitpid ( int pid, int &status, int options)
(PHP 4 >= 4.1.0)
pcntl_waitpid -- Waits on or returns the status of a forked child
Description
int pcntl_waitpid ( int pid, int &status, int options)
The pcntl_waitpid() function suspends execution of the current process 
until a child as specified by the pid argument has exited, or until a 
signal is delivered whose action is to terminate the current process or to 
call a signal handling function. If a child as requested by pid has 
already exited by the time of the call (a so-called "zombie" process), the 
function returns immediately. Any system resources used by the child are 
freed. Please see your system's waitpid(2) man page for specific details 
as to how waitpid works on your system. 
pcntl_waitpid() returns the process ID of the child which exited, -1 on 
error or zero if WNOHANG was used and no child was available 
The value of pid can be one of the following: 
Table 1. possible values for pid
< -1wait for any child process whose process group ID is equal to 
the absolute value of pid. 
-1wait for any child process; this is the same behaviour that the 
wait function exhibits. 
0wait for any child process whose process group ID is equal to that 
of the calling process. 
> 0wait for the child whose process ID is equal to the value of pid. 
pcntl_waitpid() will store status information in the status parameter 
which can be evaluated using the following functions: pcntl_wifexited(), 
pcntl_wifstopped(), pcntl_wifsignaled(), pcntl_wexitstatus(), 
pcntl_wtermsig() and pcntl_wstopsig(). 
The value of options is the value of zero or more of the following two 
global constants OR'ed together: 
Table 2. possible values for options
WNOHANGreturn immediately if no child has exited. 
WUNTRACEDreturn for children which are stopped, and whose status has 
not been reported. 

See also pcntl_fork(), pcntl_signal(), pcntl_wifexited(), 
pcntl_wifstopped(), pcntl_wifsignaled(), pcntl_wexitstatus(), 
pcntl_wtermsig() and pcntl_wstopsig().   pcntl_signalUppcntl_wexitstatus
#

#T=int pcntl_waitpid ( int pid, int &status, int options)
pcntl_waitpid ( ^!int pid, int &status, int options);
#

#T=pcntl_wexitstatus - int pcntl_wexitstatus ( int status)
(PHP 4 >= 4.1.0)
pcntl_wexitstatus --  Returns the return code of a terminated child 
Description
int pcntl_wexitstatus ( int status)
Returns the return code of a terminated child. This function is only 
useful if pcntl_wifexited() returned TRUE. 
The parameter status is the status parameter supplied to a successfull 
call to pcntl_waitpid(). 
See also pcntl_waitpid() and pcntl_wifexited().   pcntl_waitpidUppcntl_wifexited
#

#T=int pcntl_wexitstatus ( int status)
pcntl_wexitstatus ( ^!int status);
#

#T=pcntl_wifexited - int pcntl_wifexited ( int status)
(PHP 4 >= 4.1.0)
pcntl_wifexited --  Returns TRUE if status code represents a successful 
exit 
Description
int pcntl_wifexited ( int status)
Returns TRUE if the child status code represents a successful exit. 
The parameter status is the status parameter supplied to a successfull 
call to pcntl_waitpid(). 
See also pcntl_waitpid() and pcntl_wexitstatus().   pcntl_wexitstatusUppcntl_wifsignaled
#

#T=int pcntl_wifexited ( int status)
pcntl_wifexited ( ^!int status);
#

#T=pcntl_wifsignaled - int pcntl_wifsignaled ( int status)
(PHP 4 >= 4.1.0)
pcntl_wifsignaled --  Returns TRUE if status code represents a termination 
due to a signal 
Description
int pcntl_wifsignaled ( int status)
Returns TRUE if the child process exited because of a signal which was not 
caught. 
The parameter status is the status parameter supplied to a successfull 
call to pcntl_waitpid(). 
See also pcntl_waitpid() and pcntl_signal().   pcntl_wifexitedUppcntl_wifstopped
#

#T=int pcntl_wifsignaled ( int status)
pcntl_wifsignaled ( ^!int status);
#

#T=pcntl_wifstopped - int pcntl_wifstopped ( int status)
(PHP 4 >= 4.1.0)
pcntl_wifstopped --  Returns TRUE if child process is currently stopped 
Description
int pcntl_wifstopped ( int status)
Returns TRUE if the child process which caused the return is currently 
stopped; this is only possible if the call to pcntl_waitpid() was done 
using the option WUNTRACED. 
The parameter status is the status parameter supplied to a successfull 
call to pcntl_waitpid(). 
See also pcntl_waitpid().   pcntl_wifsignaledUppcntl_wstopsig
#

#T=int pcntl_wifstopped ( int status)
pcntl_wifstopped ( ^!int status);
#

#T=pcntl_wstopsig - int pcntl_wstopsig ( int status)
(PHP 4 >= 4.1.0)
pcntl_wstopsig --  Returns the signal which caused the child to stop 
Description
int pcntl_wstopsig ( int status)
Returns the number of the signal which caused the child to stop. This 
function is only useful if pcntl_wifstopped() returned TRUE. 
The parameter status is the status parameter supplied to a successfull 
call to pcntl_waitpid(). 
See also pcntl_waitpid() and pcntl_wifstopped().   pcntl_wifstoppedUppcntl_wtermsig
#

#T=int pcntl_wstopsig ( int status)
pcntl_wstopsig ( ^!int status);
#

#T=pcntl_wtermsig - int pcntl_wtermsig ( int status)
(PHP 4 >= 4.1.0)
pcntl_wtermsig --  Returns the signal which caused the child to terminate 
Description
int pcntl_wtermsig ( int status)
Returns the number of the signal that caused the child process to 
terminate. This function is only useful if pcntl_wifsignaled() returned 
TRUE. 
The parameter status is the status parameter supplied to a successfull 
call to pcntl_waitpid(). 
See also pcntl_waitpid(), pcntl_signal() and pcntl_wifsignaled().   pcntl_wstopsigUpProgram Execution functions
pdf_add_annotation
pdf_add_annotation -- Deprecated: Adds annotation
Description
This function is deprecated, use pdf_add_note() instead.   PDF functionsUppdf_add_bookmark
#

#T=int pcntl_wtermsig ( int status)
pcntl_wtermsig ( ^!int status);
#

#T=pdf_add_bookmark - int pdf_add_bookmark ( resource pdfdoc, string text [, int parent [, int 
(PHP 4 >= 4.0.1)
pdf_add_bookmark -- Adds bookmark for current page
Description
int pdf_add_bookmark ( resource pdfdoc, string text [, int parent [, int 
open]])
Add a nested bookmark under parent, or a new top-level bookmark if parent 
= 0. Returns a bookmark descriptor which may be used as parent for 
subsequent nested bookmarks. If open = 1, child bookmarks will be folded 
out, and invisible if open = 0. 
Example 1. pdf_add_bookmark() example
  <?php
  // create a new PDF

  $pdf = pdf_new();
  pdf_open_file($pdf);
  pdf_set_info($pdf, "Author", "Bob Nijman");

  // begin a new page
  pdf_begin_page($pdf, 300, 300);

  // add a top-level bookmark
  $bookmark = pdf_add_bookmark($pdf, "People");

  // add a nested bookmark
  pdf_add_bookmark($pdf, "Rasmus", $bookmark);

  // and some text
  pdf_set_font($pdf, "Helvetica", 20, "host");
  $text = "This is R's page";
  $width = pdf_stringwidth($pdf, $text);
  pdf_set_text_pos($pdf, (300-$width)/2, 100);
  pdf_show($pdf, $text);

  // close the page and the PDF
  pdf_end_page($pdf); 
  pdf_close($pdf);

  ?> 

  pdf_add_annotationUppdf_add_launchlink
#

#T=int pdf_add_bookmark ( resource pdfdoc, string text [, int parent [, int 
pdf_add_bookmark ( ^!resource pdfdoc, string text [, int parent [, int ;
#

#T=pdf_add_launchlink - bool pdf_add_launchlink ( resource pdfdoc, float llx, float lly, float 
(PHP 4 >= 4.0.5)
pdf_add_launchlink -- Add a launch annotation for current page
Description
bool pdf_add_launchlink ( resource pdfdoc, float llx, float lly, float 
urx, float ury, string filename)
Adds a link to a web resource specified by filename. Returns TRUE on 
success or FALSE on failure. 
See also pdf_add_locallink().   pdf_add_bookmarkUppdf_add_locallink
#

#T=bool pdf_add_launchlink ( resource pdfdoc, float llx, float lly, float 
pdf_add_launchlink ( ^!resource pdfdoc, float llx, float lly, float ;
#

#T=pdf_add_locallink - bool pdf_add_locallink ( resource pdfdoc, float lowerleftx, float 
(PHP 4 >= 4.0.5)
pdf_add_locallink -- Add a link annotation for current page
Description
bool pdf_add_locallink ( resource pdfdoc, float lowerleftx, float 
lowerlefty, float upperrightx, float upperrighty, int page, string dest)
Add a link annotation to a target within the current PDF file. Returns 
TRUE on success or FALSE on failure. 
dest is the zoom setting on the destination page, it can be one of retain, 
fitpage, fitwidth, fitheight or fitbbox. 
See also pdf_add_launchlink().   pdf_add_launchlinkUppdf_add_note
#

#T=bool pdf_add_locallink ( resource pdfdoc, float lowerleftx, float 
pdf_add_locallink ( ^!resource pdfdoc, float lowerleftx, float ;
#

#T=pdf_add_note - bool pdf_add_note ( resource pdfdoc, float llx, float lly, float urx, 
(PHP 4 >= 4.0.5)
pdf_add_note -- Sets annotation for current page
Description
bool pdf_add_note ( resource pdfdoc, float llx, float lly, float urx, 
float ury, string contents, string title, string icon, int open)
Sets an annotation for the current page. icon is one of comment, insert, 
note, paragraph, newparagraph, key, or help. Returns TRUE on success or 
FALSE on failure.   pdf_add_locallinkUppdf_add_outline
pdf_add_outline
pdf_add_outline -- Deprecated: Adds bookmark for current page
Description
This function is deprecated, use pdf_add_bookmark() instead.   pdf_add_noteUppdf_add_pdflink
#

#T=bool pdf_add_note ( resource pdfdoc, float llx, float lly, float urx, 
pdf_add_note ( ^!resource pdfdoc, float llx, float lly, float urx, ;
#

#T=pdf_add_pdflink - bool pdf_add_pdflink ( resource pdfdoc, float bottom_left_x, float 
(PHP 3>= 3.0.12, PHP 4 )
pdf_add_pdflink -- Adds file link annotation for current page
Description
bool pdf_add_pdflink ( resource pdfdoc, float bottom_left_x, float 
bottom_left_y, float up_right_x, float up_right_y, string filename, int 
page, string dest)
Add a file link annotation (to a PDF target). Returns TRUE on success or 
FALSE on failure. 
See also pdf_add_locallink() and pdf_add_weblink().   pdf_add_outlineUppdf_add_thumbnail
#

#T=bool pdf_add_pdflink ( resource pdfdoc, float bottom_left_x, float 
pdf_add_pdflink ( ^!resource pdfdoc, float bottom_left_x, float ;
#

#T=pdf_add_thumbnail - bool pdf_add_thumbnail ( resource pdfdoc, int image)
(PHP 4 >= 4.0.5)
pdf_add_thumbnail -- Adds thumbnail for current page
Description
bool pdf_add_thumbnail ( resource pdfdoc, int image)
Adds an existing image as thumbnail for the current page. Thumbnail images 
must not be wider or higher than 106 pixels. Returns TRUE on success or 
FALSE on failure. 
See also pdf_open_image(), pdf_open_image_file(), pdf_open_memory_image(). 
  pdf_add_pdflinkUppdf_add_weblink
#

#T=bool pdf_add_thumbnail ( resource pdfdoc, int image)
pdf_add_thumbnail ( ^!resource pdfdoc, int image);
#

#T=pdf_add_weblink - bool pdf_add_weblink ( resource pdfdoc, float lowerleftx, float 
(PHP 3>= 3.0.12, PHP 4 )
pdf_add_weblink -- Adds weblink for current page
Description
bool pdf_add_weblink ( resource pdfdoc, float lowerleftx, float 
lowerlefty, float upperrightx, float upperrighty, string url)
Add a weblink annotation to a target url on the Web. Returns TRUE on 
success or FALSE on failure.   pdf_add_thumbnailUppdf_arc
#

#T=bool pdf_add_weblink ( resource pdfdoc, float lowerleftx, float 
pdf_add_weblink ( ^!resource pdfdoc, float lowerleftx, float ;
#

#T=pdf_arc - bool pdf_arc ( resource pdfdoc, float x, float y, float r, float alpha, 
(PHP 3>= 3.0.6, PHP 4 )
pdf_arc -- Draws an arc (counterclockwise)
Description
bool pdf_arc ( resource pdfdoc, float x, float y, float r, float alpha, 
float beta)
Add a counterclockwise circular arc from alpha to beta degrees with center 
(x; y) and radius r. Actual drawing of the circle is performed by the next 
stroke or fill operation. 
Example 1. pdf_arcn() example
  <?php
      // prepare document
      $pdf = pdf_new();
      pdf_open_file($pdf, "");
      pdf_begin_page($pdf, 595, 842);
      
      // an outlined arc
      pdf_arc($pdf, 200, 700, 100, 0, 90);
      pdf_stroke($pdf);

      // a filled arc
      pdf_arc($pdf, 200, 700, 50, 0, 90);
      pdf_fill($pdf);

    // an outlined and filled arc
    pdf_setcolor($pdf, "fill", "gray", 0.8);
      pdf_arc($pdf, 400, 700, 50, 0, 90);
    pdf_fill_stroke($pdf);

      // finish document
      pdf_end_page($pdf);
      pdf_close($pdf);
      header("Content-type: application/pdf");
      echo pdf_get_buffer($pdf);
      pdf_delete($pdf);
  ?> 
See also: pdf_arcn(), pdf_circle(), pdf_stroke(), pdf_fill() and 
pdf_fill_stroke().   pdf_add_weblinkUppdf_arcn
#

#T=bool pdf_arc ( resource pdfdoc, float x, float y, float r, float alpha, 
pdf_arc ( ^!resource pdfdoc, float x, float y, float r, float alpha, ;
#

#T=pdf_arcn - bool pdf_arcn ( resource pdfdoc, float x, float y, float r, float alpha, 
(PHP 4 >= 4.0.5)
pdf_arcn -- Draws an arc (clockwise)
Description
bool pdf_arcn ( resource pdfdoc, float x, float y, float r, float alpha, 
float beta)
Add a clockwise circular arc from alpha to beta degrees with center (x; y) 
and radius r. Actual drawing of the circle is performed by the next stroke 
or fill operation. 
Example 1. pdf_arcn() example
  <?php
      // prepare document
      $pdf = pdf_new();
      pdf_open_file($pdf, "");
      pdf_begin_page($pdf, 595, 842);
      
      // an outlined arcn
      pdf_arcn($pdf, 200, 700, 100, 0, 90);
      pdf_stroke($pdf);

      // a filled arcn
      pdf_arcn($pdf, 200, 700, 50, 0, 90);
      pdf_fill($pdf);

    // an outlined and filled arcn
    pdf_setcolor($pdf, "fill", "gray", 0.8);
      pdf_arcn($pdf, 400, 700, 50, 0, 90);
    pdf_fill_stroke($pdf);

      // finish document
      pdf_end_page($pdf);
      pdf_close($pdf);
      header("Content-type: application/pdf");
      echo pdf_get_buffer($pdf);
      pdf_delete($pdf);
  ?> 
See also: pdf_arc(), pdf_circle(), pdf_stroke(), pdf_fill() and 
pdf_fillstroke().   pdf_arcUppdf_attach_file
#

#T=bool pdf_arcn ( resource pdfdoc, float x, float y, float r, float alpha, 
pdf_arcn ( ^!resource pdfdoc, float x, float y, float r, float alpha, ;
#

#T=pdf_attach_file - bool pdf_attach_file ( resource pdfdoc, float llx, float lly, float urx, 
(PHP 4 >= 4.0.5)
pdf_attach_file -- Adds a file attachment for current page
Description
bool pdf_attach_file ( resource pdfdoc, float llx, float lly, float urx, 
float ury, string filename, string description, string author, string 
mimetype, string icon)
Add a file attachment annotation. icon is one of graph, paperclip, 
pushpin, or tag. Returns TRUE on success or FALSE on failure. 
Note: Only the 'Full' Acrobat software will be able to display these 
file attachments. All other PDF viewers will either show nothing or 
display a question mark.   pdf_arcnUppdf_begin_page
#

#T=bool pdf_attach_file ( resource pdfdoc, float llx, float lly, float urx, 
pdf_attach_file ( ^!resource pdfdoc, float llx, float lly, float urx, ;
#

#T=pdf_begin_page - bool pdf_begin_page ( resource pdfdoc, float width, float height)
(PHP 3>= 3.0.6, PHP 4 )
pdf_begin_page -- Starts new page
Description
bool pdf_begin_page ( resource pdfdoc, float width, float height)
Add a new page to the document. Returns TRUE on success or FALSE on 
failure. The width and height are specified in points, which are 1/72 of 
an inch. 
Table 1. Common Page Sizes in Points
namesize
A02380&#10007;3368
A11684&#10007;2380
A21190&#10007;1684
A3842&#10007;1190
A4595&#10007;842
A5421&#10007;595
A6297&#10007;421
B5501&#10007;709
letter (8.5"&#10007;11")612&#10007;792
legal (8.5"&#10007;14")612&#10007;1008
ledger (17"&#10007;11")1224&#10007;792
11"&#10007;17"792&#10007;1224

See also pdf_end_page().   pdf_attach_fileUppdf_begin_pattern
#

#T=bool pdf_begin_page ( resource pdfdoc, float width, float height)
pdf_begin_page ( ^!resource pdfdoc, float width, float height);
#

#T=pdf_begin_pattern - int pdf_begin_pattern ( resource pdfdoc, float width, float height, float 
(PHP 4 >= 4.0.5)
pdf_begin_pattern -- Starts new pattern
Description
int pdf_begin_pattern ( resource pdfdoc, float width, float height, float 
xstep, float ystep, int painttype)
Starts a new pattern definition and returns a pattern handle. width, and 
height define the bounding box for the pattern. xstep and ystep give the 
repeated pattern offsets. painttype=1 means that the pattern has its own 
colour settings whereas a value of 2 indicates that the current colour is 
used when the pattern is applied. 
See also pdf_end_pattern().   pdf_begin_pageUppdf_begin_template
#

#T=int pdf_begin_pattern ( resource pdfdoc, float width, float height, float 
pdf_begin_pattern ( ^!resource pdfdoc, float width, float height, float ;
#

#T=pdf_begin_template - int pdf_begin_template ( resource pdfdoc, float width, float height)
(PHP 4 >= 4.0.5)
pdf_begin_template -- Starts new template
Description
int pdf_begin_template ( resource pdfdoc, float width, float height)
Start a new template definition.   pdf_begin_patternUppdf_circle
#

#T=int pdf_begin_template ( resource pdfdoc, float width, float height)
pdf_begin_template ( ^!resource pdfdoc, float width, float height);
#

#T=pdf_circle - bool pdf_circle ( resource pdfdoc, float x, float y, float r)
(PHP 3>= 3.0.6, PHP 4 )
pdf_circle -- Draws a circle
Description
bool pdf_circle ( resource pdfdoc, float x, float y, float r)
Add a circle with center (x, y) and radius r to the current page. Actual 
drawing of the circle is performed by the next stroke or fill operation. 
Returns TRUE on success or FALSE on failure. 
Example 1. pdf_circle() example
  <?php
      // prepare document
      $pdf = pdf_new();
      pdf_open_file($pdf, "");
      pdf_begin_page($pdf, 595, 842);
      
      // an outlined circle
      pdf_circle($pdf, 200, 700, 100);
      pdf_stroke($pdf);

      // a filled circle
      pdf_circle($pdf, 200, 700, 50);
      pdf_fill($pdf);

    // an outlined and filled circle
    pdf_setcolor($pdf, "fill", "gray", 0.3);
      pdf_circle($pdf, 400, 700, 50);
    pdf_fill_stroke($pdf);

      // finish document
      pdf_end_page($pdf);
      pdf_close($pdf);
      header("Content-type: application/pdf");
      echo pdf_get_buffer($pdf);
      pdf_delete($pdf);
  ?> 
See also: pdf_arc(), pdf_arcn(), pdf_curveto(), pdf_stroke(), pdf_fill() 
and pdf_fill_stroke().   pdf_begin_templateUppdf_clip
#

#T=bool pdf_circle ( resource pdfdoc, float x, float y, float r)
pdf_circle ( ^!resource pdfdoc, float x, float y, float r);
#

#T=pdf_clip - bool pdf_clip ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_clip -- Clips to current path
Description
bool pdf_clip ( resource pdfdoc)
Use the current path as clipping path. Returns TRUE on success or FALSE on 
failure.   pdf_circleUppdf_close_image
#

#T=bool pdf_clip ( resource pdfdoc)
pdf_clip ( ^!resource pdfdoc);
#

#T=pdf_close_image - void pdf_close_image ( resource pdfdoc, int image)
(PHP 3>= 3.0.7, PHP 4 )
pdf_close_image -- Closes an image
Description
void pdf_close_image ( resource pdfdoc, int image)
Close an image retrieved with the pdf_open_image() function.   pdf_clipUppdf_close_pdi_page
#

#T=void pdf_close_image ( resource pdfdoc, int image)
pdf_close_image ( ^!resource pdfdoc, int image);
#

#T=pdf_close_pdi_page - bool pdf_close_pdi_page ( resource pdfdoc, int pagehandle)
(PHP 4 >= 4.0.5)
pdf_close_pdi_page --  Close the page handle 
Description
bool pdf_close_pdi_page ( resource pdfdoc, int pagehandle)
Close the page handle, and free all page-related resources. Returns TRUE 
on success or FALSE on failure.   pdf_close_imageUppdf_close_pdi
#

#T=bool pdf_close_pdi_page ( resource pdfdoc, int pagehandle)
pdf_close_pdi_page ( ^!resource pdfdoc, int pagehandle);
#

#T=pdf_close_pdi - bool pdf_close_pdi ( resource pdfdoc, int dochandle)
(PHP 4 >= 4.0.5)
pdf_close_pdi --  Close the input PDF document 
Description
bool pdf_close_pdi ( resource pdfdoc, int dochandle)
Close all open page handles, and close the input PDF document. Returns 
TRUE on success or FALSE on failure. 
See also pdf_open_pdi().   pdf_close_pdi_pageUppdf_close
#

#T=bool pdf_close_pdi ( resource pdfdoc, int dochandle)
pdf_close_pdi ( ^!resource pdfdoc, int dochandle);
#

#T=pdf_close - bool pdf_close ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_close -- Closes a pdf resource
Description
bool pdf_close ( resource pdfdoc)
Close the generated PDF file, and free all document-related resources. 
Returns TRUE on success or FALSE on failure. 
See also pdf_new().   pdf_close_pdiUppdf_closepath_fill_stroke
#

#T=bool pdf_close ( resource pdfdoc)
pdf_close ( ^!resource pdfdoc);
#

#T=pdf_closepath_fill_stroke - bool pdf_closepath_fill_stroke ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_closepath_fill_stroke -- Closes, fills and strokes current path
Description
bool pdf_closepath_fill_stroke ( resource pdfdoc)
Close the path, fill, and stroke it. Returns TRUE on success or FALSE on 
failure. 
See also pdf_closepath() and pdf_closepath_stroke().   pdf_closeUppdf_closepath_stroke
#

#T=bool pdf_closepath_fill_stroke ( resource pdfdoc)
pdf_closepath_fill_stroke ( ^!resource pdfdoc);
#

#T=pdf_closepath_stroke - bool pdf_closepath_stroke ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_closepath_stroke -- Closes path and draws line along path
Description
bool pdf_closepath_stroke ( resource pdfdoc)
Close the path, and stroke it. Returns TRUE on success or FALSE on 
failure. 
See also pdf_closepath() and pdf_closepath_fil_stroke().   pdf_closepath_fill_strokeUppdf_closepath
#

#T=bool pdf_closepath_stroke ( resource pdfdoc)
pdf_closepath_stroke ( ^!resource pdfdoc);
#

#T=pdf_closepath - bool pdf_closepath ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_closepath -- Closes path
Description
bool pdf_closepath ( resource pdfdoc)
Close the current path. Returns TRUE on success or FALSE on failure. 
See also pdf_closepath_stroke() and pdf_closepath_fil_stroke().   pdf_closepath_strokeUppdf_concat
#

#T=bool pdf_closepath ( resource pdfdoc)
pdf_closepath ( ^!resource pdfdoc);
#

#T=pdf_concat - bool pdf_concat ( resource pdfdoc, float a, float b, float c, float d, 
(PHP 4 >= 4.0.5)
pdf_concat -- Concatenate a matrix to the CTM
Description
bool pdf_concat ( resource pdfdoc, float a, float b, float c, float d, 
float e, float f)
Concatenate a matrix to the CTM. Returns TRUE on success or FALSE on 
failure.   pdf_closepathUppdf_continue_text
#

#T=bool pdf_concat ( resource pdfdoc, float a, float b, float c, float d, 
pdf_concat ( ^!resource pdfdoc, float a, float b, float c, float d, ;
#

#T=pdf_continue_text - bool pdf_continue_text ( resource pdfdoc, string text)
(PHP 3>= 3.0.6, PHP 4 )
pdf_continue_text -- Outputs text in next line
Description
bool pdf_continue_text ( resource pdfdoc, string text)
Print text at the next line. Returns TRUE on success or FALSE on failure.   pdf_concatUppdf_curveto
#

#T=bool pdf_continue_text ( resource pdfdoc, string text)
pdf_continue_text ( ^!resource pdfdoc, string text);
#

#T=pdf_curveto - bool pdf_curveto ( resource pdfdoc, float x1, float y1, float x2, float 
(PHP 3>= 3.0.6, PHP 4 )
pdf_curveto -- Draws a curve
Description
bool pdf_curveto ( resource pdfdoc, float x1, float y1, float x2, float 
y2, float x3, float y3)
Draw a Bezier curve from the current point, using 3 more control points. 
Returns TRUE on success or FALSE on failure.   pdf_continue_textUppdf_delete
#

#T=bool pdf_curveto ( resource pdfdoc, float x1, float y1, float x2, float 
pdf_curveto ( ^!resource pdfdoc, float x1, float y1, float x2, float ;
#

#T=pdf_delete - bool pdf_delete ( resource pdfdoc)
(PHP 4 >= 4.0.5)
pdf_delete -- Deletes a PDF object
Description
bool pdf_delete ( resource pdfdoc)
Delete the PDF resource, and free all internal resources. Returns TRUE on 
success or FALSE on failure. 
See also pdf_new().   pdf_curvetoUppdf_end_page
#

#T=bool pdf_delete ( resource pdfdoc)
pdf_delete ( ^!resource pdfdoc);
#

#T=pdf_end_page - bool pdf_end_page ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_end_page -- Ends a page
Description
bool pdf_end_page ( resource pdfdoc)
Finish the page. Returns TRUE on success or FALSE on failure. 
See also pdf_begin_page().   pdf_deleteUppdf_end_pattern
#

#T=bool pdf_end_page ( resource pdfdoc)
pdf_end_page ( ^!resource pdfdoc);
#

#T=pdf_end_pattern - bool pdf_end_pattern ( resource pdfdoc)
(PHP 4 >= 4.0.5)
pdf_end_pattern -- Finish pattern
Description
bool pdf_end_pattern ( resource pdfdoc)
Finish the pattern definition. Returns TRUE on success or FALSE on 
failure. 
See also pdf_begin_pattern().   pdf_end_pageUppdf_end_template
#

#T=bool pdf_end_pattern ( resource pdfdoc)
pdf_end_pattern ( ^!resource pdfdoc);
#

#T=pdf_end_template - bool pdf_end_template ( resource pdfdoc)
(PHP 4 >= 4.0.5)
pdf_end_template -- Finish template
Description
bool pdf_end_template ( resource pdfdoc)
Finish the template definition. Returns TRUE on success or FALSE on 
failure.   pdf_end_patternUppdf_endpath
pdf_endpath
pdf_endpath -- Deprecated: Ends current path
Description
This function is deprecated, use one of the pdf_stroke(), pdf_clip() or 
pdf_closepath_fill_stroke() functions instead.   pdf_end_templateUppdf_fill_stroke
#

#T=bool pdf_end_template ( resource pdfdoc)
pdf_end_template ( ^!resource pdfdoc);
#

#T=pdf_fill_stroke - bool pdf_fill_stroke ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_fill_stroke -- Fills and strokes current path
Description
bool pdf_fill_stroke ( resource pdfdoc)
Fill and stroke the path with the current fill and stroke color. Returns 
TRUE on success or FALSE on failure. 
See also pdf_setcolor().   pdf_endpathUppdf_fill
#

#T=bool pdf_fill_stroke ( resource pdfdoc)
pdf_fill_stroke ( ^!resource pdfdoc);
#

#T=pdf_fill - bool pdf_fill ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_fill -- Fills current path
Description
bool pdf_fill ( resource pdfdoc)
Fill the interior of the path with the current fill color. Returns TRUE on 
success or FALSE on failure. 
See also pdf_setcolor().   pdf_fill_strokeUppdf_findfont
#

#T=bool pdf_fill ( resource pdfdoc)
pdf_fill ( ^!resource pdfdoc);
#

#T=pdf_findfont - int pdf_findfont ( resource pdfdoc, string fontname, string encoding [, 
(PHP 4 >= 4.0.5)
pdf_findfont -- Prepare font for later use with pdf_setfont().
Description
int pdf_findfont ( resource pdfdoc, string fontname, string encoding [, 
int embed])
Prepare a font for later use with pdf_setfont(). The metrics will be 
loaded, and if embed is nonzero, the font file will be checked, but not 
yet used. encoding is one of builtin, macroman, winansi, host, a 
user-defined encoding name or the name of a CMap. 
pdf_findfont() returns a font handle or FALSE on error. 
Example 1. pdf_findfont() example
  <?php

  $font = pdf_findfont($pdf, "Times New Roman", "winansi", 1);
  if ($font) {
      pdf_setfont($pdf, $font, 10);
  }

  ?> 

  pdf_fillUppdf_get_buffer
#

#T=int pdf_findfont ( resource pdfdoc, string fontname, string encoding [, 
pdf_findfont ( ^!resource pdfdoc, string fontname, string encoding [, ;
#

#T=pdf_get_buffer - string pdf_get_buffer ( resource pdfdoc)
(PHP 4 >= 4.0.5)
pdf_get_buffer -- Fetch the buffer containing the generated PDF data.
Description
string pdf_get_buffer ( resource pdfdoc)
Get the contents of the PDF output buffer. The result must be used by the 
client before calling any other PDFlib function.   pdf_findfontUppdf_get_font
pdf_get_font
pdf_get_font -- Deprecated: font handling
Description
This function is deprecated, use pdf_get_value() instead.   pdf_get_bufferUppdf_get_fontname
pdf_get_fontname
pdf_get_fontname -- Deprecated: font handling
Description
This function is deprecated, use pdf_get_parameter() instead.   pdf_get_fontUppdf_get_fontsize
pdf_get_fontsize
pdf_get_fontsize -- Deprecated: font handling
Description
This function is deprecated, use pdf_get_value() instead.   pdf_get_fontnameUppdf_get_image_height
pdf_get_image_height
pdf_get_image_height -- Deprecated: returns height of an image
Description
This function is deprecated, use pdf_get_value() instead.   pdf_get_fontsizeUppdf_get_image_width
pdf_get_image_width
pdf_get_image_width -- Deprecated: Returns width of an image
Description
This function is deprecated, use pdf_get_value() instead.   pdf_get_image_heightUppdf_get_majorversion
#

#T=string pdf_get_buffer ( resource pdfdoc)
pdf_get_buffer ( ^!resource pdfdoc);
#

#T=pdf_get_majorversion - int pdf_get_majorversion ( void )
(PHP 4 >= 4.2.0)
pdf_get_majorversion --  Returns the major version number of the PDFlib 
Description
int pdf_get_majorversion ( void )
Returns the major version number of the PDFlib. 
See also pdf_get_minorversion().   pdf_get_image_widthUppdf_get_minorversion
#

#T=int pdf_get_majorversion ( void )
pdf_get_majorversion ( ^!void );
#

#T=pdf_get_minorversion - int pdf_get_minorversion ( void )
(PHP 4 >= 4.2.0)
pdf_get_minorversion --  Returns the minor version number of the PDFlib 
Description
int pdf_get_minorversion ( void )
Returns the minor version number of the PDFlib. 
See also pdf_get_majorversion().   pdf_get_majorversionUppdf_get_parameter
#

#T=int pdf_get_minorversion ( void )
pdf_get_minorversion ( ^!void );
#

#T=pdf_get_parameter - string pdf_get_parameter ( resource pdfdoc, string key [, float modifier])
(PHP 4 >= 4.0.1)
pdf_get_parameter -- Gets certain parameters
Description
string pdf_get_parameter ( resource pdfdoc, string key [, float modifier])
Get the contents of some PDFlib parameter with string type.   pdf_get_minorversionUppdf_get_pdi_parameter
#

#T=string pdf_get_parameter ( resource pdfdoc, string key [, float modifier])
pdf_get_parameter ( ^!resource pdfdoc, string key [, float modifier]);
#

#T=pdf_get_pdi_parameter - string pdf_get_pdi_parameter ( resource pdfdoc, string key, int document, 
(PHP 4 >= 4.0.5)
pdf_get_pdi_parameter -- Get some PDI string parameters
Description
string pdf_get_pdi_parameter ( resource pdfdoc, string key, int document, 
int page, int index)
Get the contents of some PDI document parameter with string type.   pdf_get_parameterUppdf_get_pdi_value
#

#T=string pdf_get_pdi_parameter ( resource pdfdoc, string key, int document, 
pdf_get_pdi_parameter ( ^!resource pdfdoc, string key, int document, ;
#

#T=pdf_get_pdi_value - string pdf_get_pdi_value ( resource pdfdoc, string key, int doc, int page, 
(PHP 4 >= 4.0.5)
pdf_get_pdi_value -- Gets some PDI numerical parameters
Description
string pdf_get_pdi_value ( resource pdfdoc, string key, int doc, int page, 
int index)
Get the contents of some PDI document parameter with numerical type.   pdf_get_pdi_parameterUppdf_get_value
#

#T=string pdf_get_pdi_value ( resource pdfdoc, string key, int doc, int page, 
pdf_get_pdi_value ( ^!resource pdfdoc, string key, int doc, int page, ;
#

#T=pdf_get_value - float pdf_get_value ( resource pdfdoc, string key [, float modifier])
(PHP 4 >= 4.0.1)
pdf_get_value -- Gets certain numerical value
Description
float pdf_get_value ( resource pdfdoc, string key [, float modifier])
Get the contents of some PDFlib parameter with float type.   pdf_get_pdi_valueUppdf_initgraphics
#

#T=float pdf_get_value ( resource pdfdoc, string key [, float modifier])
pdf_get_value ( ^!resource pdfdoc, string key [, float modifier]);
#

#T=pdf_initgraphics - bool pdf_initgraphics ( resource pdfdoc)
(PHP 4 >= 4.0.5)
pdf_initgraphics -- Resets graphic state
Description
bool pdf_initgraphics ( resource pdfdoc)
Reset all implicit color and graphics state parameters to their defaults. 
Returns TRUE on success or FALSE on failure.   pdf_get_valueUppdf_lineto
#

#T=bool pdf_initgraphics ( resource pdfdoc)
pdf_initgraphics ( ^!resource pdfdoc);
#

#T=pdf_lineto - bool pdf_lineto ( resource pdfdoc, float x, float y)
(PHP 3>= 3.0.6, PHP 4 )
pdf_lineto -- Draws a line
Description
bool pdf_lineto ( resource pdfdoc, float x, float y)
Draw a line from the current point to (x, y). Returns TRUE on success or 
FALSE on failure.   pdf_initgraphicsUppdf_makespotcolor
#

#T=bool pdf_lineto ( resource pdfdoc, float x, float y)
pdf_lineto ( ^!resource pdfdoc, float x, float y);
#

#T=pdf_makespotcolor - bool pdf_makespotcolor ( resource pdfdoc, string spotname)
(PHP 4 >= 4.0.5)
pdf_makespotcolor -- Makes a spotcolor
Description
bool pdf_makespotcolor ( resource pdfdoc, string spotname)
Make a named spot color from the current color. Returns TRUE on success or 
FALSE on failure. 
See also pdf_setcolor().   pdf_linetoUppdf_moveto
#

#T=bool pdf_makespotcolor ( resource pdfdoc, string spotname)
pdf_makespotcolor ( ^!resource pdfdoc, string spotname);
#

#T=pdf_moveto - bool pdf_moveto ( resource pdfdoc, float x, float y)
(PHP 3>= 3.0.6, PHP 4 )
pdf_moveto -- Sets current point
Description
bool pdf_moveto ( resource pdfdoc, float x, float y)
Set the current point to (x, y. Returns TRUE on success or FALSE on 
failure. 
Note: The current point for graphics and the current text output 
position are maintained separately. See pdf_set_text_pos() to set the 
text output position.   pdf_makespotcolorUppdf_new
#

#T=bool pdf_moveto ( resource pdfdoc, float x, float y)
pdf_moveto ( ^!resource pdfdoc, float x, float y);
#

#T=pdf_new - resource pdf_new ( )
(PHP 4 >= 4.0.5)
pdf_new -- Creates a new pdf resource
Description
resource pdf_new ( )
Create a new PDF resource, using default error handling and memory 
management. 
See also pdf_close().   pdf_movetoUppdf_open_CCITT
#

#T=resource pdf_new ( )
pdf_new ( ^!);
#

#T=pdf_open_CCITT - int pdf_open_CCITT ( resource pdfdoc, string filename, int width, int 
(PHP 4 >= 4.0.5)
pdf_open_CCITT -- Opens a new image file with raw CCITT data
Description
int pdf_open_CCITT ( resource pdfdoc, string filename, int width, int 
height, int BitReverse, int k, int Blackls1)
Open a raw CCITT image.   pdf_newUppdf_open_file
#

#T=int pdf_open_CCITT ( resource pdfdoc, string filename, int width, int 
pdf_open_CCITT ( ^!resource pdfdoc, string filename, int width, int ;
#

#T=pdf_open_file - bool pdf_open_file ( resource pdfdoc [, string filename])
(PHP 4 >= 4.0.5)
pdf_open_file -- Opens a new pdf object
Description
bool pdf_open_file ( resource pdfdoc [, string filename])
Create a new PDF file using the supplied file name. If filename is empty 
the PDF document will be generated in memory instead of on file. The 
result must be fetched by the client with the pdf_get_buffer() function. 
Returns TRUE on success or FALSE on failure. 
The following example shows how to create a pdf document in memory and how 
to output it correctly. Example 1. Creating a PDF document in memory
  <?php

  $pdf = pdf_new();

  pdf_open_file($pdf);
  pdf_begin_page($pdf, 595, 842);
  pdf_set_font($pdf, "Times-Roman", 30, "host");
  pdf_set_value($pdf, "textrendering", 1);
  pdf_show_xy($pdf, "A PDF document created in memory!", 50, 
  750);
  pdf_end_page($pdf);
  pdf_close($pdf);

  $data = pdf_get_buffer($pdf);

  header("Content-type: application/pdf");
  header("Content-disposition: inline; filename=test.pdf");
  header("Content-length: " . strlen($data));

  echo $data;

  ?> 

  pdf_open_CCITTUppdf_open_gif
pdf_open_gif
pdf_open_gif -- Deprecated: Opens a GIF image
Description
This function is deprecated, use pdf_open_image() instead.   pdf_open_fileUppdf_open_image_file
#

#T=bool pdf_open_file ( resource pdfdoc [, string filename])
pdf_open_file ( ^!resource pdfdoc [, string filename]);
#

#T=pdf_open_image_file - int pdf_open_image_file ( resource pdfdoc, string imagetype, string 
(PHP 3 CVS only, PHP 4 )
pdf_open_image_file -- Reads an image from a file
Description
int pdf_open_image_file ( resource pdfdoc, string imagetype, string 
filename [, string stringparam [, string intparam]])
Open an image file. Supported types are jpeg, tiff, gif, and png. 
stringparam is either , mask, masked, or page. intparamis either 0, the 
image id of the applied mask, or the page.   pdf_open_gifUppdf_open_image
#

#T=int pdf_open_image_file ( resource pdfdoc, string imagetype, string 
pdf_open_image_file ( ^!resource pdfdoc, string imagetype, string ;
#

#T=pdf_open_image - int pdf_open_image ( resource PDF-document, string imagetype, string 
(PHP 4 >= 4.0.5)
pdf_open_image -- Versatile function for images
Description
int pdf_open_image ( resource PDF-document, string imagetype, string 
source, string data, long length, int width, int height, int components, 
int bpc, string params)
Use image data from a variety of data sources. Supported types are jpeg, 
ccitt, raw. Supported sources are memory, fileref, url. len is only used 
when type is raw, params is only used when type is ccitt.   pdf_open_image_fileUppdf_open_jpeg
pdf_open_jpeg
pdf_open_jpeg -- Deprecated: Opens a JPEG image
Description
This function is deprecated, use pdf_open_image() instead.   pdf_open_imageUppdf_open_memory_image
#

#T=int pdf_open_image ( resource PDF-document, string imagetype, string 
pdf_open_image ( ^!resource PDF-document, string imagetype, string ;
#

#T=pdf_open_memory_image - int pdf_open_memory_image ( resource pdfdoc, resource image)
(PHP 3>= 3.0.10, PHP 4 )
pdf_open_memory_image -- Opens an image created with PHP's image functions
Description
int pdf_open_memory_image ( resource pdfdoc, resource image)
The pdf_open_memory_image() function takes an image created with the PHP's 
image functions and makes it available for the pdf resource. The function 
returns a pdf image identifier. Example 1. Including a memory image
  <?php
  $im = imagecreate(100, 100);
  $col = imagecolorallocate($im, 80, 45, 190);
  imagefill($im, 10, 10, $col);
  $pim = pdf_open_memory_image($pdf, $im);
  imagedestroy($im);
  pdf_place_image($pdf, $pim, 100, 100, 1);
  pdf_close_image($pdf, $pim);
  ?> 
See also pdf_close_image() and pdf_place_image().   pdf_open_jpegUppdf_open_pdi_page
#

#T=int pdf_open_memory_image ( resource pdfdoc, resource image)
pdf_open_memory_image ( ^!resource pdfdoc, resource image);
#

#T=pdf_open_pdi_page - int pdf_open_pdi_page ( resource pdfdoc, int dochandle, int pagenumber, 
(PHP 4 >= 4.0.5)
pdf_open_pdi_page --  Prepare a page 
Description
int pdf_open_pdi_page ( resource pdfdoc, int dochandle, int pagenumber, 
string pagelabel)
Prepare a page for later use with pdf_place_image()   pdf_open_memory_imageUppdf_open_pdi
#

#T=int pdf_open_pdi_page ( resource pdfdoc, int dochandle, int pagenumber, 
pdf_open_pdi_page ( ^!resource pdfdoc, int dochandle, int pagenumber, ;
#

#T=pdf_open_pdi - int pdf_open_pdi ( resource pdfdoc, string filename, string stringparam, 
(PHP 4 >= 4.0.5)
pdf_open_pdi --  Opens a PDF file 
Description
int pdf_open_pdi ( resource pdfdoc, string filename, string stringparam, 
int intparam)
Opens an existing PDF document and prepares it for later use. 
See also pdf_close_pdi().   pdf_open_pdi_pageUppdf_open_png
pdf_open_png
pdf_open_png --  Deprecated: Opens a PNG image 
Description
This function is deprecated, use pdf_open_image() instead.   pdf_open_pdiUppdf_open_tiff
pdf_open_tiff
pdf_open_tiff -- Deprecated: Opens a TIFF image
Description
This function is deprecated, use pdf_open_image() instead.   pdf_open_pngUppdf_open
pdf_open
pdf_open -- Deprecated: Open a new pdf object
Description
This function is deprecated, use pdf_new() plus pdf_open_file() instead.   pdf_open_tiffUppdf_place_image
#

#T=int pdf_open_pdi ( resource pdfdoc, string filename, string stringparam, 
pdf_open_pdi ( ^!resource pdfdoc, string filename, string stringparam, ;
#

#T=pdf_place_image - bool pdf_place_image ( resource pdfdoc, int image, float x, float y, float 
(PHP 3>= 3.0.7, PHP 4 )
pdf_place_image -- Places an image on the page
Description
bool pdf_place_image ( resource pdfdoc, int image, float x, float y, float 
scale)
Place an image with the lower left corner at (x, y), and scale it. Returns 
TRUE on success or FALSE on failure.   pdf_openUppdf_place_pdi_page
#

#T=bool pdf_place_image ( resource pdfdoc, int image, float x, float y, float 
pdf_place_image ( ^!resource pdfdoc, int image, float x, float y, float ;
#

#T=pdf_place_pdi_page - bool pdf_place_pdi_page ( resource pdfdoc, int page, float x, float y, 
(PHP 4 >= 4.0.6)
pdf_place_pdi_page -- Places an image on the page
Description
bool pdf_place_pdi_page ( resource pdfdoc, int page, float x, float y, 
float sx, float sy)
Place a PDI page with the lower left corner at (x, y), and scale it. 
Returns TRUE on success or FALSE on failure.   pdf_place_imageUppdf_rect
#

#T=bool pdf_place_pdi_page ( resource pdfdoc, int page, float x, float y, 
pdf_place_pdi_page ( ^!resource pdfdoc, int page, float x, float y, ;
#

#T=pdf_rect - bool pdf_rect ( resource pdfdoc, float x, float y, float width, float 
(PHP 3>= 3.0.6, PHP 4 )
pdf_rect -- Draws a rectangle
Description
bool pdf_rect ( resource pdfdoc, float x, float y, float width, float 
height)
Draw a (width * height) rectangle at lower left (x, y). Returns TRUE on 
success or FALSE on failure.   pdf_place_pdi_pageUppdf_restore
#

#T=bool pdf_rect ( resource pdfdoc, float x, float y, float width, float 
pdf_rect ( ^!resource pdfdoc, float x, float y, float width, float ;
#

#T=pdf_restore - bool pdf_restore ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_restore -- Restores formerly saved environment
Description
bool pdf_restore ( resource pdfdoc)
Restore the most recently saved graphics state. Returns TRUE on success or 
FALSE on failure.   pdf_rectUppdf_rotate
#

#T=bool pdf_restore ( resource pdfdoc)
pdf_restore ( ^!resource pdfdoc);
#

#T=pdf_rotate - bool pdf_rotate ( resource pdfdoc, float phi)
(PHP 3>= 3.0.6, PHP 4 )
pdf_rotate -- Sets rotation
Description
bool pdf_rotate ( resource pdfdoc, float phi)
Rotate the coordinate system by phi degrees. Returns TRUE on success or 
FALSE on failure.   pdf_restoreUppdf_save
#

#T=bool pdf_rotate ( resource pdfdoc, float phi)
pdf_rotate ( ^!resource pdfdoc, float phi);
#

#T=pdf_save - bool pdf_save ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_save -- Saves the current environment
Description
bool pdf_save ( resource pdfdoc)
Save the current graphics state. Returns TRUE on success or FALSE on 
failure.   pdf_rotateUppdf_scale
#

#T=bool pdf_save ( resource pdfdoc)
pdf_save ( ^!resource pdfdoc);
#

#T=pdf_scale - bool pdf_scale ( resource pdfdoc, float x-scale, float y-scale)
(PHP 3>= 3.0.6, PHP 4 )
pdf_scale -- Sets scaling
Description
bool pdf_scale ( resource pdfdoc, float x-scale, float y-scale)
Scale the coordinate system. Returns TRUE on success or FALSE on failure.   pdf_saveUppdf_set_border_color
#

#T=bool pdf_scale ( resource pdfdoc, float x-scale, float y-scale)
pdf_scale ( ^!resource pdfdoc, float x-scale, float y-scale);
#

#T=pdf_set_border_color - bool pdf_set_border_color ( resource pdfdoc, float red, float green, float 
(PHP 3>= 3.0.12, PHP 4 )
pdf_set_border_color -- Sets color of border around links and annotations
Description
bool pdf_set_border_color ( resource pdfdoc, float red, float green, float 
blue)
Set the border color for all kinds of annotations. Returns TRUE on success 
or FALSE on failure.   pdf_scaleUppdf_set_border_dash
#

#T=bool pdf_set_border_color ( resource pdfdoc, float red, float green, float 
pdf_set_border_color ( ^!resource pdfdoc, float red, float green, float ;
#

#T=pdf_set_border_dash - bool pdf_set_border_dash ( resource pdfdoc, float black, float white)
(PHP 4 >= 4.0.1)
pdf_set_border_dash -- Sets dash style of border around links and 
annotations
Description
bool pdf_set_border_dash ( resource pdfdoc, float black, float white)
Sets the border dash style for all kinds of annotations. Returns TRUE on 
success or FALSE on failure. 
See also pdf_setdash().   pdf_set_border_colorUppdf_set_border_style
#

#T=bool pdf_set_border_dash ( resource pdfdoc, float black, float white)
pdf_set_border_dash ( ^!resource pdfdoc, float black, float white);
#

#T=pdf_set_border_style - bool pdf_set_border_style ( resource pdfdoc, string style, float width)
(PHP 3>= 3.0.12, PHP 4 )
pdf_set_border_style -- Sets style of border around links and annotations
Description
bool pdf_set_border_style ( resource pdfdoc, string style, float width)
Sets the border style for all kinds of annotations. style is solid or 
dashed. Returns TRUE on success or FALSE on failure.   pdf_set_border_dashUppdf_set_char_spacing
pdf_set_char_spacing
pdf_set_char_spacing -- Deprecated: Sets character spacing
Description
This function is deprecated, use pdf_set_value() instead.   pdf_set_border_styleUppdf_set_duration
pdf_set_duration
pdf_set_duration -- Deprecated: Sets duration between pages
Description
This function is deprecated, use pdf_set_value() instead.   pdf_set_char_spacingUppdf_set_font
pdf_set_font
pdf_set_font -- Deprecated: Selects a font face and size
Description
This function is deprecated, use pdf_findfont() plus pdf_setfont() 
instead.   pdf_set_durationUppdf_set_horiz_scaling
pdf_set_horiz_scaling
pdf_set_horiz_scaling -- Sets horizontal scaling of text
Description
This function is deprecated, use pdf_set_value() instead.   pdf_set_fontUppdf_set_info_author
pdf_set_info_author
pdf_set_info_author --  Deprecated: Fills the author field of the document 

Description
This function is deprecated, use pdf_set_info() instead.   pdf_set_horiz_scalingUppdf_set_info_creator
pdf_set_info_creator
pdf_set_info_creator --  Deprecated: Fills the creator field of the 
document 
Description
This function is deprecated, use pdf_set_info() instead.   pdf_set_info_authorUppdf_set_info_keywords
pdf_set_info_keywords
pdf_set_info_keywords --  Deprecated: Fills the keywords field of the 
document 
Description
This function is deprecated, use pdf_set_info() instead.   pdf_set_info_creatorUppdf_set_info_subject
pdf_set_info_subject
pdf_set_info_subject --  Deprecated: Fills the subject field of the 
document 
Description
This function is deprecated, use pdf_set_info() instead.   pdf_set_info_keywordsUppdf_set_info_title
pdf_set_info_title
pdf_set_info_title --  Deprecated: Fills the title field of the document 
Description
This function is deprecated, use pdf_set_info() instead.   pdf_set_info_subjectUppdf_set_info
#

#T=bool pdf_set_border_style ( resource pdfdoc, string style, float width)
pdf_set_border_style ( ^!resource pdfdoc, string style, float width);
#

#T=pdf_set_info - bool pdf_set_info ( resource pdfdoc, string key, string value)
(PHP 4 >= 4.0.1)
pdf_set_info -- Fills a field of the document information
Description
bool pdf_set_info ( resource pdfdoc, string key, string value)
Fill document information field key with value. Returns TRUE on success or 
FALSE on failure. key is one of Subject, Title, Creator, Author, Keywords, 
or a user-defined key.   pdf_set_info_titleUppdf_set_leading
pdf_set_leading
pdf_set_leading -- Deprecated: Sets distance between text lines
Description
This function is deprecated, use pdf_set_value() instead.   pdf_set_infoUppdf_set_parameter
#

#T=bool pdf_set_info ( resource pdfdoc, string key, string value)
pdf_set_info ( ^!resource pdfdoc, string key, string value);
#

#T=pdf_set_parameter - bool pdf_set_parameter ( resource pdfdoc, string key, string value)
(PHP 4 )
pdf_set_parameter -- Sets certain parameters
Description
bool pdf_set_parameter ( resource pdfdoc, string key, string value)
Sets some PDFlib parameters with string type. Returns TRUE on success or 
FALSE on failure.   pdf_set_leadingUppdf_set_text_matrix
pdf_set_text_matrix
pdf_set_text_matrix -- Deprecated: Sets the text matrix
Description
This function is deprecated, use pdf_set_paramter() instead.   pdf_set_parameterUppdf_set_text_pos
#

#T=bool pdf_set_parameter ( resource pdfdoc, string key, string value)
pdf_set_parameter ( ^!resource pdfdoc, string key, string value);
#

#T=pdf_set_text_pos - bool pdf_set_text_pos ( resource pdfdoc, float x, float y)
(PHP 3>= 3.0.6, PHP 4 )
pdf_set_text_pos -- Sets text position
Description
bool pdf_set_text_pos ( resource pdfdoc, float x, float y)
Set the text output position specified by x and y. Returns TRUE on success 
or FALSE on failure.   pdf_set_text_matrixUppdf_set_text_rendering
pdf_set_text_rendering
pdf_set_text_rendering -- Deprecated: Determines how text is rendered
Description
This function is deprecated, use pdf_set_value() instead.   pdf_set_text_posUppdf_set_text_rise
pdf_set_text_rise
pdf_set_text_rise -- Deprecated: Sets the text rise
Description
This function is deprecated, use pdf_set_value() instead.   pdf_set_text_renderingUppdf_set_value
#

#T=bool pdf_set_text_pos ( resource pdfdoc, float x, float y)
pdf_set_text_pos ( ^!resource pdfdoc, float x, float y);
#

#T=pdf_set_value - bool pdf_set_value ( resource pdfdoc, string key, float value)
(PHP 4 >= 4.0.1)
pdf_set_value -- Sets certain numerical value
Description
bool pdf_set_value ( resource pdfdoc, string key, float value)
Set the value of some PDFlib parameter with float type. Returns TRUE on 
success or FALSE on failure.   pdf_set_text_riseUppdf_set_word_spacing
pdf_set_word_spacing
pdf_set_word_spacing -- Deprecated: Sets spacing between words
Description
This function is deprecated, use pdf_set_value() instead.   pdf_set_valueUppdf_setcolor
#

#T=bool pdf_set_value ( resource pdfdoc, string key, float value)
pdf_set_value ( ^!resource pdfdoc, string key, float value);
#

#T=pdf_setcolor - bool pdf_setcolor ( resource pdfdoc, string type, string colorspace, float 
(PHP 4 >= 4.0.5)
pdf_setcolor -- Sets fill and stroke color
Description
bool pdf_setcolor ( resource pdfdoc, string type, string colorspace, float 
c1 [, float c2 [, float c3 [, float c4]]])
Set the current color space and color. Returns TRUE on success or FALSE on 
failure. The parameter type can be fill, stroke or both to specify that 
the color is set for filling, stroking or both filling and stroking. The 
parameter colorspace can be gray, rgb, cmyk, spot or pattern. The 
parameters c1, c2, c3 and c4 represent the color components for the color 
space specified by colorspace. Except as otherwise noted, the color 
components are floating-point values that range from 0 to 1. 
For gray only c1 is used. 
For rgb parameters c1, c2, and c3 specify the red, green and blue values 
respectively. 
<?php
// Set fill and stroke colors to white.
pdf_setcolor($pdf, "both", "rgb", 1, 1, 1);
?> 

For cmyk, parameters c1, c2, c3, and c4 are the cyan, magenta, yellow and 
black values, respectively. 
<?php
// Set fill and stroke colors to black.
pdf_setcolor($pdf, "both", "cmyk", 0, 0, 0, 1);
?> 

For spot, c1 should be a spot color handles returned by 
pdf_makespotcolor() and c2 is a tint value between 0 and 1. 
For pattern, c1 should be a pattern handle returned by 
pdf_begin_pattern().   pdf_set_word_spacingUppdf_setdash
#

#T=bool pdf_setcolor ( resource pdfdoc, string type, string colorspace, float 
pdf_setcolor ( ^!resource pdfdoc, string type, string colorspace, float ;
#

#T=pdf_setdash - bool pdf_setdash ( resource pdfdoc, float b, float w)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setdash -- Sets dash pattern
Description
bool pdf_setdash ( resource pdfdoc, float b, float w)
Set the current dash pattern to b black and w white units. Returns TRUE on 
success or FALSE on failure.   pdf_setcolorUppdf_setflat
#

#T=bool pdf_setdash ( resource pdfdoc, float b, float w)
pdf_setdash ( ^!resource pdfdoc, float b, float w);
#

#T=pdf_setflat - bool pdf_setflat ( resource pdfdoc, float flatness)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setflat -- Sets flatness
Description
bool pdf_setflat ( resource pdfdoc, float flatness)
Sets the flatness to a value between 0 and 100 inclusive. Returns TRUE on 
success or FALSE on failure.   pdf_setdashUppdf_setfont
#

#T=bool pdf_setflat ( resource pdfdoc, float flatness)
pdf_setflat ( ^!resource pdfdoc, float flatness);
#

#T=pdf_setfont - bool pdf_setfont ( resource pdfdoc, int font, float size)
(PHP 4 >= 4.0.5)
pdf_setfont -- Set the current font
Description
bool pdf_setfont ( resource pdfdoc, int font, float size)
Set the current font in the given size, using a font handle returned by 
pdf_findfont(). Returns TRUE on success or FALSE on failure. 
See also pdf_findfont().   pdf_setflatUppdf_setgray_fill
#

#T=bool pdf_setfont ( resource pdfdoc, int font, float size)
pdf_setfont ( ^!resource pdfdoc, int font, float size);
#

#T=pdf_setgray_fill - bool pdf_setgray_fill ( resource pdfdoc, float gray)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setgray_fill -- Sets filling color to gray value
Description
bool pdf_setgray_fill ( resource pdfdoc, float gray)
Set the current fill color to a gray value between 0 and 1 inclusive. 
Returns TRUE on success or FALSE on failure. 
Note: PDFlib V4.0: Deprecated, use pdf_setcolor() instead.   pdf_setfontUppdf_setgray_stroke
#

#T=bool pdf_setgray_fill ( resource pdfdoc, float gray)
pdf_setgray_fill ( ^!resource pdfdoc, float gray);
#

#T=pdf_setgray_stroke - bool pdf_setgray_stroke ( resource pdfdoc, float gray)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setgray_stroke -- Sets drawing color to gray value
Description
bool pdf_setgray_stroke ( resource pdfdoc, float gray)
Set the current stroke color to a gray value between 0 and 1 inclusive. 
Returns TRUE on success or FALSE on failure. 
Note: PDFlib V4.0: Deprecated, use pdf_setcolor() instead.   pdf_setgray_fillUppdf_setgray
#

#T=bool pdf_setgray_stroke ( resource pdfdoc, float gray)
pdf_setgray_stroke ( ^!resource pdfdoc, float gray);
#

#T=pdf_setgray - bool pdf_setgray ( resource pdfdoc, float gray)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setgray -- Sets drawing and filling color to gray value
Description
bool pdf_setgray ( resource pdfdoc, float gray)
Set the current fill and stroke color. Returns TRUE on success or FALSE on 
failure. 
Note: PDFlib V4.0: Deprecated, use pdf_setcolor() instead.   pdf_setgray_strokeUppdf_setlinecap
#

#T=bool pdf_setgray ( resource pdfdoc, float gray)
pdf_setgray ( ^!resource pdfdoc, float gray);
#

#T=pdf_setlinecap - void pdf_setlinecap ( resource pdfdoc, int linecap)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setlinecap -- Sets linecap parameter
Description
void pdf_setlinecap ( resource pdfdoc, int linecap)
Set the linecap parameter to a value between 0 and 2 inclusive.   pdf_setgrayUppdf_setlinejoin
#

#T=void pdf_setlinecap ( resource pdfdoc, int linecap)
pdf_setlinecap ( ^!resource pdfdoc, int linecap);
#

#T=pdf_setlinejoin - bool pdf_setlinejoin ( resource pdfdoc, int value)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setlinejoin -- Sets linejoin parameter
Description
bool pdf_setlinejoin ( resource pdfdoc, int value)
Sets the line join parameter to a value between 0 and 2 inclusive. Returns 
TRUE on success or FALSE on failure.   pdf_setlinecapUppdf_setlinewidth
#

#T=bool pdf_setlinejoin ( resource pdfdoc, int value)
pdf_setlinejoin ( ^!resource pdfdoc, int value);
#

#T=pdf_setlinewidth - void pdf_setlinewidth ( resource pdfdoc, float width)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setlinewidth -- Sets line width
Description
void pdf_setlinewidth ( resource pdfdoc, float width)
Sets the current linewidth to width. Returns TRUE on success or FALSE on 
failure.   pdf_setlinejoinUppdf_setmatrix
#

#T=void pdf_setlinewidth ( resource pdfdoc, float width)
pdf_setlinewidth ( ^!resource pdfdoc, float width);
#

#T=pdf_setmatrix - bool pdf_setmatrix ( resource pdfdoc, float a, float b, float c, float d, 
(PHP 4 >= 4.0.5)
pdf_setmatrix -- Sets current transformation matrix
Description
bool pdf_setmatrix ( resource pdfdoc, float a, float b, float c, float d, 
float e, float f)
Explicitly set the current transformation matrix. Returns TRUE on success 
or FALSE on failure.   pdf_setlinewidthUppdf_setmiterlimit
#

#T=bool pdf_setmatrix ( resource pdfdoc, float a, float b, float c, float d, 
pdf_setmatrix ( ^!resource pdfdoc, float a, float b, float c, float d, ;
#

#T=pdf_setmiterlimit - bool pdf_setmiterlimit ( resource pdfdoc, float miter)
(PHP 3>= 3.0.6, PHP 4 )
pdf_setmiterlimit -- Sets miter limit
Description
bool pdf_setmiterlimit ( resource pdfdoc, float miter)
Set the miter limit to a value greater than or equal to 1. Returns TRUE on 
success or FALSE on failure.   pdf_setmatrixUppdf_setpolydash
pdf_setpolydash
pdf_setpolydash -- Deprecated: Sets complicated dash pattern
Description
This function is deprecated, use pdf_setdash() instead.   pdf_setmiterlimitUppdf_setrgbcolor_fill
#

#T=bool pdf_setmiterlimit ( resource pdfdoc, float miter)
pdf_setmiterlimit ( ^!resource pdfdoc, float miter);
#

#T=pdf_setrgbcolor_fill - bool pdf_setrgbcolor_fill ( resource pdfdoc, float red_value, float 
(PHP 3>= 3.0.6, PHP 4 )
pdf_setrgbcolor_fill -- Sets filling color to rgb color value
Description
bool pdf_setrgbcolor_fill ( resource pdfdoc, float red_value, float 
green_value, float blue_value)
Set the current fill color to the supplied RGB values. Returns TRUE on 
success or FALSE on failure. 
Note: PDFlib V4.0: Deprecated, use pdf_setcolor() instead.   pdf_setpolydashUppdf_setrgbcolor_stroke
#

#T=bool pdf_setrgbcolor_fill ( resource pdfdoc, float red_value, float 
pdf_setrgbcolor_fill ( ^!resource pdfdoc, float red_value, float ;
#

#T=pdf_setrgbcolor_stroke - bool pdf_setrgbcolor_stroke ( resource pdfdoc, float red_value, float 
(PHP 3>= 3.0.6, PHP 4 )
pdf_setrgbcolor_stroke -- Sets drawing color to rgb color value
Description
bool pdf_setrgbcolor_stroke ( resource pdfdoc, float red_value, float 
green_value, float blue_value)
Set the current stroke color to the supplied RGB values. Returns TRUE on 
success or FALSE on failure. 
Note: PDFlib V4.0: Deprecated, use pdf_setcolor() instead.   pdf_setrgbcolor_fillUppdf_setrgbcolor
#

#T=bool pdf_setrgbcolor_stroke ( resource pdfdoc, float red_value, float 
pdf_setrgbcolor_stroke ( ^!resource pdfdoc, float red_value, float ;
#

#T=pdf_setrgbcolor - bool pdf_setrgbcolor ( resource pdfdoc, float red_value, float 
(PHP 3>= 3.0.6, PHP 4 )
pdf_setrgbcolor -- Sets drawing and filling color to rgb color value
Description
bool pdf_setrgbcolor ( resource pdfdoc, float red_value, float 
green_value, float blue_value)
Set the current fill and stroke color to the supplied RGB values. Returns 
TRUE on success or FALSE on failure. 
Note: PDFlib V4.0: Deprecated, use pdf_setcolor() instead.   pdf_setrgbcolor_strokeUppdf_show_boxed
#

#T=bool pdf_setrgbcolor ( resource pdfdoc, float red_value, float 
pdf_setrgbcolor ( ^!resource pdfdoc, float red_value, float ;
#

#T=pdf_show_boxed - int pdf_show_boxed ( resource pdfdoc, string text, float left, float top, 
(PHP 4 )
pdf_show_boxed -- Output text in a box
Description
int pdf_show_boxed ( resource pdfdoc, string text, float left, float top, 
float width, float height, string mode [, string feature])
Format text in the current font and size into the supplied text box 
according to the requested formatting mode, which must be one of left, 
right, center, justify or fulljustify. If width and height are 0, only a 
single line is placed at the point (left, top) in the requested mode. 
Returns the number of characters that did not fit in the specified box. 
Returns 0 if all characters fit or the width and height parameters were 
set to 0 for single-line formatting.   pdf_setrgbcolorUppdf_show_xy
#

#T=int pdf_show_boxed ( resource pdfdoc, string text, float left, float top, 
pdf_show_boxed ( ^!resource pdfdoc, string text, float left, float top, ;
#

#T=pdf_show_xy - bool pdf_show_xy ( resource pdfdoc, string text, float x, float y)
(PHP 3>= 3.0.6, PHP 4 )
pdf_show_xy -- Output text at given position
Description
bool pdf_show_xy ( resource pdfdoc, string text, float x, float y)
Print text in the current font at ( x, y). Returns TRUE on success or 
FALSE on failure.   pdf_show_boxedUppdf_show
#

#T=bool pdf_show_xy ( resource pdfdoc, string text, float x, float y)
pdf_show_xy ( ^!resource pdfdoc, string text, float x, float y);
#

#T=pdf_show - bool pdf_show ( resource pdfdoc, string text)
(PHP 3>= 3.0.6, PHP 4 )
pdf_show -- Output text at current position
Description
bool pdf_show ( resource pdfdoc, string text)
Print text in the current font and size at the current position. Returns 
TRUE on success or FALSE on failure.   pdf_show_xyUppdf_skew
#

#T=bool pdf_show ( resource pdfdoc, string text)
pdf_show ( ^!resource pdfdoc, string text);
#

#T=pdf_skew - bool pdf_skew ( resource pdfdoc, float alpha, float beta)
(PHP 4 )
pdf_skew -- Skews the coordinate system
Description
bool pdf_skew ( resource pdfdoc, float alpha, float beta)
Skew the coordinate system in x and y direction by alpha and beta degrees. 
Returns TRUE on success or FALSE on failure.   pdf_showUppdf_stringwidth
#

#T=bool pdf_skew ( resource pdfdoc, float alpha, float beta)
pdf_skew ( ^!resource pdfdoc, float alpha, float beta);
#

#T=pdf_stringwidth - float pdf_stringwidth ( resource pdfdoc, string text [, int font [, float 
(PHP 3>= 3.0.6, PHP 4 )
pdf_stringwidth -- Returns width of text using current font
Description
float pdf_stringwidth ( resource pdfdoc, string text [, int font [, float 
size]])
Returns the width of text using the last font set by pdf_setfont(). If the 
optional parameters font and size are specified, the width will be 
calculated using that font and size instead. Please note that font is a 
font handle returned by pdf_findfont(). 
Note: Both the font and size parameters must be used together. 
See also pdf_setfont() and pdf_findfont().   pdf_skewUppdf_stroke
#

#T=float pdf_stringwidth ( resource pdfdoc, string text [, int font [, float 
pdf_stringwidth ( ^!resource pdfdoc, string text [, int font [, float ;
#

#T=pdf_stroke - bool pdf_stroke ( resource pdfdoc)
(PHP 3>= 3.0.6, PHP 4 )
pdf_stroke -- Draws line along path
Description
bool pdf_stroke ( resource pdfdoc)
Stroke the path with the current color and line width, and clear it. 
Returns TRUE on success or FALSE on failure.   pdf_stringwidthUppdf_translate
#

#T=bool pdf_stroke ( resource pdfdoc)
pdf_stroke ( ^!resource pdfdoc);
#

#T=pdf_translate - bool pdf_translate ( resource pdfdoc, float tx, float ty)
(PHP 3>= 3.0.6, PHP 4 )
pdf_translate -- Sets origin of coordinate system
Description
bool pdf_translate ( resource pdfdoc, float tx, float ty)
Translate the origin of the coordinate system.   pdf_strokeUpVerisign Payflow Pro functions
#

#T=bool pdf_translate ( resource pdfdoc, float tx, float ty)
pdf_translate ( ^!resource pdfdoc, float tx, float ty);
#

#T=pfpro_cleanup - void pfpro_cleanup ( void )
(PHP 4 >= 4.0.2)
pfpro_cleanup -- Shuts down the Payflow Pro library
Description
void pfpro_cleanup ( void )
pfpro_cleanup() is used to shutdown the Payflow Pro library cleanly. It 
should be called after you have processed any transactions and before the 
end of your script. However you may omit this call, in which case this 
extension will automatically call pfpro_cleanup() after your script 
terminates. 
See also pfpro_init().   Verisign Payflow Pro functionsUppfpro_init
#

#T=void pfpro_cleanup ( void )
pfpro_cleanup ( ^!void );
#

#T=pfpro_init - void pfpro_init ( void )
(PHP 4 >= 4.0.2)
pfpro_init -- Initialises the Payflow Pro library
Description
void pfpro_init ( void )
pfpro_init() is used to initialise the Payflow Pro library. You may omit 
this call, in which case this extension will automatically call 
pfpro_init() before the first transaction. 
See also pfpro_cleanup().   pfpro_cleanupUppfpro_process_raw
#

#T=void pfpro_init ( void )
pfpro_init ( ^!void );
#

#T=pfpro_process_raw - string pfpro_process_raw ( string parameters [, string address [, int port 
(PHP 4 >= 4.0.2)
pfpro_process_raw -- Process a raw transaction with Payflow Pro
Description
string pfpro_process_raw ( string parameters [, string address [, int port 
[, int timeout [, string proxy_address [, int proxy_port [, string 
proxy_logon [, string proxy_password]]]]]]])
Returns: A string containing the response. 
pfpro_process_raw() processes a raw transaction string with Payflow Pro. 
You should really use pfpro_process() instead, as the encoding rules of 
these transactions are non-standard. 
The first parameter in this case is a string containing the raw 
transaction request. All other parameters are the same as with 
pfpro_process(). The return value is a string containing the raw response. 

Note: Be sure to read the Payflow Pro Developers Guide for full details 
of the required parameters and encoding rules. You would be well advised 
to use pfpro_process() instead. 
Example 1. Payflow Pro raw example
  <?php

  pfpro_init();

  $response = 
  pfpro_process_raw("USER=mylogin&PWD[5]=m&ndy&PARTNER=VeriSign&TRXTYPE=S&TENDER=C&AMT=1.50&ACCT=4111111111111111&EXPDATE=0904");

  if (!$response) {
    die("Couldn't establish link to Verisign.\n");
  }

  echo "Verisign raw response was " . $response;

  pfpro_cleanup();

  ?> 

  pfpro_initUppfpro_process
#

#T=string pfpro_process_raw ( string parameters [, string address [, int port 
pfpro_process_raw ( ^!string parameters [, string address [, int port ;
#

#T=pfpro_process - array pfpro_process ( array parameters [, string address [, int port [, 
(PHP 4 >= 4.0.2)
pfpro_process -- Process a transaction with Payflow Pro
Description
array pfpro_process ( array parameters [, string address [, int port [, 
int timeout [, string proxy_address [, int proxy_port [, string 
proxy_logon [, string proxy_password]]]]]]])
Returns: An associative array containing the response 
pfpro_process() processes a transaction with Payflow Pro. The first 
parameter is an associative array containing keys and values that will be 
encoded and passed to the processor. 
The second parameter is optional and specifies the host to connect to. By 
default this is "test.signio.com", so you will certainly want to change 
this to "connect.signio.com" in order to process live transactions. 
The third parameter specifies the port to connect on. It defaults to 443, 
the standard SSL port. 
The fourth parameter specifies the timeout to be used, in seconds. This 
defaults to 30 seconds. Note that this timeout appears to only begin once 
a link to the processor has been established and so your script could 
potentially continue for a very long time in the event of DNS or network 
problems. 
The fifth parameter, if required, specifies the hostname of your SSL 
proxy. The sixth parameter specifies the port to use. 
The seventh and eighth parameters specify the logon identity and password 
to use on the proxy. 
The function returns an associative array of the keys and values in the 
response. 
Note: Be sure to read the Payflow Pro Developers Guide for full details 
of the required parameters. 
Example 1. Payflow Pro example
  <?php

  pfpro_init();

  $transaction = array('USER'    => 'mylogin',
		       'PWD'     => 'mypassword',
		       'PARTNER' => 'VeriSign',
		       'TRXTYPE' => 'S',
		       'TENDER'  => 'C',
		       'AMT'     => 1.50,
		       'ACCT'    => '4111111111111111',
		       'EXPDATE' => '0904'
		      );

  $response = pfpro_process($transaction);

  if (!$response) {
    die("Couldn't establish link to Verisign.\n");
  }

  echo "Verisign response code was " . $response['RESULT'];
  echo ", which means: " . $response['RESPMSG'] . "\n";

  echo "\nThe transaction request: ";
  print_r($transaction);

  echo "\nThe response: ";
  print_r($response);

  pfpro_cleanup();

  ?> 

  pfpro_process_rawUppfpro_version
#

#T=array pfpro_process ( array parameters [, string address [, int port [, 
pfpro_process ( ^!array parameters [, string address [, int port [, ;
#

#T=pfpro_version - string pfpro_version ( void )
(PHP 4 >= 4.0.2)
pfpro_version -- Returns the version of the Payflow Pro software
Description
string pfpro_version ( void )
pfpro_version() returns the version string of the Payflow Pro library. At 
the time of writing, this was L211.   pfpro_processUpPHP Options&Information
#

#T=string pfpro_version ( void )
pfpro_version ( ^!void );
#

#T=pfsockopen - resource pfsockopen ( string hostname, int port [, int errno [, string 
(PHP 3>= 3.0.7, PHP 4 )
pfsockopen --  Open persistent Internet or Unix domain socket connection 
Description
resource pfsockopen ( string hostname, int port [, int errno [, string 
errstr [, int timeout]]])
This function behaves exactly as fsockopen() with the difference that the 
connection is not closed after the script finishes. It is the persistent 
version of fsockopen().   openlogUpsocket_get_status
#

#T=resource pfsockopen ( string hostname, int port [, int errno [, string 
pfsockopen ( ^!string hostname, int port [, int errno [, string ;
#

#T=pg_affected_rows - int pg_affected_rows ( resource result)
(PHP 4 >= 4.2.0)
pg_affected_rows -- Returns number of affected records (tuples)
Description
int pg_affected_rows ( resource result)
pg_affected_rows() returns the number of tuples (instances/records/rows) 
affected by INSERT, UPDATE, and DELETE queries executed by pg_query(). If 
no tuple is affected by this function, it will return 0. 
Example 1. pg_affected_rows() example
  <?php
       $result = pg_query($conn, "INSERT INTO authors VALUES 
  ('Orwell', 2002, 'Animal Farm')");
       $cmdtuples = pg_affected_rows($result);
       echo $cmdtuples . " tuples are affected.\n";
  ?> 
Note: This function used to be called pg_cmdtuples(). 
See also pg_query() and pg_num_rows().   PostgreSQL functionsUppg_cancel_query
#

#T=int pg_affected_rows ( resource result)
pg_affected_rows ( ^!resource result);
#

#T=pg_cancel_query - bool pg_cancel_query ( resource connection)
(PHP 4 >= 4.2.0)
pg_cancel_query --  Cancel asynchronous query 
Description
bool pg_cancel_query ( resource connection)
pg_cancel_query() cancel asynchronous query sent by pg_send_query(). You 
cannot cancel query executed by pg_query(). 
See also pg_send_query() and pg_connection_busy().   pg_affected_rowsUppg_client_encoding
#

#T=bool pg_cancel_query ( resource connection)
pg_cancel_query ( ^!resource connection);
#

#T=pg_client_encoding - string pg_client_encoding ( [resource connection])
(PHP 3 CVS only, PHP 4 >= 4.0.3)
pg_client_encoding --  Gets the client encoding 
Description
string pg_client_encoding ( [resource connection])
pg_client_encoding() returns the client encoding as the string. The 
returned string should be either : SQL_ASCII, EUC_JP, EUC_CN, EUC_KR, 
EUC_TW, UNICODE, MULE_INTERNAL, LATINX (X=1...9), KOI8, WIN, ALT, SJIS, 
BIG5, WIN1250. 
Note: This function requires PHP-4.0.3 or higher and PostgreSQL-7.0 or 
higher. If libpq is compiled without multibyte encoding support, 
pg_set_client_encoding() always return "SQL_ASCII". Supported encoding 
depends on PostgreSQL version. Refer to PostgreSQL manual for details to 
enable multibyte support and encoding supported. 
The function used to be called pg_clientencoding(). 
See also pg_set_client_encoding().   pg_cancel_queryUppg_close
#

#T=string pg_client_encoding ( [resource connection])
pg_client_encoding ( ^![resource connection]);
#

#T=pg_close - bool pg_close ( resource connection)
(PHP 3, PHP 4 )
pg_close -- Closes a PostgreSQL connection
Description
bool pg_close ( resource connection)
pg_close() closes the non-persistent connection to a PostgreSQL database 
associated with the given connection resource. Returns TRUE on success or 
FALSE on failure. 
Note: Using pg_close() is not usually necessary, as non-persistent open 
connections are automatically closed at the end of the script. 
Example 1. pg_close() example
  <?php
      $dbconn = pg_connect("host=localhost port=5432 
  dbname=mary")
	  or die("Could not connect");
      echo "Connected successfully";
      pg_close($dbconn);
  ?> 
If there is open large object resource on the connection, do not close the 
connection before closing all large object resources.   pg_client_encodingUppg_connect
#

#T=bool pg_close ( resource connection)
pg_close ( ^!resource connection);
#

#T=pg_connect - resource pg_connect ( string connection_string)
(PHP 3, PHP 4 )
pg_connect -- Open a PostgreSQL connection
Description
resource pg_connect ( string connection_string)
pg_connect() returns a connection resource that is needed by other 
PostgreSQL functions. 
pg_connect() opens a connection to a PostgreSQL database specified by the 
connection_string. It returns a connection resource on success. It returns 
FALSE if the connection could not be made. connection_string should be a 
quoted string. Example 1. Using pg_connect()
  <?php
  $dbconn = pg_connect("dbname=mary");
  //connect to a database named "mary"

  $dbconn2 = pg_connect("host=localhost port=5432 dbname=mary");
  // connect to a database named "mary" on "localhost" at port 
  "5432"

  $dbconn3 = pg_connect("host=sheep port=5432 dbname=mary 
  user=lamb password=foo");
  //connect to a database named "mary" on the host "sheep" with 
  a username and password

  $conn_string = "host=sheep port=5432 dbname=test user=lamb 
  password=bar";
  $dbconn4 = pg_connect($conn_string);
  //connect to a database named "test" on the host "sheep" with 
  a username and password
  ?> 

The arguments available for connection_string includes host, port, tty, 
options, dbname, user, and password. 
If a second call is made to pg_connect() with the same connection_string, 
no new connection will be established, but instead, the connection 
resource of the already opened connection will be returned. You can have 
multiple connections to the same database if you use different connection 
strings. 
The old syntax with multiple parameters $conn = pg_connect("host", "port", 
"options", "tty", "dbname") has been deprecated. 
See also pg_pconnect(), pg_close(), pg_host(), pg_port(), pg_tty(), 
pg_options() and pg_dbname().   pg_closeUppg_connection_busy
#

#T=resource pg_connect ( string connection_string)
pg_connect ( ^!string connection_string);
#

#T=pg_connection_busy - bool pg_connection_busy ( resource connection)
(PHP 4 >= 4.2.0)
pg_connection_busy --  Get connection is busy or not 
Description
bool pg_connection_busy ( resource connection)
pg_connection_busy() returns TRUE if the connection is busy. If it is 
busy, a previous query is still executing. If pg_get_result() is called, 
it will be blocked. 
Example 1. pg_connection_busy() example
  <?php
      $dbconn = pg_connect("dbname=publisher") or die("Could not 
  connect");
      $bs = pg_connection_busy($dbconn);
      if ($bs) {
	  echo 'connection is busy';
      } else {
	 echo 'connection is not busy';
      }
  ?> 
See also pg_connection_status() and pg_get_result().   pg_connectUppg_connection_reset
#

#T=bool pg_connection_busy ( resource connection)
pg_connection_busy ( ^!resource connection);
#

#T=pg_connection_reset - bool pg_connection_reset ( resource connection)
(PHP 4 >= 4.2.0)
pg_connection_reset --  Reset connection (reconnect) 
Description
bool pg_connection_reset ( resource connection)
pg_connection_reset() resets the connection. It is useful for error 
recovery. Returns TRUE on success or FALSE on failure. 
Example 1. pg_connection_reset() example
  <?php
      $dbconn = pg_connect("dbname=publisher") or die("Could not 
  connect");
      $dbconn2 = pg_connection_reset($dbconn);
      if ($dbconn2) {
	  echo "reset successful\n";
      } else {
	  echo "reset failed\n";
      }
  ?> 
See also pg_connect(), pg_pconnect() and pg_connection_status().   pg_connection_busyUppg_connection_status
#

#T=bool pg_connection_reset ( resource connection)
pg_connection_reset ( ^!resource connection);
#

#T=pg_connection_status - int pg_connection_status ( resource connection)
(PHP 4 >= 4.2.0)
pg_connection_status --  Get connection status 
Description
int pg_connection_status ( resource connection)
pg_connection_status() returns a connection status. Possible statuses are 
PGSQL_CONNECTION_OK and PGSQL_CONNECTION_BAD. The return value 0 as 
integer indicates a valid connection. 
Example 1. pg_connection_status() example
  <?php
      $dbconn = pg_connect("dbname=publisher") or die("Could not 
  connect");
      $stat = pg_connection_status($dbconn);
      if ($stat === 0) {
	  echo 'Connection status ok';
      } else {
	  echo 'Connection status bad';
      }    
  ?> 
See also pg_connection_busy().   pg_connection_resetUppg_convert
#

#T=int pg_connection_status ( resource connection)
pg_connection_status ( ^!resource connection);
#

#T=pg_convert - array pg_convert ( resource connection, string table_name, array 
(PHP 4 >= 4.3.0)
pg_convert --  Convert associative array value into suitable for SQL 
statement. 
Description
array pg_convert ( resource connection, string table_name, array 
assoc_array [, int options])
pg_convert() checks and converts the values in assoc_array into suitable 
values for use in a SQL statement. Precondition for pg_convert() is the 
existence of a table table_name which has at least as many columns as 
assoc_array has elements. The fieldnames as well as the fieldvalues in 
table_name must match the indices and values of assoc_array. Returns an 
array with the converted values on success, FALSE otherwise. 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also pg_meta_data().   pg_connection_statusUppg_copy_from
#

#T=array pg_convert ( resource connection, string table_name, array 
pg_convert ( ^!resource connection, string table_name, array ;
#

#T=pg_copy_from - bool pg_copy_from ( resource connection, string table_name, array rows [, 
(PHP 4 >= 4.2.0)
pg_copy_from --  Insert records into a table from an array 
Description
bool pg_copy_from ( resource connection, string table_name, array rows [, 
string delimiter [, string null_as]])
pg_copy_from() insert records into a table from rows. It issues COPY FROM 
SQL command internally to insert records. Returns TRUE on success or FALSE 
on failure. 
See also pg_copy_to().   pg_convertUppg_copy_to
#

#T=bool pg_copy_from ( resource connection, string table_name, array rows [, 
pg_copy_from ( ^!resource connection, string table_name, array rows [, ;
#

#T=pg_copy_to - array pg_copy_to ( resource connection, string table_name [, string 
(PHP 4 >= 4.2.0)
pg_copy_to --  Copy a table to an array 
Description
array pg_copy_to ( resource connection, string table_name [, string 
delimiter [, string null_as]])
pg_copy_to() copies a table to an array. It issues COPY TO SQL command 
internally to insert records. The resulting array is returned. It returns 
FALSE on failure. 
See also pg_copy_from().   pg_copy_fromUppg_dbname
#

#T=array pg_copy_to ( resource connection, string table_name [, string 
pg_copy_to ( ^!resource connection, string table_name [, string ;
#

#T=pg_dbname - string pg_dbname ( resource connection)
(PHP 3, PHP 4 )
pg_dbname -- Get the database name
Description
string pg_dbname ( resource connection)
pg_dbname() returns the name of the database that the given PostgreSQL 
connection resource. It returns FALSE, if connection is not a valid 
PostgreSQL connection resource. 
Example 1. pg_dbname() example
  <?php
      error_reporting(E_ALL);

      pg_connect("host=localhost port=5432 dbname=mary");
      echo pg_dbname(); // mary
  ?> 

  pg_copy_toUppg_delete
#

#T=string pg_dbname ( resource connection)
pg_dbname ( ^!resource connection);
#

#T=pg_delete - mixed pg_delete ( resource connection, string table_name, array 
(PHP 4 >= 4.3.0)
pg_delete --  Deletes records. 
Description
mixed pg_delete ( resource connection, string table_name, array 
assoc_array [, int options])
pg_delete() deletes record condition specified by assoc_array which has 
field=>value. If option is specified, pg_convert() is applied to 
assoc_array with specified option. 
Example 1. pg_delete() example
  <?php 
      $db = pg_connect('dbname=foo');
      // This is safe, since $_POST is converted automatically
      $res = pg_delete($db, 'post_log', $_POST);
      if ($res) {
	  echo "POST data is deleted: $res\n";
      } else {
	  echo "User must have sent wrong inputs\n";
      }
  ?> 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also pg_convert().   pg_dbnameUppg_end_copy
#

#T=mixed pg_delete ( resource connection, string table_name, array 
pg_delete ( ^!resource connection, string table_name, array ;
#

#T=pg_end_copy - bool pg_end_copy ( [resource connection])
(PHP 4 >= 4.0.3)
pg_end_copy -- Sync with PostgreSQL backend
Description
bool pg_end_copy ( [resource connection])
pg_end_copy() syncs the PostgreSQL frontend (usually a web server process) 
with the PostgreSQL server after doing a copy operation performed by 
pg_put_line(). pg_end_copy() must be issued, otherwise the PostgreSQL 
server may get out of sync with the frontend and will report an error. 
Returns TRUE on success or FALSE on failure. 
For further details and an example, see also pg_put_line().   pg_deleteUppg_escape_bytea
#

#T=bool pg_end_copy ( [resource connection])
pg_end_copy ( ^![resource connection]);
#

#T=pg_escape_bytea - string pg_escape_bytea ( string data)
(PHP 4 >= 4.2.0)
pg_escape_bytea --  Escape binary for bytea type 
Description
string pg_escape_bytea ( string data)
pg_escape_bytea() escapes string for bytea datatype. It returns escaped 
string. 
Note: When you SELECT bytea type, PostgreSQL returns octal byte value 
prefixed by \ (e.g. \032). Users are supposed to convert back to binary 
format by yourself. 
This function requires PostgreSQL 7.2 or later. With PostgreSQL 7.2.0 
and 7.2.1, bytea type must be casted when you enable multi-byte support. 
i.e. INSERT INTO test_table (image) VALUES ('$image_escaped'::bytea); 
PostgreSQL 7.2.2 or later does not need cast. Exception is when client 
and backend character encoding does not match, there may be multi-byte 
stream error. User must cast to bytea to avoid this error. 
See also pg_unescape_bytea() and pg_escape_string().   pg_end_copyUppg_escape_string
#

#T=string pg_escape_bytea ( string data)
pg_escape_bytea ( ^!string data);
#

#T=pg_escape_string - string pg_escape_string ( string data)
(PHP 4 >= 4.2.0)
pg_escape_string --  Escape string for text/char type 
Description
string pg_escape_string ( string data)
pg_escape_string() escapes string for text/char datatype. It returns 
escaped string for PostgreSQL. Use of this function is recommended instead 
of addslashes(). 
Note: This function requires PostgreSQL 7.2 or later. 
See also pg_escape_bytea()   pg_escape_byteaUppg_fetch_all
#

#T=string pg_escape_string ( string data)
pg_escape_string ( ^!string data);
#

#T=pg_fetch_all - array pg_fetch_all ( resource result)
(PHP 4 >= 4.3.0)
pg_fetch_all -- Fetches all rows from a result as an array
Description
array pg_fetch_all ( resource result)
pg_fetch_all() returns an array that contains all rows (tuples/records) in 
result resource. It returns FALSE, if there are no rows. 
Example 1. PostgreSQL fetch all
  <?php 
  $conn = pg_pconnect("dbname=publisher");
  if (!$conn) {
      echo "An error occured.\n";
      exit;
  }

  $result = pg_query($conn, "SELECT * FROM authors");
  if (!$result) {
      echo "An error occured.\n";
      exit;
  }

  $arr = pg_fetch_all($result);

  var_dump($arr);

  ?> 
See also pg_fetch_row(), pg_fetch_array(), pg_fetch_object() and 
pg_fetch_result().   pg_escape_stringUppg_fetch_array
#

#T=array pg_fetch_all ( resource result)
pg_fetch_all ( ^!resource result);
#

#T=pg_fetch_array - array pg_fetch_array ( resource result [, int row [, int result_type]])
(PHP 3>= 3.0.1, PHP 4 )
pg_fetch_array -- Fetch a row as an array
Description
array pg_fetch_array ( resource result [, int row [, int result_type]])
pg_fetch_array() returns an array that corresponds to the fetched row 
(tuples/records). It returns FALSE, if there are no more rows. 
pg_fetch_array() is an extended version of pg_fetch_row(). In addition to 
storing the data in the numeric indices (field index) to the result array, 
it also stores the data in associative indices (field name) by default. 
row is row (record) number to be retrieved. First row is 0. 
result_type is an optional parameter that controls how the return value is 
initialized. result_type is a constant and can take the following values: 
PGSQL_ASSOC, PGSQL_NUM, and PGSQL_BOTH. pg_fetch_array() returns 
associative array that has field name as key for PGSQL_ASSOC, field index 
as key with PGSQL_NUM and both field name/index as key with PGSQL_BOTH. 
Default is PGSQL_BOTH. 
Note: result_type was added in PHP 4.0. 
pg_fetch_array() is NOT significantly slower than using pg_fetch_row(), 
while it provides a significant ease of use. 
Example 1. pg_fetch_array() example
  <?php 

  $conn = pg_pconnect("dbname=publisher");
  if (!$conn) {
      echo "An error occured.\n";
      exit;
  }

  $result = pg_query($conn, "SELECT * FROM authors");
  if (!$result) {
      echo "An error occured.\n";
      exit;
  }

  $arr = pg_fetch_array($result, 0, PGSQL_NUM);
  echo $arr[0] . " <- array\n";

  $arr = pg_fetch_array($result, 1, PGSQL_ASSOC);
  echo $arr["author"] . " <- array\n";

  ?> 
Note: From 4.1.0, row became optional. Calling pg_fetch_array() will 
increment internal row counter by 1. 
See also pg_fetch_row(), pg_fetch_object() and pg_fetch_result().   pg_fetch_allUppg_fetch_assoc
#

#T=array pg_fetch_array ( resource result [, int row [, int result_type]])
pg_fetch_array ( ^!resource result [, int row [, int result_type]]);
#

#T=pg_fetch_assoc - array pg_fetch_assoc ( resource result [, int row])
(PHP 4 >= 4.3.0)
pg_fetch_assoc -- Fetch a row as an associative array
Description
array pg_fetch_assoc ( resource result [, int row])
pg_fetch_assoc() returns an associative array that corresponds to the 
fetched row (tuples/records). It returns FALSE, if there are no more rows. 

pg_fetch_assoc() is equivalent to calling pg_fetch_array() with 
PGSQL_ASSOC for the optional third parameter. It only returns an 
associative array. If you need the numeric indices, use pg_fetch_row(). 
row is row (record) number to be retrieved. First row is 0. 
pg_fetch_assoc() is NOT significantly slower than using pg_fetch_row(), 
while it provides a significant ease of use. 
Example 1. pg_fetch_assoc() example
  <?php 
  $conn = pg_connect("dbname=publisher");
  if (!$conn) {
      echo "An error occured.\n";
      exit;
  }

  $result = pg_query($conn, "SELECT id, author, email FROM 
  authors");
  if (!$result) {
      echo "An error occured.\n";
      exit;
  }

  while ($row = pg_fetch_assoc($result)) {
      echo $row['id'];
      echo $row['author'];
      echo $row['email'];
  }
  ?> 
See also pg_fetch_row(), pg_fetch_array(), pg_fetch_object() and 
pg_fetch_result().   pg_fetch_arrayUppg_fetch_object
#

#T=array pg_fetch_assoc ( resource result [, int row])
pg_fetch_assoc ( ^!resource result [, int row]);
#

#T=pg_fetch_object - object pg_fetch_object ( resource result [, int row [, int result_type]])
(PHP 3>= 3.0.1, PHP 4 )
pg_fetch_object -- Fetch a row as an object
Description
object pg_fetch_object ( resource result [, int row [, int result_type]])
pg_fetch_object() returns an object with properties that correspond to the 
fetched row. It returns FALSE if there are no more rows or error. 
pg_fetch_object() is similar to pg_fetch_array(), with one difference - an 
object is returned, instead of an array. Indirectly, that means that you 
can only access the data by the field names, and not by their offsets 
(numbers are illegal property names). 
row is row (record) number to be retrieved. First row is 0. 
Speed-wise, the function is identical to pg_fetch_array(), and almost as 
quick as pg_fetch_row() (the difference is insignificant). 
Note: From 4.1.0, row is optional. 
From 4.3.0, result_type is default to PGSQL_ASSOC while older versions' 
default was PGSQL_BOTH. There is no use for numeric property, since 
numeric property name is invalid in PHP. 
result_type may be deleted in future versions. 
Example 1. pg_fetch_object() example
  <?php 

  $database = "store";

  $db_conn = pg_connect("host=localhost port=5432 
  dbname=$database");
  if (!$db_conn) {
      echo "Failed connecting to postgres database $database\n";
      exit;
  }

  $qu = pg_query($db_conn, "SELECT * FROM books ORDER BY 
  author");

  $row = 0; // postgres needs a row counter 

  while ($data = pg_fetch_object($qu, $row)) {
      echo $data->author . " (";
      echo $data->year . "): ";
      echo $data->title . "<br />";
      $row++;
  }

  pg_free_result($qu);
  pg_close($db_conn);

  ?> 
Note: From 4.1.0, row became optional. Calling pg_fetch_object() will 
increment internal row counter counter by 1. 
See also pg_query(), pg_fetch_array(), pg_fetch_assoc(), pg_fetch_row() 
and pg_fetch_result().   pg_fetch_assocUppg_fetch_result
#

#T=object pg_fetch_object ( resource result [, int row [, int result_type]])
pg_fetch_object ( ^!resource result [, int row [, int result_type]]);
#

#T=pg_fetch_result - mixed pg_fetch_result ( resource result, int row, mixed field)
(PHP 4 >= 4.2.0)
pg_fetch_result -- Returns values from a result resource
Description
mixed pg_fetch_result ( resource result, int row, mixed field)
pg_fetch_result() returns values from a result resource returned by 
pg_query(). row is integer. field is field name (string) or field index 
(integer). The row and field specify what cell in the table of results to 
return. Row numbering starts from 0. Instead of naming the field, you may 
use the field index as an unquoted number. Field indices start from 0. 
PostgreSQL has many built in types and only the basic ones are directly 
supported here. All forms of integer types are returned as integer values. 
All forms of float, and real types are returned as float values. Boolean 
is returned as "t" or "f". All other types, including arrays are returned 
as strings formatted in the same default PostgreSQL manner that you would 
see in the psql program.   pg_fetch_objectUppg_fetch_row
#

#T=mixed pg_fetch_result ( resource result, int row, mixed field)
pg_fetch_result ( ^!resource result, int row, mixed field);
#

#T=pg_fetch_row - array pg_fetch_row ( resource result, int row)
(PHP 3>= 3.0.1, PHP 4 )
pg_fetch_row -- Get a row as an enumerated array
Description
array pg_fetch_row ( resource result, int row)
pg_fetch_row() fetches one row of data from the result associated with the 
specified result resource. The row (record) is returned as an array. Each 
result column is stored in an array offset, starting at offset 0. 
It returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
Example 1. pg_fetch_row() example
  <?php 
  $conn = pg_pconnect("dbname=publisher");
  if (!$conn) {
      echo "An error occured.\n";
      exit;
  }

  $result = pg_query($conn, "SELECT * FROM authors");
  if (!$result) {
      echo "An error occured.\n";
      exit;
  }

  while ($row = pg_fetch_row($result, $i)) {
    for ($j=0; $j < count($row); $j++) {
      echo $row[$j] . "&nbsp;";
    }

    echo "<br />\n";

  }

  ?> 
Note: From 4.1.0, row became optional. Calling pg_fetch_row() will 
increment internal row counter by 1. 
See also pg_query(), pg_fetch_array(), pg_fetch_object() and 
pg_fetch_result().   pg_fetch_resultUppg_field_is_null
#

#T=array pg_fetch_row ( resource result, int row)
pg_fetch_row ( ^!resource result, int row);
#

#T=pg_field_is_null - int pg_field_is_null ( resource result, int row, mixed field)
(PHP 4 >= 4.2.0)
pg_field_is_null -- Test if a field is NULL
Description
int pg_field_is_null ( resource result, int row, mixed field)
pg_field_is_null() tests if a field is NULL or not. It returns 1 if the 
field in the given row is NULL. It returns 0 if the field in the given row 
is NOT NULL. Field can be specified as column index (number) or fieldname 
(string). Row numbering starts at 0. 
Example 1. pg_field_is_null() example
  <?php
      $dbconn = pg_connect("dbname=publisher") or die ("Could 
  not connect");
      $res = pg_query($dbconn, "select * from authors where 
  author = 'Orwell'");
      if ($res) {
	  if (pg_field_is_null($res, 0, "year") == 1) {
	      echo "The value of the field year is null.\n";
	  }
	  if (pg_field_is_null($res, 0, "year") == 0) {
	      echo "The value of the field year is not null.\n";
	}
     }
  ?> 
Note: This function used to be called pg_fieldisnull().   pg_fetch_rowUppg_field_name
#

#T=int pg_field_is_null ( resource result, int row, mixed field)
pg_field_is_null ( ^!resource result, int row, mixed field);
#

#T=pg_field_name - string pg_field_name ( resource result, int field_number)
(PHP 4 >= 4.2.0)
pg_field_name -- Returns the name of a field
Description
string pg_field_name ( resource result, int field_number)
pg_field_name() returns the name of the field occupying the given 
field_number in the given PostgreSQL result resource. Field numbering 
starts from 0. 
Example 1. Getting informations about fields
  <?php
      $dbconn = pg_connect("dbname=publisher") or die("Could not 
  connect");

      $res = pg_query($dbconn, "select * from authors where 
  author = 'Orwell'");
      $i = pg_num_fields($res);
      for ($j = 0; $j < $i; $j++) {
	  echo "column $j\n";
	  $fieldname = pg_field_name($res, $j);
	  echo "fieldname: $fieldname\n";
	  echo "printed length: " . pg_field_prtlen($res, 
  $fieldname) . " characters\n";
	  echo "storage length: " . pg_field_size($res, $j) . " 
  bytes\n";
	  echo "field type: " . pg_field_type($res, $j) . " 
  \n\n";
      }
  ?> 

The above example would produce the following output: 
column 0
fieldname: author
printed length: 6 characters
storage length: -1 bytes
field type: varchar 

column 1
fieldname: year
printed length: 4 characters
storage length: 2 bytes
field type: int2 

column 2
fieldname: title
printed length: 24 characters
storage length: -1 bytes
field type: varchar
Note: This function used to be called pg_fieldname(). 
See also pg_field_num().   pg_field_is_nullUppg_field_num
#

#T=string pg_field_name ( resource result, int field_number)
pg_field_name ( ^!resource result, int field_number);
#

#T=pg_field_num - int pg_field_num ( resource result, string field_name)
(PHP 4 >= 4.2.0)
pg_field_num -- Returns the field number of the named field
Description
int pg_field_num ( resource result, string field_name)
pg_field_num() will return the number of the column (field) slot that 
corresponds to the field_name in the given PostgreSQL result resource. 
Field numbering starts at 0. This function will return -1 on error. 
See the example given at the pg_field_name() page. 
Note: This function used to be called pg_fieldnum(). 
See also pg_field_name().   pg_field_nameUppg_field_prtlen
#

#T=int pg_field_num ( resource result, string field_name)
pg_field_num ( ^!resource result, string field_name);
#

#T=pg_field_prtlen - int pg_field_prtlen ( resource result, int row_number, string field_name)
(PHP 4 >= 4.2.0)
pg_field_prtlen -- Returns the printed length
Description
int pg_field_prtlen ( resource result, int row_number, string field_name)
pg_field_prtlen() returns the actual printed length (number of characters) 
of a specific value in a PostgreSQL result. Row numbering starts at 0. 
This function will return -1 on an error. 
See the example given at the pg_field_name() page. 
Note: This function used to be called pg_fieldprtlen(). 
See also pg_field_size().   pg_field_numUppg_field_size
#

#T=int pg_field_prtlen ( resource result, int row_number, string field_name)
pg_field_prtlen ( ^!resource result, int row_number, string field_name);
#

#T=pg_field_size - int pg_field_size ( resource result, int field_number)
(PHP 4 >= 4.2.0)
pg_field_size --  Returns the internal storage size of the named field 
Description
int pg_field_size ( resource result, int field_number)
pg_field_size() returns the internal storage size (in bytes) of the field 
number in the given PostgreSQL result. Field numbering starts at 0. A 
field size of -1 indicates a variable length field. This function will 
return FALSE on error. 
See the example given at the pg_field_name() page. 
Note: This function used to be called pg_fieldsize(). 
See also pg_field_prtlen() and pg_field_type().   pg_field_prtlenUppg_field_type
#

#T=int pg_field_size ( resource result, int field_number)
pg_field_size ( ^!resource result, int field_number);
#

#T=pg_field_type - string pg_field_type ( resource result, int field_number)
(PHP 4 >= 4.2.0)
pg_field_type --  Returns the type name for the corresponding field number 

Description
string pg_field_type ( resource result, int field_number)
pg_field_type() returns a string containing the type name of the given 
field_number in the given PostgreSQL result resource. Field numbering 
starts at 0. 
See the example given at the pg_field_name() page. 
Note: This function used to be called pg_fieldtype(). 
See also pg_field_prtlen() and pg_field_name().   pg_field_sizeUppg_free_result
#

#T=string pg_field_type ( resource result, int field_number)
pg_field_type ( ^!resource result, int field_number);
#

#T=pg_free_result - bool pg_free_result ( resource result)
(PHP 4 >= 4.2.0)
pg_free_result -- Free result memory
Description
bool pg_free_result ( resource result)
pg_free_result() only needs to be called if you are worried about using 
too much memory while your script is running. All result memory will 
automatically be freed when the script is finished. But, if you are sure 
you are not going to need the result data anymore in a script, you may 
call pg_free_result() with the result resource as an argument and the 
associated result memory will be freed. Returns TRUE on success or FALSE 
on failure. 
Note: This function used to be called pg_freeresult(). 
See also pg_query().   pg_field_typeUppg_get_notify
#

#T=bool pg_free_result ( resource result)
pg_free_result ( ^!resource result);
#

#T=pg_get_notify - array pg_get_notify ( resource connection [, int result_type])
(PHP 4 >= 4.3.0)
pg_get_notify -- Ping database connection
Description
array pg_get_notify ( resource connection [, int result_type])
pg_get_notify() gets notify message sent by NOTIFY SQL command. To receive 
notify messages, LISTEN SQL command must be issued. If there is notify 
message on the connection, array contains message name and backend PID is 
returned. If there is no message, FALSE is returned. 
See also pg_get_pid() 
Example 1. PostgreSQL NOTIFY message
  <?php 
  $conn = pg_pconnect("dbname=publisher");
  if (!$conn) {
      echo "An error occured.\n";
      exit;
  }

  // Listen 'author_updated' message from other processes
  pg_query($conn, 'LISTEN author_updated;');
  $notify = pg_get_notify($conn);
  if (!$notify) {
      echo "No messages\n";
  } else {
      print_r($notify);
  }
  ?> 

  pg_free_resultUppg_get_pid
#

#T=array pg_get_notify ( resource connection [, int result_type])
pg_get_notify ( ^!resource connection [, int result_type]);
#

#T=pg_get_pid - int pg_get_pid ( resource connection)
(PHP 4 >= 4.3.0)
pg_get_pid -- Ping database connection
Description
int pg_get_pid ( resource connection)
pg_get_pid() gets backend (database server process) PID. PID is useful to 
check if NOTIFY message is sent from other process or not. 
Example 1. PostgreSQL backend PID
  <?php 
  $conn = pg_pconnect("dbname=publisher");
  if (!$conn) {
      echo "An error occured.\n";
      exit;
  }

  // Backend process PID. Use PID with pg_get_notify()
  $pid = pg_get_pid($conn);
  ?> 
See also pg_get_notify().   pg_get_notifyUppg_get_result
#

#T=int pg_get_pid ( resource connection)
pg_get_pid ( ^!resource connection);
#

#T=pg_get_result - resource pg_get_result ( [resource connection])
(PHP 4 >= 4.2.0)
pg_get_result --  Get asynchronous query result 
Description
resource pg_get_result ( [resource connection])
pg_get_result() get result resource from async query executed by 
pg_send_query(). pg_send_query() can send multiple queries to PostgreSQL 
server and pg_get_result() is used to get query result one by one. It 
returns result resource. If there is no more results, it returns FALSE.   pg_get_pidUppg_host
#

#T=resource pg_get_result ( [resource connection])
pg_get_result ( ^![resource connection]);
#

#T=pg_host - string pg_host ( resource connection)
(PHP 3, PHP 4 )
pg_host --  Returns the host name associated with the connection 
Description
string pg_host ( resource connection)
pg_host() returns the host name of the given PostgreSQL connection 
resource is connected to. 
See also pg_connect() and pg_pconnect().   pg_get_resultUppg_insert
#

#T=string pg_host ( resource connection)
pg_host ( ^!resource connection);
#

#T=pg_insert - bool pg_insert ( resource connection, string table_name, array assoc_array 
(PHP 4 >= 4.3.0)
pg_insert --  Insert array into table. 
Description
bool pg_insert ( resource connection, string table_name, array assoc_array 
[, int options])
pg_insert() inserts the values of assoc_array into the table specified by 
table_name. table_name must at least have as many columns as assoc_array 
has elements. The fieldnames as well as the fieldvalues in table_name must 
match the indices and values of assoc_array. Returns TRUE on success or 
FALSE on failure. If options is specified, pg_insert() is applied to 
assoc_array with specified option. 
Example 1. pg_insert() example
  <?php 
      $dbconn = pg_connect('dbname=foo');
      // This is safe, since $_POST is converted automatically
      $res = pg_insert($dbconn, 'post_log', $_POST);
      if ($res) {
	  echo "POST data is successfully logged\n";
      } else {
	  echo "User must have sent wrong inputs\n";
      }
  ?> 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also pg_convert().   pg_hostUppg_last_error
#

#T=bool pg_insert ( resource connection, string table_name, array assoc_array 
pg_insert ( ^!resource connection, string table_name, array assoc_array ;
#

#T=pg_last_error - string pg_last_error ( [resource connection])
(PHP 4 >= 4.2.0)
pg_last_error -- Get the last error message string of a connection
Description
string pg_last_error ( [resource connection])
pg_last_error() returns the last error message for given connection. 
Error messages may be overwritten by internal PostgreSQL(libpq) function 
calls. It may not return appropriate error message, if multiple errors are 
occurred inside a PostgreSQL module function. 
Use pg_result_error(), pg_result_status() and pg_connection_status() for 
better error handling. 
Note: This function used to be called pg_errormessage(). 
See also pg_result_error().   pg_insertUppg_last_notice
#

#T=string pg_last_error ( [resource connection])
pg_last_error ( ^![resource connection]);
#

#T=pg_last_notice - string pg_last_notice ( resource connection)
(PHP 4 >= 4.0.6)
pg_last_notice --  Returns the last notice message from PostgreSQL server 
Description
string pg_last_notice ( resource connection)
pg_last_notice() returns the last notice message from the PostgreSQL 
server specified by connection. The PostgreSQL server sends notice 
messages in several cases, e.g. if the transactions can't be continued. 
With pg_last_notice(), you can avoid issuing useless queries, by checking 
whether the notice is related to the transaction or not. 
Warning
This function is EXPERIMENTAL and it is not fully implemented yet. 
pg_last_notice() was added in PHP 4.0.6. However, PHP 4.0.6 has 
problem with notice message handling. Use of the PostgreSQL module 
with PHP 4.0.6 is not recommended even if you are not using 
pg_last_notice(). 
This function is fully implemented in PHP 4.3.0. PHP earlier than 
PHP 4.3.0 ignores database connection parameter. 

Notice message tracking can be set to optional by setting 1 for 
pgsql.ignore_notice in php.ini from PHP 4.3.0. 
Notice message logging can be set to optional by setting 0 for 
pgsql.log_notice in php.ini from PHP 4.3.0. Unless pgsql.ignore_notice is 
set to 0, notice message cannot be logged. 
See also pg_query() and pg_last_error().   pg_last_errorUppg_last_oid
#

#T=string pg_last_notice ( resource connection)
pg_last_notice ( ^!resource connection);
#

#T=pg_last_oid - int pg_last_oid ( resource result)
(PHP 4 >= 4.2.0)
pg_last_oid -- Returns the last object's oid
Description
int pg_last_oid ( resource result)
pg_last_oid() is used to retrieve the oid assigned to an inserted tuple 
(record) if the result resource is used from the last command sent via 
pg_query() and was an SQL INSERT. Returns a positive integer if there was 
a valid oid. It returns FALSE if an error occurs or the last command sent 
via pg_query() was not an INSERT or INSERT is failed. 
OID field became an optional field from PostgreSQL 7.2. When OID field is 
not defined in a table, programmer must use pg_result_status() to check if 
record is is inserted successfully or not. 
Note: This function used to be called pg_getlastoid(). 
See also pg_query() and pg_result_status()   pg_last_noticeUppg_lo_close
#

#T=int pg_last_oid ( resource result)
pg_last_oid ( ^!resource result);
#

#T=pg_lo_close - bool pg_lo_close ( resource large_object)
(PHP 4 >= 4.2.0)
pg_lo_close -- Close a large object
Description
bool pg_lo_close ( resource large_object)
pg_lo_close() closes a Large Object. large_object is a resource for the 
large object from pg_lo_open(). 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_loclose(). 
See also pg_lo_open(), pg_lo_create() and pg_lo_import().   pg_last_oidUppg_lo_create
#

#T=bool pg_lo_close ( resource large_object)
pg_lo_close ( ^!resource large_object);
#

#T=pg_lo_create - int pg_lo_create ( resource connection)
(PHP 4 >= 4.2.0)
pg_lo_create -- Create a large object
Description
int pg_lo_create ( resource connection)
pg_lo_create() creates a Large Object and returns the oid of the large 
object. connection specifies a valid database connection opened by 
pg_connect() or pg_pconnect(). PostgreSQL access modes INV_READ, 
INV_WRITE, and INV_ARCHIVE are not supported, the object is created always 
with both read and write access. INV_ARCHIVE has been removed from 
PostgreSQL itself (version 6.3 and above). It returns large object oid, 
otherwise it returns FALSE if an error occurred. 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_locreate().   pg_lo_closeUppg_lo_export
#

#T=int pg_lo_create ( resource connection)
pg_lo_create ( ^!resource connection);
#

#T=pg_lo_export - bool pg_lo_export ( int oid, string pathname [, resource connection])
(PHP 4 >= 4.2.0)
pg_lo_export -- Export a large object to file
Description
bool pg_lo_export ( int oid, string pathname [, resource connection])
The oid argument specifies oid of the large object to export and the 
pathname argument specifies the pathname of the file. It returns FALSE if 
an error occurred, TRUE otherwise. 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_loexport(). 
See also pg_lo_import().   pg_lo_createUppg_lo_import
#

#T=bool pg_lo_export ( int oid, string pathname [, resource connection])
pg_lo_export ( ^!int oid, string pathname [, resource connection]);
#

#T=pg_lo_import - int pg_lo_import ( [resource connection, string pathname])
(PHP 4 >= 4.2.0)
pg_lo_import -- Import a large object from file
Description
int pg_lo_import ( [resource connection, string pathname])
In versions before PHP 4.2.0 the syntax of this function was different, 
see the following definition: 
int pg_lo_import ( string pathname [, resource connection])
The pathname argument specifies the pathname of the file to be imported as 
a large object. It returns FALSE if an error occurred, oid of the just 
created large object otherwise. 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: When safe mode is enabled, PHP checks whether the files or 
directories you are about to operate on have the same UID (owner) as the 
script that is being executed.
Note: This function used to be called pg_loimport(). 
See also pg_lo_export() and pg_lo_open().   pg_lo_exportUppg_lo_open
#

#T=int pg_lo_import ( [resource connection, string pathname])
pg_lo_import ( ^![resource connection, string pathname]);
#

#T=pg_lo_open - resource pg_lo_open ( resource connection, int oid, string mode)
(PHP 4 >= 4.2.0)
pg_lo_open -- Open a large object
Description
resource pg_lo_open ( resource connection, int oid, string mode)
pg_lo_open() opens a Large Object and returns large object resource. The 
resource encapsulates information about the connection. oid specifies a 
valid large object oid and mode can be either "r", "w", or "rw". It 
returns FALSE if there is an error. 
Warning
Do not close the database connection before closing the large object 
resource. 

To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_loopen(). 
See also pg_lo_close() and pg_lo_create().   pg_lo_importUppg_lo_read_all
#

#T=resource pg_lo_open ( resource connection, int oid, string mode)
pg_lo_open ( ^!resource connection, int oid, string mode);
#

#T=pg_lo_read_all - int pg_lo_read_all ( resource large_object)
(PHP 4 >= 4.2.0)
pg_lo_read_all --  Reads an entire large object and send straight to 
browser 
Description
int pg_lo_read_all ( resource large_object)
pg_lo_read_all() reads a large object and passes it straight through to 
the browser after sending all pending headers. Mainly intended for sending 
binary data like images or sound. It returns number of bytes read. It 
returns FALSE, if an error occurred. 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_loreadall(). 
See also pg_lo_read().   pg_lo_openUppg_lo_read
#

#T=int pg_lo_read_all ( resource large_object)
pg_lo_read_all ( ^!resource large_object);
#

#T=pg_lo_read - string pg_lo_read ( resource large_object, int len)
(PHP 4 >= 4.2.0)
pg_lo_read -- Read a large object
Description
string pg_lo_read ( resource large_object, int len)
pg_lo_read() reads at most len bytes from a large object and returns it as 
a string. large_object specifies a valid large object resource andlen 
specifies the maximum allowable size of the large object segment. It 
returns FALSE if there is an error. 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_loread(). 
See also pg_lo_read_all().   pg_lo_read_allUppg_lo_seek
#

#T=string pg_lo_read ( resource large_object, int len)
pg_lo_read ( ^!resource large_object, int len);
#

#T=pg_lo_seek - bool pg_lo_seek ( resource large_object, int offset [, int whence])
(PHP 4 >= 4.2.0)
pg_lo_seek --  Seeks position of large object 
Description
bool pg_lo_seek ( resource large_object, int offset [, int whence])
pg_lo_seek() seeks position of large object resource. whence is 
PGSQL_SEEK_SET, PGSQL_SEEK_CUR or PGSQL_SEEK_END. 
See also pg_lo_tell().   pg_lo_readUppg_lo_tell
#

#T=bool pg_lo_seek ( resource large_object, int offset [, int whence])
pg_lo_seek ( ^!resource large_object, int offset [, int whence]);
#

#T=pg_lo_tell - int pg_lo_tell ( resource large_object)
(PHP 4 >= 4.2.0)
pg_lo_tell --  Returns current position of large object 
Description
int pg_lo_tell ( resource large_object)
pg_lo_tell() returns current position (offset from the beginning of large 
object). 
See also pg_lo_seek().   pg_lo_seekUppg_lo_unlink
#

#T=int pg_lo_tell ( resource large_object)
pg_lo_tell ( ^!resource large_object);
#

#T=pg_lo_unlink - bool pg_lo_unlink ( resource connection, int oid)
(PHP 4 >= 4.2.0)
pg_lo_unlink -- Delete a large object
Description
bool pg_lo_unlink ( resource connection, int oid)
pg_lo_unlink() deletes a large object with the oid. Returns TRUE on 
success or FALSE on failure. 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_lo_unlink(). 
See also pg_lo_create() and pg_lo_import().   pg_lo_tellUppg_lo_write
#

#T=bool pg_lo_unlink ( resource connection, int oid)
pg_lo_unlink ( ^!resource connection, int oid);
#

#T=pg_lo_write - int pg_lo_write ( resource large_object, string data)
(PHP 4 >= 4.2.0)
pg_lo_write -- Write a large object
Description
int pg_lo_write ( resource large_object, string data)
pg_lo_write() writes at most to a large object from a variable data and 
returns the number of bytes actually written, or FALSE in the case of an 
error. large_object is a large object resource from pg_lo_open(). 
To use the large object (lo) interface, it is necessary to enclose it 
within a transaction block. 
Note: This function used to be called pg_lowrite(). 
See also pg_lo_create() and pg_lo_open().   pg_lo_unlinkUppg_meta_data
#

#T=int pg_lo_write ( resource large_object, string data)
pg_lo_write ( ^!resource large_object, string data);
#

#T=pg_meta_data - array pg_meta_data ( resource connection, string table_name)
(PHP 4 >= 4.3.0)
pg_meta_data --  Get meta data for table. 
Description
array pg_meta_data ( resource connection, string table_name)
pg_meta_data() returns table definition for table_name as an array. If 
there is error, it returns FALSE 
Example 1. Getting table metadata
  <?php
      $dbconn = pg_connect("dbname=publisher") or die("Could not 
  connect");

      $meta = pg_meta_data($dbconn, 'authors');
      if (is_array($meta)) {
	  echo '<pre>';
	  var_dump($meta);
	  echo '</pre>';
      }
  ?> 

The above example would produce the following output: 
array(3) {
["author"]=>
array(5) {
["num"]=>
int(1)
["type"]=>
string(7) "varchar"
["len"]=>
int(-1)
["not null"]=>
bool(false)
["has default"]=>
bool(false)
}
["year"]=>
array(5) {
["num"]=>
int(2)
["type"]=>
string(4) "int2"
["len"]=>
int(2)
["not null"]=>
bool(false)
["has default"]=>
bool(false)
}
["title"]=>
array(5) {
["num"]=>
int(3)
["type"]=>
string(7) "varchar"
["len"]=>
int(-1)
["not null"]=>
bool(false)
["has default"]=>
bool(false)
}
}
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also pg_convert().   pg_lo_writeUppg_num_fields
#

#T=array pg_meta_data ( resource connection, string table_name)
pg_meta_data ( ^!resource connection, string table_name);
#

#T=pg_num_fields - int pg_num_fields ( resource result)
(PHP 4 >= 4.2.0)
pg_num_fields -- Returns the number of fields
Description
int pg_num_fields ( resource result)
pg_num_fields() returns the number of fields (columns) in a PostgreSQL 
result. The argument is a result resource returned by pg_query(). This 
function will return -1 on error. 
Note: This function used to be called pg_numfields(). 
See also pg_num_rows() and pg_affected_rows().   pg_meta_dataUppg_num_rows
#

#T=int pg_num_fields ( resource result)
pg_num_fields ( ^!resource result);
#

#T=pg_num_rows - int pg_num_rows ( resource result)
(PHP 4 >= 4.2.0)
pg_num_rows -- Returns the number of rows
Description
int pg_num_rows ( resource result)
pg_num_rows() will return the number of rows in a PostgreSQL result 
resource. result is a query result resource returned by pg_query(). This 
function will return -1 on error. 
Note: Use pg_affected_rows() to get number of rows affected by INSERT, 
UPDATE and DELETE query. 
Note: This function used to be called pg_numrows(). 
See also pg_num_fields() and pg_affected_rows().   pg_num_fieldsUppg_options
#

#T=int pg_num_rows ( resource result)
pg_num_rows ( ^!resource result);
#

#T=pg_options - string pg_options ( resource connection)
(PHP 3, PHP 4 )
pg_options -- Get the options associated with the connection
Description
string pg_options ( resource connection)
pg_options() will return a string containing the options specified on the 
given PostgreSQL connection resource.   pg_num_rowsUppg_pconnect
#

#T=string pg_options ( resource connection)
pg_options ( ^!resource connection);
#

#T=pg_pconnect - resource pg_pconnect ( string connection_string)
(PHP 3, PHP 4 )
pg_pconnect -- Open a persistent PostgreSQL connection
Description
resource pg_pconnect ( string connection_string)
pg_pconnect() opens a connection to a PostgreSQL database. It returns a 
connection resource that is needed by other PostgreSQL functions. 
For a description of the connection_string parameter, see pg_connect(). 
To enable persistent connection, the pgsql.allow_persistent php.ini 
directive must be set to "On" (which is the default). The maximum number 
of persistent connection can be defined with the pgsql.max_persistent 
php.ini directive (defaults to -1 for no limit). The total number of 
connections can be set with the pgsql.max_links php.ini directive. 
pg_close() will not close persistent links generated by pg_pconnect(). 
See also pg_connect(), and the section Persistent Database Connections for 
more information.   pg_optionsUppg_ping
#

#T=resource pg_pconnect ( string connection_string)
pg_pconnect ( ^!string connection_string);
#

#T=pg_ping - bool pg_ping ( resource connection)
(PHP 4 >= 4.3.0)
pg_ping -- Ping database connection
Description
bool pg_ping ( resource connection)
pg_ping() ping database connection, try to reconnect if it is broken. It 
returns TRUE if connection is alive, otherwise FALSE. 
Example 1. pg_ping() example
  <?php 
  $conn = pg_pconnect("dbname=publisher");
  if (!$conn) {
      echo "An error occured.\n";
      exit;
  }

  if (!pg_ping($conn))
      die("Connection is broken\n");
  ?> 
See also pg_connection_status() and pg_connection_reset().   pg_pconnectUppg_port
#

#T=bool pg_ping ( resource connection)
pg_ping ( ^!resource connection);
#

#T=pg_port - int pg_port ( resource connection)
(PHP 3, PHP 4 )
pg_port --  Return the port number associated with the connection 
Description
int pg_port ( resource connection)
pg_port() returns the port number that the given PostgreSQL connection 
resource is connected to.   pg_pingUppg_put_line
#

#T=int pg_port ( resource connection)
pg_port ( ^!resource connection);
#

#T=pg_put_line - bool pg_put_line ( [resource connection, string data])
(PHP 4 >= 4.0.3)
pg_put_line -- Send a NULL-terminated string to PostgreSQL backend
Description
bool pg_put_line ( [resource connection, string data])
pg_put_line() sends a NULL-terminated string to the PostgreSQL backend 
server. This is useful for example for very high-speed inserting of data 
into a table, initiated by starting a PostgreSQL copy-operation. That 
final NULL-character is added automatically. Returns TRUE on success or 
FALSE on failure. 
Note: The application must explicitly send the two characters "\." on 
the last line to indicate to the backend that it has finished sending 
its data. 
Example 1. High-speed insertion of data into a table
  <?php 
      $conn = pg_pconnect("dbname=foo");
      pg_query($conn, "create table bar (a int4, b char(16), d 
  float8)");
      pg_query($conn, "copy bar from stdin");
      pg_put_line($conn, "3\thello world\t4.5\n");
      pg_put_line($conn, "4\tgoodbye world\t7.11\n");
      pg_put_line($conn, "\\.\n");
      pg_end_copy($conn);
  ?> 
See also pg_end_copy().   pg_portUppg_query
#

#T=bool pg_put_line ( [resource connection, string data])
pg_put_line ( ^![resource connection, string data]);
#

#T=pg_query - resource pg_query ( resource connection, string query)
(PHP 4 >= 4.2.0)
pg_query -- Execute a query
Description
resource pg_query ( resource connection, string query)
pg_query() returns a query result resource if query could be executed. It 
returns FALSE on failure or if connection is not a valid connection. 
Details about the error can be retrieved using the pg_last_error() 
function if connection is valid. pg_query() sends an SQL statement to the 
PostgreSQL database specified by the connection resource. The connection 
must be a valid connection that was returned by pg_connect() or 
pg_pconnect(). The return value of this function is an query result 
resource to be used to access the results from other PostgreSQL functions 
such as pg_fetch_array(). 
Note: connection is an optional parameter for pg_query(). If connection 
is not set, default connection is used. Default connection is the last 
connection made by pg_connect() or pg_pconnect(). 
Although connection can be omitted, it is not recommended, since it 
could be a cause of hard to find bug in script. 
Note: This function used to be called pg_exec(). pg_exec() is still 
available for compatibility reasons but users are encouraged to use the 
newer name. 
See also pg_connect(), pg_pconnect(), pg_fetch_array(), pg_fetch_object(), 
pg_num_rows() and pg_affected_rows().   pg_put_lineUppg_result_error
#

#T=resource pg_query ( resource connection, string query)
pg_query ( ^!resource connection, string query);
#

#T=pg_result_error - string pg_result_error ( resource result)
(PHP 4 >= 4.2.0)
pg_result_error --  Get error message associated with result 
Description
string pg_result_error ( resource result)
pg_result_error() returns error message associated with result resource. 
Therefore, user has better chance to get better error message than 
pg_last_error(). 
See also pg_query(), pg_send_query(), pg_get_result(), pg_last_error() and 
pg_last_notice()   pg_queryUppg_result_seek
#

#T=string pg_result_error ( resource result)
pg_result_error ( ^!resource result);
#

#T=pg_result_seek - array pg_result_seek ( resource result, int offset)
(PHP 4 >= 4.3.0)
pg_result_seek -- Set internal row offset in result resource
Description
array pg_result_seek ( resource result, int offset)
pg_result_seek() set internal row offset in result resource. It returns 
FALSE, if there is error. 
See also pg_fetch_row(), pg_fetch_assoc(), pg_fetch_array(), 
pg_fetch_object() and pg_fetch_result().   pg_result_errorUppg_result_status
#

#T=array pg_result_seek ( resource result, int offset)
pg_result_seek ( ^!resource result, int offset);
#

#T=pg_result_status - int pg_result_status ( resource result)
(PHP 4 >= 4.2.0)
pg_result_status --  Get status of query result 
Description
int pg_result_status ( resource result)
pg_result_status() returns status of result resource. Possible return 
values are PGSQL_EMPTY_QUERY, PGSQL_COMMAND_OK, PGSQL_TUPLES_OK, 
PGSQL_COPY_TO, PGSQL_COPY_FROM, PGSQL_BAD_RESPONSE, PGSQL_NONFATAL_ERROR 
and PGSQL_FATAL_ERROR. 
See also pg_connection_status().   pg_result_seekUppg_select
#

#T=int pg_result_status ( resource result)
pg_result_status ( ^!resource result);
#

#T=pg_select - array pg_select ( resource connection, string table_name, array 
(PHP 4 >= 4.3.0)
pg_select --  Select records. 
Description
array pg_select ( resource connection, string table_name, array 
assoc_array [, int options])
pg_select() selects records specified by assoc_array which has 
field=>value. For successful query, it returns array contains all records 
and fields that match the condition specified by assoc_array. If options 
is specified, pg_convert() is applied to assoc_array with specified 
option. 
Example 1. pg_select() example
  <?php 
      $db = pg_connect('dbname=foo');
      // This is safe, since $_POST is converted automatically
      $rec = pg_select($db, 'post_log', $_POST);
      if ($rec) {
	  echo "Records selected\n";
	  var_dump($rec);
      } else {
	  echo "User must have sent wrong inputs\n";
      }
  ?> 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also pg_convert()   pg_result_statusUppg_send_query
#

#T=array pg_select ( resource connection, string table_name, array 
pg_select ( ^!resource connection, string table_name, array ;
#

#T=pg_send_query - bool pg_send_query ( resource connection, string query)
(PHP 4 >= 4.2.0)
pg_send_query --  Sends asynchronous query 
Description
bool pg_send_query ( resource connection, string query)

bool pg_send_query ( string query)
pg_send_query() send asynchronous query to the connection. Unlike 
pg_query(), it can send multiple query to PostgreSQL and get the result 
one by one using pg_get_result(). Script execution is not blocked while 
query is executing. Use pg_connection_busy() to check connection is busy 
(i.e. query is executing). Query may be cancelled by calling 
pg_cancel_query(). 
Although user can send multiple query at once, user cannot send multiple 
query over busy connection. If query is sent while connection is busy, it 
waits until last query is finished and discards all result. 
Example 1. Asynchronous Queries
  <?php
      $dbconn = pg_connect("dbname=publisher") or die("Could not 
  connect");

      if (!pg_connection_busy($dbconn)) {
	  pg_send_query($dbconn, "select * from authors; select 
  count(*) from authors;");
      }
      
      $res1 = pg_get_result($dbconn);
      echo "First call to pg_get_result(): $res1\n";
      $rows1 = pg_num_rows($res1);
      echo "$res1 has $rows1 records\n\n";
      
      $res2 = pg_get_result($dbconn);
      echo "second call to pg_get_result(): $res2\n";
      $rows2 = pg_num_rows($res2);
      echo "$res2 has $rows2 records\n";
  ?> 

The above example would produce the following output: 
first call to pg_get_result(): Resource id #3
Resource id #3 has 3 records

second call to pg_get_result(): Resource id #4
Resource id #4 has 1 records
See also pg_query(), pg_cancel_query(), pg_get_result() and 
pg_connection_busy().   pg_selectUppg_set_client_encoding
#

#T=bool pg_send_query ( resource connection, string query)
pg_send_query ( ^!resource connection, string query);
#

#T=pg_set_client_encoding - int pg_set_client_encoding ( [resource connection, string encoding])
(PHP 3 CVS only, PHP 4 >= 4.0.3)
pg_set_client_encoding --  Set the client encoding 
Description
int pg_set_client_encoding ( [resource connection, string encoding])
pg_set_client_encoding() sets the client encoding and returns 0 if success 
or -1 if error. 
encoding is the client encoding and can be either : SQL_ASCII, EUC_JP, 
EUC_CN, EUC_KR, EUC_TW, UNICODE, MULE_INTERNAL, LATINX (X=1...9), KOI8, 
WIN, ALT, SJIS, BIG5, WIN1250. Available encoding depends on your 
PostgreSQL and libpq version. Refer to PostgreSQL manual for supported 
encodings for your PostgreSQL. 
Note: This function requires PHP-4.0.3 or higher and PostgreSQL-7.0 or 
higher. Supported encoding depends on PostgreSQL version. Refer to 
PostgreSQL manual for details. 
The function used to be called pg_setclientencoding(). 
See also pg_client_encoding().   pg_send_queryUppg_trace
#

#T=int pg_set_client_encoding ( [resource connection, string encoding])
pg_set_client_encoding ( ^![resource connection, string encoding]);
#

#T=pg_trace - bool pg_trace ( string pathname [, string mode [, resource connection]])
(PHP 4 >= 4.0.1)
pg_trace -- Enable tracing a PostgreSQL connection
Description
bool pg_trace ( string pathname [, string mode [, resource connection]])
pg_trace() enables tracing of the PostgreSQL frontend/backend 
communication to a debugging file specified as pathname. To fully 
understand the results, one needs to be familiar with the internals of 
PostgreSQL communication protocol. For those who are not, it can still be 
useful for tracing errors in queries sent to the server, you could do for 
example grep '^To backend' trace.log and see what query actually were sent 
to the PostgreSQL server. For more information, refer to PostgreSQL 
manual. 
pathname and mode are the same as in fopen() (mode defaults to 'w'), 
connection specifies the connection to trace and defaults to the last one 
opened. 
pg_trace() returns TRUE if pathname could be opened for logging, FALSE 
otherwise. 
See also fopen() and pg_untrace().   pg_set_client_encodingUppg_tty
#

#T=bool pg_trace ( string pathname [, string mode [, resource connection]])
pg_trace ( ^!string pathname [, string mode [, resource connection]]);
#

#T=pg_tty - string pg_tty ( resource connection)
(PHP 3, PHP 4 )
pg_tty --  Return the tty name associated with the connection 
Description
string pg_tty ( resource connection)
pg_tty() returns the tty name that server side debugging output is sent to 
on the given PostgreSQL connection resource.   pg_traceUppg_unescape_bytea
#

#T=string pg_tty ( resource connection)
pg_tty ( ^!resource connection);
#

#T=pg_unescape_bytea - string pg_unescape_bytea ( string data)
(PHP 4 >= 4.3.0)
pg_unescape_bytea --  Unescape binary for bytea type 
Description
string pg_unescape_bytea ( string data)
pg_unescape_bytea() unescapes string from bytea datatype. It returns 
unescaped string (binary). 
Note: When you SELECT bytea type, PostgreSQL returns octal byte value 
prefixed by \ (e.g. \032). Users are supposed to convert back to binary 
format by yourself. 
This function requires PostgreSQL 7.2 or later. With PostgreSQL 7.2.0 
and 7.2.1, bytea type must be casted when you enable multi-byte support. 
i.e. INSERT INTO test_table (image) VALUES ('$image_escaped'::bytea); 
PostgreSQL 7.2.2 or later does not need cast. Exception is when client 
and backend character encoding does not match, there may be multi-byte 
stream error. User must cast to bytea to avoid this error. 
See also pg_escape_bytea() and pg_escape_string()   pg_ttyUppg_untrace
#

#T=string pg_unescape_bytea ( string data)
pg_unescape_bytea ( ^!string data);
#

#T=pg_untrace - bool pg_untrace ( [resource connection])
(PHP 4 >= 4.0.1)
pg_untrace -- Disable tracing of a PostgreSQL connection
Description
bool pg_untrace ( [resource connection])
Stop tracing started by pg_trace(). connection specifies the connection 
that was traced and defaults to the last one opened. 
Returns always TRUE. 
See also pg_trace().   pg_unescape_byteaUppg_update
#

#T=bool pg_untrace ( [resource connection])
pg_untrace ( ^![resource connection]);
#

#T=pg_update - mixed pg_update ( resource connection, string table_name, array data, 
(PHP 4 >= 4.3.0)
pg_update --  Update table. 
Description
mixed pg_update ( resource connection, string table_name, array data, 
array condition [, int options])
pg_update() updates records that matches condition with data. If options 
is specified, pg_convert() is applied to data with specified options. 
Example 1. pg_update() example
  <?php 
      $db = pg_connect('dbname=foo');
      $data = array('field1'=>'AA', 'field2'=>'BB');
      
      // This is safe, since $_POST is converted automatically
      $res = pg_update($db, 'post_log', $_POST, $data);
      if ($res) {
	  echo "Data is updated: $res\n";
      } else {
	  echo "User must have sent wrong inputs\n";
      }
  ?> 
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also pg_convert().   pg_untraceUpProcess Control Functions
#

#T=mixed pg_update ( resource connection, string table_name, array data, 
pg_update ( ^!resource connection, string table_name, array data, ;
#

#T=php_ini_scanned_files - string php_ini_scanned_files ( void )
(PHP 4 >= 4.3.0)
php_ini_scanned_files -- Return a list of .ini files parsed from the 
additional ini dir
Description
string php_ini_scanned_files ( void )
php_ini_scanned_files() returns a comma-separated list of configuration 
files parsed after php.ini. These files are found in a directory defined 
by the --with-config-file-scan-dir. option which is set during 
compilation. 
Returns a comma-separated string of .ini files on success. If the 
directive --with-config-files-scan-dir wasn't set, FALSE is returned. If 
it was set and the directory was empty, an empty string is returned. If a 
file is unrecognizable, the file will still make it into the returned 
string but a PHP error will also result. This PHP error will be seen both 
at compile time and while using php_ini_scanned_files(). 
The returned configuration files also include the path as declared in the 
--with-config-file-scan-dir directive. Also, each comma is followed by a 
newline. 
Example 1. A simple example to list the returned ini files
  <?php
  if ($filelist = php_ini_scanned_files()) {
      if (strlen($filelist) > 0) {
	  $files = explode(',', $filelist);

	  foreach ($files as $file) {
	      echo "<li>" . trim($file) . "</li>\n";
	  }
      }
  }
  ?> 
See also ini_set() and phpinfo().   memory_get_usageUpphp_logo_guid
#

#T=string php_ini_scanned_files ( void )
php_ini_scanned_files ( ^!void );
#

#T=php_logo_guid - string php_logo_guid ( void )
(PHP 4 )
php_logo_guid -- Gets the logo guid
Description
string php_logo_guid ( void )
This function returns the ID which can be used to display the PHP logo 
using the built-in image. 
Example 1. php_logo_guid() example
  <?php

  echo '<img src="' . $_SERVER['PHP_SELF'] .
       '?=' . php_logo_guid() . '" alt="PHP Logo !" />';

  ?> 
See also phpinfo(), phpversion(), phpcredits() and zend_logo_guid().   php_ini_scanned_filesUpphp_sapi_name
#

#T=string php_logo_guid ( void )
php_logo_guid ( ^!void );
#

#T=php_sapi_name - string php_sapi_name ( void )
(PHP 4 >= 4.0.1)
php_sapi_name --  Returns the type of interface between web server and PHP 

Description
string php_sapi_name ( void )
php_sapi_name() returns a lowercase string which describes the type of 
interface between web server and PHP (Server API, SAPI). In CGI PHP, this 
string is "cgi", in mod_php for Apache, this string is "apache" and so on. 

Example 1. php_sapi_name() example
  <?php
  $sapi_type = php_sapi_name();
  if ($sapi_type == "cgi") {
      echo "You are using CGI PHP\n";
  } else {
      echo "You are not using CGI PHP\n";
  }
  ?> 

  php_logo_guidUpphp_uname
#

#T=string php_sapi_name ( void )
php_sapi_name ( ^!void );
#

#T=php_uname - string php_uname ( void )
(PHP 4 >= 4.0.2)
php_uname --  Returns information about the operating system PHP was built 
on 
Description
string php_uname ( void )
php_uname() returns a string with a description of the operating system 
PHP is built on. If you're just wanting the name of the operating system, 
consider using the PHP_OS constant. 
Example 1. Some php_uname() examples
  <?php
  echo php_uname();
  echo PHP_OS;

  /* Some possible outputs:
  Linux localhost 2.4.21-0.13mdk #1 Fri Mar 14 15:08:06 EST 2003 
  i686
  Linux

  FreeBSD localhost 3.2-RELEASE #15: Mon Dec 17 08:46:02 GMT 
2001
  FreeBSD

  Windows NT XN1 5.1 build 2600
  WINNT
  */

  if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
      echo 'This is a server using Windows!';
  } else {
      echo 'This is a server not using Windows!';
  }

  ?> 
There are also some related Predefined PHP constants that may come in 
handy, for example: 
Example 2. A few OS related constant examples
  <?php
  // *nix
  echo DIRECTORY_SEPARATOR; // :
  echo PHP_SHLIB_SUFFIX;    // so

  // Win*
  echo DIRECTORY_SEPARATOR; // ;
  echo PHP_SHLIB_SUFFIX;    // dll
  ?> 
See also phpversion(), php_sapi_name(), and phpinfo().   php_sapi_nameUpphpcredits
#

#T=string php_uname ( void )
php_uname ( ^!void );
#

#T=phpcredits - void phpcredits ( [int flag])
(PHP 4 )
phpcredits -- Prints out the credits for PHP
Description
void phpcredits ( [int flag])
This function prints out the credits listing the PHP developers, modules, 
etc. It generates the appropriate HTML codes to insert the information in 
a page. flag is optional, and it defaults to CREDITS_ALL. To generate a 
custom credits page, you may want to use the flag parameter. For example 
to print the general credits, you will use somewhere in your code: 
<?php
phpcredits(CREDITS_GENERAL);
?> 

And if you want to print the core developers and the documentation group, 
in a page of its own, you will use: 
<?php
phpcredits(CREDITS_GROUP + CREDITS_DOCS + CREDITS_FULLPAGE);
?> 

And if you feel like embedding all the credits in your page, then code 
like the one below will do it: 
<html>
<head>
<title>My credits page</title>
</head>
<body>
<?php
// some code of your own
phpcredits(CREDITS_ALL);
// some more code
?>
</body>
</html> 

Table 1. Pre-defined phpcredits() flags
namedescription
CREDITS_ALLAll the credits, equivalent to using: CREDITS_DOCS + 
CREDITS_GENERAL + CREDITS_GROUP + CREDITS_MODULES + 
CREDITS_FULLPAGE. It generates a complete stand-alone HTML page with 
the appropriate tags. 
CREDITS_DOCSThe credits for the documentation team
CREDITS_FULLPAGEUsually used in combination with the other flags. 
Indicates that the a complete stand-alone HTML page needs to be 
printed including the information indicated by the other flags. 
CREDITS_GENERALGeneral credits: Language design and concept, PHP 4.0 
authors and SAPI module. 
CREDITS_GROUPA list of the core developers
CREDITS_MODULESA list of the extension modules for PHP, and their 
authors 
CREDITS_SAPIA list of the server API modules for PHP, and their 
authors 

See also phpinfo(), phpversion() and php_logo_guid().   php_unameUpphpinfo
#

#T=void phpcredits ( [int flag])
phpcredits ( ^![int flag]);
#

#T=phpinfo - int phpinfo ( [int what])
(PHP 3, PHP 4 )
phpinfo -- Outputs lots of PHP information
Description
int phpinfo ( [int what])
Outputs a large amount of information about the current state of PHP. This 
includes information about PHP compilation options and extensions, the PHP 
version, server information and environment (if compiled as a module), the 
PHP environment, OS version information, paths, master and local values of 
configuration options, HTTP headers, and the PHP License. 
Because every system is setup differently, phpinfo() is commonly used to 
check configuration settings and for available predefined variables on a 
given system. Also, phpinfo() is a valuable debugging tool as it contains 
all EGPCS (Environment, GET, POST, Cookie, Server) data. 
The output may be customized by passing one or more of the following 
constants bitwise values summed together in the optional what parameter. 
One can also combine the respective constants or bitwise values together 
with the or operator. 
Table 1. phpinfo() options
Name (constant)ValueDescription
INFO_GENERAL1The configuration line, php.ini location, build date, 
Web Server, System and more. 
INFO_CREDITS2PHP 4 Credits. See also phpcredits(). 
INFO_CONFIGURATION4Current Local and Master values for PHP 
directives. See also ini_get(). 
INFO_MODULES8Loaded modules and their respective settings. See also 
get_loaded_modules(). 
INFO_ENVIRONMENT16Environment Variable information that's also 
available in $_ENV. 
INFO_VARIABLES32Shows all predefined variables from EGPCS 
(Environment, GET, POST, Cookie, Server). 
INFO_LICENSE64PHP License information. See also the license faq. 
INFO_ALL-1Shows all of the above. This is the default value. 

Example 1. phpinfo() examples
  <?php

  // Show all information, defaults to INFO_ALL
  phpinfo();

  // Show just the module information.
  // phpinfo(8) yields identical results.
  phpinfo(INFO_MODULES);

  ?> 
Note: Parts of the information displayed are disabled when the 
expose_php configuration setting is set to off. This includes the PHP 
and Zend logos, and the credits. 
See also phpversion(), phpcredits(), php_logo_guid(), ini_get(), 
ini_set(), get_loaded_modules(), and the section on Predefined Variables.   phpcreditsUpphpversion
#

#T=int phpinfo ( [int what])
phpinfo ( ^![int what]);
#

#T=phpversion - string phpversion ( void )
(PHP 3, PHP 4 )
phpversion -- Gets the current PHP version
Description
string phpversion ( void )
Returns a string containing the version of the currently running PHP 
parser. 
Note: This information is also available in the predefined constant 
PHP_VERSION. 
Example 1. phpversion() example
  <?php
  // prints e.g. 'Current PHP version: 4.1.1'
  echo 'Current PHP version: ' . phpversion();
  ?> 
See also version_compare(), phpinfo(), phpcredits(), php_logo_guid(), and 
zend_version().   phpinfoUpputenv
#

#T=string phpversion ( void )
phpversion ( ^!void );
#

#T=pi - float pi ( void )
(PHP 3, PHP 4 )
pi -- Get value of pi
Description
float pi ( void )
Returns an approximation of pi. The returned float has a precision based 
on the precision directive in php.ini, which defaults to 14. Also, you can 
use the M_PI constant which yields identical results to pi(). 
<?php
echo pi(); // 3.1415926535898
echo M_PI; // 3.1415926535898
?> 
  octdecUppow
#

#T=float pi ( void )
pi ( ^!void );
#

#T=png2wbmp - int png2wbmp ( string pngname, string wbmpname, int d_height, int d_width, 
(PHP 4 >= 4.0.5)
png2wbmp -- Convert PNG image file to WBMP image file
Description
int png2wbmp ( string pngname, string wbmpname, int d_height, int d_width, 
int threshold)
Converts the pngname PNG file to WBMP format, and saves it as wbmpname. 
With the d_height and d_width you specify the height and width of the 
destination image. 
Note: WBMP support is only available if PHP was compiled against GD-1.8 
or later. 
See also jpeg2wbmp().   jpeg2wbmpUpread_exif_data
#

#T=int png2wbmp ( string pngname, string wbmpname, int d_height, int d_width, 
png2wbmp ( ^!string pngname, string wbmpname, int d_height, int d_width, ;
#

#T=popen - resource popen ( string command, string mode)
(PHP 3, PHP 4 )
popen -- Opens process file pointer
Description
resource popen ( string command, string mode)
Opens a pipe to a process executed by forking the command given by 
command. 
Returns a file pointer identical to that returned by fopen(), except that 
it is unidirectional (may only be used for reading or writing) and must be 
closed with pclose(). This pointer may be used with fgets(), fgetss(), and 
fputs(). 
If an error occurs, returns FALSE. 
Note: If you're looking for bi-directional support (two-way), use 
proc_open(). 
Example 1. popen() example
  <?php
  $handle = popen("/bin/ls", "r");
  ?> 
If the command to be executed could not be found, a valid resource is 
returned. This may seem odd, but makes sense; it allows you to access any 
error message returned by the shell: 
<?php
error_reporting(E_ALL);

/* Add redirection so we can get stderr. */
$handle = popen('/path/to/spooge 2>&1', 'r');
echo "'$handle'; " . gettype($handle) . "\n";
$read = fread($handle, 2096);
echo $read;
pclose($handle);
?> 

Note: When safe mode is enabled, you can only execute executables within 
the safe_mode_exec_dir. For practical reasons it's currently not allowed 
to have .. components in the path to the executable. 
See also pclose(), fopen(), and proc_open().   pcloseUpreadfile
#

#T=resource popen ( string command, string mode)
popen ( ^!string command, string mode);
#

#T=pos - mixed pos ( array array)
(PHP 3, PHP 4 )
pos -- Get the current element from an array
Description
mixed pos ( array array)
This is an alias for current(). 
See also end(), next(), prev(), and reset().   nextUpprev
#

#T=mixed pos ( array array)
pos ( ^!array array);
#

#T=posix_ctermid - string posix_ctermid ( void )
(PHP 3>= 3.0.13, PHP 4 )
posix_ctermid -- Get path name of controlling terminal
Description
string posix_ctermid ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  POSIX functionsUpposix_get_last_error
#

#T=string posix_ctermid ( void )
posix_ctermid ( ^!void );
#

#T=posix_get_last_error - int posix_get_last_error ( void )
(PHP 4 >= 4.2.0)
posix_get_last_error --  Retrieve the error number set by the last posix 
function that failed. 
Description
int posix_get_last_error ( void )
Returns the errno (error number) set by the last posix function that 
failed. If no errors exist, 0 is returned. If you're wanting the system 
error message associated with the errno, use posix_strerror(). 
See also posix_strerror().   posix_ctermidUpposix_getcwd
#

#T=int posix_get_last_error ( void )
posix_get_last_error ( ^!void );
#

#T=posix_getcwd - string posix_getcwd ( void )
(PHP 3>= 3.0.13, PHP 4 )
posix_getcwd -- Pathname of current directory
Description
string posix_getcwd ( void )
posix_getcwd() returns the absolute pathname of the script's current 
working directory. posix_getcwd() returns FALSE on error.   posix_get_last_errorUpposix_getegid
#

#T=string posix_getcwd ( void )
posix_getcwd ( ^!void );
#

#T=posix_getegid - int posix_getegid ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getegid --  Return the effective group ID of the current process 
Description
int posix_getegid ( void )
Return the numeric effective group ID of the current process. See also 
posix_getgrgid() for information on how to convert this into a useable 
group name.   posix_getcwdUpposix_geteuid
#

#T=int posix_getegid ( void )
posix_getegid ( ^!void );
#

#T=posix_geteuid - int posix_geteuid ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_geteuid --  Return the effective user ID of the current process 
Description
int posix_geteuid ( void )
Return the numeric effective user ID of the current process. See also 
posix_getpwuid() for information on how to convert this into a useable 
username.   posix_getegidUpposix_getgid
#

#T=int posix_geteuid ( void )
posix_geteuid ( ^!void );
#

#T=posix_getgid - int posix_getgid ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getgid --  Return the real group ID of the current process 
Description
int posix_getgid ( void )
Return the numeric real group ID of the current process. See also 
posix_getgrgid() for information on how to convert this into a useable 
group name.   posix_geteuidUpposix_getgrgid
#

#T=int posix_getgid ( void )
posix_getgid ( ^!void );
#

#T=posix_getgrgid - array posix_getgrgid ( int gid)
(PHP 3>= 3.0.13, PHP 4 )
posix_getgrgid -- Return info about a group by group id
Description
array posix_getgrgid ( int gid)
Returns an array of information about a group and FALSE on failure. If gid 
isn't a number then NULL is returned and an E_WARNING level error is 
generated. 
Example 1. Example use of posix_getgrgid()
  <?php

  $groupid   = posix_getegid();
  $groupinfo = posix_getgrgid($groupid);

  print_r($groupinfo);

  ?> 

An example output: 
Array
(
[name]    => toons
[passwd]  => x
[members] => Array 
( 
[0] => tom
[1] => jerry
)
[gid]     => 42
)
Note: As of PHP 4.2.0, members is returned as an array of member 
usernames in the group. Before this time it was simply an integer (the 
number of members in the group) and the member names were returned with 
numerical indices. 
See also posix_getegid(), filegroup(), stat(), and safe_mode_gid.   posix_getgidUpposix_getgrnam
#

#T=array posix_getgrgid ( int gid)
posix_getgrgid ( ^!int gid);
#

#T=posix_getgrnam - array posix_getgrnam ( string name)
(PHP 3>= 3.0.13, PHP 4 )
posix_getgrnam -- Return info about a group by name
Description
array posix_getgrnam ( string name)
Warning
This function is currently not documented; only the argument list is 
available.
  posix_getgrgidUpposix_getgroups
#

#T=array posix_getgrnam ( string name)
posix_getgrnam ( ^!string name);
#

#T=posix_getgroups - array posix_getgroups ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getgroups --  Return the group set of the current process 
Description
array posix_getgroups ( void )
Returns an array of integers containing the numeric group ids of the group 
set of the current process. See also posix_getgrgid() for information on 
how to convert this into useable group names.   posix_getgrnamUpposix_getlogin
#

#T=array posix_getgroups ( void )
posix_getgroups ( ^!void );
#

#T=posix_getlogin - string posix_getlogin ( void )
(PHP 3>= 3.0.13, PHP 4 )
posix_getlogin -- Return login name
Description
string posix_getlogin ( void )
Returns the login name of the user owning the current process. See 
posix_getpwnam() for information how to get more information about this 
user.   posix_getgroupsUpposix_getpgid
#

#T=string posix_getlogin ( void )
posix_getlogin ( ^!void );
#

#T=posix_getpgid - int posix_getpgid ( int pid)
(PHP 3>= 3.0.10, PHP 4 )
posix_getpgid -- Get process group id for job control
Description
int posix_getpgid ( int pid)
Returns the process group identifier of the process pid. 
This is not a POSIX function, but is common on BSD and System V systems. 
If your system does not support this function at system level, this PHP 
function will always return FALSE.   posix_getloginUpposix_getpgrp
#

#T=int posix_getpgid ( int pid)
posix_getpgid ( ^!int pid);
#

#T=posix_getpgrp - int posix_getpgrp ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getpgrp --  Return the current process group identifier 
Description
int posix_getpgrp ( void )
Return the process group identifier of the current process. See POSIX.1 
and the getpgrp(2) manual page on your POSIX system for more information 
on process groups.   posix_getpgidUpposix_getpid
#

#T=int posix_getpgrp ( void )
posix_getpgrp ( ^!void );
#

#T=posix_getpid - int posix_getpid ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getpid -- Return the current process identifier
Description
int posix_getpid ( void )
Return the process identifier of the current process.  posix_getpgrpUpposix_getppid
#

#T=int posix_getpid ( void )
posix_getpid ( ^!void );
#

#T=posix_getppid - int posix_getppid ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getppid -- Return the parent process identifier
Description
int posix_getppid ( void )
Return the process identifier of the parent process of the current 
process.   posix_getpidUpposix_getpwnam
#

#T=int posix_getppid ( void )
posix_getppid ( ^!void );
#

#T=posix_getpwnam - array posix_getpwnam ( string username)
(PHP 3>= 3.0.13, PHP 4 )
posix_getpwnam -- Return info about a user by username
Description
array posix_getpwnam ( string username)
Returns an associative array containing information about a user 
referenced by an alphanumeric username, passed in the username parameter. 
The array elements returned are: 
Table 1. The user information array
ElementDescription
nameThe name element contains the username of the user. This is a 
short, usually less than 16 character "handle" of the user, not her 
real, full name. This should be the same as the username parameter 
used when calling the function, and hence redundant. 
passwdThe passwd element contains the user's password in an 
encrypted format. Often, for example on a system employing "shadow" 
passwords, an asterisk is returned instead. 
uidUser ID of the user in numeric form. 
gidThe group ID of the user. Use the function posix_getgrgid() to 
resolve the group name and a list of its members. 
gecosGECOS is an obsolete term that refers to the finger information 
field on a Honeywell batch processing system. The field, however, 
lives on, and its contents have been formalized by POSIX. The field 
contains a comma separated list containing the user's full name, 
office phone, office number, and home phone number. On most systems, 
only the user's full name is available. 
dirThis element contains the absolute path to the home directory of 
the user. 
shellThe shell element contains the absolute path to the executable 
of the user's default shell. 
  posix_getppidUpposix_getpwuid
#

#T=array posix_getpwnam ( string username)
posix_getpwnam ( ^!string username);
#

#T=posix_getpwuid - array posix_getpwuid ( int uid)
(PHP 3>= 3.0.13, PHP 4 )
posix_getpwuid -- Return info about a user by user id
Description
array posix_getpwuid ( int uid)
Returns an associative array containing information about a user 
referenced by a numeric user ID, passed in the uid parameter. 
The array elements returned are: 
Table 1. The user information array
ElementDescription
nameThe name element contains the username of the user. This is a 
short, usually less than 16 character "handle" of the user, not her 
real, full name. 
passwdThe passwd element contains the user's password in an 
encrypted format. Often, for example on a system employing "shadow" 
passwords, an asterisk is returned instead. 
uidUser ID, should be the same as the uid parameter used when 
calling the function, and hence redundant. 
gidThe group ID of the user. Use the function posix_getgrgid() to 
resolve the group name and a list of its members. 
gecosGECOS is an obsolete term that refers to the finger information 
field on a Honeywell batch processing system. The field, however, 
lives on, and its contents have been formalized by POSIX. The field 
contains a comma separated list containing the user's full name, 
office phone, office number, and home phone number. On most systems, 
only the user's full name is available. 
dirThis element contains the absolute path to the home directory of 
the user. 
shellThe shell element contains the absolute path to the executable 
of the user's default shell. 
  posix_getpwnamUpposix_getrlimit
#

#T=array posix_getpwuid ( int uid)
posix_getpwuid ( ^!int uid);
#

#T=posix_getrlimit - array posix_getrlimit ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getrlimit -- Return info about system resource limits
Description
array posix_getrlimit ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  posix_getpwuidUpposix_getsid
#

#T=array posix_getrlimit ( void )
posix_getrlimit ( ^!void );
#

#T=posix_getsid - int posix_getsid ( int pid)
(PHP 3>= 3.0.10, PHP 4 )
posix_getsid -- Get the current sid of the process
Description
int posix_getsid ( int pid)
Return the sid of the process pid. If pid is 0, the sid of the current 
process is returned. 
This is not a POSIX function, but is common on System V systems. If your 
system does not support this function at system level, this PHP function 
will always return FALSE.   posix_getrlimitUpposix_getuid
#

#T=int posix_getsid ( int pid)
posix_getsid ( ^!int pid);
#

#T=posix_getuid - int posix_getuid ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_getuid --  Return the real user ID of the current process 
Description
int posix_getuid ( void )
Return the numeric real user ID of the current process. See also 
posix_getpwuid() for information on how to convert this into a useable 
username.   posix_getsidUpposix_isatty
#

#T=int posix_getuid ( void )
posix_getuid ( ^!void );
#

#T=posix_isatty - bool posix_isatty ( int fd)
(PHP 3>= 3.0.13, PHP 4 )
posix_isatty --  Determine if a file descriptor is an interactive terminal 

Description
bool posix_isatty ( int fd)
Warning
This function is currently not documented; only the argument list is 
available.
  posix_getuidUpposix_kill
#

#T=bool posix_isatty ( int fd)
posix_isatty ( ^!int fd);
#

#T=posix_kill - bool posix_kill ( int pid, int sig)
(PHP 3>= 3.0.13, PHP 4 )
posix_kill -- Send a signal to a process
Description
bool posix_kill ( int pid, int sig)
Send the signal sig to the process with the process identifier pid. 
Returns FALSE, if unable to send the signal, TRUE otherwise. 
See also the kill(2) manual page of your POSIX system, which contains 
additional information about negative process identifiers, the special pid 
0, the special pid -1, and the signal number 0.   posix_isattyUpposix_mkfifo
#

#T=bool posix_kill ( int pid, int sig)
posix_kill ( ^!int pid, int sig);
#

#T=posix_mkfifo - bool posix_mkfifo ( string pathname, int mode)
(PHP 3>= 3.0.13, PHP 4 )
posix_mkfifo --  Create a fifo special file (a named pipe) 
Description
bool posix_mkfifo ( string pathname, int mode)
posix_mkfifo() creates a special FIFO file which exists in the file system 
and acts as a bidirectional communication endpoint for processes. 
The second parameter mode has to be given in octal notation (e.g. 0644). 
The permission of the newly created FIFO also depends on the setting of 
the current umask(). The permissions of the created file are (mode & 
~umask). 
Note: When safe mode is enabled, PHP checks whether the directory in 
which you are about to operate has the same UID (owner) as the script 
that is being executed.  posix_killUpposix_setegid
#

#T=bool posix_mkfifo ( string pathname, int mode)
posix_mkfifo ( ^!string pathname, int mode);
#

#T=posix_setegid - bool posix_setegid ( int gid)
(PHP 4 >= 4.0.2)
posix_setegid --  Set the effective GID of the current process 
Description
bool posix_setegid ( int gid)
Set the effective group ID of the current process. This is a privileged 
function and you need appropriate privileges (usually root) on your system 
to be able to perform this function. 
Returns TRUE on success, FALSE otherwise.   posix_mkfifoUpposix_seteuid
#

#T=bool posix_setegid ( int gid)
posix_setegid ( ^!int gid);
#

#T=posix_seteuid - bool posix_seteuid ( int uid)
(PHP 4 >= 4.0.2)
posix_seteuid --  Set the effective UID of the current process 
Description
bool posix_seteuid ( int uid)
Set the real user ID of the current process. This is a privileged function 
and you need appropriate privileges (usually root) on your system to be 
able to perform this function. 
Returns TRUE on success, FALSE otherwise. See also posix_setgid().   posix_setegidUpposix_setgid
#

#T=bool posix_seteuid ( int uid)
posix_seteuid ( ^!int uid);
#

#T=posix_setgid - bool posix_setgid ( int gid)
(PHP 3>= 3.0.13, PHP 4 )
posix_setgid --  Set the GID of the current process 
Description
bool posix_setgid ( int gid)
Set the real group ID of the current process. This is a privileged 
function and you need appropriate privileges (usually root) on your system 
to be able to perform this function. The appropriate order of function 
calls is posix_setgid() first, posix_setuid() last. 
Returns TRUE on success, FALSE otherwise.   posix_seteuidUpposix_setpgid
#

#T=bool posix_setgid ( int gid)
posix_setgid ( ^!int gid);
#

#T=posix_setpgid - int posix_setpgid ( int pid, int pgid)
(PHP 3>= 3.0.13, PHP 4 )
posix_setpgid -- set process group id for job control
Description
int posix_setpgid ( int pid, int pgid)
Let the process pid join the process group pgid. See POSIX.1 and the 
setsid(2) manual page on your POSIX system for more informations on 
process groups and job control. Returns TRUE on success, FALSE otherwise.   posix_setgidUpposix_setsid
#

#T=int posix_setpgid ( int pid, int pgid)
posix_setpgid ( ^!int pid, int pgid);
#

#T=posix_setsid - int posix_setsid ( void )
(PHP 3>= 3.0.13, PHP 4 )
posix_setsid -- Make the current process a session leader
Description
int posix_setsid ( void )
Make the current process a session leader. See POSIX.1 and the setsid(2) 
manual page on your POSIX system for more informations on process groups 
and job control. Returns the session id.   posix_setpgidUpposix_setuid
#

#T=int posix_setsid ( void )
posix_setsid ( ^!void );
#

#T=posix_setuid - bool posix_setuid ( int uid)
(PHP 3>= 3.0.13, PHP 4 )
posix_setuid --  Set the UID of the current process 
Description
bool posix_setuid ( int uid)
Set the real user ID of the current process. This is a privileged function 
and you need appropriate privileges (usually root) on your system to be 
able to perform this function. 
Returns TRUE on success, FALSE otherwise. See also posix_setgid().   posix_setsidUpposix_strerror
#

#T=bool posix_setuid ( int uid)
posix_setuid ( ^!int uid);
#

#T=posix_strerror - string posix_strerror ( int errno)
(PHP 4 >= 4.2.0)
posix_strerror --  Retrieve the system error message associated with the 
given errno. 
Description
string posix_strerror ( int errno)
Returns the POSIX system error message associated with the given errno. If 
errno is 0, then the string "Success" is returned. The function 
posix_get_last_error() is used for retrieving the last POSIX errno. 
See also posix_get_last_error().   posix_setuidUpposix_times
#

#T=string posix_strerror ( int errno)
posix_strerror ( ^!int errno);
#

#T=posix_times - array posix_times ( void )
(PHP 3>= 3.0.13, PHP 4 )
posix_times -- Get process times
Description
array posix_times ( void )
Returns a hash of strings with information about the current process CPU 
usage. The indices of the hash are 
ticks - the number of clock ticks that have elapsed since reboot. 
utime - user time used by the current process. 
stime - system time used by the current process. 
cutime - user time used by current process and children. 
cstime - system time used by current process and children.   posix_strerrorUpposix_ttyname
#

#T=array posix_times ( void )
posix_times ( ^!void );
#

#T=posix_ttyname - string posix_ttyname ( int fd)
(PHP 3>= 3.0.13, PHP 4 )
posix_ttyname -- Determine terminal device name
Description
string posix_ttyname ( int fd)
Warning
This function is currently not documented; only the argument list is 
available.
  posix_timesUpposix_uname
#

#T=string posix_ttyname ( int fd)
posix_ttyname ( ^!int fd);
#

#T=posix_uname - array posix_uname ( void )
(PHP 3>= 3.0.10, PHP 4 )
posix_uname -- Get system name
Description
array posix_uname ( void )
Returns a hash of strings with information about the system. The indices 
of the hash are 
sysname - operating system name (e.g. Linux) 
nodename - system name (e.g. valiant) 
release - operating system release (e.g. 2.2.10) 
version - operating system version (e.g. #4 Tue Jul 20 17:01:36 MEST 
1999) 
machine - system architecture (e.g. i586) 
domainname - DNS domainname (e.g. php.net) 
domainname is a GNU extension and not part of POSIX.1, so this field is 
only available on GNU systems or when using the GNU libc. 
Posix requires that you must not make any assumptions about the format of 
the values, e.g. you cannot rely on three digit version numbers or 
anything else returned by this function.   posix_ttynameUpPostgreSQL functions
#

#T=array posix_uname ( void )
posix_uname ( ^!void );
#

#T=pow - number pow ( number base, number exp)
(PHP 3, PHP 4 )
pow -- Exponential expression
Description
number pow ( number base, number exp)
Returns base raised to the power of exp. If possible, this function will 
return an integer. 
If the power cannot be computed, a warning will be issued, and pow() will 
return FALSE. 
Example 1. Some examples of pow()
  <?php

  var_dump(pow(2, 8)); // int(256)
  echo pow(-1, 20); // 1
  echo pow(0, 0); // 1

  echo pow(-1, 5.5); // error

  ?> 
Warning
In PHP 4.0.6 and earlier pow() always returned a float, and did not 
issue warnings. 

See also exp() and sqrt().   piUprad2deg
#

#T=number pow ( number base, number exp)
pow ( ^!number base, number exp);
#

#T=preg_grep - array preg_grep ( string pattern, array input)
(PHP 4 )
preg_grep --  Return array entries that match the pattern 
Description
array preg_grep ( string pattern, array input)
preg_grep() returns the array consisting of the elements of the input 
array that match the given pattern. 
Since PHP 4.0.4, the results returned by preg_grep() are indexed using the 
keys from the input array. If this behavior is undesirable, use 
array_values() on the array returned by preg_grep() to reindex the values. 

Example 1. preg_grep() example
  <?php
  // return all array elements
  // containing floating point numbers
  $fl_array = preg_grep("/^(\d+)?\.\d+$/", $array);
  ?> 

  Pattern SyntaxUppreg_match_all
#

#T=array preg_grep ( string pattern, array input)
preg_grep ( ^!string pattern, array input);
#

#T=preg_match_all - int preg_match_all ( string pattern, string subject, array matches [, int 
(PHP 3>= 3.0.9, PHP 4 )
preg_match_all -- Perform a global regular expression match
Description
int preg_match_all ( string pattern, string subject, array matches [, int 
flags])
Searches subject for all matches to the regular expression given in 
pattern and puts them in matches in the order specified by flags. 
After the first match is found, the subsequent searches are continued on 
from end of the last match. 
flags can be a combination of the following flags (note that it doesn't 
make sense to use PREG_PATTERN_ORDER together with PREG_SET_ORDER): 
PREG_PATTERN_ORDER
Orders results so that $matches[0] is an array of full pattern matches, 
$matches[1] is an array of strings matched by the first parenthesized 
subpattern, and so on. 
<?php
preg_match_all("|<[^>]+>(.*)</[^>]+>|U", 
  "<b>example: </b><div align=left>this is a test</div>", 
  $out, PREG_PATTERN_ORDER);
echo $out[0][0] . ", " . $out[0][1] . "\n";
echo $out[1][0] . ", " . $out[1][1] . "\n";
?> 

This example will produce: 
<b>example: </b>, <div align=left>this is a test</div>
example: , this is a test

So, $out[0] contains array of strings that matched full pattern, and 
$out[1] contains array of strings enclosed by tags. 
PREG_SET_ORDER
Orders results so that $matches[0] is an array of first set of matches, 
$matches[1] is an array of second set of matches, and so on. 
<?php
preg_match_all("|<[^>]+>(.*)</[^>]+>|U", 
  "<b>example: </b><div align=\"left\">this is a test</div>", 
  $out, PREG_SET_ORDER);
echo $out[0][0] . ", " . $out[0][1] . "\n";
echo $out[1][0] . ", " . $out[1][1] . "\n";
?> 

This example will produce: 
<b>example: </b>, example: 
<div align="left">this is a test</div>, this is a test

In this case, $matches[0] is the first set of matches, and 
$matches[0][0] has text matched by full pattern, $matches[0][1] has text 
matched by first subpattern and so on. Similarly, $matches[1] is the 
second set of matches, etc. 
PREG_OFFSET_CAPTURE
If this flag is set, for every occurring match the appendant string 
offset will also be returned. Note that this changes the return value in 
an array where every element is an array consisting of the matched 
string at offset 0 and it's string offset into subject at offset 1. This 
flag is available since PHP 4.3.0 . 
If no order flag is given, PREG_PATTERN_ORDER is assumed. 
Returns the number of full pattern matches (which might be zero), or FALSE 
if an error occurred. 
Example 1. Getting all phone numbers out of some text.
  <?php
  preg_match_all("/\(?  (\d{3})?  \)?  (?(1)  [\-\s] ) 
  \d{3}-\d{4}/x",
		  "Call 555-1212 or 1-800-555-1212", $phones);
  ?> 
Example 2. Find matching HTML tags (greedy)
  <?php
  // The \\2 is an example of backreferencing. This tells pcre 
  that
  // it must match the second set of parentheses in the regular 
  expression
  // itself, which would be the ([\w]+) in this case. The extra 
  backslash is 
  // required because the string is in double quotes.
  $html = "<b>bold text</b><a href=howdy.html>click me</a>";

  preg_match_all("/(<([\w]+)[^>]*>)(.*)(<\/\\2>)/", $html, 
  $matches);

  for ($i=0; $i< count($matches[0]); $i++) {
    echo "matched: " . $matches[0][$i] . "\n";
    echo "part 1: " . $matches[1][$i] . "\n";
    echo "part 2: " . $matches[3][$i] . "\n";
    echo "part 3: " . $matches[4][$i] . "\n\n";
  }
  ?> 

This example will produce: 
matched: <b>bold text</b>
part 1: <b>
part 2: bold text
part 3: </b>

matched: <a href=howdy.html>click me</a>
part 1: <a href=howdy.html>
part 2: click me
part 3: </a>
See also preg_match(), preg_replace(), and preg_split().   preg_grepUppreg_match
#

#T=int preg_match_all ( string pattern, string subject, array matches [, int 
preg_match_all ( ^!string pattern, string subject, array matches [, int ;
#

#T=preg_match - int preg_match ( string pattern, string subject [, array matches [, int 
(PHP 3>= 3.0.9, PHP 4 )
preg_match -- Perform a regular expression match
Description
int preg_match ( string pattern, string subject [, array matches [, int 
flags]])
Searches subject for a match to the regular expression given in pattern. 
If matches is provided, then it is filled with the results of search. 
$matches[0] will contain the text that matched the full pattern, 
$matches[1] will have the text that matched the first captured 
parenthesized subpattern, and so on. 
flags can be the following flag: 
PREG_OFFSET_CAPTURE
If this flag is set, for every occurring match the appendant string 
offset will also be returned. Note that this changes the return value in 
an array where every element is an array consisting of the matched 
string at offset 0 and it's string offset into subject at offset 1. This 
flag is available since PHP 4.3.0 . 
The flags parameter is available since PHP 4.3.0 . 
preg_match() returns the number of times pattern matches. That will be 
either 0 times (no match) or 1 time because preg_match() will stop 
searching after the first match. preg_match_all() on the contrary will 
continue until it reaches the end of subject. preg_match() returns FALSE 
if an error occurred. 
Tip: Do not use preg_match() if you only want to check if one string is 
contained in another string. Use strpos() or strstr() instead as they 
will be faster. 
Example 1. Find the string of text "php"
  <?php
  // The "i" after the pattern delimiter indicates a 
  case-insensitive search
  if (preg_match("/php/i", "PHP is the web scripting language of 
  choice.")) {
      echo "A match was found.";
  } else {
      echo "A match was not found.";
  }
  ?> 
Example 2. Find the word "web"
  <?php
  /* The \b in the pattern indicates a word boundary, so only 
  the distinct
  * word "web" is matched, and not a word partial like "webbing" 
  or "cobweb" */
  if (preg_match("/\bweb\b/i", "PHP is the web scripting 
  language of choice.")) {
      echo "A match was found.";
  } else {
      echo "A match was not found.";
  }

  if (preg_match("/\bweb\b/i", "PHP is the website scripting 
  language of choice.")) {
      echo "A match was found.";
  } else {
      echo "A match was not found.";
  }
  ?> 
Example 3. Getting the domain name out of a URL
  <?php
  // get host name from URL
  preg_match("/^(http:\/\/)?([^\/]+)/i",
      "http://www.php.net/index.html", $matches);
  $host = $matches[2];

  // get last two segments of host name
  preg_match("/[^\.\/]+\.[^\.\/]+$/", $host, $matches);
  echo "domain name is: {$matches[0]}\n";
  ?> 

This example will produce: 
domain name is: php.net
See also preg_match_all(), preg_replace(), and preg_split().   preg_match_allUppreg_quote
#

#T=int preg_match ( string pattern, string subject [, array matches [, int 
preg_match ( ^!string pattern, string subject [, array matches [, int ;
#

#T=preg_quote - string preg_quote ( string str [, string delimiter])
(PHP 3>= 3.0.9, PHP 4 )
preg_quote -- Quote regular expression characters
Description
string preg_quote ( string str [, string delimiter])
preg_quote() takes str and puts a backslash in front of every character 
that is part of the regular expression syntax. This is useful if you have 
a run-time string that you need to match in some text and the string may 
contain special regex characters. 
If the optional delimiter is specified, it will also be escaped. This is 
useful for escaping the delimiter that is required by the PCRE functions. 
The / is the most commonly used delimiter.
The special regular expression characters are: . \\ + * ? [ ^ ] $ ( ) { } 
= ! < > | : 
Example 1. preg_quote() example
  <?php
  $keywords = "$40 for a g3/400";
  $keywords = preg_quote($keywords, "/");
  echo $keywords; // returns \$40 for a g3\/400
  ?> 
Example 2. Italicizing a word within some text
  <?php
  // In this example, preg_quote($word) is used to keep the
  // asterisks from having special meaning to the regular
  // expression.

  $textbody = "This book is *very* difficult to find.";
  $word = "*very*";
  $textbody = preg_replace ("/" . preg_quote($word) . "/",
			    "<i>" . $word . "</i>",
			    $textbody);
  ?> 

  preg_matchUppreg_replace_callback
#

#T=string preg_quote ( string str [, string delimiter])
preg_quote ( ^!string str [, string delimiter]);
#

#T=preg_replace_callback - mixed preg_replace_callback ( mixed pattern, callback callback, mixed 
(PHP 4 >= 4.0.5)
preg_replace_callback -- Perform a regular expression search and replace 
using a callback
Description
mixed preg_replace_callback ( mixed pattern, callback callback, mixed 
subject [, int limit])
The behavior of this function is almost identical to preg_replace(), 
except for the fact that instead of replacement parameter, one should 
specify a callback that will be called and passed an array of matched 
elements in the subject string. The callback should return the replacement 
string. 
Example 1. preg_replace_callback() example
  <?php
    // this text was used in 2002
    // we want to get this up to date for 2003
    $text = "April fools day is 04/01/2002\n";
    $text.= "Last christmas was 12/24/2001\n";

    // the callback function
    function next_year($matches) {
      // as usual: $matches[0] is the complete match
      // $matches[1] the match for the first subpattern
      // enclosed in '(...)' and so on
      return $matches[1].($matches[2]+1);
    }

    echo preg_replace_callback(
		"|(\d{2}/\d{2}/)(\d{4})|",
		"next_year",
		$text);

    // result is:
    // April fools day is 04/01/2003
    // Last christmas was 12/24/2002
  ?> 
You'll often need the callback function for a preg_replace_callback() in 
just one place. In this case you can use create_function() to declare an 
anonymous function as callback within the call to preg_replace_callback(). 
By doing it this way you have all information for the call in one place 
and do not clutter the function namespace with a callback functions name 
not used anywhere else. 
Example 2. preg_replace_callback() and create_function()
  <?php
    /* a unix-style command line filter to convert uppercase
     * letters at the beginning of paragraphs to lowercase */

    $fp = fopen("php://stdin", "r") or die("can't read stdin");
    while (!feof($fp)) {
	$line = fgets($fp);
	$line = preg_replace_callback(
	    '|<p>\s*\w|',
	    create_function(
		// single quotes are essential here,
		// or alternative escape all $ as \$
		'$matches',
		'return strtolower($matches[0]);'
	    ),
	    $line
	);
	echo $line;
    }
    fclose($fp);
  ?> 
See also preg_replace() and create_function().   preg_quoteUppreg_replace
#

#T=mixed preg_replace_callback ( mixed pattern, callback callback, mixed 
preg_replace_callback ( ^!mixed pattern, callback callback, mixed ;
#

#T=preg_replace - mixed preg_replace ( mixed pattern, mixed replacement, mixed subject [, 
(PHP 3>= 3.0.9, PHP 4 )
preg_replace -- Perform a regular expression search and replace
Description
mixed preg_replace ( mixed pattern, mixed replacement, mixed subject [, 
int limit])
Searches subject for matches to pattern and replaces them with 
replacement. If limit is specified, then only limit matches will be 
replaced; if limit is omitted or is -1, then all matches are replaced. 
Replacement may contain references of the form \\n or (since PHP 4.0.4) 
$n, with the latter form being the preferred one. Every such reference 
will be replaced by the text captured by the n'th parenthesized pattern. n 
can be from 0 to 99, and \\0 or $0 refers to the text matched by the whole 
pattern. Opening parentheses are counted from left to right (starting from 
1) to obtain the number of the capturing subpattern. 
When working with a replacement pattern where a backreference is 
immediately followed by another number (i.e.: placing a literal number 
immediately after a matched pattern), you cannot use the familiar \\1 
notation for your backreference. \\11, for example, would confuse 
preg_replace() since it does not know whether you want the \\1 
backreference followed by a literal 1, or the \\11 backreference followed 
by nothing. In this case the solution is to use \${1}1. This creates an 
isolated $1 backreference, leaving the 1 as a literal. 
Example 1. Using backreferences followed by numeric literals
  <?php
  $string = "April 15, 2003";
  $pattern = "/(\w+) (\d+), (\d+)/i";
  $replacement = "\${1}1,\$3";
  echo preg_replace($pattern, $replacement, $string);
  ?> 

This example will output : 
April1,2003
If matches are found, the new subject will be returned, otherwise subject 
will be returned unchanged. 
Every parameter to preg_replace() (except limit) can be an unidimensional 
array. When using arrays with pattern and replacement, the keys are 
processed in the order they appear in the array. This is not necessarily 
the same as the numerical index order. If you use indexes to identify 
which pattern should be replaced by which replacement, you should perform 
a ksort() on each array prior to calling preg_replace(). 
Example 2. Using indexed arrays with preg_replace()
  <?php
  $string = "The quick brown fox jumped over the lazy dog.";

  $patterns[0] = "/quick/";
  $patterns[1] = "/brown/";
  $patterns[2] = "/fox/";

  $replacements[2] = "bear";
  $replacements[1] = "black";
  $replacements[0] = "slow";

  echo preg_replace($patterns, $replacements, $string);
  ?> 

Output: 
The bear black slow jumped over the lazy dog.

By ksorting patterns and replacements, we should get what we wanted. 

  <?php

  ksort($patterns);
  ksort($replacements);

  echo preg_replace($patterns, $replacements, $string);

  ?> 

Output : 
The slow black bear jumped over the lazy dog.
If subject is an array, then the search and replace is performed on every 
entry of subject, and the return value is an array as well. 
If pattern and replacement are arrays, then preg_replace() takes a value 
from each array and uses them to do search and replace on subject. If 
replacement has fewer values than pattern, then empty string is used for 
the rest of replacement values. If pattern is an array and replacement is 
a string, then this replacement string is used for every value of pattern. 
The converse would not make sense, though. 
/e modifier makes preg_replace() treat the replacement parameter as PHP 
code after the appropriate references substitution is done. Tip: make sure 
that replacement constitutes a valid PHP code string, otherwise PHP will 
complain about a parse error at the line containing preg_replace(). 
Example 3. Replacing several values
  <?php
  $patterns = array ("/(19|20)(\d{2})-(\d{1,2})-(\d{1,2})/",
		     "/^\s*{(\w+)}\s*=/");
  $replace = array ("\\3/\\4/\\1\\2", "$\\1 =");
  echo preg_replace($patterns, $replace, "{startDate} = 
  1999-5-27");
  ?> 

This example will produce: 
$startDate = 5/27/1999
Example 4. Using /e modifier
  <?php
  preg_replace("/(<\/?)(\w+)([^>]*>)/e", 
		"'\\1'.strtoupper('\\2').'\\3'", 
		$html_body);
  ?> 

This would capitalize all HTML tags in the input text. 

Example 5. Convert HTML to text
  <?php
  // $document should contain an HTML document.
  // This will remove HTML tags, javascript sections
  // and white space. It will also convert some
  // common HTML entities to their text equivalent.

  $search = array ("'<script[^>]*?>.*?</script>'si",  // Strip 
  out javascript
		   "'<[\/\!]*?[^<>]*?>'si",           // Strip 
  out HTML tags
		   "'([\r\n])[\s]+'",                 // Strip 
  out white space
		   "'&(quot|#34);'i",                 // Replace 
  HTML entities
		   "'&(amp|#38);'i",
		   "'&(lt|#60);'i",
		   "'&(gt|#62);'i",
		   "'&(nbsp|#160);'i",
		   "'&(iexcl|#161);'i",
		   "'&(cent|#162);'i",
		   "'&(pound|#163);'i",
		   "'&(copy|#169);'i",
		   "'&#(\d+);'e");                    // 
  evaluate as php

  $replace = array ("",
		    "",
		    "\\1",
		    "\"",
		    "&",
		    "<",
		    ">",
		    " ",
		    chr(161),
		    chr(162),
		    chr(163),
		    chr(169),
		    "chr(\\1)");

  $text = preg_replace($search, $replace, $document);
  ?> 
Note: Parameter limit was added after PHP 4.0.1pl2. 
See also preg_match(), preg_match_all(), and preg_split().   preg_replace_callbackUppreg_split
#

#T=mixed preg_replace ( mixed pattern, mixed replacement, mixed subject [, 
preg_replace ( ^!mixed pattern, mixed replacement, mixed subject [, ;
#

#T=preg_split - array preg_split ( string pattern, string subject [, int limit [, int 
(PHP 3>= 3.0.9, PHP 4 )
preg_split -- Split string by a regular expression
Description
array preg_split ( string pattern, string subject [, int limit [, int 
flags]])
Returns an array containing substrings of subject split along boundaries 
matched by pattern. 
If limit is specified, then only substrings up to limit are returned, and 
if limit is -1, it actually means "no limit", which is useful for 
specifying the flags. 
flags can be any combination of the following flags (combined with bitwise 
| operator): 
PREG_SPLIT_NO_EMPTY
If this flag is set, only non-empty pieces will be returned by 
preg_split(). 
PREG_SPLIT_DELIM_CAPTURE
If this flag is set, parenthesized expression in the delimiter pattern 
will be captured and returned as well. This flag was added for 4.0.5. 
PREG_SPLIT_OFFSET_CAPTURE
If this flag is set, for every occurring match the appendant string 
offset will also be returned. Note that this changes the return value in 
an array where every element is an array consisting of the matched 
string at offset 0 and it's string offset into subject at offset 1. This 
flag is available since PHP 4.3.0 . 
Example 1. preg_split() example : Get the parts of a search string
  <?php
  // split the phrase by any number of commas or space 
  characters,
  // which include " ", \r, \t, \n and \f
  $keywords = preg_split("/[\s,]+/", "hypertext language, 
  programming");
  ?> 
Example 2. Splitting a string into component characters
  <?php
  $str = 'string';
  $chars = preg_split('//', $str, -1, PREG_SPLIT_NO_EMPTY);
  print_r($chars);
  ?> 
Example 3. Splitting a string into matches and their offsets
  <?php
  $str = 'hypertext language programming';
  $chars = preg_split('/ /', $str, -1, 
  PREG_SPLIT_OFFSET_CAPTURE);
  print_r($chars);
  ?> 

will yield: 
Array
(
[0] => Array
(
[0] => hypertext
[1] => 0
)

[1] => Array
(
[0] => language
[1] => 10
)

[2] => Array
(
[0] => programming
[1] => 19
)

)
Note: Parameter flags was added in PHP 4 Beta 3. 
See also spliti(), split(), implode(), preg_match(), preg_match_all(), and 
preg_replace().   preg_replaceUpqtdom functions
#

#T=array preg_split ( string pattern, string subject [, int limit [, int 
preg_split ( ^!string pattern, string subject [, int limit [, int ;
#

#T=prev - mixed prev ( array array)
(PHP 3, PHP 4 )
prev -- Rewind the internal array pointer
Description
mixed prev ( array array)
Returns the array value in the previous place that's pointed to by the 
internal array pointer, or FALSE if there are no more elements. 
Warning
If the array contains empty elements then this function will return 
FALSE for these elements as well. To properly traverse an array 
which may contain empty elements see the each() function. 

prev() behaves just like next(), except it rewinds the internal array 
pointer one place instead of advancing it. 
Example 1. Example use of prev() and friends
  <?php
  $transport = array('foot', 'bike', 'car', 'plane');
  $mode = current($transport); // $mode = 'foot';
  $mode = next($transport);    // $mode = 'bike';
  $mode = next($transport);    // $mode = 'car';
  $mode = prev($transport);    // $mode = 'bike';
  $mode = end($transport);     // $mode = 'plane';
  ?> 
See also current(), end(), next(), and reset().   posUprange
#

#T=mixed prev ( array array)
prev ( ^!array array);
#

#T=print_r - bool print_r ( mixed expression [, bool return])
(PHP 4 )
print_r --  Prints human-readable information about a variable 
Description
bool print_r ( mixed expression [, bool return])
Note: The return parameter was added in PHP 4.3.0 
print_r() displays information about a variable in a way that's readable 
by humans. If given a string, integer or float, the value itself will be 
printed. If given an array, values will be presented in a format that 
shows keys and elements. Similar notation is used for objects. print_r() 
and var_export() will also show protected and private properties of 
objects with PHP 5, on the contrary to var_dump(). 
Remember that print_r() will move the array pointer to the end. Use 
reset() to bring it back to beginning. 
<pre>
<?php
$a = array ('a' => 'apple', 'b' => 'banana', 'c' => array ('x', 
'y', 'z'));
print_r ($a);
?>
</pre> 

Which will output: 
<pre>
Array
(
[a] => apple
[b] => banana
[c] => Array
(
[0] => x
[1] => y
[2] => z
)
)
</pre>

If you would like to capture the output of print_r(), use the return 
parameter. If this parameter is set to TRUE, print_r() will return its 
output, instead of printing it (which it does by default). 
Example 1. return parameter example
  <?php
      $b = array ('m' => 'monkey', 'foo' => 'bar', 'x' => array 
  ('x', 'y', 'z'));
      $results = print_r($b, true); //$results now contains 
  output from print_r
  ?> 
Note: If you need to capture the output of print_r() with a version of 
PHP prior to 4.3.0, use the output-control functions. 
Note: Prior to PHP 4.0.4, print_r() will continue forever if given an 
array or object that contains a direct or indirect reference to itself. 
An example is print_r($GLOBALS) because $GLOBALS is itself a global 
variable that contains a reference to itself. 
See also ob_start(), var_dump() and var_export().   issetUpserialize
#

#T=bool print_r ( mixed expression [, bool return])
print_r ( ^!mixed expression [, bool return]);
#

#T=print - int print ( string arg)
(PHP 3, PHP 4 )
print -- Output a string
Description
int print ( string arg)
Outputs arg. Returns 1, always. 
print() is not actually a real function (it is a language construct) so 
you are not required to use parentheses with its argument list. 
Example 1. print() examples
  <?php
  print("Hello World");

  print "print() also works without parentheses.";

  print "This spans
  multiple lines. The newlines will be 
  output as well";

  print "This spans\nmultiple lines. The newlines will 
  be\noutput as well.";

  print "escaping characters is done \"Like this\".";

  // You can use variables inside of a print statement
  $foo = "foobar";
  $bar = "barbaz";

  print "foo is $foo"; // foo is foobar

  // You can also use arrays
  $bar = array("value" => "foo");

  print "this is {$bar['value']} !"; // this is foo !

  // Using single quotes will print the variable name, not the 
  value
  print 'foo is $foo'; // foo is $foo

  // If you are not using any other characters, you can just 
  print variables
  print $foo;          // foobar

  print <<<END
  This uses the "here document" syntax to output
  multiple lines with $variable interpolation. Note
  that the here document terminator must appear on a
  line with just a semicolon no extra whitespace!
  END;
  ?> 
For a short discussion about the differences between print() and echo(), 
see this FAQTs Knowledge Base Article: 
http://www.faqts.com/knowledge_base/view.phtml/aid/1/fid/40 
Note: Because this is a language construct and not a function, it cannot 
be called using variable functions
See also echo(), printf(), and flush().   parse_strUpprintf
printer_abort
(no version information, might be only in CVS)
printer_abort -- Deletes the printer's spool file
Description
void printer_abort ( resource handle)
This function deletes the printers spool file. 
handle must be a valid handle to a printer. 
Example 1. printer_abort() example
  <?php
  $handle = printer_open();
  printer_abort($handle);
  printer_close($handle);
  ?> 

  Printer functionsUpprinter_close
printer_close
(no version information, might be only in CVS)
printer_close -- Close an open printer connection
Description
void printer_close ( resource handle)
This function closes the printer connection. printer_close() also closes 
the active device context. 
handle must be a valid handle to a printer. 
Example 1. printer_close() example
  <?php
  $handle = printer_open();
  printer_close($handle);
  ?> 

  printer_abortUpprinter_create_brush
printer_create_brush
(no version information, might be only in CVS)
printer_create_brush -- Create a new brush
Description
mixed printer_create_brush ( int style, string color)
The function creates a new brush and returns a handle to it. A brush is 
used to fill shapes. For an example see printer_select_brush(). color must 
be a color in RGB hex format, i.e. "000000" for black, style must be one 
of the following constants: 
PRINTER_BRUSH_SOLID: creates a brush with a solid color. 
PRINTER_BRUSH_DIAGONAL: creates a brush with a 45-degree upward 
left-to-right hatch ( / ). 
PRINTER_BRUSH_CROSS: creates a brush with a cross hatch ( + ). 
PRINTER_BRUSH_DIAGCROSS: creates a brush with a 45 cross hatch ( x ). 
PRINTER_BRUSH_FDIAGONAL: creates a brush with a 45-degree downward 
left-to-right hatch ( \ ). 
PRINTER_BRUSH_HORIZONTAL: creates a brush with a horizontal hatch ( - ). 

PRINTER_BRUSH_VERTICAL: creates a brush with a vertical hatch ( | ). 
PRINTER_BRUSH_CUSTOM: creates a custom brush from an BMP file. The 
second parameter is used to specify the BMP instead of the RGB color 
code.   printer_closeUpprinter_create_dc
printer_create_dc
(no version information, might be only in CVS)
printer_create_dc -- Create a new device context
Description
void printer_create_dc ( resource handle)
The function creates a new device context. A device context is used to 
customize the graphic objects of the document. handle must be a valid 
handle to a printer. 
Example 1. printer_create_dc() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle);
  printer_start_page($handle);

  printer_create_dc($handle);
  /* do some stuff with the dc */
  printer_set_option($handle, PRINTER_TEXT_COLOR, "333333");
  printer_draw_text($handle, 1, 1, "text");
  printer_delete_dc($handle);

  /* create another dc */
  printer_create_dc($handle);
  printer_set_option($handle, PRINTER_TEXT_COLOR, "000000");
  printer_draw_text($handle, 1, 1, "text");
  /* do some stuff with the dc */

  printer_delete_dc($handle);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_create_brushUpprinter_create_font
printer_create_font
(no version information, might be only in CVS)
printer_create_font -- Create a new font
Description
mixed printer_create_font ( string face, int height, int width, int 
font_weight, bool italic, bool underline, bool strikeout, int orientaton)
The function creates a new font and returns a handle to it. A font is used 
to draw text. For an example see printer_select_font(). face must be a 
string specifying the font face. height specifies the font height, and 
width the font width. The font_weight specifies the font weight (400 is 
normal), and can be one of the following predefined constants. 
PRINTER_FW_THIN: sets the font weight to thin (100). 
PRINTER_FW_ULTRALIGHT: sets the font weight to ultra light (200). 
PRINTER_FW_LIGHT: sets the font weight to light (300). 
PRINTER_FW_NORMAL: sets the font weight to normal (400). 
PRINTER_FW_MEDIUM: sets the font weight to medium (500). 
PRINTER_FW_BOLD: sets the font weight to bold (700). 
PRINTER_FW_ULTRABOLD: sets the font weight to ultra bold (800). 
PRINTER_FW_HEAVY: sets the font weight to heavy (900). 
italic can be TRUE or FALSE, and sets whether the font should be italic. 
underline can be TRUE or FALSE, and sets whether the font should be 
underlined. 
strikeout can be TRUE or FALSE, and sets whether the font should be 
stroked out. 
orientation specifies a rotation. For an example see 
printer_select_font().   printer_create_dcUpprinter_create_pen
printer_create_pen
(no version information, might be only in CVS)
printer_create_pen -- Create a new pen
Description
mixed printer_create_pen ( int style, int width, string color)
The function creates a new pen and returns a handle to it. A pen is used 
to draw lines and curves. For an example see printer_select_pen(). color 
must be a color in RGB hex format, i.e. "000000" for black, width 
specifies the width of the pen whereas style must be one of the following 
constants: 
PRINTER_PEN_SOLID: creates a solid pen. 
PRINTER_PEN_DASH: creates a dashed pen. 
PRINTER_PEN_DOT: creates a dotted pen. 
PRINTER_PEN_DASHDOT: creates a pen with dashes and dots. 
PRINTER_PEN_DASHDOTDOT: creates a pen with dashes and double dots. 
PRINTER_PEN_INVISIBLE: creates an invisible pen.   printer_create_fontUpprinter_delete_brush
printer_delete_brush
(no version information, might be only in CVS)
printer_delete_brush -- Delete a brush
Description
bool printer_delete_brush ( resource handle)
The function deletes the selected brush. For an example see 
printer_select_brush(). Returns TRUE on success or FALSE on failure. 
handle must be a valid handle to a brush.   printer_create_penUpprinter_delete_dc
printer_delete_dc
(no version information, might be only in CVS)
printer_delete_dc -- Delete a device context
Description
bool printer_delete_dc ( resource handle)
The function deletes the device context. Returns TRUE on success or FALSE 
on failure. For an example see printer_create_dc(). handle must be a valid 
handle to a printer.   printer_delete_brushUpprinter_delete_font
printer_delete_font
(no version information, might be only in CVS)
printer_delete_font -- Delete a font
Description
bool printer_delete_font ( resource handle)
The function deletes the selected font. For an example see 
printer_select_font(). Returns TRUE on success or FALSE on failure. handle 
must be a valid handle to a font.   printer_delete_dcUpprinter_delete_pen
printer_delete_pen
(no version information, might be only in CVS)
printer_delete_pen -- Delete a pen
Description
bool printer_delete_pen ( resource handle)
The function deletes the selected pen. For an example see 
printer_select_pen(). Returns TRUE on success or FALSE on failure. handle 
must be a valid handle to a pen.   printer_delete_fontUpprinter_draw_bmp
printer_draw_bmp
(no version information, might be only in CVS)
printer_draw_bmp -- Draw a bmp
Description
void printer_draw_bmp ( resource handle, string filename, int x, int y)
The function simply draws an bmp the bitmap filename at position x, y. 
handle must be a valid handle to a printer. 
Returns TRUE on success or FALSE on failure. 
Example 1. printer_draw_bmp() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  printer_draw_bmp($handle, "c:\\image.bmp", 1, 1);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_delete_penUpprinter_draw_chord
printer_draw_chord
(no version information, might be only in CVS)
printer_draw_chord -- Draw a chord
Description
void printer_draw_chord ( resource handle, int rec_x, int rec_y, int 
rec_x1, int rec_y1, int rad_x, int rad_y, int rad_x1, int rad_y1)
The function simply draws an chord. handle must be a valid handle to a 
printer. 
rec_x is the upper left x coordinate of the bounding rectangle. 
rec_y is the upper left y coordinate of the bounding rectangle. 
rec_x1 is the lower right x coordinate of the bounding rectangle. 
rec_y1 is the lower right y coordinate of the bounding rectangle. 
rad_x is x coordinate of the radial defining the beginning of the chord. 
rad_y is y coordinate of the radial defining the beginning of the chord. 
rad_x1 is x coordinate of the radial defining the end of the chord. 
rad_y1 is y coordinate of the radial defining the end of the chord. 
Example 1. printer_draw_chord() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 2, "000000");
  printer_select_pen($handle, $pen);

  $brush = printer_create_brush(PRINTER_BRUSH_SOLID, "2222FF");
  printer_select_brush($handle, $brush);

  printer_draw_chord($handle, 1, 1, 500, 500, 1, 1, 500, 1);

  printer_delete_brush($brush);
  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);   
  ?> 

  printer_draw_bmpUpprinter_draw_elipse
printer_draw_elipse
(no version information, might be only in CVS)
printer_draw_elipse -- Draw an ellipse
Description
void printer_draw_elipse ( resource handle, int ul_x, int ul_y, int lr_x, 
int lr_y)
The function simply draws an ellipse. handle must be a valid handle to a 
printer. 
ul_x is the upper left x coordinate of the ellipse. 
ul_y is the upper left y coordinate of the ellipse. 
lr_x is the lower right x coordinate of the ellipse. 
lr_y is the lower right y coordinate of the ellipse. 
Example 1. printer_draw_elipse() example 
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 2, "000000");
  printer_select_pen($handle, $pen);

  $brush = printer_create_brush(PRINTER_BRUSH_SOLID, "2222FF");
  printer_select_brush($handle, $brush);

  printer_draw_elipse($handle, 1, 1, 500, 500);

  printer_delete_brush($brush);
  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);     
  ?> 

  printer_draw_chordUpprinter_draw_line
printer_draw_line
(no version information, might be only in CVS)
printer_draw_line -- Draw a line
Description
void printer_draw_line ( resource printer_handle, int from_x, int from_y, 
int to_x, int to_y)
The function simply draws a line from position from_x, from_y to position 
to_x, to_y using the selected pen. printer_handle must be a valid handle 
to a printer. 
Example 1. printer_draw_line() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 30, "000000");
  printer_select_pen($handle, $pen);

  printer_draw_line($handle, 1, 10, 1000, 10);
  printer_draw_line($handle, 1, 60, 500, 60);

  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_draw_elipseUpprinter_draw_pie
printer_draw_pie
(no version information, might be only in CVS)
printer_draw_pie -- Draw a pie
Description
void printer_draw_pie ( resource handle, int rec_x, int rec_y, int rec_x1, 
int rec_y1, int rad1_x, int rad1_y, int rad2_x, int rad2_y)
The function simply draws an pie. handle must be a valid handle to a 
printer. 
rec_x is the upper left x coordinate of the bounding rectangle. 
rec_y is the upper left y coordinate of the bounding rectangle. 
rec_x1 is the lower right x coordinate of the bounding rectangle. 
rec_y1 is the lower right y coordinate of the bounding rectangle. 
rad1_x is x coordinate of the first radial's ending. 
rad1_y is y coordinate of the first radial's ending. 
rad2_x is x coordinate of the second radial's ending. 
rad2_y is y coordinate of the second radial's ending. 
Example 1. printer_draw_pie() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 2, "000000");
  printer_select_pen($handle, $pen);

  $brush = printer_create_brush(PRINTER_BRUSH_SOLID, "2222FF");
  printer_select_brush($handle, $brush);

  printer_draw_pie($handle, 1, 1, 500, 500, 1, 1, 500, 1);

  printer_delete_brush($brush);
  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle); 
  ?> 

  printer_draw_lineUpprinter_draw_rectangle
printer_draw_rectangle
(no version information, might be only in CVS)
printer_draw_rectangle -- Draw a rectangle
Description
void printer_draw_rectangle ( resource handle, int ul_x, int ul_y, int 
lr_x, int lr_y)
The function simply draws a rectangle. 
handle must be a valid handle to a printer. 
ul_x is the upper left x coordinate of the rectangle. 
ul_y is the upper left y coordinate of the rectangle. 
lr_x is the lower right x coordinate of the rectangle. 
lr_y is the lower right y coordinate of the rectangle. 
Example 1. printer_draw_rectangle() example 
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 2, "000000");
  printer_select_pen($handle, $pen);

  $brush = printer_create_brush(PRINTER_BRUSH_SOLID, "2222FF");
  printer_select_brush($handle, $brush);

  printer_draw_rectangle($handle, 1, 1, 500, 500);

  printer_delete_brush($brush);
  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_draw_pieUpprinter_draw_roundrect
printer_draw_roundrect
(no version information, might be only in CVS)
printer_draw_roundrect -- Draw a rectangle with rounded corners
Description
void printer_draw_roundrect ( resource handle, int ul_x, int ul_y, int 
lr_x, int lr_y, int width, int height)
The function simply draws a rectangle with rounded corners. 
handle must be a valid handle to a printer. 
ul_x is the upper left x coordinate of the rectangle. 
ul_y is the upper left y coordinate of the rectangle. 
lr_x is the lower right x coordinate of the rectangle. 
lr_y is the lower right y coordinate of the rectangle. 
width is the width of the ellipse. 
height is the height of the ellipse. 
Example 1. printer_draw_roundrect() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 2, "000000");
  printer_select_pen($handle, $pen);

  $brush = printer_create_brush(PRINTER_BRUSH_SOLID, "2222FF");
  printer_select_brush($handle, $brush);

  printer_draw_roundrect($handle, 1, 1, 500, 500, 200, 200);

  printer_delete_brush($brush);
  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_draw_rectangleUpprinter_draw_text
printer_draw_text
(no version information, might be only in CVS)
printer_draw_text -- Draw text
Description
void printer_draw_text ( resource printer_handle, string text, int x, int 
y)
The function simply draws text at position x, y using the selected font. 
printer_handle must be a valid handle to a printer. 
Example 1. printer_draw_text() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $font = printer_create_font("Arial", 72, 48, 400, false, 
  false, false, 0);
  printer_select_font($handle, $font);
  printer_draw_text($handle, "test", 10, 10);
  printer_delete_font($font);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_draw_roundrectUpprinter_end_doc
printer_end_doc
(no version information, might be only in CVS)
printer_end_doc -- Close document
Description
bool printer_end_doc ( resource handle)
Closes a new document in the printer spooler. The document is now ready 
for printing. For an example see printer_start_doc(). handle must be a 
valid handle to a printer.   printer_draw_textUpprinter_end_page
printer_end_page
(no version information, might be only in CVS)
printer_end_page -- Close active page
Description
bool printer_end_page ( resource handle)
The function closes the active page in the active document. For an example 
see printer_start_doc(). handle must be a valid handle to a printer.   printer_end_docUpprinter_get_option
printer_get_option
(no version information, might be only in CVS)
printer_get_option -- Retrieve printer configuration data
Description
mixed printer_get_option ( resource handle, string option)
The function retrieves the configuration setting of option. handle must be 
a valid handle to a printer. Take a look at printer_set_option() for the 
settings that can be retrieved, additionally the following settings can be 
retrieved: 
PRINTER_DEVICENAME returns the devicename of the printer. 
PRINTER_DRIVERVERSION returns the printer driver version. 
Example 1. printer_get_option() example
  <?php
  $handle = printer_open();
  echo printer_get_option($handle, PRINTER_DRIVERVERSION);
  printer_close($handle);
  ?> 

  printer_end_pageUpprinter_list
printer_list
(no version information, might be only in CVS)
printer_list -- Return an array of printers attached to the server 
Description
array printer_list ( int enumtype [, string name [, int level]])
The function enumerates available printers and their capabilities. level 
sets the level of information request. Can be 1,2,4 or 5. enumtype must be 
one of the following predefined constants: 
PRINTER_ENUM_LOCAL: enumerates the locally installed printers. 
PRINTER_ENUM_NAME: enumerates the printer of name, can be a server, 
domain or print provider. 
PRINTER_ENUM_SHARED: this parameter can't be used alone, it has to be 
OR'ed with other parameters, i.e. PRINTER_ENUM_LOCAL to detect the 
locally shared printers. 
PRINTER_ENUM_DEFAULT: (Win9.x only) enumerates the default printer. 
PRINTER_ENUM_CONNECTIONS: (WinNT/2000 only) enumerates the printers to 
which the user has made connections. 
PRINTER_ENUM_NETWORK: (WinNT/2000 only) enumerates network printers in 
the computer's domain. Only valid if level is 1. 
PRINTER_ENUM_REMOTE: (WinNT/2000 only) enumerates network printers and 
print servers in the computer's domain. Only valid if level is 1. 
Example 1. printer_list() example
  <?php
  /* detect locally shared printer */
  var_dump(printer_list(PRINTER_ENUM_LOCAL | 
  PRINTER_ENUM_SHARED));
  ?> 

  printer_get_optionUpprinter_logical_fontheight
printer_logical_fontheight
(no version information, might be only in CVS)
printer_logical_fontheight -- Get logical font height
Description
int printer_logical_fontheight ( resource handle, int height)
The function calculates the logical font height of height. handle must be 
a valid handle to a printer. 
Example 1. printer_logical_fontheight() example 
  <?php
  $handle = printer_open();
  echo printer_logical_fontheight($handle, 72);
  printer_close($handle);
  ?> 

  printer_listUpprinter_open
printer_open
(no version information, might be only in CVS)
printer_open -- Open connection to a printer
Description
mixed printer_open ( [string devicename])
This function tries to open a connection to the printer devicename, and 
returns a handle on success or FALSE on failure. 
If no parameter was given it tries to open a connection to the default 
printer (if not specified in php.ini as printer.default_printer, PHP tries 
to detect it). 
printer_open() also starts a device context. 
Example 1. printer_open() example
  <?php
  $handle = printer_open("HP Deskjet 930c");
  $handle = printer_open();
  ?> 

  printer_logical_fontheightUpprinter_select_brush
printer_select_brush
(no version information, might be only in CVS)
printer_select_brush -- Select a brush
Description
void printer_select_brush ( resource printer_handle, resource 
brush_handle)
The function selects a brush as the active drawing object of the actual 
device context. A brush is used to fill shapes. If you draw an rectangle 
the brush is used to draw the shapes, while the pen is used to draw the 
border. If you haven't selected a brush before drawing shapes, the shape 
won't be filled. printer_handle must be a valid handle to a printer. 
brush_handle must be a valid handle to a brush. 
Example 1. printer_select_brush() example 
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 2, "000000");
  printer_select_pen($handle, $pen);
  $brush = printer_create_brush(PRINTER_BRUSH_CUSTOM, 
  "c:\\brush.bmp");
  printer_select_brush($handle, $brush);

  printer_draw_rectangle($handle, 1, 1, 500, 500);

  printer_delete_brush($brush);

  $brush = printer_create_brush(PRINTER_BRUSH_SOLID, "000000");
  printer_select_brush($handle, $brush);
  printer_draw_rectangle($handle, 1, 501, 500, 1001);
  printer_delete_brush($brush);

  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_openUpprinter_select_font
printer_select_font
(no version information, might be only in CVS)
printer_select_font -- Select a font
Description
void printer_select_font ( resource printer_handle, resource font_handle)
The function selects a font to draw text. printer_handle must be a valid 
handle to a printer. font_handle must be a valid handle to a font. 
Example 1. printer_select_font() example 
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $font = printer_create_font("Arial", 148, 76, 
  PRINTER_FW_MEDIUM, false, false, false, -50);
  printer_select_font($handle, $font);
  printer_draw_text($handle, "PHP is simply cool", 40, 40);
  printer_delete_font($font);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_select_brushUpprinter_select_pen
printer_select_pen
(no version information, might be only in CVS)
printer_select_pen -- Select a pen
Description
void printer_select_pen ( resource printer_handle, resource pen_handle)
The function selects a pen as the active drawing object of the actual 
device context. A pen is used to draw lines and curves. I.e. if you draw a 
single line the pen is used. If you draw an rectangle the pen is used to 
draw the borders, while the brush is used to fill the shape. If you 
haven't selected a pen before drawing shapes, the shape won't be outlined. 
printer_handle must be a valid handle to a printer. pen_handle must be a 
valid handle to a pen. 
Example 1. printer_select_pen() example 
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  $pen = printer_create_pen(PRINTER_PEN_SOLID, 30, "2222FF");
  printer_select_pen($handle, $pen);

  printer_draw_line($handle, 1, 60, 500, 60);

  printer_delete_pen($pen);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_select_fontUpprinter_set_option
printer_set_option
(no version information, might be only in CVS)
printer_set_option -- Configure the printer connection
Description
bool printer_set_option ( resource handle, int option, mixed value)
The function sets the following options for the current connection. handle 
must be a valid handle to a printer. For option can be one of the 
following constants: 
PRINTER_COPIES: sets how many copies should be printed, value must be an 
integer. 
PRINTER_MODE: specifies the type of data (text, raw or emf), value must 
be a string. 
PRINTER_TITLE: specifies the name of the document, value must be a 
string. 
PRINTER_ORIENTATION: specifies the orientation of the paper, value can 
be either PRINTER_ORIENTATION_PORTRAIT or PRINTER_ORIENTATION_LANDSCAPE 
PRINTER_RESOLUTION_Y: specifies the y-resolution in DPI, value must be 
an integer. 
PRINTER_RESOLUTION_X: specifies the x-resolution in DPI, value must be 
an integer. 
PRINTER_PAPER_FORMAT: specifies the a predefined paper format, set value 
to PRINTER_FORMAT_CUSTOM if you want to specify a custom format with 
PRINTER_PAPER_WIDTH and PRINTER_PAPER_LENGTH. value can be one of the 
following constants. 
PRINTER_FORMAT_CUSTOM: let's you specify a custom paper format. 
PRINTER_FORMAT_LETTER: specifies standard letter format (8 1/2- by 
11-inches). 
PRINTER_FORMAT_LETTER: specifies standard legal format (8 1/2- by 
14-inches). 
PRINTER_FORMAT_A3: specifies standard A3 format (297- by 
420-millimeters). 
PRINTER_FORMAT_A4: specifies standard A4 format (210- by 
297-millimeters). 
PRINTER_FORMAT_A5: specifies standard A5 format (148- by 
210-millimeters). 
PRINTER_FORMAT_B4: specifies standard B4 format (250- by 
354-millimeters). 
PRINTER_FORMAT_B5: specifies standard B5 format (182- by 
257-millimeter). 
PRINTER_FORMAT_FOLIO: specifies standard FOLIO format (8 1/2- by 
13-inch). 
PRINTER_PAPER_LENGTH: if PRINTER_PAPER_FORMAT is set to 
PRINTER_FORMAT_CUSTOM, PRINTER_PAPER_LENGTH specifies a custom paper 
length in mm, value must be an integer. 
PRINTER_PAPER_WIDTH: if PRINTER_PAPER_FORMAT is set to 
PRINTER_FORMAT_CUSTOM, PRINTER_PAPER_WIDTH specifies a custom paper 
width in mm, value must be an integer. 
PRINTER_SCALE: specifies the factor by which the printed output is to be 
scaled. the page size is scaled from the physical page size by a factor 
of scale/100. for example if you set the scale to 50, the output would 
be half of it's original size. value must be an integer. 
PRINTER_BACKGROUND_COLOR: specifies the background color for the actual 
device context, value must be a string containing the rgb information in 
hex format i.e. "005533". 
PRINTER_TEXT_COLOR: specifies the text color for the actual device 
context, value must be a string containing the rgb information in hex 
format i.e. "005533". 
PRINTER_TEXT_ALIGN: specifies the text alignment for the actual device 
context, value can be combined through OR'ing the following constants: 
PRINTER_TA_BASELINE: text will be aligned at the base line. 
PRINTER_TA_BOTTOM: text will be aligned at the bottom. 
PRINTER_TA_TOP: text will be aligned at the top. 
PRINTER_TA_CENTER: text will be aligned at the center. 
PRINTER_TA_LEFT: text will be aligned at the left. 
PRINTER_TA_RIGHT: text will be aligned at the right. 
Example 1. printer_set_option() example
  <?php
  $handle = printer_open();
  printer_set_option($handle, PRINTER_SCALE, 75);
  printer_set_option($handle, PRINTER_TEXT_ALIGN, 
  PRINTER_TA_LEFT);
  printer_close($handle);
  ?> 

  printer_select_penUpprinter_start_doc
printer_start_doc
(no version information, might be only in CVS)
printer_start_doc -- Start a new document
Description
bool printer_start_doc ( resource handle [, string document])
The function creates a new document in the printer spooler. A document can 
contain multiple pages, it's used to schedule the print job in the 
spooler. handle must be a valid handle to a printer. The optional 
parameter document can be used to set an alternative document name. 
Example 1. printer_start_doc() example
  <?php
  $handle = printer_open();
  printer_start_doc($handle, "My Document");
  printer_start_page($handle);

  printer_end_page($handle);
  printer_end_doc($handle);
  printer_close($handle);
  ?> 

  printer_set_optionUpprinter_start_page
printer_start_page
(no version information, might be only in CVS)
printer_start_page -- Start a new page
Description
bool printer_start_page ( resource handle)
The function creates a new page in the active document. For an example see 
printer_start_doc(). handle must be a valid handle to a printer.   printer_start_docUpprinter_write
printer_write
(no version information, might be only in CVS)
printer_write -- Write data to the printer
Description
bool printer_write ( resource handle, string content)
Writes content directly to the printer. Returns TRUE on success or FALSE 
on failure. 
handle must be a valid handle to a printer. 
Example 1. printer_write() example
  <?php
  $handle = printer_open();
  printer_write($handle, "Text to print");
  printer_close($handle);
  ?> 

  printer_start_pageUpPspell Functions
#

#T=int print ( string arg)
print ( ^!string arg);
#

#T=printf - void printf ( string format [, mixed args])
(PHP 3, PHP 4 )
printf -- Output a formatted string
Description
void printf ( string format [, mixed args])
Produces output according to format, which is described in the 
documentation for sprintf(). 
See also print(), sprintf(), vprintf(), sscanf(), fscanf() and flush().   printUpquoted_printable_decode
#

#T=void printf ( string format [, mixed args])
printf ( ^!string format [, mixed args]);
#

#T=proc_close - int proc_close ( resource process)
(PHP 4 >= 4.3.0)
proc_close --  Close a process opened by proc_open() and return the exit 
code of that process. 
Description
int proc_close ( resource process)
proc_close() is similar to pclose() except that it only works on processes 
opened by proc_open(). proc_close() waits for the process to terminate, 
and returns it's exit code. If you have open pipes to that process, you 
should fclose() them prior to calling this function in order to avoid a 
deadlock - the child process may not be able to exit while the pipes are 
open.   passthruUpproc_get_status
#

#T=int proc_close ( resource process)
proc_close ( ^!resource process);
#

#T=proc_get_status - array proc_get_status ( resource process)
(PHP 5 CVS only)
proc_get_status --  Get information about a process opened by proc_open() 
Description
array proc_get_status ( resource process)
proc_get_status() fetches data about a process opened using proc_open(). 
The collected information is returned in an array containing the following 
elements: 
elementtypedescription
commandstringThe command string that was passed to proc_open()
pidintprocess id
runningboolTRUE if the process is still running, FALSE if it has 
terminated 
signaledboolTRUE if the child process has been terminated by an 
uncaught signal. Always set to FALSE on Windows. 
stoppedboolTRUE if the child process has been stopped by a signal. 
Always set to FALSE on Windows. 
exitcodeintthe exit code returned by the process (which is only 
meaningful if running is FALSE) 
termsigintthe number of the signal that caused the child process to 
terminate its execution (only meaningful if signaled is TRUE) 
stopsigintthe number of the signal that caused the child process to 
stop its execution (only meaningful if stopped is TRUE) 

See also proc_open().   proc_closeUpproc_nice
#

#T=array proc_get_status ( resource process)
proc_get_status ( ^!resource process);
#

#T=proc_nice - bool proc_nice ( int priority)
(PHP 5 CVS only)
proc_nice --  Change the priority of the current process 
Description
bool proc_nice ( int priority)
proc_nice() changes the priority of the current process. If an error 
occurs, like the user lacks permission to change the priority, an error of 
level E_WARNING is generated and FALSE is returned. Otherwise, TRUE is 
returned. 
Note: proc_nice() will only exist if your system has 'nice' 
capabilities. 'nice' conforms to: SVr4, SVID EXT, AT&T, X/OPEN, BSD 4.3. 
This means that proc_nice() is not available on Windows. 
proc_nice() is not related to proc_open() and its associated functions in 
any way.   proc_get_statusUpproc_open
#

#T=bool proc_nice ( int priority)
proc_nice ( ^!int priority);
#

#T=proc_open - resource proc_open ( string cmd, array descriptorspec, array pipes)
(PHP 4 >= 4.3.0)
proc_open --  Execute a command and open file pointers for input/output 
Description
resource proc_open ( string cmd, array descriptorspec, array pipes)
proc_open() is similar to popen() but provides a much greater degree of 
control over the program execution. cmd is the command to be executed by 
the shell. descriptorspec is an indexed array where the key represents the 
descriptor number and the value represents how PHP will pass that 
descriptor to the child process. pipes will be set to an indexed array of 
file pointers that correspond to PHP's end of any pipes that are created. 
The return value is a resource representing the process; you should free 
it using proc_close() when you are finished with it. 
<?php
$descriptorspec = array(
0 => array("pipe", "r"),  // stdin is a pipe that the child will 
read from
1 => array("pipe", "w"),  // stdout is a pipe that the child will 
write to
2 => array("file", "/tmp/error-output.txt", "a") // stderr is a 
file to write to
);
$process = proc_open("php", $descriptorspec, $pipes);
if (is_resource($process)) {
// $pipes now looks like this:
// 0 => writeable handle connected to child stdin
// 1 => readable handle connected to child stdout
// Any error output will be appended to /tmp/error-output.txt

fwrite($pipes[0], "<?php echo \"Hello World!\"; ?>");
fclose($pipes[0]);

while (!feof($pipes[1])) {
    echo fgets($pipes[1], 1024);
}
fclose($pipes[1]);
// It is important that you close any pipes before calling
// proc_close in order to avoid a deadlock
$return_value = proc_close($process);

echo "command returned $return_value\n";
}
?> 

The file descriptor numbers in descriptorspec are not limited to 0, 1 and 
2 - you may specify any valid file descriptor number and it will be passed 
to the child process. This allows your script to interoperate with other 
scripts that run as "co-processes". In particular, this is useful for 
passing passphrases to programs like PGP, GPG and openssl in a more secure 
manner. It is also useful for reading status information provided by those 
programs on auxiliary file descriptors. 
Note: Windows compatibility: Descriptors beyond 2 (stderr) are made 
available to the child process as inheritable handles, but since the 
Windows architecture does not associate file descriptor numbers with 
low-level handles, the child process does not (yet) have a means of 
accessing those handles. Stdin, stdout and stderr work as expected. 
Note: If you only need a uni-directional (one-way) process pipe, use 
popen() instead, as it is much easier to use. 
See also stream_select(), exec(), system(), passthru(), popen(), 
escapeshellcmd(), and the backtick operator.   proc_niceUpproc_terminate
#

#T=resource proc_open ( string cmd, array descriptorspec, array pipes)
proc_open ( ^!string cmd, array descriptorspec, array pipes);
#

#T=proc_terminate - int proc_terminate ( resource process [, int signal])
(PHP 5 CVS only)
proc_terminate --  kills a process opened by proc_open 
Description
int proc_terminate ( resource process [, int signal])
Signals a process (created using proc_open()) that it should terminate. 
proc_terminate() returns immediately and does not wait for the process to 
terminate. 
The optional signal is only useful on POSIX operating systems; you may 
specify a signal to send to the process using the kill(2) system call. The 
default is SIGTERM. 
proc_terminate() allows you terminate the process and continue with other 
tasks. You may poll the process (to see if it has stopped yet) by using 
the proc_get_status() function. 
See also proc_open(), proc_close(), and proc_get_status().   proc_openUpshell_exec
#

#T=int proc_terminate ( resource process [, int signal])
proc_terminate ( ^!resource process [, int signal]);
#

#T=pspell_add_to_personal - int pspell_add_to_personal ( int dictionary_link, string word)
(PHP 4 >= 4.0.2)
pspell_add_to_personal -- Add the word to a personal wordlist
Description
int pspell_add_to_personal ( int dictionary_link, string word)
pspell_add_to_personal() adds a word to the personal wordlist. If you used 
pspell_new_config() with pspell_config_personal() to open the dictionary, 
you can save the wordlist later with pspell_save_wordlist(). Please, note 
that this function will not work unless you have pspell .11.2 and aspell 
.32.5 or later. 
Example 1. pspell_add_to_personal()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, 
  "/var/dictionaries/custom.pws");
  $pspell_link = pspell_new_config($pspell_config);

  pspell_add_to_personal($pspell_link, "Vlad");
  pspell_save_wordlist($pspell_link);
  ?> 

  Pspell FunctionsUppspell_add_to_session
#

#T=int pspell_add_to_personal ( int dictionary_link, string word)
pspell_add_to_personal ( ^!int dictionary_link, string word);
#

#T=pspell_add_to_session - int pspell_add_to_session ( int dictionary_link, string word)
(PHP 4 >= 4.0.2)
pspell_add_to_session -- Add the word to the wordlist in the current 
session 
Description
int pspell_add_to_session ( int dictionary_link, string word)
pspell_add_to_session() adds a word to the wordlist associated with the 
current session. It is very similar to pspell_add_to_personal()   pspell_add_to_personalUppspell_check
#

#T=int pspell_add_to_session ( int dictionary_link, string word)
pspell_add_to_session ( ^!int dictionary_link, string word);
#

#T=pspell_check - bool pspell_check ( int dictionary_link, string word)
(PHP 4 >= 4.0.2)
pspell_check -- Check a word
Description
bool pspell_check ( int dictionary_link, string word)
pspell_check() checks the spelling of a word and returns TRUE if the 
spelling is correct, FALSE if not. 
Example 1. pspell_check()
  <?php
  $pspell_link = pspell_new("en");

  if (pspell_check($pspell_link, "testt")) {
      echo "This is a valid spelling";
  } else {
      echo "Sorry, wrong spelling";
  }
  ?> 

  pspell_add_to_sessionUppspell_clear_session
#

#T=bool pspell_check ( int dictionary_link, string word)
pspell_check ( ^!int dictionary_link, string word);
#

#T=pspell_clear_session - int pspell_clear_session ( int dictionary_link)
(PHP 4 >= 4.0.2)
pspell_clear_session -- Clear the current session
Description
int pspell_clear_session ( int dictionary_link)
pspell_clear_session() clears the current session. The current wordlist 
becomes blank, and, for example, if you try to save it with 
pspell_save_wordlist(), nothing happens. 
Example 1. pspell_add_to_personal()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, 
  "/var/dictionaries/custom.pws");
  $pspell_link = pspell_new_config($pspell_config);

  pspell_add_to_personal($pspell_link, "Vlad");
  pspell_clear_session($pspell_link);
  pspell_save_wordlist($pspell_link);    //"Vlad" will not be 
  saved
  ?> 

  pspell_checkUppspell_config_create
#

#T=int pspell_clear_session ( int dictionary_link)
pspell_clear_session ( ^!int dictionary_link);
#

#T=pspell_config_create - int pspell_config_create ( string language [, string spelling [, string 
(PHP 4 >= 4.0.2)
pspell_config_create -- Create a config used to open a dictionary
Description
int pspell_config_create ( string language [, string spelling [, string 
jargon [, string encoding]]])
pspell_config_create() has a very similar syntax to pspell_new(). In fact, 
using pspell_config_create() immediately followed by pspell_new_config() 
will produce the exact same result. However, after creating a new config, 
you can also use pspell_config_*() functions before calling 
pspell_new_config() to take advantage of some advanced functionality. 
The language parameter is the language code which consists of the two 
letter ISO 639 language code and an optional two letter ISO 3166 country 
code after a dash or underscore. 
The spelling parameter is the requested spelling for languages with more 
than one spelling such as English. Known values are 'american', 'british', 
and 'canadian'. 
The jargon parameter contains extra information to distinguish two 
different words lists that have the same language and spelling parameters. 

The encoding parameter is the encoding that words are expected to be in. 
Valid values are 'utf-8', 'iso8859-*', 'koi8-r', 'viscii', 'cp1252', 
'machine unsigned 16', 'machine unsigned 32'. This parameter is largely 
untested, so be careful when using. 
The mode parameter is the mode in which spellchecker will work. There are 
several modes available: 
PSPELL_FAST - Fast mode (least number of suggestions) 
PSPELL_NORMAL - Normal mode (more suggestions) 
PSPELL_BAD_SPELLERS - Slow mode (a lot of suggestions) 
For more information and examples, check out inline manual pspell 
website:http://aspell.net/. 
Example 1. pspell_config_create()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, 
  "/var/dictionaries/custom.pws");
  pspell_config_repl($pspell_config, 
  "/var/dictionaries/custom.repl");
  $pspell_link = pspell_new_personal($pspell_config, "en");
  ?> 

  pspell_clear_sessionUppspell_config_ignore
#

#T=int pspell_config_create ( string language [, string spelling [, string 
pspell_config_create ( ^!string language [, string spelling [, string ;
#

#T=pspell_config_ignore - int pspell_config_ignore ( int dictionary_link, int n)
(PHP 4 >= 4.0.2)
pspell_config_ignore -- Ignore words less than N characters long
Description
int pspell_config_ignore ( int dictionary_link, int n)
pspell_config_ignore() should be used on a config before calling 
pspell_new_config(). This function allows short words to be skipped by the 
spellchecker. Words less then n characters will be skipped. 
Example 1. pspell_config_ignore()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_ignore($pspell_config, 5);
  $pspell_link = pspell_new_config($pspell_config);
  pspell_check($pspell_link, "abcd");    //will not result in an 
  error
  ?> 

  pspell_config_createUppspell_config_mode
#

#T=int pspell_config_ignore ( int dictionary_link, int n)
pspell_config_ignore ( ^!int dictionary_link, int n);
#

#T=pspell_config_mode - int pspell_config_mode ( int dictionary_link, int mode)
(PHP 4 >= 4.0.2)
pspell_config_mode -- Change the mode number of suggestions returned
Description
int pspell_config_mode ( int dictionary_link, int mode)
pspell_config_mode() should be used on a config before calling 
pspell_new_config(). This function determines how many suggestions will be 
returned by pspell_suggest(). 
The mode parameter is the mode in which spellchecker will work. There are 
several modes available: 
PSPELL_FAST - Fast mode (least number of suggestions) 
PSPELL_NORMAL - Normal mode (more suggestions) 
PSPELL_BAD_SPELLERS - Slow mode (a lot of suggestions) 
Example 1. pspell_config_mode()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_mode($pspell_config, PSPELL_FAST);
  $pspell_link = pspell_new_config($pspell_config);
  pspell_check($pspell_link, "thecat");
  ?> 

  pspell_config_ignoreUppspell_config_personal
#

#T=int pspell_config_mode ( int dictionary_link, int mode)
pspell_config_mode ( ^!int dictionary_link, int mode);
#

#T=pspell_config_personal - int pspell_config_personal ( int dictionary_link, string file)
(PHP 4 >= 4.0.2)
pspell_config_personal -- Set a file that contains personal wordlist
Description
int pspell_config_personal ( int dictionary_link, string file)
pspell_config_personal() should be used on a config before calling 
pspell_new_config(). The personal wordlist will be loaded and used in 
addition to the standard one after you call pspell_new_config(). If the 
file does not exist, it will be created. The file is also the file where 
pspell_save_wordlist() will save personal wordlist to. The file should be 
writable by whoever PHP runs as (e.g. nobody). Please, note that this 
function will not work unless you have pspell .11.2 and aspell .32.5 or 
later. 
Example 1. pspell_config_personal()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, 
  "/var/dictionaries/custom.pws");
  $pspell_link = pspell_new_config($pspell_config);
  pspell_check($pspell_link, "thecat");
  ?> 

  pspell_config_modeUppspell_config_repl
#

#T=int pspell_config_personal ( int dictionary_link, string file)
pspell_config_personal ( ^!int dictionary_link, string file);
#

#T=pspell_config_repl - int pspell_config_repl ( int dictionary_link, string file)
(PHP 4 >= 4.0.2)
pspell_config_repl -- Set a file that contains replacement pairs
Description
int pspell_config_repl ( int dictionary_link, string file)
pspell_config_repl() should be used on a config before calling 
pspell_new_config(). The replacement pairs improve the quality of the 
spellchecker. When a word is misspelled, and a proper suggestion was not 
found in the list, pspell_store_replacement() can be used to store a 
replacement pair and then pspell_save_wordlist() to save the wordlist 
along with the replacement pairs. The file should be writable by whoever 
PHP runs as (e.g. nobody). Please, note that this function will not work 
unless you have pspell .11.2 and aspell .32.5 or later. 
Example 1. pspell_config_repl()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, 
  "/var/dictionaries/custom.pws");
  pspell_config_repl($pspell_config, 
  "/var/dictionaries/custom.repl");
  $pspell_link = pspell_new_config($pspell_config);
  pspell_check($pspell_link, "thecat");
  ?> 

  pspell_config_personalUppspell_config_runtogether
#

#T=int pspell_config_repl ( int dictionary_link, string file)
pspell_config_repl ( ^!int dictionary_link, string file);
#

#T=pspell_config_runtogether - int pspell_config_runtogether ( int dictionary_link, bool flag)
(PHP 4 >= 4.0.2)
pspell_config_runtogether -- Consider run-together words as valid 
compounds
Description
int pspell_config_runtogether ( int dictionary_link, bool flag)
pspell_config_runtogether() should be used on a config before calling 
pspell_new_config(). This function determines whether run-together words 
will be treated as legal compounds. That is, "thecat" will be a legal 
compound, although there should be a space between the two words. Changing 
this setting only affects the results returned by pspell_check(); 
pspell_suggest() will still return suggestions. 
Example 1. pspell_config_runtogether()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_runtogether($pspell_config, true);
  $pspell_link = pspell_new_config($pspell_config);
  pspell_check($pspell_link, "thecat");
  ?> 

  pspell_config_replUppspell_config_save_repl
#

#T=int pspell_config_runtogether ( int dictionary_link, bool flag)
pspell_config_runtogether ( ^!int dictionary_link, bool flag);
#

#T=pspell_config_save_repl - int pspell_config_save_repl ( int dictionary_link, bool flag)
(PHP 4 >= 4.0.2)
pspell_config_save_repl -- Determine whether to save a replacement pairs 
list along with the wordlist
Description
int pspell_config_save_repl ( int dictionary_link, bool flag)
pspell_config_save_repl() should be used on a config before calling 
pspell_new_config(). It determines whether pspell_save_wordlist() will 
save the replacement pairs along with the wordlist. Usually there is no 
need to use this function because if pspell_config_repl() is used, the 
replacement pairs will be saved by pspell_save_wordlist() anyway, and if 
it is not, the replacement pairs will not be saved. Please, note that this 
function will not work unless you have pspell .11.2 and aspell .32.5 or 
later.   pspell_config_runtogetherUppspell_new_config
#

#T=int pspell_config_save_repl ( int dictionary_link, bool flag)
pspell_config_save_repl ( ^!int dictionary_link, bool flag);
#

#T=pspell_new_config - int pspell_new_config ( int config)
(PHP 4 >= 4.0.2)
pspell_new_config -- Load a new dictionary with settings based on a given 
config 
Description
int pspell_new_config ( int config)
pspell_new_config() opens up a new dictionary with settings specified in a 
config, created with with pspell_config_create() and modified with 
pspell_config_*() functions. This method provides you with the most 
flexibility and has all the functionality provided by pspell_new() and 
pspell_new_personal(). 
The config parameter is the one returned by pspell_config_create() when 
the config was created. 
Example 1. pspell_new_config()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, 
  "/var/dictionaries/custom.pws");
  pspell_config_repl($pspell_config, 
  "/var/dictionaries/custom.repl");
  $pspell_link = pspell_new_config($pspell_config);
  ?> 

  pspell_config_save_replUppspell_new_personal
#

#T=int pspell_new_config ( int config)
pspell_new_config ( ^!int config);
#

#T=pspell_new_personal - int pspell_new_personal ( string personal, string language [, string 
(PHP 4 >= 4.0.2)
pspell_new_personal -- Load a new dictionary with personal wordlist
Description
int pspell_new_personal ( string personal, string language [, string 
spelling [, string jargon [, string encoding [, int mode]]]])
pspell_new_personal() opens up a new dictionary with a personal wordlist 
and returns the dictionary link identifier for use in other pspell 
functions. The wordlist can be modified and saved with 
pspell_save_wordlist(), if desired. However, the replacement pairs are not 
saved. In order to save replacement pairs, you should create a config 
using pspell_config_create(), set the personal wordlist file with 
pspell_config_personal(), set the file for replacement pairs with 
pspell_config_repl(), and open a new dictionary with pspell_new_config(). 
The personal parameter specifies the file where words added to the 
personal list will be stored. It should be an absolute filename beginning 
with '/' because otherwise it will be relative to $HOME, which is "/root" 
for most systems, and is probably not what you want. 
The language parameter is the language code which consists of the two 
letter ISO 639 language code and an optional two letter ISO 3166 country 
code after a dash or underscore. 
The spelling parameter is the requested spelling for languages with more 
than one spelling such as English. Known values are 'american', 'british', 
and 'canadian'. 
The jargon parameter contains extra information to distinguish two 
different words lists that have the same language and spelling parameters. 

The encoding parameter is the encoding that words are expected to be in. 
Valid values are 'utf-8', 'iso8859-*', 'koi8-r', 'viscii', 'cp1252', 
'machine unsigned 16', 'machine unsigned 32'. This parameter is largely 
untested, so be careful when using. 
The mode parameter is the mode in which spellchecker will work. There are 
several modes available: 
PSPELL_FAST - Fast mode (least number of suggestions) 
PSPELL_NORMAL - Normal mode (more suggestions) 
PSPELL_BAD_SPELLERS - Slow mode (a lot of suggestions) 
PSPELL_RUN_TOGETHER - Consider run-together words as legal compounds. 
That is, "thecat" will be a legal compound, although there should be a 
space between the two words. Changing this setting only affects the 
results returned by pspell_check(); pspell_suggest() will still return 
suggestions. 
Mode is a bitmask constructed from different constants listed above. 
However, PSPELL_FAST, PSPELL_NORMAL and PSPELL_BAD_SPELLERS are mutually 
exclusive, so you should select only one of them. 
For more information and examples, check out inline manual pspell 
website:http://aspell.net/. 
Example 1. pspell_new_personal()
  <?php
  $pspell_link = pspell_new_personal 
  ("/var/dictionaries/custom.pws", 
	  "en", "", "", "", PSPELL_FAST|PSPELL_RUN_TOGETHER);
  ?> 

  pspell_new_configUppspell_new
#

#T=int pspell_new_personal ( string personal, string language [, string 
pspell_new_personal ( ^!string personal, string language [, string ;
#

#T=pspell_new - int pspell_new ( string language [, string spelling [, string jargon [, 
(PHP 4 >= 4.0.2)
pspell_new -- Load a new dictionary
Description
int pspell_new ( string language [, string spelling [, string jargon [, 
string encoding [, int mode]]]])
pspell_new() opens up a new dictionary and returns the dictionary link 
identifier for use in other pspell functions. 
The language parameter is the language code which consists of the two 
letter ISO 639 language code and an optional two letter ISO 3166 country 
code after a dash or underscore. 
The spelling parameter is the requested spelling for languages with more 
than one spelling such as English. Known values are 'american', 'british', 
and 'canadian'. 
The jargon parameter contains extra information to distinguish two 
different words lists that have the same language and spelling parameters. 

The encoding parameter is the encoding that words are expected to be in. 
Valid values are 'utf-8', 'iso8859-*', 'koi8-r', 'viscii', 'cp1252', 
'machine unsigned 16', 'machine unsigned 32'. This parameter is largely 
untested, so be careful when using. 
The mode parameter is the mode in which spellchecker will work. There are 
several modes available: 
PSPELL_FAST - Fast mode (least number of suggestions) 
PSPELL_NORMAL - Normal mode (more suggestions) 
PSPELL_BAD_SPELLERS - Slow mode (a lot of suggestions) 
PSPELL_RUN_TOGETHER - Consider run-together words as legal compounds. 
That is, "thecat" will be a legal compound, although there should be a 
space between the two words. Changing this setting only affects the 
results returned by pspell_check(); pspell_suggest() will still return 
suggestions. 
Mode is a bitmask constructed from different constants listed above. 
However, PSPELL_FAST, PSPELL_NORMAL and PSPELL_BAD_SPELLERS are mutually 
exclusive, so you should select only one of them. 
For more information and examples, check out inline manual pspell 
website:http://aspell.net/. 
Example 1. pspell_new()
  <?php
  $pspell_link = pspell_new "en", "", "", "", 
			     (PSPELL_FAST|PSPELL_RUN_TOGETHER));
  ?> 

  pspell_new_personalUppspell_save_wordlist
#

#T=int pspell_new ( string language [, string spelling [, string jargon [, 
pspell_new ( ^!string language [, string spelling [, string jargon [, ;
#

#T=pspell_save_wordlist - int pspell_save_wordlist ( int dictionary_link)
(PHP 4 >= 4.0.2)
pspell_save_wordlist -- Save the personal wordlist to a file
Description
int pspell_save_wordlist ( int dictionary_link)
pspell_save_wordlist() saves the personal wordlist from the current 
session. The dictionary has to be open with pspell_new_personal(), and the 
location of files to be saved specified with pspell_config_personal() and 
(optionally) pspell_config_repl(). Please, note that this function will 
not work unless you have pspell .11.2 and aspell .32.5 or later. 
Example 1. pspell_add_to_personal()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, "/tmp/dicts/newdict");
  $pspell_link = pspell_new_config($pspell_config);

  pspell_add_to_personal($pspell_link, "Vlad");
  pspell_save_wordlist($pspell_link);
  ?> 

  pspell_newUppspell_store_replacement
#

#T=int pspell_save_wordlist ( int dictionary_link)
pspell_save_wordlist ( ^!int dictionary_link);
#

#T=pspell_store_replacement - int pspell_store_replacement ( int dictionary_link, string misspelled, 
(PHP 4 >= 4.0.2)
pspell_store_replacement -- Store a replacement pair for a word
Description
int pspell_store_replacement ( int dictionary_link, string misspelled, 
string correct)
pspell_store_replacement() stores a replacement pair for a word, so that 
replacement can be returned by pspell_suggest() later. In order to be able 
to take advantage of this function, you have to use pspell_new_personal() 
to open the dictionary. In order to permanently save the replacement pair, 
you have to use pspell_config_personal() and pspell_config_repl() to set 
the path where to save your custom wordlists, and then use 
pspell_save_wordlist() for the changes to be written to disk. Please, note 
that this function will not work unless you have pspell .11.2 and aspell 
.32.5 or later. 
Example 1. pspell_store_replacement()
  <?php
  $pspell_config = pspell_config_create("en");
  pspell_config_personal($pspell_config, 
  "/var/dictionaries/custom.pws");
  pspell_config_repl($pspell_config, 
  "/var/dictionaries/custom.repl");
  $pspell_link = pspell_new_config($pspell_config);

  pspell_store_replacement($pspell_link, $misspelled, $correct);
  pspell_save_wordlist($pspell_link);
  ?> 

  pspell_save_wordlistUppspell_suggest
#

#T=int pspell_store_replacement ( int dictionary_link, string misspelled, 
pspell_store_replacement ( ^!int dictionary_link, string misspelled, ;
#

#T=pspell_suggest - array pspell_suggest ( int dictionary_link, string word)
(PHP 4 >= 4.0.2)
pspell_suggest -- Suggest spellings of a word
Description
array pspell_suggest ( int dictionary_link, string word)
pspell_suggest() returns an array of possible spellings for the given 
word. 
Example 1. pspell_suggest() example
  <?php
  $pspell_link = pspell_new("en");

  if (!pspell_check($pspell_link, "testt")) {
      $suggestions = pspell_suggest($pspell_link, "testt");

      foreach ($suggestions as $suggestion) {
	  echo "Possible spelling: $suggestion<br />"; 
      }
  }
  ?> 

  pspell_store_replacementUpGNU Readline
#

#T=array pspell_suggest ( int dictionary_link, string word)
pspell_suggest ( ^!int dictionary_link, string word);
#

#T=putenv - void putenv ( string setting)
(PHP 3, PHP 4 )
putenv -- Sets the value of an environment variable
Description
void putenv ( string setting)
Adds setting to the server environment. The environment variable will only 
exist for the duration of the current request. At the end of the request 
the environment is restored to its original state. 
Setting certain environment variables may be a potential security breach. 
The safe_mode_allowed_env_vars directive contains a comma-delimited list 
of prefixes. In Safe Mode, the user may only alter environment variables 
whose names begin with the prefixes supplied by this directive. By 
default, users will only be able to set environment variables that begin 
with PHP_ (e.g. PHP_FOO=BAR). Note: if this directive is empty, PHP will 
let the user modify ANY environment variable! 
The safe_mode_protected_env_vars directive contains a comma-delimited list 
of environment variables, that the end user won't be able to change using 
putenv(). These variables will be protected even if 
safe_mode_allowed_env_vars is set to allow to change them. 
Warning
These directives have only effect when safe-mode itself is enabled! 

Example 1. Setting an environment variable
  <?php
  putenv("UNIQID=$uniqid");
  ?> 
See also getenv().   phpversionUprestore_include_path
#

#T=void putenv ( string setting)
putenv ( ^!string setting);
#

#T=qdom_error - string qdom_error ( void )
(PHP 4 >= 4.0.5)
qdom_error -- Returns the error string from the last QDOM operation or 
FALSE if no errors occurred
Description
string qdom_error ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  qtdom functionsUpqdom_tree
#

#T=string qdom_error ( void )
qdom_error ( ^!void );
#

#T=qdom_tree - object qdom_tree ( string )
(PHP 4 >= 4.0.4)
qdom_tree -- Creates a tree of an XML string
Description
object qdom_tree ( string )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  qdom_errorUpRegular Expression Functions (POSIX Extended)
#

#T=object qdom_tree ( string )
qdom_tree ( ^!string );
#

#T=quoted_printable_decode - string quoted_printable_decode ( string str)
(PHP 3>= 3.0.6, PHP 4 )
quoted_printable_decode --  Convert a quoted-printable string to an 8 bit 
string 
Description
string quoted_printable_decode ( string str)
This function returns an 8-bit binary string corresponding to the decoded 
quoted printable string. This function is similar to imap_qprint(), except 
this one does not require the IMAP module to work.   printfUpquotemeta
#

#T=string quoted_printable_decode ( string str)
quoted_printable_decode ( ^!string str);
#

#T=quotemeta - string quotemeta ( string str)
(PHP 3, PHP 4 )
quotemeta -- Quote meta characters
Description
string quotemeta ( string str)
Returns a version of str with a backslash character (\) before every 
character that is among these: . \\ + * ? [ ^ ] ( $ )

See also addslashes(), htmlentities(), htmlspecialchars(), nl2br(), and 
stripslashes().   quoted_printable_decodeUprtrim
#

#T=string quotemeta ( string str)
quotemeta ( ^!string str);
#

#T=rad2deg - float rad2deg ( float number)
(PHP 3>= 3.0.4, PHP 4 )
rad2deg --  Converts the radian number to the equivalent number in degrees 

Description
float rad2deg ( float number)
This function converts number from radian to degrees. 
Example 1. rad2deg() example
  <?php

  echo rad2deg(M_PI_4); // 45

  ?> 
See also deg2rad().   powUprand
#

#T=float rad2deg ( float number)
rad2deg ( ^!float number);
#

#T=rand - int rand ( [int min, int max])
(PHP 3, PHP 4 )
rand -- Generate a random value
Description
int rand ( [int min, int max])
If called without the optional min, max arguments rand() returns a 
pseudo-random value between 0 and RAND_MAX. If you want a random number 
between 5 and 15 (inclusive), for example, use rand (5, 15). 
Example 1. rand() example
  <?php
  echo rand() . "\n";
  echo rand() . "\n";

  echo rand(5, 15);
  ?> 

The above example will output something similar to: 
7771
22264
11
Note: On some platforms (such as Windows) RAND_MAX is only 32768. If you 
require a range larger than 32768, consider using mt_rand() instead. 
Note: As of PHP 4.2.0, there is no need to seed the random number 
generator with srand() or mt_srand() as this is now done automatically. 
Note: In versions before 3.0.7 the meaning of max was range. To get the 
same results in these versions the short example should be rand (5, 11) 
to get a random number between 5 and 15. 
See also srand(), getrandmax(), and mt_rand().   rad2degUpround
#

#T=int rand ( [int min, int max])
rand ( ^![int min, int max]);
#

#T=range - array range ( int low, int high [, int step])
(PHP 3>= 3.0.8, PHP 4 )
range --  Create an array containing a range of elements 
Description
array range ( int low, int high [, int step])
range() returns an array of elements from low to high, inclusive. If low > 
high, the sequence will be from high to low. 
New parameter: The optional step parameter was added in 5.0.0. 
If a step value is given, it will be used as the increment between 
elements in the sequence. step should be given as a positive number. If 
not specified, step will default to 1. 
Example 1. range() examples
  <?php
  // array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12)
  foreach (range(0, 12) as $number) {
      echo $number;
  }

  // The step parameter was introduced in 5.0.0
  // array(0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100)
  foreach (range(0, 100, 10) as $number) {
      echo $number;
  }

  // Use of character sequences introduced in 4.1.0
  // array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i');
  foreach (range('a', 'i') as $letter) {
      echo $letter;
  }
  // array('c', 'b', 'a');
  foreach (range('c', 'a') as $letter) {
      echo $letter;
  }
  ?> 
Note: Prior to PHP version 4.1.0, range() only generated incrementing 
integer arrays. Support for character sequences and decrementing arrays 
was added in 4.1.0. Character sequence values are limited to a length of 
one. If a length greater than one is entered, only the first character 
is used. 
Caution
In PHP versions 4.1.0 through 4.3.2, range() sees numeric strings as 
strings and not integers. Instead, they will be used for character 
sequences. For example, "4242" is treated as "4". 

See also shuffle(), array_fill(), and foreach.   prevUpreset
#

#T=array range ( int low, int high [, int step])
range ( ^!int low, int high [, int step]);
#

#T=rawurldecode - string rawurldecode ( string str)
(PHP 3, PHP 4 )
rawurldecode -- Decode URL-encoded strings
Description
string rawurldecode ( string str)
Returns a string in which the sequences with percent (%) signs followed by 
two hex digits have been replaced with literal characters. 
Example 1. rawurldecode() example
  <?php

  echo rawurldecode('foo%20bar%40baz'); // foo bar@baz

  ?> 
Note: rawurldecode() does not decode plus symbols ('+') into spaces. 
urldecode() does. 
See also rawurlencode(), urldecode() and urlencode().   parse_urlUprawurlencode
#

#T=string rawurldecode ( string str)
rawurldecode ( ^!string str);
#

#T=rawurlencode - string rawurlencode ( string str)
(PHP 3, PHP 4 )
rawurlencode -- URL-encode according to RFC 1738
Description
string rawurlencode ( string str)
Returns a string in which all non-alphanumeric characters except -_. have 
been replaced with a percent (%) sign followed by two hex digits. This is 
the encoding described in RFC 1738 for protecting literal characters from 
being interpreted as special URL delimiters, and for protecting URL's from 
being mangled by transmission media with character conversions (like some 
email systems). For example, if you want to include a password in an FTP 
URL: 
Example 1. rawurlencode() example 1
  <?php
  echo '<a href="ftp://user:', rawurlencode('foo @+%/'),
       '@ftp.example.com/x.txt">';
  ?> 
Or, if you pass information in a PATH_INFO component of the URL: 
Example 2. rawurlencode() example 2
  <?php
  echo '<a href="http://example.com/department_list_script/',
      rawurlencode('sales and marketing/Miami'), '">';
  ?> 
See also rawurldecode(), urldecode(), urlencode() and RFC 1738.   rawurldecodeUpurldecode
read_exif_data
read_exif_data -- Alias of exif_read_data()
Description
This function is an alias of exif_read_data().   png2wbmpUpIMAP, POP3 and NNTP functions
#

#T=string rawurlencode ( string str)
rawurlencode ( ^!string str);
#

#T=readdir - string readdir ( resource dir_handle)
(PHP 3, PHP 4 )
readdir -- read entry from directory handle
Description
string readdir ( resource dir_handle)
Returns the filename of the next file from the directory. The filenames 
are returned in the order in which they are stored by the filesystem. 
Please note the fashion in which readdir()'s return value is checked in 
the examples below. We are explicitly testing whether the return value is 
identical to (equal to and of the same type as--see Comparison Operators 
for more information) FALSE since otherwise, any directory entry whose 
name evaluates to FALSE will stop the loop (e.g. a directory named "0"). 
Example 1. List all files in a directory
  <?php
  // Note that !== did not exist until 4.0.0-RC2

  if ($handle = opendir('/path/to/files')) {
      echo "Directory handle: $handle\n";
      echo "Files:\n";

      /* This is the correct way to loop over the directory. */
      while (false !== ($file = readdir($handle))) { 
	  echo "$file\n";
      }

      /* This is the WRONG way to loop over the directory. */
      while ($file = readdir($handle)) { 
	  echo "$file\n";
      }

      closedir($handle); 
  }
  ?> 
Note that readdir() will return the . and .. entries. If you don't want 
these, simply strip them out: Example 2. List all files in the 
current directory and strip out . and .. 
  <?php 
  if ($handle = opendir('.')) {
      while (false !== ($file = readdir($handle))) { 
	  if ($file != "." && $file != "..") { 
	      echo "$file\n"; 
	  } 
      }
      closedir($handle); 
  }
  ?> 
See also is_dir() and glob().   opendirUprewinddir
#

#T=string readdir ( resource dir_handle)
readdir ( ^!resource dir_handle);
#

#T=readfile - int readfile ( string filename [, bool use_include_path [, resource 
(PHP 3, PHP 4 )
readfile -- Outputs a file
Description
int readfile ( string filename [, bool use_include_path [, resource 
context]])
Reads a file and writes it to the output buffer. 
Returns the number of bytes read from the file. If an error occurs, FALSE 
is returned and unless the function was called as @readfile(), an error 
message is printed. 
Tip: You can use a URL as a filename with this function if the fopen 
wrappers have been enabled. See fopen() for more details on how to 
specify the filename and Appendix I for a list of supported URL 
protocols.
You can use the optional second parameter and set it to TRUE, if you want 
to search for the file in the include_path, too. 
See also fpassthru(), file(), fopen(), include(), require(), virtual(), 
file_get_contents(), and Appendix I.   popenUpreadlink
#

#T=int readfile ( string filename [, bool use_include_path [, resource 
readfile ( ^!string filename [, bool use_include_path [, resource ;
#

#T=readgzfile - int readgzfile ( string filename [, int use_include_path])
(PHP 3, PHP 4 )
readgzfile -- Output a gz-file
Description
int readgzfile ( string filename [, int use_include_path])
Reads a file, decompresses it and writes it to standard output. 
readgzfile() can be used to read a file which is not in gzip format; in 
this case readgzfile() will directly read from the file without 
decompression. 
Returns the number of (uncompressed) bytes read from the file. If an error 
occurs, FALSE is returned and unless the function was called as 
@readgzfile, an error message is printed. 
The file filename will be opened from the filesystem and its contents 
written to standard output. 
You can use the optional second parameter and set it to "1", if you want 
to search for the file in the include_path, too. 
See also gzpassthru(), gzfile(), and gzopen().   gzwriteUpzlib_get_coding_type
#

#T=int readgzfile ( string filename [, int use_include_path])
readgzfile ( ^!string filename [, int use_include_path]);
#

#T=readline_add_history - void readline_add_history ( string line)
(PHP 4 )
readline_add_history -- Adds a line to the history
Description
void readline_add_history ( string line)
This function adds a line to the command line history.   GNU ReadlineUpreadline_clear_history
#

#T=void readline_add_history ( string line)
readline_add_history ( ^!string line);
#

#T=readline_clear_history - bool readline_clear_history ( void )
(PHP 4 )
readline_clear_history -- Clears the history
Description
bool readline_clear_history ( void )
This function clears the entire command line history.   readline_add_historyUpreadline_completion_function
#

#T=bool readline_clear_history ( void )
readline_clear_history ( ^!void );
#

#T=readline_completion_function - bool readline_completion_function ( string line)
(PHP 4 )
readline_completion_function -- Registers a completion function
Description
bool readline_completion_function ( string line)
This function registers a completion function. You must supply the name of 
an existing function which accepts a partial command line and returns an 
array of possible matches. This is the same kind of functionality you'd 
get if you hit your tab key while using Bash.   readline_clear_historyUpreadline_info
#

#T=bool readline_completion_function ( string line)
readline_completion_function ( ^!string line);
#

#T=readline_info - mixed readline_info ( [string varname [, string newvalue]])
(PHP 4 )
readline_info -- Gets/sets various internal readline variables
Description
mixed readline_info ( [string varname [, string newvalue]])
If called with no parameters, this function returns an array of values for 
all the setting readline uses. The elements will be indexed by the 
following values: done, end, erase_empty_line, library_version, 
line_buffer, mark, pending_input, point, prompt, readline_name, and 
terminal_name. 
If called with one parameter, the value of that setting is returned. If 
called with two parameters, the setting will be changed to the given 
value.   readline_completion_functionUpreadline_list_history
#

#T=mixed readline_info ( [string varname [, string newvalue]])
readline_info ( ^![string varname [, string newvalue]]);
#

#T=readline_list_history - array readline_list_history ( void )
(PHP 4 )
readline_list_history -- Lists the history
Description
array readline_list_history ( void )
This function returns an array of the entire command line history. The 
elements are indexed by integers starting at zero.   readline_infoUpreadline_read_history
#

#T=array readline_list_history ( void )
readline_list_history ( ^!void );
#

#T=readline_read_history - bool readline_read_history ( string filename)
(PHP 4 )
readline_read_history -- Reads the history
Description
bool readline_read_history ( string filename)
This function reads a command history from a file.   readline_list_historyUpreadline_write_history
#

#T=bool readline_read_history ( string filename)
readline_read_history ( ^!string filename);
#

#T=readline_write_history - bool readline_write_history ( string filename)
(PHP 4 )
readline_write_history -- Writes the history
Description
bool readline_write_history ( string filename)
This function writes the command history to a file.   readline_read_historyUpreadline
#

#T=bool readline_write_history ( string filename)
readline_write_history ( ^!string filename);
#

#T=readline - string readline ( [string prompt])
(PHP 4 )
readline -- Reads a line
Description
string readline ( [string prompt])
This function returns a single string from the user. You may specify a 
string with which to prompt the user. The line returned has the ending 
newline removed. You must add this line to the history yourself using 
readline_add_history(). 
Example 1. readline()
  <?php
  //get 3 commands from user
  for ($i=0; $i < 3; $i++) {
	  $line = readline("Command: ");
	  readline_add_history($line);
  }

  //dump history
  print_r(readline_list_history());

  //dump variables
  print_r(readline_info());
  ?> 

  readline_write_historyUpGNU Recode functions
#

#T=string readline ( [string prompt])
readline ( ^![string prompt]);
#

#T=readlink - string readlink ( string path)
(PHP 3, PHP 4 )
readlink -- Returns the target of a symbolic link
Description
string readlink ( string path)
readlink() does the same as the readlink C function and returns the 
contents of the symbolic link path or 0 in case of error. 
Example 1. readlink() example
  <?php

  // output e.g. /boot/vmlinux-2.4.20-xfs
  echo readlink('/vmlinuz');

  ?> 
See also is_link(), symlink(), and linkinfo().   readfileUprealpath
#

#T=string readlink ( string path)
readlink ( ^!string path);
#

#T=realpath - string realpath ( string path)
(PHP 4 )
realpath -- Returns canonicalized absolute pathname
Description
string realpath ( string path)
realpath() expands all symbolic links and resolves references to '/./', 
'/../' and extra '/' characters in the input path and return the 
canonicalized absolute pathname. The resulting path will have no symbolic 
link, '/./' or '/../' components. 
realpath() returns FALSE on failure, e.g. if the file does not exists. 
Example 1. realpath() example
  <?php
  $real_path = realpath("../../index.php");
  ?> 
See also: basename(), dirname(), and pathinfo().   readlinkUprename
#

#T=string realpath ( string path)
realpath ( ^!string path);
#

#T=recode_file - bool recode_file ( string request, resource input, resource output)
(PHP 3>= 3.0.13, PHP 4 )
recode_file --  Recode from file to file according to recode request 
Description
bool recode_file ( string request, resource input, resource output)
Recode the file referenced by file handle input into the file referenced 
by file handle output according to the recode request. Returns FALSE, if 
unable to comply, TRUE otherwise. 
This function does not currently process filehandles referencing remote 
files (URLs). Both filehandles must refer to local files. 
Example 1. Basic recode_file() example
  <?php
  $input = fopen('input.txt', 'r');
  $output = fopen('output.txt', 'w');
  recode_file("us..flat", $input, $output);
  ?> 

  GNU Recode functionsUprecode_string
#

#T=bool recode_file ( string request, resource input, resource output)
recode_file ( ^!string request, resource input, resource output);
#

#T=recode_string - string recode_string ( string request, string string)
(PHP 3>= 3.0.13, PHP 4 )
recode_string -- Recode a string according to a recode request
Description
string recode_string ( string request, string string)
Recode the string string according to the recode request request. Returns 
the recoded string or FALSE, if unable to perform the recode request. 
A simple recode request may be "lat1..iso646-de". See also the GNU Recode 
documentation of your installation for detailed instructions about recode 
requests. Example 1. Basic recode_string() example:
  <?php
  echo recode_string("us..flat", "The following character has a 
  diacritical mark: &aacute;");
  ?> 

  recode_fileUprecode
recode
recode -- Alias for recode_string()
Description
This function is an alias of recode_string().   recode_stringUpRegular Expression Functions (Perl-Compatible)
#

#T=string recode_string ( string request, string string)
recode_string ( ^!string request, string string);
#

#T=register_shutdown_function - void register_shutdown_function ( callback function)
(PHP 3>= 3.0.4, PHP 4 )
register_shutdown_function --  Register a function for execution on 
shutdown 
Description
void register_shutdown_function ( callback function)
Registers the function named by function to be executed when script 
processing is complete. 
Multiple calls to register_shutdown_function() can be made, and each will 
be called in the same order as they were registered. If you call exit() 
within one registered shutdown function, processing will stop completely 
and no other registered shutdown functions will be called. 
The registered shutdown functions are called after the request has been 
completed (including sending any output buffers), so it is not possible to 
send output to the browser using echo() or print(), or retrieve the 
contents of any output buffers using ob_get_contents(). 
Note: Typically undefined functions cause fatal errors in PHP, but when 
the function called with register_shutdown_function() is undefined, an 
error of level E_WARNING is generated instead. Also, for reasons 
internal to PHP, this error will refer to Unknown() at line #0. 
See also auto_append_file, exit(), and the section on connection handling. 
  get_defined_functionsUpregister_tick_function
#

#T=void register_shutdown_function ( callback function)
register_shutdown_function ( ^!callback function);
#

#T=register_tick_function - void register_tick_function ( callback function [, mixed arg])
(PHP 4 >= 4.0.3)
register_tick_function --  Register a function for execution on each tick 
Description
void register_tick_function ( callback function [, mixed arg])
Registers the function named by func to be executed when a tick is called. 
Also, you may pass an array consisting of an object and a method as the 
func. 
Example 1. register_tick_function() example
  <?php
  // using a function as the callback
  register_tick_function('my_function', true);

  // using an object->method
  $object = new my_class();
  register_tick_function(array(&$object, 'my_method'), true);
  ?> 
See also declare() and unregister_tick_function().   register_shutdown_functionUpunregister_tick_function
#

#T=void register_tick_function ( callback function [, mixed arg])
register_tick_function ( ^!callback function [, mixed arg]);
#

#T=rename - bool rename ( string oldname, string newname [, resource context])
(PHP 3, PHP 4 )
rename -- Renames a file
Description
bool rename ( string oldname, string newname [, resource context])
Attempts to rename oldname to newname. 
Returns TRUE on success or FALSE on failure. 
Example 1. Example with rename()
  <?php
  rename("/tmp/tmp_file.txt", 
  "/home/user/login/docs/my_file.txt");
  ?> 
Note: Prior to PHP 4.3.3, rename() could not rename files across 
partitions on *nix based systems. 
Note: As of PHP 5.0.0 rename() can also be used with some url wrappers. 
Refer to Appendix I for a listing of which wrappers support rename(). 
Note: The wrapper used in oldname MUST match the wrapper used in 
newname. 
Note: The context parameter was added as of PHP 5.0.0. 
See also copy(), unlink(), and move_uploaded_file().   realpathUprewind

  PrevChapter 11. Control StructuresNext

require_once()
The require_once() statement includes and evaluates the specified file 
during the execution of the script. This is a behavior similar to the 
require() statement, with the only difference being that if the code from 
a file has already been included, it will not be included again. See the 
documentation for require() for more information on how this statement 
works. 
require_once() should be used in cases where the same file might be 
included and evaluated more than once during a particular execution of a 
script, and you want to be sure that it is included exactly once to avoid 
problems with function redefinitions, variable value reassignments, etc. 
For examples on using require_once() and include_once(), look at the PEAR 
code included in the latest PHP source code distributions. 
Note: require_once() was added in PHP 4.0.1pl2 
Note: Be aware, that the behaviour of require_once() and include_once() 
may not be what you expect on a non case sensitive operating system 
(such as Windows). Example 11-8. require_once() is case 
insensitive on Windows
    <?php
    require_once("a.php"); // this will include a.php
    require_once("A.php"); // this will include a.php again on 
    Windows!
    ?> 
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 

See also require(), include(), include_once(), get_required_files(), 
get_included_files(), readfile(), and virtual().   include()Upinclude_once()

  PrevChapter 11. Control StructuresNext

require()
The require() statement includes and evaluates the specific file. 
require() includes and evaluates a specific file. Detailed information on 
how this inclusion works is described in the documentation for include(). 
require() and include() are identical in every way except how they handle 
failure. include() produces a Warning while require() results in a Fatal 
Error. In other words, don't hesitate to use require() if you want a 
missing file to halt processing of the page. include() does not behave 
this way, the script will continue regardless. Be sure to have an 
appropriate include_path setting as well. 
Example 11-2. Basic require() examples
  <?php

  require 'prepend.php';

  require $somefile;

  require ('somefile.txt');

  ?> 
See the include() documentation for more examples. 
Note: Prior to PHP 4.0.2, the following applies: require() will always 
attempt to read the target file, even if the line it's on never 
executes. The conditional statement won't affect require(). However, if 
the line on which the require() occurs is not executed, neither will any 
of the code in the target file be executed. Similarly, looping 
structures do not affect the behaviour of require(). Although the code 
contained in the target file is still subject to the loop, the require() 
itself happens only once. 
Note: Because this is a language construct and not a function, it cannot 
be called using variable functions
Warning
Windows versions of PHP prior to PHP 4.3.0 do not support accessing 
remote files via this function, even if allow_url_fopen is enabled. 

See also include(), require_once(), include_once(), eval(), file(), 
readfile(), virtual() and include_path.   returnUpinclude()
#

#T=bool rename ( string oldname, string newname [, resource context])
rename ( ^!string oldname, string newname [, resource context]);
#

#T=reset - mixed reset ( array array)
(PHP 3, PHP 4 )
reset --  Set the internal pointer of an array to its first element 
Description
mixed reset ( array array)
reset() rewinds array's internal pointer to the first element and returns 
the value of the first array element. 
Example 1. reset() example
  <?php

  $array = array('step one', 'step two', 'step three', 'step 
  four');
    
  // by default, the pointer is on the first element  
  echo current($array) . "<br />\n"; // "step one"

  // skip two steps    
  next($array);                                 
  next($array);
  echo current($array) . "<br />\n"; // "step three"
    
  // reset pointer, start again on step one
  reset($array);
  echo current($array) . "<br />\n"; // "step one"
    
  ?> 
See also current(), each(), next(), and prev().   rangeUprsort
#

#T=mixed reset ( array array)
reset ( ^!array array);
#

#T=restore_error_handler - void restore_error_handler ( void )
(PHP 4 >= 4.0.1)
restore_error_handler --  Restores the previous error handler function 
Description
void restore_error_handler ( void )
Used after changing the error handler function using set_error_handler(), 
to revert to the previous error handler (which could be the built-in or a 
user defined function) 
See also error_reporting(), set_error_handler(), trigger_error().   error_reportingUpset_error_handler
#

#T=void restore_error_handler ( void )
restore_error_handler ( ^!void );
#

#T=restore_include_path - void restore_include_path ( void )
(PHP 4 >= 4.3.0)
restore_include_path --  Restores the value of the include_path 
configuration option 
Description
void restore_include_path ( void )
Restores the include_path configuration option back to its original master 
value as set in php.ini 
Example 1. restore_include_path() example
  <?php

  echo get_include_path();  // .:/usr/local/lib/php

  set_include_path('/inc');

  echo get_include_path();  // /inc

  // Works as of PHP 4.3.0
  restore_include_path();

  // Works in all PHP versions
  ini_restore('include_path');

  echo get_include_path();  // .:/usr/local/lib/php

  ?> 
See also ini_restore(), set_include_path(), get_include_path(), and 
include().   putenvUpset_include_path

  PrevChapter 11. Control StructuresNext

return
If called from within a function, the return() statement immediately ends 
execution of the current function, and returns its argument as the value 
of the function call. return() will also end the execution of an eval() 
statement or script file. 
If called from the global scope, then execution of the current script file 
is ended. If the current script file was include()ed or require()ed, then 
control is passed back to the calling file. Furthermore, if the current 
script file was include()ed, then the value given to return() will be 
returned as the value of the include() call. If return() is called from 
within the main script file, then script execution ends. If the current 
script file was named by the auto_prepend_file or auto_append_file 
configuration options in php.ini, then that script file's execution is 
ended. 
For more information, see Returning values. 
Note: Note that since return() is a language construct and not a 
function, the parentheses surrounding its arguments are only required if 
the argument contains an expression. It is common to leave them out 
while returning a variable.   declareUprequire()
#

#T=void restore_include_path ( void )
restore_include_path ( ^!void );
#

#T=rewind - bool rewind ( resource handle)
(PHP 3, PHP 4 )
rewind -- Rewind the position of a file pointer
Description
bool rewind ( resource handle)
Sets the file position indicator for handle to the beginning of the file 
stream. 
Returns TRUE on success or FALSE on failure. 
The file pointer must be valid, and must point to a file successfully 
opened by fopen(). 
Note: If you have opened the file in append ("a") mode, any data you 
write to the file will always be appended, regardless of the file 
position. 
See also fseek() and ftell().   renameUprmdir
#

#T=bool rewind ( resource handle)
rewind ( ^!resource handle);
#

#T=rewinddir - void rewinddir ( resource dir_handle)
(PHP 3, PHP 4 )
rewinddir -- rewind directory handle
Description
void rewinddir ( resource dir_handle)
Resets the directory stream indicated by dir_handle to the beginning of 
the directory.   readdirUpscandir
#

#T=void rewinddir ( resource dir_handle)
rewinddir ( ^!resource dir_handle);
#

#T=rmdir - bool rmdir ( string dirname [, resource context])
(PHP 3, PHP 4 )
rmdir -- Removes directory
Description
bool rmdir ( string dirname [, resource context])
Attempts to remove the directory named by dirname. The directory must be 
empty, and the relevant permissions must permit this. Returns TRUE on 
success or FALSE on failure. 
Note: As of PHP 5.0.0 rmdir() can also be used with some url wrappers. 
Refer to Appendix I for a listing of which wrappers support rmdir(). 
Note: The context parameter was added as of PHP 5.0.0. 
Note: When safe mode is enabled, PHP checks whether the directory in 
which you are about to operate has the same UID (owner) as the script 
that is being executed.
See also mkdir() and unlink().   rewindUpset_file_buffer
#

#T=bool rmdir ( string dirname [, resource context])
rmdir ( ^!string dirname [, resource context]);
#

#T=round - float round ( float val [, int precision])
(PHP 3, PHP 4 )
round -- Rounds a float
Description
float round ( float val [, int precision])
Returns the rounded value of val to specified precision (number of digits 
after the decimal point). precision can also be negative or zero 
(default). 
Example 1. round() examples
  <?php
  echo round(3.4);         // 3
  echo round(3.5);         // 4
  echo round(3.6);         // 4
  echo round(3.6, 0);      // 4
  echo round(1.95583, 2);  // 1.96
  echo round(1241757, -3); // 1242000
  echo round(5.045, 2);    // 5.04
  echo round(5.055, 2);    // 5.06
  ?> 
Note: PHP doesn't handle strings like "12,300.2" correctly by default. 
See converting from strings. 
Note: The precision parameter is only available in PHP 4. 
See also ceil(), floor() and number_format().   randUpsin
#

#T=float round ( float val [, int precision])
round ( ^!float val [, int precision]);
#

#T=rsort - bool rsort ( array array [, int sort_flags])
(PHP 3, PHP 4 )
rsort -- Sort an array in reverse order
Description
bool rsort ( array array [, int sort_flags])
This function sorts an array in reverse order (highest to lowest). 
Returns TRUE on success or FALSE on failure. 
Example 1. rsort() example
  <?php
  $fruits = array("lemon", "orange", "banana", "apple");
  rsort($fruits);
  reset($fruits);
  while (list($key, $val) = each($fruits)) {
      echo "$key = $val\n";
  }
  ?> 

This example would display: 
0 = orange
1 = lemon
2 = banana
3 = apple
The fruits have been sorted in reverse alphabetical order. 
You may modify the behavior of the sort using the optional parameter 
sort_flags, for details see sort(). 
See also arsort(), asort(), ksort(), sort(), and usort().   resetUpshuffle
#

#T=bool rsort ( array array [, int sort_flags])
rsort ( ^!array array [, int sort_flags]);
#

#T=rtrim - string rtrim ( string str [, string charlist])
(PHP 3, PHP 4 )
rtrim --  Strip whitespace from the end of a string 
Description
string rtrim ( string str [, string charlist])
Note: The second parameter was added in PHP 4.1.0 
This function returns a string with whitespace stripped from the end of 
str. Without the second parameter, rtrim() will strip these characters: 
" " (ASCII 32 (0x20)), an ordinary space. 
"\t" (ASCII 9 (0x09)), a tab. 
"\n" (ASCII 10 (0x0A)), a new line (line feed). 
"\r" (ASCII 13 (0x0D)), a carriage return. 
"\0" (ASCII 0 (0x00)), the NUL-byte. 
"\x0B" (ASCII 11 (0x0B)), a vertical tab. 
You can also specify the characters you want to strip, by means of the 
charlist parameter. Simply list all characters that you want to be 
stripped. With .. you can specify a range of characters. 
Example 1. Usage example of rtrim()
  <?php

  $text = "\t\tThese are a few words :) ...  ";
  $trimmed = rtrim($text);
  // $trimmed = "\t\tThese are a few words :) ..."
  $trimmed = rtrim($text, " \t.");
  // $trimmed = "\t\tThese are a few words :)"
  $clean = rtrim($binary, "\0x00..\0x1F");
  // trim the ASCII control characters at the end of $binary 
  // (from 0 to 31 inclusive)

  ?> 
See also trim() and ltrim().   quotemetaUpsetlocale
#

#T=string rtrim ( string str [, string charlist])
rtrim ( ^!string str [, string charlist]);
#

#T=scandir - array scandir ( string directory [, int sorting_order])
(PHP 5 CVS only)
scandir --  List files and directories inside the specified path 
Description
array scandir ( string directory [, int sorting_order])
Returns an array of files and directories from the directory. If directory 
is not a directory, then boolean FALSE is returned, and an error of level 
E_WARNING is generated. 
By default, the sorted order is alphabetical in ascending order. If the 
optional sorting_order is used (set to 1), then sort order is alphabetical 
in descending order. 
Example 1. A simple scandir() example
  <?php
  $dir    = '/tmp';
  $files1 = scandir($dir);
  $files2 = scandir($dir, 1);

  print_r($files1);
  print_r($files2);
  ?> 

Outputs something like: 
Array
(
[0] => .
[1] => ..
[2] => bar.php
[3] => foo.txt
[4] => somedir
)
Array
(
[0] => somedir
[1] => foo.txt
[2] => bar.php
[3] => ..
[4] => .
)
Example 2. PHP 4 alternatives to scandir()
  <?php
  $dir = "/tmp";
  $dh  = opendir($dir);
  while (false !== ($filename = readdir($dh))) {
      $files[] = $filename;
  }

  sort($files);

  print_r($files);

  rsort($files);

  print_r($files);

  ?> 

Outputs something like: 
Array
(
[0] => .
[1] => ..
[2] => bar.php
[3] => foo.txt
[4] => somedir
)
Array
(
[0] => somedir
[1] => foo.txt
[2] => bar.php
[3] => ..
[4] => .
)
See also opendir(), readdir(), glob(), is_dir(), and sort().   rewinddirUpDOM XML functions
#

#T=array scandir ( string directory [, int sorting_order])
scandir ( ^!string directory [, int sorting_order]);
#

#T=sem_acquire - bool sem_acquire ( int sem_identifier)
(PHP 3>= 3.0.6, PHP 4 )
sem_acquire -- Acquire a semaphore
Description
bool sem_acquire ( int sem_identifier)
sem_acquire() blocks (if necessary) until the semaphore can be acquired. A 
process attempting to acquire a semaphore which it has already acquired 
will block forever if acquiring the semaphore would cause its max_acquire 
value to be exceeded. 
Returns TRUE on success or FALSE on failure. 
After processing a request, any semaphores acquired by the process but not 
explicitly released will be released automatically and a warning will be 
generated. 
See also: sem_get() and sem_release().   msg_stat_queueUpsem_get
#

#T=bool sem_acquire ( int sem_identifier)
sem_acquire ( ^!int sem_identifier);
#

#T=sem_get - int sem_get ( int key [, int max_acquire [, int perm]])
(PHP 3>= 3.0.6, PHP 4 )
sem_get -- Get a semaphore id
Description
int sem_get ( int key [, int max_acquire [, int perm]])
sem_get() returns an id that can be used to access the System V semaphore 
with the given key. The semaphore is created if necessary using the 
permission bits specified in perm (defaults to 0666). The number of 
processes that can acquire the semaphore simultaneously is set to 
max_acquire (defaults to 1). Actually this value is set only if the 
process finds it is the only process currently attached to the semaphore. 
Returns: A positive semaphore identifier on success, or FALSE on error. 
A second call to sem_get() for the same key will return a different 
semaphore identifier, but both identifiers access the same underlying 
semaphore. 
See also sem_acquire(), sem_release(), and ftok(). 
Note: This function does not work on Windows systems.   sem_acquireUpsem_release
#

#T=int sem_get ( int key [, int max_acquire [, int perm]])
sem_get ( ^!int key [, int max_acquire [, int perm]]);
#

#T=sem_release - bool sem_release ( int sem_identifier)
(PHP 3>= 3.0.6, PHP 4 )
sem_release -- Release a semaphore
Description
bool sem_release ( int sem_identifier)
sem_release() releases the semaphore if it is currently acquired by the 
calling process, otherwise a warning is generated. 
Returns TRUE on success or FALSE on failure. 
After releasing the semaphore, sem_acquire() may be called to re-acquire 
it. 
See also sem_get() and sem_acquire(). 
Note: This function does not work on Windows systems.   sem_getUpsem_remove
#

#T=bool sem_release ( int sem_identifier)
sem_release ( ^!int sem_identifier);
#

#T=sem_remove - bool sem_remove ( int sem_identifier)
(PHP 4 >= 4.1.0)
sem_remove -- Remove a semaphore
Description
bool sem_remove ( int sem_identifier)
sem_remove() removes the semaphore sem_identifier if it has been created 
by sem_get(), otherwise generates a warning. 
Returns TRUE on success or FALSE on failure. 
After removing the semaphore, it is no more accessible. 
See also: sem_get(), sem_release() and sem_acquire(). 
Note: This function does not work on Windows systems. It was added on 
PHP 4.1.0.   sem_releaseUpshm_attach
#

#T=bool sem_remove ( int sem_identifier)
sem_remove ( ^!int sem_identifier);
#

#T=serialize - string serialize ( mixed value)
(PHP 3>= 3.0.5, PHP 4 )
serialize --  Generates a storable representation of a value 
Description
string serialize ( mixed value)
serialize() returns a string containing a byte-stream representation of 
value that can be stored anywhere. 
This is useful for storing or passing PHP values around without losing 
their type and structure. 
To make the serialized string into a PHP value again, use unserialize(). 
serialize() handles all types, except the resource-type. You can even 
serialize() arrays that contain references to itself. References inside 
the array/object you are serialize()ing will also be stored. 
When serializing objects, PHP will attempt to call the member function 
__sleep() prior to serialization. This is to allow the object to do any 
last minute clean-up, etc. prior to being serialized. Likewise, when the 
object is restored using unserialize() the __wakeup() member function is 
called. 
Note: In PHP 3, object properties will be serialized, but methods are 
lost. PHP 4 removes that limitation and restores both properties and 
methods. Please see the Serializing Objects section of Classes and 
Objects for more information. 
Example 1. serialize() example
  <?php
  // $session_data contains a multi-dimensional array with 
  session
  // information for the current user.  We use serialize() to 
  store
  // it in a database at the end of the request.

  $conn = odbc_connect("webdb", "php", "chicken");
  $stmt = odbc_prepare($conn,
	"UPDATE sessions SET data = ? WHERE id = ?");
  $sqldata = array (serialize($session_data), $PHP_AUTH_USER);
  if (!odbc_execute($stmt, &$sqldata)) {
      $stmt = odbc_prepare($conn,
       "INSERT INTO sessions (id, data) VALUES(?, ?)");
      if (!odbc_execute($stmt, &$sqldata)) {
	  /* Something went wrong.. */
      }
  }
  ?> 
See Also: unserialize().   print_rUpsettype
#

#T=string serialize ( mixed value)
serialize ( ^!mixed value);
#

#T=sesam_affected_rows - int sesam_affected_rows ( string result_id)
(PHP 3 CVS only)
sesam_affected_rows --  Get number of rows affected by an immediate query 
Description
int sesam_affected_rows ( string result_id)
result_id is a valid result id returned by sesam_query(). 
Returns the number of rows affected by a query associated with result_id. 
The sesam_affected_rows() function can only return useful values when used 
in combination with "immediate" SQL statements (updating operations like 
INSERT, UPDATE and DELETE) because SESAM does not deliver any "affected 
rows" information for "select type" queries. The number returned is the 
number of affected rows. 
Example 1. sesam_affected_rows() example
  <?php
  $result = sesam_execimm("DELETE FROM PHONE WHERE LASTNAME = '" 
  . strtoupper($name) . "'");
  if (!$result) {
      /* ... error ... */
  }
  echo sesam_affected_rows($result).
      " entries with last name " . $name . " deleted.\n";
  ?> 
See also sesam_query() and sesam_execimm().   SESAM database functionsUpsesam_commit
#

#T=int sesam_affected_rows ( string result_id)
sesam_affected_rows ( ^!string result_id);
#

#T=sesam_commit - bool sesam_commit ( void )
(PHP 3 CVS only)
sesam_commit --  Commit pending updates to the SESAM database 
Description
bool sesam_commit ( void )
Returns: TRUE on success, FALSE on errors 
sesam_commit() commits any pending updates to the database. 
Note that there is no "auto-commit" feature as in other databases, as it 
could lead to accidental data loss. Uncommitted data at the end of the 
current script (or when calling sesam_disconnect()) will be discarded by 
an implied sesam_rollback() call. 
See also: sesam_rollback(). Example 1. Committing an update to the 
SESAM database
  <?php
  if (sesam_connect ("mycatalog", "myschema", "otto")) {
      if (!sesam_execimm ("INSERT INTO mytable VALUES (*, 'Small 
  Test', <0, 8, 15>)"))
	  die("insert failed");
      if (!sesam_commit())
	  die("commit failed");
  }
  ?> 

  sesam_affected_rowsUpsesam_connect
#

#T=bool sesam_commit ( void )
sesam_commit ( ^!void );
#

#T=sesam_connect - bool sesam_connect ( string catalog, string schema, string user)
(PHP 3 CVS only)
sesam_connect -- Open SESAM database connection
Description
bool sesam_connect ( string catalog, string schema, string user)
Returns TRUE if a connection to the SESAM database was made, or FALSE on 
error. 
sesam_connect() establishes a connection to an SESAM database handler 
task. The connection is always "persistent" in the sense that only the 
very first invocation will actually load the driver from the configured 
SESAM OML PLAM library. Subsequent calls will reuse the driver and will 
immediately use the given catalog, schema, and user. 
When creating a database, the "catalog" name is specified in the SESAM 
configuration directive //ADD-SQL-DATABASE-CATALOG-LIST ENTRY-1 = 
*CATALOG(CATALOG-NAME = catalogname,...) 
The "schema" references the desired database schema (see SESAM handbook). 
The "user" argument references one of the users which are allowed to 
access this "catalog" / "schema" combination. Note that "user" is 
completely independent from both the system's user id's and from HTTP 
user/password protection. It appears in the SESAM configuration only. 
See also sesam_disconnect(). Example 1. Connect to a SESAM database
  <?php
  if (!sesam_connect ("mycatalog", "myschema", "otto")) {
      die("Unable to connect to SESAM");
  }
  ?> 

  sesam_commitUpsesam_diagnostic
#

#T=bool sesam_connect ( string catalog, string schema, string user)
sesam_connect ( ^!string catalog, string schema, string user);
#

#T=sesam_diagnostic - array sesam_diagnostic ( void )
(PHP 3 CVS only)
sesam_diagnostic --  Return status information for last SESAM call 
Description
array sesam_diagnostic ( void )
Returns an associative array of status and return codes for the last SQL 
query/statement/command. Elements of the array are: 
Table 1. Status information returned by sesam_diagnostic() 
ElementContents
$array["sqlstate"]5 digit SQL return code (see the SESAM manual for 
the description of the possible values of SQLSTATE) 
$array["rowcount"]number of affected rows in last 
update/insert/delete (set after "immediate" statements only) 
$array["errmsg"]"human readable" error message string (set after 
errors only) 
$array["errcol"]error column number of previous error (0-based; or 
-1 if undefined. Set after errors only) 
$array["errlin"]error line number of previous error (0-based; or -1 
if undefined. Set after errors only) 

In the following example, a syntax error (E SEW42AE ILLEGAL CHARACTER) is 
displayed by including the offending SQL statement and pointing to the 
error location: Example 1. Displaying SESAM error messages with 
error position
  <?php
  // Function which prints a formatted error message,
  // displaying a pointer to the syntax error in the
  // SQL statement
  function PrintReturncode($exec_str) {
      $err = Sesam_Diagnostic();
      $colspan=4; // 4 cols for: sqlstate, errlin, errcol, 
  rowcount
      if ($err["errlin"] == -1)
	  --$colspan;
      if ($err["errcol"] == -1)
	  --$colspan;
      if ($err["rowcount"] == 0)
	  --$colspan;
      echo "<table border=\"1\">\n";
      echo "<tr><th colspan=\"" . $colspan . "\"><span 
  class=\"spanred\">ERROR:</span> ".
	    htmlspecialchars($err["errmsg"]) . "</th></tr>\n";
      if ($err["errcol"] >= 0) {
	  echo "<tr><td colspan=\"" . $colspan . "\"><pre>\n";
	  $errstmt = $exec_str . "\n";
	  for ($lin=0; $errstmt != ""; ++$lin) {
	      if ($lin != $err["errlin"]) { // $lin is less or 
  greater than errlin
		  if (!($i = strchr($errstmt, "\n")))
		      $i = "";
		  $line = substr ($errstmt, 0, 
  strlen($errstmt)-strlen($i)+1);
		  $errstmt = substr($i, 1);
		  if ($line != "\n")
		      echo htmlspecialchars($line);
	      } else {
		  if (! ($i = strchr ($errstmt, "\n")))
		      $i = "";
		  $line = substr ($errstmt, 0, strlen 
  ($errstmt)-strlen($i)+1);
		  $errstmt = substr($i, 1);
		  for ($col=0; $col < $err["errcol"]; ++$col)
		      echo (substr($line, $col, 1) == "\t") ? 
  "\t" : ".";
		  echo "<span class=\"spanred\">\\</span>\n";
		  echo "<span class=\"normal\">" . 
  htmlspecialchars($line) . "</span>";
		  for ($col=0; $col < $err["errcol"]; ++$col)
		      echo (substr ($line, $col, 1) == "\t") ? 
  "\t" : ".";
		  echo "<span class=\"spanred\">/</span>\n";
	      }
	  }
	  echo "</pre></td></tr>\n";
      }
      echo "<tr>\n";
      echo " <td>sqlstate=" . $err["sqlstate"] . "</td>\n";
      if ($err["errlin"] != -1)
	  echo " <td>errlin=" . $err["errlin"] . "</td>\n";
      if ($err["errcol"] != -1)
	  echo " <td>errcol=" . $err["errcol"] . "</td>\n";
      if ($err["rowcount"] != 0)
	   echo " <td>rowcount=" . $err["rowcount"] . "</td>\n";
      echo "</tr>\n";
      echo "</table>\n";
  }

  if (!sesam_connect ("mycatalog", "phoneno", "otto"))
    die ("cannot connect");

  $stmt = "SELECT * FROM phone\n" .
	  " WHERE@ LASTNAME='KRAEMER'\n" .
	  " ORDER BY FIRSTNAME";
  if (!($result = sesam_query ($stmt)))
      PrintReturncode ($stmt);
  ?> 
See also: sesam_errormsg() for simple access to the error string only   sesam_connectUpsesam_disconnect
#

#T=array sesam_diagnostic ( void )
sesam_diagnostic ( ^!void );
#

#T=sesam_disconnect - bool sesam_disconnect ( void )
(PHP 3 CVS only)
sesam_disconnect -- Detach from SESAM connection
Description
bool sesam_disconnect ( void )
Returns: always TRUE. 
sesam_disconnect() closes the logical link to a SESAM database (without 
actually disconnecting and unloading the driver). 
Note that this isn't usually necessary, as the open connection is 
automatically closed at the end of the script's execution. Uncommitted 
data will be discarded, because an implicit sesam_rollback() is executed. 
sesam_disconnect() will not close the persistent link, it will only 
invalidate the currently defined "catalog", "schema" and "user" triple, so 
that any sesam function called after sesam_disconnect() will fail. 
Example 1. Closing a SESAM connection
  <?php
  if (sesam_connect ("mycatalog", "myschema", "otto")) {
      /* ... some queries and stuff ... */
      sesam_disconnect(); 
  }
  ?> 
See also sesam_connect().   sesam_diagnosticUpsesam_errormsg
#

#T=bool sesam_disconnect ( void )
sesam_disconnect ( ^!void );
#

#T=sesam_errormsg - string sesam_errormsg ( void )
(PHP 3 CVS only)
sesam_errormsg -- Returns error message of last SESAM call
Description
string sesam_errormsg ( void )
Returns the SESAM error message associated with the most recent SESAM 
error. 
Example 1. sesam_errormsg() example
  <?php
  if (!sesam_execimm($stmt)) {
    echo sesam_errormsg() . "<br />\n";
  }
  ?> 
See also sesam_diagnostic() for the full set of SESAM SQL status 
information.   sesam_disconnectUpsesam_execimm
#

#T=string sesam_errormsg ( void )
sesam_errormsg ( ^!void );
#

#T=sesam_execimm - string sesam_execimm ( string query)
(PHP 3 CVS only)
sesam_execimm -- Execute an "immediate" SQL-statement
Description
string sesam_execimm ( string query)
Returns: A SESAM "result identifier" on success, or FALSE on error. 
sesam_execimm() executes an "immediate" statement (i.e., a statement like 
UPDATE, INSERT or DELETE which returns no result, and has no INPUT or 
OUTPUT variables). "select type" queries can not be used with 
sesam_execimm(). Sets the affected_rows value for retrieval by the 
sesam_affected_rows() function. 
Note that sesam_query() can handle both "immediate" and "select-type" 
queries. Use sesam_execimm() only if you know beforehand what type of 
statement will be executed. An attempt to use SELECT type queries with 
sesam_execimm() will return $err["sqlstate"] == "42SBW". 
The returned "result identifier" can not be used for retrieving anything 
but the sesam_affected_rows(); it is only returned for symmetry with the 
sesam_query() function. 
<?php
$stmt = "INSERT INTO mytable VALUES ('one', 'two')";
$result = sesam_execimm($stmt);
$err = sesam_diagnostic();
echo "sqlstate = " . $err["sqlstate"] . "\n".
   "Affected rows = " . $err["rowcount"] . " == " .
   sesam_affected_rows($result) . "\n";
?> 

See also sesam_query() and sesam_affected_rows().   sesam_errormsgUpsesam_fetch_array
#

#T=string sesam_execimm ( string query)
sesam_execimm ( ^!string query);
#

#T=sesam_fetch_array - array sesam_fetch_array ( string result_id [, int whence [, int offset]])
(PHP 3 CVS only)
sesam_fetch_array -- Fetch one row as an associative array
Description
array sesam_fetch_array ( string result_id [, int whence [, int offset]])
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
sesam_fetch_array() is an alternative version of sesam_fetch_row(). 
Instead of storing the data in the numeric indices of the result array, it 
stores the data in associative indices, using the field names as keys. 
result_id is a valid result id returned by sesam_query() (select type 
queries only!). 
For the valid values of the optional whenceand offset parameters, see the 
sesam_fetch_row() function for details. 
sesam_fetch_array() fetches one row of data from the result associated 
with the specified result identifier. The row is returned as an 
associative array. Each result column is stored with an associative index 
equal to its column (aka. field) name. The column names are converted to 
lower case. 
Columns without a field name (e.g., results of arithmetic operations) and 
empty fields are not stored in the array. Also, if two or more columns of 
the result have the same column names, the later column will take 
precedence. In this situation, either call sesam_fetch_row() or make an 
alias for the column. 
SELECT TBL1.COL AS FOO, TBL2.COL AS BAR FROM TBL1, TBL2

A special handling allows fetching "multiple field" columns (which would 
otherwise all have the same column names). For each column of a "multiple 
field", the index name is constructed by appending the string "(n)" where 
n is the sub-index of the multiple field column, ranging from 1 to its 
declared repetition factor. The indices are NOT zero based, in order to 
match the nomenclature used in the respective query syntax. For a column 
declared as: 
CREATE TABLE ... ( ... MULTI(3) INT )

the associative indices used for the individual "multiple field" columns 
would be "multi(1)", "multi(2)", and "multi(3)" respectively. 
Subsequent calls to sesam_fetch_array() would return the next (or prior, 
or n'th next/prior, depending on the scroll attributes) row in the result 
set, or FALSE if there are no more rows. 
Example 1. SESAM fetch array
  <?php
  $result = sesam_query("SELECT * FROM phone\n" .
			 "  WHERE LASTNAME='" . 
  strtoupper($name) . "'\n".
			 "  ORDER BY FIRSTNAME", 1);
  if (!$result) {
      /* ... error ... */
  }
  // print the table:
  echo "<table border=\"1\">\n";
  while (($row = sesam_fetch_array($result)) && count($row) > 0) 
  {
      echo "<tr>\n";
      echo "<td>" . htmlspecialchars($row["firstname"]) . 
  "</td>\n";
      echo "<td>" . htmlspecialchars($row["lastname"]) . 
  "</td>\n";
      echo "<td>" . htmlspecialchars($row["phoneno"]) . 
  "</td>\n";
      echo "</tr>\n";
  }
  echo "</table>\n";
  sesam_free_result($result);
  ?> 
See also: sesam_fetch_row() which returns an indexed array.   sesam_execimmUpsesam_fetch_result
#

#T=array sesam_fetch_array ( string result_id [, int whence [, int offset]])
sesam_fetch_array ( ^!string result_id [, int whence [, int offset]]);
#

#T=sesam_fetch_result - mixed sesam_fetch_result ( string result_id [, int max_rows])
(PHP 3 CVS only)
sesam_fetch_result -- Return all or part of a query result
Description
mixed sesam_fetch_result ( string result_id [, int max_rows])
Returns a mixed array with the query result entries, optionally limited to 
a maximum of max_rows rows. Note that both row and column indexes are 
zero-based. 
Table 1. Mixed result set returned by sesam_fetch_result() 
Array ElementContents
int $arr["count"]number of columns in result set (or zero if this 
was an "immediate" query) 
int $arr["rows"]number of rows in result set (between zero and 
max_rows) 
bool $arr["truncated"]TRUE if the number of rows was at least 
max_rows, FALSE otherwise. Note that even when this is TRUE, the 
next sesam_fetch_result() call may return zero rows because there 
are no more result entries. 
mixed $arr[col][row]result data for all the fields at row(row) and 
column(col), (where the integer index row is between 0 and 
$arr["rows"]-1, and col is between 0 and $arr["count"]-1). Fields 
may be empty, so you must check for the existence of a field by 
using the php isset() function. The type of the returned fields 
depend on the respective SQL type declared for its column (see SESAM 
overview for the conversions applied). SESAM "multiple fields" are 
"inlined" and treated like a sequence of columns. 

Note that the amount of memory used up by a large query may be gigantic. 
Use the max_rows parameter to limit the maximum number of rows returned, 
unless you are absolutely sure that your result will not use up all 
available memory. 
See also: sesam_fetch_row(), and sesam_field_array() to check for 
"multiple fields". See the description of the sesam_query() function for a 
complete example using sesam_fetch_result().   sesam_fetch_arrayUpsesam_fetch_row
#

#T=mixed sesam_fetch_result ( string result_id [, int max_rows])
sesam_fetch_result ( ^!string result_id [, int max_rows]);
#

#T=sesam_fetch_row - array sesam_fetch_row ( string result_id [, int whence [, int offset]])
(PHP 3 CVS only)
sesam_fetch_row -- Fetch one row as an array
Description
array sesam_fetch_row ( string result_id [, int whence [, int offset]])
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
The number of columns in the result set is returned in an associative 
array element $array["count"]. Because some of the result columns may be 
empty, the count() function can not be used on the result row returned by 
sesam_fetch_row(). 
result_id is a valid result id returned by sesam_query() (select type 
queries only!). 
whence is an optional parameter for a fetch operation on "scrollable" 
cursors, which can be set to the following predefined constants: 
Table 1. Valid values for "whence" parameter
ValueConstantMeaning
0SESAM_SEEK_NEXTread sequentially (after fetch, the internal default 
is set to SESAM_SEEK_NEXT) 
1SESAM_SEEK_PRIORread sequentially backwards (after fetch, the 
internal default is set to SESAM_SEEK_PRIOR) 
2SESAM_SEEK_FIRSTrewind to first row (after fetch, the default is 
set to SESAM_SEEK_NEXT) 
3SESAM_SEEK_LASTseek to last row (after fetch, the default is set to 
SESAM_SEEK_PRIOR) 
4SESAM_SEEK_ABSOLUTEseek to absolute row number given as offset 
(Zero-based. After fetch, the internal default is set to 
SESAM_SEEK_ABSOLUTE, and the internal offset value is 
auto-incremented) 
5SESAM_SEEK_RELATIVEseek relative to current scroll position, where 
offset can be a positive or negative offset value. 

This parameter is only valid for "scrollable" cursors. 
When using "scrollable" cursors, the cursor can be freely positioned on 
the result set. If the whence parameter is omitted, the global default 
values for the scrolling type (initialized to: SESAM_SEEK_NEXT, and 
settable by sesam_seek_row()) are used. If whence is supplied, its value 
replaces the global default. 
offset is an optional parameter which is only evaluated (and required) if 
whence is either SESAM_SEEK_RELATIVE or SESAM_SEEK_ABSOLUTE. This 
parameter is only valid for "scrollable" cursors. 
sesam_fetch_row() fetches one row of data from the result associated with 
the specified result identifier. The row is returned as an array (indexed 
by values between 0 and $array["count"]-1). Fields may be empty, so you 
must check for the existence of a field by using the isset() function. The 
type of the returned fields depend on the respective SQL type declared for 
its column (see SESAM overview for the conversions applied). SESAM 
"multiple fields" are "inlined" and treated like a sequence of columns. 
Subsequent calls to sesam_fetch_row() would return the next (or prior, or 
n'th next/prior, depending on the scroll attributes) row in the result 
set, or FALSE if there are no more rows. 
Example 1. SESAM fetch rows
  <?php
  $result = sesam_query("SELECT * FROM phone\n" .
			 "  WHERE LASTNAME='" . 
  strtoupper($name) . "'\n" .
			 "  ORDER BY FIRSTNAME", 1);
  if (!$result) {
      /* ... error ... */
  }
  // print the table in backward order
  echo "<table border=\"1\">\n";
  $row = sesam_fetch_row($result, SESAM_SEEK_LAST);
  while (is_array($row)) {
      echo "<tr>\n";
      for ($col = 0; $col < $row["count"]; ++$col) {
	  echo "<td>" . htmlspecialchars($row[$col]) . 
"</td>\n";
      }
      echo "</tr>\n";
      // use implied SESAM_SEEK_PRIOR
      $row = sesam_fetch_row($result);
  }
  echo "</table>\n";
  sesam_free_result($result);
  ?> 
See also: sesam_fetch_array() which returns an associative array, and 
sesam_fetch_result() which returns many rows per invocation.   sesam_fetch_resultUpsesam_field_array
#

#T=array sesam_fetch_row ( string result_id [, int whence [, int offset]])
sesam_fetch_row ( ^!string result_id [, int whence [, int offset]]);
#

#T=sesam_field_array - array sesam_field_array ( string result_id)
(PHP 3 CVS only)
sesam_field_array --  Return meta information about individual columns in 
a result 
Description
array sesam_field_array ( string result_id)
result_id is a valid result id returned by sesam_query(). 
Returns a mixed associative/indexed array with meta information (column 
name, type, precision, ...) about individual columns of the result after 
the query associated with result_id. 
Table 1. Mixed result set returned by sesam_field_array() 
Array ElementContents
int $arr["count"]Total number of columns in result set (or zero if 
this was an "immediate" query). SESAM "multiple fields" are 
"inlined" and treated like the respective number of columns. 
string $arr[col]["name"]column name for column(col), where col is 
between 0 and $arr["count"]-1. The returned value can be the empty 
string (for dynamically computed columns). SESAM "multiple fields" 
are "inlined" and treated like the respective number of columns, 
each with the same column name. 
string $arr[col]["count"]The "count" attribute describes the 
repetition factor when the column has been declared as a "multiple 
field". Usually, the "count" attribute is 1. The first column of a 
"multiple field" column however contains the number of repetitions 
(the second and following column of the "multiple field" contain a 
"count" attribute of 1). This can be used to detect "multiple 
fields" in the result set. See the example shown in the 
sesam_query() description for a sample use of the "count" attribute. 

string $arr[col]["type"]PHP variable type of the data for 
column(col), where col is between 0 and $arr["count"]-1. The 
returned value can be one of 
integer
float
string
depending on the SQL type of the result. SESAM "multiple fields" are 
"inlined" and treated like the respective number of columns, each 
with the same PHP type. 
string $arr[col]["sqltype"]SQL variable type of the column data for 
column(col), where col is between 0 and $arr["count"]-1. The 
returned value can be one of 
"CHARACTER"
"VARCHAR"
"NUMERIC"
"DECIMAL"
"INTEGER"
"SMALLINT"
"FLOAT"
"REAL"
"DOUBLE"
"DATE"
"TIME"
"TIMESTAMP"
describing the SQL type of the result. SESAM "multiple fields" are 
"inlined" and treated like the respective number of columns, each 
with the same SQL type. 
string $arr[col]["length"]The SQL "length" attribute of the SQL 
variable in column(col), where col is between 0 and $arr["count"]-1. 
The "length" attribute is used with "CHARACTER" and "VARCHAR" SQL 
types to specify the (maximum) length of the string variable. SESAM 
"multiple fields" are "inlined" and treated like the respective 
number of columns, each with the same length attribute. 
string $arr[col]["precision"]The "precision" attribute of the SQL 
variable in column(col), where col is between 0 and $arr["count"]-1. 
The "precision" attribute is used with numeric and time data types. 
SESAM "multiple fields" are "inlined" and treated like the 
respective number of columns, each with the same precision 
attribute. 
string $arr[col]["scale"]The "scale" attribute of the SQL variable 
in column(col), where col is between 0 and $arr["count"]-1. The 
"scale" attribute is used with numeric data types. SESAM "multiple 
fields" are "inlined" and treated like the respective number of 
columns, each with the same scale attribute. 

See also sesam_query() for an example of the sesam_field_array() use.   sesam_fetch_rowUpsesam_field_name
#

#T=array sesam_field_array ( string result_id)
sesam_field_array ( ^!string result_id);
#

#T=sesam_field_name - int sesam_field_name ( string result_id, int index)
(PHP 3 CVS only)
sesam_field_name --  Return one column name of the result set 
Description
int sesam_field_name ( string result_id, int index)
Returns the name of a field (i.e., the column name) in the result set, or 
FALSE on error. 
For "immediate" queries, or for dynamic columns, an empty string is 
returned. 
Note: The column index is zero-based, not one-based as in SESAM. 
See also: sesam_field_array(). It provides an easier interface to access 
the column names and types, and allows for detection of "multiple fields". 
  sesam_field_arrayUpsesam_free_result
#

#T=int sesam_field_name ( string result_id, int index)
sesam_field_name ( ^!string result_id, int index);
#

#T=sesam_free_result - int sesam_free_result ( string result_id)
(PHP 3 CVS only)
sesam_free_result -- Releases resources for the query
Description
int sesam_free_result ( string result_id)
Releases resources for the query associated with result_id. Returns FALSE 
on error.   sesam_field_nameUpsesam_num_fields
#

#T=int sesam_free_result ( string result_id)
sesam_free_result ( ^!string result_id);
#

#T=sesam_num_fields - int sesam_num_fields ( string result_id)
(PHP 3 CVS only)
sesam_num_fields --  Return the number of fields/columns in a result set 
Description
int sesam_num_fields ( string result_id)
After calling sesam_query() with a "select type" query, this function 
gives you the number of columns in the result. Returns an integer 
describing the total number of columns (aka. fields) in the current 
result_id result set or FALSE on error. 
For "immediate" statements, the value zero is returned. The SESAM 
"multiple field" columns count as their respective dimension, i.e., a 
three-column "multiple field" counts as three columns. 
See also: sesam_query() and sesam_field_array() for a way to distinguish 
between "multiple field" columns and regular columns.   sesam_free_resultUpsesam_query
#

#T=int sesam_num_fields ( string result_id)
sesam_num_fields ( ^!string result_id);
#

#T=sesam_query - string sesam_query ( string query [, bool scrollable])
(PHP 3 CVS only)
sesam_query -- Perform a SESAM SQL query and prepare the result
Description
string sesam_query ( string query [, bool scrollable])
Returns: A SESAM "result identifier" on success, or FALSE on error. 
A "result_id" resource is used by other functions to retrieve the query 
results. 
sesam_query() sends a query to the currently active database on the 
server. It can execute both "immediate" SQL statements and "select type" 
queries. If an "immediate" statement is executed, then no cursor is 
allocated, and any subsequent sesam_fetch_row() or sesam_fetch_result() 
call will return an empty result (zero columns, indicating end-of-result). 
For "select type" statements, a result descriptor and a (scrollable or 
sequential, depending on the optional boolean scrollable parameter) cursor 
will be allocated. If scrollable is omitted, the cursor will be 
sequential. 
When using "scrollable" cursors, the cursor can be freely positioned on 
the result set. For each "scrollable" query, there are global default 
values for the scrolling type (initialized to: SESAM_SEEK_NEXT) and the 
scrolling offset which can either be set once by sesam_seek_row() or each 
time when fetching a row using sesam_fetch_row(). 
For "immediate" statements, the number of affected rows is saved for 
retrieval by the sesam_affected_rows() function. 
See also: sesam_fetch_row() and sesam_fetch_result(). Example 1. 
Show all rows of the "phone" table as a HTML table 
  <?php
  if (!sesam_connect("phonedb", "demo", "otto"))
      die("cannot connect");
  $result = sesam_query("select * from phone");
  if (!$result) {
      $err = sesam_diagnostic();
      die $err["errmsg"]);
  }
  echo "<table border>\n";
  // Add title header with column names above the result:
  if ($cols = sesam_field_array($result)) {
      echo "<tr><th colspan=" . $cols["count"] . 
  ">Result:</th></tr>\n";
      echo "<tr>\n";
      for ($col = 0; $col < $cols["count"]; ++$col) {
	  $colattr = $cols[$col];
	  /* Span the table head over SESAM's "Multiple Fields": 
  */
	  if ($colattr["count"] > 1) {
	      echo "<th colspan=\"" . $colattr["count"] . "\">" 
  . $colattr["name"] .
		  "(1.." . $colattr["count"] . ")</th>\n";
	      $col += $colattr["count"] - 1;
	  } else
	      echo "<th>" . $colattr["name"] . "</th>\n";
      }
      echo "</tr>\n";
  }

  do {
      // Fetch the result in chunks of 100 rows max.
      $ok = sesam_fetch_result($result, 100);
      for ($row=0; $row < $ok["rows"]; ++$row) {
	  echo " <tr>\n";
	  for ($col = 0; $col < $ok["cols"]; ++$col) {
	      if (isset($ok[$col][$row])) {
		  echo "<td>" . $ok[$col][$row] . "</td>\n";
	      } else {
		  echo "<td>-empty-</td>\n";
	      }
	  }
	  echo "</tr>\n";
      }
  } while ($ok["truncated"]); // while there may be more data

  echo "</table>\n";
  // free result id
  sesam_free_result($result);
  ?> 

  sesam_num_fieldsUpsesam_rollback
#

#T=string sesam_query ( string query [, bool scrollable])
sesam_query ( ^!string query [, bool scrollable]);
#

#T=sesam_rollback - bool sesam_rollback ( void )
(PHP 3 CVS only)
sesam_rollback --  Discard any pending updates to the SESAM database 
Description
bool sesam_rollback ( void )
Returns: TRUE on success, FALSE on errors 
sesam_rollback() discards any pending updates to the database. Also 
affected are result cursors and result descriptors. 
At the end of each script, and as part of the sesam_disconnect() function, 
an implied sesam_rollback() is executed, discarding any pending changes to 
the database. 
See also: sesam_commit(). Example 1. Discarding an update to the 
SESAM database
  <?php
  if (sesam_connect ("mycatalog", "myschema", "otto")) {
      if (sesam_execimm ("INSERT INTO mytable VALUES (*, 'Small 
  Test', <0, 8, 15>)")
	  && sesam_execimm ("INSERT INTO othertable VALUES (*, 
  'Another Test', 1)")) {
	  sesam_commit();
      } else {
	  sesam_rollback();
      }
  }
  ?> 

  sesam_queryUpsesam_seek_row
#

#T=bool sesam_rollback ( void )
sesam_rollback ( ^!void );
#

#T=sesam_seek_row - bool sesam_seek_row ( string result_id, int whence [, int offset])
(PHP 3 CVS only)
sesam_seek_row --  Set scrollable cursor mode for subsequent fetches 
Description
bool sesam_seek_row ( string result_id, int whence [, int offset])
result_id is a valid result id (select type queries only, and only if a 
"scrollable" cursor was requested when calling sesam_query()). 
whence sets the global default value for the scrolling type, it specifies 
the scroll type to use in subsequent fetch operations on "scrollable" 
cursors, which can be set to the following predefined constants: 
Table 1. Valid values for "whence" parameter
ValueConstantMeaning
0SESAM_SEEK_NEXTread sequentially 
1SESAM_SEEK_PRIORread sequentially backwards 
2SESAM_SEEK_FIRSTfetch first row (after fetch, the default is set to 
SESAM_SEEK_NEXT) 
3SESAM_SEEK_LASTfetch last row (after fetch, the default is set to 
SESAM_SEEK_PRIOR) 
4SESAM_SEEK_ABSOLUTEfetch absolute row number given as offset 
(Zero-based. After fetch, the default is set to SESAM_SEEK_ABSOLUTE, 
and the offset value is auto-incremented) 
5SESAM_SEEK_RELATIVEfetch relative to current scroll position, where 
offset can be a positive or negative offset value (this also sets 
the default "offset" value for subsequent fetches). 

offset is an optional parameter which is only evaluated (and required) if 
whence is either SESAM_SEEK_RELATIVE or SESAM_SEEK_ABSOLUTE.   sesam_rollbackUpsesam_settransaction
#

#T=bool sesam_seek_row ( string result_id, int whence [, int offset])
sesam_seek_row ( ^!string result_id, int whence [, int offset]);
#

#T=sesam_settransaction - bool sesam_settransaction ( int isolation_level, int read_only)
(PHP 3 CVS only)
sesam_settransaction -- Set SESAM transaction parameters
Description
bool sesam_settransaction ( int isolation_level, int read_only)
Returns: TRUE if the values are valid, and the settransaction() operation 
was successful, FALSE otherwise. 
sesam_settransaction() overrides the default values for the "isolation 
level" and "read-only" transaction parameters (which are set in the SESAM 
configuration file), in order to optimize subsequent queries and guarantee 
database consistency. The overridden values are used for the next 
transaction only. 
sesam_settransaction() can only be called before starting a transaction, 
not after the transaction has been started already. 
To simplify the use in PHP scripts, the following constants have been 
predefined in PHP (see SESAM handbook for detailed explanation of the 
semantics): 
Table 1. Valid values for "Isolation_Level" parameter 
ValueConstantMeaning
1SESAM_TXISOL_READ_UNCOMMITTEDRead Uncommitted
2SESAM_TXISOL_READ_COMMITTEDRead Committed
3SESAM_TXISOL_REPEATABLE_READRepeatable Read
4SESAM_TXISOL_SERIALIZABLESerializable

Table 2. Valid values for "Read_Only" parameter 
ValueConstantMeaning
0SESAM_TXREAD_READWRITERead/Write
1SESAM_TXREAD_READONLYRead-Only

The values set by sesam_settransaction() will override the default setting 
specified in the SESAM configuration file. 
Example 1. Setting SESAM transaction parameters
  <?php
  sesam_settransaction (SESAM_TXISOL_REPEATABLE_READ,
		       SESAM_TXREAD_READONLY);
  ?> 

  sesam_seek_rowUpSession handling functions
#

#T=bool sesam_settransaction ( int isolation_level, int read_only)
sesam_settransaction ( ^!int isolation_level, int read_only);
#

#T=session_cache_expire - int session_cache_expire ( [int new_cache_expire])
(PHP 4 >= 4.2.0)
session_cache_expire -- Return current cache expire
Description
int session_cache_expire ( [int new_cache_expire])
session_cache_expire() returns the current setting of 
session.cache_expire. The value returned should be read in minutes, 
defaults to 180. If new_cache_expire is given, the current cache expire is 
replaced with new_cache_expire. 
The cache expire is reset to the default value of 180 stored in 
session.cache_limiter at request startup time. Thus, you need to call 
session_cache_expire() for every request (and before session_start() is 
called). 
Example 1. session_cache_expire() example
  <?php

  /* set the cache limiter to 'private' */

  session_cache_limiter('private');
  $cache_limiter = session_cache_limiter();

  /* set the cache expire to 30 minutes */
  session_cache_expire(30);
  $cache_expire = session_cache_expire();

  /* start the session */

  session_start();

  echo "The cache limiter is now set to $cache_limiter</ br>";
  echo "The cached session pages expire after $cache_expire 
  minutes";
  ?> 
Note: Setting new_cache_expire is of value only, if 
session.cache_limiter is set to a value different from nocache. 
See also the configuration settings session.cache_expire, 
session.cache_limiter and session_cache_limiter().   Session handling functionsUpsession_cache_limiter
#

#T=int session_cache_expire ( [int new_cache_expire])
session_cache_expire ( ^![int new_cache_expire]);
#

#T=session_cache_limiter - string session_cache_limiter ( [string cache_limiter])
(PHP 4 >= 4.0.3)
session_cache_limiter -- Get and/or set the current cache limiter
Description
string session_cache_limiter ( [string cache_limiter])
session_cache_limiter() returns the name of the current cache limiter. If 
cache_limiter is specified, the name of the current cache limiter is 
changed to the new value. 
The cache limiter defines which cache control HTTP headers are sent to the 
client. These headers determine the rules by which the page content may be 
cached by the client and intermediate proxies. Setting the cache limiter 
to nocache disallows any client/proxy caching. A value of public permits 
caching by proxies and the client, whereas private disallows caching by 
proxies and permits the client to cache the contents. 
In private mode, the Expire header sent to the client may cause confusion 
for some browsers, including Mozilla. You can avoid this problem by using 
private_no_expire mode. The expire header is never sent to the client in 
this mode. 
Note: private_no_expire was added in PHP 4.2.0. 
The cache limiter is reset to the default value stored in 
session.cache_limiter at request startup time. Thus, you need to call 
session_cache_limiter() for every request (and before session_start() is 
called). 
Example 1. session_cache_limiter() example
  <?php

  /* set the cache limiter to 'private' */

  session_cache_limiter('private');
  $cache_limiter = session_cache_limiter();

  echo "The cache limiter is now set to $cache_limiter<p>";
  ?> 
Also see the session.cache_limiter configuration directive.   session_cache_expireUpsession_decode
#

#T=string session_cache_limiter ( [string cache_limiter])
session_cache_limiter ( ^![string cache_limiter]);
#

#T=session_decode - bool session_decode ( string data)
(PHP 4 )
session_decode -- Decodes session data from a string
Description
bool session_decode ( string data)
session_decode() decodes the session data in data, setting variables 
stored in the session. 
See also session_encode().   session_cache_limiterUpsession_destroy
#

#T=bool session_decode ( string data)
session_decode ( ^!string data);
#

#T=session_destroy - bool session_destroy ( void )
(PHP 4 )
session_destroy -- Destroys all data registered to a session
Description
bool session_destroy ( void )
session_destroy() destroys all of the data associated with the current 
session. It does not unset any of the global variables associated with the 
session, or unset the session cookie. 
This function returns TRUE on success and FALSE on failure to destroy the 
session data. 
Example 1. Destroying a session
  <?php

  // Initialize the session.
  // If you are using session_name("something"), don't forget it 
  now!
  session_start();
  // Unset all of the session variables.
  session_unset();
  // Finally, destroy the session.
  session_destroy();

  ?> 
Example 2. Destroying a session with $_SESSION
  <?php

  // Initialize the session.
  // If you are using session_name("something"), don't forget it 
  now!
  session_start();
  // Unset all of the session variables.
  $_SESSION = array();
  // Finally, destroy the session.
  session_destroy();

  ?> 

  session_decodeUpsession_encode
#

#T=bool session_destroy ( void )
session_destroy ( ^!void );
#

#T=session_encode - string session_encode ( void )
(PHP 4 )
session_encode --  Encodes the current session data as a string 
Description
string session_encode ( void )
session_encode() returns a string with the contents of the current session 
encoded within. 
See also session_decode()   session_destroyUpsession_get_cookie_params
#

#T=string session_encode ( void )
session_encode ( ^!void );
#

#T=session_get_cookie_params - array session_get_cookie_params ( void )
(PHP 4 )
session_get_cookie_params --  Get the session cookie parameters 
Description
array session_get_cookie_params ( void )
The session_get_cookie_params() function returns an array with the current 
session cookie information, the array contains the following items: 
"lifetime" - The lifetime of the cookie. 
"path" - The path where information is stored. 
"domain" - The domain of the cookie. 
"secure" - The cookie should only be sent over secure connections. (This 
item was added in PHP 4.0.4.) 
See also the configuration directives session.cookie_lifetime, 
session.cookie_path, session.cookie_domain, session.cookie_secure, and 
session_set_cookie_params().   session_encodeUpsession_id
#

#T=array session_get_cookie_params ( void )
session_get_cookie_params ( ^!void );
#

#T=session_id - string session_id ( [string id])
(PHP 4 )
session_id -- Get and/or set the current session id
Description
string session_id ( [string id])
session_id() returns the session id for the current session. 
If id is specified, it will replace the current session id. session_id() 
needs to be called before session_start() for that purpose. Depending on 
the session handler, not all characters are allowed within the session id. 
For example, the file session handler only allows characters in the range 
a-z, A-Z and 0-9! 
The constant SID can also be used to retrieve the current name and session 
id as a string suitable for adding to URLs. Note that SID is only defined 
if the client didn't send the right cookie. See also Session handling. 
See also session_start(), session_set_save_handler(), and 
session.save_handler.   session_get_cookie_paramsUpsession_is_registered
#

#T=string session_id ( [string id])
session_id ( ^![string id]);
#

#T=session_is_registered - bool session_is_registered ( string name)
(PHP 4 )
session_is_registered --  Find out whether a global variable is registered 
in a session 
Description
bool session_is_registered ( string name)
session_is_registered() returns TRUE if there is a global variable with 
the name name registered in the current session. 
Note: If $_SESSION (or $HTTP_SESSION_VARS for PHP 4.0.6 or less) is 
used, use isset() to check a variable is registered in $_SESSION. 
Caution
If you are using $_SESSION (or $HTTP_SESSION_VARS), do not use 
session_register(), session_is_registered() and 
session_unregister(). 
  session_idUpsession_module_name
#

#T=bool session_is_registered ( string name)
session_is_registered ( ^!string name);
#

#T=session_module_name - string session_module_name ( [string module])
(PHP 4 )
session_module_name -- Get and/or set the current session module
Description
string session_module_name ( [string module])
session_module_name() returns the name of the current session module. If 
module is specified, that module will be used instead.   session_is_registeredUpsession_name
#

#T=string session_module_name ( [string module])
session_module_name ( ^![string module]);
#

#T=session_name - string session_name ( [string name])
(PHP 4 )
session_name -- Get and/or set the current session name
Description
string session_name ( [string name])
session_name() returns the name of the current session. If name is 
specified, the name of the current session is changed to its value. 
The session name references the session id in cookies and URLs. It should 
contain only alphanumeric characters; it should be short and descriptive 
(i.e. for users with enabled cookie warnings). The session name is reset 
to the default value stored in session.name at request startup time. Thus, 
you need to call session_name() for every request (and before 
session_start() or session_register() are called). 
Example 1. session_name() examples
  <?php

  /* set the session name to WebsiteID */

  $previous_name = session_name("WebsiteID");

  echo "The previous session name was $previous_name<p>";
  ?> 
See also the session.name configuration directive.   session_module_nameUpsession_regenerate_id
#

#T=string session_name ( [string name])
session_name ( ^![string name]);
#

#T=session_regenerate_id - bool session_regenerate_id ( void )
(PHP 4 >= 4.3.2)
session_regenerate_id --  Update the current session id with a newly 
generated one 
Description
bool session_regenerate_id ( void )
session_regenerate_id() will replace the current session id with a new 
one, and keep the current session information. 
Returns TRUE on success or FALSE on failure. 
Example 1. A session_regenerate_id() example
  <?php
  session_start();

  $old_sessionid = session_id();

  session_regenerate_id();

  $new_sessionid = session_id();

  echo "Old Session: $old_sessionid<br />";
  echo "New Session: $new_sessionid<br />";

  print_r($_SESSION);
  ?> 
Note: As of PHP 4.3.3, if session cookies are enabled, use of 
session_regenerate_id() will also submit a new session cookie with the 
new session id. 
See also session_id(), session_start(), and session_name().   session_nameUpsession_register
#

#T=bool session_regenerate_id ( void )
session_regenerate_id ( ^!void );
#

#T=session_register - bool session_register ( mixed name [, mixed ...])
(PHP 4 )
session_register --  Register one or more global variables with the 
current session 
Description
bool session_register ( mixed name [, mixed ...])
session_register() accepts a variable number of arguments, any of which 
can be either a string holding the name of a variable or an array 
consisting of variable names or other arrays. For each name, 
session_register() registers the global variable with that name in the 
current session. 
Caution
If you want your script to work regardless of register_globals, you 
need to instead use the $_SESSION array as $_SESSION entries are 
automatically registered. If your script uses session_register(), it 
will not work in environments where the PHP directive 
register_globals is disabled. 

register_globals: important note: Since PHP 4.2.0, the default value for 
the PHP directive register_globals is off. The PHP community encourages 
all to not rely on this directive but instead use other means, such as 
the superglobals. 
Caution
This registers a global variable. If you want to register a session 
variable from within a function, you need to make sure to make it 
global using the global keyword or the $GLOBALS[] array, or use the 
special session arrays as noted below. 

Caution
If you are using $_SESSION (or $HTTP_SESSION_VARS), do not use 
session_register(), session_is_registered(), and 
session_unregister(). 

This function returns TRUE when all of the variables are successfully 
registered with the session. 
If session_start() was not called before this function is called, an 
implicit call to session_start() with no parameters will be made. 
$_SESSION does not mimic this behavior and requires session_start() before 
use. 
#

#T=bool session_register ( mixed name [, mixed ...])
session_register ( ^!mixed name [, mixed ...]);
#
You can also create a session variable by simp
#T=ly setting the appropriate  - string session_save_path ( [string path])
member of the $_SESSION or $HTTP_SESSION_VARS (PHP < 4.1.0) array. 
<?php
// Use of session_register() is deprecated
$barney = "A big purple dinosaur.";
session_register("barney");

// Use of $_SESSION is preferred, as of PHP 4.1.0
$_SESSION["zim"] = "An invader from another planet.";

// The old way was to use $HTTP_SESSION_VARS
$HTTP_SESSION_VARS["spongebob"] = "He's got square pants.";
?> 

Note: It is currently impossible to register resource variables in a 
session. For example, you cannot create a connection to a database and 
store the connection id as a session variable and expect the connection 
to still be valid the next time the session is restored. PHP functions 
that return a resource are identified by having a return type of 
resource in their function definition. A list of functions that return 
resources are available in the resource types appendix. 
If $_SESSION (or $HTTP_SESSION_VARS for PHP 4.0.6 or less) is used, 
assign values to $_SESSION. For example: $_SESSION['var'] = 'ABC'; 
See also session_is_registered(), session_unregister(), and $_SESSION.   session_regenerate_idUpsession_save_path
#

#T=session_save_path - string session_save_path ( [string path])
(PHP 4 )
session_save_path -- Get and/or set the current session save path
Description
string session_save_path ( [string path])
session_save_path() returns the path of the current directory used to save 
session data. If path is specified, the path to which data is saved will 
be changed. session_save_path() needs to be called before session_start() 
for that purpose. 
Note: On some operating systems, you may want to specify a path on a 
filesystem that handles lots of small files efficiently. For example, on 
Linux, reiserfs may provide better performance than ext2fs. 
See also the session.save_path configuration directive.   session_registerUpsession_set_cookie_params
#

#T=string session_save_path ( [string path])
session_save_path ( ^![string path]);
#

#T=session_set_cookie_params - void session_set_cookie_params ( int lifetime [, string path [, string 
(PHP 4 )
session_set_cookie_params --  Set the session cookie parameters 
Description
void session_set_cookie_params ( int lifetime [, string path [, string 
domain [, bool secure]]])
Set cookie parameters defined in the php.ini file. The effect of this 
function only lasts for the duration of the script. 
Note: The secure parameter was added in PHP 4.0.4. 
See also the configuration directives session.cookie_lifetime, 
session.cookie_path, session.cookie_domain, session.cookie_secure, and 
session_get_cookie_params().   session_save_pathUpsession_set_save_handler
#

#T=void session_set_cookie_params ( int lifetime [, string path [, string 
session_set_cookie_params ( ^!int lifetime [, string path [, string ;
#

#T=session_set_save_handler - bool session_set_save_handler ( string open, string close, string read, 
(PHP 4 )
session_set_save_handler --  Sets user-level session storage functions 
Description
bool session_set_save_handler ( string open, string close, string read, 
string write, string destroy, string gc)
session_set_save_handler() sets the user-level session storage functions 
which are used for storing and retrieving data associated with a session. 
This is most useful when a storage method other than those supplied by PHP 
sessions is preferred. i.e. Storing the session data in a local database. 
Returns TRUE on success or FALSE on failure. 
Note: The "write" handler is not executed until after the output stream 
is closed. Thus, output from debugging statements in the "write" handler 
will never be seen in the browser. If debugging output is necessary, it 
is suggested that the debug output be written to a file instead. 
Note: The write handler is not executed if the session contains no data; 
this applies even if empty session variables are registered. This 
differs to the default file-based session save handler, which creates 
empty session files. 
The following example provides file based session storage similar to the 
PHP sessions default save handler files. This example could easily be 
extended to cover database storage using your favorite PHP supported 
database engine. 
Read function must return string value always to make save handler work as 
expected. Return empty string if there is no data to read. Return values 
from other handlers are converted to boolean expression. TRUE for success, 
FALSE for failure. 
Example 1. session_set_save_handler() example 
  <?php
  function open($save_path, $session_name) {
    global $sess_save_path, $sess_session_name;
	 
    $sess_save_path = $save_path;
    $sess_session_name = $session_name;
    return(true);
  }

  function close() {
    return(true);
  }

  function read($id) {
    global $sess_save_path, $sess_session_name;

    $sess_file = "$sess_save_path/sess_$id";
    if ($fp = @fopen($sess_file, "r")) {
      $sess_data = fread($fp, filesize($sess_file));
      return($sess_data);
    } else {
      return(""); // Must return "" here.
    }

  }

  function write($id, $sess_data) {
    global $sess_save_path, $sess_session_name;

    $sess_file = "$sess_save_path/sess_$id";
    if ($fp = @fopen($sess_file, "w")) {
      return(fwrite($fp, $sess_data));
    } else {
      return(false);
    }

  }

  function destroy($id) {
    global $sess_save_path, $sess_session_name;
	 
    $sess_file = "$sess_save_path/sess_$id";
    return(@unlink($sess_file));
  }

  /*********************************************
  * WARNING - You will need to implement some *
  * sort of garbage collection routine here.  *
  *********************************************/
  function gc($maxlifetime) {
    return true;
  }

  session_set_save_handler("open", "close", "read", "write", 
  "destroy", "gc");

  session_start();

  // proceed to use sessions normally

  ?> 
See also the session.save_handler configuration directive.   session_set_cookie_paramsUpsession_start
#

#T=bool session_set_save_handler ( string open, string close, string read, 
session_set_save_handler ( ^!string open, string close, string read, ;
#

#T=session_start - bool session_start ( void )
(PHP 4 )
session_start -- Initialize session data
Description
bool session_start ( void )
session_start() creates a session or resumes the current one based on the 
current session id that's being passed via a request, such as GET, POST, 
or a cookie. 
This function always returns TRUE. 
Note: If you are using cookie-based sessions, you must call 
session_start() before anything is outputted to the browser. 
Example 1. A session example: page1.php
  <?php
  // page1.php

  session_start();

  echo 'Welcome to page #1';

  $_SESSION['favcolor'] = 'green';
  $_SESSION['animal']   = 'cat';
  $_SESSION['time']     = time();

  // Works if session cookie was accepted
  echo '<br /><a href="page2.php">page 2</a>';

  // Or maybe pass along the session id, if needed
  echo '<br /><a href="page2.php?' . SID . '">page 2</a>';
  ?> 
After viewing page1.php, the second page page2.php will magically contain 
the session data. Read the session reference for information on 
propagating session ids as it, for example, explains what the constant SID 
is all about. 
Example 2. A session example: page2.php
  <?php
  // page2.php

  session_start();

  echo 'Welcome to page #2<br />';

  echo $_SESSION['favcolor']; // green
  echo $_SESSION['animal'];   // cat
  echo date('Y m d H:i:s', $_SESSION['time']);

  // You may want to use SID here, like we did in page1.php
  echo '<br /><a href="page1.php">page 1</a>';
  ?> 
If you want to use a named session, you must call session_name() before 
calling session_start(). 
session_start() will register internal output handler for URL rewriting 
when trans-sid is enabled. If a user uses ob_gzhandler or like with 
ob_start(), the order of output handler is important for proper output. 
For example, user must register ob_gzhandler before session start. 
Note: Use of zlib.output_compression is recommended rather than 
ob_gzhandler() 
Note: As of PHP 4.3.3, calling session_start() while the session has 
already been started will result in an error of level E_NOTICE. Also, 
the second session start will simply be ignored. 
See also $_SESSION, session.auto_start, and session_id().   session_set_save_handlerUpsession_unregister
#

#T=bool session_start ( void )
session_start ( ^!void );
#

#T=session_unregister - bool session_unregister ( string name)
(PHP 4 )
session_unregister --  Unregister a global variable from the current 
session 
Description
bool session_unregister ( string name)
session_unregister() unregisters the global variable named name from the 
current session. 
This function returns TRUE when the variable is successfully unregistered 
from the session. 
Note: If $_SESSION (or $HTTP_SESSION_VARS for PHP 4.0.6 or less) is 
used, use unset() to unregister a session variable. Do not unset() 
$_SESSION itself as this will disable the special function of the 
$_SESSION superglobal. 
Caution
This function does not unset the corresponding global variable for 
name, it only prevents the variable from being saved as part of the 
session. You must call unset() to remove the corresponding global 
variable. 

Caution
If you are using $_SESSION (or $HTTP_SESSION_VARS), do not use 
session_register(), session_is_registered() and 
session_unregister(). 
  session_startUpsession_unset
#

#T=bool session_unregister ( string name)
session_unregister ( ^!string name);
#

#T=session_unset - void session_unset ( void )
(PHP 4 )
session_unset --  Free all session variables 
Description
void session_unset ( void )
The session_unset() function frees all session variables currently 
registered. 
Note: If $_SESSION (or $HTTP_SESSION_VARS for PHP 4.0.6 or less) is 
used, use unset() to unregister a session variable, i.e. unset 
($_SESSION['varname']);. 
Caution
Do NOT unset the whole $_SESSION with unset($_SESSION) as this will 
disable the registering of session variables through the $_SESSION 
superglobal. 
  session_unregisterUpsession_write_close
#

#T=void session_unset ( void )
session_unset ( ^!void );
#

#T=session_write_close - void session_write_close ( void )
(PHP 4 >= 4.0.4)
session_write_close -- Write session data and end session
Description
void session_write_close ( void )
End the current session and store session data. 
Session data is usually stored after your script terminated without the 
need to call session_write_close(), but as session data is locked to 
prevent concurrent writes only one script may operate on a session at any 
time. When using framesets together with sessions you will experience the 
frames loading one by one due to this locking. You can reduce the time 
needed to load all the frames by ending the session as soon as all changes 
to session variables are done.   session_unsetUpShared Memory Functions
#

#T=void session_write_close ( void )
session_write_close ( ^!void );
#

#T=set_error_handler - string set_error_handler ( callback error_handler)
(PHP 4 >= 4.0.1)
set_error_handler --  Sets a user-defined error handler function. 
Description
string set_error_handler ( callback error_handler)
Sets a user function (error_handler) to handle errors in a script. Returns 
the previously defined error handler (if any), or FALSE on error. This 
function can be used for defining your own way of handling errors during 
runtime, for example in applications in which you need to do cleanup of 
data/files when a critical error happens, or when you need to trigger an 
error under certain conditions (using trigger_error()). 
The user function needs to accept two parameters: the error code, and a 
string describing the error. From PHP 4.0.2, three optional parameters are 
supplied: the filename in which the error occurred, the line number in 
which the error occurred, and the context in which the error occurred (an 
array that points to the active symbol table at the point the error 
occurred). 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied. (Since PHP 4.3.0) 
Note: The following error types cannot be handled with a user defined 
function: E_ERROR, E_PARSE, E_CORE_ERROR, E_CORE_WARNING, 
E_COMPILE_ERROR and E_COMPILE_WARNING. 
The example below shows the handling of internal exceptions by triggering 
errors and handling them with a user defined function: Example 1. 
Error handling with set_error_handler() and trigger_error() 
  <?php

  // redefine the user error constants - PHP 4 only
  define("FATAL", E_USER_ERROR);
  define("ERROR", E_USER_WARNING);
  define("WARNING", E_USER_NOTICE);

  // set the error reporting level for this script
  error_reporting(FATAL | ERROR | WARNING);

  // error handler function
  function myErrorHandler($errno, $errstr, $errfile, $errline) {
    switch ($errno) {
    case FATAL:
      echo "<b>FATAL</b> [$errno] $errstr<br />\n";
      echo "  Fatal error in line $errline of file $errfile";
      echo ", PHP " . PHP_VERSION . " (" . PHP_OS . ")<br />\n";
      echo "Aborting...<br />\n";
      exit(1);
      break;
    case ERROR:
      echo "<b>ERROR</b> [$errno] $errstr<br />\n";
      break;
    case WARNING:
      echo "<b>WARNING</b> [$errno] $errstr<br />\n";
      break;
    default:
      echo "Unkown error type: [$errno] $errstr<br />\n";
      break;
    }
  }

  // function to test the error handling
  function scale_by_log($vect, $scale) {
    if (!is_numeric($scale) || $scale <= 0) {
      trigger_error("log(x) for x <= 0 is undefined, you used: 
  scale = $scale",
	FATAL);
    }

    if (!is_array($vect)) {
      trigger_error("Incorrect input vector, array of values 
  expected", ERROR);
      return null;
    }

    for ($i=0; $i<count($vect); $i++) {
      if (!is_numeric($vect[$i]))
	trigger_error("Value at position $i is not a number, 
  using 0 (zero)", 
	  WARNING);
      $temp[$i] = log($scale) * $vect[$i];
    }
    return $temp;
  }

  // set to the user defined error handler
  $old_error_handler = set_error_handler("myErrorHandler");

  // trigger some errors, first define a mixed array with a 
  non-numeric item
  echo "vector a\n";
  $a = array(2,3, "foo", 5.5, 43.3, 21.11);
  print_r($a);

  // now generate second array, generating a warning
  echo "----\nvector b - a warning (b = log(PI) * a)\n";
  $b = scale_by_log($a, M_PI);
  print_r($b);

  // this is trouble, we pass a string instead of an array
  echo "----\nvector c - an error\n";
  $c = scale_by_log("not array", 2.3);
  var_dump($c);

  // this is a critical error, log of zero or negative number is 
  undefined
  echo "----\nvector d - fatal error\n";
  $d = scale_by_log($a, -2.5);

  ?> 

And when you run this sample script, the output will be : 
vector a
Array
(
[0] => 2
[1] => 3
[2] => foo
[3] => 5.5
[4] => 43.3
[5] => 21.11
)
----
vector b - a warning (b = log(PI) * a)
<b>WARNING</b> [1024] Value at position 2 is not a number, using 0 (zero)<br />
Array
(
[0] => 2.2894597716988
[1] => 3.4341896575482
[2] => 0
[3] => 6.2960143721717
[4] => 49.566804057279
[5] => 24.165247890281
)
----
vector c - an error
<b>ERROR</b> [512] Incorrect input vector, array of values expected<br />
NULL
----
vector d - fatal error
<b>FATAL</b> [256] log(x) for x <= 0 is undefined, you used: scale = -2.5<br />
Fatal error in line 36 of file trigger_error.php, PHP 4.0.2 (Linux)<br />
Aborting...<br />
It is important to remember that the standard PHP error handler is 
completely bypassed. error_reporting() settings will have no effect and 
your error handler will be called regardless - however you are still able 
to read the current value of error_reporting and act appropriately. Of 
particular note is that this value will be 0 if the statement that caused 
the error was prepended by the @ error-control operator. 
Also note that it is your responsibility to die() if necessary. If the 
error-handler function returns, script execution will continue with the 
next statement after the one that caused an error. 
Note: If errors occur before the script is executed (e.g. on file 
uploads) the custom error handler cannot be called since it is not 
registered at that time. 
See also error_reporting(), restore_error_handler(), trigger_error(), and 
error level constants.   restore_error_handlerUptrigger_error
set_file_buffer
set_file_buffer -- Alias of stream_set_write_buffer()
Description
This function is an alias of stream_set_write_buffer().   rmdirUpstat
#

#T=string set_error_handler ( callback error_handler)
set_error_handler ( ^!callback error_handler);
#

#T=set_include_path - string set_include_path ( string new_include_path)
(PHP 4 >= 4.3.0)
set_include_path --  Sets the include_path configuration option 
Description
string set_include_path ( string new_include_path)
Sets the include_path configuration option for the duration of the script. 
Returns the old include_path on success or FALSE on failure. 
Example 1. set_include_path() example
  <?php
  // Works as of PHP 4.3.0
  set_include_path('/inc');

  // Works in all PHP versions
  ini_set('include_path', '/inc');
  ?> 
See also ini_set(), get_include_path(), restore_include_path(), and 
include().   restore_include_pathUpset_magic_quotes_runtime
#

#T=string set_include_path ( string new_include_path)
set_include_path ( ^!string new_include_path);
#

#T=set_magic_quotes_runtime - bool set_magic_quotes_runtime ( int new_setting)
(PHP 3>= 3.0.6, PHP 4 )
set_magic_quotes_runtime --  Sets the current active configuration setting 
of magic_quotes_runtime 
Description
bool set_magic_quotes_runtime ( int new_setting)
Set the current active configuration setting of magic_quotes_runtime (0 
for off, 1 for on). 
See also: get_magic_quotes_gpc() and get_magic_quotes_runtime().   set_include_pathUpset_time_limit
#

#T=bool set_magic_quotes_runtime ( int new_setting)
set_magic_quotes_runtime ( ^!int new_setting);
#

#T=set_time_limit - void set_time_limit ( int seconds)
(PHP 3, PHP 4 )
set_time_limit -- Limits the maximum execution time
Description
void set_time_limit ( int seconds)
Set the number of seconds a script is allowed to run. If this is reached, 
the script returns a fatal error. The default limit is 30 seconds or, if 
it exists, the max_execution_time value defined in the php.ini. If seconds 
is set to zero, no time limit is imposed. 
When called, set_time_limit() restarts the timeout counter from zero. In 
other words, if the timeout is the default 30 seconds, and 25 seconds into 
script execution a call such as set_time_limit(20) is made, the script 
will run for a total of 45 seconds before timing out. 
Warning
set_time_limit() has no effect when PHP is running in safe mode. 
There is no workaround other than turning off safe mode or changing 
the time limit in the php.ini. 

Note: The set_time_limit() function and the configuration directive 
max_execution_time only affect the execution time of the script itself. 
Any time spent on activity that happens outside the execution of the 
script such as system calls using system(), the sleep() function, 
database queries, etc. is not included when determining the maximum time 
that the script has been running.   set_magic_quotes_runtimeUpversion_compare
#

#T=void set_time_limit ( int seconds)
set_time_limit ( ^!int seconds);
#

#T=setcookie - bool setcookie ( string name [, string value [, int expire [, string path 
(PHP 3, PHP 4 )
setcookie -- Send a cookie
Description
bool setcookie ( string name [, string value [, int expire [, string path 
[, string domain [, int secure]]]]])
setcookie() defines a cookie to be sent along with the rest of the HTTP 
headers. Like other headers, cookies must be sent before any output from 
your script (this is a protocol restriction). This requires that you place 
calls to this function prior to any output, including <html> and <head> 
tags as well as any whitespace. If output exists prior to calling this 
function, setcookie() will fail and return FALSE. If setcookie() 
successfully runs, it will return TRUE. This does not indicate whether the 
user accepted the cookie. 
Note: In PHP 4, you can use output buffering to send output prior to the 
call of this function, with the overhead of all of your output to the 
browser being buffered in the server until you send it. You can do this 
by calling ob_start() and ob_end_flush() in your script, or setting the 
output_buffering configuration directive on in your php.ini or server 
configuration files. 
All the arguments except the name argument are optional. You may also 
replace an argument with an empty string ("") in order to skip that 
argument. Because the expire and secure arguments are integers, they 
cannot be skipped with an empty string, use a zero (0) instead. The 
following table explains each parameter of the setcookie() function, be 
sure to read the Netscape cookie specification for specifics on how each 
setcookie() parameter works and RFC 2965 for additional information on how 
HTTP cookies work. 
Table 1. setcookie() parameters explained
ParameterDescriptionExamples
nameThe name of the cookie. 'cookiename' is called as 
$_COOKIE['cookiename'] 
valueThe value of the cookie. This value is stored on the clients 
computer; do not store sensitive information. Assuming the name is 
'cookiename', this value is retrieved through $_COOKIE['cookiename'] 

expireThe time the cookie expires. This is a Unix timestamp so is in 
number of seconds since the epoch. In otherwords, you'll most likely 
set this with the time() function plus the number of seconds before 
you want it to expire. Or you might use mktime(). time()+60*60*24*30 
will set the cookie to expire in 30 days. If not set, the cookie 
will expire at the end of the session (when the browser closes). 
pathThe path on the server in which the cookie will be available on. 
If set to '/', the cookie will be available within the entire 
domain. If set to '/foo/', the cookie will only be available within 
the /foo/ directory and all sub-directories such as /foo/bar/ of 
domain. The default value is the current directory that the cookie 
is being set in. 
domainThe domain that the cookie is available. To make the cookie 
available on all subdomains of example.com then you'd set it to 
'.example.com'. The . is not required but makes it compatible with 
more browsers. Setting it to www.example.com will make the cookie 
only available in the www subdomain. Refer to tail matching in the 
spec for details. 
secureIndicates that the cookie should only be transmitted over a 
secure HTTPS connection. When set to 1, the cookie will only be set 
if a secure connection exists. The default is 0. 0 or 1 

Once the cookies have been set, they can be accessed on the next page load 
with the $_COOKIE or $HTTP_COOKIE_VARS arrays. Note, autoglobals such as 
$_COOKIE became available in PHP 4.1.0. $HTTP_COOKIE_VARS has existed 
since PHP 3. Cookie values also exist in $_REQUEST. 
Note: If the PHP directive register_globals is set to on then cookie 
values will also be made into variables. In our examples below, 
$TextCookie will exist. It's recommended to use $_COOKIE. 
Common Pitfalls: 
Cookies will not become visible until the next loading of a page that 
the cookie should be visible for. To test if a cookie was successfully 
set, check for the cookie on a next loading page before the cookie 
expires. Expire time is set via the expire parameter. A nice way to 
debug the existence of cookies is by simply calling print_r($_COOKIE);. 
Cookies must be deleted with the same parameters as they were set with. 
If the value argument is an empty string (""), and all other arguments 
match a previous call to setcookie, then the cookie with the specified 
name will be deleted from the remote client. 
Cookies names can be set as array names and will be available to your 
PHP scripts as arrays but separate cookies are stored on the users 
system. Consider explode() or serialize() to set one cookie with 
multiple names and values. 
In PHP 3, multiple calls to setcookie() in the same script will be 
performed in reverse order. If you are trying to delete one cookie before 
inserting another you should put the insert before the delete. In PHP 4, 
multiple calls to setcookie() are performed in the order called. 
Some examples follow how to send cookies: Example 1. setcookie() 
send example
  <?php
  $value = 'something from somewhere';

  setcookie("TestCookie", $value);
  setcookie("TestCookie", $value, time()+3600);  /* expire in 1 
  hour */
  setcookie("TestCookie", $value, time()+3600, "/~rasmus/", 
  ".example.com", 1);
  ?> 
Note that the value portion of the cookie will automatically be urlencoded 
when you send the cookie, and when it is received, it is automatically 
decoded and assigned to a variable by the same name as the cookie name. To 
see the contents of our test cookie in a script, simply use one of the 
following examples: 
<?php
// Print an individual cookie
echo $_COOKIE["TestCookie"];
echo $HTTP_COOKIE_VARS["TestCookie"];

// Another way to debug/test is to view all cookies
print_r($_COOKIE);
?> 

When deleting a cookie you should assure that the expiration date is in 
the past, to trigger the removal mechanism in your browser. Examples 
follow how to delete cookies sent in previous example: 
Example 2. setcookie() delete example
  <?php
  // set the expiration date to one hour ago
  setcookie ("TestCookie", "", time() - 3600);
  setcookie ("TestCookie", "", time() - 3600, "/~rasmus/", 
  ".example.com", 1);
  ?> 
You may also set array cookies by using array notation in the cookie name. 
This has the effect of setting as many cookies as you have array elements, 
but when the cookie is received by your script, the values are all placed 
in an array with the cookie's name: 
Example 3. setcookie() and arrays
  <?php
  // set the cookies
  setcookie("cookie[three]", "cookiethree");
  setcookie("cookie[two]", "cookietwo");
  setcookie("cookie[one]", "cookieone");

  // after the page reloads, print them out
  if (isset($_COOKIE['cookie'])) {
      foreach ($_COOKIE['cookie'] as $name => $value) {
	  echo "$name : $value <br />\n";
      }
  }
  ?> 

which prints 
three : cookiethree
two : cookietwo
one : cookieone
Note: For more information on cookies, see Netscape's cookie 
specification at http://www.netscape.com/newsref/std/cookie_spec.html 
and RFC 2965. 
You may notice the expire parameter takes on a Unix timestamp, as 
opposed to the date format Wdy, DD-Mon-YYYY HH:MM:SS GMT, this is 
because PHP does this conversion internally. 
Note: Microsoft Internet Explorer 4 with Service Pack 1 applied does not 
correctly deal with cookies that have their path parameter set. 
Netscape Communicator 4.05 and Microsoft Internet Explorer 3.x appear to 
handle cookies incorrectly when the path and time are not set. 
See also header() and the cookies section.   headers_sentUpHyperwave functions
#

#T=bool setcookie ( string name [, string value [, int expire [, string path 
setcookie ( ^!string name [, string value [, int expire [, string path ;
#

#T=setlocale - string setlocale ( mixed category, string locale [, string ...])
(PHP 3, PHP 4 )
setlocale -- Set locale information
Description
string setlocale ( mixed category, string locale [, string ...])

string setlocale ( mixed category, array locale)
Category is a named constant (or string) specifying the category of the 
functions affected by the locale setting: 
LC_ALL for all of the below 
LC_COLLATE for string comparison, see strcoll() 
LC_CTYPE for character classification and conversion, for example 
strtoupper() 
LC_MONETARY for localeconv() 
LC_NUMERIC for decimal separator (See also localeconv()) 
LC_TIME for date and time formatting with strftime() 
If locale is the empty string "", the locale names will be set from the 
values of environment variables with the same names as the above 
categories, or from "LANG". 
If locale is NULL or "0", the locale setting is not affected, only the 
current setting is returned. 
If locale is an array or followed by additional parameters then each array 
element or parameter is tried to be set as new locale until success. This 
is useful if a locale is known under different names on different systems 
or for providing a fallback for a possibly not available locale. 
Note: Passing multiple locales is not available before PHP 4.3.0 
Setlocale returns the new current locale, or FALSE if the locale 
functionality is not implemented on your platform, the specified locale 
does not exist or the category name is invalid. An invalid category name 
also causes a warning message. Category/locale names can be found in RFC 
1766 and ISO 639. 
Note: The return value of setlocale() depends on the system that PHP is 
running. It returns exactly what the system setlocale function returns. 
Tip: Windows users will find useful information about locale strings at 
Microsoft's MSDNwebsite. Supported language strings can be found at 
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/vclib/html/_crt_language_strings.asp 
and supported country/region strings at 
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/vclib/html/_crt_country_strings.asp. 
Windows systems support the three letter codes for country/region 
specified by ISO 3166-Alpha-3, which can be found at this Unicode 
website . 
Example 1. setlocale() Examples
  <?php
  /* Set locale to Dutch */
  setlocale(LC_ALL, 'nl_NL');

  /* Output: vrijdag 22 december 1978 */
  echo strftime("%A %e %B %Y", mktime(0, 0, 0, 12, 22, 1978));

  /* try different possible locale names for german as of PHP 
  4.3.0 */
  $loc_de = setlocale(LC_ALL, 'de_DE@euro', 'de_DE', 'de', 
'ge');
  echo "Preferred locale for german on this system is 
'$loc_de'";
  ?> 
Example 2. setlocale() Examples for Windows
  <?php
  /* Set locale to Dutch */
  setlocale(LC_ALL, 'nld_nld');

  /* Output: vrijdag 22 december 1978 */
  echo strftime("%A %d %B %Y", mktime(0, 0, 0, 12, 22, 1978));

  /* try different possible locale names for german as of PHP 
  4.3.0 */
  $loc_de = setlocale(LC_ALL, 'de_DE@euro', 'de_DE', 'deu_deu');
  echo "Preferred locale for german on this system is 
'$loc_de'";
  ?> 

  rtrimUpsha1_file
#

#T=string setlocale ( mixed category, string locale [, string ...])
setlocale ( ^!mixed category, string locale [, string ...]);
#

#T=settype - bool settype ( mixed var, string type)
(PHP 3, PHP 4 )
settype -- Set the type of a variable
Description
bool settype ( mixed var, string type)
Set the type of variable var to type. 
Possibles values of type are: 
"boolean" (or, since PHP 4.2.0, "bool") 
"integer" (or, since PHP 4.2.0, "int") 
"float" (only possible since PHP 4.2.0, for older versions use the 
deprecated variant "double") 
"string" 
"array" 
"object" 
"null" (since PHP 4.2.0) 
Returns TRUE on success or FALSE on failure. 
Example 1. settype() example
  <?php
  $foo = "5bar"; // string
  $bar = true;   // boolean

  settype($foo, "integer"); // $foo is now 5   (integer)
  settype($bar, "string");  // $bar is now "1" (string)
  ?> 
See also gettype(), type-casting and type-juggling.   serializeUpstrval
#

#T=bool settype ( mixed var, string type)
settype ( ^!mixed var, string type);
#

#T=sha1_file - string sha1_file ( string filename [, bool raw_output])
(PHP 4 >= 4.3.0)
sha1_file -- Calculate the sha1 hash of a file
Description
string sha1_file ( string filename [, bool raw_output])
Calculates the sha1 hash of filename using the US Secure Hash Algorithm 1, 
and returns that hash. The hash is a 40-character hexadecimal number. Upon 
failure, FALSE is returned. If the optional raw_output is set to TRUE, 
then the sha1 digest is instead returned in raw binary format with a 
length of 20. 
Note: The optional raw_output parameter was added in PHP 5.0.0 and 
defaults to FALSE 
See also sha1(), crc32(), and md5_file()   setlocaleUpsha1
#

#T=string sha1_file ( string filename [, bool raw_output])
sha1_file ( ^!string filename [, bool raw_output]);
#

#T=sha1 - string sha1 ( string str [, bool raw_output])
(PHP 4 >= 4.3.0)
sha1 -- Calculate the sha1 hash of a string
Description
string sha1 ( string str [, bool raw_output])
Calculates the sha1 hash of str using the US Secure Hash Algorithm 1, and 
returns that hash. The hash is a 40-character hexadecimal number. If the 
optional raw_output is set to TRUE, then the sha1 digest is instead 
returned in raw binary format with a length of 20. 
Note: The optional raw_output parameter was added in PHP 5.0.0 and 
defaults to FALSE 
Example 1. A sha1() example
  <?php
  $str = 'apple';
		       
  if (sha1($str) === 'd0be2dc421be4fcd0172e5afceea3970e2f3d940') 
  {
      echo "Would you like a green or red apple?";
      exit;
  }
  ?> 
See also sha1_file(), crc32(), and md5()   sha1_fileUpsimilar_text
#

#T=string sha1 ( string str [, bool raw_output])
sha1 ( ^!string str [, bool raw_output]);
#

#T=shell_exec - string shell_exec ( string cmd)
(PHP 4 )
shell_exec --  Execute command via shell and return the complete output as 
a string 
Description
string shell_exec ( string cmd)
This function is identical to the backtick operator. 
Note: This function is disabled in safe mode.  proc_terminateUpsystem
#

#T=string shell_exec ( string cmd)
shell_exec ( ^!string cmd);
#

#T=shm_attach - int shm_attach ( int key [, int memsize [, int perm]])
(PHP 3>= 3.0.6, PHP 4 )
shm_attach -- Creates or open a shared memory segment
Description
int shm_attach ( int key [, int memsize [, int perm]])
shm_attach() returns an id that that can be used to access the System V 
shared memory with the given key, the first call creates the shared memory 
segment with memsize (default: sysvshm.init_mem in the php.ini, otherwise 
10000 bytes) and the optional perm-bits perm (default: 0666). 
A second call to shm_attach() for the same key will return a different 
shared memory identifier, but both identifiers access the same underlying 
shared memory. Memsize and perm will be ignored. 
See also: ftok(). 
Note: This function does not work on Windows systems.   sem_removeUpshm_detach
#

#T=int shm_attach ( int key [, int memsize [, int perm]])
shm_attach ( ^!int key [, int memsize [, int perm]]);
#

#T=shm_detach - bool shm_detach ( int shm_identifier)
(PHP 3>= 3.0.6, PHP 4 )
shm_detach -- Disconnects from shared memory segment
Description
bool shm_detach ( int shm_identifier)
shm_detach() disconnects from the shared memory given by the 
shm_identifier created by shm_attach(). Remember, that shared memory still 
exist in the Unix system and the data is still present. 
shm_detach() always returns TRUE.   shm_attachUpshm_get_var
#

#T=bool shm_detach ( int shm_identifier)
shm_detach ( ^!int shm_identifier);
#

#T=shm_get_var - mixed shm_get_var ( int id, int variable_key)
(PHP 3>= 3.0.6, PHP 4 )
shm_get_var -- Returns a variable from shared memory
Description
mixed shm_get_var ( int id, int variable_key)
shm_get_var() returns the variable with a given variable_key. The variable 
is still present in the shared memory. 
Note: This function does not work on Windows systems.   shm_detachUpshm_put_var
#

#T=mixed shm_get_var ( int id, int variable_key)
shm_get_var ( ^!int id, int variable_key);
#

#T=shm_put_var - int shm_put_var ( int shm_identifier, int variable_key, mixed variable)
(PHP 3>= 3.0.6, PHP 4 )
shm_put_var -- Inserts or updates a variable in shared memory
Description
int shm_put_var ( int shm_identifier, int variable_key, mixed variable)
Inserts or updates a variable with a given variable_key. All 
variable-types are supported. 
Note: This function does not work on Windows systems.   shm_get_varUpshm_remove_var
#

#T=int shm_put_var ( int shm_identifier, int variable_key, mixed variable)
shm_put_var ( ^!int shm_identifier, int variable_key, mixed variable);
#

#T=shm_remove_var - int shm_remove_var ( int id, int variable_key)
(PHP 3>= 3.0.6, PHP 4 )
shm_remove_var -- Removes a variable from shared memory 
Description
int shm_remove_var ( int id, int variable_key)
Removes a variable with a given variable_key and frees the occupied 
memory. 
Note: This function does not work on Windows systems.   shm_put_varUpshm_remove
#

#T=int shm_remove_var ( int id, int variable_key)
shm_remove_var ( ^!int id, int variable_key);
#

#T=shm_remove - int shm_remove ( int shm_identifier)
(PHP 3>= 3.0.6, PHP 4 )
shm_remove -- Removes shared memory from Unix systems
Description
int shm_remove ( int shm_identifier)
Removes shared memory from Unix systems. All data will be destroyed. 
Note: This function does not work on Windows systems.   shm_remove_varUpSESAM database functions
#

#T=int shm_remove ( int shm_identifier)
shm_remove ( ^!int shm_identifier);
#

#T=shmop_close - int shmop_close ( int shmid)
(PHP 4 >= 4.0.4)
shmop_close -- Close shared memory block
Description
int shmop_close ( int shmid)
shmop_close() is used to close a shared memory block. 
shmop_close() takes the shmid, which is the shared memory block identifier 
created by shmop_open(). 
Example 1. Closing shared memory block
  <?php
  shmop_close($shm_id);
  ?> 
This example will close shared memory block identified by $shm_id.   Shared Memory FunctionsUpshmop_delete
#

#T=int shmop_close ( int shmid)
shmop_close ( ^!int shmid);
#

#T=shmop_delete - int shmop_delete ( int shmid)
(PHP 4 >= 4.0.4)
shmop_delete -- Delete shared memory block
Description
int shmop_delete ( int shmid)
shmop_delete() is used to delete a shared memory block. 
shmop_delete() takes the shmid, which is the shared memory block 
identifier created by shmop_open(). On success 1 is returned, on failure 0 
is returned. 
Example 1. Deleting shared memory block
  <?php
  shmop_delete($shm_id);
  ?> 
This example will delete shared memory block identified by $shm_id.   shmop_closeUpshmop_open
#

#T=int shmop_delete ( int shmid)
shmop_delete ( ^!int shmid);
#

#T=shmop_open - int shmop_open ( int key, string flags, int mode, int size)
(PHP 4 >= 4.0.4)
shmop_open -- Create or open shared memory block
Description
int shmop_open ( int key, string flags, int mode, int size)
shmop_open() can create or open a shared memory block. 
shmop_open() takes 4 parameters: key, which is the system's id for the 
shared memory block, this parameter can be passed as a decimal or hex. The 
second parameter are the flags that you can use: 
"a" for access (sets SHM_RDONLY for shmat) use this flag when you need 
to open an existing shared memory segment for read only 
"c" for create (sets IPC_CREATE) use this flag when you need to create a 
new shared memory segment or if a segment with the same key exists, try 
to open it for read and write 
"w" for read & write access use this flag when you need to read and 
write to a shared memory segment, use this flag in most cases. 
"n" create a new memory segment (sets IPC_CREATE|IPC_EXCL) use this flag 
when you want to create a new shared memory segment but if one already 
exists with the same flag, fail. This is useful for security purposes, 
using this you can prevent race condition exploits. 
The third parameter is the mode, which are the permissions that you wish 
to assign to your memory segment, those are the same as permission for a 
file. Permissions need to be passed in octal form ex. 0644. The last 
parameter is size of the shared memory block you wish to create in bytes. 
Note: Note: the 3rd and 4th should be entered as 0 if you are opening an 
existing memory segment. On success shmop_open() will return an id that 
you can use to access the shared memory segment you've created. 
Example 1. Create a new shared memory block
  <?php
  $shm_key = ftok(__FILE__, 't');
  $shm_id = shmop_open($shm_key, "c", 0644, 100);
  ?> 
This example opened a shared memory block with a system id returned by 
ftok(). 
See also: ftok().   shmop_deleteUpshmop_read
#

#T=int shmop_open ( int key, string flags, int mode, int size)
shmop_open ( ^!int key, string flags, int mode, int size);
#

#T=shmop_read - string shmop_read ( int shmid, int start, int count)
(PHP 4 >= 4.0.4)
shmop_read -- Read data from shared memory block
Description
string shmop_read ( int shmid, int start, int count)
shmop_read() will read a string from shared memory block. 
shmop_read() takes 3 parameters: shmid, which is the shared memory block 
identifier created by shmop_open(), offset from which to start reading and 
count on the number of bytes to read. 
Example 1. Reading shared memory block
  <?php
  $shm_data = shmop_read($shm_id, 0, 50);
  ?> 
This example will read 50 bytes from shared memory block and place the 
data inside $shm_data.   shmop_openUpshmop_size
#

#T=string shmop_read ( int shmid, int start, int count)
shmop_read ( ^!int shmid, int start, int count);
#

#T=shmop_size - int shmop_size ( int shmid)
(PHP 4 >= 4.0.4)
shmop_size -- Get size of shared memory block
Description
int shmop_size ( int shmid)
shmop_size() is used to get the size, in bytes of the shared memory block. 

shmop_size() takes the shmid, which is the shared memory block identifier 
created by shmop_open(), the function will return and int, which 
represents the number of bytes the shared memory block occupies. 
Example 1. Getting the size of the shared memory block
  <?php
  $shm_size = shmop_size($shm_id);
  ?> 
This example will put the size of shared memory block identified by 
$shm_id into $shm_size.   shmop_readUpshmop_write
#

#T=int shmop_size ( int shmid)
shmop_size ( ^!int shmid);
#

#T=shmop_write - int shmop_write ( int shmid, string data, int offset)
(PHP 4 >= 4.0.4)
shmop_write -- Write data into shared memory block
Description
int shmop_write ( int shmid, string data, int offset)
shmop_write() will write a string into shared memory block. 
shmop_write() takes 3 parameters: shmid, which is the shared memory block 
identifier created by shmop_open(), data, a string that you want to write 
into shared memory block and offset, which specifies where to start 
writing data inside the shared memory segment. 
Example 1. Writing to shared memory block
  <?php
  $shm_bytes_written = shmop_write($shm_id, $my_string, 0);
  ?> 
This example will write data inside $my_string into shared memory block, 
$shm_bytes_written will contain the number of bytes written.   shmop_sizeUpSQLite
show_source
show_source -- Alias of highlight_file()
Description
This function is an alias of highlight_file().   packUpsleep
#

#T=int shmop_write ( int shmid, string data, int offset)
shmop_write ( ^!int shmid, string data, int offset);
#

#T=shuffle - void shuffle ( array array)
(PHP 3>= 3.0.8, PHP 4 )
shuffle -- Shuffle an array
Description
void shuffle ( array array)
This function shuffles (randomizes the order of the elements in) an array. 
You must use srand() to seed this function. Example 1. shuffle() 
example
  <?php
  $numbers = range(1, 20);
  srand((float)microtime() * 1000000);
  shuffle($numbers);
  while (list(, $number) = each($numbers)) {
      echo "$number ";
  }
  ?> 
Note: As of PHP 4.2.0, there is no need to seed the random number 
generator with srand() or mt_srand() as this is now done automatically. 
See also arsort(), asort(), ksort(), rsort(), sort(), and usort().   rsortUpsizeof
#

#T=void shuffle ( array array)
shuffle ( ^!array array);
#

#T=similar_text - int similar_text ( string first, string second [, float percent])
(PHP 3>= 3.0.7, PHP 4 )
similar_text --  Calculate the similarity between two strings 
Description
int similar_text ( string first, string second [, float percent])
This calculates the similarity between two strings as described in Oliver 
[1993]. Note that this implementation does not use a stack as in Oliver's 
pseudo code, but recursive calls which may or may not speed up the whole 
process. Note also that the complexity of this algorithm is O(N**3) where 
N is the length of the longest string. 
By passing a reference as third argument, similar_text() will calculate 
the similarity in percent for you. It returns the number of matching chars 
in both strings.   sha1Upsoundex
#

#T=int similar_text ( string first, string second [, float percent])
similar_text ( ^!string first, string second [, float percent]);
#

#T=sin - float sin ( float arg)
(PHP 3, PHP 4 )
sin -- Sine
Description
float sin ( float arg)
sin() returns the sine of the arg parameter. The arg parameter is in 
radians. 
<?php

// Precision depends on your precision directive
echo sin(deg2rad(60));  //  0.866025403 ...
echo sin(60);           // -0.304810621 ...

?> 

See also asin(), cos(), tan() and deg2rad().   roundUpsinh
#

#T=float sin ( float arg)
sin ( ^!float arg);
#

#T=sinh - float sinh ( float arg)
(PHP 4 >= 4.1.0)
sinh -- Hyperbolic sine
Description
float sinh ( float arg)
Returns the hyperbolic sine of arg, defined as (exp(arg) - exp(-arg))/2. 
See also sin(), asinh(), cos() and tan().   sinUpsqrt
sizeof
sizeof -- Alias of count()
Description
This function is an alias of count().   shuffleUpsort
#

#T=float sinh ( float arg)
sinh ( ^!float arg);
#

#T=sleep - void sleep ( int seconds)
(PHP 3, PHP 4 )
sleep -- Delay execution
Description
void sleep ( int seconds)
The sleep() function delays program execution for the given number of 
seconds. 
Example 1. sleep() example
  <?php

  // current time
  echo date('h:i:s') . "\n";

  // sleep for 10 seconds
  sleep(10);

  // wake up !
  echo date('h:i:s') . "\n";

  ?> 

This example will output (after 10 seconds) 
05:31:23
05:31:33
See also usleep() and set_time_limit()   show_sourceUpuniqid
#

#T=void sleep ( int seconds)
sleep ( ^!int seconds);
#

#T=snmp_get_quick_print - bool snmp_get_quick_print ( void )
(PHP 3>= 3.0.8, PHP 4 )
snmp_get_quick_print --  Fetches the current value of the UCD library's 
quick_print setting 
Description
bool snmp_get_quick_print ( void )
Returns the current value stored in the UCD Library for quick_print. 
quick_print is off by default. Example 1. snmp_get_quick_print() 
example
  <?php
    $quickprint = snmp_get_quick_print();
  ?> 
Above function call would return FALSE if quick_print is off, and TRUE if 
quick_print is on. 
snmp_get_quick_print() is only available when using the UCD SNMP library. 
This function is not available when using the Windows SNMP library. 
See also snmp_set_quick_print() for a full description of what quick_print 
does.   SNMP functionsUpsnmp_set_quick_print
#

#T=bool snmp_get_quick_print ( void )
snmp_get_quick_print ( ^!void );
#

#T=snmp_set_quick_print - void snmp_set_quick_print ( bool quick_print)
(PHP 3>= 3.0.8, PHP 4 )
snmp_set_quick_print -- Set the value of quick_print within the UCD SNMP 
library 
Description
void snmp_set_quick_print ( bool quick_print)
Sets the value of quick_print within the UCD SNMP library. When this is 
set (1), the SNMP library will return 'quick printed' values. This means 
that just the value will be printed. When quick_print is not enabled 
(default) the UCD SNMP library prints extra information including the type 
of the value (i.e. IpAddress or OID). Additionally, if quick_print is not 
enabled, the library prints additional hex values for all strings of three 
characters or less. 
Setting quick_print is often used when using the information returned 
rather then displaying it. 
<?php
snmp_set_quick_print(0);
$a = snmpget("127.0.0.1", "public", ".1.3.6.1.2.1.2.2.1.9.1");
echo "$a< br />\n";
snmp_set_quick_print(1);
$a = snmpget("127.0.0.1", "public", ".1.3.6.1.2.1.2.2.1.9.1");
echo "$a<br />\n";
?> 

The first value printed might be: 'Timeticks: (0) 0:00:00.00', whereas 
with quick_print enabled, just '0:00:00.00' would be printed. 
By default the UCD SNMP library returns verbose values, quick_print is 
used to return only the value. 
Currently strings are still returned with extra quotes, this will be 
corrected in a later release. 
snmp_set_quick_print() is only available when using the UCD SNMP library. 
This function is not available when using the Windows SNMP library.   snmp_get_quick_printUpsnmpget
#

#T=void snmp_set_quick_print ( bool quick_print)
snmp_set_quick_print ( ^!bool quick_print);
#

#T=snmpget - string snmpget ( string hostname, string community, string object_id [, 
(PHP 3, PHP 4 )
snmpget -- Fetch an SNMP object
Description
string snmpget ( string hostname, string community, string object_id [, 
int timeout [, int retries]])
Returns SNMP object value on success and FALSE on error. 
The snmpget() function is used to read the value of an SNMP object 
specified by the object_id. SNMP agent is specified by the hostname and 
the read community is specified by the community parameter. 
<?php
$syscontact = snmpget("127.0.0.1", "public", "system.SysContact.0");
?> 
  snmp_set_quick_printUpsnmprealwalk
#

#T=string snmpget ( string hostname, string community, string object_id [, 
snmpget ( ^!string hostname, string community, string object_id [, ;
#

#T=snmprealwalk - array snmprealwalk ( string host, string community, string object_id [, 
(PHP 3>= 3.0.8, PHP 4 )
snmprealwalk --  Return all objects including their respective object ID 
within the specified one 
Description
array snmprealwalk ( string host, string community, string object_id [, 
int timeout [, int retries]])
Warning
This function is currently not documented; only the argument list is 
available.
  snmpgetUpsnmpset
#

#T=array snmprealwalk ( string host, string community, string object_id [, 
snmprealwalk ( ^!string host, string community, string object_id [, ;
#

#T=snmpset - bool snmpset ( string hostname, string community, string object_id, string 
(PHP 3>= 3.0.12, PHP 4 )
snmpset -- Set an SNMP object
Description
bool snmpset ( string hostname, string community, string object_id, string 
type, mixed value [, int timeout [, int retries]])
Sets the specified SNMP object value, returning TRUE on success and FALSE 
on error. 
The snmpset() function is used to set the value of an SNMP object 
specified by the object_id. SNMP agent is specified by the hostname and 
the read community is specified by the community parameter.   snmprealwalkUpsnmpwalk
#

#T=bool snmpset ( string hostname, string community, string object_id, string 
snmpset ( ^!string hostname, string community, string object_id, string ;
#

#T=snmpwalk - array snmpwalk ( string hostname, string community, string object_id [, 
(PHP 3, PHP 4 )
snmpwalk -- Fetch all the SNMP objects from an agent
Description
array snmpwalk ( string hostname, string community, string object_id [, 
int timeout [, int retries]])
Returns an array of SNMP object values starting from the object_id as root 
and FALSE on error. 
snmpwalk() function is used to read all the values from an SNMP agent 
specified by the hostname. Community specifies the read community for that 
agent. A NULL object_id is taken as the root of the SNMP objects tree and 
all objects under that tree are returned as an array. If object_id is 
specified, all the SNMP objects below that object_id are returned. 
<?php
$a = snmpwalk("127.0.0.1", "public", ""); 
?> 

Above function call would return all the SNMP objects from the SNMP agent 
running on localhost. One can step through the values with a loop 
<?php
for ($i=0; $i < count($a); $i++) {
echo $a[$i];
}
?> 
  snmpsetUpsnmpwalkoid
#

#T=array snmpwalk ( string hostname, string community, string object_id [, 
snmpwalk ( ^!string hostname, string community, string object_id [, ;
#

#T=snmpwalkoid - array snmpwalkoid ( string hostname, string community, string object_id [, 
(PHP 3>= 3.0.8, PHP 4 )
snmpwalkoid -- Query for a tree of information about a network entity 
Description
array snmpwalkoid ( string hostname, string community, string object_id [, 
int timeout [, int retries]])
Returns an associative array with object ids and their respective object 
value starting from the object_id as root and FALSE on error. 
snmpwalkoid() function is used to read all object ids and their respective 
values from an SNMP agent specified by the hostname. Community specifies 
the read community for that agent. A NULL object_id is taken as the root 
of the SNMP objects tree and all objects under that tree are returned as 
an array. If object_id is specified, all the SNMP objects below that 
object_id are returned. 
The existence of snmpwalkoid() and snmpwalk() has historical reasons. Both 
functions are provided for backward compatibility. 
<?php
$a = snmpwalkoid("127.0.0.1", "public", ""); 
?> 

Above function call would return all the SNMP objects from the SNMP agent 
running on localhost. One can step through the values with a loop 
<?php
for (reset($a); $i = key($a); next($a)) {
echo "$i: $a[$i]<br />\n";
}
?> 
  snmpwalkUpSocket functions
#

#T=array snmpwalkoid ( string hostname, string community, string object_id [, 
snmpwalkoid ( ^!string hostname, string community, string object_id [, ;
#

#T=socket_accept - resource socket_accept ( resource socket)
(PHP 4 >= 4.1.0)
socket_accept -- Accepts a connection on a socket
Description
resource socket_accept ( resource socket)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

After the socket socket has been created using socket_create(), bound to a 
name with socket_bind(), and told to listen for connections with 
socket_listen(), this function will accept incoming connections on that 
socket. Once a successful connection is made, a new socket resource is 
returned, which may be used for communication. If there are multiple 
connections queued on the socket, the first will be used. If there are no 
pending connections, socket_accept() will block until a connection becomes 
present. If socket has been made non-blocking using socket_set_blocking() 
or socket_set_nonblock(), FALSE will be returned. 
The socket resource returned by socket_accept() may not be used to accept 
new connections. The original listening socket socket, however, remains 
open and may be reused. 
Returns a new socket resource on success, or FALSE on error. The actual 
error code can be retrieved by calling socket_last_error(). This error 
code may be passed to socket_strerror() to get a textual explanation of 
the error. 
See also socket_bind(), socket_connect(), socket_listen(), 
socket_create(), and socket_strerror().   Socket functionsUpsocket_bind
#

#T=resource socket_accept ( resource socket)
socket_accept ( ^!resource socket);
#

#T=socket_bind - bool socket_bind ( resource socket, string address [, int port])
(PHP 4 >= 4.1.0)
socket_bind -- Binds a name to a socket
Description
bool socket_bind ( resource socket, string address [, int port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

socket_bind() binds the name given in address to the socket described by 
socket, which must be a valid socket resource created with 
socket_create(). 
The address parameter is either an IP address in dotted-quad notation 
(e.g. 127.0.0.1), if the socket is of the AF_INET family; or the pathname 
of a Unix-domain socket, if the socket family is AF_UNIX. 
The port parameter is only used when connecting to an AF_INET socket, and 
designates the port on the remote host to which a connection should be 
made. 
Returns TRUE on success or FALSE on failure. The error code can be 
retrieved with socket_last_error(). This code may be passed to 
socket_strerror() to get a textual explanation of the error. Note that 
socket_last_error() is reported to return an invalid error code in case 
you are trying to bind the socket to a wrong address that does not belong 
to your Windows 9x/ME machine. 
See also socket_connect(), socket_listen(), socket_create(), 
socket_last_error() and socket_strerror().   socket_acceptUpsocket_clear_error
#

#T=bool socket_bind ( resource socket, string address [, int port])
socket_bind ( ^!resource socket, string address [, int port]);
#

#T=socket_clear_error - void socket_clear_error ( [resource socket])
(PHP 4 >= 4.2.0)
socket_clear_error -- Clears the error on the socket or the last error 
code
Description
void socket_clear_error ( [resource socket])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function clears the error code on the given socket or the global last 
socket error. 
This function allows explicitly resetting the error code value either of a 
socket or of the extension global last error code. This may be useful to 
detect within a part of the application if an error occurred or not. 
See also socket_last_error() and socket_strerror().   socket_bindUpsocket_close
#

#T=void socket_clear_error ( [resource socket])
socket_clear_error ( ^![resource socket]);
#

#T=socket_close - void socket_close ( resource socket)
(PHP 4 >= 4.1.0)
socket_close -- Closes a socket resource
Description
void socket_close ( resource socket)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

socket_close() closes the socket resource given by socket. 
Note: socket_close() can't be used on PHP file resources created with 
fopen(), popen(), fsockopen(), or pfsockopen(); it is meant for sockets 
created with socket_create() or socket_accept(). 
See also socket_bind(), socket_listen(), socket_create() and 
socket_strerror().   socket_clear_errorUpsocket_connect
#

#T=void socket_close ( resource socket)
socket_close ( ^!resource socket);
#

#T=socket_connect - bool socket_connect ( resource socket, string address [, int port])
(PHP 4 >= 4.1.0)
socket_connect -- Initiates a connection on a socket
Description
bool socket_connect ( resource socket, string address [, int port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Initiates a connection using the socket resource socket, which must be a 
valid socket resource created with socket_create(). 
The address parameter is either an IP address in dotted-quad notation 
(e.g. 127.0.0.1), if the socket is of the AF_INET family; or the pathname 
of a Unix domain socket, if the socket family is AF_UNIX. 
The port parameter is only used when connecting to an AF_INET socket, and 
designates the port on the remote host to which a connection should be 
made. 
Returns TRUE on success or FALSE on failure. The error code can be 
retrieved with socket_last_error(). This code may be passed to 
socket_strerror() to get a textual explanation of the error. 
See also socket_bind(), socket_listen(), socket_create(), 
socket_last_error() and socket_strerror().   socket_closeUpsocket_create_listen
#

#T=bool socket_connect ( resource socket, string address [, int port])
socket_connect ( ^!resource socket, string address [, int port]);
#

#T=socket_create_listen - resource socket_create_listen ( int port [, int backlog])
(PHP 4 >= 4.1.0)
socket_create_listen -- Opens a socket on port to accept connections 
Description
resource socket_create_listen ( int port [, int backlog])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function is meant to ease the task of creating a new socket which 
only listens to accept new connections. 
socket_create_listen() create a new socket resource of type AF_INET 
listening on all local interfaces on the given port waiting for new 
connections. 
The backlog parameter defines the maximum length the queue of pending 
connections may grow to. SOMAXCONN may be passed as backlog parameter, see 
socket_listen() for more information. 
socket_create_listen() returns a new socket resource on success or FALSE 
on error. The error code can be retrieved with socket_last_error(). This 
code may be passed to socket_strerror() to get a textual explanation of 
the error. 
Note: If you want to create a socket which only listens on a certain 
interfaces you need to use socket_create(), socket_bind() and 
socket_listen(). 
See also socket_create(), socket_bind(), socket_listen(), 
socket_last_error() and socket_strerror().   socket_connectUpsocket_create_pair
#

#T=resource socket_create_listen ( int port [, int backlog])
socket_create_listen ( ^!int port [, int backlog]);
#

#T=socket_create_pair - bool socket_create_pair ( int domain, int type, int protocol, array &fd)
(PHP 4 >= 4.1.0)
socket_create_pair -- Creates a pair of indistinguishable sockets and 
stores them in fds. 
Description
bool socket_create_pair ( int domain, int type, int protocol, array &fd)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_create_listenUpsocket_create
#

#T=bool socket_create_pair ( int domain, int type, int protocol, array &fd)
socket_create_pair ( ^!int domain, int type, int protocol, array &fd);
#

#T=socket_create - resource socket_create ( int domain, int type, int protocol)
(PHP 4 >= 4.1.0)
socket_create -- Create a socket (endpoint for communication)
Description
resource socket_create ( int domain, int type, int protocol)
Creates and returns a socket resource, also referred to as an endpoint of 
communication. A typical network connection is made up of 2 sockets, one 
performing the role of the client, and another performing the role of the 
server. 
The domain parameter specifies the protocol family to be used by the 
socket. 
Table 1. Available address/protocol families
DomainDescription
AF_INETIPv4 Internet based protocols. TCP and UDP are common 
protocols of this protocol family. 
AF_INET6IPv6 Internet based protocols. TCP and UDP are common 
protocols of this protocol family. Support added in PHP 5.0.0. 
AF_UNIXLocal communication protocol family. High efficiency and low 
overhead make it a great form of IPC (Interprocess Communication). 

The type parameter selects the type of communication to be used by the 
socket. 
Table 2. Available socket types
TypeDescription
SOCK_STREAMProvides sequenced, reliable, full-duplex, 
connection-based byte streams. An out-of-band data transmission 
mechanism may be supported. The TCP protocol is based on this socket 
type. 
SOCK_DGRAMSupports datagrams (connectionless, unreliable messages of 
a fixed maximum length). The UDP protocol is based on this socket 
type. 
SOCK_SEQPACKETProvides a sequenced, reliable, two-way 
connection-based data transmission path for datagrams of fixed 
maximum length; a consumer is required to read an entire packet with 
each read call. 
SOCK_RAWProvides raw network protocol access. This special type of 
socket can be used to manually construct any type of protocol. A 
common use for this socket type is to perform ICMP requests (like 
ping, traceroute, etc). 
SOCK_RDMProvides a reliable datagram layer that does not guarantee 
ordering. This is most likely not implemented on your operating 
system. 

The protocol parameter sets the specific protocol within the specified 
domain to be used when communicating on the returned socket. The proper 
value can be retrieved by name by using getprotobyname(). If the desired 
protocol is TCP, or UDP the corresponding constants SOL_TCP, and SOL_UDP 
can also be used. 
Table 3. Common protocols
NameDescription
icmpThe Internet Control Message Protocol is used primarily by 
gateways and hosts to report errors in datagram communication. The 
"ping" command (present in most modern operating systems) is an 
example application of ICMP. 
udpThe User Datagram Protocol is a connectionless, unreliable, 
protocol with fixed record lengths. Due to these aspects, UDP 
requires a minimum amount of protocol overhead. 
tcpThe Transmission Control Protocol is a reliable, connection 
based, stream oriented, full duplex protocol. TCP guarantees that 
all data packets will be received in the order in which they were 
sent. If any packet is somehow lost during communication, TCP will 
automatically retransmit the packet until the destination host 
acknowledges that packet. For reliability and performance reasons, 
the TCP implementation itself decides the appropriate octet 
boundaries of the underlying datagram communication layer. 
Therefore, TCP applications must allow for the possibility of 
partial record transmission. 

socket_create() Returns a socket resource on success, or FALSE on error. 
The actual error code can be retrieved by calling socket_last_error(). 
This error code may be passed to socket_strerror() to get a textual 
explanation of the error. 
Note: If an invalid domain or type is given, socket_create() defaults to 
AF_INET and SOCK_STREAM respectively and additionally emits an E_WARNING 
message. 
See also socket_accept(), socket_bind(), socket_connect(), 
socket_listen(), socket_last_error(), and socket_strerror().   socket_create_pairUpsocket_get_option
#

#T=resource socket_create ( int domain, int type, int protocol)
socket_create ( ^!int domain, int type, int protocol);
#

#T=socket_get_option - mixed socket_get_option ( resource socket, int level, int optname)
(PHP 4 >= 4.3.0)
socket_get_option -- Gets socket options for the socket 
Description
mixed socket_get_option ( resource socket, int level, int optname)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

Note: This function used to be called socket_getopt() prior to PHP 4.3.0 
  socket_createUpsocket_getpeername
socket_get_status
socket_get_status --  Alias of stream_get_meta_data(). 
Description
This function is an alias of stream_get_meta_data().   pfsockopenUpsocket_set_blocking
#

#T=mixed socket_get_option ( resource socket, int level, int optname)
socket_get_option ( ^!resource socket, int level, int optname);
#

#T=socket_getpeername - bool socket_getpeername ( resource socket, string &addr [, int &port])
(PHP 4 >= 4.1.0)
socket_getpeername --  Queries the remote side of the given socket which 
may either result in host/port or in a Unix filesystem path, dependent on 
its type. 
Description
bool socket_getpeername ( resource socket, string &addr [, int &port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

If the given socket is of type AF_INET or AF_INET6, socket_getpeername() 
will return the peers (remote) IP address in appropriate notation (e.g. 
127.0.0.1 or fe80::1) in the address parameter and, if the optional port 
parameter is present, also the associated port. 
If the given socket is of type AF_UNIX, socket_getpeername() will return 
the Unix filesystem path (e.g. /var/run/daemon.sock) in the address 
parameter. 
Note: socket_getpeername() should not be used with AF_UNIX sockets 
created with socket_accept(). Only sockets created with socket_connect() 
or a primary server socket following a call to socket_bind() will return 
meaningful values. 
Returns TRUE on success or FALSE on failure. socket_getpeername() may also 
return FALSE if the socket type is not any of AF_INET, AF_INET6, or 
AF_UNIX, in which case the last socket error code is not updated. 
See also socket_getsockname(), socket_last_error() and socket_strerror().   socket_get_optionUpsocket_getsockname
#

#T=bool socket_getpeername ( resource socket, string &addr [, int &port])
socket_getpeername ( ^!resource socket, string &addr [, int &port]);
#

#T=socket_getsockname - bool socket_getsockname ( resource socket, string &addr [, int &port])
(PHP 4 >= 4.1.0)
socket_getsockname --  Queries the local side of the given socket which 
may either result in host/port or in a Unix filesystem path, dependent on 
its type. 
Description
bool socket_getsockname ( resource socket, string &addr [, int &port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

If the given socket is of type AF_INET or AF_INET6, socket_getsockname() 
will return the local IP address in appropriate notation (e.g. 127.0.0.1 
or fe80::1) in the address parameter and, if the optional port parameter 
is present, also the associated port. 
If the given socket is of type AF_UNIX, socket_getsockname() will return 
the Unix filesystem path (e.g. /var/run/daemon.sock) in the address 
parameter. 
Note: socket_getsockname() should not be used with AF_UNIX sockets 
created with socket_connect(). Only sockets created with socket_accept() 
or a primary server socket following a call to socket_bind() will return 
meaningful values. 
Returns TRUE on success or FALSE on failure. socket_getsockname() may also 
return FALSE if the socket type is not any of AF_INET, AF_INET6, or 
AF_UNIX, in which case the last socket error code is not updated. 
See also socket_getpeername(), socket_last_error() and socket_strerror().   socket_getpeernameUpsocket_iovec_add
#

#T=bool socket_getsockname ( resource socket, string &addr [, int &port])
socket_getsockname ( ^!resource socket, string &addr [, int &port]);
#

#T=socket_iovec_add - bool socket_iovec_add ( resource iovec, int iov_len)
(PHP 4 >= 4.1.0)
socket_iovec_add -- Adds a new vector to the scatter/gather array 
Description
bool socket_iovec_add ( resource iovec, int iov_len)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_getsocknameUpsocket_iovec_alloc
#

#T=bool socket_iovec_add ( resource iovec, int iov_len)
socket_iovec_add ( ^!resource iovec, int iov_len);
#

#T=socket_iovec_alloc - resource socket_iovec_alloc ( int num_vectors [, int ])
(PHP 4 >= 4.1.0)
socket_iovec_alloc --  Builds a 'struct iovec' for use with sendmsg, 
recvmsg, writev, and readv 
Description
resource socket_iovec_alloc ( int num_vectors [, int ])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_iovec_addUpsocket_iovec_delete
#

#T=resource socket_iovec_alloc ( int num_vectors [, int ])
socket_iovec_alloc ( ^!int num_vectors [, int ]);
#

#T=socket_iovec_delete - bool socket_iovec_delete ( resource iovec, int iov_pos)
(PHP 4 >= 4.1.0)
socket_iovec_delete -- Deletes a vector from an array of vectors 
Description
bool socket_iovec_delete ( resource iovec, int iov_pos)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_iovec_allocUpsocket_iovec_fetch
#

#T=bool socket_iovec_delete ( resource iovec, int iov_pos)
socket_iovec_delete ( ^!resource iovec, int iov_pos);
#

#T=socket_iovec_fetch - string socket_iovec_fetch ( resource iovec, int iovec_position)
(PHP 4 >= 4.1.0)
socket_iovec_fetch -- Returns the data held in the iovec specified by 
iovec_id[iovec_position] 
Description
string socket_iovec_fetch ( resource iovec, int iovec_position)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_iovec_deleteUpsocket_iovec_free
#

#T=string socket_iovec_fetch ( resource iovec, int iovec_position)
socket_iovec_fetch ( ^!resource iovec, int iovec_position);
#

#T=socket_iovec_free - bool socket_iovec_free ( resource iovec)
(PHP 4 >= 4.1.0)
socket_iovec_free -- Frees the iovec specified by iovec_id 
Description
bool socket_iovec_free ( resource iovec)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_iovec_fetchUpsocket_iovec_set
#

#T=bool socket_iovec_free ( resource iovec)
socket_iovec_free ( ^!resource iovec);
#

#T=socket_iovec_set - bool socket_iovec_set ( resource iovec, int iovec_position, string 
(PHP 4 >= 4.1.0)
socket_iovec_set -- Sets the data held in iovec_id[iovec_position] to 
new_val 
Description
bool socket_iovec_set ( resource iovec, int iovec_position, string 
new_val)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_iovec_freeUpsocket_last_error
#

#T=bool socket_iovec_set ( resource iovec, int iovec_position, string 
socket_iovec_set ( ^!resource iovec, int iovec_position, string ;
#

#T=socket_last_error - int socket_last_error ( [resource socket])
(PHP 4 >= 4.1.0)
socket_last_error -- Returns the last error on the socket 
Description
int socket_last_error ( [resource socket])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function returns a socket error code. 
If a socket resource is passed to this function, the last error which 
occurred on this particular socket is returned. If the socket resource is 
omitted, the error code of the last failed socket function is returned. 
The latter is in particular helpful for functions like socket_create() 
which don't return a socket on failure and socket_select() which can fail 
for reasons not directly tied to a particular socket. The error code is 
suitable to be fed to socket_strerror() which returns a string describing 
the given error code. <?php
if (false == ($socket = @socket_create(AF_INET, SOCK_STREAM, 
SOL_TCP))) {
die("Couldn't create socket, error code is: " . 
socket_last_error() .
    ",error message is: " . 
socket_strerror(socket_last_error()));
}
?> 

Note: socket_last_error() does not clear the error code, use 
socket_clear_error() for this purpose.   socket_iovec_setUpsocket_listen
#

#T=int socket_last_error ( [resource socket])
socket_last_error ( ^![resource socket]);
#

#T=socket_listen - bool socket_listen ( resource socket [, int backlog])
(PHP 4 >= 4.1.0)
socket_listen -- Listens for a connection on a socket
Description
bool socket_listen ( resource socket [, int backlog])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

After the socket socket has been created using socket_create() and bound 
to a name with socket_bind(), it may be told to listen for incoming 
connections on socket. 
A maximum of backlog incoming connections will be queued for processing. 
If a connection request arrives with the queue full the client may receive 
an error with an indication of ECONNREFUSED, or, if the underlying 
protocol supports retransmission, the request may be ignored so that 
retries may succeed. 
Note: The maximum number passed to the backlog parameter highly depends 
on the underlying platform. On Linux, it is silently truncated to 
SOMAXCONN. On win32, if passed SOMAXCONN, the underlying service 
provider responsible for the socket will set the backlog to a maximum 
reasonable value. There is no standard provision to find out the actual 
backlog value on this platform. 
socket_listen() is applicable only to sockets of type SOCK_STREAM or 
SOCK_SEQPACKET. 
Returns TRUE on success or FALSE on failure. The error code can be 
retrieved with socket_last_error(). This code may be passed to 
socket_strerror() to get a textual explanation of the error. 
See also socket_accept(), socket_bind(), socket_connect(), socket_create() 
and socket_strerror().   socket_last_errorUpsocket_read
#

#T=bool socket_listen ( resource socket [, int backlog])
socket_listen ( ^!resource socket [, int backlog]);
#

#T=socket_read - string socket_read ( resource socket, int length [, int type])
(PHP 4 >= 4.1.0)
socket_read -- Reads a maximum of length bytes from a socket
Description
string socket_read ( resource socket, int length [, int type])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function socket_read() reads from the socket resource socket created 
by the socket_create() or socket_accept() functions. The maximum number of 
bytes read is specified by the length parameter. Otherwise you can use \r, 
\n, or \0 to end reading (depending on the type parameter, see below). 
socket_read() returns the data as a string on success, or FALSE on error. 
The error code can be retrieved with socket_last_error(). This code may be 
passed to socket_strerror() to get a textual representation of the error. 
Note: socket_read() may return a zero length string ("") indicating the 
end of communication (i.e. the remote end point has closed the 
connection). 
Optional type parameter is a named constant: 
PHP_BINARY_READ - use the system read() function. Safe for reading 
binary data. (Default in PHP >= 4.1.0) 
PHP_NORMAL_READ - reading stops at \n or \r. (Default in PHP <= 4.0.6) 
See also socket_accept(), socket_bind(), socket_connect(), 
socket_listen(), socket_last_error(), socket_strerror() and 
socket_write().   socket_listenUpsocket_readv
#

#T=string socket_read ( resource socket, int length [, int type])
socket_read ( ^!resource socket, int length [, int type]);
#

#T=socket_readv - bool socket_readv ( resource socket, resource iovec_id)
(PHP 4 >= 4.1.0)
socket_readv -- Reads from an fd, using the scatter-gather array defined 
by iovec_id 
Description
bool socket_readv ( resource socket, resource iovec_id)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_readUpsocket_recv
#

#T=bool socket_readv ( resource socket, resource iovec_id)
socket_readv ( ^!resource socket, resource iovec_id);
#

#T=socket_recv - int socket_recv ( resource socket, string &buf, int len, int flags)
(PHP 4 >= 4.1.0)
socket_recv -- Receives data from a connected socket 
Description
int socket_recv ( resource socket, string &buf, int len, int flags)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_readvUpsocket_recvfrom
#

#T=int socket_recv ( resource socket, string &buf, int len, int flags)
socket_recv ( ^!resource socket, string &buf, int len, int flags);
#

#T=socket_recvfrom - int socket_recvfrom ( resource socket, string &buf, int len, int flags, 
(PHP 4 >= 4.1.0)
socket_recvfrom -- Receives data from a socket, connected or not 
Description
int socket_recvfrom ( resource socket, string &buf, int len, int flags, 
string &name [, int &port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_recvUpsocket_recvmsg
#

#T=int socket_recvfrom ( resource socket, string &buf, int len, int flags, 
socket_recvfrom ( ^!resource socket, string &buf, int len, int flags, ;
#

#T=socket_recvmsg - bool socket_recvmsg ( resource socket, resource iovec, array &control, int 
(PHP 4 >= 4.1.0)
socket_recvmsg -- Used to receive messages on a socket, whether 
connection-oriented or not 
Description
bool socket_recvmsg ( resource socket, resource iovec, array &control, int 
&controllen, int &flags, string &addr [, int &port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_recvfromUpsocket_select
#

#T=bool socket_recvmsg ( resource socket, resource iovec, array &control, int 
socket_recvmsg ( ^!resource socket, resource iovec, array &control, int ;
#

#T=socket_select - int socket_select ( array &read, array &write, array &except, int tv_sec 
(PHP 4 >= 4.1.0)
socket_select --  Runs the select() system call on the given arrays of 
sockets with a specified timeout 
Description
int socket_select ( array &read, array &write, array &except, int tv_sec 
[, int tv_usec])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

socket_select() accepts arrays of sockets and waits for them to change 
status. Those coming with BSD sockets background will recognize that those 
socket resource arrays are in fact the so-called file descriptor sets. 
Three independent arrays of socket resources are watched. 
The sockets listed in the read array will be watched to see if characters 
become available for reading (more precisely, to see if a read will not 
block - in particular, a socket resource is also ready on end-of-file, in 
which case a socket_read() will return a zero length string). 
The sockets listed in the write array will be watched to see if a write 
will not block. 
The sockets listed in the except array will be watched for exceptions. 
Warning
On exit, the arrays are modified to indicate which socket resource 
actually changed status. 

You do not need to pass every array to socket_select(). You can leave it 
out and use an empty array or NULL instead. Also do not forget that those 
arrays are passed by reference and will be modified after socket_select() 
returns. 
Example 1. socket_select() example
  <?php
  /* Prepare the read array */
  $read = array($socket1, $socket2);

  $num_changed_sockets = socket_select($read, $write = NULL, 
  $except = NULL, 0);

  if ($num_changed_sockets === false) {
      /* Error handling */
  } else if ($num_changed_sockets > 0) {
      /* At least at one of the sockets something interesting 
  happened */
  }
  ?> 
Note: Due a limitation in the current Zend Engine it is not possible to 
pass a constant modifier like NULL directly as a parameter to a function 
which expects this parameter to be passed by reference. Instead use a 
temporary variable or an expression with the leftmost member being a 
temporary variable: Example 2. Using NULL with socket_select()
    <?php
    socket_select($r, $w, $e = NULL, 0);
    ?> 
The tv_sec and tv_usec together form the timeout parameter. The timeout is 
an upper bound on the amount of time elapsed before socket_select() 
return. tv_sec may be zero , causing socket_select() to return 
immediately. This is useful for polling. If tv_sec is NULL (no timeout), 
socket_select() can block indefinitely. 
On success socket_select() returns the number of socket resources 
contained in the modified arrays, which may be zero if the timeout expires 
before anything interesting happens. On error FALSE is returned. The error 
code can be retrieved with socket_last_error(). 
Note: Be sure to use the === operator when checking for an error. Since 
the socket_select() may return 0 the comparison with == would evaluate 
to TRUE: Example 3. Understanding socket_select()'s result
    <?php
    if (false === socket_select($r, $w, $e = NULL, 0)) {
	echo "socket_select() failed, reason: " .
	    socket_strerror(socket_last_error()) . "\n";
    }
    ?> 
Note: Be aware that some socket implementations need to be handled very 
carefully. A few basic rules: 
You should always try to use socket_select() without timeout. Your 
program should have nothing to do if there is no data available. Code 
that depends on timeouts is not usually portable and difficult to 
debug. 
No socket resource must be added to any set if you do not intend to 
check its result after the socket_select() call, and respond 
appropriately. After socket_select() returns, all socket resources in 
all arrays must be checked. Any socket resource that is available for 
writing must be written to, and any socket resource available for 
reading must be read from. 
If you read/write to a socket returns in the arrays be aware that they 
do not necessarily read/write the full amount of data you have 
requested. Be prepared to even only be able to read/write a single 
byte. 
It's common to most socket implementations that the only exception 
caught with the except array is out-of-bound data received on a 
socket. 
See also socket_read(), socket_write(), socket_last_error() and 
socket_strerror().   socket_recvmsgUpsocket_send
#

#T=int socket_select ( array &read, array &write, array &except, int tv_sec 
socket_select ( ^!array &read, array &write, array &except, int tv_sec ;
#

#T=socket_send - int socket_send ( resource socket, string buf, int len, int flags)
(PHP 4 >= 4.1.0)
socket_send -- Sends data to a connected socket 
Description
int socket_send ( resource socket, string buf, int len, int flags)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function socket_send() sends len bytes to the socket socket from buf 
The value of flags can be any ORed combination of the following: 
Table 1. possible values for flags
0x1Process OOB (out-of-band) data 
0x2Peek at incoming message 
0x4Bypass routing, use direct interface 
0x8Data completes record 
0x100Data completes transaction 

See also socket_sendmsg() and socket_sendto().   socket_selectUpsocket_sendmsg
#

#T=int socket_send ( resource socket, string buf, int len, int flags)
socket_send ( ^!resource socket, string buf, int len, int flags);
#

#T=socket_sendmsg - bool socket_sendmsg ( resource socket, resource iovec, int flags, string 
(PHP 4 >= 4.1.0)
socket_sendmsg -- Sends a message to a socket, regardless of whether it is 
connection-oriented or not 
Description
bool socket_sendmsg ( resource socket, resource iovec, int flags, string 
addr [, int port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_sendUpsocket_sendto
#

#T=bool socket_sendmsg ( resource socket, resource iovec, int flags, string 
socket_sendmsg ( ^!resource socket, resource iovec, int flags, string ;
#

#T=socket_sendto - int socket_sendto ( resource socket, string buf, int len, int flags, 
(PHP 4 >= 4.1.0)
socket_sendto -- Sends a message to a socket, whether it is connected or 
not 
Description
int socket_sendto ( resource socket, string buf, int len, int flags, 
string addr [, int port])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function socket_sendto() sends len bytes from buf through the socket 
socket to the port at the address addr 
The value of flags can be one of the following: 
Table 1. possible values for flags
0x1Process OOB (out-of-band) data. 
0x2Peek at incoming message. 
0x4Bypass routing, use direct interface. 
0x8Data completes record. 
0x100Data completes transaction. 

Example 1. socket_sendto() Example
  <?php
      $sh = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
      if (socket_bind($sh, '127.0.0.1', 4242)) {
	  echo "Socket bound correctly";
      }
      $buf = 'Test Message';
      $len = strlen($buf);
      if (socket_sendto($sh, $buf, $len, 0x100, '192.168.0.2', 
  4242) !== false) {
	  echo "Message sent correctly";
      }
      socket_close($sh);
  ?> 
See also socket_send() and socket_sendmsg().   socket_sendmsgUpsocket_set_block
#

#T=int socket_sendto ( resource socket, string buf, int len, int flags, 
socket_sendto ( ^!resource socket, string buf, int len, int flags, ;
#

#T=socket_set_block - bool socket_set_block ( resource socket)
(PHP 4 >= 4.2.0)
socket_set_block --  Sets blocking mode on a socket resource 
Description
bool socket_set_block ( resource socket)
Warning
This function is currently not documented; only the argument list is 
available.

Returns TRUE on success or FALSE on failure. 
See also socket_set_nonblock() and socket_set_option()   socket_sendtoUpsocket_set_nonblock
socket_set_blocking
socket_set_blocking -- Alias for stream_set_blocking()
Description
This function is an alias for stream_set_blocking().   socket_get_statusUpsocket_set_timeout
#

#T=bool socket_set_block ( resource socket)
socket_set_block ( ^!resource socket);
#

#T=socket_set_nonblock - bool socket_set_nonblock ( resource socket)
(PHP 4 >= 4.1.0)
socket_set_nonblock -- Sets nonblocking mode for file descriptor fd 
Description
bool socket_set_nonblock ( resource socket)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

Returns TRUE on success or FALSE on failure. 
See also socket_set_block() and socket_set_option()   socket_set_blockUpsocket_set_option
#

#T=bool socket_set_nonblock ( resource socket)
socket_set_nonblock ( ^!resource socket);
#

#T=socket_set_option - bool socket_set_option ( resource socket, int level, int optname, mixed 
(PHP 4 >= 4.3.0)
socket_set_option -- Sets socket options for the socket
Description
bool socket_set_option ( resource socket, int level, int optname, mixed 
optval)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.

Note: This function used to be called socket_setopt() prior to PHP 4.3.0 
  socket_set_nonblockUpsocket_shutdown
socket_set_timeout
socket_set_timeout -- Alias for stream_set_timeout()
Description
socket_set_timeout() is an alias for stream_set_timeout().   socket_set_blockingUpsyslog
#

#T=bool socket_set_option ( resource socket, int level, int optname, mixed 
socket_set_option ( ^!resource socket, int level, int optname, mixed ;
#

#T=socket_shutdown - bool socket_shutdown ( resource socket [, int how])
(PHP 4 >= 4.1.0)
socket_shutdown -- Shuts down a socket for receiving, sending, or both. 
Description
bool socket_shutdown ( resource socket [, int how])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The socket_shutdown() function allows you to stop incoming, outgoing or 
all data (the default) from being sent through the socket 
The value of how can be one of the following: 
Table 1. possible values for how
0Shutdown socket reading 
1Shutdown socket writing 
2Shutdown socket reading and writing 
  socket_set_optionUpsocket_strerror
#

#T=bool socket_shutdown ( resource socket [, int how])
socket_shutdown ( ^!resource socket [, int how]);
#

#T=socket_strerror - string socket_strerror ( int errno)
(PHP 4 >= 4.1.0)
socket_strerror -- Return a string describing a socket error
Description
string socket_strerror ( int errno)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

socket_strerror() takes as its errno parameter a socket error code as 
returned by socket_last_error() and returns the corresponding explanatory 
text. This makes it a bit more pleasant to figure out why something didn't 
work; for instance, instead of having to track down a system include file 
to find out what '-111' means, you just pass it to socket_strerror(), and 
it tells you what happened. 
Example 1. socket_strerror() example
  <?php
  if (false == ($socket = @socket_create(AF_INET, SOCK_STREAM, 
  SOL_TCP))) {
     echo "socket_create() failed: reason: " . 
  socket_strerror(socket_last_error()) . "\n";
  } 

  if (false == (@socket_bind($socket, '127.0.0.1', 80))) {
     echo "socket_bind() failed: reason: " . 
  socket_strerror(socket_last_error($socket)) . "\n";
  }
  ?> 

The expected output from the above example (assuming the script is 
not run with root privileges): socket_bind() failed: reason: Permission denied
See also socket_accept(), socket_bind(), socket_connect(), 
socket_listen(), and socket_create().   socket_shutdownUpsocket_write
#

#T=string socket_strerror ( int errno)
socket_strerror ( ^!int errno);
#

#T=socket_write - int socket_write ( resource socket, string buffer [, int length])
(PHP 4 >= 4.1.0)
socket_write -- Write to a socket
Description
int socket_write ( resource socket, string buffer [, int length])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The function socket_write() writes to the socket socket from buffer. 
The optional parameter length can specify an alternate length of bytes 
written to the socket. If this length is greater then the buffer length, 
it is silently truncated to the length of the buffer. 
Returns the number of bytes successfully written to the socket or FALSE 
one error. The error code can be retrieved with socket_last_error(). This 
code may be passed to socket_strerror() to get a textual explanation of 
the error. 
Note: socket_write() does not necessarily write all bytes from the given 
buffer. It's valid that, depending on the network buffers etc., only a 
certain amount of data, even one byte, is written though your buffer is 
greater. You have to watch out so you don't unintentionally forget to 
transmit the rest of your data. 
Note: It is perfectly valid for socket_write() to return zero which 
means no bytes have been written. Be sure to use the === operator to 
check for FALSE in case of an error. 
See also socket_accept(), socket_bind(), socket_connect(), 
socket_listen(), socket_read() and socket_strerror().   socket_strerrorUpsocket_writev
#

#T=int socket_write ( resource socket, string buffer [, int length])
socket_write ( ^!resource socket, string buffer [, int length]);
#

#T=socket_writev - bool socket_writev ( resource socket, resource iovec_id)
(PHP 4 >= 4.1.0)
socket_writev -- Writes to a file descriptor, fd, using the scatter-gather 
array defined by iovec_id 
Description
bool socket_writev ( resource socket, resource iovec_id)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  socket_writeUpStream functions
#

#T=bool socket_writev ( resource socket, resource iovec_id)
socket_writev ( ^!resource socket, resource iovec_id);
#

#T=sort - bool sort ( array array [, int sort_flags])
(PHP 3, PHP 4 )
sort -- Sort an array
Description
bool sort ( array array [, int sort_flags])
This function sorts an array. Elements will be arranged from lowest to 
highest when this function has completed. 
Note: This function assigns new keys for the elements in array. It will 
remove any existing keys you may have assigned, rather than just 
reordering the keys. 
Returns TRUE on success or FALSE on failure. 
Example 1. sort() example
  <?php

  $fruits = array("lemon", "orange", "banana", "apple");
  sort($fruits);
  reset($fruits);
  while (list($key, $val) = each($fruits)) {
      echo "fruits[" . $key . "] = " . $val . "\n";
  }

  ?> 

This example would display: 
fruits[0] = apple
fruits[1] = banana
fruits[2] = lemon
fruits[3] = orange
The fruits have been sorted in alphabetical order. 
The optional second parameter sort_flags may be used to modify the sorting 
behavior using these values: 
Sorting type flags: 
SORT_REGULAR - compare items normally
SORT_NUMERIC - compare items numerically
SORT_STRING - compare items as strings
Note: The second parameter was added in PHP 4. 
See also arsort(), asort(), ksort(), natsort(), natcasesort(), rsort(), 
usort(), array_multisort(), and uksort().   sizeofUpuasort
#

#T=bool sort ( array array [, int sort_flags])
sort ( ^!array array [, int sort_flags]);
#

#T=soundex - string soundex ( string str)
(PHP 3, PHP 4 )
soundex -- Calculate the soundex key of a string
Description
string soundex ( string str)
Calculates the soundex key of str. 
Soundex keys have the property that words pronounced similarly produce the 
same soundex key, and can thus be used to simplify searches in databases 
where you know the pronunciation but not the spelling. This soundex 
function returns a string 4 characters long, starting with a letter. 
This particular soundex function is one described by Donald Knuth in "The 
Art Of Computer Programming, vol. 3: Sorting And Searching", 
Addison-Wesley (1973), pp. 391-392. 
Example 1. Soundex Examples
  <?php
  soundex("Euler") == soundex("Ellery"); // E460
  soundex("Gauss") == soundex("Ghosh"); // G200
  soundex("Hilbert") == soundex("Heilbronn"); // H416
  soundex("Knuth") == soundex("Kant"); // K530
  soundex("Lloyd") == soundex("Ladd"); // L300
  soundex("Lukasiewicz") == soundex("Lissajous"); // L222
  ?> 
See also levenshtein(), metaphone(), and similar_text().   similar_textUpsprintf
#

#T=string soundex ( string str)
soundex ( ^!string str);
#

#T=split - array split ( string pattern, string string [, int limit])
(PHP 3, PHP 4 )
split -- split string into array by regular expression
Description
array split ( string pattern, string string [, int limit])
Tip: preg_split(), which uses a Perl-compatible regular expression 
syntax, is often a faster alternative to split(). If you don't require 
the power of regular expressions, it is faster to use explode(), which 
doesn't incur the overhead of the regular expression engine. 
Returns an array of strings, each of which is a substring of string formed 
by splitting it on boundaries formed by the case-sensitive regular 
expression pattern. If limit is set, the returned array will contain a 
maximum of limit elements with the last element containing the whole rest 
of string. If an error occurs, split() returns FALSE. 
To split off the first four fields from a line from /etc/passwd: 
Example 1. split() example
  <?php
  list($user, $pass, $uid, $gid, $extra) =
      split(":", $passwd_line, 5);
  ?> 
If there are n occurrences of pattern, the returned array will contain n+1 
items. For example, if there is no occurrence of pattern, an array with 
only one element will be returned. Of course, this is also true if string 
is empty. 
To parse a date which may be delimited with slashes, dots, or hyphens: 
Example 2. split() example
  <?php
  // Delimiters may be slash, dot, or hyphen
  $date = "04/30/1973";
  list($month, $day, $year) = split('[/.-]', $date);
  echo "Month: $month; Day: $day; Year: $year<br />\n";
  ?> 
For users looking for a way to emulate Perl's @chars = split('', $str) 
behaviour, please see the examples for preg_split(). 
Please note that pattern is a regular expression. If you want to split on 
any of the characters which are considered special by regular expressions, 
you'll need to escape them first. If you think split() (or any other regex 
function, for that matter) is doing something weird, please read the file 
regex.7, included in the regex/ subdirectory of the PHP distribution. It's 
in manpage format, so you'll want to do something along the lines of man 
/usr/local/src/regex/regex.7 in order to read it. 
See also: preg_split(), spliti(), explode(), implode(), chunk_split(), and 
wordwrap().   eregiUpspliti
#

#T=array split ( string pattern, string string [, int limit])
split ( ^!string pattern, string string [, int limit]);
#

#T=spliti - array spliti ( string pattern, string string [, int limit])
(PHP 4 >= 4.0.1)
spliti --  Split string into array by regular expression case insensitive 
Description
array spliti ( string pattern, string string [, int limit])
This function is identical to split() except that this ignores case 
distinction when matching alphabetic characters. 
See also preg_spliti(), split(), explode(), and implode().   splitUpsql_regcase
#

#T=array spliti ( string pattern, string string [, int limit])
spliti ( ^!string pattern, string string [, int limit]);
#

#T=sprintf - string sprintf ( string format [, mixed args])
(PHP 3, PHP 4 )
sprintf -- Return a formatted string
Description
string sprintf ( string format [, mixed args])
Returns a string produced according to the formatting string format. 
The format string is composed of zero or more directives: ordinary 
characters (excluding %) that are copied directly to the result, and 
conversion specifications, each of which results in fetching its own 
parameter. This applies to both sprintf() and printf(). 
Each conversion specification consists of a percent sign (%), followed by 
one or more of these elements, in order: 
An optional padding specifier that says what character will be used for 
padding the results to the right string size. This may be a space 
character or a 0 (zero character). The default is to pad with spaces. An 
alternate padding character can be specified by prefixing it with a 
single quote ('). See the examples below. 
An optional alignment specifier that says if the result should be 
left-justified or right-justified. The default is right-justified; a - 
character here will make it left-justified. 
An optional number, a width specifier that says how many characters 
(minimum) this conversion should result in. 
An optional precision specifier that says how many decimal digits should 
be displayed for floating-point numbers. This option has no effect for 
other types than float. (Another function useful for formatting numbers 
is number_format().) 
A type specifier that says what type the argument data should be treated 
as. Possible types: 
% - a literal percent character. No argument is required. 
b - the argument is treated as an integer, and presented as a 
binary number. 
c - the argument is treated as an integer, and presented as the 
character with that ASCII value. 
d - the argument is treated as an integer, and presented as a 
(signed) decimal number. 
u - the argument is treated as an integer, and presented as an 
unsigned decimal number. 
f - the argument is treated as a float, and presented as a 
floating-point number. 
o - the argument is treated as an integer, and presented as an 
octal number. 
s - the argument is treated as and presented as a string. 
x - the argument is treated as an integer and presented as a 
hexadecimal number (with lowercase letters). 
X - the argument is treated as an integer and presented as a 
hexadecimal number (with uppercase letters). 

As of PHP version 4.0.6 the format string supports argument 
numbering/swapping. Here is an example: Example 1. Argument swapping
  <?php
  $format = "There are %d monkeys in the %s";
  printf($format, $num, $location);
  ?> 

This might output, "There are 5 monkeys in the tree". But imagine we are 
creating a format string in a separate file, commonly because we would 
like to internationalize it and we rewrite it as: Example 2. 
Argument swapping
  <?php
  $format = "The %s contains %d monkeys";
  printf($format, $num, $location);
  ?> 

We now have a problem. The order of the placeholders in the format string 
does not match the order of the arguments in the code. We would like to 
leave the code as is and simply indicate in the format string which 
arguments the placeholders refer to. We would write the format string like 
this instead: Example 3. Argument swapping
  <?php
  $format = "The %2\$s contains %1\$d monkeys";
  printf($format, $num, $location);
  ?> 

An added benefit here is that you can repeat the placeholders without 
adding more arguments in the code. For example: Example 4. Argument 
swapping
  <?php
  $format = "The %2\$s contains %1\$d monkeys.
	     That's a nice %2\$s full of %1\$d monkeys.";
  printf($format, $num, $location);
  ?> 
See also printf(), sscanf(), fscanf(), vsprintf(), and number_format(). 
Examples
Example 5. sprintf(): zero-padded integers
  <?php
  $isodate = sprintf("%04d-%02d-%02d", $year, $month, $day);
  ?> 

Example 6. sprintf(): formatting currency
  <?php
  $money1 = 68.75;
  $money2 = 54.35;
  $money = $money1 + $money2;
  // echo $money will output "123.1";
  $formatted = sprintf("%01.2f", $money);
  // echo $formatted will output "123.10"
  ?> 

  soundexUpsscanf
#

#T=string sprintf ( string format [, mixed args])
sprintf ( ^!string format [, mixed args]);
#

#T=sql_regcase - string sql_regcase ( string string)
(PHP 3, PHP 4 )
sql_regcase --  Make regular expression for case insensitive match 
Description
string sql_regcase ( string string)
Returns a valid regular expression which will match string, ignoring case. 
This expression is string with each alphabetic character converted to a 
bracket expression; this bracket expression contains that character's 
uppercase and lowercase form. Other characters remain unchanged. 
Example 1. sql_regcase() example
  <?php
  echo sql_regcase("Foo - bar.");
  ?> 

prints: 
[Ff][Oo][Oo] - [Bb][Aa][Rr].
This can be used to achieve case insensitive pattern matching in products 
which support only case sensitive regular expressions.   splitiUpSemaphore, Shared Memory and IPC Functions
sqlite_array_query
(no version information, might be only in CVS)
sqlite_array_query -- Execute a query against a given database and returns 
an array.
Description
array sqlite_array_query ( resource dbhandle, string query [, int 
result_type [, bool decode_binary]])

array sqlite_array_query ( string query, resource dbhandle [, int 
result_type [, bool decode_binary]])
sqlite_array_query() is similar to calling sqlite_query() and then 
sqlite_fetch_array() for each row of the result set and storing it into an 
array, as shown in the example below. Calling sqlite_array_query() is 
significantly faster than using such a script. 
Example 1. sqlite_array_query() implemented yourself
  <?php
  $q = sqlite_query($dbhandle, "SELECT * from foo LIMIT 100");
  $rows = array();
  while ($r = sqlite_fetch_array($q)) {
      $rows[] = $r;
  }
  ?> 
Tip: sqlite_array_query() is best suited to queries returning 45 rows or 
less. If you have more data than that, it is recommended that you write 
your scripts to use sqlite_unbuffered_query() instead for more optimal 
performance. 
See also sqlite_query(), sqlite_fetch_array(), and sqlite_fetch_string().   SQLiteUpsqlite_busy_timeout
sqlite_busy_timeout
(no version information, might be only in CVS)
sqlite_busy_timeout -- Set busy timeout duration, or disable busy 
handlers.
Description
void sqlite_busy_timeout ( resource dbhandle, int milliseconds)
Set the maximum time that sqlite will wait for a dbhandle to become ready 
for use to milliseconds. If milliseconds is 0, busy handlers will be 
disabled and sqlite will return immediately with a SQLITE_BUSY status code 
if another process/thread has the database locked for an update. 
PHP sets the default busy timeout to be 60 seconds when the database is 
opened. 
Note: There are one thousand (1000) milliseconds in one second. 
See also sqlite_open().   sqlite_array_queryUpsqlite_changes
sqlite_changes
(no version information, might be only in CVS)
sqlite_changes --  Returns the number of rows that were changed by the 
most recent SQL statement. 
Description
int sqlite_changes ( resource dbhandle)
Returns the numbers of rows that were changed by the most recent SQL 
statement executed against the dbhandle database handle. 
See also sqlite_num_rows().   sqlite_busy_timeoutUpsqlite_close
sqlite_close
(no version information, might be only in CVS)
sqlite_close -- Closes an open SQLite database.
Description
void sqlite_close ( resource dbhandle)
Closes the given database handle. If the database was persistent, it will 
be closed and removed from the persistent list. 
See also sqlite_open() and sqlite_popen().   sqlite_changesUpsqlite_column
sqlite_column
(no version information, might be only in CVS)
sqlite_column -- Fetches a column from the current row of a result set.
Description
mixed sqlite_column ( resource result, mixed index_or_name [, bool 
decode_binary])
Fetches the value of a column named index_or_name (if it is a string), or 
of the ordinal column numbered index_or_name (if it is an integer) from 
the current row of the query result handle result. The decode binary flag 
operates in the same way as described under sqlite_fetch_array(). 
Use this function when you are iterating a large result set with many 
columns, or with columns that contain large amounts of data. 
See also sqlite_fetch_string().   sqlite_closeUpsqlite_create_aggregate
sqlite_create_aggregate
(no version information, might be only in CVS)
sqlite_create_aggregate -- Register an aggregating UDF for use in SQL 
statements.
Description
bool sqlite_create_aggregate ( resource dbhandle, string function_name, 
mixed step_func, mixed finalize_func [, int num_args])
sqlite_create_aggregate() is similar to sqlite_create_function() except 
that it registers functions that can be used to calculate a result 
aggregated across all the rows of a query. 
The key difference between this function and sqlite_create_function() is 
that two functions are required to manage the aggregate; step_func is 
called for each row of the result set. Your PHP function should accumulate 
the result and store it into the aggregation context. Once all the rows 
have been processed, finalize_func will be called and it should then take 
the data from the aggregation context and return the result. 
Example 1. max_length aggregation function example
  <?php
  $data = array(
     'one',
     'two',
     'three',
     'four',
     'five',
     'six',
     'seven',
     'eight',
     'nine',
     'ten',
     );
  $dbhandle = sqlite_open(':memory:');
  sqlite_query($dbhandle, "CREATE TABLE strings(a)");
  foreach ($data as $str) {
      $str = sqlite_escape_string($str);
      sqlite_query($dbhandle, "INSERT INTO strings VALUES 
  ('$str')");
  }

  function max_len_step(&$context, $string) {
      if (strlen($string) > $context) {
	  $context = strlen($string);
      }
  }

  function max_len_finalize(&$context) {
      return $context;
  }

  sqlite_create_aggregate($dbhandle, 'max_len', 'max_len_step', 
  'max_len_finalize');

  var_dump(sqlite_array_query($dbhandle, 'SELECT max_len(a) from 
  strings'));

  ?> 
In this example, we are creating an aggregating function that will 
calculate the length of the longest string in one of the columns of the 
table. For each row, the max_len_step function is called and passed a 
context parameter. The context parameter is just like any other PHP 
variable and be set to hold an array or even an object value. In this 
example, we are simply using it to hold the maximum length we have seen so 
far; if the string has a length longer than the current maximum, we update 
the the context to hold this new maximum length. 
After all of the rows have been processed, SQLite calls the 
max_len_finalize function to determine the aggregate result. Here, we 
could perform some kind of calculation based on the data found in the 
context. In our simple example though, we have been calculating the result 
as the query progressed, so we simply need to return the context value. 
Note: The example above will not work correctly if the column contains 
binary data. Take a look at the manual page for 
sqlite_udf_decode_binary() for an explanation of why this is so, and an 
example of how to make it respect the binary encoding. 
Tip: It is NOT recommended for you to store a copy of the values in the 
context and then process them at the end, as you would cause SQLite to 
use a lot of memory to process the query - just think of how much memory 
you would need if a million rows were stored in memory, each containing 
a string 32 bytes in length. 
Tip: You can use sqlite_create_function() and sqlite_create_aggregate() 
to override SQLite native SQL functions. 
See also sqlite_create_function(), sqlite_udf_encode_binary() and 
sqlite_udf_decode_binary().   sqlite_columnUpsqlite_create_function
sqlite_create_function
(no version information, might be only in CVS)
sqlite_create_function --  Registers a "regular" User Defined Function for 
use in SQL statements. 
Description
bool sqlite_create_function ( resource dbhandle, string function_name, 
mixed callback [, int num_args])
sqlite_create_function() allows you to register a PHP function with SQLite 
as an UDF (User Defined Function), so that it can be called from within 
your SQL statements. 
dbhandle specifies the database handle that you wish to extend, 
function_name specifies the name of the function that you will use in your 
SQL statements, callback is any valid PHP callback to specify a PHP 
function that should be called to handle the SQL function. The optional 
parameter num_args is used as a hint by the SQLite expression 
parser/evaluator. It is recommended that you specify a value if your 
function will only ever accept a fixed number of parameters. 
The UDF can be used in any SQL statement that can call functions, such as 
SELECT and UPDATE statements and also in triggers. 
Example 1. sqlite_create_function() example
  <?php
  function md5_and_reverse($string) {
      return strrev(md5($string));
  }

  if ($dbhandle = sqlite_open('mysqlitedb', 0666, $sqliteerror)) 
  {
      
      sqlite_create_function($dbhandle, 'md5rev', 
  'md5_and_reverse', 1);
      
      $sql  = 'SELECT md5rev(filename) FROM files';
      $rows = sqlite_array_query($dbhandle, $sql);
  } else {
      echo 'Error opening sqlite db: ' . $sqliteerror;
      exit;
  }
  ?> 
In this example, we have a function that calculates the md5 sum of a 
string, and then reverses it. When the SQL statement executes, it returns 
the value of the filename transformed by our function. The data returned 
in $rows contains the processed result. 
The beauty of this technique is that you do not need to process the result 
using a foreach() loop after you have queried for the data. 
PHP registers a special function named php when the database is first 
opened. The php function can be used to call any PHP function without 
having to register it first. 
Example 2. Example of using the PHP function
  <?php
  $rows = sqlite_array_query($dbhandle, "SELECT php('md5', 
  filename) from files");
  ?> 

This example will call the md5() on each filename column in the 
database and return the result into $rows 

Note: For performance reasons, PHP will not automatically encode/decode 
binary data passed to and from your UDF's. You need to manually 
encode/decode the parameters and return values if you need to process 
binary data in this way. Take a look at sqlite_udf_encode_binary() and 
sqlite_udf_decode_binary() for more details. 
Tip: It is not recommended to use UDF's to handle processing of binary 
data, unless high performance is not a key requirement of your 
application. 
Tip: You can use sqlite_create_function() and sqlite_create_aggregate() 
to override SQLite native SQL functions. 
See also sqlite_create_aggregate().   sqlite_create_aggregateUpsqlite_current
sqlite_current
(no version information, might be only in CVS)
sqlite_current -- Fetches the current row from a result set as an array.
Description
array sqlite_current ( resource result [, int result_type [, bool 
decode_binary]])
sqlite_current() is identical to sqlite_fetch_array() except that it does 
not advance to the next row prior to returning the data; it returns the 
data from the current position only. 
If the current position is beyond the final row, this function returns 
FALSE 
Note: This function will not work on unbuffered result handles. 
See also sqlite_seek(), sqlite_next(), and sqlite_fetch_array().   sqlite_create_functionUpsqlite_error_string
sqlite_error_string
(no version information, might be only in CVS)
sqlite_error_string -- Returns the textual description of an error code.
Description
string sqlite_error_string ( int error_code)
Returns a human readable description of the error_code returned from 
sqlite_last_error(). 
See also sqlite_last_error().   sqlite_currentUpsqlite_escape_string
sqlite_escape_string
(no version information, might be only in CVS)
sqlite_escape_string -- Escapes a string for use as a query parameter
Description
string sqlite_escape_string ( string item)
sqlite_escape_string() will correctly quote the string specified by item 
for use in an SQLite SQL statement. This includes doubling up single-quote 
characters (') and checking for binary-unsafe characters in the query 
string. 
If the item contains a NUL character, or if it begins with a character 
whose ordinal value is 0x01, PHP will apply a binary encoding scheme so 
that you can safely store and retrieve binary data. 
Although the encoding makes it safe to insert the data, it will render 
simple text comparisons and LIKE clauses in your queries unusable for the 
columns that contain the binary data. In practice, this shouldn't be a 
problem, as your schema should be such that you don't use such things on 
binary columns (in fact, it might be better to store binary data using 
other means, such as in files). 
Warning
addslashes() should NOT be used to quote your strings for SQLite 
queries; it will lead to strange results when retrieving your data. 

Note: Do not use this function to encode the return values from UDF's 
created using sqlite_create_function() or sqlite_create_aggregate() - 
use sqlite_udf_encode_binary() instead. 
See also sqlite_udf_encode_binary().   sqlite_error_stringUpsqlite_fetch_array
sqlite_fetch_array
(no version information, might be only in CVS)
sqlite_fetch_array -- Fetches the next row from a result set as an array.
Description
array sqlite_fetch_array ( resource result [, int result_type [, bool 
decode_binary]])
Fetches the next row from the given result handle. If there are no more 
rows, returns FALSE, otherwise returns an associative array representing 
the row data. 
result_type can be used to specify how you want the results to be 
returned. The default value is SQLITE_BOTH which returns columns indexed 
by their ordinal column number and by column name. SQLITE_ASSOC causes the 
array to be indexed only by column names, and SQLITE_NUM to be indexed 
only by ordinal column numbers. 
The column names returned by SQLITE_ASSOC and SQLITE_BOTH will be 
case-folded according to the value of the sqlite.assoc_case configuration 
option. 
When decode_binary is set to TRUE (the default), PHP will decode the 
binary encoding it applied to the data if it was encoded using the 
sqlite_escape_string(). You will usually always leave this value at its 
default, unless you are interoperating with databases created by other 
sqlite capable applications. 
See also sqlite_array_query() and sqlite_fetch_string().   sqlite_escape_stringUpsqlite_fetch_single
sqlite_fetch_single
(no version information, might be only in CVS)
sqlite_fetch_single -- Fetches the first column of a result set as a 
string.
Description
string sqlite_fetch_single ( resource result [, int result_type [, bool 
decode_binary]])
sqlite_fetch_single() is identical to sqlite_fetch_array() except that it 
returns the value of the first column of the rowset. 
This is the most optimal way to retrieve data when you are only interested 
in the values from a single column of data. 
Example 1. A sqlite_fetch_single() example
  <?php
  if ($dbhandle = sqlite_open('mysqlitedb', 0666, $sqliteerror)) 
  {

      $sql = "SELECT id FROM sometable WHERE id = 42";
      $res = sqlite_query($dbhandle, $sql);

      if (sqlite_num_rows($res) > 0) {
	  echo sqlite_fetch_single($res); // 42
      }
      
      sqlite_close($dbhandle);
  }
  ?> 
See also sqlite_fetch_array().   sqlite_fetch_arrayUpsqlite_fetch_string
sqlite_fetch_string
sqlite_fetch_string -- Alias of sqlite_fetch_single()
Description
This function is an alias of sqlite_fetch_single().   sqlite_fetch_singleUpsqlite_field_name
sqlite_field_name
(no version information, might be only in CVS)
sqlite_field_name -- Returns the name of a particular field.
Description
string sqlite_field_name ( resource result, int field_index)
Given the ordinal column number, field_index, returns the name of that 
field in the result handle result.   sqlite_fetch_stringUpsqlite_has_more
sqlite_has_more
(no version information, might be only in CVS)
sqlite_has_more -- Returns whether or not more rows are available.
Description
bool sqlite_has_more ( resource result)
sqlite_has_more() returns TRUE if there are more rows available from the 
result handle, or FALSE otherwise. 
See also sqlite_num_rows() and sqlite_changes().   sqlite_field_nameUpsqlite_last_error
sqlite_last_error
(no version information, might be only in CVS)
sqlite_last_error -- Returns the error code of the last error for a 
database.
Description
int sqlite_last_error ( resource dbhandle)
Returns the error code from the last operation performed on dbhandle, the 
database handle. A human readable description of the error code can be 
retrieved using sqlite_error_string(). 
See also sqlite_error_string().   sqlite_has_moreUpsqlite_last_insert_rowid
sqlite_last_insert_rowid
(no version information, might be only in CVS)
sqlite_last_insert_rowid -- Returns the rowid of the most recently 
inserted row.
Description
int sqlite_last_insert_rowid ( resource dbhandle)
Returns the rowid of the row that was most recently inserted into the 
database dbhandle, if it was created as an auto-increment field. 
Tip: You can create auto-increment fields in SQLite by declaring them as 
INTEGER PRIMARY KEY in your table schema.   sqlite_last_errorUpsqlite_libencoding
sqlite_libencoding
(no version information, might be only in CVS)
sqlite_libencoding -- Returns the encoding of the linked SQLite library.
Description
string sqlite_libencoding ( void )
The SQLite library may be compiled in either ISO-8859-1 or UTF-8 
compatible modes. This function allows you to determine which encoding 
scheme is used by your version of the library. 
Warning
The default PHP distribution builds libsqlite in ISO-8859-1 encoding 
mode. However, this is a misnomer; rather than handling ISO-8859-1, 
it operates according to your current locale settings for string 
comparisons and sort ordering. So, rather than ISO-8859-1, you 
should think of it as being '8-bit' instead. 

When compiled with UTF-8 support, sqlite handles encoding and decoding of 
UTF-8 multi-byte character sequences, but does not yet do a complete job 
when working with the data (no normalization is performed for example), 
and some comparison operations may still not be carried out correctly. 
Warning
It is not recommended that you use PHP in a web-server configuration 
with a version of the SQLite library compiled with UTF-8 support, 
since libsqlite will abort the process if it detects a problem with 
the UTF-8 encoding. 

See also sqlite_libversion().   sqlite_last_insert_rowidUpsqlite_libversion
sqlite_libversion
(no version information, might be only in CVS)
sqlite_libversion -- Returns the version of the linked SQLite library.
Description
string sqlite_libversion ( void )
Returns the version of the linked SQLite library as a string. 
See also sqlite_libencoding().   sqlite_libencodingUpsqlite_next
sqlite_next
(no version information, might be only in CVS)
sqlite_next -- Seek to the next row number.
Description
bool sqlite_next ( resource result)
sqlite_next() advances the result handle result to the next row. Returns 
FALSE if there are no more rows, TRUE otherwise. 
Note: This function cannot be used with unbuffered result handles. 
See also sqlite_seek(), sqlite_current() and sqlite_rewind().   sqlite_libversionUpsqlite_num_fields
sqlite_num_fields
(no version information, might be only in CVS)
sqlite_num_fields -- Returns the number of fields in a result set.
Description
int sqlite_num_fields ( resource result)
Returns the number of fields in the result set. 
See also sqlite_column() and sqlite_num_rows().   sqlite_nextUpsqlite_num_rows
sqlite_num_rows
(no version information, might be only in CVS)
sqlite_num_rows -- Returns the number of rows in a buffered result set.
Description
int sqlite_num_rows ( resource result)
Returns the number of rows in the buffered result set. 
Note: This function cannot be used with unbuffered result sets. 
See also sqlite_changes() and sqlite_query().   sqlite_num_fieldsUpsqlite_open
sqlite_open
(no version information, might be only in CVS)
sqlite_open -- Opens a SQLite database. Will create the database if it 
does not exist
Description
resource sqlite_open ( string filename [, int mode [, string 
&error_message]])
Returns a resource (database handle) on success, FALSE on error. 
The filename parameter is the name of the database. It can be a relative 
or absolute path to the file that sqlite will use to store your data. If 
the file does not exist, sqlite will attempt to create it. You MUST have 
write permissions to the file if you want to insert data or modify the 
database schema. 
The mode parameter specifies the mode of the file and is intended to be 
used to open the database in read-only mode. Presently, this parameter is 
ignored by the sqlite library. The default value for mode is the octal 
value 0666 and this is the recommended value to use if you need access to 
the errmessage parameter. 
errmessage is passed by reference and is set to hold a descriptive error 
message explaining why the database could not be opened if there was an 
error. 
Example 1. sqlite_open() example
  <?php
  if ($db = sqlite_open('mysqlitedb', 0666, $sqliteerror)) { 
      sqlite_query($db, 'CREATE TABLE foo (bar varchar(10))');
      sqlite_query($db, "INSERT INTO foo VALUES ('fnord')");
      $result = sqlite_query($db, 'select bar from foo');
      var_dump(sqlite_fetch_array($result)); 
  } else {
      die($sqliteerror);
  }
  ?> 
Tip: On Unix platforms, SQLite is sensitive to scripts that use the 
fork() system call. If you do have such a script, it is recommended that 
you close the handle prior to forking and then re-open it in the child 
and/or parent. For more information on this issue, see The C language 
interface to the SQLite library in the section entitled Multi-Threading 
And SQLite. 
Tip: It is not recommended to work with SQLite databases mounted on NFS 
partitions. Since NFS is notoriously bad when it comes to locking you 
may find that you cannot even open the database at all, and if it 
succeeds, the locking behaviour may be undefined. 
Note: Starting with SQLite library version 2.8.2, you can specify 
:memory: as the filename to create a database that lives only in the 
memory of the computer. This is useful mostly for temporary processing, 
as the in-memory database will be destroyed when the process ends. It 
can also be useful when coupled with the ATTACH DATABASE SQL statement 
to load other databases and move and query data between them. 
Note: SQLite is safe mode and open_basedir aware. 
See also sqlite_popen(), sqlite_close() and sqlite_query().   sqlite_num_rowsUpsqlite_popen
sqlite_popen
(no version information, might be only in CVS)
sqlite_popen --  Opens a persistent handle to an SQLite database. Will 
create the database if it does not exist. 
Description
resource sqlite_popen ( string filename [, int mode [, string 
&error_message]])
This function behaves identically to sqlite_open() except that is uses the 
persistent resource mechanism of PHP. For information about the meaning of 
the parameters, read the sqlite_open() manual page. 
sqlite_popen() will first check to see if a persistent handle has already 
been opened for the given filename. If it finds one, it returns that 
handle to your script, otherwise it opens a fresh handle to the database. 
The benefit of this approach is that you don't incur the performance cost 
of re-reading the database and index schema on each page hit served by 
persistent web server SAPI's (any SAPI except for regular CGI or CLI). 
Note: If you use persistent handles and have the database updated by a 
background process (perhaps via a crontab), and that process re-creates 
the database by overwriting it (either by unlinking and rebuilding, or 
moving the updated version to replace the current version), you may 
experience undefined behaviour when a persistent handle on the old 
version of the database is recycled. 
To avoid this situation, have your background processes open the same 
database file and perform their updates in a transaction. 
See also sqlite_open(), sqlite_close() and sqlite_query().   sqlite_openUpsqlite_query
sqlite_query
(no version information, might be only in CVS)
sqlite_query --  Executes a query against a given database and returns a 
result handle. 
Description
resource sqlite_query ( resource dbhandle, string query)

resource sqlite_query ( string query, resource dbhandle)
Executes an SQL statement given by the query against a given database 
handle (specified by the dbhandle parameter). 
For queries that return rows, this function will return a result handle 
which can then be used with functions such as sqlite_fetch_array() and 
sqlite_seek(). 
For other kinds of queries, this function will return a boolean result; 
TRUE for success or FALSE for failure. 
Regardless of the query type, this function will return FALSE if the query 
failed. 
sqlite_query() returns a buffered, seekable result handle. This is useful 
for reasonably small queries where you need to be able to randomly access 
the rows. Buffered result handles will allocate memory to hold the entire 
result and will not return until it has been fetched. If you only need 
sequential access to the data, it is recommended that you use the much 
higher performance sqlite_unbuffered_query() instead. 
Note: Two alternative syntaxes are supported for compatibility with 
other database extensions (such as MySQL). The preferred form is the 
first one, where the db parameter is the first parameter to the 
function. 
Warning
SQLite will execute multiple queries separated by semicolons, so you 
can use it to execute a batch of SQL that you have loaded from a 
file or have embedded in a script. 
When executing multiple queries, the return value of this function 
will be FALSE if the was an error, but undefined otherwise (it might 
be TRUE for success or it might return a result handle). 

See also sqlite_unbuffered_query() and sqlite_array_query().   sqlite_popenUpsqlite_rewind
sqlite_rewind
(no version information, might be only in CVS)
sqlite_rewind -- Seek to the first row number.
Description
bool sqlite_rewind ( resource result)
sqlite_rewind() seeks back to the first row in the result set. Returns 
FALSE if there are no rows in the result set, TRUE otherwise. 
Note: This function cannot be used with unbuffered result sets. 
See also sqlite_next(), sqlite_current(), and sqlite_seek().   sqlite_queryUpsqlite_seek
sqlite_seek
(no version information, might be only in CVS)
sqlite_seek -- Seek to a particular row number of a buffered result set.
Description
bool sqlite_seek ( resource result, int rownum)
sqlite_seek() seeks to the row given by the parameter rownum. The row 
number is zero-based (0 is the first row). Returns FALSE if the row does 
not exist, TRUE otherwise. 
Note: This function cannot be used with unbuffered result handles. 
See also sqlite_next(), sqlite_current() and sqlite_rewind().   sqlite_rewindUpsqlite_udf_decode_binary
sqlite_udf_decode_binary
(no version information, might be only in CVS)
sqlite_udf_decode_binary -- Decode binary data passed as parameters to an 
UDF.
Description
string sqlite_udf_decode_binary ( string data)
sqlite_udf_decode_binary() decodes the binary encoding that was applied to 
the parameter by either sqlite_udf_encode_binary() or 
sqlite_escape_string(). 
You must call this function on parameters passed to your UDF if you need 
them to handle binary data, as the binary encoding employed by PHP will 
obscure the content and of the parameter in its natural, non-coded form. 
PHP does not perform this encode/decode operation automatically as it 
would severely impact performance if it did. 
Example 1. binary-safe max_length aggregation function example
  <?php
  $data = array(
     'one',
     'two',
     'three',
     'four',
     'five',
     'six',
     'seven',
     'eight',
     'nine',
     'ten',
     );
  $db = sqlite_open(':memory:');
  sqlite_query($db, "CREATE TABLE strings(a)");
  foreach ($data as $str) {
      $str = sqlite_escape_string($str);
      sqlite_query($db, "INSERT INTO strings VALUES ('$str')");
  }

  function max_len_step(&$context, $string) {
      $string = sqlite_udf_decode_binary($string);
      if (strlen($string) > $context) {
	  $context = strlen($string);
      }
  }

  function max_len_finalize(&$context) {
      return $context;
  }

  sqlite_create_aggregate($db, 'max_len', 'max_len_step', 
  'max_len_finalize');

  var_dump(sqlite_array_query($db, 'SELECT max_len(a) from 
  strings'));

  ?> 
See also sqlite_udf_encode_binary(), sqlite_create_function() and 
sqlite_create_aggregate().   sqlite_seekUpsqlite_udf_encode_binary
sqlite_udf_encode_binary
(no version information, might be only in CVS)
sqlite_udf_encode_binary -- Encode binary data before returning it from an 
UDF.
Description
string sqlite_udf_encode_binary ( string data)
sqlite_udf_encode_binary() applies a binary encoding to the data so that 
it can be safely returned from queries (since the underlying libsqlite API 
is not binary safe). 
If there is a chance that your data might be binary unsafe (e.g.: it 
contains a NUL byte in the middle rather than at the end, or if it has and 
0x01 byte as the first character) then you must call this function to 
encode the return value from your UDF. 
PHP does not perform this encode/decode operation automatically as it 
would severely impact performance if it did. 
Note: Do not use sqlite_escape_string() to quote strings returned from 
UDF's as it will lead to double-quoting of the data. Use 
sqlite_udf_encode_binary() instead! 
See also sqlite_udf_decode_binary(), sqlite_escape_string(), 
sqlite_create_function() and sqlite_create_aggregate().   sqlite_udf_decode_binaryUpsqlite_unbuffered_query
sqlite_unbuffered_query
(no version information, might be only in CVS)
sqlite_unbuffered_query -- Execute a query that does not prefetch and 
buffer all data
Description
resource sqlite_unbuffered_query ( resource dbhandle, string query)

resource sqlite_unbuffered_query ( string query, resource dbhandle)
sqlite_unbuffered_query() is identical to sqlite_query() except that the 
result that is returned is a sequential forward-only result set that can 
only be used to read each row, one after the other. 
This function is ideal for generating things such as HTML tables where you 
only need to process one row at a time and don't need to randomly access 
the row data. 
Note: Functions such as sqlite_seek(), sqlite_rewind(), sqlite_next(), 
sqlite_current(), and sqlite_num_rows() do not work on result handles 
returned from sqlite_unbuffered_query(). 
See also sqlite_query().   sqlite_udf_encode_binaryUpShockwave Flash functions
#

#T=string sql_regcase ( string string)
sql_regcase ( ^!string string);
#

#T=sqrt - float sqrt ( float arg)
(PHP 3, PHP 4 )
sqrt -- Square root
Description
float sqrt ( float arg)
Returns the square root of arg. 
<?php
// Precision depends on your precision directive
echo sqrt(9); // 3
echo sqrt(10); // 3.16227766 ...
?> 

See also pow().   sinhUpsrand
#

#T=float sqrt ( float arg)
sqrt ( ^!float arg);
#

#T=srand - void srand ( [int seed])
(PHP 3, PHP 4 )
srand -- Seed the random number generator
Description
void srand ( [int seed])
Seeds the random number generator with seed. Since PHP 4.2.0, the seed 
becomes optional and defaults to a random value if omitted. 
<?php
// seed with microseconds
function make_seed() {
list($usec, $sec) = explode(' ', microtime());
return (float) $sec + ((float) $usec * 100000);
}
srand(make_seed());
$randval = rand();
?> 

Note: As of PHP 4.2.0, there is no need to seed the random number 
generator with srand() or mt_srand() as this is now done automatically. 
See also rand(), getrandmax() and mt_srand().   sqrtUptan
#

#T=void srand ( [int seed])
srand ( ^![int seed]);
#

#T=sscanf - mixed sscanf ( string str, string format [, string var1])
(PHP 4 >= 4.0.1)
sscanf --  Parses input from a string according to a format 
Description
mixed sscanf ( string str, string format [, string var1])
The function sscanf() is the input analog of printf(). sscanf() reads from 
the string str and interprets it according to the specified format. If 
only two parameters were passed to this function, the values parsed will 
be returned as an array. 
Any whitespace in the format string matches any whitespace in the input 
string. This means that even a tab \t in the format string can match a 
single space character in the input string. 
Example 1. sscanf() Example
  <?php
  // getting the serial number
  $serial = sscanf("SN/2350001", "SN/%d");
  // and the date of manufacturing
  $mandate = "January 01 2000";
  list($month, $day, $year) = sscanf($mandate, "%s %d %d");
  echo "Item $serial was manufactured on: $year-" . 
  substr($month, 0, 3) . "-$day\n";
  ?> 

If optional parameters are passed, the function will return the number of 
assigned values. The optional parameters must be passed by reference. 
Example 2. sscanf() - using optional parameters
  <?php
  // get author info and generate DocBook entry
  $auth = "24\tLewis Carroll";
  $n = sscanf($auth, "%d\t%s %s", &$id, &$first, &$last);
  echo "<author id='$id'>
      <firstname>$first</firstname>
      <surname>$last</surname>
  </author>\n";
  ?> 
See also fscanf(), printf(), and sprintf().   sprintfUpstr_ireplace
#

#T=mixed sscanf ( string str, string format [, string var1])
sscanf ( ^!string str, string format [, string var1]);
#

#T=stat - array stat ( string filename)
(PHP 3, PHP 4 )
stat -- Gives information about a file
Description
array stat ( string filename)
Gathers the statistics of the file named by filename. If filename is a 
symbolic link, statistics are from the file itself, not the symlink. 
lstat() is identical to stat() except it would instead be based off the 
symlinks status. 
In case of error, stat() returns FALSE. It also will throw a warning. 
Returns an array with the statistics of the file with the following 
elements. This array is zero-based. In addition to returning these 
attributes in a numeric array, they can be accessed with associative 
indices, as noted next to each parameter; this is available since PHP 
4.0.6: 
Table 1. stat() and fstat() result format
NumericAssociative (since PHP 4.0.6)Description
0devdevice number
1inoinode number
2modeinode protection mode
3nlinknumber of links
4uiduserid of owner
5gidgroupid of owner
6rdevdevice type, if inode device *
7sizesize in bytes
8atimetime of last access (Unix timestamp)
9mtimetime of last modification (Unix timestamp)
10ctimetime of last change (Unix timestamp)
11blksizeblocksize of filesystem IO *
12blocksnumber of blocks allocated

* - only valid on systems supporting the st_blksize type--other systems 
(i.e. Windows) return -1. 
Note: The results of this function are cached. See clearstatcache() for 
more details.
Tip: As of PHP 5.0.0 this function can also be used with some url 
wrappers. Refer to Appendix I for a listing of which wrappers support 
stat() family of functionality.
See also lstat(), fstat(), filemtime(), and filegroup().   set_file_bufferUpsymlink
#

#T=array stat ( string filename)
stat ( ^!string filename);
#

#T=str_ireplace - mixed str_ireplace ( mixed search, mixed replace, mixed subject [, int 
(PHP 5 CVS only)
str_ireplace --  Case-insensitive version of str_replace(). 
Description
mixed str_ireplace ( mixed search, mixed replace, mixed subject [, int 
&count])
This function returns a string or an array with all occurrences of search 
in subject (ignoring case) replaced with the given replace value. If you 
don't need fancy replacing rules, you should generally use this function 
instead of eregi_replace() or preg_replace() with the i modifier. 
If subject is an array, then the search and replace is performed with 
every entry of subject, and the return value is an array as well. 
If search and replace are arrays, then str_ireplace() takes a value from 
each array and uses them to do search and replace on subject. If replace 
has fewer values than search, then an empty string is used for the rest of 
replacement values. If search is an array and replace is a string; then 
this replacement string is used for every value of search. 
Example 1. str_ireplace() example
  <?php
  $bodytag = str_ireplace("%body%", "black", "<body 
  text=%BODY%>");
  ?> 
This function is binary safe. 
Note: As of PHP 5.0.0 the number of matched and replaced needles will be 
returned in count which is passed by reference. Prior to PHP 5.0.0 this 
parameter is not available. 
See also: str_replace(), ereg_replace(), preg_replace(), and strtr().   sscanfUpstr_pad
#

#T=mixed str_ireplace ( mixed search, mixed replace, mixed subject [, int 
str_ireplace ( ^!mixed search, mixed replace, mixed subject [, int ;
#

#T=str_pad - string str_pad ( string input, int pad_length [, string pad_string [, int 
(PHP 4 >= 4.0.1)
str_pad --  Pad a string to a certain length with another string 
Description
string str_pad ( string input, int pad_length [, string pad_string [, int 
pad_type]])
This functions returns the input string padded on the left, the right, or 
both sides to the specified padding length. If the optional argument 
pad_string is not supplied, the input is padded with spaces, otherwise it 
is padded with characters from pad_string up to the limit. 
Optional argument pad_type can be STR_PAD_RIGHT, STR_PAD_LEFT, or 
STR_PAD_BOTH. If pad_type is not specified it is assumed to be 
STR_PAD_RIGHT. 
If the value of pad_length is negative or less than the length of the 
input string, no padding takes place. 
Example 1. str_pad() example
  <?php
  $input = "Alien";
  echo str_pad($input, 10);                      // produces 
  "Alien     "
  echo str_pad($input, 10, "-=", STR_PAD_LEFT);  // produces 
  "-=-=-Alien"
  echo str_pad($input, 10, "_", STR_PAD_BOTH);   // produces 
  "__Alien___"
  echo str_pad($input, 6 , "___");               // produces 
  "Alien_"
  ?> 
Note: The pad_string may be truncated if the required number of padding 
characters can't be evenly divided by the pad_string's length.   str_ireplaceUpstr_repeat
#

#T=string str_pad ( string input, int pad_length [, string pad_string [, int 
str_pad ( ^!string input, int pad_length [, string pad_string [, int ;
#

#T=str_repeat - string str_repeat ( string input, int multiplier)
(PHP 4 )
str_repeat -- Repeat a string
Description
string str_repeat ( string input, int multiplier)
Returns input_str repeated multiplier times. multiplier has to be greater 
than or equal to 0. If the multiplier is set to 0, the function will 
return an empty string. 
Example 1. str_repeat() example
  <?php
  echo str_repeat("-=", 10);
  ?> 
This will output "-=-=-=-=-=-=-=-=-=-=". 
See also for, str_pad(), and substr_count().   str_padUpstr_replace
#

#T=string str_repeat ( string input, int multiplier)
str_repeat ( ^!string input, int multiplier);
#

#T=str_replace - mixed str_replace ( mixed search, mixed replace, mixed subject [, int 
(PHP 3>= 3.0.6, PHP 4 )
str_replace --  Replace all occurrences of the search string with the 
replacement string 
Description
mixed str_replace ( mixed search, mixed replace, mixed subject [, int 
&count])
This function returns a string or an array with all occurrences of search 
in subject replaced with the given replace value. If you don't need fancy 
replacing rules, you should always use this function instead of 
ereg_replace() or preg_replace(). 
As of PHP 4.0.5, every parameter in str_replace() can be an array. 
Warning
In PHP versions prior to 4.3.3 a bug existed when using arrays as 
both search and replace parameters which caused empty search indexes 
to be skipped without advancing the internal pointer on the replace 
array. This has been corrected in PHP 4.3.3, any scripts which 
relied on this bug should remove empty search values prior to 
calling this function in order to mimick the original behavior. 

If subject is an array, then the search and replace is performed with 
every entry of subject, and the return value is an array as well. 
If search and replace are arrays, then str_replace() takes a value from 
each array and uses them to do search and replace on subject. If replace 
has fewer values than search, then an empty string is used for the rest of 
replacement values. If search is an array and replace is a string; then 
this replacement string is used for every value of search. 
Example 1. str_replace() examples
  <?php
  // Provides: <body text='black'>
  $bodytag = str_replace("%body%", "black", "<body 
  text='%body%'>");

  // Provides: Hll Wrld f PHP
  $vowels = array("a", "e", "i", "o", "u", "A", "E", "I", "O", 
  "U");
  $onlyconsonants = str_replace($vowels, "", "Hello World of 
  PHP");

  // Provides: You should eat pizza, beer, and ice cream every 
  day
  $phrase  = "You should eat fruits, vegetables, and fiber every 
  day.";
  $healthy = array("fruits", "vegetables", "fiber");
  $yummy   = array("pizza", "beer", "ice cream");

  $newphrase = str_replace($healthy, $yummy, $phrase);

  // Use of the count parameter is available as of PHP 5.0.0
  $str = str_replace("ll", "", "good golly miss molly!", 
$count);
  echo $count; // 2
  ?> 
Note: This function is binary-safe.
Note: As of PHP 5.0.0 the number of matched and replaced needles 
(search) will be returned in count which is passed by reference. Prior 
to PHP 5.0.0 this parameter is not available. 
See also str_ireplace(), substr_replace(), ereg_replace(), preg_replace(), 
and strtr().   str_repeatUpstr_rot13
#

#T=mixed str_replace ( mixed search, mixed replace, mixed subject [, int 
str_replace ( ^!mixed search, mixed replace, mixed subject [, int ;
#

#T=str_rot13 - string str_rot13 ( string str)
(PHP 4 >= 4.2.0)
str_rot13 -- Perform the rot13 transform on a string
Description
string str_rot13 ( string str)
This function performs the ROT13 encoding on the str argument and returns 
the resulting string. The ROT13 encoding simply shifts every letter by 13 
places in the alphabet while leaving non-alpha characters untouched. 
Encoding and decoding are done by the same function, passing an encoded 
string as argument will return the original version. 
Example 1. rot13() example
  <?php

  echo str_rot13('PHP 4.3.0'); // CUC 4.3.0

  ?> 
Note: The behaviour of this function was buggy until PHP 4.3.0. Before 
this, the str was also modified, as if passed by reference.   str_replaceUpstr_shuffle
#

#T=string str_rot13 ( string str)
str_rot13 ( ^!string str);
#

#T=str_shuffle - string str_shuffle ( string str)
(PHP 4 >= 4.3.0)
str_shuffle -- Randomly shuffles a string
Description
string str_shuffle ( string str)
str_shuffle() shuffles a string. One permutation of all possible is 
created. 
Example 1. str_shuffle() example
  <?php
  $str = 'abcdef';
  $shuffled = str_shuffle($str);

  // This will echo something like: bfdaec
  echo $shuffled;
  ?> 
See also shuffle() and rand().   str_rot13Upstr_split
#

#T=string str_shuffle ( string str)
str_shuffle ( ^!string str);
#

#T=str_split - array str_split ( string string [, int split_length])
(PHP 5 CVS only)
str_split --  Convert a string to an array 
Description
array str_split ( string string [, int split_length])
Converts a string to an array. If the optional split_length parameter is 
specified, the returned array will be broken down into chunks with each 
being split_length in length, otherwise each chunk will be one character 
in length. 
FALSE is returned if split_length is less than 1. If the split_length 
length exceeds the length of string, the entire string is returned as the 
first (and only) array element. 
Example 1. Example uses of str_split()
  <?php

  $str = "Hello Friend";

  $arr1 = str_split($str);
  $arr2 = str_split($str, 3);

  print_r($arr1);
  print_r($arr2);

  ?> 

Output may look like: 
Array
(
[0] => H
[1] => e
[2] => l
[3] => l
[4] => o
[5] =>
[6] => F
[7] => r
[8] => i
[9] => e
[10] => n
[11] => d
)

Array
(
[0] => Hel
[1] => lo 
[2] => Fri
[3] => end
)
Example 2. Examples related to str_split()
  <?php

  $str = "Hello Friend";

  echo $str{0};  // H
  echo $str{8};  // i

  // Creates: array('H','e','l','l','o',' 
  ','F','r','i','e','n','d')
  $arr1 = preg_split('//', $str, -1, PREG_SPLIT_NO_EMPTY);

  ?> 
See also preg_split(), split(), count_chars(), str_word_count(), and for.   str_shuffleUpstr_word_count
#

#T=array str_split ( string string [, int split_length])
str_split ( ^!string string [, int split_length]);
#

#T=str_word_count - mixed str_word_count ( string string [, int format])
(PHP 4 >= 4.3.0)
str_word_count --  Return information about words used in a string 
Description
mixed str_word_count ( string string [, int format])
Counts the number of words inside string. If the optional format is not 
specified, then the return value will be an integer representing the 
number of words found. In the event the format is specified, the return 
value will be an array, content of which is dependent on the format. The 
possible value for the format and the resultant outputs are listed below. 
1 - returns an array containing all the words found inside the string. 
2 - returns an associative array, where the key is the numeric position 
of the word inside the string and the value is the actual word itself. 
For the purpose of this function, 'word' is defined as a locale dependent 
string containing alphabetic characters, which also may contain, but not 
start with "'" and "-" characters. 
Example 1. Example uses for str_word_count()
  <?php

  $str = "Hello friend, you're
	  looking          good today!";

  $a   = str_word_count($str, 1);
  $b   = str_word_count($str, 2);
  $c   = str_word_count($str);

  print_r($a);
  print_r($b);
  echo $c;
  ?> 

Output may look like: 
Array
(
[0] => Hello
[1] => friend
[2] => you're
[3] => looking
[4] => good
[5] => today
)

Array
(
[0] => Hello
[6] => friend
[14] => you're
[29] => looking
[46] => good
[51] => today
)

6
See also explode(), preg_split(), split(), count_chars(), and 
substr_count().   str_splitUpstrcasecmp
#

#T=mixed str_word_count ( string string [, int format])
str_word_count ( ^!string string [, int format]);
#

#T=strcasecmp - int strcasecmp ( string str1, string str2)
(PHP 3>= 3.0.2, PHP 4 )
strcasecmp --  Binary safe case-insensitive string comparison 
Description
int strcasecmp ( string str1, string str2)
Returns < 0 if str1 is less than str2; > 0 if str1 is greater than str2, 
and 0 if they are equal. Example 1. strcasecmp() example
  <?php
  $var1 = "Hello";
  $var2 = "hello";
  if (strcasecmp($var1, $var2) == 0) {
      echo '$var1 is equal to $var2 in a case-insensitive string 
  comparison';
  }
  ?> 
See also ereg(), strcmp(), substr(), stristr(), strncasecmp(), and 
strstr().   str_word_countUpstrchr
strchr
strchr -- Alias for strstr()
Description
This function is an alias of strstr().   strcasecmpUpstrcmp
#

#T=int strcasecmp ( string str1, string str2)
strcasecmp ( ^!string str1, string str2);
#

#T=strcmp - int strcmp ( string str1, string str2)
(PHP 3, PHP 4 )
strcmp -- Binary safe string comparison
Description
int strcmp ( string str1, string str2)
Returns < 0 if str1 is less than str2; > 0 if str1 is greater than str2, 
and 0 if they are equal. 
Note that this comparison is case sensitive. 
See also ereg(), strcasecmp(), substr(), stristr(), strncasecmp(), 
strncmp(), and strstr().   strchrUpstrcoll
#

#T=int strcmp ( string str1, string str2)
strcmp ( ^!string str1, string str2);
#

#T=strcoll - int strcoll ( string str1, string str2)
(PHP 4 >= 4.0.5)
strcoll -- Locale based string comparison
Description
int strcoll ( string str1, string str2)
Returns < 0 if str1 is less than str2; > 0 if str1 is greater than str2, 
and 0 if they are equal. strcoll() uses the current locale for doing the 
comparisons. If the current locale is C or POSIX, this function is 
equivalent to strcmp(). 
Note that this comparison is case sensitive, and unlike strcmp() this 
function is not binary safe. 
Note: strcoll() was added in PHP 4.0.5, but was not enabled for win32 
until 4.2.3. 
See also ereg(), strcmp(), strcasecmp(), substr(), stristr(), 
strncasecmp(), strncmp(), strstr(), and setlocale().   strcmpUpstrcspn
#

#T=int strcoll ( string str1, string str2)
strcoll ( ^!string str1, string str2);
#

#T=strcspn - int strcspn ( string str1, string str2)
(PHP 3>= 3.0.3, PHP 4 )
strcspn --  Find length of initial segment not matching mask 
Description
int strcspn ( string str1, string str2)
Returns the length of the initial segment of str1 which does not contain 
any of the characters in str2. 
See also strspn().   strcollUpstrip_tags
#

#T=int strcspn ( string str1, string str2)
strcspn ( ^!string str1, string str2);
#

#T=stream_context_create - resource stream_context_create ( array options)
(PHP 4 >= 4.3.0)
stream_context_create -- Create a streams context
Description
resource stream_context_create ( array options)
Creates and returns a stream context with any options supplied in options 
preset. 
options must be an associative array of associative arrays in the format 
$arr['wrapper']['option'] = $value. 
Example 1. Using stream_context_create()
  <?php
  $opts = array(
    'http'=>array(
      'method'=>"GET",
      'header'=>"Accept-language: en\r\n" . 
		"Cookie: foo=bar\r\n"
    )
  );

  $context = stream_context_create($opts);

  /* Sends an http request to www.example.com
     with additional headers shown above */
  $fp = fopen('http://www.example.com', 'r', false, $context);
  fpassthru($fp);
  fclose($fp);
  ?> 
See Also: stream_context_set_option(), and Listing of supported wrappers 
with context options (Appendix I)   Stream functionsUpstream_context_get_options
#

#T=resource stream_context_create ( array options)
stream_context_create ( ^!array options);
#

#T=stream_context_get_options - array stream_context_get_options ( resource stream|context)
(PHP 4 >= 4.3.0)
stream_context_get_options -- Retrieve options for a 
stream/wrapper/context
Description
array stream_context_get_options ( resource stream|context)
Returns an array of options on the specified stream or context.   stream_context_createUpstream_context_set_option
#

#T=array stream_context_get_options ( resource stream|context)
stream_context_get_options ( ^!resource stream|context);
#

#T=stream_context_set_option - bool stream_context_set_option ( resource context|stream, string wrapper, 
(PHP 4 >= 4.3.0)
stream_context_set_option -- Sets an option for a stream/wrapper/context
Description
bool stream_context_set_option ( resource context|stream, string wrapper, 
string option, mixed value)
Sets an option on the specified context. value is set to option for 
wrapper   stream_context_get_optionsUpstream_context_set_params
#

#T=bool stream_context_set_option ( resource context|stream, string wrapper, 
stream_context_set_option ( ^!resource context|stream, string wrapper, ;
#

#T=stream_context_set_params - bool stream_context_set_params ( resource stream|context, array params)
(PHP 4 >= 4.3.0)
stream_context_set_params -- Set parameters for a stream/wrapper/context
Description
bool stream_context_set_params ( resource stream|context, array params)
params should be an associative array of the structure: 
$params['paramname'] = "paramvalue";. 
Table 1. Parameters
ParametersPurpose
notificationName of user-defined callback function to be called 
whenever a stream triggers a notification. 
  stream_context_set_optionUpstream_copy_to_stream
#

#T=bool stream_context_set_params ( resource stream|context, array params)
stream_context_set_params ( ^!resource stream|context, array params);
#

#T=stream_copy_to_stream - int stream_copy_to_stream ( resource source, resource dest [, int 
(PHP 5 CVS only)
stream_copy_to_stream -- Copies data from one stream to another
Description
int stream_copy_to_stream ( resource source, resource dest [, int 
maxlength])
Makes a copy of up to maxlength bytes of data from the current position in 
source to dest. If maxlength is not specified, all remaining content in 
source will be copied. Returns the total count of bytes copied. 
Example 1. stream_copy_to_stream() example
  <?php
  $src = fopen('http://www.example.com', 'r');
  $dest1 = fopen('first1k.txt', 'w');
  $dest2 = fopen('remainder.txt', 'w');

  echo stream_copy_to_stream($src, $dest1, 1024) . " bytes 
  copied to first1k.txt\n";
  echo stream_copy_to_stream($src, $dest2) . " bytes copied to 
  remainder.txt\n";

  ?> 
See also copy().   stream_context_set_paramsUpstream_filter_append
#

#T=int stream_copy_to_stream ( resource source, resource dest [, int 
stream_copy_to_stream ( ^!resource source, resource dest [, int ;
#

#T=stream_filter_append - bool stream_filter_append ( resource stream, string filtername [, int 
(PHP 4 >= 4.3.0)
stream_filter_append -- Attach a filter to a stream.
Description
bool stream_filter_append ( resource stream, string filtername [, int 
read_write [, mixed params]])
Adds filtername to the list of filters attached to stream. This filter 
will be added with the specified params to the end of the list and will 
therefore be called last during stream operations. To add a filter to the 
beginning of the list, use stream_filter_prepend(). 
By default, stream_filter_append() will attach the filter to the read 
filter chain if the file was opened for reading (i.e. File Mode: r, and/or 
+). The filter will also be attached to the write filter chain if the file 
was opened for writing (i.e. File Mode: w, a, and/or +). 
STREAM_FILTER_READ, STREAM_FILTER_WRITE, and/or STREAM_FILTER_ALL can also 
be passed to the read_write parameter to override this behavior. 
Example 1. Controlling where filters are applied
  <?php
  /* Open a test file for reading and writing */
  $fp = fopen("test.txt", "rw");

  /* Apply the ROT13 filter to the
  * write filter chain, but not the
  * read filter chain */
  stream_filter_append($fp, "string.rot13", 
STREAM_FILTER_WRITE);

  /* Write a simple string to the file
  * it will be ROT13 transformed on the
  * way out */
  fwrite($fp, "This is a test\n");

  /* Back up to the beginning of the file */
  rewind($fp);

  /* Read the contents of the file back out.
  * Had the filter been applied to the
  * read filter chain as well, we would see
  * the text ROT13ed back to its original state */
  fpassthru($fp);

  fclose($fp);

  /* Expected Output
     ---------------

  Guvf vf n grfg

  */
  ?> 
When using custom (user) filters: stream_filter_register() must be 
called first in order to register the desired user filter to filtername. 

See also stream_filter_register(), and stream_filter_prepend()   stream_copy_to_streamUpstream_filter_prepend
#

#T=bool stream_filter_append ( resource stream, string filtername [, int 
stream_filter_append ( ^!resource stream, string filtername [, int ;
#

#T=stream_filter_prepend - bool stream_filter_prepend ( resource stream, string filtername [, int 
(PHP 4 >= 4.3.0)
stream_filter_prepend -- Attach a filter to a stream.
Description
bool stream_filter_prepend ( resource stream, string filtername [, int 
read_write [, mixed params]])
Adds filtername to the list of filters attached to stream. This filter 
will be added with the specified params to the beginning of the list and 
will therefore be called first during stream operations. To add a filter 
to the end of the list, use stream_filter_append(). 
By default, stream_filter_prepend() will attach the filter to the read 
filter chain if the file was opened for reading (i.e. File Mode: r, and/or 
+). The filter will also be attached to the write filter chain if the file 
was opened for writing (i.e. File Mode: w, a, and/or +). 
STREAM_FILTER_READ, STREAM_FILTER_WRITE, and/or STREAM_FILTER_ALL can also 
be passed to the read_write parameter to override this behavior. See 
stream_filter_append() for an example of using this parameter. 
When using custom (user) filters: stream_filter_register() must be 
called first in order to register the desired user filter to filtername. 

See also stream_filter_register(), and stream_filter_append()   stream_filter_appendUpstream_filter_register
#

#T=bool stream_filter_prepend ( resource stream, string filtername [, int 
stream_filter_prepend ( ^!resource stream, string filtername [, int ;
#

#T=stream_filter_register - bool stream_filter_register ( string filtername, string classname)
(PHP 5 CVS only)
stream_filter_register --  Register a stream filter implemented as a PHP 
class derived from php_user_filter 
Description
bool stream_filter_register ( string filtername, string classname)
stream_filter_register() allows you to implement your own filter on any 
registered stream used with all the other filesystem functions (such as 
fopen(), fread() etc.). 
To implement a filter, you need to define a class as an extension of 
php_user_filter with a number of member functions as defined below. When 
performing read/write operations on the stream to which your filter is 
attached, PHP will pass the data through your filter (and any other 
filters attached to that stream) so that the data may be modified as 
desired. You must implement the methods exactly as described below - doing 
otherwise will lead to undefined behaviour. 
stream_filter_register() will return FALSE if the filtername is already 
defined. 
int filter ( resource in, resource out, int &consumed, bool closing)
This method is called whenever data is read from or written to the 
attached stream (such as with fread() or fwrite()). in is a resource 
pointing to a bucket brigade which contains one or more bucket objects 
containing data to be filtered. out is a resource pointing to a second 
bucket brigade into which your modified buckets should be placed. 
consumed, which must always be declared by reference, should be 
incremented by the length of the data which your filter reads in and 
alters. In most cases this means you will increment consumed by 
$bucket->datalen for each $bucket. If the stream is in the process of 
closing (and therefore this is the last pass through the filterchain), the 
closing parameter will be set to TRUE The filter method must return one of 
three values upon completion. 
Return ValueMeaning
PSFS_PASS_ONFilter processed successfully with data available in the 
out bucket brigade. 
PSFS_FEED_MEFilter processed successfully, however no data was 
available to return. More data is required from the stream or prior 
filter. 
PSFS_ERR_FATAL (default)The filter experienced an unrecoverable 
error and cannot continue. 

void oncreate ( void )
This method is called during instantiation of the filter class object. If 
your filter allocates or initializes any other resources (such as a 
buffer), this is the place to do it. Your implementation of this method 
should return FALSE on failure, or TRUE on success. 
When your filter is first instantiated, and yourfilter->oncreate() is 
called, a number of properties will be available as shown in the table 
below. 
PropertyContents
FilterClass->filternameA string containing the name the filter was 
instantiated with. Filters may be registered under multiple names or 
under wildcards. Use this property to determine which name was used.
FilterClass->paramsThe contents of the params parameter passed to 
stream_filter_append() or stream_filter_prepend().

void onclose ( void )
This method is called upon filter shutdown (typically, this is also during 
stream shutdown), and is executed after the flush method is called. If any 
resources were allocated or initialzed during oncreate this would be the 
time to destroy or dispose of them. 
The example below implements a filter named strtoupper on the foo-bar.txt 
stream which will capitalize all letter characters written to/read from 
that stream. Example 1. Filter for capitalizing characters on 
foo-bar.txt stream
  <?php

  /* Define our filter class */
  class strtoupper_filter extends php_user_filter {
    function filter($in, $out, &$consumed, $closing) {
      while ($bucket = stream_bucket_make_writeable($in)) {
	$bucket->data = strtoupper($bucket->data);
	$consumed += $bucket->datalen;
	stream_bucket_append($out, $bucket);
      }
      return PSFS_PASS_ON;
    }
  } 

  /* Register our filter with PHP */
  stream_filter_register("strtoupper", "strtoupper_filter")
      or die("Failed to register filter");

  $fp = fopen("foo-bar.txt", "w");

  /* Attach the registered filter to the stream just opened */
  stream_filter_append($fp, "strtoupper");

  fwrite($fp, "Line1\n");
  fwrite($fp, "Word - 2\n");
  fwrite($fp, "Easy As 123\n");

  fclose($fp);

  /* Read the contents back out
  */
  readfile("foo-bar.txt");

  ?> 

Output 
LINE1
WORD - 2
EASY AS 123
Example 2. Registering a generic filter class to match multiple 
filter names.
  <?php

  /* Define our filter class */
  class string_filter extends php_user_filter {
    var $mode;

    function filter($in, $out, &$consumed, $closing) {
      while ($bucket = stream_bucket_make_writeable($in)) {
	if ($this->mode == 1) {
	  $bucket->data = strtoupper($bucket->data);
	} elseif ($this->mode == 0) {
	  $bucket->data = strtoupper($bucket->data);
	}

	$consumed += $bucket->datalen;
	stream_bucket_append($out, $bucket);
      }
      return PSFS_PASS_ON;
    }

    function oncreate() {
      if ($this->filtername == 'str.toupper') {
	$this->mode = 1;
      } elseif ($this->filtername == 'str.tolower') {
	$this->mode = 0;
      } else {
	/* Some other str.* filter was asked for,
	   report failure so that PHP will keep looking */
	return false;
      }

      return true;
    }
  } 

  /* Register our filter with PHP */
  stream_filter_register("str.*", "string_filter")
      or die("Failed to register filter");

  $fp = fopen("foo-bar.txt", "w");

  /* Attach the registered filter to the stream just opened 
     We could alternately bind to str.tolower here */
  stream_filter_append($fp, "str.toupper");

  fwrite($fp, "Line1\n");
  fwrite($fp, "Word - 2\n");
  fwrite($fp, "Easy As 123\n");

  fclose($fp);

  /* Read the contents back out
  */
  readfile("foo-bar.txt");

  /* Output
  * ------

  LINE1
  WORD - 2
  EASY AS 123

  */

  ?> 
See Also: stream_wrapper_register(), stream_filter_prepend(), and 
stream_filter_append()   stream_filter_prependUpstream_get_contents
stream_get_contents
(no version information, might be only in CVS)
stream_get_contents -- Reads remainder of a stream into a string
Description
string stream_get_contents ( resource handle [, int maxlength])
Identical to file_get_contents(), except that stream_get_contents() 
operates on an already open file resource and returns the remaining 
contents, up to maxlength bytes, in a string. 
Note: This function is binary-safe.
See also: fgets(), fread(), and fpassthru().   stream_filter_registerUpstream_get_filters
#

#T=bool stream_filter_register ( string filtername, string classname)
stream_filter_register ( ^!string filtername, string classname);
#

#T=stream_get_filters - array stream_get_filters ( void )
(PHP 5 CVS only)
stream_get_filters -- Retrieve list of registered filters
Description
array stream_get_filters ( void )
Returns an indexed array containing the name of all stream filters 
available on the running system. 
Example 1. Using stream_get_filters()
  <?php
  $streamlist = stream_get_filters();
  print_r($streamlist);
  ?> 

Output will be similar to the following Note: there may be more or 
fewer filters in your version of PHP. 
Array (
[0] => string.rot13
[1] => string.toupper
[2] => string.tolower
[3] => string.base64
[4] => string.quoted-printable
)
See also stream_filter_register(), and stream_get_wrappers()   stream_get_contentsUpstream_get_line
#

#T=array stream_get_filters ( void )
stream_get_filters ( ^!void );
#

#T=stream_get_line - string stream_get_line ( resource handle, int length, string ending)
(PHP 5 CVS only)
stream_get_line -- Gets line from stream resource up to a given delimiter
Description
string stream_get_line ( resource handle, int length, string ending)
Returns a string of up to length bytes read from the file pointed to by 
handle. Reading ends when length bytes have been read, when the string 
specified by ending is found (which is notincluded in the return value), 
or on EOF (whichever comes first). 
If an error occurs, returns FALSE. 
This function is nearly identical to fgets() except in that it allows end 
of line delimiters other than the standard \n, \r, and \r\n, and does not 
return the delimiter itself. 
See also fread(), fgets(), and fgetc(),   stream_get_filtersUpstream_get_meta_data
#

#T=string stream_get_line ( resource handle, int length, string ending)
stream_get_line ( ^!resource handle, int length, string ending);
#

#T=stream_get_meta_data - array stream_get_meta_data ( resource stream)
(PHP 4 >= 4.3.0)
stream_get_meta_data -- Retrieves header/meta data from streams/file 
pointers
Description
array stream_get_meta_data ( resource stream)
Returns information about an existing stream. The stream can be any stream 
created by fopen(), fsockopen() and pfsockopen(). The result array 
contains the following items: 
timed_out (bool) - TRUE if the stream timed out while waiting for data 
on the last call to fread() or fgets(). 
blocked (bool) - TRUE if the stream is in blocking IO mode. See 
stream_set_blocking(). 
eof (bool) - TRUE if the stream has reached end-of-file. Note that for 
socket streams this member can be TRUE even when unread_bytes is 
non-zero. To determine if there is more data to be read, use feof() 
instead of reading this item. 
unread_bytes (int) - the number of bytes currently contained in the read 
buffer. 
The following items were added in PHP 4.3: 
stream_type (string) - a label describing the underlying implementation 
of the stream. 
wrapper_type (string) - a label describing the protocol wrapper 
implementation layered over the stream. See Appendix I for more 
information about wrappers. 
wrapper_data (mixed) - wrapper specific data attached to this stream. 
See Appendix I for more information about wrappers and their wrapper 
data. 
filters (array) - and array containing the names of any filters that 
have been stacked onto this stream. Filters are currently undocumented. 
Note: This function was introduced in PHP 4.3, but prior to this 
version, socket_get_status() could be used to retrieve the first four 
items, for socket based streams only. 
In PHP 4.3 and later, socket_get_status() is an alias for this function. 

Note: This function does NOT work on sockets created by the Socket 
extension.   stream_get_lineUpstream_get_transports
#

#T=array stream_get_meta_data ( resource stream)
stream_get_meta_data ( ^!resource stream);
#

#T=stream_get_transports - array stream_get_transports ( void )
(PHP 5 CVS only)
stream_get_transports -- Retrieve list of registered socket transports
Description
array stream_get_transports ( void )
Returns an indexed array containing the name of all socket transports 
available on the running system. 
Example 1. Using stream_get_transports()
  <?php
  $xportlist = stream_get_transports();
  print_r($xportlist);
  ?> 

Output will be similar to the following Note: there may be more or 
fewer transports in your version of PHP 
Array (
[0] => tcp
[1] => udp
[2] => unix
[3] => udg
)
See also stream_get_filters(), and stream_get_wrappers()   stream_get_meta_dataUpstream_get_wrappers
#

#T=array stream_get_transports ( void )
stream_get_transports ( ^!void );
#

#T=stream_get_wrappers - array stream_get_wrappers ( void )
(PHP 5 CVS only)
stream_get_wrappers -- Retrieve list of registered streams
Description
array stream_get_wrappers ( void )
Returns an indexed array containing the name of all stream wrappers 
available on the running system. 
See also stream_wrapper_register()   stream_get_transportsUpstream_register_wrapper
#

#T=array stream_get_wrappers ( void )
stream_get_wrappers ( ^!void );
#

#T=stream_select - int stream_select ( resource &read, resource &write, resource &except, int 
(PHP 4 >= 4.3.0)
stream_select -- Runs the equivalent of the select() system call on the 
given arrays of streams with a timeout specified by tv_sec and tv_usec 
Description
int stream_select ( resource &read, resource &write, resource &except, int 
tv_sec [, int tv_usec])
The stream_select() function accepts arrays of streams and waits for them 
to change status. Its operation is equivalent to that of the 
socket_select() function except in that it acts on streams. 
The streams listed in the read array will be watched to see if characters 
become available for reading (more precisely, to see if a read will not 
block - in particular, a stream resource is also ready on end-of-file, in 
which case an fread() will return a zero length string). 
The streams listed in the write array will be watched to see if a write 
will not block. 
The streams listed in the except array will be watched for high priority 
exceptional ("out-of-band") data arriving. 
Note: When stream_select() returns, the arrays read, write and except 
are modified to indicate which stream resource(s) actually changed 
status. 
The tv_sec and tv_usec together form the timeout parameter, tv_sec 
specifies the number of seconds while tv_usec the number of microseconds. 
The timeout is an upper bound on the amount of time that stream_select() 
will wait before it returns. If tv_sec and tv_usec are both set to 0, 
stream_select() will not wait for data - instead it will return 
immediately, indicating the current status of the streams. If tv_sec is 
NULL stream_select() can block indefinitely, returning only when an event 
on one of the watched streams occurs (or if a signal interrupts the system 
call). 
On success stream_select() returns the number of stream resources 
contained in the modified arrays, which may be zero if the timeout expires 
before anything interesting happens. On error FALSE is returned and a 
warning raised (this can happen if the system call is interrupted by an 
incoming signal). 
Warning
Using a timeout value of 0 allows you to instantaneously poll the 
status of the streams, however, it is NOT a good idea to use a 0 
timeout value in a loop as it will cause your script to consume too 
much CPU time. 
It is much better to specify a timeout value of a few seconds, 
although if you need to be checking and running other code 
concurrently, using a timeout value of at least 200000 microseconds 
will help reduce the CPU usage of your script. 
Remember that the timeout value is the maximum time that will 
elapse; stream_select() will return as soon as the requested streams 
are ready for use. 

You do not need to pass every array to stream_select(). You can leave it 
out and use an empty array or NULL instead. Also do not forget that those 
arrays are passed by reference and will be modified after stream_select() 
returns. 
This example checks to see if data has arrived for reading on either 
$stream1 or $stream2. Since the timeout value is 0 it will return 
immediately: <?php
/* Prepare the read array */
$read = array($stream1, $stream2);

if (false === ($num_changed_streams = stream_select($read, $write = 
NULL, $except = NULL, 0))) {
/* Error handling */
} elseif ($num_changed_streams > 0) {
/* At least on one of the streams something interesting happened 
*/
}
?> 

Note: Due to a limitation in the current Zend Engine it is not possible 
to pass a constant modifier like NULL directly as a parameter to a 
function which expects this parameter to be passed by reference. Instead 
use a temporary variable or an expression with the leftmost member being 
a temporary variable: <?php
stream_select($r, $w, $e = NULL, 0);
?> 

Note: Be sure to use the === operator when checking for an error. Since 
the stream_select() may return 0 the comparison with == would evaluate 
to TRUE: <?php
if (false === stream_select($r, $w, $e = NULL, 0)) {
  echo "stream_select() failed\n";
}
?> 

Note: If you read/write to a stream returned in the arrays be aware that 
they do not necessarily read/write the full amount of data you have 
requested. Be prepared to even only be able to read/write a single byte. 

Windows 98 Note: stream_select() used on a pipe returned from 
proc_open() may cause data loss under Windows 98. 
See also stream_set_blocking()   stream_register_wrapperUpstream_set_blocking
#

#T=int stream_select ( resource &read, resource &write, resource &except, int 
stream_select ( ^!resource &read, resource &write, resource &except, int ;
#

#T=stream_set_blocking - bool stream_set_blocking ( resource stream, int mode)
(PHP 4 >= 4.3.0)
stream_set_blocking -- Set blocking/non-blocking mode on a stream
Description
bool stream_set_blocking ( resource stream, int mode)
If mode is FALSE, the given stream will be switched to non-blocking mode, 
and if TRUE, it will be switched to blocking mode. This affects calls like 
fgets() and fread() that read from the stream. In non-blocking mode an 
fgets() call will always return right away while in blocking mode it will 
wait for data to become available on the stream. 
Returns TRUE on success or FALSE on failure. 
This function was previously called as set_socket_blocking() and later 
socket_set_blocking() but this usage is deprecated. 
Note: Prior to PHP 4.3, this function only worked on socket based 
streams. Since PHP 4.3, this function works for any stream that supports 
non-blocking mode (currently, regular files and socket streams). 
See also stream_select().   stream_selectUpstream_set_timeout
#

#T=bool stream_set_blocking ( resource stream, int mode)
stream_set_blocking ( ^!resource stream, int mode);
#

#T=stream_set_timeout - bool stream_set_timeout ( resource stream, int seconds [, int 
(PHP 4 >= 4.3.0)
stream_set_timeout -- Set timeout period on a stream
Description
bool stream_set_timeout ( resource stream, int seconds [, int 
microseconds])
Sets the timeout value on stream, expressed in the sum of seconds and 
microseconds. Returns TRUE on success or FALSE on failure. Example 
1. stream_set_timeout() example
  <?php
  $fp = fsockopen("www.example.com", 80);
  if (!$fp) {
      echo "Unable to open\n";
  } else {
      fputs($fp, "GET / HTTP/1.0\n\n");
      stream_set_timeout($fp, 2);
      $res = fread($fp, 2000);
      var_dump(stream_get_meta_data($fp));
      fclose($fp);
      echo $res;
  }
  ?> 
Note: As of PHP 4.3, this function can (potentially) work on any kind of 
stream. In PHP 4.3, socket based streams are still the only kind 
supported in the PHP core, although streams from other extensions may 
support this function. 
This function was previously called as set_socket_timeout() and later 
socket_set_timeout() but this usage is deprecated. 
See also: fsockopen() and fopen().   stream_set_blockingUpstream_set_write_buffer
#

#T=bool stream_set_timeout ( resource stream, int seconds [, int 
stream_set_timeout ( ^!resource stream, int seconds [, int ;
#

#T=stream_set_write_buffer - int stream_set_write_buffer ( resource stream, int buffer)
(PHP 4 >= 4.3.0)
stream_set_write_buffer -- Sets file buffering on the given stream
Description
int stream_set_write_buffer ( resource stream, int buffer)
Output using fwrite() is normally buffered at 8K. This means that if there 
are two processes wanting to write to the same output stream (a file), 
each is paused after 8K of data to allow the other to write. 
stream_set_write_buffer() sets the buffering for write operations on the 
given filepointer stream to buffer bytes. If buffer is 0 then write 
operations are unbuffered. This ensures that all writes with fwrite() are 
completed before other processes are allowed to write to that output 
stream. 
The function returns 0 on success, or EOF if the request cannot be 
honored. 
The following example demonstrates how to use stream_set_write_buffer() to 
create an unbuffered stream. Example 1. stream_set_write_buffer() 
example
  <?php
  $fp = fopen($file, "w");
  if ($fp) {
    stream_set_write_buffer($fp, 0);
    fputs($fp, $output);
    fclose($fp);
  }
  ?> 
See also fopen() and fwrite().   stream_set_timeoutUpstream_socket_accept
#

#T=int stream_set_write_buffer ( resource stream, int buffer)
stream_set_write_buffer ( ^!resource stream, int buffer);
#

#T=stream_socket_accept - resource stream_socket_accept ( resource server_socket [, int timeout [, 
(PHP 5 CVS only)
stream_socket_accept --  Accept a connection on a socket created by 
stream_socket_server() 
Description
resource stream_socket_accept ( resource server_socket [, int timeout [, 
string &peername]])
Accept a connection on a socket previously created by 
stream_socket_server(). If timeout is specified, the default socket accept 
timeout will be overridden with the time specified in seconds. The name 
(address) of the client which connected will be passed back in peername if 
included and available from the selected transport. 
peername can also be determined later using stream_socket_get_name(). 
If the call fails, it will return FALSE. 
See also stream_socket_server(), stream_socket_get_name(), 
stream_set_blocking(), stream_set_timeout(), fgets(), fgetss(), fputs(), 
fclose(), feof(), and the Curl extension.   stream_set_write_bufferUpstream_socket_client
#

#T=resource stream_socket_accept ( resource server_socket [, int timeout [, 
stream_socket_accept ( ^!resource server_socket [, int timeout [, ;
#

#T=stream_socket_client - resource stream_socket_client ( string remote_socket [, int &errno [, 
(PHP 5 CVS only)
stream_socket_client --  Open Internet or Unix domain socket connection 
Description
resource stream_socket_client ( string remote_socket [, int &errno [, 
string &errstr [, float timeout [, int flags [, resource context]]]]])
Initiates a stream or datagram connection to the destination specified by 
remote_socket. The type of socket created is determined by the transport 
specified using standard url formatting: transport://target. For Internet 
Domain sockets (AF_INET) such as TCP and UDP, the target portion of the 
remote_socket parameter should consist of a hostname or IP address 
followed by a colon and a port number. For Unix domain sockets, the target 
portion should point to the socket file on the filesystem. The optional 
timeout can be used to set a timeout in seconds for the connect system 
call. flags is a bitmask field which may be set to any combination of 
connection flags. Currently the selection of connection flags is limited 
to STREAM_CLIENT_ASYNC_CONNECT and STREAM_CLIENT_PERSISTENT. 
Note: If you need to set a timeout for reading/writing data over the 
socket, use stream_set_timeout(), as the timeout parameter to 
stream_socket_client() only applies while connecting the socket. 
stream_socket_client() returns a stream resource which may be used 
together with the other file functions (such as fgets(), fgetss(), 
fputs(), fclose(), and feof()). 
If the call fails, it will return FALSE and if the optional errno and 
errstr arguments are present they will be set to indicate the actual 
system level error that occurred in the system-level connect() call. If 
the value returned in errno is 0 and the function returned FALSE, it is an 
indication that the error occurred before the connect() call. This is most 
likely due to a problem initializing the socket. Note that the errno and 
errstr arguments will always be passed by reference. 
Depending on the environment, the Unix domain or the optional connect 
timeout may not be available. A list of available transports can be 
retrieved using stream_get_transports(). See Appendix J for a list of 
built in transports. 
The stream will by default be opened in blocking mode. You can switch it 
to non-blocking mode by using stream_set_blocking(). Example 1. 
stream_socket_client() Example
  <?php
  $fp = stream_socket_client("tcp://www.example.com:80", $errno, 
  $errstr, 30);
  if (!$fp) {
      echo "$errstr ($errno)<br />\n";
  } else {
      fputs($fp, "GET / HTTP/1.0\r\nHost: 
  www.example.com\r\nAccept: */*\r\n\r\n");
      while (!feof($fp)) {
	  echo fgets($fp, 1024);
      }
      fclose($fp);
  }
  ?> 

The example below shows how to retrieve the day and time from the UDP 
service "daytime" (port 13) in your own machine. Example 2. Using 
UDP connection
  <?php
  $fp = stream_socket_client("udp://127.0.0.1:13", $errno, 
  $errstr);
  if (!$fp) {
      echo "ERROR: $errno - $errstr<br />\n";
  } else {
      fwrite($fp, "\n");
      echo fread($fp, 26);
      fclose($fp);
  }
  ?> 
Warning
UDP sockets will sometimes appear to have opened without an error, 
even if the remote host is unreachable. The error will only become 
apparent when you read or write data to/from the socket. The reason 
for this is because UDP is a "connectionless" protocol, which means 
that the operating system does not try to establish a link for the 
socket until it actually needs to send or receive data. 

Note: When specifying a numerical IPv6 address (e.g. fe80::1) you must 
enclose the IP in square brackets. For example, tcp://[fe80::1]:80.
See also stream_socket_server(), stream_set_blocking(), 
stream_set_timeout(), fgets(), fgetss(), fputs(), fclose(), feof(), and 
the Curl extension.   stream_socket_acceptUpstream_socket_get_name
#

#T=resource stream_socket_client ( string remote_socket [, int &errno [, 
stream_socket_client ( ^!string remote_socket [, int &errno [, ;
#

#T=stream_socket_get_name - string stream_socket_get_name ( resource handle, bool want_peer)
(PHP 5 CVS only)
stream_socket_get_name -- Retrieve the name of the local or remote sockets
Description
string stream_socket_get_name ( resource handle, bool want_peer)
Returns the local or remote name of a given socket connection. If 
want_peer is set to TRUE the remote socket name will be returned, if it is 
set to FALSE the local socket name will be returned. 
See also stream_socket_accept()   stream_socket_clientUpstream_socket_recvfrom
stream_socket_recvfrom
(no version information, might be only in CVS)
stream_socket_recvfrom -- Receives data from a socket, connected or not 
Description
string stream_socket_recvfrom ( resource socket, int length [, int flags 
[, string &address]])
The function stream_socket_recvfrom() accepts data from a remote socket up 
to length bytes. If address is provided it will be populated with the 
address of the remote socket. 
The value of flags can be any combination of the following: 
Table 1. possible values for flags
STREAM_OOBProcess OOB (out-of-band) data. 
STREAM_PEEKRetrieve data from the socket, but do not consume the 
buffer. Subsequent calls to fread() or stream_socket_recvfrom() will 
see the same data. 

Example 1. stream_socket_sendto() Example
  <?php
  /* Open a server socket to port 1234 on localhost */
  $server = stream_socket_server('tcp://127.0.0.1:1234');

  /* Accept a connection */
  $socket = stream_socket_accept($server);

  /* Grab a packet (1500 is a typical MTU size) of OOB data */
  echo "Received Out-Of-Band: '" . 
  stream_socket_recvfrom($socket, 1500, STREAM_OOB) . "'\n";

  /* Take a peek at the normal in-band data, but don't comsume 
  it. */
  echo "Data: '" . stream_socket_recvfrom($socket, 1500, 
  STREAM_PEEK) . "'\n";

  /* Get the exact same packet again, but remove it from the 
  buffer this time. */
  echo "Data: '" . stream_socket_recvfrom($socket, 1500) . 
"'\n";

  /* Close it up */
  fclose($socket);
  fclose($server);
  ?> 
See also stream_socket_sendto(), stream_socket_client(), and 
stream_socket_server().   stream_socket_get_nameUpstream_socket_sendto
stream_socket_sendto
(no version information, might be only in CVS)
stream_socket_sendto -- Sends a message to a socket, whether it is 
connected or not 
Description
int stream_socket_sendto ( resource socket, string data [, int flags [, 
string address]])
The function stream_socket_sendto() sends the data specified by data 
through the socket specified by socket. The address specified when the 
socket stream was created will be used unless an alternate address is 
specified in address. 
The value of flags can be any combination of the following: 
Table 1. possible values for flags
STREAM_OOBProcess OOB (out-of-band) data. 

Example 1. stream_socket_sendto() Example
  <?php
  /* Open a socket to port 1234 on localhost */
  $socket = stream_socket_client('tcp://127.0.0.1:1234');

  /* Send ordinary data via ordinary channels. */
  fwrite($socket, "Normal data transmit.");

  /* Send more data out of band. */
  stream_socket_sendto($socket, "Out of Band data.", 
STREAM_OOB);

  /* Close it up */
  fclose($socket);
  ?> 
See also stream_socket_recvfrom(), stream_socket_client(), and 
stream_socket_server().   stream_socket_recvfromUpstream_socket_server
#

#T=string stream_socket_get_name ( resource handle, bool want_peer)
stream_socket_get_name ( ^!resource handle, bool want_peer);
#

#T=stream_socket_server - resource stream_socket_server ( string local_socket [, int &errno [, 
(PHP 5 CVS only)
stream_socket_server --  Create an Internet or Unix domain server socket 
Description
resource stream_socket_server ( string local_socket [, int &errno [, 
string &errstr [, int flags [, resource context]]]])
Creates a stream or datagram socket on the specified local_socket. The 
type of socket created is determined by the transport specified using 
standard url formatting: transport://target. For Internet Domain sockets 
(AF_INET) such as TCP and UDP, the target portion of the remote_socket 
parameter should consist of a hostname or IP address followed by a colon 
and a port number. For Unix domain sockets, the target portion should 
point to the socket file on the filesystem. flags is a bitmask field which 
may be set to any combination of socket creation flags. The default value 
of flags is STREAM_SERVER_BIND | STREAM_SERVER_LISTEN. 
This function only creates a socket, to begin accepting connections use 
stream_socket_accept(). 
If the call fails, it will return FALSE and if the optional errno and 
errstr arguments are present they will be set to indicate the actual 
system level error that occurred in the system-level socket(), bind(), and 
listen() calls. If the value returned in errno is 0 and the function 
returned FALSE, it is an indication that the error occurred before the 
bind() call. This is most likely due to a problem initializing the socket. 
Note that the errno and errstr arguments will always be passed by 
reference. 
Depending on the environment, Unix domain sockets may not be available. A 
list of available transports can be retrieved using 
stream_get_transports(). See Appendix J for a list of bulitin transports. 
stream_socket_server(). Example 1. stream_socket_server() Example
  <?php
  $socket = stream_socket_server("tcp://0.0.0.0:8000", $errno, 
  $errstr);
  if (!$socket) {
    echo "$errstr ($errno)<br />\n";
  } else {
    while ($conn = stream_socket_accept($socket)) {
      fputs($conn, 'The local time is ' . date('n/j/Y g:i a') . 
  "\n");
      fclose($conn);
    }
    fclose($socket);
  }
  ?> 
The example below shows how to act as a time server which can respond to 
time queries as shown in an example on stream_socket_client(). 
Note: Most systems require root access to create a server socket on a 
port below 1024. 
Example 2. Using UDP server sockets
  <?php
  $socket = stream_socket_server("udp://0.0.0.0:13", $errno, 
  $errstr);
  if (!$socket) {
      echo "ERROR: $errno - $errstr<br />\n";
  } else {
    while ($conn = stream_socket_accept($socket)) {
      fwrite($conn, date("D M j H:i:s Y\r\n"));
      fclose($conn);
    }
    fclose($socket);
  }
  ?> 
Note: When specifying a numerical IPv6 address (e.g. fe80::1) you must 
enclose the IP in square brackets. For example, tcp://[fe80::1]:80.
See also stream_socket_client(), stream_set_blocking(), 
stream_set_timeout(), fgets(), fgetss(), fputs(), fclose(), feof(), and 
the Curl extension.   stream_socket_sendtoUpstream_wrapper_register
#

#T=resource stream_socket_server ( string local_socket [, int &errno [, 
stream_socket_server ( ^!string local_socket [, int &errno [, ;
#

#T=stream_wrapper_register - bool stream_wrapper_register ( string protocol, string classname)
(PHP 4 >= 4.3.2)
stream_wrapper_register -- Register a URL wrapper implemented as a PHP 
class
Description
bool stream_wrapper_register ( string protocol, string classname)
stream_wrapper_register() allows you to implement your own protocol 
handlers and streams for use with all the other filesystem functions (such 
as fopen(), fread() etc.). 
To implement a wrapper, you need to define a class with a number of member 
functions, as defined below. When someone fopens your stream, PHP will 
create an instance of classname and then call methods on that instance. 
You must implement the methods exactly as described below - doing 
otherwise will lead to undefined behaviour. 
Note: As of PHP 5.0.0 the instance of classname will be populated with a 
context property referencing a Context Resource which may be accessed 
with stream_context_get_options(). If no context was passed to the 
stream creation function, context will be set to NULL. 
stream_wrapper_register() will return FALSE if the protocol already has a 
handler. 
bool stream_open ( string path, string mode, int options, string 
opened_path)
This method is called immediately after your stream object is created. 
path specifies the URL that was passed to fopen() and that this object is 
expected to retrieve. You can use parse_url() to break it apart. 
mode is the mode used to open the file, as detailed for fopen(). You are 
responsible for checking that mode is valid for the path requested. 
options holds additional flags set by the streams API. It can hold one or 
more of the following values OR'd together. 
FlagDescription
STREAM_USE_PATHIf path is relative, search for the resource using 
the include_path. 
STREAM_REPORT_ERRORSIf this flag is set, you are responsible for 
raising errors using trigger_error() during opening of the stream. 
If this flag is not set, you should not raise any errors. 

If the path is opened successfully, and STREAM_USE_PATH is set in options, 
you should set opened_path to the full path of the file/resource that was 
actually opened. 
If the requested resource was opened successfully, you should return TRUE, 
otherwise you should return FALSE 
void stream_close ( void )
This method is called when the stream is closed, using fclose(). You must 
release any resources that were locked or allocated by the stream. 
string stream_read ( int count)
This method is called in response to fread() and fgets() calls on the 
stream. You must return up-to count bytes of data from the current 
read/write position as a string. If there are less than count bytes 
available, return as many as are available. If no more data is available, 
return either FALSE or an empty string. You must also update the 
read/write position of the stream by the number of bytes that were 
successfully read. 
int stream_write ( string data)
This method is called in response to fwrite() calls on the stream. You 
should store data into the underlying storage used by your stream. If 
there is not enough room, try to store as many bytes as possible. You 
should return the number of bytes that were successfully stored in the 
stream, or 0 if none could be stored. You must also update the read/write 
position of the stream by the number of bytes that were successfully 
written. 
bool stream_eof ( void )
This method is called in response to feof() calls on the stream. You 
should return TRUE if the read/write position is at the end of the stream 
and if no more data is available to be read, or FALSE otherwise. 
int stream_tell ( void )
This method is called in response to ftell() calls on the stream. You 
should return the current read/write position of the stream. 
bool stream_seek ( int offset, int whence)
This method is called in response to fseek() calls on the stream. You 
should update the read/write position of the stream according to offset 
and whence. See fseek() for more information about these parameters. 
Return TRUE if the position was updated, FALSE otherwise. 
bool stream_flush ( void )
This method is called in response to fflush() calls on the stream. If you 
have cached data in your stream but not yet stored it into the underlying 
storage, you should do so now. Return TRUE if the cached data was 
successfully stored (or if there was no data to store), or FALSE if the 
data could not be stored. 
array stream_stat ( void )
This method is called in response to fstat() calls on the stream and 
should return an array containing the same values as appropriate for the 
stream. 
bool unlink ( string path)
This method is called in response to unlink() calls on URL paths 
associated with the wrapper and should attempt to delete the item 
specified by path. It should return TRUE on success or FALSE on failure. 
In order for the appropriate error message to be returned, do not define 
this method if your wrapper does not support unlinking. 
Note: Userspace wrapper unlink method is not supported prior to PHP 
5.0.0. 
bool rename ( string path_from, string path_to)
This method is called in response to rename() calls on URL paths 
associated with the wrapper and should attempt to rename the item 
specified by path_from to the specification given by path_to. It should 
return TRUE on success or FALSE on failure. In order for the appropriate 
error message to be returned, do not define this method if your wrapper 
does not support renaming. 
Note: Userspace wrapper rename method is not supported prior to PHP 
5.0.0. 
bool mkdir ( string path, int mode, int options)
This method is called in response to mkdir() calls on URL paths associated 
with the wrapper and should attempt to create the directory specified by 
path. It should return TRUE on success or FALSE on failure. In order for 
the appropriate error message to be returned, do not define this method if 
your wrapper does not support creating directories. Posible values for 
options include STREAM_REPORT_ERRORS and STREAM_MKDIR_RECURSIVE. 
Note: Userspace wrapper mkdir method is not supported prior to PHP 
5.0.0. 
bool rmdir ( string path, int options)
This method is called in response to rmdir() calls on URL paths associated 
with the wrapper and should attempt to remove the directory specified by 
path. It should return TRUE on success or FALSE on failure. In order for 
the appropriate error message to be returned, do not define this method if 
your wrapper does not support removing directories. Possible values for 
options include STREAM_REPORT_ERRORS. 
Note: Userspace wrapper rmdir method is not supported prior to PHP 
5.0.0. 
bool dir_opendir ( string path, int options)
This method is called immediately when your stream object is created for 
examining directory contents with opendir(). path specifies the URL that 
was passed to opendir() and that this object is expected to explore. You 
can use parse_url() to break it apart. 
array url_stat ( string path, int flags)
This method is called in response to stat() calls on the URL paths 
associated with the wrapper and should return as many elements in common 
with the system function as possible. Unknown or unavailable values should 
be set to a rational value (usually 0). 
flags holds additional flags set by the streams API. It can hold one or 
more of the following values OR'd together. 
FlagDescription
STREAM_URL_STAT_LINKFor resources with the ability to link to other 
resource (such as an HTTP Location: forward, or a filesystem 
symlink). This flag specified that only information about the link 
itself should be returned. Not the resource pointed to by the link. 
This flag is set in response to calls to lstat(), is_link(), or 
filetype(). 
STREAM_URL_STAT_QUIETIf this flag is set, your wrapper should not 
raise any errors. If this flag is not set, you are responsible for 
reporting errors using the trigger_error() function during stating 
of the path. 

string dir_readdir ( void )
This method is called in response to readdir() and should return a string 
representing the next filename in the location opened by dir_opendir(). 
bool dir_rewinddir ( void )
This method is called in response to rewinddir() and should reset the 
output generated by dir_readdir(). i.e.: The next call to dir_readdir() 
should return the first entry in the location returned by dir_opendir(). 
bool dir_closedir ( void )
This method is called in response to closedir(). You should release any 
resources which were locked or allocated during the opening and use of the 
directory stream. 
The example below implements a var:// protocol handler that allows 
read/write access to a named global variable using standard filesystem 
stream functions such as fread(). The var:// protocol implemented below, 
given the url "var://foo" will read/write data to/from $GLOBALS["foo"]. 
Example 1. A Stream for reading/writing global variables
  <?php

  class VariableStream {
      var $position;
      var $varname;
     
      function stream_open($path, $mode, $options, 
  &$opened_path) {
	  $url = parse_url($path);
	  $this->varname = $url["host"];
	  $this->position = 0;
	  
	  return true;
      }

      function stream_read($count) {
	  $ret = substr($GLOBALS[$this->varname], 
  $this->position, $count);
	  $this->position += strlen($ret);
	  return $ret;
      }

      function stream_write($data) {
	  $left = substr($GLOBALS[$this->varname], 0, 
  $this->position);
	  $right = substr($GLOBALS[$this->varname], 
  $this->position + strlen($data));
	  $GLOBALS[$this->varname] = $left . $data . $right;
	  $this->position += strlen($data);
	  return strlen($data);
      }

      function stream_tell() {
	  return $this->position;
      }

      function stream_eof() {
	  return $this->position >= 
  strlen($GLOBALS[$this->varname]);
      }

      function stream_seek($offset, $whence) {
	  switch ($whence) {
	      case SEEK_SET:
		  if ($offset < strlen($GLOBALS[$this->varname]) 
  && $offset >= 0) {
		       $this->position = $offset;
		       return true;
		  } else {
		       return false;
		  }
		  break;
		  
	      case SEEK_CUR:
		  if ($offset >= 0) {
		       $this->position += $offset;
		       return true;
		  } else {
		       return false;
		  }
		  break;
		  
	      case SEEK_END:
		  if (strlen($GLOBALS[$this->varname]) + $offset 
  >= 0) {
		       $this->position = 
  strlen($GLOBALS[$this->varname]) + $offset;
		       return true;
		  } else {
		       return false;
		  }
		  break;
		  
	      default:
		  return false;
	  }
      }
  }

  stream_wrapper_register("var", "VariableStream")
      or die("Failed to register protocol");

  $myvar = "";
      
  $fp = fopen("var://myvar", "r+");

  fwrite($fp, "line1\n");
  fwrite($fp, "line2\n");
  fwrite($fp, "line3\n");

  rewind($fp);
  while (!feof($fp)) {
      echo fgets($fp);
  }
  fclose($fp);
  var_dump($myvar);

  ?> 

  stream_socket_serverUpString functions
#

#T=bool stream_wrapper_register ( string protocol, string classname)
stream_wrapper_register ( ^!string protocol, string classname);
#

#T=strftime - string strftime ( string format [, int timestamp])
(PHP 3, PHP 4 )
strftime --  Format a local time/date according to locale settings 
Description
string strftime ( string format [, int timestamp])
Returns a string formatted according to the given format string using the 
given timestamp or the current local time if no timestamp is given. Month 
and weekday names and other language dependent strings respect the current 
locale set with setlocale(). 
The following conversion specifiers are recognized in the format string: 
%a - abbreviated weekday name according to the current locale 
%A - full weekday name according to the current locale 
%b - abbreviated month name according to the current locale 
%B - full month name according to the current locale 
%c - preferred date and time representation for the current locale 
%C - century number (the year divided by 100 and truncated to an 
integer, range 00 to 99) 
%d - day of the month as a decimal number (range 01 to 31) 
%D - same as %m/%d/%y 
%e - day of the month as a decimal number, a single digit is preceded by 
a space (range ' 1' to '31') 
%g - like %G, but without the century. 
%G - The 4-digit year corresponding to the ISO week number (see %V). 
This has the same format and value as %Y, except that if the ISO week 
number belongs to the previous or next year, that year is used instead. 
%h - same as %b 
%H - hour as a decimal number using a 24-hour clock (range 00 to 23) 
%I - hour as a decimal number using a 12-hour clock (range 01 to 12) 
%j - day of the year as a decimal number (range 001 to 366) 
%m - month as a decimal number (range 01 to 12) 
%M - minute as a decimal number 
%n - newline character 
%p - either `am' or `pm' according to the given time value, or the 
corresponding strings for the current locale 
%r - time in a.m. and p.m. notation 
%R - time in 24 hour notation 
%S - second as a decimal number 
%t - tab character 
%T - current time, equal to %H:%M:%S 
%u - weekday as a decimal number [1,7], with 1 representing Monday 
Warning
Sun Solaris seems to start with Sunday as 1 although ISO 9889:1999 
(the current C standard) clearly specifies that it should be 
Monday. 

%U - week number of the current year as a decimal number, starting with 
the first Sunday as the first day of the first week 
%V - The ISO 8601:1988 week number of the current year as a decimal 
number, range 01 to 53, where week 1 is the first week that has at least 
4 days in the current year, and with Monday as the first day of the 
week. (Use %G or %g for the year component that corresponds to the week 
number for the specified timestamp.) 
%W - week number of the current year as a decimal number, starting with 
the first Monday as the first day of the first week 
%w - day of the week as a decimal, Sunday being 0 
%x - preferred date representation for the current locale without the 
time 
%X - preferred time representation for the current locale without the 
date 
%y - year as a decimal number without a century (range 00 to 99) 
%Y - year as a decimal number including the century 
%Z - time zone or name or abbreviation 
%% - a literal `%' character 
Note: Not all conversion specifiers may be supported by your C library, 
in which case they will not be supported by PHP's strftime(). 
Additionally, not all platforms support negative timestamps, therefore 
your date range may be limited to no earlier than the Unix epoch. This 
means that e.g. %e, %T, %R and %D (there might be more) and dates prior 
to Jan 1, 1970 will not work on Windows, some Linux distributions, and a 
few other operating systems. For Windows systems a complete overview of 
supported conversion specifiers can be found at this MSDN website. 
Example 1. strftime() locale examples
  <?php
  setlocale(LC_TIME, "C");
  echo strftime("%A");
  setlocale(LC_TIME, "fi_FI");
  echo strftime(" in Finnish is %A,");
  setlocale(LC_TIME, "fr_FR");
  echo strftime(" in French %A and");
  setlocale(LC_TIME, "de_DE");
  echo strftime(" in German %A.\n");
  ?> 

This example works if you have the respective locales installed in your 
system. 
Note: %G and %V, which are based on ISO 8601:1988 week numbers can give 
unexpected (albeit correct) results if the numbering system is not 
thoroughly understood. See %V above and example below. 
Example 2. ISO 8601:1988 week number example
  <?php
  /*     December 2002 / January 2003
  ISOWk  M   Tu  W   Thu F   Sa  Su
  ----- ----------------------------
  51     16  17  18  19  20  21  22 
  52     23  24  25  26  27  28  29
  1      30  31   1   2   3   4   5
  2       6   7   8   9  10  11  12
  3      13  14  15  16  17  18  19   */

  // Outputs: 12/28/2002 - %V,%G,%Y = 52,2002,2002
  echo "12/28/2002 - %V,%G,%Y = " . strftime("%V,%G,%Y", 
  strtotime("12/28/2002")) . "\n";

  // Outputs: 12/30/2002 - %V,%G,%Y = 1,2003,2002
  echo "12/30/2002 - %V,%G,%Y = " . strftime("%V,%G,%Y", 
  strtotime("12/30/2002")) . "\n";

  // Outputs: 1/3/2003 - %V,%G,%Y = 1,2003,2003
  echo "1/3/2003 - %V,%G,%Y = " . 
  strftime("%V,%G,%Y",strtotime("1/3/2003")) . "\n";

  // Outputs: 1/10/2003 - %V,%G,%Y = 2,2003,2003
  echo "1/10/2003 - %V,%G,%Y = " . 
  strftime("%V,%G,%Y",strtotime("1/10/2003")) . "\n";

  /*     December 2004 / January 2005
  ISOWk  M   Tu  W   Thu F   Sa  Su
  ----- ----------------------------
  51     13  14  15  16  17  18  19
  52     20  21  22  23  24  25  26
  53     27  28  29  30  31   1   2
  1       3   4   5   6   7   8   9
  2      10  11  12  13  14  15  16   */

  // Outputs: 12/23/2004 - %V,%G,%Y = 52,2004,2004
  echo "12/23/2004 - %V,%G,%Y = " . 
  strftime("%V,%G,%Y",strtotime("12/23/2004")) . "\n";

  // Outputs: 12/31/2004 - %V,%G,%Y = 53,2004,2004
  echo "12/31/2004 - %V,%G,%Y = " . 
  strftime("%V,%G,%Y",strtotime("12/31/2004")) . "\n";

  // Outputs: 1/2/2005 - %V,%G,%Y = 53,2004,2005
  echo "1/2/2005 - %V,%G,%Y = " . 
  strftime("%V,%G,%Y",strtotime("1/2/2005")) . "\n";

  // Outputs: 1/3/2005 - %V,%G,%Y = 1,2005,2005
  echo "1/3/2005 - %V,%G,%Y = " . 
  strftime("%V,%G,%Y",strtotime("1/3/2005")) . "\n";

  ?> 
See also setlocale(), mktime(), and the Open Group specification of 
strftime().   mktimeUpstrtotime
#

#T=string strftime ( string format [, int timestamp])
strftime ( ^!string format [, int timestamp]);
#

#T=strip_tags - string strip_tags ( string str [, string allowable_tags])
(PHP 3>= 3.0.8, PHP 4 )
strip_tags -- Strip HTML and PHP tags from a string
Description
string strip_tags ( string str [, string allowable_tags])
This function tries to return a string with all HTML and PHP tags stripped 
from a given str. It errors on the side of caution in case of incomplete 
or bogus tags. It uses the same tag stripping state machine as the 
fgetss() function. 
You can use the optional second parameter to specify tags which should not 
be stripped. 
Note: allowable_tags was added in PHP 3.0.13 and PHP 4.0b3. 
Example 1. strip_tags() example
  <?php
  $string = strip_tags($string, '<a><b><i><u>');
  ?> 
Warning
This function does not modify any attributes on the tags that you 
allow using allowable_tags, including the style and onmouseover 
attributes that a mischievous user may abuse when posting text that 
will be shown to other users. 

See also htmlspecialchars().   strcspnUpstripcslashes
#

#T=string strip_tags ( string str [, string allowable_tags])
strip_tags ( ^!string str [, string allowable_tags]);
#

#T=stripcslashes - string stripcslashes ( string str)
(PHP 4 )
stripcslashes --  Un-quote string quoted with addcslashes() 
Description
string stripcslashes ( string str)
Returns a string with backslashes stripped off. Recognizes C-like \n, \r 
..., octal and hexadecimal representation. 
See also addcslashes().   strip_tagsUpstripos
#

#T=string stripcslashes ( string str)
stripcslashes ( ^!string str);
#

#T=stripos - int stripos ( string haystack, string needle [, int offset])
(PHP 5 CVS only)
stripos --  Find position of first occurrence of a case-insensitive string 

Description
int stripos ( string haystack, string needle [, int offset])
Returns the numeric position of the first occurrence of needle in the 
haystack string. Unlike strpos(), stripos() is case-insensitive. 
Note that the needle may be a string of one or more characters. 
If needle is not found, stripos() will return boolean FALSE. 
Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

Example 1. stripos() examples
  <?php
  $findme    = 'a';
  $mystring1 = 'xyz';
  $mystring2 = 'ABC';

  $pos1 = stripos($mystring1, $findme);
  $pos2 = stripos($mystring2, $findme);

  // Nope, 'a' is certainly not in 'xyz'
  if ($pos1 === false) {
      echo "The string '$findme' was not found in the string 
  '$mystring1'";
  }

  // Note our use of ===.  Simply == would not work as expected
  // because the position of 'a' is the 0th (first) character.
  if ($pos2 !== false) {
      echo "We found '$findme' in '$mystring2' at position 
  $pos2";
  }
  ?> 
If needle is not a string, it is converted to an integer and applied as 
the ordinal value of a character. 
The optional offset parameter allows you to specify which character in 
haystack to start searching. The position returned is still relative to 
the the beginning of haystack. 
See also strpos(), strrpos(), strrchr(), substr(), stristr(), strstr(), 
strripos() and str_ireplace().   stripcslashesUpstripslashes
#

#T=int stripos ( string haystack, string needle [, int offset])
stripos ( ^!string haystack, string needle [, int offset]);
#

#T=stripslashes - string stripslashes ( string str)
(PHP 3, PHP 4 )
stripslashes --  Un-quote string quoted with addslashes() 
Description
string stripslashes ( string str)
Returns a string with backslashes stripped off. (\' becomes ' and so on.) 
Double backslashes (\\) are made into a single backslash (\). 
An example use of stripslashes() is when the PHP directive 
magic_quotes_gpc is on (it's on by default), and you aren't inserting this 
data into a place (such as a database) that requires escaping. For 
example, if you're simply outputting data straight from an HTML form. 
Example 1. A stripslashes() example
  <?php
  $str = "Is your name O\'reilly?";

  // Outputs: Is your name O'reilly?
  echo stripslashes($str);
  ?> 
See also addslashes() and get_magic_quotes_gpc().   striposUpstristr
#

#T=string stripslashes ( string str)
stripslashes ( ^!string str);
#

#T=stristr - string stristr ( string haystack, string needle)
(PHP 3>= 3.0.6, PHP 4 )
stristr --  Case-insensitive strstr() 
Description
string stristr ( string haystack, string needle)
Returns all of haystack from the first occurrence of needle to the end. 
needle and haystack are examined in a case-insensitive manner. 
If needle is not found, returns FALSE. 
If needle is not a string, it is converted to an integer and applied as 
the ordinal value of a character. 
Example 1. stristr() example
  <?php
    $email = 'USER@EXAMPLE.com';
    $domain = stristr($email, 'e');
    echo $domain; 
  // outputs ER@EXAMPLE.com
  ?> 
See also strchr(), strrchr(), substr(), and ereg().   stripslashesUpstrlen
#

#T=string stristr ( string haystack, string needle)
stristr ( ^!string haystack, string needle);
#

#T=strlen - int strlen ( string str)
(PHP 3, PHP 4 )
strlen -- Get string length
Description
int strlen ( string str)
Returns the length of string. 
Example 1. A strlen() example
  <?php
  $str = 'abcdef';
  echo strlen($str); // 6

  $str = ' ab cd ';
  echo strlen($str); // 7
  ?> 
See also count().   stristrUpstrnatcasecmp
#

#T=int strlen ( string str)
strlen ( ^!string str);
#

#T=strnatcasecmp - int strnatcasecmp ( string str1, string str2)
(PHP 4 )
strnatcasecmp --  Case insensitive string comparisons using a "natural 
order" algorithm 
Description
int strnatcasecmp ( string str1, string str2)
This function implements a comparison algorithm that orders alphanumeric 
strings in the way a human being would. The behaviour of this function is 
similar to strnatcmp(), except that the comparison is not case sensitive. 
For more information see: Martin Pool's Natural Order String Comparison 
page. 
Similar to other string comparison functions, this one returns < 0 if str1 
is less than str2; > 0 if str1 is greater than str2, and 0 if they are 
equal. 
See also ereg(), strcasecmp(), substr(), stristr(), strcmp(), strncmp(), 
strncasecmp(), strnatcmp(), and strstr().   strlenUpstrnatcmp
#

#T=int strnatcasecmp ( string str1, string str2)
strnatcasecmp ( ^!string str1, string str2);
#

#T=strnatcmp - int strnatcmp ( string str1, string str2)
(PHP 4 )
strnatcmp --  String comparisons using a "natural order" algorithm 
Description
int strnatcmp ( string str1, string str2)
This function implements a comparison algorithm that orders alphanumeric 
strings in the way a human being would, this is described as a "natural 
ordering". An example of the difference between this algorithm and the 
regular computer string sorting algorithms (used in strcmp()) can be seen 
below: 
<?php
$arr1 = $arr2 = array("img12.png", "img10.png", "img2.png", 
"img1.png");
echo "Standard string comparison\n";
usort($arr1, "strcmp");
print_r($arr1);
echo "\nNatural order string comparison\n";
usort($arr2, "strnatcmp");
print_r($arr2);
?> 

The code above will generate the following output: 
Standard string comparison
Array
(
[0] => img1.png
[1] => img10.png
[2] => img12.png
[3] => img2.png
)

Natural order string comparison
Array
(
[0] => img1.png
[1] => img2.png
[2] => img10.png
[3] => img12.png
)

For more information see: Martin Pool's Natural Order String Comparison 
page. 
Similar to other string comparison functions, this one returns < 0 if str1 
is less than str2; > 0 if str1 is greater than str2, and 0 if they are 
equal. 
Note that this comparison is case sensitive. 
See also ereg(), strcasecmp(), substr(), stristr(), strcmp(), strncmp(), 
strncasecmp(), strnatcasecmp(), strstr(), natsort() and natcasesort().   strnatcasecmpUpstrncasecmp
#

#T=int strnatcmp ( string str1, string str2)
strnatcmp ( ^!string str1, string str2);
#

#T=strncasecmp - int strncasecmp ( string str1, string str2, int len)
(PHP 4 >= 4.0.2)
strncasecmp --  Binary safe case-insensitive string comparison of the 
first n characters 
Description
int strncasecmp ( string str1, string str2, int len)
This function is similar to strcasecmp(), with the difference that you can 
specify the (upper limit of the) number of characters (len) from each 
string to be used in the comparison. If any of the strings is shorter than 
len, then the length of that string will be used for the comparison. 
Returns < 0 if str1 is less than str2; > 0 if str1 is greater than str2, 
and 0 if they are equal. 
See also ereg(), strcasecmp(), strcmp(), substr(), stristr(), and 
strstr().   strnatcmpUpstrncmp
#

#T=int strncasecmp ( string str1, string str2, int len)
strncasecmp ( ^!string str1, string str2, int len);
#

#T=strncmp - int strncmp ( string str1, string str2, int len)
(PHP 4 )
strncmp --  Binary safe string comparison of the first n characters 
Description
int strncmp ( string str1, string str2, int len)
This function is similar to strcmp(), with the difference that you can 
specify the (upper limit of the) number of characters (len) from each 
string to be used in the comparison. If any of the strings is shorter than 
len, then the length of that string will be used for the comparison. 
Returns < 0 if str1 is less than str2; > 0 if str1 is greater than str2, 
and 0 if they are equal. 
Note that this comparison is case sensitive. 
See also ereg(), strncasecmp(), strcasecmp(), substr(), stristr(), 
strcmp(), and strstr().   strncasecmpUpstrpos
#

#T=int strncmp ( string str1, string str2, int len)
strncmp ( ^!string str1, string str2, int len);
#

#T=strpos - int strpos ( string haystack, string needle [, int offset])
(PHP 3, PHP 4 )
strpos --  Find position of first occurrence of a string 
Description
int strpos ( string haystack, string needle [, int offset])
Returns the numeric position of the first occurrence of needle in the 
haystack string. Unlike the strrpos(), this function can take a full 
string as the needle parameter and the entire string will be used. 
If needle is not found, strpos() will return boolean FALSE. 
Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

Example 1. strpos() examples
  <?php
  $mystring = 'abc';
  $findme   = 'a';
  $pos = strpos($mystring, $findme);

  // Note our use of ===.  Simply == would not work as expected
  // because the position of 'a' was the 0th (first) character.
  if ($pos === false) {
      echo "The string '$findme' was not found in the string 
  '$mystring'";
  } else {
      echo "The string '$findme' was found in the string 
  '$mystring'";
      echo " and exists at position $pos";
  }

  // We can search for the character, ignoring anything before 
  the offset
  $newstring = 'abcdef abcdef';
  $pos = strpos($newstring, 'a', 1); // $pos = 7, not 0
  ?> 
If needle is not a string, it is converted to an integer and applied as 
the ordinal value of a character. 
The optional offset parameter allows you to specify which character in 
haystack to start searching. The position returned is still relative to 
the the beginning of haystack. 
See also strrpos(), stripos(), strripos(), strrchr(), substr(), stristr(), 
and strstr().   strncmpUpstrrchr
#

#T=int strpos ( string haystack, string needle [, int offset])
strpos ( ^!string haystack, string needle [, int offset]);
#

#T=strrchr - string strrchr ( string haystack, char needle)
(PHP 3, PHP 4 )
strrchr --  Find the last occurrence of a character in a string 
Description
string strrchr ( string haystack, char needle)
This function returns the portion of haystack which starts at the last 
occurrence of needle and goes until the end of haystack. 
Returns FALSE if needle is not found. 
If needle contains more than one character, only the first is used. This 
behavior is different from that of strchr(). 
If needle is not a string, it is converted to an integer and applied as 
the ordinal value of a character. Example 1. strrchr() example
  <?php
  // get last directory in $PATH
  $dir = substr(strrchr($PATH, ":"), 1);

  // get everything after last newline
  $text = "Line 1\nLine 2\nLine 3";
  $last = substr(strrchr($text, 10), 1 );
  ?> 
See also strchr(), substr(), stristr(), and strstr().   strposUpstrrev
#

#T=string strrchr ( string haystack, char needle)
strrchr ( ^!string haystack, char needle);
#

#T=strrev - string strrev ( string string)
(PHP 3, PHP 4 )
strrev -- Reverse a string
Description
string strrev ( string string)
Returns string, reversed. Example 1. Reversing a string with 
strrev()
  <?php
  echo strrev("Hello world!"); // outputs "!dlrow olleH"
  ?> 

  strrchrUpstrripos
#

#T=string strrev ( string string)
strrev ( ^!string string);
#

#T=strripos - int strripos ( string haystack, string needle [, int offset])
(PHP 5 CVS only)
strripos --  Find position of last occurrence of a case-insensitive string 
in a string 
Description
int strripos ( string haystack, string needle [, int offset])
Returns the numeric position of the last occurrence of needle in the 
haystack string. Unlike strrpos(), strripos() is case-insensitive. Also 
note that string positions start at 0, and not 1. 
Note that the needle may be a string of one or more characters. 
If needle is not found, FALSE is returned. 
Warning
This function may return Boolean FALSE, but may also return a 
non-Boolean value which evaluates to FALSE, such as 0 or "". Please 
read the section on Booleans for more information. Use the === 
operator for testing the return value of this function.

Example 1. A simple strripos() example
  <?php
  $haystack = 'ababcd';
  $needle   = 'aB';

  $pos      = strripos($haystack, $needle);

  if ($pos === false) {
      echo "Sorry, we did not find ($needle) in ($haystack)";
  } else {
      echo "Congratulations!\n";
      echo "We found the last ($needle) in ($haystack) at 
  position ($pos)";
  }
  ?> 

Outputs: 
Congratulations!
We found the last (aB) in (ababcd) at position (2)
offset may be specified to begin searching an arbitrary number of 
characters into the string. Negative values will stop searching at an 
arbitrary point prior to the end of the string. 
See also strrpos(), strrchr(), substr(), stripos() and stristr().   strrevUpstrrpos
#

#T=int strripos ( string haystack, string needle [, int offset])
strripos ( ^!string haystack, string needle [, int offset]);
#

#T=strrpos - int strrpos ( string haystack, string needle [, int offset])
(PHP 3, PHP 4 )
strrpos --  Find position of last occurrence of a char in a string 
Description
int strrpos ( string haystack, string needle [, int offset])
Returns the numeric position of the last occurrence of needle in the 
haystack string. Note that the needle in this case can only be a single 
character in PHP 4. If a string is passed as the needle, then only the 
first character of that string will be used. 
If needle is not found, returns FALSE. 
It is easy to mistake the return values for "character found at position 
0" and "character not found". Here's how to detect the difference: 
<?php

// in PHP 4.0b3 and newer:
$pos = strrpos($mystring, "b");
if ($pos === false) { // note: three equal signs
// not found...
}

// in versions older than 4.0b3:
$pos = strrpos($mystring, "b");
if (is_bool($pos) && !$pos) {
// not found...
}
?> 

If needle is not a string, it is converted to an integer and applied as 
the ordinal value of a character. 
Note: As of PHP 5.0.0 offset may be specified to begin searching an 
arbitrary number of characters into the string. Negative values will 
stop searching at an arbitrary point prior to the end of the string. 
Note: The needle may be a string of more than one character as of PHP 
5.0.0. 
See also strpos(), strripos(), strrchr(), substr(), stristr(), and 
strstr().   strriposUpstrspn
#

#T=int strrpos ( string haystack, string needle [, int offset])
strrpos ( ^!string haystack, string needle [, int offset]);
#

#T=strspn - int strspn ( string str1, string str2)
(PHP 3>= 3.0.3, PHP 4 )
strspn --  Find length of initial segment matching mask 
Description
int strspn ( string str1, string str2)
Returns the length of the initial segment of str1 which consists entirely 
of characters in str2. 
The line of code: 
<?php
$var = strspn("42 is the answer, what is the question ...", 
"1234567890");
?> 

will assign 2 to $var, because the string "42" will be the longest segment 
containing characters from "1234567890". 
See also strcspn().   strrposUpstrstr
#

#T=int strspn ( string str1, string str2)
strspn ( ^!string str1, string str2);
#

#T=strstr - string strstr ( string haystack, string needle)
(PHP 3, PHP 4 )
strstr -- Find first occurrence of a string
Description
string strstr ( string haystack, string needle)
Returns part of haystack string from the first occurrence of needle to the 
end of haystack. 
If needle is not found, returns FALSE. 
If needle is not a string, it is converted to an integer and applied as 
the ordinal value of a character. 
Note: This function is case-sensitive. For case-insensitive searches, 
use stristr(). 
Example 1. strstr() example
  <?php
  $email = 'user@example.com';
  $domain = strstr($email, '@');
  echo $domain; // prints @example.com
  ?> 
Note: If you only want to determine if a particular needle occurs within 
haystack, use the faster and less memory intensive function strpos() 
instead. 
See also ereg(), preg_match(), strchr(), stristr(), strpos(), strrchr(), 
and substr().   strspnUpstrtok
#

#T=string strstr ( string haystack, string needle)
strstr ( ^!string haystack, string needle);
#

#T=strtok - string strtok ( string arg1, string arg2)
(PHP 3, PHP 4 )
strtok -- Tokenize string
Description
string strtok ( string arg1, string arg2)
strtok() splits a string (arg1) into smaller strings (tokens), with each 
token being delimited by any character from arg2. That is, if you have a 
string like "This is an example string" you could tokenize this string 
into its individual words by using the space character as the token. 
Example 1. strtok() example
  <?php
  $string = "This is\tan example\nstring";
  /* Use tab and newline as tokenizing characters as well  */
  $tok = strtok($string, " \n\t");
  while ($tok) {
      echo "Word=$tok<br />";
      $tok = strtok(" \n\t");
  }
  ?> 
Note that only the first call to strtok uses the string argument. Every 
subsequent call to strtok only needs the token to use, as it keeps track 
of where it is in the current string. To start over, or to tokenize a new 
string you simply call strtok with the string argument again to initialize 
it. Note that you may put multiple tokens in the token parameter. The 
string will be tokenized when any one of the characters in the argument 
are found. 
The behavior when an empty part was found changed with PHP 4.1.0. The old 
behavior returned an empty string, while the new, correct, behavior simply 
skips the part of the string: Example 2. Old strtok() behavior
  <?php
  $first_token  = strtok('/something', '/');
  $second_token = strtok('/');
  var_dump($first_token, $second_token);
  ?> 

Output: 
string(0) ""
string(9) "something"

Example 3. New strtok() behavior
  <?php
  $first_token  = strtok('/something', '/');
  $second_token = strtok('/');
  var_dump($first_token, $second_token);
  ?> 

Output: 
string(9) "something"
bool(false)
Also be careful that your tokens may be equal to "0". This evaluates to 
FALSE in conditional expressions. 
See also split() and explode().   strstrUpstrtolower
#

#T=string strtok ( string arg1, string arg2)
strtok ( ^!string arg1, string arg2);
#

#T=strtolower - string strtolower ( string str)
(PHP 3, PHP 4 )
strtolower -- Make a string lowercase
Description
string strtolower ( string str)
Returns string with all alphabetic characters converted to lowercase. 
Note that 'alphabetic' is determined by the current locale. This means 
that in i.e. the default "C" locale, characters such as umlaut-A () will 
not be converted. 
Example 1. strtolower() example
  <?php
  $str = "Mary Had A Little Lamb and She LOVED It So";
  $str = strtolower($str);
  echo $str; // Prints mary had a little lamb and she loved it 
so
  ?> 
See also strtoupper(), ucfirst(), and ucwords().   strtokUpstrtoupper
#

#T=string strtolower ( string str)
strtolower ( ^!string str);
#

#T=strtotime - 
Descriptio
(PHP 3>= 3.0.12, PHP 4 )
strtotime --  Parse about any English textual datetime description into a 
Unix timestamp 
Description
int strtotime ( string time [, int now])
The function expects to be given a string containing an English date 
format and will try to parse that format into a Unix timestamp relative to 
the timestamp given in now, or the current time if none is supplied. Upon 
failure, -1 is returned. 
Because strtotime() behaves according to GNU date syntax, have a look at 
the GNU manual page titled Date Input Formats. Described there is valid 
syntax for the time parameter. 
Example 1. strtotime() examples
  <?php
  echo strtotime("now"), "\n";
  echo strtotime("10 September 2000"), "\n";
  echo strtotime("+1 day"), "\n";
  echo strtotime("+1 week"), "\n";
  echo strtotime("+1 week 2 days 4 hours 2 seconds"), "\n";
  echo strtotime("next Thursday"), "\n";
  echo strtotime("last Monday"), "\n";
  ?> 
Example 2. Checking for failure
  <?php
  $str = 'Not Good';
  if (($timestamp = strtotime($str)) === -1) {
      echo "The string ($str) is bogus";
  } else {
      echo "$str == " . date('l dS of F Y h:i:s A', $timestamp);
  }
  ?> 
Note: The valid range of a timestamp is typically from Fri, 13 Dec 1901 
20:45:54 GMT to Tue, 19 Jan 2038 03:14:07 GMT. (These are the dates that 
correspond to the minimum and maximum values for a 32-bit signed 
integer.) Additionally, not all platforms support negative timestamps, 
therefore your date range may be limited to no earlier than the Unix 
epoch. This means that e.g. dates prior to Jan 1, 1970 will not work on 
Windows, some Linux distributions, and a few other operating systems.   strftimeUptime
#

#T=
Descriptio

;
^!#

#T=strtoupper - string strtoupper ( string string)
(PHP 3, PHP 4 )
strtoupper -- Make a string uppercase
Description
string strtoupper ( string string)
Returns string with all alphabetic characters converted to uppercase. 
Note that 'alphabetic' is determined by the current locale. For instance, 
in the default "C" locale characters such as umlaut-a () will not be 
converted. 
Example 1. strtoupper() example
  <?php
  $str = "Mary Had A Little Lamb and She LOVED It So";
  $str = strtoupper($str);
  echo $str; // Prints MARY HAD A LITTLE LAMB AND SHE LOVED IT 
SO
  ?> 
See also strtolower(), ucfirst(), and ucwords().   strtolowerUpstrtr
#

#T=string strtoupper ( string string)
strtoupper ( ^!string string);
#

#T=strtr - string strtr ( string str, string from, string to)
(PHP 3, PHP 4 )
strtr -- Translate certain characters
Description
string strtr ( string str, string from, string to)

string strtr ( string str, array replace_pairs)
This function returns a copy of str, translating all occurrences of each 
character in from to the corresponding character in to and returning the 
result. 
If from and to are different lengths, the extra characters in the longer 
of the two are ignored. Example 1. strtr() example
  <?php
  $addr = strtr($addr, "", "aao");
  ?> 
strtr() may be called with only two arguments. If called with two 
arguments it behaves in a new way: from then has to be an array that 
contains string -> string pairs that will be replaced in the source 
string. strtr() will always look for the longest possible match first and 
will *NOT* try to replace stuff that it has already worked on. 
Example 2. strtr() example with two arguments
  <?php
  $trans = array("hello" => "hi", "hi" => "hello");
  echo strtr("hi all, I said hello", $trans);
  ?> 

This will show: 
hello all, I said hi
Note: This optional to and from parameters were added in PHP 4.0.0 
See also ereg_replace().   strtoupperUpsubstr_compare
#

#T=string strtr ( string str, string from, string to)
strtr ( ^!string str, string from, string to);
#

#T=strval - string strval ( mixed var)
(PHP 3, PHP 4 )
strval -- Get string value of a variable
Description
string strval ( mixed var)
Returns the string value of var. See the documentation on string for more 
information on converting to string. 
var may be any scalar type. You cannot use strval() on arrays or objects. 
See also floatval(), intval(), settype() and Type juggling.   settypeUpunserialize
substr_compare
(no version information, might be only in CVS)
substr_compare --  Binary safe optionally case insensitive comparison of 2 
strings from an offset, up to length characters 
Description
int substr_compare ( string main_str, string str, int offset [, int length 
[, bool case_sensitivity]])
Warning
This function is currently not documented; only the argument list is 
available.
  strtrUpsubstr_count
#

#T=string strval ( mixed var)
strval ( ^!mixed var);
#

#T=substr_count - int substr_count ( string haystack, string needle)
(PHP 4 )
substr_count -- Count the number of substring occurrences
Description
int substr_count ( string haystack, string needle)
substr_count() returns the number of times the needle substring occurs in 
the haystack string. 
Example 1. substr_count() example
  <?php
  echo substr_count("This is a test", "is"); // prints out 2
  ?> 
See also count_chars(), strpos(), substr(), and strstr().   substr_compareUpsubstr_replace
#

#T=int substr_count ( string haystack, string needle)
substr_count ( ^!string haystack, string needle);
#

#T=substr_replace - string substr_replace ( string string, string replacement, int start [, 
(PHP 4 )
substr_replace -- Replace text within a portion of a string
Description
string substr_replace ( string string, string replacement, int start [, 
int length])
substr_replace() replaces a copy of string delimited by the start and 
(optionally) length parameters with the string given in replacement. The 
result is returned. 
If start is positive, the replacing will begin at the start'th offset into 
string. 
If start is negative, the replacing will begin at the start'th character 
from the end of string. 
If length is given and is positive, it represents the length of the 
portion of string which is to be replaced. If it is negative, it 
represents the number of characters from the end of string at which to 
stop replacing. If it is not given, then it will default to strlen( string 
); i.e. end the replacing at the end of string. 
Example 1. substr_replace() example
  <?php
  $var = 'ABCDEFGH:/MNRPQR/';
  echo "Original: $var<hr />\n";

  /* These two examples replace all of $var with 'bob'. */
  echo substr_replace($var, 'bob', 0) . "<br />\n";
  echo substr_replace($var, 'bob', 0, strlen($var)) . "<br 
/>\n";

  /* Insert 'bob' right at the beginning of $var. */
  echo substr_replace($var, 'bob', 0, 0) . "<br />\n";

  /* These next two replace 'MNRPQR' in $var with 'bob'. */
  echo substr_replace($var, 'bob', 10, -1) . "<br />\n";
  echo substr_replace($var, 'bob', -7, -1) . "<br />\n";

  /* Delete 'MNRPQR' from $var. */
  echo substr_replace($var, '', 10, -1) . "<br />\n";
  ?> 
See also str_replace() and substr().   substr_countUpsubstr
#

#T=string substr_replace ( string string, string replacement, int start [, 
substr_replace ( ^!string string, string replacement, int start [, ;
#

#T=substr - string substr ( string string, int start [, int length])
(PHP 3, PHP 4 )
substr -- Return part of a string
Description
string substr ( string string, int start [, int length])
substr() returns the portion of string specified by the start and length 
parameters. 
If start is non-negative, the returned string will start at the start'th 
position in string, counting from zero. For instance, in the string 
'abcdef', the character at position 0 is 'a', the character at position 2 
is 'c', and so forth. 
Example 1. Basic substr() usage
  <?php
  $rest = substr("abcdef", 1);    // returns "bcdef"
  $rest = substr("abcdef", 1, 3); // returns "bcd"
  $rest = substr("abcdef", 0, 4); // returns "abcd"
  $rest = substr("abcdef", 0, 8); // returns "abcdef"

  // Accessing via curly braces is another option
  $string = 'abcdef';
  echo $string{0};                // returns a
  echo $string{3};                // returns d
  ?> 
If start is negative, the returned string will start at the start'th 
character from the end of string. 
Example 2. Using a negative start
  <?php
  $rest = substr("abcdef", -1);    // returns "f"
  $rest = substr("abcdef", -2);    // returns "ef"
  $rest = substr("abcdef", -3, 1); // returns "d"
  ?> 
If length is given and is positive, the string returned will contain at 
most length characters beginning from start (depending on the length of 
string). If string is less than start characters long, FALSE will be 
returned. 
If length is given and is negative, then that many characters will be 
omitted from the end of string (after the start position has been 
calculated when a start is negative). If start denotes a position beyond 
this truncation, an empty string will be returned. 
Example 3. Using a negative length
  <?php
  $rest = substr("abcdef", 0, -1);  // returns "abcde"
  $rest = substr("abcdef", 2, -1);  // returns "cde"
  $rest = substr("abcdef", 4, -4);  // returns ""
  $rest = substr("abcdef", -3, -1); // returns "de"
  ?> 
See also strrchr(), substr_replace(), ereg(), and trim().   substr_replaceUptrim
#

#T=string substr ( string string, int start [, int length])
substr ( ^!string string, int start [, int length]);
#

#T=swf_actiongeturl - void swf_actiongeturl ( string url, string target)
(PHP 4 <= 4.3.2)
swf_actiongeturl -- Get a URL from a Shockwave Flash movie
Description
void swf_actiongeturl ( string url, string target)
The swf_actiongeturl() function gets the URL specified by the parameter 
url with the target target.   Shockwave Flash functionsUpswf_actiongotoframe
#

#T=void swf_actiongeturl ( string url, string target)
swf_actiongeturl ( ^!string url, string target);
#

#T=swf_actiongotoframe - void swf_actiongotoframe ( int framenumber)
(PHP 4 <= 4.3.2)
swf_actiongotoframe -- Play a frame and then stop
Description
void swf_actiongotoframe ( int framenumber)
The swf_actiongotoframe() function will go to the frame specified by 
framenumber, play it, and then stop.   swf_actiongeturlUpswf_actiongotolabel
#

#T=void swf_actiongotoframe ( int framenumber)
swf_actiongotoframe ( ^!int framenumber);
#

#T=swf_actiongotolabel - void swf_actiongotolabel ( string label)
(PHP 4 <= 4.3.2)
swf_actiongotolabel --  Display a frame with the specified label 
Description
void swf_actiongotolabel ( string label)
The swf_actiongotolabel() function displays the frame with the label given 
by the label parameter and then stops.   swf_actiongotoframeUpswf_actionnextframe
#

#T=void swf_actiongotolabel ( string label)
swf_actiongotolabel ( ^!string label);
#

#T=swf_actionnextframe - void swf_actionnextframe ( void )
(PHP 4 <= 4.3.2)
swf_actionnextframe -- Go forward one frame
Description
void swf_actionnextframe ( void )
Go forward one frame.   swf_actiongotolabelUpswf_actionplay
#

#T=void swf_actionnextframe ( void )
swf_actionnextframe ( ^!void );
#

#T=swf_actionplay - void swf_actionplay ( void )
(PHP 4 <= 4.3.2)
swf_actionplay --  Start playing the flash movie from the current frame 
Description
void swf_actionplay ( void )
Start playing the flash movie from the current frame.   swf_actionnextframeUpswf_actionprevframe
#

#T=void swf_actionplay ( void )
swf_actionplay ( ^!void );
#

#T=swf_actionprevframe - void swf_actionprevframe ( void )
(PHP 4 <= 4.3.2)
swf_actionprevframe -- Go backwards one frame
Description
void swf_actionprevframe ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  swf_actionplayUpswf_actionsettarget
#

#T=void swf_actionprevframe ( void )
swf_actionprevframe ( ^!void );
#

#T=swf_actionsettarget - void swf_actionsettarget ( string target)
(PHP 4 <= 4.3.2)
swf_actionsettarget -- Set the context for actions
Description
void swf_actionsettarget ( string target)
The swf_actionsettarget() function sets the context for all actions. You 
can use this to control other flash movies that are currently playing.   swf_actionprevframeUpswf_actionstop
#

#T=void swf_actionsettarget ( string target)
swf_actionsettarget ( ^!string target);
#

#T=swf_actionstop - void swf_actionstop ( void )
(PHP 4 <= 4.3.2)
swf_actionstop --  Stop playing the flash movie at the current frame 
Description
void swf_actionstop ( void )
Stop playing the flash movie at the current frame.   swf_actionsettargetUpswf_actiontogglequality
#

#T=void swf_actionstop ( void )
swf_actionstop ( ^!void );
#

#T=swf_actiontogglequality - void swf_actiontogglequality ( void )
(PHP 4 <= 4.3.2)
swf_actiontogglequality --  Toggle between low and high quality 
Description
void swf_actiontogglequality ( void )
Toggle the flash movie between high and low quality.   swf_actionstopUpswf_actionwaitforframe
#

#T=void swf_actiontogglequality ( void )
swf_actiontogglequality ( ^!void );
#

#T=swf_actionwaitforframe - void swf_actionwaitforframe ( int framenumber, int skipcount)
(PHP 4 <= 4.3.2)
swf_actionwaitforframe --  Skip actions if a frame has not been loaded 
Description
void swf_actionwaitforframe ( int framenumber, int skipcount)
The swf_actionwaitforframe() function will check to see if the frame, 
specified by the framenumber parameter has been loaded, if not it will 
skip the number of actions specified by the skipcount parameter. This can 
be useful for "Loading..." type animations.   swf_actiontogglequalityUpswf_addbuttonrecord
#

#T=void swf_actionwaitforframe ( int framenumber, int skipcount)
swf_actionwaitforframe ( ^!int framenumber, int skipcount);
#

#T=swf_addbuttonrecord - void swf_addbuttonrecord ( int states, int shapeid, int depth)
(PHP 4 <= 4.3.2)
swf_addbuttonrecord --  Controls location, appearance and active area of 
the current button 
Description
void swf_addbuttonrecord ( int states, int shapeid, int depth)
The swf_addbuttonrecord() function allows you to define the specifics of 
using a button. The first parameter, states, defines what states the 
button can have, these can be any or all of the following constants: 
BSHitTest, BSDown, BSOver or BSUp. The second parameter, the shapeid is 
the look of the button, this is usually the object id of the shape of the 
button. The depth parameter is the placement of the button in the current 
frame. Example 1. swf_addbuttonrecord() example 
  <?php
  swf_startButton($objid, TYPE_MENUBUTTON);
  swf_addButtonRecord(BSDown|BSOver, $buttonImageId, 340);
  swf_onCondition(MenuEnter);
  swf_actionGetUrl("http://www.example.com", "_level1");
  swf_onCondition(MenuExit);
  swf_actionGetUrl("", "_level1");
  swf_endButton();
  ?> 

  swf_actionwaitforframeUpswf_addcolor
#

#T=void swf_addbuttonrecord ( int states, int shapeid, int depth)
swf_addbuttonrecord ( ^!int states, int shapeid, int depth);
#

#T=swf_addcolor - void swf_addcolor ( float r, float g, float b, float a)
(PHP 4 <= 4.3.2)
swf_addcolor --  Set the global add color to the rgba value specified 
Description
void swf_addcolor ( float r, float g, float b, float a)
The swf_addcolor() function sets the global add color to the rgba color 
specified. This color is then used (implicitly) by the swf_placeobject(), 
swf_modifyobject() and the swf_addbuttonrecord() functions. The color of 
the object will be add by the rgba values when the object is written to 
the screen. 
Note: The rgba values can be either positive or negative.   swf_addbuttonrecordUpswf_closefile
#

#T=void swf_addcolor ( float r, float g, float b, float a)
swf_addcolor ( ^!float r, float g, float b, float a);
#

#T=swf_closefile - void swf_closefile ( [int return_file])
(PHP 4 <= 4.3.2)
swf_closefile -- Close the current Shockwave Flash file
Description
void swf_closefile ( [int return_file])
Close a file that was opened by the swf_openfile() function. If the 
return_file parameter is set then the contents of the SWF file are 
returned from the function. 
Example 1. Creating a simple flash file based on user input and 
outputting it and saving it in a database 
  <?php

  // The $text variable is submitted by the
  // user

  // Global variables for database
  // access (used in the swf_savedata() function)
  $DBHOST = "localhost";
  $DBUSER = "sterling";
  $DBPASS = "secret";

  swf_openfile("php://stdout", 256, 256, 30, 1, 1, 1);

      swf_definefont(10, "Ligon-Bold");
	  swf_fontsize(12);
	  swf_fontslant(10);
      
      swf_definetext(11, $text, 1);
      
      swf_pushmatrix();
	  swf_translate(-50, 80, 0);
	  swf_placeobject(11, 60);
      swf_popmatrix();

      swf_showframe();
    
      swf_startdoaction();
	  swf_actionstop();
      swf_enddoaction();

  $data = swf_closefile(1);

  $data ?
    swf_savedata($data) :
    die("Error could not save SWF file");

  // void swf_savedata(string data)
  // Save the generated file a database
  // for later retrieval
  function swf_savedata($data) {
      global $DBHOST, 
	     $DBUSER,
	     $DBPASS;
      
      $dbh = @mysql_connect($DBHOST, $DBUSER, $DBPASS);

      if (!$dbh) {
	  die (sprintf("Error [%d]: %s",
			mysql_errno(), mysql_error()));
      }

      $stmt = "INSERT INTO swf_files (file) VALUES ('$data')";

      $sth = @mysql_query($stmt, $dbh);

      if (!$sth) {
	  die (sprintf("Error [%d]: %s",
			mysql_errno(), mysql_error()));
      }

      @mysql_free_result($sth);
      @mysql_close($dbh);
  }
  ?> 

  swf_addcolorUpswf_definebitmap
#

#T=void swf_closefile ( [int return_file])
swf_closefile ( ^![int return_file]);
#

#T=swf_definebitmap - void swf_definebitmap ( int objid, string image_name)
(PHP 4 <= 4.3.2)
swf_definebitmap -- Define a bitmap
Description
void swf_definebitmap ( int objid, string image_name)
The swf_definebitmap() function defines a bitmap given a GIF, JPEG, RGB or 
FI image. The image will be converted into a Flash JPEG or Flash color map 
format.   swf_closefileUpswf_definefont
#

#T=void swf_definebitmap ( int objid, string image_name)
swf_definebitmap ( ^!int objid, string image_name);
#

#T=swf_definefont - void swf_definefont ( int fontid, string fontname)
(PHP 4 <= 4.3.2)
swf_definefont --  Defines a font 
Description
void swf_definefont ( int fontid, string fontname)
The swf_definefont() function defines a font given by the fontname 
parameter and gives it the id specified by the fontid parameter. It then 
sets the font given by fontname to the current font.   swf_definebitmapUpswf_defineline
#

#T=void swf_definefont ( int fontid, string fontname)
swf_definefont ( ^!int fontid, string fontname);
#

#T=swf_defineline - void swf_defineline ( int objid, float x1, float y1, float x2, float y2, 
(PHP 4 <= 4.3.2)
swf_defineline -- Define a line
Description
void swf_defineline ( int objid, float x1, float y1, float x2, float y2, 
float width)
The swf_defineline() defines a line starting from the x coordinate given 
by x1 and the y coordinate given by y1 parameter. Up to the x coordinate 
given by the x2 parameter and the y coordinate given by the y2 parameter. 
It will have a width defined by the width parameter.   swf_definefontUpswf_definepoly
#

#T=void swf_defineline ( int objid, float x1, float y1, float x2, float y2, 
swf_defineline ( ^!int objid, float x1, float y1, float x2, float y2, ;
#

#T=swf_definepoly - void swf_definepoly ( int objid, array coords, int npoints, float width)
(PHP 4 <= 4.3.2)
swf_definepoly --  Define a polygon 
Description
void swf_definepoly ( int objid, array coords, int npoints, float width)
The swf_definepoly() function defines a polygon given an array of x, y 
coordinates (the coordinates are defined in the parameter coords). The 
parameter npoints is the number of overall points that are contained in 
the array given by coords. The width is the width of the polygon's border, 
if set to 0.0 the polygon is filled.   swf_definelineUpswf_definerect
#

#T=void swf_definepoly ( int objid, array coords, int npoints, float width)
swf_definepoly ( ^!int objid, array coords, int npoints, float width);
#

#T=swf_definerect - void swf_definerect ( int objid, float x1, float y1, float x2, float y2, 
(PHP 4 <= 4.3.2)
swf_definerect -- Define a rectangle
Description
void swf_definerect ( int objid, float x1, float y1, float x2, float y2, 
float width)
The swf_definerect() defines a rectangle with an upper left hand 
coordinate given by the x, x1, and the y, y1. And a lower right hand 
coordinate given by the x coordinate, x2, and the y coordinate, y2 . Width 
of the rectangles border is given by the width parameter, if the width is 
0.0 then the rectangle is filled.   swf_definepolyUpswf_definetext
#

#T=void swf_definerect ( int objid, float x1, float y1, float x2, float y2, 
swf_definerect ( ^!int objid, float x1, float y1, float x2, float y2, ;
#

#T=swf_definetext - void swf_definetext ( int objid, string str, int docenter)
(PHP 4 <= 4.3.2)
swf_definetext -- Define a text string
Description
void swf_definetext ( int objid, string str, int docenter)
Define a text string (the str parameter) using the current font and font 
size. The docenter is where the word is centered, if docenter is 1, then 
the word is centered in x.   swf_definerectUpswf_endbutton
#

#T=void swf_definetext ( int objid, string str, int docenter)
swf_definetext ( ^!int objid, string str, int docenter);
#

#T=swf_endbutton - void swf_endbutton ( void )
(PHP 4 <= 4.3.2)
swf_endbutton --  End the definition of the current button 
Description
void swf_endbutton ( void )
The swf_endbutton() function ends the definition of the current button.   swf_definetextUpswf_enddoaction
#

#T=void swf_endbutton ( void )
swf_endbutton ( ^!void );
#

#T=swf_enddoaction - void swf_enddoaction ( void )
(PHP 4 <= 4.3.2)
swf_enddoaction -- End the current action
Description
void swf_enddoaction ( void )
Ends the current action started by the swf_startdoaction() function.   swf_endbuttonUpswf_endshape
#

#T=void swf_enddoaction ( void )
swf_enddoaction ( ^!void );
#

#T=swf_endshape - void swf_endshape ( void )
(PHP 4 <= 4.3.2)
swf_endshape --  Completes the definition of the current shape 
Description
void swf_endshape ( void )
The swf_endshape() completes the definition of the current shape.   swf_enddoactionUpswf_endsymbol
#

#T=void swf_endshape ( void )
swf_endshape ( ^!void );
#

#T=swf_endsymbol - void swf_endsymbol ( void )
(PHP 4 <= 4.3.2)
swf_endsymbol -- End the definition of a symbol
Description
void swf_endsymbol ( void )
The swf_endsymbol() function ends the definition of a symbol that was 
started by the swf_startsymbol() function.   swf_endshapeUpswf_fontsize
#

#T=void swf_endsymbol ( void )
swf_endsymbol ( ^!void );
#

#T=swf_fontsize - void swf_fontsize ( float size)
(PHP 4 <= 4.3.2)
swf_fontsize -- Change the font size
Description
void swf_fontsize ( float size)
The swf_fontsize() function changes the font size to the value given by 
the size parameter.   swf_endsymbolUpswf_fontslant
#

#T=void swf_fontsize ( float size)
swf_fontsize ( ^!float size);
#

#T=swf_fontslant - void swf_fontslant ( float slant)
(PHP 4 <= 4.3.2)
swf_fontslant -- Set the font slant
Description
void swf_fontslant ( float slant)
Set the current font slant to the angle indicated by the slant parameter. 
Positive values create a forward slant, negative values create a negative 
slant.   swf_fontsizeUpswf_fonttracking
#

#T=void swf_fontslant ( float slant)
swf_fontslant ( ^!float slant);
#

#T=swf_fonttracking - void swf_fonttracking ( float tracking)
(PHP 4 <= 4.3.2)
swf_fonttracking -- Set the current font tracking
Description
void swf_fonttracking ( float tracking)
Set the font tracking to the value specified by the tracking parameter. 
This function is used to increase the spacing between letters and text, 
positive values increase the space and negative values decrease the space 
between letters.   swf_fontslantUpswf_getbitmapinfo
#

#T=void swf_fonttracking ( float tracking)
swf_fonttracking ( ^!float tracking);
#

#T=swf_getbitmapinfo - array swf_getbitmapinfo ( int bitmapid)
(PHP 4 <= 4.3.2)
swf_getbitmapinfo -- Get information about a bitmap
Description
array swf_getbitmapinfo ( int bitmapid)
The swf_getbitmapinfo() function returns an array of information about a 
bitmap given by the bitmapid parameter. The returned array has the 
following elements: 
"size" - The size in bytes of the bitmap. 
"width" - The width in pixels of the bitmap. 
"height" - The height in pixels of the bitmap.   swf_fonttrackingUpswf_getfontinfo
#

#T=array swf_getbitmapinfo ( int bitmapid)
swf_getbitmapinfo ( ^!int bitmapid);
#

#T=swf_getfontinfo - array swf_getfontinfo ( void )
(PHP 4 <= 4.3.2)
swf_getfontinfo --  The height in pixels of a capital A and a lowercase x 
Description
array swf_getfontinfo ( void )
The swf_getfontinfo() function returns an associative array with the 
following parameters: 
Aheight - The height in pixels of a capital A. 
xheight - The height in pixels of a lowercase x.   swf_getbitmapinfoUpswf_getframe
#

#T=array swf_getfontinfo ( void )
swf_getfontinfo ( ^!void );
#

#T=swf_getframe - int swf_getframe ( void )
(PHP 4 <= 4.3.2)
swf_getframe -- Get the frame number of the current frame
Description
int swf_getframe ( void )
The swf_getframe() function gets the number of the current frame.   swf_getfontinfoUpswf_labelframe
#

#T=int swf_getframe ( void )
swf_getframe ( ^!void );
#

#T=swf_labelframe - void swf_labelframe ( string name)
(PHP 4 <= 4.3.2)
swf_labelframe -- Label the current frame
Description
void swf_labelframe ( string name)
Label the current frame with the name given by the name parameter.   swf_getframeUpswf_lookat
#

#T=void swf_labelframe ( string name)
swf_labelframe ( ^!string name);
#

#T=swf_lookat - void swf_lookat ( float view_x, float view_y, float view_z, float 
(PHP 4 <= 4.3.2)
swf_lookat -- Define a viewing transformation
Description
void swf_lookat ( float view_x, float view_y, float view_z, float 
reference_x, float reference_y, float reference_z, float twist)
The swf_lookat() function defines a viewing transformation by giving the 
viewing position (the parameters view_x, view_y, and view_z) and the 
coordinates of a reference point in the scene, the reference point is 
defined by the reference_x, reference_y , and reference_z parameters. The 
twist controls the rotation along with viewer's z axis.   swf_labelframeUpswf_modifyobject
#

#T=void swf_lookat ( float view_x, float view_y, float view_z, float 
swf_lookat ( ^!float view_x, float view_y, float view_z, float ;
#

#T=swf_modifyobject - void swf_modifyobject ( int depth, int how)
(PHP 4 <= 4.3.2)
swf_modifyobject -- Modify an object
Description
void swf_modifyobject ( int depth, int how)
Updates the position and/or color of the object at the specified depth, 
depth. The parameter how determines what is updated. how can either be the 
constant MOD_MATRIX or MOD_COLOR or it can be a combination of both 
(MOD_MATRIX|MOD_COLOR). 
MOD_COLOR uses the current mulcolor (specified by the function 
swf_mulcolor()) and addcolor (specified by the function swf_addcolor()) to 
color the object. MOD_MATRIX uses the current matrix to position the 
object.   swf_lookatUpswf_mulcolor
#

#T=void swf_modifyobject ( int depth, int how)
swf_modifyobject ( ^!int depth, int how);
#

#T=swf_mulcolor - void swf_mulcolor ( float r, float g, float b, float a)
(PHP 4 <= 4.3.2)
swf_mulcolor --  Sets the global multiply color to the rgba value 
specified 
Description
void swf_mulcolor ( float r, float g, float b, float a)
The swf_mulcolor() function sets the global multiply color to the rgba 
color specified. This color is then used (implicitly) by the 
swf_placeobject(), swf_modifyobject() and the swf_addbuttonrecord() 
functions. The color of the object will be multiplied by the rgba values 
when the object is written to the screen. 
Note: The rgba values can be either positive or negative.   swf_modifyobjectUpswf_nextid
#

#T=void swf_mulcolor ( float r, float g, float b, float a)
swf_mulcolor ( ^!float r, float g, float b, float a);
#

#T=swf_nextid - int swf_nextid ( void )
(PHP 4 <= 4.3.2)
swf_nextid -- Returns the next free object id
Description
int swf_nextid ( void )
The swf_nextid() function returns the next available object id.   swf_mulcolorUpswf_oncondition
#

#T=int swf_nextid ( void )
swf_nextid ( ^!void );
#

#T=swf_oncondition - void swf_oncondition ( int transition)
(PHP 4 <= 4.3.2)
swf_oncondition --  Describe a transition used to trigger an action list 
Description
void swf_oncondition ( int transition)
The swf_oncondition() function describes a transition that will trigger an 
action list. There are several types of possible transitions, the 
following are for buttons defined as TYPE_MENUBUTTON: 
IdletoOverUp 
OverUptoIdle 
OverUptoOverDown 
OverDowntoOverUp 
IdletoOverDown 
OutDowntoIdle 
MenuEnter (IdletoOverUp|IdletoOverDown) 
MenuExit (OverUptoIdle|OverDowntoIdle) 
For TYPE_PUSHBUTTON there are the following options: 
IdletoOverUp 
OverUptoIdle 
OverUptoOverDown 
OverDowntoOverUp 
OverDowntoOutDown 
OutDowntoOverDown 
OutDowntoIdle 
ButtonEnter (IdletoOverUp|OutDowntoOverDown) 
ButtonExit (OverUptoIdle|OverDowntoOutDown)   swf_nextidUpswf_openfile
#

#T=void swf_oncondition ( int transition)
swf_oncondition ( ^!int transition);
#

#T=swf_openfile - void swf_openfile ( string filename, float width, float height, float 
(PHP 4 <= 4.3.2)
swf_openfile -- Open a new Shockwave Flash file
Description
void swf_openfile ( string filename, float width, float height, float 
framerate, float r, float g, float b)
The swf_openfile() function opens a new file named filename with a width 
of width and a height of height a frame rate of framerate and background 
with a red color of r a green color of g and a blue color of b. 
The swf_openfile() must be the first function you call, otherwise your 
script will cause a segfault. If you want to send your output to the 
screen make the filename: "php://stdout" (support for this is in 4.0.1 and 
up).   swf_onconditionUpswf_ortho2
swf_ortho
(4.0.1 - 4.3.2 only)
swf_ortho --  Defines an orthographic mapping of user coordinates onto the 
current viewport 
Description
void swf_ortho ( float xmin, float xmax, float ymin, float ymax, float 
zmin, float zmax)
The swf_ortho() function defines an orthographic mapping of user 
coordinates onto the current viewport.   swf_ortho2Upswf_perspective
#

#T=void swf_openfile ( string filename, float width, float height, float 
swf_openfile ( ^!string filename, float width, float height, float ;
#

#T=swf_ortho2 - void swf_ortho2 ( float xmin, float xmax, float ymin, float ymax)
(PHP 4 <= 4.3.2)
swf_ortho2 --  Defines 2D orthographic mapping of user coordinates onto 
the current viewport 
Description
void swf_ortho2 ( float xmin, float xmax, float ymin, float ymax)
The swf_ortho2() function defines a two dimensional orthographic mapping 
of user coordinates onto the current viewport, this defaults to one to one 
mapping of the area of the Flash movie. If a perspective transformation is 
desired, the swf_perspective () function can be used.   swf_openfileUpswf_ortho
#

#T=void swf_ortho2 ( float xmin, float xmax, float ymin, float ymax)
swf_ortho2 ( ^!float xmin, float xmax, float ymin, float ymax);
#

#T=swf_perspective - void swf_perspective ( float fovy, float aspect, float near, float far)
(PHP 4 <= 4.3.2)
swf_perspective --  Define a perspective projection transformation 
Description
void swf_perspective ( float fovy, float aspect, float near, float far)
The swf_perspective() function defines a perspective projection 
transformation. The fovy parameter is field-of-view angle in the y 
direction. The aspect parameter should be set to the aspect ratio of the 
viewport that is being drawn onto. The near parameter is the near clipping 
plane and the far parameter is the far clipping plane. 
Note: Various distortion artifacts may appear when performing a 
perspective projection, this is because Flash players only have a two 
dimensional matrix. Some are not to pretty.   swf_orthoUpswf_placeobject
#

#T=void swf_perspective ( float fovy, float aspect, float near, float far)
swf_perspective ( ^!float fovy, float aspect, float near, float far);
#

#T=swf_placeobject - void swf_placeobject ( int objid, int depth)
(PHP 4 <= 4.3.2)
swf_placeobject -- Place an object onto the screen
Description
void swf_placeobject ( int objid, int depth)
Places the object specified by objid in the current frame at a depth of 
depth. The objid parameter and the depth must be between 1 and 65535. 
This uses the current mulcolor (specified by swf_mulcolor()) and the 
current addcolor (specified by swf_addcolor()) to color the object and it 
uses the current matrix to position the object. 
Note: Full RGBA colors are supported.   swf_perspectiveUpswf_polarview
#

#T=void swf_placeobject ( int objid, int depth)
swf_placeobject ( ^!int objid, int depth);
#

#T=swf_polarview - void swf_polarview ( float dist, float azimuth, float incidence, float 
(PHP 4 <= 4.3.2)
swf_polarview --  Define the viewer's position with polar coordinates 
Description
void swf_polarview ( float dist, float azimuth, float incidence, float 
twist)
The swf_polarview() function defines the viewer's position in polar 
coordinates. The dist parameter gives the distance between the viewpoint 
to the world space origin. The azimuth parameter defines the azimuthal 
angle in the x,y coordinate plane, measured in distance from the y axis. 
The incidence parameter defines the angle of incidence in the y,z plane, 
measured in distance from the z axis. The incidence angle is defined as 
the angle of the viewport relative to the z axis. Finally the twist 
specifies the amount that the viewpoint is to be rotated about the line of 
sight using the right hand rule.   swf_placeobjectUpswf_popmatrix
#

#T=void swf_polarview ( float dist, float azimuth, float incidence, float 
swf_polarview ( ^!float dist, float azimuth, float incidence, float ;
#

#T=swf_popmatrix - void swf_popmatrix ( void )
(PHP 4 <= 4.3.2)
swf_popmatrix --  Restore a previous transformation matrix 
Description
void swf_popmatrix ( void )
The swf_popmatrix() function pushes the current transformation matrix back 
onto the stack.   swf_polarviewUpswf_posround
#

#T=void swf_popmatrix ( void )
swf_popmatrix ( ^!void );
#

#T=swf_posround - void swf_posround ( int round)
(PHP 4 <= 4.3.2)
swf_posround --  Enables or Disables the rounding of the translation when 
objects are placed or moved 
Description
void swf_posround ( int round)
The swf_posround() function enables or disables the rounding of the 
translation when objects are placed or moved, there are times when text 
becomes more readable because rounding has been enabled. The round is 
whether to enable rounding or not, if set to the value of 1, then rounding 
is enabled, if set to 0 then rounding is disabled.   swf_popmatrixUpswf_pushmatrix
#

#T=void swf_posround ( int round)
swf_posround ( ^!int round);
#

#T=swf_pushmatrix - void swf_pushmatrix ( void )
(PHP 4 <= 4.3.2)
swf_pushmatrix --  Push the current transformation matrix back unto the 
stack 
Description
void swf_pushmatrix ( void )
The swf_pushmatrix() function pushes the current transformation matrix 
back onto the stack.   swf_posroundUpswf_removeobject
#

#T=void swf_pushmatrix ( void )
swf_pushmatrix ( ^!void );
#

#T=swf_removeobject - void swf_removeobject ( int depth)
(PHP 4 <= 4.3.2)
swf_removeobject -- Remove an object
Description
void swf_removeobject ( int depth)
Removes the object at the depth specified by depth.   swf_pushmatrixUpswf_rotate
#

#T=void swf_removeobject ( int depth)
swf_removeobject ( ^!int depth);
#

#T=swf_rotate - void swf_rotate ( float angle, string axis)
(PHP 4 <= 4.3.2)
swf_rotate -- Rotate the current transformation
Description
void swf_rotate ( float angle, string axis)
The swf_rotate() rotates the current transformation by the angle given by 
the angle parameter around the axis given by the axis parameter. Valid 
values for the axis are 'x' (the x axis), 'y' (the y axis) or 'z' (the z 
axis).   swf_removeobjectUpswf_scale
#

#T=void swf_rotate ( float angle, string axis)
swf_rotate ( ^!float angle, string axis);
#

#T=swf_scale - void swf_scale ( float x, float y, float z)
(PHP 4 <= 4.3.2)
swf_scale -- Scale the current transformation
Description
void swf_scale ( float x, float y, float z)
The swf_scale() scales the x coordinate of the curve by the value of the x 
parameter, the y coordinate of the curve by the value of the y parameter, 
and the z coordinate of the curve by the value of the z parameter.   swf_rotateUpswf_setfont
#

#T=void swf_scale ( float x, float y, float z)
swf_scale ( ^!float x, float y, float z);
#

#T=swf_setfont - void swf_setfont ( int fontid)
(PHP 4 <= 4.3.2)
swf_setfont -- Change the current font
Description
void swf_setfont ( int fontid)
The swf_setfont() sets the current font to the value given by the fontid 
parameter.   swf_scaleUpswf_setframe
#

#T=void swf_setfont ( int fontid)
swf_setfont ( ^!int fontid);
#

#T=swf_setframe - void swf_setframe ( int framenumber)
(PHP 4 <= 4.3.2)
swf_setframe -- Switch to a specified frame
Description
void swf_setframe ( int framenumber)
The swf_setframe() changes the active frame to the frame specified by 
framenumber.   swf_setfontUpswf_shapearc
#

#T=void swf_setframe ( int framenumber)
swf_setframe ( ^!int framenumber);
#

#T=swf_shapearc - void swf_shapearc ( float x, float y, float r, float ang1, float ang2)
(PHP 4 <= 4.3.2)
swf_shapearc -- Draw a circular arc
Description
void swf_shapearc ( float x, float y, float r, float ang1, float ang2)
The swf_shapearc() function draws a circular arc from angle A given by the 
ang1 parameter to angle B given by the ang2 parameter. The center of the 
circle has an x coordinate given by the x parameter and a y coordinate 
given by the y, the radius of the circle is given by the r parameter.   swf_setframeUpswf_shapecurveto3
#

#T=void swf_shapearc ( float x, float y, float r, float ang1, float ang2)
swf_shapearc ( ^!float x, float y, float r, float ang1, float ang2);
#

#T=swf_shapecurveto - void swf_shapecurveto ( float x1, float y1, float x2, float y2)
(PHP 4 <= 4.3.2)
swf_shapecurveto --  Draw a quadratic bezier curve between two points 
Description
void swf_shapecurveto ( float x1, float y1, float x2, float y2)
The swf_shapecurveto() function draws a quadratic bezier curve from the 
current location, though the x coordinate given by x1 and the y coordinate 
given by y1 to the x coordinate given by x2 and the y coordinate given by 
y2. The current position is then set to the x,y coordinates given by the 
x2 and y2 parameters   swf_shapecurveto3Upswf_shapefillbitmapclip
#

#T=void swf_shapecurveto ( float x1, float y1, float x2, float y2)
swf_shapecurveto ( ^!float x1, float y1, float x2, float y2);
#

#T=swf_shapecurveto3 - void swf_shapecurveto3 ( float x1, float y1, float x2, float y2, float x3, 
(PHP 4 <= 4.3.2)
swf_shapecurveto3 -- Draw a cubic bezier curve
Description
void swf_shapecurveto3 ( float x1, float y1, float x2, float y2, float x3, 
float y3)
Draw a cubic bezier curve using the x,y coordinate pairs x1, y1 and x2,y2 
as off curve control points and the x,y coordinate x3, y3 as an endpoint. 
The current position is then set to the x,y coordinate pair given by 
x3,y3.   swf_shapearcUpswf_shapecurveto
#

#T=void swf_shapecurveto3 ( float x1, float y1, float x2, float y2, float x3, 
swf_shapecurveto3 ( ^!float x1, float y1, float x2, float y2, float x3, ;
#

#T=swf_shapefillbitmapclip - void swf_shapefillbitmapclip ( int bitmapid)
(PHP 4 <= 4.3.2)
swf_shapefillbitmapclip --  Set current fill mode to clipped bitmap 
Description
void swf_shapefillbitmapclip ( int bitmapid)
Sets the fill to bitmap clipped, empty spaces will be filled by the bitmap 
given by the bitmapid parameter.   swf_shapecurvetoUpswf_shapefillbitmaptile
#

#T=void swf_shapefillbitmapclip ( int bitmapid)
swf_shapefillbitmapclip ( ^!int bitmapid);
#

#T=swf_shapefillbitmaptile - void swf_shapefillbitmaptile ( int bitmapid)
(PHP 4 <= 4.3.2)
swf_shapefillbitmaptile --  Set current fill mode to tiled bitmap 
Description
void swf_shapefillbitmaptile ( int bitmapid)
Sets the fill to bitmap tile, empty spaces will be filled by the bitmap 
given by the bitmapid parameter (tiled).   swf_shapefillbitmapclipUpswf_shapefilloff
#

#T=void swf_shapefillbitmaptile ( int bitmapid)
swf_shapefillbitmaptile ( ^!int bitmapid);
#

#T=swf_shapefilloff - void swf_shapefilloff ( void )
(PHP 4 <= 4.3.2)
swf_shapefilloff -- Turns off filling
Description
void swf_shapefilloff ( void )
The swf_shapefilloff() function turns off filling for the current shape.   swf_shapefillbitmaptileUpswf_shapefillsolid
#

#T=void swf_shapefilloff ( void )
swf_shapefilloff ( ^!void );
#

#T=swf_shapefillsolid - void swf_shapefillsolid ( float r, float g, float b, float a)
(PHP 4 <= 4.3.2)
swf_shapefillsolid --  Set the current fill style to the specified color 
Description
void swf_shapefillsolid ( float r, float g, float b, float a)
The swf_shapefillsolid() function sets the current fill style to solid, 
and then sets the fill color to the values of the rgba parameters.   swf_shapefilloffUpswf_shapelinesolid
#

#T=void swf_shapefillsolid ( float r, float g, float b, float a)
swf_shapefillsolid ( ^!float r, float g, float b, float a);
#

#T=swf_shapelinesolid - void swf_shapelinesolid ( float r, float g, float b, float a, float width)
(PHP 4 <= 4.3.2)
swf_shapelinesolid -- Set the current line style
Description
void swf_shapelinesolid ( float r, float g, float b, float a, float width)
The swf_shapelinesolid() function sets the current line style to the color 
of the rgba parameters and width to the width parameter. If 0.0 is given 
as a width then no lines are drawn.   swf_shapefillsolidUpswf_shapelineto
#

#T=void swf_shapelinesolid ( float r, float g, float b, float a, float width)
swf_shapelinesolid ( ^!float r, float g, float b, float a, float width);
#

#T=swf_shapelineto - void swf_shapelineto ( float x, float y)
(PHP 4 <= 4.3.2)
swf_shapelineto -- Draw a line
Description
void swf_shapelineto ( float x, float y)
The swf_shapelineto() draws a line to the x,y coordinates given by the x 
parameter & the y parameter. The current position is then set to the x,y 
parameters.   swf_shapelinesolidUpswf_shapemoveto
#

#T=void swf_shapelineto ( float x, float y)
swf_shapelineto ( ^!float x, float y);
#

#T=swf_shapemoveto - void swf_shapemoveto ( float x, float y)
(PHP 4 <= 4.3.2)
swf_shapemoveto -- Move the current position
Description
void swf_shapemoveto ( float x, float y)
The swf_shapemoveto() function moves the current position to the x 
coordinate given by the x parameter and the y position given by the y 
parameter.   swf_shapelinetoUpswf_showframe
#

#T=void swf_shapemoveto ( float x, float y)
swf_shapemoveto ( ^!float x, float y);
#

#T=swf_showframe - void swf_showframe ( void )
(PHP 4 <= 4.3.2)
swf_showframe -- Display the current frame
Description
void swf_showframe ( void )
The swf_showframe function will output the current frame.   swf_shapemovetoUpswf_startbutton
#

#T=void swf_showframe ( void )
swf_showframe ( ^!void );
#

#T=swf_startbutton - void swf_startbutton ( int objid, int type)
(PHP 4 <= 4.3.2)
swf_startbutton -- Start the definition of a button
Description
void swf_startbutton ( int objid, int type)
The swf_startbutton() function starts off the definition of a button. The 
type parameter can either be TYPE_MENUBUTTON or TYPE_PUSHBUTTON. The 
TYPE_MENUBUTTON constant allows the focus to travel from the button when 
the mouse is down, TYPE_PUSHBUTTON does not allow the focus to travel when 
the mouse is down.   swf_showframeUpswf_startdoaction
#

#T=void swf_startbutton ( int objid, int type)
swf_startbutton ( ^!int objid, int type);
#

#T=swf_startdoaction - 
Descriptio
(PHP 4 <= 4.3.2)
swf_startdoaction --  Start a description of an action list for the 
current frame 
Description
void swf_startdoaction ( void )
The swf_startdoaction() function starts the description of an action list 
for the current frame. This must be called before actions are defined for 
the current frame.   swf_startbuttonUpswf_startshape
#

#T=
Descriptio

;
^!#

#T=swf_startshape - void swf_startshape ( int objid)
(PHP 4 <= 4.3.2)
swf_startshape -- Start a complex shape
Description
void swf_startshape ( int objid)
The swf_startshape() function starts a complex shape, with an object id 
given by the objid parameter.   swf_startdoactionUpswf_startsymbol
#

#T=void swf_startshape ( int objid)
swf_startshape ( ^!int objid);
#

#T=swf_startsymbol - void swf_startsymbol ( int objid)
(PHP 4 <= 4.3.2)
swf_startsymbol -- Define a symbol
Description
void swf_startsymbol ( int objid)
Define an object id as a symbol. Symbols are tiny flash movies that can be 
played simultaneously. The objid parameter is the object id you want to 
define as a symbol.   swf_startshapeUpswf_textwidth
#

#T=void swf_startsymbol ( int objid)
swf_startsymbol ( ^!int objid);
#

#T=swf_textwidth - float swf_textwidth ( string str)
(PHP 4 <= 4.3.2)
swf_textwidth -- Get the width of a string
Description
float swf_textwidth ( string str)
The swf_textwidth() function gives the width of the string, str, in 
pixels, using the current font and font size.   swf_startsymbolUpswf_translate
#

#T=float swf_textwidth ( string str)
swf_textwidth ( ^!string str);
#

#T=swf_translate - void swf_translate ( float x, float y, float z)
(PHP 4 <= 4.3.2)
swf_translate -- Translate the current transformations
Description
void swf_translate ( float x, float y, float z)
The swf_translate() function translates the current transformation by the 
x, y, and z values given.   swf_textwidthUpswf_viewport
#

#T=void swf_translate ( float x, float y, float z)
swf_translate ( ^!float x, float y, float z);
#

#T=swf_viewport - void swf_viewport ( float xmin, float xmax, float ymin, float ymax)
(PHP 4 <= 4.3.2)
swf_viewport -- Select an area for future drawing
Description
void swf_viewport ( float xmin, float xmax, float ymin, float ymax)
The swf_viewport() function selects an area for future drawing for xmin to 
xmax and ymin to ymax, if this function is not called the area defaults to 
the size of the screen.   swf_translateUpSNMP functions
#

#T=void swf_viewport ( float xmin, float xmax, float ymin, float ymax)
swf_viewport ( ^!float xmin, float xmax, float ymin, float ymax);
#

#T=SWFAction - new swfaction ( string script)
(PHP 4 >= 4.0.5)
SWFAction -- Creates a new Action.
Description
new swfaction ( string script)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfaction() creates a new Action, and compiles the given script into an 
SWFAction object. 
The script syntax is based on the C language, but with a lot taken out- 
the SWF bytecode machine is just too simpleminded to do a lot of things we 
might like. For instance, we can't implement function calls without a 
tremendous amount of hackery because the jump bytecode has a hardcoded 
offset value. No pushing your calling address to the stack and returning- 
every function would have to know exactly where to return to. 
So what's left? The compiler recognises the following tokens: 
break 
for 
continue 
if 
else 
do 
while 
There is no typed data; all values in the SWF action machine are stored as 
strings. The following functions can be used in expressions: 
time()
Returns the number of milliseconds (?) elapsed since the movie started. 
random(seed)
Returns a pseudo-random number in the range 0-seed. 
length(expr)
Returns the length of the given expression. 
int(number)
Returns the given number rounded down to the nearest integer. 
concat(expr, expr)
Returns the concatenation of the given expressions. 
ord(expr)
Returns the ASCII code for the given character 
chr(num)
Returns the character for the given ASCII code 
substr(string, location, length)
Returns the substring of length length at location location of the given 
string string. 
Additionally, the following commands may be used: 
duplicateClip(clip, name, depth)
Duplicate the named movie clip (aka sprite). The new movie clip has name 
name and is at depth depth. 
removeClip(expr)
Removes the named movie clip. 
trace(expr)
Write the given expression to the trace log. Doubtful that the browser 
plugin does anything with this. 
startDrag(target, lock, [left, top, right, bottom])
Start dragging the movie clip target. The lock argument indicates 
whether to lock the mouse (?)- use 0 (FALSE) or 1 (TRUE). Optional 
parameters define a bounding area for the dragging. 
stopDrag()
Stop dragging my heart around. And this movie clip, too. 
callFrame(expr)
Call the named frame as a function. 
getURL(url, target, [method])
Load the given URL into the named target. The target argument 
corresponds to HTML document targets (such as "_top" or "_blank"). The 
optional method argument can be POST or GET if you want to submit 
variables back to the server. 
loadMovie(url, target)
Load the given URL into the named target. The target argument can be a 
frame name (I think), or one of the magical values "_level0" (replaces 
current movie) or "_level1" (loads new movie on top of current movie). 
nextFrame()
Go to the next frame. 
prevFrame()
Go to the last (or, rather, previous) frame. 
play()
Start playing the movie. 
stop()
Stop playing the movie. 
toggleQuality()
Toggle between high and low quality. 
stopSounds()
Stop playing all sounds. 
gotoFrame(num)
Go to frame number num. Frame numbers start at 0. 
gotoFrame(name)
Go to the frame named name. Which does a lot of good, since I haven't 
added frame labels yet. 
setTarget(expr)
Sets the context for action. Or so they say- I really have no idea what 
this does. 
And there's one weird extra thing. The expression frameLoaded(num) can be 
used in if statements and while loops to check if the given frame number 
has been loaded yet. Well, it's supposed to, anyway, but I've never tested 
it and I seriously doubt it actually works. You can just use 
/:framesLoaded instead. 
Movie clips (all together now- aka sprites) have properties. You can read 
all of them (or can you?), you can set some of them, and here they are: 
x 
y 
xScale 
yScale 
currentFrame - (read-only) 
totalFrames - (read-only) 
alpha - transparency level 
visible - 1=on, 0=off (?) 
width - (read-only) 
height - (read-only) 
rotation 
target - (read-only) (???) 
framesLoaded - (read-only) 
name 
dropTarget - (read-only) (???) 
url - (read-only) (???) 
highQuality - 1=high, 0=low (?) 
focusRect - (???) 
soundBufTime - (???) 
So, setting a sprite's x position is as simple as /box.x = 100;. Why the 
slash in front of the box, though? That's how flash keeps track of the 
sprites in the movie, just like a Unix filesystem- here it shows that box 
is at the top level. If the sprite named box had another sprite named biff 
inside of it, you'd set its x position with /box/biff.x = 100;. At least, 
I think so; correct me if I'm wrong here. 
This simple example will move the red square across the window. 
Example 1. swfaction() example
  <?php
    $s = new SWFShape();
    $f = $s->addFill(0xff, 0, 0);
    $s->setRightFill($f);

    $s->movePenTo(-500, -500);
    $s->drawLineTo(500, -500);
    $s->drawLineTo(500, 500);
    $s->drawLineTo(-500, 500);
    $s->drawLineTo(-500, -500);

    $p = new SWFSprite();
    $i = $p->add($s);
    $i->setDepth(1);
    $p->nextFrame();

    for ($n=0; $n<5; ++$n) {
      $i->rotate(-15);
      $p->nextFrame();
    }

    $m = new SWFMovie();
    $m->setBackground(0xff, 0xff, 0xff);
    $m->setDimension(6000, 4000);

    $i = $m->add($p);
    $i->setDepth(1);
    $i->moveTo(-500,2000);
    $i->setName("box");

    $m->add(new SWFAction("/box.x += 3;"));
    $m->nextFrame();
    $m->add(new SWFAction("gotoFrame(0); play();"));
    $m->nextFrame();

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 
This simple example tracks down your mouse on the screen. Example 2. 
swfaction() example
  <?php

    $m = new SWFMovie();
    $m->setRate(36.0);
    $m->setDimension(1200, 800);
    $m->setBackground(0, 0, 0);

    /* mouse tracking sprite - empty, but follows mouse so we 
can
       get its x and y coordinates */

    $i = $m->add(new SWFSprite());
    $i->setName('mouse');

    $m->add(new SWFAction("
      startDrag('/mouse', 1); /* '1' means lock sprite to the 
  mouse */
    "));

    /* might as well turn off antialiasing, since these are just 
  squares. */

    $m->add(new SWFAction("
      this.quality = 0;
    "));

    /* morphing box */
    $r = new SWFMorph();
    $s = $r->getShape1();

    /* Note this is backwards from normal shapes.  No idea why. 
  */
    $s->setLeftFill($s->addFill(0xff, 0xff, 0xff));
    $s->movePenTo(-40, -40);
    $s->drawLine(80, 0);
    $s->drawLine(0, 80);
    $s->drawLine(-80, 0);
    $s->drawLine(0, -80);

    $s = $r->getShape2();

    $s->setLeftFill($s->addFill(0x00, 0x00, 0x00));
    $s->movePenTo(-1, -1);
    $s->drawLine(2, 0);
    $s->drawLine(0, 2);
    $s->drawLine(-2, 0);
    $s->drawLine(0, -2);

    /* sprite container for morphing box -
       this is just a timeline w/ the box morphing */

    $box = new SWFSprite();
    $box->add(new SWFAction("
      stop();
    "));
    $i = $box->add($r);

    for ($n=0; $n<=20; ++$n) {
      $i->setRatio($n/20);
      $box->nextFrame();
    }

    /* this container sprite allows us to use the same action 
  code many times */

    $cell = new SWFSprite();
    $i = $cell->add($box);
    $i->setName('box');

    $cell->add(new SWFAction("

      setTarget('box');

      /* ...x means the x coordinate of the parent, i.e. (..).x 
  */
      dx = (/mouse.x + random(6)-3 - ...x)/5;
      dy = (/mouse.y + random(6)-3 - ...y)/5;
      gotoFrame(int(dx*dx + dy*dy));

    "));

    $cell->nextFrame();
    $cell->add(new SWFAction("

      gotoFrame(0);
      play();

    "));

    $cell->nextFrame();

    /* finally, add a bunch of the cells to the movie */

    for ($x=0; $x<12; ++$x) {
      for ($y=0; $y<8; ++$y) {
	$i = $m->add($cell);
	$i->moveTo(100*$x+50, 100*$y+50);
      }
    }

    $m->nextFrame();

    $m->add(new SWFAction("

      gotoFrame(1);
      play();

    "));

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 
Same as above, but with nice colored balls... Example 3. swfaction() 
example
  <?php

    $m = new SWFMovie();
    $m->setDimension(11000, 8000);
    $m->setBackground(0x00, 0x00, 0x00);

    $m->add(new SWFAction("

  this.quality = 0;
  /frames.visible = 0;
  startDrag('/mouse', 1);

    "));

    // mouse tracking sprite
    $t = new SWFSprite();
    $i = $m->add($t);
    $i->setName('mouse');

    $g = new SWFGradient();
    $g->addEntry(0, 0xff, 0xff, 0xff, 0xff);
    $g->addEntry(0.1, 0xff, 0xff, 0xff, 0xff);
    $g->addEntry(0.5, 0xff, 0xff, 0xff, 0x5f);
    $g->addEntry(1.0, 0xff, 0xff, 0xff, 0);

    // gradient shape thing
    $s = new SWFShape();
    $f = $s->addFill($g, SWFFILL_RADIAL_GRADIENT);
    $f->scaleTo(0.03);
    $s->setRightFill($f);
    $s->movePenTo(-600, -600);
    $s->drawLine(1200, 0);
    $s->drawLine(0, 1200);
    $s->drawLine(-1200, 0);
    $s->drawLine(0, -1200);

    // need to make this a sprite so we can multColor it
    $p = new SWFSprite();
    $p->add($s);
    $p->nextFrame();

    // put the shape in here, each frame a different color
    $q = new SWFSprite();
    $q->add(new SWFAction("gotoFrame(random(7)+1); stop();"));
    $i = $q->add($p);

    $i->multColor(1.0, 1.0, 1.0);
    $q->nextFrame();
    $i->multColor(1.0, 0.5, 0.5);
    $q->nextFrame();
    $i->multColor(1.0, 0.75, 0.5);
    $q->nextFrame();
    $i->multColor(1.0, 1.0, 0.5);
    $q->nextFrame();
    $i->multColor(0.5, 1.0, 0.5);
    $q->nextFrame();
    $i->multColor(0.5, 0.5, 1.0);
    $q->nextFrame();
    $i->multColor(1.0, 0.5, 1.0);
    $q->nextFrame();

    // finally, this one contains the action code
    $p = new SWFSprite();
    $i = $p->add($q);
    $i->setName('frames');
    $p->add(new SWFAction("

  dx = (/:mousex-/:lastx)/3 + random(10)-5;
  dy = (/:mousey-/:lasty)/3;
  x = /:mousex;
  y = /:mousey;
  alpha = 100;

    "));
    $p->nextFrame();

    $p->add(new SWFAction("

  this.x = x;
  this.y = y;
  this.alpha = alpha;
  x += dx;
  y += dy;
  dy += 3;
  alpha -= 8;

    "));
    $p->nextFrame();

    $p->add(new SWFAction("prevFrame(); play();"));
    $p->nextFrame();

    $i = $m->add($p);
    $i->setName('frames');
    $m->nextFrame();

    $m->add(new SWFAction("

  lastx = mousex;
  lasty = mousey;
  mousex = /mouse.x;
  mousey = /mouse.y;

  ++num;

  if (num == 11)
    num = 1;

  removeClip('char' & num);
  duplicateClip(/frames, 'char' & num, num);

    "));

    $m->nextFrame();
    $m->add(new SWFAction("prevFrame(); play();"));

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  ming_useswfversionUpSWFBitmap->getHeight
SWFBitmap->getHeight
(no version information, might be only in CVS)
SWFBitmap->getHeight -- Returns the bitmap's height.
Description
int swfbitmap->getheight ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbitmap->getheight() returns the bitmap's height in pixels. 
See also swfbitmap->getwidth().   SWFActionUpSWFBitmap->getWidth
SWFBitmap->getWidth
(no version information, might be only in CVS)
SWFBitmap->getWidth -- Returns the bitmap's width.
Description
int swfbitmap->getwidth ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbitmap->getwidth() returns the bitmap's width in pixels. 
See also swfbitmap->getheight().   SWFBitmap->getHeightUpSWFBitmap
#

#T=new swfaction ( string script)
swfaction ( ^!string script);
#

#T=SWFBitmap - new swfbitmap ( string filename [, int alphafilename])
(PHP 4 >= 4.0.5)
SWFBitmap -- Loads Bitmap object
Description
new swfbitmap ( string filename [, int alphafilename])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbitmap() creates a new SWFBitmap object from the Jpeg or DBL file named 
filename. alphafilename indicates a MSK file to be used as an alpha mask 
for a Jpeg image. 
Note: We can only deal with baseline (frame 0) jpegs, no baseline 
optimized or progressive scan jpegs! 
SWFBitmap has the following methods : swfbitmap->getwidth() and 
swfbitmap->getheight(). 
You can't import png images directly, though- have to use the png2dbl 
utility to make a dbl ("define bits lossless") file from the png. The 
reason for this is that I don't want a dependency on the png library in 
ming- autoconf should solve this, but that's not set up yet. Example 
1. Import PNG files
  <?php
    $s = new SWFShape();
    $f = $s->addFill(new SWFBitmap("png.dbl"));
    $s->setRightFill($f);

    $s->drawLine(32, 0);
    $s->drawLine(0, 32);
    $s->drawLine(-32, 0);
    $s->drawLine(0, -32);

    $m = new SWFMovie();
    $m->setDimension(32, 32);
    $m->add($s);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 
And you can put an alpha mask on a jpeg fill. Example 2. swfbitmap() 
example
  <?php

    $s = new SWFShape();

    // .msk file generated with "gif2mask" utility
    $f = $s->addFill(new SWFBitmap("alphafill.jpg", 
  "alphafill.msk"));
    $s->setRightFill($f);

    $s->drawLine(640, 0);
    $s->drawLine(0, 480);
    $s->drawLine(-640, 0);
    $s->drawLine(0, -480);

    $c = new SWFShape();
    $c->setRightFill($c->addFill(0x99, 0x99, 0x99));
    $c->drawLine(40, 0);
    $c->drawLine(0, 40);
    $c->drawLine(-40, 0);
    $c->drawLine(0, -40);

    $m = new SWFMovie();
    $m->setDimension(640, 480);
    $m->setBackground(0xcc, 0xcc, 0xcc);

    // draw checkerboard background
    for ($y=0; $y<480; $y+=40) {
      for ($x=0; $x<640; $x+=80) {
	$i = $m->add($c);
	$i->moveTo($x, $y);
      }

      $y+=40;

      for ($x=40; $x<640; $x+=80) {
	$i = $m->add($c);
	$i->moveTo($x, $y);
      }
    }

    $m->add($s);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFBitmap->getWidthUpswfbutton_keypress
#

#T=new swfbitmap ( string filename [, int alphafilename])
swfbitmap ( ^!string filename [, int alphafilename]);
#

#T=swfbutton_keypress - int swfbutton_keypress ( string str)
(PHP 4 >= 4.0.5)
swfbutton_keypress --  Returns the action flag for keyPress(char) 
Description
int swfbutton_keypress ( string str)
Warning
This function is currently not documented; only the argument list is 
available.
  SWFBitmapUpSWFbutton->addAction
SWFbutton->addAction
(no version information, might be only in CVS)
SWFbutton->addAction -- Adds an action
Description
void swfbutton->addaction ( resource action, int flags)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton->addaction() adds the action action to this button for the given 
conditions. The following flags are valid: SWFBUTTON_MOUSEOVER, 
SWFBUTTON_MOUSEOUT, SWFBUTTON_MOUSEUP, SWFBUTTON_MOUSEUPOUTSIDE, 
SWFBUTTON_MOUSEDOWN, SWFBUTTON_DRAGOUT and SWFBUTTON_DRAGOVER. 
See also swfbutton->addshape() and swfaction().   swfbutton_keypressUpSWFbutton->addShape
SWFbutton->addShape
(no version information, might be only in CVS)
SWFbutton->addShape -- Adds a shape to a button
Description
void swfbutton->addshape ( resource shape, int flags)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton->addshape() adds the shape shape to this button. The following 
flags' values are valid: SWFBUTTON_UP, SWFBUTTON_OVER, SWFBUTTON_DOWN or 
SWFBUTTON_HIT. SWFBUTTON_HIT isn't ever displayed, it defines the hit 
region for the button. That is, everywhere the hit shape would be drawn is 
considered a "touchable" part of the button.   SWFbutton->addActionUpSWFbutton->setAction
#

#T=int swfbutton_keypress ( string str)
swfbutton_keypress ( ^!string str);
#

#T=SWFbutton - new swfbutton ( void )
(PHP 4 >= 4.0.5)
SWFbutton -- Creates a new Button.
Description
new swfbutton ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton() creates a new Button. Roll over it, click it, see it call 
action code. Swank. 
SWFButton has the following methods : swfbutton->addshape(), 
swfbutton->setup(), swfbutton->setover() swfbutton->setdown(), 
swfbutton->sethit() swfbutton->setaction() and swfbutton->addaction(). 
This simple example will show your usual interactions with buttons : 
rollover, rollon, mouseup, mousedown, noaction. Example 1. 
swfbutton() example
  <?php

    $f = new SWFFont("_serif");

    $p = new SWFSprite();

    function label($string) {
      global $f;

      $t = new SWFTextField();
      $t->setFont($f);
      $t->addString($string);
      $t->setHeight(200);
      $t->setBounds(3200, 200);
      return $t;
    }
    
    function addLabel($string) {
      global $p;

      $i = $p->add(label($string));
      $p->nextFrame();
      $p->remove($i);
    }

    $p->add(new SWFAction("stop();"));
    addLabel("NO ACTION");
    addLabel("SWFBUTTON_MOUSEUP");
    addLabel("SWFBUTTON_MOUSEDOWN");
    addLabel("SWFBUTTON_MOUSEOVER");
    addLabel("SWFBUTTON_MOUSEOUT");
    addLabel("SWFBUTTON_MOUSEUPOUTSIDE");
    addLabel("SWFBUTTON_DRAGOVER");
    addLabel("SWFBUTTON_DRAGOUT");

    function rect($r, $g, $b) {
      $s = new SWFShape();
      $s->setRightFill($s->addFill($r, $g, $b));
      $s->drawLine(600, 0);
      $s->drawLine(0, 600);
      $s->drawLine(-600, 0);
      $s->drawLine(0, -600);

      return $s;
    }

    $b = new SWFButton();
    $b->addShape(rect(0xff, 0, 0), SWFBUTTON_UP | 
SWFBUTTON_HIT);
    $b->addShape(rect(0, 0xff, 0), SWFBUTTON_OVER);
    $b->addShape(rect(0, 0, 0xff), SWFBUTTON_DOWN);

    $b->addAction(new SWFAction("setTarget('/label'); 
  gotoFrame(1);"),
	      SWFBUTTON_MOUSEUP);

    $b->addAction(new SWFAction("setTarget('/label'); 
  gotoFrame(2);"),
	  SWFBUTTON_MOUSEDOWN);

    $b->addAction(new SWFAction("setTarget('/label'); 
  gotoFrame(3);"),
	  SWFBUTTON_MOUSEOVER);

    $b->addAction(new SWFAction("setTarget('/label'); 
  gotoFrame(4);"),
	  SWFBUTTON_MOUSEOUT);

    $b->addAction(new SWFAction("setTarget('/label'); 
  gotoFrame(5);"),
	  SWFBUTTON_MOUSEUPOUTSIDE);

    $b->addAction(new SWFAction("setTarget('/label'); 
  gotoFrame(6);"),
	  SWFBUTTON_DRAGOVER);

    $b->addAction(new SWFAction("setTarget('/label'); 
  gotoFrame(7);"),
	  SWFBUTTON_DRAGOUT);

    $m = new SWFMovie();
    $m->setDimension(4000, 3000);

    $i = $m->add($p);
    $i->setName("label");
    $i->moveTo(400, 1900);

    $i = $m->add($b);
    $i->moveTo(400, 900);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 
This simple example will enables you to drag draw a big red button on the 
windows. No drag-and-drop, just moving around. Example 2. 
swfbutton->addaction() example
  <?php

    $s = new SWFShape();
    $s->setRightFill($s->addFill(0xff, 0, 0));
    $s->drawLine(1000,0);
    $s->drawLine(0,1000);
    $s->drawLine(-1000,0);
    $s->drawLine(0,-1000);

    $b = new SWFButton();
    $b->addShape($s, SWFBUTTON_HIT | SWFBUTTON_UP | 
  SWFBUTTON_DOWN | SWFBUTTON_OVER);

    $b->addAction(new SWFAction("startDrag('/test', 0);"), // 
  '0' means don't lock to mouse
	  SWFBUTTON_MOUSEDOWN);

    $b->addAction(new SWFAction("stopDrag();"),
	  SWFBUTTON_MOUSEUP | SWFBUTTON_MOUSEUPOUTSIDE);

    $p = new SWFSprite();
    $p->add($b);
    $p->nextFrame();

    $m = new SWFMovie();
    $i = $m->add($p);
    $i->setName('test');
    $i->moveTo(1000,1000);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFbutton->setUpUpSWFDisplayItem->addColor
SWFbutton->setAction
(no version information, might be only in CVS)
SWFbutton->setAction -- Sets the action
Description
void swfbutton->setaction ( resource action)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton->setaction() sets the action to be performed when the button is 
clicked. Alias for addAction(shape, SWFBUTTON_MOUSEUP). action is a 
swfaction(). 
See also swfbutton->addshape() and swfaction().   SWFbutton->addShapeUpSWFbutton->setdown
SWFbutton->setdown
(no version information, might be only in CVS)
SWFbutton->setdown -- Alias for addShape(shape, SWFBUTTON_DOWN))
Description
void swfbutton->setdown ( resource shape)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton->setdown() alias for addShape(shape, SWFBUTTON_DOWN). 
See also swfbutton->addshape() and swfaction().   SWFbutton->setActionUpSWFbutton->setHit
SWFbutton->setHit
(no version information, might be only in CVS)
SWFbutton->setHit -- Alias for addShape(shape, SWFBUTTON_HIT)
Description
void swfbutton->sethit ( resource shape)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton->sethit() alias for addShape(shape, SWFBUTTON_HIT). 
See also swfbutton->addshape() and swfaction().   SWFbutton->setdownUpSWFbutton->setOver
SWFbutton->setOver
(no version information, might be only in CVS)
SWFbutton->setOver -- Alias for addShape(shape, SWFBUTTON_OVER)
Description
void swfbutton->setover ( resource shape)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton->setover() alias for addShape(shape, SWFBUTTON_OVER). 
See also swfbutton->addshape() and swfaction().   SWFbutton->setHitUpSWFbutton->setUp
SWFbutton->setUp
(no version information, might be only in CVS)
SWFbutton->setUp -- Alias for addShape(shape, SWFBUTTON_UP)
Description
void swfbutton->setup ( resource shape)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfbutton->setup() alias for addShape(shape, SWFBUTTON_UP). 
See also swfbutton->addshape() and swfaction().   SWFbutton->setOverUpSWFbutton
SWFDisplayItem->addColor
(no version information, might be only in CVS)
SWFDisplayItem->addColor -- Adds the given color to this item's color 
transform.
Description
void swfdisplayitem->addcolor ( [int red [, int green [, int blue [, int 
a]]]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->addcolor() adds the color to this item's color transform. 
The color is given in its RGB form. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add().   SWFbuttonUpSWFDisplayItem->move
SWFDisplayItem
(no version information, might be only in CVS)
SWFDisplayItem -- Creates a new displayitem object.
Description
new swfdisplayitem ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem() creates a new swfdisplayitem object. 
Here's where all the animation takes place. After you define a shape, a 
text object, a sprite, or a button, you add it to the movie, then use the 
returned handle to move, rotate, scale, or skew the thing. 
SWFDisplayItem has the following methods : swfdisplayitem->move(), 
swfdisplayitem->moveto(), swfdisplayitem->scaleto(), 
swfdisplayitem->scale(), swfdisplayitem->rotate(), 
swfdisplayitem->rotateto(), swfdisplayitem->skewxto(), 
swfdisplayitem->skewx(), swfdisplayitem->skewyto() 
swfdisplayitem->skewyto(), swfdisplayitem->setdepth() 
swfdisplayitem->remove(), swfdisplayitem->setname() 
swfdisplayitem->setratio(), swfdisplayitem->addcolor() and 
swfdisplayitem->multcolor().   SWFDisplayItem->skewYToUpSWFFill->moveTo
SWFDisplayItem->move
(no version information, might be only in CVS)
SWFDisplayItem->move -- Moves object in relative coordinates.
Description
void swfdisplayitem->move ( int dx, int dy)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->move() moves the current object by (dx,dy) from its 
current position. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->moveto().   SWFDisplayItem->addColorUpSWFDisplayItem->moveTo
SWFDisplayItem->moveTo
(no version information, might be only in CVS)
SWFDisplayItem->moveTo -- Moves object in global coordinates.
Description
void swfdisplayitem->moveto ( int x, int y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->moveto() moves the current object to (x,y) in global 
coordinates. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->move().   SWFDisplayItem->moveUpSWFDisplayItem->multColor
SWFDisplayItem->multColor
(no version information, might be only in CVS)
SWFDisplayItem->multColor -- Multiplies the item's color transform.
Description
void swfdisplayitem->multcolor ( [int red [, int green [, int blue [, int 
a]]]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->multcolor() multiplies the item's color transform by the 
given values. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
This simple example will modify your picture's atmospher to Halloween (use 
a landscape or bright picture). Example 1. 
swfdisplayitem->multcolor() example
  <?php

    $b = new SWFBitmap("backyard.jpg");
    // note use your own picture :-)
    $s = new SWFShape();
    $s->setRightFill($s->addFill($b));
    $s->drawLine($b->getWidth(), 0);
    $s->drawLine(0, $b->getHeight());
    $s->drawLine(-$b->getWidth(), 0);
    $s->drawLine(0, -$b->getHeight());

    $m = new SWFMovie();
    $m->setDimension($b->getWidth(), $b->getHeight());

    $i = $m->add($s);

    for ($n=0; $n<=20; ++$n) {
      $i->multColor(1.0-$n/10, 1.0, 1.0);
      $i->addColor(0xff*$n/20, 0, 0);
      $m->nextFrame();
    }

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFDisplayItem->moveToUpSWFDisplayItem->remove
SWFDisplayItem->remove
(no version information, might be only in CVS)
SWFDisplayItem->remove -- Removes the object from the movie
Description
void swfdisplayitem->remove ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->remove() removes this object from the movie's display 
list. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfmovie->add().   SWFDisplayItem->multColorUpSWFDisplayItem->Rotate
SWFDisplayItem->Rotate
(no version information, might be only in CVS)
SWFDisplayItem->Rotate -- Rotates in relative coordinates.
Description
void swfdisplayitem->rotate ( float ddegrees)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->rotate() rotates the current object by ddegrees degrees 
from its current rotation. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->rotateto().   SWFDisplayItem->removeUpSWFDisplayItem->rotateTo
SWFDisplayItem->rotateTo
(no version information, might be only in CVS)
SWFDisplayItem->rotateTo -- Rotates the object in global coordinates.
Description
void swfdisplayitem->rotateto ( float degrees)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->rotateto() set the current object rotation to degrees 
degrees in global coordinates. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
This example bring three rotating string from the background to the 
foreground. Pretty nice. Example 1. swfdisplayitem->rotateto() 
example
  <?php
    $thetext =  "ming!";

    $f = new SWFFont("Bauhaus 93.fdb");

    $m = new SWFMovie();
    $m->setRate(24.0);
    $m->setDimension(2400, 1600);
    $m->setBackground(0xff, 0xff, 0xff);

    // functions with huge numbers of arbitrary
    // arguments are always a good idea!  Really!

    function text($r, $g, $b, $a, $rot, $x, $y, $scale, $string) 
  {
      global $f, $m;

      $t = new SWFText();
      $t->setFont($f);
      $t->setColor($r, $g, $b, $a);
      $t->setHeight(960);
      $t->moveTo(-($f->getWidth($string))/2, $f->getAscent()/2);
      $t->addString($string);

      // we can add properties just like a normal PHP var,
      // as long as the names aren't already used.
      // e.g., we can't set $i->scale, because that's a function

      $i = $m->add($t);
      $i->x = $x;
      $i->y = $y;
      $i->rot = $rot;
      $i->s = $scale;
      $i->rotateTo($rot);
      $i->scale($scale, $scale);

      // but the changes are local to the function, so we have 
to
      // return the changed object.  kinda weird..

      return $i;
  }

    function step($i) {
      $oldrot = $i->rot;
      $i->rot = 19*$i->rot/20;
      $i->x = (19*$i->x + 1200)/20;
      $i->y = (19*$i->y + 800)/20;
      $i->s = (19*$i->s + 1.0)/20;

      $i->rotateTo($i->rot);
      $i->scaleTo($i->s, $i->s);
      $i->moveTo($i->x, $i->y);

      return $i;
    }

    // see?  it sure paid off in legibility:

    $i1 = text(0xff, 0x33, 0x33, 0xff, 900, 1200, 800, 0.03, 
  $thetext);
    $i2 = text(0x00, 0x33, 0xff, 0x7f, -560, 1200, 800, 0.04, 
  $thetext);
    $i3 = text(0xff, 0xff, 0xff, 0x9f, 180, 1200, 800, 0.001, 
  $thetext);

    for ($i=1; $i<=100; ++$i) {
      $i1 = step($i1);
      $i2 = step($i2);
      $i3 = step($i3);

      $m->nextFrame();
    }

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 
See also swfdisplayitem->rotate().   SWFDisplayItem->RotateUpSWFDisplayItem->scale
SWFDisplayItem->scale
(no version information, might be only in CVS)
SWFDisplayItem->scale -- Scales the object in relative coordinates.
Description
void swfdisplayitem->scale ( int dx, int dy)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->scale() scales the current object by (dx,dy) from its 
current size. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->scaleto().   SWFDisplayItem->rotateToUpSWFDisplayItem->scaleTo
SWFDisplayItem->scaleTo
(no version information, might be only in CVS)
SWFDisplayItem->scaleTo -- Scales the object in global coordinates.
Description
void swfdisplayitem->scaleto ( int x, int y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->scaleto() scales the current object to (x,y) in global 
coordinates. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->scale().   SWFDisplayItem->scaleUpSWFDisplayItem->setDepth
SWFDisplayItem->setDepth
(no version information, might be only in CVS)
SWFDisplayItem->setDepth -- Sets z-order
Description
void swfdisplayitem->setdepth ( float depth)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->rotate() sets the object's z-order to depth. Depth 
defaults to the order in which instances are created (by adding a 
shape/text to a movie)- newer ones are on top of older ones. If two 
objects are given the same depth, only the later-defined one can be moved. 

The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add().   SWFDisplayItem->scaleToUpSWFDisplayItem->setName
SWFDisplayItem->setName
(no version information, might be only in CVS)
SWFDisplayItem->setName -- Sets the object's name
Description
void swfdisplayitem->setname ( string name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->setname() sets the object's name to name, for targetting 
with action script. Only useful on sprites. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add().   SWFDisplayItem->setDepthUpSWFDisplayItem->setRatio
SWFDisplayItem->setRatio
(no version information, might be only in CVS)
SWFDisplayItem->setRatio -- Sets the object's ratio.
Description
void swfdisplayitem->setratio ( float ratio)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->setratio() sets the object's ratio to ratio. Obviously 
only useful for morphs. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
This simple example will morph nicely three concentric circles. 
Example 1. swfdisplayitem->setname() example
  <?php

    $p = new SWFMorph();

    $g = new SWFGradient();
    $g->addEntry(0.0, 0, 0, 0);
    $g->addEntry(0.16, 0xff, 0xff, 0xff);
    $g->addEntry(0.32, 0, 0, 0);
    $g->addEntry(0.48, 0xff, 0xff, 0xff);
    $g->addEntry(0.64, 0, 0, 0);
    $g->addEntry(0.80, 0xff, 0xff, 0xff);
    $g->addEntry(1.00, 0, 0, 0);

    $s = $p->getShape1();
    $f = $s->addFill($g, SWFFILL_RADIAL_GRADIENT);
    $f->scaleTo(0.05);
    $s->setLeftFill($f);
    $s->movePenTo(-160, -120);
    $s->drawLine(320, 0);
    $s->drawLine(0, 240);
    $s->drawLine(-320, 0);
    $s->drawLine(0, -240);

    $g = new SWFGradient();
    $g->addEntry(0.0, 0, 0, 0);
    $g->addEntry(0.16, 0xff, 0, 0);
    $g->addEntry(0.32, 0, 0, 0);
    $g->addEntry(0.48, 0, 0xff, 0);
    $g->addEntry(0.64, 0, 0, 0);
    $g->addEntry(0.80, 0, 0, 0xff);
    $g->addEntry(1.00, 0, 0, 0);

    $s = $p->getShape2();
    $f = $s->addFill($g, SWFFILL_RADIAL_GRADIENT);
    $f->scaleTo(0.05);
    $f->skewXTo(1.0);
    $s->setLeftFill($f);
    $s->movePenTo(-160, -120);
    $s->drawLine(320, 0);
    $s->drawLine(0, 240);
    $s->drawLine(-320, 0);
    $s->drawLine(0, -240);

    $m = new SWFMovie();
    $m->setDimension(320, 240);
    $i = $m->add($p);
    $i->moveTo(160, 120);

    for ($n=0; $n<=1.001; $n+=0.01) {
      $i->setRatio($n);
      $m->nextFrame();
    }

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFDisplayItem->setNameUpSWFDisplayItem->skewX
SWFDisplayItem->skewX
(no version information, might be only in CVS)
SWFDisplayItem->skewX -- Sets the X-skew.
Description
void swfdisplayitem->skewx ( float ddegrees)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->skewx() adds ddegrees to current x-skew. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->skewx(), swfdisplayitem->skewy() and 
swfdisplayitem->skewyto().   SWFDisplayItem->setRatioUpSWFDisplayItem->skewXTo
SWFDisplayItem->skewXTo
(no version information, might be only in CVS)
SWFDisplayItem->skewXTo -- Sets the X-skew.
Description
void swfdisplayitem->skewxto ( float degrees)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->skewxto() sets the x-skew to degrees. For degrees is 1.0, 
it means a 45-degree forward slant. More is more forward, less is more 
backward. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->skewx(), swfdisplayitem->skewy() and 
swfdisplayitem->skewyto().   SWFDisplayItem->skewXUpSWFDisplayItem->skewY
SWFDisplayItem->skewY
(no version information, might be only in CVS)
SWFDisplayItem->skewY -- Sets the Y-skew.
Description
void swfdisplayitem->skewy ( float ddegrees)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->skewy() adds ddegrees to current y-skew. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->skewyto(), swfdisplayitem->skewx() and 
swfdisplayitem->skewxto().   SWFDisplayItem->skewXToUpSWFDisplayItem->skewYTo
SWFDisplayItem->skewYTo
(no version information, might be only in CVS)
SWFDisplayItem->skewYTo -- Sets the Y-skew.
Description
void swfdisplayitem->skewyto ( float degrees)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfdisplayitem->skewyto() sets the y-skew to degrees. For degrees is 1.0, 
it means a 45-degree forward slant. More is more upward, less is more 
downward. 
The object may be a swfshape(), a swfbutton(), a swftext() or a 
swfsprite() object. It must have been added using the swfmovie->add(). 
See also swfdisplayitem->skewy(), swfdisplayitem->skewx() and 
swfdisplayitem->skewxto().   SWFDisplayItem->skewYUpSWFDisplayItem
#

#T=new swfbutton ( void )
swfbutton ( ^!void );
#

#T=SWFFill - new SWFFill ( void )
(PHP 4 >= 4.0.5)
SWFFill -- Loads SWFFill object
Description
new SWFFill ( void )
The swffill() object allows you to transform (scale, skew, rotate) bitmap 
and gradient fills. swffill() objects are created by the 
swfshape->addfill() methods. 
SWFFill has the following methods : swffill->moveto() and 
swffill->scaleto(), swffill->rotateto(), swffill->skewxto() and 
swffill->skewyto().   SWFFill->skewYToUpswffont->getwidth
SWFFill->moveTo
(no version information, might be only in CVS)
SWFFill->moveTo -- Moves fill origin
Description
void swffill->moveto ( int x, int y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swffill->moveto() moves fill's origin to (x,y) in global coordinates.   SWFDisplayItemUpSWFFill->rotateTo
SWFFill->rotateTo
(no version information, might be only in CVS)
SWFFill->rotateTo -- Sets fill's rotation
Description
void swffill->rotateto ( float degrees)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swffill->rotateto() sets fill's rotation to degrees degrees.   SWFFill->moveToUpSWFFill->scaleTo
SWFFill->scaleTo
(no version information, might be only in CVS)
SWFFill->scaleTo -- Sets fill's scale
Description
void swffill->scaleto ( int x, int y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swffill->scaleto() sets fill's scale to x in the x-direction, y in the 
y-direction.   SWFFill->rotateToUpSWFFill->skewXTo
SWFFill->skewXTo
(no version information, might be only in CVS)
SWFFill->skewXTo -- Sets fill x-skew
Description
void swffill->skewxto ( float x)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swffill->skewxto() sets fill x-skew to x. For x is 1.0, it is a 45-degree 
forward slant. More is more forward, less is more backward.   SWFFill->scaleToUpSWFFill->skewYTo
SWFFill->skewYTo
(no version information, might be only in CVS)
SWFFill->skewYTo -- Sets fill y-skew
Description
void swffill->skewyto ( float y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swffill->skewyto() sets fill y-skew to y. For y is 1.0, it is a 45-degree 
upward slant. More is more upward, less is more downward.   SWFFill->skewXToUpSWFFill
swffont->getwidth
(no version information, might be only in CVS)
swffont->getwidth -- Returns the string's width
Description
int swffont->getwidth ( string string)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swffont->getwidth() returns the string string's width, using font's 
default scaling. You'll probably want to use the swftext() version of this 
method which uses the text object's scale.   SWFFillUpSWFFont
#

#T=new SWFFill ( void )
SWFFill ( ^!void );
#

#T=SWFFont - new swffont ( string filename)
(PHP 4 >= 4.0.5)
SWFFont -- Loads a font definition
Description
new swffont ( string filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

If filename is the name of an FDB file (i.e., it ends in ".fdb"), load the 
font definition found in said file. Otherwise, create a browser-defined 
font reference. 
FDB ("font definition block") is a very simple wrapper for the SWF 
DefineFont2 block which contains a full description of a font. One may 
create FDB files from SWT Generator template files with the included 
makefdb utility- look in the util directory off the main ming distribution 
directory. 
Browser-defined fonts don't contain any information about the font other 
than its name. It is assumed that the font definition will be provided by 
the movie player. The fonts _serif, _sans, and _typewriter should always 
be available. For example: <?php
$f = newSWFFont("_sans"); 
?> 
will give you the standard sans-serif font, probably the same as what 
you'd get with <font name="sans-serif"> in HTML. 
swffont() returns a reference to the font definition, for use in the 
swftext->setfont() and the swftextfield->setfont() methods. 
SWFFont has the following methods : swffont->getwidth().   swffont->getwidthUpSWFGradient->addEntry
SWFGradient->addEntry
(no version information, might be only in CVS)
SWFGradient->addEntry -- Adds an entry to the gradient list.
Description
void swfgradient->addentry ( float ratio, int red, int green, int blue [, 
int a])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfgradient->addentry() adds an entry to the gradient list. ratio is a 
number between 0 and 1 indicating where in the gradient this color 
appears. Thou shalt add entries in order of increasing ratio. 
red, green, blue is a color (RGB mode). Last parameter a is optional.   SWFFontUpSWFGradient
#

#T=new swffont ( string filename)
swffont ( ^!string filename);
#

#T=SWFGradient - new swfgradient ( void )
(PHP 4 >= 4.0.5)
SWFGradient -- Creates a gradient object
Description
new swfgradient ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfgradient() creates a new SWFGradient object. 
After you've added the entries to your gradient, you can use the gradient 
in a shape fill with the swfshape->addfill() method. 
SWFGradient has the following methods : swfgradient->addentry(). 
This simple example will draw a big black-to-white gradient as background, 
and a reddish disc in its center. Example 1. swfgradient() example
  <?php

    $m = new SWFMovie();
    $m->setDimension(320, 240);

    $s = new SWFShape();

    // first gradient- black to white
    $g = new SWFGradient();
    $g->addEntry(0.0, 0, 0, 0);
    $g->addEntry(1.0, 0xff, 0xff, 0xff);

    $f = $s->addFill($g, SWFFILL_LINEAR_GRADIENT);
    $f->scaleTo(0.01);
    $f->moveTo(160, 120);
    $s->setRightFill($f);
    $s->drawLine(320, 0);
    $s->drawLine(0, 240);
    $s->drawLine(-320, 0);
    $s->drawLine(0, -240);

    $m->add($s);

    $s = new SWFShape();

    // second gradient- radial gradient from red to transparent
    $g = new SWFGradient();
    $g->addEntry(0.0, 0xff, 0, 0, 0xff);
    $g->addEntry(1.0, 0xff, 0, 0, 0);

    $f = $s->addFill($g, SWFFILL_RADIAL_GRADIENT);
    $f->scaleTo(0.005);
    $f->moveTo(160, 120);
    $s->setRightFill($f);
    $s->drawLine(320, 0);
    $s->drawLine(0, 240);
    $s->drawLine(-320, 0);
    $s->drawLine(0, -240);

    $m->add($s);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFGradient->addEntryUpSWFMorph->getshape1
SWFMorph->getshape1
(no version information, might be only in CVS)
SWFMorph->getshape1 -- Gets a handle to the starting shape
Description
mixed swfmorph->getshape1 ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmorph->getshape1() gets a handle to the morph's starting shape. 
swfmorph->getshape1() returns an swfshape() object.   SWFGradientUpSWFMorph->getshape2
SWFMorph->getshape2
(no version information, might be only in CVS)
SWFMorph->getshape2 -- Gets a handle to the ending shape
Description
mixed swfmorph->getshape2 ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmorph->getshape2() gets a handle to the morph's ending shape. 
swfmorph->getshape2() returns an swfshape() object.   SWFMorph->getshape1UpSWFMorph
#

#T=new swfgradient ( void )
swfgradient ( ^!void );
#

#T=SWFMorph - new swfmorph ( void )
(PHP 4 >= 4.0.5)
SWFMorph -- Creates a new SWFMorph object.
Description
new swfmorph ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmorph() creates a new SWFMorph object. 
Also called a "shape tween". This thing lets you make those tacky twisting 
things that make your computer choke. Oh, joy! 
The methods here are sort of weird. It would make more sense to just have 
newSWFMorph(shape1, shape2);, but as things are now, shape2 needs to know 
that it's the second part of a morph. (This, because it starts writing its 
output as soon as it gets drawing commands- if it kept its own description 
of its shapes and wrote on completion this and some other things would be 
much easier.) 
SWFMorph has the following methods : swfmorph->getshape1() and 
swfmorph->getshape1(). 
This simple example will morph a big red square into a smaller blue 
black-bordered square. Example 1. swfmorph() example
  <?php
    $p = new SWFMorph();

    $s = $p->getShape1();
    $s->setLine(0, 0, 0, 0);

    /* Note that this is backwards from normal shapes (left 
  instead of right).
       I have no idea why, but this seems to work.. */

    $s->setLeftFill($s->addFill(0xff, 0, 0));
    $s->movePenTo(-1000,-1000);
    $s->drawLine(2000,0);
    $s->drawLine(0,2000);
    $s->drawLine(-2000,0);
    $s->drawLine(0,-2000);

    $s = $p->getShape2();
    $s->setLine(60,0,0,0);
    $s->setLeftFill($s->addFill(0, 0, 0xff));
    $s->movePenTo(0,-1000);
    $s->drawLine(1000,1000);
    $s->drawLine(-1000,1000);
    $s->drawLine(-1000,-1000);
    $s->drawLine(1000,-1000);

    $m = new SWFMovie();
    $m->setDimension(3000,2000);
    $m->setBackground(0xff, 0xff, 0xff);

    $i = $m->add($p);
    $i->moveTo(1500,1000);

    for ($r=0.0; $r<=1.0; $r+=0.1) {
      $i->setRatio($r);
      $m->nextFrame();
    }

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFMorph->getshape2UpSWFMovie->add
SWFMovie->add
(no version information, might be only in CVS)
SWFMovie->add -- Adds any type of data to a movie.
Description
void swfmovie->add ( resource instance)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->add() adds instance to the current movie. instance is any type 
of data : Shapes, text, fonts, etc. must all be added to the movie to make 
this work. 
For displayable types (shape, text, button, sprite), this returns an 
swfdisplayitem(), a handle to the object in a display list. Thus, you can 
add the same shape to a movie multiple times and get separate handles back 
for each separate instance. 
See also all other objects (adding this later), and swfmovie->remove() 
See examples in : swfdisplayitem->rotateto() and swfshape->addfill().   SWFMorphUpSWFMovie->nextframe
#

#T=new swfmorph ( void )
swfmorph ( ^!void );
#

#T=SWFMovie - new swfmovie ( void )
(PHP 4 >= 4.0.5)
SWFMovie -- Creates a new movie object, representing an SWF version 4 
movie.
Description
new swfmovie ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie() creates a new movie object, representing an SWF version 4 
movie. 
SWFMovie has the following methods : swfmovie->output(),swfmovie->save(), 
swfmovie->add(), swfmovie->remove(), swfmovie->nextframe(), 
swfmovie->setbackground(), swfmovie->setrate(), swfmovie->setdimension(), 
swfmovie->setframes() and swfmovie->streammp3(). 
See examples in : swfdisplayitem->rotateto(), swfshape->setline(), 
swfshape->addfill()... Any example will use this object.   SWFMovie->streammp3UpSWFShape->addFill
SWFMovie->nextframe
(no version information, might be only in CVS)
SWFMovie->nextframe -- Moves to the next frame of the animation.
Description
void swfmovie->nextframe ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->nextframe() moves to the next frame of the animation.   SWFMovie->addUpSWFMovie->output
SWFMovie->output
(no version information, might be only in CVS)
SWFMovie->output -- Dumps your lovingly prepared movie out.
Description
void swfmovie->output ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->output() dumps your lovingly prepared movie out. In PHP, 
preceding this with the command <?php
header('Content-type: application/x-shockwave-flash'); 
?> 
convinces the browser to display this as a flash movie. 
See also swfmovie->save(). 
See examples in : swfmovie->streammp3(), swfdisplayitem->rotateto(), 
swfaction()... Any example will use this method.   SWFMovie->nextframeUpswfmovie->remove
swfmovie->remove
(no version information, might be only in CVS)
swfmovie->remove -- Removes the object instance from the display list.
Description
void swfmovie->remove ( resource instance)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->remove() removes the object instance instance from the display 
list. 
See also swfmovie->add().   SWFMovie->outputUpSWFMovie->save
SWFMovie->save
(no version information, might be only in CVS)
SWFMovie->save -- Saves your movie in a file.
Description
void swfmovie->save ( string filename)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->save() saves your movie to the file named filename. 
See also output().   swfmovie->removeUpSWFMovie->setbackground
SWFMovie->setbackground
(no version information, might be only in CVS)
SWFMovie->setbackground -- Sets the background color.
Description
void swfmovie->setbackground ( int red, int green, int blue)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->setbackground() sets the background color. Why is there no rgba 
version? Think about it. (Actually, that's not such a dumb question after 
all- you might want to let the HTML background show through. There's a way 
to do that, but it only works on IE4. Search the 
http://www.macromedia.com/ site for details.)   SWFMovie->saveUpSWFMovie->setdimension
SWFMovie->setdimension
(no version information, might be only in CVS)
SWFMovie->setdimension -- Sets the movie's width and height.
Description
void swfmovie->setdimension ( int width, int height)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->setdimension() sets the movie's width to width and height to 
height.   SWFMovie->setbackgroundUpSWFMovie->setframes
SWFMovie->setframes
(no version information, might be only in CVS)
SWFMovie->setframes -- Sets the total number of frames in the animation.
Description
void swfmovie->setframes ( string numberofframes)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->setframes() sets the total number of frames in the animation to 
numberofframes.   SWFMovie->setdimensionUpSWFMovie->setrate
SWFMovie->setrate
(no version information, might be only in CVS)
SWFMovie->setrate -- Sets the animation's frame rate.
Description
void swfmovie->setrate ( int rate)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->setrate() sets the frame rate to rate, in frame per seconds. 
Animation will slow down if the player can't render frames fast enough- 
unless there's a streaming sound, in which case display frames are 
sacrificed to keep sound from skipping.   SWFMovie->setframesUpSWFMovie->streammp3
SWFMovie->streammp3
(no version information, might be only in CVS)
SWFMovie->streammp3 -- Streams a MP3 file.
Description
void swfmovie->streammp3 ( string mp3FileName)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfmovie->streammp3() streams the mp3 file mp3FileName. Not very robust in 
dealing with oddities (can skip over an initial ID3 tag, but that's about 
it). Like swfshape->addjpegfill(), this isn't a stable function- we'll 
probably need to make a separate SWFSound object to contain sound types. 
Note that the movie isn't smart enough to put enough frames in to contain 
the entire mp3 stream- you'll have to add (length of song * frames per 
second) frames to get the entire stream in. 
Yes, now you can use ming to put that rock and roll devil worship music 
into your SWF files. Just don't tell the RIAA. Example 1. 
swfmovie->streammp3() example
  <?php
    $m = new SWFMovie();
    $m->setRate(12.0);
    $m->streamMp3("distortobass.mp3");
    // use your own MP3

    // 11.85 seconds at 12.0 fps = 142 frames
    $m->setFrames(142);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFMovie->setrateUpSWFMovie
SWFShape->addFill
(no version information, might be only in CVS)
SWFShape->addFill -- Adds a solid fill to the shape.
Description
void swfshape->addfill ( int red, int green, int blue [, int a])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

void swfshape->addfill ( SWFbitmap bitmap [, int flags])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

void swfshape->addfill ( SWFGradient gradient [, int flags])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->addfill() adds a solid fill to the shape's list of fill styles. 
swfshape->addfill() accepts three different types of arguments. 
red, green, blue is a color (RGB mode). Last parameter a is optional. 
The bitmap argument is an swfbitmap() object. The flags argument can be 
one of the following values : SWFFILL_CLIPPED_BITMAP or 
SWFFILL_TILED_BITMAP. Default is SWFFILL_TILED_BITMAP. I think. 
The gradient argument is an swfgradient() object. The flags argument can 
be one of the following values : SWFFILL_RADIAL_GRADIENT or 
SWFFILL_LINEAR_GRADIENT. Default is SWFFILL_LINEAR_GRADIENT. I'm sure 
about this one. Really. 
swfshape->addfill() returns an swffill() object for use with the 
swfshape->setleftfill() and swfshape->setrightfill() functions described 
below. 
See also swfshape->setleftfill() and swfshape->setrightfill(). 
This simple example will draw a frame on a bitmap. Ah, here's another 
buglet in the flash player- it doesn't seem to care about the second 
shape's bitmap's transformation in a morph. According to spec, the bitmap 
should stretch along with the shape in this example.. Example 1. 
swfshape->addfill() example
  <?php

    $p = new SWFMorph();

    $b = new SWFBitmap("alphafill.jpg");
    // use your own bitmap
    $width = $b->getWidth();
    $height = $b->getHeight();

    $s = $p->getShape1();
    $f = $s->addFill($b, SWFFILL_TILED_BITMAP);
    $f->moveTo(-$width/2, -$height/4);
    $f->scaleTo(1.0, 0.5);
    $s->setLeftFill($f);
    $s->movePenTo(-$width/2, -$height/4);
    $s->drawLine($width, 0);
    $s->drawLine(0, $height/2);
    $s->drawLine(-$width, 0);
    $s->drawLine(0, -$height/2);

    $s = $p->getShape2();
    $f = $s->addFill($b, SWFFILL_TILED_BITMAP);

    // these two have no effect!
    $f->moveTo(-$width/4, -$height/2);
    $f->scaleTo(0.5, 1.0);

    $s->setLeftFill($f);
    $s->movePenTo(-$width/4, -$height/2);
    $s->drawLine($width/2, 0);
    $s->drawLine(0, $height);
    $s->drawLine(-$width/2, 0);
    $s->drawLine(0, -$height);

    $m = new SWFMovie();
    $m->setDimension($width, $height);
    $i = $m->add($p);
    $i->moveTo($width/2, $height/2);

    for ($n=0; $n<1.001; $n+=0.03) {
      $i->setRatio($n);
      $m->nextFrame();
    }

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFMovieUpSWFShape->drawCurve
SWFShape->drawCurve
(no version information, might be only in CVS)
SWFShape->drawCurve -- Draws a curve (relative).
Description
void swfshape->drawcurve ( int controldx, int controldy, int anchordx, int 
anchordy)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->drawcurve() draws a quadratic curve (using the current line 
style,set by swfshape->setline()) from the current pen position to the 
relative position (anchorx,anchory) using relative control point 
(controlx,controly). That is, head towards the control point, then 
smoothly turn to the anchor point. 
See also swfshape->drawlineto(), swfshape->drawline(), 
swfshape->movepento() and swfshape->movepen().   SWFShape->addFillUpSWFShape->drawCurveTo
SWFShape->drawCurveTo
(no version information, might be only in CVS)
SWFShape->drawCurveTo -- Draws a curve.
Description
void swfshape->drawcurveto ( int controlx, int controly, int anchorx, int 
anchory)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->drawcurveto() draws a quadratic curve (using the current line 
style, set by swfshape->setline()) from the current pen position to 
(anchorx,anchory) using (controlx,controly) as a control point. That is, 
head towards the control point, then smoothly turn to the anchor point. 
See also swfshape->drawlineto(), swfshape->drawline(), 
swfshape->movepento() and swfshape->movepen().   SWFShape->drawCurveUpSWFShape->drawLine
SWFShape->drawLine
(no version information, might be only in CVS)
SWFShape->drawLine -- Draws a line (relative).
Description
void swfshape->drawline ( int dx, int dy)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->drawline() draws a line (using the current line style set by 
swfshape->setline()) from the current pen position to displacement 
(dx,dy). 
See also swfshape->movepento(), swfshape->drawcurveto(), 
swfshape->movepen() and swfshape->drawlineto().   SWFShape->drawCurveToUpSWFShape->drawLineTo
SWFShape->drawLineTo
(no version information, might be only in CVS)
SWFShape->drawLineTo -- Draws a line.
Description
void swfshape->drawlineto ( int x, int y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->setrightfill() draws a line (using the current line style, set 
by swfshape->setline()) from the current pen position to point (x,y) in 
the shape's coordinate space. 
See also swfshape->movepento(), swfshape->drawcurveto(), 
swfshape->movepen() and swfshape->drawline().   SWFShape->drawLineUpSWFShape->movePen
#

#T=new swfmovie ( void )
swfmovie ( ^!void );
#

#T=SWFShape - new swfshape ( void )
(PHP 4 >= 4.0.5)
SWFShape -- Creates a new shape object.
Description
new swfshape ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape() creates a new shape object. 
SWFShape has the following methods : swfshape->setline(), 
swfshape->addfill(), swfshape->setleftfill(), swfshape->setrightfill(), 
swfshape->movepento(), swfshape->movepen(), swfshape->drawlineto(), 
swfshape->drawline(), swfshape->drawcurveto() and swfshape->drawcurve(). 
This simple example will draw a big red elliptic quadrant. Example 
1. swfshape() example
  <?php
    $s = new SWFShape();
    $s->setLine(40, 0x7f, 0, 0);
    $s->setRightFill($s->addFill(0xff, 0, 0));
    $s->movePenTo(200, 200);
    $s->drawLineTo(6200, 200);
    $s->drawLineTo(6200, 4600);
    $s->drawCurveTo(200, 4600, 200, 200);

    $m = new SWFMovie();
    $m->setDimension(6400, 4800);
    $m->setRate(12.0);
    $m->add($s);
    $m->nextFrame();

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFShape->setRightFillUpswfsprite->add
SWFShape->movePen
(no version information, might be only in CVS)
SWFShape->movePen -- Moves the shape's pen (relative).
Description
void swfshape->movepen ( int dx, int dy)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->setrightfill() move the shape's pen from coordinates (current 
x,current y) to (current x + dx, current y + dy) in the shape's coordinate 
space. 
See also swfshape->movepento(), swfshape->drawcurveto(), 
swfshape->drawlineto() and swfshape->drawline().   SWFShape->drawLineToUpSWFShape->movePenTo
SWFShape->movePenTo
(no version information, might be only in CVS)
SWFShape->movePenTo -- Moves the shape's pen.
Description
void swfshape->movepento ( int x, int y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->setrightfill() move the shape's pen to (x,y) in the shape's 
coordinate space. 
See also swfshape->movepen(), swfshape->drawcurveto(), 
swfshape->drawlineto() and swfshape->drawline().   SWFShape->movePenUpSWFShape->setLeftFill
SWFShape->setLeftFill
(no version information, might be only in CVS)
SWFShape->setLeftFill -- Sets left rasterizing color.
Description
void swfshape->setleftfill ( swfgradient fill)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

void swfshape->setleftfill ( int red, int green, int blue [, int a])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

What this nonsense is about is, every edge segment borders at most two 
fills. When rasterizing the object, it's pretty handy to know what those 
fills are ahead of time, so the swf format requires these to be specified. 

swfshape->setleftfill() sets the fill on the left side of the edge- that 
is, on the interior if you're defining the outline of the shape in a 
counter-clockwise fashion. The fill object is an SWFFill object returned 
from one of the addFill functions above. 
This seems to be reversed when you're defining a shape in a morph, though. 
If your browser crashes, just try setting the fill on the other side. 
Shortcut for swfshape->setleftfill($s->addfill($r, $g, $b [, $a]));. 
See also swfshape->setrightfill().   SWFShape->movePenToUpSWFShape->setLine
SWFShape->setLine
(no version information, might be only in CVS)
SWFShape->setLine -- Sets the shape's line style.
Description
void swfshape->setline ( int width [, int red [, int green [, int blue [, 
int a]]]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfshape->setline() sets the shape's line style. width is the line's 
width. If width is 0, the line's style is removed (then, all other 
arguments are ignored). If width > 0, then line's color is set to red, 
green, blue. Last parameter a is optional. 
swfshape->setline() accepts 1, 4 or 5 arguments (not 3 or 2). 
You must declare all line styles before you use them (see example). 
This simple example will draw a big "!#%*@", in funny colors and gracious 
style. Example 1. swfshape->setline() example
  <?php
    $s = new SWFShape();
    $f1 = $s->addFill(0xff, 0, 0);
    $f2 = $s->addFill(0xff, 0x7f, 0);
    $f3 = $s->addFill(0xff, 0xff, 0);
    $f4 = $s->addFill(0, 0xff, 0);
    $f5 = $s->addFill(0, 0, 0xff);

    // bug: have to declare all line styles before you use them
    $s->setLine(40, 0x7f, 0, 0);
    $s->setLine(40, 0x7f, 0x3f, 0);
    $s->setLine(40, 0x7f, 0x7f, 0);
    $s->setLine(40, 0, 0x7f, 0);
    $s->setLine(40, 0, 0, 0x7f);

    $f = new SWFFont('Techno.fdb');

    $s->setRightFill($f1);
    $s->setLine(40, 0x7f, 0, 0);
    $s->drawGlyph($f, '!');
    $s->movePen($f->getWidth('!'), 0);

    $s->setRightFill($f2);
    $s->setLine(40, 0x7f, 0x3f, 0);
    $s->drawGlyph($f, '#');
    $s->movePen($f->getWidth('#'), 0);

    $s->setRightFill($f3);
    $s->setLine(40, 0x7f, 0x7f, 0);
    $s->drawGlyph($f, '%');
    $s->movePen($f->getWidth('%'), 0);

    $s->setRightFill($f4);
    $s->setLine(40, 0, 0x7f, 0);
    $s->drawGlyph($f, '*');
    $s->movePen($f->getWidth('*'), 0);

    $s->setRightFill($f5);
    $s->setLine(40, 0, 0, 0x7f);
    $s->drawGlyph($f, '@');

    $m = new SWFMovie();
    $m->setDimension(3000,2000);
    $m->setRate(12.0);
    $i = $m->add($s);
    $i->moveTo(1500-$f->getWidth("!#%*@")/2, 
  1000+$f->getAscent()/2);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFShape->setLeftFillUpSWFShape->setRightFill
SWFShape->setRightFill
(no version information, might be only in CVS)
SWFShape->setRightFill -- Sets right rasterizing color.
Description
void swfshape->setrightfill ( swfgradient fill)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

void swfshape->setrightfill ( int red, int green, int blue [, int a])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also swfshape->setleftfill(). 
Shortcut for swfshape->setrightfill($s->addfill($r, $g, $b [, $a]));.   SWFShape->setLineUpSWFShape
swfsprite->add
(no version information, might be only in CVS)
swfsprite->add -- Adds an object to a sprite
Description
void swfsprite->add ( resource object)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfsprite->add() adds a swfshape(), a swfbutton(), a swftext(), a 
swfaction() or a swfsprite() object. 
For displayable types (swfshape(), swfbutton(), swftext(), swfaction() or 
swfsprite()), this returns a handle to the object in a display list.   SWFShapeUpSWFSprite->nextframe
#

#T=new swfshape ( void )
swfshape ( ^!void );
#

#T=SWFSprite - new swfsprite ( void )
(PHP 4 >= 4.0.5)
SWFSprite -- Creates a movie clip (a sprite)
Description
new swfsprite ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfsprite() are also known as a "movie clip", this allows one to create 
objects which are animated in their own timelines. Hence, the sprite has 
most of the same methods as the movie. 
swfsprite() has the following methods : swfsprite->add(), 
swfsprite->remove(), swfsprite->nextframe() and swfsprite->setframes(). 
This simple example will spin gracefully a big red square. Example 
1. swfsprite() example
  <?php
    $s = new SWFShape();
    $s->setRightFill($s->addFill(0xff, 0, 0));
    $s->movePenTo(-500, -500);
    $s->drawLineTo(500, -500);
    $s->drawLineTo(500, 500);
    $s->drawLineTo(-500, 500);
    $s->drawLineTo(-500, -500);

    $p = new SWFSprite();
    $i = $p->add($s);
    $p->nextFrame();
    $i->rotate(15);
    $p->nextFrame();
    $i->rotate(15);
    $p->nextFrame();
    $i->rotate(15);
    $p->nextFrame();
    $i->rotate(15);
    $p->nextFrame();
    $i->rotate(15);
    $p->nextFrame();

    $m = new SWFMovie();
    $i = $m->add($p);
    $i->moveTo(1500, 1000);
    $i->setName("blah");

    $m->setBackground(0xff, 0xff, 0xff);
    $m->setDimension(3000, 2000);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFSprite->setframesUpSWFText->addString
SWFSprite->nextframe
(no version information, might be only in CVS)
SWFSprite->nextframe -- Moves to the next frame of the animation.
Description
void swfsprite->nextframe ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfsprite->setframes() moves to the next frame of the animation.   swfsprite->addUpSWFSprite->remove
SWFSprite->remove
(no version information, might be only in CVS)
SWFSprite->remove -- Removes an object to a sprite
Description
void swfsprite->remove ( resource object)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfsprite->remove() remove a swfshape(), a swfbutton(), a swftext(), a 
swfaction() or a swfsprite() object from the sprite.   SWFSprite->nextframeUpSWFSprite->setframes
SWFSprite->setframes
(no version information, might be only in CVS)
SWFSprite->setframes -- Sets the total number of frames in the animation.
Description
void swfsprite->setframes ( int numberofframes)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swfsprite->setframes() sets the total number of frames in the animation to 
numberofframes.   SWFSprite->removeUpSWFSprite
SWFText->addString
(no version information, might be only in CVS)
SWFText->addString -- Draws a string
Description
void swftext->addstring ( string string)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext->addstring() draws the string string at the current pen (cursor) 
location. Pen is at the baseline of the text; i.e., ascending text is in 
the -y direction.   SWFSpriteUpSWFText->getWidth
SWFText->getWidth
(no version information, might be only in CVS)
SWFText->getWidth -- Computes string's width
Description
void swftext->getwidth ( string string)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext->addstring() returns the rendered width of the string string at 
the text object's current font, scale, and spacing settings.   SWFText->addStringUpSWFText->moveTo
#

#T=new swfsprite ( void )
swfsprite ( ^!void );
#

#T=SWFText - new swftext ( void )
(PHP 4 >= 4.0.5)
SWFText -- Creates a new SWFText object.
Description
new swftext ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext() creates a new SWFText object, fresh for manipulating. 
SWFText has the following methods : swftext->setfont(), 
swftext->setheight(), swftext->setspacing(), swftext->setcolor(), 
swftext->moveto(), swftext->addstring() and swftext->getwidth(). 
This simple example will draw a big yellow "PHP generates Flash with Ming" 
text, on white background. Example 1. swftext() example
  <?php
    $f = new SWFFont("Techno.fdb");
    $t = new SWFText();
    $t->setFont($f);
    $t->moveTo(200, 2400);
    $t->setColor(0xff, 0xff, 0);
    $t->setHeight(1200);
    $t->addString("PHP generates Flash with Ming!!");

    $m = new SWFMovie();
    $m->setDimension(5400, 3600);

    $m->add($t);

    header('Content-type: application/x-shockwave-flash');
    $m->output();
  ?> 

  SWFText->setSpacingUpSWFTextField->addstring
SWFText->moveTo
(no version information, might be only in CVS)
SWFText->moveTo -- Moves the pen
Description
void swftext->moveto ( int x, int y)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext->moveto() moves the pen (or cursor, if that makes more sense) to 
(x,y) in text object's coordinate space. If either is zero, though, value 
in that dimension stays the same. Annoying, should be fixed.   SWFText->getWidthUpSWFText->setColor
SWFText->setColor
(no version information, might be only in CVS)
SWFText->setColor -- Sets the current font color
Description
void swftext->setcolor ( int red, int green, int blue [, int a])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext->setspacing() changes the current text color. Default is black. I 
think. Color is represented using the RGB system.   SWFText->moveToUpSWFText->setFont
SWFText->setFont
(no version information, might be only in CVS)
SWFText->setFont -- Sets the current font
Description
void swftext->setfont ( string font)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext->setfont() sets the current font to font.   SWFText->setColorUpSWFText->setHeight
SWFText->setHeight
(no version information, might be only in CVS)
SWFText->setHeight -- Sets the current font height
Description
void swftext->setheight ( int height)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext->setheight() sets the current font height to height. Default is 
240.   SWFText->setFontUpSWFText->setSpacing
SWFText->setSpacing
(no version information, might be only in CVS)
SWFText->setSpacing -- Sets the current font spacing
Description
void swftext->setspacing ( float spacing)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftext->setspacing() sets the current font spacing to spacingspacing. 
Default is 1.0. 0 is all of the letters written at the same point. This 
doesn't really work that well because it inflates the advance across the 
letter, doesn't add the same amount of spacing between the letters. I 
should try and explain that better, prolly. Or just fix the damn thing to 
do constant spacing. This was really just a way to figure out how letter 
advances work, anyway.. So nyah.   SWFText->setHeightUpSWFText
SWFTextField->addstring
(no version information, might be only in CVS)
SWFTextField->addstring -- Concatenates the given string to the text field
Description
void swftextfield->addstring ( string string)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setname() concatenates the string string to the text field.   SWFTextUpSWFTextField->align
SWFTextField->align
(no version information, might be only in CVS)
SWFTextField->align -- Sets the text field alignment
Description
void swftextfield->align ( int alignement)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->align() sets the text field alignment to alignement. Valid 
values for alignement are : SWFTEXTFIELD_ALIGN_LEFT, 
SWFTEXTFIELD_ALIGN_RIGHT, SWFTEXTFIELD_ALIGN_CENTER and 
SWFTEXTFIELD_ALIGN_JUSTIFY.   SWFTextField->addstringUpSWFTextField->setbounds
#

#T=new swftext ( void )
swftext ( ^!void );
#

#T=SWFTextField - new swftextfield ( [int flags])
(PHP 4 >= 4.0.5)
SWFTextField -- Creates a text field object
Description
new swftextfield ( [int flags])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield() creates a new text field object. Text Fields are less 
flexible than swftext() objects- they can't be rotated, scaled 
non-proportionally, or skewed, but they can be used as form entries, and 
they can use browser-defined fonts. 
The optional flags change the text field's behavior. It has the following 
possibles values : 
SWFTEXTFIELD_DRAWBOX draws the outline of the textfield 
SWFTEXTFIELD_HASLENGTH 
SWFTEXTFIELD_HTML allows text markup using HTML-tags 
SWFTEXTFIELD_MULTILINE allows multiple lines 
SWFTEXTFIELD_NOEDIT indicates that the field shouldn't be user-editable 
SWFTEXTFIELD_NOSELECT makes the field non-selectable 
SWFTEXTFIELD_PASSWORD obscures the data entry 
SWFTEXTFIELD_WORDWRAP allows text to wrap 
Flags are combined with the bitwise OR operation. For example, <?php
$t = newSWFTextField(SWFTEXTFIELD_PASSWORD | SWFTEXTFIELD_NOEDIT); 
?> 
creates a totally useless non-editable password field. 
SWFTextField has the following methods : swftextfield->setfont(), 
swftextfield->setbounds(), swftextfield->align(), 
swftextfield->setheight(), swftextfield->setleftmargin(), 
swftextfield->setrightmargin(), swftextfield->setmargins(), 
swftextfield->setindentation(), swftextfield->setlinespacing(), 
swftextfield->setcolor(), swftextfield->setname() and 
swftextfield->addstring().   SWFTextField->setrightMarginUpMiscellaneous functions
SWFTextField->setbounds
(no version information, might be only in CVS)
SWFTextField->setbounds -- Sets the text field width and height
Description
void swftextfield->setbounds ( int width, int height)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setbounds() sets the text field width to width and height to 
height. If you don't set the bounds yourself, Ming makes a poor guess at 
what the bounds are.   SWFTextField->alignUpSWFTextField->setcolor
SWFTextField->setcolor
(no version information, might be only in CVS)
SWFTextField->setcolor -- Sets the color of the text field. 
Description
void swftextfield->setcolor ( int red, int green, int blue [, int a])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setcolor() sets the color of the text field. Default is 
fully opaque black. Color is represented using RGB system.   SWFTextField->setboundsUpSWFTextField->setFont
SWFTextField->setFont
(no version information, might be only in CVS)
SWFTextField->setFont -- Sets the text field font
Description
void swftextfield->setfont ( string font)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setfont() sets the text field font to the [browser-defined?] 
font font.   SWFTextField->setcolorUpSWFTextField->setHeight
SWFTextField->setHeight
(no version information, might be only in CVS)
SWFTextField->setHeight -- Sets the font height of this text field font.
Description
void swftextfield->setheight ( int height)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setheight() sets the font height of this text field font to 
the given height height. Default is 240.   SWFTextField->setFontUpSWFTextField->setindentation
SWFTextField->setindentation
(no version information, might be only in CVS)
SWFTextField->setindentation -- Sets the indentation of the first line.
Description
void swftextfield->setindentation ( int width)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setindentation() sets the indentation of the first line in 
the text field, to width.   SWFTextField->setHeightUpSWFTextField->setLeftMargin
SWFTextField->setLeftMargin
(no version information, might be only in CVS)
SWFTextField->setLeftMargin -- Sets the left margin width of the text 
field.
Description
void swftextfield->setleftmargin ( int width)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setleftmargin() sets the left margin width of the text field 
to width. Default is 0.   SWFTextField->setindentationUpSWFTextField->setLineSpacing
SWFTextField->setLineSpacing
(no version information, might be only in CVS)
SWFTextField->setLineSpacing -- Sets the line spacing of the text field.
Description
void swftextfield->setlinespacing ( int height)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setlinespacing() sets the line spacing of the text field to 
the height of height. Default is 40.   SWFTextField->setLeftMarginUpSWFTextField->setMargins
SWFTextField->setMargins
(no version information, might be only in CVS)
SWFTextField->setMargins -- Sets the margins width of the text field.
Description
void swftextfield->setmargins ( int left, int right)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setmargins() set both margins at once, for the man on the 
go.   SWFTextField->setLineSpacingUpSWFTextField->setname
SWFTextField->setname
(no version information, might be only in CVS)
SWFTextField->setname -- Sets the variable name
Description
void swftextfield->setname ( string name)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setname() sets the variable name of this text field to name, 
for form posting and action scripting purposes.   SWFTextField->setMarginsUpSWFTextField->setrightMargin
SWFTextField->setrightMargin
(no version information, might be only in CVS)
SWFTextField->setrightMargin -- Sets the right margin width of the text 
field.
Description
void swftextfield->setrightmargin ( int width)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

swftextfield->setrightmargin() sets the right margin width of the text 
field to width. Default is 0.   SWFTextField->setnameUpSWFTextField
#

#T=new swftextfield ( [int flags])
swftextfield ( ^![int flags]);
#

#T=sybase_affected_rows - int sybase_affected_rows ( [resource link_identifier])
(PHP 3>= 3.0.6, PHP 4 )
sybase_affected_rows -- Gets number of affected rows in last query
Description
int sybase_affected_rows ( [resource link_identifier])
sybase_affected_rows() returns the number of rows affected by the last 
INSERT, UPDATE or DELETE query on the server associated with the specified 
link identifier. If the link identifier isn't specified, the last opened 
link is assumed. 
Example 1. Delete-Query
  <?php
      /* connect to database */
      sybase_connect('SYBASE', '', '') or
	  die("Could not connect");
      sybase_select_db("db");

      sybase_query("DELETE FROM sometable WHERE id < 10");
      printf("Records deleted: %d\n", sybase_affected_rows());
  ?> 

The above example would produce the following output: 
Records deleted: 10
This command is not effective for SELECT statements, only on statements 
which modify records. To retrieve the number of rows returned from a 
SELECT, use sybase_num_rows(). 
Note: This function is only available using the CT library interface to 
Sybase, and not the DB library.
See also sybase_num_rows().   Sybase functionsUpsybase_close
#

#T=int sybase_affected_rows ( [resource link_identifier])
sybase_affected_rows ( ^![resource link_identifier]);
#

#T=sybase_close - bool sybase_close ( [resource link_identifier])
(PHP 3, PHP 4 )
sybase_close -- Closes a Sybase connection
Description
bool sybase_close ( [resource link_identifier])
sybase_close() closes the link to a Sybase database that's associated with 
the specified link link_identifier. If the link identifier isn't 
specified, the last opened link is assumed. 
Returns TRUE on success or FALSE on failure. 
Note that this isn't usually necessary, as non-persistent open links are 
automatically closed at the end of the script's execution. 
sybase_close() will not close persistent links generated by 
sybase_pconnect(). 
See also sybase_connect() and sybase_pconnect().   sybase_affected_rowsUpsybase_connect
#

#T=bool sybase_close ( [resource link_identifier])
sybase_close ( ^![resource link_identifier]);
#

#T=sybase_connect - resource sybase_connect ( [string servername [, string username [, string 
(PHP 3, PHP 4 )
sybase_connect -- Opens a Sybase server connection
Description
resource sybase_connect ( [string servername [, string username [, string 
password [, string charset [, string appname]]]]])
Returns a positive Sybase link identifier on success, or FALSE on failure. 

sybase_connect() establishes a connection to a Sybase server. The 
servername argument has to be a valid servername that is defined in the 
'interfaces' file. 
In case a second call is made to sybase_connect() with the same arguments, 
no new link will be established, but instead, the link identifier of the 
already opened link will be returned. 
The link to the server will be closed as soon as the execution of the 
script ends, unless it's closed earlier by explicitly calling 
sybase_close(). 
Example 1. sybase_connect() example
  <?php
      $link = sybase_connect('SYBASE', '', '')
	      or die("Could not connect !");
      echo "Connected successfully";
      sybase_close($link);
  ?> 
See also sybase_pconnect() and sybase_close().   sybase_closeUpsybase_data_seek
#

#T=resource sybase_connect ( [string servername [, string username [, string 
sybase_connect ( ^![string servername [, string username [, string ;
#

#T=sybase_data_seek - bool sybase_data_seek ( resource result_identifier, int row_number)
(PHP 3, PHP 4 )
sybase_data_seek -- Moves internal row pointer
Description
bool sybase_data_seek ( resource result_identifier, int row_number)
Returns TRUE on success or FALSE on failure. 
sybase_data_seek() moves the internal row pointer of the Sybase result 
associated with the specified result identifier to pointer to the 
specified row number. The next call to sybase_fetch_row() would return 
that row. 
See also sybase_fetch_row().   sybase_connectUpsybase_deadlock_retry_count
#

#T=bool sybase_data_seek ( resource result_identifier, int row_number)
sybase_data_seek ( ^!resource result_identifier, int row_number);
#

#T=sybase_deadlock_retry_count - void sybase_deadlock_retry_count ( int retry_count)
(PHP 4 >= 4.3.0)
sybase_deadlock_retry_count -- Sets the deadlock retry count
Description
void sybase_deadlock_retry_count ( int retry_count)
Using sybase_deadlock_retry_count(), the number of retries can be defined 
in cases of deadlocks. By default, every deadlock is retried an infinite 
number of times or until the process is killed by Sybase, the executing 
script is killed (for instance, by set_time_limit()) or the query 
succeeds. 
Table 1. Values for retry_count
-1Retry forever (default)
0Do not retry
nRetry n times

Note: This function is only available using the CT library interface to 
Sybase, and not the DB library.  sybase_data_seekUpsybase_fetch_array
#

#T=void sybase_deadlock_retry_count ( int retry_count)
sybase_deadlock_retry_count ( ^!int retry_count);
#

#T=sybase_fetch_array - array sybase_fetch_array ( resource result)
(PHP 3, PHP 4 )
sybase_fetch_array -- Fetch row as array
Description
array sybase_fetch_array ( resource result)
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
sybase_fetch_array() is an extended version of sybase_fetch_row(). In 
addition to storing the data in the numeric indices of the result array, 
it also stores the data in associative indices, using the field names as 
keys. 
An important thing to note is that using sybase_fetch_array() is NOT 
significantly slower than using sybase_fetch_row(), while it provides a 
significant added value. 
Note: When selecting fields with identical names (for instance, in a 
join), the associative indices will have a sequential number prepended. 
See the example for details. 
Example 1. Identical fieldnames
  <?php
      $dbh = sybase_connect('SYBASE', '', '');
      $q = sybase_query('SELECT * FROM p, a WHERE p.person_id= 
  a.person_id');
      var_dump(sybase_fetch_array($q));
      sybase_close($dbh);
  ?> 

The above example would produce the following output (assuming the 
two tables only have each one column called "person_id"): 
array(4) {
[0]=>
int(1)
["person_id"]=>
int(1)
[1]=>
int(1)
["person_id1"]=>
int(1)
}
See also sybase_fetch_row(), sybase_fetch_assoc() and 
sybase_fetch_object().   sybase_deadlock_retry_countUpsybase_fetch_assoc
#

#T=array sybase_fetch_array ( resource result)
sybase_fetch_array ( ^!resource result);
#

#T=sybase_fetch_assoc - array sybase_fetch_assoc ( resource result)
(PHP 4 >= 4.3.0)
sybase_fetch_assoc -- Fetch a result row as an associative array
Description
array sybase_fetch_assoc ( resource result)
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
sybase_fetch_assoc() is a version of sybase_fetch_row() that uses column 
names instead of integers for indices in the result array. Columns from 
different tables with the same names are returned as name, name1, name2, 
..., nameN. 
An important thing to note is that using sybase_fetch_assoc() is NOT 
significantly slower than using sybase_fetch_row(), while it provides a 
significant added value. 
See also sybase_fetch_array(), sybase_fetch_object() and 
sybase_fetch_row().   sybase_fetch_arrayUpsybase_fetch_field
#

#T=array sybase_fetch_assoc ( resource result)
sybase_fetch_assoc ( ^!resource result);
#

#T=sybase_fetch_field - object sybase_fetch_field ( resource result [, int field_offset])
(PHP 3, PHP 4 )
sybase_fetch_field -- Get field information from a result
Description
object sybase_fetch_field ( resource result [, int field_offset])
Returns an object containing field information. 
sybase_fetch_field() can be used in order to obtain information about 
fields in a certain query result. If the field offset isn't specified, the 
next field that wasn't yet retrieved by sybase_fetch_field() is retrieved. 

The properties of the object are: 
name - column name. if the column is a result of a function, this 
property is set to computed#N, where #N is a serial number. 
column_source - the table from which the column was taken 
max_length - maximum length of the column 
numeric - 1 if the column is numeric 
type - datatype of the column 
See also sybase_field_seek().   sybase_fetch_assocUpsybase_fetch_object
#

#T=object sybase_fetch_field ( resource result [, int field_offset])
sybase_fetch_field ( ^!resource result [, int field_offset]);
#

#T=sybase_fetch_object - object sybase_fetch_object ( resource result [, mixed object])
(PHP 3, PHP 4 )
sybase_fetch_object -- Fetch a row as an object
Description
object sybase_fetch_object ( resource result [, mixed object])
Returns an object with properties that correspond to the fetched row, or 
FALSE if there are no more rows. 
sybase_fetch_object() is similar to sybase_fetch_assoc(), with one 
difference - an object is returned, instead of an array. 
Use the second object to specify the type of object you want to return. If 
this parameter is omitted, the object will be of type stdClass. 
Note: As of PHP 4.3.0, this function will no longer return numeric 
object members. 
Old behaviour: object(stdclass)(3) {
[0]=>
string(3) "foo"
["foo"]=>
string(3) "foo"
[1]=>
string(3) "bar"
["bar"]=>
string(3) "bar"
}
New behaviour: object(stdclass)(3) {
["foo"]=>
string(3) "foo"
["bar"]=>
string(3) "bar"
}

Example 1. sybase_fetch_object() return as Foo
  <?php
      class Foo {
	  var $foo, $bar, $baz;
      }
      
      // {...]
      $qrh= sybase_query('SELECT foo, bar, baz FROM example');
      $foo= sybase_fetch_object($qrh, 'Foo');
      $bar= sybase_fetch_object($qrh, new Foo());
      // {...]
  ?> 
Speed-wise, the function is identical to sybase_fetch_array(), and almost 
as quick as sybase_fetch_row() (the difference is insignificant). 
See also sybase_fetch_array() and sybase_fetch_row().   sybase_fetch_fieldUpsybase_fetch_row
#

#T=object sybase_fetch_object ( resource result [, mixed object])
sybase_fetch_object ( ^!resource result [, mixed object]);
#

#T=sybase_fetch_row - array sybase_fetch_row ( resource result)
(PHP 3, PHP 4 )
sybase_fetch_row -- Get a result row as an enumerated array
Description
array sybase_fetch_row ( resource result)
Returns an array that corresponds to the fetched row, or FALSE if there 
are no more rows. 
sybase_fetch_row() fetches one row of data from the result associated with 
the specified result identifier. The row is returned as an array. Each 
result column is stored in an array offset, starting at offset 0. 
Subsequent call to sybase_fetch_row() would return the next row in the 
result set, or FALSE if there are no more rows. 
Table 1. Data types
PHPSybase
stringVARCHAR, TEXT, CHAR, IMAGE, BINARY, VARBINARY, DATETIME
intNUMERIC (w/o precision), DECIMAL (w/o precision), INT, BIT, 
TINYINT, SMALLINT
floatNUMERIC (w/ precision), DECIMAL (w/ precision), REAL, FLOAT, 
MONEY
NULLNULL

See also sybase_fetch_array(), sybase_fetch_assoc(), 
sybase_fetch_object(), sybase_data_seek() and sybase_result().   sybase_fetch_objectUpsybase_field_seek
#

#T=array sybase_fetch_row ( resource result)
sybase_fetch_row ( ^!resource result);
#

#T=sybase_field_seek - bool sybase_field_seek ( resource result, int field_offset)
(PHP 3, PHP 4 )
sybase_field_seek -- Sets field offset
Description
bool sybase_field_seek ( resource result, int field_offset)
Seeks to the specified field offset. If the next call to 
sybase_fetch_field() won't include a field offset, this field would be 
returned. 
Returns TRUE on success or FALSE on failure. 
See also sybase_fetch_field().   sybase_fetch_rowUpsybase_free_result
#

#T=bool sybase_field_seek ( resource result, int field_offset)
sybase_field_seek ( ^!resource result, int field_offset);
#

#T=sybase_free_result - bool sybase_free_result ( resource result)
(PHP 3, PHP 4 )
sybase_free_result -- Frees result memory
Description
bool sybase_free_result ( resource result)
sybase_free_result() only needs to be called if you are worried about 
using too much memory while your script is running. All result memory will 
automatically be freed when the script ends. You may call 
sybase_free_result() with the result identifier as an argument and the 
associated result memory will be freed.   sybase_field_seekUpsybase_get_last_message
#

#T=bool sybase_free_result ( resource result)
sybase_free_result ( ^!resource result);
#

#T=sybase_get_last_message - string sybase_get_last_message ( void )
(PHP 3, PHP 4 )
sybase_get_last_message -- Returns the last message from the server
Description
string sybase_get_last_message ( void )
sybase_get_last_message() returns the last message reported by the server. 

See also sybase_min_message_severity().   sybase_free_resultUpsybase_min_client_severity
#

#T=string sybase_get_last_message ( void )
sybase_get_last_message ( ^!void );
#

#T=sybase_min_client_severity - void sybase_min_client_severity ( int severity)
(PHP 3, PHP 4 )
sybase_min_client_severity -- Sets minimum client severity
Description
void sybase_min_client_severity ( int severity)
sybase_min_client_severity() sets the minimum client severity level. 
Note: This function is only available using the CT library interface to 
Sybase, and not the DB library.
See also sybase_min_server_severity().   sybase_get_last_messageUpsybase_min_error_severity
#

#T=void sybase_min_client_severity ( int severity)
sybase_min_client_severity ( ^!int severity);
#

#T=sybase_min_error_severity - void sybase_min_error_severity ( int severity)
(PHP 3, PHP 4 )
sybase_min_error_severity -- Sets minimum error severity
Description
void sybase_min_error_severity ( int severity)
sybase_min_error_severity() sets the minimum error severity level. 
See also sybase_min_message_severity().   sybase_min_client_severityUpsybase_min_message_severity
#

#T=void sybase_min_error_severity ( int severity)
sybase_min_error_severity ( ^!int severity);
#

#T=sybase_min_message_severity - void sybase_min_message_severity ( int severity)
(PHP 3, PHP 4 )
sybase_min_message_severity -- Sets minimum message severity
Description
void sybase_min_message_severity ( int severity)
sybase_min_message_severity() sets the minimum message severity level. 
See also sybase_min_error_severity().   sybase_min_error_severityUpsybase_min_server_severity
#

#T=void sybase_min_message_severity ( int severity)
sybase_min_message_severity ( ^!int severity);
#

#T=sybase_min_server_severity - void sybase_min_server_severity ( int severity)
(PHP 3, PHP 4 )
sybase_min_server_severity -- Sets minimum server severity
Description
void sybase_min_server_severity ( int severity)
sybase_min_server_severity() sets the minimum server severity level. 
Note: This function is only available using the CT library interface to 
Sybase, and not the DB library.
See also sybase_min_client_severity().   sybase_min_message_severityUpsybase_num_fields
#

#T=void sybase_min_server_severity ( int severity)
sybase_min_server_severity ( ^!int severity);
#

#T=sybase_num_fields - int sybase_num_fields ( resource result)
(PHP 3, PHP 4 )
sybase_num_fields -- Gets the number of fields in a result set
Description
int sybase_num_fields ( resource result)
sybase_num_fields() returns the number of fields in a result set. 
See also sybase_query(), sybase_fetch_field() and sybase_num_rows().   sybase_min_server_severityUpsybase_num_rows
#

#T=int sybase_num_fields ( resource result)
sybase_num_fields ( ^!resource result);
#

#T=sybase_num_rows - int sybase_num_rows ( resource result)
(PHP 3, PHP 4 )
sybase_num_rows -- Get number of rows in a result set
Description
int sybase_num_rows ( resource result)
sybase_num_rows() returns the number of rows in a result set. 
See also sybase_num_fields(), sybase_query() and sybase_fetch_row().   sybase_num_fieldsUpsybase_pconnect
#

#T=int sybase_num_rows ( resource result)
sybase_num_rows ( ^!resource result);
#

#T=sybase_pconnect - resource sybase_pconnect ( [string servername [, string username [, string 
(PHP 3, PHP 4 )
sybase_pconnect -- Open persistent Sybase connection
Description
resource sybase_pconnect ( [string servername [, string username [, string 
password [, string charset [, string appname]]]]])
Returns a positive Sybase persistent link identifier on success, or FALSE 
on error. 
sybase_pconnect() acts very much like sybase_connect() with two major 
differences. 
First, when connecting, the function would first try to find a 
(persistent) link that's already open with the same host, username and 
password. If one is found, an identifier for it will be returned instead 
of opening a new connection. 
Second, the connection to the SQL server will not be closed when the 
execution of the script ends. Instead, the link will remain open for 
future use (sybase_close() will not close links established by 
sybase_pconnect()()). 
This type of links is therefore called 'persistent'. 
See also sybase_connect().   sybase_num_rowsUpsybase_query
#

#T=resource sybase_pconnect ( [string servername [, string username [, string 
sybase_pconnect ( ^![string servername [, string username [, string ;
#

#T=sybase_query - resource sybase_query ( string query, resource link_identifier)
(PHP 3, PHP 4 )
sybase_query -- Sends a Sybase query
Description
resource sybase_query ( string query, resource link_identifier)
Returns a positive Sybase result identifier on success, or FALSE on error. 

sybase_query() sends a query to the currently active database on the 
server that's associated with the specified link identifier. If the link 
identifier isn't specified, the last opened link is assumed. If no link is 
open, the function tries to establish a link as if sybase_connect() was 
called, and use it. 
See also sybase_select_db() and sybase_connect().   sybase_pconnectUpsybase_result
#

#T=resource sybase_query ( string query, resource link_identifier)
sybase_query ( ^!string query, resource link_identifier);
#

#T=sybase_result - string sybase_result ( resource result, int row, mixed field)
(PHP 3, PHP 4 )
sybase_result -- Get result data
Description
string sybase_result ( resource result, int row, mixed field)
Returns the contents of the cell at the row and offset in the specified 
Sybase result set. 
sybase_result() returns the contents of one cell from a Sybase result set. 
The field argument can be the field's offset, or the field's name, or the 
field's table dot field's name (tablename.fieldname). If the column name 
has been aliased ('select foo as bar from...'), use the alias instead of 
the column name. 
When working on large result sets, you should consider using one of the 
functions that fetch an entire row (specified below). As these functions 
return the contents of multiple cells in one function call, they're MUCH 
quicker than sybase_result(). Also, note that specifying a numeric offset 
for the field argument is much quicker than specifying a fieldname or 
tablename.fieldname argument. 
Recommended high-performance alternatives: sybase_fetch_row(), 
sybase_fetch_array() and sybase_fetch_object().   sybase_queryUpsybase_select_db
#

#T=string sybase_result ( resource result, int row, mixed field)
sybase_result ( ^!resource result, int row, mixed field);
#

#T=sybase_select_db - bool sybase_select_db ( string database_name [, resource link_identifier])
(PHP 3, PHP 4 )
sybase_select_db -- Selects a Sybase database
Description
bool sybase_select_db ( string database_name [, resource link_identifier])
sybase_select_db() sets the current active database on the server that's 
associated with the specified link identifier. If no link identifier is 
specified, the last opened link is assumed. If no link is open, the 
function will try to establish a link as if sybase_connect() was called, 
and use it. 
Returns TRUE on success or FALSE on failure. 
Every subsequent call to sybase_query() will be made on the active 
database. 
See also sybase_connect(), sybase_pconnect() and sybase_query()   sybase_resultUpsybase_set_message_handler
#

#T=bool sybase_select_db ( string database_name [, resource link_identifier])
sybase_select_db ( ^!string database_name [, resource link_identifier]);
#

#T=sybase_set_message_handler - bool sybase_set_message_handler ( callback handler)
(PHP 4 >= 4.3.0)
sybase_set_message_handler -- Sets the handler called when a server 
message is raised
Description
bool sybase_set_message_handler ( callback handler)
sybase_set_message_handler() sets a user function to handle messages 
generated by the server. You may specify the name of a global function, or 
use an array to specify an object reference and a method name. 
The handler expects five arguments in the following order: message number, 
severity, state, line number and description. The first four are integers. 
The last is a string. If the function returns FALSE, PHP generates an 
ordinary error message. 
Returns TRUE on success or FALSE on failure. 
Example 1. sybase_set_message_handler() callback function
  <?php
      function msg_handler($msgnumber, $severity, $state, $line, 
  $text) {
	  var_dump($msgnumber, $severity, $state, $line, $text);
      }
      
      sybase_set_message_handler('msg_handler');
  ?> 

Example 2. sybase_set_message_handler() callback to a class
  <?php
      class Sybase {
	  function handler($msgnumber, $severity, $state, $line, 
  $text) {
	      var_dump($msgnumber, $severity, $state, $line, 
  $text);
	  }
      }
      
      $sybase= new Sybase();
      sybase_set_message_handler(array($sybase, 'handler'));
  ?> 

Example 3. sybase_set_message_handler() unhandled messages
  <?php
      // Return FALSE from this function to indicate you can't 
  handle
      // this. The error is printed out as a warning, the way 
  you're used
      // to it if there is no handler installed.
      function msg_handler($msgnumber, $severity, $state, $line, 
  $text) {
	  if (257 == $msgnumber) {
	      return false;
	  }
	  var_dump($msgnumber, $severity, $state, $line, $text);
      }
      
      sybase_set_message_handler('msg_handler');
  ?> 

  sybase_select_dbUpsybase_unbuffered_query
#

#T=bool sybase_set_message_handler ( callback handler)
sybase_set_message_handler ( ^!callback handler);
#

#T=sybase_unbuffered_query - resource sybase_unbuffered_query ( string query, resource link_identifier)
(PHP 4 >= 4.3.0)
sybase_unbuffered_query -- Send a Sybase query and do not block
Description
resource sybase_unbuffered_query ( string query, resource link_identifier)
Returns a positive Sybase result identifier on success, or FALSE on error. 

sybase_unbuffered_query() sends a query to the currently active database 
on the server that's associated with the specified link identifier. If the 
link identifier isn't specified, the last opened link is assumed. If no 
link is open, the function tries to establish a link as if 
sybase_connect() was called, and use it. 
Unlike sybase_query(), sybase_unbuffered_query() reads only the first row 
of the result set. sybase_fetch_array() and similar function read more 
rows as needed. sybase_data_seek() reads up to the target row. The 
behavior may produce better performance for large result sets. 
sybase_num_rows() will only return the correct number of rows if all 
result sets have been read. To Sybase, the number of rows is not known and 
is therefore computed by the client implementation. 
Note: If you don't read all of the resultsets prior to executing the 
next query, PHP will raise a warning and cancel all of the pending 
results. To get rid of this, use sybase_free_result() which will cancel 
pending results of an unbuffered query. 
The optional store_result can be FALSE to indicate the resultsets 
shouldn't be fetched into memory, thus minimizing memory usage which is 
particularly interesting with very large resultsets. 
Example 1. sybase_unbuffered_query() example
  <?php
	 $dbh= sybase_connect('SYBASE', '', '');
	 $q= sybase_unbuffered_query('select firstname, lastname 
  from huge_table', $dbh, false);
	 sybase_data_seek($q, 10000);
	 $i= 0;
	 while ($row= sybase_fetch_row($q)) {
		 echo $row[0] . ' ' . $row[0];
		 if ($i++ > 40000) break;
	 }
	 sybase_free_result($q);
	 sybase_close($dbh);
  ?> 

  sybase_set_message_handlerUptidy Functions
#

#T=resource sybase_unbuffered_query ( string query, resource link_identifier)
sybase_unbuffered_query ( ^!string query, resource link_identifier);
#

#T=symlink - bool symlink ( string target, string link)
(PHP 3, PHP 4 )
symlink -- Creates a symbolic link
Description
bool symlink ( string target, string link)
symlink() creates a symbolic link from the existing target with the 
specified name link. 
Returns TRUE on success or FALSE on failure. 
See also link() to create hard links, and readlink() along with 
linkinfo().   statUptempnam
#

#T=bool symlink ( string target, string link)
symlink ( ^!string target, string link);
#

#T=syslog - int syslog ( int priority, string message)
(PHP 3, PHP 4 )
syslog -- Generate a system log message
Description
int syslog ( int priority, string message)
syslog() generates a log message that will be distributed by the system 
logger. priority is a combination of the facility and the level, values 
for which are given in the next section. The remaining argument is the 
message to send, except that the two characters %m will be replaced by the 
error message string (strerror) corresponding to the present value of 
errno. 
Table 1. syslog() Priorities (in descending order)
ConstantDescription
LOG_EMERGsystem is unusable
LOG_ALERTaction must be taken immediately
LOG_CRITcritical conditions
LOG_ERRerror conditions
LOG_WARNINGwarning conditions
LOG_NOTICEnormal, but significant, condition
LOG_INFOinformational message
LOG_DEBUGdebug-level message

Example 1. Using syslog()
  <?php
  define_syslog_variables();
  // open syslog, include the process ID and also send
  // the log to standard error, and use a user defined
  // logging mechanism
  openlog("myScripLog", LOG_PID | LOG_PERROR, LOG_LOCAL0);

  // some code

  if (authorized_client()) {
      // do something
  } else {
      // unauthorized client!
      // log the attempt
      $access = date("Y/m/d H:i:s");
      syslog(LOG_WARNING, "Unauthorized client: $access 
  $REMOTE_ADDR ($HTTP_USER_AGENT)");
  }

  closelog();
  ?> 

For information on setting up a user defined log handler, see the 
syslog.conf(5) Unix manual page. More information on the syslog facilities 
and option can be found in the man pages for syslog(3) on Unix machines. 
On Windows NT, the syslog service is emulated using the Event Log. 
Note: Use of LOG_LOCAL0 through LOG_LOCAL7 for the facility parameter of 
openlog() is not available in Windows. 
See also define_syslog_variables(), openlog() and closelog().   socket_set_timeoutUpNcurses terminal screen control functions
#

#T=int syslog ( int priority, string message)
syslog ( ^!int priority, string message);
#

#T=system - string system ( string command [, int return_var])
(PHP 3, PHP 4 )
system -- Execute an external program and display the output
Description
string system ( string command [, int return_var])
system() is just like the C version of the function in that it executes 
the given command and outputs the result. If a variable is provided as the 
second argument, then the return status code of the executed command will 
be written to this variable. 
Warning
If you are going to allow data coming from user input to be passed 
to this function, then you should be using escapeshellarg() or 
escapeshellcmd() to make sure that users cannot trick the system 
into executing arbitrary commands. 

Note: If you start a program using this function and want to leave it 
running in the background, you have to make sure that the output of that 
program is redirected to a file or some other output stream or else PHP 
will hang until the execution of the program ends. 
The system() call also tries to automatically flush the web server's 
output buffer after each line of output if PHP is running as a server 
module. 
Returns the last line of the command output on success, and FALSE on 
failure. 
If you need to execute a command and have all the data from the command 
passed directly back without any interference, use the passthru() 
function. 
Example 1. system() example
  <?php
  echo '<pre>';

  // Outputs all the result of shellcommand "ls", and returns
  // the last output line into $last_line. Stores the return 
  value
  // of the shell command in $retval.
  $last_line = system('ls', $retval);

  // Printing additional info
  echo '
  </pre>
  <hr />Last line of the output: ' . $last_line . '
  <hr />Return value: ' . $retval;
  ?> 
Note: When safe mode is enabled, you can only execute executables within 
the safe_mode_exec_dir. For practical reasons it's currently not allowed 
to have .. components in the path to the executable. 
See also exec(), passthru(), popen(), escapeshellcmd(), and the backtick 
operator.   shell_execUpPrinter functions
#

#T=string system ( string command [, int return_var])
system ( ^!string command [, int return_var]);
#

#T=tan - float tan ( float arg)
(PHP 3, PHP 4 )
tan -- Tangent
Description
float tan ( float arg)
tan() returns the tangent of the arg parameter. The arg parameter is in 
radians. 
Example 1. tan() example
  <?php

  echo tan(M_PI_2); // 1

  ?> 
See also atan(), sin(), cos() and deg2rad().   srandUptanh
#

#T=float tan ( float arg)
tan ( ^!float arg);
#

#T=tanh - float tanh ( float arg)
(PHP 4 >= 4.1.0)
tanh -- Hyperbolic tangent
Description
float tanh ( float arg)
Returns the hyperbolic tangent of arg, defined as sinh(arg)/cosh(arg). 
See also tan(), atanh(), sin() and cos().   tanUpMulti-Byte String Functions
#

#T=float tanh ( float arg)
tanh ( ^!float arg);
#

#T=tempnam - string tempnam ( string dir, string prefix)
(PHP 3, PHP 4 )
tempnam -- Create file with unique file name
Description
string tempnam ( string dir, string prefix)
Creates a file with a unique filename in the specified directory. If the 
directory does not exist, tempnam() may generate a file in the system's 
temporary directory, and return the name of that. 
Prior to PHP 4.0.6, the behaviour of the tempnam() function was system 
dependent. On Windows the TMP environment variable will override the dir 
parameter, on Linux the TMPDIR environment variable has precedence, while 
SVR4 will always use your dir parameter if the directory it points to 
exists. Consult your system documentation on the tempnam(3) function if in 
doubt. 
Note: If PHP cannot create a file in the specified dir parameter, it 
falls back on the system default. 
Returns the new temporary filename, or the FALSE string on failure. 
Example 1. tempnam() example
  <?php
  $tmpfname = tempnam("/tmp", "FOO");

  $handle = fopen($tmpfname, "w");
  fwrite($handle, "writing to tempfile");
  fclose($handle);

  // do here something

  unlink($tmpfname);
  ?> 
Note: This function's behavior changed in 4.0.3. The temporary file is 
also created to avoid a race condition where the file might appear in 
the filesystem between the time the string was generated and before the 
the script gets around to creating the file. Note, that you need to 
remove the file in case you need it no more, it is not done 
automatically. 
See also tmpfile() and unlink().   symlinkUptmpfile
#

#T=string tempnam ( string dir, string prefix)
tempnam ( ^!string dir, string prefix);
#

#T=textdomain - string textdomain ( string text_domain)
(PHP 3>= 3.0.7, PHP 4 )
textdomain -- Sets the default domain
Description
string textdomain ( string text_domain)
This function sets the domain to search within when calls are made to 
gettext(), usually the named after an application. The previous default 
domain is returned. Call it with NULL as parameter to get the current 
setting without changing it.   ngettextUpGMP functions
tidy_access_count
(no version information, might be only in CVS)
tidy_access_count --  Returns the Number of Tidy accessibility warnings 
encountered for specified document. 
Description
int tidy_access_count ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy FunctionsUptidy_clean_repair
tidy_clean_repair
(no version information, might be only in CVS)
tidy_clean_repair --  Execute configured cleanup and repair operations on 
parsed markup 
Description
bool tidy_clean_repair ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_access_countUptidy_config_count
tidy_config_count
(no version information, might be only in CVS)
tidy_config_count --  Returns the Number of Tidy configuration errors 
encountered for specified document. 
Description
int tidy_config_count ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_clean_repairUptidy_diagnose
tidy_diagnose
(no version information, might be only in CVS)
tidy_diagnose --  Run configured diagnostics on parsed and repaired 
markup. 
Description
bool tidy_diagnose ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_config_countUptidy_error_count
tidy_error_count
(no version information, might be only in CVS)
tidy_error_count --  Returns the Number of Tidy errors encountered for 
specified document. 
Description
int tidy_error_count ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_diagnoseUptidy_get_body
tidy_get_body
(no version information, might be only in CVS)
tidy_get_body --  Returns a TidyNode Object starting from the >BODY< tag 
of the tidy parse tree 
Description
object tidy_get_body ( resource tidy)
Warning
This function is currently not documented; only the argument list is 
available.

Note: This function is only available with Zend Engine 2, this means PHP 
>= 5.0.0.  tidy_error_countUptidy_get_config
tidy_get_config
(no version information, might be only in CVS)
tidy_get_config --  Get current Tidy configuration 
Description
array tidy_get_config ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_get_bodyUptidy_get_error_buffer
tidy_get_error_buffer
(no version information, might be only in CVS)
tidy_get_error_buffer --  Return warnings and errors which occurred 
parsing the specified document 
Description
string tidy_get_error_buffer ( [bool detailed])
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_get_configUptidy_get_head
tidy_get_head
(no version information, might be only in CVS)
tidy_get_head --  Returns a TidyNode Object starting from the >HEAD< tag 
of the tidy parse tree 
Description
object tidy_get_head ( void )
Warning
This function is currently not documented; only the argument list is 
available.

Note: This function is only available with Zend Engine 2, this means PHP 
>= 5.0.0.  tidy_get_error_bufferUptidy_get_html_ver
tidy_get_html_ver
(no version information, might be only in CVS)
tidy_get_html_ver --  Get the Detected HTML version for the specified 
document. 
Description
int tidy_get_html_ver ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_get_headUptidy_get_html
tidy_get_html
(no version information, might be only in CVS)
tidy_get_html --  Returns a TidyNode Object starting from the >HTML< tag 
of the tidy parse tree 
Description
object tidy_get_html ( void )
Warning
This function is currently not documented; only the argument list is 
available.

Note: This function is only available with Zend Engine 2, this means PHP 
>= 5.0.0.  tidy_get_html_verUptidy_get_output
tidy_get_output
(no version information, might be only in CVS)
tidy_get_output --  Return a string representing the parsed tidy markup 
Description
string tidy_get_output ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_get_htmlUptidy_get_release
tidy_get_release
(no version information, might be only in CVS)
tidy_get_release --  Get release date (version) for Tidy library 
Description
string tidy_get_release ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_get_outputUptidy_get_root
tidy_get_root
(no version information, might be only in CVS)
tidy_get_root --  Returns a TidyNode Object representing the root of the 
tidy parse tree 
Description
object tidy_get_root ( void )
Warning
This function is currently not documented; only the argument list is 
available.

Note: This function is only available with Zend Engine 2, this means PHP 
>= 5.0.0.  tidy_get_releaseUptidy_get_status
tidy_get_status
(no version information, might be only in CVS)
tidy_get_status --  Get status of specified document. 
Description
int tidy_get_status ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_get_rootUptidy_getopt
tidy_getopt
(no version information, might be only in CVS)
tidy_getopt --  Returns the value of the specified configuration option 
for the tidy document. 
Description
mixed tidy_getopt ( string option)
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_get_statusUptidy_is_xhtml
tidy_is_xhtml
(no version information, might be only in CVS)
tidy_is_xhtml --  Indicates if the document is a generic (non HTML/XHTML) 
XML document. 
Description
bool tidy_is_xhtml ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_getoptUptidy_load_config
tidy_load_config
(no version information, might be only in CVS)
tidy_load_config --  Load an ASCII Tidy configuration file with the 
specified encoding 
Description
void tidy_load_config ( string filename, string encoding)
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_is_xhtmlUptidy_node->attributes
tidy_node->attributes
(no version information, might be only in CVS)
tidy_node->attributes --  Returns an array of attribute objects for node 
Description
array tidy_node->attributes ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_load_configUptidy_node->children
tidy_node->children
(no version information, might be only in CVS)
tidy_node->children --  Returns an array of child nodes 
Description
array tidy_node->children ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->attributesUptidy_node->get_attr
tidy_node->get_attr
(no version information, might be only in CVS)
tidy_node->get_attr --  Return the attribute with the provided attribute 
id 
Description
tidy_attr tidy_node->get_attr ( int attrib_id)
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->childrenUptidy_node->get_nodes
tidy_node->get_nodes
(no version information, might be only in CVS)
tidy_node->get_nodes --  Return an array of nodes under this node with the 
specified id 
Description
array tidy_node->get_nodes ( int node_id)
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->get_attrUptidy_node->has_children
tidy_node->has_children
(no version information, might be only in CVS)
tidy_node->has_children --  Returns true if this node has children 
Description
bool tidy_node->has_children ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->get_nodesUptidy_node->has_siblings
tidy_node->has_siblings
(no version information, might be only in CVS)
tidy_node->has_siblings --  Returns true if this node has siblings 
Description
bool tidy_node->has_siblings ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->has_childrenUptidy_node->is_asp
tidy_node->is_asp
(no version information, might be only in CVS)
tidy_node->is_asp --  Returns true if this node is ASP 
Description
bool tidy_node->is_asp ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->has_siblingsUptidy_node->is_comment
tidy_node->is_comment
(no version information, might be only in CVS)
tidy_node->is_comment --  Returns true if this node represents a comment 
Description
bool tidy_node->is_comment ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_aspUptidy_node->is_html
tidy_node->is_html
(no version information, might be only in CVS)
tidy_node->is_html --  Returns true if this node is part of a HTML 
document 
Description
bool tidy_node->is_html ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_commentUptidy_node->is_jsp
tidy_node->is_jsp
(no version information, might be only in CVS)
tidy_node->is_jsp --  Returns true if this node is JSP 
Description
bool tidy_node->is_jsp ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_htmlUptidy_node->is_jste
tidy_node->is_jste
(no version information, might be only in CVS)
tidy_node->is_jste --  Returns true if this node is JSTE 
Description
bool tidy_node->is_jste ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_jspUptidy_node->is_text
tidy_node->is_text
(no version information, might be only in CVS)
tidy_node->is_text --  Returns true if this node represents text (no 
markup) 
Description
bool tidy_node->is_text ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_jsteUptidy_node->is_xhtml
tidy_node->is_xhtml
(no version information, might be only in CVS)
tidy_node->is_xhtml --  Returns true if this node is part of a XHTML 
document 
Description
bool tidy_node->is_xhtml ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_textUptidy_node->is_xml
tidy_node->is_xml
(no version information, might be only in CVS)
tidy_node->is_xml --  Returns true if this node is part of a XML document 
Description
bool tidy_node->is_xml ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_xhtmlUptidy_node->next
tidy_node->next
(no version information, might be only in CVS)
tidy_node->next --  Returns the next sibling to this node 
Description
tidy_node tidy_node->next ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->is_xmlUptidy_node->prev
tidy_node->prev
(no version information, might be only in CVS)
tidy_node->prev --  Returns the previous sibling to this node 
Description
tidy_node tidy_node->prev ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->nextUptidy_node->tidy_node
tidy_node->tidy_node
(no version information, might be only in CVS)
tidy_node->tidy_node --  Constructor. 
Description
void tidy_node->tidy_node ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->prevUptidy_parse_file
tidy_parse_file
(no version information, might be only in CVS)
tidy_parse_file --  Parse markup in file or URI 
Description
bool tidy_parse_file ( string file [, bool use_include_path])
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_node->tidy_nodeUptidy_parse_string
tidy_parse_string
(no version information, might be only in CVS)
tidy_parse_string --  Parse a document stored in a string 
Description
bool tidy_parse_string ( string input)
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_parse_fileUptidy_repair_file
tidy_repair_file
(no version information, might be only in CVS)
tidy_repair_file --  Repair a file using an optionally provided 
configuration file 
Description
bool tidy_repair_file ( string filename [, string config_file [, bool 
use_include_path]])
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_parse_stringUptidy_repair_string
tidy_repair_string
(no version information, might be only in CVS)
tidy_repair_string --  Repair a string using an optionally provided 
configuration file 
Description
bool tidy_repair_string ( string data [, string config_file])
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_repair_fileUptidy_reset_config
tidy_reset_config
(no version information, might be only in CVS)
tidy_reset_config --  Restore Tidy configuration to default values 
Description
string tidy_reset_config ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_repair_stringUptidy_save_config
tidy_save_config
(no version information, might be only in CVS)
tidy_save_config --  Save current settings to named file. Only non-default 
values are written. 
Description
bool tidy_save_config ( string filename)
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_reset_configUptidy_set_encoding
tidy_set_encoding
(no version information, might be only in CVS)
tidy_set_encoding --  Set the input/output character encoding for parsing 
markup. 
Description
bool tidy_set_encoding ( string encoding)
Sets the encoding for input/output documents. Returns TRUE on success or 
FALSE on failure. Possible values for encoding are ascii, latin1, raw, 
utf8, iso2022, mac, win1252, utf16le, utf16be, utf16, big5, and shiftjis.   tidy_save_configUptidy_setopt
tidy_setopt
(no version information, might be only in CVS)
tidy_setopt --  Updates the configuration settings for the specified tidy 
document. 
Description
bool tidy_setopt ( string option, mixed newvalue)
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_set_encodingUptidy_warning_count
tidy_warning_count
(no version information, might be only in CVS)
tidy_warning_count --  Returns the Number of Tidy warnings encountered for 
specified document. 
Description
int tidy_warning_count ( void )
Warning
This function is currently not documented; only the argument list is 
available.
  tidy_setoptUpTokenizer functions
#

#T=string textdomain ( string text_domain)
textdomain ( ^!string text_domain);
#

#T=time - int time ( void )
(PHP 3, PHP 4 )
time -- Return current Unix timestamp
Description
int time ( void )
Returns the current time measured in the number of seconds since the Unix 
Epoch (January 1 1970 00:00:00 GMT). 
See also date() and microtime().   strtotimeUpdBase functions
#

#T=int time ( void )
time ( ^!void );
#

#T=tmpfile - resource tmpfile ( void )
(PHP 3>= 3.0.13, PHP 4 )
tmpfile -- Creates a temporary file
Description
resource tmpfile ( void )
Creates a temporary file with an unique name in write mode, returning a 
file handle similar to the one returned by fopen(). The file is 
automatically removed when closed (using fclose()), or when the script 
ends. 
For details, consult your system documentation on the tmpfile(3) function, 
as well as the stdio.h header file. 
Example 1. tmpfile() example
  <?php
  $temp = tmpfile();
  fwrite($temp, "writing to tempfile");
  fclose($temp); // this removes the file
  ?> 
See also tempnam().   tempnamUptouch
#

#T=resource tmpfile ( void )
tmpfile ( ^!void );
#

#T=token_get_all - array token_get_all ( string source)
(PHP 4 >= 4.2.0)
token_get_all -- Split given source into PHP tokens
Description
array token_get_all ( string source)
token_get_all() parses the given source string into PHP language tokens 
using the Zend engine's lexical scanner. The function returns an array of 
token identifiers. Each individual token identifier is either a single 
character (i.e.: ;, ., >, !, etc...), or a two element array containing 
the token index in element 0, and the string content of the original token 
in element 1. 
For a list of parser tokens, see Appendix L, or use token_name() to 
translate a token value into its string representation. 
Example 1. token_get_all() examples
  <?php
    $tokens = token_get_all('<?'); // => array(array(T_OPEN_TAG, 
  '<?'));
    $tokens = token_get_all('<? echo; ?>'); /* => array(
						      
  array(T_OPEN_TAG, '<?'), 
						      
  array(T_ECHO, 'echo'),
						      ';',
						      
  array(T_CLOSE_TAG, '?>') ); */

  /* Note in the following example that the string is parsed as 
  T_INLINE_HTML
     rather than the otherwise expected T_ML_COMMENT.
     This is because no open/close tags were used in the "code" 
  provided.
     This would be equivalent to putting a comment outside of <? 
  ?> tags in a normal file. */
    $tokens = token_get_all('/* comment */'); // => 
  array(array(T_INLINE_HTML, '/* comment */'));
  ?> 

  Tokenizer functionsUptoken_name
#

#T=array token_get_all ( string source)
token_get_all ( ^!string source);
#

#T=token_name - string token_name ( int token)
(PHP 4 >= 4.2.0)
token_name -- Get the symbolic name of a given PHP token
Description
string token_name ( int token)
token_name() returns the symbolic name for a PHP token value. The symbolic 
name returned matches the name of the matching token constant. 
Example 1. token_name() example
  <?php
    // 260 is the token value for the T_REQUIRE token
    echo token_name(260);        // -> "T_REQUIRE"

    // a token constant maps to its own name
    echo token_name(T_FUNCTION); // -> "T_FUNCTION"
  ?> 

  token_get_allUpURL Functions
#

#T=string token_name ( int token)
token_name ( ^!int token);
#

#T=touch - bool touch ( string filename [, int time [, int atime]])
(PHP 3, PHP 4 )
touch -- Sets access and modification time of file
Description
bool touch ( string filename [, int time [, int atime]])
Attempts to set the access and modification time of the file named by 
filename to the value given by time. If the option time is not given, uses 
the present time. This is equivalent to what utime (sometimes referred to 
as utimes) does. If the third option atime is present, the access time of 
the given filename is set to the value of atime. Note that the access time 
is always modified, regardless of the number of parameters. 
If the file does not exist, it is created. Returns TRUE on success or 
FALSE on failure. 
Example 1. touch() example
  <?php
  if (touch($FileName)) {
      echo "$FileName modification time has been 
	     changed to todays date and time";
  } else {
      echo "Sorry Could Not change modification time of 
  $FileName";
  }
  ?> 

  tmpfileUpumask
#

#T=bool touch ( string filename [, int time [, int atime]])
touch ( ^!string filename [, int time [, int atime]]);
#

#T=trigger_error - void trigger_error ( string error_msg [, int error_type])
(PHP 4 >= 4.0.1)
trigger_error --  Generates a user-level error/warning/notice message 
Description
void trigger_error ( string error_msg [, int error_type])
Used to trigger a user error condition, it can be used by in conjunction 
with the built-in error handler, or with a user defined function that has 
been set as the new error handler (set_error_handler()). It only works 
with the E_USER family of constants, and will default to E_USER_NOTICE. 
This function is useful when you need to generate a particular response to 
an exception at runtime. For example: 
<?php
if (assert($divisor == 0)) {
trigger_error("Cannot divide by zero", E_USER_ERROR);
}
?> 

Note: See set_error_handler() for a more extensive example. 
Note: error_msg is limited to 1024 characters in length. Any additional 
characters beyond 1024 will be truncated. 
See also error_reporting(), set_error_handler(), restore_error_handler(), 
and error level constants.   set_error_handlerUpuser_error
#

#T=void trigger_error ( string error_msg [, int error_type])
trigger_error ( ^!string error_msg [, int error_type]);
#

#T=trim - string trim ( string str [, string charlist])
(PHP 3, PHP 4 )
trim --  Strip whitespace from the beginning and end of a string 
Description
string trim ( string str [, string charlist])
Note: The optional charlist parameter was added in PHP 4.1.0 
This function returns a string with whitespace stripped from the beginning 
and end of str. Without the second parameter, trim() will strip these 
characters: 
" " (ASCII 32 (0x20)), an ordinary space. 
"\t" (ASCII 9 (0x09)), a tab. 
"\n" (ASCII 10 (0x0A)), a new line (line feed). 
"\r" (ASCII 13 (0x0D)), a carriage return. 
"\0" (ASCII 0 (0x00)), the NUL-byte. 
"\x0B" (ASCII 11 (0x0B)), a vertical tab. 
You can also specify the characters you want to strip, by means of the 
charlist parameter. Simply list all characters that you want to be 
stripped. With .. you can specify a range of characters. 
Example 1. Usage example of trim()
  <?php

  $text = "\t\tThese are a few words :) ...  ";
  $trimmed = trim($text);
  // $trimmed = "These are a few words :) ..."
  $trimmed = trim($text, " \t.");
  // $trimmed = "These are a few words :)"
  $clean = trim($binary, "\0x00..\0x1F");
  // trim the ASCII control characters at the beginning and end 
  of $binary
  // (from 0 to 31 inclusive)

  ?> 
See also ltrim() and rtrim().   substrUpucfirst
#

#T=string trim ( string str [, string charlist])
trim ( ^!string str [, string charlist]);
#

#T=uasort - bool uasort ( array array, callback cmp_function)
(PHP 3>= 3.0.4, PHP 4 )
uasort --  Sort an array with a user-defined comparison function and 
maintain index association 
Description
bool uasort ( array array, callback cmp_function)
This function sorts an array such that array indices maintain their 
correlation with the array elements they are associated with. This is used 
mainly when sorting associative arrays where the actual element order is 
significant. The comparison function is user-defined. 
Returns TRUE on success or FALSE on failure. 
Note: Please see usort() and uksort() for examples of user-defined 
comparison functions. 
See also usort(), uksort(), sort(), asort(), arsort(), ksort(), and 
rsort().   sortUpuksort
#

#T=bool uasort ( array array, callback cmp_function)
uasort ( ^!array array, callback cmp_function);
#

#T=ucfirst - string ucfirst ( string str)
(PHP 3, PHP 4 )
ucfirst -- Make a string's first character uppercase
Description
string ucfirst ( string str)
Returns a string with the first character of str capitalized, if that 
character is alphabetic. 
Note that 'alphabetic' is determined by the current locale. For instance, 
in the default "C" locale characters such as umlaut-a () will not be 
converted. Example 1. ucfirst() example
  <?php
  $foo = 'hello world!';
  $foo = ucfirst($foo);             // Hello world!

  $bar = 'HELLO WORLD!';
  $bar = ucfirst($bar);             // HELLO WORLD!
  $bar = ucfirst(strtolower($bar)); // Hello world!
  ?> 
See also strtolower(), strtoupper(), and ucwords().   trimUpucwords
#

#T=string ucfirst ( string str)
ucfirst ( ^!string str);
#

#T=ucwords - string ucwords ( string str)
(PHP 3>= 3.0.3, PHP 4 )
ucwords --  Uppercase the first character of each word in a string 
Description
string ucwords ( string str)
Returns a string with the first character of each word in str capitalized, 
if that character is alphabetic. 
The definition of a word is any string of characters that is immediately 
after a whitespace (These are: space, form-feed, newline, carriage return, 
horizontal tab, and vertical tab). 
Example 1. ucwords() example
  <?php
  $foo = 'hello world!';
  $foo = ucwords($foo);             // Hello World! 

  $bar = 'HELLO WORLD!';
  $bar = ucwords($bar);             // HELLO WORLD!
  $bar = ucwords(strtolower($bar)); // Hello World!
  ?> 
See also strtoupper(), strtolower() and ucfirst().   ucfirstUpvprintf
#

#T=string ucwords ( string str)
ucwords ( ^!string str);
#

#T=udm_add_search_limit - bool udm_add_search_limit ( resource agent, int var, string val)
(PHP 4 >= 4.0.5)
udm_add_search_limit -- Add various search limits
Description
bool udm_add_search_limit ( resource agent, int var, string val)
udm_add_search_limit() adds search restrictions. Returns TRUE on success 
or FALSE on failure. 
agent - a link to Agent, received after call to udm_alloc_agent(). 
var - defines parameter, indicating limit. 
val - defines the value of the current parameter. 
Possible var values: 
UDM_LIMIT_URL - defines document URL limitations to limit the search 
through subsection of the database. It supports SQL % and _ LIKE 
wildcards, where % matches any number of characters, even zero 
characters, and _ matches exactly one character. E.g. 
http://www.example.___/catalog may stand for 
http://www.example.com/catalog and http://www.example.net/catalog. 
UDM_LIMIT_TAG - defines site TAG limitations. In indexer-conf you can 
assign specific TAGs to various sites and parts of a site. Tags in 
mnoGoSearch 3.1.x are lines, that may contain metasymbols % and _. 
Metasymbols allow searching among groups of tags. E.g. there are links 
with tags ABCD and ABCE, and search restriction is by ABC_ - the search 
will be made among both of the tags. 
UDM_LIMIT_LANG - defines document language limitations. 
UDM_LIMIT_CAT - defines document category limitations. Categories are 
similar to tag feature, but nested. So you can have one category inside 
another and so on. You have to use two characters for each level. Use a 
hex number going from 0-F or a 36 base number going from 0-Z. Therefore 
a top-level category like 'Auto' would be 01. If it has a subcategory 
like 'Ford', then it would be 01 (the parent category) and then 'Ford' 
which we will give 01. Put those together and you get 0101. If 'Auto' 
had another subcategory named 'VW', then it's id would be 01 because it 
belongs to the 'Ford' category and then 02 because it's the next 
category. So it's id would be 0102. If VW had a sub category called 
'Engine' then it's id would start at 01 again and it would get the 'VW' 
id 02 and 'Auto' id of 01, making it 010201. If you want to search for 
sites under that category then you pass it cat=010201 in the url. 
UDM_LIMIT_DATE - defines limitation by date the document was modified. 
Format of parameter value: a string with first character < or >, then 
with no space - date in unixtime format, for example: 
Example 1. 
    <?php
	  Udm_Add_Search_Limit($udm, UDM_LIMIT_DATE, 
    "&lt;908012006");
    ?> 
If > character is used, then the search will be restricted to those 
documents having a modification date greater than entered, if <, then 
smaller.   mnoGoSearch FunctionsUpudm_alloc_agent
#

#T=bool udm_add_search_limit ( resource agent, int var, string val)
udm_add_search_limit ( ^!resource agent, int var, string val);
#

#T=udm_alloc_agent - resource udm_alloc_agent ( string dbaddr [, string dbmode])
(PHP 4 >= 4.0.5)
udm_alloc_agent -- Allocate mnoGoSearch session
Description
resource udm_alloc_agent ( string dbaddr [, string dbmode])
Returns a mnogosearch agent identifier on success, FALSE on failure. This 
function creates a session with database parameters. 
dbaddr - URL-style database description, with options (type, host, 
database name, port, user and password) to connect to SQL database. Do not 
matter for built-in text files support. Format for dbaddr: 
DBType:[//[DBUser[:DBPass]@]DBHost[:DBPort]]/DBName/. Currently supported 
DBType values are: mysql, pgsql, msql, solid, mssql, oracle, and ibase. 
Actually, it does not matter for native libraries support, but ODBC users 
should specify one of the supported values. If your database type is not 
supported, you may use unknown instead. 
dbmode - You may select the SQL database mode of words storage. Possible 
values of dbmode are: single, multi, crc, or crc-multi. When single is 
specified, all words are stored in the same table. If multi is selected, 
words will be located in different tables depending of their lengths. 
"multi" mode is usually faster, but requires more tables in the database. 
If "crc" mode is selected, mnoGoSearch will store 32 bit integer word IDs 
calculated by CRC32 algorithm instead of words. This mode requires less 
disk space and it is faster comparing with "single" and "multi" modes. 
crc-multi uses the same storage structure with the "crc" mode, but also 
stores words in different tables depending on words lengths like in 
"multi" mode. 
Note: dbaddr and dbmode must match those used during indexing. 
Note: In fact this function does not open a connection to the database 
and thus does not check the entered login and password. Establishing a 
connection to the database and login/password verification is done by 
udm_find().   udm_add_search_limitUpudm_api_version
#

#T=resource udm_alloc_agent ( string dbaddr [, string dbmode])
udm_alloc_agent ( ^!string dbaddr [, string dbmode]);
#

#T=udm_api_version - int udm_api_version ( void )
(PHP 4 >= 4.0.5)
udm_api_version -- Get mnoGoSearch API version.
Description
int udm_api_version ( void )
udm_api_version() returns the mnoGoSearch API version number. E.g. if 
mnoGoSearch 3.1.10 API is used, this function will return 30110. 
This function allows the user to identify which API functions are 
available, e.g. udm_get_doc_count() function is only available in 
mnoGoSearch 3.1.11 or later. 
Example 1. udm_api_version() example
  <?php
  if (udm_api_version() >= 30111) {
      echo  "Total number of urls in database: " . 
  udm_get_doc_count($udm) . "<br \>\n";
  }
  ?> 

  udm_alloc_agentUpudm_cat_list
#

#T=int udm_api_version ( void )
udm_api_version ( ^!void );
#

#T=udm_cat_list - array udm_cat_list ( resource agent, string category)
(PHP 4 >= 4.0.6)
udm_cat_list -- Get all the categories on the same level with the current 
one.
Description
array udm_cat_list ( resource agent, string category)
Returns an array listing all categories of the same level as the current 
category in the categories tree. agent is the agent identifier returned by 
a previous call to >udm_alloc_agent(). 
The function can be useful for developing categories tree browser. 
The returned array consists of pairs. Elements with even index numbers 
contain the category paths, odd elements contain the corresponding 
category names. 
$array[0] will contain '020300'
$array[1] will contain 'Audi'
$array[2] will contain '020301'
$array[3] will contain 'BMW'
$array[4] will contain '020302'
$array[5] will contain 'Opel'
...
etc.

Following is an example of displaying links of the current level in 
format: Audi
BMW
Opel
...
Example 1. udm_cat_list()example
  <?php
  $cat_list_arr = udm_cat_list($udm_agent, $cat);
  $cat_list = '';
  for ($i=0; $i<count($cat_list_arr); $i+=2) {
      $path = $cat_list_arr[$i];
      $name = $cat_list_arr[$i+1];
      $cat_list .= "<a 
  href=\"$_SERVER[PHP_SELF]?cat=$path\">$name</a><br />";
  }
  ?> 
See also udm_cat_path().   udm_api_versionUpudm_cat_path
#

#T=array udm_cat_list ( resource agent, string category)
udm_cat_list ( ^!resource agent, string category);
#

#T=udm_cat_path - array udm_cat_path ( resource agent, string category)
(PHP 4 >= 4.0.6)
udm_cat_path -- Get the path to the current category.
Description
array udm_cat_path ( resource agent, string category)
Returns an array describing the path in the categories tree from the tree 
root to the current one, specified by category. agent is the agent 
identifier returned by a previous call to >udm_alloc_agent(). 
The returned array consists of pairs. Elements with even index numbers 
contain the category paths, odd elements contain the corresponding 
category names. 
For example, the call $array=udm_cat_path($agent, '02031D'); may return 
the following array: $array[0] will contain ''
$array[1] will contain 'Root'
$array[2] will contain '02'
$array[3] will contain 'Sport'
$array[4] will contain '0203'
$array[5] will contain 'Auto'
$array[4] will contain '02031D'
$array[5] will contain 'Ferrari'

Example 1. Specifying path to the current category in the following 
format: '> Root > Sport > Auto > Ferrari' 
  <?php
    $cat_path_arr = udm_cat_path($udm_agent, $cat);
    $cat_path = '';
    for ($i=0; $i<count($cat_path_arr); $i+=2) {
      $path = $cat_path_arr[$i];
      $name = $cat_path_arr[$i+1];
      $cat_path .= " > <a 
  href=\"$_SERVER[PHP_SELF]?cat=$path\">$name</a> ";
    }
  ?> 
See also udm_cat_list().   udm_cat_listUpudm_check_charset
#

#T=array udm_cat_path ( resource agent, string category)
udm_cat_path ( ^!resource agent, string category);
#

#T=udm_check_charset - bool udm_check_charset ( resource agent, string charset)
(PHP 4 >= 4.2.0)
udm_check_charset --  Check if the given charset is known to mnogosearch 
Description
bool udm_check_charset ( resource agent, string charset)
Warning
This function is currently not documented; only the argument list is 
available.
  udm_cat_pathUpudm_check_stored
#

#T=bool udm_check_charset ( resource agent, string charset)
udm_check_charset ( ^!resource agent, string charset);
#

#T=udm_check_stored - int udm_check_stored ( resource agent, int link, string doc_id)
(PHP 4 >= 4.2.0)
udm_check_stored --  Check connection to stored 
Description
int udm_check_stored ( resource agent, int link, string doc_id)
Warning
This function is currently not documented; only the argument list is 
available.
  udm_check_charsetUpudm_clear_search_limits
#

#T=int udm_check_stored ( resource agent, int link, string doc_id)
udm_check_stored ( ^!resource agent, int link, string doc_id);
#

#T=udm_clear_search_limits - bool udm_clear_search_limits ( resource agent)
(PHP 4 >= 4.0.5)
udm_clear_search_limits -- Clear all mnoGoSearch search restrictions
Description
bool udm_clear_search_limits ( resource agent)
udm_clear_search_limits() resets defined search limitations and returns 
TRUE. 
See also udm_add_search_limit().   udm_check_storedUpudm_close_stored
#

#T=bool udm_clear_search_limits ( resource agent)
udm_clear_search_limits ( ^!resource agent);
#

#T=udm_close_stored - int udm_close_stored ( resource agent, int link)
(PHP 4 >= 4.2.0)
udm_close_stored --  Close connection to stored 
Description
int udm_close_stored ( resource agent, int link)
Warning
This function is currently not documented; only the argument list is 
available.
  udm_clear_search_limitsUpudm_crc32
#

#T=int udm_close_stored ( resource agent, int link)
udm_close_stored ( ^!resource agent, int link);
#

#T=udm_crc32 - int udm_crc32 ( resource agent, string str)
(PHP 4 >= 4.2.0)
udm_crc32 --  Return CRC32 checksum of given string 
Description
int udm_crc32 ( resource agent, string str)
Warning
This function is currently not documented; only the argument list is 
available.
  udm_close_storedUpudm_errno
#

#T=int udm_crc32 ( resource agent, string str)
udm_crc32 ( ^!resource agent, string str);
#

#T=udm_errno - int udm_errno ( resource agent)
(PHP 4 >= 4.0.5)
udm_errno -- Get mnoGoSearch error number
Description
int udm_errno ( resource agent)
udm_errno() returns mnoGoSearch error number, zero if no error. 
agent - link to agent identifier, received after call to 
udm_alloc_agent(). 
Receiving numeric agent error code.   udm_crc32Upudm_error
#

#T=int udm_errno ( resource agent)
udm_errno ( ^!resource agent);
#

#T=udm_error - string udm_error ( resource agent)
(PHP 4 >= 4.0.5)
udm_error -- Get mnoGoSearch error message
Description
string udm_error ( resource agent)
udm_error() returns mnoGoSearch error message, empty string if no error. 
agent - link to agent identifier, received after call to 
udm_alloc_agent(). 
Receiving agent error message.   udm_errnoUpudm_find
#

#T=string udm_error ( resource agent)
udm_error ( ^!resource agent);
#

#T=udm_find - resource udm_find ( resource agent, string query)
(PHP 4 >= 4.0.5)
udm_find -- Perform search
Description
resource udm_find ( resource agent, string query)
Returns a result link identifier on success, or FALSE on failure. 
The search itself. The first argument - session, the next one - query 
itself. To find something just type words you want to find and press 
SUBMIT button. For example, "mysql odbc". You should not use quotes " in 
query, they are written here only to divide a query from other text. 
mnoGoSearch will find all documents that contain word "mysql" and/or word 
"odbc". Best documents having bigger weights will be displayed first. If 
you use search mode ALL, search will return documents that contain both 
(or more) words you entered. In case you use mode ANY, the search will 
return list of documents that contain any of the words you entered. If you 
want more advanced results you may use query language. You should select 
"bool" match mode in the search from. 
mnoGoSearch understands the following boolean operators: 
& - logical AND. For example, "mysql & odbc". mnoGoSearch will find any 
URLs that contain both "mysql" and "odbc". 
| - logical OR. For example "mysql|odbc". mnoGoSearch will find any URLs, 
that contain word "mysql" or word "odbc". 
~ - logical NOT. For example "mysql & ~odbc". mnoGoSearch will find URLs 
that contain word "mysql" and do not contain word "odbc" at the same time. 
Note that ~ just excludes given word from results. Query "~odbc" will find 
nothing! 
() - group command to compose more complex queries. For example "(mysql | 
msql) & ~postgres". Query language is simple and powerful at the same 
time. Just consider query as usual boolean expression.   udm_errorUpudm_free_agent
#

#T=resource udm_find ( resource agent, string query)
udm_find ( ^!resource agent, string query);
#

#T=udm_free_agent - int udm_free_agent ( resource agent)
(PHP 4 >= 4.0.5)
udm_free_agent -- Free mnoGoSearch session
Description
int udm_free_agent ( resource agent)
Returns TRUE on success or FALSE on failure. 
agent - link to agent identifier, received ` after call to 
udm_alloc_agent(). 
Freeing up memory allocated for agent session.   udm_findUpudm_free_ispell_data
#

#T=int udm_free_agent ( resource agent)
udm_free_agent ( ^!resource agent);
#

#T=udm_free_ispell_data - bool udm_free_ispell_data ( int agent)
(PHP 4 >= 4.0.5)
udm_free_ispell_data -- Free memory allocated for ispell data
Description
bool udm_free_ispell_data ( int agent)
udm_free_ispell_data() always returns TRUE. 
agent - agent link identifier, received after call to udm_alloc_agent(). 
Note: This function is supported beginning from version 3.1.12 of 
mnoGoSearch and it does not do anything in previous versions.   udm_free_agentUpudm_free_res
#

#T=bool udm_free_ispell_data ( int agent)
udm_free_ispell_data ( ^!int agent);
#

#T=udm_free_res - bool udm_free_res ( resource res)
(PHP 4 >= 4.0.5)
udm_free_res -- Free mnoGoSearch result
Description
bool udm_free_res ( resource res)
Returns TRUE on success or FALSE on failure. 
res - a link to result identifier, received after call to udm_find(). 
Freeing up memory allocated for results.   udm_free_ispell_dataUpudm_get_doc_count
#

#T=bool udm_free_res ( resource res)
udm_free_res ( ^!resource res);
#

#T=udm_get_doc_count - int udm_get_doc_count ( resource agent)
(PHP 4 >= 4.0.5)
udm_get_doc_count -- Get total number of documents in database.
Description
int udm_get_doc_count ( resource agent)
udm_get_doc_count() returns the number of documents in the database. 
agent - link to agent identifier, received after call to 
udm_alloc_agent(). 
Note: This function is supported only in mnoGoSearch 3.1.11 or later.   udm_free_resUpudm_get_res_field
#

#T=int udm_get_doc_count ( resource agent)
udm_get_doc_count ( ^!resource agent);
#

#T=udm_get_res_field - string udm_get_res_field ( resource res, int row, int field)
(PHP 4 >= 4.0.5)
udm_get_res_field -- Fetch mnoGoSearch result field
Description
string udm_get_res_field ( resource res, int row, int field)
udm_get_res_field() returns result field value on success, FALSE on error. 

res - a link to result identifier, received after call to udm_find(). 
row - the number of the link on the current page. May have values from 0 
to UDM_PARAM_NUM_ROWS-1. 
field - field identifier, may have the following values: 
UDM_FIELD_URL - document URL field 
UDM_FIELD_CONTENT - document Content-type field (for example, 
text/html). 
UDM_FIELD_CATEGORY - document category field. Use udm_cat_path() to get 
full path to current category from the categories tree root. (This 
parameter is available only in PHP 4.0.6 or later). 
UDM_FIELD_TITLE - document title field. 
UDM_FIELD_KEYWORDS - document keywords field (from META KEYWORDS tag). 
UDM_FIELD_DESC - document description field (from META DESCRIPTION tag). 

UDM_FIELD_TEXT - document body text (the first couple of lines to give 
an idea of what the document is about). 
UDM_FIELD_SIZE - document size. 
UDM_FIELD_URLID - unique URL ID of the link. 
UDM_FIELD_RATING - page rating (as calculated by mnoGoSearch). 
UDM_FIELD_MODIFIED - last-modified field in unixtime format. 
UDM_FIELD_ORDER - the number of the current document in set of found 
documents. 
UDM_FIELD_CRC - document CRC.   udm_get_doc_countUpudm_get_res_param
#

#T=string udm_get_res_field ( resource res, int row, int field)
udm_get_res_field ( ^!resource res, int row, int field);
#

#T=udm_get_res_param - string udm_get_res_param ( resource res, int param)
(PHP 4 >= 4.0.5)
udm_get_res_param -- Get mnoGoSearch result parameters
Description
string udm_get_res_param ( resource res, int param)
udm_get_res_param() returns result parameter value on success, FALSE on 
error. 
res - a link to result identifier, received after call to udm_find(). 
param - parameter identifier, may have the following values: 
UDM_PARAM_NUM_ROWS - number of received found links on the current page. 
It is equal to UDM_PARAM_PAGE_SIZE for all search pages, on the last 
page - the rest of links. 
UDM_PARAM_FOUND - total number of results matching the query. 
UDM_PARAM_WORDINFO - information on the words found. E.g. search for "a 
good book" will return "a: stopword, good:5637, book: 120" 
UDM_PARAM_SEARCHTIME - search time in seconds. 
UDM_PARAM_FIRST_DOC - the number of the first document displayed on 
current page. 
UDM_PARAM_LAST_DOC - the number of the last document displayed on 
current page.   udm_get_res_fieldUpudm_load_ispell_data
#

#T=string udm_get_res_param ( resource res, int param)
udm_get_res_param ( ^!resource res, int param);
#

#T=udm_load_ispell_data - bool udm_load_ispell_data ( resource agent, int var, string val1, string 
(PHP 4 >= 4.0.5)
udm_load_ispell_data -- Load ispell data
Description
bool udm_load_ispell_data ( resource agent, int var, string val1, string 
val2, int flag)
udm_load_ispell_data() loads ispell data. Returns TRUE on success or FALSE 
on failure. 
agent - agent link identifier, received after call to udm_alloc_agent(). 
var - parameter, indicating the source for ispell data. May have the 
following values: 
After using this function to free memory allocated for ispell data, please 
use udm_free_ispell_data(), even if you use UDM_ISPELL_TYPE_SERVER mode. 
The fastest mode is UDM_ISPELL_TYPE_SERVER. UDM_ISPELL_TYPE_TEXT is slower 
and UDM_ISPELL_TYPE_DB is the slowest. The above pattern is TRUE for 
mnoGoSearch 3.1.10 - 3.1.11. It is planned to speed up DB mode in future 
versions and it is going to be faster than TEXT mode. 
UDM_ISPELL_TYPE_DB - indicates that ispell data should be loaded from 
SQL. In this case, parameters val1 and val2 are ignored and should be 
left blank. flag should be equal to 1. 
Note: flag indicates that after loading ispell data from defined 
source it should be sorted (it is necessary for correct functioning of 
ispell). In case of loading ispell data from files there may be 
several calls to udm_load_ispell_data(), and there is no sense to sort 
data after every call, but only after the last one. Since in db mode 
all the data is loaded by one call, this parameter should have the 
value 1. In this mode in case of error, e.g. if ispell tables are 
absent, the function will return FALSE and code and error message will 
be accessible through udm_error() and udm_errno(). 
Example 1. udm_load_ispell_data()example
    <?php
    if (! udm_load_ispell_data($udm, UDM_ISPELL_TYPE_DB, '', '', 
    1)) {
      printf("Error #%d: '%s'\n", udm_errno($udm), 
    udm_error($udm));
      exit;
    }
    ?> 
UDM_ISPELL_TYPE_AFFIX - indicates that ispell data should be loaded from 
file and initiates loading affixes file. In this case val1 defines 
double letter language code for which affixes are loaded, and val2 - 
file path. Please note, that if a relative path entered, the module 
looks for the file not in UDM_CONF_DIR, but in relation to current path, 
i.e. to the path where the script is executed. In case of error in this 
mode, e.g. if file is absent, the function will return FALSE, and an 
error message will be displayed. Error message text cannot be accessed 
through udm_error() and udm_errno(), since those functions can only 
return messages associated with SQL. Please, see flag parameter 
description in UDM_ISPELL_TYPE_DB. 
Example 2. udm_load_ispell_data() example
    <?php
    if ((! udm_load_ispell_data($udm, UDM_ISPELL_TYPE_AFFIX, 
    'en', '/opt/ispell/en.aff', 0)) ||
	(! udm_load_ispell_data($udm, UDM_ISPELL_TYPE_AFFIX, 
    'ru', '/opt/ispell/ru.aff', 0)) ||
	(! udm_load_ispell_data($udm, UDM_ISPELL_TYPE_SPELL, 
    'en', '/opt/ispell/en.dict', 0)) ||
	(! udm_load_ispell_data($udm, UDM_ISPELL_TYPE_SPELL, 
    'ru', '/opt/ispell/ru.dict', 1))) {
	exit;
    }
    ?> 
Note: flag is equal to 1 only in the last call. 
UDM_ISPELL_TYPE_SPELL - indicates that ispell data should be loaded from 
file and initiates loading of ispell dictionary file. In this case val1 
defines double letter language code for which affixes are loaded, and 
val2 - file path. Please note, that if a relative path entered, the 
module looks for the file not in UDM_CONF_DIR, but in relation to 
current path, i.e. to the path where the script is executed. In case of 
error in this mode, e.g. if file is absent, the function will return 
FALSE, and an error message will be displayed. Error message text cannot 
be accessed through udm_error() and udm_errno(), since those functions 
can only return messages associated with SQL. Please, see flag parameter 
description in UDM_ISPELL_TYPE_DB. 
<?php
   if ((! Udm_Load_Ispell_Data($udm, UDM_ISPELL_TYPE_AFFIX, 
'en', '/opt/ispell/en.aff', 0)) ||
      (! Udm_Load_Ispell_Data($udm, UDM_ISPELL_TYPE_AFFIX, 'ru', 
'/opt/ispell/ru.aff', 0)) ||
      (! Udm_Load_Ispell_Data($udm, UDM_ISPELL_TYPE_SPELL, 'en', 
'/opt/ispell/en.dict', 0)) ||
      (! Udm_Load_Ispell_Data($udm, UDM_ISPELL_TYPE_SPELL, 'ru', 
'/opt/ispell/ru.dict', 1))) {
    exit;
    }
?> 

Note: flag is equal to 1 only in the last call. 
UDM_ISPELL_TYPE_SERVER - enables spell server support. val1 parameter 
indicates address of the host running spell server. val2 ` is not used 
yet, but in future releases it is going to indicate number of port used 
by spell server. flag parameter in this case is not needed since ispell 
data is stored on spellserver already sorted. 
Spelld server reads spell-data from a separate configuration file 
(/usr/local/mnogosearch/etc/spelld.conf by default), sorts it and stores 
in memory. With clients server communicates in two ways: to indexer all 
the data is transferred (so that indexer starts faster), from search.cgi 
server receives word to normalize and then passes over to client 
(search.cgi) list of normalized word forms. This allows fastest, 
compared to db and text modes processing of search queries (by omitting 
loading and sorting all the spell data). 
udm_load_ispell_data() function in UDM_ISPELL_TYPE_SERVER mode does not 
actually load ispell data, but only defines server address. In fact, 
server is automatically used by udm_find() function when performing 
search. In case of errors, e.g. if spellserver is not running or invalid 
host indicated, there are no messages returned and ispell conversion 
does not work. 
Note: This function is available in mnoGoSearch 3.1.12 or later. 
Example:
<?php
if (!udm_load_ispell_data($udm, UDM_ISPELL_TYPE_SERVER, '', '', 
1)) {
  echo "Error loading ispell data from server<br />\n";
  exit;
}
?> 
  udm_get_res_paramUpudm_open_stored
#

#T=bool udm_load_ispell_data ( resource agent, int var, string val1, string 
udm_load_ispell_data ( ^!resource agent, int var, string val1, string ;
#

#T=udm_open_stored - int udm_open_stored ( resource agent, string storedaddr)
(PHP 4 >= 4.2.0)
udm_open_stored --  Open connection to stored 
Description
int udm_open_stored ( resource agent, string storedaddr)
Warning
This function is currently not documented; only the argument list is 
available.
  udm_load_ispell_dataUpudm_set_agent_param
#

#T=int udm_open_stored ( resource agent, string storedaddr)
udm_open_stored ( ^!resource agent, string storedaddr);
#

#T=udm_set_agent_param - bool udm_set_agent_param ( resource agent, int var, string val)
(PHP 4 >= 4.0.5)
udm_set_agent_param -- Set mnoGoSearch agent session parameters
Description
bool udm_set_agent_param ( resource agent, int var, string val)
Returns TRUE on success or FALSE on failure. Defines mnoGoSearch session 
parameters. 
The following parameters and their values are available: 
UDM_PARAM_PAGE_NUM - used to choose search results page number (results 
are returned by pages beginning from 0, with UDM_PARAM_PAGE_SIZE results 
per page). 
UDM_PARAM_PAGE_SIZE - number of search results displayed on one page. 
UDM_PARAM_SEARCH_MODE - search mode. The following values available: 
UDM_MODE_ALL - search for all words; UDM_MODE_ANY - search for any word; 
UDM_MODE_PHRASE - phrase search; UDM_MODE_BOOL - boolean search. See 
udm_find() for details on boolean search. 
UDM_PARAM_CACHE_MODE - turns on or off search result cache mode. When 
enabled, the search engine will store search results to disk. In case a 
similar search is performed later, the engine will take results from the 
cache for faster performance. Available values: UDM_CACHE_ENABLED, 
UDM_CACHE_DISABLED. 
UDM_PARAM_TRACK_MODE - turns on or off trackquery mode. Since version 
3.1.2 mnoGoSearch has a query tracking support. Note that tracking is 
implemented in SQL version only and not available in built-in database. 
To use tracking, you have to create tables for tracking support. For 
MySQL, use create/mysql/track.txt. When doing a search, front-end uses 
those tables to store query words, a number of found documents and 
current Unix timestamp in seconds. Available values: UDM_TRACK_ENABLED, 
UDM_TRACK_DISABLED. 
UDM_PARAM_PHRASE_MODE - defines whether index database using phrases 
("phrase" parameter in indexer.conf). Possible values: 
UDM_PHRASE_ENABLED and UDM_PHRASE_DISABLED. Please note, that if phrase 
search is enabled (UDM_PHRASE_ENABLED), it is still possible to do 
search in any mode (ANY, ALL, BOOL or PHRASE). In 3.1.10 version of 
mnoGoSearch phrase search is supported only in sql and built-in database 
modes, while beginning with 3.1.11 phrases are supported in cachemode as 
well. 
Examples of phrase search: 
"Arizona desert" - This query returns all indexed documents that contain 
"Arizona desert" as a phrase. Notice that you need to put double quotes 
around the phrase 
UDM_PARAM_CHARSET - defines local charset. Available values: set of 
charsets supported by mnoGoSearch, e.g. koi8-r, cp1251, ... 
UDM_PARAM_STOPFILE - Defines name and path to stopwords file. (There is 
a small difference with mnoGoSearch - while in mnoGoSearch if relative 
path or no path entered, it looks for this file in relation to 
UDM_CONF_DIR, the module looks for the file in relation to current path, 
i.e. to the path where the PHP script is executed.) 
UDM_PARAM_STOPTABLE - Load stop words from the given SQL table. You may 
use several StopwordTable commands. This command has no effect when 
compiled without SQL database support. 
UDM_PARAM_WEIGHT_FACTOR - represents weight factors for specific 
document parts. Currently body, title, keywords, description, url are 
supported. To activate this feature please use degrees of 2 in *Weight 
commands of the indexer.conf. Let's imagine that we have these weights: 

URLWeight     1
BodyWeight    2
TitleWeight   4
KeywordWeight 8
DescWeight    16

As far as indexer uses bit OR operation for word weights when some word 
presents several time in the same document, it is possible at search 
time to detect word appearance in different document parts. Word which 
appears only in the body will have 00000010 aggregate weight (in binary 
notation). Word used in all document parts will have 00011111 aggregate 
weight. 
This parameter's value is a string of hex digits ABCDE. Each digit is a 
factor for corresponding bit in word weight. For the given above weights 
configuration: 

E is a factor for weight 1  (URL Weight bit)
D is a factor for weight 2  (BodyWeight bit)
C is a factor for weight 4  (TitleWeight bit)
B is a factor for weight 8  (KeywordWeight bit)
A is a factor for weight 16 (DescWeight bit)

Examples: 
UDM_PARAM_WEIGHT_FACTOR=00001 will search through URLs only. 
UDM_PARAM_WEIGHT_FACTOR=00100 will search through Titles only. 
UDM_PARAM_WEIGHT_FACTOR=11100 will search through 
Title,Keywords,Description but not through URL and Body. 
UDM_PARAM_WEIGHT_FACTOR=F9421 will search through: 

Description with factor 15  (F hex)
Keywords with factor 9
Title with factor  4
Body with factor 2
URL with factor 1

If UDM_PARAM_WEIGHT_FACTOR variable is omitted, original weight value is 
taken to sort results. For a given above weight configuration it means 
that document description has a most big weight 16. 
UDM_PARAM_WORD_MATCH - word match. You may use this parameter to choose 
word match type. This feature works only in "single" and "multi" modes 
using SQL based and built-in database. It does not work in cachemode and 
other modes since they use word CRC and do not support substring search. 
Available values: 
UDM_MATCH_BEGIN - word beginning match;
UDM_MATCH_END - word ending match;
UDM_MATCH_WORD - whole word match;
UDM_MATCH_SUBSTR - word substring match.
UDM_PARAM_MIN_WORD_LEN - defines minimal word length. Any word shorter 
this limit is considered to be a stopword. Please note that this 
parameter value is inclusive, i.e. if UDM_PARAM_MIN_WORD_LEN=3, a word 3 
characters long will not be considered a stopword, while a word 2 
characters long will be. Default value is 1. 
UDM_PARAM_ISPELL_PREFIXES - Possible values: UDM_PREFIXES_ENABLED and 
UDM_PREFIXES_DISABLED, that respectively enable or disable using 
prefixes. E.g. if a word "tested" is in search query, also words like 
"test", "testing", etc. Only suffixes are supported by default. Prefixes 
usually change word meanings, for example if somebody is searching for 
the word "tested" one hardly wants "untested" to be found. Prefixes 
support may also be found useful for site's spelling checking purposes. 
In order to enable ispell, you have to load ispell data with 
udm_load_ispell_data(). 
UDM_PARAM_CROSS_WORDS - enables or disables crosswords support. Possible 
values: UDM_CROSS_WORDS_ENABLED and UDM_CROSS_WORDS_DISABLED. 
The crosswords feature allows to assign words between <a href="xxx"> and 
</a> also to a document this link leads to. It works in SQL database 
mode and is not supported in built-in database and Cachemode. 
Note: Crosswords are supported only in mnoGoSearch 3.1.11 or later. 
UDM_PARAM_VARDIR - specifies a custom path to directory where indexer 
stores data when using built-in database and in cache mode. By default 
/var directory of mnoGoSearch installation is used. Can have only string 
values. The parameter is available in PHP 4.1.0 or later.   udm_open_storedUpmSQL functions
#

#T=bool udm_set_agent_param ( resource agent, int var, string val)
udm_set_agent_param ( ^!resource agent, int var, string val);
#

#T=uksort - bool uksort ( array array, callback cmp_function)
(PHP 3>= 3.0.4, PHP 4 )
uksort --  Sort an array by keys using a user-defined comparison function 
Description
bool uksort ( array array, callback cmp_function)
uksort() will sort the keys of an array using a user-supplied comparison 
function. If the array you wish to sort needs to be sorted by some 
non-trivial criteria, you should use this function. 
Function cmp_function should accept two parameters which will be filled by 
pairs of array keys. The comparison function must return an integer less 
than, equal to, or greater than zero if the first argument is considered 
to be respectively less than, equal to, or greater than the second. 
Returns TRUE on success or FALSE on failure. 
Example 1. uksort() example
  <?php
  function cmp($a, $b) {
      if ($a == $b) {
	  return 0;
      }
      return ($a > $b) ? -1 : 1;
  }

  $a = array(4 => "four", 3 => "three", 20 => "twenty", 10 => 
  "ten");

  uksort($a, "cmp");

  while (list($key, $value) = each($a)) {
      echo "$key: $value\n";
  }
  ?> 

This example would display: 
20: twenty
10: ten
4: four
3: three
See also usort(), uasort(), sort(), asort(), arsort(), ksort(), natsort(), 
and rsort().   uasortUpusort
#

#T=bool uksort ( array array, callback cmp_function)
uksort ( ^!array array, callback cmp_function);
#

#T=umask - int umask ( [int mask])
(PHP 3, PHP 4 )
umask -- Changes the current umask
Description
int umask ( [int mask])
umask() sets PHP's umask to mask & 0777 and returns the old umask. When 
PHP is being used as a server module, the umask is restored when each 
request is finished. 
umask() without arguments simply returns the current umask.   touchUpunlink
#

#T=int umask ( [int mask])
umask ( ^![int mask]);
#

#T=uniqid - string uniqid ( string prefix [, bool lcg])
(PHP 3, PHP 4 )
uniqid -- Generate a unique ID
Description
string uniqid ( string prefix [, bool lcg])
uniqid() returns a prefixed unique identifier based on the current time in 
microseconds. The prefix can be useful for instance if you generate 
identifiers simultaneously on several hosts that might happen to generate 
the identifier at the same microsecond. Prefix can be up to 114 characters 
long. 
If the optional lcg parameter is TRUE, uniqid() will add additional 
"combined LCG" entropy at the end of the return value, which should make 
the results more unique. 
With an empty prefix, the returned string will be 13 characters long. If 
lcg is TRUE, it will be 23 characters. 
Note: The lcg parameter is only available in PHP 4 and PHP 3.0.13 and 
later. 
If you need a unique identifier or token and you intend to give out that 
token to the user via the network (i.e. session cookies), it is 
recommended that you use something along these lines: 
<?php
// no prefix
$token = md5(uniqid(""));

// better, difficult to guess
$better_token = md5(uniqid(rand(), true));
?> 

This will create a 32 character identifier (a 128 bit hex number) that is 
extremely difficult to predict.   sleepUpunpack
#

#T=string uniqid ( string prefix [, bool lcg])
uniqid ( ^!string prefix [, bool lcg]);
#

#T=unixtojd - int unixtojd ( [int timestamp])
(PHP 4 )
unixtojd -- Convert Unix timestamp to Julian Day
Description
int unixtojd ( [int timestamp])
Return the Julian Day for a Unix timestamp (seconds since 1.1.1970), or 
for the current day if no timestamp is given. 
See also jdtounix().   JulianToJDUpCCVS API Functions
#

#T=int unixtojd ( [int timestamp])
unixtojd ( ^![int timestamp]);
#

#T=unlink - bool unlink ( string filename [, resource context])
(PHP 3, PHP 4 )
unlink -- Deletes a file
Description
bool unlink ( string filename [, resource context])
Deletes filename. Similar to the Unix C unlink() function. Returns TRUE on 
success or FALSE on failure. 
Note: As of PHP 5.0.0 unlink() can also be used with some url wrappers. 
Refer to Appendix I for a listing of which wrappers support unlink(). 
Note: The context parameter was added as of PHP 5.0.0. 
See also rmdir() for removing directories.   umaskUpForms Data Format functions
#

#T=bool unlink ( string filename [, resource context])
unlink ( ^!string filename [, resource context]);
#

#T=unpack - array unpack ( string format, string data)
(PHP 3, PHP 4 )
unpack -- Unpack data from binary string
Description
array unpack ( string format, string data)
unpack() from binary string into array according to format. Returns array 
containing unpacked elements of binary string. 
unpack() works slightly different from Perl as the unpacked data is stored 
in an associative array. To accomplish this you have to name the different 
format codes and separate them by a slash /. Example 1. unpack() 
example
  <?php
  $array = unpack("c2chars/nint", $binarydata);
  ?> 

The resulting array will contain the entries "chars1", "chars2" and 
"int". 

Caution
Note that PHP internally stores integral values as signed. If you 
unpack a large unsigned long and it is of the same size as PHP 
internally stored values the result will be a negative number even 
though unsigned unpacking was specified. 

See also pack() for an explanation of the format codes.   uniqidUpusleep
#

#T=array unpack ( string format, string data)
unpack ( ^!string format, string data);
#

#T=unregister_tick_function - void unregister_tick_function ( string function_name)
(PHP 4 >= 4.0.3)
unregister_tick_function --  De-register a function for execution on each 
tick 
Description
void unregister_tick_function ( string function_name)
De-registers the function named by function_name so it is no longer 
executed when a tick is called.  register_tick_functionUpGettext
#

#T=void unregister_tick_function ( string function_name)
unregister_tick_function ( ^!string function_name);
#

#T=unserialize - mixed unserialize ( string str)
(PHP 3>= 3.0.5, PHP 4 )
unserialize --  Creates a PHP value from a stored representation 
Description
mixed unserialize ( string str)
unserialize() takes a single serialized variable (see serialize()) and 
converts it back into a PHP value. The converted value is returned, and 
can be an integer, float, string, array or object. In case the passed 
string is not unserializeable, FALSE is returned. 
unserialize_callback_func directive: It's possible to set a 
callback-function which will be called, if an undefined class should be 
instantiated during unserializing. (to prevent getting an incomplete 
object "__PHP_Incomplete_Class".) Use your php.ini, ini_set() or 
.htaccess to define 'unserialize_callback_func'. Everytime an undefined 
class should be instantiated, it'll be called. To disable this feature 
just empty this setting. Also note that the directive 
unserialize_callback_func directive became available in PHP 4.2.0. 
If the variable being unserialized is an object, after successfully 
reconstructing the object PHP will automatically attempt to call the 
__wakeup() member function (if it exists). Example 1. 
unserialize_callback_func example
  <?php
  $serialized_object='O:1:"a":1:{s:5:"value";s:3:"100";}';

  // unserialize_callback_func directive available as of PHP 
  4.2.0
  ini_set('unserialize_callback_func', 'mycallback'); // set 
  your callback_function

  function mycallback($classname) {
      // just include a file containing your classdefinition
      // you get $classname to figure out which classdefinition 
  is required
  }
  ?> 
Note: In PHP 3, methods are not preserved when unserializing a 
serialized object. PHP 4 removes that limitation and restores both 
properties and methods. Please see the Serializing Objects section of 
Classes and Objects or more information. 
Example 2. unserialize() example
  <?php
  // Here, we use unserialize() to load session data to the
  // $session_data array from the string selected from a 
  database.
  // This example complements the one described with 
serialize().

  $conn = odbc_connect("webdb", "php", "chicken");
  $stmt = odbc_prepare($conn, "SELECT data FROM sessions WHERE 
  id = ?");
  $sqldata = array ($PHP_AUTH_USER);
  if (!odbc_execute($stmt, &$sqldata) || !odbc_fetch_into($stmt, 
  &$tmp)) {
      // if the execute or fetch fails, initialize to empty 
array
      $session_data = array();
  } else {
      // we should now have the serialized data in $tmp[0].
      $session_data = unserialize($tmp[0]);
      if (!is_array($session_data)) {
	  // something went wrong, initialize to empty array
	  $session_data = array();
      }
  }
  ?> 
See also serialize().   strvalUpunset
#

#T=mixed unserialize ( string str)
unserialize ( ^!string str);
#

#T=unset - void unset ( mixed var [, mixed var [, ...]])
(PHP 3, PHP 4 )
unset -- Unset a given variable
Description
void unset ( mixed var [, mixed var [, ...]])
unset() destroys the specified variables. Note that in PHP 3, unset() will 
always return TRUE (actually, the integer value 1). In PHP 4, however, 
unset() is no longer a true function: it is now a statement. As such no 
value is returned, and attempting to take the value of unset() results in 
a parse error. 
Example 1. unset() example
  <?php
  // destroy a single variable
  unset($foo);

  // destroy a single element of an array
  unset($bar['quux']);

  // destroy more than one variable
  unset($foo1, $foo2, $foo3);
  ?> 
The behavior of unset() inside of a function can vary depending on what 
type of variable you are attempting to destroy. 
If a globalized variable is unset() inside of a function, only the local 
variable is destroyed. The variable in the calling environment will retain 
the same value as before unset() was called. 
<?php
function destroy_foo() {
global $foo;
unset($foo);
}

$foo = 'bar';
destroy_foo();
echo $foo;
?> 

The above example would output: 
bar

If a variable that is PASSED BY REFERENCE is unset() inside of a function, 
only the local variable is destroyed. The variable in the calling 
environment will retain the same value as before unset() was called. 
<?php
function foo(&$bar) {
unset($bar);
$bar = "blah";
}

$bar = 'something';
echo "$bar\n";

foo($bar);
echo "$bar\n";
?> 

The above example would output: 
something
something

If a static variable is unset() inside of a function, unset() destroys the 
variable and all its references. 
<?php
function foo() {
static $a;
$a++;
echo "$a\n";
unset($a);
}

foo();
foo();
foo();
?> 

The above example would output: 
1
2
3

If you would like to unset() a global variable inside of a function, you 
can use the $GLOBALS array to do so: 
<?php
function foo() {
unset($GLOBALS['bar']);
}

$bar = "something";
foo();
?> 

Note: Because this is a language construct and not a function, it cannot 
be called using variable functions
See also isset(), empty(), and array_splice().   unserializeUpvar_dump
#

#T=void unset ( mixed var [, mixed var [, ...]])
unset ( ^!mixed var [, mixed var [, ...]]);
#

#T=urldecode - string urldecode ( string str)
(PHP 3, PHP 4 )
urldecode -- Decodes URL-encoded string
Description
string urldecode ( string str)
Decodes any %## encoding in the given string. The decoded string is 
returned. Example 1. urldecode() example
  <?php
  $a = explode('&', $QUERY_STRING);
  $i = 0;
  while ($i < count($a)) {
      $b = split('=', $a[$i]);
      echo 'Value for parameter ', 
  htmlspecialchars(urldecode($b[0])),
	   ' is ', htmlspecialchars(urldecode($b[1])), "<br 
  />\n";
      $i++;
  }
  ?> 
See also urlencode(), rawurlencode() and rawurldecode().   rawurlencodeUpurlencode
#

#T=string urldecode ( string str)
urldecode ( ^!string str);
#

#T=urlencode - string urlencode ( string str)
(PHP 3, PHP 4 )
urlencode -- URL-encodes string
Description
string urlencode ( string str)
Returns a string in which all non-alphanumeric characters except -_. have 
been replaced with a percent (%) sign followed by two hex digits and 
spaces encoded as plus (+) signs. It is encoded the same way that the 
posted data from a WWW form is encoded, that is the same way as in 
application/x-www-form-urlencoded media type. This differs from the 
RFC1738 encoding (see rawurlencode()) in that for historical reasons, 
spaces are encoded as plus (+) signs. This function is convenient when 
encoding a string to be used in a query part of an URL, as a convenient 
way to pass variables to the next page: Example 1. urlencode() 
example
  <?php
  echo '<a href="mycgi?foo=', urlencode($userinput), '">';
  ?> 
Note: Be careful about variables that may match HTML entities. Things like 
&amp, &copy and &pound are parsed by the browser and the actual entity is 
used instead of the desired variable name. This is an obvious hassle that 
the W3C has been telling people about for years. The reference is here: 
http://www.w3.org/TR/html4/appendix/notes.html#h-B.2.2 PHP supports 
changing the argument separator to the W3C-suggested semi-colon through 
the arg_separator .ini directive. Unfortunately most user agents do not 
send form data in this semi-colon separated format. A more portable way 
around this is to use &amp; instead of & as the separator. You don't need 
to change PHP's arg_separator for this. Leave it as &, but simply encode 
your URLs using htmlentities(urlencode($data)). 
Example 2. urlencode() and htmlentities() example
  <?php
  echo '<a href="mycgi?foo=', 
  htmlentities(urlencode($userinput)), '">';
  ?> 
See also urldecode(), htmlentities(), rawurldecode() and rawurlencode().   urldecodeUpVariable Functions
user_error
user_error -- Alias of trigger_error()
Description
This function is an alias of trigger_error().   trigger_errorUpFile alteration monitor functions
#

#T=string urlencode ( string str)
urlencode ( ^!string str);
#

#T=usleep - void usleep ( int micro_seconds)
(PHP 3, PHP 4 )
usleep -- Delay execution in microseconds
Description
void usleep ( int micro_seconds)
The usleep() function delays program execution for the given number of 
micro_seconds. A microsecond is one millionth of a second. 
Note: This function does not work on Windows systems. 
See also sleep() and set_time_limit().   unpackUpmnoGoSearch Functions
#

#T=void usleep ( int micro_seconds)
usleep ( ^!int micro_seconds);
#

#T=usort - bool usort ( array array, callback cmp_function)
(PHP 3>= 3.0.3, PHP 4 )
usort --  Sort an array by values using a user-defined comparison function 

Description
bool usort ( array array, callback cmp_function)
This function will sort an array by its values using a user-supplied 
comparison function. If the array you wish to sort needs to be sorted by 
some non-trivial criteria, you should use this function. 
The comparison function must return an integer less than, equal to, or 
greater than zero if the first argument is considered to be respectively 
less than, equal to, or greater than the second. 
Note: If two members compare as equal, their order in the sorted array 
is undefined. Up to PHP 4.0.6 the user defined functions would keep the 
original order for those elements, but with the new sort algorithm 
introduced with 4.1.0 this is no longer the case as there is no solution 
to do so in an efficient way. 
Returns TRUE on success or FALSE on failure. 
Example 1. usort() example
  <?php
  function cmp($a, $b) {
      if ($a == $b) {
	  return 0;
      }
      return ($a < $b) ? -1 : 1;
  }

  $a = array(3, 2, 5, 6, 1);

  usort($a, "cmp");

  while (list($key, $value) = each($a)) {
      echo "$key: $value\n";
  }
  ?> 

This example would display: 
0: 1
1: 2
2: 3
3: 5
4: 6
Note: Obviously in this trivial case the sort() function would be more 
appropriate. 
Example 2. usort() example using multi-dimensional array 
  <?php
  function cmp($a, $b) {
      return strcmp($a["fruit"], $b["fruit"]);
  }

  $fruits[0]["fruit"] = "lemons";
  $fruits[1]["fruit"] = "apples";
  $fruits[2]["fruit"] = "grapes";

  usort($fruits, "cmp");

  while (list($key, $value) = each($fruits)) {
      echo "\$fruits[$key]: " . $value["fruit"] . "\n";
  }
  ?> 

When sorting a multi-dimensional array, $a and $b contain references 
to the first index of the array. 
This example would display: 
$fruits[0]: apples
$fruits[1]: grapes
$fruits[2]: lemons
Example 3. usort() example using a member function of an object 
  <?php
  class TestObj {
      var $name;

      function TestObj($name) {
	  $this->name = $name;
      }

      /* This is the static comparing function: */
      function cmp_obj($a, $b) {
	  $al = strtolower($a->name);
	  $bl = strtolower($b->name);
	  if ($al == $bl) {
	      return 0;
	  }
	  return ($al > $bl) ? +1 : -1;
      }
  }

  $a[] = new TestObj("c");
  $a[] = new TestObj("b");
  $a[] = new TestObj("d");

  usort($a, array("TestObj", "cmp_obj"));

  foreach ($a as $item) {
      echo $item->name . "\n";
  }
  ?> 

This example would display: 
b
c
d
See also uasort(), uksort(), sort(), asort(), arsort(),ksort(), natsort(), 
and rsort().   uksortUpAspell functions [deprecated]
#

#T=bool usort ( array array, callback cmp_function)
usort ( ^!array array, callback cmp_function);
#

#T=utf8_decode - string utf8_decode ( string data)
(PHP 3>= 3.0.6, PHP 4 )
utf8_decode --  Converts a string with ISO-8859-1 characters encoded with 
UTF-8 to single-byte ISO-8859-1. 
Description
string utf8_decode ( string data)
This function decodes data, assumed to be UTF-8 encoded, to ISO-8859-1. 
See also utf8_encode() for an explanation of UTF-8 encoding.   XML parser functionsUputf8_encode
#

#T=string utf8_decode ( string data)
utf8_decode ( ^!string data);
#

#T=utf8_encode - string utf8_encode ( string data)
(PHP 3>= 3.0.6, PHP 4 )
utf8_encode -- encodes an ISO-8859-1 string to UTF-8
Description
string utf8_encode ( string data)
This function encodes the string data to UTF-8, and returns the encoded 
version. UTF-8 is a standard mechanism used by Unicode for encoding wide 
character values into a byte stream. UTF-8 is transparent to plain ASCII 
characters, is self-synchronized (meaning it is possible for a program to 
figure out where in the bytestream characters start) and can be used with 
normal string comparison functions for sorting and such. PHP encodes UTF-8 
characters in up to four bytes, like this: 
Table 1. UTF-8 encoding
bytesbitsrepresentation
170bbbbbbb
211110bbbbb 10bbbbbb
3161110bbbb 10bbbbbb 10bbbbbb
42111110bbb 10bbbbbb 10bbbbbb 10bbbbbb

Each b represents a bit that can be used to store character data.   utf8_decodeUpxml_error_string
#

#T=string utf8_encode ( string data)
utf8_encode ( ^!string data);
#

#T=var_dump - void var_dump ( mixed expression [, mixed expression [, ...]])
(PHP 3>= 3.0.5, PHP 4 )
var_dump -- Dumps information about a variable
Description
void var_dump ( mixed expression [, mixed expression [, ...]])
This function displays structured information about one or more 
expressions that includes its type and value. Arrays and objects are 
explored recursively with values indented to show structure. 
In PHP only public properties of objects will be returned in the output. 
var_export() and print_r() will also return protected and private 
properties. 
Tip: As with anything that outputs its result directly to the browser, 
you can use the output-control functions to capture the output of this 
function, and save it in a string (for example).
Example 1. var_dump() example
  <?php
  $a = array (1, 2, array ("a", "b", "c"));
  var_dump($a);
  ?> 

Output: 
array(3) {
[0]=>
int(1)
[1]=>
int(2)
[2]=>
array(3) {
[0]=>
string(1) "a"
[1]=>
string(1) "b"
[2]=>
string(1) "c"
}
}
  <?php

  $b = 3.1;
  $c = true;
  var_dump($b, $c);

  ?> 

output: 
float(3.1)
bool(true)
See also var_export() and print_r().   unsetUpvar_export
#

#T=void var_dump ( mixed expression [, mixed expression [, ...]])
var_dump ( ^!mixed expression [, mixed expression [, ...]]);
#

#T=var_export - mixed var_export ( mixed expression [, bool return])
(PHP 4 >= 4.2.0)
var_export -- Outputs or returns a parsable string representation of a 
variable
Description
mixed var_export ( mixed expression [, bool return])
This function returns structured information about the variable that is 
passed to this function. It is similar to var_dump() with two exceptions. 
The first one is that the returned representation is valid PHP code, the 
second that it will also return protected and private properties of an 
object with PHP 5. 
You can also return the variable representation by using TRUE as second 
parameter to this function. 
<?php
$a = array (1, 2, array ("a", "b", "c"));
var_export($a);
?> 

output: 
array (
0 => 1,
1 => 2,
2 => 
array (
0 => 'a',
1 => 'b',
2 => 'c',
),
)
<?php

$b = 3.1;
$v = var_export($b, true);
echo $v;

?> 

output: 
3.1

See also var_export() and print_r().   var_dumpUpvpopmail functions
#

#T=mixed var_export ( mixed expression [, bool return])
var_export ( ^!mixed expression [, bool return]);
#

#T=version_compare - int version_compare ( string version1, string version2 [, string 
(PHP 4 >= 4.1.0)
version_compare --  Compares two "PHP-standardized" version number strings 

Description
int version_compare ( string version1, string version2 [, string 
operator])
version_compare() compares two "PHP-standardized" version number strings. 
This is useful if you would like to write programs working only on some 
versions of PHP. 
version_compare() returns -1 if the first version is lower than the 
second, 0 if they are equal, and +1 if the second is lower. 
The function first replaces _, - and + with a dot . in the version strings 
and also inserts dots . before and after any non number so that for 
example '4.3.2RC1' becomes '4.3.2.RC.1'. Then it splits the results like 
if you were using explode('.', $ver). Then it compares the parts starting 
from left to right. If a part contains special version strings these are 
handled in the following order: dev < alpha = a < beta = b < RC < pl. This 
way not only versions with different levels like '4.1' and '4.1.2' can be 
compared but also any PHP specific version containing development state. 
If you specify the third optional operator argument, you can test for a 
particular relationship. The possible operators are: <, lt, <=, le, >, gt, 
>=, ge, ==, =, eq, !=, <>, ne respectively. Using this argument, the 
function will return 1 if the relationship is the one specified by the 
operator, 0 otherwise. 
Example 1. version_compare() example
  <?php
  // prints -1
  echo version_compare("4.0.4", "4.0.6");

  // these all print 1
  echo version_compare("4.0.4", "4.0.6", "<");
  echo version_compare("4.0.6", "4.0.6", "eq");
  ?> 

  set_time_limitUpzend_logo_guid
#

#T=int version_compare ( string version1, string version2 [, string 
version_compare ( ^!string version1, string version2 [, string ;
#

#T=virtual - int virtual ( string filename)
(PHP 3, PHP 4 )
virtual -- Perform an Apache sub-request
Description
int virtual ( string filename)
virtual() is an Apache-specific function which is equivalent to 
<!--#include virtual...--> in mod_include. It performs an Apache 
sub-request. It is useful for including CGI scripts or .shtml files, or 
anything else that you would parse through Apache. Note that for a CGI 
script, the script must generate valid CGI headers. At the minimum that 
means it must generate a Content-type header. 
To run the sub-request, all buffers are terminated and flushed to the 
browser, pending headers are sent too. 
As of PHP 4.0.6, you can use virtual() on PHP files. However, it is 
typically better to use include() or require() if you need to include 
another PHP file. 
Note: From PHP 4.3.3 on you can use this function with the NSAPI server 
module in Netscape/iPlanet/SunONE webservers, too.   getallheadersUpArray Functions
vpopmail_add_alias_domain_ex
(4.0.5 - 4.2.3 only)
vpopmail_add_alias_domain_ex -- Add alias to an existing virtual domain
Description
bool vpopmail_add_alias_domain_ex ( string olddomain, string newdomain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail functionsUpvpopmail_add_alias_domain
vpopmail_add_alias_domain
(4.0.5 - 4.2.3 only)
vpopmail_add_alias_domain -- Add an alias for a virtual domain
Description
bool vpopmail_add_alias_domain ( string domain, string aliasdomain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_add_alias_domain_exUpvpopmail_add_domain_ex
vpopmail_add_domain_ex
(4.0.5 - 4.2.3 only)
vpopmail_add_domain_ex -- Add a new virtual domain
Description
bool vpopmail_add_domain_ex ( string domain, string passwd [, string quota 
[, string bounce [, bool apop]]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_add_alias_domainUpvpopmail_add_domain
vpopmail_add_domain
(4.0.5 - 4.2.3 only)
vpopmail_add_domain -- Add a new virtual domain
Description
bool vpopmail_add_domain ( string domain, string dir, int uid, int gid)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_add_domain_exUpvpopmail_add_user
vpopmail_add_user
(4.0.5 - 4.2.3 only)
vpopmail_add_user -- Add a new user to the specified virtual domain
Description
bool vpopmail_add_user ( string user, string domain, string password [, 
string gecos [, bool apop]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_add_domainUpvpopmail_alias_add
vpopmail_alias_add
(4.1.0 - 4.2.3 only)
vpopmail_alias_add -- insert a virtual alias
Description
bool vpopmail_alias_add ( string user, string domain, string alias)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_add_userUpvpopmail_alias_del_domain
vpopmail_alias_del_domain
(4.1.0 - 4.2.3 only)
vpopmail_alias_del_domain -- deletes all virtual aliases of a domain
Description
bool vpopmail_alias_del_domain ( string domain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_alias_addUpvpopmail_alias_del
vpopmail_alias_del
(4.1.0 - 4.2.3 only)
vpopmail_alias_del -- deletes all virtual aliases of a user
Description
bool vpopmail_alias_del ( string user, string domain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_alias_del_domainUpvpopmail_alias_get_all
vpopmail_alias_get_all
(4.1.0 - 4.2.3 only)
vpopmail_alias_get_all -- get all lines of an alias for a domain
Description
array vpopmail_alias_get_all ( string domain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_alias_delUpvpopmail_alias_get
vpopmail_alias_get
(4.1.0 - 4.2.3 only)
vpopmail_alias_get -- get all lines of an alias for a domain
Description
array vpopmail_alias_get ( string alias, string domain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_alias_get_allUpvpopmail_auth_user
vpopmail_auth_user
(4.0.5 - 4.2.3 only)
vpopmail_auth_user -- Attempt to validate a username/domain/password. 
Returns true/false
Description
bool vpopmail_auth_user ( string user, string domain, string password [, 
string apop])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_alias_getUpvpopmail_del_domain_ex
vpopmail_del_domain_ex
(4.0.5 - 4.2.3 only)
vpopmail_del_domain_ex -- Delete a virtual domain
Description
bool vpopmail_del_domain_ex ( string domain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_auth_userUpvpopmail_del_domain
vpopmail_del_domain
(4.0.5 - 4.2.3 only)
vpopmail_del_domain -- Delete a virtual domain
Description
bool vpopmail_del_domain ( string domain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_del_domain_exUpvpopmail_del_user
vpopmail_del_user
(4.0.5 - 4.2.3 only)
vpopmail_del_user -- Delete a user from a virtual domain
Description
bool vpopmail_del_user ( string user, string domain)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_del_domainUpvpopmail_error
vpopmail_error
(4.0.5 - 4.2.3 only)
vpopmail_error -- Get text message for last vpopmail error. Returns string
Description
string vpopmail_error ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_del_userUpvpopmail_passwd
vpopmail_passwd
(4.0.5 - 4.2.3 only)
vpopmail_passwd -- Change a virtual user's password
Description
bool vpopmail_passwd ( string user, string domain, string password)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_errorUpvpopmail_set_user_quota
vpopmail_set_user_quota
(4.0.5 - 4.2.3 only)
vpopmail_set_user_quota -- Sets a virtual user's quota
Description
bool vpopmail_set_user_quota ( string user, string domain, string quota)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  vpopmail_passwdUpW32api functions
#

#T=int virtual ( string filename)
virtual ( ^!string filename);
#

#T=vprintf - void vprintf ( string format, array args)
(PHP 4 >= 4.1.0)
vprintf -- Output a formatted string
Description
void vprintf ( string format, array args)
Display array values as a formatted string according to format (which is 
described in the documentation for sprintf()). 
Operates as printf() but accepts an array of arguments, rather than a 
variable number of arguments. 
See also printf(), sprintf(), vsprintf()   ucwordsUpvsprintf
#

#T=void vprintf ( string format, array args)
vprintf ( ^!string format, array args);
#

#T=vsprintf - string vsprintf ( string format, array args)
(PHP 4 >= 4.1.0)
vsprintf -- Return a formatted string
Description
string vsprintf ( string format, array args)
Return array values as a formatted string according to format (which is 
described in the documentation for sprintf()). 
Operates as sprintf() but accepts an array of arguments, rather than a 
variable number of arguments. 
See also sprintf() and vprintf()   vprintfUpwordwrap
w32api_deftype
(4.2.0 - 4.2.3 only)
w32api_deftype -- Defines a type for use with other w32api_functions
Description
bool w32api_deftype ( string typename, string member1_type, string 
member1_name [, string ... [, string ...]])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

If you would like to define a type for a w32api call, you need to call 
w32api_deftype(). This function takes 2n+1 arguments, where n is the 
number of members the type has. The first argument is the name of the 
type. After that is the type of the member followed by the members name 
(in pairs). A member type can be a user defined type. All the type names 
are case sensitive. Built in type names should be provided in lowercase. 
Returns TRUE on success or FALSE on failure.   W32api functionsUpw32api_init_dtype
w32api_init_dtype
(4.2.0 - 4.2.3 only)
w32api_init_dtype --  Creates an instance of the data type typename and 
fills it with the values passed 
Description
resource w32api_init_dtype ( string typename, mixed value [, mixed ...])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function creates an instance of the data type named typename, filling 
in the values of the data type. The typename parameter is case sensitive. 
You should give the values in the same order as you defined the data type 
with w32api_deftype(). The type of the resource returned is dynaparm.   w32api_deftypeUpw32api_invoke_function
w32api_invoke_function
(4.2.0 - 4.2.3 only)
w32api_invoke_function -- Invokes function funcname with the arguments 
passed after the function name
Description
mixed w32api_invoke_function ( string funcname, mixed argument [, mixed 
...])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

w32api_invoke_function() tries to find the previously registered function, 
named funcname, passing the parameters you provided. The return type is 
the one you set when you registered the function, the value is the one 
returned by the function itself. Any of the arguments can be of any PHP 
type or w32api_deftype() defined type, as needed.   w32api_init_dtypeUpw32api_register_function
w32api_register_function
(4.2.0 - 4.2.3 only)
w32api_register_function -- Registers function function_name from library 
with PHP
Description
bool w32api_register_function ( string library, string function_name, 
string return_type)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function tries to find the function_name function in libary, and 
tries to import it into PHP. The function will be registered with the 
given return_type. This type can be a generic PHP type, or a type defined 
with w32api_deftype(). All type names are case sensitive. Built in type 
names should be provided in lowercase. Returns TRUE on success or FALSE on 
failure.   w32api_invoke_functionUpw32api_set_call_method
w32api_set_call_method
(4.2.0 - 4.2.3 only)
w32api_set_call_method -- Sets the calling method used
Description
void w32api_set_call_method ( int method)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

This function sets the method call type. The parameter can be one of the 
constants DC_CALL_CDECL or DC_CALL_STD. The extension default is 
DC_CALL_STD.   w32api_register_functionUpWDDX Functions
#

#T=string vsprintf ( string format, array args)
vsprintf ( ^!string format, array args);
#

#T=wddx_add_vars - bool wddx_add_vars ( int packet_id, mixed name_var [, mixed ...])
(PHP 3>= 3.0.7, PHP 4 )
wddx_add_vars --  Add variables to a WDDX packet with the specified ID 
Description
bool wddx_add_vars ( int packet_id, mixed name_var [, mixed ...])
wddx_add_vars() is used to serialize passed variables and add the result 
to the packet specified by the packet_id. The variables to be serialized 
are specified in exactly the same way as wddx_serialize_vars().   WDDX FunctionsUpwddx_deserialize
#

#T=bool wddx_add_vars ( int packet_id, mixed name_var [, mixed ...])
wddx_add_vars ( ^!int packet_id, mixed name_var [, mixed ...]);
#

#T=wddx_deserialize - mixed wddx_deserialize ( string packet)
(PHP 3>= 3.0.7, PHP 4 )
wddx_deserialize -- Deserializes a WDDX packet
Description
mixed wddx_deserialize ( string packet)
wddx_deserialize() takes a packet string and deserializes it. It returns 
the result which can be string, number, or array. Note that structures are 
deserialized into associative arrays.   wddx_add_varsUpwddx_packet_end
#

#T=mixed wddx_deserialize ( string packet)
wddx_deserialize ( ^!string packet);
#

#T=wddx_packet_end - string wddx_packet_end ( int packet_id)
(PHP 3>= 3.0.7, PHP 4 )
wddx_packet_end -- Ends a WDDX packet with the specified ID
Description
string wddx_packet_end ( int packet_id)
wddx_packet_end() ends the WDDX packet specified by the packet_id and 
returns the string with the packet.   wddx_deserializeUpwddx_packet_start
#

#T=string wddx_packet_end ( int packet_id)
wddx_packet_end ( ^!int packet_id);
#

#T=wddx_packet_start - int wddx_packet_start ( [string comment])
(PHP 3>= 3.0.7, PHP 4 )
wddx_packet_start --  Starts a new WDDX packet with structure inside it 
Description
int wddx_packet_start ( [string comment])
Use wddx_packet_start() to start a new WDDX packet for incremental 
addition of variables. It takes an optional comment string and returns a 
packet ID for use in later functions. It automatically creates a structure 
definition inside the packet to contain the variables.   wddx_packet_endUpwddx_serialize_value
#

#T=int wddx_packet_start ( [string comment])
wddx_packet_start ( ^![string comment]);
#

#T=wddx_serialize_value - string wddx_serialize_value ( mixed var [, string comment])
(PHP 3>= 3.0.7, PHP 4 )
wddx_serialize_value -- Serialize a single value into a WDDX packet
Description
string wddx_serialize_value ( mixed var [, string comment])
wddx_serialize_value() is used to create a WDDX packet from a single given 
value. It takes the value contained in var, and an optional comment string 
that appears in the packet header, and returns the WDDX packet.   wddx_packet_startUpwddx_serialize_vars
#

#T=string wddx_serialize_value ( mixed var [, string comment])
wddx_serialize_value ( ^!mixed var [, string comment]);
#

#T=wddx_serialize_vars - string wddx_serialize_vars ( mixed var_name [, mixed ...])
(PHP 3>= 3.0.7, PHP 4 )
wddx_serialize_vars -- Serialize variables into a WDDX packet
Description
string wddx_serialize_vars ( mixed var_name [, mixed ...])
wddx_serialize_vars() is used to create a WDDX packet with a structure 
that contains the serialized representation of the passed variables. 
wddx_serialize_vars() takes a variable number of arguments, each of which 
can be either a string naming a variable or an array containing strings 
naming the variables or another array, etc. 
Example 1. wddx_serialize_vars() example
  <?php
  $a = 1;
  $b = 5.5;
  $c = array("blue", "orange", "violet");
  $d = "colors";

  $clvars = array("c", "d");
  echo wddx_serialize_vars("a", "b", $clvars);
  ?> 
The above example will produce: <wddxPacket version='1.0'><header/><data><struct><var name='a'><number>1</number></var>
<var name='b'><number>5.5</number></var><var name='c'><array length='3'>
<string>blue</string><string>orange</string><string>violet</string></array></var>
<var name='d'><string>colors</string></var></struct></data></wddxPacket>
  wddx_serialize_valueUpXML parser functions
#

#T=string wddx_serialize_vars ( mixed var_name [, mixed ...])
wddx_serialize_vars ( ^!mixed var_name [, mixed ...]);
#

#T=wordwrap - string wordwrap ( string str [, int width [, string break [, boolean 
(PHP 4 >= 4.0.2)
wordwrap --  Wraps a string to a given number of characters using a string 
break character. 
Description
string wordwrap ( string str [, int width [, string break [, boolean 
cut]]])
Returns a string with str wrapped at the column number specified by the 
optional width parameter. The line is broken using the (optional) break 
parameter. 
wordwrap() will automatically wrap at column 75 and break using '\n' 
(newline) if width or break are not given. 
If the cut is set to 1, the string is always wrapped at the specified 
width. So if you have a word that is larger than the given width, it is 
broken apart. (See second example). 
Note: The optional cut parameter was added in PHP 4.0.3 
Example 1. wordwrap() example
  <?php
  $text = "The quick brown fox jumped over the lazy dog.";
  $newtext = wordwrap($text, 20, "<br />");

  echo "$newtext\n";
  ?> 

This example would display: 
The quick brown fox
jumped over the 
lazy dog.

Example 2. wordwrap() example
  <?php
  $text = "A very long woooooooooooord.";
  $newtext = wordwrap($text, 8, "\n", 1);

  echo "$newtext\n";
  ?> 

This example would display: 
A very
long
wooooooo
ooooord.
See also nl2br().   vsprintfUpSybase functions
#

#T=string wordwrap ( string str [, int width [, string break [, boolean 
wordwrap ( ^!string str [, int width [, string break [, boolean ;
#

#T=xml_error_string - string xml_error_string ( int code)
(PHP 3>= 3.0.6, PHP 4 )
xml_error_string -- get XML parser error string
Description
string xml_error_string ( int code)
code
An error code from xml_get_error_code(). 
Returns a string with a textual description of the error code code, or 
FALSE if no description was found.   utf8_encodeUpxml_get_current_byte_index
#

#T=string xml_error_string ( int code)
xml_error_string ( ^!int code);
#

#T=xml_get_current_byte_index - int xml_get_current_byte_index ( resource parser)
(PHP 3>= 3.0.6, PHP 4 )
xml_get_current_byte_index -- get current byte index for an XML parser
Description
int xml_get_current_byte_index ( resource parser)
parser
A reference to the XML parser to get byte index from. 
This function returns FALSE if parser does not refer to a valid parser, or 
else it returns which byte index the parser is currently at in its data 
buffer (starting at 0).   xml_error_stringUpxml_get_current_column_number
#

#T=int xml_get_current_byte_index ( resource parser)
xml_get_current_byte_index ( ^!resource parser);
#

#T=xml_get_current_column_number - int xml_get_current_column_number ( resource parser)
(PHP 3>= 3.0.6, PHP 4 )
xml_get_current_column_number --  Get current column number for an XML 
parser 
Description
int xml_get_current_column_number ( resource parser)
parser
A reference to the XML parser to get column number from. 
This function returns FALSE if parser does not refer to a valid parser, or 
else it returns which column on the current line (as given by 
xml_get_current_line_number()) the parser is currently at.   xml_get_current_byte_indexUpxml_get_current_line_number
#

#T=int xml_get_current_column_number ( resource parser)
xml_get_current_column_number ( ^!resource parser);
#

#T=xml_get_current_line_number - int xml_get_current_line_number ( resource parser)
(PHP 3>= 3.0.6, PHP 4 )
xml_get_current_line_number -- get current line number for an XML parser
Description
int xml_get_current_line_number ( resource parser)
parser
A reference to the XML parser to get line number from. 
This function returns FALSE if parser does not refer to a valid parser, or 
else it returns which line the parser is currently at in its data buffer.   xml_get_current_column_numberUpxml_get_error_code
#

#T=int xml_get_current_line_number ( resource parser)
xml_get_current_line_number ( ^!resource parser);
#

#T=xml_get_error_code - int xml_get_error_code ( resource parser)
(PHP 3>= 3.0.6, PHP 4 )
xml_get_error_code -- get XML parser error code
Description
int xml_get_error_code ( resource parser)
parser
A reference to the XML parser to get error code from. 
This function returns FALSE if parser does not refer to a valid parser, or 
else it returns one of the error codes listed in the error codes section.   xml_get_current_line_numberUpxml_parse_into_struct
#

#T=int xml_get_error_code ( resource parser)
xml_get_error_code ( ^!resource parser);
#

#T=xml_parse_into_struct - int xml_parse_into_struct ( resource parser, string data, array &values [, 
(PHP 3>= 3.0.8, PHP 4 )
xml_parse_into_struct -- Parse XML data into an array structure
Description
int xml_parse_into_struct ( resource parser, string data, array &values [, 
array &index])
This function parses an XML file into 2 parallel array structures, one 
(index) containing pointers to the location of the appropriate values in 
the values array. These last two parameters must be passed by reference. 
Below is an example that illustrates the internal structure of the arrays 
being generated by the function. We use a simple note tag embedded inside 
a para tag, and then we parse this an print out the structures generated: 
<?php
$simple = "<para><note>simple note</note></para>";
$p = xml_parser_create();
xml_parse_into_struct($p, $simple, $vals, $index);
xml_parser_free($p);
echo "Index array\n";
print_r($index);
echo "\nVals array\n";
print_r($vals);
?> 

When we run that code, the output will be: 
Index array
Array
(
[PARA] => Array
(
[0] => 0
[1] => 2
)

[NOTE] => Array
(
[0] => 1
)

)

Vals array
Array
(
[0] => Array
(
[tag] => PARA
[type] => open
[level] => 1
)

[1] => Array
(
[tag] => NOTE
[type] => complete
[level] => 2
[value] => simple note
)

[2] => Array
(
[tag] => PARA
[type] => close
[level] => 1
)

)

Event-driven parsing (based on the expat library) can get complicated when 
you have an XML document that is complex. This function does not produce a 
DOM style object, but it generates structures amenable of being 
transversed in a tree fashion. Thus, we can create objects representing 
the data in the XML file easily. Let's consider the following XML file 
representing a small database of aminoacids information: Example 1. 
moldb.xml - small database of molecular information
<?xml version="1.0"?>
<moldb>

<molecule>
<name>Alanine</name>
<symbol>ala</symbol>
<code>A</code>
<type>hydrophobic</type>
</molecule>

<molecule>
<name>Lysine</name>
<symbol>lys</symbol>
<code>K</code>
<type>charged</type>
</molecule>

</moldb>

And some code to parse the document and generate the appropriate objects: 
Example 2. parsemoldb.php - parses moldb.xml into and array of 
molecular objects 
  <?php

  class AminoAcid {
      var $name;  // aa name
      var $symbol;    // three letter symbol
      var $code;  // one letter code
      var $type;  // hydrophobic, charged or neutral
      
      function AminoAcid ($aa) {
	  foreach ($aa as $k=>$v)
	      $this->$k = $aa[$k];
      }
  }

  function readDatabase($filename) {
      // read the XML database of aminoacids
      $data = implode("", file($filename));
      $parser = xml_parser_create();
      xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 
0);
      xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
      xml_parse_into_struct($parser, $data, $values, $tags);
      xml_parser_free($parser);

      // loop through the structures
      foreach ($tags as $key=>$val) {
	  if ($key == "molecule") {
	      $molranges = $val;
	      // each contiguous pair of array entries are the 
	      // lower and upper range for each molecule 
  definition
	      for ($i=0; $i < count($molranges); $i+=2) {
		      $offset = $molranges[$i] + 1;
		  $len = $molranges[$i + 1] - $offset;
		  $tdb[] = parseMol(array_slice($values, 
  $offset, $len));
	      }
	  } else {
	      continue;
	  }
      }
      return $tdb;
  }

  function parseMol($mvalues) {
      for ($i=0; $i < count($mvalues); $i++)
	  $mol[$mvalues[$i]["tag"]] = $mvalues[$i]["value"];
      return new AminoAcid($mol);
  }

  $db = readDatabase("moldb.xml");
  echo "** Database of AminoAcid objects:\n";
  print_r($db);

  ?> 

After executing parsemoldb.php, the variable $db contains an array of 
AminoAcid objects, and the output of the script confirms that: 
** Database of AminoAcid objects:
Array
(
[0] => aminoacid Object
(
[name] => Alanine
[symbol] => ala
[code] => A
[type] => hydrophobic
)

[1] => aminoacid Object
(
[name] => Lysine
[symbol] => lys
[code] => K
[type] => charged
)

)
  xml_get_error_codeUpxml_parse
#

#T=int xml_parse_into_struct ( resource parser, string data, array &values [, 
xml_parse_into_struct ( ^!resource parser, string data, array &values [, ;
#

#T=xml_parse - bool xml_parse ( resource parser, string data [, bool is_final])
(PHP 3>= 3.0.6, PHP 4 )
xml_parse -- start parsing an XML document
Description
bool xml_parse ( resource parser, string data [, bool is_final])
parser
A reference to the XML parser to use. 
data
Chunk of data to parse. A document may be parsed piece-wise by calling 
xml_parse() several times with new data, as long as the is_final 
parameter is set and TRUE when the last data is parsed. 
is_final (optional)
If set and TRUE, data is the last piece of data sent in this parse. 
When the XML document is parsed, the handlers for the configured events 
are called as many times as necessary, after which this function returns 
TRUE or FALSE. 
TRUE is returned if the parse was successful, FALSE if it was not 
successful, or if parser does not refer to a valid parser. For 
unsuccessful parses, error information can be retrieved with 
xml_get_error_code(), xml_error_string(), xml_get_current_line_number(), 
xml_get_current_column_number() and xml_get_current_byte_index().   xml_parse_into_structUpxml_parser_create_ns
#

#T=bool xml_parse ( resource parser, string data [, bool is_final])
xml_parse ( ^!resource parser, string data [, bool is_final]);
#

#T=xml_parser_create_ns - resource xml_parser_create_ns ( [string encoding [, string separator]])
(PHP 4 >= 4.0.5)
xml_parser_create_ns --  Create an XML parser with namespace support 
Description
resource xml_parser_create_ns ( [string encoding [, string separator]])
xml_parser_create_ns() creates a new XML parser with XML namespace support 
and returns a resource handle referencing it to be used by the other XML 
functions. 
With a namespace aware parser tag parameters passed to the various handler 
functions will consist of namespace and tag name separated by the string 
specified in seperator or ':' by default. 
The optional encoding specifies the character encoding of the XML input to 
be parsed. Supported encodings are "ISO-8859-1", which is also the default 
if no encoding is specified, "UTF-8" and "US-ASCII". 
See also xml_parser_create(), and xml_parser_free().   xml_parseUpxml_parser_create
#

#T=resource xml_parser_create_ns ( [string encoding [, string separator]])
xml_parser_create_ns ( ^![string encoding [, string separator]]);
#

#T=xml_parser_create - resource xml_parser_create ( [string encoding])
(PHP 3>= 3.0.6, PHP 4 )
xml_parser_create -- create an XML parser
Description
resource xml_parser_create ( [string encoding])
xml_parser_create() creates a new XML parser and returns a resource handle 
referencing it to be used by the other XML functions. 
The optional encoding specifies the character encoding of the XML input to 
be parsed. Supported encodings are "ISO-8859-1", which is also the default 
if no encoding is specified, "UTF-8" and "US-ASCII". 
See also xml_parser_create_ns() and xml_parser_free().   xml_parser_create_nsUpxml_parser_free
#

#T=resource xml_parser_create ( [string encoding])
xml_parser_create ( ^![string encoding]);
#

#T=xml_parser_free - bool xml_parser_free ( resource parser)
(PHP 3>= 3.0.6, PHP 4 )
xml_parser_free -- Free an XML parser
Description
bool xml_parser_free ( resource parser)
parser
A reference to the XML parser to free. 
This function returns FALSE if parser does not refer to a valid parser, or 
else it frees the parser and returns TRUE.   xml_parser_createUpxml_parser_get_option
#

#T=bool xml_parser_free ( resource parser)
xml_parser_free ( ^!resource parser);
#

#T=xml_parser_get_option - mixed xml_parser_get_option ( resource parser, int option)
(PHP 3>= 3.0.6, PHP 4 )
xml_parser_get_option -- get options from an XML parser
Description
mixed xml_parser_get_option ( resource parser, int option)
parser
A reference to the XML parser to get an option from. 
option
Which option to fetch. See xml_parser_set_option() for a list of 
options. 
This function returns FALSE if parser does not refer to a valid parser, or 
if the option could not be set. Else the option's value is returned. 
See xml_parser_set_option() for the list of options.   xml_parser_freeUpxml_parser_set_option
#

#T=mixed xml_parser_get_option ( resource parser, int option)
xml_parser_get_option ( ^!resource parser, int option);
#

#T=xml_parser_set_option - bool xml_parser_set_option ( resource parser, int option, mixed value)
(PHP 3>= 3.0.6, PHP 4 )
xml_parser_set_option -- set options in an XML parser
Description
bool xml_parser_set_option ( resource parser, int option, mixed value)
parser
A reference to the XML parser to set an option in. 
option
Which option to set. See below. 
value
The option's new value. 
This function returns FALSE if parser does not refer to a valid parser, or 
if the option could not be set. Else the option is set and TRUE is 
returned. 
The following options are available: 
Table 1. XML parser options
Option constantData typeDescription
XML_OPTION_CASE_FOLDINGintegerControls whether case-folding is 
enabled for this XML parser. Enabled by default. 
XML_OPTION_TARGET_ENCODINGstringSets which target encoding to use in 
this XML parser. By default, it is set to the same as the source 
encoding used by xml_parser_create(). Supported target encodings are 
ISO-8859-1, US-ASCII and UTF-8. 
  xml_parser_get_optionUpxml_set_character_data_handler
#

#T=bool xml_parser_set_option ( resource parser, int option, mixed value)
xml_parser_set_option ( ^!resource parser, int option, mixed value);
#

#T=xml_set_character_data_handler - bool xml_set_character_data_handler ( resource parser, callback handler)
(PHP 3>= 3.0.6, PHP 4 )
xml_set_character_data_handler -- set up character data handler
Description
bool xml_set_character_data_handler ( resource parser, callback handler)
Sets the character data handler function for the XML parser parser. 
handler is a string containing the name of a function that must exist when 
xml_parse() is called for parser. 
The function named by handler must accept two parameters: handler ( 
resource parser, string data)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
data
The second parameter, data, contains the character data as a string. 
If a handler function is set to an empty string, or FALSE, the handler in 
question is disabled. 
TRUE is returned if the handler is set up, FALSE if parser is not a 
parser. 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_parser_set_optionUpxml_set_default_handler
#

#T=bool xml_set_character_data_handler ( resource parser, callback handler)
xml_set_character_data_handler ( ^!resource parser, callback handler);
#

#T=xml_set_default_handler - bool xml_set_default_handler ( resource parser, callback handler)
(PHP 3>= 3.0.6, PHP 4 )
xml_set_default_handler -- set up default handler
Description
bool xml_set_default_handler ( resource parser, callback handler)
Sets the default handler function for the XML parser parser. handler is a 
string containing the name of a function that must exist when xml_parse() 
is called for parser. 
The function named by handler must accept two parameters: handler ( 
resource parser, string data)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
data
The second parameter, data, contains the character data. This may be the 
XML declaration, document type declaration, entities or other data for 
which no other handler exists. 
If a handler function is set to an empty string, or FALSE, the handler in 
question is disabled. 
TRUE is returned if the handler is set up, FALSE if parser is not a 
parser. 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_character_data_handlerUpxml_set_element_handler
#

#T=bool xml_set_default_handler ( resource parser, callback handler)
xml_set_default_handler ( ^!resource parser, callback handler);
#

#T=xml_set_element_handler - bool xml_set_element_handler ( resource parser, callback 
(PHP 3>= 3.0.6, PHP 4 )
xml_set_element_handler -- set up start and end element handlers
Description
bool xml_set_element_handler ( resource parser, callback 
start_element_handler, callback end_element_handler)
Sets the element handler functions for the XML parser parser. 
start_element_handler and end_element_handler are strings containing the 
names of functions that must exist when xml_parse() is called for parser. 
The function named by start_element_handler must accept three parameters: 
start_element_handler ( resource parser, string name, array attribs)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
name
The second parameter, name, contains the name of the element for which 
this handler is called. If case-folding is in effect for this parser, 
the element name will be in uppercase letters. 
attribs
The third parameter, attribs, contains an associative array with the 
element's attributes (if any). The keys of this array are the attribute 
names, the values are the attribute values. Attribute names are 
case-folded on the same criteria as element names. Attribute values are 
not case-folded. 
The original order of the attributes can be retrieved by walking through 
attribs the normal way, using each(). The first key in the array was the 
first attribute, and so on. 
The function named by end_element_handler must accept two parameters: 
end_element_handler ( resource parser, string name)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
name
The second parameter, name, contains the name of the element for which 
this handler is called. If case-folding is in effect for this parser, 
the element name will be in uppercase letters. 
If a handler function is set to an empty string, or FALSE, the handler in 
question is disabled. 
TRUE is returned if the handlers are set up, FALSE if parser is not a 
parser. 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_default_handlerUpxml_set_end_namespace_decl_handler
#

#T=bool xml_set_element_handler ( resource parser, callback 
xml_set_element_handler ( ^!resource parser, callback ;
#

#T=xml_set_end_namespace_decl_handler - bool xml_set_end_namespace_decl_handler ( resource pind, callback handler)
(PHP 4 >= 4.0.5)
xml_set_end_namespace_decl_handler --  Set up character data handler 
Description
bool xml_set_end_namespace_decl_handler ( resource pind, callback handler)
Warning
This function is currently not documented; only the argument list is 
available.

Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_element_handlerUpxml_set_external_entity_ref_handler
#

#T=bool xml_set_end_namespace_decl_handler ( resource pind, callback handler)
xml_set_end_namespace_decl_handler ( ^!resource pind, callback handler);
#

#T=xml_set_external_entity_ref_handler - bool xml_set_external_entity_ref_handler ( resource parser, callback 
(PHP 3>= 3.0.6, PHP 4 )
xml_set_external_entity_ref_handler -- set up external entity reference 
handler
Description
bool xml_set_external_entity_ref_handler ( resource parser, callback 
handler)
Sets the external entity reference handler function for the XML parser 
parser. handler is a string containing the name of a function that must 
exist when xml_parse() is called for parser. 
The function named by handler must accept five parameters, and should 
return an integer value. If the value returned from the handler is FALSE 
(which it will be if no value is returned), the XML parser will stop 
parsing and xml_get_error_code() will return 
XML_ERROR_EXTERNAL_ENTITY_HANDLING. handler ( resource parser, string 
open_entity_names, string base, string system_id, string public_id)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
open_entity_names
The second parameter, open_entity_names, is a space-separated list of 
the names of the entities that are open for the parse of this entity 
(including the name of the referenced entity). 
base
This is the base for resolving the system identifier (system_id) of the 
external entity. Currently this parameter will always be set to an empty 
string. 
system_id
The fourth parameter, system_id, is the system identifier as specified 
in the entity declaration. 
public_id
The fifth parameter, public_id, is the public identifier as specified in 
the entity declaration, or an empty string if none was specified; the 
whitespace in the public identifier will have been normalized as 
required by the XML spec. 
If a handler function is set to an empty string, or FALSE, the handler in 
question is disabled. 
TRUE is returned if the handler is set up, FALSE if parser is not a 
parser. 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_end_namespace_decl_handlerUpxml_set_notation_decl_handler
#

#T=bool xml_set_external_entity_ref_handler ( resource parser, callback 
xml_set_external_entity_ref_handler ( ^!resource parser, callback ;
#

#T=xml_set_notation_decl_handler - bool xml_set_notation_decl_handler ( resource parser, callback handler)
(PHP 3>= 3.0.6, PHP 4 )
xml_set_notation_decl_handler -- set up notation declaration handler
Description
bool xml_set_notation_decl_handler ( resource parser, callback handler)
Sets the notation declaration handler function for the XML parser parser. 
handler is a string containing the name of a function that must exist when 
xml_parse() is called for parser. 
A notation declaration is part of the document's DTD and has the following 
format: <!NOTATION <parameter>name</parameter>
{ <parameter>systemId</parameter> | <parameter>publicId</parameter>?>
See section 4.7 of the XML 1.0 spec for the definition of notation 
declarations. 
The function named by handler must accept five parameters: handler ( 
resource parser, string notation_name, string base, string system_id, 
string public_id)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
notation_name
This is the notation's name, as per the notation format described above. 

base
This is the base for resolving the system identifier (system_id) of the 
notation declaration. Currently this parameter will always be set to an 
empty string. 
system_id
System identifier of the external notation declaration. 
public_id
Public identifier of the external notation declaration. 
If a handler function is set to an empty string, or FALSE, the handler in 
question is disabled. 
TRUE is returned if the handler is set up, FALSE if parser is not a 
parser. 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_external_entity_ref_handlerUpxml_set_object
#

#T=bool xml_set_notation_decl_handler ( resource parser, callback handler)
xml_set_notation_decl_handler ( ^!resource parser, callback handler);
#

#T=xml_set_object - void xml_set_object ( resource parser, object object)
(PHP 4 )
xml_set_object -- Use XML Parser within an object
Description
void xml_set_object ( resource parser, object object)
This function allows to use parser inside object. All callback functions 
could be set with xml_set_element_handler() etc and assumed to be methods 
of object. 
<?php
class xml  {
var $parser;

function xml() {
    $this->parser = xml_parser_create();

    xml_set_object($this->parser, &$this);
    xml_set_element_handler($this->parser, "tag_open", 
"tag_close");
    xml_set_character_data_handler($this->parser, "cdata");
}

function parse($data) { 
    xml_parse($this->parser, $data);
}

function tag_open($parser, $tag, $attributes) { 
    var_dump($parser, $tag, $attributes); 
}

function cdata($parser, $cdata) {
    var_dump($parser, $cdata);
}

function tag_close($parser, $tag) {
    var_dump($parser, $tag);
}

} // end of class xml

$xml_parser = new xml();
$xml_parser->parse("<A ID='hallo'>PHP</A>");
?> 
  xml_set_notation_decl_handlerUpxml_set_processing_instruction_handler
#

#T=void xml_set_object ( resource parser, object object)
xml_set_object ( ^!resource parser, object object);
#

#T=xml_set_processing_instruction_handler - bool xml_set_processing_instruction_handler ( resource parser, callback 
(PHP 3>= 3.0.6, PHP 4 )
xml_set_processing_instruction_handler --  Set up processing instruction 
(PI) handler 
Description
bool xml_set_processing_instruction_handler ( resource parser, callback 
handler)
Sets the processing instruction (PI) handler function for the XML parser 
parser. handler is a string containing the name of a function that must 
exist when xml_parse() is called for parser. 
A processing instruction has the following format: 
<?
target 
data?>

You can put PHP code into such a tag, but be aware of one limitation: in 
an XML PI, the PI end tag (?>) can not be quoted, so this character 
sequence should not appear in the PHP code you embed with PIs in XML 
documents. If it does, the rest of the PHP code, as well as the "real" PI 
end tag, will be treated as character data. 
The function named by handler must accept three parameters: handler ( 
resource parser, string target, string data)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
target
The second parameter, target, contains the PI target. 
data
The third parameter, data, contains the PI data. 
If a handler function is set to an empty string, or FALSE, the handler in 
question is disabled. 
TRUE is returned if the handler is set up, FALSE if parser is not a 
parser. 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_objectUpxml_set_start_namespace_decl_handler
#

#T=bool xml_set_processing_instruction_handler ( resource parser, callback 
xml_set_processing_instruction_handler ( ^!resource parser, callback ;
#

#T=xml_set_start_namespace_decl_handler - bool xml_set_start_namespace_decl_handler ( resource pind, callback hdl)
(PHP 4 >= 4.0.5)
xml_set_start_namespace_decl_handler --  Set up character data handler 
Description
bool xml_set_start_namespace_decl_handler ( resource pind, callback hdl)
Warning
This function is currently not documented; only the argument list is 
available.

Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_processing_instruction_handlerUpxml_set_unparsed_entity_decl_handler
#

#T=bool xml_set_start_namespace_decl_handler ( resource pind, callback hdl)
xml_set_start_namespace_decl_handler ( ^!resource pind, callback hdl);
#

#T=xml_set_unparsed_entity_decl_handler - bool xml_set_unparsed_entity_decl_handler ( resource parser, callback 
(PHP 3>= 3.0.6, PHP 4 )
xml_set_unparsed_entity_decl_handler --  Set up unparsed entity 
declaration handler 
Description
bool xml_set_unparsed_entity_decl_handler ( resource parser, callback 
handler)
Sets the unparsed entity declaration handler function for the XML parser 
parser. handler is a string containing the name of a function that must 
exist when xml_parse() is called for parser. 
This handler will be called if the XML parser encounters an external 
entity declaration with an NDATA declaration, like the following: <!ENTITY <parameter>name</parameter> {<parameter>publicId</parameter> | <parameter>systemId</parameter>}
NDATA <parameter>notationName</parameter>

See section 4.2.2 of the XML 1.0 spec for the definition of notation 
declared external entities. 
The function named by handler must accept six parameters: handler ( 
resource parser, string entity_name, string base, string system_id, string 
public_id, string notation_name)
parser
The first parameter, parser, is a reference to the XML parser calling 
the handler. 
entity_name
The name of the entity that is about to be defined. 
base
This is the base for resolving the system identifier (systemId) of the 
external entity. Currently this parameter will always be set to an empty 
string. 
system_id
System identifier for the external entity. 
public_id
Public identifier for the external entity. 
notation_name
Name of the notation of this entity (see 
xml_set_notation_decl_handler()). 
If a handler function is set to an empty string, or FALSE, the handler in 
question is disabled. 
TRUE is returned if the handler is set up, FALSE if parser is not a 
parser. 
Note: Instead of a function name, an array containing an object 
reference and a method name can also be supplied.  xml_set_start_namespace_decl_handlerUpXML-RPC functions
#

#T=bool xml_set_unparsed_entity_decl_handler ( resource parser, callback 
xml_set_unparsed_entity_decl_handler ( ^!resource parser, callback ;
#

#T=xmlrpc_decode_request - array xmlrpc_decode_request ( string xml, string &method [, string 
(PHP 4 >= 4.1.0)
xmlrpc_decode_request -- Decodes XML into native PHP types
Description
array xmlrpc_decode_request ( string xml, string &method [, string 
encoding])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  XML-RPC functionsUpxmlrpc_decode
#

#T=array xmlrpc_decode_request ( string xml, string &method [, string 
xmlrpc_decode_request ( ^!string xml, string &method [, string ;
#

#T=xmlrpc_decode - array xmlrpc_decode ( string xml [, string encoding])
(PHP 4 >= 4.1.0)
xmlrpc_decode -- Decodes XML into native PHP types
Description
array xmlrpc_decode ( string xml [, string encoding])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_decode_requestUpxmlrpc_encode_request
#

#T=array xmlrpc_decode ( string xml [, string encoding])
xmlrpc_decode ( ^!string xml [, string encoding]);
#

#T=xmlrpc_encode_request - string xmlrpc_encode_request ( string method, mixed params)
(PHP 4 >= 4.1.0)
xmlrpc_encode_request -- Generates XML for a method request
Description
string xmlrpc_encode_request ( string method, mixed params)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_decodeUpxmlrpc_encode
#

#T=string xmlrpc_encode_request ( string method, mixed params)
xmlrpc_encode_request ( ^!string method, mixed params);
#

#T=xmlrpc_encode - string xmlrpc_encode ( mixed value)
(PHP 4 >= 4.1.0)
xmlrpc_encode -- Generates XML for a PHP value
Description
string xmlrpc_encode ( mixed value)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_encode_requestUpxmlrpc_get_type
#

#T=string xmlrpc_encode ( mixed value)
xmlrpc_encode ( ^!mixed value);
#

#T=xmlrpc_get_type - string xmlrpc_get_type ( mixed value)
(PHP 4 >= 4.1.0)
xmlrpc_get_type -- Gets xmlrpc type for a PHP value. Especially useful for 
base64 and datetime strings
Description
string xmlrpc_get_type ( mixed value)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_encodeUpxmlrpc_parse_method_descriptions
#

#T=string xmlrpc_get_type ( mixed value)
xmlrpc_get_type ( ^!mixed value);
#

#T=xmlrpc_parse_method_descriptions - 
xmlrpc_parse_method_de
(PHP 4 >= 4.1.0)
xmlrpc_parse_method_descriptions -- Decodes XML into a list of method 
descriptions
Description
array xmlrpc_parse_method_descriptions ( string xml)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_get_typeUpxmlrpc_server_add_introspection_data
#

#T=
(PHP 4 >= 4.1.0

PHP 4 ^!>= 4.1.0;
#

#T=xmlrpc_server_add_introspection_data - int xmlrpc_server_add_introspection_data ( resource server, array desc)
(PHP 4 >= 4.1.0)
xmlrpc_server_add_introspection_data -- Adds introspection documentation
Description
int xmlrpc_server_add_introspection_data ( resource server, array desc)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_parse_method_descriptionsUpxmlrpc_server_call_method
#

#T=int xmlrpc_server_add_introspection_data ( resource server, array desc)
xmlrpc_server_add_introspection_data ( ^!resource server, array desc);
#

#T=xmlrpc_server_call_method - mixed xmlrpc_server_call_method ( resource server, string xml, mixed 
(PHP 4 >= 4.1.0)
xmlrpc_server_call_method -- Parses XML requests and call methods
Description
mixed xmlrpc_server_call_method ( resource server, string xml, mixed 
user_data [, array output_options])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_server_add_introspection_dataUpxmlrpc_server_create
#

#T=mixed xmlrpc_server_call_method ( resource server, string xml, mixed 
xmlrpc_server_call_method ( ^!resource server, string xml, mixed ;
#

#T=xmlrpc_server_create - resource xmlrpc_server_create ( void )
(PHP 4 >= 4.1.0)
xmlrpc_server_create -- Creates an xmlrpc server
Description
resource xmlrpc_server_create ( void )
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_server_call_methodUpxmlrpc_server_destroy
#

#T=resource xmlrpc_server_create ( void )
xmlrpc_server_create ( ^!void );
#

#T=xmlrpc_server_destroy - int xmlrpc_server_destroy ( resource server)
(PHP 4 >= 4.1.0)
xmlrpc_server_destroy -- Destroys server resources
Description
int xmlrpc_server_destroy ( resource server)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_server_createUpxmlrpc_server_register_introspection_callback
#

#T=int xmlrpc_server_destroy ( resource server)
xmlrpc_server_destroy ( ^!resource server);
#

#T=xmlrpc_server_register_introspection_callback - bool xmlrpc_server_register_introspection_callback ( resource server, 
(PHP 4 >= 4.1.0)
xmlrpc_server_register_introspection_callback -- Register a PHP function 
to generate documentation
Description
bool xmlrpc_server_register_introspection_callback ( resource server, 
string function)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_server_destroyUpxmlrpc_server_register_method
#

#T=bool xmlrpc_server_register_introspection_callback ( resource server, 
xmlrpc_server_register_introspection_callback ( ^!resource server, ;
#

#T=xmlrpc_server_register_method - bool xmlrpc_server_register_method ( resource server, string method_name, 
(PHP 4 >= 4.1.0)
xmlrpc_server_register_method -- Register a PHP function to resource 
method matching method_name
Description
bool xmlrpc_server_register_method ( resource server, string method_name, 
string function)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_server_register_introspection_callbackUpxmlrpc_set_type
#

#T=bool xmlrpc_server_register_method ( resource server, string method_name, 
xmlrpc_server_register_method ( ^!resource server, string method_name, ;
#

#T=xmlrpc_set_type - bool xmlrpc_set_type ( string value, string type)
(PHP 4 >= 4.1.0)
xmlrpc_set_type -- Sets xmlrpc type, base64 or datetime, for a PHP string 
value
Description
bool xmlrpc_set_type ( string value, string type)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

Warning
This function is currently not documented; only the argument list is 
available.
  xmlrpc_server_register_methodUpXSLT functions
#

#T=bool xmlrpc_set_type ( string value, string type)
xmlrpc_set_type ( ^!string value, string type);
#

#T=xpath_eval_expression - array xpath_eval_expression ( object xpath_context)
(PHP 4 >= 4.0.4)
xpath_eval_expression --  Evaluates the XPath Location Path in the given 
string 
Description
array xpath_eval_expression ( object xpath_context)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also xpath_eval()   domxml_xslt_stylesheetUpxpath_eval
#

#T=array xpath_eval_expression ( object xpath_context)
xpath_eval_expression ( ^!object xpath_context);
#

#T=xpath_eval - array xpath_eval ( object xpath context, string xpath expression [, object 
(PHP 4 >= 4.0.4)
xpath_eval --  Evaluates the XPath Location Path in the given string 
Description
array xpath_eval ( object xpath context, string xpath expression [, object 
contextnode])
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

The optional contextnode can be specified for doing relative XPath 
queries. 
See also xpath_new_context()   xpath_eval_expressionUpxpath_new_context
#

#T=array xpath_eval ( object xpath context, string xpath expression [, object 
xpath_eval ( ^!object xpath context, string xpath expression [, object ;
#

#T=xpath_new_context - object xpath_new_context ( object dom document)
(PHP 4 >= 4.0.4)
xpath_new_context --  Creates new xpath context 
Description
object xpath_new_context ( object dom document)
Warning
This function is EXPERIMENTAL. The behaviour of this function, the 
name of this function, and anything else documented about this 
function may change without notice in a future release of PHP. Use 
this function at your own risk.

See also xpath_eval()   xpath_evalUpxptr_eval
#

#T=object xpath_new_context ( object dom document)
xpath_new_context ( ^!object dom document);
#

#T=xptr_eval - int xptr_eval ( [object xpath_context, string eval_str])
(PHP 4 >= 4.0.4)
xptr_eval --  Evaluate the XPtr Location Path in the given string 
Description
int xptr_eval ( [object xpath_context, string eval_str])
Warning
This function is currently not documented; only the argument list is 
available.
  xpath_new_contextUpxptr_new_context
#

#T=int xptr_eval ( [object xpath_context, string eval_str])
xptr_eval ( ^![object xpath_context, string eval_str]);
#

#T=xptr_new_context - string xptr_new_context ( [object doc_handle])
(PHP 4 >= 4.0.4)
xptr_new_context --  Create new XPath Context 
Description
string xptr_new_context ( [object doc_handle])
Warning
This function is currently not documented; only the argument list is 
available.
  xptr_evalUp.NET functions
#

#T=string xptr_new_context ( [object doc_handle])
xptr_new_context ( ^![object doc_handle]);
#

#T=xslt_create - resource xslt_create ( void )
(PHP 4 >= 4.0.3)
xslt_create -- Create a new XSLT processor
Description
resource xslt_create ( void )
Create and return a new XSLT processor resource for manipulation by the 
other XSLT functions. 
Example 1. xslt_create() example
  <?php
  function xml2html($xmldata, $xsl) { 
      /* $xmldata -> your XML */
      /* $xsl -> XSLT file */     

      $path = 'include';
      $arguments = array('/_xml' => $xmldata);
      $xsltproc = xslt_create();
      xslt_set_encoding($xsltproc, 'ISO-8859-1');
      $html =
	  xslt_process($xsltproc, 'arg:/_xml', "$path/$xsl", 
  NULL, $arguments);

      if (empty($html)) {
	 die('XSLT processing error: '. xslt_error($xsltproc));
      }
      xslt_free($xsltproc);
      return $html;
  }            
  ?> 
See also xslt_free().   XSLT functionsUpxslt_errno
#

#T=resource xslt_create ( void )
xslt_create ( ^!void );
#

#T=xslt_errno - int xslt_errno ( resource xh)
(PHP 4 >= 4.0.3)
xslt_errno -- Returns an error number
Description
int xslt_errno ( resource xh)
Returns an error code describing the last error that occurred on the 
passed XSLT processor.   xslt_createUpxslt_error
#

#T=int xslt_errno ( resource xh)
xslt_errno ( ^!resource xh);
#

#T=xslt_error - mixed xslt_error ( resource xh)
(PHP 4 >= 4.0.3)
xslt_error -- Returns an error string
Description
mixed xslt_error ( resource xh)
Returns a string describing the last error that occurred on the passed 
XSLT processor. 
Example 1. Handling errors using the xslt_error() and xslt_errno() 
functions. 
  <?php

  $xh = xslt_create();
  $result = xslt_process($xh, 'dog.xml', 'pets.xsl');
  if (!$result) {
      die(sprintf("Cannot process XSLT document [%d]: %s", 
		  xslt_errno($xh), xslt_error($xh)));
  }

  echo $result;

  xslt_free($xh);
  ?> 

  xslt_errnoUpxslt_free
#

#T=mixed xslt_error ( resource xh)
xslt_error ( ^!resource xh);
#

#T=xslt_free - void xslt_free ( resource xh)
(PHP 4 >= 4.0.3)
xslt_free -- Free XSLT processor
Description
void xslt_free ( resource xh)
Free the XSLT processor identified by the given handle. 
See also xslt_create()   xslt_errorUpxslt_process
#

#T=void xslt_free ( resource xh)
xslt_free ( ^!resource xh);
#

#T=xslt_process - mixed xslt_process ( resource xh, string xmlcontainer, string xslcontainer 
(PHP 4 >= 4.0.3)
xslt_process -- Perform an XSLT transformation
Description
mixed xslt_process ( resource xh, string xmlcontainer, string xslcontainer 
[, string resultcontainer [, array arguments [, array parameters]]])
The xslt_process() function is the crux of the new XSLT extension. It 
allows you to perform an XSLT transformation using almost any type of 
input source - the containers. This is accomplished through the use of 
argument buffers -- a concept taken from the Sablotron XSLT processor 
(currently the only XSLT processor this extension supports). The input 
containers default to a filename 'containing' the document to be 
processed. The result container defaults to a filename for the transformed 
document. If the result container is not specified - i.e. NULL - than the 
result is returned. 
Warning
This function has changed it's arguments, sinceversion 4.0.6. Do NOT 
provide the actual XML or XSL content as 2nd and 3rd argument, as 
this will create a segmentation fault, in Sablotron versions up to 
and including 0.95. 

Containers can also be set via the $arguments array (see below). 
The simplest type of transformation with the xslt_process() function is 
the transformation of an XML file with an XSLT file, placing the result in 
a third file containing the new XML (or HTML) document. Doing this with 
sablotron is really quite easy... 
Example 1. Using the xslt_process() to transform an XML file and a 
XSL file to a new XML file
  <?php

  // Allocate a new XSLT processor
  $xh = xslt_create();

  // Process the document
  if (xslt_process($xh, 'sample.xml', 'sample.xsl', 
  'result.xml')) {
      echo "SUCCESS, sample.xml was transformed by sample.xsl 
  into result.xml";
      echo ", result.xml has the following contents\n<br />\n";
      echo "<pre>\n";
      readfile('result.xml');
      echo "</pre>\n";
  } else {
      echo "Sorry, sample.xml could not be transformed by 
  sample.xsl into";
      echo "  result.xml the reason is that " . xslt_error($xh) 
  . " and the ";
      echo "error code is " . xslt_errno($xh);
  }

  xslt_free($xh);

  ?> 
While this functionality is great, many times, especially in a web 
environment, you want to be able to print out your results directly. 
Therefore, if you omit the third argument to the xslt_process() function 
(or provide a NULL value for the argument), it will automatically return 
the value of the XSLT transformation, instead of writing it to a file... 
Example 2. Using the xslt_process() to transform an XML file and a 
XSL file to a variable containing the resulting XML data
  <?php

  // Allocate a new XSLT processor
  $xh = xslt_create();

  // Process the document, returning the result into the $result 
  variable
  $result = xslt_process($xh, 'sample.xml', 'sample.xsl');
  if ($result) {
      echo "SUCCESS, sample.xml was transformed by sample.xsl 
  into the \$result";
      echo " variable, the \$result variable has the following 
  contents\n<br />\n";
      echo "<pre>\n";
      echo $result;
      echo "</pre>\n";
  } else {
      echo "Sorry, sample.xml could not be transformed by 
  sample.xsl into";
      echo "  the \$result variable the reason is that " . 
  xslt_error($xh) . 
      echo " and the error code is " . xslt_errno($xh);
  }

  xslt_free($xh);

  ?> 
The above two cases are the two simplest cases there are when it comes to 
XSLT transformation and I'd dare say that they are the most common cases, 
however, sometimes you get your XML and XSLT code from external sources, 
such as a database or a socket. In these cases you'll have the XML and/or 
XSLT data in a variable -- and in production applications the overhead of 
dumping these to file may be too much. This is where XSLT's "argument" 
syntax, comes to the rescue. Instead of files as the XML and XSLT 
arguments to the xslt_process() function, you can specify "argument place 
holders" which are then substituted by values given in the arguments array 
(5th parameter to the xslt_process() function). The following is an 
example of processing XML and XSLT into a result variable without the use 
of files at all. 
Example 3. Using the xslt_process() to transform a variable 
containing XML data and a variable containing XSL data into a 
variable containing the resulting XML data
  <?php
  // $xml and $xsl contain the XML and XSL data

  $arguments = array(
       '/_xml' => $xml,
       '/_xsl' => $xsl
  );

  // Allocate a new XSLT processor
  $xh = xslt_create();

  // Process the document
  $result = xslt_process($xh, 'arg:/_xml', 'arg:/_xsl', NULL, 
  $arguments); 
  if ($result) {
      echo "SUCCESS, sample.xml was transformed by sample.xsl 
  into the \$result";
      echo " variable, the \$result variable has the following 
  contents\n<br />\n";
      echo "<pre>\n";
      echo $result;
      echo "</pre>\n";
  } else {
      echo "Sorry, sample.xml could not be transformed by 
  sample.xsl into";
      echo "  the \$result variable the reason is that " . 
  xslt_error($xh) . 
      echo " and the error code is " . xslt_errno($xh);
  }
  xslt_free($xh);
  ?> 
Finally, the last argument to the xslt_process() function represents an 
array for any top-level parameters that you want to pass to the XSLT 
document. These parameters can then be accessed within your XSL files 
using the <xsl:param name="parameter_name"> instruction. The parameters 
must be UTF-8 encoded and their values will be interpreted as strings by 
the Sablotron processor. In other words - you cannot pass node-sets as 
parameters to the XSLT document. 
Note: Please note that file:// is needed in front of path if you use 
Windows.   xslt_freeUpxslt_set_base
#

#T=mixed xslt_process ( resource xh, string xmlcontainer, string xslcontainer 
xslt_process ( ^!resource xh, string xmlcontainer, string xslcontainer ;
#

#T=xslt_set_base - void xslt_set_base ( resource xh, string uri)
(PHP 4 >= 4.0.5)
xslt_set_base -- Set the base URI for all XSLT transformations
Description
void xslt_set_base ( resource xh, string uri)
Sets the base URI for all XSLT transformations, the base URI is used with 
Xpath instructions to resolve document() and other commands which access 
external resources. It is also used to resolve URIs for the <xsl:include> 
and <xsl:import> elements. 
As of 4.3, the default base URI is the directory of the executing script. 
In effect, it is the directory name value of the __FILE__ constant. Prior 
to 4.3, the default base URI was less predictable. 
Note: Please note that file:// is needed in front of path if you use 
Windows.   xslt_processUpxslt_set_encoding
#

#T=void xslt_set_base ( resource xh, string uri)
xslt_set_base ( ^!resource xh, string uri);
#

#T=xslt_set_encoding - void xslt_set_encoding ( resource xh, string encoding)
(PHP 4 >= 4.0.5)
xslt_set_encoding -- Set the encoding for the parsing of XML documents
Description
void xslt_set_encoding ( resource xh, string encoding)
Set the output encoding for the XSLT transformations. When using the 
Sablotron backend this option is only available when you compile Sablotron 
with encoding support.   xslt_set_baseUpxslt_set_error_handler
#

#T=void xslt_set_encoding ( resource xh, string encoding)
xslt_set_encoding ( ^!resource xh, string encoding);
#

#T=xslt_set_error_handler - void xslt_set_error_handler ( resource xh, mixed handler)
(PHP 4 >= 4.0.4)
xslt_set_error_handler -- Set an error handler for a XSLT processor
Description
void xslt_set_error_handler ( resource xh, mixed handler)
Set an error handler function for the XSLT processor given by xh, this 
function will be called whenever an error occurs in the XSLT 
transformation (this function is also called for notices).   xslt_set_encodingUpxslt_set_log
#

#T=void xslt_set_error_handler ( resource xh, mixed handler)
xslt_set_error_handler ( ^!resource xh, mixed handler);
#

#T=xslt_set_log - void xslt_set_log ( resource xh, mixed log)
(PHP 4 >= 4.0.6)
xslt_set_log -- Set the log file to write log messages to
Description
void xslt_set_log ( resource xh, mixed log)
xh
A reference to the XSLT parser. 
log
This parameter is either a boolean value which toggles logging on and 
off, or a string containing the logfile in which log errors too. 
This function allows you to set the file in which you want XSLT log 
messages to, XSLT log messages are different than error messages, in that 
log messages are not actually error messages but rather messages related 
to the state of the XSLT processor. They are useful for debugging XSLT, 
when something goes wrong. 
By default logging is disabled, in order to enable logging you must first 
call xslt_set_log() with a boolean parameter which enables logging, then 
if you want to set the log file to debug to, you must then pass it a 
string containing the filename: Example 1. Using the XSLT Logging 
features 
  <?php

  $xh = xslt_create();
  xslt_set_log($xh, true);
  xslt_set_log($xh, getcwd() . 'myfile.log');

  $result = xslt_process($xh, 'dog.xml', 'pets.xsl');
  echo $result;

  xslt_free($xh);
  ?> 
Note: Please note that file:// is needed in front of path if you use 
Windows.   xslt_set_error_handlerUpxslt_set_sax_handler
xslt_set_sax_handler
(4.0.3 - 4.0.6 only)
xslt_set_sax_handler -- Set SAX handlers for a XSLT processor
Description
void xslt_set_sax_handler ( resource xh, array handlers)
Set SAX handlers on the resource handle given by xh. SAX handlers should 
be a two dimensional array with the format (all top level elements are 
optional): 
array(
[document] => 
array(
    start document handler,
    end document handler
),
[element] => 
array(
    start element handler,
    end element handler
),
[namespace] => 
array(
    start namespace handler,
    end namespace handler
),
[comment] => comment handler,
[pi] => processing instruction handler,
[character] => character data handler
) 
  xslt_set_logUpxslt_set_sax_handlers
#

#T=void xslt_set_log ( resource xh, mixed log)
xslt_set_log ( ^!resource xh, mixed log);
#

#T=xslt_set_sax_handlers - void xslt_set_sax_handlers ( resource processor, array handlers)
(PHP 4 >= 4.0.6)
xslt_set_sax_handlers --  Set the SAX handlers to be called when the XML 
document gets processed 
Description
void xslt_set_sax_handlers ( resource processor, array handlers)
Warning
This function is currently not documented; only the argument list is 
available.
  xslt_set_sax_handlerUpxslt_set_scheme_handler
xslt_set_scheme_handler
(4.0.5 - 4.0.6 only)
xslt_set_scheme_handler -- Set Scheme handlers for a XSLT processor
Description
void xslt_set_scheme_handler ( resource xh, array handlers)
Set Scheme handlers on the resource handle given by xh. Scheme handlers 
should be an array with the format (all elements are optional): 
array(
[get_all] => get all handler,
[open] => open handler,
[get] => get handler,
[put] => put handler,
[close] => close handler
) 
  xslt_set_sax_handlersUpxslt_set_scheme_handlers
#

#T=void xslt_set_sax_handlers ( resource processor, array handlers)
xslt_set_sax_handlers ( ^!resource processor, array handlers);
#

#T=xslt_set_scheme_handlers - void xslt_set_scheme_handlers ( resource processor, array handlers)
(PHP 4 >= 4.0.6)
xslt_set_scheme_handlers --  Set the scheme handlers for the XSLT 
processor 
Description
void xslt_set_scheme_handlers ( resource processor, array handlers)
Warning
This function is currently not documented; only the argument list is 
available.
  xslt_set_scheme_handlerUpYAZ functions
#

#T=void xslt_set_scheme_handlers ( resource processor, array handlers)
xslt_set_scheme_handlers ( ^!resource processor, array handlers);
#

#T=yaz_addinfo - string yaz_addinfo ( resource id)
(PHP 4 >= 4.0.1)
yaz_addinfo -- Returns additional error information
Description
string yaz_addinfo ( resource id)
Returns additional error message for target (last request), identified by 
parameter id. An empty string is returned if the last operation was 
successful or if no additional information was provided by the target. 
See also yaz_error().   YAZ functionsUpyaz_ccl_conf
#

#T=string yaz_addinfo ( resource id)
yaz_addinfo ( ^!resource id);
#

#T=yaz_ccl_conf - int yaz_ccl_conf ( resource id, array config)
(PHP 4 >= 4.0.5)
yaz_ccl_conf -- Configure CCL parser
Description
int yaz_ccl_conf ( resource id, array config)
This function configures the CCL query parser for a target with 
definitions of access points (CCL qualifiers) and their mapping to RPN. To 
map a specific CCL query to RPN afterwards call the yaz_ccl_parse() 
function. Each index of the array config is the name of a CCL field and 
the corresponding value holds a string that specifies a mapping to RPN. 
The mapping is a sequence of attribute-type, attribute-value pairs. 
Attribute-type and attribute-value is separated by an equal sign (=). Each 
pair is separated by white space. 
Example 1. CCL configuration
In the example below, the CCL parser is configured to support three 
CCL fields: ti, au and isbn. Each field is mapped to their BIB-1 
equivalent. It is assumed that variable $id is the connection ID. 
  <?php
  $fields["ti"] = "1=4";
  $fields["au"] = "1=1";
  $fields["isbn"] = "1=7";
  yaz_ccl_conf($id, $fields);
  ?> 

  yaz_addinfoUpyaz_ccl_parse
#

#T=int yaz_ccl_conf ( resource id, array config)
yaz_ccl_conf ( ^!resource id, array config);
#

#T=yaz_ccl_parse - bool yaz_ccl_parse ( resource id, string query, array & result)
(PHP 4 >= 4.0.5)
yaz_ccl_parse -- Invoke CCL Parser
Description
bool yaz_ccl_parse ( resource id, string query, array & result)
This function invokes a CCL parser. It converts a given CCL FIND query to 
an RPN query which may be passed to the yaz_search() function to perform a 
search. To define a set of valid CCL fields call yaz_ccl_conf() prior to 
this function. If the supplied query was successfully converted to RPN, 
this function returns TRUE, and the index rpn of the supplied array result 
holds a valid RPN query. If the query could not be converted (because of 
invalid syntax, unknown field, etc.) this function returns FALSE and three 
indexes are set in the resulting array to indicate the cause of failure: 
errorcode CCL error code (integer), errorstring CCL error string, and 
errorpos approximate position in query of failure (integer is character 
position). 
Example 1. CCL Parsing
We will try to search using CCL. In the example below, $ccl is a CCL 
query. 
  <?php
  yaz_ccl_conf($id, $fields);  // see example for yaz_ccl_conf
  if (!yaz_ccl_parse($id, $ccl, &$cclresult)) {
      echo 'Error: ' . $cclresult["errorstring"];
  } else {
      $rpn = $cclresult["rpn"];
      yaz_search($id, "rpn", $rpn);
  }
  ?> 

  yaz_ccl_confUpyaz_close
#

#T=bool yaz_ccl_parse ( resource id, string query, array & result)
yaz_ccl_parse ( ^!resource id, string query, array & result);
#

#T=yaz_close - bool yaz_close ( resource id)
(PHP 4 >= 4.0.1)
yaz_close -- Close YAZ connection
Description
bool yaz_close ( resource id)
Closes the connection given by parameter id. The id is a connection 
resource as returned by a previous call to yaz_connect(). 
Returns TRUE on success or FALSE on failure.   yaz_ccl_parseUpyaz_connect
#

#T=bool yaz_close ( resource id)
yaz_close ( ^!resource id);
#

#T=yaz_connect - resource yaz_connect ( string zurl [, mixed options])
(PHP 4 >= 4.0.1)
yaz_connect --  Prepares for a connection to a Z39.50 target (server). 
Description
resource yaz_connect ( string zurl [, mixed options])
This function returns a connection resource on success, zero on failure. 
yaz_connect() prepares for a connection to a Z39.50 target. The zurl 
argument takes the form host[:port][/database]. If port is omitted 210 is 
used. If database is omitted Default is used. This function is 
non-blocking and does not attempt to establish a socket - it merely 
prepares a connect to be performed later when yaz_wait() is called. 
If the second argument, options, is given as a string it is treated as the 
Z39.50 V2 authentication string (OpenAuth). 
If options is given as an array the contents of the array serves as 
options. Note that array options are only supported for PHP 4.1.0 and 
later. 
yaz_connect() options
user
Username for authentication.
group
Group for authentication.
password
Password for authentication.
cookie
Cookie for session (YAZ proxy).
proxy
Proxy for connection (YAZ proxy).
persistent
A boolean. If TRUE the connection is persistent; If FALSE the connection 
is not persistent. By default connections are persistent. 
piggyback
A boolean. If TRUE piggyback is enabled for searches; If FALSE piggyback 
is disabled. By default piggyback is enabled. Enabling piggyback is more 
efficient and usually saves a network-round-trip for first time fetches 
of records. However, a few Z39.50 targets do not support piggyback or 
they ignore element set names. For those, piggyback should be disabled. 
charset
A string that specifies character set to be used in Z39.50 language and 
character set negotiation. Use strings such as: ISO-8859-1, UTF-8, 
UTF-16. 
Most Z39.50 targets do not support this feature (and thus, this is 
ignored). Many targets use the ISO-8859-1 encoding for queries and 
messages. MARC21/USMARC records are not affected by this setting. 
Note: The use of a proxy often improves performance. A Z39.50 proxy is 
part of the free YAZ++ package.   yaz_closeUpyaz_database
#

#T=resource yaz_connect ( string zurl [, mixed options])
yaz_connect ( ^!string zurl [, mixed options]);
#

#T=yaz_database - bool yaz_database ( resource id, string databases)
(PHP 4 >= 4.0.6)
yaz_database --  Specifies the databases within a session 
Description
bool yaz_database ( resource id, string databases)
This function specifies one or more databases to be used in search, 
retrieval, etc. - overriding databases specified in call to yaz_connect(). 
Multiple databases are separated by a plus sign +. 
This function allows you to use different sets of databases within a 
session. 
Returns TRUE on success or FALSE on failure.   yaz_connectUpyaz_element
#

#T=bool yaz_database ( resource id, string databases)
yaz_database ( ^!resource id, string databases);
#

#T=yaz_element - bool yaz_element ( resource id, string elementset)
(PHP 4 >= 4.0.1)
yaz_element --  Specifies Element-Set Name for retrieval 
Description
bool yaz_element ( resource id, string elementset)
This function sets the element set name for retrieval. Call this function 
before yaz_search() or yaz_present() to specify the element set name for 
records to be retrieved. Most servers support F (for full records) and B 
(for brief records). 
Returns TRUE on success or FALSE on failure.   yaz_databaseUpyaz_errno
#

#T=bool yaz_element ( resource id, string elementset)
yaz_element ( ^!resource id, string elementset);
#

#T=yaz_errno - int yaz_errno ( resource id)
(PHP 4 >= 4.0.1)
yaz_errno -- Returns error number
Description
int yaz_errno ( resource id)
Returns an errornumber for the target (last request) identified by id. The 
error code is either a Z39.50 diagnostic code (usually a Bib-1 diagnostic) 
or a client side error code which is generated by PHP/YAZ itself, such as 
"Connect failed", "Init Rejected", etc. 
yaz_errno() should be called after network activity for each target - 
(after yaz_wait() returns) to determine the success or failure of the last 
operation (e.g. search). To get a text description of the error, call 
yaz_error().   yaz_elementUpyaz_error
#

#T=int yaz_errno ( resource id)
yaz_errno ( ^!resource id);
#

#T=yaz_error - 
string yaz_error ( resourc
(PHP 4 >= 4.0.1)
yaz_error -- Returns error description
Description
string yaz_error ( resource id)
Returns an error text message for target (last request), identified by 
parameter id. An empty string is returned if the last operation was 
successful. 
yaz_error() returns an English text message corresponding to the last 
error number as returned by yaz_errno().   yaz_errnoUpyaz_get_option
#

#T=
string yaz_error ( resourc

yaz_error ( ^!resourc;
#

#T=yaz_get_option - string yaz_get_option ( resource id, string name)
(PHP 5 CVS only)
yaz_get_option -- Returns value of option for connection
Description
string yaz_get_option ( resource id, string name)
Returns the value of the option specified with name. If an option is not 
set, an empty string is returned. 
See the description of yaz_set_option() for available options.   yaz_errorUpyaz_hits
#

#T=string yaz_get_option ( resource id, string name)
yaz_get_option ( ^!resource id, string name);
#

#T=yaz_hits - int yaz_hits ( resource id)
(PHP 4 >= 4.0.1)
yaz_hits -- Returns number of hits for last search
Description
int yaz_hits ( resource id)
yaz_hits() returns the number of hits for the last search.   yaz_get_optionUpyaz_itemorder
#

#T=int yaz_hits ( resource id)
yaz_hits ( ^!resource id);
#

#T=yaz_itemorder - int yaz_itemorder ( resource id, array args)
(PHP 4 >= 4.0.5)
yaz_itemorder --  Prepares for Z39.50 Item Order with an ILL-Request 
package 
Description
int yaz_itemorder ( resource id, array args)
This function prepares for an Extended Services request using the Profile 
for the Use of Z39.50 Item Order Extended Service to Transport ILL 
(Profile/1). See this and the specification. The args parameter must be a 
hash array with information about the Item Order request to be sent. The 
key of the hash is the name of the corresponding ASN.1 tag path. For 
example, the ISBN below the Item-ID has the key item-id,ISBN. 
The ILL-Request parameters are: 

protocol-version-num
transaction-id,initial-requester-id,person-or-institution-symbol,person
transaction-id,initial-requester-id,person-or-institution-symbol,institution
transaction-id,initial-requester-id,name-of-person-or-institution,name-of-person
transaction-id,initial-requester-id,name-of-person-or-institution,name-of-institution
transaction-id,transaction-group-qualifier
transaction-id,transaction-qualifier
transaction-id,sub-transaction-qualifier
service-date-time,this,date
service-date-time,this,time
service-date-time,original,date
service-date-time,original,time
requester-id,person-or-institution-symbol,person
requester-id,person-or-institution-symbol,institution
requester-id,name-of-person-or-institution,name-of-person
requester-id,name-of-person-or-institution,name-of-institution
responder-id,person-or-institution-symbol,person
responder-id,person-or-institution-symbol,institution
responder-id,name-of-person-or-institution,name-of-person
responder-id,name-of-person-or-institution,name-of-institution
transaction-type
delivery-address,postal-address,name-of-person-or-institution,name-of-person
delivery-address,postal-address,name-of-person-or-institution,name-of-institution
delivery-address,postal-address,extended-postal-delivery-address
delivery-address,postal-address,street-and-number
delivery-address,postal-address,post-office-box
delivery-address,postal-address,city
delivery-address,postal-address,region
delivery-address,postal-address,country
delivery-address,postal-address,postal-code
delivery-address,electronic-address,telecom-service-identifier
delivery-address,electronic-address,telecom-service-addreess
billing-address,postal-address,name-of-person-or-institution,name-of-person
billing-address,postal-address,name-of-person-or-institution,name-of-institution
billing-address,postal-address,extended-postal-delivery-address
billing-address,postal-address,street-and-number
billing-address,postal-address,post-office-box
billing-address,postal-address,city
billing-address,postal-address,region
billing-address,postal-address,country
billing-address,postal-address,postal-code
billing-address,electronic-address,telecom-service-identifier
billing-address,electronic-address,telecom-service-addreess
ill-service-type
requester-optional-messages,can-send-RECEIVED
requester-optional-messages,can-send-RETURNED
requester-optional-messages,requester-SHIPPED
requester-optional-messages,requester-CHECKED-IN
search-type,level-of-service
search-type,need-before-date
search-type,expiry-date
search-type,expiry-flag
place-on-hold
client-id,client-name
client-id,client-status
client-id,client-identifier
item-id,item-type
item-id,call-number
item-id,author
item-id,title
item-id,sub-title
item-id,sponsoring-body
item-id,place-of-publication
item-id,publisher
item-id,series-title-number
item-id,volume-issue
item-id,edition
item-id,publication-date
item-id,publication-date-of-component
item-id,author-of-article
item-id,title-of-article
item-id,pagination
item-id,ISBN
item-id,ISSN
item-id,additional-no-letters
item-id,verification-reference-source
copyright-complicance
retry-flag
forward-flag
requester-note
forward-note

There are also a few parameters that are part of the Extended Services 
Request package and the ItemOrder package: 

package-name
user-id
contact-name
contact-phone
contact-email
itemorder-item
  yaz_hitsUpyaz_present
#

#T=int yaz_itemorder ( resource id, array args)
yaz_itemorder ( ^!resource id, array args);
#

#T=yaz_present - bool yaz_present ( resource id)
(PHP 4 >= 4.0.5)
yaz_present --  Prepares for retrieval (Z39.50 present). 
Description
bool yaz_present ( resource id)
This function prepares for retrieval of records after a successful search. 
The yaz_range() should be called prior to this function to specify the 
range of records to be retrieved. 
Returns TRUE on success or FALSE on failure.   yaz_itemorderUpyaz_range
#

#T=bool yaz_present ( resource id)
yaz_present ( ^!resource id);
#

#T=yaz_range - bool yaz_range ( resource id, int start, int number)
(PHP 4 >= 4.0.1)
yaz_range --  Specifies the maximum number of records to retrieve 
Description
bool yaz_range ( resource id, int start, int number)
This function should be called before either yaz_search() or yaz_present() 
to specify a range of records to be retrieved. The parameter start 
specifies the position of the first record to be retrieved and parameter 
number is the number of records. Records in a result set are numbered 1, 
2, ... $hits where $hits is the count returned by yaz_hits(). 
Returns TRUE on success or FALSE on failure.   yaz_presentUpyaz_record
#

#T=bool yaz_range ( resource id, int start, int number)
yaz_range ( ^!resource id, int start, int number);
#

#T=yaz_record - string yaz_record ( resource id, int pos, string type)
(PHP 4 >= 4.0.1)
yaz_record -- Returns a record
Description
string yaz_record ( resource id, int pos, string type)
Returns the record at position pos or an empty string if no record exists 
at the given position. 
The yaz_record() function inspects a record in the current result set at 
the position specified by parameter pos. If no database record exists at 
the given position an empty string is returned. The type specifies the 
form of the returned record. 
If type is "string" the record is returned in a string representation 
suitable for printing (for XML and SUTRS). If type is "array" the record 
is returned as an array representation (for structured records). If type 
is "raw" the record is returned in its original raw form. 
Records in a result set are numbered 1, 2, ... $hits where $hits is the 
count returned by yaz_hits().   yaz_rangeUpyaz_scan_result
#

#T=string yaz_record ( resource id, int pos, string type)
yaz_record ( ^!resource id, int pos, string type);
#

#T=yaz_scan_result - array yaz_scan_result ( resource id [, array & result])
(PHP 4 >= 4.0.5)
yaz_scan_result -- Returns Scan Response result
Description
array yaz_scan_result ( resource id [, array & result])
yaz_scan_result() returns terms and associated information as received 
from the target in the last performed yaz_scan(). This function returns an 
array (0..n-1) where n is the number of terms returned. Each value is a 
pair where the first item is the term, and the second item is the 
result-count. If the optional parameter result is given it will be 
modified to hold additional information taken from the Scan Response: 
number (number of entries returned), stepsize (Step-size), position 
(position of term), status (Scan Status).   yaz_recordUpyaz_scan
#

#T=array yaz_scan_result ( resource id [, array & result])
yaz_scan_result ( ^!resource id [, array & result]);
#

#T=yaz_scan - int yaz_scan ( resource id, string type, string startterm [, array flags])
(PHP 4 >= 4.0.5)
yaz_scan -- Prepares for a scan
Description
int yaz_scan ( resource id, string type, string startterm [, array flags])
This function prepares for a Z39.50 Scan Request, where parameter id 
specifies connection. Starting term point for the scan is given by 
startterm. The form in which the starting term is specified is given by 
parameter type. Currently only type rpn is supported. The optional 
parameter flags specifies additional information to control the behaviour 
of the scan request. Three indexes are currently read from the flags: 
number (number of terms requested), position (preferred position of term) 
and stepSize (preferred step size). To actually transfer the Scan Request 
to the target and receive the Scan Response, yaz_wait() must be called. 
Upon completion of yaz_wait() call yaz_error() and yaz_scan_result() to 
handle the response. 
The syntax of startterm is similar to the RPN query as described in 
yaz_search(). The startterm consists of zero or more @attr-operator 
specifications, then followed by exactly one token. 
Example 1. PHP function that scans titles
  <?php
  function scan_titles($id, $startterm) {
    yaz_scan($id, "rpn", "@attr 1=4 " . $startterm);
    yaz_wait();
    $errno = yaz_errno($id);
    if ($errno == 0) {
      $ar = yaz_scan_result($id, &$options);
      echo 'Scan ok; ';
      while (list($key, $val) = each($options)) {
	echo "$key = $val &nbsp;";
      }
      echo '<br /><table>';
      while (list($key, list($k, $term, $tcount)) = each($ar)) {
	if (empty($k)) continue;
	echo "<tr><td>$term</td><td>$tcount</td></tr>";
      }
      echo '</table>';
    } else {
      echo "Scan failed. Error: " . yaz_error($id) . "<br />";
    }
  }
  ?> 

  yaz_scan_resultUpyaz_schema
#

#T=int yaz_scan ( resource id, string type, string startterm [, array flags])
yaz_scan ( ^!resource id, string type, string startterm [, array flags]);
#

#T=yaz_schema - int yaz_schema ( resource id, string schema)
(PHP 4 >= 4.2.0)
yaz_schema --  Specifies schema for retrieval. 
Description
int yaz_schema ( resource id, string schema)
The schema must be specified as an OID (Object Identifier) in a raw 
dot-notation (like 1.2.840.10003.13.4) or as one of the known registered 
schemas: GILS-schema, Holdings, Zthes, ... This function should be called 
before yaz_search() or yaz_present().   yaz_scanUpyaz_search
#

#T=int yaz_schema ( resource id, string schema)
yaz_schema ( ^!resource id, string schema);
#

#T=yaz_search - int yaz_search ( resource id, string type, string query)
(PHP 4 >= 4.0.1)
yaz_search -- Prepares for a search
Description
int yaz_search ( resource id, string type, string query)
yaz_search() prepares for a search on the connection given by parameter 
id. The parameter type represents the query type - only "rpn" is supported 
now in which case the third argument specifies a Type-1 query in prefix 
query notation. Like yaz_connect() this function is non-blocking and only 
prepares for a search to be executed later when yaz_wait() is called. 
The RPN query
The RPN query is a textual representation of the Type-1 query as defined 
by the Z39.50 standard. However, in the text representation as used by YAZ 
a prefix notation is used, that is the operater precedes the operands. The 
query string is a sequence of tokens where white space is ignored unless 
surrounded by double quotes. Tokens beginning with an at-character (@) are 
considered operators, otherwise they are treated as search terms. 
Table 1. RPN Operators
ConstructDescription
@and query1 query2intersection of query1 and query2
@or query1 query2union of query1 and query2
@not query1 query2query1 and not query2
@set nameresult set reference
@attrset set queryspecifies attribute-set for query. This 
construction is only allowed once - in the beginning of the whole 
query
@attr [set] type=value queryapplies attribute to query. The type and 
value are integers specifying the attribute-type and attribute-value 
respectively. The set, if given, specifies the attribute-set.

Example 1. Query Examples
You can search for simple terms, like this computer
which matches documents where "computer" occur. No attributes are 
specified. 
The Query "knuth donald"
matches documents where "knuth donald" occur (provided that the 
server supports phrase search). 
This query applies two attributes for the same phrase. @attr 1=1003 @attr 4=1 "knuth donald"
First attribute is type 1 (Bib-1 use), attribute value is 1003 
(Author). Second attribute has is type 4 (structure), value 1 
(phrase), so this should match documents where Donald Knuth is 
author. 
This query @and @or a b @not @or c d e
would in infix notation look like (a or b) and ((c or d) not e). 
Another, more complex, one: @attrset gils @and @attr 1=4 art @attr 1=2000 company
The query as a whole uses the GILS attributeset. The query matches 
documents where art occur in the title (GILS,BIB-1) and in which 
company occur as Distributor (GILS). 

You can find information about attributes at the Z39.50 Maintenance Agency 
site. 
Note: If you would like to use a more friendly notation, use the CCL 
parser - functions yaz_ccl_conf() and yaz_ccl_parse().   yaz_schemaUpyaz_set_option
#

#T=int yaz_search ( resource id, string type, string query)
yaz_search ( ^!resource id, string type, string query);
#

#T=yaz_set_option - string yaz_set_option ( resource id, string name, string value)
(PHP 5 CVS only)
yaz_set_option -- Sets one or more options for connection
Description
string yaz_set_option ( resource id, string name, string value)
Sets option name to value. 
Table 1. PYP/YAZ Connection Options
NameDescription
implementationNameimplementation name of target
implementationVersionimplementation version of target
implementationIdimplementation ID of target
schemaschema for retrieval. By default, no schema is used. Setting 
this option is equivalent to using function yaz_schema()
preferredRecordSyntaxrecord syntax for retrieval. By default, no 
syntax is used. Setting this option is equivalent to using function 
yaz_syntax()
startoffset for first record to be retrieved via yaz_search() or 
yaz_present(). Records are numbered from zero and upwards. Setting 
this option in combination with option count has the same effect as 
calling yaz_range() except that records are numbered from 1 in 
yaz_range() 
countmaximum number of records to be retrieved via yaz_search() or 
yaz_present(). 
elementSetNameelement-set-name for retrieval. Setting this option is 
equivalent to calling yaz_element(). 
  yaz_searchUpyaz_sort
#

#T=string yaz_set_option ( resource id, string name, string value)
yaz_set_option ( ^!resource id, string name, string value);
#

#T=yaz_sort - int yaz_sort ( resource id, string criteria)
(PHP 4 >= 4.1.0)
yaz_sort -- Sets sorting criteria
Description
int yaz_sort ( resource id, string criteria)
This function sets sorting criteria and enables Z39.50 Sort. Call this 
function before yaz_search(). Using this function alone does not have any 
effect. When used in conjunction with yaz_search(), a Z39.50 Sort will be 
sent after a search response has been received and before any records are 
retrieved with Z39.50 Present (yaz_present(). The parameter criteria takes 
the form 
field1 flags1 field2 flags2 ... 
where field1 specifies the primary attributes for sort, field2 seconds, 
etc.. The field specifies either a numerical attribute combinations 
consisting of type=value pairs separated by comma (e.g. 1=4,2=1) ; or the 
field may specify a plain string criteria (e.g. title. The flags is a 
sequence of the following characters which may not be separated by any 
white space. 
Sort Flags
a
Sort ascending
d
Sort descending
i
Case insensitive sorting
s
Case sensitive sorting
Example 1. Sort Criterias
To sort on Bib1 attribute title, case insensitive, and ascending you 
would use the following sort criteria: 1=4 ia

If the secondary sorting criteria should be author, case sensitive 
and ascending you would use: 1=4 ia 1=1003 sa

  yaz_set_optionUpyaz_syntax
#

#T=int yaz_sort ( resource id, string criteria)
yaz_sort ( ^!resource id, string criteria);
#

#T=yaz_syntax - int yaz_syntax ( resource id, string syntax)
(PHP 4 >= 4.0.1)
yaz_syntax --  Specifies the preferred record syntax for retrieval. 
Description
int yaz_syntax ( resource id, string syntax)
The syntax must be specified as an OID (Object Identifier) in a raw 
dot-notation (like 1.2.840.10003.5.10) or as one of the known registered 
record syntaxes (sutrs, usmarc, grs1, xml, etc.). This function should be 
called before yaz_search() or yaz_present().   yaz_sortUpyaz_wait
#

#T=int yaz_syntax ( resource id, string syntax)
yaz_syntax ( ^!resource id, string syntax);
#

#T=yaz_wait - int yaz_wait ( [array options])
(PHP 4 >= 4.0.1)
yaz_wait -- Wait for Z39.50 requests to complete
Description
int yaz_wait ( [array options])
This function carries out networked (blocked) activity for outstanding 
requests which have been prepared by the functions yaz_connect(), 
yaz_search(), yaz_present(), yaz_scan() and yaz_itemorder(). yaz_wait() 
returns when all targets have either completed all requests or aborted (in 
case of errors). 
If the options array is given that holds options that change the behaviour 
of yaz_wait(). 
timeout
Sets timeout in seconds. If a target has not responded within the 
timeout it is considered dead and yaz_wait() returns. The default value 
for timeout is 15 seconds.   yaz_syntaxUpYP/NIS Functions
#

#T=int yaz_wait ( [array options])
yaz_wait ( ^![array options]);
#

#T=yp_all - void yp_all ( string domain, string map, string callback)
(PHP 4 >= 4.0.6)
yp_all --  Traverse the map and call a function on each entry 
Description
void yp_all ( string domain, string map, string callback)
Warning
This function is currently not documented; only the argument list is 
available.
  YP/NIS FunctionsUpyp_cat
#

#T=void yp_all ( string domain, string map, string callback)
yp_all ( ^!string domain, string map, string callback);
#

#T=yp_cat - array yp_cat ( string domain, string map)
(PHP 4 >= 4.0.6)
yp_cat --  Return an array containing the entire map 
Description
array yp_cat ( string domain, string map)
yp_cat() returns all map entries as an array with the maps key values as 
array indices and the maps entries as array data.   yp_allUpyp_err_string
#

#T=array yp_cat ( string domain, string map)
yp_cat ( ^!string domain, string map);
#

#T=yp_err_string - string yp_err_string ( int errorcode)
(PHP 4 >= 4.0.6)
yp_err_string --  Returns the error string associated with the given error 
code 
Description
string yp_err_string ( int errorcode)
yp_err_string() returns the error message associated with the given error 
code. Useful to indicate what exactly went wrong. 
Example 1. Example for NIS errors
  <?php
      echo "Error: " . yp_err_string(yp_errno());
  ?> 
See also yp_errno().   yp_catUpyp_errno
#

#T=string yp_err_string ( int errorcode)
yp_err_string ( ^!int errorcode);
#

#T=yp_errno - int yp_errno ( void )
(PHP 4 >= 4.0.6)
yp_errno --  Returns the error code of the previous operation 
Description
int yp_errno ( void )
yp_errno() returns the error code of the previous operation. 
Possible errors are: 
1 args to function are bad
2 RPC failure - domain has been unbound
3 can't bind to server on this domain
4 no such map in server's domain
5 no such key in map
6 internal yp server or client error
7 resource allocation failure
8 no more records in map database
9 can't communicate with portmapper
10 can't communicate with ypbind
11 can't communicate with ypserv
12 local domain name not set
13 yp database is bad
14 yp version mismatch
15 access violation
16 database busy

See also yp_err_string().   yp_err_stringUpyp_first
#

#T=int yp_errno ( void )
yp_errno ( ^!void );
#

#T=yp_first - array yp_first ( string domain, string map)
(PHP 3>= 3.0.7, PHP 4 )
yp_first --  Returns the first key-value pair from the named map 
Description
array yp_first ( string domain, string map)
yp_first() returns the first key-value pair from the named map in the 
named domain, otherwise FALSE. 
Example 1. Example for the NIS first
  <?php
  $entry = yp_first($domain, "passwd.byname");

  $key = key($entry);
  $value = $entry [$key];

  echo "First entry in this map has key " . $key . " and value " 
  . $value;
  ?> 
See also yp_next() and yp_get_default_domain().   yp_errnoUpyp_get_default_domain
#

#T=array yp_first ( string domain, string map)
yp_first ( ^!string domain, string map);
#

#T=yp_get_default_domain - int yp_get_default_domain ( void )
(PHP 3>= 3.0.7, PHP 4 )
yp_get_default_domain -- Fetches the machine's default NIS domain
Description
int yp_get_default_domain ( void )
yp_get_default_domain() returns the default domain of the node or FALSE. 
Can be used as the domain parameter for successive NIS calls. 
A NIS domain can be described a group of NIS maps. Every host that needs 
to look up information binds itself to a certain domain. Refer to the 
documents mentioned at the beginning for more detailed information. 
Example 1. Example for the default domain
  <?php
  $domain = yp_get_default_domain();
  echo "Default NIS domain is: " . $domain;
  ?> 

  yp_firstUpyp_master
#

#T=int yp_get_default_domain ( void )
yp_get_default_domain ( ^!void );
#

#T=yp_master - string yp_master ( string domain, string map)
(PHP 3>= 3.0.7, PHP 4 )
yp_master --  Returns the machine name of the master NIS server for a map 
Description
string yp_master ( string domain, string map)
yp_master() returns the machine name of the master NIS server for a map. 
Example 1. Example for the NIS master
  <?php
  $number = yp_master($domain, $mapname);
  echo "Master for this map is: " . $master;
  ?> 
See also yp_get_default_domain().   yp_get_default_domainUpyp_match
#

#T=string yp_master ( string domain, string map)
yp_master ( ^!string domain, string map);
#

#T=yp_match - string yp_match ( string domain, string map, string key)
(PHP 3>= 3.0.7, PHP 4 )
yp_match -- Returns the matched line
Description
string yp_match ( string domain, string map, string key)
yp_match() returns the value associated with the passed key out of the 
specified map or FALSE. This key must be exact.
Example 1. Example for NIS match
  <?php
  $entry = yp_match($domain, "passwd.byname", "joe");
  echo "Matched entry is: " . $entry;
  ?> 

The above code will produce : 
joe:##joe:11111:100:Joe User:/home/j/joe:/usr/local/bin/bash
See also yp_get_default_domain().   yp_masterUpyp_next
#

#T=string yp_match ( string domain, string map, string key)
yp_match ( ^!string domain, string map, string key);
#

#T=yp_next - array yp_next ( string domain, string map, string key)
(PHP 3>= 3.0.7, PHP 4 )
yp_next -- Returns the next key-value pair in the named map.
Description
array yp_next ( string domain, string map, string key)
yp_next() returns the next key-value pair in the named map after the 
specified key or FALSE. 
Example 1. Example for NIS next
  <?php
  $entry = yp_next($domain, "passwd.byname", "joe");

  if (!$entry) {
      echo "No more entries found\n";
      echo "<!--" . yp_errno() . ": " . yp_err_string() . "-->";
  }

  $key = key($entry);

  echo "The next entry after joe has key " . $key 
	. " and value " . $entry[$key];
  ?> 
See also yp_first() and yp_get_default_domain().   yp_matchUpyp_order
#

#T=array yp_next ( string domain, string map, string key)
yp_next ( ^!string domain, string map, string key);
#

#T=yp_order - int yp_order ( string domain, string map)
(PHP 3>= 3.0.7, PHP 4 )
yp_order -- Returns the order number for a map
Description
int yp_order ( string domain, string map)
yp_order() returns the order number for a map or FALSE. 
Example 1. Example for the NIS order
  <?php
      $number = yp_order($domain, $mapname);
      echo "Order number for this map is: " . $number;
  ?> 

#T=int yp_order ( string domain, string map)
yp_order ( ^!string domain, string map);
#
See also yp_get_default_domain().   yp_nextUpZip File Functions (Read Only Access)
#T=zend_logo_guid - string zend_logo_guid ( void )
(PHP 4 )
zend_logo_guid -- Gets the Zend guid
Description
string zend_logo_guid ( void )
This function returns the ID which can be used to display the Zend logo 
using the built-in image. 
Example 1. zend_logo_uid() example
  <?php

  echo '<img src="' . $_SERVER['PHP_SELF'] .
       '?=' . zend_logo_guid() . '" alt="Zend Logo !" />';

  ?> 
See also php_logo_guid().   version_compareUpzend_version
#

#T=string zend_logo_guid ( void )
zend_logo_guid ( ^!void );
#

#T=zend_version - string zend_version ( void )
(PHP 4 )
zend_version -- Gets the version of the current Zend engine
Description
string zend_version ( void )
Returns a string containing the version of the currently running Zend 
Engine. 
Example 1. zend_version() example
  <?php
  // prints e.g. 'Zend engine version: 1.0.4'
  echo "Zend engine version: " . zend_version();
  ?> 
See also phpinfo(), phpcredits(), php_logo_guid(), and phpversion().   zend_logo_guidUpPOSIX functions
zip_close
(4.1.0 - 4.3.2 only)
zip_close -- Close a Zip File Archive
Description
void zip_close ( resource zip)
Closes a zip file archive. The parameter zip must be a zip archive 
previously opened by zip_open(). 
This function has no return value. 
See also zip_open() and zip_read().   Zip File Functions (Read Only Access)Upzip_entry_close
zip_entry_close
(4.1.0 - 4.3.2 only)
zip_entry_close -- Close a Directory Entry
Description
void zip_entry_close ( resource zip_entry)
Closes a directory entry specified by zip_entry. The parameter zip_entry 
must be a valid directory entry opened by zip_entry_open(). 
This function has no return value. 
See also zip_entry_open() and zip_entry_read().   zip_closeUpzip_entry_compressedsize
zip_entry_compressedsize
(4.1.0 - 4.3.2 only)
zip_entry_compressedsize -- Retrieve the Compressed Size of a Directory 
Entry
Description
int zip_entry_compressedsize ( resource zip_entry)
Returns the compressed size of the directory entry specified by zip_entry. 
The parameter zip_entry is a valid directory entry returned by zip_read(). 

See also zip_open() and zip_read().   zip_entry_closeUpzip_entry_compressionmethod
zip_entry_compressionmethod
(4.1.0 - 4.3.2 only)
zip_entry_compressionmethod -- Retrieve the Compression Method of a 
Directory Entry
Description
string zip_entry_compressionmethod ( resource zip_entry)
Returns the compression method of the directory entry specified by 
zip_entry. The parameter zip_entry is a valid directory entry returned by 
zip_read(). 
See also zip_open() and zip_read().   zip_entry_compressedsizeUpzip_entry_filesize
zip_entry_filesize
(4.1.0 - 4.3.2 only)
zip_entry_filesize -- Retrieve the Actual File Size of a Directory Entry
Description
int zip_entry_filesize ( resource zip_entry)
Returns the actual size of the directory entry specified by zip_entry. The 
parameter zip_entry is a valid directory entry returned by zip_read(). 
See also zip_open() and zip_read().   zip_entry_compressionmethodUpzip_entry_name
zip_entry_name
(4.1.0 - 4.3.2 only)
zip_entry_name -- Retrieve the Name of a Directory Entry
Description
string zip_entry_name ( resource zip_entry)
Returns the name of the directory entry specified by zip_entry. The 
parameter zip_entry is a valid directory entry returned by zip_read(). 
See also zip_open() and zip_read().   zip_entry_filesizeUpzip_entry_open
zip_entry_open
(4.1.0 - 4.3.2 only)
zip_entry_open -- Open a Directory Entry for Reading
Description
bool zip_entry_open ( resource zip, resource zip_entry [, string mode])
Opens a directory entry in a zip file for reading. The parameter zip is a 
valid resource handle returned by zip_open(). The parameter zip_entry is a 
directory entry resource returned by zip_read(). The optional parameter 
mode can be any of the modes specified in the documentation for fopen(). 
Note: Currently, mode is ignored and is always "rb". This is due to the 
fact that zip support in PHP is read only access. Please see fopen() for 
an explanation of various modes, including "rb". 
Returns TRUE on success or FALSE on failure. 
Note: Unlike fopen() and other similar functions, the return value of 
zip_entry_open() only indicates the result of the operation and is not 
needed for reading or closing the directory entry. 
See also zip_entry_read() and zip_entry_close().   zip_entry_nameUpzip_entry_read
zip_entry_read
(4.1.0 - 4.3.2 only)
zip_entry_read -- Read From an Open Directory Entry
Description
string zip_entry_read ( resource zip_entry [, int length])
Reads up to length bytes from an open directory entry. If length is not 
specified, then zip_entry_read() will attempt to read 1024 bytes. The 
parameter zip_entry is a valid directory entry returned by zip_read(). 
Note: The length parameter should be the uncompressed length you wish to 
read. 
Returns the data read, or FALSE if the end of the file is reached. 
See also zip_entry_open(), zip_entry_close() and zip_entry_filesize().   zip_entry_openUpzip_open
zip_open
(4.1.0 - 4.3.2 only)
zip_open -- Open a Zip File Archive
Description
resource zip_open ( string filename)
Opens a new zip archive for reading. The filename parameter is the 
filename of the zip archive to open. 
Returns a resource handle for later use with zip_read() and zip_close() or 
returns FALSE if filename does not exist. 
See also zip_read() and zip_close().   zip_entry_readUpzip_read
zip_read
(4.1.0 - 4.3.2 only)
zip_read -- Read Next Entry in a Zip File Archive
Description
resource zip_read ( resource zip)
Reads the next entry in a zip file archive. The parameter zip must be a 
zip archive previously opened by zip_open(). 
Returns a directory entry resource for later use with the zip_entry_...() 
functions or FALSE if there's no more entries to read. 
See also zip_open(), zip_close(), zip_entry_open(), and zip_entry_read().   zip_openUpZlib Compression Functions
#

#T=string zend_version ( void )
zend_version ( ^!void );
#

#T=zlib_get_coding_type - string zlib_get_coding_type ( void )
(PHP 4 >= 4.3.2)
zlib_get_coding_type -- Returns the coding type used for output 
compression
Description
string zlib_get_coding_type ( void )
Returns the coding type used for output compression. Possible return 
values are gzip, deflate, or FALSE 
See also the zlib.output_compression directive.   readgzfileUpZend API

  PrevChapter 12. FunctionsNext

Function arguments
Information may be passed to functions via the argument list, which is a 
comma-delimited list of variables and/or constants. 
PHP supports passing arguments by value (the default), passing by 
reference, and default argument values. Variable-length argument lists are 
supported only in PHP 4 and later; see Variable-length argument lists and 
the function references for func_num_args(), func_get_arg(), and 
func_get_args() for more information. A similar effect can be achieved in 
PHP 3 by passing an array of arguments to a function: 
Example 12-4. Passing arrays to functions
  <?php
  function takes_array($input)
  {
      echo "$input[0] + $input[1] = ", $input[0]+$input[1];
  }
  ?> 
Making arguments be passed by reference
By default, function arguments are passed by value (so that if you change 
the value of the argument within the function, it does not get changed 
outside of the function). If you wish to allow a function to modify its 
arguments, you must pass them by reference. 
If you want an argument to a function to always be passed by reference, 
you can prepend an ampersand (&) to the argument name in the function 
definition: 
Example 12-5. Passing function parameters by reference
  <?php
  function add_some_extra(&$string)
  {
      $string .= 'and something extra.';
  }
  $str = 'This is a string, ';
  add_some_extra($str);
  echo $str;    // outputs 'This is a string, and something 
  extra.'
  ?> 
Default argument values
A function may define C++-style default values for scalar arguments as 
follows: 
Example 12-6. Use of default parameters in functions
  <?php
  function makecoffee ($type = "cappuccino")
  {
      return "Making a cup of $type.\n";
  }
  echo makecoffee ();
  echo makecoffee ("espresso");
  ?> 
The output from the above snippet is: 
Making a cup of cappuccino.
Making a cup of espresso.

The default value must be a constant expression, not (for example) a 
variable, a class member or a function call. 
Note that when using default arguments, any defaults should be on the 
right side of any non-default arguments; otherwise, things will not work 
as expected. Consider the following code snippet: 
Example 12-7. Incorrect usage of default function arguments
  <?php
  function makeyogurt ($type = "acidophilus", $flavour)
  {
      return "Making a bowl of $type $flavour.\n";
  }

  echo makeyogurt ("raspberry");   // won't work as expected
  ?> 
The output of the above example is: 
Warning: Missing argument 2 in call to makeyogurt() in 
/usr/local/etc/httpd/htdocs/php3test/functest.html on line 41
Making a bowl of raspberry .

Now, compare the above with this: 
Example 12-8. Correct usage of default function arguments
  <?php
  function makeyogurt ($flavour, $type = "acidophilus")
  {
      return "Making a bowl of $type $flavour.\n";
  }

  echo makeyogurt ("raspberry");   // works as expected
  ?> 
The output of this example is: 
Making a bowl of acidophilus raspberry.

Variable-length argument lists
PHP 4 has support for variable-length argument lists in user-defined 
functions. This is really quite easy, using the func_num_args(), 
func_get_arg(), and func_get_args() functions. 
No special syntax is required, and argument lists may still be explicitly 
provided with function definitions and will behave as normal.   FunctionsUpReturning values
Chapter 12. Functions
Table of Contents
User-defined functions
Function arguments
Returning values
Variable functions
Internal (built-in) functions
User-defined functions
A function may be defined using syntax such as the following: 
Example 12-1. Pseudo code to demonstrate function uses
  <?php
  function foo ($arg_1, $arg_2, /* ..., */ $arg_n)
  {
      echo "Example function.\n";
      return $retval;
  }
  ?> 
Any valid PHP code may appear inside a function, even other functions and 
class definitions. 
In PHP 3, functions must be defined before they are referenced. No such 
requirement exists in PHP 4. Except when a function is conditionally 
defined such as shown in the two examples below. 
When a function is defined in a conditional manner such as the two 
examples shown. Its definition must be processed prior to being called. 
Example 12-2. Conditional functions
  <?php

  $makefoo = true;

  /* We can't call foo() from here 
     since it doesn't exist yet,
     but we can call bar() */

  bar();

  if ($makefoo) {
    function foo ()
    {
      echo "I don't exist until program execution reaches 
me.\n";
    }
  }

  /* Now we can safely call foo()
     since $makefoo evaluated to true */

  if ($makefoo) foo();

  function bar() 
  {
    echo "I exist immediately upon program start.\n";
  }

  ?> 
Example 12-3. Functions within functions
  <?php
  function foo() 
  {
    function bar() 
    {
      echo "I don't exist until foo() is called.\n";
    }
  }

  /* We can't call bar() yet
     since it doesn't exist. */

  foo();

  /* Now we can call bar(),
     foo()'s processesing has
     made it accessible. */

  bar();

  ?> 
PHP does not support function overloading, nor is it possible to undefine 
or redefine previously-declared functions. 
Note: Function names are case-insensitive, though it is usually good 
form to call functions as they appear in their declaration. 
PHP 3 does not support variable numbers of arguments to functions, 
although default arguments are supported (see Default argument values for 
more information). PHP 4 supports both: see Variable-length argument lists 
and the function references for func_num_args(), func_get_arg(), and 
func_get_args() for more information.   include_once()UpFunction arguments

  PrevChapter 12. FunctionsNext

Internal (built-in) functions
PHP comes standard with many functions and constructs. There are also 
functions that require specific PHP extensions compiled in otherwise 
you'll get fatal "undefined function" errors. For example, to use image 
functions such as imagecreatetruecolor(), you'll need your PHP compiled 
with GD support. Or, to use mysql_connect() you'll need your PHP compiled 
in with MySQL support. There are many core functions that are included in 
every version of PHP like the string and variable functions. A call to 
phpinfo() or get_loaded_extensions() will show you which extensions are 
loaded into your PHP. Also note that many extensions are enabled by 
default and that the PHP manual is split up by extension. See the 
configuration, installation, and individual extension chapters, for 
information on how to setup your PHP. 
Reading and understanding a function's prototype is explained within the 
manual section titled how to read a function definition. It's important to 
realize what a function returns or if a function works directly on a 
passed in value. For example, str_replace() will return the modified 
string while usort() works on the actual passed in variable itself. Each 
manual page also has specific information for each function like 
information on function parameters, behavior changes, return values for 
both success and failure, and availability information. Knowing these 
important (yet often subtle) differences is crucial for writing correct 
PHP code. 
See also function_exists(), the function reference, get_extension_funcs(), 
and dl().   Variable functionsUpClasses and Objects

  PrevChapter 12. FunctionsNext

Returning values
Values are returned by using the optional return statement. Any type may 
be returned, including lists and objects. This causes the function to end 
its execution immediately and pass control back to the line from which it 
was called. See return() for more information. 
Example 12-9. Use of return()
  <?php
  function square ($num)
  {
      return $num * $num;
  }
  echo square (4);   // outputs '16'.
  ?> 
You can't return multiple values from a function, but similar results can 
be obtained by returning a list. 
Example 12-10. Returning an array to get multiple values
  <?php
  function small_numbers()
  {
      return array (0, 1, 2);
  }
  list ($zero, $one, $two) = small_numbers();
  ?> 
To return a reference from a function, you have to use the reference 
operator & in both the function declaration and when assigning the 
returned value to a variable: 
Example 12-11. Returning a reference from a function
  <?php
  function &returns_reference()
  {
      return $someref;
  }

  $newref =& returns_reference();
  ?> 
For more information on references, please check out References Explained. 
  Function argumentsUpVariable functions

  PrevChapter 12. FunctionsNext

Variable functions
PHP supports the concept of variable functions. This means that if a 
variable name has parentheses appended to it, PHP will look for a function 
with the same name as whatever the variable evaluates to, and will attempt 
to execute it. Among other things, this can be used to implement 
callbacks, function tables, and so forth. 
Variable functions won't work with language constructs such as echo(), 
print(), unset(), isset(), empty(), include(), require() and the like. You 
need to use your own wrapper function to utilize any of these constructs 
as variable functions. 
Example 12-12. Variable function example
  <?php
  function foo()
  {
      echo "In foo()<br>\n";
  }

  function bar($arg = '')
  {
      echo "In bar(); argument was '$arg'.<br>\n";
  }

  // This is a wrapper function around echo
  function echoit($string)
  {
      echo $string;
  }

  $func = 'foo';
  $func();        // This calls foo()

  $func = 'bar';
  $func('test');  // This calls bar()

  $func = 'echoit';
  $func('test');  // This calls echoit()
  ?> 
You can also call an object's method by using the variable functions 
feature. Example 12-13. Variable method example
  <?php
  class Foo
  {
      function Variable()
      {
	  $name = 'Bar';
	  $this->$name(); // This calls the Bar() method
      }
      
      function Bar()
      {
	  echo "This is Bar";
      }
  }

  $foo = new Foo();
  $funcname = "Variable";
  $foo->$funcname();  // This calls $foo->Variable()

  ?> 
See also call_user_func(), variable variables and function_exists().   Returning valuesUpInternal (built-in) functions
